-- name=int_achievements
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_achievements", interface.originhub );
  ObjSet( "int_achievements", { pos_z = pos_z } );
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

  private.event_anim_end = {};
  private.DIRECTION =  -1;

  private.MOUSE_OVER_ANIM_TIME = 0.3;

  private.MOVE_ANIM_POS_X_BEG =   -240;
  private.MOVE_ANIM_POS_X_END =   215;
  private.MOVE_ANIM_TIME      =  0.6;

  private.show  = false; --на экране или нет
  private.timer = 3; --время таймера

  private.IMG_X = 91;
  private.IMG_Y = -14;

  private.TEXT_NAME_X = 75;
  private.TEXT_NAME_Y = -10;

  private.CURRENT_ACHIEV = "";

  ObjSet( "obj_int_achievements_root", { alp = 0 } );

  ObjSet( "obj_int_achievements_button", 
  {
    event_mdown = private.GoAchievements,
    event_menter = private.MouseEnter,
    event_mleave = private.MouseLeave,
  } );

  private.WideScreenUpdate();

end;
--******************************************************************************************
function public.Destroy()

  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

end;
--******************************************************************************************
function public.Show ( name )
  
  ObjSet( "obj_int_achievements_root", { active = true, visible = true, input = true } );
  private.show = true;
  private.ShowAnim( "show", name );
  
end;
--******************************************************************************************
function public.Hide ()

  ObjSet( "obj_int_achievements_root", { input = false } );
  private.show = false;
  private.HideAnim( "hide" );

end;
--******************************************************************************************
function private.WideScreenUpdate ()

  local direction = private.DIRECTION or 0;

  if ( direction ~= 0 and ObjGet( "int_achievements" ) ) then

    local offset = 0.5 * ( GetAppWidth() - 1024 );
    local position =  0;

    local posx = position + ( direction * offset );
    ObjSet( "obj_int_achievements_root", { pos_x = posx } );
    local pos_obj = ObjGet( "obj_int_achievements_other" ).pos_x;
    ObjSet( "obj_int_achievements_other", { pos_x = pos_obj - posx } );

  end;

end;
--******************************************************************************************
function private.EventAnimEnd ( event_id )

  if ( event_id == "show" ) then

    ObjSet( "obj_int_achievements", { input = true } );
    
    ObjSet( "tmr_int_achievements_hide", { endtrig = public.Hide, time = private.timer, playing = true } );

    ObjSet( "pfx_int_achievements_anim", { active = true } );
    PartSysStart( "pfx_int_achievements_anim" );

  elseif ( event_id == "hide" ) then

    ObjSet( "obj_int_achievements_root", { active = false, visible = false } );
    ObjSet( "obj_int_achievements", { input = false } );
    ObjSet( "pfx_int_achievements_anim", { active = false } );

    private.DeleteObjAchiev();

  end;
  
end;
--******************************************************************************************
function private.GoAchievements ()

  SetCursor( CURSOR_NULL );

  ObjSet( "tmr_int_achievements_hide", { endtrig = public.Hide, time = 0.01, playing = true } );
  
  cmn.EnterRmWithoutInterface( "rm_achievements" );

  if ( common.GetCurrentSubRoom() ) then

     common.CloseSubRoom();

  end;

end;
--******************************************************************************************
function private.ShowAnim ( event_id, name )

  local obj       = "obj_int_achievements";
  local func_end  = function () private.EventAnimEnd( event_id ); end;
  local tme       = private.MOVE_ANIM_TIME;

  ObjSet( "obj_int_achievements_root", { alp = 1 } );
  ObjStopAnimate( obj, "pos_x" ); 
  ObjSet( "tmr_int_achievements_hide", { playing = false } );

  local current_posx = ObjGet( obj ).pos_x; 
  local distance = math.abs( private.MOVE_ANIM_POS_X_BEG - current_posx );

  if ( distance ~= 0 ) then

    local overtime = distance * ( tme / ( private.MOVE_ANIM_POS_X_END - private.MOVE_ANIM_POS_X_BEG ) );
    ObjAnimate( obj, "pos_x", 0, 0, func_end,
    {
      0.0,          2, current_posx,
      overtime,     2, private.MOVE_ANIM_POS_X_BEG,
      overtime+tme, 2, private.MOVE_ANIM_POS_X_END
    } );
  
  else
  
    ObjAnimate( obj, "pos_x", 0, 0, func_end,
    {
      0.0, 2, private.MOVE_ANIM_POS_X_BEG,
      tme, 2, private.MOVE_ANIM_POS_X_END
    } );
  
  end;

  private.CURRENT_ACHIEV = name;
  private.CreatObjAchiev( name );

end;
--******************************************************************************************
function private.HideAnim ( event_id )

  local obj           = "obj_int_achievements";
  local func_end      = function () private.EventAnimEnd( event_id ); end;
  local tme           = private.MOVE_ANIM_TIME;
  local current_posx  = private.MOVE_ANIM_POS_X_END;

  ObjStopAnimate( obj, "pos_x" ); 
  current_posx = ObjGet( obj ).pos_x; 
  
  ObjAnimate( obj, "pos_x", 0, 0, func_end,
  {
    0.0, 1, current_posx,
    tme, 1, private.MOVE_ANIM_POS_X_BEG
  } );

  ObjSet( "tmr_int_achievements_hide", { playing = false } );

end;
--******************************************************************************************
function private.CreatObjAchiev ( name )

  private.LIST = --такой же список есть int_achievements
  { --2 ой элемент в этой матрице - назване спрайта
    { "not_skip_mg_1",        "fin_3_mg_withoutskip" }, --прохождение 3 мг без скипа 
    { "not_skip_mg_2",        "fin_5_mg_withoutskip" }, --прохождение 5 мг без скипа
    { "not_skip_mg_3",        "fin_10_mg_withoutskip" }, --прохождение 10 мг без скипа
    { "not_skip_mg_4",        "fin_all_mg_withoutskip" },  --прохождение всех мг без скипа

    { "not_skip_ho_1",        "fin_3_ho_withouthint" }, --прохождение 3 ХО без хинта
    { "not_skip_ho_2",        "fin_5_ho_withouthint" }, --прохождение 5 ХО без хинта
    { "not_skip_ho_3",        "fin_10_ho_withouthint" }, --прохождение 10 ХО без хинта
    { "not_skip_ho_4",        "fin_all_ho_withouthint" }, --прохождение всех ХО без хинта

    { "ho_three_1",           "fin_3ho_3minutes" }, --прохождение 3-х ХО подряд, меньше чем за 3 минуты каждое
    { "ho_three_2",           "fin_5ho_3minutes" }, --прохождение 5 ХО подряд, меньше чем за 3 минуты каждое
    { "ho_three_3",           "fin_10ho_3minutes" }, --прохождение 10 ХО подряд, меньше чем за 3 минуты каждое

    { "ho_three_obj_three",   "get3object_ho_3seconds" }, --подбор 3-х объектов ХО за 3 секунды
    { "ho_five_obj_five",     "get3object_ho_5seconds" }, --подбор 5 объектов ХО за 5 секунды
    { "ho_ten_obj_ten",       "get3object_ho_10seconds" }, --подбор 10 объектов ХО за 10 секунды

    { "ho_ten_min",           "fin_1ho_10minutes" }, --прохождение 1-го ХО больше чем за 10 минут

    { "ho_one_min",           "fin_1ho_1minute" }, --прохождение 1-го ХО меньше чем за 1 минуту

    { "mg_one_min",           "fin_1mg_1minutes" }, --Прохождение 1-ой МГ меньше чем за 1 минуту
    
    --нестандартные ачивки
    { "save_professor",    "save_professor" }, --спасение професора
    { "use_teleport",    "teleport" }, --использование телепорта
    { "superpuzzle_no_skip",    "superpuzzle_no_skip" }, --прохождение суперпазла без скипа 
    { "vid_no_skip",    "vid_no_skip" }, --просмотр видео без скипа
    { "dialog_no_skip",    "dialog_no_skip" }, --просмотр биалогов без скипа
    { "wrong_apply",          "wrong_apply" }, --неправильное применение ?? хз чё за ачивка
    { "cake",    "cake" }, --скушать пироженку
  };

  local achiev_name = name or private.CURRENT_ACHIEV;

  if ( not ObjGet( "txt_int_achievements_achiev_name" ) ) then

    ObjCreate( "txt_int_achievements_achiev_name", "text" );
    ObjAttach( "txt_int_achievements_achiev_name", "obj_int_achievements" );

    ObjSet( "txt_int_achievements_achiev_name", 
    { 
        pos_x = private.TEXT_NAME_X, 
        pos_y = private.TEXT_NAME_Y,
        pos_z = 1,
        input = false,
        fontcolor_r = 0.8945,
        fontcolor_g = 0.875,
        fontcolor_b = 0.6328,
        res = "assets/fonts/times",
        fontsize = 20,
        maxwidth = 240,
        align = 1,
        linespacing = 0.8,
        display_outline = 1,
        outline_size = 1
      } );
    

  end;      

  local name_icon = 0;
  for i = 1, #private.LIST do

    if ( achiev_name == private.LIST[ i ][ 1 ] ) then

      name_icon = private.LIST[ i ][ 2 ];
      break;

    end;

  end;

  ObjSet( "spr_int_achievements_icon", { res = "assets/interface/resources/achievements/icon/"..name_icon } );
  ObjSet( "txt_int_achievements_achiev_name", { text = "str_achievements_name_"..achiev_name } );

end;
--******************************************************************************************
function private.DeleteObjAchiev ()
  
  ObjDelete( "txt_int_achievements_achiev_name" );
  private.CURRENT_ACHIEV = "";

end;
--******************************************************************************************
function private.MouseEnter ()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_achievements_button_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

  ObjSet( "tmr_int_achievements_hide", { active = false } );

end;
--******************************************************************************************
function private.MouseLeave ()

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_achievements_button_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

  ObjSet( "tmr_int_achievements_hide", { active = true } );

end;
--******************************************************************************************