-- name=int_button_map_impl
--******************************************************************************************
function public.Init ()
  --
  public.DIRECTION = -1;
  public.POSITION = 57;

  private.MOUSE_OVER_ANIM_TIME = 0.3;

  ObjSet("obj_int_button_map_button", {
    event_mdown = int_button_map.MouseDown,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  });

end;
--******************************************************************************************
function private.MouseEnterAnim()

  common_impl.PlayAudio( "sfx", "aud_menter", 0, "", 0 );

  SetCursor( CURSOR_HAND );
  local obj = "vid_int_button_map_button_focus";
  --local alp = ObjGet( obj ).alp;
  --local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

  ObjSet( obj, { active = true, visible = true } );

  --ObjAnimate( obj, "alp", 0, 0, "",
  --{
  --  0.0, 2, alp,
  --  tme, 2, 1
  --} );

end;
--******************************************************************************************
function private.MouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT ); 
  local obj = "vid_int_button_map_button_focus";
  --local alp = ObjGet( obj ).alp;
  --local tme = alp * private.MOUSE_OVER_ANIM_TIME;

  ObjSet( obj, { active = false, visible = false } );

  --ObjAnimate( obj, "alp", 0, 0, "",
  --{
  --  0.0, 1, alp,
  --  tme, 1, 0
  --} );

end;
--******************************************************************************************
function public.WideScreenUpdate()

  if ( not GetWideScreen() ) then

    ObjSet( "int_button_map_impl", { pos_x = 57 } );
  
  else

    ObjSet( "int_button_map_impl", { pos_x = -50 } );

  end;

end;
--******************************************************************************************