-- name=int_button_morph
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_button_morph", interface.originhub );
  
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

  private.collect_loaded = false;

  private.DIRECTION =  1;
  private.MOUSE_OVER_ANIM_TIME = 0.3;
  private.MOVE_ANIM_POS_X_BEG =   974;
  private.MOVE_ANIM_POS_X_END = 656;
  private.MOVE_ANIM_TIME      =  0.6;
  private.show  = false; --на экране или нет
  private.timer = 3; --время таймера
  private.is_get = false --совершен подбор

  private.WideScreenUpdate();

  ObjMultiSet({
    { "int_button_morph", { pos_z = pos_z }},
    { "obj_int_button_morph_root", { alp = 1 }},
    { "obj_int_button_morph", { pos_x = private.MOVE_ANIM_POS_X_BEG }},
    { "obj_int_button_morph_button", { event_mdown = private.ButtonDown, event_menter = private.ButtonEnter, event_mleave = private.ButtonLeave }},
  });

end;
--******************************************************************************************
function public.Destroy()

  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

end;
--******************************************************************************************
function public.Show ( count )

  if count then

    private.is_get = true;
    ng_global.morph.objects_count = count;

  end;

  private.show = true;
  private.ShowAnim( "show" );
  
end;
--******************************************************************************************
function public.Hide ()

  private.is_get = false;
  private.show = false;
  private.HideAnim( "hide" );

end;
--******************************************************************************************
function private.WideScreenUpdate()

  local direction = private.DIRECTION or 0;

  if ( direction ~= 0 and ObjGet( "int_button_morph" ) ) then
   
    local offset = 0.5 * ( GetAppWidth() - 1024 );
    local position =  0;
    local posx = position + ( direction * offset );
    local pos_obj = ObjGet( "obj_int_button_morph_other" ).pos_x;

    ObjSet( "obj_int_button_morph_root", { pos_x = posx } );
    ObjSet( "obj_int_button_morph_other", { pos_x = pos_obj - posx } );

  end;

end;
--******************************************************************************************
function private.EventAnimEnd ( event_id )

  if ( event_id == "show" ) then

    ObjSet( "tmr_int_button_morph_hide", { endtrig = public.Hide, time = private.timer, playing = true } );
    ObjSet( "spr_int_button_morph_button_left", { visible = false } );
    ObjSet( "spr_int_button_morph_button_focus_left", { visible = false } );
    ObjSet( "spr_int_button_morph_button_focus_right", { visible = true } );
    
  elseif ( event_id == "hide" ) then

    ObjSet( "spr_int_button_morph_button_left", { visible = true } );
    ObjSet( "spr_int_button_morph_button_focus_left", { visible = true } );
    ObjSet( "spr_int_button_morph_button_focus_right", { visible = false } );

  end;
  
end;
--******************************************************************************************
--******************************************************************************************
function private.ShowAnim ( event_id )

  local obj       = "obj_int_button_morph";
  local tme       = private.MOVE_ANIM_TIME;

  if private.is_get then

    private.SetCounter( ng_global.morph.objects_count );

  else

    private.SetCounter( ng_global.morph.objects_count + 1 );

  end;

  ObjSet( "obj_int_button_morph_root", { alp = 1 } );
  ObjStopAnimate( obj, "pos_x" ); 
  ObjSet( "tmr_int_button_morph_hide", { playing = false } );

  local func_show_end = function ()

    if private.is_get then

      private.is_get = false;
      private.ShowAnimCounter( ng_global.morph.objects_count );

    end;

    private.EventAnimEnd( event_id );

  end;

  local current_posx = ObjGet( obj ).pos_x; 
  local distance = math.abs( private.MOVE_ANIM_POS_X_BEG - current_posx );

  if ( distance ~= 0 ) then

    local overtime = distance * ( tme / ( private.MOVE_ANIM_POS_X_END - private.MOVE_ANIM_POS_X_BEG ) );
    ObjAnimate( obj, "pos_x", 0, 0, func_show_end,
    {
      0.0,          2, current_posx,
      overtime,     2, private.MOVE_ANIM_POS_X_BEG,
      overtime+tme, 2, private.MOVE_ANIM_POS_X_END

    } );
  
  else
  
    ObjAnimate( obj, "pos_x", 0, 0, func_show_end,
    {
      0.0, 2, private.MOVE_ANIM_POS_X_BEG,
      tme, 2, private.MOVE_ANIM_POS_X_END

    } );
  
  end;

end;
--******************************************************************************************
function private.SetCounter ( object_count )

  local units_old  = ( object_count - 1 ) % 10;
  local scores_old = ( object_count - 1 - units_old ) / 10;

  local scroll = { 224, 166, 111, 55, -1, -56, -113, -169, -225, -280 };

  local curr_pos_y = 280;

  if ( units_old ~= 0 ) then

    curr_pos_y = scroll[ units_old ];

  end; 
  ObjSet( "spr_int_button_morph_digits_1", { pos_y = curr_pos_y } );

  curr_pos_y = 280;
  if ( scores_old ~= 0 ) then

    curr_pos_y = scroll[ scores_old ];

  end; 
  ObjSet( "spr_int_button_morph_digits_10", { pos_y = curr_pos_y } );

end;
--******************************************************************************************
function private.ShowAnimCounter ( object_count )

  local scroll = { 224, 166, 111, 55, -1, -56, -113, -169, -225, -280 }; 

  local units_old  = ( object_count - 1 ) % 10;
  local scores_old = ( object_count - 1 - units_old ) / 10;

  local units_new  = object_count % 10;
  local scores_new = ( object_count - units_new ) / 10;

  local next_pos_y_1 = -280;
  if ( units_new ~=0 ) then

    next_pos_y_1 = scroll[ units_new ]; 

  end;

  local next_pos_y_10 = 280;
  if ( scores_new ~= 0 ) then

    next_pos_y_10 = scroll[ scores_new ]; 

  end;

  ObjAnimate( "spr_int_button_morph_digits_1", "pos_y", 0, 0, "", 
  { 
    0.0, 3, ObjGet( "spr_int_button_morph_digits_1" ).pos_y,  
    0.6, 3, next_pos_y_1
  } );  
  ObjAnimate( "spr_int_button_morph_digits_10", "pos_y", 0, 0, "", 
  { 
    0.0, 3, ObjGet( "spr_int_button_morph_digits_10" ).pos_y,  
    0.6, 3, next_pos_y_10
  } );  

end;
--******************************************************************************************
function private.HideAnim ( event_id )

  local obj           = "obj_int_button_morph";
  local func_end      = function () private.EventAnimEnd( event_id ); end;
  local tme           = private.MOVE_ANIM_TIME;
  local current_posx  = private.MOVE_ANIM_POS_X_END;

  ObjStopAnimate( obj, "pos_x" ); 
  current_posx = ObjGet( obj ).pos_x; 
  
  ObjAnimate( obj, "pos_x", 0, 0, func_end,
  {
    0.0, 1, current_posx,
    tme, 1, private.MOVE_ANIM_POS_X_BEG

  } );

  ObjSet( "tmr_int_button_morph_hide", { playing = false } );

end;
--******************************************************************************************
function private.ButtonDown ()

  if private.show then

    public.Hide();

  else

    public.Show();

  end;

end;
--******************************************************************************************
function private.ButtonEnter ()

  common_impl.PlayAudio( "sfx", "aud_guidance", 0, "", 0 );
  SetCursor( CURSOR_HAND );

  local obj_focus = "obj_int_button_morph_button_focus";
  local alp = ObjGet( obj_focus ).alp;

  ObjAnimate( obj_focus, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );


end;
--******************************************************************************************
function private.ButtonLeave ()

  SetCursor( CURSOR_DEFAULT );

  local type = type or "spr";
  local obj_focus = "obj_int_button_morph_button_focus";
  local alp = ObjGet( obj_focus ).alp;

  ObjAnimate( obj_focus, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

end;
--******************************************************************************************
--******************************************************************************************