-- name=int_button_skip_impl
function public.Init ()

  public.DIRECTION = 0;
  public.POSITION = 932;

  private.RELOAD_VID_FRAME_COUNT =  1098;
  private.RELOAD_ANIM_FRAME_COUNT = 18;
  private.RELOAD_BEGIN_ANIM_TIME  = 0;

  private.BUTTON_MOUSE_OVER_ANIM_TIME = 0.3;
  private.SHOW_ANIM_TIME = 0.3;

  ObjSet("obj_int_button_skip_button", {
    event_mdown = int_button_skip.MouseDown,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  });

end;
--******************************************************************************************
function public.WideScreenUpdate()

  if ( not GetWideScreen() ) then
    ObjSet( "int_button_skip_impl", { pos_x = 932 } );
  else
    ObjSet( "int_button_skip_impl", { pos_x = 1039 } );
  end;

end;
--******************************************************************************************
function public.ShowAnim( event_id )

  local trg = function () int_button_skip.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "obj_int_button_skip_impl", "alp", 0, 0, trg,
  {
    0.0, 3, 0,
    tme, 3, 1
  } );

end;
--******************************************************************************************
function public.HideAnim( event_id )

  local trg = function () int_button_skip.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "obj_int_button_skip_impl", "alp", 0, 0, trg,
  {
    0.0, 3, 1,
    tme, 3, 0
  } );

end;
--******************************************************************************************
function public.ChangeToStatic()

  ObjSet( "obj_int_button_skip_reload", { active = false, visible = false } );
  ObjSet( "obj_int_button_skip_static", { active = true, visible = true } );
  ObjSet( "spr_int_button_skip_static", { visible = true } );
  ObjSet( "vid_int_button_skip_loader", { active = false, visible = false } );

  if ( ng_global.currentprogress == "std" ) then 

    if ( ng_global.progress and ng_global.progress[ "std" ] and  ng_global.progress[ "std" ][ "win_small_suitcase" ] ) then

      if ( ng_global.progress[ "std" ] ) then

        if ( ng_global.progress[ "std" ][ "win_small_suitcase" ] ) then

          if ( cmn.IsEventStart( "win_small_suitcase" ) and not cmn.IsEventDone( "win_small_suitcase" ) ) then

            common_impl.TutorialShow( "tutorial_page_5" );

          end;

        end;

      end;

    end;

  end;

end;
--******************************************************************************************
function public.ChangeToReload( is_begin )

  ObjSet( "obj_int_button_skip_static", { active = false, visible = false } );
  ObjSet( "vid_int_button_skip_loader", { active = true, visible = true } );

  ObjSet( "spr_int_button_skip_static", { visible = false } );
  ObjSet( "obj_int_button_skip_reload", { active = true, visible = true } );

  private.ReloadAnim( is_begin );

end;
--******************************************************************************************
function public.SetHardcore( is_hardcore )

  if ( is_hardcore ) then

    ObjSet( "obj_int_button_skip_active",   { visible = false } );
    ObjSet( "obj_int_button_skip_hardcore", { active = true, visible = true } );

  else

    ObjSet( "obj_int_button_skip_hardcore", { active = false, visible = false } );
    ObjSet( "obj_int_button_skip_active",   { visible = true } );

  end;

end;
--******************************************************************************************
function private.ReloadAnim( is_begin )

  if ( is_begin ) and ObjGet( "vid_int_button_skip_close" ).playing then

    ObjSet( 'vid_int_button_skip_loader', { visible = false } );

  end;

  if ( not ObjGet( "tmr_int_button_skip_reload" ) ) then
    return;
  end;

  local time_min    = int_button_skip.GetTimeMin();
  local time_remain = int_button_skip.GetTimeRemain();
  local time_full   = int_button_skip.GetTimeFull();
  
  local frame_count = private.RELOAD_ANIM_FRAME_COUNT;
  local vid_frame_count = private.RELOAD_VID_FRAME_COUNT;

  -- время на один фрейм
  local time_frame = time_full / frame_count;
  local vid_time_frame = time_full / vid_frame_count;  

  local time_current = time_full - time_remain;
  local frame_current = math.floor( time_current / time_frame );
  local vid_frame_current = math.floor( time_current / vid_time_frame );

  --DbgTrace( "SKIP RELOAD: time = "..time_current..", frame = "..frame_current );

  ObjSet( "vid_int_button_skip_loader", { frame = vid_frame_current } );

  if ( frame_current < frame_count ) then

    local trg = function ()

      private.ReloadAnim();

    end;

    ObjSet( "tmr_int_button_skip_reload_anim", { endtrig = trg, time = time_min, playing = true } );

  end;

end;
--******************************************************************************************
function private.MouseEnterAnim()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_button_skip_button_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.BUTTON_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.MouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_button_skip_button_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.BUTTON_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************
function public.StartAnimReloadBegin()

  ObjSet( "vid_int_button_skip_loader", { active = false, visible = false } );  
  ObjSet( "vid_int_button_skip_close", { active = true, visible = true } );
  ObjSet( "spr_int_button_skip_static", { active = false, visible = false } );    
  ObjSet( "vid_int_button_skip_close", { alp = 1 } );
  VidStop( "vid_int_button_skip_close" );

  local func_end = function()

    ObjSet( 'vid_int_button_skip_close', { active = false, visible = false } );
    ObjSet( 'vid_int_button_skip_loader', { visible = true } );

  end;

  VidPlay( "vid_int_button_skip_close", func_end );

end;