-- name=int_map_impl
--******************************************************************************************
function public.Init ()

  public.DIRECTION = 0;

  private.SHOW_ANIM_TIME = 0.3;
  private.HIDE_ANIM_TIME = 0.3;

  private.POPUP_WINDOW_BACK_X = 0;
  private.POPUP_WINDOW_BACK_Y = 0;

  private.HUB_POPUP_WINDOW_X = 200;
  private.HUB_POPUP_WINDOW_Y = 0;

  private.curren_location_audio_env = {};

  private.MIN_END_Y = -280;
  
    private.screen = 
    {
       [ "park_1" ]           = { screen = 1, visit = false, lock = false, activ = false }
      ,[ "park_2" ]           = { screen = 1, visit = false, lock = false, activ = false }
      ,[ "car" ]              = { screen = 1, visit = false, lock = false, activ = false }
      ,[ "porch" ]            = { screen = 1, visit = false, lock = false, activ = false }
      ,[ "hall" ]             = { screen = 1, visit = false, lock = false, activ = false }
      ,[ "courtyard" ]        = { screen = 1, visit = false, lock = false, activ = false }
      ,[ "lounge" ]           = { screen = 1, visit = false, lock = false, activ = false }
      ,[ "bar" ]              = { screen = 1, visit = false, lock = false, activ = false }
      ,[ "corridor" ]         = { screen = 1, visit = false, lock = false, activ = false }

      ,[ "archives" ]         = { screen = 2, visit = false, lock = false, activ = false }
      ,[ "childrensroom" ]    = { screen = 2, visit = false, lock = false, activ = false }
      ,[ "corridorelevator" ] = { screen = 2, visit = false, lock = false, activ = false }
      ,[ "lab" ]              = { screen = 2, visit = false, lock = false, activ = false }
      ,[ "lowerlevel" ]       = { screen = 2, visit = false, lock = false, activ = false }
      ,[ "receptionroom" ]    = { screen = 2, visit = false, lock = false, activ = false }
      ,[ "bar_2" ]            = { screen = 1, visit = false, lock = false, activ = false }
      ,[ "courtyard_2" ]      = { screen = 1, visit = false, lock = false, activ = false }
      ,[ "lounge_2" ]         = { screen = 1, visit = false, lock = false, activ = false }
      ,[ "hall_2" ]           = { screen = 1, visit = false, lock = false, activ = false }

      ,[ "archives_3" ]       = { screen = 2, visit = false, lock = false, activ = false }
      ,[ "ventilationshaft" ] = { screen = 3, visit = false, lock = false, activ = false }
      ,[ "powerunit" ]        = { screen = 3, visit = false, lock = false, activ = false }
      ,[ "terenceroom" ]      = { screen = 3, visit = false, lock = false, activ = false }
      ,[ "secondfloor" ]      = { screen = 3, visit = false, lock = false, activ = false }
      ,[ "examroom" ]         = { screen = 3, visit = false, lock = false, activ = false }
      ,[ "tortureroom" ]      = { screen = 3, visit = false, lock = false, activ = false }

      ,[ "apartment" ]       = { screen = 4, visit = false, lock = false, activ = false }
      ,[ "parkinglot" ]      = { screen = 4, visit = false, lock = false, activ = false }
      ,[ "porch_ext" ]       = { screen = 1, visit = false, lock = false, activ = false }
      ,[ "nearcafe" ]        = { screen = 4, visit = false, lock = false, activ = false }
      ,[ "cafe" ]            = { screen = 4, visit = false, lock = false, activ = false }
      ,[ "hall_ext" ]        = { screen = 1, visit = false, lock = false, activ = false }
      ,[ "secondfloor_ext" ] = { screen = 3, visit = false, lock = false, activ = false }
      ,[ "terenceroom_ext" ] = { screen = 3, visit = false, lock = false, activ = false }
      ,[ "managerroom" ]     = { screen = 4, visit = false, lock = false, activ = false }
    };

    private.save_rooms = 
    {
      [ "bar" ]                 = { level2 = "bar_2" },
      [ "courtyard" ]           = { level2 = "courtyard_2" },
      [ "lounge" ]              = { level2 = "lounge_2" },
      [ "hall" ]                = { level2 = "hall_2", levelext = "hall_ext" },

      [ "archives" ]            = { level3 = "archives_3" },

      [ "porch" ]               = { levelext = "porch_ext" },
      [ "secondfloor" ]         = { levelext = "secondfloor_ext" },
      [ "terenceroom" ]         = { levelext = "terenceroom_ext" },
    };

  local table_multiset = {};

  table.insert( table_multiset, { "obj_map_btn_close", { 
    event_mdown = int_map.Close,
    event_menter = function () private.ButtonEnter( "spr_map_btn_close_focus" ) end, 
    event_mleave = function () private.ButtonLeave( "spr_map_btn_close_focus" ) end 
  } } );

  private.levels_numbers = { level1 = 1, level2 = 2, level3 = 3, levelext = 4 }
  
  for i = 1, 4 do
    
    table.insert( table_multiset, { "obj_map_button_level"..i, { 
      input        = false,
      event_mdown  = function () private.ButtonLevelMDown( i ) end,
      event_menter = function () private.ButtonEnter( "spr_map_button_level"..i.."_light" ) end, 
      event_mleave = function () private.ButtonLeave( "spr_map_button_level"..i.."_light" ) end
    } } );

    table.insert( table_multiset, { "spr_map_button_level"..i,           { res = "assets/interface/resources/map/layers/button_2" } } );
    table.insert( table_multiset, { "spr_map_button_level"..i.."_light", { res = "assets/interface/resources/map/layers/button_2_light" } } );

  end;

  table.insert( table_multiset, { "obj_map_back_paper_clk", { 
    event_mdown = private.PaperClk 
  } } );

  table.insert( table_multiset, { "obj_map_paper", { 
    event_mdown = private.PaperClk,
    scale_x = 0, scaley = 0
  } } );

  --table.insert( table_multiset, { "obj_map_btn_diary", { 
  --  visible = true, input = true,
  --  event_mdown = interface.DiaryShow,
  --  event_menter = function() common_impl.DialogButtonMouseEnter( "map_btn_diary" ) end, 
  --  event_mleave = function() common_impl.DialogButtonMouseLeave( "map_btn_diary" ) end
  --} } );

--  if ( IsCollectorsEdition() or IsSurveyEdition() ) then
--
--    local table_multiset_ce = {
--
--      { "obj_map_btn_collectibles2", { 
--          visible = true, input = true,
--          event_mdown = function() private.ButtonDown( "rm_collectibles2" ); end,
--          event_menter = function() common_impl.DialogButtonMouseEnter( "map_btn_collectibles2" ) end, 
--          event_mleave = function() common_impl.DialogButtonMouseLeave( "map_btn_collectibles2" ) end } }, 
--
--      { "obj_map_btn_collectibles", { 
--          visible = true, input = true,
--          event_mdown = function() private.ButtonDown( "rm_collectibles" ); end,
--          event_menter = function() common_impl.DialogButtonMouseEnter( "map_btn_collectibles" ) end, 
--          event_mleave = function() common_impl.DialogButtonMouseLeave( "map_btn_collectibles" ) end } }, 
--
--      { "obj_map_btn_achiev", { 
--          visible = true, input = true,
--          event_mdown = function() private.ButtonDown( "rm_achievements" ); end,
--          event_menter = function() common_impl.DialogButtonMouseEnter( "map_btn_achiev" ) end, 
--          event_mleave = function() common_impl.DialogButtonMouseLeave( "map_btn_achiev" ) end } }, 
--
--    };
--
--    for i = 1, #table_multiset_ce do
--    
--      table.insert( table_multiset, table_multiset_ce[ i ] );
--
--    end;
--
--  end;

  for room, value in pairs( private.screen ) do    

    local obj = "obj_map_screen_"..private.screen[ room ].screen.."_"..room.."_marker";
    table.insert( table_multiset, { obj, { 
                                      event_mdown  = function() private.MarkerMDown( room ) end, 
                                      event_menter = function() private.MarkerMEnter( CURSOR_HAND, room ) end, 
                                      event_mleave = function() private.MarkerMLeave() end } } );

  end;
  
  ObjMultiSet( table_multiset );
  
  private.current_screen = 1;

  private.InitAnimations();

end;
--******************************************************************************************
function public.WideScreenUpdate ()

  if ( not GetWideScreen() ) then

    --

  else

    --

  end;

end;
--******************************************************************************************
function public.ShowAnim ( event_id )

  local func_end = function () 

    int_map.EventAnimEnd( event_id ); 
    private.curren_location_audio_env = cmn.GetAudio( "env" );
    common_impl.EnvPlay( { "aud_map_env" }, "" );

  end;

  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "int_map", "alp", 0, 0, func_end,
  {
    0.0, 3, 0,
    tme, 3, 1
  } );

  private.current_screen = private.screen[ private.pos_player ].screen;

  private.SetCurrentScreen();

  ObjSet( "obj_map_marker_player", { visible = true, pos_x = 0, pos_y = 0 } );
  ObjAttach( "obj_map_marker_player", "obj_map_screen_"..private.current_screen.."_"..private.pos_player.."_marker_player_place" );

  for room, value in pairs( private.screen ) do

    private.CheckMapRoom( room );

  end;

end;
--******************************************************************************************
function public.HideAnim ( event_id )

  local func_end = function () 

    int_map.EventAnimEnd( event_id );

    common_impl.PlayDialogTimer();

    if( #private.curren_location_audio_env > 0 ) then

      common_impl.EnvPlay( private.curren_location_audio_env, "" );

    end;

  end;

  local tme = private.HIDE_ANIM_TIME;

  common_impl.PlayAudio( "sfx", "aud_clk_map", 0, "", 0 );

  ObjAnimate( "int_map", "alp", 0, 0, func_end,
  {
    0.0, 3, 1,
    tme, 3, 0
  } );

end;
--******************************************************************************************
function public.UpdateGameMode ( msg, params )

  if ( params.mode == 3 and not ng_global.gamemode_custom[ "tasks" ] ) then
    
  end;

end;
--******************************************************************************************
-- function *** Buttons *** () end;
--******************************************************************************************
  function private.ButtonDown ( room )

    common.GotoRoom( room, 0, true );
    interface.WidgetSetVisible( InterfaceWidget_Map, false ); 
    common_impl.Lock( true );

  end;
--******************************************************************************************
  function private.ButtonEnter ( obj )

    local tme = 0.3;

    SetCursor( CURSOR_HAND );

    local alp = ObjGet( obj ).alp;
    ObjAnimate( obj, "alp", 0, 0, "", 
    { 
      0.0,              0, alp, 
      tme *( 1 - alp ), 0,    1
    } );

  end;
  --******************************************************************************************
  function private.ButtonLeave ( obj )

    local tme = 0.3;

    SetCursor( CURSOR_DEFAULT );

    local alp = ObjGet( obj ).alp;

    ObjAnimate( obj, "alp", 0, 0, "", 
    { 
      0.0,       0,    alp, 
      tme *alp , 0,    0
    } ); 

  end;
--******************************************************************************************
-- function *** Marker *** () end;
--******************************************************************************************
  function private.MarkerMDown ( room )

    local chapter = ng_global.progress[ ng_global.currentprogress ].common.chapter;

    if private.save_rooms[ room ] then
  
      if private.save_rooms[ room ][ chapter ] then

         room = private.save_rooms[ room ][ chapter ];

      end;

    end;
  
    if ( GetCurrentRoom() ~= "rm_"..room ) then

      cmn.GotoRoom( "rm_"..room );  
    
      cmn.CheckGiveCustomAchiev( "use_teleport" );

    end;

    int_map.Close();
    
  end;
  --******************************************************************************************
  function private.MarkerMEnter ( cur_type, room )

    local cur = cur_type or CURSOR_DEFAULT;

    SetCursor( cur );

    common_impl.PopupShow( room );

  end;
  --******************************************************************************************
  function private.MarkerMLeave ()

    SetCursor( CURSOR_DEFAULT );

    common_impl.PopupHide();

  end;
--******************************************************************************************
-- function *** Button Level *** () end;
--******************************************************************************************
  function private.ButtonLevelMDown ( level )

    local old_screen = private.current_screen;
    local new_screen = level;

    private.current_screen = level;

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.SetCurrentScreen(); 

    end;

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_button4", 0, "", 0 );
    ObjAnimate( "obj_map_screen_"..old_screen, "alp", 0, 0, func_end, { 0,0,1, 0.3,0,0 } );
    ObjAnimate( "obj_map_screen_"..new_screen, "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );

    local spr_name_old = "spr_map_button_level"..old_screen;
    local spr_name_new = "spr_map_button_level"..new_screen;
    local params_old = ObjGet( spr_name_old );
    local params_new = ObjGet( spr_name_new );

    local offset = 6;

    ObjAnimate( spr_name_old, "pos_xy", 0, 0, "", { 
      0.0,  0,  params_old.pos_x,           params_old.pos_y,
      0.2,  0,  params_old.pos_x + offset,  params_old.pos_y - offset
    } );

    ObjAnimate( spr_name_new, "pos_xy", 0, 0, "", { 
      0.0,  0,  params_new.pos_x,           params_new.pos_y,
      0.2,  0,  params_new.pos_x - offset,  params_new.pos_y + offset
    } );

  end;
--******************************************************************************************
-- function *** Paper *** () end;
--******************************************************************************************
  function private.PaperClk ()

    local beg_scale = 0;    
    local end_scale = 1;

    local param = ObjGet( "obj_map_back_paper_clk" );

    local beg_pos_x = param.pos_x;
    local beg_pos_y = param.pos_y;

    local end_pos_x = 0;
    local end_pos_y = 0;

    local obj_input = true;

    if ( private.map_paper_open ) then

      beg_scale, end_scale = end_scale, beg_scale;
      beg_pos_x, end_pos_x = end_pos_x, beg_pos_x;
      beg_pos_y, end_pos_y = end_pos_y, beg_pos_y;
      obj_input = false;

      private.map_paper_open = false;

    else

      private.map_paper_open = true;

    end

    common_impl.Lock( true );

    local obj_name = "obj_map_paper";
 
    local func_end = function ()

      ObjSet( obj_name, { input = obj_input } );
    
      common_impl.Lock( false );

    end;

    common_impl.PlayAudio( "sfx", "aud_paper", 0, "", 0 );
    ObjAnimate( obj_name, "pos_xy", 0, 0, func_end, { 
      0.0,  0,  beg_pos_x,  beg_pos_y,
      0.2,  0,  end_pos_x,  end_pos_y,
    } );

    ObjAnimate( obj_name, "scale_xy", 0, 0, "", { 
      0.0,  0,  beg_scale,  beg_scale,
      0.2,  0,  end_scale,  end_scale,
    } );

  end;
--******************************************************************************************
-- function *** LOGIC *** () end;
--******************************************************************************************
  function public.VisitMapRoom ( name )
        
    local current_screen = private.screen[ name ].screen;
    local current_lock   = private.screen[ name ].lock;
   
    private.screen[ name ].visit = true;      
    private.pos_player = name; 
      
    ObjSet( "obj_map_screen_"..current_screen.."_"..name, { active = true, visible = true, input = true } );
    ObjSet( "spr_map_screen_"..current_screen.."_"..name.."_shadow", { visible = false } );

  end;
  --******************************************************************************************
  function public.LockMapRoom ( name, lock )
    
    if ( private.screen[ name ] ) then

      private.screen[ name ].lock = lock;

    end;

  end;
  --******************************************************************************************
  function public.ActiveTaskRoom ( name, active )
      
    if ( private.screen[ name ] ) then

      private.screen[ name ].activ = active;    

    end;

  end;
  --******************************************************************************************
  function private.CheckMapRoom ( room_name )

    local current_screen = private.screen[ room_name ].screen;
    local current_lock   = private.screen[ room_name ].lock;
    local current_visit  = private.screen[ room_name ].visit;
    local current_activ  = private.screen[ room_name ].activ;
    local table_multiset = {};

    local marker_name = "obj_map_screen_"..current_screen.."_"..room_name;

    if ( current_visit ) then

      table.insert( table_multiset, { marker_name.."_marker", { visible = true } } );        

      table.insert( table_multiset, { marker_name.."_marker_blocked", { visible = current_lock } } );
      table.insert( table_multiset, { marker_name.."_marker", { input = not current_lock } } );

      table.insert( table_multiset, { marker_name.."_marker_task", { visible = current_activ } } );
      table.insert( table_multiset, { marker_name.."_marker_no_task", { visible = not current_activ } } );

    else

      table.insert( table_multiset, { marker_name.."_marker", { visible = false, input = false } } );        

    end;

    ObjMultiSet( table_multiset );

  end;
  --******************************************************************************************
  function private.SetCurrentScreen ()

    local table_multiset = {};

    for s = 1, 4 do
      
      table.insert( table_multiset, { "obj_map_screen_"..s,       { input = false, alp = 0 } } );
      table.insert( table_multiset, { "obj_map_button_level"..s,  { input = false } } );

    end;

    local current_level = private.levels_numbers[ ng_global.progress[ ng_global.currentprogress ].common.chapter ];

    for i = 1, current_level do
      
      table.insert( table_multiset, { "obj_map_button_level"..i,           { input = true } } );
      table.insert( table_multiset, { "spr_map_button_level"..i,           { res = "assets/interface/resources/map/layers/button_1", pos_x = 0, pos_y = 0 } } );
      table.insert( table_multiset, { "spr_map_button_level"..i.."_light", { res = "assets/interface/resources/map/layers/button_1_light" } } );

    end;

    local current_level_name = private.current_screen ;

    table.insert( table_multiset, { "obj_map_screen_"..current_level_name,      { input = true, alp = 1 } } );
    table.insert( table_multiset, { "obj_map_button_level"..current_level_name, { input = false } } );
    table.insert( table_multiset, { "spr_map_button_level"..current_level_name, { pos_x = -6, pos_y = 6 } } );

    if ( #table_multiset > 0 ) then

      ObjMultiSet( table_multiset );

    end;

  end;
  --******************************************************************************************
--******************************************************************************************
-- function *** ANIM *** () end;
--******************************************************************************************
  function private.InitAnimations ()
      
    ObjAnimate( "spr_int_map_fan_2", "ang", 1, 0, "", { 0, 0, 0,    0.5, 0, 6.28 } );

  end;
--******************************************************************************************