-- name=ho_floorhole
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "floorhole" );
  game.relations[ "ho_floorhole" ].exitroom = "rm_lounge";
  private.room_objname = "ho_floorhole";
  --------------------------------------------------------------------------------------------------
  private.win_floorhole = {};

  private.win_floorhole.pos_inv = 
  {-230, -110, 10, 130, 250, 370, 490, 610, 730, 850, 970, 1090};

  private.win_floorhole.task = { "blot",   "bucket",            "chair",     "feather", 
                                 "fire",   "fire_extinguisher", "hexagon3",  "lock", 
                                 "magnet", "plug",              "scissors",  "whirligig" };

  for i = 1, #private.win_floorhole.task do

    ObjSet( "spr_floorhole_"..private.win_floorhole.task[ i ], { event_mdown = function () private.CompleteTask( private.win_floorhole.task[ i ] ); end, input = false } );

  end;

  private.Animation ();

  --------------------------------------------------------------------------------------------
  -- function opn_floorhole () end;
  --------------------------------------------------------------------------------------------
  local opn_floorhole = function ()

  end;

  cmn.AddSubscriber( "opn_floorhole", opn_floorhole, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_floorhole () end;
  --------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_floorhole" ] =
  {
      type = "win",
      room = "rm_lounge",
      zz = private.room_objname,
      zz_gate = "gho_lounge_floorhole"
  };
  --------------------------------------------------------------------------------------------------
  local win_floorhole_func = function ()

    if ( cmn.IsEventDone( "win_floorhole" ) ) then

      interface.InventoryItemAdd( "inv_hexagon3", "spr_floorhole_win" );
      ObjDelete( "gho_lounge_floorhole" );
      ObjAttach( "obj_int_taskpanel_ho2", "ho_floorhole" );
      cmn.SetInvPlusRGB( "toolbox", true );

    end;

  end;
  cmn.AddSubscriber( "win_floorhole", win_floorhole_func );
  --------------------------------------------------------------------------------------------------
  local start_floorhole_func = function ()

    if ( cmn.IsEventStart( "win_floorhole" ) ) then

        common_impl.ProcessHoStart( "floorhole" );

        local ho_found = ng_global.progress[ "std" ][ "win_floorhole" ].found;

        for i = 1, #ho_found, 1 do

            ObjDelete( ho_found[ i ][ "object" ] );

        end;

    end;

  end;
  cmn.AddSubscriber( "win_floorhole", start_floorhole_func, "ho_floorhole" );
  --------------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();
  common_impl.EnvPlay( { "mus_env/aud_ho_mus_env" }, "", 0.5 );

  if ( not cmn.IsEventDone( "opn_floorhole" ) ) then

      cmn.SetEventDone( "opn_floorhole" );
      cmn.CallEventHandler( "opn_floorhole" );

  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "blot",                 1, 0, { { "spr_floorhole_blot"        } } );
  interface.TaskPanelTaskAdd( ho_items, "bucket",               1, 0, { { "spr_floorhole_bucket"   } } );
  interface.TaskPanelTaskAdd( ho_items, "chair",                1, 0, { { "spr_floorhole_chair"  } } );
  interface.TaskPanelTaskAdd( ho_items, "feather",              1, 0, { { "spr_floorhole_feather" } } );
  interface.TaskPanelTaskAdd( ho_items, "fire",                 1, 0, { { "spr_floorhole_fire"     } } );
  interface.TaskPanelTaskAdd( ho_items, "fire_extinguisher",    1, 0, { { "spr_floorhole_fire_extinguisher"       } } );
  interface.TaskPanelTaskAdd( ho_items, "hexagon3",             1, 0, { { "spr_floorhole_hexagon3"      } } );
  interface.TaskPanelTaskAdd( ho_items, "lock",                 1, 0, { { "spr_floorhole_lock"      } } );
  interface.TaskPanelTaskAdd( ho_items, "magnet",               1, 0, { { "spr_floorhole_magnet"} } );
  interface.TaskPanelTaskAdd( ho_items, "plug",                 1, 0, { { "spr_floorhole_plug"       } } );
  interface.TaskPanelTaskAdd( ho_items, "scissors",             1, 0, { { "spr_floorhole_scissors" } } );
  interface.TaskPanelTaskAdd( ho_items, "whirligig",            1, 0, { { "spr_floorhole_whirligig"     } } );

  if ( not cmn.IsEventStart( "win_floorhole" ) ) then

    cmn.InitHo( "floorhole" );

  end;

  interface.TaskPanelShow( ho_items );
  private.Panel();

  --local pages = ng_global.progress[ "std" ][ "see_tutorial" ].state.pages;

--  if pages[ "tutorial_page_14" ][ "shown" ] == 0 then
--
--      cmn.TutorialShow( "tutorial_page_14" );  
--
--  elseif pages[ "tutorial_page_14" ][ "shown" ] == 1 and
--      pages[ "tutorial_page_17" ][ "shown" ] == 0 then
--
--      cmn.TutorialShow( "tutorial_page_17" );  
--      cmn.TutorialSetShown( "tutorial_page_14" );
--
--  end;

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();

  if cmn.IsEventStart( "see_tutorial" ) then

    common_impl.TutorialShow( "tutorial_page_13" );

  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  common_impl.PassingHoStop();

  ObjSet( "obj_int_taskpanel", { alp = 1 } );
  ObjSet( "txt_int_taskpanel", { alp = 1 } );

end;
--*********************************************************************************************************************
function public.HoComplete ()

  common_impl.PassingHoWin();

end;
--*********************************************************************************************************************
function private.CompleteTask ( name )

  cmn.Lock( true );

  cmn.HoTaskFind( "spr_floorhole_"..name, name );

  for i = 1,#private.win_floorhole.task do

    if ( private.win_floorhole.task[ i ] == name ) then 

      local object_name = "obj_"..i; 
      local collect_name  = "pfx_floorhole_collect_"..object_name.."_effect";
      ng_global.progress[ "std" ][ "win_floorhole" ].task_check[ i ] = 1;
      ObjCreate( collect_name, "partsys" );

      ObjSet( collect_name,
      {
        res    = "assets/interface/resources/effects_ho_hint",
        pos_x  = ObjGet( object_name ).pos_x, pos_y = ObjGet( object_name ).pos_y,
        active = 1, visible = 1, input = 0
      } );

      ObjAttach( collect_name, "obj_int_taskpanel_ho2" );
      ObjSet( collect_name, { blendmode = 2, scale_x = 0.9, scale_y = 0.9 } );
      --PartSysSetMaskObj( collect_name, object_name );  
      local func_end = function () private.AnimInv( i ); end;
      ObjAnimate( object_name, "alp", 0, 0, func_end,
      { 
        0.0, 0, 1.0,
        0.1, 0, 0.0
        --1.0, 0, 0.0
      } );

    end;

  end;

end;
--*********************************************************************************************************************
function private.GetItem ( name )

end;
--*********************************************************************************************************************
function private.UseItem ( name ) 
  
end;
--*********************************************************************************************************************
function private.UseItemEnd ( name )

end;
--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );

  if ( not ng_global.progress[ "std" ]["win_floorhole"].task_check ) then

     ng_global.progress["std"]["win_floorhole"].task_check = {0,0,0,0,0,0,0,0,0,0,0,0};

  end;

  local posx = -230;
  local tmp = 0;

  ObjSet( "obj_int_taskpanel_ho2", { croprect_init = true, croprect_x = -295, croprect_y = -200, croprect_w = 617, croprect_h = 400 } );

  for i = 1,#private.win_floorhole.task do 

     local obj = "obj_"..i;

     if ( ng_global.progress["std"]["win_floorhole"].task_check[ i ] == 0 ) and
        ( not ObjGet( obj ) ) then

        ObjCreate( obj, "obj" );
        ObjAttach( obj, "obj_int_taskpanel_ho2" );
        ObjAttach( "obj_int_taskpanel_ho2" , "spr_int_taskpanel" );
        ObjSet( obj, { pos_x = posx, pos_y = 30, inputrect_init = true, inputrect_x = -45, inputrect_y = -45, inputrect_w = 90, inputrect_h = 90, alp = 1, input = 0  } );
        local spr = "spr_floorhole_"..private.win_floorhole.task[ i ].."_inv";
        ObjCreate( spr, "spr" );
        ObjSet( spr, { res = "assets/levels/level1/ho_floorhole/layers/"..private.win_floorhole.task[ i ].."_silhouette", scale_x = 0.95, scale_y = 0.95 } );
        ObjAttach( spr, obj );
        tmp = tmp + 1;
        if ( tmp < 6 ) then

           private.CheckPanel( i, tmp );
          
        end;

        posx = posx + 120;

        if ( tmp == 12 ) then

            ng_global.progress["std"]["win_floorhole"].set = 1;

        end;

     else

     end;

  end;
   
end;
--********************************************************************************************************************* 
function private.CheckPanel ( i, tmp ) 

   local obj = "obj_"..i;

   if ( tmp < 6 ) then

      ObjSet( obj, { input = 1 } );

      ObjAnimate( obj, "alp", 0, 0, "", 
      { 
        0,0,0, 
        0.3,0,1 
      } );

      ObjSet( "spr_floorhole_"..private.win_floorhole.task[ i ], { alp = 1, input = 1 } );


   end;
   
end;
--*********************************************************************************************************************
function private.AnimInv ( num )

  local item = "obj_"..num;
  local tmp = num + 1;

    for i = tmp,#private.win_floorhole.task do

      local obj_tmp = "obj_"..i;

      if obj_tmp ~= nil and ng_global.progress["std"]["win_floorhole"].task_check[i] ~= 1 then

        ObjAnimate( "obj_"..i, "pos_x", 0, 0, "", 
        { 
          0.0,3,ObjGet( "obj_"..i ).pos_x, 
          0.4,3,ObjGet( "obj_"..i ).pos_x-120
          --0.8,3,ObjGet( "obj_"..i ).pos_x-120
        } );

        if ObjGet( "obj_"..i ).pos_x-120 == 250 then

          ObjAnimate( "obj_"..i, "scale_xy", 0, 0, "", 
          { 
            0.0,0,0.2,0.2, 
            0.3,0,1,1, 
            0.4,0,1.2,1.2,
            0.5,0,1,1

            --0.0,0,0.2,0.2, 
            --0.6,0,1,1, 
            --0.8,0,1.2,1.2,
            --1.0,0,1,1

          } );

        end;

      end;

    end;

  private.Check( num );

end;
--*********************************************************************************************************************
function private.Check ( num )  

  local tmp = 0;

  for i = 1,#private.win_floorhole.task do

    local item = "obj_"..i;

    if ( item and ng_global.progress[ "std" ][ "win_floorhole" ].task_check[ i ] ~= 1 ) then

       tmp = tmp + 1;

       if ( tmp < 6 ) then

          ObjSet( "spr_floorhole_"..private.win_floorhole.task[ i ], { alp = 1, input = 1 } );

       end;

       num = num + 1;

    end;

  end;

  local func_end = function () 

    if not cmn.IsEventDone( "win_floorhole" ) then

      cmn.Lock( false ) 

    end;

  end;

  ObjAnimate( "ho_floorhole", "alp", 0, 0, func_end, 
    { 
      0.0, 3, 1, 
      0.5, 3, 1
    } );

end;
--*********************************************************************************************************************
function private.Animation ()

  ObjAnimate( "spr_floorhole_light1", "alp", 1, 0, "", 
  { 
    0.0,  0,  1.0,
    3.0,  0,  0.0,
    6.0,  0,  1.0
  } );

end;
--*********************************************************************************************************************