-- name=ho_stash
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "stash" );
  game.relations[ "ho_stash" ].exitroom = "rm_lounge";
  private.room_objname = "ho_stash";
  private.ho_name = "stash";
  --------------------------------------------------------------------------------------------------
  
  --ObjMultiSet( {
  --
  --{ "obj_stash_clk_box", { event_mdown = function() private.clk_box() end } },
  --
  --} );


  private.color = { r = 0.7804, g = 0.60392, b = 0.42352 }; 
  private.task = { "eternity", "list",    "finance",     "advertisement",
                   "four",     "graphs",  "stethoscope", "time", 
                   "formula",  "terence", "happy" ,      "closed",
                   "hummer" };
  private.max_count = #private.task;
  for i = 1, #private.task do

    ObjSet( "spr_stash_"..private.task[ i ], 
      { 
        event_mdown = function () private.CompleteTask( private.task[ i ] ); end, 
        input = false 
      } );

  end;

  private.InitAnimations();

  common_impl.hint[ "win_stash" ] = {
      type = "win",
      room = "rm_lounge",
      zz = "ho_stash",
      zz_gate = "gho_lounge_stash"
  }; 
  local win_stash_func = function ()

    if ( cmn.IsEventDone( "win_stash" ) ) then

      interface.InventoryItemAdd( "inv_hammer", "spr_stash_win" );
      ObjDelete( "gho_lounge_stash" );  
      cmn.SetInvPlusRGB( "bottle", true );

    end;

  end;
  cmn.AddSubscriber( "win_stash", win_stash_func );
  --------------------------------------------------------------------------------------------------
  local start_stash_func = function ()

    if ( cmn.IsEventStart( "win_stash" ) ) then

      --cmn.ProcessHoStart( "stash" );
      local ho_found = ng_global.progress[ "std" ][ "win_stash" ].found;

      for i = 1, #ho_found, 1 do
        ObjDelete( ho_found[ i ][ "object" ] );
      end;

    end;

  end;
  cmn.AddSubscriber( "win_stash", start_stash_func, "ho_stash" );  
  --------------------------------------------------------------------------------------------
  -- function get_hammer () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hammer" ] = {
    type = "get",
    get_obj = "spr_stash_hammer",
    room = private.room_objname,
    zz = "zz_stash",
    zz_gate = "gzz_stash_stash"
  };
  
  local get_hammer_inv = function ()
  
    interface.InventoryItemAdd( "inv_hammer", "spr_stash_hammer" );
  
  end;
  
  local get_hammer_closezz = function ()
  
    ObjDelete( "gfx_stash_hammer" );
  
  end;
  
  cmn.AddSubscriber( "get_hammer", get_hammer_inv );
  cmn.AddSubscriber( "get_hammer", get_hammer_closezz, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();
  common_impl.EnvPlay( { "mus_env/aud_ho_mus_env" }, "", 0.5 );

  if ( not cmn.IsEventDone( "opn_stash" ) ) then
  
    cmn.SetEventDone( "opn_stash" );
    cmn.CallEventHandler( "opn_stash" );
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "eternity",           1, 0, { { "spr_stash_eternity" } } );
  interface.TaskPanelTaskAdd( ho_items, "list",               1, 0, { { "spr_stash_list" } } );
  interface.TaskPanelTaskAdd( ho_items, "finance",            1, 0, { { "spr_stash_finance" } } );
  interface.TaskPanelTaskAdd( ho_items, "advertisement",      1, 0, { { "spr_stash_advertisement" } } );
  interface.TaskPanelTaskAdd( ho_items, "four",               1, 0, { { "spr_stash_four" } } );
  interface.TaskPanelTaskAdd( ho_items, "graphs",             1, 0, { { "spr_stash_graphs" } } );
  interface.TaskPanelTaskAdd( ho_items, "stethoscope",        1, 0, { { "spr_stash_stethoscope" } } );
  interface.TaskPanelTaskAdd( ho_items, "time",               1, 0, { { "spr_stash_time" } } );
  interface.TaskPanelTaskAdd( ho_items, "formula",            1, 0, { { "spr_stash_formula" } } );
  interface.TaskPanelTaskAdd( ho_items, "terence",            1, 0, { { "spr_stash_terence" } } );
  interface.TaskPanelTaskAdd( ho_items, "happy",              1, 0, { { "spr_stash_happy" } } );
  interface.TaskPanelTaskAdd( ho_items, "closed",             1, 0, { { "spr_stash_closed" } } );
  interface.TaskPanelTaskAdd( ho_items, "hummer",             1, 0, { { "spr_stash_hummer" } } );

  if ( not cmn.IsEventStart( "win_stash" ) ) then

    cmn.InitHo( "stash" );

  end;

  interface.TaskPanelShow( ho_items );
  private.Panel();
--
--  if ( not ng_global.progress[ "std" ]["win_stash"].clk_box ) then
--
--     ng_global.progress[ "std" ]["win_stash"].clk_box = false;
--
--  else
--
--    if ( ng_global.progress[ "std" ]["win_stash"].clk_box == true ) then
--
--      private.clk_box_end();
--    
--    end;
--
--  end;

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();

  if cmn.IsEventStart( "see_tutorial" ) then

    common_impl.TutorialShow( "tutorial_page_12" );

  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();
  common_impl.StopAllVoc();

end;
--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  common_impl.PassingHoStop();

  ObjSet( "obj_int_taskpanel", { alp = 1 } );
  ObjSet( "txt_int_taskpanel", { alp = 1 } );

  ObjAttach( "obj_int_taskpanel_ho3" , "ho_stash" ); 

end;
--*********************************************************************************************************************
function public.HoComplete ()

  common_impl.PassingHoWin();
  
end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_hammer ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_hammer" );
  cmn.CallEventHandler( "get_hammer" );

end;
--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );
  ObjSet( "obj_int_taskpanel_ho3", { pos_y = 23, croprect_init = true, croprect_x = -295, croprect_y = -200, croprect_w = 617, croprect_h = 400 } );
  ObjAttach( "obj_int_taskpanel_ho3" , "spr_int_taskpanel" ); 
  
  if ( not ng_global.progress[ "std" ]["win_stash"].count_task ) then

     ng_global.progress["std"]["win_stash"].count_task = 1;

  end;

  local count_task = ng_global.progress["std"]["win_stash"].count_task

  for i = 1, private.max_count do 

    local name = "txt_"..private.ho_name.."_phrase_"..i;

      if ( not ObjGet( name ) ) then

        ObjCreate( name, "text" );
        ObjAttach( name, "obj_int_taskpanel_ho3" );

        local tsk = "tsk_"..private.ho_name.."_phrase_"..i;    
        ObjSet( name, 
          { 
            alp = 0,
            res = "assets/fonts/mt7_10",
            text = tsk,
            fontsize = 18,
            maxwidth = 570, 
            param0 = 1,  
            param1 = private.color.r,  
            param2 = private.color.g,  
            param3 = private.color.b,  

          } );

      end;

  end;

  ObjSet( "txt_"..private.ho_name.."_phrase_"..count_task, { alp = 1 } ); 
  private.SetHoState();

end;
--*********************************************************************************************************************
function private.CompleteTask ( name )

  cmn.Lock( true );

  cmn.HoTaskFind( "spr_stash_"..name, name );
  
  local count_task = ng_global.progress["std"]["win_stash"].count_task;

  local next_count_task = count_task + 1;
  ng_global.progress["std"]["win_stash"].count_task = next_count_task;
  if ( count_task < private.max_count ) then

    ObjAnimate( "txt_"..private.ho_name.."_phrase_"..count_task, "alp",0,0, "",
      { 
        0.0, 0, ObjGet( "txt_"..private.ho_name.."_phrase_"..count_task ).alp,
        1.0, 0, 0.0
      } ); 
    ObjAnimate( "txt_"..private.ho_name.."_phrase_"..next_count_task, "alp",0,0, "",
      { 
        0.0, 0, ObjGet( "txt_"..private.ho_name.."_phrase_"..next_count_task ).alp,
        1.0, 0, 1.0
      } );    

  end; 

  local func_end = function ()

    cmn.Lock( false );

    if ( ng_global.progress["std"]["win_stash"].count_task <= private.max_count ) then

      private.SetHoState();

    end;    

  end;

  ObjAnimate( "obj_stash_objects", "alp",0,0, func_end,
    { 
      0.0, 0, ObjGet( "obj_stash_objects" ).alp,
      1.0, 0, ObjGet( "obj_stash_objects" ).alp
    } );


end;
--*********************************************************************************************************************
--function private.clk_box ()
--
--  cmn.Lock( true );
--
--  local func_end = function ()
--
--    private.clk_box_end();
--
--  end;
--
--  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_drawer_handle", 0, "", 0 );
--
--  ObjAnimate( "spr_stash_box", "alp",0,0, func_end,
--    { 
--      0.0, 0, ObjGet( "spr_stash_box" ).alp,
--      0.5, 0, 1
--    } );
--
--end;
--*********************************************************************************************************************
--function private.clk_box_end ()
--
--  cmn.Lock( false );
--  ObjSet( "spr_stash_box", { alp = 1, input = true } );
--  ng_global.progress[ "std" ]["win_stash"].clk_box = true;
--  ObjDelete( "obj_stash_clk_box" );
--
--end;
--*********************************************************************************************************************
function private.SetHoState ()

  for i = 1, #private.task do

    ObjSet( "spr_stash_"..private.task[ i ], 
      { 
        input = false 
      } );

  end;
  for i = 1, private.max_count do 

    ObjSet( "txt_"..private.ho_name.."_phrase_"..i, { alp = 0 } );  

  end;

  local count_task = ng_global.progress["std"]["win_stash"].count_task;
  ObjSet( "spr_stash_"..private.task[ count_task ], 
    { 
      input = true

    } );

  ObjSet( "txt_"..private.ho_name.."_phrase_"..count_task, { alp = 1 } ); 

  common_impl.StopAllVoc();
  common_impl.PlayAudio( "voc", "level1/voc/aud_stash_phrase_"..count_task.."_voc", 0, "", 0 );

end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;