-- name=ho_suitcase
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "suitcase" );
  game.relations[ "ho_suitcase" ].exitroom = "rm_park_1";
  private.room_objname = "ho_suitcase";
  private.cout_piece = 8
  private.cout_items = 8;
  private.find_final_object = "str_suitcase_final_object";
  --------------------------------------------------------------------------------------------------
   local table_multiset = {};

   table.insert( table_multiset, { "spr_suitcase_compass",            { event_mdown = function() private.TaskComplete( "compass", 1 ) end } } );
   table.insert( table_multiset, { "spr_suitcase_film",               { event_mdown = function() private.TaskComplete( "film", 8 ) end } } );
   table.insert( table_multiset, { "spr_suitcase_globe",              { event_mdown = function() private.TaskComplete( "globe", 4 ) end } } );
   table.insert( table_multiset, { "spr_suitcase_handprint",          { event_mdown = function() private.TaskComplete( "handprint", 7 ) end } } );
   table.insert( table_multiset, { "spr_suitcase_headphones",         { event_mdown = function() private.TaskComplete( "headphones", 3 ) end } } );
   table.insert( table_multiset, { "spr_suitcase_lotteryticket",      { event_mdown = function() private.TaskComplete( "lotteryticket", 6 ) end } } );
   table.insert( table_multiset, { "spr_suitcase_star",               { event_mdown = function() private.TaskComplete( "star", 2 ) end } } );
   table.insert( table_multiset, { "spr_suitcase_audiocassette",      { event_mdown = function() private.TaskComplete( "audiocassette", 5 ) end } } );

   table.insert( table_multiset, { "spr_suitcase_certificateempty",   { event_mdown = function() private.get_certificateempty() end } } );

  for i = 1, private.cout_piece do

   table.insert( table_multiset, { "spr_suitcase_piece_"..i, 
                                  { 
                                    event_mdown  = function () private.ClkPiece( i ) end,
                                    event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end,
                                    event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end  
                                  } } );

  end;

  private.item_list_with_piece = { "beetle",     "compass",       "globe", "handprint", 
                                   "headphones", "lotteryticket", "star",   "audiocassette" };
  ObjMultiSet( table_multiset );
  private.InitAnimations();
  --------------------------------------------------------------------------------------------
  -- function win_suitcase () end;
  --------------------------------------------------------------------------------------------  
  common_impl.hint[ "win_suitcase" ] = {
      type = "win",
      room = "rm_park_1",
      zz = private.room_objname,
      zz_gate = "gho_park_1_suitcase"
  };
  
  local win_suitcase_inv = function ()

    if ( cmn.IsEventDone( "win_suitcase" ) ) then

       interface.InventoryItemAdd( "inv_certificate", "spr_suitcase_win" );    

    end;

  end;

  local win_suitcase_loc = function ()

    if ( cmn.IsEventDone( "win_suitcase" ) ) then

       ObjDelete( "gho_park_1_suitcase" );

    end;

  end;
  cmn.AddSubscriber( "win_suitcase", win_suitcase_inv );
  cmn.AddSubscriber( "win_suitcase", win_suitcase_loc, "rm_park_1" );
  --------------------------------------------------------------------------------------------------
  local start_suitcase_func = function ()

    if ( cmn.IsEventStart( "win_suitcase" ) ) then

      local ho_found = ng_global.progress[ "std" ][ "win_suitcase" ].found;

      for i = 1, #ho_found, 1 do

        ObjDelete( ho_found[ i ][ "object" ] );

      end;

    end;

  end;
  cmn.AddSubscriber( "win_suitcase", start_suitcase_func, private.room_objname );  
end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();
  common_impl.EnvPlay( { "mus_env/aud_ho_mus_env" }, "", 0.5 );

  if ( not cmn.IsEventDone( "opn_suitcase" ) ) then
  
    cmn.InitHo( "suitcase" );
    cmn.SetEventDone( "opn_suitcase" );
    ng_global.progress[ "std" ][ "win_suitcase" ].pieces = { };
    ng_global.progress[ "std" ][ "win_suitcase" ].puzzles = { };

    for i = 1, private.cout_piece do
  
      ng_global.progress[ "std" ][ "win_suitcase" ].pieces[ i ] = 0;
      ng_global.progress[ "std" ][ "win_suitcase" ].puzzles[ i ] = 0;

    end;

    ng_global.progress[ "std" ][ "win_suitcase" ].objects_counter = private.cout_piece;
    ng_global.progress[ "std" ][ "win_suitcase" ].puzzle_counter = private.cout_piece;

    ng_global.progress[ "std" ][ "win_suitcase" ].item_counter = private.cout_items;
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "compass",              1, 0, { { "spr_suitcase_compass" } } );
  interface.TaskPanelTaskAdd( ho_items, "film",                 1, 0, { { "spr_suitcase_film" } } );
  interface.TaskPanelTaskAdd( ho_items, "globe",                1, 0, { { "spr_suitcase_globe" } } );
  interface.TaskPanelTaskAdd( ho_items, "handprint",            1, 0, { { "spr_suitcase_handprint" } } );
  interface.TaskPanelTaskAdd( ho_items, "headphones",           1, 0, { { "spr_suitcase_headphones" } } );
  interface.TaskPanelTaskAdd( ho_items, "lotteryticket",        1, 0, { { "spr_suitcase_lotteryticket" } } );
  interface.TaskPanelTaskAdd( ho_items, "star",                 1, 0, { { "spr_suitcase_star" } } );
  interface.TaskPanelTaskAdd( ho_items, "audiocassette",        1, 0, { { "spr_suitcase_audiocassette" } } );

  interface.TaskPanelTaskAdd( ho_items, "piece_1",              1, 0, { { "spr_suitcase_piece_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_2",              1, 0, { { "spr_suitcase_piece_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_3",              1, 0, { { "spr_suitcase_piece_3" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_4",              1, 0, { { "spr_suitcase_piece_4" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_5",              1, 0, { { "spr_suitcase_piece_5" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_6",              1, 0, { { "spr_suitcase_piece_6" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_7",              1, 0, { { "spr_suitcase_piece_7" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_8",              1, 0, { { "spr_suitcase_piece_8" } } );
  
  interface.TaskPanelTaskAdd( ho_items, "certificateempty",     1, 0, { { "spr_suitcase_certificateempty" } } );  
  
  interface.TaskPanelShow( ho_items );
  private.MakePanel();

  for i = 1, #ng_global.progress[ "std" ][ "win_suitcase" ].pieces do

    if ( ng_global.progress[ "std" ][ "win_suitcase" ].pieces[ i ] == 1 ) then

      ObjSet( "spr_suitcase_piece_"..i, { input = true } );
      ObjSet( "gfx_suitcase_piece_"..i, { active = true } );

    end;   

  end;

  for i = 1, #ng_global.progress[ "std" ][ "win_suitcase" ].puzzles do

    if ( ng_global.progress[ "std" ][ "win_suitcase" ].puzzles[ i ] == 1 ) then

      ObjDelete( "spr_suitcase_piece_"..i );
      ObjDelete( "spr_suitcase_piece_"..i.."_shadow" );
      ObjSet( "spr_suitcase_certificate_"..i, { alp = 1 } );

    end;   

  end;
 
  if ( ng_global.progress[ "std" ][ "win_suitcase" ].item_counter == 0 ) then

    ObjAttach( "txt_suitcase_task", "int_taskpanel_impl");
    ObjSet( "obj_int_taskpanel", { alp = 0 } );

    if ( ng_global.progress[ "std" ][ "win_suitcase" ].puzzle_counter == 0 ) then

      ObjSet( "spr_suitcase_certificateempty", { input = true } );
      ObjDelete( "obj_suitcase_clk_certificat" );
      ObjSet( "txt_suitcase_task", { alp = 1, text = private.find_final_object } );

    else 

     ObjSet( "txt_suitcase_task", { alp = 1, param0 = ng_global.progress[ "std" ][ "win_suitcase" ].puzzle_counter } );
         
    end;

  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();

  if cmn.IsEventStart( "see_tutorial" ) then

    if not ObjGet( "int_tutorial" ).visible then

      common_impl.TutorialShow( "tutorial_page_6" );

    end;

  end;

end;
--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  ObjAttach( "txt_suitcase_task", "ho_suitcase");
  common_impl.PassingHoStop();
  private.ReMakePanel();

end;
--*********************************************************************************************************************
function public.HoComplete ()

  common_impl.PassingHoWin();

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete ( task_name, piece_number, object )
  
  local find_obj = "spr_suitcase_"..task_name;
  if ( object ) then

    find_obj = object;

  end;

  cmn.HoTaskFind( find_obj, task_name );
  
  ng_global.progress[ "std" ][ "win_suitcase" ].item_counter = ng_global.progress[ "std" ][ "win_suitcase" ].item_counter - 1;

  if ( piece_number ) then

    ObjSet( "spr_suitcase_piece_"..piece_number, { input = true } );
    ObjSet( "gfx_suitcase_piece_"..piece_number, { active = true } );
    ng_global.progress[ "std" ][ "win_suitcase" ].pieces[ piece_number ] = 1;

  end;

  if ( ng_global.progress[ "std" ][ "win_suitcase" ].item_counter == 0 ) then

    ObjAttach( "txt_suitcase_task", "int_taskpanel_impl");
    ObjSet( "obj_int_taskpanel", { alp = 0 } );
    ObjSet( "txt_suitcase_task", { alp = 1, param0 = ng_global.progress["std"]["win_suitcase"].puzzle_counter } );
    ObjSet( "obj_suitcase_piece", { input = true } );
    
  end;
 
end;
--------------------------------------------------------------------------------------------
function private.ClkPiece ( id )

  local old_coords = ObjGet( "spr_suitcase_piece_"..id );
  local new_coords = ObjGet( "spr_suitcase_certificateempty" );

  ObjSet( "spr_suitcase_piece_"..id, { pos_z = 5, input = false } );
  ObjSet( "spr_suitcase_piece_"..id.."_shadow", { alp = 0 } );

  local func_end = function()

    ng_global.progress[ "std" ][ "win_suitcase" ].puzzle_counter = ng_global.progress[ "std" ][ "win_suitcase" ].puzzle_counter - 1;
    ng_global.progress[ "std" ][ "win_suitcase" ].puzzles[ id ] = 1;
    ObjSet( "txt_suitcase_task", { param0 = ng_global.progress[ "std" ][ "win_suitcase" ].puzzle_counter } );

    cmn.HoTaskFind( "spr_suitcase_piece_"..id.."_complete", "piece_"..id );
    ObjDelete( "spr_suitcase_piece_"..id );

    if ( ng_global.progress[ "std" ][ "win_suitcase" ].puzzle_counter == 0 ) then

      ObjSet( "spr_suitcase_certificateempty", { input = true } );
      ObjDelete( "obj_suitcase_clk_certificat" );
      ObjSet( "txt_suitcase_task", { text = private.find_final_object } );
 
    end;
    
  end;

  common_impl.StopAudio( "sfx", "aud_hide_sfx", 0 );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_ho_clk1", 0, "", 0 );

  ObjAnimate( "spr_suitcase_piece_"..id, "pos_xy", 0, 0, func_end, 
  { 
    0.0, 0, old_coords.pos_x, old_coords.pos_y,   
    0.5, 0, new_coords.pos_x, new_coords.pos_y 
  } );
  ObjAnimate( "spr_suitcase_piece_"..id, "scale_xy", 0, 0, "", 
  { 
    0.0, 0, ObjGet( "spr_suitcase_piece_"..id ).scale_x, ObjGet( "spr_suitcase_piece_"..id ).scale_y,   
    0.5, 0, 0, 0 
  } );

  ObjAnimate( "spr_suitcase_certificate_"..id, "alp", 0, 0, "", 
  { 
    0.0, 0, 0, 
    0.3, 0, 0, 
    0.5, 0, 1 
  } );  
  ObjAnimate( "spr_suitcase_piece_"..id.."_complete", "alp", 0, 0, "", 
  { 
    0.0, 0, 0, 
    0.3, 0, 0, 
    0.5, 0, 1 
  } );  

end;
--------------------------------------------------------------------------------------------
function private.get_certificateempty ()

  cmn.HoTaskFind( "spr_suitcase_certificateempty", "certificateempty" );

end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_suitcase_light", "alp", 1, 0, "", 
  { 
    0.0, 0, 1, 
    3.0, 0, 0, 
    6.0, 0, 1 
  } );  

end;
--*********************************************************************************************************************
function private.MakePanel ()

  ObjSet( "obj_int_taskpanel_task_5", { pos_y = 45 } );
  ObjSet( "obj_int_taskpanel_task_6", { pos_y = 45 } );
  ObjSet( "obj_int_taskpanel_task_7", { pos_y = 45 } );
  ObjSet( "obj_int_taskpanel_task_8", { pos_y = 45 } );

  ObjSet( "obj_int_taskpanel_task_9", { alp = 0 } );
  ObjSet( "obj_int_taskpanel_task_10", { alp = 0 } );
  ObjSet( "obj_int_taskpanel_task_11", { alp = 0 } );
  ObjSet( "obj_int_taskpanel_task_12", { alp = 0 } );

end;
--*********************************************************************************************************************
function private.ReMakePanel ()

  ObjSet( "obj_int_taskpanel_task_5", { pos_y = 30 } );
  ObjSet( "obj_int_taskpanel_task_6", { pos_y = 30 } );
  ObjSet( "obj_int_taskpanel_task_7", { pos_y = 30 } );
  ObjSet( "obj_int_taskpanel_task_8", { pos_y = 30 } );

  ObjSet( "obj_int_taskpanel_task_9", { alp = 1 } );
  ObjSet( "obj_int_taskpanel_task_10", { alp = 1 } );
  ObjSet( "obj_int_taskpanel_task_11", { alp = 1 } );
  ObjSet( "obj_int_taskpanel_task_12", { alp = 1 } );

end;
--*********************************************************************************************************************