-- name=mg_panel
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_panel";

  private.count_cross = { 4, 4, 7 } 
  private.move_step = 3.5;
  private.count_rounds = 8;
  private.count_rounds_in_row = 3;
  private.count_keys = 3;

  ObjMultiSet( { 
    { "spr_panel_safetylock",   { event_mdown = private.get_safetylock } },
    { "obj_panel_clk_panel",    { event_mdown = private.clk_panel } }
  } );

  for i = 1, private.count_rounds do

    for j = 1, private.count_rounds_in_row do

      ObjSet( "obj_panel_col_clk_"..i.."_"..j, 
        { 
          event_mdown  = function () private.ClkCol( i, j ) end,
          event_menter = function () private.Col_Event_Menter( i, j ) end,
          event_mleave = function () private.Col_Event_Mleave( i, j ) end 
        } );
      ObjSet( "spr_panel_col_clk_"..i.."_"..j, { alp = 0 } );

    end;

  end;

  for i = 1, private.count_rounds do

    ObjSet( "spr_panel_key_"..i, 
      { 
        event_mdown  = function () private.ClkKey( i ) end,
        event_menter = function () private.Key_Event_Menter( i ) end,
        event_mleave = function () private.Key_Event_Mleave( i ) end 
      } );

  end;

  private.InitAnimations();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_uppershelf = function ()

    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    local mas_parent_gfx = 

    {
      private.room_objname,
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;
  cmn.AddSubscriber( "update_game_mode_uppershelf", update_game_mode_uppershelf, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_safetylock () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_safetylock" ] = {
    type = "get",
    get_obj = "spr_panel_safetylock",
    room = private.room_objname,
    zz_gate = "gmg_bar_panel"
  };
  
  local get_safetylock_inv = function ()
  
    interface.InventoryItemAdd( "inv_safetylock", "spr_panel_safetylock" );
    ObjDelete( "gmg_bar_panel" );
  
  end;
  
  local get_safetylock_closezz = function ()
  
    ObjDelete( "gfx_panel_safetylock" );
  
  end;

  local get_safetylock_loc = function ()
  
    ObjDelete( "spr_bar_panel_5" );
  
  end;
  
  cmn.AddSubscriber( "get_safetylock", get_safetylock_inv );
  cmn.AddSubscriber( "get_safetylock", get_safetylock_closezz, private.room_objname );
  cmn.AddSubscriber( "get_safetylock", get_safetylock_loc, "rm_bar" );
  --------------------------------------------------------------------------------------------
  -- function win_panel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_panel" ] = {
    type = "win",
    room = private.room_objname,
    zz = "gmg_bar_panel"
  };
  local win_panel = function ()

    if ( cmn.IsEventDone( "win_panel" ) ) then  

      ObjSet( "spr_panel_safetylock", { input = true } );
      ObjSet( "obj_panel_win", { pos_y = 0 } );
      ObjSet( "obj_panel_mg", { input = false } );

    else

    end;

  end;

  local win_panel_loc = function ()

    if ( cmn.IsEventDone( "win_panel" ) ) then  

      ObjSet( "spr_bar_panel_4", { alp = 1 } );

    end;

  end;

  cmn.AddSubscriber( "win_panel", win_panel, private.room_objname );
  cmn.AddSubscriber( "win_panel", win_panel_loc, "rm_bar" );

  --------------------------------------------------------------------------------------------
  -- function clk_panel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_panel" ] = {
    type = "click",
    use_place = "obj_panel_clk_panel",
    room = private.room_objname
  };

  local clk_panel_beg = function ()

    ObjDelete( "obj_panel_clk_panel" );
  
  end;
  local clk_panel_end = function ()

    ObjSet( "obj_panel_mg", { input = true } );
    ObjSet( "spr_panel_door_open", { alp = 1 } );  
    ObjDelete( "spr_panel_door_close" );
    
  end;
  local clk_panel_loc = function ()

    ObjDelete( "spr_bar_panel_2" );
    ObjSet( "spr_bar_panel_3", { alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_panel", clk_panel_beg, private.room_objname );
  cmn.AddSubscriber( "clk_panel", clk_panel_end, private.room_objname );
  cmn.AddSubscriber( "clk_panel", clk_panel_loc, "rm_bar" );
  cmn.AddSubscriber( "clk_panel_beg", clk_panel_beg, private.room_objname );
  cmn.AddSubscriber( "clk_panel_end", clk_panel_end, private.room_objname );
  cmn.AddSubscriber( "clk_panel_end", clk_panel_loc, "rm_bar" );
  --------------------------------------------------------------------------------------------


end;
--*********************************************************************************************************************
function public.Load ()

  if ( cmn.IsEventStart( "win_panel" ) ) then

    for i = 1, private.count_keys do

      ObjSet( "spr_panel_key_"..i, 
        {
          pos_x = ng_global.progress[ "std" ][ "win_panel" ].state_coord[ i ][ 1 ], 
          pos_y = ng_global.progress[ "std" ][ "win_panel" ].state_coord[ i ][ 2 ], 
        } );

      if ( ng_global.progress[ "std" ][ "win_panel" ].state[ i ] ) then

        ObjSet( "spr_panel_key_"..i, 
          {
            alp = 0 
          } );

      end;

    end;  

    for i = 1, private.count_rounds do

      for j = 1, private.count_rounds_in_row do

        if ( ng_global.progress[ "std" ][ "win_panel" ].round[ i ][ j ] ) then

          ObjSet( "obj_panel_col_clk_"..i.."_"..j, { input = false } );
          ObjSet( "obj_panel_col_"..i, { pos_y = ObjGet( "obj_panel_col_clk_"..i.."_"..j ).pos_y } )
    
        else

          ObjSet( "obj_panel_col_clk_"..i.."_"..j, { input = true } );      

        end;

      end;

    end;

  end;

end;
--*********************************************************************************************************************
function public.Open () 

  if ( cmn.IsEventStart( "win_panel" ) and not cmn.IsEventDone( "win_panel" ) ) then

    cmn.MiniGameShow( "panel" );
    common_impl.PassingMgStart( "panel" );

  end;


end;
--*********************************************************************************************************************
function public.PreOpen ()

  if ( not cmn.IsEventStart( "win_panel" ) ) then

    ng_global.progress[ "std" ][ "win_panel" ].state_coord = { { 531, 142 }, 
                                                               { 538, 509 },
                                                               { 487, 343 } };

    ng_global.progress[ "std" ][ "win_panel" ].state = { false, false, false };
 
    ng_global.progress[ "std" ][ "win_panel" ].round = { { false, true, false },   --1
                                                         { false, true, false },   --2
                                                         { false, true, false },   --3
                                                         { false, true, false },   --4
                                                         { false, true, false },   --5
                                                         { false, true, false },   --6
                                                         { false, true, false },   --7
                                                         { false, true, false } }; --8

  end;

end;
--*********************************************************************************************************************
function public.Close ()



end;
--*********************************************************************************************************************
function public.PreClose ()

  if ( cmn.IsEventStart( "win_panel" ) and not cmn.IsEventDone( "win_panel" ) ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_safetylock ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_safetylock" );
  cmn.CallEventHandler( "get_safetylock" );

  cmn.GotoRoom( "rm_bar" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLK *** () end;
--*********************************************************************************************************************
function private.clk_panel ()

  cmn.CallEventHandler( "clk_panel_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_panel" );
    cmn.CallEventHandler( "clk_panel_end" );

    cmn.MiniGameShow( "panel" );
    common_impl.PassingMgStart( "panel" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_electrical", 0, "", 0 ); 
  ObjAnimate( "spr_panel_door_close", "scale_x", 0, 0, func_end,
    { 
      0.0, 0, 1, 
      0.5, 0, 0
    } );  
  ObjAnimate( "spr_panel_door_close", "alp", 0, 0, "",
    { 
      0.0, 0, 1,
      0.2, 0, 1,  
      0.5, 0, 0
    } );  
  ObjAnimate( "spr_panel_door_open", "alp", 0, 0, "",
    { 
      0.0, 0, 0,
      0.2, 0, 0,  
      0.5, 0, 1
    } ); 
--

end;
--*********************************************************************************************************************
-- function *** PROGRESS WUN *** () end;
--*********************************************************************************************************************
function public.Reset ()

  cmn.Lock( true );
  local pos_x_keys = { 538, 538, 487 };
  for i = 1, private.count_keys do

    ObjAnimate( "spr_panel_key_"..i, "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_panel_key_"..i ).alp,
        0.3, 0, 1
      } ); 
    ObjAnimate( "spr_panel_key_"..i, "pos_x", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_panel_key_"..i ).pos_x,
        0.3, 0, pos_x_keys[ i ]
      } ); 

  end;

  for i = 1, private.count_rounds do

    ObjAnimate( "obj_panel_col_"..i, "pos_y", 0, 0, "",
      { 
        0.0, 0, ObjGet( "obj_panel_col_"..i ).pos_y,
        0.3, 0, ObjGet( "obj_panel_col_clk_"..i.."_2" ).pos_y
      } );     

  end;

  local fun_end = function ()

    for i = 1, private.count_rounds do
 
      for k = 1, private.count_rounds_in_row do

        ObjSet( "obj_panel_col_clk_"..i.."_"..k, { input = true } );

      end;
      ObjSet( "obj_panel_col_clk_"..i.."_2", { input = false } );

    end;

    for i = 1, private.count_keys do

      ObjSet( "spr_panel_key_"..i, { input = true } );

    end;

    ng_global.progress[ "std" ][ "win_panel" ].state_coord = { { 531, 142 }, 
                                                               { 538, 509 },
                                                               { 487, 343 } };

    ng_global.progress[ "std" ][ "win_panel" ].state = { false, false, false };
 
    ng_global.progress[ "std" ][ "win_panel" ].round = { { false, true, false },   --1
                                                         { false, true, false },   --2
                                                         { false, true, false },   --3
                                                         { false, true, false },   --4
                                                         { false, true, false },   --5
                                                         { false, true, false },   --6
                                                         { false, true, false },   --7
                                                         { false, true, false } }; --8
    cmn.Lock( false );

  end;

  ObjAnimate( "obj_panel_mg", "alp", 0, 0, fun_end,
    { 
      0.0, 0, ObjGet( "obj_panel_mg" ).alp,
      0.3, 0, ObjGet( "obj_panel_mg" ).alp
    } );

end;
--*********************************************************************************************************************

--*********************************************************************************************************************
function public.Skip ()

port.skip_mg = true;
  cmn.Lock( true );

  local pos_x_keys = { -271, -271, 1242 };
  for i = 1, private.count_keys do

    ObjAnimate( "spr_panel_key_"..i, "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_panel_key_"..i ).alp,
        0.6, 0, 0
      } ); 
    ObjAnimate( "spr_panel_key_"..i, "pos_x", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_panel_key_"..i ).pos_x,
        0.6, 0, pos_x_keys[ i ]
      } ); 

  end;

  local func_end = function ()

    private.Win();

  end;

  ObjAnimate( "obj_panel_mg", "alp", 0, 0, func_end,
    { 
      0.0, 0, ObjGet( "obj_panel_mg" ).alp,
      0.3, 0, ObjGet( "obj_panel_mg" ).alp
    } );

end;
--*********************************************************************************************************************
function private.WinEnd ()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_panel" );
  cmn.CallEventHandler( "win_panel" );

  common_impl.PassingMgWin( "panel" );

end;
--*********************************************************************************************************************
function private.Win ()

  local func_end = function ()

    cmn.Lock( false );

    for i = 1, 3 do

      ng_global.progress[ "std" ][ "win_panel" ].state_coord[ i ][ 1 ] = ObjGet( "spr_panel_key_"..i ).pos_x;
      ng_global.progress[ "std" ][ "win_panel" ].state_coord[ i ][ 2 ] = ObjGet( "spr_panel_key_"..i ).pos_y;
      ng_global.progress[ "std" ][ "win_panel" ].state[ i ] = true;

    end;

    private.WinEnd();

  end;

  cmn.Lock( true );
  ObjAnimate( "obj_panel_win", "pos_y", 0, 0, func_end,
    { 
      0.0, 1, ObjGet( "obj_panel_win" ).pos_y,
      0.6, 1, 0
    } );


end;
--*********************************************************************************************************************
function private.Col_Event_Menter ( i, j )

  common_impl.SetCursor( CURSOR_HAND );
  ObjAnimate( "spr_panel_col_clk_"..i.."_"..j, "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_panel_col_clk_"..i.."_"..j ).alp,
      0.2, 0, 1
    } );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_menter1", 0, "", 0 );

end;
--*********************************************************************************************************************
function private.Col_Event_Mleave ( i, j )

  common_impl.SetCursor( CURSOR_DEFAULT );
  ObjAnimate( "spr_panel_col_clk_"..i.."_"..j, "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_panel_col_clk_"..i.."_"..j ).alp,
      0.2, 0, 0
    } );

end;
--*********************************************************************************************************************
function private.ClkCol ( i, j )

  local func_end = function ()

    cmn.Lock( false );

    for k = 1, private.count_rounds_in_row do

      ObjSet( "obj_panel_col_clk_"..i.."_"..k, { input = true } );

    end;

    ng_global.progress[ "std" ][ "win_panel" ].round[ i ] = { false, false, false };  
    ng_global.progress[ "std" ][ "win_panel" ].round[ i ][ j ] = true;
    ObjSet( "obj_panel_col_clk_"..i.."_"..j, { input = false } );

  end;

  cmn.Lock( true );

  ObjAnimate( "obj_panel_col_"..i, "pos_xy", 0, 0, func_end,
    { 
      0.0, 0, ObjGet( "obj_panel_col_"..i ).pos_x, ObjGet( "obj_panel_col_"..i ).pos_y,
      0.3, 0, ObjGet( "obj_panel_col_clk_"..i.."_"..j ).pos_x, ObjGet( "obj_panel_col_clk_"..i.."_"..j ).pos_y,
    } );  

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_panel_clk1", 0, "", 0 );

end;
--*********************************************************************************************************************
function private.Key_Event_Menter ( id )

  common_impl.SetCursor( CURSOR_HAND );
  ObjAnimate( "spr_panel_light_key_"..id, "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_panel_light_key_"..id ).alp,
      0.2, 0, 1
    } );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_menter1", 0, "", 0 );

end;
--*********************************************************************************************************************
function private.Key_Event_Mleave ( id )

  common_impl.SetCursor( CURSOR_DEFAULT );
  ObjAnimate( "spr_panel_light_key_"..id, "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_panel_light_key_"..id ).alp,
      0.2, 0, 0
    } );

end;
--*********************************************************************************************************************
function private.ClkKey ( id )

  local func_end = function () 

    private.CheckKey( id );

  end;

  cmn.Lock( true );
  ObjSet( "tmr_panel_move_key" , 
    { 
      playing = true, 
      time = 0.000001,  
      endtrig = func_end         
    } );

  if ( not private.flag_sound_clk ) then

    if ( private.CheckKeyCross( id ) ) then

      common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

    else

     common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_panel_clk2", 0, "", 0 );

    end

    private.flag_sound_clk = true;

  end;

end;
--*********************************************************************************************************************
function private.CheckKey ( id )

  if ( private.CheckKeyCross( id ) ) then

    ng_global.progress[ "std" ][ "win_panel" ].state_coord[ id ][ 1 ] = ObjGet( "spr_panel_key_"..id ).pos_x;
    ng_global.progress[ "std" ][ "win_panel" ].state_coord[ id ][ 2 ] = ObjGet( "spr_panel_key_"..id ).pos_y;

    ObjSet( "tmr_panel_move_key" , { playing = false } ); 
    cmn.Lock( false ); 

    private.flag_sound_clk = false;

  elseif ( id == 1 or id == 2 ) then 

    if ( ObjGet( "spr_panel_key_"..id ).pos_x <= -22 ) then

      private.WinKeyAnim( id ); 
      cmn.Lock( false ); 

      private.flag_sound_clk = false;

    else   
      
      local curr_pos = ObjGet( "spr_panel_key_"..id ).pos_x;
      ObjSet( "spr_panel_key_"..id, {  pos_x = curr_pos - private.move_step } );
      private.ClkKey( id );

    end;

  elseif ( id == 3 ) then

    if ( ObjGet( "spr_panel_key_"..id ).pos_x >= 963 ) then

      private.WinKeyAnim( id ); 
      cmn.Lock( false ); 

      private.flag_sound_clk = false;

    else  

      local curr_pos = ObjGet( "spr_panel_key_"..id ).pos_x;
      ObjSet( "spr_panel_key_"..id, {  pos_x = curr_pos + private.move_step } );
      private.ClkKey( id );

    end;

  end;  

end;
--*********************************************************************************************************************
function private.CheckKeyCross ( id )

  local bool = false;

  for i = 1, private.count_cross[ id ] do

    local name_key = "obj_panel_key_"..id.."_cross_"..i;

    for j = 1, private.count_rounds do

      if ( cmn.ApplyObj( name_key, "obj_panel_cross_"..j ) ) then

        bool = true;
        break;            

      end;

    end;

  end;

  return bool;  

end;
--*********************************************************************************************************************
function private.WinKeyAnim ( id )
  

  local end_pos_x = -271;

  if ( id == 3 ) then

    end_pos_x = 1242;

  end;

  local fun_end = function ()

    if ( private.HowManyKeys() == 2 ) then 
  
      private.Win();      

    else
      
      ObjSet( "spr_panel_key_"..id, { input = false, alp = 0 } );
      ng_global.progress[ "std" ][ "win_panel" ].state[ id ] = true;
      ng_global.progress[ "std" ][ "win_panel" ].state_coord[ id ][ 1 ] = ObjGet( "spr_panel_key_"..id ).pos_x;
      ng_global.progress[ "std" ][ "win_panel" ].state_coord[ id ][ 2 ] = ObjGet( "spr_panel_key_"..id ).pos_y;

    end;  

  end;

  cmn.Lock( true );
  ObjAnimate( "spr_panel_key_"..id, "pos_x", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_panel_key_"..id ).pos_x,
      0.5, 0, end_pos_x
    } );  
  ObjAnimate( "spr_panel_key_"..id, "alp", 0, 0, fun_end,
    { 
      0.0, 0, 1,
      0.5, 0, 0
    } );  

end;
--*********************************************************************************************************************
function private.HowManyKeys ()

  local count = 0;
  for i = 1, private.count_keys do

    if ( ng_global.progress[ "std" ][ "win_panel" ].state[ i ] ) then

      count = count + 1;

    end;

  end;

  return count;
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_panel_light", "alp", 1, 0, "",
  { 
    0.0, 0, 1.0,
    3.0, 0, 0.3,
    6.0, 0, 1.0
  } );  

end;




 