-- name=level1

function public.Start ( param )


  
  interface.WidgetAdd( InterfaceWidget_Pause, 10000000 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 20 );

  if IsCollectorsEdition() then

    interface.WidgetAdd( InterfaceWidget_BtnGuide, 20 );

  end;

  interface.WidgetAdd( InterfaceWidget_BtnHint, 11  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 12 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 27 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 27 );

  --interface.WidgetAdd( InterfaceWidget_TaskHeader );
  interface.WidgetAdd( InterfaceWidget_Inventory, 9 );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 10 );

  interface.WidgetAdd( InterfaceWidget_Effects, 11 );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 11 );

  interface.WidgetAdd( InterfaceWidget_DialogHo, 19 );

  interface.ButtonLockAdd();
  interface.LockAdd();

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8);

  interface.WidgetAdd( InterfaceWidget_ItemPanel );
  interface.WidgetAdd( InterfaceWidget_Popup, 27 );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog, 26 );

  interface.WidgetAdd( InterfaceWidget_DialogVideo, 26 );
  interface.WidgetAdd( InterfaceWidget_DialogStory );
  interface.WidgetAdd( InterfaceWidget_DialogCharacter, 8 );

  interface.WidgetAdd( InterfaceWidget_StrategyGuide, 28 );
  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial );

  interface.WidgetAdd( InterfaceWidget_Map, 26  );

  interface.PanelNotificationAdd();
  interface.DeployInvAdd( 9 );
  interface.DialogHintAdd();
  interface.ButtonTaskAdd( 1 );
  interface.DialogTaskAdd( 20 );  
  interface.DiaryAdd( 28 );
  
  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    interface.BtnCollectibles2Add( 18 );
    interface.BtnCollectiblesAdd( 18 );
    interface.AchievementsAdd( 18 );
    interface.BtnMorphAdd( 18 );

  end;

  private.Init();

  ModLoad( "assets/levels/level1/mod_level1_inv" );
  level1_inv.Init();

  common.LevelLoad( "level1", "std", "rm_park_1", param, private.menu_moduls );
  --ModLoad( "assets/interface/map/mod_map" );

  common_impl.Collectibles2Load();
  common_impl.AchievementsLoad();

  private.TutorialSetParams();
  interface.KeyUpdate();

  cmn.PlayMusEnv();

end;
    
function private.Init ()

  game = {};
  game.room_names =
  {
    "rm_park_1"
    ,"rm_park_2"
    ,"rm_car"
    ,"rm_porch"
    ,"rm_hall"
    ,"rm_courtyard"
    ,"rm_lounge"
    ,"rm_bar"
    ,"rm_corridor"
    ,"ho_suitcase"
    ,"ho_stash"
    ,"ho_floorhole"
    ,"mg_superpuzzle1"
    ,"mg_panel"
    ,"rm_demo"
  };
  game.progress_names_room =
  {
   { "see_intro" }
  ,{ "opn_park_1" }
  ,{ "dlg_park_1_professor_1" ,              "rm_park_1" ,             { "opn_park_1" } }
  ,{ "win_small_suitcase"  }
  ,{ "opn_suitcase" }
  ,{ "win_suitcase",                         "rm_park_1",              { "win_small_suitcase" } }
  ,{ "use_certificate",                      "rm_park_1",              { "win_suitcase" } }
  ,{ "dlg_park_1_professor_2" ,              "rm_park_1" ,             { "use_certificate" } }
  ,{ "see_attempt",                          "rm_park_1" ,             { "dlg_park_1_professor_2" } }
  ,{ "get_gloves",                           "rm_park_1",              { "see_attempt" } }  
  ,{ "use_gloves_1",                         "rm_park_1",              { "get_gloves" } }
  ,{ "clk_sofit_1",                          "rm_park_1",              { "use_gloves_1" } }
  ,{ "clk_sofit_2",                          "rm_park_1",              { "clk_sofit_1" } }
  ,{ "clk_sofit_3",                          "rm_park_1",              { "clk_sofit_2" } }
  ,{ "get_sofit",                            "rm_park_1",              { "clk_sofit_3" } }
  ,{ "clk_shot_1" }
  ,{ "use_gloves_3",                         "rm_park_1",              { "get_gloves" } }
  ,{ "get_metallic_shield",                  "rm_park_1",              { "use_gloves_3" } }
  ,{ "opn_park_2" }
  ,{ "dlg_park_2_professor_4" ,              "rm_park_2" ,             { "opn_park_2" } }
  ,{ "clk_shot_2",                           "rm_park_2",              { "dlg_park_2_professor_4" } }
  ,{ "clk_floor",                            "rm_park_2",              { "dlg_park_2_professor_4" }  }
  ,{ "use_gloves_2",                         "rm_park_2",              { "clk_floor" } }
  ,{ "get_hook",                             "rm_park_2",              { "use_gloves_2" } }
  ,{ "clk_hook_1" }
  ,{ "clk_hook_2" }
  ,{ "clk_hook_3" }
  ,{ "use_hook" }
  ,{ "get_sofit_hook" }
  ,{ "use_sofit_hook_1",                     "rm_park_2",              { "get_sofit_hook" } }
  ,{ "use_sofit_hook_2",                     "rm_park_2",              { "use_sofit_hook_1" } }
  ,{ "see_park_2_professor_escape",          "rm_park_2",              { "use_sofit_hook_2" } }
  ,{ "opn_car" }
  ,{ "see_bodyguard",                        "rm_car",                 { "opn_car" } }
  ,{ "see_trip",                             "rm_car",                 { "see_bodyguard" } }
  ,{ "dlg_car_in_the_car",                   "rm_car",                 { "see_trip" } }
  ,{ "see_exit_car",                         "rm_car",                 { "dlg_car_in_the_car" } }
  ,{ "opn_porch" }
  ,{ "dlg_porch_professor_bodyguard",        "rm_porch",               { "opn_porch" } }
  ,{ "see_leave_bodyguard",                  "rm_porch",               { "dlg_porch_professor_bodyguard" } }
  ,{ "dlg_car_driver",                       "rm_car",                 { "see_leave_bodyguard" } }
  ,{ "get_trunk_code",                       "rm_car",                 { "dlg_car_driver" } }
  ,{ "use_trunk_code",                       "rm_porch",               { "get_trunk_code" } }
  ,{ "win_trunk_code",                       "rm_porch",               { "use_trunk_code" } }
  ,{ "clk_porch_trash_1",                    "rm_porch",               { "win_trunk_code" } }
  ,{ "clk_porch_trash_2",                    "rm_porch",               { "clk_porch_trash_1" } }
  ,{ "get_reynolds_case",                    "rm_porch",               { "clk_porch_trash_2" } }
  ,{ "use_reynolds_case",                    "rm_porch",               { "get_reynolds_case" } }
  ,{ "see_screaming_bodyguard",              "rm_porch",               { "use_reynolds_case" } }
  --rm hall
  ,{ "opn_hall" }
  ,{ "see_disappearance_professor",          "rm_hall",                { "opn_hall" } }
  ,{ "see_masked_man_1",                     "rm_hall",                { "see_disappearance_professor" } }
  ,{ "clk_courtyard_door",                   "rm_hall",                { "see_masked_man_1" } } 
  ,{ "get_slider",                           "rm_hall",                { "clk_courtyard_door" } }
  ,{ "use_slider",                           "rm_hall",                { "get_slider" } }
  ,{ "clk_reception_slider",                 "rm_hall",                { "use_slider" } }
  ,{ "clk_reception_paperclip_1",            "rm_hall",                { "clk_reception_slider" } }
  ,{ "clk_reception_paperclip_2",            "rm_hall",                { "clk_reception_paperclip_1" } }
  ,{ "get_picklockclip",                     "rm_hall",                { "clk_reception_paperclip_2" } }
  ,{ "use_picklockclip",                     "rm_hall",                { "get_picklockclip" } }
  ,{ "get_toolbox",                          "rm_hall",                { "use_picklockclip" } }
  ,{ "get_magnet",                           "rm_hall",                { "see_masked_man_1" } }
  ,{ "use_magnet_1",                         "rm_hall",                { "get_magnet" } }
  ,{ "get_hexagon1",                         "rm_hall",                { "use_magnet_1" } }
  ,{ "use_hexagon1" }
  ,{ "clk_hexagon1" }
  ,{ "get_screwdriver" }
  ,{ "use_magnet_2",                         "rm_hall",                { "get_toolbox", "get_magnet" } }
  ,{ "get_receptionbell",                    "rm_hall",                { "use_magnet_2" }  }
  ,{ "use_receptionbell",                    "rm_hall",                { "get_receptionbell" } }
  ,{ "clk_reception_bell",                   "rm_hall",                { "use_receptionbell" }  }
  ,{ "get_bulbbox",                          "rm_hall",                { "clk_reception_bell" } }
  ,{ "clk_bulbbox_1" }
  ,{ "clk_bulbbox_2" }
  ,{ "get_bulb" }
  ,{ "use_bulb",                             "rm_hall",                { "get_bulb" } }
  ,{ "use_screwdriver_1",                    "rm_hall",                { "get_screwdriver" }  }
  ,{ "get_valve",                            "rm_hall",                { "use_screwdriver_1" } }
  ,{ "get_lionpen1",                         "rm_hall",                { "use_screwdriver_1" } }
  ,{ "get_scoop",                            "rm_hall",                { "see_masked_man_1" } }
  ,{ "use_valve",                            "rm_hall",                { "get_valve" } }
  ,{ "use_scoop",                            "rm_hall",                { "get_scoop" } }
  ,{ "clk_bodyguardthings_valve",            "rm_hall",                { "use_valve", "use_scoop" } }
  ,{ "get_saucepan",                         "rm_hall",                { "clk_bodyguardthings_valve" } }
  ,{ "use_lionpen1",                         "rm_hall",                { "get_lionpen1" } }
  ,{ "clk_reception_door_1",                 "rm_hall",                { "use_lionpen1" } }
  ,{ "get_plaster",                          "rm_hall",                { "clk_reception_door_1" } }
  ,{ "use_plaster" }
  ,{ "get_waterscoop" }
  ,{ "use_waterscoop",                       "rm_hall",                { "get_waterscoop" } }
  ,{ "get_hexagon2",                         "rm_hall",                { "use_waterscoop" } }
  ,{ "see_hall_scare_2",                     "rm_hall",                { "get_hexagon2" } }
  ,{ "use_hexagon2" }
  ,{ "clk_hexagon2" }
  ,{ "get_boxwrench" }
  ,{ "use_boxwrench",                        "rm_hall",                { "get_boxwrench" } }
  ,{ "get_leverlamp",                        "rm_hall",                { "use_boxwrench" } }
  ,{ "use_leverlamp",                        "rm_hall",                { "get_leverlamp" } }
  ,{ "win_lampwall",                         "rm_hall",                { "use_leverlamp", "use_bulb" } }
  ,{ "see_flashback_hall",                   "rm_hall",                { "win_lampwall" } }
  --rm courtyard
  ,{ "opn_courtyard" }
  ,{ "clk_bar_door",                         "rm_courtyard",           { "opn_courtyard" } } 
  ,{ "get_button",                           "rm_courtyard",           { "opn_courtyard" } }
  ,{ "use_button",                           "rm_courtyard",           { "get_button" } }
  ,{ "clk_button",                           "rm_courtyard",           { "use_button" } }
  ,{ "get_lionpen2",                         "rm_courtyard",           { "clk_button" } }
  ,{ "get_codedpaper",                       "rm_courtyard",           { "clk_button" } }
  ,{ "use_lionpen2",                         "rm_hall",                { "get_lionpen2" } }
  ,{ "clk_reception_door_2",                 "rm_hall",                { "use_lionpen2" } }
  ,{ "get_developingliquid",                 "rm_hall",                { "clk_reception_door_2" } }
  ,{ "get_razor",                            "rm_hall",                { "clk_reception_door_2" } }
  ,{ "clk_codedpaper1" }
  ,{ "clk_codedpaper2" }
  ,{ "use_developingliquid" }
  ,{ "clk_codedpaper3" }
  ,{ "get_antirustrecipe" }
  ,{ "see_courtyard_scare_1",                "rm_courtyard",           { "get_antirustrecipe" } }
  ,{ "use_antirustrecipe",                   "rm_courtyard",           { "get_antirustrecipe" } }
  ,{ "win_chemicalsshelf",                   "rm_courtyard",           { "use_antirustrecipe" } }
  ,{ "get_antirust",                         "rm_courtyard",           { "win_chemicalsshelf" } }
  ,{ "use_antirust_1",                       "rm_courtyard",           { "get_antirust" } }
  ,{ "clk_floormechanism_antirust_1",        "rm_courtyard",           { "use_antirust_1" } }
  ,{ "clk_floormechanism_folder",            "rm_courtyard",           { "clk_floormechanism_antirust_1" } }
  ,{ "get_crossbow",                         "rm_courtyard",           { "clk_floormechanism_antirust_1" } }
  ,{ "get_loungekey",                        "rm_courtyard",           { "clk_floormechanism_antirust_1" } }
  ,{ "use_razor",                            "rm_courtyard",           { "get_razor" } }
  ,{ "use_loungekey",                        "rm_courtyard",           { "get_loungekey", "use_razor" }  }
  ,{ "clk_loungekey_1",                      "rm_courtyard",           { "use_loungekey" }  }
  ,{ "clk_loungekey_2",                      "rm_courtyard",           { "clk_loungekey_1" }  }
  -- rm_lounge
  ,{ "opn_lounge" }
  ,{ "anm_chargedcrossbow" }
  ,{ "use_magnet_3",                         "rm_lounge",              { "opn_lounge" }  }
  ,{ "get_arrow",                            "rm_lounge",              { "use_magnet_3" }  }
  ,{ "use_arrow" }
  ,{ "clk_crossbow_1" }
  ,{ "clk_crossbow_2" }
  ,{ "get_chargedcrossbow" }
  ,{ "use_chargedcrossbow",                  "rm_lounge",              { "get_chargedcrossbow" } }
  ,{ "win_lounge",                           "rm_lounge",              { "use_chargedcrossbow" } } --ммг арболет
  ,{ "see_masked_man_3",                     "rm_lounge" ,             { "win_lounge" } }
  ,{ "get_broom",                            "rm_courtyard",           { "see_masked_man_1" }  }
  ,{ "use_broom",                            "rm_lounge",              { "see_masked_man_3", "get_broom" } }
  ,{ "get_brokenbroom",                      "rm_lounge",              { "use_broom" } }
  ,{ "get_crystalfigurine",                  "rm_lounge",              { "use_broom" } }  
  ,{ "opn_floorhole" }
  ,{ "win_floorhole",                        "rm_lounge",              { "get_crystalfigurine" } }
  ,{ "use_hexagon3" }
  ,{ "clk_hexagon3" }
  ,{ "get_clippers" }
  ,{ "use_clippers_1",                       "rm_hall",                { "get_clippers" } }
  ,{ "get_chain1",                           "rm_hall",                { "use_clippers_1" } }
  ,{ "get_boathookhead",                     "rm_hall",                { "use_clippers_1" } }
  ,{ "see_hall_scare_3",                     "rm_hall",                { "get_chain1" } }
  ,{ "clk_boathookhead_1" }
  ,{ "clk_boathookhead_2" }
  ,{ "use_boathookhead" }
  ,{ "get_boathook" }
  ,{ "see_lounge_scare_1",                   "rm_lounge",              { "get_broom" } }
  ,{ "use_boathook_1",                       "rm_lounge",              { "get_boathook" }  }
  ,{ "get_drainplug",                        "rm_lounge",              { "use_boathook_1" }  }
  ,{ "clk_chain2_1" }
  ,{ "clk_chain2_2" }
  ,{ "get_chain2" }
  ,{ "use_chain",                            "rm_courtyard",           { "get_chain1", "get_chain2" } }
  ,{ "win_floormechanism",                   "rm_courtyard",           { "use_chain" } }
  ,{ "see_flashback_courtyard",              "rm_courtyard",           { "win_floormechanism" } }
  --bar
  ,{ "opn_bar" }
  ,{ "see_turn_off_light",                   "rm_bar",                 { "opn_bar" } }
  ,{ "use_clippers_2",                       "rm_bar",                 { "see_turn_off_light" } }
  ,{ "clk_panel",                            "rm_bar",                 { "use_clippers_2" } }
  ,{ "win_panel",                            "rm_bar",                 { "clk_panel" } }
  ,{ "get_safetylock",                       "rm_bar",                 { "win_panel"  } }
  ,{ "see_turn_on_light",                    "rm_bar",                 { "get_safetylock" } }
  ,{ "use_safetylock",                       "rm_lounge",              { "get_safetylock" } }
  ,{ "clk_safetylock_1",                     "rm_lounge",              { "use_safetylock" } }
  ,{ "clk_safetylock_2",                     "rm_lounge",              { "clk_safetylock_1" } }
  ,{ "get_wire",                             "rm_lounge",              { "clk_safetylock_2" } }
  ,{ "see_lounge_scare_2",                   "rm_lounge",              { "get_wire" } }
  ,{ "use_wire",                             "rm_lounge",              { "get_wire" } }
  ,{ "clk_wire",                             "rm_lounge",              { "use_wire" } }
  ,{ "get_switch",                           "rm_lounge",              { "clk_wire" } }
  ,{ "use_switch",                           "rm_lounge",              { "get_switch" } }
  ,{ "clk_switch",                           "rm_lounge",              { "use_switch" } }
  ,{ "get_mousetrap",                        "rm_lounge",              { "clk_switch" } }
  ,{ "clk_spring_1" }
  ,{ "clk_spring_2" }
  ,{ "get_spring" }
  ,{ "see_courtyard_scare_2",                "rm_courtyard",           { "get_spring" } }
  ,{ "clk_spring_mousehole",                 "rm_lounge",              { "clk_switch" } }
  ,{ "use_spring",                           "rm_lounge",              { "get_spring", "clk_spring_mousehole" } }
  ,{ "get_figurinepart",                     "rm_lounge",              { "use_spring" } }
  ,{ "use_figurinepart",                     "rm_lounge",              { "get_figurinepart" } }
  ,{ "clk_figurinepart",                     "rm_lounge",              { "use_figurinepart" } }
  ,{ "opn_stash",                            "rm_lounge",              { "clk_figurinepart" } }
  ,{ "win_stash",                            "rm_lounge",              { "clk_figurinepart" } }
  ,{ "clk_stashwall_web",                    "rm_bar",                 { "see_turn_on_light" } }
  ,{ "get_bottle",                           "rm_bar",                 { "clk_stashwall_web" } }
  ,{ "use_hammer" }
  ,{ "get_glasspiece" }
  ,{ "get_plug" }
  ,{ "get_triangle1" }
  ,{ "see_bar_scare_1",                      "rm_bar",                 { "get_triangle1" } }
  ,{ "use_glasspiece",                       "rm_bar",                 { "get_glasspiece" } }
  ,{ "get_rope",                             "rm_bar",                 { "use_glasspiece" } }
  ,{ "clk_triangle2",                        "rm_bar",                 { "see_turn_on_light" } }
  ,{ "get_triangle2",                        "rm_bar",                 { "clk_triangle2" } }
  ,{ "use_screwdriver_2",                    "rm_lounge",              { "get_screwdriver" } }
  ,{ "get_basreliefpart",                    "rm_lounge",              { "use_screwdriver_2" } }
  ,{ "use_basreliefpart",                    "rm_bar",                 { "get_basreliefpart" } }
  ,{ "win_barstand",                         "rm_bar",                 { "use_basreliefpart" } }
  ,{ "get_register",                         "rm_bar",                 { "win_barstand" } } -- ММГ Барельеф.
  ,{ "clk_triangle3_1" }
  ,{ "clk_triangle3_2" }
  ,{ "clk_triangle3_3" }
  ,{ "clk_triangle3_4" }
  ,{ "get_triangle3" }
  ,{ "see_masked_man_4",                     "rm_bar" ,                { "get_triangle3" } }
  ,{ "clk_stashwall_door",                   "rm_bar",                 { "get_rope" } }
  ,{ "use_triangle",                         "rm_bar",                 { "get_triangle1", "get_triangle2", "get_triangle3", "clk_stashwall_door" } }
  ,{ "clk_stashwall_button",                 "rm_bar",                 { "use_triangle" }  }
  ,{ "win_superpuzzle1",                     "rm_bar",                 { "clk_stashwall_button" } }
  ,{ "opn_corridor" }
  ,{ "see_outro",                            "rm_corridor",            { "opn_corridor" } } 
  ,{ "get_collect_morph_item_1_1" }
  ,{ "get_collect_morph_item_1_2" }
  ,{ "get_collect_morph_item_1_3" }
  ,{ "get_collect_morph_item_1_4" }

  ,{ "get_collect_item_1_1" }
  ,{ "get_collect_item_1_2" }
  ,{ "get_collect_item_1_3" }
  };

  game.progress_names = {};
  for i = 1, #game.progress_names_room do
    game.progress_names[ i ] = game.progress_names_room[ i ][ 1 ];
  end;
  
  game.relations = {};

  private.menu_moduls = {
    "rm_credits"
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {
      "rm_collectibles2",
      "rm_collectibles",
      "rm_achievements",
    }

    for i = 1, #menu_moduls_ce do

      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );

    end;

  end;

end;

function private.TutorialSetParams()

  if not ng_global.progress[ "std" ][ "see_tutorial" ] then

    ng_global.progress[ "std" ][ "see_tutorial" ] = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].done  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].start = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].state.no  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state.currentpage = "tutorial_page_1";
    ng_global.progress[ "std" ][ "see_tutorial" ].func = function()
      --
    end;
    local offset = 0;

    if ( GetWideScreen() ) then

      offset = 0.5 * ( GetAppWidth() - 1024 );
      

    end;


    ng_global.progress[ "std" ][ "see_tutorial" ].state.pages = {

      [ "tutorial_page_1" ] = { shown = 0, noskip = true, posx = 512, posy = 200, arrows = {} } , -- Показать туториал? 

      [ "tutorial_page_2" ] = { shown = 0, noskip = false, posx = 650, posy = 150, arrows = { 
                                                                              { pos_x = 410, pos_y = 290, ang =  2.3 }
                                                                            } },   -- клик на профессора

      [ "tutorial_page_3" ] = { shown = 0, noskip = false, posx = 300, posy = 450, arrows = { 
                                                                              { pos_x = 280, pos_y = 650, ang =  3.14 }
                                                                            } },   -- клик на чемодан
      [ "tutorial_page_4" ] = { shown = 0, noskip = false, posx = 350, posy = 150, arrows = { 
                                                                              { pos_x = 100, pos_y = -50, ang =  2.3, target = "obj_int_button_info" }
                                                                            } },   -- МГ инфо
      [ "tutorial_page_5" ] = { shown = 0, noskip = false, posx = 800, posy = 200, arrows = { 
                                                                              { pos_x = 0, pos_y = -80, ang =  3.5, target = "obj_int_button_skip_impl" }
                                                                            } },   -- МГ скип
      [ "tutorial_page_6" ] = { shown = 0, noskip = false, posx = 512, posy = 300, arrows = {} },   -- ХО под каждым объектом осколок
      [ "tutorial_page_7" ] = { shown = 0, noskip = false, posx = 480, posy = 480, arrows = { 
                                                                               { pos_x = 220, pos_y = 380, ang =  1 }
                                                                            } },   -- подбор перчатки
      [ "tutorial_page_8" ] = { shown = 0, noskip = false, posx = 300, posy = 250, arrows = { 
                                                                              { pos_x = 270, pos_y = 650, ang =  3.14 },
                                                                              { pos_x = 530, pos_y = 370, ang =  4 }
                                                                            } },   -- применение перчатки
      [ "tutorial_page_9" ] = { shown = 0, noskip = false, posx = 650, posy = 400, arrows = { 
                                                                              { pos_x = -70, pos_y = -70, ang =  3.8, target = "obj_int_button_hint_impl" }
                                                                            } },   -- клик на хинт
      [ "tutorial_page_10" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
                                                                              { pos_x = -100, pos_y = 100, ang =  -0.8, target = "obj_int_investigation_button_back"  }
                                                                            } },   -- карта
      [ "tutorial_page_11" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
                                                                              --{ pos_x = 0, pos_y = -60, ang =  3.14 }
                                                                            } },   -- локация в карте
      [ "tutorial_page_12" ] = { shown = 0, noskip = true, posx = 512, posy = 300, arrows = {} },   -- ХО найти нужный объект
      [ "tutorial_page_13" ] = { shown = 0, noskip = true, posx = 512, posy = 300, arrows = {} },   -- ХО тени
      [ "tutorial_page_14" ] = { shown = 0, noskip = true, posx = 512, posy = 200, arrows = { 
                                                                              { pos_x = -50, pos_y = -60, ang =  3.14, target = "spr_int_panel_providence" },
                                                                            } },   -- ХО пары

      [ "tutorial_page_15" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
                                                                              { pos_x = -60, pos_y = -60, ang =  -2.3, target = "obj_livingroom_providence_use_invitem_1" },
                                                                              { pos_x = 0, pos_y = -60, ang =  3.14, target = "inv_object_1" }
                                                                            } },   -- переход в ХО
      [ "tutorial_page_16" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
                                                                              { pos_x = 100, pos_y = 0, ang =  1.72, target = "spr_focus_arrow_right" },
                                                                            } },   -- ХО обычная
      [ "tutorial_page_17" ] = { shown = 0, noskip = false, posx = 350, posy = 350, arrows = { 
                                                                              { pos_x = 0, pos_y = -70, ang =  3.14, target = "obj_int_button_task" }
                                                                            } },   -- таск
      [ "tutorial_page_18" ] = { shown = 0, noskip = false, posx = 600, posy = 500, arrows = { 
                                                                              { pos_x = 150, pos_y = 0, ang =  1.6, target = "obj_int_button_collectibles2_button" }
                                                                            } },   -- колекторс2
      [ "tutorial_page_19" ] = { shown = 0, noskip = true, posx = 512, posy = 300, arrows = { 
                                                                              { pos_x = 0, pos_y = 0, ang =  -2, target = "obj_int_button_morph" }
                                                                            } },   -- морфинг
      [ "tutorial_page_20" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
                                                                              { pos_x = 150, pos_y = -50, ang =  2, target = "obj_int_button_collectibles_button" }
                                                                            } },   -- маски
      [ "tutorial_page_21" ] = { shown = 0, noskip = false, posx = 450, posy = 450, arrows = { 
                                                                              { pos_x = 50, pos_y = 50, ang =  0.6, target = "obj_int_achievements_button" }
                                                                            } },   -- ачивки

      [ "tutorial_page_23" ] = { shown = 0, noskip = false, posx = 600, posy = 450, arrows = { 
                                                                              { pos_x = 850, pos_y = 350, ang =  -1 }
                                                                            } },   -- подобрать колекторс

      [ "tutorial_page_24" ] = { shown = 0, noskip = false, posx = 400, posy = 400, arrows = { 
                                                                              { pos_x = 130, pos_y = 330, ang =  0.8 }
                                                                            } },   -- подобрать морфинг

      [ "tutorial_page_25" ] = { shown = 0, noskip = false, posx = 350, posy = 280, arrows = { 
                                                                              { pos_x = 620, pos_y = 180, ang =  -1 }
                                                                            } },   -- подобрать колекторс2

      [ "tutorial_page_26" ] = { shown = 0, noskip = false, posx = 400, posy = 270, arrows = { 
                                                                              { pos_x = 670, pos_y = 350, ang =  -2 }
                                                                            } },   -- подобрать колекторс2

   };

  end;
end;
