-- name=level1_inv
--*********************************************************************************************************************
function public.Init ()
  
  if port.isPortable() == 1 then
    port.InventoryPopupInit("level1_inv_hub");
    port.VideoResizeInRoom("level1_inv");
  end;
  private.small_suitcase_init();
  private.sofit_init();
  private.toolbox_init();
  private.bulbbox_init();
  private.codedpaper_init();
  private.crossbow_init();
  private.brokenbroom_init();
  private.drainplug_init();
  private.mousetrap_init();
  private.bottle_init();
  private.register_init();
  private.saucepan_init();

  --ObjSet( "", {  } );
  ObjMultiSet({ 
  { "obj_deploy_inv_small_suitcase_win",        { event_mdown = private.SmallSuitcaseWin } },
  { "inv_small_suitcase",                       { event_mdown = private.Show_Small_Suitcase } }
  });

  -- sound on all inventory objects during dragging for conteiner inventory_hub

  local invRelationsHub1 = ObjGetRelations( "level1_inv_hub" );

  if invRelationsHub1.childs then
    
    for i = 1, #invRelationsHub1.childs, 1 do 
      
      local invCurrent = invRelationsHub1.childs[i];
      ObjSet( invCurrent, { event_startdrag = cmn.GetInvObjectSfx } );
      
    end;
    
  end;

end;

--*********************************************************************************************************************
function private.StringDivide ( string )  

  local table = { };
  local id = 1;
  local il = 1;

  for i = 1, string.len( string ) do

    if ( string.sub( string, i, i ) == "_" ) then

      table[ id ] = string.sub( string, il, i - 1 );
      il = i + 1;
      id = id + 1;

    end

    if ( i == string.len( string ) ) then

      table[id] = string.sub( string, il, i );
      il = i + 1;
      id = id + 1;

    end

  end

  return table;

end;
--*********************************************************************************************************************
function private.ObjIntersectCheck ( obj_to_apply, obj_to_check, obj_complex_inv )

  local obj_complex_inv = obj_complex_inv or "deploy_inv_"..private.StringDivide( obj_to_check )[4];  
  
  return interface.GetCurrentInv() == obj_complex_inv and ObjIntersect( obj_to_apply, obj_to_check );

end;
--*********************************************************************************************************************
-- function *** small suitcase *** () end;
--*********************************************************************************************************************
  function private.Show_Small_Suitcase ()

    level1_inv.SmallSuitcaseInitVar();

    cmn.MiniGameShow( "small_suitcase" );
    common_impl.PassingMgStart( "small_suitcase" );

    common_impl.ShowDeployInv( "inv_small_suitcase" ); 

  end;
  --------------------------------------------------------------------------------------------
  function private.small_suitcase_init ()

    private.SmallSuitcaseInit();
    ObjMultiSet({ 
      { "inv_small_suitcase", { event_mdown = function () private.ItemGo(); end } },
    });
    --------------------------------------------------------------------------------------------
    -- function win_small_suitcase () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "win_small_suitcase" ] =
    {
      type = "click",
      use_place = "obj_deploy_inv_small_suitcase_win",
      room = "int_deploy_inv",
      zz = "deploy_inv_small_suitcase",
      zz_gate = "inv_small_suitcase"
    };
    -----------------------------------------------
    local win_small_suitcase_inv = function ()

      if ( cmn.IsEventDone( "win_small_suitcase" ) ) then

        interface.InventoryItemRemove( "inv_small_suitcase" );

      end;

    end;

    local win_small_suitcase = function ()

      if ( cmn.IsEventDone( "win_small_suitcase" ) ) then

        ObjSet( "spr_deploy_inv_small_suitcase_cover_2", { alp = 1 } );

      elseif ( cmn.IsEventStart( "win_small_suitcase" ) ) then

        private.SmallSuitcaseLoad();

      end;

    end;

    local win_small_suitcase_loc = function ()

      if ( cmn.IsEventDone( "win_small_suitcase" ) ) then

        ObjSet( "spr_park_1_suitcase", { alp = 1 } );
        ObjSet( "gho_park_1_suitcase", { active = true, input = true } );

      end;

    end;

    cmn.AddSubscriber( "win_small_suitcase", win_small_suitcase_inv );
    cmn.AddSubscriber( "win_small_suitcase", win_small_suitcase, "inv_small_suitcase" );
    cmn.AddSubscriber( "win_small_suitcase", win_small_suitcase_loc, "rm_park_1" );

  end;
  --*********************************************************************************************************************
  -- function *** MMG SMALL SUITCASE *** () end;
  --*********************************************************************************************************************
    function private.SmallSuitcaseInit ()

      int_deploy_inv.Define( "small_suitcase" );

      local tb = {}

      for i = 1, 4 do

        table.insert( tb, { "obj_deploy_inv_small_suitcase_panel_key_"..i,
        {
          event_mdown = function () private.SmallSuitcaseClick( i ); end ,
          event_menter = function () common_impl.SetCursor( CURSOR_HAND );  end,
          event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end } 
        } );

      end;

      ObjMultiSet( tb );

      private.small_suitcase_key_click = 1;
      private.small_suitcase_key = { 2, 4, 1, 3 };

      ---------------------------------------------------------------------------------
      function small_suitcase.Skip ()   

        local func_end = "";

        cmn.Lock( true );

        for i = 1, 4 do

          if ( i == 4 ) then

            func_end = function ()

              cmn.Lock( false );

              private.SmallSuitcaseWin();

            end;

          end

          local obj = "spr_deploy_inv_small_suitcase_panel_key_"..i.."_2";

          ObjAnimate( obj, "alp", 0, 0, func_end,
          {

            0.0, 0, ObjGet( obj ).alp,
            0.3, 3, 1

          } );

        end;

      end;
      ---------------------------------------------------------------------------------
      function small_suitcase.Reset () 

        private.small_suitcase_key_click = 1;

        local func_end = ""

        cmn.Lock( true );

        common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_case_clk1" );

        for i = 1, 4 do

          if ( i == 4 ) then

            func_end = function ()

              cmn.Lock( false );

              public.SmallSuitcaseInitVar();

            end;

          end

          ObjSet( "obj_deploy_inv_small_suitcase_panel_key_"..i, { input = true } );

          ObjAnimate( "spr_deploy_inv_small_suitcase_panel_key_"..i.."_2", "alp", 0, 0, func_end,
          {
            0.0, 0, ObjGet( "spr_deploy_inv_small_suitcase_panel_key_"..i.."_2" ).alp,
            0.3, 0, 0
          } );

        end;

      end;
      ---------------------------------------------------------------------------------

    end;

    -----------------------------------------------------------------------------------
    function private.SmallSuitcaseLoad ()

      if ng_global.progress[ "std" ][ "win_small_suitcase" ].key_click then

        local key_click = ng_global.progress[ "std" ][ "win_small_suitcase" ].key_click;

        private.small_suitcase_key_click = key_click;

        for i = 1, ( private.small_suitcase_key_click - 1 ) do

          ObjSet( "spr_deploy_inv_small_suitcase_panel_key_"..private.small_suitcase_key[ i ].."_2", { alp = 1, input = false } );

        end;

      end;

    end;
    -----------------------------------------------------------------------------------
    function public.SmallSuitcaseInitVar ()

      private.small_suitcase_key_click = 1;
      --ng_global.progress[ "std" ][ "win_small_suitcase" ].key_click = 1;

    end;
    -----------------------------------------------------------------------------------
    function private.SmallSuitcaseClick ( key )

      local func_end = function ()

        cmn.Lock( false );

        if key == private.small_suitcase_key[ private.small_suitcase_key_click ] then

          private.small_suitcase_key_click = private.small_suitcase_key_click + 1;

          private.SmallSuitcaseIsWin();

        else

          small_suitcase.Reset();

        end;

      end;

      cmn.Lock( true );

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_case_clk1" );

      ObjSet( "obj_deploy_inv_small_suitcase_panel_key_"..key, { input = false } );
      ObjAnimate( "spr_deploy_inv_small_suitcase_panel_key_"..key.."_2", "alp", 0, 0, func_end, { 0, 0, 0,   0.3, 0 ,1 } );

    end;
    -----------------------------------------------------------------------------------
    function private.SmallSuitcaseSaveVar ()

      ng_global.progress[ "std" ][ "win_small_suitcase" ].key_click = private.small_suitcase_key_click;

    end;
    -----------------------------------------------------------------------------------
    function private.SmallSuitcaseIsWin ()

      if private.small_suitcase_key_click == 5 then

        private.SmallSuitcaseWin();

      else

        private.SmallSuitcaseSaveVar()

      end;

    end;
    -----------------------------------------------------------------------------------
    function private.SmallSuitcaseWin ()

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_case_opn" );

      local func_end = function ()

        cmn.Lock( false );

        cmn.MiniGameHide( "small_suitcase" );

        cmn.SetEventDone( "win_small_suitcase" );
        cmn.CallEventHandler( "win_small_suitcase", "inv_small_suitcase" );

        common_impl.PassingMgWin( "small_suitcase" );

        common_impl.HideDeployInv();

        cmn.GotoRoom( "ho_suitcase" );

      end;

      cmn.Lock( true );

      ObjAnimate( "spr_deploy_inv_small_suitcase_cover", "alp", 0, 0, func_end, { 0, 0, 0,   0.3, 0, 1 } );

    end;
  -----------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** sofit *** () end;
--*********************************************************************************************************************
  function private.sofit_init ()

    --------------------------------------------------------------------------------------------
    ObjMultiSet({ 
      { "spr_deploy_inv_sofit_1", { event_mdown = private.get_sofit_hook } },
      { "spr_deploy_inv_sofit_2", { event_mdown = private.get_sofit_hook } },
      { "spr_deploy_inv_sofit_3", { event_mdown = private.get_sofit_hook } },
      { "spr_deploy_inv_sofit_4", { event_mdown = private.get_sofit_hook } },
      { "spr_deploy_inv_sofit_hook", { event_mdown = private.get_sofit_hook } },
      { "obj_deploy_inv_sofit_clk_hook_1", { event_mdown = private.clk_hook_1 } },
      { "obj_deploy_inv_sofit_clk_hook_2", { event_mdown = private.clk_hook_2 } },
      { "obj_deploy_inv_sofit_clk_hook_3", { event_mdown = private.clk_hook_3 } },
    });
    --------------------------------------------------------------------------------------------
    -- function use_hook () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_hook" ] = {
        type = "use",
        inv_obj = "inv_hook",
        use_place = "obj_deploy_inv_sofit_use_hook",
        room = "int_deploy_inv",
        zz = "deploy_inv_sofit",
        zz_gate = "inv_sofit"
    };

    local use_hook_inv = function ()
      
      interface.InventoryItemRemove( "inv_hook" );

    end;

    local use_hook_beg = function ()

      ObjDelete( "obj_deploy_inv_sofit_use_hook" );

    end;
    local use_hook_end = function ()

      ObjSet( "spr_deploy_inv_sofit_hook", { alp = 1 } );

      if cmn.IsEventDone( "clk_hook_3" ) then

        ObjSet( "obj_deploy_inv_sofit", { input = true } );
        ObjSet( "gfx_deploy_inv_sofit", { active = true } );

      end;

    end;

    cmn.AddSubscriber( "use_hook", use_hook_inv );
    cmn.AddSubscriber( "use_hook", use_hook_beg, "inv_sofit" );
    cmn.AddSubscriber( "use_hook", use_hook_end, "inv_sofit" );
    cmn.AddSubscriber( "use_hook_inv", use_hook_inv );
    cmn.AddSubscriber( "use_hook_beg", use_hook_beg, "inv_sofit" );
    cmn.AddSubscriber( "use_hook_end", use_hook_end, "inv_sofit" );
    --------------------------------------------------------------------------------------------
    -- function clk_hook_1 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_hook_1" ] = {
        type = "click",
        use_place = "obj_deploy_inv_sofit_clk_hook_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_sofit",
        zz_gate = "inv_sofit"
    };

    local clk_hook_1_beg = function ()

      ObjDelete( "obj_deploy_inv_sofit_clk_hook_1" );

    end;
    local clk_hook_1_end = function ()

      ObjSet( "obj_deploy_inv_sofit_clk_hook_2", { input = true } );

      ObjSet( "spr_deploy_inv_sofit_3", { pos_x = 196, pos_y = -109 } );
      ObjSet( "spr_deploy_inv_sofit_4", { pos_x = -73, pos_y = 7 } );

    end;

    cmn.AddSubscriber( "clk_hook_1", clk_hook_1_beg, "inv_sofit" );
    cmn.AddSubscriber( "clk_hook_1", clk_hook_1_end, "inv_sofit" );
    cmn.AddSubscriber( "clk_hook_1_beg", clk_hook_1_beg, "inv_sofit" );
    cmn.AddSubscriber( "clk_hook_1_end", clk_hook_1_end, "inv_sofit" );
    --------------------------------------------------------------------------------------------
    -- function clk_hook_2 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_hook_2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_sofit_clk_hook_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_sofit",
        zz_gate = "inv_sofit"
    };

    local clk_hook_2_beg = function ()

      ObjDelete( "obj_deploy_inv_sofit_clk_hook_2" );

    end;
    local clk_hook_2_end = function ()

      ObjSet( "obj_deploy_inv_sofit_clk_hook_3", { input = true } );

      ObjSet( "spr_deploy_inv_sofit_2", { pos_x = 162, pos_y = -89 } );
      ObjSet( "spr_deploy_inv_sofit_4", { pos_x = -208, pos_y = 81 } );

    end;

    cmn.AddSubscriber( "clk_hook_2", clk_hook_2_beg, "inv_sofit" );
    cmn.AddSubscriber( "clk_hook_2", clk_hook_2_end, "inv_sofit" );
    cmn.AddSubscriber( "clk_hook_2_beg", clk_hook_2_beg, "inv_sofit" );
    cmn.AddSubscriber( "clk_hook_2_end", clk_hook_2_end, "inv_sofit" );
    --------------------------------------------------------------------------------------------
    -- function clk_hook_3 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_hook_3" ] = {
        type = "click",
        use_place = "obj_deploy_inv_sofit_clk_hook_3",
        room = "int_deploy_inv",
        zz = "deploy_inv_sofit",
        zz_gate = "inv_sofit"
    };

    local clk_hook_3_inv = function ()

      if not cmn.IsEventDone( "get_hook" ) then 

        cmn.SetInvPlusRGB( "sofit", false );

      end;

    end;

    local clk_hook_3_beg = function ()

      ObjDelete( "obj_deploy_inv_sofit_clk_hook_3" );

    end;
    local clk_hook_3_end = function ()

      ObjSet( "spr_deploy_inv_sofit_1", { pos_x = 137, pos_y = -76 } );
      ObjSet( "spr_deploy_inv_sofit_4", { pos_x = -299, pos_y = 132 } );

      if cmn.IsEventDone( "use_hook" ) then

        ObjSet( "obj_deploy_inv_sofit", { input = true } );
        ObjSet( "gfx_deploy_inv_sofit", { active = true } );

      end;

    end;

    cmn.AddSubscriber( "clk_hook_3", clk_hook_3_inv );
    cmn.AddSubscriber( "clk_hook_3", clk_hook_3_beg, "inv_sofit" );
    cmn.AddSubscriber( "clk_hook_3", clk_hook_3_end, "inv_sofit" );
    cmn.AddSubscriber( "clk_hook_3_inv", clk_hook_3_inv );
    cmn.AddSubscriber( "clk_hook_3_beg", clk_hook_3_beg, "inv_sofit" );
    cmn.AddSubscriber( "clk_hook_3_end", clk_hook_3_end, "inv_sofit" );
    --------------------------------------------------------------------------------------------
    -- function get_sofit_hook () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_sofit_hook" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_sofit_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_sofit",
        zz_gate = "inv_sofit"
    };
    local get_sofit_hook_inv = function ()

      interface.InventoryItemRemove( "inv_sofit" );
      interface.InventoryItemAdd( "inv_sofit_hook", "obj_deploy_inv_sofit" );

    end;
    local get_sofit_hook = function ()

      ObjDelete( "gfx_deploy_inv_sofit" );

    end;
    cmn.AddSubscriber( "get_sofit_hook", get_sofit_hook_inv );
    cmn.AddSubscriber( "get_sofit_hook", get_sofit_hook, "inv_sofit" );
    --------------------------------------------------------------------------------------------

  end;
  -------------------------------------------------------------------------------------------
  function public.use_hook ()

    local item = "inv_hook";

    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_sofit_use_hook" ) )  then

      cmn.CallEventHandler( "use_hook_inv" );
      cmn.CallEventHandler( "use_hook_beg", "inv_sofit" );

      local func_end = function ()
        
        cmn.Lock( false );

        cmn.SetEventDone( "use_hook" );
        cmn.CallEventHandler( "use_hook_end", "inv_sofit" );

        common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx" );
        
      end;

      cmn.Lock( true );

      common_impl.ItemFly( "spr_deploy_inv_sofit_hook", func_end, 0.7 );

      return true; 

    end;

    return false;

  end;
  -------------------------------------------------------------------------------------------
  function private.clk_hook_1 ()

    cmn.CallEventHandler( "clk_hook_1_beg", "inv_sofit" );

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.SetEventDone( "clk_hook_1" );
      cmn.CallEventHandler( "clk_hook_1_end", "inv_sofit" );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_foot_batten_clk" );

    ObjAnimate( "spr_deploy_inv_sofit_4", "pos_xy", 0, 0, func_end, 
    {

      0, 0, 89, -80,
      0.5, 3, -73, 7,

    } );

    ObjAnimate( "spr_deploy_inv_sofit_3", "pos_xy", 0, 0, "", 
    {

      0, 0, 34, -22,
      0.5, 3, 196, -109,

    } );

  end;
  -------------------------------------------------------------------------------------------
  function private.clk_hook_2 ()

    cmn.CallEventHandler( "clk_hook_2_beg", "inv_sofit" );

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.SetEventDone( "clk_hook_2" );
      cmn.CallEventHandler( "clk_hook_2_end", "inv_sofit" );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_foot_batten_clk" );

    ObjAnimate( "spr_deploy_inv_sofit_4", "pos_xy", 0, 0, func_end, 
    {

      0, 0, -73, 7,
      0.5, 3, -208, 81,

    } );

    ObjAnimate( "spr_deploy_inv_sofit_2", "pos_xy", 0, 0, "", 
    {

      0, 0, 27, -15,
      0.5, 3, 162, -89,

    } );

  end;
  -------------------------------------------------------------------------------------------
  function private.clk_hook_3 ()

    cmn.CallEventHandler( "clk_hook_3_inv", "inv_sofit" );
    cmn.CallEventHandler( "clk_hook_3_beg", "inv_sofit" );

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.SetEventDone( "clk_hook_3" );
      cmn.CallEventHandler( "clk_hook_3_end", "inv_sofit" );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_foot_batten_clk" );

    ObjAnimate( "spr_deploy_inv_sofit_4", "pos_xy", 0, 0, func_end, 
    {

      0, 0, -208, 81,
      0.5, 3, -299, 132,

    } );

    ObjAnimate( "spr_deploy_inv_sofit_1", "pos_xy", 0, 0, "", 
    {

      0, 0, 46, -25,
      0.5, 3, 137, -76,

    } );

  end;
  --------------------------------------------------------------------------------------------
  function private.get_sofit_hook ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_sofit_hook" );
    cmn.CallEventHandler( "get_sofit_hook", "inv_sofit" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************
-- function *** toolbox *** () end;
--*********************************************************************************************************************
  function private.toolbox_init ()
    --------------------------------------------------------------------------------------------
    ObjMultiSet({ 
      { "spr_deploy_inv_toolbox_screwdriver", { event_mdown = private.get_screwdriver } }, 
      { "spr_deploy_inv_toolbox_boxwrench",   { event_mdown = private.get_boxwrench } },    
      { "spr_deploy_inv_toolbox_clippers",   { event_mdown = private.get_clippers } }, 
      { "obj_deploy_inv_toolbox_clk_hexagon1", { event_mdown = private.clk_hexagon1 } },
      { "obj_deploy_inv_toolbox_clk_hexagon2", { event_mdown = private.clk_hexagon2 } },
      { "obj_deploy_inv_toolbox_clk_hexagon3", { event_mdown = private.clk_hexagon3 } }
           
    });
    --------------------------------------------------------------------------------------------
    -- USE -------------------------------------------------------------------------------------
    -- *** function use_hexagon1 **--------------------------------------------------------
    common_impl.hint[ "use_hexagon1" ] = {
        type = "use",
        inv_obj = "inv_hexagon1",
        use_place = "obj_deploy_inv_toolbox_use_hexagon1",
        room = "int_deploy_inv",
        zz = "deploy_inv_toolbox",
        zz_gate = "inv_toolbox"
    };    
    function use_hexagon1_beg ()
      
      ObjDelete( "obj_deploy_inv_toolbox_use_hexagon1" );
      interface.InventoryItemRemove( "inv_hexagon1" );

    end;
    function use_hexagon1_end ()
      
      ObjSet( "spr_deploy_inv_toolbox_hexagon1", { alp = 1, visible = true } );
      ObjSet( "obj_deploy_inv_toolbox_clk_hexagon1", { input = true } );

    end;
    cmn.AddSubscriber( "use_hexagon1", use_hexagon1_beg );
    cmn.AddSubscriber( "use_hexagon1", use_hexagon1_end, "inv_toolbox" );
    cmn.AddSubscriber( "use_hexagon1_beg", use_hexagon1_beg );
    cmn.AddSubscriber( "use_hexagon1_end", use_hexagon1_end, "inv_toolbox" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_hexagon2" ] = {
        type = "use",
        inv_obj = "inv_hexagon2",
        use_place = "obj_deploy_inv_toolbox_use_hexagon2",
        room = "int_deploy_inv",
        zz = "deploy_inv_toolbox",
        zz_gate = "inv_toolbox"
    };    
    function use_hexagon2_beg ()
      
      ObjDelete( "obj_deploy_inv_toolbox_use_hexagon2" );
      interface.InventoryItemRemove( "inv_hexagon2" );

    end;
    function use_hexagon2_end ()
      
      ObjSet( "spr_deploy_inv_toolbox_hexagon2", { alp = 1, visible = true } );
      ObjSet( "obj_deploy_inv_toolbox_clk_hexagon2", { input = true } );

    end;
    cmn.AddSubscriber( "use_hexagon2", use_hexagon2_beg  );
    cmn.AddSubscriber( "use_hexagon2", use_hexagon2_end, "inv_toolbox" );
    cmn.AddSubscriber( "use_hexagon2_beg", use_hexagon2_beg );
    cmn.AddSubscriber( "use_hexagon2_end", use_hexagon2_end, "inv_toolbox" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_hexagon3" ] = {
        type = "use",
        inv_obj = "inv_hexagon3",
        use_place = "obj_deploy_inv_toolbox_use_hexagon3",
        room = "int_deploy_inv",
        zz = "deploy_inv_toolbox",
        zz_gate = "inv_toolbox"
    };    
    function use_hexagon3_beg ()
      
      ObjDelete( "obj_deploy_inv_toolbox_use_hexagon3" );
      interface.InventoryItemRemove( "inv_hexagon3" );

    end;
    function use_hexagon3_end ()
      
      ObjSet( "spr_deploy_inv_toolbox_hexagon3", { alp = 1, visible = true } );
      ObjSet( "obj_deploy_inv_toolbox_clk_hexagon3", { input = true } );

    end;
    cmn.AddSubscriber( "use_hexagon3", use_hexagon3_beg  );
    cmn.AddSubscriber( "use_hexagon3", use_hexagon3_end, "inv_toolbox" );
    cmn.AddSubscriber( "use_hexagon3_beg", use_hexagon3_beg );
    cmn.AddSubscriber( "use_hexagon3_end", use_hexagon3_end, "inv_toolbox" );

    --------------------------------------------------------------------------------------------
    -- function clk_hexagon1 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_hexagon1" ] = {
        type = "click",
        use_place = "obj_deploy_inv_toolbox_clk_hexagon1",
        room = "int_deploy_inv",
        zz = "deploy_inv_toolbox",
        zz_gate = "inv_toolbox"
    };

    local clk_hexagon1_beg = function ()

      ObjDelete( "obj_deploy_inv_toolbox_clk_hexagon1" );

    end;
    local clk_hexagon1_end = function ()

      ObjSet( "gfx_deploy_inv_toolbox_screwdriver", { active = true } );
      if not cmn.IsEventDone( "get_screwdriver" ) then 
        ObjSet( "spr_deploy_inv_toolbox_cupboard_open_middle", { alp = 1, visible = true, input = true, pos_x = -42, pos_y = 74 } );
        ObjSet( "spr_deploy_inv_toolbox_cupboard_cover_middle", { alp = 0, visible = false } );
      end;

    end;

    cmn.AddSubscriber( "clk_hexagon1", clk_hexagon1_beg, "inv_toolbox" );
    cmn.AddSubscriber( "clk_hexagon1", clk_hexagon1_end, "inv_toolbox" );
    cmn.AddSubscriber( "clk_hexagon1_beg", clk_hexagon1_beg, "inv_toolbox" );
    cmn.AddSubscriber( "clk_hexagon1_end", clk_hexagon1_end, "inv_toolbox" );

    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_hexagon2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_toolbox_clk_hexagon2",
        room = "int_deploy_inv",
        zz = "deploy_inv_toolbox",
        zz_gate = "inv_toolbox"
    };

    local clk_hexagon2_beg = function ()

      ObjDelete( "obj_deploy_inv_toolbox_clk_hexagon2" );

    end;
    local clk_hexagon2_end = function ()

      ObjSet( "gfx_deploy_inv_toolbox_boxwrench", { active = true } );
      ObjSet( "spr_deploy_inv_toolbox_cupboard_open_up", { alp = 1, visible = true, input = true } );
      ObjDelete( "spr_deploy_inv_toolbox_cupboard_cover_up" );

    end;

    cmn.AddSubscriber( "clk_hexagon2", clk_hexagon2_beg, "inv_toolbox" );
    cmn.AddSubscriber( "clk_hexagon2", clk_hexagon2_end, "inv_toolbox" );
    cmn.AddSubscriber( "clk_hexagon2_beg", clk_hexagon2_beg, "inv_toolbox" );
    cmn.AddSubscriber( "clk_hexagon2_end", clk_hexagon2_end, "inv_toolbox" );

    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_hexagon3" ] = {
        type = "click",
        use_place = "obj_deploy_inv_toolbox_clk_hexagon3",
        room = "int_deploy_inv",
        zz = "deploy_inv_toolbox",
        zz_gate = "inv_toolbox"
    };

    local clk_hexagon3_beg = function ()

      ObjDelete( "obj_deploy_inv_toolbox_clk_hexagon3" );

    end;
    local clk_hexagon3_end = function ()

      ObjSet( "gfx_deploy_inv_toolbox_clippers", { active = true } );
      ObjSet( "spr_deploy_inv_toolbox_cupboard_open_down", { alp = 1, visible = true, input = true, pos_x = -63, pos_y = 196 } );
      ObjDelete( "spr_deploy_inv_toolbox_cupboard_cover_down" );

    end;

    cmn.AddSubscriber( "clk_hexagon3", clk_hexagon3_beg, "inv_toolbox" );
    cmn.AddSubscriber( "clk_hexagon3", clk_hexagon3_end, "inv_toolbox" );
    cmn.AddSubscriber( "clk_hexagon3_beg", clk_hexagon3_beg, "inv_toolbox" );
    cmn.AddSubscriber( "clk_hexagon3_end", clk_hexagon3_end, "inv_toolbox" );

  --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_screwdriver" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_toolbox_screwdriver",
        room = "int_deploy_inv",
        zz = "deploy_inv_toolbox",
        zz_gate = "inv_toolbox"
    };
    function get_screwdriver_inv ()

      interface.InventoryItemAdd( "inv_screwdriver", "spr_deploy_inv_toolbox_screwdriver" );
      cmn.SetInvPlusRGB( "toolbox", false );

    end;
    function get_screwdriver_input ()

      ObjSet( "spr_deploy_inv_toolbox_cupboard_open_middle", { input = false } );

    end;
    function get_screwdriver_deploy ()

      ObjDelete( "spr_deploy_inv_toolbox_cupboard_open_middle" );
      ObjSet( "spr_deploy_inv_toolbox_cupboard_cover_middle", { alp = 1, visible = true } );

    end;

    cmn.AddSubscriber( "get_screwdriver", get_screwdriver_inv );
    cmn.AddSubscriber( "get_screwdriver", get_screwdriver_input, "inv_toolbox" );
    cmn.AddSubscriber( "get_screwdriver", get_screwdriver_deploy, "inv_toolbox" );
    cmn.AddSubscriber( "get_screwdriver_inv", get_screwdriver_inv, "inv_toolbox" );
    cmn.AddSubscriber( "get_screwdriver_inv", get_screwdriver_input, "inv_toolbox" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_boxwrench" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_toolbox_boxwrench",
        room = "int_deploy_inv",
        zz = "deploy_inv_toolbox",
        zz_gate = "inv_toolbox"
    };
    function get_boxwrench_inv ()

      interface.InventoryItemAdd( "inv_boxwrench", "spr_deploy_inv_toolbox_boxwrench" );
      cmn.SetInvPlusRGB( "toolbox", false );

    end;
    cmn.AddSubscriber( "get_boxwrench", get_boxwrench_inv );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_clippers" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_toolbox_clippers",
        room = "int_deploy_inv",
        zz = "deploy_inv_toolbox",
        zz_gate = "inv_toolbox"
    };
    function get_clippers_inv ()

      interface.InventoryItemRemove( "inv_toolbox" );
      interface.InventoryItemAdd( "inv_clippers", "spr_deploy_inv_toolbox_clippers" );

    end;
    cmn.AddSubscriber( "get_clippers", get_clippers_inv );
    --------------------------------------------------------------------------------------------

  end;
  -- USE -------------------------------------------------------------------------------------
  function public.use_hexagon1 ()

    local item = "inv_hexagon1";

    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_toolbox_use_hexagon1" ) )  then

      cmn.CallEventHandler( "use_hexagon1_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_hexagon1" );
        cmn.CallEventHandler( "use_hexagon1_end", "inv_toolbox" );
        common_impl.PlayAudio( "sfx", "level1/sfx/aud_box_use_part1" );

        private.clk_hexagon1();
        
      end;

      cmn.Lock( true );
      common_impl.ItemFly( "spr_deploy_inv_toolbox_hexagon1", func_end, -2.3 );

      return true; 

    end;

    return false;

  end;
  ------------------------------------------------------------------------------------------
  function public.use_hexagon2 ()

    local item = "inv_hexagon2";

    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_toolbox_use_hexagon2" ) )  then

      cmn.CallEventHandler( "use_hexagon2_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_hexagon2" );
        cmn.CallEventHandler( "use_hexagon2_end", "inv_toolbox" );
        common_impl.PlayAudio( "sfx", "level1/sfx/aud_box_use_part1" );

        private.clk_hexagon2();

      end;

      cmn.Lock( true );
      common_impl.ItemFly( "spr_deploy_inv_toolbox_hexagon2", func_end, 0 );

      return true; 

    end;

    return false;

  end;
  ------------------------------------------------------------------------------------------
  function public.use_hexagon3 ()

    local item = "inv_hexagon3";

    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_toolbox_use_hexagon3" ) ) and
    cmn.IsEventDone( "get_screwdriver" ) then

      cmn.CallEventHandler( "use_hexagon3_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_hexagon3" );
        cmn.CallEventHandler( "use_hexagon3_end", "inv_toolbox" );
        common_impl.PlayAudio( "sfx", "level1/sfx/aud_box_use_part1" );

        private.clk_hexagon3();

      end;

      cmn.Lock( true );
      common_impl.ItemFly( "spr_deploy_inv_toolbox_hexagon3", func_end, -2.3 );

      return true; 

    end;

    return false;

  end;

  -- CLK ------------------------------------------------------------------------------------
  function private.clk_hexagon1 ()

    cmn.CallEventHandler( "clk_hexagon1_beg", "inv_toolbox" );

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.SetEventDone( "clk_hexagon1" );
      cmn.CallEventHandler( "clk_hexagon1_end", "inv_toolbox" );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_cell" );

    ObjSet( "spr_deploy_inv_toolbox_cupboard_open_middle", { visible = true } );
    ObjAnimate( "spr_deploy_inv_toolbox_cupboard_open_middle", "alp",0,0, "", { 0, 1, 0,    0.6, 1, 1 } );
    ObjAnimate( "spr_deploy_inv_toolbox_cupboard_cover_middle", "alp",0,0, "", { 0, 2, 1,    0.6, 2, 0 } );

    ObjAnimate( "spr_deploy_inv_toolbox_cupboard_open_middle", "pos_xy",0,0, func_end, { 0, 3, -31, 43,    0.6, 3, -42, 74 } );

  end;

  --------------------------------------------------------------------------------------------

  function private.clk_hexagon2 ()

    cmn.CallEventHandler( "clk_hexagon2_beg", "inv_toolbox" );

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.SetEventDone( "clk_hexagon2" );
      cmn.CallEventHandler( "clk_hexagon2_end", "inv_toolbox" );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_cell" );

    ObjSet( "spr_deploy_inv_toolbox_cupboard_open_up", { visible = true } );
    ObjAnimate( "spr_deploy_inv_toolbox_cupboard_open_up", "alp",0,0, "", { 0, 1, 0,    0.6, 1, 1 } );
    ObjAnimate( "spr_deploy_inv_toolbox_cupboard_cover_up", "alp",0,0, func_end, { 0, 2, 1,    0.6, 2, 0 } );

  end;

  --------------------------------------------------------------------------------------------

  function private.clk_hexagon3 ()

    cmn.CallEventHandler( "clk_hexagon3_beg", "inv_toolbox" );

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.SetEventDone( "clk_hexagon3" );
      cmn.CallEventHandler( "clk_hexagon3_end", "inv_toolbox" );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_cell" );

    ObjSet( "spr_deploy_inv_toolbox_cupboard_open_down", { visible = true } );
    ObjAnimate( "spr_deploy_inv_toolbox_cupboard_open_down", "alp",0,0, "", { 0, 1, 0,    0.6, 1, 1 } );
    ObjAnimate( "spr_deploy_inv_toolbox_cupboard_cover_down", "alp",0,0, func_end, { 0, 2, 1,    0.6, 2, 0 } );

    ObjAnimate( "spr_deploy_inv_toolbox_cupboard_open_down", "pos_xy",0,0, func_end, { 0, 3, -53, 169,    0.6, 3, -63, 196 } );

  end;


  -- GET -------------------------------------------------------------------------------------
  function private.get_screwdriver ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );


    ObjDelete( "gfx_deploy_inv_toolbox_screwdriver" );

    local func_end = function ()
      
      cmn.Lock( false );
      common_impl.HideDeployInv();

    end;

    cmn.Lock( true );

    cmn.SetEventDone( "get_screwdriver" );
    cmn.CallEventHandler( "get_screwdriver_inv", "inv_toolbox" );  

    ObjSet( "tmr_deploy_inv_toolbox", 
    {
      playing = true,
      time = 0.8, 
      endtrig = function() common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_cell" ); end,
    } );
    
    ObjSet( "spr_deploy_inv_toolbox_cupboard_cover_middle", { visible = true } );
    ObjAnimate( "spr_deploy_inv_toolbox_cupboard_cover_middle", "alp",0,0, "", { 0, 1, 0,    0.8, 1, 0,    1.4, 1, 1 } );
    ObjAnimate( "spr_deploy_inv_toolbox_cupboard_open_middle", "alp",0,0, func_end, { 0, 2, 1,    0.8, 2, 1,    1.4, 2, 0 } );

    ObjAnimate( "spr_deploy_inv_toolbox_cupboard_open_middle", "pos_xy",0,0, "", { 0, 3, -42, 74,    0.8, 3, -42, 74,    1.4, 3, -31, 43 } );

  end;
  --------------------------------------------------------------------------------------------
  function private.get_boxwrench ()

    ObjDelete( "gfx_deploy_inv_toolbox_boxwrench" );
    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_boxwrench" );
    cmn.CallEventHandler( "get_boxwrench", "inv_toolbox" );

  end;
  --------------------------------------------------------------------------------------------
  function private.get_clippers ()

    ObjDelete( "gfx_deploy_inv_toolbox_clippers" );
    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_clippers" );
    cmn.CallEventHandler( "get_clippers", "inv_toolbox" );

    --по воводу этой строчки не уверен
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************
-- function *** bulbbox *** () end;
--*********************************************************************************************************************
  function private.bulbbox_init ()

    --------------------------------------------------------------------------------------------
    ObjMultiSet({ 
      { "spr_deploy_inv_bulbbox_bulb", { event_mdown = private.get_bulb } },
      { "obj_deploy_clk_bulbbox_1", { event_mdown = private.clk_bulbbox_1 } },
      { "obj_deploy_clk_bulbbox_2", { event_mdown = private.clk_bulbbox_2 } },
    });
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_bulb" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_bulbbox_bulb",
        room = "int_deploy_inv",
        zz = "deploy_inv_bulbbox",
        zz_gate = "inv_bulbbox"
    };
    function get_bulb_inv ()

      interface.InventoryItemRemove( "inv_bulbbox" );
      interface.InventoryItemAdd( "inv_bulb", "spr_deploy_inv_bulbbox_bulb" );

    end;
    cmn.AddSubscriber( "get_bulb", get_bulb_inv );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_bulbbox_1" ] = {
        type = "click",
        use_place = "obj_deploy_clk_bulbbox_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_bulbbox",
        zz_gate = "inv_bulbbox"
    };
    function clk_bulbbox_1 ()

      ObjDelete( "spr_deploy_inv_bulbbox_box_1" );
      ObjDelete( "obj_deploy_clk_bulbbox_1" );
      ObjSet( "obj_deploy_inv_bulbbox_box_2", { alp = 1 } );
      ObjSet( "obj_deploy_clk_bulbbox_2", { input = true } );

    end;
    cmn.AddSubscriber( "clk_bulbbox_1", clk_bulbbox_1, "inv_bulbbox" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_bulbbox_2" ] = {
        type = "click",
        use_place = "obj_deploy_clk_bulbbox_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_bulbbox",
        zz_gate = "inv_bulbbox"
    };
    function clk_bulbbox_2 ()

      ObjDelete( "obj_deploy_clk_bulbbox_2" );
      ObjSet( "obj_deploy_inv_bulbbox_box_2", { input = true } );
      ObjSet( "gfx_deploy_inv_bulbbox_bulb", { active = true } );
      ObjDelete( "spr_deploy_inv_bulbbox_box_open" );
      ObjDelete( "spr_deploy_inv_bulbbox_box_2" );

    end;
    cmn.AddSubscriber( "clk_bulbbox_2", clk_bulbbox_2, "inv_bulbbox" );
    --------------------------------------------------------------------------------------------

  end;
  ----------------------------------------------------------------------------------------------
  function private.get_bulb ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_bulb" );
    cmn.CallEventHandler( "get_bulb", "inv_bulbbox" );
    common_impl.HideDeployInv();

  end;
  ----------------------------------------------------------------------------------------------
  function private.clk_bulbbox_1 ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "clk_bulbbox_1" );
      cmn.CallEventHandler( "clk_bulbbox_1", "inv_bulbbox" );

    end;

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_cardbox", 0, "", 0 );

    func_end();
    --ObjAnimate( "obj_deploy_inv_bulbbox_box_2", "alp", 0, 0, func_end, { 0, 0, 0,   0.2, 0, 1 } );

  end;
  ----------------------------------------------------------------------------------------------
  function private.clk_bulbbox_2 ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "clk_bulbbox_2" );
      cmn.CallEventHandler( "clk_bulbbox_2", "inv_bulbbox" );

      common_impl.ShowBbt( "bbt_deploy_inv_bulbbox_clk_bulbbox_2" );

    end;

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_cardbox", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_bulbbox_box_open", "pos_x", 0, 0, func_end, 
    { 
      0.0, 0, -366,
      1.3, 0, 376
    } );
    ObjAnimate( "spr_deploy_inv_bulbbox_box_2", "pos_x", 0, 0, "", 
    {
      0.0, 0, -11,
      1.3, 0, 731
    } );
    ObjAnimate( "spr_deploy_inv_bulbbox_box_open", "alp", 0, 0, "",
    { 
      0.0, 0, 1,   
      1.0, 0, 1,   
      1.3, 0, 0 
    } );
    ObjAnimate( "spr_deploy_inv_bulbbox_box_2", "alp", 0, 0, "", 
    { 
      0.0, 0, 1,   
      1.0, 0, 1,   
      1.3, 0, 0 
    } );

  end;
--*********************************************************************************************************************
-- function *** codedpaper *** () end;
--*********************************************************************************************************************
  function private.codedpaper_init ()

    --------------------------------------------------------------------------------------------
    ObjMultiSet({ 
      { "spr_deploy_inv_codedpaper_antirustrecipe", { event_mdown = private.get_antirustrecipe } },   
      { "spr_deploy_inv_codedpaper_close", { event_mdown = private.clk_codedpaper1 } },   
      { "spr_deploy_inv_codedpaper_open", { event_mdown = private.clk_codedpaper2 } }, 
      { "spr_deploy_inv_codedpaper_developingliquid", { event_mdown = private.clk_codedpaper3 } },      
    });
    --------------------------------------------------------------------------------------------
    -- USE -------------------------------------------------------------------------------------
    common_impl.hint[ "use_developingliquid" ] = {
        type = "use",
        inv_obj = "inv_developingliquid",
        use_place = "obj_deploy_inv_codedpaper_use_developingliquid",
        room = "int_deploy_inv",
        zz = "deploy_inv_codedpaper",
        zz_gate = "inv_codedpaper"
    };    
    function use_developingliquid_beg ()
      
      ObjDelete( "obj_deploy_inv_codedpaper_use_developingliquid" );
      interface.InventoryItemRemove( "inv_developingliquid" );

    end;
    function use_developingliquid_end ()
      
      ObjSet( "spr_deploy_inv_codedpaper_developingliquid", { input = true, alp = 1, visible = true } );

    end;
    cmn.AddSubscriber( "use_developingliquid", use_developingliquid_beg );
    cmn.AddSubscriber( "use_developingliquid", use_developingliquid_end, "inv_codedpaper" );
    cmn.AddSubscriber( "use_developingliquid_beg", use_developingliquid_beg );
    cmn.AddSubscriber( "use_developingliquid_end", use_developingliquid_end, "inv_codedpaper" );

    --------------------------------------------------------------------------------------------
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_codedpaper1" ] = {
        type = "click",
        use_place = "spr_deploy_inv_codedpaper_close",
        room = "int_deploy_inv",
        zz = "deploy_inv_codedpaper",
        zz_gate = "inv_codedpaper"
    };

    local clk_codedpaper1_beg = function ()

      ObjSet( "spr_deploy_inv_codedpaper_close", { input = false } );

    end;
    local clk_codedpaper1_end = function ()

      ObjSet( "spr_deploy_inv_codedpaper_open", { alp = 1, visible = true, input = true } );
      ObjDelete( "spr_deploy_inv_codedpaper_close" );

    end;

    cmn.AddSubscriber( "clk_codedpaper1", clk_codedpaper1_beg, "inv_codedpaper" );
    cmn.AddSubscriber( "clk_codedpaper1", clk_codedpaper1_end, "inv_codedpaper" );
    cmn.AddSubscriber( "clk_codedpaper1_beg", clk_codedpaper1_beg, "inv_codedpaper" );
    cmn.AddSubscriber( "clk_codedpaper1_end", clk_codedpaper1_end, "inv_codedpaper" );

    ----------------------------------------------------------------------------------------------

    common_impl.hint[ "clk_codedpaper2" ] = {
        type = "click",
        use_place = "spr_deploy_inv_codedpaper_open",
        room = "int_deploy_inv",
        zz = "deploy_inv_codedpaper",
        zz_gate = "inv_codedpaper"
    };

    local clk_codedpaper2_inv = function ()

      ObjSet( "inv_codedpaper", { res = "assets/levels/level1/inv_deploy/inv_codedpaper/inv/inv_antirustrecipe2" } );

      if not cmn.IsEventDone( "get_developingliquid" ) then
        cmn.SetInvPlusRGB( "codedpaper", false ); 
      end;

    end;

    local clk_codedpaper2_beg = function ()

      ObjSet( "spr_deploy_inv_codedpaper_open", { input = false } );

    end;
    local clk_codedpaper2_end = function ()

      ObjSet( "obj_deploy_inv_codedpaper_use_developingliquid", { pos_z = 10 } );
      ObjSet( "spr_deploy_inv_codedpaper_antirustrecipe", { alp = 1, visible = true } );
      ObjDelete( "spr_deploy_inv_codedpaper_open" );

    end;

    cmn.AddSubscriber( "clk_codedpaper2", clk_codedpaper2_inv );
    cmn.AddSubscriber( "clk_codedpaper2", clk_codedpaper2_beg, "inv_codedpaper" );
    cmn.AddSubscriber( "clk_codedpaper2", clk_codedpaper2_end, "inv_codedpaper" );
    cmn.AddSubscriber( "clk_codedpaper2_inv", clk_codedpaper2_inv, "inv_codedpaper" );
    cmn.AddSubscriber( "clk_codedpaper2_beg", clk_codedpaper2_beg, "inv_codedpaper" );
    cmn.AddSubscriber( "clk_codedpaper2_end", clk_codedpaper2_end, "inv_codedpaper" );

    ----------------------------------------------------------------------------------------------

    common_impl.hint[ "clk_codedpaper3" ] = {
        type = "click",
        use_place = "spr_deploy_inv_codedpaper_developingliquid",
        room = "int_deploy_inv",
        zz = "deploy_inv_codedpaper",
        zz_gate = "inv_codedpaper"
    };

    local clk_codedpaper3_inv = function ()

    end;
    local clk_codedpaper3_beg = function ()

      ObjSet( "spr_deploy_inv_codedpaper_developingliquid", { input = false } );

    end;
    local clk_codedpaper3_end = function ()

      ObjDelete( "vid_deploy_inv_codedpaper_developingliquid" );
      ObjSet( "gfx_deploy_inv_codedpaper_antirustrecipe", { active = true } );
      ObjSet( "spr_deploy_inv_codedpaper_antirustrecipe", { input = true } );
      ObjSet( "spr_deploy_inv_codedpaper_spot", { alp = 1, visible = true } );
      ObjSet( "spr_deploy_inv_codedpaper_recipe", { alp = 1, visible = true } );
      ObjDelete( "spr_deploy_inv_codedpaper_developingliquid" );

    end;

    cmn.AddSubscriber( "clk_codedpaper3", clk_codedpaper3_inv );
    cmn.AddSubscriber( "clk_codedpaper3", clk_codedpaper3_beg, "inv_codedpaper" );
    cmn.AddSubscriber( "clk_codedpaper3", clk_codedpaper3_end, "inv_codedpaper" );
    cmn.AddSubscriber( "clk_codedpaper3_inv", clk_codedpaper3_inv );
    cmn.AddSubscriber( "clk_codedpaper3_beg", clk_codedpaper3_beg, "inv_codedpaper" );
    cmn.AddSubscriber( "clk_codedpaper3_end", clk_codedpaper3_end, "inv_codedpaper" );

    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_antirustrecipe" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_codedpaper_antirustrecipe",
        room = "int_deploy_inv",
        zz = "deploy_inv_codedpaper",
        zz_gate = "inv_codedpaper"
    };
    function get_antirustrecipe_inv ()

      interface.InventoryItemRemove( "inv_codedpaper" );      
      interface.InventoryItemAdd( "inv_antirustrecipe", "spr_deploy_inv_codedpaper_antirustrecipe" );

    end;
    cmn.AddSubscriber( "get_antirustrecipe", get_antirustrecipe_inv );
    --------------------------------------------------------------------------------------------

  end;
  -- USE ---------------------------------------------------------------------------------------
  function public.use_developingliquid ()

    local item = "inv_developingliquid";

    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_codedpaper_use_developingliquid" ) and cmn.IsEventDone( "clk_codedpaper2" ) )  then

      cmn.CallEventHandler( "use_developingliquid_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_developingliquid" );
        cmn.CallEventHandler( "use_developingliquid_end", "inv_codedpaper" );
        
      end;

      cmn.Lock( true );
      common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx" );

      ObjSet( "spr_deploy_inv_codedpaper_developingliquid", { alp = 0, visible = true } );
      ObjAnimate( "spr_deploy_inv_codedpaper_developingliquid", "alp",0,0, func_end, { 0, 0, 0,    0.6, 0, 1 } );

      return true; 

    end;

    return false;

  end;

  -- CLK ------------------------------------------------------------------------------------
  function private.clk_codedpaper1 ()

    cmn.CallEventHandler( "clk_codedpaper1_beg", "inv_codedpaper" );

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.SetEventDone( "clk_codedpaper1" );
      cmn.CallEventHandler( "clk_codedpaper1_end", "inv_codedpaper" );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_package" );

    ObjAnimate( "spr_deploy_inv_codedpaper_close", "alp",0,0, "", { 0, 2, 1,    0.6, 2, 0 } );
    ObjSet( "spr_deploy_inv_codedpaper_open", { alp = 0, visible = true } );
    ObjAnimate( "spr_deploy_inv_codedpaper_open", "alp",0,0, func_end, { 0, 1, 0,    0.6, 1, 1 } );

  end;

  --------------------------------------------------------------------------------------------

  function private.clk_codedpaper2 ()

    cmn.CallEventHandler( "clk_codedpaper2_beg", "inv_codedpaper" );

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.CallEventHandler( "clk_codedpaper2_inv" );
      cmn.SetEventDone( "clk_codedpaper2" );
      cmn.CallEventHandler( "clk_codedpaper2_end", "inv_codedpaper" );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_package" );

    ObjAnimate( "spr_deploy_inv_codedpaper_open", "alp",0,0, "", { 0, 2, 1,    0.6, 2, 0 } );
    ObjSet( "spr_deploy_inv_codedpaper_antirustrecipe", { alp = 0, visible = true } );
    ObjAnimate( "spr_deploy_inv_codedpaper_antirustrecipe", "alp",0,0, func_end, { 0, 1, 0,    0.6, 1, 1 } );

  end;

  --------------------------------------------------------------------------------------------

  function private.clk_codedpaper3 ()

    cmn.CallEventHandler( "clk_codedpaper3_inv", "inv_codedpaper" );
    cmn.CallEventHandler( "clk_codedpaper3_beg", "inv_codedpaper" );

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.SetEventDone( "clk_codedpaper3" );
      cmn.CallEventHandler( "clk_codedpaper3_end", "inv_codedpaper" );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_tube" );

    ObjAnimate( "spr_deploy_inv_codedpaper_developingliquid", "alp",0,0, "", { 0, 0, 1,    0.3, 0, 0 } );

    ObjSet( "vid_deploy_inv_codedpaper_developingliquid", { alp = 0, visible = true } );
    ObjAnimate( "vid_deploy_inv_codedpaper_developingliquid", "alp",0,0, "", { 0, 0, 0,    0.6, 0, 1 } );
    VidPlay( "vid_deploy_inv_codedpaper_developingliquid", func_end );

  end;

  -- GET -------------------------------------------------------------------------------------
  function private.get_antirustrecipe ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    ObjDelete( "gfx_deploy_inv_codedpaper_antirustrecipe" );
    cmn.SetEventDone( "get_antirustrecipe" );
    cmn.CallEventHandler( "get_antirustrecipe", "inv_codedpaper" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************
-- function *** crossbow *** () end;
--*********************************************************************************************************************
  function private.crossbow_init ()

    --------------------------------------------------------------------------------------------
    ObjMultiSet({ 
      { "spr_deploy_inv_crossbow_chargedcrossbow", { event_mdown = private.get_chargedcrossbow } },
      { "obj_deploy_inv_crossbow_clk_crossbow_1", { event_mdown = private.clk_crossbow_1 } },
      { "obj_deploy_inv_crossbow_clk_crossbow_2", { event_mdown = private.clk_crossbow_2 } },
    });
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_arrow" ] = {
        type = "use",
        inv_obj = "inv_arrow",
        use_place = "obj_deploy_inv_crossbow_use_arrow",
        room = "int_deploy_inv",
        zz = "deploy_inv_crossbow",
        zz_gate = "inv_crossbow"
    };
    function use_arrow_inv ()
      
      interface.InventoryItemRemove( "inv_arrow" );

    end;
    function use_arrow_beg ()
      
      ObjDelete( "obj_deploy_inv_crossbow_use_arrow" );

    end;
    function use_arrow_end ()

      ObjSet( "spr_deploy_inv_crossbow_chargedcrossbow_bowstring_1_arrow", { alp = 1 } );
      ObjSet( "obj_deploy_inv_crossbow_clk_crossbow_2", { input = true } );

    end;
    cmn.AddSubscriber( "use_arrow", use_arrow_inv );
    cmn.AddSubscriber( "use_arrow", use_arrow_beg, "inv_crossbow" );
    cmn.AddSubscriber( "use_arrow", use_arrow_end, "inv_crossbow" );
    cmn.AddSubscriber( "use_arrow_inv", use_arrow_inv );
    cmn.AddSubscriber( "use_arrow_beg", use_arrow_beg, "inv_crossbow" );
    cmn.AddSubscriber( "use_arrow_end", use_arrow_end, "inv_crossbow" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_crossbow_2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_crossbow_clk_crossbow_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_crossbow",
        zz_gate = "inv_crossbow"
    };
    function clk_crossbow_2 ()

      ObjSet( "obj_deploy_inv_crossbow_chargedcrossbow_bowstring_2", { alp = 1 } );
      ObjDelete( "obj_deploy_inv_crossbow_chargedcrossbow_bowstring_1" );
      ObjDelete( "obj_deploy_inv_crossbow_clk_crossbow_2" );
      ObjSet( "spr_deploy_inv_crossbow_chargedcrossbow", { input = true } );
      ObjSet( "gfx_deploy_inv_crossbow_chargedcrossbow", { active = true } );

    end;
    cmn.AddSubscriber( "clk_crossbow_2", clk_crossbow_2, "inv_crossbow" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_chargedcrossbow" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_crossbow_chargedcrossbow",
        room = "int_deploy_inv",
        zz = "deploy_inv_crossbow",
        zz_gate = "inv_crossbow"
    };
    function get_chargedcrossbow_inv ()

      interface.InventoryItemRemove( "inv_crossbow" );
      interface.InventoryItemAdd( "inv_chargedcrossbow", "spr_deploy_inv_crossbow_chargedcrossbow" );

    end;
    function get_chargedcrossbow ()

      ObjDelete( "gfx_deploy_inv_crossbow_chargedcrossbow" );

    end;
    cmn.AddSubscriber( "get_chargedcrossbow", get_chargedcrossbow_inv );
    cmn.AddSubscriber( "get_chargedcrossbow", get_chargedcrossbow, "inv_crossbow" );
    --------------------------------------------------------------------------------------------

  end;
  ----------------------------------------------------------------------------------------------
  function public.use_arrow ()

    local item = "inv_arrow";

    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_crossbow_use_arrow" ) )  then

      cmn.CallEventHandler( "use_arrow_inv" );
      cmn.CallEventHandler( "use_arrow_beg", "inv_crossbow" );

      local func_end = function ()
        
        cmn.Lock( false );

        cmn.SetEventDone( "use_arrow" );
        cmn.CallEventHandler( "use_arrow_end", "inv_crossbow" );
        
      end;

      cmn.Lock( true );

      common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx" );

      ObjAnimate( "spr_deploy_inv_crossbow_chargedcrossbow_bowstring_1_arrow", "alp", 0, 0, func_end,
        { 
          0.0, 0, 0.0, 
          0.3, 0, 1.0
        } );

      return true; 

    end;

    return false;

  end;
  ----------------------------------------------------------------------------------------------
  function private.clk_crossbow_2 ()

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.SetEventDone( "clk_crossbow_2" );
      cmn.CallEventHandler( "clk_crossbow_2", "inv_crossbow" );

      common_impl.ShowBbt( "bbt_deploy_inv_crossbow_clk_crossbow_2" );
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_crossbow" );

    ObjAnimate( "obj_deploy_inv_crossbow_chargedcrossbow_bowstring_1", "alp", 0, 0, func_end,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );

    ObjAnimate( "obj_deploy_inv_crossbow_chargedcrossbow_bowstring_2", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

  end;
  ---------------------------------------------------------------------------------------------
  function private.get_chargedcrossbow ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_chargedcrossbow" );
    cmn.CallEventHandler( "get_chargedcrossbow", "inv_crossbow" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************
-- function *** brokenbroom *** () end;
--*********************************************************************************************************************
  function private.brokenbroom_init ()

    --------------------------------------------------------------------------------------------
    ObjMultiSet({ 
      { "spr_deploy_inv_brokenbroom_boathook",            { event_mdown = private.get_boathook } },   
 
      { "obj_deploy_inv_brokenbroom_clk_boathookhead_1",  { event_mdown = private.clk_boathookhead_1 } },      
      { "obj_deploy_inv_brokenbroom_clk_boathookhead_2",  { event_mdown = private.clk_boathookhead_2 } },        
    } );
    --------------------------------------------------------------------------------------------
    -- USE -------------------------------------------------------------------------------------
    common_impl.hint[ "use_boathookhead" ] = {
        type = "use",
        inv_obj = "inv_boathookhead",
        use_place = "obj_deploy_inv_brokenbroom_use_boathookhead",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokenbroom",
        zz_gate = "inv_brokenbroom"
    };    
    function use_boathookhead_beg ()
      
      ObjDelete( "obj_deploy_inv_brokenbroom_use_boathookhead" );
      interface.InventoryItemRemove( "inv_boathookhead" );

    end;
    function use_boathookhead_end ()
      
      ObjSet( "spr_deploy_inv_brokenbroom_boathook", { input = true, alp = 1 } );
      ObjSet( "gfx_deploy_inv_brokenbroom_boathook", { active = true } );
      ObjSet( "spr_deploy_inv_brokenbroom_gaff", { alp = 1 } );
      ObjSet( "inv_brokenbroom", { res = "assets/levels/level1/inv_deploy/inv_brokenbroom/inv/inv_boathook" } );

    end;
    cmn.AddSubscriber( "use_boathookhead", use_boathookhead_beg );
    cmn.AddSubscriber( "use_boathookhead", use_boathookhead_end, "inv_brokenbroom" );
    cmn.AddSubscriber( "use_boathookhead_beg", use_boathookhead_beg );
    cmn.AddSubscriber( "use_boathookhead_end", use_boathookhead_end, "inv_brokenbroom" );
    -- CLK -------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_boathookhead_1" ] = {
        type = "click",
        use_place = "obj_deploy_inv_brokenbroom_clk_boathookhead_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokenbroom",
        zz_gate = "inv_brokenbroom"
    };
    local clk_boathookhead_1_beg = function ()

      ObjDelete( "obj_deploy_inv_brokenbroom_clk_boathookhead_1" );

    end;
    function clk_boathookhead_1_end ()
    
      ObjDelete( "obj_deploy_inv_brokenbroom_rope" );
      ObjSet( "obj_deploy_inv_brokenbroom_clk_boathookhead_2", { input = true } );

    end;
    cmn.AddSubscriber( "clk_boathookhead_1", clk_boathookhead_1_beg, "inv_brokenbroom" );
    cmn.AddSubscriber( "clk_boathookhead_1", clk_boathookhead_1_end, "inv_brokenbroom" );
    cmn.AddSubscriber( "clk_boathookhead_1_beg", clk_boathookhead_1_beg, "inv_brokenbroom" );
    cmn.AddSubscriber( "clk_boathookhead_1_end", clk_boathookhead_1_end, "inv_brokenbroom" );
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_boathookhead_2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_brokenbroom_clk_boathookhead_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokenbroom",
        zz_gate = "inv_brokenbroom"
    };
    local clk_boathookhead_2_inv = function ()

      if not cmn.IsEventDone( "get_boathookhead" ) then

        cmn.SetInvPlusRGB( "brokenbroom", false );

      end;

    end;
    local clk_boathookhead_2_beg = function ()

      ObjDelete( "obj_deploy_inv_brokenbroom_clk_boathookhead_2" );

    end;
    function clk_boathookhead_2_end ()
    
      ObjDelete( "spr_deploy_inv_brokenbroom_broom" );
      ObjSet( "obj_deploy_inv_brokenbroom_use_boathookhead", { input = true } );
      ObjSet( "inv_brokenbroom", { res="assets/levels/level1/inv_deploy/inv_brokenbroom/inv/inv_stalk" } );

    end;
    cmn.AddSubscriber( "clk_boathookhead_2", clk_boathookhead_2_inv );
    cmn.AddSubscriber( "clk_boathookhead_2", clk_boathookhead_2_beg, "inv_brokenbroom" );
    cmn.AddSubscriber( "clk_boathookhead_2", clk_boathookhead_2_end, "inv_brokenbroom" );
    cmn.AddSubscriber( "clk_boathookhead_2_inv", clk_boathookhead_2_inv );
    cmn.AddSubscriber( "clk_boathookhead_2_beg", clk_boathookhead_2_beg, "inv_brokenbroom" );
    cmn.AddSubscriber( "clk_boathookhead_2_end", clk_boathookhead_2_end, "inv_brokenbroom" );
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_boathook" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_brokenbroom_boathook",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokenbroom",
        zz_gate = "inv_brokenbroom"
    };
    function get_boathook_inv ()

      interface.InventoryItemRemove( "inv_brokenbroom" );
      interface.InventoryItemAdd( "inv_boathook", "spr_deploy_inv_brokenbroom_boathook" );

    end;
    cmn.AddSubscriber( "get_boathook", get_boathook_inv );
    --------------------------------------------------------------------------------------------

  end;
  -- USE ---------------------------------------------------------------------------------------
  function public.use_boathookhead ()

    local item = "inv_boathookhead";

    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_brokenbroom_use_boathookhead" ) and 
      cmn.IsEventDone( "clk_boathookhead_1" ) and cmn.IsEventDone( "clk_boathookhead_2" ) ) then

      cmn.CallEventHandler( "use_boathookhead_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_boathookhead" );
        cmn.CallEventHandler( "use_boathookhead_end", "inv_brokenbroom" );
        
      end;

      cmn.Lock( true );
      common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_hook" );

      common_impl.ItemFly( "spr_deploy_inv_brokenbroom_gaff", func_end, -2.0 );

      --ObjAnimate( "spr_deploy_inv_brokenbroom_gaff", "alp", 0, 0, func_end,
      --  { 
      --    0.0, 0, 0.0, 
      --    0.3, 0, 1.0
      --  } );

      return true; 

    end;

    return false;

  end;
  -- GET -------------------------------------------------------------------------------------
  function private.get_boathook ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_boathook" );
    cmn.CallEventHandler( "get_boathook", "inv_brokenbroom" );
    common_impl.HideDeployInv();

  end;
  -- CLK -------------------------------------------------------------------------------------
  function private.clk_boathookhead_1 ()

    cmn.CallEventHandler( "clk_boathookhead_1_beg", "inv_brokenbroom" );

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.SetEventDone( "clk_boathookhead_1" );
      cmn.CallEventHandler( "clk_boathookhead_1_end", "inv_brokenbroom" );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_brush1" );

    ObjAnimate( "spr_deploy_inv_brokenbroom_rope_1", "alp", 0, 0, "", 
    {
      0.0, 0, ObjGet( "spr_deploy_inv_brokenbroom_rope_1" ).alp,
      0.3, 0, 0
    } );
    ObjAnimate( "spr_deploy_inv_brokenbroom_rope_2", "alp", 0, 0, func_end, 
    {
      0.0, 0, ObjGet( "spr_deploy_inv_brokenbroom_rope_2" ).alp,
      0.3, 0, ObjGet( "spr_deploy_inv_brokenbroom_rope_2" ).alp,
      0.6, 0, 0
    } );

  end;
  --------------------------------------------------------------------------------------------
  function private.clk_boathookhead_2 ()

    cmn.CallEventHandler( "clk_boathookhead_2_inv" );
    cmn.CallEventHandler( "clk_boathookhead_2_beg", "inv_brokenbroom" );

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.SetEventDone( "clk_boathookhead_2" );
      cmn.CallEventHandler( "clk_boathookhead_2_end", "inv_brokenbroom" );

      common_impl.ShowBbt( "bbt_deploy_inv_boathookhead_clk_boat" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_brush2" );

    ObjAnimate( "spr_deploy_inv_brokenbroom_broom", "alp", 0, 0, func_end, 
    {
      0.0, 0, ObjGet( "spr_deploy_inv_brokenbroom_broom" ).alp,
      0.3, 0, 0
    } );

  end;
--*********************************************************************************************************************
-- function *** drainplug *** () end;
--*********************************************************************************************************************
  function private.drainplug_init ()
    --------------------------------------------------------------------------------------------
    ObjMultiSet( { 
      { "spr_deploy_inv_drainplug_chain2",       { event_mdown = private.get_chain2 } },   
      { "obj_deploy_inv_drainplug_clk_chain2_1", { event_mdown = private.clk_chain2_1 } },      
      { "obj_deploy_inv_drainplug_clk_chain2_2", { event_mdown = private.clk_chain2_2 } },         
    } );
    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_chain2" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_drainplug_chain2",
        room = "int_deploy_inv",
        zz = "deploy_inv_drainplug",
        zz_gate = "inv_drainplug"
    };
    function get_chain2_inv ()

      ObjSet( "inv_chain", { frame = ObjGet( "inv_chain" ).frame + 1 } );
      interface.InventoryItemRemove( "inv_drainplug" );
      interface.InventoryItemAdd( "inv_chain", "spr_deploy_inv_drainplug_chain2" );

    end;
    cmn.AddSubscriber( "get_chain2", get_chain2_inv );
    -- CLK -------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_chain2_1" ] = {
        type = "click",
        use_place = "obj_deploy_inv_drainplug_clk_chain2_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_drainplug",
        zz_gate = "inv_drainplug"
    };
    local clk_chain2_1_beg = function ()

      ObjDelete( "obj_deploy_inv_drainplug_clk_chain2_1" );

    end;
    function clk_chain2_1_end ()
    
      ObjSet( "spr_deploy_inv_drainplug_ring_part", { ang = -1.03 } );
      ObjSet( "obj_deploy_inv_drainplug_clk_chain2_2", { input = true } );

    end;
    cmn.AddSubscriber( "clk_chain2_1", clk_chain2_1_beg, "inv_drainplug" );
    cmn.AddSubscriber( "clk_chain2_1", clk_chain2_1_end, "inv_drainplug" );
    cmn.AddSubscriber( "clk_chain2_1_beg", clk_chain2_1_beg, "inv_drainplug" );
    cmn.AddSubscriber( "clk_chain2_1_end", clk_chain2_1_end, "inv_drainplug" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_chain2_2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_drainplug_clk_chain2_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_drainplug",
        zz_gate = "inv_drainplug"
    };
    local clk_chain2_2_beg = function ()

      ObjDelete( "obj_deploy_inv_drainplug_clk_chain2_2" );

    end;
    function clk_chain2_2_end ()

      ObjDelete( "obj_deploy_inv_drainplug_over" );
      ObjDelete( "spr_deploy_inv_drainplug_patch_1" );
      ObjSet( "spr_deploy_inv_drainplug_chain2", { input = true } );
      ObjSet( "gfx_deploy_inv_drainplug_chain2", { active = true } );

    end;
    cmn.AddSubscriber( "clk_chain2_2", clk_chain2_2_beg, "inv_drainplug" );
    cmn.AddSubscriber( "clk_chain2_2", clk_chain2_2_end, "inv_drainplug" );
    cmn.AddSubscriber( "clk_chain2_2_beg", clk_chain2_2_beg, "inv_drainplug" );
    cmn.AddSubscriber( "clk_chain2_2_end", clk_chain2_2_end, "inv_drainplug" );

  end;
  -- GET -------------------------------------------------------------------------------------
  function private.get_chain2 ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_chain2" );
    cmn.CallEventHandler( "get_chain2", "inv_drainplug" );
    common_impl.HideDeployInv();

  end;
  -- CLK -------------------------------------------------------------------------------------
  function private.clk_chain2_1 ()

    cmn.CallEventHandler( "clk_chain2_1_beg", "inv_drainplug" );

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.SetEventDone( "clk_chain2_1" );
      cmn.CallEventHandler( "clk_chain2_1_end", "inv_drainplug" );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk7" );

    ObjAnimate( "spr_deploy_inv_drainplug_ring_part", "ang", 0, 0, func_end, 
    {
      0.0, 0, ObjGet( "spr_deploy_inv_drainplug_ring_part" ).ang,
      0.3, 0, -1.03
    } );

  end;
  --------------------------------------------------------------------------------------------
  function private.clk_chain2_2 ()

    cmn.CallEventHandler( "clk_chain2_2_beg", "inv_drainplug" );

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.SetEventDone( "clk_chain2_2" );
      cmn.CallEventHandler( "clk_chain2_2_end", "inv_drainplug" );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk7" );

    ObjAnimate( "spr_deploy_inv_drainplug_patch_1", "alp", 0, 0, "", 
    {
      0.0, 0, ObjGet( "spr_deploy_inv_drainplug_patch_1" ).alp,
      0.3, 0, 0
    } );
    ObjAnimate( "obj_deploy_inv_drainplug_over", "alp", 0, 0, func_end, 
    {
      0.0, 0, ObjGet( "obj_deploy_inv_drainplug_over" ).alp,
      0.3, 0, 0
    } );

  end;
--*********************************************************************************************************************
-- function *** mousetrap *** () end;
--*********************************************************************************************************************
  function private.mousetrap_init ()
    --------------------------------------------------------------------------------------------
    ObjMultiSet( { 
      { "spr_deploy_inv_mousetrap_spring",        { event_mdown = private.get_spring } },   

      { "obj_deploy_inv_mousetrap_clk_spring_1",  { event_mdown = private.clk_spring_1 } },      
      { "obj_deploy_inv_mousetrap_clk_spring_2",  { event_mdown = private.clk_spring_2 } },         
    } );
    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_spring" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_mousetrap_spring",
        room = "int_deploy_inv",
        zz = "deploy_inv_mousetrap",
        zz_gate = "inv_mousetrap"
    };
    function get_spring_inv ()

      interface.InventoryItemRemove( "inv_mousetrap" );
      interface.InventoryItemAdd( "inv_spring", "spr_deploy_inv_mousetrap_spring" );

    end;
    cmn.AddSubscriber( "get_spring", get_spring_inv );
    -- CLK -------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_spring_1" ] = {
        type = "click",
        use_place = "obj_deploy_inv_mousetrap_clk_spring_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_mousetrap",
        zz_gate = "inv_mousetrap"
    };
    local clk_spring_1_beg = function ()

      ObjDelete( "obj_deploy_inv_mousetrap_clk_spring_1" );

    end;
    function clk_spring_1_end ()
    
      ObjDelete( "spr_deploy_inv_mousetrap_cheese" );
      ObjSet( "obj_deploy_inv_mousetrap_clk_spring_2", { input = true } )

    end;
    cmn.AddSubscriber( "clk_spring_1", clk_spring_1_beg, "inv_mousetrap" );
    cmn.AddSubscriber( "clk_spring_1", clk_spring_1_end, "inv_mousetrap" );
    cmn.AddSubscriber( "clk_spring_1_beg", clk_spring_1_beg, "inv_mousetrap" );
    cmn.AddSubscriber( "clk_spring_1_end", clk_spring_1_end, "inv_mousetrap" );
    --------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_spring_2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_mousetrap_clk_spring_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_mousetrap",
        zz_gate = "inv_mousetrap"
    };
    local clk_spring_2_beg = function ()

      ObjDelete( "obj_deploy_inv_mousetrap_clk_spring_2" );

    end;
    function clk_spring_2_end ()
    
      ObjDelete( "spr_deploy_inv_mousetrap_curve_big" );
      ObjDelete( "spr_deploy_inv_mousetrap_spring_patch" );
      ObjDelete( "spr_deploy_inv_mousetrap_stick_shadow" );

      ObjSet( "spr_deploy_inv_mousetrap_stick_shadow_1", { ang = 1.18 } );
      ObjSet( "spr_deploy_inv_mousetrap_stick", { ang = 1.28 } );

      ObjSet( "spr_deploy_inv_mousetrap_spring", { input = true } );
      ObjSet( "gfx_deploy_inv_mousetrap_spring", { active = true } );

    end;
    cmn.AddSubscriber( "clk_spring_2", clk_spring_2_beg, "inv_mousetrap" );
    cmn.AddSubscriber( "clk_spring_2", clk_spring_2_end, "inv_mousetrap" );
    cmn.AddSubscriber( "clk_spring_2_beg", clk_spring_2_beg, "inv_mousetrap" );
    cmn.AddSubscriber( "clk_spring_2_end", clk_spring_2_end, "inv_mousetrap" );

  end;
  -- GET -------------------------------------------------------------------------------------
  function private.get_spring ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_spring" );
    cmn.CallEventHandler( "get_spring", "inv_mousetrap" );
    common_impl.HideDeployInv();

  end;
  -- CLK -------------------------------------------------------------------------------------
  function private.clk_spring_1 ()

    cmn.CallEventHandler( "clk_spring_1_beg", "inv_mousetrap" );

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.SetEventDone( "clk_spring_1" );
      cmn.CallEventHandler( "clk_spring_1_end", "inv_mousetrap" );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk1" );

    ObjAnimate( "spr_deploy_inv_mousetrap_cheese", "alp", 0, 0, func_end, 
    {
      0.0, 0, ObjGet( "spr_deploy_inv_mousetrap_cheese" ).alp,
      0.3, 0, 0
    } );

  end;
  --------------------------------------------------------------------------------------------
  function private.clk_spring_2 ()

    cmn.CallEventHandler( "clk_spring_2_beg", "inv_mousetrap" );

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.SetEventDone( "clk_spring_2" );
      cmn.CallEventHandler( "clk_spring_2_end", "inv_mousetrap" );

      common_impl.ShowBbt( "bbt_deploy_inv_mousetrap_clk_spring_2" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5" );

    ObjAnimate( "spr_deploy_inv_mousetrap_stick_shadow", "alp", 0, 0, "", 
    {
      0.0, 0, ObjGet( "spr_deploy_inv_mousetrap_stick_shadow" ).alp,
      0.3, 0, 0
    } );

    ObjAnimate( "spr_deploy_inv_mousetrap_stick_shadow_1", "ang", 0, 0, "", 
    {
      0.0, 2, ObjGet( "spr_deploy_inv_mousetrap_stick_shadow_1" ).ang,
      0.5, 2, 1.18
    } );
    ObjAnimate( "spr_deploy_inv_mousetrap_stick", "ang", 0, 0, "", 
    {
      0.0, 2, ObjGet( "spr_deploy_inv_mousetrap_stick" ).ang,
      0.5, 2, 1.28
    } );

    ObjAnimate( "spr_deploy_inv_mousetrap_curve_big", "alp", 0, 0, func_end, 
    {
      0.0, 0, ObjGet( "spr_deploy_inv_mousetrap_curve_big" ).alp,
      0.5, 0, ObjGet( "spr_deploy_inv_mousetrap_curve_big" ).alp,
      0.8, 0, 0
    } );

  end;
--*********************************************************************************************************************
-- function *** bottle *** () end;
--*********************************************************************************************************************
  function private.bottle_init ()

    --------------------------------------------------------------------------------------------
    ObjMultiSet( { 
      { "spr_deploy_inv_bottle_glasspiece", { event_mdown = private.get_glasspiece } },      
      { "spr_deploy_inv_bottle_plug",       { event_mdown = private.get_plug } },      
      { "spr_deploy_inv_bottle_triangle1",  { event_mdown = private.get_triangle1 } },  

      { "obj_deploy_inv_bottle_clk_hammer", { event_mdown = private.clk_hammer } },  
    } );
    --------------------------------------------------------------------------------------------
    -- USE -------------------------------------------------------------------------------------
    common_impl.hint[ "use_hammer" ] = {
        type = "use",
        inv_obj = "inv_hammer",
        use_place = "obj_deploy_inv_bottle_use_hammer",
        room = "int_deploy_inv",
        zz = "deploy_inv_bottle",
        zz_gate = "inv_bottle"
    };

    function use_hammer_beg ()
      
      ObjDelete( "obj_deploy_inv_bottle_use_hammer" );
      interface.InventoryItemRemove( "inv_hammer" );  

    end;
    function use_hammer_end ()
      
      ObjDelete( "vid_deploy_inv_bottle_use_hammer" );
      ObjSet( "obj_deploy_inv_bottle_broken_bottle", { alp = 1, input = true  } );

    end;
    cmn.AddSubscriber( "use_hammer", use_hammer_beg );
    cmn.AddSubscriber( "use_hammer", use_hammer_end, "inv_bottle" );
    cmn.AddSubscriber( "use_hammer_beg", use_hammer_beg );
    cmn.AddSubscriber( "use_hammer_end", use_hammer_end, "inv_bottle" );
    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_glasspiece" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_bottle_glasspiece",
        room = "int_deploy_inv",
        zz = "deploy_inv_bottle",
        zz_gate = "inv_bottle"
    };
    function get_glasspiece_inv ()

      if ( cmn.IsEventDone( "get_plug" ) and  cmn.IsEventDone( "get_triangle1" ) ) then

        interface.InventoryItemRemove( "inv_bottle" );          

      end;

      interface.InventoryItemAdd( "inv_glasspiece", "spr_deploy_inv_bottle_glasspiece" );

    end;
    cmn.AddSubscriber( "get_glasspiece", get_glasspiece_inv );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_plug" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_bottle_plug",
        room = "int_deploy_inv",
        zz = "deploy_inv_bottle",
        zz_gate = "inv_bottle"
    };
    function get_plug_inv ()

      if ( cmn.IsEventDone( "get_glasspiece" ) and  cmn.IsEventDone( "get_triangle1" ) ) then

        interface.InventoryItemRemove( "inv_bottle" );          

      end;

      interface.InventoryItemAdd( "inv_plug", "spr_deploy_inv_bottle_plug" );

    end;
    cmn.AddSubscriber( "get_plug", get_plug_inv );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_triangle1" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_bottle_triangle1",
        room = "int_deploy_inv",
        zz = "deploy_inv_bottle",
        zz_gate = "inv_bottle"
    };
    function get_triangle1_inv ()

      if ( cmn.IsEventDone( "get_glasspiece" ) and  cmn.IsEventDone( "get_plug" ) ) then

        interface.InventoryItemRemove( "inv_bottle" );          

      end;

      ObjSet( "inv_triangle", { frame = ObjGet( "inv_triangle" ).frame + 1 } );
      interface.InventoryItemAdd( "inv_triangle", "spr_deploy_inv_bottle_triangle1" );

    end;
    cmn.AddSubscriber( "get_triangle1", get_triangle1_inv );
    --------------------------------------------------------------------------------------------

  end;
  -- USE ---------------------------------------------------------------------------------------
  function public.use_hammer ()

    local item = "inv_hammer";

    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_bottle_use_hammer" ) )  then

      cmn.CallEventHandler( "use_hammer_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_hammer" );
        cmn.CallEventHandler( "use_hammer_end", "inv_bottle" );
        
      end;

      cmn.Lock( true );
      common_impl.PlayAudio("sfx","level1/sfx/aud_use_hammer" );

      --ObjAnimate( "spr_deploy_inv_bottle_cracks", "alp", 0, 0, func_end,
      --  { 
      --    0.0, 0, ObjGet( "spr_deploy_inv_bottle_cracks" ).alp, 
      --    0.3, 0, 1.0
      --  } );
      VidPlay( "vid_deploy_inv_bottle_use_hammer", func_end );

      return true; 

    end;

    return false;

  end;
  -- GET -------------------------------------------------------------------------------------
  function private.get_glasspiece ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_glasspiece" );
    cmn.CallEventHandler( "get_glasspiece", "inv_bottle" );
    
    if ( cmn.IsEventDone( "get_plug" ) and  cmn.IsEventDone( "get_triangle1" ) ) then

      common_impl.HideDeployInv();          

    end;

  end;
  --------------------------------------------------------------------------------------------
  function private.get_plug ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_plug" );
    cmn.CallEventHandler( "get_plug", "inv_bottle" );
    
    if ( cmn.IsEventDone( "get_glasspiece" ) and  cmn.IsEventDone( "get_triangle1" ) ) then

      common_impl.HideDeployInv();          

    end;

  end;
  --------------------------------------------------------------------------------------------
  function private.get_triangle1 ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_triangle1" );
    cmn.CallEventHandler( "get_triangle1", "inv_bottle" );
    
    if ( cmn.IsEventDone( "get_plug" ) and  cmn.IsEventDone( "get_glasspiece" ) ) then

      common_impl.HideDeployInv();          

    end;

  end;
--*********************************************************************************************************************
-- function *** register *** () end;
--*********************************************************************************************************************
  function private.register_init ()
    --------------------------------------------------------------------------------------------
    ObjMultiSet( { 
      { "spr_deploy_inv_register_triangle3",         { event_mdown = private.get_triangle3 } },  

      { "obj_deploy_inv_register_clk_triangle3_1", { event_mdown = private.clk_triangle3_1 } },      
      { "obj_deploy_inv_register_clk_triangle3_2", { event_mdown = private.clk_triangle3_2 } },      
      { "obj_deploy_inv_register_clk_triangle3_3", { event_mdown = private.clk_triangle3_3 } },          
      { "obj_deploy_inv_register_clk_triangle3_4", { event_mdown = private.clk_triangle3_4 } },          
    } );
    --------------------------------------------------------------------------------------------
    -- CLK -------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_triangle3_1" ] = {
        type = "click",
        use_place = "obj_deploy_inv_register_clk_triangle3_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_register",
        zz_gate = "inv_register"
    };
    local clk_triangle3_1_beg = function ()

      ObjDelete( "obj_deploy_inv_register_clk_triangle3_1" );

    end;
    function clk_triangle3_1_end ()
    
      ObjDelete( "spr_deploy_inv_register_back" );

      ObjSet( "obj_deploy_inv_register_page_1", { alp = 1 } );
      ObjSet( "obj_deploy_inv_register_clk_triangle3_2", { input = true } );

    end;
    cmn.AddSubscriber( "clk_triangle3_1", clk_triangle3_1_beg, "inv_register" );
    cmn.AddSubscriber( "clk_triangle3_1", clk_triangle3_1_end, "inv_register" );
    cmn.AddSubscriber( "clk_triangle3_1_beg", clk_triangle3_1_beg, "inv_register" );
    cmn.AddSubscriber( "clk_triangle3_1_end", clk_triangle3_1_end, "inv_register" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_triangle3_2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_register_clk_triangle3_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_register",
        zz_gate = "inv_register"
    };
    local clk_triangle3_2_beg = function ()

      ObjDelete( "obj_deploy_inv_register_clk_triangle3_2" );

    end;
    function clk_triangle3_2_end ()
    
      ObjSet( "obj_deploy_inv_register_page_2", { alp = 1 } );
      ObjSet( "obj_deploy_inv_register_clk_triangle3_3", { input = true } );

    end;
    cmn.AddSubscriber( "clk_triangle3_2", clk_triangle3_2_beg, "inv_register" );
    cmn.AddSubscriber( "clk_triangle3_2", clk_triangle3_2_end, "inv_register" );
    cmn.AddSubscriber( "clk_triangle3_2_beg", clk_triangle3_2_beg, "inv_register" );
    cmn.AddSubscriber( "clk_triangle3_2_end", clk_triangle3_2_end, "inv_register" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_triangle3_3" ] = {
        type = "click",
        use_place = "obj_deploy_inv_register_clk_triangle3_3",
        room = "int_deploy_inv",
        zz = "deploy_inv_register",
        zz_gate = "inv_register"
    };
    local clk_triangle3_3_beg = function ()

      ObjDelete( "obj_deploy_inv_register_clk_triangle3_3" );

    end;
    function clk_triangle3_3_end ()
    
      ObjSet( "spr_deploy_inv_register_page_2_frame", { alp = 1, input = true } );
      ObjSet( "obj_deploy_inv_register_clk_triangle3_4", { input = true } );

    end;
    cmn.AddSubscriber( "clk_triangle3_3", clk_triangle3_3_beg, "inv_register" );
    cmn.AddSubscriber( "clk_triangle3_3", clk_triangle3_3_end, "inv_register" );
    cmn.AddSubscriber( "clk_triangle3_3_beg", clk_triangle3_3_beg, "inv_register" );
    cmn.AddSubscriber( "clk_triangle3_3_end", clk_triangle3_3_end, "inv_register" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_triangle3_4" ] = {
        type = "click",
        use_place = "obj_deploy_inv_register_clk_triangle3_4",
        room = "int_deploy_inv",
        zz = "deploy_inv_register",
        zz_gate = "inv_register"
    };
    local clk_triangle3_4_beg = function ()

      ObjDelete( "obj_deploy_inv_register_clk_triangle3_4" );

    end;
    function clk_triangle3_4_end ()
    
      ObjDelete( "obj_deploy_inv_register_page_2" );

      ObjSet( "obj_deploy_inv_register_page_3", { alp = 1, input = true } );

    end;
    cmn.AddSubscriber( "clk_triangle3_4", clk_triangle3_4_beg, "inv_register" );
    cmn.AddSubscriber( "clk_triangle3_4", clk_triangle3_4_end, "inv_register" );
    cmn.AddSubscriber( "clk_triangle3_4_beg", clk_triangle3_4_beg, "inv_register" );
    cmn.AddSubscriber( "clk_triangle3_4_end", clk_triangle3_4_end, "inv_register" );
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_triangle3" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_register_triangle3",
        room = "int_deploy_inv",
        zz = "deploy_inv_register",
        zz_gate = "inv_register"
    };
    function get_triangle3_inv ()

      interface.InventoryItemRemove( "inv_register" );

      ObjSet( "inv_triangle", { frame = ObjGet( "inv_triangle" ).frame + 1 } );
      interface.InventoryItemAdd( "inv_triangle", "spr_deploy_inv_register_triangle3" );

    end;
    cmn.AddSubscriber( "get_triangle3", get_triangle3_inv );
  end;
  -- CLK -------------------------------------------------------------------------------------
  function private.clk_triangle3_1 ()

    cmn.CallEventHandler( "clk_triangle3_1_beg", "inv_register" );

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.SetEventDone( "clk_triangle3_1" );
      cmn.CallEventHandler( "clk_triangle3_1_end", "inv_register" );

      common_impl.ShowBbt( "bbt_deploy_inv_register_clk_triangle3_1" );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_book" );

    ObjAnimate( "spr_deploy_inv_register_back", "alp", 0, 0, "", 
      {
        0.0, 0, ObjGet( "spr_deploy_inv_register_back" ).alp,
        0.3, 0, 0
      } );
    ObjAnimate( "obj_deploy_inv_register_page_1", "alp", 0, 0, func_end, 
      {
        0.0, 0, ObjGet( "obj_deploy_inv_register_page_1" ).alp,
        0.3, 0, 1
      } );

  end;
  --------------------------------------------------------------------------------------------
  function private.clk_triangle3_2 ()

    cmn.CallEventHandler( "clk_triangle3_2_beg", "inv_register" );

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.SetEventDone( "clk_triangle3_2" );
      cmn.CallEventHandler( "clk_triangle3_2_end", "inv_register" );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_page" );

    ObjAnimate( "obj_deploy_inv_register_page_2", "alp", 0, 0, func_end, 
      {
        0.0, 0, ObjGet( "obj_deploy_inv_register_page_2" ).alp,
        0.3, 0, 1
      } );

  end;
  --------------------------------------------------------------------------------------------
  function private.clk_triangle3_3 ()

    cmn.CallEventHandler( "clk_triangle3_3_beg", "inv_register" );

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.SetEventDone( "clk_triangle3_3" );
      cmn.CallEventHandler( "clk_triangle3_3_end", "inv_register" );

      common_impl.ShowBbt( "bbt_register_clk_triangle3_3" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "aud_paper" );

    ObjAnimate( "spr_deploy_inv_register_page_2_frame", "alp", 0, 0, func_end, 
      {
        0.0, 0, 0,
        0.3, 0, 1
      } );

  end;
  --------------------------------------------------------------------------------------------
  function private.clk_triangle3_4 ()

    cmn.CallEventHandler( "clk_triangle3_4_beg", "inv_register" );

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.SetEventDone( "clk_triangle3_4" );
      cmn.CallEventHandler( "clk_triangle3_4_end", "inv_register" );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_page" );

    ObjAnimate( "obj_deploy_inv_register_page_2", "alp", 0, 0, "", 
      {
        0.0, 0, ObjGet( "obj_deploy_inv_register_page_2" ).alp,
        0.3, 0, 0
      } );
    ObjAnimate( "obj_deploy_inv_register_page_3", "alp", 0, 0, func_end, 
      {
        0.0, 0, ObjGet( "obj_deploy_inv_register_page_3" ).alp,
        0.3, 0, 1
      } );

  end;
  -- GET -------------------------------------------------------------------------------------
  function private.get_triangle3 ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_triangle3" );
    cmn.CallEventHandler( "get_triangle3", "inv_register" );
    common_impl.HideDeployInv();

  end;
--*********************************************************************************************************************
-- function *** saucepan *** () end;
--*********************************************************************************************************************
  function private.saucepan_init()
    --------------------------------------------------------------------------------------------
    ObjMultiSet( { 

      { "spr_deploy_inv_saucepan",         { event_mdown = private.get_waterscoop } },  

    } );
    -- USE -------------------------------------------------------------------------------------
    common_impl.hint[ "use_plaster" ] = {
        type = "use",
        inv_obj = "inv_plaster",
        use_place = "obj_deploy_inv_saucepan_use_plaster",
        room = "int_deploy_inv",
        zz = "deploy_inv_saucepan",
        zz_gate = "inv_saucepan"
    };    
    function use_plaster_beg ()

      ObjDelete( "obj_deploy_inv_saucepan_use_plaster" );
      interface.InventoryItemRemove( "inv_plaster" );   

    end;
    function use_plaster_end ()

      ObjDelete( "vid_deploy_inv_saucepan_water" );
      ObjDelete( "vid_deploy_inv_saucepan_use_gypsum" );
      ObjSet( "vid_deploy_inv_saucepan_plaster", { alp = 1, playing = true } );

      ObjDelete( "spr_deploy_inv_saucepan_waterscoop" );
      ObjSet( "spr_deploy_inv_saucepan", { alp = 1, visible = 1, input = true } );
      ObjSet( "gfx_deploy_inv_saucepan", { active = true } );

    end;
    cmn.AddSubscriber( "use_plaster", use_plaster_beg );
    cmn.AddSubscriber( "use_plaster", use_plaster_end, "inv_saucepan" );
    cmn.AddSubscriber( "use_plaster_beg", use_plaster_beg );
    cmn.AddSubscriber( "use_plaster_end", use_plaster_end, "inv_saucepan" );
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_waterscoop" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_saucepan",
        room = "int_deploy_inv",
        zz = "deploy_inv_saucepan",
        zz_gate = "inv_saucepan"
    };
    function get_waterscoop_inv ()

      interface.InventoryItemRemove( "inv_saucepan" );

      interface.InventoryItemAdd( "inv_waterscoop", "spr_deploy_inv_saucepan" );
       
    end;
    cmn.AddSubscriber( "get_waterscoop", get_waterscoop_inv );

  end;
  -- USE ---------------------------------------------------------------------------------------
  function public.use_plaster ()

    local item = "inv_plaster";
    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_saucepan_use_plaster" ) )  then

      cmn.CallEventHandler( "use_plaster_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_plaster" );
        cmn.CallEventHandler( "use_plaster_end", "inv_saucepan" );
        
      end;

      local func_end_2 = function ()
        
        ObjSet( "spr_deploy_inv_saucepan_waterscoop", { alp = 0 } );
        
      end;

      cmn.Lock( true );
      common_impl.PlayAudio( "sfx","level1/sfx/aud_use_powder" );

      ObjSet( "vid_deploy_inv_saucepan_use_gypsum", { alp = 0, visible = true } );
      ObjAnimate( "vid_deploy_inv_saucepan_use_gypsum", "alp",0,0, func_end_2, { 0, 0, 0,    0.3, 0, 1 } );
      VidPlay( "vid_deploy_inv_saucepan_use_gypsum", func_end );

      return true; 

    end;

    return false;

  end;
  -- GET -------------------------------------------------------------------------------------
  function private.get_waterscoop ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_waterscoop" );
    cmn.CallEventHandler( "get_waterscoop", "inv_saucepan" );
    
    common_impl.HideDeployInv();          

  end;
--***********************************************************************************
function private.ItemGo ()

  if ( cmn.IsEventDone( "win_small_suitcase" ) ) then

    cmn.GotoRoom( "ho_suitcase" );

  else

    common_impl.ShowDeployInv( "inv_small_suitcase" ); 
    level1_inv.SmallSuitcaseInitVar();

  end;

end;
--***********************************************************************************













