-- name=rm_bar
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_bar";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_stashwall", "room_hub" );
  ObjAttach( "zz_panel", "room_hub" );
  ObjAttach( "zz_barstand", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
    { "spr_stashwall_bottle",               { event_mdown = private.get_bottle } },
    { "spr_stashwall_rope_1",               { event_mdown = private.get_rope } },
    { "spr_stashwall_rope_2",               { event_mdown = private.get_rope } },
    { "spr_barstand_triangle2",             { event_mdown = private.get_triangle2 } },
    { "spr_barstand_register",              { event_mdown = private.get_register } },

    { "obj_stashwall_clk_stashwall_web",    { event_mdown = private.clk_stashwall_web } },
    { "obj_stashwall_clk_stashwall_door",   { event_mdown = private.clk_stashwall_door } },
    { "obj_stashwall_clk_stashwall_button", { event_mdown = private.clk_stashwall_button } },
    { "obj_stashwall_use_glasspiece",       { event_mdown = private.ClkUseGlasspiece } },
    { "obj_barstand_clk_triangle2",         { event_mdown = private.clk_triangle2 } },
    { "obj_panel_use_clippers_2",           { event_mdown = private.ClkLock } },

    { "obj_bar_see_turn_off_light",         { event_mdown = private.TurnOffLight } },
    { "obj_bar_see_turn_off_light_focus",   { event_mdown = private.TurnOffLight } },

    { "spr_collect2_item_1_2",              { event_mdown = private.get_collect2_item_1_2 } },

    { "spr_bar_collect_item",               { event_mdown = function () common_impl.GetCollectItem( "get_collect_item_1_3" ); end } },
    { "spr_bar_collect_morph_item",         { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_1_4" ); end } },
    { "spr_barstand_cookies",               { event_mdown = private.get_cookies } },
  } );

  private.InitAnimations();
  private.InitBarstand();
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_bar = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "gmg_bar_superpuzzle1",
      "gmg_bar_panel",
      "gzz_bar_stashwall",
      "gzz_bar_panel",
      "gzz_bar_barstand"
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_stashwall",
      "zz_panel",
      "zz_barstand",
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_bar", update_game_mode_bar, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_bar = function ()

  local effects_table = 
  {
    "anm_bar_door_dark",
    "anm_bar_lights_tv",
    "anm_bar_bottle",
    "anm_bar_lights_tv_dark",
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_bar", update_performance_mode_bar, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_bar () end;
  --------------------------------------------------------------------------------------------
  local opn_bar_map = function ()

    common_impl.VisitMapRoom( "bar" );

  end;
  cmn.AddSubscriber( "opn_bar", opn_bar_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_bottle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bottle" ] = {
    type = "get",
    get_obj = "spr_stashwall_bottle",
    room = private.room_objname,
    zz = "zz_stashwall",
    zz_gate = "gzz_bar_stashwall"
  };
  
  local get_bottle_inv = function ()
  
    interface.InventoryItemAdd( "inv_bottle", "spr_stashwall_bottle" );
    ObjSet( "inv_bottle", { drag = false } );  

  end;
  
  local get_bottle_closezz = function ()
  
    ObjDelete( "gfx_stashwall_bottle" );
    ObjDelete( "spr_stashwall_bottle_shadow" );

    ObjDelete( "spr_bar_stashwall_bottel" );
  
  end;
  
  cmn.AddSubscriber( "get_bottle", get_bottle_inv );
  cmn.AddSubscriber( "get_bottle", get_bottle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_rope () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_rope" ] = {
    type = "get",
    get_obj = "spr_stashwall_rope_1",
    room = private.room_objname,
    zz = "zz_stashwall",
    zz_gate = "gzz_bar_stashwall"
  };
  
  local get_rope_inv = function ()
  
    interface.InventoryItemAdd( "inv_rope", "obj_stashwall_rope" );
  
  end;
  
  local get_rope_closezz = function ()
  
    ObjDelete( "gfx_stashwall_rope" );
    ObjDelete( "spr_stashwall_rope_over" );
    ObjSet( "obj_stashwall_clk_stashwall_door", { input = true } );

    ObjDelete( "spr_bar_stashwall_3" );
    ObjSet( "spr_bar_stashwall_cover", { alp = 1 } );

  end;
  
  cmn.AddSubscriber( "get_rope", get_rope_inv );
  cmn.AddSubscriber( "get_rope", get_rope_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_triangle2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_triangle2" ] = {
    type = "get",
    get_obj = "spr_barstand_triangle2",
    room = private.room_objname,
    zz = "zz_barstand",
    zz_gate = "gzz_bar_barstand"
  };
  
  local get_triangle2_inv = function ()
  
    ObjSet( "inv_triangle", { frame = ObjGet( "inv_triangle" ).frame + 1 } );
    interface.InventoryItemAdd( "inv_triangle", "spr_barstand_triangle2" );
  
  end;
  
  local get_triangle2_closezz = function ()
  
    ObjDelete( "gfx_barstand_triangle2" );

    if ( cmn.IsEventDone( "get_register" ) and cmn.IsGetCollect2( "get_collect2_item_1_2" ) ) then

      ObjDelete( "gzz_bar_barstand" );

    end;

    ObjDelete( "spr_bar_barstand_2" );
    ObjSet( "spr_bar_barstand_3", { alp = 1 } );
  
  end;
  
  cmn.AddSubscriber( "get_triangle2", get_triangle2_inv );
  cmn.AddSubscriber( "get_triangle2", get_triangle2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_register () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_register" ] = {
    type = "get",
    get_obj = "spr_barstand_register",
    room = private.room_objname,
    zz = "zz_barstand",
    zz_gate = "gzz_bar_barstand"
  };
  
  local get_register_inv = function ()
  
    interface.InventoryItemAdd( "inv_register", "spr_barstand_register" );
    ObjSet( "inv_register", { drag = false } );
  
  end;
  
  local get_register_closezz = function ()
  
    ObjDelete( "gfx_barstand_register" );

    if ( cmn.IsEventDone( "get_triangle2" ) and cmn.IsGetCollect2( "get_collect2_item_1_2" ) ) then

      ObjDelete( "gzz_bar_barstand" );

    end;  

  end;
  
  cmn.AddSubscriber( "get_register", get_register_inv );
  cmn.AddSubscriber( "get_register", get_register_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_glasspiece () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_glasspiece" ] = {
    type = "use",
    inv_obj = "inv_glasspiece",
    use_place = "obj_stashwall_use_glasspiece",
    room = private.room_objname,
    zz = "zz_stashwall",
    zz_gate = "gzz_bar_stashwall"
  };
  local use_glasspiece_inv = function ()
  
    interface.InventoryItemRemove( "inv_glasspiece" );
  
  end;
  local use_glasspiece_beg = function ()
  
    ObjDelete( "obj_stashwall_use_glasspiece" );
  
  end;
  local use_glasspiece_end = function ()
  
    ObjSet( "obj_stashwall_rope", { input = true, alp = 1 } );
    ObjSet( "gfx_stashwall_rope", { active = true } );
    ObjDelete( "anm_stashwall_glass" );

    ObjDelete( "spr_bar_stashwall_2" );
    ObjSet( "spr_bar_stashwall_3", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_glasspiece", use_glasspiece_beg, private.room_objname );
  cmn.AddSubscriber( "use_glasspiece", use_glasspiece_inv );
  cmn.AddSubscriber( "use_glasspiece", use_glasspiece_end, private.room_objname );
  cmn.AddSubscriber( "use_glasspiece_inv", use_glasspiece_inv, private.room_objname );
  cmn.AddSubscriber( "use_glasspiece_beg", use_glasspiece_beg, private.room_objname );
  cmn.AddSubscriber( "use_glasspiece_end", use_glasspiece_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_1_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_1_3 = function ()
  
    ObjDelete( "obj_bar_collect" );
  
  end;    
  cmn.AddSubscriber( "get_collect_item_1_3", get_collect_item_1_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_1_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_1_2 = function ()
  
    ObjDelete( "obj_collect2_item_1_2" );

    if ( cmn.IsEventDone( "get_register" ) and  
        cmn.IsEventDone( "get_triangle2" ) ) then

      ObjDelete( "gzz_bar_barstand" );

    end;
  
  end;    
  cmn.AddSubscriber( "get_collect2_item_1_2", get_collect2_item_1_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_4 = function ()
  
    ObjDelete( "obj_bar_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_4", get_collect_morph_item_1_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_triangle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_triangle" ] = {
    type = "use",
    inv_obj = "inv_triangle",
    use_place = "obj_stashwall_use_triangle",
    room = private.room_objname,
    zz = "zz_stashwall",
    zz_gate = "gzz_bar_stashwall"
  };
  local use_triangle_inv = function ()
  
    interface.InventoryItemRemove( "inv_triangle" );
  
  end;
  local use_triangle_beg = function ()
  
    ObjDelete( "obj_stashwall_use_triangle" );
  
  end;
  local use_triangle_end = function ()
  
    ObjSet( "spr_stashwall_triangle_1", { alp = 1 } );
    ObjSet( "spr_stashwall_triangle_2", { alp = 1 } );
    ObjSet( "spr_stashwall_triangle_3", { alp = 1 } );
    ObjSet( "anm_stashwall_button", { alp = 1 } );

    ObjSet( "obj_stashwall_clk_stashwall_button", { input = true } );

    ObjSet( "spr_bar_stashwall_triangle1", { alp = 1 } );
    ObjSet( "spr_bar_stashwall_triangle2", { alp = 1 } );
    ObjSet( "spr_bar_stashwall_triangle3", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_triangle", use_triangle_beg, private.room_objname );
  cmn.AddSubscriber( "use_triangle", use_triangle_inv );
  cmn.AddSubscriber( "use_triangle", use_triangle_end, private.room_objname );
  cmn.AddSubscriber( "use_triangle_inv", use_triangle_inv, private.room_objname );
  cmn.AddSubscriber( "use_triangle_beg", use_triangle_beg, private.room_objname );
  cmn.AddSubscriber( "use_triangle_end", use_triangle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_clippers_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_clippers_2" ] = {
    type = "use",
    inv_obj = "inv_clippers",
    use_place = "obj_panel_use_clippers_2",
    room = private.room_objname,
    zz = "zz_panel",
    zz_gate = "gzz_bar_panel"
  };
  local use_clippers_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_clippers" );
  
  end;
  local use_clippers_2_beg = function ()
  
    ObjDelete( "obj_panel_lock" );
    ObjDelete( "obj_panel_use_clippers_2" );
  
  end;
  local use_clippers_2_end = function ()
  
    ObjDelete( "gzz_bar_panel" );
    ObjSet( "gmg_bar_panel", { input = true, active = true } );

    ObjDelete( "spr_bar_panel_1" );
    ObjSet( "spr_bar_panel_2", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_clippers_2", use_clippers_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_clippers_2", use_clippers_2_inv );
  cmn.AddSubscriber( "use_clippers_2", use_clippers_2_end, private.room_objname );
  cmn.AddSubscriber( "use_clippers_2_inv", use_clippers_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_clippers_2_beg", use_clippers_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_clippers_2_end", use_clippers_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_basreliefpart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_basreliefpart" ] = {
    type = "use",
    inv_obj = "inv_basreliefpart",
    use_place = "obj_barstand_use_basreliefpart",
    room = private.room_objname,
    zz = "zz_barstand",
    zz_gate = "gzz_bar_barstand"
  };
  local use_basreliefpart_inv = function ()
  
    interface.InventoryItemRemove( "inv_basreliefpart" );
  
  end;
  local use_basreliefpart_beg = function ()
  
    ObjDelete( "obj_barstand_use_basreliefpart" );
  
  end;
  local use_basreliefpart_end = function ()
  
    ObjSet( "obj_barstand_mmg", { input = true } );
    ObjSet( "spr_barstand_basreliefpart_4", { alp = 1 } );
    ObjDelete( "spr_barstand_cover" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_basreliefpart", use_basreliefpart_beg, private.room_objname );
  cmn.AddSubscriber( "use_basreliefpart", use_basreliefpart_inv );
  cmn.AddSubscriber( "use_basreliefpart", use_basreliefpart_end, private.room_objname );
  cmn.AddSubscriber( "use_basreliefpart_inv", use_basreliefpart_inv, private.room_objname );
  cmn.AddSubscriber( "use_basreliefpart_beg", use_basreliefpart_beg, private.room_objname );
  cmn.AddSubscriber( "use_basreliefpart_end", use_basreliefpart_end, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS CLK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_triangle2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_triangle2" ] = {
    type = "click",
    use_place = "obj_barstand_clk_triangle2",
    room = private.room_objname,
    zz = "zz_barstand",
    zz_gate = "gzz_bar_barstand"
  };

  local clk_triangle2_beg = function ()
  
    ObjDelete( "obj_barstand_clk_triangle2" );
  
  end;
  local clk_triangle2_end = function ()

    ObjSet( "spr_barstand_triangle2", { input = true } );
    ObjSet( "gfx_barstand_triangle2", { active = true } );
    ObjSet( "spr_barstand_wineglass", { pos_x = 107, pos_y = -143 } );

    ObjDelete( "spr_bar_barstand_1" );
    ObjSet( "spr_bar_barstand_2", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_triangle2", clk_triangle2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_triangle2", clk_triangle2_end, private.room_objname );
  cmn.AddSubscriber( "clk_triangle2_beg", clk_triangle2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_triangle2_end", clk_triangle2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_stashwall_web () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_stashwall_web" ] = {
    type = "click",
    use_place = "obj_stashwall_clk_stashwall_web",
    room = private.room_objname,
    zz = "zz_stashwall",
    zz_gate = "gzz_bar_stashwall"
  };

  local clk_stashwall_web_beg = function ()
  
    ObjDelete( "obj_stashwall_clk_stashwall_web" );
  
  end;
  local clk_stashwall_web_end = function ()

    ObjDelete( "spr_stashwall_web_1" );
    ObjDelete( "spr_stashwall_web_2" );
    ObjSet( "spr_stashwall_bottle", { input = true } );
    ObjSet( "gfx_stashwall_bottle", { active = true } );
    ObjSet( "obj_stashwall_use_glasspiece", { input = true } );

    ObjDelete( "spr_bar_stashwall_1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_stashwall_web", clk_stashwall_web_beg, private.room_objname );
  cmn.AddSubscriber( "clk_stashwall_web", clk_stashwall_web_end, private.room_objname );
  cmn.AddSubscriber( "clk_stashwall_web_beg", clk_stashwall_web_beg, private.room_objname );
  cmn.AddSubscriber( "clk_stashwall_web_end", clk_stashwall_web_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_stashwall_door () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_stashwall_door" ] = {
    type = "click",
    use_place = "obj_stashwall_clk_stashwall_door",
    room = private.room_objname,
    zz = "zz_stashwall",
    zz_gate = "gzz_bar_stashwall"
  };

  local clk_stashwall_door_beg = function ()
  
    ObjDelete( "obj_stashwall_clk_stashwall_door" );
  
  end;
  local clk_stashwall_door_end = function ()

    ObjSet( "spr_stashwall_door_1", { pos_x = -230, pos_y = -75, scale_x = 0.97, scale_y = 0.97 } );
    ObjSet( "spr_stashwall_door_2", { pos_x = 356, pos_y = -50, scale_x = 1.04, scale_y = 1.04 } );

    ObjSet( "obj_stashwall_use_triangle", { input = true } );

    ObjDelete( "spr_bar_stashwall_cover" );
    ObjSet( "spr_bar_stashwall_4", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_stashwall_door", clk_stashwall_door_beg, private.room_objname );
  cmn.AddSubscriber( "clk_stashwall_door", clk_stashwall_door_end, private.room_objname );
  cmn.AddSubscriber( "clk_stashwall_door_beg", clk_stashwall_door_beg, private.room_objname );
  cmn.AddSubscriber( "clk_stashwall_door_end", clk_stashwall_door_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_stashwall_button () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_stashwall_button" ] = {
    type = "click",
    use_place = "obj_stashwall_clk_stashwall_button",
    room = private.room_objname,
    zz = "zz_stashwall",
    zz_gate = "gzz_bar_stashwall"
  };

  local clk_stashwall_button_beg = function ()
  
    ObjDelete( "obj_stashwall_clk_stashwall_button" );
  
  end;
  local clk_stashwall_button_end = function ()

    ObjSet( "gmg_bar_superpuzzle1", { input = true, active = true } );
    ObjDelete( "gzz_bar_stashwall" );

    ObjDelete( "spr_bar_stashwall" );
    ObjDelete( "spr_bar_stashwall_4" );

  end;

  local clk_stashwall_button_anm = function ()

    ObjDelete( "anm_bar_secret_door" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_stashwall_button", clk_stashwall_button_beg, private.room_objname );
  cmn.AddSubscriber( "clk_stashwall_button", clk_stashwall_button_end, private.room_objname );
  cmn.AddSubscriber( "clk_stashwall_button", clk_stashwall_button_anm, private.room_objname );
  cmn.AddSubscriber( "clk_stashwall_button_beg", clk_stashwall_button_beg, private.room_objname );
  cmn.AddSubscriber( "clk_stashwall_button_end", clk_stashwall_button_end, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS WIN
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function win_barstand () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_barstand" ] =
  {
      type = "win",
      room = private.room_objname,
      zz = "zz_barstand",
      zz_gate = "gzz_bar_barstand"
  };
  local win_barstand = function ()

    if ( cmn.IsEventDone( "win_barstand" ) ) then

      ObjSet( "spr_barstand_register", { input = true, alp = 1 } );  
      ObjSet( "gfx_barstand_register", { active = true } );  
      ObjSet( "obj_barstand_mmg", { input = false } );      
      --ObjSet( "obj_barstand_mmg_right", { pos_x = 155, pos_y = -80 } );
      ObjSet( "obj_barstand_mmg_right", { pos_x = 149, pos_y = -70 } );
      ObjSet( "obj_barstand_mmg_left", { pos_x = -143, pos_y = 53 } );
      ObjSet( "spr_barstand_patch_2", { pos_z = 3 } );

    end;

  end;
  cmn.AddSubscriber( "win_barstand", win_barstand, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_turn_off_light () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_turn_off_light" ] = {
    type = "click",
    use_place = "obj_bar_see_turn_off_light_focus",
    room = private.room_objname
  };

  local see_turn_off_light = function ()

    ObjDelete( "obj_bar_see_turn_off_light" );
    ObjSet( "spr_bar_back_dark", { alp = 1 } );
    ObjSet( "anm_bar_lights_tv", { alp = 0, playing = false } );
    ObjSet( "anm_bar_lights_tv_dark", { alp = 1, playing = true } );
    ObjDelete( "anm_bar_door_dark" );

  end;

  cmn.AddSubscriber( "see_turn_off_light", see_turn_off_light, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_turn_on_light () end;
  --------------------------------------------------------------------------------------------
  local see_turn_on_light = function ()

    ObjSet( "gzz_bar_stashwall", { input = true, active = true } );
    ObjSet( "gzz_bar_barstand", { input = true, active = true } );
    ObjDelete( "spr_bar_back_dark" );
    ObjDelete( "anm_bar_bottle" );
    ObjSet( "obj_bar_bottle", { alp = 1 } );
    ObjSet( "anm_bar_lights_tv", { alp = 1, playing = true } );
    --ObjSet( "anm_bar_lights_tv_dark", { alp = 0, playing = true } );
    ObjDelete( "anm_bar_lights_tv_dark" );

    ObjSet( "obj_bar_objects", { input = true } );

  end;

  cmn.AddSubscriber( "see_turn_on_light", see_turn_on_light, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_bar_scare_1 () end;
  --------------------------------------------------------------------------------------------
  local see_bar_scare_1 = function ()



  end;

  cmn.AddSubscriber( "see_bar_scare_1", see_bar_scare_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_masked_man_4 () end;
  --------------------------------------------------------------------------------------------
  local see_masked_man_4 = function ()



  end;

  cmn.AddSubscriber( "see_masked_man_4", see_masked_man_4, private.room_objname );
 
end;
--*********************************************************************************************************************
function public.Load ()

  if ( cmn.IsEventStart( "win_barstand" ) ) then

    private.win_barstand_state = ng_global.progress[ "std" ][ "win_barstand" ].state;   
 
    for i = 1, private.win_barstand_state do

      local basreliefpart_coord_y = { -37, -12, -81, 36 };
      ObjSet( "spr_barstand_basreliefpart_"..i, 
        { 
          input = false, 
          pos_y = basreliefpart_coord_y[ i ] + 4 
        } );
      ObjSet( "spr_barstand_basreliefpart_"..i.."_shadow", { alp = 1 } );

    end;

  end;

end;
--*********************************************************************************************************************
function private.Init_Subroom ()

  --*********************************************************************************************************************
  -- function zz_barstand () end;
  --*********************************************************************************************************************

    subroom.Define( "zz_barstand" );
    
    function zz_barstand.PreOpen ()

    end;
    -------------------------------------------------
    function zz_barstand.Open ()

      if ( cmn.IsEventStart( "win_barstand" ) and not cmn.IsEventDone( "win_barstand" ) ) then

        cmn.MiniGameShow( "barstand" );
        common_impl.PassingMgStart( "barstand" );

      end;

    end;
    -------------------------------------------------
    function zz_barstand.PreClose ()

      if ( cmn.IsEventStart( "win_barstand" ) and not cmn.IsEventDone( "win_barstand" ) ) then

        cmn.MiniGameHide( "barstand" );
        common_impl.PassingMgStop( "barstand" );

      end;

    end;
    -------------------------------------------------
    function zz_barstand.Close ()

    end;
    -------------------------------------------------
    function zz_barstand.Reset ()

      local basreliefpart_coord_y = { -37, -12, -81, 36 };

      cmn.Lock( true );
      for i = 1, 4 do

        ObjAnimate( "spr_barstand_basreliefpart_"..i, "pos_y", 0, 0, "",
          { 
            0.0, 0, ObjGet( "spr_barstand_basreliefpart_"..i ).pos_y, 
            0.3, 0, basreliefpart_coord_y[ i ]
          } );
        ObjAnimate( "spr_barstand_basreliefpart_"..i.."_shadow", "alp", 0, 0, "",
          { 
            0.0, 0, ObjGet( "spr_barstand_basreliefpart_"..i.."_shadow" ).alp, 
            0.3, 0, 0
          } );

      end;

      local func_end = function ()

        cmn.Lock( false );
        private.win_barstand_state = 0;
        ng_global.progress[ "std" ][ "win_barstand" ].state = private.win_barstand_state;   
  
        for i = 1, 4 do

          ObjSet( "spr_barstand_basreliefpart_"..i, { input = true } );

        end;   

      end;

      ObjAnimate( "obj_barstand_mmg", "pos_y", 0, 0, func_end,
        { 
          0.0, 0, ObjGet(  "obj_barstand_mmg" ).pos_y, 
          0.3, 0, ObjGet(  "obj_barstand_mmg" ).pos_y
        } );

    end;
    -------------------------------------------------
    function zz_barstand.Skip ()

      cmn.Lock( true );
      for i = 1, 4 do

        ObjAnimate( "spr_barstand_basreliefpart_"..i, "pos_y", 0, 0, "",
        { 
          0.0, 0, ObjGet( "spr_barstand_basreliefpart_"..i ).pos_y, 
          0.3, 0, ObjGet( "spr_barstand_basreliefpart_"..i ).pos_y + 4
        } );
        ObjAnimate( "spr_barstand_basreliefpart_"..i.."_shadow", "alp", 0, 0, "",
        { 
          0.0, 0, ObjGet( "spr_barstand_basreliefpart_"..i.."_shadow" ).alp, 
          0.3, 0, 1
        } );

      end;

      local func_end = function ()

        private.WinAnimBarstand();

      end;

      ObjAnimate( "obj_barstand_mmg", "pos_y", 0, 0, func_end,
      { 
        0.0, 0, ObjGet(  "obj_barstand_mmg" ).pos_y, 
        0.3, 0, ObjGet(  "obj_barstand_mmg" ).pos_y
      } );

    end;

  --*********************************************************************************************************************
  -- function zz_stashwall () end;
  --*********************************************************************************************************************

    subroom.Define( "zz_stashwall" );
    
    function zz_stashwall.PreOpen ()

    end;
    -------------------------------------------------
    function zz_stashwall.Open ()

    end;
    -------------------------------------------------
    function zz_stashwall.PreClose ()

    end;
    -------------------------------------------------
    function zz_stashwall.Close ()

      if cmn.IsEventDone( "clk_stashwall_button" ) then

        cmn.Lock( true );

        AnimPlay( "anm_bar_secret_door", "DoAnim", function() cmn.Lock( false ) end );

      end;

    end;

end;
--*********************************************************************************************************************

function public.Open ()

  private.opn_bar();

  if not ( cmn.IsEventDone( "see_turn_on_light" ) ) then

    if ( cmn.IsEventDone( "win_panel" ) ) then

      private.TurnOnLight();      
      
    end;

  end;

  if not ( cmn.IsEventDone( "see_bar_scare_1" ) ) then

    if ( cmn.IsEventDone( "get_triangle1" ) ) then

      private.BarScare_1();      
      
    end;

  end;

  if not ( cmn.IsEventDone( "see_masked_man_4" ) ) then

    if ( cmn.IsEventDone( "get_triangle3" ) ) then

      private.MaskedMan_4();      
      
    end;

  end;

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.CollectItemMorphing();
  common_impl.MorphItemMorphing();

  if  not cmn.IsEventDone("win_barstand") then

    common_impl.EnvPlay( { "level1/env/aud_rm_bar1_env" }, "", 0.5 );
    --cmn.PlayMusEnv();

  else

    common_impl.EnvPlay( { "level1/env/aud_rm_courtyard_env" }, "", 0.5 );
    --cmn.PlayMusEnv();

  end;
  

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_glasspiece ()

  local item = "inv_glasspiece";

  if ( cmn.ApplyObj( item, "gzz_bar_stashwall" ) and cmn.IsEventDone( "see_turn_on_light" ) and cmn.IsEventDone( "clk_stashwall_web" ) ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stashwall", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stashwall_use_glasspiece" ) and cmn.IsEventDone( "see_turn_on_light" ) and cmn.IsEventDone( "clk_stashwall_web" ) ) then

    cmn.CallEventHandler( "use_glasspiece_inv" );
    cmn.CallEventHandler( "use_glasspiece_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_glasspiece" );
      cmn.CallEventHandler( "use_glasspiece_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_splinter", 0, "", 0 );

    AnimPlay( "anm_stashwall_glass", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_triangle ()

  local item = "inv_triangle";

  if ( cmn.ApplyObj( item, "gzz_bar_stashwall" ) and cmn.IsEventDone( "see_turn_on_light" ) and cmn.IsEventDone( "clk_stashwall_door" ) and
       cmn.IsEventDone( "get_triangle1" ) and cmn.IsEventDone( "get_triangle2" ) and cmn.IsEventDone( "get_triangle3" ) ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stashwall", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stashwall_use_triangle" ) and cmn.IsEventDone( "see_turn_on_light" ) and cmn.IsEventDone( "clk_stashwall_door" ) and
           cmn.IsEventDone( "get_triangle1" ) and cmn.IsEventDone( "get_triangle2" ) and cmn.IsEventDone( "get_triangle3" ) ) then

    cmn.CallEventHandler( "use_triangle_inv" );
    cmn.CallEventHandler( "use_triangle_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_triangle" );
      cmn.CallEventHandler( "use_triangle_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

    cmn.ItemFly( "spr_stashwall_triangle_1", func_end, 3.93 );
    cmn.ItemFly( "spr_stashwall_triangle_2", nil, 0 );
    cmn.ItemFly( "spr_stashwall_triangle_3", nil, 2.35 );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_clippers_2 ()

  local item = "inv_clippers";

  if ( cmn.ApplyObj( item, "gzz_bar_panel" ) and cmn.IsEventDone( "see_turn_off_light" ) ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_panel", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_panel_use_clippers_2" ) and cmn.IsEventDone( "see_turn_off_light" ) ) then

    cmn.CallEventHandler( "use_clippers_2_inv" );
    cmn.CallEventHandler( "use_clippers_2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_clippers_2" );
      cmn.CallEventHandler( "use_clippers_2_end" );

      common.CloseSubRoom();
      cmn.GotoRoom( "mg_panel" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_boltcutter1", 0, "", 0 );
    
    ObjSet( "anm_panel_nippers", { alp = 1 } );
    AnimPlay( "anm_panel_nippers", "DoAnim", func_end );
    
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_basreliefpart ()

  local item = "inv_basreliefpart";

  if ( cmn.ApplyObj( item, "gzz_bar_barstand" ) and cmn.IsEventDone( "see_turn_on_light" ) ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_barstand", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_barstand_use_basreliefpart" ) and cmn.IsEventDone( "see_turn_on_light" ) ) then

    cmn.CallEventHandler( "use_basreliefpart_inv" );
    cmn.CallEventHandler( "use_basreliefpart_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_basreliefpart" );
      cmn.CallEventHandler( "use_basreliefpart_end" );

      private.InitBarstandStart();

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );

    ObjAnimate( "spr_barstand_basreliefpart_4", "alp", 0, 0, func_end,
      { 
        0.0, 0, ObjGet( "spr_barstand_basreliefpart_4" ).alp, 
        0.3, 0, 1.0
      } );
    ObjAnimate( "spr_barstand_cover", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_barstand_cover" ).alp, 
        0.3, 0, 0
      } );
    
    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_bottle ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_bottle" );
  cmn.CallEventHandler( "get_bottle" );

end;
--------------------------------------------------------------------------------------------
function private.get_rope ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_rope" );
  cmn.CallEventHandler( "get_rope" );

end;
--------------------------------------------------------------------------------------------
function private.get_triangle2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_triangle2" );
  cmn.CallEventHandler( "get_triangle2" );

  if ( cmn.IsEventDone( "get_register" ) and cmn.IsGetCollect2( "get_collect2_item_1_2" ) ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_register ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_register" );
  cmn.CallEventHandler( "get_register" );

  if ( cmn.IsEventDone( "get_triangle2" ) and cmn.IsGetCollect2( "get_collect2_item_1_2" ) ) then

    common.CloseSubRoom();

  end;
  
  if port.isPortable()==1 then
      iOS_RateMe();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_1_2 ()

  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_1_2" ); 

    if ( cmn.IsEventDone( "get_register" ) and  
        cmn.IsEventDone( "get_triangle2" ) ) then

      common.CloseSubRoom();

    end;

  end;

  common_impl.PlayEffectHO( "spr_collect2_item_1_2", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_1_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_cookies ()

  local func_end = function () 

    ObjDelete( "spr_barstand_cookies" );
    cmn.CheckGiveCustomAchiev( "cake" );

  end;

  common_impl.PlayEffectHO( "spr_barstand_cookies", func_end );

end;

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_triangle2 ()

  cmn.CallEventHandler( "clk_triangle2_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_triangle2" );
    cmn.CallEventHandler( "clk_triangle2_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_bar_clk_glass", 0, "", 0 );
  ObjAnimate( "spr_barstand_wineglass", "pos_xy", 0, 0, func_end,
    { 
      0.0, 3, ObjGet( "spr_barstand_wineglass" ).pos_x, ObjGet( "spr_barstand_wineglass" ).pos_y,
      0.3, 3, 107, -143 
    } );

end;
--------------------------------------------------------------------------------------------
function private.clk_stashwall_web ()

  cmn.CallEventHandler( "clk_stashwall_web_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_stashwall_web" );
    cmn.CallEventHandler( "clk_stashwall_web_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_net", 0, "", 0 );

  ObjAnimate( "spr_stashwall_web_1", "alp", 0, 0, "",
    { 
      0.0, 0, 1,
      0.3, 0, 0 
    } );

  ObjAnimate( "spr_stashwall_web_2", "alp", 0, 0, func_end,
    { 
      0.0, 0, 1,
      0.3, 0, 1,
      0.6, 0, 0,
    } );

end;
--------------------------------------------------------------------------------------------
function private.clk_stashwall_door ()

  cmn.CallEventHandler( "clk_stashwall_door_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_stashwall_door" );
    cmn.CallEventHandler( "clk_stashwall_door_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_open_stash_bar", 0, "", 0 );

  ObjAnimate( "spr_stashwall_door_1", "pos_xy", 0, 0, func_end,
    { 
      0.0, 0, -68, -67,
      0.8, 3, -230, -75,
    } );
  ObjAnimate( "spr_stashwall_door_1", "scale_xy", 0, 0, "",
    { 
      0.0, 0, 1, 1,
      0.8, 3, 0.97, 0.97,
    } );

  ObjAnimate( "spr_stashwall_door_2", "pos_xy", 0, 0, "",
    { 
      0.0, 0, 157, -53,
      0.8, 3, 356, -50,
    } );
  ObjAnimate( "spr_stashwall_door_2", "scale_xy", 0, 0, "",
    { 
      0.0, 0, 1, 1,
      0.8, 3, 1.04, 1.04,
    } );

end;
--------------------------------------------------------------------------------------------
function private.clk_stashwall_button ()

  cmn.CallEventHandler( "clk_stashwall_button_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_stashwall_button" );
    cmn.CallEventHandler( "clk_stashwall_button_end" );

    common.CloseSubRoom();

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_open_stonedoor", 0, "", 0 );

  AnimPlay( "anm_stashwall_button", "DoAnim", func_end );

end;
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG BARSTAND *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.InitBarstandStart ()

    ng_global.progress[ "std" ][ "win_barstand" ].state = 0;

    cmn.MiniGameShow( "barstand" );
    common_impl.PassingMgStart( "barstand" );

  end;
  --*******************************************************************************************************************
  function private.InitBarstand ()

    private.win_barstand_state = 0;    
    --ObjMultiSet( {  
    --  { "obj", { event_mdown  = function () end,
    --             event_menter = function () SetCursor( CURSOR_HAND );  end,
    --             event_mleave = function () SetCursor( CURSOR_DEFAULT ); end
    --           } };
    --} ); 

    for i = 1, 4 do

      ObjSet( "spr_barstand_basreliefpart_"..i, 
        {      
          event_mdown  = function () private.ClkBasreliefpart( i ) end,
          event_menter = function () common_impl.SetCursor( CURSOR_HAND );  end,
          event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end
        } );

    end;

  end;
  --*******************************************************************************************************************
  function private.ClkBasreliefpart ( id )

    local func_end = function ()

      if ( ( private.win_barstand_state + 1 ) == id ) then
        
        if ( ( private.win_barstand_state + 1 ) == 4 ) then

          private.WinAnimBarstand();  

        else   

          cmn.Lock( false );

          private.win_barstand_state = private.win_barstand_state + 1;
          ng_global.progress[ "std" ][ "win_barstand" ].state = private.win_barstand_state;
          ObjSet( "spr_barstand_basreliefpart_"..id, { input = false } );

        end;

      else

        common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

        zz_barstand.Reset();

      end;
      

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "aud_get_inv_in_hand_sfx", 0, "", 0 );

    ObjAnimate( "spr_barstand_basreliefpart_"..id, "pos_y", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_barstand_basreliefpart_"..id ).pos_y, 
        0.3, 0, ObjGet( "spr_barstand_basreliefpart_"..id ).pos_y + 4,
      } );
    ObjAnimate( "spr_barstand_basreliefpart_"..id.."_shadow", "alp", 0, 0, func_end,
      { 
        0.0, 0, ObjGet( "spr_barstand_basreliefpart_"..id.."_shadow" ).alp, 
        0.3, 0, 1
      } );

  end;

  --*******************************************************************************************************************
  function private.WinAnimBarstand ()

    local func_end = function ()

      private.WinBarstand();

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_open_bar_stage", 0, "", 0 );

    ObjSet( "spr_barstand_patch_2", { pos_z = 3 } );
    ObjAnimate( "obj_barstand_mmg_right", "pos_xy", 0, 0, "",
      { 
        0.0, 1, ObjGet( "obj_barstand_mmg_right" ).pos_x, ObjGet( "obj_barstand_mmg_right" ).pos_y,
        0.5, 1, 149, -70
      } );
    ObjAnimate( "obj_barstand_mmg_left", "pos_xy", 0, 0, func_end,
      { 
        0.0, 1, ObjGet( "obj_barstand_mmg_left" ).pos_x, ObjGet( "obj_barstand_mmg_left" ).pos_y,
        0.5, 1, -143, 53
      } );

  end;
  --*******************************************************************************************************************
  function private.WinBarstand ()

    cmn.Lock( false );
    ng_global.progress[ "std" ][ "win_barstand" ].state = 4;

    cmn.MiniGameHide( "barstand" );
    common_impl.PassingMgWin( "barstand"); 

    cmn.SetEventDone( "win_barstand" );
    cmn.CallEventHandler( "win_barstand" );

  end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_bar ()

  if not ( cmn.IsEventDone( "opn_bar" ) ) then

    cmn.SetEventDone( "opn_bar" );
    cmn.CallEventHandler( "opn_bar" ); 

    common_impl.ShowBbt( "bbt_bar_opn_bar" );

    interface.KeyTaskDone( true );

    ObjSet( "tmr_bar_close_door", { playing = true, time = 3, endtrig = private.TurnOffLight } );

  end;

end;
--*********************************************************************************************************************
function private.ClkLock ()

  common_impl.ShowBbt( 'bbt_panel_use_clippers_2' );

  cmn.Lock( true )

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

  ObjAnimate( "spr_panel_lock", "ang", 0, 0, function() cmn.Lock( false ) end, { 0, 0, 0,   0.2, 3, 0.03,   0.4, 3, 0 } );

end;
--*********************************************************************************************************************
function private.ClkUseGlasspiece ()

  common_impl.ShowBbt( 'bbt_stashwall_use_glasspiece' );

  cmn.Lock( true )

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk8", 0, "", 0 );

  ObjAnimate( "anm_stashwall_glass", "pos_y", 0, 0, function() cmn.Lock( false ) end, { 0, 0, -275,   0.2, 3, -274,   0.4, 3, -275 } );

end;
--*********************************************************************************************************************
function private.TurnOffLight ()

  local func_end = function ()

    cmn.SetEventDone( "see_turn_off_light" );
    cmn.CallEventHandler( "see_turn_off_light" );

    common_impl.ShowBbt( "bbt_bar_see_turn_off_light" );

    common_impl.StopAudio( "sfx", "level1/sfx/aud_close_door", 0.2 );

  end;

  ObjSet( "tmr_bar_close_door", { playing = false } );
  interface.DialogTaskHide();
  int_blackbartext.Hide();

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_close_door", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_bar_close_door", func_end );

end;
--*********************************************************************************************************************
function private.TurnOnLight ()

  local func_end = function ()

    cmn.Lock( false );
    private.TurnOnLightEnd();    

  end;

  cmn.Lock( true );
  ObjAnimate( "spr_bar_back_dark", "alp", 0, 0, func_end, 
  { 
    0.0, 0, 1.0,   
    0.3, 0, 0.0
  } );
  
end;
--*********************************************************************************************************************
function private.TurnOnLightEnd ()

  local func_end = function ()

    cmn.SetEventDone( "see_turn_on_light" );
    cmn.CallEventHandler( "see_turn_on_light" );

    common_impl.ShowBbt( "bbt_bar_see_turn_on_light" );
    interface.KeyTaskAdd( "find_professor" );

    common_impl.StopAudio( "sfx", "level1/sfx/aud_terenc", 0.2 );

    cmn.PlayMusDanger();

  end;  

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_terence", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_bar_terence", func_end );

end;
--*********************************************************************************************************************
function private.BarScare_1 ()

  local func_end = function ()

    cmn.SetEventDone( "see_bar_scare_1" );
    cmn.CallEventHandler( "see_bar_scare_1" );

    --common_impl.ShowBbt( "bbt_bar_see_bar_scare_1" );

    --cmn.PlayMusDanger();

  end;

  func_end();

  --тут анимация пуглаки


--  common_impl.PlayAudio( "sfx", "level1/sfx/aud_hall_disappearance_professor", 0, "", 0 );
--  cmn.PlayDialogVideo( "vid_hall_disappearance_professor", func_end );

end;
--*********************************************************************************************************************
function private.MaskedMan_4 ()

  local func_end = function ()

    cmn.SetEventDone( "see_masked_man_4" );
    cmn.CallEventHandler( "see_masked_man_4" );

    --common_impl.ShowBbt( "bbt_bar_see_masked_man_4" );

  end;

  func_end();

  --тут анимация пуглаки


--  common_impl.PlayAudio( "sfx", "level1/sfx/aud_hall_disappearance_professor", 0, "", 0 );

--  cmn.PlayDialogVideo( "vid_hall_disappearance_professor", func_end );

end;

--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** ANIMATIONS *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_bar_light_2", "alp", 1, 0, "",
    { 
      0.0, 0, 1.0, 
      2.0, 0, 1.0,
      2.1, 0, 0.0,
      2.2, 0, 1.0, 
      2.3, 0, 0.0,
      4.9, 0, 0.0,
      5.0, 0, 1.0
    } );     
  ObjAnimate( "spr_bar_light_1", "alp", 1, 0, "",
    { 
      0.0, 0, 1.0, 
      4.5, 0, 0.0,
      9.0, 0, 1.0
    } );    
  ObjAnimate( "spr_bar_light_5", "alp", 1, 0, "",
    { 
      0.0, 0, 1.0, 
      0.1, 0, 0.0,
      3.0, 0, 0.0,
      3.1, 0, 1.0,
      3.2, 0, 0.0,
      3.5, 0, 0.5,
      3.6, 0, 1.0,
      6.0, 0, 1.0,
    } );  
  ObjAnimate( "spr_bar_light_6", "alp", 1, 0, "",
    { 
      0.0, 0, 1.0, 
      0.1, 0, 0.0,
      0.2, 0, 1.0,
      0.3, 0, 0.0,
      0.4, 0, 1.0,
      6.0, 0, 1.0,
    } );
  ObjAnimate( "spr_stashwall_light", "alp", 1, 0, "",
    { 
      0.0, 0, 1.0, 
      2.0, 0, 0.5,
      4.0, 0, 1.0
    } );   

end;
--*********************************************************************************************************************



