-- name=rm_car
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_car";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();

  local tb = {}
  table.insert( tb, { "obj_car_see_bodyguard",              { event_mdown = private.Bodyguard } } );
  table.insert( tb, { "obj_car_dlg_in_the_car",             { event_mdown = private.dlg_in_the_car_click } } );
  table.insert( tb, { "obj_car_dlg_in_the_car_focus",       { event_mdown = private.dlg_in_the_car_click } } );
  table.insert( tb, { "obj_car_dlg_driver",                 { event_mdown = private.dlg_driver_click } } );
  table.insert( tb, { "obj_car_dlg_driver_focus",           { event_mdown = private.dlg_driver_click } } );
  table.insert( tb, { "obj_car_see_trip",                   { event_mdown = private.Trip } } );
  table.insert( tb, { "obj_car_handle",                     { event_mdown = private.HandleClk } } );

  table.insert( tb, { "obj_car_driver_driver",              { event_mdown = function() private.ClkDlgCode( "start" ); end } } );
  table.insert( tb, { "obj_car_driver_driver_focus",        { event_mdown = function() private.ClkDlgCode( "start" ); end } } );

  for i = 1, 7 do

    table.insert( tb, { "spr_car_driver_professor_trunk_code_"..i,
    {

      event_mdown = function() private.CodeClk( i ) end,
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ); end,
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ); end

    } } );

  end;

  table.insert( tb, { "obj_car_in_the_car_professor",       { event_mdown = function() private.ClkDlgFolder( "start" ); end } } );
  table.insert( tb, { "obj_car_in_the_car_professor_focus", { event_mdown = function() private.ClkDlgFolder( "start" ); end } } );
  table.insert( tb, { "obj_car_in_the_car_open_project",    { event_mdown = private.FolderOpenProject } } );
  table.insert( tb, { "obj_car_in_the_car_open_project_focus", 
  {
    event_mdown = private.FolderOpenProject,
    event_menter = private.FolderEnterList,
    event_mleave = private.FolderLeaveList
  } } );
  for i = 1, 3 do

    for j = 1, ( ( i - 1 ) * 2 ) + 6 do

      table.insert( tb, { "spr_car_in_the_car_folder_project_"..i.."_"..j,
      {

        drag = true;
        event_startdrag = function() private.DragFolderPart( j ); end,
        event_dragdrop = function() private.DropFolderPart( j ); end,
        event_menter = function() common_impl.SetCursor( CURSOR_HAND ); end,
        event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ); end

      } } );

    end;

  end;

  ObjMultiSet( tb );

  private.InitAnimations();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_car = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then  
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then   
      visible_sparkle_ho = false;
    end;
    local gates = 
    {

    }
    for i = 1, #gates do
      local name = gates[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then  
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then   
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {

    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_car", update_game_mode_car, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_car = function ()
    
    local effects_table = 
    {
      "anm_car_light",
      "anm_car_professor",
      "anm_car_duglas_will",
      "anm_car_driver_driver",
    }

    local active = true;

    if ( GetPerformanceMode() == 1 ) then

      active = false;

    end;

    for i = 1, #effects_table do

      ObjSet( effects_table[ i ], { active = active } );

    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_car", update_performance_mode_car, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_car () end;
  --------------------------------------------------------------------------------------------
  local opn_car = function ()

    

  end;

  local opn_car_map = function ()

    common_impl.VisitMapRoom( "car" );

  end;

  cmn.AddSubscriber( "opn_car", opn_car_map );
  cmn.AddSubscriber( "opn_car", opn_car, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_trunk_code () end;
  --------------------------------------------------------------------------------------------
  local get_trunk_code_inv = function ()

    interface.InventoryItemAdd( "inv_trunk_code", "spr_car_driver_professor_trunk_code_1" );

  end;

  cmn.AddSubscriber( "get_trunk_code", get_trunk_code_inv );
  --------------------------------------------------------------------------------------------
  -- function dlg_car_in_the_car () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_car_in_the_car" ] = {
    type = "click",
    use_place = "obj_car_dlg_in_the_car_focus",
    room = private.room_objname
  };

  local dlg_car_in_the_car = function ()

  end;

  cmn.AddSubscriber( "dlg_car_in_the_car", dlg_car_in_the_car, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_car_driver () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_car_driver" ] = {
    type = "click",
    use_place = "obj_car_dlg_driver",
    room = private.room_objname
  };

  local dlg_car_driver = function ()

    ObjDelete( "obj_car_dlg_driver" );

  end;

  cmn.AddSubscriber( "dlg_car_driver", dlg_car_driver, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_bodyguard () end;
  --------------------------------------------------------------------------------------------
  local see_bodyguard = function ()

    ObjDelete( "obj_car_see_bodyguard" );
    ObjSet( "vid_car_tobias_idle", { alp = 1 } );
    ObjSet( "spr_car_bodyguard", { alp = 1 } );
    ObjSet( "obj_car_see_trip", { input = true } );

  end;

  cmn.AddSubscriber( "see_bodyguard", see_bodyguard, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_trip () end;
  --------------------------------------------------------------------------------------------
  local see_trip = function ()

    ObjDelete( "obj_car_see_trip" );
    ObjSet( "obj_car_dlg_in_the_car", { input = true } );

  end;

  cmn.AddSubscriber( "see_trip", see_trip, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_exit_car () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_exit_car" ] = {
    type = "click",
    use_place = "obj_car_dlg_in_the_car",
    room = private.room_objname
  };

  local see_exit_car = function ()

    ObjDelete( "obj_car_dlg_in_the_car" );
    ObjDelete( "spr_car_bodyguard" );
    ObjDelete( "vid_car_tobias_idle" );
    ObjDelete( "anm_car_professor" );
    ObjDelete( "vid_car_professor_idle" );
    ObjDelete( "obj_car_in_the_car_characters_all" );
    ObjSet( "grm_car_porch", { active = true, input = true, active = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_car_porch_focus");
    end;
  end;

  cmn.AddSubscriber( "see_exit_car", see_exit_car, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load()

end;
--********************************************************************************************************************
function private.Init_Subroom()


end;
--*********************************************************************************************************************
function public.Open()

  if not ( cmn.IsEventDone( "opn_car" ) ) then

    cmn.SetEventDone( "opn_car" );
    common_impl.ShowBbt( "bbt_car_opn_car" );
    interface.KeyTaskDone( true );

    cmn.CheckGiveCustomAchiev( "save_professor" );

    ObjSet( "tmr_car_bodyguard", { playing = true, time = 3, endtrig = private.Bodyguard } );
    
  end;

  if ( cmn.IsEventDone( "see_bodyguard" ) and not cmn.IsEventDone( "see_trip" ) ) then

    ObjSet( "tmr_car_trip", { playing = true, time = 3, endtrig = private.Trip } );

  end;

  cmn.CallEventHandler( "opn_car" );

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen()

  ObjStopAnimate( "rm_car", "scale_xy" );
  ObjStopAnimate( "rm_car", "pos_xy" );

  ObjSet( private.room_objname, {
    color_r = 1,
    color_g = 1,
    color_b = 1,
    scale_x = 1,
    scale_y = 1,
    pos_x = 0,
    pos_y = 0
  } );
  --common_impl.EnvPlay( { "level1/env/aud_car_env" }, "", 0.5 );

  common_impl.EnvPlay( { "level1/env/aud_car_env" }, "", 0.5 );

  common_impl.MorphItemMorphing();

end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************

--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
function private.get_trunk_code ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_trunk_code" );
  cmn.CallEventHandler( "get_trunk_code" );

end;
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************

--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.Bodyguard ()

  local func_end = function ()

    cmn.SetEventDone( "see_bodyguard" );
    cmn.CallEventHandler( "see_bodyguard" );

    common_impl.StopAudio( "sfx", "level1/sfx/aud_car_bodyguard", 0.2 )

    common_impl.ShowBbt( "bbt_car_see_bodyguard" );

    ObjSet( "tmr_car_trip", { playing = true, time = 3, endtrig = private.Trip } );

  end;

  ObjSet( "tmr_car_bodyguard", { playing = false } );
  interface.DialogTaskHide();
  int_blackbartext.Hide();

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_car_bodyguard", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_car_bodyguard", func_end );

end;
--------------------------------------------------------------------------------------------
function public.SwitchFrase ( dlg_name, count_txt )

  if dlg_name == "in_the_car" then

    if ( count_txt == 1 ) then

      ObjSet( "spr_int_dialog_character_icon", { res = "assets/interface/resources/dialog_character/btm_3" } );

      ObjAnimate( "rm_car", "scale_xy", 0, 0, "", { 0, 0, 1, 1,   0.3, 3, 1.2, 1.2 } );

    elseif ( count_txt == 2 ) then

      ObjSet( "vid_car_professor_idle", { alp = 0 } );
      ObjSet( "vid_car_in_the_car_answer_1", { alp = 0, playing = false } );
      ObjSet( "spr_int_dialog_character_icon", { res = "assets/interface/resources/dialog_character/btm_1" } );

      private.DlgFolder = ObjGet( "obj_int_dialog_character_input" ).event_mdown;
      ObjSet( "obj_int_dialog_character_input", { input = false } );

      ObjSet( "spr_car_professor_hand", { alp = 1 } );
      ObjSet( "obj_car_in_the_car_professor", { input = true } );

      ObjAnimate( "rm_car", "pos_xy", 0, 0, "", { 0, 0, 0, 0,  0.3, 3, -234, 16 } );

    elseif ( count_txt == 6 ) then

      ObjSet( "spr_int_dialog_character_icon", { res = "assets/interface/resources/dialog_character/btm_2" } );
      ObjSet( "anm_car_duglas_will", { alp = 0, active = false, visible = false } );
      ObjSet( "anm_car_driver_driver", { alp = 1, active = true, visible = true } );
      ObjSet( "spr_car_mirror_1", { alp = 0 } );
      ObjSet( "spr_car_mirror_2", { alp = 1 } );

      ObjAnimate( "rm_car", "pos_xy", 0, 0, "", { 0, 0, -234, 16,   0.3, 3, -32, 1 } );

    elseif ( count_txt == 7 ) then

      ObjSet( "spr_int_dialog_character_icon", { res = "assets/interface/resources/dialog_character/btm_3" } );

      ObjSet( "anm_car_duglas_will", { alp = 1, active = true, visible = true } );
      ObjSet( "anm_car_driver_driver", { alp = 0, active = false, visible = false } );
      ObjSet( "spr_car_mirror_1", { alp = 1 } );
      ObjSet( "spr_car_mirror_2", { alp = 0 } );

    end;

  elseif dlg_name == "driver" then

    if count_txt == 1 then

      common_impl.continue_visible = false; 
      common_impl.frases = { 2 };
      common_impl.icons = { "trunk" };
      common_impl.DialogCharacterShowDialogQuestions( 1 );

    elseif count_txt == 2 then

      private.DlgCode = ObjGet( "obj_int_dialog_character_input" ).event_mdown;
      ObjSet( "obj_int_dialog_character_input", { input = false } );

      ObjSet( "spr_car_driver_hand", { alp = 1 } );
      ObjSet( "obj_car_driver_driver", { input = true } );

    end;

  end;

end;
--------------------------------------------------------------------------------------------
function private.dlg_in_the_car_click ()

  common_impl.continue_visible = true;
  ObjSet( "obj_car_in_the_car_characters_all", { alp = 1 } );

  common_impl.DialogCharacterStart( "in_the_car", 8, nil, nil, true, private.dlg_in_the_car_end );

  ObjSet( "spr_car_mirror", { alp = 0 } );
  ObjSet( "spr_car_mirror_1", { alp = 1 } );

end;
--------------------------------------------------------------------------------------------
function private.dlg_in_the_car_end ()

  int_button_info.Hide();

  ObjSet( "vid_car_professor_idle", { alp = 1 } );
  ObjSet( "obj_car_lip_professor", { alp = 0 } );

  cmn.CallEventHandler( "dlg_car_in_the_car" ); 

  ObjSet( "spr_car_mirror", { alp = 1 } );
  ObjSet( "spr_car_mirror_1", { alp = 0 } );
  ObjSet( "spr_car_mirror_2", { alp = 0 } );
  ObjSet( "spr_car_professor_hand", { alp = 0 } );
  ObjSet( "anm_car_duglas_will", { alp = 1, active = true, visible = true } );
  ObjSet( "anm_car_driver_driver", { alp = 0, active = false, visible = false } );

  ObjAnimate( "rm_car", "scale_xy", 0, 0, "", { 0, 0, ObjGet( "rm_car" ).scale_x, ObjGet( "rm_car" ).scale_y,   0.3, 3, 1, 1 } );
  ObjAnimate( "rm_car", "pos_xy", 0, 0, "", { 0, 0, ObjGet( "rm_car" ).pos_x, ObjGet( "rm_car" ).pos_y,   0.3, 3, 0, 0 } );
  ObjSet( "spr_int_dialog_character_icon", { res = "" } );
  private.ExitCar()

end;
--------------------------------------------------------------------------------------------
function private.Trip ()

  local func_end = function ()

    cmn.SetEventDone( "see_trip" );
    cmn.CallEventHandler( "see_trip" );

    common_impl.StopAudio( "voc", "level1/voc/aud_car_trip_voc", 0.2 );
    common_impl.StopAudio( "sfx", "level1/sfx/aud_car_trip", 0.2 );

    common_impl.ShowBbt( "bbt_car_see_trip" );

  end;

  ObjSet( "tmr_car_trip", { playing = false } );

  int_blackbartext.Hide();

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_car_trip", 0, "", 0 );
  common_impl.PlayAudio( "voc", "level1/voc/aud_car_trip_voc", 0, "", 0 );

  --cmn.PlayMusEnv( "mus_env/aud_track3_mus_env" );

  cmn.PlayDialogVideo( "vid_car_trip", func_end );

end;
--------------------------------------------------------------------------------------------
function private.ExitCar ()

  local func_end = function ()

    cmn.SetEventDone( "see_exit_car" );
    cmn.CallEventHandler( "see_exit_car" );

    --ObjSet( private.room_objname, { color_r = 0, color_g = 0, color_b = 0 } );

    cmn.GotoRoom( "rm_porch" );
    --common_impl.StopAudio( "sfx", "level1/sfx/aud_out_from_car", 0.2 );

  end;

  func_end();

  --common_impl.PlayAudio( "sfx", "level1/sfx/aud_out_from_car", 0, "", 0 );

  --cmn.PlayDialogVideo( "vid_car_exit_car", func_end );

end;
--------------------------------------------------------------------------------------------
function private.dlg_driver_click ()

  common_impl.continue_visible = false; 
  ObjSet( "spr_car_mirror", { alp = 0 } );
  ObjSet( "spr_car_mirror_2", { alp = 1 } );
  ObjSet( "anm_car_duglas_will", { alp = 0, active = false, visible = false } );
  ObjSet( "anm_car_driver_driver", { alp = 1, active = true, visible = true } );

  common_impl.DialogCharacterStart( "driver", 4, nil, nil, true, private.dlg_driver_click_end );

end;
--------------------------------------------------------------------------------------------
function private.dlg_driver_click_end ()

  cmn.CallEventHandler( "dlg_car_driver" );

  ObjSet( "spr_car_mirror", { alp = 1 } );
  ObjSet( "spr_car_mirror_2", { alp = 0 } );
  ObjSet( "spr_car_driver_hand", { alp = 0 } );

  ObjSet( "anm_car_duglas_will", { alp = 1, active = true, visible = true } );
  ObjSet( "anm_car_driver_driver", { alp = 0, active = false, visible = false } );

  int_button_info.Hide();

  private.get_trunk_code();

end;
--------------------------------------------------------------------------------------------
function private.ClkDlgCode ( state )

  if state == "start" then

    private.DlgCode = ObjGet( "obj_int_dialog_character_input" ).event_mdown;

    ObjSet( "obj_car_driver_professor_trunk_code", { input = true } );

    local func_end = function()

      cmn.Lock( false );

      private.current_code = nil;
      private.code = 0;

      private.DlgCode();
      ObjDelete( "obj_car_driver_driver" );

      int_button_info.Show();

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_book", 0, "", 0 );
    ObjAnimate( "obj_car_driver_professor_trunk_code", "alp", 0, 0, func_end, { 0, 0, 0,   0.3, 0, 1 } );
    ObjAnimate( "spr_car_driver_hand", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 } );
    ObjAnimate( "txt_int_dialog_character_continue", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 } );

  elseif state == "close" then

    local func_end = function()

      cmn.Lock( false );

      private.DlgCode();
      ObjSet( "obj_int_dialog_character_input", { event_mdown = private.DlgCode } );
      ObjSet( "obj_car_driver_professor_trunk_code", { input = false } );

    end;

    cmn.Lock( true );

    ObjAnimate( "obj_car_driver_professor_trunk_code", "alp", 0, 0, func_end, { 0, 0, 1,   0.3, 0, 0 } )
    ObjAnimate( "txt_int_dialog_character_continue", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 } );

  end;

end;
--------------------------------------------------------------------------------------------
function private.CodeClk ( code )

  cmn.Lock( true );

  if not private.current_code then

    common_impl.PlayAudio( "sfx", "aud_paper", 0, "", 0 );
    private.current_code = code;

    ObjAnimate( "spr_car_driver_professor_trunk_code_"..code, "scale_xy", 0, 0, function() cmn.Lock( false ); end, { 0, 0, 1, 1,   0.2, 3, 1.1, 1.1 } );

  elseif private.current_code == code then

    common_impl.PlayAudio( "sfx", "aud_paper", 0, "", 0 );
    private.current_code = nil;

    ObjAnimate( "spr_car_driver_professor_trunk_code_"..code, "scale_xy", 0, 0, function() cmn.Lock( false ); end, { 0, 0, 1.1, 1.1,   0.2, 3, 1, 1 } );

  elseif ( private.current_code + code == 9 ) then

    local func_end = function ()

      cmn.Lock( false );

      if private.code == 3 then

        ObjDelete( "spr_car_driver_hand" );
        private.ClkDlgCode( "close" );

      end;

    end;

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_mmg_code_clk", 0, "", 0 );
    ObjAnimate( "spr_car_driver_professor_trunk_code_"..code, "scale_xy", 0, 0, "", { 0, 0, 1, 1,   0.2, 3, 1.1, 1.1 } );
    ObjAnimate( "spr_car_driver_professor_trunk_code_"..code, "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 1,   0.5, 0, 0 } );
    ObjAnimate( "spr_car_driver_professor_trunk_code_"..private.current_code, "alp", 0, 0, func_end, { 0, 0, 1,   0.2, 0, 1,   0.5, 0, 0 } );

    private.current_code = nil;
    private.code = private.code + 1;

  else

    common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );
    ObjAnimate( "spr_car_driver_professor_trunk_code_"..code, "scale_xy", 0, 0, function() cmn.Lock( false ); end, { 0, 0, 1, 1,   0.2, 3, 1.1, 1.1,   0.3, 3, 1.1, 1.1,   0.5, 3, 1, 1 } );
    ObjAnimate( "spr_car_driver_professor_trunk_code_"..private.current_code, "scale_xy", 0, 0, "", { 0, 0, 1.1, 1.1,   0.3, 3, 1.1, 1.1,   0.5, 3, 1, 1 } );

    private.current_code = nil;

  end;

end;
--------------------------------------------------------------------------------------------
function private.ClkDlgFolder ( state )

  if state == "start" then

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    ObjSet( "obj_car_in_the_car_folder", { input = true } );

    local func_end = function()

      cmn.Lock( false );

      private.project = 1;
      private.project_part = 0;
      private.project_part_ang = nil;
      private.project_part_pos = {
                                    { { 89, -119 }, { 221, -118 }, { 87, 6 },    { 221, 6 },   { 86, 132 },  { 221, 133 } },
                                    { { 88, -81 },  { 96, -83 },   { 221, -86 }, { 223, -80 }, { 223, 106 }, { 222, 109 }, { 89, 103 }, { 85, 99 } },
                                    { { 69, -79 },  { 90, -116 },  { 220, -112 },{ 243, -77 }, { 155, -44 }, { 63, 102 },  { 88, 134 }, { 220, 134 }, { 245, 107 }, { 155, 73 } }
                                 };

      ObjDelete( "obj_car_in_the_car_professor" );

    end;

    cmn.Lock( true );

    ObjAnimate( "obj_car_in_the_car_folder", "alp", 0, 0, func_end, { 0, 0, 0,   0.3, 0, 1 } );
    ObjAnimate( "spr_car_professor_hand", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 } );
    ObjAnimate( "txt_int_dialog_character_continue", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 } );

  elseif state == "close" then

    local func_end = function()

      cmn.Lock( false );

      private.DlgFolder();
      ObjSet( "obj_int_dialog_character_input", { input = true, event_mdown = private.DlgFolder } );
      ObjSet( "obj_car_in_the_car_folder", { input = false } );

    end;

    cmn.Lock( true );

    ObjAnimate( "obj_car_in_the_car_folder", "alp", 0, 0, func_end, { 0, 0, 1,   0.3, 0, 0 } );
    ObjAnimate( "txt_int_dialog_character_continue", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 } );

    int_button_info.Hide();

  end;

end;
--------------------------------------------------------------------------------------------
function private.FolderOpenProject ()

  cmn.Lock( true );

  private.DlgFolder();

  ObjSet( "obj_car_in_the_car_open_project", { input = false } );

  local old_project = "obj_car_in_the_car_folder_project_"..( private.project - 1 );
  local new_project = "obj_car_in_the_car_folder_project_"..private.project;

  if private.project == 1 then

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_book", 0, "", 0 );
    old_project = "spr_car_in_the_car_folder_1";
    new_project = "spr_car_in_the_car_folder_2";

    int_button_info.Show( "in_the_car" );

  end;

  ObjSet( old_project, { input = false } );
  ObjSet( new_project, { input = true } );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_page", 0, "", 0 );
  ObjAnimate( old_project, "alp", 0, 0, "", { 0, 0, 1,   0.2, 0, 0 } );
  ObjAnimate( "spr_car_in_the_car_folder_list_2", "alp", 0, 0, "", { 0, 0, 0,   0.2, 0, 1,   0.3, 0, 1,   0.5, 0, 0 } );
  ObjAnimate( new_project, "alp", 0, 0, function() cmn.Lock( false ); end, { 0, 0, 0,   0.3, 0, 0,   0.5, 0, 1 } );

  if private.project == 2 then

    ObjAnimate( "spr_car_in_the_car_folder_list_3", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 0,   0.5, 0, 1 } );

  end;

end;
--------------------------------------------------------------------------------------------
function private.FolderEnterList ()

  if private.project ~= 1 then

    SetCursor( CURSOR_HAND );

    local obj = "spr_car_in_the_car_folder_list_4";
    local alp = ObjGet( obj ).alp;

    ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( 0.3 * ( 1 - alp ) ), 0, 1 } );

  end;

end;
--------------------------------------------------------------------------------------------
function private.FolderLeaveList ()

  if private.project ~= 1 then

    SetCursor( CURSOR_DEFAULT );

    local obj = "spr_car_in_the_car_folder_list_4";
    local alp = ObjGet( obj ).alp;

    ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( 0.3 * alp ), 0, 0 } );

  end;

end;
--------------------------------------------------------------------------------------------
function private.DragFolderPart ( part )
  
  local obj = "spr_car_in_the_car_folder_project_"..private.project.."_"..part;

  private.project_part_ang = ObjGet( obj ).ang;

  ObjSet( obj, { ang = 0, pos_z = 1 } );

  common_impl.PlayAudio( "sfx", "aud_get_inv_in_hand_sfx", 0, "", 0 );

end;
--------------------------------------------------------------------------------------------
function private.DropFolderPart ( part )

  local obj = "spr_car_in_the_car_folder_project_"..private.project.."_"..part;
  local pos_cur = GetObjPosByObj( obj, "spr_car_in_the_car_folder_2" );
  local pos_delta = 50;

  local tb = {};
  table.insert( tb, { obj, { pos_z = 0 } } );

  if math.abs( pos_cur[ 1 ] - private.project_part_pos[ private.project ][ part ][ 1 ] ) < pos_delta and
     math.abs( pos_cur[ 2 ] - private.project_part_pos[ private.project ][ part ][ 2 ] ) < pos_delta then

    common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );

    table.insert( tb, { obj, { pos_x = private.project_part_pos[ private.project ][ part ][ 1 ], pos_y = private.project_part_pos[ private.project ][ part ][ 2 ], input = false } } );

    private.project_part = private.project_part + 1;

    if private.project_part == #private.project_part_pos[ private.project ] then

      common_impl.PlayAudio( "sfx", "aud_paper", 0, "", 0 );
      private.project_part = 0;
      private.project = private.project + 1;

      ObjSet( "obj_car_in_the_car_open_project", { input = true } );

      if private.project == 4 then

        private.ClkDlgFolder( "close" )

      end;

    end;

  else

    common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

    table.insert( tb, { obj, { ang = private.project_part_ang } } );

  end;

  private.project_part_ang = nil;

  ObjMultiSet( tb );

end;
--------------------------------------------------------------------------------------------
function private.HandleClk ()

  cmn.Lock( true );
  
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_lever_car", 0, "", 0 );
  ObjAnimate( "spr_car_handle", "ang", 0, 0, function() cmn.Lock( false );  end , 
  {
    0.0, 0, 0,
    0.3, 3, 0.05,
    0.6, 3, 0,
  } );

end;
--*********************************************************************************************************************
-- function *** ANIM *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.InitAnimations ()

  ObjAnimate( "spr_car_spruce", "ang", 1, 0, "", { 0, 0, 0,    1, 2, -0.02,   3, 3, 0.02,   4, 1, 0  } );

end;