-- name=rm_corridor
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_corridor";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  
  ObjMultiSet({ 
    { "obj_corridor_outro", { event_mdown = private.Outro }},

  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_corridor = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {

    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 
    {

    };

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_corridor", update_game_mode_corridor, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_corridor = function ()

  local effects_table = 
  {
    "anm_corridor_doors",
    "anm_corridor_light",
    "anm_corridor_cloth",
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_corridor", update_performance_mode_corridor, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_corridor () end;
  --------------------------------------------------------------------------------------------
  local opn_corridor_map = function ()

    common_impl.LockMapRoom( "hall", true );
    common_impl.LockMapRoom( "bar", true );
    common_impl.LockMapRoom( "courtyard", true );
    common_impl.LockMapRoom( "lounge", true );

  end;
  cmn.AddSubscriber( "opn_corridor", opn_corridor_map );
  
  --------------------------------------------------------------------------------------------
  -- function see_outro () end;
  --------------------------------------------------------------------------------------------

  common_impl.hint[ "see_outro" ] =
  {
      type = "click",
      use_place = "obj_corridor_outro",
      room = private.room_objname,
  };


  local see_outro = function ()



  end;
  cmn.AddSubscriber( "see_outro", see_outro, private.room_objname );
 
end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_corridor();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_corridor ()

  if not ( cmn.IsEventDone( "opn_corridor" ) ) then

    cmn.SetEventDone( "opn_corridor" );
    cmn.CallEventHandler( "opn_corridor" ); 

    common_impl.ShowBbt( "bbt_corridor_opn_corridor" );

    ObjSet( "tmr_corridor_outro", { playing = true, time = 3, endtrig = private.Outro } );

  end;

end;
--*********************************************************************************************************************

function private.Outro ()

  local func_end = function ()

    cmn.SetEventDone( "see_outro" );
    cmn.CallEventHandler( "see_outro" );

    --cmn.EnterRmWithoutInterface( "rm_demo" );
    
    common_impl.StopAudio( "sfx", "llevel1/sfx/aud_outro_lvl1", 0.2 );
    common_impl.StopAudio( "voc", "level1/voc/aud_outro_voc", 0.2 );
    
    local prg = ng_global.currentprogress;
    ng_global.progress[ prg ].common.chapter = "level2";
    ng_global.progress[ prg ].common.currentroom = nil;
    local level = ng_global.progress[ prg ].common.chapter;

    common.LevelSwitch( level );

  end;

  ObjSet( "tmr_corridor_outro", { playing = false } );
  int_blackbartext.Hide();

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_outro_lvl1", 0, "", 0 );
  common_impl.PlayAudio( "voc", "level1/voc/aud_outro_voc", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_corridor_outro", func_end );

end;
--*********************************************************************************************************************





