-- name=rm_courtyard
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_courtyard";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_thicket", "room_hub" );
  ObjAttach( "zz_chemicalsshelf", "room_hub" );
  ObjAttach( "zz_floormechanism", "room_hub" );
  ObjAttach( "zz_fountain", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
    { "spr_chemicalsshelf_antirust",              { event_mdown = private.get_antirust } },
    { "spr_floormechanism_loungekey",             { event_mdown = private.get_loungekey } },
    { "spr_floormechanism_button",                { event_mdown = private.get_button } },
    { "spr_floormechanism_crossbow",              { event_mdown = private.get_crossbow } },
    { "spr_fountain_lionpen2",                    { event_mdown = private.get_lionpen2 } },
    { "spr_fountain_codedpaper",                  { event_mdown = private.get_codedpaper } },
    { "spr_fountain_broom",                       { event_mdown = private.get_broom } },
    { "obj_courtyard_clk_bar_door",               { event_mdown = private.clk_bar_door } },
    { "obj_fountain_clk_button",                  { event_mdown = private.clk_button } },
    { "spr_fountain_door_close",                  { event_mdown = private.FountainFeedbackAnim } },
    { "obj_thicket_clk_loungekey_1",              { event_mdown = private.clk_loungekey_1 } },
    { "obj_thicket_clk_loungekey_2",              { event_mdown = private.clk_loungekey_2 } },
    { "obj_floormechanism_clk_antirust_1",        { event_mdown = private.clk_floormechanism_antirust_1 } },
    { "spr_floormechanism_folder_closed",         { event_mdown = private.clk_floormechanism_folder } },
    { "obj_floormechanism_use_antirust_1",        { event_mdown = private.FloormechanismFeedbackAnim } },
    { "obj_courtyard_clk_bar_door_2",             { event_mdown = private.ClkBarDoor_2 } },
    { "obj_courtyard_clk_arrow",                  { event_mdown = private.ClkNeonBar } },

    { "spr_collect2_item_1_1",                    { event_mdown = private.get_collect2_item_1_1 } },

  });

  private.InitAnimations();
  private.InitChemicalsshelf()
  private.FloormechanismInit();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_courtyard = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "gzz_courtyard_thicket",
      "gzz_courtyard_chemicalsshelf",
      "gzz_courtyard_floormechanism",
      "gzz_courtyard_fountain"
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_chemicalsshelf",
      "zz_fountain",
      "zz_thicket",
      "zz_floormechanism"
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_courtyard", update_game_mode_courtyard, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_courtyard = function ()

  local effects_table = 
  {
    "anm_courtyard_sky",
    "anm_courtyard_newspaper",
    "anm_courtyard_white_noise",
    "anm_courtyard_h_light",
    "anm_courtyard_lights_bar_back",
    "anm_courtyard_fog",
    "anm_courtyard_umbrella",
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_courtyard", update_performance_mode_courtyard, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_courtyard () end;
  --------------------------------------------------------------------------------------------
  local opn_courtyard_map = function ()

    common_impl.VisitMapRoom( "courtyard" );

  end;
  cmn.AddSubscriber( "opn_courtyard", opn_courtyard_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_antirust () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_antirust" ] = {
    type = "get",
    get_obj = "spr_chemicalsshelf_antirust",
    room = private.room_objname,
    zz = "zz_chemicalsshelf",
    zz_gate = "gzz_courtyard_chemicalsshelf"
  };
  
  local get_antirust_inv = function ()
  
    interface.InventoryItemAdd( "inv_antirust", "spr_chemicalsshelf_antirust" );

  end;
  
  local get_antirust_closezz = function ()
  
    ObjDelete( "spr_chemicalsshelf_antirustshadow" );
    ObjDelete( "gfx_chemicalsshelf_antirust" );
    ObjDelete( "gzz_courtyard_chemicalsshelf" );
  
  end;
  
  cmn.AddSubscriber( "get_antirust", get_antirust_inv );
  cmn.AddSubscriber( "get_antirust", get_antirust_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_loungekey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_loungekey" ] = {
    type = "get",
    get_obj = "spr_floormechanism_loungekey",
    room = private.room_objname,
    zz = "zz_floormechanism",
    zz_gate = "gzz_courtyard_floormechanism"
  };
  
  local get_loungekey_inv = function ()
  
    interface.InventoryItemAdd( "inv_loungekey", "spr_floormechanism_loungekey" );
  
  end;
  
  local get_loungekey_closezz = function ()
  
    ObjDelete( "gfx_floormechanism_loungekey" );
    ObjDelete( "spr_courtyard_key" );
 
  end;
  
  cmn.AddSubscriber( "get_loungekey", get_loungekey_inv );
  cmn.AddSubscriber( "get_loungekey", get_loungekey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_button () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_button" ] = {
    type = "get",
    get_obj = "spr_floormechanism_button",
    room = private.room_objname,
    zz = "zz_floormechanism",
    zz_gate = "gzz_courtyard_floormechanism"
  };
  
  local get_button_inv = function ()
  
    interface.InventoryItemAdd( "inv_button", "spr_floormechanism_button" );
  
  end;
  
  local get_button_closezz = function ()
  
    ObjDelete( "spr_floormechanism_button_shadow" );
    ObjDelete( "gfx_floormechanism_button" );
    ObjDelete( "spr_courtyard_floormechanism_button" );
  
  end;
  
  cmn.AddSubscriber( "get_button", get_button_inv );
  cmn.AddSubscriber( "get_button", get_button_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crossbow () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_crossbow" ] = {
    type = "get",
    get_obj = "spr_floormechanism_crossbow",
    room = private.room_objname,
    zz = "zz_floormechanism",
    zz_gate = "gzz_courtyard_floormechanism"
  };
  
  local get_crossbow_inv = function ()
  
    interface.InventoryItemAdd( "inv_crossbow", "spr_floormechanism_crossbow" );
    ObjSet( "inv_crossbow", { drag = false } );

    if cmn.IsEventDone( "get_arrow" ) then

      cmn.SetInvPlusRGB( "crossbow", true );

    end;
  
  end;
  
  local get_crossbow_closezz = function ()
  
    ObjDelete( "gfx_floormechanism_crossbow" );
    ObjDelete( "spr_courtyard_crossbow" );
  
  end;
  
  cmn.AddSubscriber( "get_crossbow", get_crossbow_inv );
  cmn.AddSubscriber( "get_crossbow", get_crossbow_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lionpen2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lionpen2" ] = {
    type = "get",
    get_obj = "spr_fountain_lionpen2",
    room = private.room_objname,
    zz = "zz_fountain",
    zz_gate = "gzz_courtyard_fountain"
  };
  
  local get_lionpen2_inv = function ()
  
    interface.InventoryItemAdd( "inv_lionpen2", "spr_fountain_lionpen2" );
  
  end;
  
  local get_lionpen2_closezz = function ()

    ObjDelete( "spr_fountain_lionpen2_shadow" );
    ObjDelete( "spr_courtyard_fountain_handle" );

    if ( cmn.IsEventDone( "get_lionpen2" ) and cmn.IsEventDone( "get_codedpaper") and
    cmn.IsEventDone( "get_broom" ) and cmn.IsGetCollect2( "get_collect2_item_1_1" ) ) then 

      ObjDelete( "gzz_courtyard_fountain" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_lionpen2", get_lionpen2_inv );
  cmn.AddSubscriber( "get_lionpen2", get_lionpen2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_codedpaper () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_codedpaper" ] = {
    type = "get",
    get_obj = "spr_fountain_codedpaper",
    room = private.room_objname,
    zz = "zz_fountain",
    zz_gate = "gzz_courtyard_fountain"
  };
  
  local get_codedpaper_inv = function ()
  
    interface.InventoryItemAdd( "inv_codedpaper", "spr_fountain_codedpaper" );
    ObjSet( "inv_codedpaper", { drag = false } );

  end;
  
  local get_codedpaper_closezz = function ()

    if ( cmn.IsEventDone( "get_lionpen2" ) and cmn.IsEventDone( "get_codedpaper") and
    cmn.IsEventDone( "get_broom" ) and cmn.IsGetCollect2( "get_collect2_item_1_1" ) ) then 

      ObjDelete( "gzz_courtyard_fountain" );

    end;  
  
  end;
  
  cmn.AddSubscriber( "get_codedpaper", get_codedpaper_inv );
  cmn.AddSubscriber( "get_codedpaper", get_codedpaper_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_broom () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_broom" ] = {
    type = "get",
    get_obj = "spr_fountain_broom",
    room = private.room_objname,
    zz = "zz_fountain",
    zz_gate = "gzz_courtyard_fountain"
  };
  
  local get_broom_inv = function ()
  
    interface.InventoryItemAdd( "inv_broom", "spr_fountain_broom" );
  
  end;
  
  local get_broom_closezz = function ()

    ObjDelete( "spr_courtyard_fountain_broom" );
    ObjDelete( "spr_fountain_broom_shadow" );

    if ( cmn.IsEventDone( "get_lionpen2" ) and cmn.IsEventDone( "get_codedpaper") and
    cmn.IsEventDone( "get_broom" ) and cmn.IsGetCollect2( "get_collect2_item_1_1" ) ) then 

      ObjDelete( "gzz_courtyard_fountain" );

    end;
    
  end;
  
  cmn.AddSubscriber( "get_broom", get_broom_inv );
  cmn.AddSubscriber( "get_broom", get_broom_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_1_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_1_1 = function ()
  
    ObjDelete( "obj_collect2_item_1_1" );

    if ( cmn.IsEventDone( "get_lionpen2" ) and cmn.IsEventDone( "get_codedpaper") and
      cmn.IsEventDone( "get_broom" ) ) then

      ObjDelete( "gzz_courtyard_fountain" );

    end;
  
  end;    
  cmn.AddSubscriber( "get_collect2_item_1_1", get_collect2_item_1_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_razor () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_razor" ] = {
    type = "use",
    inv_obj = "inv_razor",
    use_place = "obj_thicket_use_razor",
    room = private.room_objname,
    zz = "zz_thicket",
    zz_gate = "gzz_courtyard_thicket"
  };
  local use_razor_inv = function ()
  
    interface.InventoryItemRemove( "inv_razor" );
  
  end;
  local use_razor_beg = function ()
  
    ObjDelete( "obj_thicket_use_razor" );
  
  end;
  local use_razor_end = function ()

    ObjSet( "obj_thicket_use_loungekey", { input = true } );
    ObjDelete( "anm_bodyguardthings_use_magnet" );
    ObjDelete( "spr_thicket_grass_1" );
    ObjDelete( "spr_thicket_grass_2" );

    ObjDelete( "spr_courtyard_thicket_bush_2" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_razor", use_razor_beg, private.room_objname );
  cmn.AddSubscriber( "use_razor", use_razor_inv );
  cmn.AddSubscriber( "use_razor", use_razor_end, private.room_objname );
  cmn.AddSubscriber( "use_razor_inv", use_razor_inv, private.room_objname );
  cmn.AddSubscriber( "use_razor_beg", use_razor_beg, private.room_objname );
  cmn.AddSubscriber( "use_razor_end", use_razor_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_loungekey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_loungekey" ] = {
    type = "use",
    inv_obj = "inv_loungekey",
    use_place = "obj_thicket_use_loungekey",
    room = private.room_objname,
    zz = "zz_thicket",
    zz_gate = "gzz_courtyard_thicket"
  };
  local use_loungekey_inv = function ()
  
    interface.InventoryItemRemove( "inv_loungekey" );
  
  end;
  local use_loungekey_beg = function ()
  
    ObjDelete( "obj_thicket_use_loungekey" );
  
  end;
  local use_loungekey_end = function ()
  
    ObjSet( "spr_thicket_key_1", { alp = 1, visible = true } );
    ObjSet( "obj_thicket_clk_loungekey_1", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_loungekey", use_loungekey_beg, private.room_objname );
  cmn.AddSubscriber( "use_loungekey", use_loungekey_inv );
  cmn.AddSubscriber( "use_loungekey", use_loungekey_end, private.room_objname );
  cmn.AddSubscriber( "use_loungekey_inv", use_loungekey_inv, private.room_objname );
  cmn.AddSubscriber( "use_loungekey_beg", use_loungekey_beg, private.room_objname );
  cmn.AddSubscriber( "use_loungekey_end", use_loungekey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_antirustrecipe () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_antirustrecipe" ] = {
    type = "use",
    inv_obj = "inv_antirustrecipe",
    use_place = "obj_chemicalsshelf_use_antirustrecipe",
    room = private.room_objname,
    zz = "zz_chemicalsshelf",
    zz_gate = "gzz_courtyard_chemicalsshelf"
  };
  local use_antirustrecipe_inv = function ()
  
    interface.InventoryItemRemove( "inv_antirustrecipe" );
  
  end;
  local use_antirustrecipe_beg = function ()
  
    ObjDelete( "obj_chemicalsshelf_use_antirustrecipe" );
  
  end;
  local use_antirustrecipe_end = function ()
  
    ObjSet( "spr_chemicalsshelf_antirustrecipe", { input = true, alp = 1 } );
    ObjSet( "obj_chemicalsshelf_mmg", { input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_antirustrecipe", use_antirustrecipe_beg, private.room_objname );
  cmn.AddSubscriber( "use_antirustrecipe", use_antirustrecipe_inv );
  cmn.AddSubscriber( "use_antirustrecipe", use_antirustrecipe_end, private.room_objname );
  cmn.AddSubscriber( "use_antirustrecipe_inv", use_antirustrecipe_inv, private.room_objname );
  cmn.AddSubscriber( "use_antirustrecipe_beg", use_antirustrecipe_beg, private.room_objname );
  cmn.AddSubscriber( "use_antirustrecipe_end", use_antirustrecipe_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chain1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chain" ] = {
    type = "use",
    inv_obj = "inv_chain",
    use_place = "obj_floormechanism_use_chain",
    room = private.room_objname,
    zz = "zz_floormechanism",
    zz_gate = "gzz_courtyard_floormechanism"
  };
  local use_chain_inv = function ()
  
    interface.InventoryItemRemove( "inv_chain" );
  
  end;
  local use_chain_beg = function ()
  
    ObjDelete( "obj_floormechanism_use_chain" );
  
  end;
  local use_chain_end = function ()

    ObjSet( "spr_floormechanism_chain_left", { alp = 1, visible = true } );
    ObjSet( "spr_floormechanism_chain_right", { alp = 1, visible = true } );
    ObjDelete( "spr_floormechanism_chainbroken_right" );

    ObjSet( "obj_floormechanism_mmg", { input = true } );
    ObjDelete( "spr_floormechanism_gate_left" );
    ObjDelete( "spr_floormechanism_chain_left" );
    ObjDelete( "spr_floormechanism_gate_right" );
    ObjDelete( "spr_floormechanism_chain_right" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chain", use_chain_beg, private.room_objname );
  cmn.AddSubscriber( "use_chain", use_chain_inv );
  cmn.AddSubscriber( "use_chain", use_chain_end, private.room_objname );
  cmn.AddSubscriber( "use_chain_inv", use_chain_inv, private.room_objname );
  cmn.AddSubscriber( "use_chain_beg", use_chain_beg, private.room_objname );
  cmn.AddSubscriber( "use_chain_end", use_chain_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_antirust_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_antirust_1" ] = {
    type = "use",
    inv_obj = "inv_antirust",
    use_place = "obj_floormechanism_use_antirust_1",
    room = private.room_objname,
    zz = "zz_floormechanism",
    zz_gate = "gzz_courtyard_floormechanism"
  };
  local use_antirust_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_antirust" );
  
  end;
  local use_antirust_1_beg = function ()
  
    ObjDelete( "obj_floormechanism_use_antirust_1" );
  
  end;
  local use_antirust_1_end = function ()
  
    ObjDelete( "vid_floormechanism_antirust" );
    ObjDelete( "spr_floormechanism_valve_rust" );
    ObjSet( "spr_floormechanism_valve_norust", { alp = 1, visible = true } );
    ObjSet( "spr_floormechanism_valve_norust_light", { alp = 1, visible = true } );
    ObjSet( "obj_floormechanism_clk_antirust_1", { input = true } );
    ObjDelete( "spr_courtyard_hatch_rust" );
    ObjSet( "spr_courtyard_hatch", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_antirust_1", use_antirust_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_antirust_1", use_antirust_1_inv );
  cmn.AddSubscriber( "use_antirust_1", use_antirust_1_end, private.room_objname );
  cmn.AddSubscriber( "use_antirust_1_inv", use_antirust_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_antirust_1_beg", use_antirust_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_antirust_1_end", use_antirust_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_button () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_button" ] = {
    type = "use",
    inv_obj = "inv_button",
    use_place = "obj_fountain_use_button",
    room = private.room_objname,
    zz = "zz_fountain",
    zz_gate = "gzz_courtyard_fountain"
  };
  local use_button_inv = function ()
  
    interface.InventoryItemRemove( "inv_button" );
  
  end;
  local use_button_beg = function ()
  
    ObjDelete( "obj_fountain_use_button" );
    ObjSet( "spr_courtyard_fountain_button", { alp = 1, visible = true } );
  
  end;
  local use_button_end = function ()

    ObjSet( "obj_fountain_clk_button", { input = true } );
    ObjSet( "spr_fountain_button_off", { alp = 1, visible = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_button", use_button_beg, private.room_objname );
  cmn.AddSubscriber( "use_button", use_button_inv );
  cmn.AddSubscriber( "use_button", use_button_end, private.room_objname );
  cmn.AddSubscriber( "use_button_inv", use_button_inv, private.room_objname );
  cmn.AddSubscriber( "use_button_beg", use_button_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_end", use_button_end, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS CLK
--*********************************************************************************************************************
  -- function clk_bar_door () end;
  --------------------------------------------------------------------------------------------
  local clk_bar_door_beg = function ()

    ObjDelete( "obj_courtyard_clk_bar_door" );
  
  end;
  local clk_bar_door_end = function ()

    ObjDelete( "anm_courtyard_guillotine" );
    ObjSet( "obj_courtyard_guillotine", { alp = 1 } );
    ObjSet( "obj_courtyard_clk_bar_door_2", { input = true } );
    ObjSet( "anm_courtyard_guillotine2", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_bar_door", clk_bar_door_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bar_door", clk_bar_door_end, private.room_objname );
  cmn.AddSubscriber( "clk_bar_door_beg", clk_bar_door_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bar_door_end", clk_bar_door_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_button () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_button" ] = {
    type = "click",
    use_place = "obj_fountain_clk_button",
    room = private.room_objname,
    zz = "zz_fountain",
    zz_gate = "gzz_courtyard_fountain"
  };

  local clk_button_beg = function ()

    ObjDelete( "obj_fountain_clk_button" );
    ObjSet( "spr_courtyard_fountain_open", { alp = 1, visible = true } );
  
  end;
  local clk_button_end = function ()

    ObjSet( "obj_fountain_open", { alp = 1, visible = true, input = true } );
    ObjDelete( "spr_fountain_door_close" );
    ObjSet( "spr_fountain_button_on", { alp = 1, visible = true } );
    ObjDelete( "spr_fountain_button_off" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_button", clk_button_beg, private.room_objname );
  cmn.AddSubscriber( "clk_button", clk_button_end, private.room_objname );
  cmn.AddSubscriber( "clk_button_beg", clk_button_beg, private.room_objname );
  cmn.AddSubscriber( "clk_button_end", clk_button_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_loungekey_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_loungekey_1" ] = {
    type = "click",
    use_place = "obj_thicket_clk_loungekey_1",
    room = private.room_objname,
    zz = "zz_thicket",
    zz_gate = "gzz_courtyard_thicket"
  };

  local clk_loungekey_1_beg = function ()

    ObjDelete( "obj_thicket_clk_loungekey_1" );
  
  end;
  local clk_loungekey_1_end = function ()

    ObjSet( "obj_thicket_clk_loungekey_2", { input = true } );
    ObjSet( "spr_thicket_key_2", { alp = 1, visible = true } );
    ObjDelete( "spr_thicket_key_1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_loungekey_1", clk_loungekey_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_loungekey_1", clk_loungekey_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_loungekey_1_beg", clk_loungekey_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_loungekey_1_end", clk_loungekey_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_loungekey_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_loungekey_2" ] = {
    type = "click",
    use_place = "obj_thicket_clk_loungekey_2",
    room = private.room_objname,
    zz = "zz_thicket",
    zz_gate = "gzz_courtyard_thicket"
  };

  local clk_loungekey_2_beg = function ()

    ObjDelete( "obj_thicket_clk_loungekey_2" );
  
  end;
  local clk_loungekey_2_end = function ()

    ObjDelete( "spr_thicket_key_2" );
    ObjSet( "spr_thicket_door_open", { alp = 1, visible = true } );
    ObjDelete( "gzz_courtyard_thicket" );
    ObjSet( "grm_courtyard_lounge", { alp = 1, visible = true, input = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_courtyard_lounge_focus");
    end;    
    ObjSet( "spr_courtyard_door_open", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_loungekey_2", clk_loungekey_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_loungekey_2", clk_loungekey_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_loungekey_2_beg", clk_loungekey_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_loungekey_2_end", clk_loungekey_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_floormechanism_folder () end;
  --------------------------------------------------------------------------------------------

  local clk_floormechanism_folder_beg = function ()
  
  end;
  local clk_floormechanism_folder_end = function ()

    ObjDelete( "spr_floormechanism_folder_closed" );
    ObjSet( "spr_floormechanism_folder_opened", { input = true } );

  end;
  local clk_floormechanism_folder_small = function ()

    ObjSet( "spr_floormechanism_folder_opened", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_floormechanism_folder", clk_floormechanism_folder_beg, private.room_objname );
  cmn.AddSubscriber( "clk_floormechanism_folder", clk_floormechanism_folder_end, private.room_objname );
  cmn.AddSubscriber( "clk_floormechanism_folder", clk_floormechanism_folder_small, private.room_objname );
  cmn.AddSubscriber( "clk_floormechanism_folder_beg", clk_floormechanism_folder_beg, private.room_objname );
  cmn.AddSubscriber( "clk_floormechanism_folder_end", clk_floormechanism_folder_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_floormechanism_antirust_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_floormechanism_antirust_1" ] = {
    type = "click",
    use_place = "obj_floormechanism_clk_antirust_1",
    room = private.room_objname,
    zz = "zz_floormechanism",
    zz_gate = "gzz_courtyard_floormechanism"
  };

  local clk_floormechanism_antirust_1_beg = function ()

    ObjDelete( "obj_floormechanism_clk_antirust_1" );
    ObjSet( "spr_courtyard_hatch_after_use", { alp = 1, visible = true } );
    ObjSet( "spr_courtyard_hatch", { alp = 0, visible = false } );
  
  end;
  local clk_floormechanism_antirust_1_end = function ()

    ObjDelete( "spr_floormechanism_valve_norust_light" );
    ObjDelete( "spr_floormechanism_can" );
    ObjSet( "obj_floormechanism_use_chain", { input = true } );
    ObjSet( "spr_floormechanism_folder_closed", { input = true } );

    ObjSet( "spr_floormechanism_crossbow", { input = true } );
    ObjSet( "gfx_floormechanism_crossbow", { active = true } );

    ObjSet( "spr_floormechanism_loungekey", { input = true } );
    ObjSet( "gfx_floormechanism_loungekey", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_floormechanism_antirust_1", clk_floormechanism_antirust_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_floormechanism_antirust_1", clk_floormechanism_antirust_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_floormechanism_antirust_1_beg", clk_floormechanism_antirust_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_floormechanism_antirust_1_end", clk_floormechanism_antirust_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- PROGRESS WIN
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function win_chemicalsshelf () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_chemicalsshelf" ] =
  {
      type = "win",
      room = private.room_objname,
      zz = "zz_chemicalsshelf",
      zz_gate = "gzz_courtyard_chemicalsshelf"
  };
--*********************************************************************************************************************
  local win_chemicalsshelf = function ()

    if ( cmn.IsEventDone( "win_chemicalsshelf" ) ) then

    ObjMultiSet( {  
      { "spr_chemicalsshelf_antirust",          { input = true, alp = 1 } },
      { "spr_chemicalsshelf_antirustcrack",     { alp = 0 } },
      { "obj_chemicalsshelf_mmg",               { input = false, alp = 0 } }
    } );
      --ObjSet( "spr_chemicalsshelf_antirust", { input = true, alp = 1 } );   
      --ObjSet( "spr_chemicalsshelf_antirustcrack", { alp = 0 } );   
      --ObjSet( "spr_chemicalsshelf_antirustshadow", { alp = 0 } ); 
      --ObjSet( "obj_chemicalsshelf_mmg", { input = false } );     

    end;

  end;

  cmn.AddSubscriber( "win_chemicalsshelf", win_chemicalsshelf, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_floormechanism () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_floormechanism" ] =
  {
      type = "win",
      room = private.room_objname,
      zz = "zz_floormechanism",
      zz_gate = "gzz_courtyard_floormechanism"
  };
--*********************************************************************************************************************
  local win_floormechanism = function ()

    if ( cmn.IsEventDone( "win_floormechanism" ) ) then
      
      ObjSet( "obj_floormechanism_mmg", { input = false } );
      ObjDelete( "gzz_courtyard_floormechanism" );
      ObjDelete( "obj_courtyard_clk_bar_door_2" );
    
    end;

  end;

  cmn.AddSubscriber( "win_floormechanism", win_floormechanism, private.room_objname );
--*********************************************************************************************************************
--*********************************************************************************************************************
-- PROGRESS SEE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function see_courtyard_scare_1 () end;
  --------------------------------------------------------------------------------------------
  local see_courtyard_scare_1 = function ()

    ObjDelete( "anm_courtyard_tv" );
    ObjSet( "obj_courtyard_tv", { alp = 1 } );

    ObjSet( "obj_courtyard_use_stepladder", { input = true } );

  end;

  cmn.AddSubscriber( "see_courtyard_scare_1", see_courtyard_scare_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_flashback_courtyard () end;
  --------------------------------------------------------------------------------------------
  local see_flashback_courtyard = function ()

    ObjSet( "grm_courtyard_bar", { active = true, input = true, visible = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_courtyard_bar_focus");
    end;    
    ObjDelete( "vid_courtyard_flashback_courtyard" );
    ObjSet( "spr_courtyard_coctail", { alp = 1 } );
    ObjSet( "spr_courtyard_arrow3", { alp = 1 } );
    ObjSet( "obj_courtyard_clk_arrow", { input = true } );
    ObjDelete( "vid_courtyard_guilotine" );
    ObjDelete( "anm_courtyard_guillotine2" );
    ObjSet( "spr_courtyard_patch_guliotine_broken", { alp = 1 } );

    ObjDelete( "obj_courtyard_clk_bar_door" );

  end;

  cmn.AddSubscriber( "see_flashback_courtyard", see_flashback_courtyard, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_courtyard_scare_2 () end;
  --------------------------------------------------------------------------------------------
  local see_courtyard_scare_2 = function ()

    ObjDelete( "anm_courtyard_h_light" );
    ObjDelete( "spr_courtyard_h" );
    ObjDelete( "spr_courtyard_hatch_after_use" );
    ObjSet( "spr_courtyard_hatch", { alp = 1, visible = true } );    

  end;

  cmn.AddSubscriber( "see_courtyard_scare_2", see_courtyard_scare_2, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load()

  -- function mmg_chemicalsshelf () end; ----------------------------------------------------------------------------------
    if ( cmn.IsEventStart( "win_chemicalsshelf" ) ) then

      if ( ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_knife_funnel1 ) then 

        ObjSet( "spr_chemicalsshelf_funnel1", { input = true, pos_x = -197, pos_y = 140 } );
        ObjSet( "spr_chemicalsshelf_funnel1shadow", { pos_x = -190, pos_y = 164 } );
        ObjSet( "obj_chemicalsshelf_use_knife_funnel1", { input = false } );

      end;

      if ( ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_knife_plasticpipes ) then

        ObjSet( "spr_chemicalsshelf_plasticpipes",   { alp = 1 } );
        ObjSet( "spr_chemicalsshelf_plasticpipes_1", { alp = 0 } );
        ObjSet( "obj_chemicalsshelf_use_knife_plasticpipes", { input = false } );    

      end;
      private.KnifeCheck();

      if ( ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_skotch_antirustrecipe_1 ) then

        ObjSet( "spr_chemicalsshelf_antirustscotch1", { alp = 1 } );      

      end;

      if ( ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_skotch_antirustrecipe_2 ) then

        ObjSet( "spr_chemicalsshelf_antirustscotch2", { alp = 1 } );

      end;

      if ( ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_funnel1_bottle ) then

        ObjSet( "spr_chemicalsshelf_funnel1", { input = false, alp = 0 } );
        ObjSet( "spr_chemicalsshelf_funnel1shadow", {  alp = 0 } );    
        ObjSet( "spr_chemicalsshelf_funnel2", { alp = 1 } ); 

      end;

      if ( ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_bottle_1 ) then

        ObjSet( "spr_chemicalsshelf_bottle1", { input = false, alp = 0 } );
        ObjSet( "spr_chemicalsshelf_bottle1shadow", {  alp = 0 } );

      end;

      if ( ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_bottle_2 ) then

        ObjSet( "spr_chemicalsshelf_bottle2", { input = false, alp = 0 } );
        ObjSet( "spr_chemicalsshelf_bottle2shadow", {  alp = 0 } );

      end;
      if (  ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_bottle_1 and 
        ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_bottle_2 ) then 

        ObjSet( "spr_chemicalsshelf_funnel2", { alp = 0 } );

      end;

      if ( ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.clk_bottle1 ) then

        ObjSet( "obj_chemicalsshelf_clk_bottle1", { input = false } );
        ObjSet( "spr_chemicalsshelf_bottle1", { input = true } );
        ObjSet( "spr_chemicalsshelf_bottle1cover", { alp = 0 } );

      end;

      if ( ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.clk_cover2 ) then

        ObjSet( "obj_chemicalsshelf_clk_cover2", { input = false } );
        ObjSet( "spr_chemicalsshelf_cover1", { alp = 0 } );
        ObjSet( "spr_chemicalsshelf_cover2", { alp = 1 } );

      end;
      private.PlasticpipesCheck();

      if ( ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_antirustcrack_plasticpipes ) then

        ObjSet( "spr_chemicalsshelf_antirustcover", { alp = 1 } );
        ObjSet( "obj_chemicalsshelf_plasticpipes", { input = false, pos_z = 0, ang = 0, alp = 0 } );

      end;

    end;  
  ---------------------------------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function private.Init_Subroom()

  --*******************************************************************************************************************
  --*** function zz_chemicalsshelf () end ****
  -- зз стена со светильником
    subroom.Define( "zz_chemicalsshelf" );
    function zz_chemicalsshelf.Open ()

      if ( cmn.IsEventStart( "win_chemicalsshelf" ) and not cmn.IsEventDone( "win_chemicalsshelf" ) ) then

        cmn.MiniGameShow( "chemicalsshelf" );
        common_impl.PassingMgStart( "chemicalsshelf" );

      end;

    end;  
    -------------------------------------------------
    function zz_chemicalsshelf.PreOpen ()

    end;  
    -------------------------------------------------
    function zz_chemicalsshelf.PreClose ()

      if ( cmn.IsEventStart( "win_chemicalsshelf" ) and not cmn.IsEventDone( "win_chemicalsshelf" ) ) then

        cmn.MiniGameHide( "chemicalsshelf" );
        common_impl.PassingMgStop( "chemicalsshelf" );

      end;

    end; 
    ------------------------------------------------- 
    function zz_chemicalsshelf.Close ()

      if ( cmn.IsEventDone( "use_antirustrecipe" ) ) then

        cmn.NoteScaleClose( { "spr_chemicalsshelf_antirustrecipe" } ); 

      end;

    end;
    -------------------------------------------------
    function zz_chemicalsshelf.Reset ()

      ObjMultiSet( {  
        { "spr_chemicalsshelf_bottle2shadow",           { alp = 1, pos_z = -3 } },
        { "spr_chemicalsshelf_scotch1shadow",           { alp = 1, pos_z = -2 } },
        { "spr_chemicalsshelf_bottle1shadow",           { alp = 1, pos_z = -1 } },
        { "spr_chemicalsshelf_funnel1shadow",           { alp = 1, pos_z = -1 } },
        { "spr_chemicalsshelf_knifeshadow",             { alp = 1, pos_z = -1 } },
        { "spr_chemicalsshelf_scotch1",                 { alp = 1, pos_z = -1, input = true } },
        { "spr_chemicalsshelf_bottle2",                 { alp = 1, pos_z = 0, input = true } },
        { "spr_chemicalsshelf_cover1",                  { alp = 1, pos_z = 0, input = false } },
        { "spr_chemicalsshelf_funnel1",                 { alp = 1, pos_z = 0, input = false } },
        { "obj_chemicalsshelf_clk_cover2",              { alp = 1, input = true } },
        { "obj_chemicalsshelf_clk_bottle1",             { alp = 1, input = true } },
        --{ "spr_chemicalsshelf_antirustshadow",          { alp = 1, pos_z = 3, input = false } },
        { "spr_chemicalsshelf_plasticpipes_1",          { alp = 1 } },

        { "spr_chemicalsshelf_antirustcrack",           { alp = 1, pos_z = 5, input = false } },
            { "spr_chemicalsshelf_antirustscotch1",         { alp = 0, input = false } },
            { "spr_chemicalsshelf_funnel2",                 { alp = 0, pos_z = 6, input = false } },
            { "spr_chemicalsshelf_partfunnel",              { alp = 1, pos_z = 7, input = false } },
            { "spr_chemicalsshelf_antirustcover",           { alp = 0, pos_z = 8, input = false } },
            { "spr_chemicalsshelf_antirustscotch2",         { alp = 0, pos_z = 9, input = false } },

        { "spr_chemicalsshelf_knife",                   { alp = 1, pos_z = 8, input = true } },

        { "obj_chemicalsshelf_plasticpipes",            { alp = 1, pos_z = 7, input = false } },
            { "spr_chemicalsshelf_plasticpipes",            { alp = 0, input = false } },
            { "spr_chemicalsshelf_cover2",                  { alp = 0, input = false } },

        { "spr_chemicalsshelf_bottle1",                 { alp = 1, pos_z = -1, input = false } },
            { "spr_chemicalsshelf_bottle1cover",                 { alp = 1, input = false } },

        { "obj_chemicalsshelf_use_knife_funnel1",       { input = true } },
        { "obj_chemicalsshelf_use_knife_plasticpipes",  { input = true } }

      } );

      ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_knife_funnel1 = false; -- применение ножа на воронку из бутылки
      ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_knife_plasticpipes = false; -- применение ножа на резиновую трубку
      ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_knife_3 = false;

      ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_skotch_antirustrecipe_1 = false; -- применение скотча на треснутую бутылки
      ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_skotch_antirustrecipe_2 = false; -- применение скотча на бутылку когда на неё вставлен распылитель

      ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_antirustcrack_antirustrecipe = false; 

      ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_bottle_1 = false; -- применение красной бутылки
      ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_bottle_2 = false; -- применение зелёной бутылки


      ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.clk_bottle1 = false; -- открыть крышку у красной бутылке
      ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.clk_cover2 = false; -- 

      ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_antirustcrack_plasticpipes = false; -- применение распылителя с резиновой трубкой на бутылки 
      ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_funnel1_bottle = false; -- применение воронки на бутылку

      ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.progress = { false, false, false, false, false, false }; 

    end;
    -------------------------------------------------  
    function zz_chemicalsshelf.ResetEnd ()

    end;
    -------------------------------------------------
    function zz_chemicalsshelf.Skip ()

      local func_end = function ()

        cmn.Lock( true );
        private.WinChemicalsshelf();

      end;

      cmn.Lock( true );
      ObjAnimate( "obj_chemicalsshelf_mmg", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      ObjAnimate( "spr_chemicalsshelf_antirust", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

    end;
    -------------------------------------------------
  --*******************************************************************************************************************
  --*** function zz_floormechanism () end ****
  -- зз стена со светильником
    subroom.Define( "zz_floormechanism" );
    function zz_floormechanism.Open ()

    end;  
    -------------------------------------------------
    function zz_floormechanism.PreOpen ()

      if ( cmn.IsEventStart( "win_floormechanism" ) and not cmn.IsEventDone( "win_floormechanism" ) ) then

        cmn.MiniGameShow( "floormechanism" );
        common_impl.PassingMgStart( "floormechanism" );

      end;

      private.FloormechanismLoad();
      private.FloormechanismUpdate(); 

    end;  
    -------------------------------------------------
    function zz_floormechanism.PreClose ()

      if ( cmn.IsEventStart( "win_floormechanism" ) and not cmn.IsEventDone( "win_floormechanism" ) ) then

        cmn.MiniGameHide( "floormechanism" );
        common_impl.PassingMgStop( "floormechanism" );

      end;

    end; 
    ------------------------------------------------- 
    function zz_floormechanism.Close ()

      if ( cmn.IsEventDone( "clk_floormechanism_antirust_1" ) ) then
        cmn.NoteScaleClose( { "spr_floormechanism_folder_opened" }, { "spr_floormechanism_folder_big" } );
      end;

    end;
    -------------------------------------------------
    function zz_floormechanism.Reset ()

      private.FloormechanismDefault();
      private.FloormechanismSave();
      private.FloormechanismUpdate();

    end;
    -------------------------------------------------  
    function zz_floormechanism.ResetEnd ()

    end;
    -------------------------------------------------
    function zz_floormechanism.Skip ()

      private.floormechanism_circle = private.floormechanism_circle_win;
      private.FloormechanismSave();
      private.FloormechanismUpdate();

    end;
  --*******************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_courtyard();

  if not ( cmn.IsEventDone( "see_courtyard_scare_1" ) ) then

    if ( cmn.IsEventDone( "get_antirustrecipe" ) ) then

      private.CourtyardScare_1();      
      
    end;

  end;

  if not ( cmn.IsEventDone( "see_courtyard_scare_2" ) ) then

    if ( cmn.IsEventDone( "get_spring" ) ) then

      private.CourtyardScare_2();      
      
    end;

  end;

  if ( cmn.IsEventDone( "win_floormechanism" ) ) and
  ( not cmn.IsEventDone( "see_flashback_courtyard" ) ) then 
      private.FlashbackCourtyard();
  end;

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();

  common_impl.EnvPlay( { "level1/env/aud_rm_courtyard_env" }, "", 0.5 );
  --cmn.PlayMusEnv();

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_razor ()

  local item = "inv_razor";

  if cmn.ApplyObj( item, "gzz_courtyard_thicket" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_thicket", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_thicket_use_razor" ) ) then

    cmn.CallEventHandler( "use_razor_inv" );
    cmn.CallEventHandler( "use_razor_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_razor" );
      cmn.CallEventHandler( "use_razor_end" );

    end;

    local func_end_2 = function ()

      ObjSet( "spr_thicket_grass_1", { alp = 0 } );
      ObjSet( "spr_thicket_grass_2", { alp = 0 } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_axe", 0, "", 0 );

    ObjSet( "anm_thicket_razor", { alp = 0, visible = true } );
    ObjAnimate( "anm_thicket_razor", "alp",0,0, func_end_2, { 0, 0, 0,    0.3, 0, 1 } );
    AnimPlay( "anm_thicket_razor", "DuAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_loungekey ()

  local item = "inv_loungekey";

  if cmn.ApplyObj( item, "gzz_courtyard_thicket" ) and cmn.IsEventDone( "use_razor" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_thicket", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_thicket_use_loungekey" ) and cmn.IsEventDone( "use_razor" ) ) then

    cmn.CallEventHandler( "use_loungekey_inv" );
    cmn.CallEventHandler( "use_loungekey_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_loungekey" );
      cmn.CallEventHandler( "use_loungekey_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_key_courtyard", 0, "", 0 );

    cmn.ItemFly( "spr_thicket_key_1", func_end, -2.27 );
    
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_chain ()

  local item = "inv_chain";

  if cmn.ApplyObj( item, "gzz_courtyard_floormechanism" ) and cmn.IsEventDone( "get_chain1" ) and cmn.IsEventDone( "get_chain2" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_floormechanism", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_floormechanism_use_chain" ) and
  cmn.IsEventDone( "use_antirust_1" ) and cmn.IsEventDone( "get_chain1" ) and cmn.IsEventDone( "get_chain2" ) ) then

    cmn.CallEventHandler( "use_chain_inv" );
    cmn.CallEventHandler( "use_chain_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_chain" );
      cmn.CallEventHandler( "use_chain_end" );

      cmn.MiniGameShow( "floormechanism" );
      common_impl.PassingMgStart( "floormechanism" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_chain", 0, "", 0 );

    ObjSet( "spr_floormechanism_chain_left", { alp = 0, visible = true } );
    ObjAnimate( "spr_floormechanism_chain_left", "alp",0,0, "", { 0, 0, 0,    0.6, 0, 1 } );

    ObjAnimate( "spr_floormechanism_chainbroken_right", "alp",0,0, "", { 0, 2, 1,    0.6, 2, 0 } );
    ObjSet( "spr_floormechanism_chain_right", { alp = 0, visible = true } );
    ObjAnimate( "spr_floormechanism_chain_right", "alp",0,0, "", { 0, 1, 0,    0.6, 1, 1 } );

    ObjAnimate( "spr_floormechanism_gate_left", "pos_x",0,0, "", { 0, 3, -125,    0.6, 3, -125,    1.6, 3, -375 } );
    ObjAnimate( "spr_floormechanism_chain_left", "pos_x",0,0, "", { 0, 3, -138,    0.6, 3, -138,    1.6, 3, -388 } );

    ObjAnimate( "spr_floormechanism_gate_right", "pos_x",0,0, "", { 0, 3, 68,    0.6, 3, 68,    1.6, 3, 318 } );
    ObjAnimate( "spr_floormechanism_chain_right", "pos_x",0,0, func_end, { 0, 3, 73,    0.6, 3, 73,    1.6, 3, 323 } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_antirustrecipe ()

  local item = "inv_antirustrecipe";

  if cmn.ApplyObj( item, "gzz_courtyard_chemicalsshelf" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_chemicalsshelf", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_chemicalsshelf_use_antirustrecipe" ) ) then

    cmn.CallEventHandler( "use_antirustrecipe_inv" );
    cmn.CallEventHandler( "use_antirustrecipe_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_antirustrecipe" );
      cmn.CallEventHandler( "use_antirustrecipe_end" );

      private.InitChemicalsshelfStart();

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "aud_paper", 0, "", 0 );

    ObjAnimate( "spr_chemicalsshelf_antirustrecipe", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_antirust_1 ()

  local item = "inv_antirust";

  if cmn.ApplyObj( item, "gzz_courtyard_floormechanism" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_floormechanism", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_floormechanism_use_antirust_1" ) ) then

    cmn.CallEventHandler( "use_antirust_1_inv" );
    cmn.CallEventHandler( "use_antirust_1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_antirust_1" );
      cmn.CallEventHandler( "use_antirust_1_end" );

    end;

    local func_end_2 = function ()

      ObjSet( "spr_floormechanism_valve_rust", { alp = 0 } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_spray", 0, "", 0 );

    ObjSet( "vid_floormechanism_antirust", { alp = 0, visible = true } ); 
    ObjAnimate( "vid_floormechanism_antirust", "alp",0,0, func_end_2, { 0, 0, 0,    0.3, 0, 1 } );  
    VidPlay( "vid_floormechanism_antirust", func_end ); 

    ObjSet( "spr_floormechanism_valve_norust_light", { alp = 0, visible = true } ); 
    ObjAnimate( "spr_floormechanism_valve_norust_light", "alp",0,0, "", { 0, 0, 0,     2.4, 0, 0,    3.0, 0, 1 } );  

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_button ()

  local item = "inv_button";

  if cmn.ApplyObj( item, "gzz_courtyard_fountain" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fountain", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_fountain_use_button" ) ) then

    cmn.CallEventHandler( "use_button_inv" );
    cmn.CallEventHandler( "use_button_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_button" );
      cmn.CallEventHandler( "use_button_end" );

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_drawer_handle", 0, "", 0 );

    end;

    cmn.Lock( true );
    cmn.ItemFly( "spr_fountain_button_off", func_end, 2.27 );


    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_antirust ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_antirust" );
  cmn.CallEventHandler( "get_antirust" );

  common.CloseSubRoom(); 

end;
--------------------------------------------------------------------------------------------
function private.get_loungekey ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_loungekey" );
  cmn.CallEventHandler( "get_loungekey" );

end;
--------------------------------------------------------------------------------------------
function private.get_button ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_button" );
  cmn.CallEventHandler( "get_button" );

end;
--------------------------------------------------------------------------------------------
function private.get_crossbow ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_crossbow" );
  cmn.CallEventHandler( "get_crossbow" );

end;
--------------------------------------------------------------------------------------------
function private.get_lionpen2 ()
  
  ObjDelete( "gfx_fountain_lionpen2" );
  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_lionpen2" );
  cmn.CallEventHandler( "get_lionpen2" );

  if ( cmn.IsEventDone( "get_codedpaper") and
    cmn.IsEventDone( "get_broom" ) and cmn.IsGetCollect2( "get_collect2_item_1_1" ) ) then
 
    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_codedpaper ()

  ObjDelete( "gfx_fountain_codedpaper" );
  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_codedpaper" );
  cmn.CallEventHandler( "get_codedpaper" );

  if ( cmn.IsEventDone( "get_lionpen2") and
    cmn.IsEventDone( "get_broom" ) and cmn.IsGetCollect2( "get_collect2_item_1_1" ) ) then 

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_broom ()

  ObjDelete( "gfx_fountain_broom" );
  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_broom" );
  cmn.CallEventHandler( "get_broom" );

  if ( cmn.IsEventDone( "get_lionpen2") and
    cmn.IsEventDone( "get_codedpaper" ) and cmn.IsGetCollect2( "get_collect2_item_1_1" ) ) then 

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_1_1 ()

  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_1_1" ); 

    if ( cmn.IsEventDone( "get_lionpen2" ) and cmn.IsEventDone( "get_codedpaper") and
      cmn.IsEventDone( "get_broom" ) ) then

      common.CloseSubRoom();

    end;

  end;

  common_impl.PlayEffectHO( "spr_collect2_item_1_1", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_1_1" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_bar_door ()

  cmn.CallEventHandler( "clk_bar_door_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_bar_door" );
    cmn.CallEventHandler( "clk_bar_door_end" );

    common_impl.ShowBbt( "bbt_courtyard_clk_bar_door_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_guillotine1", 0, "", 0 );
  AnimPlay( "anm_courtyard_guillotine", "guillotine", func_end );

end;

--------------------------------------------------------------------------------------------

function private.clk_button ()

  cmn.CallEventHandler( "clk_button_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_button" );
    cmn.CallEventHandler( "clk_button_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_button_courtyard", 0, "", 0 );

  ObjAnimate( "spr_fountain_button_off", "alp",0,0, "", { 0, 2, 1,    0.6, 2, 0 } );
  ObjSet( "spr_fountain_button_on", { alp = 0, visible = true } );
  ObjAnimate( "spr_fountain_button_on", "alp",0,0, "", { 0, 1, 0,    0.6, 1, 1 } );

  ObjAnimate( "spr_fountain_door_close", "alp",0,0, "", { 0, 2, 1,    0.6, 2, 1,    1.2, 2, 0 } );
  ObjSet( "obj_fountain_open", { alp = 0, visible = true } );
  ObjAnimate( "obj_fountain_open", "alp",0,0, func_end, { 0, 1, 0,    0.6, 1, 0,    1.2, 1, 1 } );

end;

--------------------------------------------------------------------------------------------

function private.clk_loungekey_1 ()

  cmn.CallEventHandler( "clk_loungekey_1_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_loungekey_1" );
    cmn.CallEventHandler( "clk_loungekey_1_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_key_courtyard", 0, "", 0 );

  ObjAnimate( "spr_thicket_key_1", "alp",0,0, "", { 0, 2, 1,    0.6, 2, 0 } );
  ObjSet( "spr_thicket_key_2", { alp = 0, visible = true } );
  ObjAnimate( "spr_thicket_key_2", "alp",0,0, func_end, { 0, 1, 0,    0.6, 1, 1 } );

end;

--------------------------------------------------------------------------------------------

function private.clk_loungekey_2 ()

  cmn.CallEventHandler( "clk_loungekey_2_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_loungekey_2" );
    cmn.CallEventHandler( "clk_loungekey_2_end" );
    common.CloseSubRoom();

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_door_courtyard", 0, "", 0 );

  ObjAnimate( "spr_thicket_key_2", "alp",0,0, "", { 0, 2, 1,    0.6, 2, 0 } );
  ObjSet( "spr_thicket_door_open", { alp = 0, visible = true } );
  ObjAnimate( "spr_thicket_door_open", "alp",0,0, func_end, { 0, 0, 0,    0.6, 0, 1 } );

end;


--------------------------------------------------------------------------------------------

function private.clk_floormechanism_folder ()

  cmn.CallEventHandler( "clk_floormechanism_folder_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_floormechanism_folder" );
    cmn.CallEventHandler( "clk_floormechanism_folder_end" );

  end;

  cmn.Lock( true );

  cmn.NoteScale( "spr_floormechanism_folder_closed",  "spr_floormechanism_folder_big" );

  func_end();

end;

--------------------------------------------------------------------------------------------

function private.clk_floormechanism_antirust_1 ()

  cmn.CallEventHandler( "clk_floormechanism_antirust_1_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_floormechanism_antirust_1" );
    cmn.CallEventHandler( "clk_floormechanism_antirust_1_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_courtyard_clk_valve1", 0, "", 0 );


  local time = 0.6;

  ObjAnimate( "spr_floormechanism_valve_norust_light", "alp",0,0, "", { 0, 1, 1,    0.4, 1, 0 } );
  ObjAnimate( "spr_floormechanism_valve_norust_2", "alp",0,0, "", { 0, 0, 0,    time, 0, 1,    2*time, 0, 0,    3*time, 0, 1 } );
  ObjAnimate( "spr_floormechanism_can", "pos_xy",0,0, func_end, { 0, 3, 0, -6,    3*time, 3, 0, -6,    3*time+1.2, 3, 639, -388 } );

end;

--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG CHEMICALSSHELF *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.InitChemicalsshelfStart ()

    ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state = {};

    ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_knife_funnel1 = false; -- применение ножа на воронку из бутылки
    ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_knife_plasticpipes = false; -- применение ножа на резиновую трубку
    ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_knife_3 = false;

    ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_skotch_antirustrecipe_1 = false; -- применение скотча на треснутую бутылки
    ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_skotch_antirustrecipe_2 = false; -- применение скотча на бутылку когда на неё вставлен распылитель

    ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_antirustcrack_antirustrecipe = false; 

    ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_bottle_1 = false; -- применение красной бутылки
    ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_bottle_2 = false; -- применение зелёной бутылки


    ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.clk_bottle1 = false; -- открыть крышку у красной бутылке
    ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.clk_cover2 = false; -- 

    ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_antirustcrack_plasticpipes = false; -- применение распылителя с резиновой трубкой на бутылки 
    ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_funnel1_bottle = false; -- применение воронки на бутылку

    ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.progress = { false, false, false, false, false, false }; 

    cmn.MiniGameShow( "chemicalsshelf" );
    common_impl.PassingMgStart( "chemicalsshelf" );

  end;
  --*******************************************************************************************************************
  function private.InitChemicalsshelf ()

    private.win_chemicalsshelf_state = {};    
    ObjMultiSet( {  
      { "spr_chemicalsshelf_scotch1", 
        { 
          event_mdown    = function () private.ClkSkotchForDrug();  end,
          event_menter   = function () SetCursor( CURSOR_GET );  end,
          event_mleave   = function () SetCursor( CURSOR_DEFAULT ); end,
          event_dragdrop = function () private.SkotchDrop(); end
        } },
      { "spr_chemicalsshelf_knife", 
        { 
          event_mdown    = function () private.ClkKnifeForDrug();  end,
          event_menter   = function () SetCursor( CURSOR_GET );  end,
          event_mleave   = function () SetCursor( CURSOR_DEFAULT ); end,
          event_dragdrop = function () private.KnifeDrop(); end
        } },
      { "spr_chemicalsshelf_funnel1", 
        { 
          event_mdown    = function () private.ClkFunnel1ForDrug();  end,
          event_menter   = function () SetCursor( CURSOR_GET );  end,
          event_mleave   = function () SetCursor( CURSOR_DEFAULT ); end,
          event_dragdrop = function () private.Funnel1Drop(); end
        } },
      { "spr_chemicalsshelf_bottle1", 
        { 
          event_mdown    = function () private.ClkBottle1ForDrug();  end,
          event_menter   = function () SetCursor( CURSOR_GET );  end,
          event_mleave   = function () SetCursor( CURSOR_DEFAULT ); end,
          event_dragdrop = function () private.Bottle1Drop(); end
        } },
      { "spr_chemicalsshelf_bottle2", 
        { 
          event_mdown    = function () private.ClkBottle2ForDrug();  end,
          event_menter   = function () SetCursor( CURSOR_GET );  end,
          event_mleave   = function () SetCursor( CURSOR_DEFAULT ); end,
          event_dragdrop = function () private.Bottle2Drop(); end
        } },
      { "obj_chemicalsshelf_plasticpipes", 
        { 
          event_mdown    = function () private.ClkPlasticpipesForDrug();  end,
          event_menter   = function () SetCursor( CURSOR_GET );  end,
          event_mleave   = function () SetCursor( CURSOR_DEFAULT ); end,
          event_dragdrop = function () private.PlasticpipesDrop(); end
        } },

      { "obj_chemicalsshelf_clk_bottle1", 
        { 
          event_mdown    = function () private.ClkBottle1();  end,
          event_menter   = function () SetCursor( CURSOR_HAND );  end,
          event_mleave   = function () SetCursor( CURSOR_DEFAULT ); end,
        } },

      { "obj_chemicalsshelf_clk_cover2", 
        { 
          event_mdown    = function () private.ClkCover2();  end,
          event_menter   = function () SetCursor( CURSOR_HAND );  end,
          event_mleave   = function () SetCursor( CURSOR_DEFAULT ); end,
        } },
      { "obj_chemicalsshelf_use_knife_plasticpipes", 
        { 
          event_mdown    = function () private.UseKnifePlasticpipes (); end,
          event_menter   = function () SetCursor( CURSOR_USE );  end,
          event_mleave   = function () SetCursor( CURSOR_DEFAULT ); end,
        } },
      { "obj_chemicalsshelf_use_knife_funnel1", 
        { 
          event_mdown    = function () common_impl.ShowBbt( "bbt_chemicalsshelf_use_knife_funnel1" ); end,
          event_menter   = function () SetCursor( CURSOR_USE );  end,
          event_mleave   = function () SetCursor( CURSOR_DEFAULT ); end,
        } },
      { "obj_chemicalsshelf_use_antirustcrack", 
        { 
          event_mdown    = function () private.AntirustcrackBbtShow(); end,
          event_menter   = function () SetCursor( CURSOR_USE );  end,
          event_mleave   = function () SetCursor( CURSOR_DEFAULT ); end,
        } },

    } ); 

    --{ "obj_chemicalsshelf_use_antirustcrack", 
    --  { 
    --    event_mdown    = function () common_impl.ShowBbt( "bbt_bchemicalsshelf_use_antirustcrack" ); end,
    --    event_menter   = function () SetCursor( CURSOR_HAND );  end,
    --    event_mleave   = function () SetCursor( CURSOR_DEFAULT ); end,
    --  } },
  end;
  --*******************************************************************************************************************
  function private.WinChemicalsshelf ()

    cmn.Lock( false );
    cmn.MiniGameHide( "chemicalsshelf" );
    common_impl.PassingMgWin( "chemicalsshelf" );  

    cmn.SetEventDone( "win_chemicalsshelf" );
    cmn.CallEventHandler( "win_chemicalsshelf" );

  end;
  --*******************************************************************************************************************
  function private.ClkSkotchForDrug ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_in_hand_sfx", 0, "", 0 );

    ObjSet( "spr_chemicalsshelf_scotch1", { pos_z = 20 } );
    ObjSet( "spr_chemicalsshelf_scotch1shadow", {  alp = 0 } );

  end;
  --*******************************************************************************************************************
  function private.SkotchDrop ()

    local item = "spr_chemicalsshelf_scotch1";

    if ( cmn.ApplyObj( item, "obj_chemicalsshelf_use_antirustcrack" ) and not ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_skotch_antirustrecipe_1 ) then

      local func_end = function ()

        cmn.Lock( false ); 
        ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_skotch_antirustrecipe_1 = true;
        ObjSet( "spr_chemicalsshelf_antirustscotch1", { alp = 1 } );
        ObjSet( "spr_chemicalsshelf_scotch1", { input = true } );
        private.SkotchCheck();  

        ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.progress[ 1 ] = true;

      end;

      cmn.Lock( true );

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_scotch1", 0, "", 0 );

      ObjSet( "spr_chemicalsshelf_scotch1", { input = false, alp = 0 } );
      ObjSet( "spr_chemicalsshelf_scotch1shadow", { alp = 0 } );
      ObjSet( "anm_chemicalsshelf_knife_scotch_antirustscotch1", { alp = 1 } );

      AnimPlay( "anm_chemicalsshelf_knife_scotch_antirustscotch1", "antirustscotch1", "" );

      ObjAnimate( "anm_chemicalsshelf_knife_scotch_antirustscotch1", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "anm_chemicalsshelf_knife_scotch_antirustscotch1" ).alp, 
        2.6, 0, ObjGet( "anm_chemicalsshelf_knife_scotch_antirustscotch1" ).alp, 
        2.8, 0, 0.0
      } );
      ObjAnimate( "spr_chemicalsshelf_antirustscotch1", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_chemicalsshelf_antirustscotch1" ).alp, 
        2.6, 0, ObjGet( "spr_chemicalsshelf_antirustscotch1" ).alp, 
        2.8, 0, 1.0
      } );
      ObjAnimate( "spr_chemicalsshelf_scotch1", "alp", 0, 0, func_end,
      { 
        0.0, 0, ObjGet( "spr_chemicalsshelf_scotch1" ).alp, 
        2.6, 0, ObjGet( "spr_chemicalsshelf_scotch1" ).alp, 
        2.8, 0, 1.0
      } );
      ObjAnimate( "spr_chemicalsshelf_scotch1shadow", "alp", 0, 0, func_end,
      { 
        0.0, 0, ObjGet( "spr_chemicalsshelf_scotch1shadow" ).alp, 
        2.6, 0, ObjGet( "spr_chemicalsshelf_scotch1shadow" ).alp, 
        2.8, 0, 1.0
      } );

    elseif ( cmn.ApplyObj( item, "obj_chemicalsshelf_use_antirustcrack" ) and 
      ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_antirustcrack_plasticpipes ) then

      local func_end = function ()

        cmn.Lock( false );  
        ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_skotch_antirustrecipe_2 = true;
        ObjSet( "spr_chemicalsshelf_antirustscotch2", { alp = 1 } );
        private.WinChemicalsshelf();
        private.SkotchCheck(); 

      end;

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_scotch2", 0, "", 0 );

      ObjSet( "spr_chemicalsshelf_scotch1", { input = false, alp = 0 } );
      ObjSet( "spr_chemicalsshelf_scotch1shadow", { alp = 0 } );

      cmn.Lock( true );

      ObjSet( "spr_chemicalsshelf_scotch1", { input = false, alp = 0 } );
      ObjSet( "anm_chemicalsshelf_knife_scotch_antirustscotch2", { alp = 1 } );

      AnimPlay( "anm_chemicalsshelf_knife_scotch_antirustscotch2", "antirustscotch2", func_end );
    
    else 

      common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );
      common_impl.ShowBbt( "bbt_chemicalsshelf_wrong_apply" );

      ObjSet( "spr_chemicalsshelf_scotch1", { pos_z = -1 } );
      ObjSet( "spr_chemicalsshelf_scotch1shadow", {  alp = 1 } );

    end;

  end;
  --*******************************************************************************************************************
  function private.SkotchCheck ()

    if ( ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_skotch_antirustrecipe_1 == true and
      ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_skotch_antirustrecipe_2 == true ) then

      ObjSet( "spr_chemicalsshelf_scotch1", { input = false, alp = 0 } );
      ObjSet( "spr_chemicalsshelf_scotch1shadow", { alp = 0 } );

    end;

  end;
  --*******************************************************************************************************************
  function private.ClkKnifeForDrug ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_in_hand_sfx", 0, "", 0 );

    ObjSet( "spr_chemicalsshelf_knife", { pos_z = 20 } );
    ObjSet( "spr_chemicalsshelf_knifeshadow", {  alp = 0 } );

  end;
  --*******************************************************************************************************************
  function private.KnifeDrop ()

    local item = "spr_chemicalsshelf_knife";

    if ( cmn.ApplyObj( item, "obj_chemicalsshelf_use_knife_funnel1" ) and not ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_knife_funnel1 ) then

      local func_end = function ()

        cmn.Lock( false );

        ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_knife_funnel1 = true;        
        
        ObjSet( "spr_chemicalsshelf_funnel1", { input = true, alp = 1, pos_x = -220.122, pos_y = 114.538, ang = 0.1047 } );
        ObjSet( "spr_chemicalsshelf_funnel1shadow", { alp = 1, pos_x = -229.122, pos_y = 133.538, ang = 0.1047 } );
        ObjSet( "obj_chemicalsshelf_use_knife_funnel1", { input = false } );

        private.KnifeCheck(); 

      end;

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_knife1", 0, "", 0 );

      cmn.Lock( true );
      
      ObjSet( "spr_chemicalsshelf_knife", { alp = 0 } );
      ObjSet( "spr_chemicalsshelf_knifeshadow", { alp = 0 } );
      ObjSet( "anm_chemicalsshelf_knife_scotch_funnel", { alp = 1 } );
      ObjSet( "spr_chemicalsshelf_funnel1", { alp = 0, pos_x = -220.122, pos_y = 114.538, ang = 0.1047 } );
      ObjSet( "spr_chemicalsshelf_funnel1shadow", { alp = 0, pos_x = -229.122, pos_y = 133.538, ang = 0.1047 } );

      AnimPlay( "anm_chemicalsshelf_knife_scotch_funnel", "funnel", "" );

      ObjAnimate( "anm_chemicalsshelf_knife_scotch_funnel", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "anm_chemicalsshelf_knife_scotch_funnel" ).alp, 
        1.7, 0, ObjGet( "anm_chemicalsshelf_knife_scotch_funnel" ).alp, 
        1.8, 0, 0
      } );
      ObjAnimate( "spr_chemicalsshelf_funnel1", "alp", 0, 0, func_end,
      { 
        0.0, 0, ObjGet( "spr_chemicalsshelf_funnel1" ).alp,
        1.6, 0, ObjGet( "spr_chemicalsshelf_funnel1" ).alp,
        1.8, 0, 1
      } );
      ObjAnimate( "spr_chemicalsshelf_funnel1shadow", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_chemicalsshelf_funnel1shadow" ).alp,
        1.6, 0, ObjGet( "spr_chemicalsshelf_funnel1shadow" ).alp,
        1.8, 0, 1
      } );

      if not( ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_knife_plasticpipes ) then

        ObjAnimate( "spr_chemicalsshelf_knife", "alp", 0, 0, "",
        { 
          0.0, 0, ObjGet( "spr_chemicalsshelf_knife" ).alp,
          1.7, 0, ObjGet( "spr_chemicalsshelf_knife" ).alp,
          1.8, 0, 1
        } );
        ObjAnimate( "spr_chemicalsshelf_knifeshadow", "alp", 0, 0, "",
        { 
          0.0, 0, ObjGet( "spr_chemicalsshelf_knifeshadow" ).alp,
          1.7, 0, ObjGet( "spr_chemicalsshelf_knifeshadow" ).alp,
          1.8, 0, 1
        } );

      end;

    elseif ( cmn.ApplyObj( item, "obj_chemicalsshelf_use_knife_plasticpipes" ) and not ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_knife_plasticpipes ) then

      local func_end = function ()

        cmn.Lock( false );
        ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_knife_plasticpipes = true;
        ObjSet( "spr_chemicalsshelf_plasticpipes", { alp = 1 } );
        ObjSet( "anm_chemicalsshelf_knife_scotch_plasticpipes", { alp = 0 } );    
        ObjSet( "spr_chemicalsshelf_plasticpipes_1", { alp = 0 } );      
        ObjSet( "obj_chemicalsshelf_use_knife_plasticpipes", { input = false } );    

        private.PlasticpipesCheck(); 
        private.KnifeCheck(); 

      end;

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_knife1", 0, "", 0 );

      cmn.Lock( true );

      ObjSet( "spr_chemicalsshelf_knife", { alp = 0 } );
      ObjSet( "spr_chemicalsshelf_knifeshadow", { alp = 0 } );  
      ObjSet( "anm_chemicalsshelf_knife_scotch_plasticpipes", { alp = 1 } );    
      ObjSet( "spr_chemicalsshelf_plasticpipes_1", { alp = 0 } );        

      AnimPlay( "anm_chemicalsshelf_knife_scotch_plasticpipes", "plasticpipes", "" );

      ObjAnimate( "anm_chemicalsshelf_knife_scotch_plasticpipes", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "anm_chemicalsshelf_knife_scotch_plasticpipes" ).alp, 
        1.9, 0, ObjGet( "anm_chemicalsshelf_knife_scotch_plasticpipes" ).alp, 
        2.1, 0, 0
      } );
      ObjAnimate( "spr_chemicalsshelf_plasticpipes", "alp", 0, 0, func_end,
      { 
        0.0, 0, ObjGet( "spr_chemicalsshelf_plasticpipes" ).alp, 
        1.9, 0, ObjGet( "spr_chemicalsshelf_plasticpipes" ).alp, 
        2.1, 0, 1
      } );

      if not ( ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_knife_funnel1 ) then

        ObjAnimate( "spr_chemicalsshelf_knife", "alp", 0, 0, "",
        { 
          0.0, 0, ObjGet( "spr_chemicalsshelf_knife" ).alp, 
          1.9, 0, ObjGet( "spr_chemicalsshelf_knife" ).alp, 
          2.1, 0, 1
        } );
        ObjAnimate( "spr_chemicalsshelf_knifeshadow", "alp", 0, 0, "",
        { 
          0.0, 0, ObjGet( "spr_chemicalsshelf_knifeshadow" ).alp, 
          1.9, 0, ObjGet( "spr_chemicalsshelf_knifeshadow" ).alp, 
          2.1, 0, 1
        } );

      end;

    else 

      common_impl.ShowBbt( "bbt_chemicalsshelf_wrong_apply" );
      ObjSet( "spr_chemicalsshelf_knife", { pos_z = 8 } );
      ObjSet( "spr_chemicalsshelf_knifeshadow", {  alp = 1 } );
      common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

    end;

  end;
  --*******************************************************************************************************************
  function private.KnifeCheck ()    

    if ( ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_knife_funnel1 == true and
      ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_knife_plasticpipes == true ) then

      ObjSet( "spr_chemicalsshelf_knife", { input = false, alp = 0 } );
      ObjSet( "spr_chemicalsshelf_knifeshadow", { alp = 0 } );

    else 

      ObjSet( "spr_chemicalsshelf_knife", { pos_z = 8 } );
      ObjSet( "spr_chemicalsshelf_knifeshadow", {  alp = 1 } );

    end;
  
  end;
  --*******************************************************************************************************************
  function private.ClkFunnel1ForDrug ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_in_hand_sfx", 0, "", 0 );

    ObjSet( "spr_chemicalsshelf_funnel1", { pos_z = 20 } );
    ObjSet( "spr_chemicalsshelf_funnel1shadow", {  alp = 0 } );

  end;
  --*******************************************************************************************************************
  function private.Funnel1Drop ()

    local item = "spr_chemicalsshelf_funnel1";
    if ( cmn.ApplyObj( item, "obj_chemicalsshelf_use_antirustcrack" ) ) then

      local func_end = function ()

        cmn.Lock( false );    
        ObjSet( "spr_chemicalsshelf_funnel1", { input = false, alp = 0 } );
        ObjSet( "spr_chemicalsshelf_funnel1shadow", {  alp = 0 } );    
        ObjSet( "spr_chemicalsshelf_funnel2", { alp = 1 } );     
        ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_funnel1_bottle = true; 

        ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.progress[ 2 ] = true;

      end;

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_funnel", 0, "", 0 );

      cmn.Lock( true );
      common_impl.ItemFly( "spr_chemicalsshelf_funnel2", func_end, 0, 50 );

      ObjSet( "spr_chemicalsshelf_funnel1", { input = false, alp = 0 } );
      ObjSet( "spr_chemicalsshelf_funnel1shadow", {  alp = 0 } );

    else

      common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );
      common_impl.ShowBbt( "bbt_chemicalsshelf_wrong_apply" );
      ObjSet( "spr_chemicalsshelf_funnel1", { pos_z = 0 } );
      ObjSet( "spr_chemicalsshelf_funnel1shadow", {  alp = 1 } );

    end;

  end;
  --*******************************************************************************************************************
  function private.BottleCheck ()

    if (  ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_bottle_1 and 
        ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_bottle_2 ) then 

      local func_end = function ()

        cmn.Lock( false );
        ObjSet( "spr_chemicalsshelf_funnel2", { alp = 0 } );

      end;

      cmn.Lock( true );
      ObjAnimate( "spr_chemicalsshelf_funnel2", "alp", 0, 0, func_end,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );

    end;

  end;
  --*******************************************************************************************************************
  function private.ClkBottle1ForDrug ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_in_hand_sfx", 0, "", 0 );

    ObjSet( "spr_chemicalsshelf_bottle1", { pos_z = 20 } );
    ObjSet( "spr_chemicalsshelf_bottle1shadow", {  alp = 0 } );

  end;
  --*******************************************************************************************************************
  function private.Bottle1Drop ()

    local item = "spr_chemicalsshelf_bottle1";
    if ( cmn.ApplyObj( item, "obj_chemicalsshelf_use_antirustcrack" ) and ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_funnel1_bottle and 
        ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_skotch_antirustrecipe_1 ) then

      local func_end = function ()

        ObjSet( "vid_chemicalsshelf_water_red", { alp = 0 } );
        ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_bottle_1 = true;
        private.BottleCheck();

        ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.progress[ 4 ] = true; 
        cmn.Lock( false );

      end;

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_bottle_solution", 0, "", 0 );

      cmn.Lock( true );
      ObjAnimate( "vid_chemicalsshelf_water_red", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

      VidPlay( "vid_chemicalsshelf_water_red", func_end );

      ObjSet( "spr_chemicalsshelf_bottle1", { input = false, alp = 0 } );
      ObjSet( "spr_chemicalsshelf_bottle1shadow", {  alp = 0 } );

    else

      common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );
      common_impl.ShowBbt( "bbt_chemicalsshelf_wrong_apply" );
      ObjSet( "spr_chemicalsshelf_bottle1", { pos_z = -1 } );
      ObjSet( "spr_chemicalsshelf_bottle1shadow", {  alp = 1 } );

    end;

  end;
  --*******************************************************************************************************************
  function private.ClkBottle2ForDrug ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_in_hand_sfx", 0, "", 0 );

    ObjSet( "spr_chemicalsshelf_bottle2", { pos_z = 20 } );
    ObjSet( "spr_chemicalsshelf_bottle2shadow", {  alp = 0 } );

  end;
  --*******************************************************************************************************************
  function private.Bottle2Drop ()

    local item = "spr_chemicalsshelf_bottle2";
    if ( cmn.ApplyObj( item, "obj_chemicalsshelf_use_antirustcrack" ) and ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_funnel1_bottle and 
        ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_skotch_antirustrecipe_1 ) then

      local func_end = function ()

        ObjSet( "vid_chemicalsshelf_water_green", { alp = 0 } );
        ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_bottle_2 = true;
        private.BottleCheck(); 

        ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.progress[ 3 ] = true;       

        cmn.Lock( false );

      end;

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_bottle_solution", 0, "", 0 );

      cmn.Lock( true );
      ObjAnimate( "vid_chemicalsshelf_water_green", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.1, 0, 1.0
      } );

      VidPlay( "vid_chemicalsshelf_water_green", func_end );

      ObjSet( "spr_chemicalsshelf_bottle2", { input = false, alp = 0 } );
      ObjSet( "spr_chemicalsshelf_bottle2shadow", {  alp = 0 } );

    else

      common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );
      common_impl.ShowBbt( "bbt_chemicalsshelf_wrong_apply" );
      ObjSet( "spr_chemicalsshelf_bottle2", { pos_z = 0 } );
      ObjSet( "spr_chemicalsshelf_bottle2shadow", {  alp = 1 } );

    end;

  end;
  --*******************************************************************************************************************
--  function private.Bottle2Drop_2 ()
--
--      local func_end = function ()
--
--        ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_bottle_2 = true;
--        private.BottleCheck(); 
--
--        ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.progress[ 3 ] = true;       
--
--      end;
--
--      ObjAnimate( "vid_chemicalsshelf_water_green", "alp", 0, 0, "",
--      { 
--        0.0, 0, 1.0, 
--        0.1, 0, 0.0
--      } );
--
--  end;
  --*******************************************************************************************************************
  function private.PlasticpipesCheck ()

    if ( ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_knife_plasticpipes == true and 
      ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.clk_cover2 == true ) then

      ObjSet( "obj_chemicalsshelf_plasticpipes", { input = true } );

    end;

  end;
  --*******************************************************************************************************************
  function private.ClkPlasticpipesForDrug ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_in_hand_sfx", 0, "", 0 );

    ObjSet( "obj_chemicalsshelf_plasticpipes", { pos_z = 20, ang = -89.2398 } );
    --ObjSet( "spr_chemicalsshelf_bottle2shadow", {  alp = 0 } );

  end;
  --*******************************************************************************************************************
  function private.PlasticpipesDrop ()

    local item = "obj_chemicalsshelf_plasticpipes";
    if ( cmn.ApplyObj( item, "obj_chemicalsshelf_use_antirustcrack" ) and ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_bottle_1 and 
        ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_bottle_2 ) then

      local func_end = function ()

        cmn.Lock( false );
        ObjSet( "obj_chemicalsshelf_plasticpipes", { alp = 1 } );
        ObjSet( "obj_chemicalsshelf_plasticpipes", { input = false, pos_z = 0, ang = 0, alp = 0 } );
        ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.use_antirustcrack_plasticpipes = true;

        ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.progress[ 5 ] = true; 

      end;

      common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );

      cmn.Lock( true );
      common_impl.ItemFly( "spr_chemicalsshelf_antirustcover", func_end, nil, 0 );
      ObjSet( "obj_chemicalsshelf_plasticpipes", { input = false, pos_z = 0, ang = 0, alp = 0 } );

    else 

      common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );
      common_impl.ShowBbt( "bbt_chemicalsshelf_wrong_apply" );
      ObjSet( "obj_chemicalsshelf_plasticpipes", { pos_z = 7, ang = 0 } );
      --ObjSet( "spr_chemicalsshelf_bottle2shadow", {  alp = 1 } );

    end;

  end;
--*********************************************************************************************************************
  function private.ClkBottle1 ()

    local func_end = function ()

      cmn.Lock( false ); 
      ObjSet( "obj_chemicalsshelf_clk_bottle1", { input = false } );
      ObjSet( "spr_chemicalsshelf_bottle1", { input = true } );
      ObjSet( "spr_chemicalsshelf_bottle1cover", { alp = 0 } );
      ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.clk_bottle1 = true;

    end;

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_cover_bottle", 0, "", 0 );

    cmn.Lock( true );
    ObjAnimate( "spr_chemicalsshelf_bottle1cover", "alp", 0, 0, func_end,
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );

  end;
--*********************************************************************************************************************
  function private.ClkCover2 ()

    local func_end = function ()

      cmn.Lock( false ); 
      ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.clk_cover2 = true;

      ObjSet( "obj_chemicalsshelf_clk_cover2", { input = false } );
      ObjSet( "spr_chemicalsshelf_cover1", { alp = 0 } );
      ObjSet( "spr_chemicalsshelf_cover2", { alp = 1 } );
      private.PlasticpipesCheck();

    end;

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk6", 0, "", 0 );

    cmn.Lock( true );
    ObjAnimate( "spr_chemicalsshelf_cover1", "alp", 0, 0, func_end,
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
    ObjAnimate( "spr_chemicalsshelf_cover2", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

  end;
--*********************************************************************************************************************
  function private.AntirustcrackBbtShow ()

    for i = 1, #ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.progress do

      if not ( ng_global.progress[ "std" ][ "win_chemicalsshelf" ].state.progress[ i ] ) then

        common_impl.ShowBbt( "bbt_chemicalsshelf_use_antirustcrack_"..i );
        break;
  
      end;

    end;

  end;
--*********************************************************************************************************************
  function private.UseKnifePlasticpipes ()
 
    local func_end = function ()

      cmn.Lock( false );
      common_impl.ShowBbt( "bbt_chemicalsshelf_use_knife_plasticpipes" ); 

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk6", 0, "", 0 );
    ObjAnimate( "spr_chemicalsshelf_plasticpipes_1", "ang", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.1, 0, 0.02,
      0.3, 0, -0.02,
      0.4, 0, 0.0
    } );

  end;
--*********************************************************************************************************************
-- function *** MMG FLOORMECHANISM *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************

  private.floormechanism_state = {};
  private.floormechanism_circle = {};

  private.floormechanism_circle_win = { 59, 57, 54 };

  local FLOORMECHANISM_SLIDER_NAME = "spr_floormechanism_slider_";
  local FLOORMECHANISM_SHELL_NAME = "obj_floormechanism_shell_";
  local FLOORMECHANISM_CIRCLE_NAME = "spr_floormechanism_metalpart_";

  local FLOORMECHANISM_SLIDER_COUNT = 3;

  local FLOORMECHANISM_LEFT_BORDER = -107;
  local FLOORMECHANISM_RIGHT_BORDER = -8;

  local FLOORMECHANISM_CIRCLE_DELTA = 0.4;
  local FLOORMECHANISM_CIRCLE_LEFT_BORDER = 26;
  local FLOORMECHANISM_CIRCLE_RIGHT_BORDER = 92;

  local FLOORMECHANISM_WIN_DELTA = 5;

  --*******************************************************************************************************************
  function private.FloormechanismDefault ()

    private.floormechanism_state = { -30, -90, -40 };
    private.floormechanism_circle = { 90, 30, 60 };

  end; 

  --*******************************************************************************************************************
  function private.FloormechanismLoad ()

    private.floormechanism_state = ng_global.progress[ "std" ][ "win_floormechanism" ].state;
    private.floormechanism_circle = ng_global.progress[ "std" ][ "win_floormechanism" ].circle;

    if ( not private.floormechanism_state ) or ( not private.floormechanism_circle ) then
      private.FloormechanismDefault();
    end; 

  end;

  --*******************************************************************************************************************
  function private.FloormechanismSave ()

    ng_global.progress[ "std" ][ "win_floormechanism" ].state = private.floormechanism_state;
    ng_global.progress[ "std" ][ "win_floormechanism" ].circle = private.floormechanism_circle;

  end;

  --*******************************************************************************************************************
  function private.FloormechanismInit ()

    for i = 1, FLOORMECHANISM_SLIDER_COUNT, 1 do

      local currentShell = FLOORMECHANISM_SHELL_NAME..i;
      ObjSet( currentShell, { 
                                input = 1,
                                drag = 1,
                                event_startdrag = function () private.FloormechanismStartDrag(); end,
                                event_drag = function () private.FloormechanismDrag( i ); end,
                                event_dragdrop = function () private.FloormechanismEndDrag(); end,
                                event_menter = function () private.FloormechanismEnter(); end,
                                event_mleave = function () private.FloormechanismLeave(); end
                             } );

    end;

  end;

  --*******************************************************************************************************************
  function private.FloormechanismEnter ()
   
    SetCursor( CURSOR_HAND );

  end;

  --*******************************************************************************************************************
  function private.FloormechanismLeave ()
   
    SetCursor( CURSOR_DEFAULT );

  end;

  --*******************************************************************************************************************
  function private.FloormechanismMoveOtherSlider ( id, delta )

    local currentSlider = FLOORMECHANISM_SLIDER_NAME..id;
    local currentCircle = FLOORMECHANISM_CIRCLE_NAME..id;

    local lastPosX = private.floormechanism_state[id];
    local newPosX = lastPosX + delta;

    if newPosX >= FLOORMECHANISM_LEFT_BORDER and 
    newPosX <= FLOORMECHANISM_RIGHT_BORDER then 

      ObjSet( currentSlider, { pos_x = newPosX } ); 

      local circleLastPosX = private.floormechanism_circle[id];
      local circlePosX = circleLastPosX + delta*FLOORMECHANISM_CIRCLE_DELTA;

      if FLOORMECHANISM_CIRCLE_LEFT_BORDER <= circlePosX and 
      FLOORMECHANISM_CIRCLE_RIGHT_BORDER >= circlePosX then
        ObjSet( currentCircle, { pos_x = circlePosX } );
      end;

    end; 

  end; 


  --*******************************************************************************************************************
  function private.FloormechanismStartDrag ()
  
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_well_clk1", 0, "", 0 );

  end;


  --*******************************************************************************************************************
  function private.FloormechanismDrag ( id )
  
    local cursorPos = GetZoomCursorPos();
    local cursorPosX = cursorPos[1] - 512;
    local currentSlider = FLOORMECHANISM_SLIDER_NAME..id;
    local currentCircle = FLOORMECHANISM_CIRCLE_NAME..id;

    local lastPosX = private.floormechanism_state[id];
    local circleDelta = math.abs( lastPosX - cursorPosX );
    local circleLastPosX = private.floormechanism_circle[id];
    local deltaForOther = circleDelta;

    if cursorPosX >= FLOORMECHANISM_LEFT_BORDER and 
    cursorPosX <= FLOORMECHANISM_RIGHT_BORDER then 

      ObjSet( currentSlider, { pos_x = cursorPosX } ); 

      -- left mooving 
      if lastPosX >= cursorPosX then 

        local circlePosX = circleLastPosX - FLOORMECHANISM_CIRCLE_DELTA*circleDelta;
        if FLOORMECHANISM_CIRCLE_LEFT_BORDER <= circlePosX then 
          ObjSet( currentCircle, { pos_x = circlePosX } );
        end;

      -- right mooving 
      else

        deltaForOther = -deltaForOther;
        local circlePosX = circleLastPosX + FLOORMECHANISM_CIRCLE_DELTA*circleDelta;

        if FLOORMECHANISM_CIRCLE_RIGHT_BORDER >= circlePosX then 

          ObjSet( currentCircle, { pos_x = circlePosX } );
        end;

      end;

      ------------------------------
      ------------------------------

      if id == 1 then 

        private.FloormechanismMoveOtherSlider( 3, deltaForOther );

      elseif id == 2 then 

        private.FloormechanismMoveOtherSlider( 1, deltaForOther );
        private.FloormechanismMoveOtherSlider( 3, deltaForOther );

      else 

        private.FloormechanismMoveOtherSlider( 1, deltaForOther );

      end; 

    end;

  end;

  --*******************************************************************************************************************
  function private.FloormechanismEndDrag ()

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_well_clk2", 0, "", 0 );

    for i = 1, FLOORMECHANISM_SLIDER_COUNT, 1 do

      local currentSlider = FLOORMECHANISM_SLIDER_NAME..i;
      local lastPosX = ObjGet( currentSlider ).pos_x;
      private.floormechanism_state[i] = lastPosX;

      local currentCircle = FLOORMECHANISM_CIRCLE_NAME..i;
      local circleLastPosX = ObjGet( currentCircle ).pos_x;
      private.floormechanism_circle[i] = circleLastPosX;

    end; 

    private.FloormechanismSave();
    private.FloormechanismUpdate();

  end;

  --*******************************************************************************************************************
  function private.FloormechanismCheckWin ()

    local count = 0;
    local result = false;

    for i = 1, FLOORMECHANISM_SLIDER_COUNT, 1 do

      local circlePosX = private.floormechanism_circle[i];
      if math.abs( circlePosX - private.floormechanism_circle_win[i] ) <= FLOORMECHANISM_WIN_DELTA then 
        common_impl.PlayAudio( "sfx", "level1/sfx/aud_well_clk3", 0, "", 0 );
        count = count + 1;
      end;

    end;

    if count == FLOORMECHANISM_SLIDER_COUNT then
      result = true;
    end;

    return result;

  end;

  --*******************************************************************************************************************
  function private.FloormechanismWin ()

    ObjSet( "obj_floormechanism_mmg", { input = false } );
    cmn.Lock( true );
    cmn.MiniGameHide( "floormechanism" );

    local func_end = function ()

      cmn.Lock( false );   
      cmn.SetEventDone( "win_floormechanism" );
      cmn.CallEventHandler( "win_floormechanism" );
      common_impl.PassingMgWin( "floormechanism" ); 
 
      common.CloseSubRoom();
      private.FlashbackCourtyard(); 

    end;

    local func_end_2 = function ()

      cmn.Lock( true ); 

    end; 

    ObjAnimate( "spr_floormechanism_metalpart_active_1", "scale_x",0,0, func_end_2, { 0, 0, 1,    0.5, 0, 1 } );

    ObjAnimate( "spr_floormechanism_metalpart_active_1", "alp",0,0, "", { 0, 0, 0,    0.4, 0, 1,    0.7, 0, 0,    1.6, 0, 1,    1.8, 0, 1 } );
    ObjAnimate( "spr_floormechanism_metalpart_active_2", "alp",0,0, "", { 0, 0, 0,    0.4, 0, 1,    0.7, 0, 0,    1.6, 0, 1,    1.8, 0, 1 } );
    ObjAnimate( "spr_floormechanism_metalpart_active_3", "alp",0,0, func_end, { 0, 0, 0,    0.4, 0, 1,    0.7, 0, 0,    1.6, 0, 1,    1.8, 0, 1 } );

  end;

 --*******************************************************************************************************************
  function private.FloormechanismUpdate ()

    for i = 1, FLOORMECHANISM_SLIDER_COUNT, 1 do

      local currentPosX = private.floormechanism_state[i];
      local currentCirclePosX = private.floormechanism_circle[i];

      local currentSlider = FLOORMECHANISM_SLIDER_NAME..i;
      ObjSet( currentSlider, { pos_x = currentPosX } );

      local currentShell = FLOORMECHANISM_SHELL_NAME..i;
      ObjSet( currentShell, { pos_x = currentPosX } );

      local currentCircle = FLOORMECHANISM_CIRCLE_NAME..i;
      ObjSet( currentCircle, { pos_x = currentCirclePosX } );

    end;

    if private.FloormechanismCheckWin() then 
      private.FloormechanismWin();
    end;

  end;

--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_courtyard()

  if not ( cmn.IsEventDone( "opn_courtyard" ) ) then

    cmn.SetEventDone( "opn_courtyard" );

    common_impl.ShowBbt( "bbt_courtyard_opn_courtyard" );

    interface.KeyTaskAdd( "go_to_bar" );
    


  end;

      if (iOS_IsBought() == 0) then

      iOS_LogEvents(1);
      common.LevelSwitch("menu","unlock");
      
    end;
    
  cmn.CallEventHandler( "opn_courtyard" ); 

end;
--*********************************************************************************************************************
function private.CourtyardScare_1 ()


  cmn.StopMusEnv();

  cmn.Lock( true );
  AnimPlay( "anm_courtyard_tv", "tv", private.CourtyardScare_1_End );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_tv_scare_courtyard", 0, "", 0 );

end;
--*********************************************************************************************************************
function private.CourtyardScare_1_End ()

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "see_courtyard_scare_1" );
    cmn.CallEventHandler( "see_courtyard_scare_1" );

    common_impl.ShowBbt( "bbt_courtyard_see_courtyard_scare_1" );

    cmn.PlayMusDanger();
    cmn.PlayMusEnv();

  end;

  cmn.Lock( true );
  ObjAnimate( "obj_courtyard_tv", "alp", 0, 0, "",
  { 
    0.0, 0, 0.0, 
    0.1, 0, 1.0
  } );
  ObjAnimate( "anm_courtyard_tv", "alp", 0, 0, func_end,
  { 
    0.0, 0, 1.0, 
    0.1, 0, 0.0
  } );

end;
--*********************************************************************************************************************
function private.FlashbackCourtyard ()

  local func_after = function ()

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "see_flashback_courtyard" );
      cmn.CallEventHandler( "see_flashback_courtyard" );

      common_impl.PlayAudio(  "mus", "aud_masked_man_theme_mus", 0 );
      common_impl.ShowBbt( "bbt_courtyard_see_flashback_courtyard" );

    end;

    cmn.Lock( true );

    common_impl.StopAudio( "sfx", "level1/sfx/aud_courtyard_flashback_courtyard", 0.2 );
    common_impl.StopAudio( "voc", "level1/voc/aud_courtyard_flashback_courtyard_voc", 0.2 );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_guillotine3", 0, "", 0 );

    ObjAnimate( "spr_courtyard_coctail", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_courtyard_arrow3", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjSet( "anm_courtyard_guillotine2", { alp = 0 } );
    ObjSet( "vid_courtyard_guilotine", { alp = 1 } );
    VidPlay( "vid_courtyard_guilotine", func_end );

  end;

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_courtyard_flashback_courtyard", 0, "", 0 );
  common_impl.PlayAudio( "voc", "level1/voc/aud_courtyard_flashback_courtyard_voc", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_courtyard_flashback_courtyard", func_after );

end;
--*********************************************************************************************************************
function private.CourtyardScare_2 ()

  local func_end = function ()

    cmn.SetEventDone( "see_courtyard_scare_2" );
    cmn.CallEventHandler( "see_courtyard_scare_2" );

    common_impl.ShowBbt( "bbt_courtyard_see_courtyard_scare_2" );

    common_impl.StopAudio( "sfx", "level1/sfx/aud_terenc", 0.2 );

    cmn.PlayMusDanger();

  end;

  ObjAnimate( "spr_courtyard_hatch_after_use", "alp",0,0, "", { 0, 2, 1,    0.3, 2, 0 } );
  ObjAnimate( "spr_courtyard_h", "alp",0,0, "", { 0, 2, 1,    0.3, 2, 0 } );  
  ObjSet( "anm_courtyard_h_light", { alp = 0 } );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_terenc", 0, "", 0 );
  
  cmn.PlayDialogVideo( "vid_courtyard_terenec", func_end );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** ANIMATIONS *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_fountain_light", "alp",1,0, "", { 0,3,0.7, 1.5,3,0.1, 3,3,0.4, 5,3,1, 6,3,0.7 } );
  ObjAnimate( "spr_thicket_light", "alp",1,0, "", { 0,3,0.7, 1.5,3,0.1, 3,3,0.4, 5,3,1, 6,3,0.7 } );

  -----------------------------------------------------------------------

  ObjAnimate( "spr_courtyard_light_1", "alp", 1, 0, "",
  { 
    0.0, 0, 1, 
    4.0, 0, 0.0,
    8.0, 0, 1
  } );    

  ObjAnimate( "spr_chemicalsshelf_light_x2", "alp", 1, 0, "",
  { 
    0.0, 0, 1, 
    2.0, 0, 0.2,
    4.0, 0, 1
  } ); 

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************

function private.FountainFeedbackAnim()

  local obj = "spr_fountain_door_close";
  local x_start = ObjGet( obj ).pos_x;
  local y_start = ObjGet( obj ).pos_y;

  local time = 0.3;
  local dx = 1;
  local dy = -1;

  ObjSet( obj, { input = false } );
  local func_end = function ()
    ObjSet( obj, { input = true } );
  end;

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

  ObjAnimate( obj, "pos_x",0,0, "", { 0,0,x_start, time/4,0,x_start+dx, 3/4*time,0,x_start-dx, time,0,x_start } ); 
  ObjAnimate( obj, "pos_y",0,0, func_end, { 0,0,y_start, time/4,0,y_start+dy, 3/4*time,0,y_start-dy, time,0,y_start });  

end;

--*********************************************************************************************************************

function public.ThicketDoorClick()

  local func_end = function ()
    cmn.Lock( false );
  end;

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_door_handle", 0, "", 0 );

  cmn.Lock( true );
  ObjAnimate( "spr_thicket_door_idle", "alp",0,0, func_end, { 0, 0, 0,    0.1, 0, 1,    0.2, 0, 0 } );

end;

--*********************************************************************************************************************

function public.FloormechanismChainClick()

  local func_end = function ()

    cmn.Lock( false );

    ObjSet( "spr_floormechanism_gate_left", { alp = 1 } );
    ObjSet( "spr_floormechanism_gate_right", { alp = 1 } );
    ObjSet( "anm_floormechanism_gates_click", { alp = 0 } );
  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_gear", 0, "", 0 );

  ObjSet( "anm_floormechanism_gates_click", { alp = 1, playing = true, func = "gates" } );
  ObjAnimate( "anm_floormechanism_gates_click", "scale_x",0,0, func_end, { 0, 0, 1,    0.6, 0, 1 } );

  ObjSet( "spr_floormechanism_gate_left", { alp = 0 } );
  ObjSet( "spr_floormechanism_gate_right", { alp = 0 } );

end;

--*********************************************************************************************************************

function private.FloormechanismFeedbackAnim()

  common_impl.ShowBbt( "bbt_floormechanism_use_antirust_1" );

  local obj = "spr_floormechanism_valve_rust";
  local x_start = ObjGet( obj ).pos_x;
  local y_start = ObjGet( obj ).pos_y;

  local time = 0.3;
  local dx = 1;
  local dy = -1;

  ObjSet( "obj_floormechanism_use_antirust_1", { input = false } );

  local func_end = function ()

    ObjSet( "obj_floormechanism_use_antirust_1", { input = true } );

  end;

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_courtyard_clk_valve", 0, "", 0 );

  ObjAnimate( obj, "pos_x",0,0, "", { 0,0,x_start, time/4,0,x_start+dx, 3/4*time,0,x_start-dx, time,0,x_start } ); 
  ObjAnimate( obj, "pos_y",0,0, func_end, { 0,0,y_start, time/4,0,y_start+dy, 3/4*time,0,y_start-dy, time,0,y_start });  

end;

--*********************************************************************************************************************
function private.ClkBarDoor_2 ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( "bbt_courtyard_clk_bar_door_2" );

  end;

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_guillotine2", 0, "", 0 );

  cmn.Lock( true );
  AnimPlay( "anm_courtyard_guillotine2", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.ClkNeonBar ()
  
  local func_end = function ()

    cmn.Lock( false );

    ObjSet( "spr_courtyard_arrow1", { alp = 0 } );
    ObjSet( "spr_courtyard_arrow2", { alp = 0 } );
    ObjSet( "spr_courtyard_arrow3", { alp = 1 } );
    ObjSet( "spr_courtyard_coctail", { alp = 1 } );

  end;

  cmn.Lock( true );
  ObjSet( "spr_courtyard_arrow1", { alp = 0 } );
  ObjSet( "spr_courtyard_arrow2", { alp = 0 } );
  ObjSet( "spr_courtyard_arrow3", { alp = 0 } );
  ObjSet( "spr_courtyard_coctail", { alp = 0 } );

  ObjAnimate( "spr_courtyard_arrow1", "alp", 0, 0, "",
  { 
    0.0, 0, 0, 
    0.1, 0, 1,
    0.5, 0, 1,
    0.6, 0, 0
  } );
  ObjAnimate( "spr_courtyard_arrow2", "alp", 0, 0, "",
  { 
    0.0, 0, 0, 
    0.5, 0, 0,
    0.6, 0, 1,
    0.9, 0, 1,
    1.0, 0, 0
  } );
  ObjAnimate( "spr_courtyard_arrow3", "alp", 0, 0, "",
  { 
    0.0, 0, 0, 
    0.8, 0, 0,
    0.9, 0, 1
  } );
  ObjAnimate( "spr_courtyard_coctail", "alp", 0, 0, func_end,
  { 
    0.0, 0, 0, 
    0.7, 0, 0,
    0.7, 0, 1,
    0.9, 0, 1,
    0.9, 0, 0,
    1.1, 0, 0,
    1.1, 0, 1
  } );

end;
--*********************************************************************************************************************






