-- name=rm_hall
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_hall";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_bodyguardthings", "room_hub" );
  ObjAttach( "zz_reception", "room_hub" );
  ObjAttach( "zz_windowsill", "room_hub" );
  ObjAttach( "zz_lampwall", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
    { "spr_bodyguardthings_slider",                     { event_mdown = private.get_slider } },
    { "spr_bodyguardthings_hexagon1",                   { event_mdown = private.get_hexagon1 } },
    { "spr_bodyguardthings_waterscoop",                 { event_mdown = private.get_saucepan } },
    { "spr_bodyguardthings_chain1",                     { event_mdown = private.get_chain1 } },
    { "spr_bodyguardthings_boathookhead",               { event_mdown = private.get_boathookhead } },
    { "spr_reception_picklockclip",                     { event_mdown = private.get_picklockclip } },
    { "spr_reception_bulbbox",                          { event_mdown = private.get_bulbbox } },
    { "spr_reception_plaster",                          { event_mdown = private.get_plaster } },
    { "spr_reception_leverlamp",                        { event_mdown = private.get_leverlamp } },
    { "spr_reception_developingliquid",                 { event_mdown = private.get_developingliquid } },
    { "spr_reception_razor",                            { event_mdown = private.get_razor } },
    { "spr_windowsill_scoop",                           { event_mdown = private.get_scoop } },
    { "spr_windowsill_toolbox",                         { event_mdown = private.get_toolbox } },
    { "spr_windowsill_hexagon2",                        { event_mdown = private.get_hexagon2 } },
    { "obj_windowsill_use_picklockclip",                { event_mdown = private.ClkUsePicklockclip } },
    { "obj_windowsill_use_magnet_2",                    { event_mdown = private.ClkUseMagnet } },

    { "spr_lampwall_magnet",                            { event_mdown = private.get_magnet } },
    { "spr_lampwall_valve",                             { event_mdown = private.get_valve } },

    { "obj_hall_clk_courtyard_door",                    { event_mdown = private.clk_courtyard_door } },
    { "obj_hall_clk_courtyard_door_focus",              { event_mdown = private.clk_courtyard_door } },

    { "spr_lampwall_lionpen1",                          { event_mdown = private.get_lionpen1 } },
    { "obj_hall_see_disappearance_professor",           { event_mdown = private.DisappearanceProfessor } },
    { "obj_hall_see_masked_man_1",                      { event_mdown = private.MaskedMan_1 } },
    { "obj_hall_see_masked_man_1_focus",                { event_mdown = private.MaskedMan_1 } },

    { "obj_lampwall_use_screwdriver_1",                 { event_mdown = private.LampwallFeedbackAnim } },

    { "spr_reception_note",                             { event_mdown = private.ClkNote } },
    { "spr_reception_note_big",                         { event_mdown = private.ClkNoteBig }},
    { "obj_reception_clk_reception_slider",             { event_mdown = private.clk_reception_slider } },
    { "obj_reception_clk_reception_bell",               { event_mdown = private.clk_reception_bell } },
    { "obj_reception_clk_reception_door_1",             { event_mdown = private.clk_reception_door_1 } },
    { "obj_reception_clk_reception_door_2",             { event_mdown = private.clk_reception_door_2 } },
    { "obj_reception_use_lionpen1",                     { event_mdown = private.ClkLionpen1 } },
    { "obj_reception_use_lionpen2",                     { event_mdown = private.ClkLionpen2 } },
    { "obj_reception_use_slider",                       { event_mdown = private.ClkPurse } },
    { "obj_reception_clk_reception_paperclip_1",        { event_mdown = private.clk_reception_paperclip_1 } },
    { "obj_reception_clk_reception_paperclip_2",        { event_mdown = private.clk_reception_paperclip_2 } },
    { "obj_bodyguardthings_clk_valve",                  { event_mdown = private.clk_bodyguardthings_valve } },
    { "spr_bodyguardthings_badge",                      { event_mdown = private.BodyguardthingsFeedbackAnim } },
    { "obj_bodyguardthings_use_clippers_1",             { event_mdown = private.BodyguardthingsFeedbackAnimHook } },
    { "obj_bodyguardthings_use_magnet_1",               { event_mdown = private.BodyguardthingsFeedbackAnimHexagon } },
    { "obj_hall_clk_courtyard_door_2",                  { event_mdown = private.HallClickCourtyardDoor } },

    { "spr_collect2_item_1_4",                          { event_mdown = private.get_collect2_item_1_4 } },
    { "spr_collect2_item_1_5",                          { event_mdown = private.get_collect2_item_1_5 } },
    { "spr_hall_collect_item",                          { event_mdown = function () common_impl.GetCollectItem( "get_collect_item_1_1" ); end } },
    { "spr_hall_collect_morph_item",                    { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_1_2" ); end } },
  } );

  private.InitAnimations();
  private.InitLampWall();
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_hall = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then   
       visible_sparkle_area = false;
    end;

    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "gzz_hall_bodyguardthings",
      "gzz_hall_reception",
      "gzz_hall_windowsill",
      "gzz_hall_lampwall",
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_reception",
      "zz_windowsill",
      "zz_lampwall",
      "zz_bodyguardthings"
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_hall", update_game_mode_hall, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_hall = function ()

  local effects_table = 
  {
    "anm_hall_states_zz_lampwall_light",
    "anm_reception_lamplight",
    "anm_bodyguardthings_water",
    "anm_bodyguardthings_water_2",
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_hall", update_performance_mode_hall, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_hall () end;
  --------------------------------------------------------------------------------------------
  local opn_hall_map = function ()

    common_impl.VisitMapRoom( "hall" );

  end;
  cmn.AddSubscriber( "opn_hall", opn_hall_map );

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************  
  --------------------------------------------------------------------------------------------
  -- function get_slider () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_slider" ] = {
    type = "get",
    get_obj = "spr_bodyguardthings_slider",
    room = private.room_objname,
    zz = "zz_bodyguardthings",
    zz_gate = "gzz_hall_bodyguardthings"
  };
  
  local get_slider_inv = function ()
  
    interface.InventoryItemAdd( "inv_slider", "spr_bodyguardthings_slider" );
  
  end;
  
  local get_slider_closezz = function ()
  
    ObjDelete( "gfx_bodyguardthings_slider" );
  
  end;
  
  cmn.AddSubscriber( "get_slider", get_slider_inv );
  cmn.AddSubscriber( "get_slider", get_slider_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hexagon1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hexagon1" ] = {
    type = "get",
    get_obj = "spr_bodyguardthings_hexagon1",
    room = private.room_objname,
    zz = "zz_bodyguardthings",
    zz_gate = "gzz_hall_bodyguardthings"
  };
  
  local get_hexagon1_inv = function ()
  
    interface.InventoryItemAdd( "inv_hexagon1", "spr_bodyguardthings_hexagon1" );
    cmn.SetInvPlusRGB( "toolbox", true );

  end;
  
  local get_hexagon1_closezz = function ()
  
    ObjDelete( "gfx_bodyguardthings_hexagon1" );
  
  end;
  
  cmn.AddSubscriber( "get_hexagon1", get_hexagon1_inv );
  cmn.AddSubscriber( "get_hexagon1", get_hexagon1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_saucepan () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_saucepan" ] = {
    type = "get",
    get_obj = "spr_bodyguardthings_waterscoop",
    room = private.room_objname,
    zz = "zz_bodyguardthings",
    zz_gate = "gzz_hall_bodyguardthings"
  };
  
  local get_saucepan_inv = function ()
  
    interface.InventoryItemAdd( "inv_saucepan", "spr_bodyguardthings_waterscoop" );
    ObjSet( "inv_saucepan", { drag = false } );
  
  end;
  
  local get_saucepan_closezz = function ()
  
    ObjDelete( "spr_bodyguardthings_waterscoop_shadow" );
    ObjSet( "anm_bodyguardthings_water", { alp = 1 } ); 
    ObjDelete( "spr_hall_states_zz_bodyguardthings_saucepan" );
    ObjDelete( "gfx_bodyguardthings_waterscoop" );
  
  end;
  
  cmn.AddSubscriber( "get_saucepan", get_saucepan_inv );
  cmn.AddSubscriber( "get_saucepan", get_saucepan_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_chain1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_chain1" ] = {
    type = "get",
    get_obj = "spr_bodyguardthings_chain1",
    room = private.room_objname,
    zz = "zz_bodyguardthings",
    zz_gate = "gzz_hall_bodyguardthings"
  };
  
  local get_chain1_inv = function ()

    ObjSet( "inv_chain", { frame = ObjGet( "inv_chain" ).frame + 1 } );
    interface.InventoryItemAdd( "inv_chain", "spr_bodyguardthings_chain1" );
  
  end;
  
  local get_chain1_closezz = function ()
  
    ObjDelete( "gfx_bodyguardthings_chain1" );
    if cmn.IsEventDone( "get_boathookhead" ) then 
      ObjDelete( "gzz_hall_bodyguardthings" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_chain1", get_chain1_inv );
  cmn.AddSubscriber( "get_chain1", get_chain1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_boathookhead () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_boathookhead" ] = {
    type = "get",
    get_obj = "spr_bodyguardthings_boathookhead",
    room = private.room_objname,
    zz = "zz_bodyguardthings",
    zz_gate = "gzz_hall_bodyguardthings"
  };
  
  local get_boathookhead_inv = function ()
  
    interface.InventoryItemAdd( "inv_boathookhead", "spr_bodyguardthings_boathookhead" );
    cmn.SetInvPlusRGB( "brokenbroom", true );

  end;
  
  local get_boathookhead_closezz = function ()
  
    ObjDelete( "spr_hall_states_zz_bodyguardthings_gaff" );
    ObjDelete( "gfx_bodyguardthings_boathookhead" );
    if cmn.IsEventDone( "get_chain1" ) then 
      ObjDelete( "gzz_hall_bodyguardthings" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_boathookhead", get_boathookhead_inv );
  cmn.AddSubscriber( "get_boathookhead", get_boathookhead_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_picklockclip () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_picklockclip" ] = {
    type = "get",
    --get_obj = "spr_reception_picklockclip",
    get_obj = "obj_reception_note_hint",
    room = private.room_objname,
    zz = "zz_reception",
    zz_gate = "gzz_hall_reception"
  };
  
  local get_picklockclip_inv = function ()
  
    interface.InventoryItemAdd( "inv_picklockclip", "spr_reception_picklockclip" );
  
  end;
  
  local get_picklockclip_closezz = function ()
  
    ObjDelete( "gfx_reception_picklockclip" );
    ObjDelete( "obj_reception_note_hint" );
  
  end;
  
  cmn.AddSubscriber( "get_picklockclip", get_picklockclip_inv );
  cmn.AddSubscriber( "get_picklockclip", get_picklockclip_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bulbbox () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bulbbox" ] = {
    type = "get",
    get_obj = "spr_reception_bulbbox",
    room = private.room_objname,
    zz = "zz_reception",
    zz_gate = "gzz_hall_reception"
  };
  
  local get_bulbbox_inv = function ()
  
    interface.InventoryItemAdd( "inv_bulbbox", "spr_reception_bulbbox" );
    ObjSet( "inv_bulbbox", { drag = false } );
  
  end;
  
  local get_bulbbox_closezz = function ()
  
    ObjDelete( "gfx_reception_bulbbox" );
    ObjSet( "spr_reception_bulbbox", { croprect_init = false } );
  
  end;
  
  cmn.AddSubscriber( "get_bulbbox", get_bulbbox_inv );
  cmn.AddSubscriber( "get_bulbbox", get_bulbbox_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_plaster () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_plaster" ] = {
    type = "get",
    get_obj = "spr_reception_plaster",
    room = private.room_objname,
    zz = "zz_reception",
    zz_gate = "gzz_hall_reception"
  };
  
  local get_plaster_inv = function ()
  
    interface.InventoryItemAdd( "inv_plaster", "spr_reception_plaster" );
    cmn.SetInvPlusRGB( "saucepan", true );

  end;
  
  local get_plaster_closezz = function ()

    ObjDelete( "spr_reception_plaster_shadow" );  
    ObjDelete( "gfx_reception_plaster" );

    ObjDelete( "spr_hall_states_zz_reception_gypsum" );

  end;
  
  cmn.AddSubscriber( "get_plaster", get_plaster_inv );
  cmn.AddSubscriber( "get_plaster", get_plaster_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_leverlamp () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_leverlamp" ] = {
    type = "get",
    get_obj = "spr_reception_leverlamp",
    room = private.room_objname,
    zz = "zz_reception",
    zz_gate = "gzz_hall_reception"
  };
  
  local get_leverlamp_inv = function ()
  
    interface.InventoryItemAdd( "inv_leverlamp", "spr_reception_leverlamp" );
  
  end;
  
  local get_leverlamp_closezz = function ()
  
    ObjDelete( "gfx_reception_leverlamp" );

    ObjDelete( "spr_hall_states_zz_reception_lamp" );
  
  end;
  
  cmn.AddSubscriber( "get_leverlamp", get_leverlamp_inv );
  cmn.AddSubscriber( "get_leverlamp", get_leverlamp_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_developingliquid () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_developingliquid" ] = {
    type = "get",
    get_obj = "spr_reception_developingliquid",
    room = private.room_objname,
    zz = "zz_reception",
    zz_gate = "gzz_hall_reception"
  };
  
  local get_developingliquid_inv = function ()
  
    interface.InventoryItemAdd( "inv_developingliquid", "spr_reception_developingliquid" );
    cmn.SetInvPlusRGB( "codedpaper", true );

  end;
  
  local get_developingliquid_closezz = function ()
  
    ObjDelete( "spr_reception_developingliquid_over" );
    ObjDelete( "spr_reception_developingliquid_shadow" );
    ObjDelete( "gfx_reception_developingliquid" );

    ObjDelete( "spr_hall_states_zz_reception_developingliquid" );

  end;
  
  cmn.AddSubscriber( "get_developingliquid", get_developingliquid_inv );
  cmn.AddSubscriber( "get_developingliquid", get_developingliquid_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_razor () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_razor" ] = {
    type = "get",
    get_obj = "spr_reception_razor",
    room = private.room_objname,
    zz = "zz_reception",
    zz_gate = "gzz_hall_reception"
  };
  
  local get_razor_inv = function ()
  
    interface.InventoryItemAdd( "inv_razor", "spr_reception_razor" );
  
  end;
  
  local get_razor_closezz = function ()

    ObjDelete( "gfx_reception_razor" );
    ObjDelete( "spr_reception_razor_shadow" );

    ObjDelete( "spr_hall_states_zz_reception_razor" );

  end;
  
  cmn.AddSubscriber( "get_razor", get_razor_inv );
  cmn.AddSubscriber( "get_razor", get_razor_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_scoop () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_scoop" ] = {
    type = "get",
    get_obj = "spr_windowsill_scoop",
    room = private.room_objname,
    zz = "zz_windowsill",
    zz_gate = "gzz_hall_windowsill"
  };
  
  local get_scoop_inv = function ()
  
    interface.InventoryItemAdd( "inv_scoop", "spr_windowsill_scoop" );
  
  end;
  
  local get_scoop_closezz = function ()
  
    ObjDelete( "gfx_windowsill_scoop" );
    ObjDelete( "spr_windowsill_scoop_shadow" );
    ObjSet( "obj_windowsill_use_waterscoop", { input = true } );

    ObjDelete( "spr_hall_states_zz_windowsill_3" );

  end;
  
  cmn.AddSubscriber( "get_scoop", get_scoop_inv );
  cmn.AddSubscriber( "get_scoop", get_scoop_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_receptionbell () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_receptionbell" ] = {
    type = "get",
    get_obj = "spr_windowsill_receptionbell",
    room = private.room_objname,
    zz = "zz_windowsill",
    zz_gate = "gzz_hall_windowsill"
  };
  
  local get_receptionbell_inv = function ()
  
    interface.InventoryItemAdd( "inv_receptionbell", "spr_windowsill_receptionbell" );
  
  end;
  
  local get_receptionbell_closezz = function ()
  
    ObjDelete( "gfx_windowsill_receptionbell" );

    if ( cmn.IsEventDone( "get_hexagon2" ) and 
        cmn.IsGetCollect2( "get_collect2_item_1_4" ) ) then

      ObjDelete( "gfx_windowsill_hexagon2" );
      ObjDelete( "gzz_hall_windowsill" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_receptionbell", get_receptionbell_inv );
  cmn.AddSubscriber( "get_receptionbell", get_receptionbell_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_toolbox () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_toolbox" ] = {
    type = "get",
    get_obj = "spr_windowsill_toolbox",
    room = private.room_objname,
    zz = "zz_windowsill",
    zz_gate = "gzz_hall_windowsill"
  };
  
  local get_toolbox_inv = function ()

    interface.InventoryItemAdd( "inv_toolbox", "spr_windowsill_toolbox" );
    ObjSet( "inv_toolbox", { drag = false } );

  end;
  
  local get_toolbox_closezz = function ()
  
    ObjDelete( "gfx_windowsill_toolbox" );
    ObjSet( "obj_windowsill_use_magnet_2", { input = true } );

    ObjDelete( "spr_hall_states_zz_windowsill_2" );
  
  end;
  
  cmn.AddSubscriber( "get_toolbox", get_toolbox_inv );
  cmn.AddSubscriber( "get_toolbox", get_toolbox_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hexagon2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hexagon2" ] = {
    type = "get",
    get_obj = "spr_windowsill_hexagon2",
    room = private.room_objname,
    zz = "zz_windowsill",
    zz_gate = "gzz_hall_windowsill"
  };
  
  local get_hexagon2_inv = function ()
  
    interface.InventoryItemAdd( "inv_hexagon2", "spr_windowsill_hexagon2" );
    cmn.SetInvPlusRGB( "toolbox", true );

  end;
  
  local get_hexagon2_closezz = function ()

    if ( cmn.IsEventDone( "get_receptionbell" ) and 
        cmn.IsGetCollect2( "get_collect2_item_1_4" ) ) then

      ObjDelete( "gfx_windowsill_hexagon2" );
      ObjDelete( "gzz_hall_windowsill" );

    end;

  end;
  
  cmn.AddSubscriber( "get_hexagon2", get_hexagon2_inv );
  cmn.AddSubscriber( "get_hexagon2", get_hexagon2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_magnet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_magnet" ] = {
    type = "get",
    get_obj = "spr_lampwall_magnet",
    room = private.room_objname,
    zz = "zz_lampwall",
    zz_gate = "gzz_hall_lampwall"
  };
  
  local get_magnet_inv = function ()
  
    interface.InventoryItemAdd( "inv_magnet", "spr_lampwall_magnet" );
  
  end;
  
  local get_magnet_closezz = function ()
  
    ObjDelete( "spr_hall_states_zz_lampwall_magnet" );
    ObjDelete( "gfx_lampwall_magnet" );
  
  end;
  
  cmn.AddSubscriber( "get_magnet", get_magnet_inv );
  cmn.AddSubscriber( "get_magnet", get_magnet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_valve () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_valve" ] = {
    type = "get",
    get_obj = "spr_lampwall_valve",
    room = private.room_objname,
    zz = "zz_lampwall",
    zz_gate = "gzz_hall_lampwall"
  };
  
  local get_valve_inv = function ()
  
    interface.InventoryItemAdd( "inv_valve", "spr_lampwall_valve" );
  
  end;
  
  local get_valve_closezz = function ()
  
    ObjDelete( "spr_hall_states_zz_lampwall_valve" );
    ObjDelete( "gfx_lampwall_valve" );
  
  end;
  
  cmn.AddSubscriber( "get_valve", get_valve_inv );
  cmn.AddSubscriber( "get_valve", get_valve_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lionpen1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lionpen1" ] = {
    type = "get",
    get_obj = "spr_lampwall_lionpen1",
    room = private.room_objname,
    zz = "zz_lampwall",
    zz_gate = "gzz_hall_lampwall"
  };
  
  local get_lionpen1_inv = function ()
  
    interface.InventoryItemAdd( "inv_lionpen1", "spr_lampwall_lionpen1" );
  
  end;
  
  local get_lionpen1_closezz = function ()
  
    ObjDelete( "spr_hall_states_zz_lampwall_handle" );
    ObjDelete( "gfx_lampwall_lionpen1" );
  
  end;
  
  cmn.AddSubscriber( "get_lionpen1", get_lionpen1_inv );
  cmn.AddSubscriber( "get_lionpen1", get_lionpen1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_1_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_1_1 = function ()
  
    ObjDelete( "obj_hall_collect" );
  
  end;    
  cmn.AddSubscriber( "get_collect_item_1_1", get_collect_item_1_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_1_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_1_4 = function ()
  
    ObjDelete( "obj_collect2_item_1_4" );

    if ( cmn.IsEventDone( "get_receptionbell" ) and  
    cmn.IsEventDone( "get_hexagon2" ) ) then

      ObjDelete( "gzz_hall_windowsill" );

    end;
  
  end;    
  cmn.AddSubscriber( "get_collect2_item_1_4", get_collect2_item_1_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_1_5 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_1_5 = function ()
  
    ObjDelete( "obj_collect2_item_1_5" );
  
  end;    
  cmn.AddSubscriber( "get_collect2_item_1_5", get_collect2_item_1_5, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_2 = function ()
  
    ObjDelete( "obj_hall_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_2", get_collect_morph_item_1_2, private.room_objname );
--*********************************************************************************************************************

--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_magnet_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_magnet_1" ] = {
    type = "use",
    inv_obj = "inv_magnet",
    use_place = "obj_bodyguardthings_use_magnet_1",
    room = private.room_objname,
    zz = "zz_bodyguardthings",
    zz_gate = "gzz_hall_bodyguardthings"
  };
  local use_magnet_1_inv = function ()
  
    if cmn.IsEventDone( "use_magnet_2" ) and 
    cmn.IsEventDone( "use_magnet_3" ) then 
      interface.InventoryItemRemove( "inv_magnet" );
    end;
  
  end;
  local use_magnet_1_beg = function ()
  
    ObjDelete( "obj_bodyguardthings_use_magnet_1" );
  
  end;
  local use_magnet_1_end = function ()
  
    ObjDelete( "spr_bodyguardthings_hexagon_before" );
    ObjDelete( "anm_bodyguardthings_use_magnet" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_magnet_1", use_magnet_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnet_1", use_magnet_1_inv );
  cmn.AddSubscriber( "use_magnet_1", use_magnet_1_end, private.room_objname );
  cmn.AddSubscriber( "use_magnet_1_inv", use_magnet_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_magnet_1_beg", use_magnet_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnet_1_end", use_magnet_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_valve () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_valve" ] = {
    type = "use",
    inv_obj = "inv_valve",
    use_place = "obj_bodyguardthings_use_valve",
    room = private.room_objname,
    zz = "zz_bodyguardthings",
    zz_gate = "gzz_hall_bodyguardthings"
  };
  local use_valve_inv = function ()
  
    interface.InventoryItemRemove( "inv_valve" );
  
  end;
  local use_valve_beg = function ()
  
    ObjDelete( "obj_bodyguardthings_use_valve" );
    ObjSet( "spr_hall_states_zz_bodyguardthings_valve", { alp = 1, visible = true } );
  
  end;
  local use_valve_end = function ()

    ObjSet( "spr_bodyguardthings_valve_before", { alp = 1, visible = true } );
    if ( cmn.IsEventDone( "use_scoop" ) ) then     
      ObjSet( "obj_bodyguardthings_clk_valve", { input = true } );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_valve", use_valve_beg, private.room_objname );
  cmn.AddSubscriber( "use_valve", use_valve_inv );
  cmn.AddSubscriber( "use_valve", use_valve_end, private.room_objname );
  cmn.AddSubscriber( "use_valve_inv", use_valve_inv, private.room_objname );
  cmn.AddSubscriber( "use_valve_beg", use_valve_beg, private.room_objname );
  cmn.AddSubscriber( "use_valve_end", use_valve_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_scoop () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_scoop" ] = {
    type = "use",
    inv_obj = "inv_scoop",
    use_place = "obj_bodyguardthings_use_scoop",
    room = private.room_objname,
    zz = "zz_bodyguardthings",
    zz_gate = "gzz_hall_bodyguardthings"
  };
  local use_scoop_inv = function ()
  
    interface.InventoryItemRemove( "inv_scoop" );
  
  end;
  local use_scoop_beg = function ()
  
    ObjDelete( "obj_bodyguardthings_use_scoop" );
    ObjSet( "spr_hall_states_zz_bodyguardthings_saucepan", { alp = 1, visible = true } ); 
  
  end;
  local use_scoop_end = function ()

    ObjSet( "anm_bodyguardthings_water", { alp = 0 } ); 
    ObjSet( "anm_bodyguardthings_water_2", { alp = 1 } ); 
    ObjSet( "spr_bodyguardthings_saucepan", { alp = 1, visible = true } );  

    if ( cmn.IsEventDone( "use_valve" ) ) then    

      ObjSet( "obj_bodyguardthings_clk_valve", { input = true } );

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_scoop", use_scoop_beg, private.room_objname );
  cmn.AddSubscriber( "use_scoop", use_scoop_inv );
  cmn.AddSubscriber( "use_scoop", use_scoop_end, private.room_objname );
  cmn.AddSubscriber( "use_scoop_inv", use_scoop_inv, private.room_objname );
  cmn.AddSubscriber( "use_scoop_beg", use_scoop_beg, private.room_objname );
  cmn.AddSubscriber( "use_scoop_end", use_scoop_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_clippers_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_clippers_1" ] = {
    type = "use",
    inv_obj = "inv_clippers",
    use_place = "obj_bodyguardthings_use_clippers_1",
    room = private.room_objname,
    zz = "zz_bodyguardthings",
    zz_gate = "gzz_hall_bodyguardthings"
  };
  local use_clippers_1_inv = function ()
  
    if cmn.IsEventDone( "use_clippers_2" ) then 
      interface.InventoryItemRemove( "inv_clippers" );
    end;

  end;
  local use_clippers_1_beg = function ()
  
    ObjDelete( "obj_bodyguardthings_use_clippers_1" );
    ObjSet( "spr_hall_states_zz_bodyguardthings_gaff", { alp = 1, visible = 1 } );
    ObjDelete( "spr_hall_states_zz_bodyguardthings_chain" );
  
  end;
  local use_clippers_1_end = function ()

    ObjDelete( "anm_bodyguardthings_use_clippers" );
    ObjDelete( "obj_bodyguardthings_chain_before" );  
    ObjSet( "obj_bodyguardthings_chain_after", { alp = 1, visible = 1, input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_clippers_1", use_clippers_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_clippers_1", use_clippers_1_inv );
  cmn.AddSubscriber( "use_clippers_1", use_clippers_1_end, private.room_objname );
  cmn.AddSubscriber( "use_clippers_1_inv", use_clippers_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_clippers_1_beg", use_clippers_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_clippers_1_end", use_clippers_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_slider () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_slider" ] = {
    type = "use",
    inv_obj = "inv_slider",
    use_place = "obj_reception_use_slider",
    room = private.room_objname,
    zz = "zz_reception",
    zz_gate = "gzz_hall_reception"
  };
  local use_slider_inv = function ()
  
    interface.InventoryItemRemove( "inv_slider" );
  
  end;
  local use_slider_beg = function ()
  
    ObjDelete( "obj_reception_use_slider" );
  
  end;
  local use_slider_end = function ()

    ObjDelete( "spr_reception_slider" );
    ObjSet( "anm_reception_slider", { alp = 1 } );
    ObjSet( "obj_reception_clk_reception_slider", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_slider", use_slider_beg, private.room_objname );
  cmn.AddSubscriber( "use_slider", use_slider_inv );
  cmn.AddSubscriber( "use_slider", use_slider_end, private.room_objname );
  cmn.AddSubscriber( "use_slider_inv", use_slider_inv, private.room_objname );
  cmn.AddSubscriber( "use_slider_beg", use_slider_beg, private.room_objname );
  cmn.AddSubscriber( "use_slider_end", use_slider_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_receptionbell () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_receptionbell" ] = {
    type = "use",
    inv_obj = "inv_receptionbell",
    use_place = "obj_reception_use_receptionbell",
    room = private.room_objname,
    zz = "zz_reception",
    zz_gate = "gzz_hall_reception"
  };
  local use_receptionbell_inv = function ()
  
    interface.InventoryItemRemove( "inv_receptionbell" );
  
  end;
  local use_receptionbell_beg = function ()
  
    ObjDelete( "obj_reception_use_receptionbell" );
  
  end;
  local use_receptionbell_end = function ()
  
    ObjSet( "obj_reception_door_bell", { alp = 1 } );
    ObjSet( "obj_reception_clk_reception_bell", { input = true } );

    ObjSet( "spr_hall_states_zz_reception_bell", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_receptionbell", use_receptionbell_beg, private.room_objname );
  cmn.AddSubscriber( "use_receptionbell", use_receptionbell_inv );
  cmn.AddSubscriber( "use_receptionbell", use_receptionbell_end, private.room_objname );
  cmn.AddSubscriber( "use_receptionbell_inv", use_receptionbell_inv, private.room_objname );
  cmn.AddSubscriber( "use_receptionbell_beg", use_receptionbell_beg, private.room_objname );
  cmn.AddSubscriber( "use_receptionbell_end", use_receptionbell_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lionpen1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lionpen1" ] = {
    type = "use",
    inv_obj = "inv_lionpen1",
    use_place = "obj_reception_use_lionpen1",
    room = private.room_objname,
    zz = "zz_reception",
    zz_gate = "gzz_hall_reception"
  };
  local use_lionpen1_inv = function ()
  
    interface.InventoryItemRemove( "inv_lionpen1" );
  
  end;
  local use_lionpen1_beg = function ()
  
    ObjDelete( "obj_reception_use_lionpen1" );
  
  end;
  local use_lionpen1_end = function ()
  
    ObjSet( "spr_reception_door_close_1_handle", { alp = 1 } );
    ObjSet( "obj_reception_clk_reception_door_1", { input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lionpen1", use_lionpen1_beg, private.room_objname );
  cmn.AddSubscriber( "use_lionpen1", use_lionpen1_inv );
  cmn.AddSubscriber( "use_lionpen1", use_lionpen1_end, private.room_objname );
  cmn.AddSubscriber( "use_lionpen1_inv", use_lionpen1_inv, private.room_objname );
  cmn.AddSubscriber( "use_lionpen1_beg", use_lionpen1_beg, private.room_objname );
  cmn.AddSubscriber( "use_lionpen1_end", use_lionpen1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_boxwrench () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_boxwrench" ] = {
    type = "use",
    inv_obj = "inv_boxwrench",
    use_place = "obj_reception_use_boxwrench",
    room = private.room_objname,
    zz = "zz_reception",
    zz_gate = "gzz_hall_reception"
  };
  local use_boxwrench_inv = function ()
  
    interface.InventoryItemRemove( "inv_boxwrench" );
  
  end;
  local use_boxwrench_beg = function ()
  
    ObjDelete( "obj_reception_use_boxwrench" );
  
  end;
  local use_boxwrench_end = function ()
  
    ObjDelete( "vid_reception_boxwrench" );
    ObjSet( "spr_reception_leverlamp", { alp = 1, input = true } );
    ObjSet( "gfx_reception_leverlamp", { active = true } );
    ObjDelete( "anm_reception_lamplight_brocken" );

    ObjSet( "spr_hall_states_zz_reception_lamp", { pos_x = 942, pos_y = 424, ang = -0.13 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_boxwrench", use_boxwrench_beg, private.room_objname );
  cmn.AddSubscriber( "use_boxwrench", use_boxwrench_inv );
  cmn.AddSubscriber( "use_boxwrench", use_boxwrench_end, private.room_objname );
  cmn.AddSubscriber( "use_boxwrench_inv", use_boxwrench_inv, private.room_objname );
  cmn.AddSubscriber( "use_boxwrench_beg", use_boxwrench_beg, private.room_objname );
  cmn.AddSubscriber( "use_boxwrench_end", use_boxwrench_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lionpen2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lionpen2" ] = {
    type = "use",
    inv_obj = "inv_lionpen2",
    use_place = "obj_reception_use_lionpen2",
    room = private.room_objname,
    zz = "zz_reception",
    zz_gate = "gzz_hall_reception"
  };
  local use_lionpen2_inv = function ()
  
    interface.InventoryItemRemove( "inv_lionpen2" );
  
  end;
  local use_lionpen2_beg = function ()
  
    ObjDelete( "obj_reception_use_lionpen2" );
  
  end;
  local use_lionpen2_end = function ()
  
    ObjSet( "spr_reception_door_close_2_handle", { alp = 1 } );
    ObjSet( "obj_reception_clk_reception_door_2", { input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lionpen2", use_lionpen2_beg, private.room_objname );
  cmn.AddSubscriber( "use_lionpen2", use_lionpen2_inv );
  cmn.AddSubscriber( "use_lionpen2", use_lionpen2_end, private.room_objname );
  cmn.AddSubscriber( "use_lionpen2_inv", use_lionpen2_inv, private.room_objname );
  cmn.AddSubscriber( "use_lionpen2_beg", use_lionpen2_beg, private.room_objname );
  cmn.AddSubscriber( "use_lionpen2_end", use_lionpen2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_magnet_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_magnet_2" ] = {
    type = "use",
    inv_obj = "inv_magnet",
    use_place = "obj_windowsill_use_magnet_2",
    room = private.room_objname,
    zz = "zz_windowsill",
    zz_gate = "gzz_hall_windowsill"
  };
  local use_magnet_2_inv = function ()
  
    --interface.InventoryItemRemove( "inv_magnet" );
  
  end;
  local use_magnet_2_beg = function ()
  
    ObjDelete( "obj_windowsill_use_magnet_2" );
    ObjDelete( "obj_windowsill_magnet" );
  
  end;
  local use_magnet_2_end = function ()

    ObjDelete( "anm_windowsill_magnet" );
    ObjSet( "spr_windowsill_receptionbell", { input = true, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_magnet_2", use_magnet_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnet_2", use_magnet_2_inv );
  cmn.AddSubscriber( "use_magnet_2", use_magnet_2_end, private.room_objname );
  cmn.AddSubscriber( "use_magnet_2_inv", use_magnet_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_magnet_2_beg", use_magnet_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnet_2_end", use_magnet_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_waterscoop () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_waterscoop" ] = {
    type = "use",
    inv_obj = "inv_waterscoop",
    use_place = "obj_windowsill_use_waterscoop",
    room = private.room_objname,
    zz = "zz_windowsill",
    zz_gate = "gzz_hall_windowsill"
  };
  local use_waterscoop_inv = function ()
  
    interface.InventoryItemRemove( "inv_waterscoop" );
  
  end;
  local use_waterscoop_beg = function ()
  
    ObjDelete( "obj_windowsill_use_waterscoop" );
  
  end;
  local use_waterscoop_end = function ()
  
    ObjSet( "spr_windowsill_hexagon2", { input = true, alp = 1 } );
    ObjDelete( "vid_windowsill_hexagon2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_waterscoop", use_waterscoop_beg, private.room_objname );
  cmn.AddSubscriber( "use_waterscoop", use_waterscoop_inv );
  cmn.AddSubscriber( "use_waterscoop", use_waterscoop_end, private.room_objname );
  cmn.AddSubscriber( "use_waterscoop_inv", use_waterscoop_inv, private.room_objname );
  cmn.AddSubscriber( "use_waterscoop_beg", use_waterscoop_beg, private.room_objname );
  cmn.AddSubscriber( "use_waterscoop_end", use_waterscoop_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_picklockclip () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_picklockclip" ] = {
    type = "use",
    inv_obj = "inv_picklockclip",
    use_place = "obj_windowsill_use_picklockclip",
    room = private.room_objname,
    zz = "zz_windowsill",
    zz_gate = "gzz_hall_windowsill"
  };
  local use_picklockclip_inv = function ()
  
    interface.InventoryItemRemove( "inv_picklockclip" );
  
  end;
  local use_picklockclip_beg = function ()
  
    ObjDelete( "obj_windowsill_use_picklockclip" );
  
  end;
  local use_picklockclip_end = function ()

    ObjDelete( "spr_windowsill_door_close" );
    ObjSet( "spr_windowsill_door_open", { alp = 1 } );
    ObjSet( "spr_windowsill_toolbox", { input = true } );
    ObjSet( "gfx_windowsill_toolbox", { active = true } );

    ObjSet( "spr_hall_states_zz_windowsill_1", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_picklockclip", use_picklockclip_beg, private.room_objname );
  cmn.AddSubscriber( "use_picklockclip", use_picklockclip_inv );
  cmn.AddSubscriber( "use_picklockclip", use_picklockclip_end, private.room_objname );
  cmn.AddSubscriber( "use_picklockclip_inv", use_picklockclip_inv, private.room_objname );
  cmn.AddSubscriber( "use_picklockclip_beg", use_picklockclip_beg, private.room_objname );
  cmn.AddSubscriber( "use_picklockclip_end", use_picklockclip_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_leverlamp () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_leverlamp" ] = {
    type = "use",
    inv_obj = "inv_leverlamp",
    use_place = "obj_lampwall_use_leverlamp",
    room = private.room_objname,
    zz = "zz_lampwall",
    zz_gate = "gzz_hall_lampwall"
  };
  local use_leverlamp_inv = function ()
  
    interface.InventoryItemRemove( "inv_leverlamp" );
  
  end;
  local use_leverlamp_beg = function ()
  
    ObjDelete( "obj_lampwall_use_leverlamp" );  
    ObjSet( "spr_hall_states_zz_lampwall_lamp_left", { alp = 1, visible = true } );

  end;
  local use_leverlamp_end = function ()

    ObjSet( "spr_lampwall_darkness", { alp = 0, visible = false } );

    if cmn.IsEventDone( "use_bulb" ) then 
      ObjSet( "spr_lampwall_game_back", { pos_y = 17, input = true } );
    end;
  
    ObjSet( "spr_lampwall_lamp_left", { alp = 1, visible = true } );
    ObjSet( "spr_lampwall_backlight_left", { alp = 1, visible = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_leverlamp", use_leverlamp_beg, private.room_objname );
  cmn.AddSubscriber( "use_leverlamp", use_leverlamp_inv );
  cmn.AddSubscriber( "use_leverlamp", use_leverlamp_end, private.room_objname );
  cmn.AddSubscriber( "use_leverlamp_inv", use_leverlamp_inv, private.room_objname );
  cmn.AddSubscriber( "use_leverlamp_beg", use_leverlamp_beg, private.room_objname );
  cmn.AddSubscriber( "use_leverlamp_end", use_leverlamp_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_screwdriver_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screwdriver_1" ] = {
    type = "use",
    inv_obj = "inv_screwdriver",
    use_place = "obj_lampwall_use_screwdriver_1",
    room = private.room_objname,
    zz = "zz_lampwall",
    zz_gate = "gzz_hall_lampwall"
  };
  local use_screwdriver_1_inv = function ()
  
    if ( cmn.IsEventDone( "use_screwdriver_2" ) ) then

      interface.InventoryItemRemove( "inv_screwdriver" );

    end;
  
  end;
  local use_screwdriver_1_beg = function ()
  
    ObjDelete( "obj_lampwall_use_screwdriver_1" );
    ObjSet( "spr_hall_states_zz_lampwall_door", { alp = 1, visible = true } );
    ObjDelete( "spr_hall_states_zz_lampwall_grid" );

  end;
  local use_screwdriver_1_end = function ()
  
    ObjSet( "spr_lampwall_lionpen1", { input = true } );
    ObjSet( "gfx_lampwall_lionpen1", { active = true } );
    ObjSet( "spr_lampwall_valve", { input = true } );
    ObjSet( "gfx_lampwall_valve", { active = true } );
    ObjDelete( "vid_lampwall_screwdriver" );
    ObjDelete( "spr_lampwall_grid" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_screwdriver_1", use_screwdriver_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_1", use_screwdriver_1_inv );
  cmn.AddSubscriber( "use_screwdriver_1", use_screwdriver_1_end, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_1_inv", use_screwdriver_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_1_beg", use_screwdriver_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_1_end", use_screwdriver_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bulb () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bulb" ] = {
    type = "use",
    inv_obj = "inv_bulb",
    use_place = "obj_lampwall_use_bulb",
    room = private.room_objname,
    zz = "zz_lampwall",
    zz_gate = "gzz_hall_lampwall"
  };
  local use_bulb_inv = function ()
  
    interface.InventoryItemRemove( "inv_bulb" );
  
  end;
  local use_bulb_beg = function ()
  
    ObjDelete( "obj_lampwall_use_bulb" );
    ObjSet( "spr_hall_states_zz_lampwall_lamp_right", { alp = 1, visible = true } );
  
  end;
  local use_bulb_end = function ()

    ObjSet( "spr_lampwall_darkness", { alp = 0, visible = false } );

    if cmn.IsEventDone( "use_leverlamp" ) then 
      ObjSet( "spr_lampwall_game_back", { pos_y = 17, input = true } );
    end;

    ObjSet( "spr_lampwall_lamp_right", { alp = 1, visible = true } );
    ObjSet( "spr_lampwall_backlight_right", { alp = 1, visible = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bulb", use_bulb_beg, private.room_objname );
  cmn.AddSubscriber( "use_bulb", use_bulb_inv );
  cmn.AddSubscriber( "use_bulb", use_bulb_end, private.room_objname );
  cmn.AddSubscriber( "use_bulb_inv", use_bulb_inv, private.room_objname );
  cmn.AddSubscriber( "use_bulb_beg", use_bulb_beg, private.room_objname );
  cmn.AddSubscriber( "use_bulb_end", use_bulb_end, private.room_objname );
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************

--*********************************************************************************************************************
-- PROGRESS CLK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_courtyard_door () end;
  --------------------------------------------------------------------------------------------
  local clk_courtyard_door_beg = function ()

    ObjDelete( "obj_hall_clk_courtyard_door" );
  
  end;
  local clk_courtyard_door_end = function ()

    ObjSet( "obj_hall_clk_courtyard_door_2", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_courtyard_door", clk_courtyard_door_beg, private.room_objname );
  cmn.AddSubscriber( "clk_courtyard_door", clk_courtyard_door_end, private.room_objname );
  cmn.AddSubscriber( "clk_courtyard_door_beg", clk_courtyard_door_beg, private.room_objname );
  cmn.AddSubscriber( "clk_courtyard_door_end", clk_courtyard_door_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_reception_slider () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_reception_slider" ] = {
    type = "click",
    use_place = "obj_reception_clk_reception_slider",
    room = private.room_objname,
    zz = "zz_reception",
    zz_gate = "gzz_hall_reception"
  };

  local clk_reception_slider_beg = function ()

    ObjDelete( "obj_reception_clk_reception_slider" );
  
  end;
  local clk_reception_slider_end = function ()

    ObjSet( "spr_reception_purse_open", { alp = 1, input = true } );
    ObjDelete( "anm_reception_slider" );

    ObjSet( "spr_hall_states_zz_reception_purse_open", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_reception_slider", clk_reception_slider_beg, private.room_objname );
  cmn.AddSubscriber( "clk_reception_slider", clk_reception_slider_end, private.room_objname );
  cmn.AddSubscriber( "clk_reception_slider_beg", clk_reception_slider_beg, private.room_objname );
  cmn.AddSubscriber( "clk_reception_slider_end", clk_reception_slider_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_reception_paperclip_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_reception_paperclip_1" ] = {
    type = "click",
    --use_place = "obj_reception_clk_reception_paperclip_1",
    use_place = "obj_reception_note_hint",
    room = private.room_objname,
    zz = "zz_reception",
    zz_gate = "gzz_hall_reception"
  };

  local clk_reception_paperclip_1_beg = function ()

    ObjDelete( "obj_reception_clk_reception_paperclip_1" );
  
  end;
  local clk_reception_paperclip_1_end = function ()

    ObjDelete( "spr_reception_note_paperclip_1" );
    ObjSet( "spr_reception_note_paperclip_2", { alp = 1 } );
    ObjSet( "obj_reception_clk_reception_paperclip_2", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_reception_paperclip_1", clk_reception_paperclip_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_reception_paperclip_1", clk_reception_paperclip_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_reception_paperclip_1_beg", clk_reception_paperclip_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_reception_paperclip_1_end", clk_reception_paperclip_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_reception_paperclip_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_reception_paperclip_2" ] = {
    type = "click",
    --use_place = "obj_reception_clk_reception_paperclip_2",
    use_place = "obj_reception_note_hint",
    room = private.room_objname,
    zz = "zz_reception",
    zz_gate = "gzz_hall_reception"
  };

  local clk_reception_paperclip_2_beg = function ()

    ObjDelete( "obj_reception_clk_reception_paperclip_2" );
  
  end;
  local clk_reception_paperclip_2_end = function ()

    ObjDelete( "spr_reception_note_paperclip_2" );
    ObjSet( "spr_reception_picklockclip", { alp = 1, input = true } );
    ObjSet( "gfx_reception_picklockclip", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_reception_paperclip_2", clk_reception_paperclip_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_reception_paperclip_2", clk_reception_paperclip_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_reception_paperclip_2_beg", clk_reception_paperclip_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_reception_paperclip_2_end", clk_reception_paperclip_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_reception_bell () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_reception_bell" ] = {
    type = "click",
    use_place = "obj_reception_clk_reception_bell",
    room = private.room_objname,
    zz = "zz_reception",
    zz_gate = "gzz_hall_reception"
  };

  local clk_reception_bell_beg = function ()

    ObjDelete( "obj_reception_clk_reception_bell" );
  
  end;
  local clk_reception_bell_end = function ()

    ObjDelete( "spr_reception_door_bell_close" );
    ObjSet( "spr_reception_door_bell_open", { alp = 1 } );
    ObjSet( "spr_reception_bulbbox", { input = true } );
    ObjSet( "gfx_reception_bulbbox", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_reception_bell", clk_reception_bell_beg, private.room_objname );
  cmn.AddSubscriber( "clk_reception_bell", clk_reception_bell_end, private.room_objname );
  cmn.AddSubscriber( "clk_reception_bell_beg", clk_reception_bell_beg, private.room_objname );
  cmn.AddSubscriber( "clk_reception_bell_end", clk_reception_bell_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_reception_door_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_reception_door_1" ] = {
    type = "click",
    use_place = "obj_reception_clk_reception_door_1",
    room = private.room_objname,
    zz = "zz_reception",
    zz_gate = "gzz_hall_reception"
  };

  local clk_reception_door_1_beg = function ()

    ObjDelete( "obj_reception_clk_reception_door_1" );
  
  end;
  local clk_reception_door_1_end = function ()

    ObjDelete( "spr_reception_door_close_1" );
    ObjSet( "spr_reception_door_open_1", { alp = 1 } );
    ObjSet( "spr_reception_plaster", { input = true } );
    ObjSet( "gfx_reception_plaster", { active = true } );

    ObjDelete( "spr_hall_states_zz_reception_door_1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_reception_door_1", clk_reception_door_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_reception_door_1", clk_reception_door_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_reception_door_1_beg", clk_reception_door_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_reception_door_1_end", clk_reception_door_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_reception_door_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_reception_door_2" ] = {
    type = "click",
    use_place = "obj_reception_clk_reception_door_2",
    room = private.room_objname,
    zz = "zz_reception",
    zz_gate = "gzz_hall_reception"
  };

  local clk_reception_door_2_beg = function ()

    ObjDelete( "obj_reception_clk_reception_door_2" );
  
  end;
  local clk_reception_door_2_end = function ()

    ObjDelete( "spr_reception_door_close_2" );
    ObjSet( "spr_reception_door_open_2", { alp = 1 } );
    ObjSet( "spr_reception_developingliquid", { input = true } );
    ObjSet( "gfx_reception_developingliquid", { active = true } );
    ObjSet( "spr_reception_razor", { input = true } );
    ObjSet( "gfx_reception_razor", { active = true } );

    ObjDelete( "spr_hall_states_zz_reception_door_2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_reception_door_2", clk_reception_door_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_reception_door_2", clk_reception_door_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_reception_door_2_beg", clk_reception_door_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_reception_door_2_end", clk_reception_door_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_bodyguardthings_valve () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_bodyguardthings_valve" ] = {
    type = "click",
    use_place = "obj_bodyguardthings_clk_valve",
    room = private.room_objname,
    zz = "zz_bodyguardthings",
    zz_gate = "gzz_hall_bodyguardthings"
  };

  local clk_bodyguardthings_valve_beg = function ()

    ObjDelete( "obj_bodyguardthings_clk_valve" );
  
  end;
  local clk_bodyguardthings_valve_end = function ()

    ObjSet( "anm_bodyguardthings_water_2", { alp = 0 } );
    ObjDelete( "vid_bodyguardthings_water" );
    ObjDelete( "spr_bodyguardthings_valve_before" );
    ObjDelete( "spr_bodyguardthings_valve_middle" );
    ObjDelete( "spr_bodyguardthings_saucepan" );
    ObjSet( "spr_bodyguardthings_valve_after", { alp = 1, visible = true } );
    ObjSet( "spr_bodyguardthings_waterscoop", { alp = 1, visible = true, input = true } );
    ObjSet( "spr_bodyguardthings_waterscoop_shadow", { alp = 1, visible = true } );
    ObjSet( "gfx_bodyguardthings_waterscoop", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_bodyguardthings_valve", clk_bodyguardthings_valve_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bodyguardthings_valve", clk_bodyguardthings_valve_end, private.room_objname );
  cmn.AddSubscriber( "clk_bodyguardthings_valve_beg", clk_bodyguardthings_valve_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bodyguardthings_valve_end", clk_bodyguardthings_valve_end, private.room_objname );

--*********************************************************************************************************************

--*********************************************************************************************************************
-- PROGRESS WIN
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function win_lampwall () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_lampwall" ] =
  {
      type = "win",
      room = private.room_objname,
      zz = "zz_lampwall",
      zz_gate = "gzz_hall_lampwall"
  };
--*********************************************************************************************************************
  local win_lampwall = function ()

    if ( cmn.IsEventDone( "win_lampwall" ) ) then

      ObjDelete( "gzz_hall_lampwall" );
      ObjSet( "obj_lampwall_mmg", { input = false } );
      ObjDelete( "spr_hall_states_zz_lampwall_game" );

    end;

  end;

  cmn.AddSubscriber( "win_lampwall", win_lampwall, private.room_objname );
--*********************************************************************************************************************

--*********************************************************************************************************************
-- PROGRESS SEE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function see_disappearance_professor () end;
  --------------------------------------------------------------------------------------------
  local see_disappearance_professor = function ()

    ObjDelete( "obj_hall_see_disappearance_professor" );
    ObjDelete( "spr_hall_back_dark" );
    ObjDelete( "spr_hall_kevin" );
    ObjSet( "obj_hall_see_masked_man_1", { active = true, input = true, visible = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOff("grm_hall_porch_focus");
    end;
    ObjSet( "grm_hall_porch", { active = false, input = false, visible = false } );

  end;

  local see_disappearance_professor_map = function ()

    common_impl.LockMapRoom( "car",   true );
    common_impl.LockMapRoom( "porch", true );

  end;

  cmn.AddSubscriber( "see_disappearance_professor", see_disappearance_professor_map );
  cmn.AddSubscriber( "see_disappearance_professor", see_disappearance_professor, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_masked_man_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_masked_man_1" ] = {
    type = "click",
    use_place = "obj_hall_see_masked_man_1_focus",
    room = private.room_objname
  };
  local see_masked_man_1 = function ()

    ObjDelete( "obj_hall_see_masked_man_1" );
    ObjDelete( "vid_hall_masked_man_1" );

  end;

  cmn.AddSubscriber( "see_masked_man_1", see_masked_man_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_flashback_hall () end;
  --------------------------------------------------------------------------------------------
  local see_flashback_hall = function ()

    ObjSet( "grm_hall_courtyard", { active = true, input = true, visible = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_hall_courtyard_focus");
    end;
    ObjSet( "spr_hall_courtyard_door_open", { alp = 1 } );
    ObjDelete( "obj_hall_clk_courtyard_door_2" );
    ObjDelete( "vid_hall_clk_courtyard_door" );
    ObjDelete( "fx_hall_smoke" );

  end;

  cmn.AddSubscriber( "see_flashback_hall", see_flashback_hall, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_hall_scare_3 () end;
  --------------------------------------------------------------------------------------------
  local see_hall_scare_3 = function ()


  end;

  cmn.AddSubscriber( "see_hall_scare_3", see_hall_scare_3, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()

  --*********************************************************************************************************************
  -- function zz_lampwall() end зз стена со светильником
    subroom.Define( "zz_lampwall" );
    function zz_lampwall.Open ()

    end;  
    -------------------------------------------------
    function zz_lampwall.PreOpen ()

      if ( cmn.IsEventStart( "win_lampwall" ) and not cmn.IsEventDone( "win_lampwall" ) ) then

        cmn.MiniGameShow( "lampwall" );
        common_impl.PassingMgStart( "lampwall" );

      end;

      private.LampWallLoad();
      private.Update(); 

    end;  
    -------------------------------------------------
    function zz_lampwall.PreClose ()

      cmn.MiniGameHide( "lampwall" );
      common_impl.PassingMgStop( "lampwall" );

    end; 
    ------------------------------------------------- 
    function zz_lampwall.Close ()
           
    end;
    -------------------------------------------------
    function zz_lampwall.Reset ()

      private.LampWallDefault();
      private.LampWallSave();
      private.Update();

    end;
    -------------------------------------------------  
    function zz_lampwall.ResetEnd ()

    end;
    -------------------------------------------------
    function zz_lampwall.Skip ()

      private.lampwall_state = private.lampwall_state_win;
      private.LampWallSave();
      private.Update();

    end;
    -------------------------------------------------
  --*********************************************************************************************************************
  -- function zz_bodyguardthings() end зз стена со светильником
    subroom.Define( "zz_bodyguardthings" );
    function zz_bodyguardthings.Open ()

      if not ( ng_global.progress[ "std" ][ "opn_hall" ].opn_hall_bodyguardthings ) then

        ng_global.progress[ "std" ][ "opn_hall" ].opn_hall_bodyguardthings = true;
        common_impl.ShowBbt( "bbt_hall_opn_hall_bodyguardthings" );

      end;

      if ( cmn.IsEventDone( "use_scoop") and not cmn.IsEventDone( "get_saucepan" ) ) then

        common_impl.PlayAudio( "env", "level1/env/aud_drop_water",  1, "", 0 );
        AnimPlay( "anm_bodyguardthings_water_2", "DopAnim", "" );

      else 

        common_impl.PlayAudio( "env", "level1/env/aud_drop_water",  1, "", 0 );
        AnimPlay( "anm_bodyguardthings_water", "DopAnim", "" );

      end;

    end;  
    -------------------------------------------------
    function zz_bodyguardthings.PreOpen ()

    end;  
    -------------------------------------------------
    function zz_bodyguardthings.PreClose ()


    end; 
    ------------------------------------------------- 
    function zz_bodyguardthings.Close ()

      common_impl.StopAudio( "env", "level1/env/aud_drop_water" );
      AnimStop( "anm_bodyguardthings_water", "DopAnim" );
      AnimStop( "anm_bodyguardthings_water_2", "DopAnim" );
      
      if not ( cmn.IsEventDone( "see_hall_scare_3" ) ) then

        if ( cmn.IsEventDone( "get_boathookhead" ) ) then

          private.HallScare_3();      

        end;

      end; 
            
    end;
    -------------------------------------------------
  --*********************************************************************************************************************
  -- function zz_reception() end
    subroom.Define( "zz_reception" );
    function zz_reception.Open ()

      if cmn.IsEventStart( "see_tutorial" ) and not ng_global.collectibles2[ "get_collect2_item_1_5" ].done and IsCollectorsEdition() then

        common_impl.TutorialSetShown( "tutorial_page_25" );
        common_impl.TutorialShow( "tutorial_page_26" );

      end;

    end;  
    -------------------------------------------------
    function zz_reception.PreOpen ()

    end;  
    -------------------------------------------------
    function zz_reception.PreClose ()

    end; 
    ------------------------------------------------- 
    function zz_reception.Close ()

      cmn.NoteScaleClose( { "spr_reception_note" } );
      ObjSet( "obj_reception_note_hint", { pos_x = 218, pos_y = 173 } );

    end;
    -------------------------------------------------
  --*********************************************************************************************************************
  -- function zz_windowsill() end
    subroom.Define( "zz_windowsill" );
    function zz_windowsill.Open ()

      if cmn.IsEventStart( "see_tutorial" ) and not ng_global.collectibles2[ "get_collect2_item_1_4" ].done and IsCollectorsEdition() then

        common_impl.TutorialSetShown( "tutorial_page_26" );
        common_impl.TutorialShow( "tutorial_page_25" );

      end;

    end;  
    -------------------------------------------------
    function zz_windowsill.PreOpen ()

    end;  
    -------------------------------------------------
    function zz_windowsill.PreClose ()

    end; 
    ------------------------------------------------- 
    function zz_windowsill.Close ()

      if ( cmn.IsEventDone( "get_hexagon2" ) and not cmn.IsEventDone( "see_hall_scare_2" ) ) then

        private.HallScare_2();

      end;

    end;
    -------------------------------------------------
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_hall();

  if not ( cmn.IsEventDone( "see_hall_scare_2" ) ) then

    if ( cmn.IsEventDone( "get_hexagon2" ) ) then

      private.HallScare_2();      

    end;

  end;

  if not ( cmn.IsEventDone( "see_hall_scare_3" ) ) then

    if ( cmn.IsEventDone( "get_boathookhead" ) ) then

      private.HallScare_3();      

    end;

  end;

  if not ( cmn.IsEventDone( "see_flashback_hall" ) ) then

    if ( cmn.IsEventDone( "win_lampwall" ) ) then

      private.HallDoorOpen();     

    end;

  end;

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  --common_impl.MorphItemMorphing();

  if not cmn.IsEventDone( "see_disappearance_professor" ) then

    common_impl.EnvPlay( { "level1/env/aud_rm_bar1_env" }, "", 0.5 );

  else

    common_impl.EnvPlay( { "level1/env/aud_hall_env" }, "", 0.5 );

  end;

  --cmn.PlayMusEnv();
  common_impl.CollectItemMorphing();
  common_impl.MorphItemMorphing();

end;
--*********************************************************************************************************************
function public.Close ()

  cmn.NoteScaleClose( { "spr_hall_placat" } ); 

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_magnet_1 ()

  local item = "inv_magnet";

  if ( cmn.ApplyObj( item, "gzz_hall_bodyguardthings" ) and not cmn.IsEventDone( "use_magnet_1" ) )then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bodyguardthings", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bodyguardthings_use_magnet_1" ) ) then

    cmn.CallEventHandler( "use_magnet_1_inv" );
    cmn.CallEventHandler( "use_magnet_1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_magnet_1" );
      cmn.CallEventHandler( "use_magnet_1_end" );
      private.get_hexagon1();

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_magnet", 0, "", 0 );

    ObjSet( "anm_bodyguardthings_use_magnet", { alp = 1, visible = true } );
    ObjSet( "spr_bodyguardthings_hexagon_before", { alp = 0 } );
    AnimPlay( "anm_bodyguardthings_use_magnet", "DoAnim", func_end );

    return true;

  end;
  
  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_valve ()

  local item = "inv_valve";

  if cmn.ApplyObj( item, "gzz_hall_bodyguardthings" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bodyguardthings", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_bodyguardthings_use_valve" ) ) then

    cmn.CallEventHandler( "use_valve_inv" );
    cmn.CallEventHandler( "use_valve_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_valve" );
      cmn.CallEventHandler( "use_valve_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_valve", 0, "", 0 );

    ObjSet( "spr_bodyguardthings_valve_before", { alp = 0, visible = true } );
    ObjAnimate( "spr_bodyguardthings_valve_before", "alp",0,0, func_end, { 0, 0, 0,    0.6, 0, 1 } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_scoop ()

  local item = "inv_scoop";

  if cmn.ApplyObj( item, "gzz_hall_bodyguardthings" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bodyguardthings", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_bodyguardthings_use_scoop" ) ) then

    cmn.CallEventHandler( "use_scoop_inv" );
    cmn.CallEventHandler( "use_scoop_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_scoop" );
      cmn.CallEventHandler( "use_scoop_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_bucket", 0, "", 0 );
    common_impl.StopAudio( "env", "level1/env/aud_drop_water" );
    AnimStop( "anm_bodyguardthings_water", "DopAnim" );
    
    common_impl.PlayAudio( "env", "level1/env/aud_drop_water",  1, "", 0 );
    AnimPlay( "anm_bodyguardthings_water_2", "DopAnim", "" );

    ObjAnimate( "anm_bodyguardthings_water", "alp",0,0, "", { 0, 2, 1,    0.6, 2, 0 } );
    ObjAnimate( "anm_bodyguardthings_water_2", "alp",0,0, "", { 0, 1, 0,    0.6, 1, 1 } );

    ObjSet( "spr_bodyguardthings_saucepan", { alp = 0, visible = true } );
    ObjAnimate( "spr_bodyguardthings_saucepan", "alp",0,0, func_end, { 0, 0, 0,    0.6, 0, 1 } );
   
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_clippers_1 ()

  local item = "inv_clippers";

  if cmn.ApplyObj( item, "gzz_hall_bodyguardthings" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bodyguardthings", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_bodyguardthings_use_clippers_1" ) ) then

    cmn.CallEventHandler( "use_clippers_1_inv" );
    cmn.CallEventHandler( "use_clippers_1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_clippers_1" );
      cmn.CallEventHandler( "use_clippers_1_end" );

    end;

    local func_end_2 = function ()

      ObjSet( "obj_bodyguardthings_chain_before", { alp = 0 } );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_boltcutter", 0, "", 0 );

    ObjSet( "anm_bodyguardthings_use_clippers", { alp = 0, visible = true } );
    ObjAnimate( "anm_bodyguardthings_use_clippers", "alp",0,0, func_end_2, { 0, 0, 0,    0.3, 0, 1 } );
    AnimPlay( "anm_bodyguardthings_use_clippers", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_slider ()

  local item = "inv_slider";

  if cmn.ApplyObj( item, "gzz_hall_reception" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_reception", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_reception_use_slider" ) ) then

    cmn.CallEventHandler( "use_slider_inv" );
    cmn.CallEventHandler( "use_slider_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_slider" );
      cmn.CallEventHandler( "use_slider_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_zipper", 0, "", 0 );

    cmn.ItemFly( "spr_reception_slider", func_end, 3.9 );
  
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_receptionbell ()

  local item = "inv_receptionbell";

  if cmn.ApplyObj( item, "gzz_hall_reception" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_reception", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_reception_use_receptionbell" ) ) then

    cmn.CallEventHandler( "use_receptionbell_inv" );
    cmn.CallEventHandler( "use_receptionbell_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_receptionbell" );
      cmn.CallEventHandler( "use_receptionbell_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_call", 0, "", 0 );

    cmn.ItemFly( "obj_reception_door_bell", func_end, 0 );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_lionpen1 ()

  local item = "inv_lionpen1";

  if cmn.ApplyObj( item, "gzz_hall_reception" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_reception", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_reception_use_lionpen1" ) ) then

    cmn.CallEventHandler( "use_lionpen1_inv" );
    cmn.CallEventHandler( "use_lionpen1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_lionpen1" );
      cmn.CallEventHandler( "use_lionpen1_end" );
      common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_drawer_handle", 0, "", 0 );

    end;

    cmn.Lock( true );
    cmn.ItemFly( "spr_reception_door_close_1_handle", func_end, 1.57 );
  
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_boxwrench ()

  local item = "inv_boxwrench";

  if cmn.ApplyObj( item, "gzz_hall_reception" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_reception", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_reception_use_boxwrench" ) ) then

    cmn.CallEventHandler( "use_boxwrench_inv" );
    cmn.CallEventHandler( "use_boxwrench_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_boxwrench" );
      cmn.CallEventHandler( "use_boxwrench_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_wrench", 0, "", 0 );

    ObjAnimate( "anm_reception_lamplight_brocken", "alp", 0, 0, "", { 0, 0, 0.5,   1, 0, 0 } );
    VidPlay( "vid_reception_boxwrench", func_end );
    
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_lionpen2 ()

  local item = "inv_lionpen2";

  if cmn.ApplyObj( item, "gzz_hall_reception" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_reception", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_reception_use_lionpen2" ) ) then

    cmn.CallEventHandler( "use_lionpen2_inv" );
    cmn.CallEventHandler( "use_lionpen2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_lionpen2" );
      cmn.CallEventHandler( "use_lionpen2_end" );
      common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_drawer_handle", 0, "", 0 );

    end;

    cmn.Lock( true );
    cmn.ItemFly( "spr_reception_door_close_2_handle", func_end, 1.57 );
    
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_magnet_2 ()

  local item = "inv_magnet";

  if ( cmn.ApplyObj( item, "gzz_hall_windowsill" ) and cmn.IsEventDone( "get_toolbox" ) and not 
      cmn.IsEventDone( "use_magnet_2" ) ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_windowsill", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_windowsill_use_magnet_2" ) and cmn.IsEventDone( "get_toolbox" ) ) then

    cmn.CallEventHandler( "use_magnet_2_inv" );
    cmn.CallEventHandler( "use_magnet_2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_magnet_2" );
      cmn.CallEventHandler( "use_magnet_2_end" );

      private.get_receptionbell();

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_magnet", 0, "", 0 );

    ObjSet( "anm_windowsill_magnet", { alp = 1, pos_z = 1 } );
    AnimPlay( "anm_windowsill_magnet", "magnet", func_end );
    
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_waterscoop ()

  local item = "inv_waterscoop";

  if cmn.ApplyObj( item, "gzz_hall_windowsill" ) and cmn.IsEventDone( "get_scoop" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_windowsill", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_windowsill_use_waterscoop" ) and cmn.IsEventDone( "get_scoop" ) ) then

    cmn.CallEventHandler( "use_waterscoop_inv" );
    cmn.CallEventHandler( "use_waterscoop_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_waterscoop" );
      cmn.CallEventHandler( "use_waterscoop_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_solution", 0, "", 0 );

    VidPlay( "vid_windowsill_hexagon2", func_end );
    
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_picklockclip ()

  local item = "inv_picklockclip";

  if cmn.ApplyObj( item, "gzz_hall_windowsill" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_windowsill", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_windowsill_use_picklockclip" ) ) then

    cmn.CallEventHandler( "use_picklockclip_inv" );
    cmn.CallEventHandler( "use_picklockclip_beg" );

    local func_open = function ()

      local func_end = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_picklockclip" );
        cmn.CallEventHandler( "use_picklockclip_end" );

      end;

      ObjAnimate( "spr_windowsill_door_open", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0,
        0.3, 0, 1
      } );

      ObjAnimate( "spr_windowsill_door_close", "alp", 0, 0, "",
      { 
        0.0, 0, 1,
        0.3, 0, 0
      } );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_clip", 0, "", 0 );
  
    AnimPlay( "anm_windowsill_picklockclip", "paperclip", func_open );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_leverlamp ()

  local item = "inv_leverlamp";

  if cmn.ApplyObj( item, "gzz_hall_lampwall" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_lampwall", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_lampwall_use_leverlamp" ) ) then

    cmn.CallEventHandler( "use_leverlamp_inv" );
    cmn.CallEventHandler( "use_leverlamp_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_leverlamp" );
      cmn.CallEventHandler( "use_leverlamp_end" );

      if cmn.IsEventDone( "use_bulb" ) then 

        cmn.MiniGameShow( "lampwall" );
        common_impl.PassingMgStart( "lampwall" );

      end;

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_lamp2", 0, "", 0 );

    ObjSet( "spr_lampwall_lamp_left", { alp = 0, visible = true } );
    ObjAnimate( "spr_lampwall_lamp_left", "alp",0,0, "", { 0, 0, 0,    0.6, 0, 1 } );

    ObjSet( "spr_lampwall_backlight_left", { alp = 0, visible = true } );
    ObjAnimate( "spr_lampwall_backlight_left", "alp",0,0, "", { 0, 0, 0,    0.4, 0, 0,    1.0, 0, 1 } );

    if not cmn.IsEventDone( "use_bulb" ) then 
      ObjAnimate( "spr_lampwall_darkness", "alp",0,0, func_end, { 0, 0, 1,    0.4, 0, 1,    1.0, 0, 0 } );

    else 
      ObjAnimate( "spr_lampwall_game_back", "pos_y",0,0, func_end, { 0, 0, -450,    0.8, 0, -450,    1.6, 0, 17 } );

    end;
    
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_screwdriver_1 ()

  local item = "inv_screwdriver";

  if ( cmn.ApplyObj( item, "gzz_hall_lampwall" ) and not cmn.IsEventDone( "use_screwdriver_1" ) ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_lampwall", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_lampwall_use_screwdriver_1" ) ) then

    cmn.CallEventHandler( "use_screwdriver_1_inv" );
    cmn.CallEventHandler( "use_screwdriver_1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_screwdriver_1" );
      cmn.CallEventHandler( "use_screwdriver_1_end" );

    end;

    local func_end_2 = function ()

      ObjSet( "spr_lampwall_grid", { alp = 0 } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_screwdriwer", 0, "", 0 );

    ObjSet( "vid_lampwall_screwdriver", { alp = 0, visible = true } );
    ObjAnimate( "vid_lampwall_screwdriver", "alp",0,0, func_end_2, { 0, 0, 0,    0.3, 0, 1 } );
    VidPlay( "vid_lampwall_screwdriver", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_bulb ()

  local item = "inv_bulb";

  if cmn.ApplyObj( item, "gzz_hall_lampwall" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_lampwall", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_lampwall_use_bulb" ) ) then

    cmn.CallEventHandler( "use_bulb_inv" );
    cmn.CallEventHandler( "use_bulb_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_bulb" );
      cmn.CallEventHandler( "use_bulb_end" );

      if cmn.IsEventDone( "use_leverlamp" ) then 

        cmn.MiniGameShow( "lampwall" );
        common_impl.PassingMgStart( "lampwall" );

      end;

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_lamp", 0, "", 0 );

    ObjSet( "spr_lampwall_lamp_right", { alp = 0, visible = true } );
    ObjAnimate( "spr_lampwall_lamp_right", "alp",0,0, "", { 0, 0, 0,    0.6, 0, 1 } );

    ObjSet( "spr_lampwall_backlight_right", { alp = 0, visible = true } );
    ObjAnimate( "spr_lampwall_backlight_right", "alp",0,0, "", { 0, 0, 0,    0.4, 0, 0,    1.0, 0, 1 } );

    if not cmn.IsEventDone( "use_leverlamp" ) then 
      ObjAnimate( "spr_lampwall_darkness", "alp",0,0, func_end, { 0, 0, 1,    0.4, 0, 1,    1.0, 0, 0 } );

    else 
      ObjAnimate( "spr_lampwall_game_back", "pos_y",0,0, func_end, { 0, 0, -450,    0.8, 0, -450,    1.6, 0, 17 } );

    end;
  
    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_slider ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_slider" );
  cmn.CallEventHandler( "get_slider" );

end;
--------------------------------------------------------------------------------------------
function private.get_hexagon1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_hexagon1" );
  cmn.CallEventHandler( "get_hexagon1" );

end;
--------------------------------------------------------------------------------------------
function private.get_saucepan ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_saucepan" );
  cmn.CallEventHandler( "get_saucepan" );

  common_impl.StopAudio( "env", "level1/env/aud_drop_water" );
  AnimStop( "anm_bodyguardthings_water_2", "DopAnim" );

  common_impl.PlayAudio( "env", "level1/env/aud_drop_water",  1, "", 0 );
  AnimPlay( "anm_bodyguardthings_water", "DopAnim", "" );

end;
--------------------------------------------------------------------------------------------
function private.get_chain1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_chain1" );
  cmn.CallEventHandler( "get_chain1" );

  if cmn.IsEventDone( "get_boathookhead" ) then 
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_boathookhead ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_boathookhead" );
  cmn.CallEventHandler( "get_boathookhead" );

  if cmn.IsEventDone( "get_chain1" ) then 
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_picklockclip ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_picklockclip" );
  cmn.CallEventHandler( "get_picklockclip" );

end;
--------------------------------------------------------------------------------------------
function private.get_bulbbox ()

  cmn.Lock( true );

  local func_end = function ()

    cmn.Lock( false );

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_bulbbox" );
    cmn.CallEventHandler( "get_bulbbox" );

  end;

  ObjAnimate( "spr_reception_bulbbox", "pos_y", 0, 0, func_end, { 0, 0, 116,   0.5, 3, -89 } );
  ObjAnimate( "spr_reception_bulbbox", "croprect_h", 0, 0, "", { 0, 0, 150,   0.5, 3, 355 } );

end;
--------------------------------------------------------------------------------------------
function private.get_plaster ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_plaster" );
  cmn.CallEventHandler( "get_plaster" );

end;
--------------------------------------------------------------------------------------------
function private.get_leverlamp ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_leverlamp" );
  cmn.CallEventHandler( "get_leverlamp" );

end;
--------------------------------------------------------------------------------------------
function private.get_developingliquid ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_developingliquid" );
  cmn.CallEventHandler( "get_developingliquid" );

end;
--------------------------------------------------------------------------------------------
function private.get_razor ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_razor" );
  cmn.CallEventHandler( "get_razor" );

end;
--------------------------------------------------------------------------------------------
function private.get_scoop ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_scoop" );
  cmn.CallEventHandler( "get_scoop" );

  if port.isPortable()==1 then
      iOS_RateMe();
  end;
end;
--------------------------------------------------------------------------------------------
function private.get_receptionbell ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_receptionbell" );
  cmn.CallEventHandler( "get_receptionbell" );

  if ( cmn.IsEventDone( "get_hexagon2") and
      cmn.IsGetCollect2( "get_collect2_item_1_4" ) ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_toolbox ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_toolbox" );
  cmn.CallEventHandler( "get_toolbox" );

end;
--------------------------------------------------------------------------------------------
function private.get_hexagon2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_hexagon2" );
  cmn.CallEventHandler( "get_hexagon2" );

  common_impl.ShowBbt( "bbt_hall_get_hexagon2" );

  if ( cmn.IsEventDone( "get_receptionbell" ) and 
      cmn.IsGetCollect2( "get_collect2_item_1_4" ) ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_magnet ()

  ObjDelete( "gfx_lampwall_magnet" );
  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_magnet" );
  cmn.CallEventHandler( "get_magnet" );

end;
--------------------------------------------------------------------------------------------
function private.get_valve ()

  ObjDelete( "gfx_lampwall_valve" );
  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_valve" );
  cmn.CallEventHandler( "get_valve" );

end;
--------------------------------------------------------------------------------------------
function private.get_lionpen1 ()

  ObjDelete( "gfx_lampwall_lionpen1" );
  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_lionpen1" );
  cmn.CallEventHandler( "get_lionpen1" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_1_4 ()

  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_1_4" ); 

    if ( cmn.IsEventDone( "get_receptionbell" ) and  
        cmn.IsEventDone( "get_hexagon2" ) ) then

      common.CloseSubRoom();

    end;

  end;

  common_impl.PlayEffectHO( "spr_collect2_item_1_4", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_1_4" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_1_5 ()

  common_impl.PlayEffectHO( "spr_collect2_item_1_5", function() cmn.CallEventHandler( "get_collect2_item_1_5" ); end );
  common_impl.GetCollect2Done( "get_collect2_item_1_5" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_courtyard_door ()

  cmn.CallEventHandler( "clk_courtyard_door_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_courtyard_door" );
    cmn.CallEventHandler( "clk_courtyard_door_end" );

    common_impl.ShowBbt( "bbt_hall_clk_courtyard_door" );

    interface.KeyTaskAdd( "go_to_courtyard" );

    if cmn.IsEventStart( "see_tutorial" ) and IsCollectorsEdition() then

      common_impl.TutorialShow( "tutorial_page_23" );

    end;

  end;

  cmn.Lock( true );

  func_end();
  private.HallClickCourtyardDoor();

end;
--------------------------------------------------------------------------------------------
function private.clk_reception_slider ()

  cmn.CallEventHandler( "clk_reception_slider_beg" );

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_zipper", 0, "", 0 );

  local func_open = function ()

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_reception_slider" );
      cmn.CallEventHandler( "clk_reception_slider_end" );

    end;

    ObjAnimate( "spr_reception_purse_open", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0, 
      0.5, 0, 1
    } );  

  end;

  AnimPlay( "anm_reception_slider", "DoAnim", func_open );

end;
--------------------------------------------------------------------------------------------
function private.clk_reception_paperclip_1 ()

  cmn.CallEventHandler( "clk_reception_paperclip_1_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_reception_paperclip_1" );
    cmn.CallEventHandler( "clk_reception_paperclip_1_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_clip", 0, "", 0 );

  ObjAnimate( "spr_reception_note_paperclip_1", "alp", 0, 0, func_end,
  { 
    0.0, 0, 1, 
    0.3, 0, 0
  } );

  ObjAnimate( "spr_reception_note_paperclip_2", "alp", 0, 0, "",
  { 
    0.0, 0, 0, 
    0.3, 0, 1
  } ); 

end;
--------------------------------------------------------------------------------------------
function private.clk_reception_paperclip_2 ()

  cmn.CallEventHandler( "clk_reception_paperclip_2_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_reception_paperclip_2" );
    cmn.CallEventHandler( "clk_reception_paperclip_2_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_clip", 0, "", 0 );

  ObjAnimate( "spr_reception_note_paperclip_2", "alp", 0, 0, func_end,
  { 
    0.0, 0, 1, 
    0.3, 0, 0
  } );

  ObjAnimate( "spr_reception_picklockclip", "alp", 0, 0, "",
  { 
    0.0, 0, 0, 
    0.3, 0, 1
  } ); 

end;
--------------------------------------------------------------------------------------------
function private.clk_reception_bell ()

  cmn.CallEventHandler( "clk_reception_bell_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_reception_bell" );
    cmn.CallEventHandler( "clk_reception_bell_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_call", 0, "", 0 );

  ObjAnimate( "spr_reception_door_bell_close_bell_part", "pos_y", 0, 0, "",
  { 
    0.0, 0, -81, 
    0.1, 1, -71,
    0.3, 3, -81
  } );

  ObjAnimate( "spr_reception_door_bell_close", "alp", 0, 0, "",
  { 
    0.0, 0, 1, 
    0.5, 0, 1,
    1.0, 0, 0
  } );

  ObjAnimate( "spr_reception_door_bell_open", "alp", 0, 0, func_end,
  { 
    0.0, 0, 0, 
    0.5, 0, 0,
    1.0, 0, 1
  } ); 

end;
--------------------------------------------------------------------------------------------
function private.clk_reception_door_1 ()

  cmn.CallEventHandler( "clk_reception_door_1_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_reception_door_1" );
    cmn.CallEventHandler( "clk_reception_door_1_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_drawer_handle", 0, "", 0 );

  ObjAnimate( "spr_reception_door_close_1", "alp", 0, 0, func_end,
  { 
    0.0, 0, 1, 
    0.5, 0, 0
  } );

  ObjAnimate( "spr_reception_door_open_1", "alp", 0, 0, "",
  { 
    0.0, 0, 0, 
    0.5, 0, 1
  } ); 

end;
--------------------------------------------------------------------------------------------
function private.clk_reception_door_2 ()

  cmn.CallEventHandler( "clk_reception_door_2_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_reception_door_2" );
    cmn.CallEventHandler( "clk_reception_door_2_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_drawer_handle", 0, "", 0 );

  ObjAnimate( "spr_reception_door_close_2", "alp", 0, 0, func_end,
  { 
    0.0, 0, 1, 
    0.5, 0, 0
  } );

  ObjAnimate( "spr_reception_door_open_2", "alp", 0, 0, "",
  { 
    0.0, 0, 0, 
    0.5, 0, 1
  } ); 

end;
--------------------------------------------------------------------------------------------
function private.clk_bodyguardthings_valve ()

  cmn.CallEventHandler( "clk_bodyguardthings_valve_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_bodyguardthings_valve" );
    cmn.CallEventHandler( "clk_bodyguardthings_valve_end" );

  end;


  local func_end_first = function ()

    ObjSet( "vid_bodyguardthings_water", { alp = 0, visible = true } );
    ObjAnimate( "vid_bodyguardthings_water", "alp",0,0, "", { 0, 0, 0,    0.3, 0, 1 } );
    VidPlay( "vid_bodyguardthings_water", func_end );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_valve", 0, "", 0 );

  common_impl.StopAudio( "env", "level1/env/aud_drop_water" );
  AnimStop( "anm_bodyguardthings_water", "DopAnim" );
  AnimStop( "anm_bodyguardthings_water_2", "DopAnim" );

  local time = 0.4;

  ObjAnimate( "spr_bodyguardthings_valve_before", "alp",0,0, "", { 0, 2, 1,    0.1, 2, 1,    time, 2, 0 } );
  ObjAnimate( "spr_bodyguardthings_valve_middle", "alp",0,0, "", { 0, 1, 0,    time, 1, 1,    time+0.1, 2, 1,    2*time, 2, 0 } );
  ObjAnimate( "spr_bodyguardthings_valve_after", "alp",0,0, func_end_first, { 0, 1, 0,    time, 1, 0,    2*time, 1, 1 } );

  ObjAnimate( "anm_bodyguardthings_water_2", "alp",0,0, "", { 0, 0, 1,    time, 0, 0 } );

end;

--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG LAMPWALL *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************

  private.lampwall_state = {};

  private.lampwall_state_win = {
                                  { 1, 2, 3 }, 
                                  { 4, 5, 6 },
                                  { 7, 8, -1 }
                               };

  local LAMPWALL_PART_COUNT = 8;
  local LAMPWALL_PART_NAME = "spr_lampwall_part_";

  local LAMPWALL_START_X = -100;
  local LAMPWALL_START_Y = -80;

  local LAMPWALL_DELTA_X = 100;
  local LAMPWALL_DELTA_Y = 100;

  local movingType = "";
  local index1 = 0;
  local index2 = 0;

  --*******************************************************************************************************************
  function private.LampWallDefault ()

    -- 0 - deadlock,
    -- (-1) - hole,
    -- else - part number

    private.lampwall_state = {
                                { 5, 8, 2 }, 
                                { 7, 3, 4 },
                                { 6, 1, -1 }
                             };

  end; 


  --*******************************************************************************************************************
  function private.LampWallLoad ()

    private.lampwall_state = ng_global.progress[ "std" ][ "win_lampwall" ].state;

    if not private.lampwall_state then 
      private.LampWallDefault();
    end; 

  end;


  --*******************************************************************************************************************
  function private.LampWallSave ()

    ng_global.progress[ "std" ][ "win_lampwall" ].state = private.lampwall_state;

  end;


  --*******************************************************************************************************************
  function private.InitLampWall ()   

    for i = 1, LAMPWALL_PART_COUNT, 1 do

      local currentPart = LAMPWALL_PART_NAME..i;
      ObjSet( currentPart, { 
                              input = 1,
                              event_mdown = function () private.LampWallClick( i ); end,
                              event_menter = function () private.LampWallEnter( i ); end,
                              event_mleave = function () private.LampWallELeave( i ); end
                            } );

    end;

  end;

  --*******************************************************************************************************************
  function private.LampWallEnter ( id )
   
    SetCursor( CURSOR_HAND );
    local current = LAMPWALL_PART_NAME..id.."_enter";
    local alpha = ObjGet( current ).alp;

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_menter1", 0, "", 0 );

    ObjAnimate( current, "alp",0,0, "", { 0, 0, alpha,    0.2 * ( 1 - alpha ), 0, 1 } );
  
  end;


  --*******************************************************************************************************************
  function private.LampWallELeave ( id )  
 
    SetCursor( CURSOR_DEFAULT );
    local current = LAMPWALL_PART_NAME..id.."_enter";
    local alpha = ObjGet( current ).alp;
    ObjAnimate( current, "alp",0,0, "", { 0, 0, alpha,    0.2 * alpha, 0, 0 } );

  end;


  --*******************************************************************************************************************
  function private.GiveMovingType ( id )

    for i = 1, #private.lampwall_state, 1 do 

      local line = private.lampwall_state[i];

      for j = 1, #line, 1 do 

        if line[j] == id then 
          index1 = i;
          index2 = j;
          break;
        end;

      end;

    end;

    if index2 > 1 and private.lampwall_state[index1][index2-1] == -1 then 

      movingType = "LEFT";

    elseif index2 < 3 and private.lampwall_state[index1][index2+1] == -1 then
 
      movingType = "RIGHT";

    elseif index1 > 1 and private.lampwall_state[index1-1][index2] == -1 then 

      movingType = "UP";

    elseif index1 < 3 and private.lampwall_state[index1+1][index2] == -1 then 

      movingType = "DOWN";

    else 

      movingType = "NO";

    end; 

  end;


  --*******************************************************************************************************************
  function private.LampWallClick ( id )

    private.GiveMovingType( id );
    local currentPart = LAMPWALL_PART_NAME..id;

    local func_end = function ()

      ObjSet( "obj_lampwall_mmg", { input = true } );
      private.Update();

    end;

    if movingType == "LEFT" then 

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_mmg_lampwall_clk1", 0, "", 0 );

      local startX = LAMPWALL_START_X + LAMPWALL_DELTA_X*( index2 - 1 );
      local endX = LAMPWALL_START_X + LAMPWALL_DELTA_X*( index2 - 2 );

      private.lampwall_state[index1][index2-1] = id;
      private.lampwall_state[index1][index2] = -1;

      ObjSet( "obj_lampwall_mmg", { input = false } );
      ObjAnimate( currentPart, "pos_x",0,0, func_end, { 0, 2, startX,    0.4, 2, endX } );


    elseif movingType == "RIGHT" then 

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_mmg_lampwall_clk1", 0, "", 0 );

      local startX = LAMPWALL_START_X + LAMPWALL_DELTA_X*( index2 - 1 );
      local endX = LAMPWALL_START_X + LAMPWALL_DELTA_X*( index2 );

      private.lampwall_state[index1][index2+1] = id;
      private.lampwall_state[index1][index2] = -1;

      ObjSet( "obj_lampwall_mmg", { input = false } );
      ObjAnimate( currentPart, "pos_x",0,0, func_end, { 0, 2, startX,    0.4, 2, endX } );


    elseif movingType == "UP" then 

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_mmg_lampwall_clk1", 0, "", 0 );

      local startY = LAMPWALL_START_Y + LAMPWALL_DELTA_Y*( index1 - 1 );
      local endY = LAMPWALL_START_Y + LAMPWALL_DELTA_Y*( index1 - 2 );

      private.lampwall_state[index1-1][index2] = id;
      private.lampwall_state[index1][index2] = -1;

      ObjSet( "obj_lampwall_mmg", { input = false } );
      ObjAnimate( currentPart, "pos_y",0,0, func_end, { 0, 2, startY,    0.4, 2, endY } );


    elseif movingType == "DOWN" then 

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_mmg_lampwall_clk1", 0, "", 0 );

      local startY = LAMPWALL_START_Y + LAMPWALL_DELTA_Y*( index1 - 1 );
      local endY = LAMPWALL_START_Y + LAMPWALL_DELTA_Y*( index1 );

      private.lampwall_state[index1+1][index2] = id;
      private.lampwall_state[index1][index2] = -1;

      ObjSet( "obj_lampwall_mmg", { input = false } );
      ObjAnimate( currentPart, "pos_y",0,0, func_end, { 0, 2, startY,    0.4, 2, endY } );

    else 

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_mmg_lampwall_clk2", 0, "", 0 );

    end;

    private.LampWallSave(); 

  end;


  --*******************************************************************************************************************
  function private.LampWallIsWin()

    local count = 0;
    local result = false;

    for i = 1, #private.lampwall_state, 1 do 

      local line = private.lampwall_state[i];

      for j = 1, #line, 1 do 

        if private.lampwall_state[i][j] == private.lampwall_state_win[i][j] then 
          count = count + 1;
        end;  

      end;

    end;

    if count >= LAMPWALL_PART_COUNT then 
      result = true;
    end;

    return result;

  end;


  --*******************************************************************************************************************
  function private.LampWallWin ()

    ObjSet( "obj_lampwall_mmg", { input = false } );
    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      cmn.MiniGameHide( "lampwall" );
      common_impl.PassingMgWin( "lampwall");  

      cmn.SetEventDone( "win_lampwall" );
      cmn.CallEventHandler( "win_lampwall" );

      common.CloseSubRoom();
      private.HallDoorOpen();

    end;

    ObjAnimate( "spr_lampwall_game_back_end_light", "alp",0,0, func_end, { 0, 0, 0,    1, 0, 1,    1.6, 0, 0.2,    2.5, 0, 1 } );

  end;


  --*******************************************************************************************************************
  function private.Update ()
 
    for i = 1, #private.lampwall_state, 1 do 

      local line = private.lampwall_state[i];
      local currentY = LAMPWALL_START_Y + LAMPWALL_DELTA_Y*( i - 1 );

      for j = 1, #line, 1 do 

        --DbgTrace( "private.lampwall_state["..i.."]["..j.."]="..line[j] );

        if line[j] ~= -1 then

          local currentX = LAMPWALL_START_X + LAMPWALL_DELTA_X*( j - 1 );
          local currentPart = LAMPWALL_PART_NAME..line[j];
          ObjSet( currentPart, { pos_x = currentX, pos_y = currentY } );
    
        end;

      end;

    end;

    if private.LampWallIsWin() then 
      private.LampWallWin();
    end;

  end;



  --*******************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_hall()

  if not ( cmn.IsEventDone( "opn_hall" ) ) then

    cmn.SetEventDone( "opn_hall" );

    ng_global.progress[ "std" ][ "opn_hall" ].opn_hall_bodyguardthings = false;

    ObjSet( "tmr_hall_disappearance_professor", { playing = true, time = 3, endtrig = private.DisappearanceProfessor } );

  end;

  cmn.CallEventHandler( "opn_hall" ); 

end;
--*********************************************************************************************************************
function private.ClkUseMagnet()

  cmn.Lock( true );
  common_impl.ShowBbt( 'bbt_windowsill_use_magnet_2' );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk4", 0, "", 0 );

  ObjAnimate( "spr_windowsill_magnet_1", "pos_y", 0, 0, function() cmn.Lock( false ); end, { 0, 0, 194,   0.2, 3, 192,   0.4, 3, 194 } )

end;
--*********************************************************************************************************************
function private.ClkUsePicklockclip()

  cmn.Lock( true );
  common_impl.ShowBbt( "bbt_windowsill_use_picklockclip" );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk2", 0, "", 0 );  

  ObjAnimate( "spr_windowsill_door_close", "pos_y", 0, 0, function() cmn.Lock( false ); end, { 0, 0, 63,   0.1, 3, 64,   0.2, 3, 63 } )

end;
--*********************************************************************************************************************
function private.ClkLionpen1()

  cmn.Lock( true );
  common_impl.ShowBbt( "bbt_reception_use_lionpen1" );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk2", 0, "", 0 );  
  ObjAnimate( "spr_reception_door_close_1", "pos_y", 0, 0, function() cmn.Lock( false ); end, { 0, 0, -51,   0.1, 3, -50,   0.2, 3, -51 } )

end;
--*********************************************************************************************************************
function private.ClkLionpen2()

  cmn.Lock( true );
  common_impl.ShowBbt( "bbt_reception_use_lionpen2" );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk2", 0, "", 0 );  
  ObjAnimate( "spr_reception_door_close_2", "pos_y", 0, 0, function() cmn.Lock( false ); end, { 0, 0, -27,   0.1, 3, -26,   0.2, 3, -27 } )

end;
--*********************************************************************************************************************
function private.ClkPurse()

  cmn.Lock( true );
  common_impl.ShowBbt( "bbt_reception_use_slider" );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk1", 0, "", 0 );  

  ObjAnimate( "spr_reception_purse_close", "ang", 0, 0, function() cmn.Lock( false ); end, { 0, 0, 0,   0.2, 3, 0.02,   0.4, 3, 0 } )
  ObjAnimate( "spr_reception_purse_close_shadow", "ang", 0, 0, "", { 0, 0, 0,   0.2, 3, 0.02,   0.4, 3, 0 } )

end;
--*********************************************************************************************************************
function private.DisappearanceProfessor ()

  local func_end = function ()

    cmn.SetEventDone( "see_disappearance_professor" );
    cmn.CallEventHandler( "see_disappearance_professor" );

    common_impl.StopAudio( "voc", "level1/voc/aud_hall_disappearance_professor_voc", 0.2 );
    common_impl.StopAudio( "sfx", "level1/sfx/aud_hall_disappearance_professor", 0.2 );
    common_impl.EnvPlay( { "level1/env/aud_hall_env" }, "", 0.5 );

    common_impl.ShowBbt( "bbt_hall_see_disappearance_professor" );

    interface.KeyTaskDone( true );

  end;

  ObjSet( "tmr_hall_disappearance_professor", { playing = false } );
  int_blackbartext.Hide();

  common_impl.PlayAudio(  "mus", "level1/mus/aud_hall_disappearance_professor_mus", 0 );
  common_impl.PlayAudio( "voc", "level1/voc/aud_hall_disappearance_professor_voc", 0, "", 0 );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_hall_disappearance_professor", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_hall_disappearance_professor", func_end );

end;
--*********************************************************************************************************************
function private.MaskedMan_1 ()

  local func_end = function ()

    cmn.SetEventDone( "see_masked_man_1" );
    cmn.CallEventHandler( "see_masked_man_1" );
    common_impl.ShowBbt( "bbt_hall_see_masked_man_1" );
    interface.KeyTaskAdd( "save_professor" );

    common_impl.StopAudio( "sfx", "level1/sfx/aud_masked_man_1", 0.2 );
    common_impl.StopAudio( "voc", "level1/voc/aud_masked_man_1_voc", 0.2 );

    common_impl.PlayAudio(  "mus", "aud_masked_man_theme_mus", 0 );

  end;

  common_impl.PlayAudio( "voc", "level1/voc/aud_masked_man_1_voc", 0, "", 0 );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_masked_man_1", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_hall_masked_man_1", func_end );

end;
--*********************************************************************************************************************
function private.HallScare_2 ()

  local func_end = function ()

    cmn.SetEventDone( "see_hall_scare_2" );
    cmn.CallEventHandler( "see_hall_scare_2" );

    --cmn.GotoRoom( "rm_demo" );

    --common_impl.StopAudio( "sfx", "level1/sfx/aud_hall_disappearance_professor", 0.2 );

    --cmn.PlayMusDanger();

  end;

  func_end();

  --тут анимация пуглаки


--  common_impl.PlayAudio( "sfx", "level1/sfx/aud_hall_disappearance_professor", 0, "", 0 );

--  cmn.PlayDialogVideo( "vid_hall_disappearance_professor", func_end );

end;
--*********************************************************************************************************************

function private.FlashbackHall ()

  local func_end = function ()

    common_impl.ShowBbt( "bbt_hall_see_flashback_hall" );

    cmn.SetEventDone( "see_flashback_hall" );
    cmn.CallEventHandler( "see_flashback_hall" );

    common_impl.StopAudio( "voc", "level1/voc/aud_hall_flashback_hall_voc", 0.2 );
    common_impl.StopAudio( "sfx", "level1/sfx/aud_hall_flashback_hall", 0.2 );

    common_impl.PlayAudio(  "mus", "aud_masked_man_theme_mus", 0 );

    interface.KeyTaskDone( true );

  end;

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_hall_flashback_hall", 0, "", 0 );
  common_impl.PlayAudio( "voc", "level1/voc/aud_hall_flashback_hall_voc", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_hall_flashback_hall", func_end );

end;

--*********************************************************************************************************************
function private.HallDoorOpen ()

  local func_end = function ()

    ObjSet( "spr_hall_courtyard_door_open", { alp = 1 } );

    ObjAnimate( "rm_hall", "alp",0,0, function() private.FlashbackHall(); end, { 0, 0, 1,    0.7, 0, 1 } );

    common_impl.StopAudio( "sfx", "level1/sfx/aud_open_door_exit", 0.2 );

  end;

  ObjSet( "obj_hall_clk_courtyard_door_2", { input = false} );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_open_door_exit", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_hall_door_open", func_end );

end;

--*********************************************************************************************************************
function private.HallScare_3 ()

  local func_end = function ()

    cmn.SetEventDone( "see_hall_scare_3" );
    cmn.CallEventHandler( "see_hall_scare_3" );

    common_impl.ShowBbt( "bbt_hall_see_hall_scare_3" );
    --cmn.GotoRoom( "rm_demo" );

    --common_impl.StopAudio( "sfx", "level1/sfx/aud_hall_disappearance_professor", 0.2 );

    --cmn.PlayMusDanger();

  end;

  func_end();

  --тут анимация пуглаки


--  common_impl.PlayAudio( "sfx", "level1/sfx/aud_hall_disappearance_professor", 0, "", 0 );

--  cmn.PlayDialogVideo( "vid_hall_disappearance_professor", func_end );

end;
--*********************************************************************************************************************
function private.ClkNote ()

  cmn.NoteScale( "spr_reception_note" );
  ObjSet( "obj_reception_note_hint", { pos_x = -6, pos_y = -3 } );

end;
--*********************************************************************************************************************
function private.ClkNoteBig ()

  cmn.NoteScale( "spr_reception_note" );
  ObjSet( "obj_reception_note_hint", { pos_x = 218, pos_y = 173 } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** ANIMATIONS *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_hall_light_1", "alp",1,0, "", { 0, 3, 0.1,    0.5, 3, 1,    1.3, 3, 0.4,    2.0, 3, 1,    3.2, 3, 0.1 } );

  ObjAnimate( "spr_hall_light_2", "alp",1,0, "", { 0, 3, 1,    0.4, 3, 0.3,    1.2, 3, 1,    1.5, 3, 0.4,    2.8, 3, 1 } );

  ObjAnimate( "spr_hall_light_3", "alp",1,0, "", { 0, 3, 0.2,    0.7, 3, 0.3,    1.9, 3, 0.1,    2.4, 3, 0.3,    3.6, 3, 0.2 } );

  ObjAnimate( "spr_hall_light_4", "alp",1,0, "", { 0, 3, 0.7,    0.9, 3, 0.1,    2.2, 3, 0.4,    4.0, 3, 1,    5.1, 3, 0.7 } );

  ObjAnimate( "spr_hall_reception_light", "alp", 1, 0, "",
    { 
      0.0, 0, 1, 
      1.6, 0, 0.4,
      1.7, 0, 0,
      1.8, 0, 1,
    } );   

  ------------------------------------------------------------------------------------------

  ObjAnimate( "spr_lampwall_left_lamp_light", "alp",1,0, "", { 0, 3, 0.1,    0.9, 3, 0.7,    2.2, 3, 1,    4.0, 3, 0.4,    5.1, 3, 0.1 } );
  ObjAnimate( "spr_lampwall_right_lamp_light", "alp",1,0, "", { 0, 3, 0.7,    0.9, 3, 0.1,    2.2, 3, 0.4,    4.0, 3, 1,    5.1, 3, 0.7 } );

  ------------------------------------------------------------------------------------------

  ObjAnimate( "spr_windowsill_light", "alp", 1, 0, "",
    { 
      0.0, 0, 1.0, 
      2.0, 0, 0.5,
      4.0, 0, 1.0
    } );

  ObjAnimate( "spr_reception_light", "alp", 1, 0, "",
    { 
      0.0, 0, 1.0, 
      2.0, 0, 0.5,
      4.0, 0, 1.0
    } );

end;


--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************

function private.LampwallFeedbackAnim()

  common_impl.ShowBbt( "bbt_lampwall_use_screwdriver_1" );

  local obj = "spr_lampwall_grid";
  local x_start = ObjGet( obj ).pos_x;
  local y_start = ObjGet( obj ).pos_y;

  local time = 0.3;
  local dx = 1;
  local dy = -1;

  ObjSet( "obj_lampwall_use_screwdriver_1", { input = false } );

  local func_end = function ()

    ObjSet( "obj_lampwall_use_screwdriver_1", { input = true } );

  end;

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk3", 0, "", 0 );

  ObjAnimate( obj, "pos_x",0,0, "", { 0,0,x_start, time/4,0,x_start+dx, 3/4*time,0,x_start-dx, time,0,x_start } ); 
  ObjAnimate( obj, "pos_y",0,0, func_end, { 0,0,y_start, time/4,0,y_start+dy, 3/4*time,0,y_start-dy, time,0,y_start });  

end;

--*********************************************************************************************************************

function private.BodyguardthingsFeedbackAnim()

  common_impl.ShowBbt( "bbt_bodyguardthings_clk_badge" );

  local obj = "spr_bodyguardthings_badge";
  local x_start = ObjGet( obj ).pos_x;
  local y_start = ObjGet( obj ).pos_y;

  local time = 0.3;
  local dx = 1;
  local dy = -1;

  ObjSet( "spr_bodyguardthings_badge", { input = false } );

  local func_end = function ()

    ObjSet( "spr_bodyguardthings_badge", { input = true } );

  end;

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk1", 0, "", 0 );

  ObjAnimate( obj, "pos_x",0,0, "", { 0,0,x_start, time/4,0,x_start+dx, 3/4*time,0,x_start-dx, time,0,x_start } ); 
  ObjAnimate( obj, "pos_y",0,0, func_end, { 0,0,y_start, time/4,0,y_start+dy, 3/4*time,0,y_start-dy, time,0,y_start });  

end;

--*********************************************************************************************************************

function private.BodyguardthingsFeedbackAnimHook()

  common_impl.ShowBbt( "bbt_bodyguardthings_use_clippers_1" );

  local obj = "obj_bodyguardthings_chain_before_1";
  local x_start = ObjGet( obj ).pos_x;
  local y_start = ObjGet( obj ).pos_y;

  local time = 0.3;
  local dx = 1;
  local dy = -1;

  ObjSet( "obj_bodyguardthings_use_clippers_1", { input = false } );

  local func_end = function ()

    ObjSet( "obj_bodyguardthings_use_clippers_1", { input = true } );

  end;

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_chain", 0, "", 0 );

  ObjAnimate( obj, "pos_x",0,0, "", { 0,0,x_start, time/4,0,x_start+dx, 3/4*time,0,x_start-dx, time,0,x_start } ); 
  ObjAnimate( obj, "pos_y",0,0, func_end, { 0,0,y_start, time/4,0,y_start+dy, 3/4*time,0,y_start-dy, time,0,y_start });  

-----------------------------------------------------

  local obj_2 = "obj_bodyguardthings_chain_before_2";
  local x_start_2 = ObjGet( obj_2 ).pos_x;
  local y_start_2 = ObjGet( obj_2 ).pos_y;

  local dx_2 = -1;
  local dy_2 = 1;

  ObjAnimate( obj_2, "pos_x",0,0, "", { 0,0,x_start_2, time/4,0,x_start_2+dx_2, 3/4*time,0,x_start_2-dx_2, time,0,x_start_2 } ); 
  ObjAnimate( obj_2, "pos_y",0,0, "", { 0,0,y_start_2, time/4,0,y_start_2+dy_2, 3/4*time,0,y_start_2-dy_2, time,0,y_start_2 });  

end;

--*********************************************************************************************************************

function private.BodyguardthingsFeedbackAnimHexagon()

  common_impl.ShowBbt( 'bbt_bodyguardthings_use_magnet_1' );

  local obj = "spr_bodyguardthings_hexagon_before";
  local x_start = ObjGet( obj ).pos_x;
  local y_start = ObjGet( obj ).pos_y;

  local time = 0.3;
  local dx = 1;
  local dy = -1;

  ObjSet( "obj_bodyguardthings_use_magnet_1", { input = false } );
  local func_end = function ()
    ObjSet( "obj_bodyguardthings_use_magnet_1", { input = true } );
  end;

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk4", 0, "", 0 );

  ObjAnimate( obj, "pos_x",0,0, "", { 0,0,x_start, time/4,0,x_start+dx, 3/4*time,0,x_start-dx, time,0,x_start } ); 
  ObjAnimate( obj, "pos_y",0,0, func_end, { 0,0,y_start, time/4,0,y_start+dy, 3/4*time,0,y_start-dy, time,0,y_start });  

end;

--*********************************************************************************************************************

function private.HallClickCourtyardDoor()

  local func_end = function ()

    cmn.Lock( false );
    ObjSet( "obj_hall_clk_courtyard_door_2", { input = true } );
    ObjSet( "vid_hall_clk_courtyard_door", { alp = 0 } );
    common_impl.ShowBbt( "bbt_hall_clk_courtyard_door_2" );

  end;

  cmn.Lock( true );
  ObjSet( "obj_hall_clk_courtyard_door_2", { input = false } );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_hall_clk_courtyard_door", 0, "", 0 );

  ObjAnimate( "vid_hall_clk_courtyard_door", "alp",0,0, "", { 0, 0, 0,    0.3, 0, 1 } );
  VidPlay( "vid_hall_clk_courtyard_door", func_end );

end;

--*********************************************************************************************************************









