-- name=rm_lounge
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_lounge";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_coffeetable", "room_hub" );
  ObjAttach( "zz_washbasin", "room_hub" );
  ObjAttach( "zz_mousehole", "room_hub" );
  ObjAttach( "zz_brokenchandelier", "room_hub" );
  private.Init_Subroom();
  private.Init_Animations();

  ObjMultiSet({ 
    { "spr_coffeetable_switch",                     { event_mdown = private.get_switch } },
    { "spr_washbasin_wire",                         { event_mdown = private.get_wire } },
    { "spr_washbasin_arrow",                        { event_mdown = private.get_arrow } },
    { "spr_washbasin_drainplug",                    { event_mdown = private.get_drainplug } },
    { "spr_washbasin_basreliefpart",                { event_mdown = private.get_basreliefpart } },
    { "spr_mousehole_figurinepart",                 { event_mdown = private.get_figurinepart } },
    { "spr_mousehole_mousetrap",                    { event_mdown = private.get_mousetrap } },
    { "spr_brokenchandelier_crystalfigurine",       { event_mdown = private.get_crystalfigurine } },
    { "spr_brokenchandelier_broom",                 { event_mdown = private.get_broom } },
    { "obj_coffeetable_clk_wire",                   { event_mdown = private.clk_wire } },
    { "obj_coffeetable_clk_figurinepart",           { event_mdown = private.clk_figurinepart } },
    { "obj_washbasin_clk_safetylock_1",             { event_mdown = private.clk_safetylock_1 } },
    { "obj_washbasin_clk_safetylock_2",             { event_mdown = private.clk_safetylock_2 } },
    { "obj_washbasin_use_boathook_1",               { event_mdown = private.WashbasinClickWater } },
    { "obj_washbasin_use_safetylock",               { event_mdown = private.WashbasinClickButton } },
    { "obj_mousehole_clk_switch",                   { event_mdown = private.clk_switch } },
    { "obj_mousehole_clk_spring",                   { event_mdown = private.clk_spring_mousehole } },
    { "obj_lounge_mmg_crossbow_click",              { event_mdown = private.CrossbowClick } },
    { "obj_lounge_use_chargedcrossbow",             { event_mdown = private.ChargedcrossbowClick } },
    { "obj_washbasin_use_screwdriver_2",            { event_mdown = private.UseScrewdriver_2Click } },
    { "obj_washbasin_clk_valve_right",              { event_mdown = private.ClkValveRight } },
    { "obj_washbasin_clk_valve_left",               { event_mdown = private.ClkValveLeft} },
    { "obj_coffeetable_use_wire",                   { event_mdown = private.CoffeetableFeedbackAnim } },
    { "obj_coffeetable_use_figurinepart",           { event_mdown = private.CoffeetableClickButton } },
    { "obj_brokenchandelier_use_broom",             { event_mdown = private.BrokenchandelierFeedbackAnim } },
    { "obj_washbasin_use_magnet_3",                 { event_mdown = private.WashbasinClickArrow } },
    { "obj_lounge_clk_masked_man_3",                { event_mdown = private.MaskedMan_3 } },
    { "obj_lounge_clk_masked_man_3_focus",          { event_mdown = private.MaskedMan_3 } },
    { "spr_collect2_item_1_3",                      { event_mdown = private.get_collect2_item_1_3 } },
    { "spr_lounge_collect_item",                    { event_mdown = function () common_impl.GetCollectItem( "get_collect_item_1_2" ); end } },
    { "spr_lounge_collect_morph_item",              { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_1_3" ); end,  } },

  } );

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_lounge = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "gho_lounge_stash",
      "gho_lounge_floorhole",
      "gzz_lounge_coffeetable",
      "gzz_lounge_washbasin",
      "gzz_lounge_mousehole",
      "gzz_lounge_brokenchandelier"
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_coffeetable",
      "zz_brokenchandelier",
      "zz_mousehole",
      "zz_washbasin",
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_lounge", update_game_mode_lounge, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_lounge = function ()

  local effects_table = 
  {
    "anm_lounge_tv",
    "anm_lounge_spark",
    "anm_mousehole_arrows_light",
    "anm_mousehole_arrows_dark",
    "obj_lounge_anim" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_lounge", update_performance_mode_lounge, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_lounge () end;
  --------------------------------------------------------------------------------------------
  local opn_lounge_map = function ()

    common_impl.VisitMapRoom( "lounge" );

  end;
  cmn.AddSubscriber( "opn_lounge", opn_lounge_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_switch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_switch" ] = {
    type = "get",
    get_obj = "spr_coffeetable_switch",
    room = private.room_objname,
    zz = "zz_coffeetable",
    zz_gate = "gzz_lounge_coffeetable"
  };
  
  local get_switch_inv = function ()
  
    interface.InventoryItemAdd( "inv_switch", "spr_coffeetable_switch" );
  
  end;
  
  local get_switch_closezz = function ()
  
    ObjDelete( "spr_lounge_states_zz_coffeetable_switch" );
    ObjDelete( "gfx_coffeetable_switch" );
  
  end;
  
  cmn.AddSubscriber( "get_switch", get_switch_inv );
  cmn.AddSubscriber( "get_switch", get_switch_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wire () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wire" ] = {
    type = "get",
    get_obj = "spr_washbasin_wire",
    room = private.room_objname,
    zz = "zz_washbasin",
    zz_gate = "gzz_lounge_washbasin"
  };
  
  local get_wire_inv = function ()
  
    interface.InventoryItemAdd( "inv_wire", "spr_washbasin_wire" );
  
  end;
  
  local get_wire_closezz = function ()
  
    ObjDelete( "gfx_washbasin_wire" );

    if cmn.IsEventDone( "get_basreliefpart" ) then

      ObjDelete( "gzz_lounge_washbasin" );

    end;

  end;
  
  cmn.AddSubscriber( "get_wire", get_wire_inv );
  cmn.AddSubscriber( "get_wire", get_wire_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_arrow () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_arrow" ] = {
    type = "get",
    get_obj = "spr_washbasin_arrow",
    room = private.room_objname,
    zz = "zz_washbasin",
    zz_gate = "gzz_lounge_washbasin"
  };
  
  local get_arrow_inv = function ()
  
    interface.InventoryItemAdd( "inv_arrow", "spr_washbasin_arrow" );
    cmn.SetInvPlusRGB( "crossbow", true );

  end;
  
  local get_arrow_closezz = function ()
  
    ObjDelete( "gfx_washbasin_arrow" );
  
  end;
  
  cmn.AddSubscriber( "get_arrow", get_arrow_inv );
  cmn.AddSubscriber( "get_arrow", get_arrow_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_drainplug () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_drainplug" ] = {
    type = "get",
    get_obj = "spr_washbasin_drainplug",
    room = private.room_objname,
    zz = "zz_washbasin",
    zz_gate = "gzz_lounge_washbasin"
  };
  
  local get_drainplug_inv = function ()
  
    interface.InventoryItemAdd( "inv_drainplug", "spr_washbasin_drainplug" );
    ObjSet( "inv_drainplug", { drag = false } );
    
  end;
  
  local get_drainplug_closezz = function ()
  
    ObjDelete( "gfx_washbasin_drainplug" );

  end;
  
  cmn.AddSubscriber( "get_drainplug", get_drainplug_inv );
  cmn.AddSubscriber( "get_drainplug", get_drainplug_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_basreliefpart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_basreliefpart" ] = {
    type = "get",
    get_obj = "spr_washbasin_basreliefpart",
    room = private.room_objname,
    zz = "zz_washbasin",
    zz_gate = "gzz_lounge_washbasin"
  };
  
  local get_basreliefpart_inv = function ()
  
    interface.InventoryItemAdd( "inv_basreliefpart", "spr_washbasin_basreliefpart" );
  
  end;
  
  local get_basreliefpart_closezz = function ()

    ObjDelete( "spr_lounge_states_washbasin_basreliefpart" );  
    ObjDelete( "gfx_washbasin_basreliefpart" );

    if cmn.IsEventDone( "get_wire" ) then

      ObjDelete( "gzz_lounge_washbasin" );

    end;

  end;
  
  cmn.AddSubscriber( "get_basreliefpart", get_basreliefpart_inv );
  cmn.AddSubscriber( "get_basreliefpart", get_basreliefpart_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_figurinepart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_figurinepart" ] = {
    type = "get",
    get_obj = "spr_mousehole_figurinepart",
    room = private.room_objname,
    zz = "zz_mousehole",
    zz_gate = "gzz_lounge_mousehole"
  };


  local get_figurinepart_beg = function ()
  
    ObjSet( "spr_mousehole_statuette_without_shadow", { alp = 1, visible = true } );
    ObjDelete( "spr_mousehole_figurinepart" );

  end;
  
  local get_figurinepart_inv = function ()
  
    interface.InventoryItemAdd( "inv_figurinepart", "spr_mousehole_statuette_without_shadow" );
  
  end;
  
  local get_figurinepart_closezz = function ()
  
    if ( cmn.IsGetCollect2( "get_collect2_item_1_3" ) ) then 

      ObjDelete( "gzz_lounge_mousehole" );
  
    end;
 
  end;
  
  cmn.AddSubscriber( "get_figurinepart", get_figurinepart_beg, private.room_objname );
  cmn.AddSubscriber( "get_figurinepart", get_figurinepart_inv );
  cmn.AddSubscriber( "get_figurinepart", get_figurinepart_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mousetrap () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_mousetrap" ] = {
    type = "get",
    get_obj = "spr_mousehole_mousetrap",
    room = private.room_objname,
    zz = "zz_mousehole",
    zz_gate = "gzz_lounge_mousehole"
  };
  
  local get_mousetrap_inv = function ()
  
    interface.InventoryItemAdd( "inv_mousetrap", "spr_mousehole_mousetrap" );
    ObjSet( "inv_mousetrap", { drag = false } );
    
  end;
  
  local get_mousetrap_closezz = function ()
  
    ObjDelete( "gfx_mousehole_mousetrap" );
  
  end;
  
  cmn.AddSubscriber( "get_mousetrap", get_mousetrap_inv );
  cmn.AddSubscriber( "get_mousetrap", get_mousetrap_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crystalfigurine () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_crystalfigurine" ] = {
    type = "get",
    get_obj = "spr_brokenchandelier_crystalfigurine",
    room = private.room_objname,
    zz = "zz_brokenchandelier",
    zz_gate = "gzz_lounge_brokenchandelier"
  };
  
  local get_crystalfigurine_inv = function ()
  
    interface.InventoryItemAdd( "inv_crystalfigurine", "spr_brokenchandelier_crystalfigurine" );
  
  end;
  
  local get_crystalfigurine_closezz = function ()
  
    ObjDelete( "gfx_brokenchandelier_crystalfigurine" );
    ObjDelete( "gzz_lounge_brokenchandelier" );
    ObjSet( "gho_lounge_floorhole", { alp = 1, active = true, input = true } );
  
  end;
  
  cmn.AddSubscriber( "get_crystalfigurine", get_crystalfigurine_inv );
  cmn.AddSubscriber( "get_crystalfigurine", get_crystalfigurine_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brokenbroom () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_brokenbroom" ] = {
    type = "get",
    get_obj = "spr_brokenchandelier_brokenbroom",
    room = private.room_objname,
    zz = "zz_brokenchandelier",
    zz_gate = "gzz_lounge_brokenchandelier"
  };
  
  local get_brokenbroom_inv = function ()
  
    interface.InventoryItemAdd( "inv_brokenbroom", "spr_brokenchandelier_brokenbroom" );
    ObjSet( "inv_brokenbroom", { drag = false } );    

  end;
  
  local get_brokenbroom_closezz = function ()
  
    ObjDelete( "gfx_brokenchandelier_brokenbroom" );
  
  end;
  
  cmn.AddSubscriber( "get_brokenbroom", get_brokenbroom_inv );
  cmn.AddSubscriber( "get_brokenbroom", get_brokenbroom_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_1_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_1_2 = function ()
  
    ObjDelete( "obj_lounge_collect" );
  
  end;    
  cmn.AddSubscriber( "get_collect_item_1_2", get_collect_item_1_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_1_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_1_3 = function ()
  
    ObjDelete( "obj_collect2_item_1_3" );

    if ( cmn.IsEventDone( "get_figurinepart" ) ) then

      ObjDelete( "gzz_lounge_mousehole" );

    end;
  
  end;    
  cmn.AddSubscriber( "get_collect2_item_1_3", get_collect2_item_1_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_3 = function ()
  
    ObjDelete( "obj_lounge_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_3", get_collect_morph_item_1_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wire () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wire" ] = {
    type = "use",
    inv_obj = "inv_wire",
    use_place = "obj_coffeetable_use_wire",
    room = private.room_objname,
    zz = "zz_coffeetable",
    zz_gate = "gzz_lounge_coffeetable"
  };
  local use_wire_inv = function ()
  
    interface.InventoryItemRemove( "inv_wire" );
  
  end;
  local use_wire_beg = function ()
  
    ObjDelete( "obj_coffeetable_use_wire" );
  
  end;
  local use_wire_end = function ()
  
    ObjSet( "spr_coffeetable_wire", { alp = 1, visible = true } );
    ObjSet( "obj_coffeetable_clk_wire", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wire", use_wire_beg, private.room_objname );
  cmn.AddSubscriber( "use_wire", use_wire_inv );
  cmn.AddSubscriber( "use_wire", use_wire_end, private.room_objname );
  cmn.AddSubscriber( "use_wire_inv", use_wire_inv, private.room_objname );
  cmn.AddSubscriber( "use_wire_beg", use_wire_beg, private.room_objname );
  cmn.AddSubscriber( "use_wire_end", use_wire_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_figurinepart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_figurinepart" ] = {
    type = "use",
    inv_obj = "inv_figurinepart",
    use_place = "obj_coffeetable_use_figurinepart",
    room = private.room_objname,
    zz = "zz_coffeetable",
    zz_gate = "gzz_lounge_coffeetable"
  };
  local use_figurinepart_inv = function ()
  
    interface.InventoryItemRemove( "inv_figurinepart" );
  
  end;
  local use_figurinepart_beg = function ()
  
    ObjDelete( "obj_coffeetable_use_figurinepart" );
    ObjSet( "spr_lounge_states_zz_coffeetable_figure_part", { alp = 1, visible = true } );
  
  end;
  local use_figurinepart_end = function ()
  
    ObjSet( "spr_coffeetable_button_light", { visible = true } );
    ObjSet( "spr_coffeetable_figure_part_2", { alp = 1, visible = true } );
    ObjSet( "obj_coffeetable_clk_figurinepart", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_figurinepart", use_figurinepart_beg, private.room_objname );
  cmn.AddSubscriber( "use_figurinepart", use_figurinepart_inv );
  cmn.AddSubscriber( "use_figurinepart", use_figurinepart_end, private.room_objname );
  cmn.AddSubscriber( "use_figurinepart_inv", use_figurinepart_inv, private.room_objname );
  cmn.AddSubscriber( "use_figurinepart_beg", use_figurinepart_beg, private.room_objname );
  cmn.AddSubscriber( "use_figurinepart_end", use_figurinepart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_magnet_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_magnet_3" ] = {
    type = "use",
    inv_obj = "inv_magnet",
    use_place = "obj_washbasin_use_magnet_3",
    room = private.room_objname,
    zz = "zz_washbasin",
    zz_gate = "gzz_lounge_washbasin"
  };
  local use_magnet_3_inv = function ()
  
    if cmn.IsEventDone( "use_magnet_1" ) and 
    cmn.IsEventDone( "use_magnet_2" ) then
      interface.InventoryItemRemove( "inv_magnet" );
    end; 
  
  end;
  local use_magnet_3_beg = function ()
  
    ObjDelete( "obj_washbasin_use_magnet_3" );
  
  end;
  local use_magnet_3_end = function ()
  
    ObjDelete( "anm_washbasin_magnet" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_magnet_3", use_magnet_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnet_3", use_magnet_3_inv );
  cmn.AddSubscriber( "use_magnet_3", use_magnet_3_end, private.room_objname );
  cmn.AddSubscriber( "use_magnet_3_inv", use_magnet_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_magnet_3_beg", use_magnet_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnet_3_end", use_magnet_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_screwdriver_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screwdriver_2" ] = {
    type = "use",
    inv_obj = "inv_screwdriver",
    use_place = "obj_washbasin_use_screwdriver_2",
    room = private.room_objname,
    zz = "zz_washbasin",
    zz_gate = "gzz_lounge_washbasin"
  };
  local use_screwdriver_2_inv = function ()
  
    if ( cmn.IsEventDone( "use_screwdriver_1" ) ) then

      interface.InventoryItemRemove( "inv_screwdriver" );

    end;
  
  end;
  local use_screwdriver_2_beg = function ()
  
    ObjDelete( "obj_washbasin_use_screwdriver_2" );
  
  end;
  local use_screwdriver_2_end = function ()

    ObjDelete( "vid_washbasin_screwdriver" );
    ObjDelete( "spr_washbasin_basrelief_up_side" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_screwdriver_2", use_screwdriver_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_2", use_screwdriver_2_inv );
  cmn.AddSubscriber( "use_screwdriver_2", use_screwdriver_2_end, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_2_inv", use_screwdriver_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_2_beg", use_screwdriver_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_2_end", use_screwdriver_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_boathook_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_boathook_1" ] = {
    type = "use",
    inv_obj = "inv_boathook",
    use_place = "obj_washbasin_use_boathook_1",
    room = private.room_objname,
    zz = "zz_washbasin",
    zz_gate = "gzz_lounge_washbasin"
  };
  local use_boathook_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_boathook" );
  
  end;
  local use_boathook_1_beg = function ()
  
    ObjDelete( "obj_washbasin_use_boathook_1" );
  
  end;
  local use_boathook_1_end = function ()

    ObjSet( "anm_washbasin_waterfallen_2", { alp = 1 } );

    ObjDelete( "anm_washbasin_boathook" );
    ObjDelete( "spr_washbasin_fuse_light" );
    ObjDelete( "spr_washbasin_electrolight" );

    ObjDelete( "anm_washbasin_waterfallen" );
    ObjDelete( "vid_washbasin_water_light" );
    ObjDelete( "vid_washbasin_water_sink" );
    ObjDelete( "anm_lounge_spark" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_boathook_1", use_boathook_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_boathook_1", use_boathook_1_inv );
  cmn.AddSubscriber( "use_boathook_1", use_boathook_1_end, private.room_objname );
  cmn.AddSubscriber( "use_boathook_1_inv", use_boathook_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_boathook_1_beg", use_boathook_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_boathook_1_end", use_boathook_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_safetylock () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_safetylock" ] = {
    type = "use",
    inv_obj = "inv_safetylock",
    use_place = "obj_washbasin_use_safetylock",
    room = private.room_objname,
    zz = "zz_washbasin",
    zz_gate = "gzz_lounge_washbasin"
  };
  local use_safetylock_inv = function ()
  
    interface.InventoryItemRemove( "inv_safetylock" );
  
  end;
  local use_safetylock_beg = function ()
  
    ObjDelete( "obj_washbasin_use_safetylock" );
  
  end;
  local use_safetylock_end = function ()
  
    ObjSet( "spr_washbasin_safety_lock", { alp = 1, visible = true } );
    ObjSet( "obj_washbasin_clk_safetylock_1", { input = true } );

    ObjSet( "spr_washbasin_lamp_light", { active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_safetylock", use_safetylock_beg, private.room_objname );
  cmn.AddSubscriber( "use_safetylock", use_safetylock_inv );
  cmn.AddSubscriber( "use_safetylock", use_safetylock_end, private.room_objname );
  cmn.AddSubscriber( "use_safetylock_inv", use_safetylock_inv, private.room_objname );
  cmn.AddSubscriber( "use_safetylock_beg", use_safetylock_beg, private.room_objname );
  cmn.AddSubscriber( "use_safetylock_end", use_safetylock_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_switch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_switch" ] = {
    type = "use",
    inv_obj = "inv_switch",
    use_place = "obj_mousehole_use_switch",
    room = private.room_objname,
    zz = "zz_mousehole",
    zz_gate = "gzz_lounge_mousehole"
  };
  local use_switch_inv = function ()
  
    interface.InventoryItemRemove( "inv_switch" );
  
  end;
  local use_switch_beg = function ()
  
    ObjDelete( "obj_mousehole_use_switch" );
  
  end;
  local use_switch_end = function ()
  
    ObjSet( "spr_mousehole_switch", { alp = 1, visible = true } );
    ObjSet( "obj_mousehole_clk_switch", { input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_switch", use_switch_beg, private.room_objname );
  cmn.AddSubscriber( "use_switch", use_switch_inv );
  cmn.AddSubscriber( "use_switch", use_switch_end, private.room_objname );
  cmn.AddSubscriber( "use_switch_inv", use_switch_inv, private.room_objname );
  cmn.AddSubscriber( "use_switch_beg", use_switch_beg, private.room_objname );
  cmn.AddSubscriber( "use_switch_end", use_switch_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_spring () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_spring" ] = {
    type = "use",
    inv_obj = "inv_spring",
    use_place = "obj_mousehole_use_spring",
    room = private.room_objname,
    zz = "zz_mousehole",
    zz_gate = "gzz_lounge_mousehole"
  };
  local use_spring_inv = function ()
  
    interface.InventoryItemRemove( "inv_spring" );
  
  end;
  local use_spring_beg = function ()
  
    ObjDelete( "obj_mousehole_use_spring" );
  
  end;
  local use_spring_end = function ()
  
    ObjSet( "gfx_mousehole_figurinepart", { active = true } );
    ObjSet( "spr_mousehole_spring", { alp = 1, visible = true } );
    ObjSet( "spr_mousehole_doors_open", { alp = 1, visible = true, input = true } );
    ObjDelete( "spr_mousehole_doors" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_spring", use_spring_beg, private.room_objname );
  cmn.AddSubscriber( "use_spring", use_spring_inv );
  cmn.AddSubscriber( "use_spring", use_spring_end, private.room_objname );
  cmn.AddSubscriber( "use_spring_inv", use_spring_inv, private.room_objname );
  cmn.AddSubscriber( "use_spring_beg", use_spring_beg, private.room_objname );
  cmn.AddSubscriber( "use_spring_end", use_spring_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_broom () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_broom" ] = {
    type = "use",
    inv_obj = "inv_broom",
    use_place = "obj_brokenchandelier_use_broom",
    room = private.room_objname,
    zz = "zz_brokenchandelier",
    zz_gate = "gzz_lounge_brokenchandelier"
  };
  local use_broom_inv = function ()
  
    interface.InventoryItemRemove( "inv_broom" );
  
  end;
  local use_broom_beg = function ()
  
    ObjDelete( "obj_brokenchandelier_use_broom" );
  
  end;
  local use_broom_end = function ()
  
    ObjSet( "gfx_brokenchandelier_crystalfigurine", { active = true  } );
    ObjSet( "spr_brokenchandelier_crystalfigurine", { input = true } );
    ObjSet( "obj_brokenchandelier_after", { alp = 1, visible = true } );
    ObjDelete( "obj_brokenchandelier_before" );
    ObjDelete( "anm_brokenchandelier_broom" );
 
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_broom", use_broom_beg, private.room_objname );
  cmn.AddSubscriber( "use_broom", use_broom_inv );
  cmn.AddSubscriber( "use_broom", use_broom_end, private.room_objname );
  cmn.AddSubscriber( "use_broom_inv", use_broom_inv, private.room_objname );
  cmn.AddSubscriber( "use_broom_beg", use_broom_beg, private.room_objname );
  cmn.AddSubscriber( "use_broom_end", use_broom_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chargedcrossbow () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chargedcrossbow" ] = {
    type = "use",
    inv_obj = "inv_chargedcrossbow",
    use_place = "obj_lounge_use_chargedcrossbow",
    room = private.room_objname,
  };
  local use_chargedcrossbow_inv = function ()
  
    interface.InventoryItemRemove( "inv_chargedcrossbow" );
  
  end;
  local use_chargedcrossbow_beg = function ()
  
    ObjDelete( "obj_lounge_use_chargedcrossbow" );
  
  end;
  local use_chargedcrossbow_end = function ()
  
    ObjSet( "obj_lounge_mmg_crossbow", { alp = 1, visible = true, input = true } ); 
 
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chargedcrossbow", use_chargedcrossbow_beg, private.room_objname );
  cmn.AddSubscriber( "use_chargedcrossbow", use_chargedcrossbow_inv );
  cmn.AddSubscriber( "use_chargedcrossbow", use_chargedcrossbow_end, private.room_objname );
  cmn.AddSubscriber( "use_chargedcrossbow_inv", use_chargedcrossbow_inv, private.room_objname );
  cmn.AddSubscriber( "use_chargedcrossbow_beg", use_chargedcrossbow_beg, private.room_objname );
  cmn.AddSubscriber( "use_chargedcrossbow_end", use_chargedcrossbow_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_lounge () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_lounge" ] =
  {
      type = "win",
      use_place = "obj_lounge_mmg_crossbow_click",
      room = private.room_objname,
  };
  local win_lounge = function ()

    if ( cmn.IsEventDone( "win_lounge" ) ) then

      ObjDelete( "anm_lounge_chandelier" );
      ObjDelete( "obj_lounge_mmg_crossbow" );
      ObjSet( "gzz_lounge_brokenchandelier", { input = true, active = true, alp = 1 } );
      ObjSet( "spr_lounge_states_zz_brokenchandelier_ho_floorhole", { alp = 1, visible = true } );     
      ObjSet( "obj_lounge_clk_masked_man_3", { input = true } );

    end;

  end;

  cmn.AddSubscriber( "win_lounge", win_lounge, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_wire () end;
  --------------------------------------------------------------------------------------------

  common_impl.hint[ "clk_wire" ] = {
    type = "click",
    use_place = "obj_coffeetable_clk_wire",
    room = private.room_objname,
    zz = "zz_coffeetable",
    zz_gate = "gzz_lounge_coffeetable"
  };

  local clk_wire_beg = function ()

    ObjDelete( "obj_coffeetable_clk_wire" );
    ObjSet( "spr_lounge_states_zz_coffeetable_open", { alp = 1, visible = true } );
  
  end;
  local clk_wire_end = function ()

    ObjDelete( "spr_coffeetable_box_cover" );
    ObjSet( "gfx_coffeetable_switch", { active = true } );
    ObjSet( "spr_coffeetable_box_open", { alp = 1, visible = true, input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_wire", clk_wire_beg, private.room_objname );
  cmn.AddSubscriber( "clk_wire", clk_wire_end, private.room_objname );
  cmn.AddSubscriber( "clk_wire_beg", clk_wire_beg, private.room_objname );
  cmn.AddSubscriber( "clk_wire_end", clk_wire_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_safetylock_1 () end;
  --------------------------------------------------------------------------------------------

  common_impl.hint[ "clk_safetylock_1" ] = {
    type = "click",
    use_place = "obj_washbasin_clk_safetylock_1",
    room = private.room_objname,
    zz = "zz_washbasin",
    zz_gate = "gzz_lounge_washbasin"
  };

  local clk_safetylock_1_beg = function ()

    ObjDelete( "obj_washbasin_clk_safetylock_1" );
    ObjDelete( "spr_lounge_states_washbasin_lamp" );  

  end;
  local clk_safetylock_1_end = function ()

    ObjSet( "spr_washbasin_button_on", { alp = 1 } );
    ObjDelete( "spr_washbasin_lamp_light" );
    ObjDelete( "spr_washbasin_button_off" );
    ObjSet( "obj_washbasin_clk_safetylock_2", { input = true } );

    ObjSet( "spr_washbasin_lamp_part", { ang = -0.03 } );
    ObjSet( "spr_washbasin_wire", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_safetylock_1", clk_safetylock_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_safetylock_1", clk_safetylock_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_safetylock_1_beg", clk_safetylock_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_safetylock_1_end", clk_safetylock_1_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_safetylock_2 () end;
  --------------------------------------------------------------------------------------------

  common_impl.hint[ "clk_safetylock_2" ] = {
    type = "click",
    use_place = "obj_washbasin_clk_safetylock_2",
    room = private.room_objname,
    zz = "zz_washbasin",
    zz_gate = "gzz_lounge_washbasin"
  };

  local clk_safetylock_2_beg = function ()

    ObjDelete( "obj_washbasin_clk_safetylock_2" );
  
  end;
  local clk_safetylock_2_end = function ()

    ObjSet( "spr_washbasin_wire", { alp = 1, visible = true, input = true } );
    ObjSet( "spr_washbasin_lamp_part", { ang = -0.14 } );
    ObjSet( "spr_washbasin_wire", { pos_x =78, pos_y  = -243 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_safetylock_2", clk_safetylock_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_safetylock_2", clk_safetylock_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_safetylock_2_beg", clk_safetylock_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_safetylock_2_end", clk_safetylock_2_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_figurinepart () end;
  --------------------------------------------------------------------------------------------

  common_impl.hint[ "clk_figurinepart" ] = {
    type = "click",
    use_place = "obj_coffeetable_clk_figurinepart",
    room = private.room_objname,
    zz = "zz_coffeetable",
    zz_gate = "gzz_lounge_coffeetable"
  };

  local clk_figurinepart_beg = function ()

    ObjDelete( "obj_coffeetable_clk_figurinepart" );
    ObjSet( "spr_lounge_states_zz_coffeetable_ho_stash", { alp = 1, visible = true } );
 
  end;
  local clk_figurinepart_end = function ()

    ObjSet( "spr_coffeetable_button_on", { alp = 1, visible = true } );
    ObjSet( "spr_coffeetable_figure_part_1", { pos_y = 80 } );
    ObjSet( "spr_coffeetable_table_part_2", { pos_x = -229 } );
    ObjDelete( "spr_coffeetable_button_off" );
    ObjDelete( "gzz_lounge_coffeetable" );
    ObjSet( "gho_lounge_stash", { alp = 1, active = true, input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_figurinepart", clk_figurinepart_beg, private.room_objname );
  cmn.AddSubscriber( "clk_figurinepart", clk_figurinepart_end, private.room_objname );
  cmn.AddSubscriber( "clk_figurinepart_beg", clk_figurinepart_beg, private.room_objname );
  cmn.AddSubscriber( "clk_figurinepart_end", clk_figurinepart_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_switch () end;
  --------------------------------------------------------------------------------------------

  common_impl.hint[ "clk_switch" ] = {
    type = "click",
    use_place = "obj_mousehole_clk_switch",
    room = private.room_objname,
    zz = "zz_mousehole",
    zz_gate = "gzz_lounge_mousehole"
  };

  local clk_switch_beg = function ()

    ObjDelete( "obj_mousehole_clk_switch" );
    ObjSet( "zz_mousehole", { res = "assets/levels/level1/rm_lounge/zz_mousehole/back_1" } );
    ObjSet( "spr_lounge_states_zz_mousehole_light", { alp = 1, visible = true } );
  
  end;
  local clk_switch_end = function ()

    ObjDelete( "spr_mousehole_dark" );
    ObjSet( "gfx_mousehole_mousetrap", { active = true } );
    ObjSet( "spr_mousehole_mousetrap", { input = true } );
    ObjSet( "obj_mousehole_clk_spring", { input = true } );
    ObjSet( "obj_collect2_item_1_3", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_switch", clk_switch_beg, private.room_objname );
  cmn.AddSubscriber( "clk_switch", clk_switch_end, private.room_objname );
  cmn.AddSubscriber( "clk_switch_beg", clk_switch_beg, private.room_objname );
  cmn.AddSubscriber( "clk_switch_end", clk_switch_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_spring_mousehole () end;
  --------------------------------------------------------------------------------------------

  common_impl.hint[ "clk_spring_mousehole" ] = {
    type = "click",
    use_place = "obj_mousehole_clk_spring",
    room = private.room_objname,
    zz = "zz_mousehole",
    zz_gate = "gzz_lounge_mousehole"
  };

  local clk_spring_mousehole_beg = function ()

    ObjDelete( "obj_mousehole_clk_spring" );
  
  end;
  local clk_spring_mousehole_end = function ()

    ObjDelete( "spr_mousehole_broken_spring" );
    ObjSet( "obj_mousehole_use_spring", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_spring_mousehole", clk_spring_mousehole_beg, private.room_objname );
  cmn.AddSubscriber( "clk_spring_mousehole", clk_spring_mousehole_end, private.room_objname );
  cmn.AddSubscriber( "clk_spring_mousehole_beg", clk_spring_mousehole_beg, private.room_objname );
  cmn.AddSubscriber( "clk_spring_mousehole_end", clk_spring_mousehole_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function see_masked_man_3 () end;
  --------------------------------------------------------------------------------------------

  common_impl.hint[ "see_masked_man_3" ] = {
    type = "click",
    use_place = "obj_lounge_clk_masked_man_3_focus",
    room = private.room_objname
  };

  local see_masked_man_3 = function ()

    ObjDelete( "vid_lounge_masked_man_3" );
    ObjDelete( "obj_lounge_clk_masked_man_3" );

  end;

  cmn.AddSubscriber( "see_masked_man_3", see_masked_man_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_lounge_scare_1 () end;
  --------------------------------------------------------------------------------------------
  local see_lounge_scare_1 = function ()

    ObjDelete( "anm_lounge_tears_picture" );
    ObjSet( "obj_lounge_tears_picture", { alp = 1 } );

  end;

  cmn.AddSubscriber( "see_lounge_scare_1", see_lounge_scare_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_lounge_scare_2 () end;
  --------------------------------------------------------------------------------------------
  local see_lounge_scare_2 = function ()

    ObjDelete( "anm_lounge_mirror_crash" );
    ObjSet( "obj_lounge_mirror_crash", { alp = 1 } );

  end;

  cmn.AddSubscriber( "see_lounge_scare_2", see_lounge_scare_2, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
--private.AnimMouseHoleLight
  --*********************************************************************************************************************
  -- function zz_washbasin() end зз стена со светильником
    subroom.Define( "zz_washbasin" );
    function zz_washbasin.Open ()

      ObjSet( "tmr_washbasin_waterfallen", 
      { 
        playing = false,
      } );  

      if not ( cmn.IsEventDone( "use_boathook_1" ) ) then

        private.AnimWaterfallen();

      else

        private.AnimWaterfallen_2();

      end;

    end;  
    -------------------------------------------------
    function zz_washbasin.PreOpen ()

      if not cmn.IsEventDone( "use_boathook_1" ) then 

        common_impl.PlayAudio( "env", "level1/env/aud_electr_water_env", 1, "", 0 );
        common_impl.StopAudio( "env", "level1/env/aud_lounge_electri_env", 0.2 );

      end;

    end;  
    -------------------------------------------------
    function zz_washbasin.PreClose ()

      if not cmn.IsEventDone( "use_boathook_1" ) then 

        common_impl.PlayAudio( "env", "level1/env/aud_lounge_electri_env", 1, "", 0 );
        common_impl.StopAudio( "env", "level1/env/aud_electr_water_env", 0.2 );

      end;

    end; 
    ------------------------------------------------- 
    function zz_washbasin.Close ()

      if not ( cmn.IsEventDone( "see_lounge_scare_2" ) ) then

        if ( cmn.IsEventDone( "get_wire" ) ) then

          private.LoungeScare_2();      
          
        end;

      end;

    end;
    -------------------------------------------------
  --*********************************************************************************************************************
  -- function zz_coffeetable() end зз стена со светильником
    subroom.Define( "zz_coffeetable" );
    function zz_coffeetable.Open ()

    end;  
    -------------------------------------------------
    function zz_coffeetable.PreOpen ()

    end;  
    -------------------------------------------------
    function zz_coffeetable.PreClose ()

    end; 
    ------------------------------------------------- 
    function zz_coffeetable.Close ()

      cmn.NoteScaleClose( { "spr_coffeetable_paper" } ); 

    end;
    -------------------------------------------------
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_lounge();

  if cmn.IsEventStart( "see_tutorial" ) and IsCollectorsEdition() then

    common_impl.TutorialShow( "tutorial_page_24" );

  end;

  if ( not cmn.IsEventDone( "see_lounge_scare_1" ) and cmn.IsEventDone( "get_boathook" ) ) then

     private.LoungeScare_1();      
      
  end;

  if ( not cmn.IsEventDone( "see_lounge_scare_2" ) and cmn.IsEventDone( "get_wire" ) ) then

    private.LoungeScare_2();      
      
  end;

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "level1/env/aud_rm_lounge_env" }, "", 0.5 );
  --cmn.PlayMusEnv();

  if ( not cmn.IsEventDone( "use_boathook_1" ) ) then

    common_impl.PlayAudio( "env", "level1/env/aud_lounge_electri_env", 1, "", 0 );

  end;

  common_impl.CollectItemMorphing();
  common_impl.MorphItemMorphing();

  if not cmn.IsEventDone( "win_lounge" ) then 

    if cmn.IsEventDone( "use_chargedcrossbow" ) then 
      cmn.MiniGameShow();
      common_impl.PassingMgStart( "lounge" );
    end;

    private.CrossbowLoad();
    private.CrossbowUpdate();

  end;

  -- анимация света на мышиную нору----------------
  if ( cmn.IsEventDone( "clk_switch" ) ) then

    ObjSet( "spr_lounge_light_lamp1", { alp = 0 } );
    private.AnimMouseHoleLight();

  end;

end;
--*********************************************************************************************************************
function public.Close ()

  cmn.NoteScaleClose( { "spr_lounge_blank_form", "spr_lounge_drawing" } ); 

  if ( not cmn.IsEventDone( "use_boathook_1" ) ) then

    common_impl.StopAudio( "env", "level1/env/aud_lounge_electri_env", 0.2 );

  end

end;
--*********************************************************************************************************************
function public.PreClose ()

  if ( not cmn.IsEventDone( "win_lounge" ) and
  cmn.IsEventDone( "use_chargedcrossbow" ) ) then 

    cmn.MiniGameHide();
    common_impl.PassingMgStop( "lounge" );

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_wire ()

  local item = "inv_wire";

  if cmn.ApplyObj( item, "gzz_lounge_coffeetable" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_coffeetable", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_coffeetable_use_wire" ) ) then

    cmn.CallEventHandler( "use_wire_inv" );
    cmn.CallEventHandler( "use_wire_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_wire" );
      cmn.CallEventHandler( "use_wire_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );

    cmn.ItemFly( "spr_coffeetable_wire", func_end );
    
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_figurinepart ()

  local item = "inv_figurinepart";

  if cmn.ApplyObj( item, "gzz_lounge_coffeetable" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_coffeetable", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_coffeetable_use_figurinepart" ) ) then

    cmn.CallEventHandler( "use_figurinepart_inv" );
    cmn.CallEventHandler( "use_figurinepart_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_figurinepart" );
      cmn.CallEventHandler( "use_figurinepart_end" );

      common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );

    end;

    cmn.Lock( true );

    cmn.ItemFly( "spr_coffeetable_figure_part_2", func_end, 2.62 );
    
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_magnet_3 ()

  local item = "inv_magnet";

  if cmn.ApplyObj( item, "gzz_lounge_washbasin" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_washbasin", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_washbasin_use_magnet_3" ) ) then

    cmn.CallEventHandler( "use_magnet_3_inv" );
    cmn.CallEventHandler( "use_magnet_3_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_magnet_3" );
      cmn.CallEventHandler( "use_magnet_3_end" );

      ObjSet( "spr_washbasin_arrow", { alp = 1, pos_x = -423, pos_y = 370 } );
      private.get_arrow();

    end;

    local func_end_2 = function ()
      ObjSet( "spr_washbasin_arrow", { alp = 0 } );
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_magnet", 0, "", 0 );

    ObjSet( "anm_washbasin_magnet", { alp = 1, visible = true } );
    ObjSet( "spr_washbasin_arrow", { alp = 0 } );
    --ObjAnimate( "anm_washbasin_magnet", "alp",0,0, func_end_2, { 0, 0, 0,    0.1, 0, 1 } );
    AnimPlay( "anm_washbasin_magnet", "DoAnim", func_end );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_washbasin_use_boathook_1" ) ) then

    common_impl.ShowBbt( "bbt_washbasin_use_boathook_1_magnet" );
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_screwdriver_2 ()

  local item = "inv_screwdriver";

  if cmn.ApplyObj( item, "gzz_lounge_washbasin" ) and ( not cmn.IsEventStart( "win_lounge" ) or cmn.IsEventDone( "win_lounge" ) ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_washbasin", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_washbasin_use_screwdriver_2" ) ) then

    cmn.CallEventHandler( "use_screwdriver_2_inv" );
    cmn.CallEventHandler( "use_screwdriver_2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_screwdriver_2" );
      cmn.CallEventHandler( "use_screwdriver_2_end" );
      private.get_basreliefpart();

    end;

    local func_end_2 = function ()

      ObjSet( "spr_washbasin_basrelief_up_side", { alp = 0 } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_screwdriwer2", 0, "", 0 );

    ObjSet( "vid_washbasin_screwdriver", { alp = 0, visible = true } );
    ObjAnimate( "vid_washbasin_screwdriver", "alp",0,0, func_end_2, { 0, 0, 0,    0.3, 0, 1 } );
    VidPlay( "vid_washbasin_screwdriver", func_end );
    
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_boathook_1 ()

  local item = "inv_boathook";

  if cmn.ApplyObj( item, "gzz_lounge_washbasin" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_washbasin", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_washbasin_use_boathook_1" ) ) then

    cmn.CallEventHandler( "use_boathook_1_inv" );
    cmn.CallEventHandler( "use_boathook_1_beg" );

    local func_end = function ()

      public.use_boathook_1_end();

    end;

    local func_end_2 = function ()

      ObjSet( "spr_washbasin_fuse_light", { alp = 0 } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_sink", 0, "", 0 );

    ObjSet( "spr_washbasin_drainplug", { alp = 0, pos_x = 216, pos_y = 332 } );
    ObjSet( "anm_washbasin_boathook", { alp = 1, visible = true } );
    ObjAnimate( "anm_washbasin_boathook", "alp",0,0, func_end_2, { 0, 0, 1,    0.3, 0, 1 } );
    AnimPlay( "anm_washbasin_boathook", "DoAnim", func_end );

--

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_boathook_1_end ()

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "use_boathook_1" );
    cmn.CallEventHandler( "use_boathook_1_end" );

    ObjSet( "spr_washbasin_drainplug", { alp = 1, pos_x = 216, pos_y = 332 } );
    private.get_drainplug();

    ObjSet( "anm_washbasin_waterfallen_2", { alp = 1 } );
    private.AnimWaterfallen_2();    

  end;
  
  common_impl.StopAudio( "env", "level1/env/aud_electr_water_env", 0.2 );

  ObjSet( "anm_washbasin_waterfallen", { alp = 0 } );
  AnimStop( "anm_washbasin_waterfallen" );
  ObjSet( "tmr_washbasin_waterfallen", 
  { 
    playing = false,
  } );  

  ObjAnimate( "vid_washbasin_water_light", "alp",0,0, "",
  { 
    0.0, 0, 1,    
    0.2, 0, 1,
    0.3, 0, 0
  } );
  ObjAnimate( "vid_washbasin_water_sink", "alp",0,0, "",
  { 
    0.0, 0, 0,    
    0.3, 0, 1 
  } );
  VidPlay( "vid_washbasin_water_sink", func_end );

end;
--------------------------------------------------------------------------------------------
function public.use_safetylock ()

  local item = "inv_safetylock";

  if cmn.ApplyObj( item, "gzz_lounge_washbasin" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_washbasin", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_washbasin_use_safetylock" ) ) then

    cmn.CallEventHandler( "use_safetylock_inv" );
    cmn.CallEventHandler( "use_safetylock_beg" );

    local func_end = function ()

      cmn.Lock( false );

      common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );

      cmn.SetEventDone( "use_safetylock" );
      cmn.CallEventHandler( "use_safetylock_end" );

    end;

    cmn.Lock( true );

    cmn.ItemFly( "spr_washbasin_safety_lock", func_end, -2.27 );
    
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_switch ()

  local item = "inv_switch";

  if cmn.ApplyObj( item, "gzz_lounge_mousehole" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_mousehole", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_mousehole_use_switch" ) ) then

    cmn.CallEventHandler( "use_switch_inv" );
    cmn.CallEventHandler( "use_switch_beg" );

    local func_end = function ()

      cmn.Lock( false );

      common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );
      cmn.SetEventDone( "use_switch" );
      cmn.CallEventHandler( "use_switch_end" );

    end;

    cmn.Lock( true );
    
    cmn.ItemFly( "spr_mousehole_switch", func_end, 2.09 );
    
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_spring ()

  local item = "inv_spring";

  if cmn.ApplyObj( item, "gzz_lounge_mousehole" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_mousehole", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_mousehole_use_spring" ) and 
  cmn.IsEventDone( "clk_spring_mousehole" ) ) then

    cmn.CallEventHandler( "use_spring_inv" );
    cmn.CallEventHandler( "use_spring_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_spring" );
      cmn.CallEventHandler( "use_spring_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_spring_clock", 0, "", 0 );

    ObjSet( "spr_mousehole_spring", { alp = 0, visible = true } );
    ObjAnimate( "spr_mousehole_spring", "alp",0,0, "", { 0, 0, 0,    0.6, 0, 1 } );

    ObjAnimate( "spr_mousehole_doors", "alp",0,0, "", { 0, 2, 1,    0.6, 2, 1,    1.2, 2, 0  } );
    ObjSet( "spr_mousehole_doors_open", { alp = 0, visible = true } );
    ObjAnimate( "spr_mousehole_doors_open", "alp",0,0, func_end, { 0, 1, 0,    0.6, 1, 0,    1.2, 1, 1 } );
    
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_broom ()

  local item = "inv_broom";

  if ( cmn.ApplyObj( item, "gzz_lounge_brokenchandelier" ) and cmn.IsEventDone( "see_masked_man_3" ) ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_brokenchandelier", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_brokenchandelier_use_broom" ) and cmn.IsEventDone( "see_masked_man_3" ) ) then

    cmn.CallEventHandler( "use_broom_inv" );
    cmn.CallEventHandler( "use_broom_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_broom" );
      cmn.CallEventHandler( "use_broom_end" );

      private.get_brokenbroom();

    end;

    local func_end_2 = function ()

      ObjSet( "obj_brokenchandelier_before", { alp = 0 } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_brush", 0, "", 0 );

    ObjSet( "anm_brokenchandelier_broom", { alp = 0, visible = true } );
    ObjAnimate( "anm_brokenchandelier_broom", "alp",0,0, func_end_2, { 0, 0, 0,    0.3, 0, 1 } );
    AnimPlay( "anm_brokenchandelier_broom", "Du_Anim", func_end );
    
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_chargedcrossbow ()

  local item = "inv_chargedcrossbow";

  if ( cmn.ApplyObj( item, "obj_lounge_use_chargedcrossbow" ) ) then

    cmn.CallEventHandler( "use_chargedcrossbow_inv" );
    cmn.CallEventHandler( "use_chargedcrossbow_beg" );

    local func_end = function ()

      common_impl.PlayAudio( "sfx", "aud_opn_mg", 0, "", 0 ); 

      cmn.Lock( false );
      cmn.SetEventDone( "use_chargedcrossbow" );
      cmn.CallEventHandler( "use_chargedcrossbow_end" );

    end;

    local func_end_2 = function ()

      private.PlayAnimation( "IDLE_MOTION" );
      common_impl.PassingMgStart( "lounge" );
      cmn.MiniGameShow();
      func_end();

    end;

    cmn.Lock( true );
    --common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_chargedcrossbow", 0, "", 0 );
   
    ObjSet( "obj_lounge_mmg_crossbow", { alp = 0, visible = true } );
    ObjAnimate( "obj_lounge_mmg_crossbow", "alp",0,0, "", { 0, 0, 0,    0.6, 0, 1 } );

    AnimPlay( "anm_lounge_mmg_crossbow", "easein", func_end_2 ); 

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_switch ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
  ObjDelete( "gfx_coffeetable_switch" );

  cmn.SetEventDone( "get_switch" );
  cmn.CallEventHandler( "get_switch" );

end;
--------------------------------------------------------------------------------------------
function private.get_wire ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  ObjSet( "spr_washbasin_wire", { croprect_init = false } );

  cmn.SetEventDone( "get_wire" );
  cmn.CallEventHandler( "get_wire" );

  if cmn.IsEventDone( "get_basreliefpart" ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_arrow ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_arrow" );
  cmn.CallEventHandler( "get_arrow" );

end;
--------------------------------------------------------------------------------------------
function private.get_drainplug ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_drainplug" );
  cmn.CallEventHandler( "get_drainplug" );

end;
--------------------------------------------------------------------------------------------
function private.get_basreliefpart ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_basreliefpart" );
  cmn.CallEventHandler( "get_basreliefpart" );

  if cmn.IsEventDone( "get_wire" ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_figurinepart ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  if ( cmn.IsGetCollect2( "get_collect2_item_1_3" ) ) then 

    common.CloseSubRoom();

  end;

  cmn.SetEventDone( "get_figurinepart" );
  cmn.CallEventHandler( "get_figurinepart" );

end;
--------------------------------------------------------------------------------------------
function private.get_mousetrap ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_mousetrap" );
  cmn.CallEventHandler( "get_mousetrap" );

end;
--------------------------------------------------------------------------------------------
function private.get_crystalfigurine ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );
  common.CloseSubRoom();

  cmn.GotoRoom( 'ho_floorhole' )

  cmn.SetEventDone( "get_crystalfigurine" );
  cmn.CallEventHandler( "get_crystalfigurine" );

end;
--------------------------------------------------------------------------------------------
function private.get_brokenbroom ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_brokenbroom" );
  cmn.CallEventHandler( "get_brokenbroom" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_1_3 ()

  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_1_3" ); 

    if ( cmn.IsEventDone( "get_figurinepart" ) ) then

      common.CloseSubRoom();

    end;

  end;

  common_impl.PlayEffectHO( "spr_collect2_item_1_3", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_1_3" );

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************

function private.clk_wire ()

  cmn.CallEventHandler( "clk_wire_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_wire" );
    cmn.CallEventHandler( "clk_wire_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_box", 0, "", 0 );

  ObjAnimate( "spr_coffeetable_box_cover", "alp",0,0, "", { 0, 2, 1,    0.6, 2, 0 } );

  ObjSet( "spr_coffeetable_box_open", { alp = 0, visible = true } );
  ObjAnimate( "spr_coffeetable_box_open", "alp",0,0, func_end, { 0, 1, 0,    0.6, 1, 1 } );

end;

--------------------------------------------------------------------------------------------

function private.clk_figurinepart ()

  cmn.CallEventHandler( "clk_figurinepart_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_figurinepart" );
    cmn.CallEventHandler( "clk_figurinepart_end" );
    common.CloseSubRoom();

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_ho_stash", 0, "", 0 );

  ObjAnimate( "spr_coffeetable_button_off", "alp",0,0, "", { 0, 2, 1,    0.4, 2, 0 } );
  ObjSet( "spr_coffeetable_button_on", { alp = 0, visible = true } );
  ObjAnimate( "spr_coffeetable_button_on", "alp",0,0, "", { 0, 1, 0,    0.4, 1, 1 } );

  ObjAnimate( "spr_coffeetable_figure_part_1", "pos_y",0,0, "", { 0, 3, 60,    0.4, 3, 60,    1.0, 3, 80 } );

  ObjAnimate( "spr_coffeetable_table_part_2", "pos_x",0,0, func_end, { 0, 3, -139,    1.0, 3, -139,    1.8, 3, -229 } );

end;

--------------------------------------------------------------------------------------------

function private.clk_safetylock_1 ()

  cmn.CallEventHandler( "clk_safetylock_1_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_safetylock_1" );
    cmn.CallEventHandler( "clk_safetylock_1_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_ceiling", 0, "", 0 );

  local time = 0.6;

  ObjAnimate( "spr_washbasin_button_off", "alp",0,0, "", 
  { 
    0, 2, 1,
    time, 2, 0
  } );
  ObjAnimate( "spr_washbasin_button_on", "alp",0,0, "", 
  { 
    0, 1, 0,    
    time, 1, 1 
  } );

  ObjAnimate( "spr_washbasin_lamp_part", "ang",0,0, "", 
  { 
         0, 2, 0,    
      time, 2, 0,    
    2*time, 2, -0.03 
  } );
  ObjAnimate( "spr_washbasin_wire", "alp",0,0, func_end, 
  { 
         0, 0, 0,    
      time, 0, 0,    
    2*time, 0, 1 
  } );

end;

--------------------------------------------------------------------------------------------

function private.clk_safetylock_2 ()

  cmn.CallEventHandler( "clk_safetylock_2_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_safetylock_2" );
    cmn.CallEventHandler( "clk_safetylock_2_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

  local time = 0.6;

  ObjAnimate( "spr_washbasin_lamp_part", "ang",0,0, "", 
  { 
         0, 2, ObjGet( "spr_washbasin_lamp_part" ).ang,    
      time, 2, ObjGet( "spr_washbasin_lamp_part" ).ang,    
    2*time, 2, -0.14 
  } );
  ObjAnimate( "spr_washbasin_wire", "pos_xy",0,0, func_end, 
  { 
         0, 2, ObjGet( "spr_washbasin_wire" ).pos_x, ObjGet( "spr_washbasin_wire" ).pos_y,    
      time, 2, ObjGet( "spr_washbasin_wire" ).pos_x, ObjGet( "spr_washbasin_wire" ).pos_y,    
    2*time, 2, 78, -243
  } );

end;

--------------------------------------------------------------------------------------------

function private.clk_switch ()

  cmn.CallEventHandler( "clk_switch_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_switch" );
    cmn.CallEventHandler( "clk_switch_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_button_lounge", 0, "", 0 );

  private.AnimMouseHoleLight();
  ObjAnimate( "spr_mousehole_dark", "alp",0,0, func_end, { 0, 0, 1,    0.6, 0, 0 } );

end;

--------------------------------------------------------------------------------------------

function private.clk_spring_mousehole ()

  cmn.CallEventHandler( "clk_spring_mousehole_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_spring_mousehole" );
    cmn.CallEventHandler( "clk_spring_mousehole_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_crossbow6", 0, "", 0 );

  ObjAnimate( "spr_mousehole_broken_spring", "pos_xy",0,0, func_end, { 0, 1, 177, 112,    0.1, 1, 177, 93,    0.5, 1, 92, 308 } );

end;


--*********************************************************************************************************************
-- function *** MMG CROSSBOW *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************

  private.crossbow_state = {};
  private.crossbow_win = { 1, 1, 1 };

  local gamemode = "VERTICAL";
  local lastWinIndex = 0;

  local CROSSBOW_BUTTON_NAME = "spr_lounge_mmg_crossbow_light_button_";
  local CROSSBOW_SLIDER_VERTICAL = "spr_lounge_mmg_crossbow_runner_vertical";
  local CROSSBOW_SLIDER_HORIZONTAL = "spr_lounge_mmg_crossbow_runner_horizontal";
  local CROSSBOW_ANIM_NAME = "anm_lounge_mmg_crossbow";

  local CROSSBOW_BUTTON_COUNT = 3;
  local CROSSBOW_WIN_DELTA = 14;

  local CROSSBOW_START_Y = -199;
  local CROSSBOW_END_Y = 56;

  local CROSSBOW_START_X = -352;
  local CROSSBOW_END_X = -102;

  local CROSSBOW_WIN_Y = -75;
  local CROSSBOW_WIN_X = -227;


  --*******************************************************************************************************************
  function private.CrossbowDefault ()

    -- 0 - level 'i' is not won, 
    -- else private.crossbow_state[i] = 1 

    private.crossbow_state = { 0, 0, 0 };

  end; 


  --*******************************************************************************************************************
  function private.CrossbowLoad ()

    private.SliderMoving( true );

    local func_end = function ()

      private.PlayAnimation( "IDLE_MOTION" );

    end;

    AnimPlay( CROSSBOW_ANIM_NAME, "easein", func_end );

    private.crossbow_state = ng_global.progress[ "std" ][ "win_lounge" ].state;

    if ( not private.crossbow_state ) then
      private.CrossbowDefault();
    end; 

  end;


  --*******************************************************************************************************************
  function private.CrossbowSave ()

    ng_global.progress[ "std" ][ "win_lounge" ].state = private.crossbow_state;

  end;


  --*******************************************************************************************************************
  function private.CrossbowCheckWin ()

    local result = false;
    local count = 0;

    for i = 1, CROSSBOW_BUTTON_COUNT, 1 do 

      if private.crossbow_state[i] == private.crossbow_win[i] then 
        count = count + 1;
      end;

    end;

    if count == CROSSBOW_BUTTON_COUNT then 

      ObjSet( "obj_lounge_mmg_crossbow_click", { input = false } );
      result = true;
    end;

    return result;


  end;


  --*******************************************************************************************************************
  function private.CrossbowWin ()

    cmn.MiniGameHide();
    common_impl.ShowBbt( "bbt_lounge_win_lounge" ); 

    ObjSet( "obj_lounge_mmg_crossbow", { input = false } );
    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );   
      cmn.SetEventDone( "win_lounge" );
      cmn.CallEventHandler( "win_lounge" );

      common_impl.PassingMgWin( "lounge" );

    end;

    local func_end_2 = function ()

      ObjSet( "spr_lounge_states_zz_brokenchandelier_ho_floorhole", { alp = 1, visible = true } );

    end; 

    private.PlayAnimation ( "WIN" );
    ObjAnimate( "anm_lounge_chandelier", "alp",0,0, func_end_2, { 0, 0, 1,    0.3, 0, 0,    1, 0, 0 } );
    ObjAnimate( "obj_lounge_mmg_crossbow", "alp",0,0, func_end, { 0, 0, 1,    1, 0, 1,    1.6, 0, 0 } );

  end;


  --*******************************************************************************************************************
  function private.CrossbowClick ()

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_crossbow6", 0, "", 0 );

    local func_end = function ()

      private.PlayAnimation( "LOADING" );

    end;

    local func_end_2 = function ()

      private.PlayAnimation( "IDLE_MOTION" );
      private.SliderMoving( false );
      private.CrossbowUpdate();

    end;

    if gamemode == "VERTICAL" then 

      common_impl.StopAudio( "sfx", "level1/sfx/aud_crossbow1" );
      ObjStopAnimate( CROSSBOW_SLIDER_VERTICAL, 1 );
      gamemode = "HORIZONTAL";
      private.SliderMoving( false );

    elseif gamemode == "HORIZONTAL" then  

      ObjSet( "obj_lounge_mmg_crossbow", { input = false } );
      cmn.Lock( true );
 
      common_impl.StopAudio( "sfx", "level1/sfx/aud_crossbow2" );
      ObjStopAnimate( CROSSBOW_SLIDER_HORIZONTAL, 0 );
      local curX = ObjGet( CROSSBOW_SLIDER_HORIZONTAL ).pos_x;
      local curY = ObjGet( CROSSBOW_SLIDER_VERTICAL ).pos_y;

      gamemode = "VERTICAL";

      if math.abs( curX - CROSSBOW_WIN_X ) <= CROSSBOW_WIN_DELTA and    
      math.abs( curY - CROSSBOW_WIN_Y ) <= CROSSBOW_WIN_DELTA then   

        private.PlayAnimation( "SUCCESSFUL_SHOT" );
        ObjAnimate( "obj_lounge_mmg_crossbow", "scale_x",0,0, func_end, { 0, 0, 1,    1, 0, 1 } );
        ObjAnimate( "obj_lounge_mmg_crossbow", "scale_y",0,0, func_end_2, { 0, 0, 1,    1.45, 0, 1 } );    

        for i = 1, CROSSBOW_BUTTON_COUNT, 1 do 

          if private.crossbow_state[i] == 0 then 
            lastWinIndex = i;
            break; 
          end;

        end;

        private.crossbow_state[lastWinIndex] = 1;
        private.CrossbowSave(); 

      else 

        private.PlayAnimation( "UNSUCCESSFUL_SHOT" );  
        ObjAnimate( "obj_lounge_mmg_crossbow", "scale_x",0,0, func_end, { 0, 0, 1,    0.85, 0, 1 } );           
        ObjAnimate( "obj_lounge_mmg_crossbow", "scale_y",0,0, func_end_2, { 0, 0, 1,    1.3, 0, 1 } );

      end;

    end;

  end;


  --*******************************************************************************************************************
  function private.PlayAnimation ( typeAnim )

    AnimStop( CROSSBOW_ANIM_NAME );

    local func_end = function ()

      local lastWinButton = CROSSBOW_BUTTON_NAME..lastWinIndex;
      ObjAnimate( lastWinButton, "alp",0,0, "", { 0, 0, 0,    0.4, 0, 1,    0.6, 0, 0,    1.0, 0, 1 } );

    end;

    if typeAnim == "IDLE_MOTION" then 

      AnimPlay( CROSSBOW_ANIM_NAME, "sight", "" ); 

    elseif typeAnim == "LOADING" then 

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_crossbow4", 0, "", 0 );
      AnimPlay( CROSSBOW_ANIM_NAME, "loading", "" ); 

    elseif typeAnim == "UNSUCCESSFUL_SHOT" then 

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_crossbow3", 0, "", 0 );
      AnimPlay( CROSSBOW_ANIM_NAME, "bloomer", "" ); 

    elseif typeAnim == "SUCCESSFUL_SHOT" then 

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_crossbow5", 0, "", 0 );
      AnimPlay( CROSSBOW_ANIM_NAME, "hit", func_end ); 

    elseif typeAnim == "WIN" then 

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_fall_dummy", 0, "", 0 );
      AnimPlay( CROSSBOW_ANIM_NAME, "fall", "" ); 

    end; 

  end;


  --*******************************************************************************************************************
  function private.SliderMoving ( isOpen )

    local func_end_audio_vertical = function ()

      if cmn.IsEventDone( "use_chargedcrossbow" ) then 
        common_impl.PlayAudio( "sfx", "level1/sfx/aud_crossbow1", 0, "", 0 );
      end;

    end;

    local func_end_audio_horizontal = function ()

      if cmn.IsEventDone( "use_chargedcrossbow" ) then 
        common_impl.PlayAudio( "sfx", "level1/sfx/aud_crossbow2", 0, "", 0 );
      end;

    end;

    if gamemode == "VERTICAL" then 

      local func_end = function ()

        if cmn.IsEventDone( "use_chargedcrossbow" ) then 
          common_impl.PlayAudio( "sfx", "level1/sfx/aud_crossbow1", 0, "", 0 );
        end;

        ObjAnimate( CROSSBOW_SLIDER_VERTICAL, "pos_y",1,0, func_end_audio_vertical, { 0, 1, CROSSBOW_START_Y,    1.9, 1, CROSSBOW_END_Y,    3.8, 2, CROSSBOW_START_Y } );
        ObjSet( "obj_lounge_mmg_crossbow", { input = true } );
        cmn.Lock( false );

      end;

      if isOpen then

        if cmn.IsEventDone( "use_chargedcrossbow" ) then 
          common_impl.PlayAudio( "sfx", "level1/sfx/aud_crossbow1", 0, "", 0 );
        end;

        ObjSet( CROSSBOW_SLIDER_VERTICAL, { pos_y = CROSSBOW_START_Y } );
        ObjSet( CROSSBOW_SLIDER_HORIZONTAL, { pos_x = CROSSBOW_START_X } );
        ObjAnimate( CROSSBOW_SLIDER_VERTICAL, "pos_y",1,0, func_end_audio_vertical, { 0, 1, CROSSBOW_START_Y,    1.9, 1, CROSSBOW_END_Y,    3.8, 2, CROSSBOW_START_Y } );        

      else 

        local curY = ObjGet( CROSSBOW_SLIDER_VERTICAL ).pos_y;
        local curX = ObjGet( CROSSBOW_SLIDER_HORIZONTAL ).pos_x;

        ObjAnimate( CROSSBOW_SLIDER_VERTICAL, "pos_y",0,0, "", { 0, 3, curY,    1, 3, CROSSBOW_START_Y } );
        ObjAnimate( CROSSBOW_SLIDER_HORIZONTAL, "pos_x",0,0, func_end, { 0, 3, curX,    1, 3, CROSSBOW_START_X } );

      end;

    elseif gamemode == "HORIZONTAL" then  

      if cmn.IsEventDone( "use_chargedcrossbow" ) then 
        common_impl.PlayAudio( "sfx", "level1/sfx/aud_crossbow2", 0, "", 0 );
      end;

      ObjAnimate( CROSSBOW_SLIDER_HORIZONTAL, "pos_x",1,0, func_end_audio_horizontal, { 0, 1, CROSSBOW_START_X,    1.6, 1, CROSSBOW_END_X,    3.2, 2, CROSSBOW_START_X } );   

    end;

  end;


 --*******************************************************************************************************************
  function private.CrossbowUpdate ()

    for i = 1, CROSSBOW_BUTTON_COUNT, 1 do 

      if private.crossbow_state[i] == private.crossbow_win[i] then 

        curButton = CROSSBOW_BUTTON_NAME..i;
        ObjSet( curButton, { alp = 1 } );

      end;

    end;

    if private.CrossbowCheckWin() then 
      private.CrossbowWin();
    end;

  end;


 --*******************************************************************************************************************
  function public.Reset ()

    for i = 1, CROSSBOW_BUTTON_COUNT, 1 do 

      private.crossbow_state[i] = 0;  
      local curButton = CROSSBOW_BUTTON_NAME..i;
      local curButtonAlpha = ObjGet( curButton ).alp;
      ObjAnimate( curButton, "alp",0,0, "", { 0, 0, curButtonAlpha,    0.4, 0, 0 } );

    end;

    gamemode = "VERTICAL"; 
    lastWinIndex = 0;

    ObjStopAnimate( CROSSBOW_SLIDER_VERTICAL, 1 );
    ObjStopAnimate( CROSSBOW_SLIDER_HORIZONTAL, 0 );

    ObjSet( "obj_lounge_mmg_crossbow", { input = false } );
    cmn.Lock( true );
    private.SliderMoving( false ); 

  end; 


 --*******************************************************************************************************************
  function public.Skip ()

    for i = lastWinIndex + 1, CROSSBOW_BUTTON_COUNT, 1 do 

      local curButton = CROSSBOW_BUTTON_NAME..i;
      ObjAnimate( curButton, "alp",0,0, "", { 0, 0, 0,    0.4, 0, 1 } );

    end;

    private.CrossbowWin(); 

  end; 


--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_lounge ()

  if not ( cmn.IsEventDone( "opn_lounge" ) ) then

    cmn.SetEventDone( "opn_lounge" );

    common_impl.ShowBbt( "bbt_lounge_opn_lounge" );

  end;

  cmn.CallEventHandler( "opn_lounge" ); 

end;
--*********************************************************************************************************************
function private.MaskedMan_3 ()

  local func_end = function ()

    cmn.Lock( false );    

    cmn.SetEventDone( "see_masked_man_3" );
    cmn.CallEventHandler( "see_masked_man_3" );

    common_impl.StopAudio( "sfx", "level1/sfx/aud_masked_man_3", 0.2 );
    common_impl.StopAudio( "voc", "level1/voc/aud_masked_man_3_voc", 0.2 );

    common_impl.PlayAudio(  "mus", "aud_masked_man_theme_mus", 0 );

    common_impl.EnvPlay( { "level1/env/aud_rm_lounge_env" }, "", 0.5 );
    common_impl.PlayAudio( "env", "level1/env/aud_lounge_electri_env", 1, "", 0 );

  end;

  common_impl.StopAudio( "env", "level1/env/aud_lounge_electri_env", 0.2 );
  common_impl.StopAudio( "env", "level1/env/aud_rm_lounge_env", 0.2 );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_masked_man_3", 0, "", 0 );
  common_impl.PlayAudio( "voc", "level1/voc/aud_masked_man_3_voc", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_lounge_masked_man_3", func_end );

end;
--*********************************************************************************************************************
function private.LoungeScare_1 ()

  local func_end = function ()

    private.LoungeScare_1_2(); 

  end;

  cmn.Lock( true );
  ObjAnimate( "rm_lounge", "pos_xy", 0, 0, "",
  { 
    0.0, 0, ObjGet( "rm_lounge" ).pos_x,  ObjGet( "rm_lounge" ).pos_y,
    0.3, 0, 29, 3
  } );
  ObjAnimate( "rm_lounge", "scale_xy", 0, 0, func_end,
  { 
    0.0, 0, ObjGet( "rm_lounge" ).scale_x,  ObjGet( "rm_lounge" ).scale_y,
    0.3, 0, 1.2, 1.2
  } );

end;
--*********************************************************************************************************************
function private.LoungeScare_1_2 ()

  cmn.Lock( true );

  cmn.StopMusEnv();
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_blood_tears", 0, "", 0 );

  AnimPlay( "anm_lounge_tears_picture", "DoAnim", private.LoungeScare_1_end );

end;
--*********************************************************************************************************************
function private.LoungeScare_1_end ()

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "see_lounge_scare_1" );
    cmn.CallEventHandler( "see_lounge_scare_1" );

    common_impl.ShowBbt( "bbt_lounge_see_lounge_scare_1" );

    cmn.PlayMusDanger();
    cmn.PlayMusEnv();

  end;

  cmn.Lock( true );
  ObjAnimate( "rm_lounge", "pos_xy", 0, 0, "",
  { 
    0.0, 0, ObjGet( "rm_lounge" ).pos_x,  ObjGet( "rm_lounge" ).pos_y,
    0.3, 0, 0, 0
  } );
  ObjAnimate( "rm_lounge", "scale_xy", 0, 0, func_end,
  { 
    0.0, 0, ObjGet( "rm_lounge" ).scale_x,  ObjGet( "rm_lounge" ).scale_y,
    0.3, 0, 1, 1
  } );

end;
--*********************************************************************************************************************
function private.LoungeScare_2 ()

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "see_lounge_scare_2" );
    cmn.CallEventHandler( "see_lounge_scare_2" );

    common_impl.ShowBbt( "bbt_lounge_see_lounge_scare_2" );

    cmn.PlayMusDanger();
    cmn.PlayMusEnv();

  end;

  cmn.Lock( true );

  cmn.StopMusEnv();
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_mirror_crash", 0, "", 0 );

  AnimPlay( "anm_lounge_mirror_crash", "DoAnim", func_end );

end;

--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** ANIMATIONS *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.Init_Animations ()

  ObjAnimate( "spr_coffeetable_light", "alp",1,0, "", 
  { 
    0.0, 3, 0.7, 
    1.5, 3, 0.1, 
    3.0, 3, 0.4, 
    5.0, 3, 1, 
    6.0, 3, 0.7 
  } );
  ObjAnimate( "spr_coffeetable_button_light", "alp",1,0, "", 
  { 
    0.0, 3, 1, 
    0.6, 3, 0.3, 
    1.5, 3, 1, 
    2.2, 3, 0.1, 
    4.5, 3, 1 
  } );

  -----------------------------------------------------------------------

  ObjAnimate( "spr_washbasin_light_env", "alp",1,0, "", 
  { 
    0.0, 3, 0.7, 
    1.5, 3, 0.1, 
    3.0, 3, 0.4, 
    5.0, 3, 1, 
    6.0, 3, 0.7 
  } );

  -----------------------------------------------------------------------

  ObjAnimate( "spr_washbasin_lamp_light", "alp",1,0, "", 
  { 
    0.0, 3, 1, 
    1.0, 3, 0.5, 
    2.0, 3, 1, 

  } );
  -----------------------------------------------------------------------

  ObjAnimate( "spr_brokenchandelier_wire", "ang",1,0, "", 
  { 
    0.0, 0,  0.04,
    3.5, 0, -0.04,
    7.0, 0,  0.04 } );

end;
--*********************************************************************************************************************
function private.AnimMouseHoleLight ()

  ObjAnimate( "spr_lounge_light_lamp1", "alp",1,0, "", 
  { 
    0.0, 3, 0.0, 
    1.5, 3, 0.5, 
    3.0, 3, 0.0, 
    5.0, 3, 1, 
    7.0, 3, 0.0 
  } );

end;
--*********************************************************************************************************************
function private.AnimWaterfallen ()

  local func_end = function()

    private.AnimWaterfallenTimer();

  end;

  AnimPlay( "anm_washbasin_waterfallen", "DoAnim", func_end );  

end;
function private.AnimWaterfallenTimer ()

  ObjSet( "tmr_washbasin_waterfallen", 
  { 
    endtrig = function() private.AnimWaterfallen() end,
    time = 1,
    playing = true,
  } );  

end;
--*********************************************************************************************************************
function private.AnimWaterfallen_2 ()

  local func_end = function()

    private.AnimWaterfallenTimer_2();

  end;

  AnimPlay( "anm_washbasin_waterfallen_2", "DoAnim", func_end );  

end;
function private.AnimWaterfallenTimer_2 ()

  ObjSet( "tmr_washbasin_waterfallen", 
  { 
    endtrig = function() private.AnimWaterfallen_2() end,
    time = 1,
    playing = true,
  } );  

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.WashbasinClickArrow ()

  local func_end = function()

    cmn.Lock( false ); 
    common_impl.ShowBbt( "bbt_washbasin_use_magnet" );

  end;

  cmn.Lock( true ); 
  ObjAnimate( "spr_washbasin_arrow", "ang", 0, 0, func_end, 
  { 
    0.0, 3, 0.0, 
    0.2, 3, -0.02,
    0.4, 3, 0.0 
  } );

end;
--*********************************************************************************************************************
function private.WashbasinClickWater ()

  local func_end = function ()

    ObjSet( "obj_washbasin_use_boathook_1", { input = true } );

  end;

  common_impl.ShowBbt( 'bbt_washbasin_use_boathook_1' );
  ObjSet( "obj_washbasin_use_boathook_1", { input = false } );

  ObjAnimate( "spr_washbasin_electrolight", "alp",0,0, func_end, { 0,0,0, 0.2,0,1, 0.5,0,0, 0.7,0,1, 1.0,0,0 } );

end;

--*********************************************************************************************************************
function private.WashbasinClickButton ()

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk6", 0, "", 0 );

  local func_end = function ()

    ObjSet( "obj_washbasin_use_safetylock", { input = true } );

  end;

  common_impl.ShowBbt( 'bbt_washbasin_use_safetylock' );
  ObjSet( "obj_washbasin_use_safetylock", { input = false } );

  ObjAnimate( "spr_washbasin_button_on", "alp",0,0, "", { 0,1,0,    0.1,1,1,    0.2,2,0 } );
  ObjAnimate( "spr_washbasin_button_off", "alp",0,0, func_end, { 0,2,1,   0.1,2,0,    0.2,1,1 } );

end;


--*********************************************************************************************************************
function private.ChargedcrossbowClick ()

  if cmn.IsEventDone( "anm_chargedcrossbow" ) then 

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_dummy2", 0, "", 0 );

  else 

    cmn.SetEventDone( "anm_chargedcrossbow" );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_dummy1", 0, "", 0 );

  end;

  local func_end = function ()

    cmn.Lock( false );
    ObjSet( "obj_lounge_use_chargedcrossbow", { input = true } );

    AnimStop( "anm_lounge_chandelier" );
    AnimPlay( "anm_lounge_chandelier", "swing", "" ); 

  end;

  common_impl.ShowBbt( "bbt_lounge_use_chargedcrossbow" );

  cmn.Lock( true );
  ObjSet( "obj_lounge_use_chargedcrossbow", { input = false } );

  AnimStop( "anm_lounge_chandelier" );
  AnimPlay( "anm_lounge_chandelier", "click", func_end ); 

end;
--*********************************************************************************************************************
function private.UseScrewdriver_2Click ()

  local func_end = function()

    cmn.Lock( false );    
    common_impl.ShowBbt( "bbt_washbasin_use_screwdriver_2" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

  ObjAnimate( "spr_washbasin_basreliefpart", "ang", 0, 0, func_end,
  { 
    0.0, 0, 0,
    0.1, 0, -0.02,
    0.2, 0, 0,
    0.3, 0, -0.02,
    0.4, 0, 0
  } );

end;
--*********************************************************************************************************************
function private.ClkValveRight ()

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

  local func_end = function()

    cmn.Lock( false );    
    common_impl.ShowBbt( "bbt_washbasin_clk_valve_right" );

  end;

  cmn.Lock( true );
  AnimPlay( "anm_washbasin_valve_right", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.ClkValveLeft ()

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

  local func_end = function()

    cmn.Lock( false );    
    common_impl.ShowBbt( "bbt_washbasin_clk_valve_left" );

  end;

  cmn.Lock( true );
  AnimPlay( "anm_washbasin_valve_left", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************

function private.CoffeetableFeedbackAnim()

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk2", 0, "", 0 );
  common_impl.ShowBbt( "bbt_coffeetable_use_wire" );

  local obj = "spr_coffeetable_box_cover";
  local x_start = ObjGet( obj ).pos_x;
  local y_start = ObjGet( obj ).pos_y;

  local time = 0.3;
  local dx = 1;
  local dy = -1;

  ObjSet( "obj_coffeetable_use_wire", { input = false } );

  local func_end = function ()

    ObjSet( "obj_coffeetable_use_wire", { input = true } );

  end;

  ObjAnimate( obj, "pos_x",0,0, "", { 0,0,x_start, time/4,0,x_start+dx, 3/4*time,0,x_start-dx, time,0,x_start } ); 
  ObjAnimate( obj, "pos_y",0,0, func_end, { 0,0,y_start, time/4,0,y_start+dy, 3/4*time,0,y_start-dy, time,0,y_start });  

end;

--*********************************************************************************************************************

function private.CoffeetableClickButton()

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk4", 0, "", 0 );
  common_impl.ShowBbt( "bbt_coffeetable_use_figurinepart" );

  ObjSet( "obj_coffeetable_use_figurinepart", { input = false } );
  local func_end = function ()
    ObjSet( "obj_coffeetable_use_figurinepart", { input = true } );
  end;

  ObjAnimate( "spr_coffeetable_button_off", "alp",0,0, func_end, { 0, 0, 1,    0.1, 0, 0,    0.2, 0, 1 } );

end;

--*********************************************************************************************************************

function private.BrokenchandelierFeedbackAnim()

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_debris", 0, "", 0 );
  common_impl.ShowBbt( "bbt_brokenchandelier_use_broom" );

  local obj = "spr_brokenchandelier_mirror_1";
  local x_start = ObjGet( obj ).pos_x;
  local y_start = ObjGet( obj ).pos_y;

  local time = 0.3;
  local dx = 1;
  local dy = -1;

  ObjSet( "obj_brokenchandelier_use_broom", { input = false } );
  local func_end = function ()
    ObjSet( "obj_brokenchandelier_use_broom", { input = true } );
  end;

  ObjAnimate( obj, "pos_x",0,0, "", { 0,0,x_start, time/4,0,x_start+dx, 3/4*time,0,x_start-dx, time,0,x_start } ); 
  ObjAnimate( obj, "pos_y",0,0, func_end, { 0,0,y_start, time/4,0,y_start+dy, 3/4*time,0,y_start-dy, time,0,y_start });  

end;

--*********************************************************************************************************************





