-- name=rm_park_1
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_park_1";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.InitAnimations();

  private.anim_shoot_count = 0

  local tb = {}
  table.insert( tb, { "spr_park_1_gloves",                            { event_mdown = private.get_gloves } } );
  table.insert( tb, { "spr_park_1_metallic_shield",                   { event_mdown = private.get_metallic_shield } } );

  table.insert( tb, { "obj_sofit_clk_sofit_1",                        { event_mdown = private.clk_sofit_1 } } );
  table.insert( tb, { "obj_sofit_clk_sofit_2",                        { event_mdown = private.clk_sofit_2 } } );
  table.insert( tb, { "obj_sofit_clk_sofit_3",                        { event_mdown = private.clk_sofit_3 } } );
  table.insert( tb, { "obj_park_1_clk_professor_1",                   { event_mdown = private.dlg_professor_1_click } } );
  table.insert( tb, { "obj_park_1_clk_professor_1_focus",             { event_mdown = private.dlg_professor_1_click } } );

  table.insert( tb, { "spr_park_1_professor_2_contract_pen_1",        { event_mdown = private.ContraktGetPen } } );
  table.insert( tb, { "obj_park_1_professor_2_contract",              { event_mdown = function() private.ClkDlgContrakt( "start" ) end; } } );
  table.insert( tb, { "obj_park_1_professor_2_contract_focus",        { event_mdown = function() private.ClkDlgContrakt( "start" ) end; } } );

  table.insert( tb, { "txt_park_1_professor_2_contract_text_4",       { param0 = GetCurrentProfile() } } );

  for i = 1, 8 do

    table.insert( tb, { "obj_park_1_professor_2_contract_text_"..i,
    {
      event_mdown = function() private.ContraktClkText( i ) end,
      event_mup = function() private.ContraktClkText( i ) end,
      event_menter = private.ContraktEnterText,
      event_mleave = private.ContraktLeaveText
    } } );

  end;

  ObjSet("obj_park_1_professor_2_contract_obj_up",{ event_mup = function() private.ContraktPenStopDrag(); end });
  
  
  ObjMultiSet( tb );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_park_1 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then  
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then   
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "gzz_park_1_sofit",
      "gho_park_1_suitcase",
    };
    for i = 1, #gates do
      local name = gates[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then  
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then   
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_sofit"
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_park_1", update_game_mode_park_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_park_1 = function ()
    
    local effects_table = 
    {
      "anm_park_1_sky_after",
      "anm_park_1_balls",
      "anm_park_1_shot",
      "anm_park_1_kevin",
      "anm_park_1_electricity",
      "anm_park_1_shield_electricity",
      "anm_park_1_sky",
      "anm_park_1_balls_small",
      "anm_park_1_blind",
      "anm_park_1_light",
      "anm_park_1_camera_flares",
      "anm_park_1_balls_0",
      "anm_park_1_kevin_reynolds_1",
      "anm_park_1_kevin_reynolds_2",
      "anm_park_1_shield",
      "anm_park_1_shoot",
      "anm_sofit_electrolights",
    }

    local active = true;

    if ( GetPerformanceMode() == 1 ) then

      active = false;

    end;

    for i = 1, #effects_table do

      ObjSet( effects_table[ i ], { active = active } );

    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_park_1", update_performance_mode_park_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_park_1 () end;
  --------------------------------------------------------------------------------------------
  local opn_park_1 = function ()

  end;

  local opn_park_1_map = function ()

    common_impl.VisitMapRoom( "park_1" );

  end;

  cmn.AddSubscriber( "opn_park_1", opn_park_1_map );
  cmn.AddSubscriber( "opn_park_1", opn_park_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_attempt () end;
  --------------------------------------------------------------------------------------------
  local see_attempt = function ()
    
    ObjSet( "gzz_park_1_sofit", { active = true, input = true } );
    ObjSet( "obj_park_1_use_gloves_3", { input = true } );
    ObjSet( "spr_park_1_metallic_shield", { alp = 1 } );

    ObjDelete( "anm_park_1_kevin_reynolds_1" );
    ObjDelete( "anm_park_1_kevin_reynolds_2" );
    ObjDelete( "spr_park_1_back_park_0" );
    ObjDelete( "spr_park_1_suitcase" );
    ObjDelete( "anm_park_1_camera_flares" );
    ObjDelete( "anm_park_1_balls_0" );

    ObjSet( "spr_park_1_gloves", { input = true } );

    ObjSet( "obj_park_1_clk_window", { input = true } );
    ObjSet( "obj_park_1_clk_save_professor", { input = true } );

  end;

  cmn.AddSubscriber( "see_attempt", see_attempt, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_park_1_professor_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_park_1_professor_1" ] = {
    type = "click",
    use_place = "obj_park_1_clk_professor_1_focus",
    room = private.room_objname
  };
  local dlg_park_1_professor_1 = function ()

    ObjDelete( "obj_park_1_clk_professor_1" );
    ObjDelete( "obj_dlg_park_1_professor_1_lip" );
    ObjSet( "vid_dlg_park_1_professor_2", { active = true, visible = true } );

  end;
  cmn.AddSubscriber( "dlg_park_1_professor_1", dlg_park_1_professor_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_park_1_professor_2 () end;
  --------------------------------------------------------------------------------------------
  local dlg_park_1_professor_2 = function ()

    ObjDelete( "obj_dlg_park_1_professor_2_lip" );
    ObjDelete( "anm_park_1_kevin_reynolds_1" );

  end;
  cmn.AddSubscriber( "dlg_park_1_professor_2", dlg_park_1_professor_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gloves_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gloves_1" ] = {
      type = "use",
      inv_obj = "inv_gloves",
      use_place = "obj_sofit_use_gloves_1",
      room = private.room_objname,
      zz = "zz_sofit",
      zz_gate = "gzz_park_1_sofit"
    
  };
  local use_gloves_1_inv = function ()
  
    if cmn.IsEventDone( "use_gloves_2" ) and cmn.IsEventDone( "use_gloves_3" ) then

      interface.InventoryItemRemove( "inv_gloves" );

    end;
  
  end;
  local use_gloves_1_beg = function ()
  
    ObjDelete( "obj_sofit_use_gloves_1" );
  
  end;
  local use_gloves_1_end = function ()
  
    ObjDelete( "spr_sofit_wire_1" );
    ObjDelete( "spr_sofit_wire_3" );
    ObjDelete( "anm_sofit_electrolights" );

    ObjSet( "obj_sofit_clk_sofit_1", { input = true } );  
    ObjSet( "obj_sofit_clk_sofit_2", { input = true } );  
    ObjSet( "obj_sofit_clk_sofit_3", { input = true } ); 

    ObjDelete( "anm_park_1_electricity" ); 

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gloves_1", use_gloves_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_gloves_1", use_gloves_1_inv );
  cmn.AddSubscriber( "use_gloves_1", use_gloves_1_end, private.room_objname );
  cmn.AddSubscriber( "use_gloves_1_inv", use_gloves_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_gloves_1_beg", use_gloves_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_gloves_1_end", use_gloves_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_certificate () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_certificate" ] = {
      type = "use",
      inv_obj = "inv_certificate",
      use_place = "obj_park_1_use_certificate",
      room = private.room_objname,
  };
  local use_certificate_inv = function ()
  
    interface.InventoryItemRemove( "inv_certificate" );

  end;
  local use_certificate_beg = function ()
  
    ObjDelete( "obj_park_1_use_certificate" );
  
  end;
  local use_certificate_end = function ()
  

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_certificate", use_certificate_inv );
  cmn.AddSubscriber( "use_certificate", use_certificate_beg, private.room_objname );
  cmn.AddSubscriber( "use_certificate", use_certificate_end, private.room_objname );
  cmn.AddSubscriber( "use_certificate_inv", use_certificate_inv, private.room_objname );
  cmn.AddSubscriber( "use_certificate_beg", use_certificate_beg, private.room_objname );
  cmn.AddSubscriber( "use_certificate_end", use_certificate_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gloves_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gloves_3" ] = {
      type = "use",
      inv_obj = "inv_gloves",
      use_place = "obj_park_1_use_gloves_3",
      room = private.room_objname,
  };
  local use_gloves_3_inv = function ()
  
    if cmn.IsEventDone( "use_gloves_1" ) and cmn.IsEventDone( "use_gloves_2" ) then

      interface.InventoryItemRemove( "inv_gloves" );

    end;

  end;
  local use_gloves_3_beg = function ()
  
    ObjDelete( "obj_park_1_use_gloves_3" );
  
  end;
  local use_gloves_3_end = function ()

    ObjDelete( "vid_park_1_use_gloves" );
    ObjDelete( "anm_park_1_shield_electricity" );
    ObjSet( "spr_park_1_metallic_shield", { input = true } );
    ObjSet( "gfx_park_1_metallic_shield", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gloves_3", use_gloves_3_inv );
  cmn.AddSubscriber( "use_gloves_3", use_gloves_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_gloves_3", use_gloves_3_end, private.room_objname );
  cmn.AddSubscriber( "use_gloves_3_inv", use_gloves_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_gloves_3_beg", use_gloves_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_gloves_3_end", use_gloves_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gloves () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_gloves" ] =
  {
    type = "get",
    get_obj = "spr_park_1_gloves",
    room = private.room_objname,
  };
  -----------------------------------------------
  local get_gloves_inv = function ()

    interface.InventoryItemAdd( "inv_gloves", "spr_park_1_gloves" );

  end;

  local get_gloves_closezz = function ()

    ObjDelete( "gfx_park_1_gloves" );

  end;

  cmn.AddSubscriber( "get_gloves", get_gloves_inv );
  cmn.AddSubscriber( "get_gloves", get_gloves_closezz, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_sofit () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sofit" ] =
  {
    type = "get",
    get_obj = "spr_sofit_sofit",
    room = private.room_objname,
    zz = "zz_sofit",
    zz_gate = "gzz_park_1_sofit"
  };
  -----------------------------------------------
  local get_sofit_inv = function ()

    interface.InventoryItemAdd( "inv_sofit", "spr_sofit_sofit" );
    ObjSet( "inv_sofit", { drag = false } );

  end;

  local get_sofit_closezz = function ()

    ObjDelete( "gzz_park_1_sofit" );
    ObjDelete( "spr_park_1_sofit" );

  end;

  cmn.AddSubscriber( "get_sofit", get_sofit_inv );
  cmn.AddSubscriber( "get_sofit", get_sofit_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_metallic_shield () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_metallic_shield" ] =
  {
    type = "get",
    get_obj = "spr_park_1_metallic_shield",
    room = private.room_objname,
  };
  -----------------------------------------------
  local get_metallic_shield_closezz = function ()

    ObjDelete( "spr_park_1_metallic_shield" );
    ObjSet( "anm_park_1_shield", { active = true, alp = 1 } );
    ObjDelete( "obj_park_1_clk_save_professor" );

    ObjSet( "grm_park_1_park_2", { active = true, input = true, visible = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_park_1_park_2_focus");
    end;
--    if cmn.IsEventDone( "clk_shot_1" ) then
--
--      
--
--    end;

  end;

  cmn.AddSubscriber( "get_metallic_shield", get_metallic_shield_closezz, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_sofit_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_sofit_1" ] = {
    type = "click",
    use_place = "obj_sofit_clk_sofit_1",
    room = private.room_objname,
    zz = "zz_sofit",
    zz_gate = "gzz_park_1_sofit"
  };

  local clk_sofit_1_beg = function ()
  
    ObjDelete( "obj_sofit_clk_sofit_1" );
  
  end;
  local clk_sofit_1_end = function ()

    ObjDelete( "spr_sofit_sofit_parts_1" );

    ObjDelete( "spr_park_1_sofit_parts" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_sofit_1", clk_sofit_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_sofit_1", clk_sofit_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_sofit_1_beg", clk_sofit_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_sofit_1_end", clk_sofit_1_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_sofit_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_sofit_2" ] = {
    type = "click",
    use_place = "obj_sofit_clk_sofit_2",
    room = private.room_objname,
    zz = "zz_sofit",
    zz_gate = "gzz_park_1_sofit"
  };

  local clk_sofit_2_beg = function ()
  
    ObjDelete( "obj_sofit_clk_sofit_2" );
  
  end;
  local clk_sofit_2_end = function ()

    ObjDelete( "spr_sofit_sofit_1" );

    ObjDelete( "spr_park_1_sofit_1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_sofit_2", clk_sofit_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_sofit_2", clk_sofit_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_sofit_2_beg", clk_sofit_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_sofit_2_end", clk_sofit_2_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_sofit_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_sofit_3" ] = {
    type = "click",
    use_place = "obj_sofit_clk_sofit_3",
    room = private.room_objname,
    zz = "zz_sofit",
    zz_gate = "gzz_park_1_sofit"
  };

  local clk_sofit_3_beg = function ()

   ObjDelete( "obj_sofit_clk_sofit_3" );
  
  end;
  local clk_sofit_3_end = function ()

    ObjDelete( "spr_sofit_sofit_2" );

    ObjDelete( "spr_park_1_sofit_2" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_sofit_3", clk_sofit_3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_sofit_3", clk_sofit_3_end, private.room_objname );
  cmn.AddSubscriber( "clk_sofit_3_beg", clk_sofit_3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_sofit_3_end", clk_sofit_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_shot_1 () end;
  --------------------------------------------------------------------------------------------
  --common_impl.hint[ "clk_shot_1" ] = {
  --  type = "click",
  --  use_place = "obj_park_1_clk_shot_1",
  --  room = private.room_objname,
  --};

  local clk_shot_1_beg = function ()

  end;
  local clk_shot_1_end = function ()

    --ObjDelete( "anm_park_1_shot" );

    if cmn.IsEventDone( "get_metallic_shield" ) then

      ObjSet( "grm_park_1_park_2", { input = true } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_park_1_park_2_focus");
      end;
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_shot_1", clk_shot_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_shot_1", clk_shot_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_shot_1_beg", clk_shot_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_shot_1_end", clk_shot_1_end, private.room_objname );
end;
--*********************************************************************************************************************
function public.Load()
  
end;
--********************************************************************************************************************
function private.Init_Subroom()
  --*********************************************************************************************************************
  -- function  zz_sofit  () end;
  --*********************************************************************************************************************

    subroom.Define( "zz_sofit" );    
    function zz_sofit.PreOpen()

      common_impl.StopAudio( "env", "level1/env/aud_electri_env", 0.5 );

      if not ( cmn.IsEventDone( "use_gloves_1" ) ) then

        common_impl.PlayAudio( "env", "level1/env/aud_zz_floor_env",  1, "", 1 ); 

      end

    end;

    function zz_sofit.Open()

    end;

    function zz_sofit.PreClose()

      common_impl.StopAudio( "env", "level1/env/aud_zz_floor_env", 0.5 );

      if not ( cmn.IsEventDone( "use_gloves_3" ) ) then

        common_impl.PlayAudio( "env", "level1/env/aud_electri_env",  1, "", 1 );

      end;

    end;

    function zz_sofit.Close()

      if cmn.IsEventDone( "get_sofit" ) and not cmn.IsEventDone( "use_gloves_3" ) then

        common_impl.TutorialShow( "tutorial_page_9" );

      end;

    end;
end;
--*********************************************************************************************************************
function public.Open()

  if not cmn.IsEventStart( "see_tutorial" ) and cmn.IsEventDone( "see_intro" ) then

    common_impl.TutorialShow( "tutorial_page_1" );

  elseif cmn.IsEventStart( "see_tutorial" ) then

    common_impl.TutorialShow( "tutorial_page_2" );

    if cmn.IsEventDone( "dlg_park_1_professor_1" ) and not cmn.IsEventDone( "win_small_suitcase" ) then

      int_inventory.Show( true );
      common_impl.TutorialShow( "tutorial_page_3" );

    end;

    if cmn.IsEventDone( "see_attempt" ) then

      common_impl.TutorialShow( "tutorial_page_7" );

    end;

    if cmn.IsEventDone( "get_sofit" ) and not cmn.IsEventDone( "use_gloves_3" ) then

      common_impl.TutorialShow( "tutorial_page_9" );

    end;

  end;

  if not ( cmn.IsEventDone( "opn_park_1" ) ) then

    cmn.SetEventDone( "opn_park_1" );
 
  end;

  cmn.CallEventHandler( "opn_park_1" ); 

  if cmn.IsEventDone( "see_attempt" ) then

    private.Shoot();
    
  end;

  if not cmn.IsEventDone( "see_attempt" ) and cmn.IsEventDone( "dlg_park_1_professor_2" ) then

    private.Attempt();

  end;

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventDone( "see_intro" ) ) then

    local widget_settings = {}

    if IsCollectorsEdition() then

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu,
        InterfaceWidget_morph
      }

    else

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnMenu
      }

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 0 );

    end;

    ObjSet( private.room_objname, { color_r = 0, color_g = 0, color_b = 0 } );
    ObjAttach( "tmr_park_1_intro", private.room_objname );
    ObjSet( "tmr_park_1_intro",
    {
      time = 0.001,
      playing = true,
      endtrig = function() private.SeeIntro(); end
    } );

  else

    if not cmn.IsEventDone( "see_attempt" ) then 

      common_impl.EnvPlay( { "level1/env/aud_rm_park_1_env" }, "", 0.5 );
      --common_impl.PlayAudio( "env", "mus_env/aud_track2_mus_env",  1, "", 1 );

    else 

      common_impl.EnvPlay( { "level1/env/aud_rm_park_1_1_env" }, "", 0.5 );

      if ( cmn.IsEventDone( "use_gloves_3" ) and cmn.IsEventDone( "use_gloves_3" ) ) then
         
      else

        common_impl.PlayAudio( "env", "level1/env/aud_electri_env",  1, "", 1 );

      end

    end;

  end;

  if ( not cmn.IsEventDone( "win_small_suitcase" ) ) then

    interface.InventoryItemAdd( "inv_small_suitcase" );
    ObjSet( "inv_small_suitcase", { drag = false } );

  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  if cmn.IsEventDone( "see_attempt" ) then 

    common_impl.StopAudio( "env", "level1/env/aud_electri_env", 0.5 );

  end;

  if cmn.IsEventDone( "get_metallic_shield" ) then

    ObjSet( "anm_park_1_shield", { active = true, alp = 1 } );
    ObjSet( "anm_park_1_shoot", { alp = 0 } );
    AnimStop( "anm_park_1_shoot" );
    ObjSet( "tmr_park_1_shoot", { piaying = false } );

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
function public.use_gloves_1 ()

  local item = "inv_gloves";

  if cmn.ApplyObj( item, "gzz_park_1_sofit" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_sofit", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_sofit_use_gloves_1" ) and  cmn.IsEventDone( "see_attempt" ) ) then

    cmn.CallEventHandler( "use_gloves_1_inv" );
    cmn.CallEventHandler( "use_gloves_1_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_gloves_1" );
      cmn.CallEventHandler( "use_gloves_1_end" );

      common_impl.StopAudio( "env", "level1/env/aud_zz_floor_env", 0.5 );

      if ( cmn.IsEventDone( "use_gloves_3" ) ) then 

        common_impl.StopAudio( "env", "level1/env/aud_electri_env", 0.5 );

      end;  
  
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_remove_clk3", 0, "", 0 );

    ObjAnimate( "spr_sofit_wire_1", "alp", 0, 0, func_end,
      { 
        0.0, 0, 1, 
        0.3, 0, 0
      } );
    ObjAnimate( "spr_sofit_wire_3", "alp", 0, 0, "",
      { 
        0.0, 0, 1, 
        0.3, 0, 0
      } );
    ObjAnimate( "anm_sofit_electrolights", "alp", 0, 0, "",
      { 
        0.0, 0, 1, 
        0.3, 0, 0
      } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_certificate ()

  local item = "inv_certificate";

  if ( cmn.ApplyObj( item, "obj_park_1_use_certificate" ) and cmn.IsEventDone( "dlg_park_1_professor_1" ) ) then

    cmn.CallEventHandler( "use_certificate_inv" );
    cmn.CallEventHandler( "use_certificate_beg" );

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_park_1_use_certificate", 0, "", 0 );
    private.dlg_professor_2();

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_gloves_3 ()

  local item = "inv_gloves";

  if ( cmn.ApplyObj( item, "obj_park_1_use_gloves_3" ) and cmn.IsEventDone( "see_attempt" ) ) then

    cmn.CallEventHandler( "use_gloves_3_inv" );
    cmn.CallEventHandler( "use_gloves_3_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_gloves_3" );
      cmn.CallEventHandler( "use_gloves_3_end" );
    
      if ( cmn.IsEventDone( "use_gloves_1" ) ) then 

        common_impl.StopAudio( "env", "level1/env/aud_electri_env", 0.5 );

      end;
    
    end;

    local func_end_2 = function ()

      ObjSet( "anm_park_1_shield_electricity", { alp = 0 } );

    end; 

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_park_1_use_gloves_1", 0, "", 0 );

    ObjSet( "vid_park_1_use_gloves", { alp = 0, visible = true } );
    ObjAnimate( "vid_park_1_use_gloves", "alp",0,0, func_end_2, { 0, 0, 0,    0.3, 0, 1 } );
    VidPlay( "vid_park_1_use_gloves", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
function private.get_gloves ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_gloves" );
  cmn.CallEventHandler( "get_gloves" );

  common_impl.TutorialShow( "tutorial_page_17" );

end;
--------------------------------------------------------------------------------------------
function private.get_sofit ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_sofit" );
  cmn.CallEventHandler( "get_sofit" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_metallic_shield ()

  local func_end = function ()

    cmn.Lock(false);

    cmn.SetEventDone( "get_metallic_shield" );
    cmn.CallEventHandler( "get_metallic_shield" );

    private.clk_shot_1();

  end;

  cmn.Lock(true);

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_trash_can", 0, "", 0 );

  ObjSet( "anm_park_1_shield", { active = true } );
  ObjAnimate( "anm_park_1_shield", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0, 
      0.3, 0, 1
    } );

  ObjAnimate( "spr_park_1_metallic_shield", "alp", 0, 0, "",
    { 
      0.0, 0, 1, 
      0.3, 0, 0
    } );

end;
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_sofit_1 ()

  cmn.CallEventHandler( "clk_sofit_1_beg" );

  local func_end = function ()

    cmn.Lock(false);
    cmn.SetEventDone( "clk_sofit_1" );
    cmn.CallEventHandler( "clk_sofit_1_end" );

    if ( cmn.IsEventDone( "clk_sofit_2" ) and cmn.IsEventDone( "clk_sofit_3" ) ) then

      private.get_sofit();

    end;
  
  end;

  cmn.Lock(true);

  common_impl.PlayAudio( "sfx", "aud_remove_clk1", 0, "", 0 );
  ObjAnimate( "spr_sofit_sofit_parts_1", "pos_xy", 0, 0, func_end,
    { 
      0.0, 0, 186, 200,
      0.3, 3, 201, 365
    } );

end;
--------------------------------------------------------------------------------------------
function private.clk_sofit_2 ()

  cmn.CallEventHandler( "clk_sofit_2_beg" );

  local func_end = function ()

    cmn.Lock(false);
    cmn.SetEventDone( "clk_sofit_2" );
    cmn.CallEventHandler( "clk_sofit_2_end" );

    if ( cmn.IsEventDone( "clk_sofit_1" ) and cmn.IsEventDone( "clk_sofit_3" ) ) then

      private.get_sofit();

    end;
  
  end;

  cmn.Lock(true);

  common_impl.PlayAudio( "sfx", "aud_remove_clk2", 0, "", 0 );
  ObjAnimate( "spr_sofit_sofit_1", "pos_xy", 0, 0, func_end,
    { 
      0.0, 0, 199, 0, 
      0.5, 3, 485, -58
    } );

end;
--------------------------------------------------------------------------------------------
function private.clk_sofit_3 ()

  cmn.CallEventHandler( "clk_sofit_3_beg" );

  local func_end = function ()

    cmn.Lock(false);
    cmn.SetEventDone( "clk_sofit_3" );
    cmn.CallEventHandler( "clk_sofit_3_end" );

    if ( cmn.IsEventDone( "clk_sofit_1" ) and cmn.IsEventDone( "clk_sofit_2" ) ) then

      private.get_sofit();

    end;
  
  end;

  cmn.Lock(true);

  common_impl.PlayAudio( "sfx", "aud_remove_clk3", 0, "", 0 );
  ObjAnimate( "spr_sofit_sofit_2", "pos_xy", 0, 0, func_end,
    { 
      0.0, 0, -53, -78, 
      0.5, 3, -502, -267
    } );

end;
--------------------------------------------------------------------------------------------
function private.clk_shot_1 ()

  cmn.CallEventHandler( "clk_shot_1_beg" );

  --cmn.Lock(true);

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_park_2_clk_shot_2", 0, "", 0 );

  local func_after = function ()

    local func_end = function ()

      cmn.Lock(false);
      cmn.SetEventDone( "clk_shot_1" );
      cmn.CallEventHandler( "clk_shot_1_end" );
      common_impl.ShowBbt( "bbt_park_1_clk_shot_1" );

    end;

    if not cmn.IsEventDone( "get_metallic_shield" ) then

      ObjAnimate( "rm_park_1", "scale_xy", 0, 0, func_end,
      { 
        0.0, 3, 1, 1,
        0.5, 3, 1.4, 1.4,
        0.8, 3, 1.4, 1.4,
        1.3, 3, 1, 1,
      } );

      ObjAnimate( "rm_park_1", "pos_xy", 0,0,"",
      { 
        0.0, 3, 0, 0,
        0.5, 3, -478, -307,
        0.8, 3, -478, -307,
        1.3, 3, 0, 0,
      } );

    else

      func_end();

    end;

  end;

  AnimPlay( "anm_park_1_shot", "DoAnim", func_after );

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.SeeIntro ()

  ObjDelete( "tmr_park_1_intro" ); 

  local func_after = function ()

    ObjSet( private.room_objname, { color_r = 1, color_g = 1, color_b = 1 } );

    cmn.SetEventDone( "see_intro" );
    cmn.CallEventHandler( "see_intro" );

    common_impl.StopAudio( "voc", "level1/voc/aud_intro_lvl1_voc", 0.2 );
    common_impl.StopAudio( "sfx", "level1/sfx/aud_intro_lvl1", 0.2 );
    common_impl.EnvPlay( { "level1/env/aud_rm_park_1_env" }, "", 0.5 );
    --common_impl.PlayAudio( "env", "mus_env/aud_track2_mus_env",  1, "", 1 );

    cmn.SetEventDone( "opn_park_1" ); 
    cmn.CallEventHandler( "opn_park_1" ); 

    common_impl.ShowBbt( "bbt_park_1_opn_park_1" );
    --interface.KeyTaskAdd( "talk_with_the_man", function () common_impl.TutorialShow( "tutorial_page_1" ); end );
    common_impl.TutorialShow( "tutorial_page_1" );
      
    local widget_settings = {}

    if IsCollectorsEdition() then

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu,
        InterfaceWidget_morph
      }

    else

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnMenu
      }

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 1, true );

    end;

  end;

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_intro_lvl1", 0, "", 0 );
  common_impl.PlayAudio( "voc", "level1/voc/aud_intro_lvl1_voc", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_park_1_intro", func_after );

end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )

  if dlg_name == "professor_1" then

    if ( count_txt == 1 ) then

      for i = 1, 2 do

        VidStop( "vid_dlg_park_1_professor_1_lip_"..i );
        ObjSet( "vid_dlg_park_1_professor_1_lip_"..i, { alp = 0 } );

      end;

      ObjDelete( "vid_dlg_park_1_professor_1" );
      ObjSet( "vid_dlg_park_1_professor_1_lip_1", { alp = 1 } );
      VidPlay( "vid_dlg_park_1_professor_1_lip_1", "" );
      
    elseif ( count_txt == 2 ) then

      for i = 1, 2 do

        VidStop( "vid_dlg_park_1_professor_1_lip_"..i );
        ObjSet( "vid_dlg_park_1_professor_1_lip_"..i, { alp = 0 } );

      end;

      ObjSet( "vid_dlg_park_1_professor_1_lip_2", { alp = 1 } );
      VidPlay( "vid_dlg_park_1_professor_1_lip_2", "" );

    end;

  end;

  if dlg_name == "professor_2" then

    if ( count_txt == 1 ) then

      for i = 1, 3 do

        VidStop( "vid_dlg_park_1_professor_2_lip_"..i );
        ObjSet( "vid_dlg_park_1_professor_2_lip_"..i, { alp = 0 } );

      end;

      ObjDelete( "vid_dlg_park_1_professor_2" );
      ObjSet( "vid_dlg_park_1_professor_2_lip_1", { alp = 1 } );
      VidPlay( "vid_dlg_park_1_professor_2_lip_1", "" );

    elseif ( count_txt == 2 ) then

      private.DlgContrakt = ObjGet( "obj_int_dialog_character_input" ).event_mdown;
      ObjSet( "obj_int_dialog_character_input", { input = false } );

      ObjSet( "anm_park_1_kevin_reynolds_1", { alp = 0, active = false } );
      ObjSet( "anm_park_1_kevin_reynolds_2", { alp = 1, active = true } );
      ObjSet( "obj_park_1_professor_2_contract", { input = true } );

      for i = 1, 3 do

        VidStop( "vid_dlg_park_1_professor_2_lip_"..i );
        ObjSet( "vid_dlg_park_1_professor_2_lip_"..i, { alp = 0 } );

      end;
      ObjSet( "vid_dlg_park_1_professor_2_lip_2", { alp = 1 } );
      VidPlay( "vid_dlg_park_1_professor_2_lip_2", "" );

    elseif ( count_txt == 3 ) then

      for i = 1, 3 do

        VidStop( "vid_dlg_park_1_professor_2_lip_"..i );
        ObjSet( "vid_dlg_park_1_professor_2_lip_"..i, { alp = 0 } );

      end;

      ObjSet( "anm_park_1_kevin_reynolds_1", { alp = 0, active = false } );
      ObjSet( "anm_park_1_kevin_reynolds_2", { alp = 1, active = true } );
      ObjSet( "vid_dlg_park_1_professor_2_lip_3", { alp = 1 } );
      VidPlay( "vid_dlg_park_1_professor_2_lip_3", "" );

    end;

  end;

end;
--------------------------------------------------------------------------------------------
function private.dlg_professor_1_click ()

  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "professor_1", 3, nil, nil, true, private.dlg_professor_1_end );

end;
--------------------------------------------------------------------------------------------
function private.dlg_professor_1_end ()

  cmn.CallEventHandler( "dlg_park_1_professor_1" );   
  common_impl.ShowBbt( "bbt_park_1_dlg_park_1_professor_1" );

  interface.KeyTaskDone( true );
  interface.KeyTaskAdd( "id" );

  if not cmn.IsEventDone( "win_small_suitcase" ) then

    int_inventory.Show( true );
    common_impl.TutorialShow( "tutorial_page_3" );

  end;

  for i = 1, 2 do

    VidStop( "vid_dlg_park_1_professor_1_lip_"..i );
    ObjSet( "vid_dlg_park_1_professor_1_lip_"..i, { alp = 0 } );

  end;

end;
--------------------------------------------------------------------------------------------
function private.dlg_professor_2 ()

  cmn.CallEventHandler( "use_certificate_end" );

  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "professor_2", 4, nil, nil, true, private.dlg_professor_2_end );

end;
--------------------------------------------------------------------------------------------
function private.dlg_professor_2_end ()


  cmn.SetEventDone( "use_certificate" );
  private.Attempt();

end;
--------------------------------------------------------------------------------------------
function private.ClkDlgContrakt ( state )

  if state == "start" then

    ObjSet( "spr_park_1_professor_2_contract", { input = true } );

    local func_end = function()

      cmn.Lock( false );

      ObjDelete( "obj_park_1_professor_2_contract" );

      private.contrakt_pen = false;
      private.contrakt = 0;

    end;

    cmn.Lock( true );

    ObjSet( "anm_park_1_kevin_reynolds_1", { alp = 1, active = true } );
    ObjSet( "anm_park_1_kevin_reynolds_2", { alp = 0, active = false } );

    ObjAnimate( "spr_park_1_professor_2_contract", "alp", 0, 0, func_end, { 0, 0, 0,   0.3, 0, 1 } );
    ObjAnimate( "txt_int_dialog_character_continue", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 } );

  elseif state == "close" then

    local func_end = function()

      cmn.Lock( false );

      private.DlgContrakt();
      ObjSet( "obj_int_dialog_character_input", { input = true, event_mdown = private.DlgContrakt } );
      ObjSet( "spr_park_1_professor_2_contract", { input = false } );

    end;

    cmn.Lock( true );

    ObjAnimate( "spr_park_1_professor_2_contract", "alp", 0, 0, func_end, { 0, 0, 1,   0.3, 0, 0 } )
    ObjAnimate( "txt_int_dialog_character_continue", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 } );

  end;

end;
--------------------------------------------------------------------------------------------
function private.ContraktGetPen ()

  --SetCursor( CURSOR_NULL );

  private.contrakt_pen = true;

  ObjSet( "spr_park_1_professor_2_contract_pen_1", { alp = 0, input = false } );
  ObjSet( "spr_park_1_professor_2_contract_pen_2", { alp = 1 } );
  ObjSet( "obj_park_1_professor_2_contract_obj_up", { input = true } );
  
  private.ContraktPenDrag();

end;
--------------------------------------------------------------------------------------------
function private.ContraktPenDrag ()

  if not private.contrakt_pen then

    return;

  end;

  local pos = GetZoomCursorPos();

  local pos_x = pos[ 1 ] - 350;
  local pos_y = pos[ 2 ] - 410;

   --if port.isPortable() == 1 then
   --   if tostring(GetPlatform()) == "ios" and port.isTablet() == 0 then
   --     pos_y = pos_y - 75;
   --   else
   --     pos_y = pos_y - 50;
   --   end;
   -- end;
  
  ObjSet( "spr_park_1_professor_2_contract_pen_2", { pos_x = pos_x, pos_y = pos_y } );

  ObjAnimate( "spr_park_1_professor_2_contract_pen_2", "alp", 0, 0, private.ContraktPenDrag, { 0, 0, 1,   0.01, 0, 1 } );

end;

--------------------------------------------------------------------------------------------

function private.ContraktPenStopDrag ()
  
  private.contrakt_pen = false;
  
  ObjSet( "spr_park_1_professor_2_contract_pen_2", { pos_x = 41, pos_y = 109 } );
  
  ObjSet( "spr_park_1_professor_2_contract_pen_1", { alp = 1, input = true } );
  ObjSet( "obj_park_1_professor_2_contract_obj_up", { input = false } );
  ObjStopAnimate("spr_park_1_professor_2_contract_pen_2", "alp" );
  ObjSet( "spr_park_1_professor_2_contract_pen_2", { alp = 0 } );
  
end;

--------------------------------------------------------------------------------------------
function private.ContraktClkText ( text )

  if not private.contrakt_pen or ( text == 5 and private.contrakt ~= 7 )then

    return;

  end;

  cmn.Lock( true );

  local func_end = function ()

    cmn.Lock( false );

    private.contrakt = private.contrakt + 1;

    ObjDelete( "obj_park_1_professor_2_contract_text_"..text );

    if private.contrakt == 8 then

      private.contrakt_pen = false;

      SetCursor( CURSOR_DEFAULT );

      private.ClkDlgContrakt( "close" );

    end;

    private.ContraktPenStopDrag();
    
  end;

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_pen", 0, "", 0 );

  local prefix = "spr";

  if text == 4 then

    prefix = "txt"

  end;

  ObjAnimate( prefix.."_park_1_professor_2_contract_text_"..text, "alp", 0, 0, func_end, { 0, 0, 0,   0.3, 0, 1 } );

end;
--------------------------------------------------------------------------------------------
function private.ContraktEnterText ()

  if not private.contrakt_pen then

    common_impl.SetCursor( CURSOR_USE );

  end;

end;
--------------------------------------------------------------------------------------------
function private.ContraktLeaveText ()

  if not private.contrakt_pen then

    common_impl.SetCursor( CURSOR_DEFAULT );

  end;

end;
--------------------------------------------------------------------------------------------
function private.Attempt ()

  local func_end = function ()

    cmn.CallEventHandler( "dlg_park_1_professor_2" );   

    cmn.SetEventDone( "see_attempt" );
    cmn.CallEventHandler( "see_attempt" );

    common_impl.StopAudio( "voc", "level1/voc/aud_park_1_attempt_voc", 0.2 );
    common_impl.StopAudio( "sfx", "level1/sfx/aud_park_1_attempt", 0.2 );
    common_impl.ShowBbt( "bbt_park_1_see_attempt" );

    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "safe_place", function() common_impl.TutorialShow( "tutorial_page_7" ); end );

    common_impl.EnvPlay( { "level1/env/aud_rm_park_1_1_env" }, "", 0.5 );
    common_impl.PlayAudio( "env", "level1/env/aud_electri_env",  1, "", 1 );
    --cmn.PlayMusEnv( "mus_env/aud_track1_mus_env" );

    private.Shoot();

  end;

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_park_1_attempt", 0, "", 0 );
  common_impl.PlayAudio( "mus", "level1/mus/aud_park_1_attempt_mus", 0, "", 0 );
  common_impl.PlayAudio( "voc", "level1/voc/aud_park_1_attempt_voc", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_park_1_attempt", func_end );

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** ANIM *** () end;
--*********************************************************************************************************************

function private.Randomseed()
  
  math.randomseed( os.time() );
  for i = 1, os.time() % 100, 1 do
    math.random();
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.InitAnimations ()

  ObjAnimate( "spr_sofit_light", "alp", 1, 0, "", { 0, 0, 1,    2, 0, 0.5,   4, 0, 1  } );

end;
--------------------------------------------------------------------------------------------
function private.Shoot ()

  local tme = math.random( 5 );

  ObjSet( "tmr_park_1_shoot", { time = tme, playing = true, endtrig = private.AnimShoot } );

end;
--------------------------------------------------------------------------------------------
function private.AnimShoot ()

  private.Randomseed();
  local count = math.random( 2, 4 );

  while count == private.anim_shoot_count do 
    count = math.random( 2, 4 );
  end;

  private.anim_shoot_count = count;
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_park_2_clk_shot_"..count, 0, "", 0 );

  --ObjSet( "anm_park_1_shield", { active = false, alp = 0 } );
  ObjSet( "anm_park_1_shot", { alp = 1 } );

  local func_end = function ()

    --ObjSet( "anm_park_1_shield", { active = true, alp = 1 } );
    ObjSet( "anm_park_1_shot", { alp = 0 } );

    private.Shoot();

  end;

  AnimPlay( "anm_park_1_shot", "DoAnim", func_end );

end;
