-- name=rm_park_2
--*********************************************************************************************************************
function public.Init()

  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_park_2";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_floor", "room_hub" );
  private.Init_Subroom();
  private.InitAnimations();

  private.anim_shoot_count = 0;

  local tb = {}
  table.insert( tb, { "spr_floor_hook",                         { event_mdown = private.get_hook } } );
  table.insert( tb, { "obj_park_2_clk_shot_2",                  { event_mdown = private.clk_shot_2 } } );

  table.insert( tb, { "obj_floor_clk_floor",                    { event_mdown = private.clk_floor } } );

  table.insert( tb, { "obj_park_2_clk_box_1",                   { event_mdown = private.clk_box_1 } } );
  table.insert( tb, { "obj_park_2_clk_box_2",                   { event_mdown = private.clk_box_2 } } );
  table.insert( tb, { "obj_park_2_clk_box_3",                   { event_mdown = private.clk_box_3 } } );

  table.insert( tb, { "obj_park_2_clk_professor_4",             { event_mdown = private.dlg_professor_4_click } } );
  table.insert( tb, { "obj_park_2_clk_professor_4_focus",       { event_mdown = private.dlg_professor_4_click } } );

  table.insert( tb, { "grm_park_2_car",                         { event_mdown = private.ProfessorEscape } } );

  ObjMultiSet( tb );  
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_park_2 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then  
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then   
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "gzz_park_2_floor",
      "gzz_park_2_box"
    }
    for i = 1, #gates do
      local name = gates[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then  
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then   
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_floor",
      "zz_box"
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_park_2", update_game_mode_park_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_park_2 = function ()
    
    local effects_table = 
    {
      "obj_park_2_anim",
      "anm_park_2_shot",
      "anm_park_2_kevin_reynolds",
      "anm_park_2_shield",
      "anm_floor_wires_electrolights",
      "anm_box_ball_light",
      "anm_box_fly" 
    }

    local active = true;

    if ( GetPerformanceMode() == 1 ) then

      active = false;

    end;

    for i = 1, #effects_table do

      ObjSet( effects_table[ i ], { active = active } );

    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_park_2", update_performance_mode_park_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_park_2 () end;
  --------------------------------------------------------------------------------------------
  local opn_park_2 = function ()

  end;

  local opn_park_2_map = function ()

    common_impl.VisitMapRoom( "park_2" );

  end;

  cmn.AddSubscriber( "opn_park_2", opn_park_2_map, nil );
  cmn.AddSubscriber( "opn_park_2", opn_park_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_park_2_professor_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_park_2_professor_4" ] = {
    type = "click",
    use_place = "obj_park_2_clk_professor_4_focus",
    room = private.room_objname
  };
  local dlg_park_2_professor_4 = function ()

    ObjDelete( "obj_park_2_clk_professor_4" );
    ObjDelete( "obj_dlg_park_2_professor_4_lip" );
    ObjSet( "obj_park_2_clk_shot_2", { active = true, input = true, visible = true, alp = 1 } );

  end;
  cmn.AddSubscriber( "dlg_park_2_professor_4", dlg_park_2_professor_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gloves_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gloves_2" ] = {
      type = "use",
      inv_obj = "inv_gloves",
      use_place = "obj_floor_use_gloves_2",
      room = private.room_objname,
      zz = "zz_floor",
      zz_gate = "gzz_park_2_floor"
  };
  local use_gloves_2_inv = function ()

    if cmn.IsEventDone( "use_gloves_1" ) and cmn.IsEventDone( "use_gloves_3" ) then  

      interface.InventoryItemRemove( "inv_gloves" );

    end;
  
  end;
  local use_gloves_2_beg = function ()
  
    ObjDelete( "obj_floor_use_gloves_2" );
  
  end;
  local use_gloves_2_end = function ()

    ObjDelete( "spr_floor_wires_1" );
    ObjDelete( "spr_floor_wires_3" );
    ObjDelete( "spr_floor_wires_4" );
    ObjSet( "spr_floor_hook", { input = true } );
    ObjSet( "gfx_floor_hook", { active = true } );

    ObjDelete( "spr_park_2_floor_wire" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gloves_2", use_gloves_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_gloves_2", use_gloves_2_inv );
  cmn.AddSubscriber( "use_gloves_2", use_gloves_2_end, private.room_objname );
  cmn.AddSubscriber( "use_gloves_2_inv", use_gloves_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_gloves_2_beg", use_gloves_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_gloves_2_end", use_gloves_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sofit_hook_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sofit_hook_1" ] = {
      type = "use",
      inv_obj = "inv_sofit_hook",
      use_place = "obj_box_use_sofit_hook_1",
      room = private.room_objname,
      zz = "zz_box",
      zz_gate = "gzz_park_2_box"
  };
  local use_sofit_hook_1_beg = function ()
  
    ObjDelete( "obj_box_use_sofit_hook_1" );
  
  end;
  local use_sofit_hook_1_end = function ()
  
    ObjDelete( "anm_box_box_1" );

    ObjDelete( "spr_park_2_box_1" );
    ObjSet( "spr_park_2_box_over_1", { alp = 1 } );
    ObjDelete( "anm_park_2_balls" );

  end;
  local use_sofit_hook_1_anm = function ()
  
    ObjDelete( "anm_box_fly" );

  end;
  local use_sofit_hook_1_park1 = function ()
  
    ObjSet( "spr_park_1_box_1", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sofit_hook_1", use_sofit_hook_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_sofit_hook_1", use_sofit_hook_1_end, private.room_objname );
  cmn.AddSubscriber( "use_sofit_hook_1", use_sofit_hook_1_anm, private.room_objname );
  cmn.AddSubscriber( "use_sofit_hook_1", use_sofit_hook_1_park1, "rm_park_1" );
  cmn.AddSubscriber( "use_sofit_hook_1_beg", use_sofit_hook_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_sofit_hook_1_end", use_sofit_hook_1_end, private.room_objname );
  cmn.AddSubscriber( "use_sofit_hook_1_end", use_sofit_hook_1_park1, "rm_park_1" );
  --------------------------------------------------------------------------------------------
  -- function use_sofit_hook_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sofit_hook_2" ] = {
      type = "use",
      inv_obj = "inv_sofit_hook",
      use_place = "obj_box_use_sofit_hook_2",
      room = private.room_objname,
      zz = "zz_box",
      zz_gate = "gzz_park_2_box"
  };
  local use_sofit_hook_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_sofit_hook" );
  
  end;
  local use_sofit_hook_2_beg = function ()
  
    ObjDelete( "obj_box_use_sofit_hook_2" );

  end;
  local use_sofit_hook_2_end = function ()
  
    ObjDelete( "gzz_park_2_box" );
    ObjSet( "grm_park_2_car", { active = true, input = true, visible = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_park_2_car_focus");
    end;
    ObjDelete( "spr_park_2_box_2" );
    ObjDelete( "spr_park_2_patch_1" );
    ObjSet( "spr_park_2_box_over_2", { alp = 1 } );    

  end;
  local use_sofit_hook_1_park1 = function ()
  
    ObjSet( "spr_park_1_box_2", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sofit_hook_2", use_sofit_hook_2_inv );
  cmn.AddSubscriber( "use_sofit_hook_2", use_sofit_hook_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_sofit_hook_2", use_sofit_hook_2_end, private.room_objname );
  cmn.AddSubscriber( "use_sofit_hook_2", use_sofit_hook_1_park1, "rm_park_1" );
  cmn.AddSubscriber( "use_sofit_hook_2_inv", use_sofit_hook_2_inv );
  cmn.AddSubscriber( "use_sofit_hook_2_beg", use_sofit_hook_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_sofit_hook_2_end", use_sofit_hook_2_end, private.room_objname );
  cmn.AddSubscriber( "use_sofit_hook_2_end", use_sofit_hook_1_park1, "rm_park_1" );

  --------------------------------------------------------------------------------------------
  -- function see_park_2_professor_escape () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_park_2_professor_escape" ] = {
    type = "click",
    use_place = "grm_park_2_car",
    room = private.room_objname
  };
  local see_park_2_professor_escape = function ()

    ObjSet( "grm_park_2_car", { event_mdown = function() cmn.GotoRoom( "rm_car" ); end; } );

  end;

  local see_park_2_professor_escape_map = function ()

    common_impl.LockMapRoom( "park_2", true );
    common_impl.LockMapRoom( "park_1", true );

  end;

  cmn.AddSubscriber( "see_park_2_professor_escape", see_park_2_professor_escape_map );
  cmn.AddSubscriber( "see_park_2_professor_escape", see_park_2_professor_escape, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_hook () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hook" ] =
  {
    type = "get",
    get_obj = "spr_floor_hook",
    room = private.room_objname,
    zz = "zz_floor",
    zz_gate = "gzz_park_2_floor"
  };
  -----------------------------------------------
  local get_hook_inv = function ()

    cmn.SetInvPlusRGB( "sofit", true );
    interface.InventoryItemAdd( "inv_hook", "spr_floor_hook" );

  end;

  local get_hook_closezz = function ()

    ObjDelete( "gfx_floor_hook" );
    ObjDelete( "gzz_park_2_floor" );

    ObjDelete( "spr_park_2_floor_hook" );

  end;

  cmn.AddSubscriber( "get_hook", get_hook_inv );
  cmn.AddSubscriber( "get_hook", get_hook_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_shot_2 () end;
  --------------------------------------------------------------------------------------------

  local clk_shot_2_beg = function ()

    ObjDelete( "obj_park_2_clk_shot_2" );
  
  end;
  local clk_shot_2_end = function ()

    ObjSet( "gzz_park_2_floor", { active = true, input = true, visible = true, alp = 1 } )  
    --ObjDelete( "anm_park_2_shot" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_shot_2", clk_shot_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_shot_2", clk_shot_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_shot_2_beg", clk_shot_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_shot_2_end", clk_shot_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_floor () end;
  --------------------------------------------------------------------------------------------

  common_impl.hint[ "clk_floor" ] = {
    type = "click",
    use_place = "obj_floor_clk_floor",
    room = private.room_objname,
    zz = "zz_floor",
    zz_gate = "gzz_park_2_floor"
  };

  local clk_floor_beg = function ()

    ObjDelete( "obj_floor_clk_floor" );
  
  end;
  local clk_floor_end = function ()

    ObjSet( "spr_floor_cover_1", { pos_x = -292, pos_y = -212 } );
    ObjSet( "obj_floor_use_gloves_2", { input = true } );

    ObjDelete( "spr_park_2_floor_cover_1" );
    ObjSet( "spr_park_2_floor_cover_2", { alp = 1 } );

  end;
  local clk_floor_park_2 = function ()

    ObjDelete( "spr_park_1_floor_1" );
    ObjSet( "spr_park_1_floor_2", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_floor", clk_floor_beg, private.room_objname );
  cmn.AddSubscriber( "clk_floor", clk_floor_end, private.room_objname );
  cmn.AddSubscriber( "clk_floor", clk_floor_park_2, "rm_park_1" );
  cmn.AddSubscriber( "clk_floor_beg", clk_floor_beg, private.room_objname );
  cmn.AddSubscriber( "clk_floor_end", clk_floor_end, private.room_objname );
  cmn.AddSubscriber( "clk_floor_end", clk_floor_park_2, "rm_park_1" );
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Load()
  
end;
--********************************************************************************************************************
function private.Init_Subroom()

  --*********************************************************************************************************************
  -- function zz_floor  () end
    subroom.Define( "zz_floor" );    
    function zz_floor.PreOpen()

      ObjSet( "anm_park_2_shot", { playing = false } );
      ObjSet( "tmr_park_2_shoot", { playing = false } );
      ObjStopAnimate( "obj_park_2_anim", 8 );

      if ( cmn.IsEventDone( "clk_floor" ) and not cmn.IsEventDone( "use_gloves_2" ) ) then

        common_impl.PlayAudio( "env", "level1/env/aud_zz_floor_env",  1, "", 1 ); 

      end

    end;
    -------------------------------------------------
    function zz_floor.Open()

    end;
    -------------------------------------------------
    function zz_floor.PreClose()

      common_impl.StopAudio( "env", "level1/env/aud_zz_floor_env", 0.5 );
      ObjSet( "anm_park_2_shot", { playing = true } );
      private.Shoot();

    end;
    -------------------------------------------------
    function zz_floor.Close()

    end;
    -------------------------------------------------
  --*********************************************************************************************************************
  -- function zz_box () end

    subroom.Define( "zz_box" );    
    function zz_box.PreOpen()

      ObjSet( "anm_park_2_shot", { playing = false } );
      ObjSet( "tmr_park_2_shoot", { playing = false } );
      ObjStopAnimate( "obj_park_2_anim", 8 );

    end;
    -------------------------------------------------
    function zz_box.Open()

    end;
    -------------------------------------------------
    function zz_box.PreClose()

      ObjSet( "anm_park_2_shot", { playing = true } );
      private.Shoot();

    end;
    -------------------------------------------------
    function zz_box.Close()

    end;
    -------------------------------------------------
end;
--*********************************************************************************************************************
function public.Open()

  if not ( cmn.IsEventDone( "opn_park_2" ) ) then

    cmn.SetEventDone( "opn_park_2" );   

    common_impl.ShowBbt( "bbt_park_2_opn_park_2" );
    
  end;
  cmn.CallEventHandler( "opn_park_2" ); 

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen()

  --common_impl.EnvPlay( { "level1/env/aud_park_2_env" }, "", 0.5 );

  ObjSet( "anm_park_2_shot", { playing = true } );
  private.Shoot();

end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  ObjSet( "anm_park_2_shot", { playing = false } );
  ObjSet( "tmr_park_2_shoot", { playing = false } );
  ObjStopAnimate( "obj_park_2_anim", 8 );

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
function public.use_gloves_2 ()

  local item = "inv_gloves";

  if cmn.ApplyObj( item, "gzz_park_2_floor" ) and cmn.IsEventDone( "clk_floor" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_floor", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_floor_use_gloves_2" ) and cmn.IsEventDone( "clk_floor" ) ) then

    cmn.CallEventHandler( "use_gloves_2_inv" );
    cmn.CallEventHandler( "use_gloves_2_beg" );

    local func_end = function ()

      cmn.Lock(false );
      cmn.SetEventDone( "use_gloves_2" );
      cmn.CallEventHandler( "use_gloves_2_end" );
      common_impl.StopAudio( "env", "level1/env/aud_zz_floor_env", 0.5 );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_park_2_use_gloves_2", 0, "", 0 );

    ObjAnimate( "spr_floor_wires_3", "alp", 0, 0, "",
    { 
      0.0, 0, 1, 
      0.3, 0, 0
    } );

    ObjAnimate( "spr_floor_wires_1", "alp", 0, 0, "",
    { 
      0.0, 0, 1, 
      0.3, 0, 1,
      0.6, 0, 0,
    } );

    ObjAnimate( "spr_floor_wires_4", "alp", 0, 0, func_end,
    { 
      0.0, 0, 1, 
      0.6, 0, 1,
      0.9, 0, 0,
    } );


    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_sofit_hook_1 ()

  local item = "inv_sofit_hook";

  if cmn.ApplyObj( item, "gzz_park_2_box" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_box", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_box_use_sofit_hook_1" ) ) then

    cmn.CallEventHandler( "use_sofit_hook_1_beg" );

    local func_end = function ()

      ObjSet( item, { alp = 1 } );

      cmn.Lock( false );
      cmn.SetEventDone( "use_sofit_hook_1" );
      cmn.CallEventHandler( "use_sofit_hook_1_end" );
    
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_sofit_hook", 0, "", 0 );

   --interface.ObjDoNotDrop( item );
    ObjSet( item, { alp = 0 } );

    AnimPlay( "anm_box_box_1", "DoAnim", func_end );
    AnimPlay( "anm_box_fly", "DoAnim", "" );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_sofit_hook_2 ()

  local item = "inv_sofit_hook";

  if cmn.ApplyObj( item, "gzz_park_2_box" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_box", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_box_use_sofit_hook_2" ) and cmn.IsEventDone( "use_sofit_hook_1" ) ) then

    cmn.CallEventHandler( "use_sofit_hook_2_inv" );
    cmn.CallEventHandler( "use_sofit_hook_2_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_sofit_hook_2" );
      cmn.CallEventHandler( "use_sofit_hook_2_end" );

      common.CloseSubRoom();
    
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_sofit_hook1", 0, "", 0 );

    AnimPlay( "anm_box_box_2", "DoAnim", func_end );

    return true;

  end;

  ObjSet( item, { alp = 1 } );
  return false;

end;
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
function private.get_hook ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  common.CloseSubRoom();

  cmn.SetEventDone( "get_hook" );
  cmn.CallEventHandler( "get_hook" );

end;
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_shot_2 ()

  cmn.CallEventHandler( "clk_shot_2_beg" );

  local func_end = function ()

    --cmn.Lock( false );
    cmn.SetEventDone( "clk_shot_2" );
    cmn.CallEventHandler( "clk_shot_2_end" );

    cmn.GotoSubRoom( "zz_floor", nil, { 512, 360 } );

  end;

  common_impl.ShowBbt( "bbt_park_2_clk_shot_2" );

  --cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_park_2_clk_shot_2", 0, "", 0 );
  AnimPlay( "anm_park_2_shot", "DoAnim", "" );
  func_end();

end;
--------------------------------------------------------------------------------------------
function private.clk_floor ()

  cmn.CallEventHandler( "clk_floor_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_floor" );
    cmn.CallEventHandler( "clk_floor_end" );
    common_impl.PlayAudio( "env", "level1/env/aud_zz_floor_env",  1, "", 1 ); 

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_hatch", 0, "", 0 );
  ObjAnimate( "spr_floor_cover_1", "pos_xy", 0, 0, func_end,
  { 
    0.0, 0, -21, 5, 
    0.8, 3, -292, -212
  } );

end;

--*********************************************************************************************************************
function private.ProfessorEscape ()

  local func_end_2 = function ()

    ObjSet( "rm_park_2", { alp = 1 } );

  end;

  local func_end = function ()

    cmn.SetEventDone( "see_park_2_professor_escape" );
    cmn.CallEventHandler( "see_park_2_professor_escape" );

    ObjSet( "rm_park_2", { alp = 0 } );
    cmn.GotoRoom( "rm_car" );
    ObjAnimate( "rm_park_2", "scale_x",0,0, func_end_2, { 0, 0, 1,    1, 0, 1 } );

    common_impl.StopAudio( "sfx", "level1/sfx/aud_run_to_car", 0.2 );

  end;

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_run_to_car", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_park_2_professor_escape", func_end );

end;

--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )

  if ( dlg_name == "professor_4" ) then

    if ( count_txt == 1 ) then

      ObjSet( "vid_dlg_park_2_professor_4_lip_1", { alp = 1 } );
      VidPlay( "vid_dlg_park_2_professor_4_lip_1", "" );

      ObjAnimate( "rm_park_2", "scale_xy", 0, 0, "", 
      {
        0.0, 0, 1.0, 1.0,
        4.0, 0, 1.0, 1.0,
        4.4, 3, 1.2, 1.2,
        5.6, 0, 1.2, 1.2,
        6.0, 3, 1.0, 1.0
      } );

      ObjAnimate( "rm_park_2", "pos_xy", 0, 0, "", 
      {
        0.0, 0, 0, 0,
        4.0, 3, 0, 0,
        4.4, 3, -231, -141,
        5.6, 0, -231, -141,
        6.0, 3, 0, 0,
      } );

    end;

  end;

end;
--------------------------------------------------------------------------------------------
function private.dlg_professor_4_click ()

  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "professor_4", 2, nil, nil, true, private.dlg_professor_4_end );

end;
--------------------------------------------------------------------------------------------
function private.dlg_professor_4_end ()

  local tme = 0.4;
  local scale = ObjGet( "rm_park_2" ).scale_x;
  local pos_x = ObjGet( "rm_park_2" ).pos_x;
  local pos_y = ObjGet( "rm_park_2" ).pos_y;

  ObjAnimate( "rm_park_2", "scale_xy", 0, 0, "", 
  {
    0.0, 0, scale, scale,
    tme * ( ( scale - 1.0 ) / 0.2 ), 3, 1.0, 1.0
  } );

  ObjAnimate( "rm_park_2", "pos_xy", 0, 0, "", 
  {
    0.0, 0, pos_x, pos_y,
    tme * ( ( scale - 1.0 ) / 0.2 ), 3, 0, 0
  } );

  cmn.CallEventHandler( "dlg_park_2_professor_4" );   
  common_impl.ShowBbt( "bbt_park_2_dlg_professor_4_click" );

end;

--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** ANIM *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.InitAnimations ()

  ObjAnimate( "spr_floor_light", "alp", 1, 0, "", { 0, 0, 1,    2, 0, 0.5,   4, 0, 1  } );

end;


--*********************************************************************************************************************

function private.Randomseed()
  
  math.randomseed( os.time() );
  for i = 1, os.time() % 100, 1 do
    math.random();
  end;
  
end;

--------------------------------------------------------------------------------------------

function private.Shoot ()

  local tme = 0.01;

  local func_end = function ()

    private.Randomseed();
    local count = math.random( 2, 4 );

    while count == private.anim_shoot_count do 
      count = math.random( 2, 4 );
    end;

    private.anim_shoot_count = count;
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_park_2_clk_shot_"..count, 0, "", 0 );

    ObjAnimate( "obj_park_2_anim", "scale_x",1,0, function() private.Shoot(); end, { 0, 0, 1,    18.0167, 0, 1 } );

  end;

  ObjSet( "tmr_park_2_shoot", { time = tme, playing = true, endtrig = func_end } );

end;

--*********************************************************************************************************************



