-- name=rm_porch
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_porch";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  ObjAttach( "zz_car_trunk", "room_hub" );

  local tb = {}
  table.insert( tb, { "obj_porch_dlg_professor_bodyguard",          { event_mdown = private.dlg_professor_bodyguard_click } } );
  table.insert( tb, { "obj_porch_dlg_professor_bodyguard_focus",    { event_mdown = private.dlg_professor_bodyguard_click } } );
  table.insert( tb, { "spr_porch_reynolds_case",                    { event_mdown = private.get_reynolds_case } } );
  table.insert( tb, { "obj_porch_clk_signboard",                    { event_mdown = private.ClickSignboard } } );
  table.insert( tb, { "obj_porch_clk_trash_1",                      { event_mdown = private.clk_porch_trash_1 } } );
  table.insert( tb, { "obj_porch_clk_trash_2",                      { event_mdown = private.clk_porch_trash_2 } } );

  ObjMultiSet( tb );

  private.InitAnimations();
  private.InitTrunkCode();
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_porch = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then  
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then   
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "gzz_porch_car_trunk"
    }
    for i = 1, #gates do
      local name = gates[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then  
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then   
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_car_trunk"
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_porch", update_game_mode_porch, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_porch = function ()
    
    local effects_table = 
    {
      "anm_porch_sky",
      "obj_porch_anim", 
      "anm_porch_tobias",
      "anm_porch_kevin",
      "anm_porch_pipe",
      "anm_car_trunk_rotation_numbers",
    }

    local active = true;

    if ( GetPerformanceMode() == 1 ) then

      active = false;

    end;

    for i = 1, #effects_table do

      ObjSet( effects_table[ i ], { active = active } );

    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_porch", update_performance_mode_porch, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_porch () end;
  --------------------------------------------------------------------------------------------
  local opn_porch = function ()

  end;

  local opn_porch_map = function ()

    common_impl.VisitMapRoom( "porch" );

  end;
  cmn.AddSubscriber( "opn_porch", opn_porch_map );
  cmn.AddSubscriber( "opn_porch", opn_porch, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_reynolds_case () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_reynolds_case" ] = {
    type = "get",
    get_obj = "spr_porch_reynolds_case",
    room = "rm_porch",
  };

  local get_reynolds_case_inv = function ()

    interface.InventoryItemAdd( "inv_reynolds_case", "spr_porch_reynolds_case" );

  end;
  
  local get_reynolds_case_loc = function ()

    ObjDelete( "spr_porch_kevin_hand_1" );
    ObjSet( "spr_porch_kevin_hand_2", { alp = 1 } );
    ObjDelete( "gfx_porch_reynolds_case" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_reynolds_case", get_reynolds_case_inv );
  cmn.AddSubscriber( "get_reynolds_case", get_reynolds_case_loc, room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_trunk_code () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_trunk_code" ] = {
    type = "use",
    inv_obj = "inv_trunk_code",
    use_place = "obj_car_trunk_use_trunk_code",
    room = private.room_objname,
    zz = "zz_car_trunk",
    zz_gate = "gzz_porch_car_trunk"
  };
  local use_trunk_code_inv = function ()

    interface.InventoryItemRemove( "inv_trunk_code" );

  end;
  local use_trunk_code_beg = function ()
  
    ObjDelete( "obj_car_trunk_use_trunk_code" );
  
  end;
  local use_trunk_code_end = function ()

    ObjSet( "spr_car_trunk_bootcode", { input = true, alp = 1 } );
    ObjSet( "obj_car_trunk_mmg", { input = true, alp = 1 } );

    ObjSet( "spr_porch_car_trunk_bootcode", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_trunk_code", use_trunk_code_inv );
  cmn.AddSubscriber( "use_trunk_code", use_trunk_code_beg, private.room_objname );
  cmn.AddSubscriber( "use_trunk_code", use_trunk_code_end, private.room_objname );
  cmn.AddSubscriber( "use_trunk_code_inv", use_trunk_code_inv, private.room_objname );
  cmn.AddSubscriber( "use_trunk_code_beg", use_trunk_code_beg, private.room_objname );
  cmn.AddSubscriber( "use_trunk_code_end", use_trunk_code_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_reynolds_case () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_reynolds_case" ] = {
    type = "use",
    inv_obj = "inv_reynolds_case",
    use_place = "obj_porch_use_reynolds_case",
    room = private.room_objname
  };
  local use_reynolds_case_inv = function ()

    interface.InventoryItemRemove( "inv_reynolds_case" );

  end;
  local use_reynolds_case_beg = function ()
  
    ObjDelete( "obj_porch_use_reynolds_case" );
  
  end;
  local use_reynolds_case_end = function ()

    ObjDelete( "spr_porch_kevin_hand_2" );
    ObjSet( "spr_porch_kevin_hand_3", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_reynolds_case", use_reynolds_case_inv );
  cmn.AddSubscriber( "use_reynolds_case", use_reynolds_case_beg, private.room_objname );
  cmn.AddSubscriber( "use_reynolds_case", use_reynolds_case_end, private.room_objname );
  cmn.AddSubscriber( "use_reynolds_case_inv", use_reynolds_case_inv, private.room_objname );
  cmn.AddSubscriber( "use_reynolds_case_beg", use_reynolds_case_beg, private.room_objname );
  cmn.AddSubscriber( "use_reynolds_case_end", use_reynolds_case_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_porch_trash_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_porch_trash_1" ] = {
    type = "click",
    use_place = "obj_porch_clk_trash_1",
    room = private.room_objname,
  };
  local clk_porch_trash_1_beg = function ()

    ObjDelete( "obj_porch_clk_trash_1" );
  
  end;
  local clk_porch_trash_1_end = function ()

    ObjSet( "obj_porch_clk_trash_2", { input = true } );
    ObjDelete( "spr_porch_trash_1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_porch_trash_1", clk_porch_trash_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_porch_trash_1", clk_porch_trash_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_porch_trash_1_beg", clk_porch_trash_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_porch_trash_1_end", clk_porch_trash_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_porch_trash_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_porch_trash_2" ] = {
    type = "click",
    use_place = "obj_porch_clk_trash_2",
    room = private.room_objname,
  };
  local clk_porch_trash_2_beg = function ()

    ObjDelete( "obj_porch_clk_trash_2" );
  
  end;
  local clk_porch_trash_2_end = function ()

    ObjSet( "spr_porch_reynolds_case", { input = true } );
    ObjSet( "gfx_porch_reynolds_case", { active = true } );
    ObjDelete( "spr_porch_trash_2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_porch_trash_2", clk_porch_trash_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_porch_trash_2", clk_porch_trash_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_porch_trash_2_beg", clk_porch_trash_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_porch_trash_2_end", clk_porch_trash_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_trunk_code () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_trunk_code" ] =
  {
      type = "win",
      room = private.room_objname,
      zz = "zz_car_trunk",
      zz_gate = "gzz_porch_car_trunk"
  };
  local win_trunk_code = function ()

    if ( cmn.IsEventDone( "win_trunk_code" ) ) then
    
      ObjDelete( "gzz_porch_car_trunk" );
      --ObjDelete( "spr_porch_car_trunk_patch_1" );
      ObjSet( "obj_porch_clk_trash_1", { input = true } );
      ObjDelete( "gmg_porch_trunk" );
      ObjSet( "spr_porch_car_trunk_open", { alp = 1 } );
      ObjSet( "spr_porch_folder_1", { alp = 1, input = true } );
      ObjSet( "spr_porch_folder_2", { alp = 1, input = true } );

    end;

  end;

  cmn.AddSubscriber( "win_trunk_code", win_trunk_code, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function dlg_porch_professor_bodyguard () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_porch_professor_bodyguard" ] = {
    type = "click",
    use_place = "obj_porch_dlg_professor_bodyguard_focus",
    room = private.room_objname
  };

  local dlg_porch_professor_bodyguard = function ()

    ObjDelete( "obj_porch_dlg_professor_bodyguard" );

  end;

  local dlg_porch_professor_bodyguard_driver = function ()

    ObjSet( "obj_car_dlg_driver", { input = true } );

  end;

  cmn.AddSubscriber( "dlg_porch_professor_bodyguard", dlg_porch_professor_bodyguard, private.room_objname );
  cmn.AddSubscriber( "dlg_porch_professor_bodyguard", dlg_porch_professor_bodyguard_driver, "rm_car" );
  --------------------------------------------------------------------------------------------
  -- function see_leave_bodyguard () end;
  --------------------------------------------------------------------------------------------
  local see_leave_bodyguard = function ()

    ObjDelete( "spr_porch_door_close" );
    ObjDelete( "spr_porch_tobias" );
    ObjDelete( "vid_porch_professor_bodyguard_idle2" );
    ObjDelete( "anm_porch_logo_on" );

  end;

  cmn.AddSubscriber( "see_leave_bodyguard", see_leave_bodyguard, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_screaming_bodyguard () end;
  --------------------------------------------------------------------------------------------
  local see_screaming_bodyguard = function ()

    ObjDelete( "spr_porch_kevin" );
    ObjDelete( "vid_porch_professor_bodyguard_idle" );
    ObjDelete( "obj_porch_lip_professor" );
    ObjSet( "grm_porch_hall", { active = true, input = true, visible = true } ); 
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_porch_hall_focus");
    end;
    ObjDelete( "anm_porch_light" );

  end;

  cmn.AddSubscriber( "see_screaming_bodyguard", see_screaming_bodyguard, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load()

  --function mmg_trunk_code () end; --------------------------------------------------------------------------
    if ( cmn.IsEventStart( "win_trunk_code" ) ) then

      for i = 1, #ng_global.progress[ "std" ][ "win_trunk_code" ].state do

        local index = ng_global.progress[ "std" ][ "win_trunk_code" ].state[ i ];
        local name_obj = "spr_car_trunk_number_"..private.win_trunk_code_sprite[ i ];
        ObjSet( name_obj, { ang = private.win_trunk_code_angle[ index ] } );        

      end;

    end;  
  ---------------------------------------------------------------------------------------------------------------------

end;
--********************************************************************************************************************
function private.Init_Subroom()

  --*********************************************************************************************************************
  -- function zz_car_trunk () end;
  --*********************************************************************************************************************

    subroom.Define( "zz_car_trunk" );
    
    function zz_car_trunk.PreOpen()

    end;
    -------------------------------------------------
    function zz_car_trunk.Open()

      if ( cmn.IsEventStart( "win_trunk_code" ) and not cmn.IsEventDone( "win_trunk_code" ) ) then

        cmn.MiniGameShow( "trunk_code" );
        common_impl.PassingMgStart( "trunk_code" );

      end;

    end;
    -------------------------------------------------
    function zz_car_trunk.PreClose()

      if ( cmn.IsEventStart( "win_trunk_code" ) and not cmn.IsEventDone( "win_trunk_code" ) ) then

        cmn.MiniGameHide( "trunk_code" );
        common_impl.PassingMgStop( "trunk_code" );

      end;

    end;
    -------------------------------------------------
    function zz_car_trunk.Close()

      if cmn.IsEventDone( "use_trunk_code" ) then

        cmn.NoteScaleClose( { "spr_car_trunk_bootcode" } );

      end;

    end;
    -------------------------------------------------
    function zz_car_trunk.Reset ()

      cmn.Lock( true );
      for i = 1, #ng_global.progress[ "std" ][ "win_trunk_code" ].state do

        local name_obj = "spr_car_trunk_number_"..private.win_trunk_code_sprite[ i ];
        
        ObjAnimate( name_obj, "ang", 0, 0, "",
          { 
            0.0, 0, ObjGet( name_obj ).ang, 
            0.3, 0, private.win_trunk_code_angle[ 1 ]
          } );       

      end;

      local func_end = function () 

        zz_car_trunk.ResetEnd(); 

      end;

      ObjAnimate( "obj_car_trunk_mmg", "alp", 0, 0, func_end,
        { 
          0.0, 0, 1, 
          0.3, 0, 1
        } );  

    end;
    -------------------------------------------------  
    function zz_car_trunk.ResetEnd ()

      cmn.Lock( false );
      ng_global.progress[ "std" ][ "win_trunk_code" ].state = { 1, 1, 1, 1 };

    end;
    -------------------------------------------------
    function zz_car_trunk.Skip ()

      cmn.Lock( true );
      for i = 1, #ng_global.progress[ "std" ][ "win_trunk_code" ].state do

        local name_obj = "spr_car_trunk_number_"..private.win_trunk_code_sprite[ i ];
        
        ObjAnimate( name_obj, "ang", 0, 0, "",
          { 
            0.0, 0, ObjGet( name_obj ).ang, 
            0.3, 0, private.win_trunk_code_angle[ private.win_trunk_code_win[ i ] ]
          } );       

      end;

      local func_end = function () 

        private.WinAnimTrunkCode();

      end;

      ObjAnimate( "obj_car_trunk_mmg", "alp", 0, 0, func_end,
        { 
          0.0, 0, 1, 
          0.3, 0, 1
        } );  

    end;
    -------------------------------------------------

end;
--*********************************************************************************************************************
function public.Open()

  if not ( cmn.IsEventDone( "opn_porch" ) ) then

    cmn.SetEventDone( "opn_porch" );

    common_impl.ShowBbt( "bbt_porch_opn_porch" );

    interface.KeyTaskAdd( "follow_him");
    
  end;

  cmn.CallEventHandler( "opn_porch" ); 

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.EnvPlay( { "level1/env/aud_porch_env" }, "", 0.5 );
  --cmn.PlayMusEnv();

end;
--*********************************************************************************************************************
function public.Close()

  if cmn.IsEventDone( "win_trunk_code" ) then

    cmn.NoteScaleClose( { "spr_porch_folder_1", "spr_porch_folder_2" } );

  end;

end;
--*********************************************************************************************************************
function public.PreClose()


end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
function public.use_trunk_code ()

  local item = "inv_trunk_code";

  if cmn.ApplyObj( item, "gzz_porch_car_trunk" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_car_trunk", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_car_trunk_use_trunk_code" ) ) then

    cmn.CallEventHandler( "use_trunk_code_inv" );
    cmn.CallEventHandler( "use_trunk_code_beg" );

    local func_end = function ()

      common_impl.Lock(false );

      cmn.SetEventDone( "use_trunk_code" );
      cmn.CallEventHandler( "use_trunk_code_end" );

      private.InitTrunkCodeStart();
--      common.CloseSubRoom();
--
--      cmn.GotoRoom( "mg_trunk" );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_porch_use_trunk_code", 0, "", 0 );
    
    ObjAnimate( "spr_car_trunk_bootcode", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0, 
        0.3, 0, 1
      } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_reynolds_case ()

  local item = "inv_reynolds_case";

  if ( cmn.ApplyObj( item, "obj_porch_use_reynolds_case" ) ) then

    cmn.CallEventHandler( "use_reynolds_case_inv" );
    cmn.CallEventHandler( "use_reynolds_case_beg" );

    local func_end = function ()

      common_impl.Lock(false );

      cmn.CallEventHandler( "use_reynolds_case_end" );

      private.ScreamingBodyguard();

    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_porch_use_reynolds_case", 0, "", 0 );

    ObjAnimate( "spr_porch_kevin_hand_2", "alp", 0, 0, func_end,
      { 
        0.0, 0, 1, 
        0.3, 0, 0
      } );

    ObjAnimate( "spr_porch_kevin_hand_3", "alp", 0, 0, "",
      { 
        0.0, 0, 0, 
        0.3, 0, 1
      } );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_reynolds_case ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  ObjSet( "spr_porch_reynolds_case", { res = "assets/levels/level1/rm_porch/layers/kevin_case" } );
  cmn.SetEventDone( "get_reynolds_case" );
  cmn.CallEventHandler( "get_reynolds_case" );

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************

--------------------------------------------------------------------------------------------
function private.clk_porch_trash_1 ()

  cmn.CallEventHandler( "clk_porch_trash_1_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_porch_trash_1" );
    cmn.CallEventHandler( "clk_porch_trash_1_end" );

  end;

  cmn.Lock( true );

  local rnd = math.random(3);
  common_impl.PlayAudio( "sfx", "aud_remove_clk"..rnd, 0, "", 0 );

  --ObjAnimate( "spr_porch_trash_1", "pos_xy", 0, 0, "",
  --{ 
  --  0.0, 0, ObjGet( "spr_porch_trash_1" ).pos_x, ObjGet( "spr_porch_trash_1" ).pos_y,
  --  0.3, 0, 39, 53
  --} );
  ObjAnimate( "spr_porch_trash_1", "alp", 0, 0, func_end,
  { 
    0.0, 0, ObjGet( "spr_porch_trash_1" ).alp,
    0.3, 0, 0
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_porch_trash_2 ()

  cmn.CallEventHandler( "clk_porch_trash_2_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_porch_trash_2" );
    cmn.CallEventHandler( "clk_porch_trash_2_end" );

  end;

  cmn.Lock( true );

  local rnd = math.random(3);
  common_impl.PlayAudio( "sfx", "aud_remove_clk"..rnd, 0, "", 0 );

  --ObjAnimate( "spr_porch_trash_2", "pos_xy", 0, 0, "",
  --{ 
  --  0.0, 0, ObjGet( "spr_porch_trash_2" ).pos_x, ObjGet( "spr_porch_trash_2" ).pos_y,
  --  0.3, 0, -108, -7
  --} );
  ObjAnimate( "spr_porch_trash_2", "alp", 0, 0, func_end,
  { 
    0.0, 0, ObjGet( "spr_porch_trash_2" ).alp,
    0.3, 0, 0
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG CODE TRUNK *** () end;
--*********************************************************************************************************************
  function private.InitTrunkCodeStart ()

    ng_global.progress[ "std" ][ "win_trunk_code" ].state = { 1, 1, 1, 1 };
    cmn.MiniGameShow( "trunk_code" );
    common_impl.PassingMgStart( "trunk_code" );

  end;
  --------------------------------------------------------------------------------------------
  function private.InitTrunkCode ()

    private.win_trunk_code_sprite = { 5, 2, 7, 1 };  
    private.win_trunk_code_angle = 
    {  -0.26 
      ,-0.89 
      ,-1.6 
      ,-2.43
      ,-3.25
      ,-4.09
      ,-4.89
      ,-5.76
      ,-6.55
    };    
    private.win_trunk_code_win = { 6, 5, 8, 4 };

    ObjMultiSet( {  
      { "spr_car_trunk_number_5", { event_mdown  = function () private.ClkNumber( 1 ); end,
                                    event_menter = function () common_impl.SetCursor( CURSOR_HAND );  end,
                                    event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end } 
      };
      { "spr_car_trunk_number_2", { event_mdown  = function () private.ClkNumber( 2 ); end,
                                    event_menter = function () common_impl.SetCursor( CURSOR_HAND );  end,
                                    event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end } 
      };
      { "spr_car_trunk_number_7", { event_mdown  = function () private.ClkNumber( 3 ); end,
                                    event_menter = function () common_impl.SetCursor( CURSOR_HAND );  end,
                                    event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end } 
      };
      { "spr_car_trunk_number_1", { event_mdown  = function () private.ClkNumber( 4 ); end,
                                    event_menter = function () common_impl.SetCursor( CURSOR_HAND );  end,
                                    event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end } 
      };
    } ); 

  end;
  --------------------------------------------------------------------------------------------
  function private.ClkNumber ( id )

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_button_number", 0, "", 0 );

    local sprite = "spr_car_trunk_number_"..private.win_trunk_code_sprite[ id ];
    local curr_ang = ng_global.progress[ "std" ][ "win_trunk_code" ].state[ id ];       
    local next_ang = curr_ang + 1;  
 
    local func_end = function () 

      private.ClkNumbEnd( id ); 
   
    end;
   
    cmn.Lock( true );
    ObjAnimate( sprite, "ang", 0, 0, func_end,
      { 
        0.0, 0, private.win_trunk_code_angle[ curr_ang ], 
        0.3, 0, private.win_trunk_code_angle[ next_ang ]
      } );

  end;
  --------------------------------------------------------------------------------------------
  function private.ClkNumbEnd ( id )

    local state = {};
    for i = 1, #ng_global.progress[ "std" ][ "win_trunk_code" ].state do

      state[ i ] = ng_global.progress[ "std" ][ "win_trunk_code" ].state[ i ];

    end;

    local curr_ang = state[ id ];       
    local next_ang = curr_ang + 1; 
     
    if ( next_ang >=9 ) then

      next_ang = 1;    
      ObjSet( "spr_car_trunk_number_"..private.win_trunk_code_sprite[ id ], { ang = private.win_trunk_code_angle[ next_ang ] } );      

    end;

    state[ id ] = next_ang;

    local bool = true;
    for i = 1, #state do

      if ( state[ i ] ~= private.win_trunk_code_win[ i ] ) then

        bool = false;
        break;

      end;

    end;

    if ( bool ) then

      private.WinAnimTrunkCode();      

    else

      cmn.Lock( false );
      for i = 1, #ng_global.progress[ "std" ][ "win_trunk_code" ].state do

        ng_global.progress[ "std" ][ "win_trunk_code" ].state[ i ] = state[ i ];

      end;

    end;

  end;
  --------------------------------------------------------------------------------------------
  function private.WinAnimTrunkCode ()

    cmn.Lock( true );

    local func_end = function () 

      private.WinTrunkCode( id ); 
   
    end;

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_car_number1", 0, "", 0 );
    ObjAnimate( "spr_car_trunk_light_3", "alp", 0, 0, func_end,
      { 
        0.0, 0, ObjGet( "spr_car_trunk_light_3" ).alp, 
        0.3, 0, 1
      } ); 
    --AnimPlay( "anm_car_trunk_rotation_numbers", "DoAnim", func_end );  
    cmn.MiniGameHide( "trunk_code" );  

  end;
  --------------------------------------------------------------------------------------------
  function private.WinTrunkCode ()

    cmn.Lock( false );    
    for i = 1, #ng_global.progress[ "std" ][ "win_trunk_code" ].state do

      ng_global.progress[ "std" ][ "win_trunk_code" ].state[ i ] = private.win_trunk_code_win[ i ];

    end;    
    cmn.SetEventDone( "win_trunk_code" );
    cmn.CallEventHandler( "win_trunk_code" );

    cmn.MiniGameHide( "trunk_code" );  
    common.CloseSubRoom();
    common_impl.PassingMgWin( "trunk_code" );      

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )

  if ( dlg_name == "professor_bodyguard" ) then

    if ( count_txt == 1 ) then

      ObjSet( "spr_int_dialog_character_icon", { res = "assets/interface/resources/dialog_character/btm_3" } );
      ObjAnimate( "rm_porch", "scale_xy", 0, 0, "",
      { 
        0.0, 0, ObjGet( "rm_porch" ).scale_x, ObjGet( "rm_porch" ).scale_y,
        0.3, 0, 1.2, 1.2
      } ); 
      ObjAnimate( "rm_porch", "pos_xy", 0, 0, "",
      { 
        0.0, 0, ObjGet( "rm_porch" ).pos_x, ObjGet( "rm_porch" ).pos_y,
        0.3, 0, -202, -134,
      } ); 

      ObjSet( "vid_porch_professor_bodyguard_idle2", { alp = 0 } );
      ObjSet( "vid_porch_professor_bodyguard_1", { alp = 1 } );
      VidPlay( "vid_porch_professor_bodyguard_1", "" );

    elseif ( count_txt == 2 ) then

      ObjSet( "spr_int_dialog_character_icon", { res = "assets/interface/resources/dialog_character/btm_1" } );
      ObjAnimate( "rm_porch", "pos_xy", 0, 0, "",
      { 
        0.0, 0, ObjGet( "rm_porch" ).pos_x, ObjGet( "rm_porch" ).pos_y,
        0.3, 0, 24, -103,
      } );       

      ObjSet( "vid_porch_professor_bodyguard_idle", { alp = 0 } );
      ObjSet( "vid_porch_professor_bodyguard_2", { alp = 1 } );
      VidPlay( "vid_porch_professor_bodyguard_2", "" );

      ObjSet( "vid_porch_professor_bodyguard_1", { alp = 0 } );
      ObjSet( "vid_porch_professor_bodyguard_3", { alp = 1 } );
      VidStop( "vid_porch_professor_bodyguard_1", "" );

    elseif ( count_txt == 3 ) then

      ObjSet( "spr_int_dialog_character_icon", { res = "assets/interface/resources/dialog_character/btm_3" } );
      ObjAnimate( "rm_porch", "pos_xy", 0, 0, "",
      { 
        0.0, 0, ObjGet( "rm_porch" ).pos_x, ObjGet( "rm_porch" ).pos_y,
        0.3, 0, -202, -134,
      } );

      ObjSet( "vid_porch_professor_bodyguard_1", { alp = 0 } );
      VidPlay( "vid_porch_professor_bodyguard_3", "" );    

    end;

  end;

end;
--------------------------------------------------------------------------------------------
function private.dlg_professor_bodyguard_click ()

  common_impl.continue_visible = true; 
  ObjSet( "obj_porch_lip_professor", { alp = 1 } );

  common_impl.DialogCharacterStart( "professor_bodyguard", 4, nil, nil, true, private.dlg_professor_bodyguard_end );

end;
--------------------------------------------------------------------------------------------
function private.dlg_professor_bodyguard_end ()

  local func_end = function ()

    cmn.Lock( false );
    cmn.CallEventHandler( "dlg_porch_professor_bodyguard" );
    ObjSet( "vid_porch_professor_bodyguard_idle", { alp = 1 } );
    ObjSet( "obj_porch_lip_professor", { alp = 0 } );
    private.LeaveBodyguard();
    ObjSet( "spr_int_dialog_character_icon", { res = "" } );

  end;

  cmn.Lock( true );
  ObjAnimate( "rm_porch", "scale_xy", 0, 0, func_end,
  { 
    0.0, 0, ObjGet( "rm_porch" ).scale_x, ObjGet( "rm_porch" ).scale_y,
    0.3, 0, 1, 1
  } ); 
  ObjAnimate( "rm_porch", "pos_xy", 0, 0, "",
  { 
    0.0, 0, ObjGet( "rm_porch" ).pos_x, ObjGet( "rm_porch" ).pos_y,
    0.3, 0, 0, 0,
  } ); 

end;
--------------------------------------------------------------------------------------------
function private.LeaveBodyguard ()

  local func_anim = function ()

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "see_leave_bodyguard" );
      cmn.CallEventHandler( "see_leave_bodyguard" );

      common_impl.ShowBbt( "bbt_porch_see_leave_bodyguard" );

    end;

    common_impl.StopAudio( "sfx", "level1/sfx/aud_leave_bodyguard", 0.2 );

    cmn.Lock( true );

    ObjSet( "spr_porch_door_close", { alp = 0 } );
    ObjSet( "spr_porch_tobias", { alp = 0 } );
    ObjSet( "vid_porch_professor_bodyguard_idle2", { alp = 0 } );

    AnimPlay( "anm_porch_logo_on", "DoAnim", func_end )

  end;

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_leave_bodyguard", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_porch_leave_bodyguard", func_anim );

end;
--------------------------------------------------------------------------------------------
function private.ScreamingBodyguard ()

  local func_vid = function ()

    local func_end = function ()

      cmn.SetEventDone( "use_reynolds_case" );
      cmn.SetEventDone( "see_screaming_bodyguard" );
      cmn.CallEventHandler( "see_screaming_bodyguard" );

      common_impl.StopAudio( "sfx", "level1/sfx/aud_screaming_bodyguard", 0.2 );

      common_impl.ShowBbt( "bbt_porch_see_screaming_bodyguard" );

      cmn.GotoRoom( "rm_hall" );

    end;

    cmn.Lock( false );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_screaming_bodyguard", 0, "", 0 );

    cmn.PlayDialogVideo( "vid_porch_screaming_bodyguard", func_end );

  end;

  cmn.Lock( true );

  AnimPlay( "anm_porch_light", "DoAnim", func_vid );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** ANIMATIONS *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_car_trunk_light_1", "alp", 1, 0, "",
    { 
      0.0, 0, 1, 
      4.0, 0, 0.0,
      8.0, 0, 1
    } );    

  ObjAnimate( "spr_car_trunk_light_2", "alp", 1, 0, "",
    { 
      0.0, 0, 1, 
      3.0, 0, 0.7,
      6.0, 0, 1
    } );  


  ObjAnimate( "spr_porch_light_car", "alp",1,0, "", { 0, 0, 1,    0.8, 0, 0.3,    1.4, 0, 0.3,    2.3, 0, 1,    3.0, 0, 0.4,    4.5, 0, 1,    5.1, 0, 1 } );

end;

--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** FEEDBACK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************

function private.ClickSignboard ()

  local func_end = function ()

    cmn.Lock( false );
    ObjSet( "obj_porch_clk_signboard", { input = true } );

  end;

  cmn.Lock( true );
  ObjSet( "obj_porch_clk_signboard", { input = false } );

  ObjAnimate( "anm_porch_logo_2", "alp",0,0, "", { 0, 0, 0,    0.3, 0, 1 } );
  AnimPlay( "anm_porch_logo_2", "DoAnim", func_end );

end;


--*********************************************************************************************************************







