-- name=ho_archivedata
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "archivedata" );
  game.relations[ "ho_archivedata" ].exitroom = "rm_archives";
  private.room_objname = "ho_archivedata";
  --------------------------------------------------------------------------------------------------
  private.win_archivedata = {};

  private.win_archivedata.pos_inv = 
  {-230, -110, 10, 130, 250, 370, 490, 610, 730, 850, 970, 1090};

  private.win_archivedata.task = { "cardiogram",  "hammer",     "hand",     "hotty", 
                                   "logo",        "respirator", "rope",     "seal3", 
                                   "statuette",   "tonometer",  "vessel",   "vial" };

  for i = 1, #private.win_archivedata.task do

    ObjSet( "spr_archivedata_"..private.win_archivedata.task[ i ], 
    { 
      event_mdown = function () private.CompleteTask( private.win_archivedata.task[ i ] ); end, 
      input = false 
    } );

  end;

  private.Animation ();

  --------------------------------------------------------------------------------------------
  -- function opn_archivedata () end;
  --------------------------------------------------------------------------------------------
  local opn_archivedata = function ()

  end;

  cmn.AddSubscriber( "opn_archivedata", opn_archivedata, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_archivedata () end;
  --------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_archivedata" ] =
  {
      type = "win",
      room = "rm_archives",
      zz = private.room_objname,
      zz_gate = "gho_archives_archivedata"
  };
  --------------------------------------------------------------------------------------------------
  local win_archivedata_func = function ()

    if ( cmn.IsEventDone( "win_archivedata" ) ) then

      interface.InventoryItemAdd( "inv_seal3", "spr_archivedata_win" );

    end;

  end;
  local win_archivedata_loc = function ()

    if ( cmn.IsEventDone( "win_archivedata" ) ) then

      ObjDelete( "gho_archives_archivedata" );

      ObjDelete( "spr_archives_videoplayer_ho1" );
      ObjSet( "spr_archives_videoplayer_ho2", { alp = 1 } );

    end;

  end;
  cmn.AddSubscriber( "win_archivedata", win_archivedata_func );
  cmn.AddSubscriber( "win_archivedata", win_archivedata_loc, "rm_archives" );
  --------------------------------------------------------------------------------------------------
  local start_archivedata_func = function ()

    if ( cmn.IsEventStart( "win_archivedata" ) ) then

        common_impl.ProcessHoStart( "archivedata" );

        local ho_found = ng_global.progress[ "std" ][ "win_archivedata" ].found;

        for i = 1, #ho_found, 1 do

            ObjDelete( ho_found[ i ][ "object" ] );

        end;

    end;

  end;
  cmn.AddSubscriber( "win_archivedata", start_archivedata_func, "ho_archivedata" );
  --------------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();
  common_impl.EnvPlay( { "mus_env/aud_ho_mus_env" }, "", 0.5 );

  if ( not cmn.IsEventDone( "opn_archivedata" ) ) then

      cmn.SetEventDone( "opn_archivedata" );
      cmn.CallEventHandler( "opn_archivedata" );

  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "cardiogram",             1, 0, { { "spr_archivedata_cardiogram" } } );
  interface.TaskPanelTaskAdd( ho_items, "hammer",                 1, 0, { { "spr_archivedata_hammer" } } );
  interface.TaskPanelTaskAdd( ho_items, "hand",                   1, 0, { { "spr_archivedata_hand" } } );
  interface.TaskPanelTaskAdd( ho_items, "hotty",                  1, 0, { { "spr_archivedata_hotty" } } );
  interface.TaskPanelTaskAdd( ho_items, "logo",                   1, 0, { { "spr_archivedata_logo" } } );
  interface.TaskPanelTaskAdd( ho_items, "respirator",             1, 0, { { "spr_archivedata_respirator" } } );
  interface.TaskPanelTaskAdd( ho_items, "rope",                   1, 0, { { "spr_archivedata_rope" } } );
  interface.TaskPanelTaskAdd( ho_items, "seal3",                  1, 0, { { "spr_archivedata_seal3" } } );
  interface.TaskPanelTaskAdd( ho_items, "statuette",              1, 0, { { "spr_archivedata_statuette" } } );
  interface.TaskPanelTaskAdd( ho_items, "tonometer",              1, 0, { { "spr_archivedata_tonometer" } } );
  interface.TaskPanelTaskAdd( ho_items, "vessel",                 1, 0, { { "spr_archivedata_vessel" } } );
  interface.TaskPanelTaskAdd( ho_items, "vial",                   1, 0, { { "spr_archivedata_vial" } } );

  if ( not cmn.IsEventStart( "win_archivedata" ) ) then

    cmn.InitHo( "archivedata" );

  end;
  


  interface.TaskPanelShow( ho_items );
  private.Panel();
  
  if (cmn.IsEventDone( "win_archivedata" )) then
    cmn.CallEventHandler( "win_archivedata" );
    interface.TaskPanelHide();
    interface.ItemPanelHide();
    common.GotoRoom( game.relations[ "ho_archivedata" ].exitroom );
  end;

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();

--  if cmn.IsEventStart( "see_tutorial" ) then
--
--    common_impl.TutorialShow( "tutorial_page_13" );
--
--  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  common_impl.PassingHoStop();

  ObjSet( "obj_int_taskpanel", { alp = 1 } );
  ObjSet( "txt_int_taskpanel", { alp = 1 } );

end;
--*********************************************************************************************************************
function public.HoComplete ()

  common_impl.PassingHoWin();

end;
--*********************************************************************************************************************
function private.CompleteTask ( name )

  local func_end = function ()

    cmn.Lock( true );

    cmn.HoTaskFind( "spr_archivedata_"..name, name );

    for i = 1,#private.win_archivedata.task do

      if ( private.win_archivedata.task[ i ] == name ) then 

        local object_name = "obj_"..i; 
        local collect_name  = "pfx_archivedata_collect_"..object_name.."_effect";
        ng_global.progress[ "std" ][ "win_archivedata" ].task_check[ i ] = 1;
        ObjCreate( collect_name, "partsys" );

        if  ( cmn.IsEventDone( "win_archivedata" ) ) then

          cmn.Lock( false );

        end;

        ObjSet( collect_name,
        {
          res    = "assets/interface/resources/effects_ho_hint",
          pos_x  = ObjGet( object_name ).pos_x, pos_y = ObjGet( object_name ).pos_y,
          active = 1, visible = 1, input = 0
        } );

        ObjAttach( collect_name, "obj_int_taskpanel_ho_archivedata" );
        ObjSet( collect_name, { blendmode = 2, scale_x = 0.9, scale_y = 0.9 } );
        --PartSysSetMaskObj( collect_name, object_name );  
        local func_end = function () private.AnimInv( i ); end;
        ObjAnimate( object_name, 8,0,0, func_end,
        { 
          0.0, 0, 1.0,
          0.1, 0, 0.0
          --1.0, 0, 0.0
        } );

      end;

    end;

  end;

  if #ng_global.progress[ "std" ][ "win_archivedata" ].found == 11 then

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_terence_2lvl", 0, "", 0 );

    cmn.PlayDialogVideo( "vid_archivedata_terenec", func_end );

  else

    func_end();

  end;

end;
--*********************************************************************************************************************
function private.GetItem ( name )

end;
--*********************************************************************************************************************
function private.UseItem ( name ) 
  
end;
--*********************************************************************************************************************
function private.UseItemEnd ( name )

end;
--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );

  if ( not ng_global.progress[ "std" ]["win_archivedata"].task_check ) then

     ng_global.progress["std"]["win_archivedata"].task_check = {0,0,0,0,0,0,0,0,0,0,0,0};

  end;

  local posx = -230;
  local tmp = 0;

  ObjSet( "obj_int_taskpanel_ho_archivedata", { croprect_init = true, croprect_x = -295, croprect_y = -200, croprect_w = 617, croprect_h = 400 } );

  for i = 1,#private.win_archivedata.task do 

     local obj = "obj_"..i;

     if ( ng_global.progress["std"]["win_archivedata"].task_check[ i ] == 0 ) and
        ( not ObjGet( obj ) ) then

        ObjCreate( obj, "obj" );
        ObjAttach( obj, "obj_int_taskpanel_ho_archivedata" );
        ObjAttach( "obj_int_taskpanel_ho_archivedata" , "spr_int_taskpanel" );
        ObjSet( obj, { pos_x = posx, pos_y = 30, inputrect_init = true, inputrect_x = -45, inputrect_y = -45, inputrect_w = 90, inputrect_h = 90, alp = 1, input = 0  } );
        local spr = "spr_archivedata_"..private.win_archivedata.task[ i ].."_inv";
        ObjCreate( spr, "spr" );
        ObjSet( spr, { res = "assets/levels/level2/ho_archivedata/layers/"..private.win_archivedata.task[ i ].."_shadow", scale_x = 0.95, scale_y = 0.95 } );
        ObjAttach( spr, obj );
        tmp = tmp + 1;
        if ( tmp < 6 ) then

           private.CheckPanel( i, tmp );
          
        end;

        posx = posx + 120;

        if ( tmp == 12 ) then

            ng_global.progress["std"]["win_archivedata"].set = 1;

        end;

     else

     end;

  end;
   
end;
--********************************************************************************************************************* 
function private.CheckPanel ( i, tmp ) 

   local obj = "obj_"..i;

   if ( tmp < 6 ) then

      ObjSet( obj, { input = 1 } );

      ObjAnimate( obj, "alp", 0, 0, "", 
      { 
        0,0,0, 
        0.3,0,1 
      } );

      ObjSet( "spr_archivedata_"..private.win_archivedata.task[ i ], { alp = 1, input = 1 } );


   end;
   
end;
--*********************************************************************************************************************
function private.AnimInv ( num )

  local item = "obj_"..num;
  local tmp = num + 1;

    for i = tmp,#private.win_archivedata.task do

      local obj_tmp = "obj_"..i;

      if obj_tmp ~= nil and ng_global.progress["std"]["win_archivedata"].task_check[i] ~= 1 then

        ObjAnimate( "obj_"..i, "pos_x", 0, 0, "", 
        { 
          0.0,3,ObjGet( "obj_"..i ).pos_x, 
          0.4,3,ObjGet( "obj_"..i ).pos_x-120
          --0.8,3,ObjGet( "obj_"..i ).pos_x-120
        } );

        if ObjGet( "obj_"..i ).pos_x-120 == 250 then

          ObjAnimate( "obj_"..i, "scale_xy", 0, 0, "", 
          { 
            0.0,0,0.2,0.2, 
            0.3,0,1,1, 
            0.4,0,1.2,1.2,
            0.5,0,1,1

            --0.0,0,0.2,0.2, 
            --0.6,0,1,1, 
            --0.8,0,1.2,1.2,
            --1.0,0,1,1

          } );

        end;

      end;

    end;

  private.Check( num );

end;
--*********************************************************************************************************************
function private.Check ( num )  

  local tmp = 0;

  for i = 1,#private.win_archivedata.task do

    local item = "obj_"..i;

    if ( item and ng_global.progress[ "std" ][ "win_archivedata" ].task_check[ i ] ~= 1 ) then

       tmp = tmp + 1;

       if ( tmp < 6 ) then

          ObjSet( "spr_archivedata_"..private.win_archivedata.task[ i ], { alp = 1, input = 1 } );

       end;

       num = num + 1;

    end;

  end;

  local func_end = function () 

  cmn.Lock( false ) 

  end;

  ObjAnimate( "ho_archivedata", "alp", 0, 0, func_end, 
    { 
      0.0, 3, 1, 
      0.5, 3, 1
    } );

end;
--*********************************************************************************************************************
function private.Animation ()

  ObjAnimate( "spr_archivedata_light1", "alp", 1, 0, "", 
  { 
    0.0,  0,  1.0,
    3.0,  0,  0.0,
    6.0,  0,  1.0
  } );

end;
--*********************************************************************************************************************