-- name=ho_experimentroom
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "experimentroom" );
  game.relations[ "ho_experimentroom" ].exitroom = "rm_lab";
  private.room_objname = "ho_experimentroom";
  private.ho_name = "experimentroom";
  --------------------------------------------------------------------------------------------------
  
  ObjMultiSet( {

    { "obj_experimentroom_clk_flashlight", { event_mdown = function() private.clk_flashlight() end } },

  } );

  private.color = { r = 0.7804, g = 0.60392, b = 0.42352 }; 
  private.task = { "five",           "vaccine",       "hands",      "project",
                   "photo",          "military_man",  "eternal",    "newspapers", 
                   "tests_results",  "inhaler",       "phone" ,     "dead", 
                   "videocamera" };

  private.max_count = #private.task;
  for i = 1, #private.task do

    ObjSet( "spr_experimentroom_"..private.task[ i ], 
    { 
      event_mdown = function () private.CompleteTask( private.task[ i ] ); end, 
      input = false 
    } );

  end;

  private.InitAnimations();

  common_impl.hint[ "win_experimentroom" ] = {
      type = "win",
      room = "rm_lab",
      zz = "ho_experimentroom",
      zz_gate = "gho_lab_experimentroom"
  }; 
  local win_experimentroom_func = function ()

    if ( cmn.IsEventDone( "win_experimentroom" ) ) then

      interface.InventoryItemAdd( "inv_camera", "spr_experimentroom_win" );
      ObjSet( "inv_camera", { drag = false } );

      ObjDelete( "gho_lab_experimentroom" );  
      cmn.SetInvPlusRGB( "bottle", true );
      ObjSet( "tmr_experimentroom_flashlight", { playing = false } ); 
      ObjDelete( "tmr_experimentroom_flashlight" );

      if ( not cmn.IsGetCollect2( "get_collect2_item_2_2" ) ) then

        ObjSet( "gzz_lab_masterswitch", { input = true, visible = true, active = true } );

      end;

    end;

  end;
  cmn.AddSubscriber( "win_experimentroom", win_experimentroom_func );
  --------------------------------------------------------------------------------------------------
  local start_experimentroom_func = function ()

    if ( cmn.IsEventStart( "win_experimentroom" ) ) then

      --cmn.ProcessHoStart( "experimentroom" );
      local ho_found = ng_global.progress[ "std" ][ "win_experimentroom" ].found;

      for i = 1, #ho_found, 1 do

        ObjDelete( ho_found[ i ][ "object" ] );

      end;

    end;

  end;
  cmn.AddSubscriber( "win_experimentroom", start_experimentroom_func, "ho_experimentroom" );  

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();
  common_impl.EnvPlay( { "mus_env/aud_ho_mus_env" }, "", 0.5 );

  if ( not cmn.IsEventDone( "opn_experimentroom" ) ) then
  
    cmn.SetEventDone( "opn_experimentroom" );
    cmn.CallEventHandler( "opn_experimentroom" );
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "five",               1, 0, { { "spr_experimentroom_five", "obj_experimentroom_clk_flashlight" } } );
  interface.TaskPanelTaskAdd( ho_items, "vaccine",            1, 0, { { "spr_experimentroom_vaccine" } } );
  interface.TaskPanelTaskAdd( ho_items, "hands",              1, 0, { { "spr_experimentroom_hands" } } );
  interface.TaskPanelTaskAdd( ho_items, "project",            1, 0, { { "spr_experimentroom_project" } } );
  interface.TaskPanelTaskAdd( ho_items, "photo",              1, 0, { { "spr_experimentroom_photo" } } );
  interface.TaskPanelTaskAdd( ho_items, "military_man",       1, 0, { { "spr_experimentroom_military_man" } } );
  interface.TaskPanelTaskAdd( ho_items, "eternal",            1, 0, { { "spr_experimentroom_eternal" } } );
  interface.TaskPanelTaskAdd( ho_items, "tests_results",      1, 0, { { "spr_experimentroom_tests_results" } } );
  interface.TaskPanelTaskAdd( ho_items, "inhaler",            1, 0, { { "spr_experimentroom_inhaler" } } );
  interface.TaskPanelTaskAdd( ho_items, "phone",              1, 0, { { "spr_experimentroom_phone" } } );
  interface.TaskPanelTaskAdd( ho_items, "dead",               1, 0, { { "spr_experimentroom_dead" } } );
  interface.TaskPanelTaskAdd( ho_items, "newspapers",         1, 0, { { "spr_experimentroom_newspapers" } } );
  interface.TaskPanelTaskAdd( ho_items, "videocamera",        1, 0, { { "spr_experimentroom_videocamera" } } );

  if ( not cmn.IsEventStart( "win_experimentroom" ) ) then

    cmn.InitHo( "experimentroom" );

  end;

  interface.TaskPanelShow( ho_items );
  private.Panel();

  if ( not ng_global.progress[ "std" ]["win_experimentroom"].clk_flashlight ) then

     ng_global.progress[ "std" ]["win_experimentroom"].clk_flashlight = false;

  else

    if ( ng_global.progress[ "std" ]["win_experimentroom"].clk_flashlight == true ) then

      private.clk_flashlight_end();
    
    end;

  end;


end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();

--  if cmn.IsEventStart( "see_tutorial" ) then
--
--    common_impl.TutorialShow( "tutorial_page_12" );
--
--  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();
  common_impl.StopAllVoc();

end;
--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  common_impl.PassingHoStop();

  ObjSet( "obj_int_taskpanel", { alp = 1 } );
  ObjSet( "txt_int_taskpanel", { alp = 1 } );

  ObjAttach( "obj_int_taskpanel_ho_experimentroom" , "ho_experimentroom" ); 

end;
--*********************************************************************************************************************
function public.HoComplete ()

  ObjSet( "tmr_experimentroom_flashlight", { playing = false } );
  --common_impl.PlayAudio( "sfx", "aud_ho_win" );
  common_impl.PassingHoWin();
  
end;
--*********************************************************************************************************************

--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );
  ObjSet( "obj_int_taskpanel_ho_experimentroom", { pos_y = 23, croprect_init = true, croprect_x = -295, croprect_y = -200, croprect_w = 617, croprect_h = 400 } );
  ObjAttach( "obj_int_taskpanel_ho_experimentroom" , "spr_int_taskpanel" ); 
  
  if ( not ng_global.progress[ "std" ]["win_experimentroom"].count_task ) then

     ng_global.progress["std"]["win_experimentroom"].count_task = 1;

  end;

  local count_task = ng_global.progress["std"]["win_experimentroom"].count_task

  for i = 1, private.max_count do 

    local name = "txt_"..private.ho_name.."_phrase_"..i;

      if ( not ObjGet( name ) ) then

        ObjCreate( name, "text" );
        ObjAttach( name, "obj_int_taskpanel_ho_experimentroom" );

        local tsk = "tsk_"..private.ho_name.."_phrase_"..i;    
        ObjSet( name, 
          { 
            alp = 0,
            res = "assets/fonts/mt7_10",
            text = tsk,
            fontsize = 18,
            maxwidth = 570, 
            param0 = 1,  
            param1 = private.color.r,  
            param2 = private.color.g,  
            param3 = private.color.b,  

          } );

      end;

  end;

  ObjSet( "txt_"..private.ho_name.."_phrase_"..count_task, { alp = 1 } ); 
  private.SetHoState();

end;
--*********************************************************************************************************************
function private.SetHoState ()

  for i = 1, #private.task do

    ObjSet( "spr_experimentroom_"..private.task[ i ], 
    { 
      input = false 

    } );

  end;
  for i = 1, private.max_count do 

    ObjSet( "txt_"..private.ho_name.."_phrase_"..i, { alp = 0 } );  

  end;

  local count_task = ng_global.progress["std"]["win_experimentroom"].count_task;
  if ( private.task[ count_task ] == "five" ) then

    if ( ng_global.progress[ "std" ]["win_experimentroom"].clk_flashlight ) then

      ObjSet( "spr_experimentroom_"..private.task[ count_task ], 
      { 
        input = true

      } );

    else  

      ObjSet( "obj_experimentroom_clk_flashlight", { input = true } );

    end;

  else

    ObjSet( "spr_experimentroom_"..private.task[ count_task ], 
    { 
      input = true

    } );

  end;

  ObjSet( "txt_"..private.ho_name.."_phrase_"..count_task, { alp = 1 } ); 

  common_impl.StopAllVoc();
  common_impl.PlayAudio( "voc", "level2/voc/aud_experimentroom_phrase_"..count_task.."_voc", 0, "", 0 );

end;
--*********************************************************************************************************************
function private.CompleteTask ( name )

  cmn.Lock( true );

  cmn.HoTaskFind( "spr_experimentroom_"..name, name );
  
  local count_task = ng_global.progress["std"]["win_experimentroom"].count_task;

  local next_count_task = count_task + 1;
  ng_global.progress["std"]["win_experimentroom"].count_task = next_count_task;
  if ( count_task < private.max_count ) then

    ObjAnimate( "txt_"..private.ho_name.."_phrase_"..count_task, "alp",0,0, "",
      { 
        0.0, 0, ObjGet( "txt_"..private.ho_name.."_phrase_"..count_task ).alp,
        0.5, 0, 0.0
      } ); 
    ObjAnimate( "txt_"..private.ho_name.."_phrase_"..next_count_task, "alp",0,0, "",
      { 
        0.0, 0, ObjGet( "txt_"..private.ho_name.."_phrase_"..next_count_task ).alp,
        0.5, 0, 1.0
      } );    

  end; 

  local func_end = function ()

    cmn.Lock( false );

    if ( ng_global.progress["std"]["win_experimentroom"].count_task <= private.max_count ) then

      private.SetHoState();

    end;    

  end;

  ObjAnimate( "obj_experimentroom_objects", "alp",0,0, func_end,
    { 
      0.0, 0, ObjGet( "obj_experimentroom_objects" ).alp,
      0.5, 0, ObjGet( "obj_experimentroom_objects" ).alp
    } );


end;
--*********************************************************************************************************************
function private.clk_flashlight ()

  cmn.Lock( true );

  local func_end = function() 

    cmn.Lock( false );
    private.clk_flashlight_end ();

    ng_global.progress[ "std" ]["win_experimentroom"].clk_flashlight = true;
    private.SetHoState();

  end;

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk9", 0, "", 0 );
  
  ObjAnimate( "spr_experimentroom_mask1", "alp",0,0, func_end,
  { 
    0.0, 0, ObjGet( "spr_experimentroom_mask1" ).alp,
    0.3, 0, 0
  } );
  ObjAnimate( "spr_experimentroom_mask", "alp",0,0, "",
  { 
    0.0, 0, ObjGet( "spr_experimentroom_mask" ).alp,
    0.15, 0, 0.8
  } );  
  ObjAnimate( "spr_experimentroom_flashlight", "alp",0,0, "",
  { 
    0.0, 0, ObjGet( "spr_experimentroom_flashlight" ).alp,
    0.2, 0, 0
  } ); 

end;
--*********************************************************************************************************************
function private.clk_flashlight_end ()

  ObjDelete( "obj_experimentroom_clk_flashlight" );
  ObjDelete( "spr_experimentroom_mask1" );
  ObjDelete( "spr_experimentroom_flashlight" );
  ObjSet( "spr_experimentroom_mask", { alp = 0.8 } );
  ObjSet( "tmr_experimentroom_flashlight", 
  { 
    playing = true, 
    time = 0.001, 
    endtrig = function() private.cursor_flashlight() end 
  } ); 

end;
--*********************************************************************************************************************
function private.cursor_flashlight ()

  local pos = GetZoomCursorPos();
  local pcx = pos[ 1 ];
  local pcy = pos[ 2 ];

  if ( not cmn.IsEventDone( "win_experimentroom" ) ) then

    ObjSet( "spr_experimentroom_mask", { pos_x = pcx, pos_y = pcy} );
    ObjSet( "tmr_experimentroom_flashlight", 
    { 
      playing = true, 
      time = 0.001, 
      endtrig = function() private.cursor_flashlight() end 
    } ); 

  end;

end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;