-- name=ho_indollhouse
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "indollhouse" );
  game.relations[ "ho_indollhouse" ].exitroom = "rm_childrensroom";
  private.room_objname = "ho_indollhouse";
  private.cout_piece = 12
  private.cout_items = 12;
  private.find_final_object = "str_indollhouse_final_object";
  --------------------------------------------------------------------------------------------------
   local table_multiset = {};
--obj_indollhouse_use_dino
   table.insert( table_multiset, { "spr_indollhouse_bandage",             { event_mdown = function() private.TaskComplete( "bandage", 8 ) end } } );
   table.insert( table_multiset, { "spr_indollhouse_glasses",             { event_mdown = function() private.TaskComplete( "glasses", 2 ) end } } );
   table.insert( table_multiset, { "spr_indollhouse_imp",                 { event_mdown = function() private.TaskComplete( "imp", 11 ) end } } );
   table.insert( table_multiset, { "spr_indollhouse_kite",                { event_mdown = function() private.TaskComplete( "kite", 10 ) end } } );
   table.insert( table_multiset, { "spr_indollhouse_pillow",              { event_mdown = function() private.TaskComplete( "pillow", 7 ) end } } );
   table.insert( table_multiset, { "spr_indollhouse_pyramid",             { event_mdown = function() private.TaskComplete( "pyramid", 12 ) end } } );
   table.insert( table_multiset, { "spr_indollhouse_rattle",              { event_mdown = function() private.TaskComplete( "rattle", 5 ) end } } );
   table.insert( table_multiset, { "spr_indollhouse_sun",                 { event_mdown = function() private.TaskComplete( "sun", 9 ) end } } );
   table.insert( table_multiset, { "spr_indollhouse_tortoise",            { event_mdown = function() private.TaskComplete( "tortoise", 3 ) end } } );
   table.insert( table_multiset, { "spr_indollhouse_boat",                { event_mdown = function() private.TaskComplete( "boat", 4 ) end } } );
   table.insert( table_multiset, { "spr_indollhouse_flamingo",            { event_mdown = function() private.TaskComplete( "flamingo", 6 ) end } } );
   table.insert( table_multiset, { "spr_indollhouse_phonendoscope",       { event_mdown = function() private.TaskComplete( "phonendoscope", 1 ) end } } );

   table.insert( table_multiset, { "spr_indollhouse_card",                { event_mdown = function() private.card() end } } );

  for i = 1, private.cout_piece do

   table.insert( table_multiset, { "spr_indollhouse_part_"..i, 
                                  { 
                                    event_mdown    = function () private.ClkPartForDrug( i ) end,
                                    event_menter   = function () common_impl.SetCursor( CURSOR_GET ); end,
                                    event_mleave   = function () common_impl.SetCursor( CURSOR_DEFAULT ); end,
                                    event_dragdrop = function () private.DropPart ( i );  end 
                                  } } );

  end;

  ObjMultiSet( table_multiset );
  private.InitAnimations();
  --------------------------------------------------------------------------------------------
  -- function win_indollhouse () end;
  --------------------------------------------------------------------------------------------  
  common_impl.hint[ "win_indollhouse" ] = {
      type = "win",
      room = "rm_childrensroom",
      zz = "ho_indollhouse",
      zz_gate = "gho_childrensroom_indollhouse"
  };
  
  local win_indollhouse_inv = function ()
  
    if ( cmn.IsEventDone( "win_indollhouse" ) ) then

      interface.InventoryItemAdd( "inv_kevinscard", "spr_indollhouse_win" );
  
    end;

  end;
  
  local win_indollhouse_closezz = function ()
  
    
  
  end;
  
  local win_indollhouse_loc = function ()
  
    if ( cmn.IsEventDone( "win_indollhouse" ) ) then

      ObjDelete( "gho_childrensroom_indollhouse" );
  
    end;

  end;
  
  cmn.AddSubscriber( "win_indollhouse", win_indollhouse_inv );
  cmn.AddSubscriber( "win_indollhouse", win_indollhouse_closezz, private.room_objname );
  cmn.AddSubscriber( "win_indollhouse", win_indollhouse_loc, "rm_childrensroom" );

  --------------------------------------------------------------------------------------------------
  local start_indollhouse_func = function ()

    if ( cmn.IsEventStart( "win_indollhouse" ) ) then

      local ho_found = ng_global.progress[ "std" ][ "win_indollhouse" ].found;

      for i = 1, #ho_found, 1 do
        ObjDelete( ho_found[ i ][ "object" ] );
      end;

    end;

  end;
  cmn.AddSubscriber( "win_indollhouse", start_indollhouse_func, "ho_indollhouse" );  

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();
  common_impl.EnvPlay( { "mus_env/aud_ho_mus_env" }, "", 0.5 );

  if ( not cmn.IsEventDone( "opn_indollhouse" ) ) then
  
    cmn.InitHo( "indollhouse" );
    cmn.SetEventDone( "opn_indollhouse" );
    ng_global.progress[ "std" ][ "win_indollhouse" ].pieces = { };
    ng_global.progress[ "std" ][ "win_indollhouse" ].puzzles = { };

    for i = 1, private.cout_piece do
  
      ng_global.progress[ "std" ][ "win_indollhouse" ].pieces[ i ] = 0;
      ng_global.progress[ "std" ][ "win_indollhouse" ].puzzles[ i ] = 0;

    end;

    ng_global.progress[ "std" ][ "win_indollhouse" ].objects_counter = private.cout_piece;
    ng_global.progress[ "std" ][ "win_indollhouse" ].puzzle_counter = private.cout_piece;

    ng_global.progress[ "std" ][ "win_indollhouse" ].item_counter = private.cout_items;

    ng_global.progress[ "std" ][ "win_indollhouse" ].dino_relation = 
    { 
      {   },      -- 1
      { 1 },      -- 2
      { 2 },      -- 3
      { 2 },      -- 4
      { 3 },      -- 5
      { 5 },      -- 6
      { 2 },      -- 7
      { 6 },      -- 8
      { 8 },      -- 9
      { 3 },      -- 10
      { 7 },      -- 11
      { 9 } };    -- 12
    ng_global.progress[ "std" ][ "win_indollhouse" ].dino_state = 
    { false, false, false, 
      false, false, false, 
      false, false, false, 
      false, false, false };
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "bandage",                1, 0, { { "spr_indollhouse_bandage" } } );
  interface.TaskPanelTaskAdd( ho_items, "glasses",                1, 0, { { "spr_indollhouse_glasses" } } );
  interface.TaskPanelTaskAdd( ho_items, "imp",                    1, 0, { { "spr_indollhouse_imp" } } );
  interface.TaskPanelTaskAdd( ho_items, "kite",                   1, 0, { { "spr_indollhouse_kite" } } );
  interface.TaskPanelTaskAdd( ho_items, "pillow",                 1, 0, { { "spr_indollhouse_pillow" } } );
  interface.TaskPanelTaskAdd( ho_items, "pyramid",                1, 0, { { "spr_indollhouse_pyramid" } } );
  interface.TaskPanelTaskAdd( ho_items, "rattle",                 1, 0, { { "spr_indollhouse_rattle" } } );
  interface.TaskPanelTaskAdd( ho_items, "sun",                    1, 0, { { "spr_indollhouse_sun" } } );
  interface.TaskPanelTaskAdd( ho_items, "tortoise",               1, 0, { { "spr_indollhouse_tortoise" } } );
  interface.TaskPanelTaskAdd( ho_items, "boat",                   1, 0, { { "spr_indollhouse_boat" } } );
  interface.TaskPanelTaskAdd( ho_items, "flamingo",               1, 0, { { "spr_indollhouse_flamingo" } } );
  interface.TaskPanelTaskAdd( ho_items, "phonendoscope",          1, 0, { { "spr_indollhouse_phonendoscope" } } );

  interface.TaskPanelTaskAdd( ho_items, "part_1",                 1, 0, { { "obj_indollhouse_part_1_hint", "obj_indollhouse_dino_1_hint" } } );
  interface.TaskPanelTaskAdd( ho_items, "part_2",                 1, 0, { { "obj_indollhouse_part_2_hint", "obj_indollhouse_dino_2_hint" } } );
  interface.TaskPanelTaskAdd( ho_items, "part_3",                 1, 0, { { "obj_indollhouse_part_3_hint", "obj_indollhouse_dino_3_hint" } } );
  interface.TaskPanelTaskAdd( ho_items, "part_4",                 1, 0, { { "obj_indollhouse_part_4_hint", "obj_indollhouse_dino_4_hint" } } );
  interface.TaskPanelTaskAdd( ho_items, "part_5",                 1, 0, { { "obj_indollhouse_part_5_hint", "obj_indollhouse_dino_5_hint" } } );
  interface.TaskPanelTaskAdd( ho_items, "part_6",                 1, 0, { { "obj_indollhouse_part_6_hint", "obj_indollhouse_dino_6_hint" } } );
  interface.TaskPanelTaskAdd( ho_items, "part_7",                 1, 0, { { "obj_indollhouse_part_7_hint", "obj_indollhouse_dino_7_hint" } } );
  interface.TaskPanelTaskAdd( ho_items, "part_8",                 1, 0, { { "obj_indollhouse_part_8_hint", "obj_indollhouse_dino_8_hint" } } );
  interface.TaskPanelTaskAdd( ho_items, "part_9",                 1, 0, { { "obj_indollhouse_part_9_hint", "obj_indollhouse_dino_9_hint" } } );
  interface.TaskPanelTaskAdd( ho_items, "part_10",                1, 0, { { "obj_indollhouse_part_10_hint", "obj_indollhouse_dino_10_hint" } } );
  interface.TaskPanelTaskAdd( ho_items, "part_11",                1, 0, { { "obj_indollhouse_part_11_hint", "obj_indollhouse_dino_11_hint" } } );
  interface.TaskPanelTaskAdd( ho_items, "part_12",                1, 0, { { "obj_indollhouse_part_12_hint", "obj_indollhouse_dino_12_hint" } } );
  
  interface.TaskPanelTaskAdd( ho_items, "card",                   1, 0, { { "spr_indollhouse_card" } } );  
  
  interface.TaskPanelShow( ho_items );

  for i = 1, #ng_global.progress[ "std" ][ "win_indollhouse" ].pieces do

    if ( ng_global.progress[ "std" ][ "win_indollhouse" ].pieces[ i ] == 1 ) then

      ObjSet( "spr_indollhouse_part_"..i, { input = true } );

    end;   

  end;

  for i = 1, #ng_global.progress[ "std" ][ "win_indollhouse" ].puzzles do

    ObjSet( "spr_indollhouse_part_"..i, { input = true } );

    if ( ng_global.progress[ "std" ][ "win_indollhouse" ].dino_state[ i ] == true ) then

      ObjDelete( "spr_indollhouse_part_"..i );  
      ObjDelete( "obj_indollhouse_dino_"..i.."_hint" );
      ObjSet( "spr_indollhouse_dino_"..i, { alp = 1 } );

    end;

  end;

  if ( ng_global.progress[ "std" ][ "win_indollhouse" ].item_counter == 0 ) then
    
    ObjSet( "obj_indollhouse_use_dino", { input = true } );
    ObjAttach( "txt_indollhouse_task", "int_taskpanel_impl");
    ObjSet( "obj_int_taskpanel", { alp = 0 } );
    ObjSet( "txt_indollhouse_task", { alp = 1, param0 = ng_global.progress["std"]["win_indollhouse"].puzzle_counter } );
    private.MakeHintForParts();

    ObjAttach( "txt_indollhouse_task", "int_taskpanel_impl");
    ObjSet( "obj_int_taskpanel", { alp = 0 } );

    if ( ng_global.progress[ "std" ][ "win_indollhouse" ].puzzle_counter == 0 ) then

      ObjDelete( "obj_indollhouse_use_dino" );
      ObjSet( "spr_indollhouse_paper", { pos_x = 285, pos_y = 442 } );
      ObjSet( "spr_indollhouse_card", { input = true, alp = 1 } );
      ObjSet( "txt_suitcase_task", { text = private.find_final_object } );  
      ObjSet( "txt_indollhouse_task", { alp = 1, text = private.find_final_object } );

    else 

      ObjSet( "txt_indollhouse_task", { alp = 1, param0 = ng_global.progress[ "std" ][ "win_indollhouse" ].puzzle_counter } );
         
    end;

  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();

--  if cmn.IsEventStart( "see_tutorial" ) then
--
--    common_impl.TutorialShow( "tutorial_page_6" );
--
--  end;

end;
--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  ObjAttach( "txt_indollhouse_task", "ho_indollhouse");
  common_impl.PassingHoStop();

end;
--*********************************************************************************************************************
function public.HoComplete ()

  common_impl.PassingHoWin();

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete ( task_name, piece_number )
  
  local find_obj = "spr_indollhouse_"..task_name;

  cmn.HoTaskFind( find_obj, task_name );
  
  ng_global.progress[ "std" ][ "win_indollhouse" ].item_counter = ng_global.progress[ "std" ][ "win_indollhouse" ].item_counter - 1;
  if ( piece_number ) then

    ObjSet( "spr_indollhouse_part_"..piece_number, { input = true } );
    ng_global.progress[ "std" ][ "win_indollhouse" ].pieces[ piece_number ] = 1;
    private.MakeHintForParts();

  end;

  if ( ng_global.progress[ "std" ][ "win_indollhouse" ].item_counter == 0 ) then

    ObjSet( "obj_indollhouse_use_dino", { input = true } );
    ObjAttach( "txt_indollhouse_task", "int_taskpanel_impl");
    ObjSet( "obj_int_taskpanel", { alp = 0 } );
    ObjSet( "txt_indollhouse_task", { alp = 1, param0 = ng_global.progress["std"]["win_indollhouse"].puzzle_counter } );
    --ObjSet( "obj_indollhouse_piece", { input = true } );

  end;
 
end;
--------------------------------------------------------------------------------------------
function private.ClkPartForDrug ( id )

  common_impl.PlayAudio( "sfx", "aud_get_inv_in_hand_sfx", 0, "", 0 );

  ObjAttach( "spr_indollhouse_part_"..id, "ho_indollhouse" );
  ObjSet( "spr_indollhouse_part_"..id, { pos_z = 20 } );  

end;
--------------------------------------------------------------------------------------------
function private.DropPart ( id ) 

  local item = "spr_indollhouse_part_"..id;
  if ( cmn.ApplyObj( item, "obj_indollhouse_use_dino" ) and private.Is_Drop( id ) ) then

    common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );

    ng_global.progress[ "std" ][ "win_indollhouse" ].puzzle_counter = ng_global.progress[ "std" ][ "win_indollhouse" ].puzzle_counter - 1;
    ng_global.progress[ "std" ][ "win_indollhouse" ].puzzles[ id ] = 1;
    ng_global.progress[ "std" ][ "win_indollhouse" ].dino_state[ id ] = true;

    ObjDelete( "spr_indollhouse_part_"..id );  
    ObjDelete( "obj_indollhouse_dino_"..id.."_hint" );
    ObjSet( "spr_indollhouse_dino_"..id, { alp = 1 } ); 
    ObjSet( "txt_indollhouse_task", { param0 = ng_global.progress[ "std" ][ "win_indollhouse" ].puzzle_counter } );
    cmn.HoTaskFind( "spr_indollhouse_dino_"..id.."_complete", "part_"..id );
    private.MakeHintForParts();

    if ( ng_global.progress[ "std" ][ "win_indollhouse" ].puzzle_counter == 0 ) then

      local func_end = function () 

        ObjSet( "spr_indollhouse_paper", { pos_x = 285, pos_y = 442 } );
        ObjDelete( "obj_indollhouse_use_dino" );
        ObjSet( "spr_indollhouse_card", { alp = 1 } );
        ObjSet( "spr_indollhouse_card", { input = true, alp = 1 } );
        ObjSet( "txt_indollhouse_task", { text = private.find_final_object } );        

      end;

      ObjAnimate( "spr_indollhouse_paper", "pos_xy", 0, 0, func_end, 
      { 
        0.0, 3, ObjGet( "spr_indollhouse_paper" ).pos_x, ObjGet( "spr_indollhouse_paper" ).pos_y,  
        0.3, 3, 285, 442
      } );
      ObjAnimate( "spr_indollhouse_paper", "alp", 0, 0, "", 
      { 
        0.0, 0, ObjGet( "spr_indollhouse_paper" ).alp, 
        0.3, 0, 1
      } );
      ObjAnimate( "spr_indollhouse_card", "alp", 0, 0, "", 
      { 
        0.0, 0, ObjGet( "spr_indollhouse_card" ).alp,  
        0.3, 0, 1
      } );
 
    end;

  else

    if ( id == 6 ) then

      ObjAttach( "spr_indollhouse_part_"..id, "ho_indollhouse" );
      ObjSet( "spr_indollhouse_part_"..id, { pos_z = -5 } );  

    elseif ( id == 10 ) then

      ObjAttach( "spr_indollhouse_part_"..id, "ho_indollhouse" );
      ObjSet( "spr_indollhouse_part_"..id, { pos_z = 3 } ); 

    else
 
      ObjAttach( "spr_indollhouse_part_"..id, "obj_indollhouse_part" );
      ObjSet( "spr_indollhouse_part_"..id, { pos_z = 0 } ); 

    end; 

  end;

end;
--------------------------------------------------------------------------------------------
function private.Is_Drop ( id )

  if ( ng_global.progress[ "std" ][ "win_indollhouse" ].pieces[ id ] == 1 ) then

    if ( #ng_global.progress[ "std" ][ "win_indollhouse" ].dino_relation[ id ] == 0 ) then

      return true;

    else

      local bool = true;

      for i = 1, #ng_global.progress[ "std" ][ "win_indollhouse" ].dino_relation[ id ] do

        local num = ng_global.progress[ "std" ][ "win_indollhouse" ].dino_relation[ id ][ i ];
        if ( ng_global.progress[ "std" ][ "win_indollhouse" ].dino_state[ num ] == false ) then

          bool = false;
          break;

        end;

       end;

       return bool;

    end;

  end;

end;
--------------------------------------------------------------------------------------------
function private.MakeHintForParts ()

  for i = 1, #ng_global.progress[ "std" ][ "win_indollhouse" ].dino_relation do

    if ( private.Is_Drop( i ) ) then

      ObjSet( "obj_indollhouse_dino_"..i.."_hint", { input = true } );
      ObjSet( "obj_indollhouse_part_"..i.."_hint", { input = true } );

    else
      
      ObjSet( "obj_indollhouse_dino_"..i.."_hint", { input = false } );
      ObjSet( "obj_indollhouse_part_"..i.."_hint", { input = false } );

    end;

  end;

end;
--------------------------------------------------------------------------------------------
function private.card ()

  cmn.HoTaskFind( "spr_indollhouse_card", "card" );

end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_indollhouse_s_hook", "ang", 1, 0, "", 
  { 
    0.0, 3, 0.11, 
    2.0, 3, -0.06, 
    4.0, 3, 0.11 
  } );  
  ObjAnimate( "spr_indollhouse_s_whirligig", "ang", 1, 0, "", 
  { 
    0.0, 3, 0.11, 
    4.0, 3, -0.07, 
    8.0, 3, 0.11 
  } );  

end;
--*********************************************************************************************************************