-- name=mg_metalcases
--*********************************************************************************************************************
function public.Init ()

  private.LogicInit();  

  private.room_objname = "mg_metalcases";

  --------------------------------------------------------------------------------------------
  -- function win_metalcases () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_metalcases" ] = {
    type = "win",
    room = "rm_corridorelevator",
    zz = "mg_metalcases",
    zz_gate = "gmg_corridorelevator_metalcases"
  };

  local win_metalcases = function ()

    if ( cmn.IsEventDone( "win_metalcases" ) ) then  

      ObjSet( "obj_metalcases_conteiner", { input = false } );

    end;

  end;

  local win_metalcases_loc = function ()

    if ( cmn.IsEventDone( "win_metalcases" ) ) then  

      ObjDelete( "gmg_corridorelevator_metalcases" );
      ObjSet( "gzz_corridorelevator_metalcase", { input = true, active = true, visible = true } );
      ObjSet( "spr_metalcase_roller", { input = true } );
      ObjDelete( "spr_metalcase_mg_cover" );

    end;

  end;


  cmn.AddSubscriber( "win_metalcases", win_metalcases, private.room_objname );
  cmn.AddSubscriber( "win_metalcases", win_metalcases_loc, "rm_corridorelevator" );

  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Open () 

  if not cmn.IsEventDone( "win_metalcases" ) then

    common_impl.PassingMgStart();

  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  if not cmn.IsEventDone( "win_metalcases" ) then

    cmn.MiniGameShow();

  end;

  private.Load();
  private.Update();

end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()

  if not cmn.IsEventDone( "win_metalcases" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
function private.get_roller ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_roller" );
  cmn.CallEventHandler( "get_roller" );

  cmn.GotoRoom( "rm_corridorelevator" );

end;
--*********************************************************************************************************************
function public.Reset ()

  private.Default();
  private.Save();
  private.Update();

end;
--*********************************************************************************************************************

function public.Skip ()

port.skip_mg = true;
  for i = 1, #private.state, 1 do 

    private.state[i] = private.state_win[i];

  end;

  private.Save();
  private.Update();

end;


--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MINIGAME LOGIC *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************


private.state = {};

-- dynamic array stores information about boxes, which are must move
private.infoAboutMovingBoxes = {};

private.state_win = { 1, 2, 11, 12, 3, 4, 13, 14, 5, 6, -1, 15, 16, 7, 8, 17, 18, 9, 10, 19, 20 };


-- array stores coordinates of cells, where boxes are standing 
private.position = {
                      { pos_x = 273, pos_y = 218 },
                      { pos_x = 391, pos_y = 218 },
                      { pos_x = 626, pos_y = 218 },
                      { pos_x = 744, pos_y = 218 },

                      { pos_x = 332, pos_y = 277 },
                      { pos_x = 449, pos_y = 277 },
                      { pos_x = 567, pos_y = 277 },
                      { pos_x = 686, pos_y = 277 },

                      { pos_x = 273, pos_y = 337 },
                      { pos_x = 391, pos_y = 337 },
                      { pos_x = 508, pos_y = 337 },
                      { pos_x = 626, pos_y = 337 },
                      { pos_x = 745, pos_y = 337 },

                      { pos_x = 333, pos_y = 396 },
                      { pos_x = 449, pos_y = 396 },
                      { pos_x = 568, pos_y = 396 },
                      { pos_x = 686, pos_y = 396 },

                      { pos_x = 274, pos_y = 456 },
                      { pos_x = 391, pos_y = 456 },
                      { pos_x = 627, pos_y = 456 },
                      { pos_x = 745, pos_y = 456 } 

                   };


-- array stores connections between cells on four directions: 
-- North-West, North-East, South-East and South-West 
private.links = {
                    { north_west = 0, north_east = 0, south_east = 5, south_west = 0 },
                    { north_west = 0, north_east = 0, south_east = 6, south_west = 5 },
                    { north_west = 0, north_east = 0, south_east = 8, south_west = 7 },
                    { north_west = 0, north_east = 0, south_east = 0, south_west = 8 },

                    { north_west = 1, north_east = 2, south_east = 10, south_west = 9 },
                    { north_west = 2, north_east = 0, south_east = 11, south_west = 10 },
                    { north_west = 0, north_east = 3, south_east = 12, south_west = 11 },
                    { north_west = 3, north_east = 4, south_east = 13, south_west = 12 },

                    { north_west = 0, north_east = 5, south_east = 14, south_west = 0 },
                    { north_west = 5, north_east = 6, south_east = 15, south_west = 14 },
                    { north_west = 6, north_east = 7, south_east = 16, south_west = 15 },
                    { north_west = 7, north_east = 8, south_east = 17, south_west = 16 },
                    { north_west = 8, north_east = 0, south_east = 0, south_west = 17 },

                    { north_west = 9, north_east = 10, south_east = 19, south_west = 18 },
                    { north_west = 10, north_east = 11, south_east = 0, south_west = 19 },
                    { north_west = 11, north_east = 12, south_east = 20, south_west = 0 },
                    { north_west = 12, north_east = 13, south_east = 21, south_west = 20 },

                    { north_west = 0, north_east = 14, south_east = 0, south_west = 0 },
                    { north_west = 14, north_east = 15, south_east = 0, south_west = 0 },
                    { north_west = 16, north_east = 17, south_east = 0, south_west = 0 },
                    { north_west = 17, north_east = 0, south_east = 0, south_west = 0 }

                };


-- array stores boxes colors  
private.colors = {
                    "blue",
                    "blue",
                    "blue",
                    "blue",
                    "blue",
                    "blue",
                    "blue",
                    "blue",
                    "blue",
                    "blue",

                    "red",
                    "red",
                    "red",
                    "red",
                    "red",
                    "red",
                    "red",
                    "red",
                    "red",
                    "red" 
                 };


local METALCASES_BOX_COUNT = 20;
local METALCASES_EMPTY = 0;
local METALCASES_HOLE = -1;
local METALCASES_MOVING_BOXES = 2;
local METALCASES_BOX_NAME = "spr_metalcases_box_";


local isSearchSuccessful = false;


--*******************************************************************************************************************
function private.Default ()

  private.state = { 11, 6, 19, 1, 12, 3, 20, 18, 2, 4, -1, 17, 5, 13, 7, 16, 8, 15, 9, 14, 10 };

end; 


--*******************************************************************************************************************
function private.Load ()

  private.state = ng_global.progress[ "std" ][ "win_metalcases" ].state;

  if not private.state then 
    private.Default();
  end; 

end;


--*******************************************************************************************************************
function private.Save ()

  ng_global.progress[ "std" ][ "win_metalcases" ].state = private.state;

end;


--*******************************************************************************************************************
function private.LogicInit ()   

  for i = 1, METALCASES_BOX_COUNT, 1 do

    local currentBox = METALCASES_BOX_NAME..i;
    ObjSet( currentBox, { 
                            input = 1,
                            event_mdown = function () private.Click( i ); end,
                            event_menter = function () private.Enter( i ); end,
                            event_mleave = function () private.Leave( i ); end
                         } );

  end;

end;

--*******************************************************************************************************************
function private.Enter ( id )

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_menter1", 0, "", 0 );
 
  SetCursor( CURSOR_HAND );
  local current = METALCASES_BOX_NAME..id.."_focus";
  local alpha = ObjGet( current ).alp;
  ObjAnimate( current, "alp",0,0, "", { 0, 0, alpha,    0.2 * ( 1 - alpha ), 0, 1 } );

end;


--*******************************************************************************************************************
function private.Leave ( id )  

  SetCursor( CURSOR_DEFAULT );
  local current = METALCASES_BOX_NAME..id.."_focus";
  local alpha = ObjGet( current ).alp;
  ObjAnimate( current, "alp",0,0, "", { 0, 0, alpha,    0.2 * alpha, 0, 0 } );

end;


--*******************************************************************************************************************
-- getting cell id by box id 

function private.GetPositionByBoxId ( id )

  local position = 1;

  for i = 1, #private.state, 1 do 

    if id == private.state[i] then 

      position = i;
      break;

    end;

  end;

  return position; 

end;


--*******************************************************************************************************************
-- getting moving direction: isTwoBoxes == false, it is searching in nearest boxes,
-- else it is searching in nearest boxes relatively nearest boxes of current box 

function private.GetTypeMoving ( positionId, isTwoBoxes )

  local result = "NO_MOVING";

  local northWestBox = private.links[ positionId ].north_west;
  local northEastBox = private.links[ positionId ].north_east;
  local southEastBox = private.links[ positionId ].south_east;
  local southWestBox = private.links[ positionId ].south_west;

  if isTwoBoxes then

    if northWestBox ~= METALCASES_EMPTY then 
      northWestBox = private.links[ northWestBox ].north_west;
    end;

    if northEastBox ~= METALCASES_EMPTY then 
      northEastBox = private.links[ northEastBox ].north_east;
    end; 

    if southEastBox ~= METALCASES_EMPTY then 
      southEastBox = private.links[ southEastBox ].south_east;
    end;

    if southWestBox ~= METALCASES_EMPTY then 
      southWestBox = private.links[ southWestBox ].south_west;
    end;

  end;

  if northWestBox ~= METALCASES_EMPTY and private.state[ northWestBox ] == METALCASES_HOLE then 
    result = "north_west";

  elseif northEastBox ~= METALCASES_EMPTY and private.state[ northEastBox ] == METALCASES_HOLE then 
    result = "north_east";

  elseif southEastBox ~= METALCASES_EMPTY and private.state[ southEastBox ] == METALCASES_HOLE then 
    result = "south_east";

  elseif southWestBox ~= METALCASES_EMPTY and private.state[ southWestBox ] == METALCASES_HOLE then 
    result = "south_west";

  end; 

  return result; 

end;


--*******************************************************************************************************************
function private.Click ( id )

  local currentBox = METALCASES_BOX_NAME..id; 

  local func_end = function()

    ObjSet( currentBox, { pos_z = 0 } );
    cmn.Lock( false );
    ObjSet( "obj_metalcases_conteiner", { input = true } );
    private.Update(); 

  end;

  local positionId = private.GetPositionByBoxId( id );
  local typeMovingOne = private.GetTypeMoving( positionId, false );

  if typeMovingOne ~= "NO_MOVING" then 

    cmn.Lock( true );
    ObjSet( "obj_metalcases_conteiner", { input = false } );

    local oldX = private.position[ positionId ].pos_x;
    local oldY = private.position[ positionId ].pos_y;

    local newPositionId = private.links[ positionId ][ typeMovingOne ];
    local newX = private.position[ newPositionId ].pos_x;
    local newY = private.position[ newPositionId ].pos_y;

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_mmg_lampwall_clk1", 0, "", 0 );

    ObjAnimate( currentBox, "pos_xy",0,0, func_end, { 0, 3, oldX, oldY,    0.3, 3, newX, newY } );

    local temp = private.state[ positionId ];
    private.state[ positionId ] = private.state[ newPositionId ];
    private.state[ newPositionId ] = temp;

    private.Save(); 

  else 

    local typeMovingTwo = private.GetTypeMoving( positionId, true ); 

    if typeMovingTwo ~= "NO_MOVING" then 

      cmn.Lock( true );
      ObjSet( "obj_metalcases_conteiner", { input = false } );

      local oldX = private.position[ positionId ].pos_x;
      local oldY = private.position[ positionId ].pos_y;

      local newPositionId = private.links[ positionId ][ typeMovingTwo ];
      newPositionId = private.links[ newPositionId ][ typeMovingTwo ];

      local newX = private.position[ newPositionId ].pos_x;
      local newY = private.position[ newPositionId ].pos_y;

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_mmg_lampwall_clk1", 0, "", 0 );

      ObjSet( currentBox, { pos_z = 10 } );
      ObjAnimate( currentBox, "pos_xy",0,0, func_end, { 0, 3, oldX, oldY,    0.6, 3, newX, newY } );

      local temp = private.state[ positionId ];
      private.state[ positionId ] = private.state[ newPositionId ];
      private.state[ newPositionId ] = temp;

      private.Save(); 

    end;

  end; 

end;


--*******************************************************************************************************************
function private.Update ()

  for i = 1, #private.state, 1 do 

    local boxId = private.state[i];

    if boxId ~= METALCASES_HOLE then 

      local currentX = private.position[i].pos_x;
      local currentY = private.position[i].pos_y;

      local currentBox = METALCASES_BOX_NAME..boxId;
      ObjSet( currentBox, { pos_x = currentX, pos_y = currentY } );

    end; 

  end;

  if private.CheckWin() then 

    ObjSet( "obj_metalcases_conteiner", { input = false } );
    private.Win();

  end;

end;


--*******************************************************************************************************************
function private.CheckWin ()

  local fieldBlueHalf = { 1, 2, 5, 6, 9, 10, 14, 15, 18, 19 };
  local fieldRedHalf = { 3, 4, 7, 8, 12, 13, 16, 17, 20, 21 };
  local result = true;

  for i = 1, #fieldBlueHalf, 1 do 

    local positionId = fieldBlueHalf[i];
    local boxId = private.state[positionId];
    if boxId == METALCASES_HOLE or private.colors[boxId] ~= "blue" then

      result = false;

    end;

  end; 

---------------------------------------------

  for i = 1, #fieldRedHalf, 1 do 

    local positionId = fieldRedHalf[i];
    local boxId = private.state[positionId];
    if boxId == METALCASES_HOLE or private.colors[boxId] ~= "red" then

      result = false;

    end;

  end; 

  return result;

end;


--*******************************************************************************************************************
function private.Win ()

  cmn.Lock( true );

  cmn.MiniGameHide();

  for i = 1, METALCASES_BOX_COUNT, 1 do 

    local func_end = "";
    if i == METALCASES_BOX_COUNT then

      func_end = function()

        rm_corridorelevator.open_metalcase = true;

        cmn.Lock( flase );
        cmn.SetEventDone( "win_metalcases" );
        cmn.CallEventHandler( "win_metalcases" );

        common_impl.PassingMgWin();
        cmn.GotoRoom( "rm_corridorelevator" );

      end;

    end;

    local boxFocus = METALCASES_BOX_NAME..i.."_focus";
    local currentAlpha = ObjGet( boxFocus ).alp;

    ObjAnimate( boxFocus, "alp",0,0, func_end, { 0, 3, currentAlpha,    0.6, 3, 1,    1.0, 3, 0,    1.8, 3, 1,    2.2, 3, 0 } );

  end;

end;
--*********************************************************************************************************************







