-- name=level2

function public.Start ( param )

  interface.WidgetAdd( InterfaceWidget_Pause, 10000000 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 20 );

  if IsCollectorsEdition() then

    interface.WidgetAdd( InterfaceWidget_BtnGuide, 20 );

  end;

  interface.WidgetAdd( InterfaceWidget_BtnHint, 11  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 12 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 27 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 27 );

  --interface.WidgetAdd( InterfaceWidget_TaskHeader );
  interface.WidgetAdd( InterfaceWidget_Inventory, 9 );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 10 );

  interface.WidgetAdd( InterfaceWidget_Effects, 11 );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 11 );

  interface.WidgetAdd( InterfaceWidget_DialogHo, 19 );

  interface.ButtonLockAdd();
  interface.LockAdd();

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8);

  interface.WidgetAdd( InterfaceWidget_ItemPanel );
  interface.WidgetAdd( InterfaceWidget_Popup, 27 );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog, 26 );

  interface.WidgetAdd( InterfaceWidget_DialogVideo, 26 );
  interface.WidgetAdd( InterfaceWidget_DialogStory );
  interface.WidgetAdd( InterfaceWidget_DialogCharacter, 8 );

  interface.WidgetAdd( InterfaceWidget_StrategyGuide, 28 );
  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial );

  interface.WidgetAdd( InterfaceWidget_Map, 26  );

  interface.PanelNotificationAdd();
  interface.DeployInvAdd( 9 );
  interface.DialogHintAdd();
  interface.ButtonTaskAdd( 1 );
  interface.DialogTaskAdd( 20 );  
  interface.DiaryAdd( 28 );
  
  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    interface.BtnCollectibles2Add( 18 );
    interface.BtnCollectiblesAdd( 18 );
    interface.AchievementsAdd( 18 );
    interface.BtnMorphAdd( 18 );

  end;

  private.Init();
  ModLoad( "assets/levels/level2/mod_level2_inv" );
  level2_inv.Init();

  common.LevelLoad( "level2", "std", "rm_corridorelevator", param, private.menu_moduls );
  common_impl.Collectibles2Load();

  --private.TutorialSetParams();
  interface.KeyUpdate();

  cmn.PlayMusEnv();

end;
    
function private.Init ()

  game = {};
  game.room_names =
  {
  "rm_hall_2"
  ,"rm_lounge_2"
  ,"rm_corridorelevator"
  ,"rm_bar_2"
  ,"rm_courtyard_2"
  ,"rm_childrensroom"
  ,"rm_lowerlevel"
  ,"rm_receptionroom"
  ,"rm_lab"
  ,"rm_archives"
  ,"mg_superpuzzle2"
  ,"mg_metalcases"
  ,"ho_indollhouse"
  ,"ho_experimentroom"
  ,"mg_distillatingstill"
  ,"ho_archivedata"
  };

  game.progress_names_room =
  {
  { "beg_levele2" }
  ,{ "opn_corridorelevator" }
  ,{ "opn_courtyard_2" }
  ,{ "opn_bar_2" }
  ,{ "opn_hall_2" }
  ,{ "opn_lounge_2" }
  ,{ "clk_rightwall",                     "rm_corridorelevator",          { "opn_corridorelevator" } }
  ,{ "clk_valve_2",                       "rm_corridorelevator",          { "clk_rightwall" } }
  ,{ "get_valve_2",                       "rm_corridorelevator",          { "clk_valve_2" } }
  ,{ "use_valve_2",                       "rm_corridorelevator",          { "get_valve_2" } }
  ,{ "clk_valve_metalcase",               "rm_corridorelevator",          { "use_valve_2" } }
  ,{ "clk_battery1",                      "rm_corridorelevator",          { "clk_valve_metalcase" } }
  ,{ "get_battery1",                      "rm_corridorelevator",          { "clk_battery1" } }
  ,{ "get_battery2",                      "rm_corridorelevator",          { "opn_corridorelevator" } }
  ,{ "clk_douglasthings",                 "rm_corridorelevator",          { "opn_corridorelevator" } }
  ,{ "use_battery_1",                     "rm_corridorelevator",          { "get_battery1", "get_battery2" }  }
  ,{ "get_stepladder",                    "rm_corridorelevator",          { "use_battery_1" } }
  ,{ "see_courtyard_3",                   "rm_courtyard",                 { "get_stepladder" } }
  ,{ "use_stepladder",                    "rm_courtyard",                 { "see_courtyard_3" } }
  ,{ "opn_childrensroom" }
  ,{ "use_antirust_2_1",                  "rm_childrensroom",             { "opn_childrensroom" } }
  ,{ "clk_dollhead",                      "rm_childrensroom",             { "use_antirust_2_1" } }
  ,{ "get_dollhead",                      "rm_childrensroom",             { "clk_dollhead"} }
  ,{ "use_dollhead",                      "rm_childrensroom",             { "get_dollhead" } }
  ,{ "get_dollhousepart",                 "rm_childrensroom",             { "use_dollhead" } }
  ,{ "use_dollhousepart",                 "rm_childrensroom",             { "get_dollhousepart" } }
  ,{ "get_trianglekey",                   "rm_childrensroom",             { "use_dollhousepart" } }
  ,{ "use_trianglekey",                   "rm_corridorelevator",          { "get_trianglekey" } }
  ,{ "clk_trianglekey",                   "rm_corridorelevator",          { "use_trianglekey" } }
  ,{ "win_metalcases",                    "rm_corridorelevator",          { "clk_trianglekey" } }
  ,{ "get_roller",                        "rm_corridorelevator",          { "win_metalcases" } }
  ,{ "clk_roller",                        "rm_corridorelevator",          { "get_stepladder" } }
  ,{ "use_roller",                        "rm_corridorelevator",          { "get_roller", "clk_roller" } }
  ,{ "clk_lever",                         "rm_corridorelevator",          { "use_roller" } }
  ,{ "get_hook_1",                        "rm_corridorelevator",          { "clk_lever" } }
  ,{ "get_redwire",                       "rm_corridorelevator",          { "clk_lever" } }
  ,{ "use_rope_2" }
  ,{ "clk_rope_1" }
  ,{ "clk_rope_2" }
  ,{ "get_hookedrope" }
  ,{ "use_hookedrope",                    "rm_corridorelevator",          { "get_hookedrope", "clk_douglasthings" } }
  ,{ "win_elevator",                      "rm_corridorelevator",          { "use_hookedrope" } }
  ,{ "get_douglasthings",                 "rm_corridorelevator",          { "win_elevator" } }
  ,{ "clk_pocket_1"  }
  ,{ "clk_pocket_2"  }
  ,{ "get_douglascard"  }
  ,{ "see_flashback_douglas",             "rm_corridorelevator",          { "get_douglascard" } }
  ,{ "clk_pocket_3"  }
  ,{ "clk_pocket_4"  }
  ,{ "get_hanky" }
  ,{ "use_hanky",                         "rm_childrensroom",             { "get_hanky" } }
  ,{ "get_tuner",                         "rm_childrensroom",             { "use_hanky" } }
  ,{ "see_childrensroom_scare_1",         "rm_childrensroom",             { "get_tuner" } }
  ,{ "see_parm_masked_man",               "rm_childrensroom",             { "opn_childrensroom" } }
  ,{ "use_tuner",                         "rm_childrensroom",             { "get_tuner" } }
  ,{ "get_plate",                         "rm_childrensroom",             { "use_tuner" } }
  ,{ "use_plate",                         "rm_childrensroom",             { "get_plate" } }  
  ,{ "get_dummyshand",                    "rm_childrensroom",             { "use_plate" } }
  ,{ "clk_blanket",                       "rm_childrensroom",             { "opn_childrensroom" } }
  ,{ "use_dummyshand",                    "rm_childrensroom",             { "get_dummyshand", "clk_blanket" } }
  ,{ "get_handle",                        "rm_childrensroom",             { "use_dummyshand" } } 
  ,{ "use_handle",                        "rm_childrensroom",             { "get_handle" } }
  ,{ "clk_handle",                        "rm_childrensroom",             { "use_handle" } } 
  ,{ "get_voodoodoll",                    "rm_childrensroom",             { "clk_handle" } }
  ,{ "clk_voodoodollpin_1" }
  ,{ "clk_voodoodollpin_all" }
  ,{ "get_lockpickset" }
  ,{ "use_lockpickset",                   "rm_childrensroom",             { "get_lockpickset" } }
  ,{ "opn_indollhouse" }
  ,{ "win_indollhouse",                   "rm_childrensroom",             { "use_lockpickset" } }
  ,{ "see_corridorelevator_2",            "rm_corridorelevator",          { "win_indollhouse" } }
  ,{ "use_kevinscard",                    "rm_corridorelevator",          { "win_indollhouse" } }
  ,{ "use_douglascard",                   "rm_corridorelevator",          { "get_douglascard" } }
  ,{ "clk_button_elevator",               "rm_corridorelevator",          { "use_kevinscard", "use_douglascard" } }
  -- rm_lowerlevel
  ,{ "opn_lowerlevel" }
  ,{ "use_antirust_2_2",                  "rm_lowerlevel",                { "opn_lowerlevel" }  }
  ,{ "get_fridgehandle1",                 "rm_lowerlevel",                { "use_antirust_2_2" }  }
  ,{ "see_lowerlevel_masked",             "rm_lowerlevel",                { "get_fridgehandle1" }  }
  ,{ "use_fridgehandle1",                 "rm_lowerlevel",                { "get_fridgehandle1" } }
  ,{ "clk_fridgehandle1",                 "rm_lowerlevel",                { "use_fridgehandle1" } }
  ,{ "get_registrationentries",           "rm_lowerlevel",                { "clk_fridgehandle1" } }
  ,{ "clk_registrationentries" }
  ,{ "get_douglasamulet" }
  ,{ "use_douglasamulet",                 "rm_lowerlevel",                { "get_douglasamulet" } }
  ,{ "get_receptionroomkey",              "rm_lowerlevel",                { "use_douglasamulet" } }
  ,{ "see_lowerlevel_lowerlevel",         "rm_lowerlevel",                { "get_receptionroomkey" } }
  ,{ "use_receptionroomkey",              "rm_lowerlevel",                { "get_receptionroomkey" } }
  ,{ "clk_receptionroomkey",              "rm_lowerlevel",                { "use_receptionroomkey" } }
  -- rm_receptionroom
  ,{ "opn_receptionroom" }
  ,{ "get_flashlight",                    "rm_receptionroom",             { "opn_receptionroom" } }
  ,{ "clk_flashlight_open" }
  ,{ "use_battery_2" }
  ,{ "clk_flashlight_close" }
  ,{ "clk_button_flashlight" }
  ,{ "get_workingflashlight" }
  ,{ "use_workingflashlight_1",           "rm_lowerlevel",                { "get_workingflashlight" } }
  ,{ "get_fridgehandle2",                 "rm_lowerlevel",                { "use_workingflashlight_1" } }
  ,{ "use_fridgehandle2",                 "rm_lowerlevel",                { "get_fridgehandle2" } }
  ,{ "get_wheelchairwheel",               "rm_lowerlevel",                { "use_fridgehandle2" } }
  ,{ "get_gasmask",                       "rm_lowerlevel",                { "use_fridgehandle2" } }
  ,{ "use_wheelchairwheel",               "rm_lowerlevel",                { "get_wheelchairwheel" } }
  -- rm_lab
  ,{ "opn_lab" }
  ,{ "clk_emergency_alarm",               "rm_lab",                       { "opn_lab" } }
  ,{ "use_gasmask",                       "rm_lab",                       { "clk_emergency_alarm" }  }
  ,{ "win_gasmask",                       "rm_lab",                       { "use_gasmask" } }
  ,{ "get_fridgehandle3",                 "rm_lab",                       { "win_gasmask" } }
  ,{ "use_fridgehandle3",                 "rm_lowerlevel",                { "get_fridgehandle3" } }
  ,{ "clk_fridgehandle3",                 "rm_lowerlevel",                { "use_fridgehandle3" } }
  ,{ "get_cheese",                        "rm_lowerlevel",                { "clk_fridgehandle3" } }
  ,{ "use_cheese",                        "rm_receptionroom",             { "get_cheese" } }
  ,{ "get_coin1",                         "rm_receptionroom",             { "use_cheese" } }
  ,{ "see_receptionroom_horror",          "rm_receptionroom",             { "get_coin1" } }
  ,{ "use_coin1",                         "rm_receptionroom",             { "get_coin1" } }
  ,{ "clk_coin_1",                        "rm_receptionroom",             { "use_coin1" } }
  ,{ "get_bronzewhorl",                   "rm_receptionroom",             { "clk_coin_1" } }
  ,{ "use_bronzewhorl",                   "rm_receptionroom",             { "get_bronzewhorl" } }
  ,{ "clk_bronzewhorl",                   "rm_receptionroom",             { "use_bronzewhorl" } }
  ,{ "get_surgicalclip",                  "rm_receptionroom",             { "clk_bronzewhorl" } }
  ,{ "use_surgicalclip",                  "rm_lowerlevel",                { "get_surgicalclip" } }
  ,{ "get_masterswitch",                  "rm_lowerlevel",                { "use_surgicalclip" } }
  ,{ "use_masterswitch",                  "rm_lab",                       { "get_masterswitch" } }
  ,{ "clk_masterswitch",                  "rm_lab",                       { "use_masterswitch" } }
  ,{ "opn_experimentroom" }
  ,{ "win_experimentroom",                "rm_lab",                       { "clk_masterswitch" } }
  ,{ "clk_camera_button" }
  ,{ "get_bluewire" }
  ,{ "clk_flap_wire",                     "rm_lab",                       { "win_gasmask" } }
  ,{ "use_bluewire",                      "rm_lab",                       { "get_bluewire", "clk_flap_wire" } } 
  ,{ "use_redwire",                       "rm_lab",                       { "get_redwire", "clk_flap_wire" } }
  ,{ "get_hexkey",                        "rm_lab",                       { "use_bluewire", "use_redwire" } }
  ,{ "use_hexkey_1",                      "rm_lab",                       { "get_hexkey" } }
  ,{ "get_coin2",                         "rm_lab",                       { "use_hexkey_1" } }
  ,{ "use_coin2",                         "rm_receptionroom",             { "get_coin2" } }
  ,{ "clk_coin_2",                        "rm_receptionroom",             { "use_coin2" } }
  ,{ "get_switch_2",                      "rm_receptionroom",             { "clk_coin_2" } }
  ,{ "use_switch_2",                      "rm_receptionroom",             { "get_switch_2" } }
  ,{ "clk_switch_2",                      "rm_receptionroom",             { "use_switch_2" } }
  ,{ "get_accesspassword",                "rm_receptionroom",             { "clk_switch_2" } }
  ,{ "use_accesspassword",                "rm_lab",                       { "get_accesspassword" } }
  ,{ "win_password",                      "rm_lab",                       { "use_accesspassword" } }
  ,{ "win_labdesk",                       "rm_lab",                       { "win_password" } }
  ,{ "get_labassistantskey",              "rm_lab",                       { "win_labdesk" } }
  ,{ "use_labassistantskey",              "rm_lab",                       { "get_labassistantskey" } }
  ,{ "clk_labassistantskey",              "rm_lab",                       { "use_labassistantskey" } }
  ,{ "get_patientsprofile",               "rm_lab",                       { "clk_labassistantskey" } }
  ,{ "clk_profile" }
  ,{ "clk_note" }
  ,{ "get_scotchtapepiece" }
  ,{ "use_scotchtapepiece",               "rm_lab",                       { "get_scotchtapepiece", "use_hexkey_1" } }
  ,{ "get_fingerprint",                   "rm_lab",                       { "use_scotchtapepiece" } }
  ,{ "use_fingerprint",                   "rm_lab",                       { "get_fingerprint" } }
  -- rm_archives
  ,{ "opn_archives" }
  ,{ "get_volumecontrol",                 "rm_archives",                  { "opn_archives" } }
  ,{ "get_mapsheet_2",                    "rm_archives",                  { "opn_archives" } }
  ,{ "use_volumecontrol",                 "rm_archives",                  { "get_volumecontrol" } }
  ,{ "use_cork",                          "rm_archives",                  { "opn_archives" } }
  ,{ "get_button1",                       "rm_archives",                  { "use_cork", "use_volumecontrol" } }
  ,{ "use_hexkey_2",                      "rm_archives",                  { "get_hexkey", "opn_archives" } }
  ,{ "get_button2",                       "rm_archives",                  { "use_hexkey_2" } }
  ,{ "use_button1",                       "rm_lab",                       { "get_button1" } }
  ,{ "use_button2",                       "rm_lab",                       { "get_button2" } }
  ,{ "clk_distillatingstill_button_1",    "rm_lab",                       { "use_button1", "use_button2" } }
  ,{ "clk_distillatingstill_button_2",    "rm_lab",                       { "use_button1", "use_button2" } }
  ,{ "win_distillatingstill",             "rm_lab",                       { "clk_distillatingstill_button_1", "clk_distillatingstill_button_2" } }
  ,{ "get_seal1",                         "rm_lab",                       { "win_distillatingstill" } }
  ,{ "get_dnainfinityamulet1",            "rm_lab",                       { "win_distillatingstill" } }
  ,{ "use_dnainfinityamulet1",            "rm_lab",                       { "get_dnainfinityamulet1" } }
  ,{ "get_filehandle",                    "rm_lab",                       { "use_dnainfinityamulet1" } }
  ,{ "use_filehandle",                    "rm_lowerlevel",                { "get_filehandle" } }
  ,{ "get_file",                          "rm_lowerlevel",                { "use_filehandle" } }
  ,{ "use_file",                          "rm_lowerlevel",                { "get_file" } }
  ,{ "get_pipepiece",                     "rm_lowerlevel",                { "use_file" } }
  ,{ "use_pipepiece",                     "rm_archives",                  { "get_pipepiece" } }
  ,{ "get_chip",                          "rm_archives",                  { "use_pipepiece" } }
  ,{ "use_chip",                          "rm_archives",                  { "get_chip" } }
  ,{ "get_videotape",                     "rm_archives",                  { "use_chip" } }
  ,{ "clk_videotape" }
  ,{ "get_dnainfinityamulet2" }
  ,{ "use_dnainfinityamulet2",            "rm_lab",                       { "get_dnainfinityamulet2" } }
  ,{ "get_fridgehandle4",                 "rm_lab",                       { "use_dnainfinityamulet2" } }
  ,{ "use_fridgehandle4",                 "rm_lowerlevel",                { "get_fridgehandle4" } }
  ,{ "get_hint",                          "rm_lowerlevel",                { "use_fridgehandle4" } }
  ,{ "get_seal2",                         "rm_lowerlevel",                { "use_fridgehandle4" } }
  ,{ "use_hint",                          "rm_archives",                  { "get_hint" } }
  ,{ "win_videoplayer",                   "rm_archives",                  { "use_hint" } }
  ,{ "opn_archivedata" }
  ,{ "win_archivedata",                   "rm_archives",                  { "win_videoplayer" } }
  ,{ "use_seal1",                         "rm_archives",                  { "get_seal1", "get_mapsheet_2" }  }
  ,{ "use_seal2",                         "rm_archives",                  { "get_seal2", "get_mapsheet_2" } }
  ,{ "use_seal3",                         "rm_archives",                  { "win_archivedata", "get_mapsheet_2" } }
  ,{ "win_superpuzzle2",                  "rm_archives",                  { "use_seal1", "use_seal2", "use_seal3" } }
  ,{ "see_outro_lvl2",                    "rm_archives",                  { "win_superpuzzle2" } }

  ,{ "get_collect_item_2_1" }
  ,{ "get_collect_item_2_2" }
  ,{ "get_collect_item_2_3" }
  ,{ "get_collect_morph_item_2_1" }
  ,{ "get_collect_morph_item_2_2" }
  ,{ "get_collect_morph_item_2_3" }
  ,{ "get_collect_morph_item_2_4" }
  ,{ "get_collect_morph_item_2_5" }
  ,{ "get_collect_morph_item_2_6" }
  };
  
  game.progress_names = {};
  for i = 1, #game.progress_names_room do
    game.progress_names[ i ] = game.progress_names_room[ i ][ 1 ];
  end;

  game.relations = {};

  private.menu_moduls = {
    "rm_credits"
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {
      "rm_collectibles2",
      "rm_collectibles",
      "rm_achievements",
    }

    for i = 1, #menu_moduls_ce do

      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );

    end;

  end;

end;

--function private.TutorialSetParams ()
--
--  if not ng_global.progress[ "std" ][ "see_tutorial" ] then
--
--    ng_global.progress[ "std" ][ "see_tutorial" ] = {};
--    ng_global.progress[ "std" ][ "see_tutorial" ].done  = 0;
--    ng_global.progress[ "std" ][ "see_tutorial" ].start = 0;
--    ng_global.progress[ "std" ][ "see_tutorial" ].state = {};
--    ng_global.progress[ "std" ][ "see_tutorial" ].state.no  = 0;
--    ng_global.progress[ "std" ][ "see_tutorial" ].state.currentpage = "tutorial_page_1";
--    ng_global.progress[ "std" ][ "see_tutorial" ].func = function()
--      --
--    end;
--
--  end;
--
--end;