-- name=level2_inv
--*********************************************************************************************************************
function public.Init ()
  if port.isPortable() == 1 then
    port.InventoryPopupInit("level2_inv_hub");
    port.VideoResizeInRoom("level2_inv");
  end;
  private.hook_1_init();
  private.douglasthings_init();
  private.voodoodoll_init();
  private.registrationentries_init();
  private.flashlight_init();
  private.camera_init();
  private.patientsprofile_init();
  private.videotape_init();

  --------------------------------------------------------------------------------------------
  ObjMultiSet( { 
    { "spr_deploy_inv_hook_1_hookedrope",                     { event_mdown = private.get_hookedrope         } }, 
    { "spr_deploy_inv_douglasthings_douglascard",             { event_mdown = private.get_douglascard        } }, 
    { "spr_deploy_inv_douglasthings_hanky",                   { event_mdown = private.get_hanky              } }, 
    { "spr_deploy_inv_voodoodoll_lockpickset",                { event_mdown = private.get_lockpickset        } }, 
    { "spr_deploy_inv_registrationentries_douglasamulet",     { event_mdown = private.get_douglasamulet      } }, 
    { "obj_deploy_inv_flashlight_get_flashlight",             { event_mdown = private.get_workingflashlight  } }, 
    { "spr_deploy_inv_camera_bluewire",                       { event_mdown = private.get_bluewire           } }, 
    { "spr_deploy_inv_patientsprofile_scotchtapepiece",       { event_mdown = private.get_scotchtapepiece    } }, 
    { "spr_deploy_inv_videotape_dnainfinityamulet2",          { event_mdown = private.get_dnainfinityamulet2 } }, 
  } );

  --------------------------------------------------------------------------------------------

  -- sound on all inventory objects during dragging for conteiner inventory_hub

  local invRelationsHub2 = ObjGetRelations( "level2_inv_hub" );

  if invRelationsHub2.childs then
    
    for i = 1, #invRelationsHub2.childs, 1 do 
      
      local invCurrent = invRelationsHub2.childs[i];
      ObjSet( invCurrent, { event_startdrag = cmn.GetInvObjectSfx } );
      
    end;
    
  end;

end;
--*********************************************************************************************************************
function private.StringDivide ( string )  

  local table = { };
  local id = 1;
  local il = 1;

  for i = 1, string.len( string ) do

    if ( string.sub( string, i, i ) == "_" ) then

      table[ id ] = string.sub( string, il, i - 1 );
      il = i + 1;
      id = id + 1;

    end

    if ( i == string.len( string ) ) then

      table[id] = string.sub( string, il, i );
      il = i + 1;
      id = id + 1;

    end

  end

  return table;

end;
--*********************************************************************************************************************
function private.ObjIntersectCheck ( obj_to_apply, obj_to_check, obj_complex_inv )

  local obj_complex_inv = obj_complex_inv or "deploy_inv_"..private.StringDivide( obj_to_check )[4];  
  
  return interface.GetCurrentInv() == obj_complex_inv and ObjIntersect( obj_to_apply, obj_to_check );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** hook_1 *** () end;
--*********************************************************************************************************************
  function private.hook_1_init ()

    ObjSet( "obj_deploy_inv_hook_1_clk_rope_1", { event_mdown = private.clk_rope_1 } );
    ObjSet( "obj_deploy_inv_hook_1_clk_rope_2", { event_mdown = private.clk_rope_2 } );

    --------------------------------------------------------------------------------------------
    -- USE -------------------------------------------------------------------------------------
    common_impl.hint[ "use_rope_2" ] = {
        type = "use",
        inv_obj = "inv_rope_2",
        use_place = "obj_deploy_inv_hook_1_use_rope_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_hook_1",
        zz_gate = "inv_hook_1"
    };    
    local use_rope_2_inv = function ()
    
      interface.InventoryItemRemove( "inv_rope_2" );
    
    end;
    function use_rope_2_beg ()
      
      ObjDelete( "obj_deploy_inv_hook_1_use_rope_2" );

    end;
    function use_rope_2_end ()

      ObjSet( "spr_deploy_inv_hook_1_rope_2",     { alp = 1                     });
      ObjSet( "obj_deploy_inv_hook_1_clk_rope_1", { input = true, active = true });  

    end;
    cmn.AddSubscriber( "use_rope_2", use_rope_2_beg, "inv_hook_1" );
    cmn.AddSubscriber( "use_rope_2", use_rope_2_inv );
    cmn.AddSubscriber( "use_rope_2", use_rope_2_end, "inv_hook_1" );
    cmn.AddSubscriber( "use_rope_2_beg", use_rope_2_beg, "inv_hook_1" );
    cmn.AddSubscriber( "use_rope_2_inv", use_rope_2_inv );
    cmn.AddSubscriber( "use_rope_2_end", use_rope_2_end, "inv_hook_1" );

    --------------------------------------------------------------------------------------------
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_rope_1" ] = {
        type = "click",
        use_place = "obj_deploy_inv_hook_1_clk_rope_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_hook_1",
        zz_gate = "inv_hook_1"
    };
    function clk_rope_1_inv_beg ()

      ObjDelete( "obj_deploy_inv_hook_1_clk_rope_1" );

    end;
    function clk_rope_1_inv_end ()

      ObjSet( "spr_deploy_inv_hook_1_hookedrope", { pos_x = 126 , pos_y = -45   });
      ObjSet( "spr_deploy_inv_hook_1_hook_2",     { pos_x =  60 , pos_y = -10   }); 
      ObjSet( "obj_deploy_inv_hook_1_clk_rope_2", { input = true, active = true });  

    end;
    cmn.AddSubscriber( "clk_rope_1_inv_beg", clk_rope_1_inv_beg, "inv_hook_1" );
    cmn.AddSubscriber( "clk_rope_1_inv_end", clk_rope_1_inv_end, "inv_hook_1" );
    cmn.AddSubscriber( "clk_rope_1", clk_rope_1_inv_beg, "inv_hook_1" );
    cmn.AddSubscriber( "clk_rope_1", clk_rope_1_inv_end, "inv_hook_1" );

    --------------------------------------------------------------------------------------------
    
    common_impl.hint[ "clk_rope_2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_hook_1_clk_rope_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_hook_1",
        zz_gate = "inv_hook_1"
    };
    function clk_rope_2_inv_beg ()

      ObjDelete( "obj_deploy_inv_hook_1_clk_rope_2" );

    end;
    function clk_rope_2_inv_end ()

      ObjDelete( "spr_deploy_inv_hook_1_rope" );
      ObjSet( "spr_deploy_inv_hook_1_rope_3",     { alp = 1       });
      ObjSet( "spr_deploy_inv_hook_1_hookedrope", { input = true  });

    end;
    cmn.AddSubscriber( "clk_rope_2_inv_beg", clk_rope_2_inv_beg, "inv_hook_1" );
    cmn.AddSubscriber( "clk_rope_2_inv_end", clk_rope_2_inv_end, "inv_hook_1" );
    cmn.AddSubscriber( "clk_rope_2", clk_rope_2_inv_beg, "inv_hook_1" );
    cmn.AddSubscriber( "clk_rope_2", clk_rope_2_inv_end, "inv_hook_1" );

    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------

    common_impl.hint[ "get_hookedrope" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_hook_1_hookedrope",
        room = "int_deploy_inv",
        zz = "deploy_inv_hook_1",
        zz_gate = "inv_hook_1"
    };

    function get_hookedrope_inv ()

      interface.InventoryItemAdd( "inv_hookedrope", "obj_deploy_inv_hook_1" );
      interface.InventoryItemRemove( "inv_hook_1" );

    end;
    function get_hookedrope_inv_zz ()

      ObjDelete( "gfx_deploy_inv_hook_1_hookedrope" );

    end;
    cmn.AddSubscriber( "get_hookedrope", get_hookedrope_inv );
    cmn.AddSubscriber( "get_hookedrope", get_hookedrope_inv_zz, "inv_hook_1" );
    --------------------------------------------------------------------------------------------

  end;

  ----------------------------------------------------------------------------------------------
  -- USE ---------------------------------------------------------------------------------------
  function public.use_rope_2 ()

    local item = "inv_rope_2";

    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_hook_1_use_rope_2", "deploy_inv_hook_1" ) )  then

      cmn.CallEventHandler( "use_rope_2_beg", "inv_hook_1" );
      cmn.CallEventHandler( "use_rope_2_inv" );

      local func_end = function ()
       
        cmn.Lock( false );
        cmn.SetEventDone( "use_rope_2" );
        cmn.CallEventHandler( "use_rope_2_end", "inv_hook_1" );
        
      end;

      cmn.Lock( true );

      common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_rope", 0, "", 0 );

      common_impl.ItemFly( "spr_deploy_inv_hook_1_rope_2", func_end, -2.3 );

      return true;  

    end;

    return false;

  end;

  ----------------------------------------------------------------------------------------------
  -- CLK -------------------------------------------------------------------------------------
  function private.clk_rope_1 ()

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "clk_rope_1" );
      cmn.CallEventHandler( "clk_rope_1_inv_end", "inv_hook_1" );
    
    end;
  
    cmn.Lock( true );

    cmn.CallEventHandler( "clk_rope_1_inv_beg", "inv_hook_1" );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_hook", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_hook_1_hookedrope", "pos_xy", 0, 0, func_end, 
    { 
      0.0, 0, 102, -167,
      0.8, 0, 338, -247,
      1.5, 2, 126, -45 
    } );
    ObjAnimate( "spr_deploy_inv_hook_1_hook_2", "pos_xy", 0, 0, "", 
    { 
      0.0, 0,  34, -126,
      0.8, 0, 271, -211,
      1.5, 2,  60, -10 
    } );

  end;

  ----------------------------------------------------------------------------------------------
  function private.clk_rope_2 ()

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "clk_rope_2" );
      cmn.CallEventHandler( "clk_rope_2_inv_end", "inv_hook_1" );
    
    end;
  
    cmn.Lock( true );

    cmn.CallEventHandler( "clk_rope_2_inv_beg", "inv_hook_1" );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_rope", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_hook_1_rope", "alp", 0, 0, "", 
    { 
      0.0, 0, 1,
      0.6, 0, 0,  
    } );
    ObjAnimate( "spr_deploy_inv_hook_1_rope_3", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0,
      0.6, 0, 1,  
    } );

  end;
  ----------------------------------------------------------------------------------------------
  -- GET -------------------------------------------------------------------------------------
  function private.get_hookedrope ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_hookedrope" );
    cmn.CallEventHandler( "get_hookedrope", "inv_hook_1" );
    
    --if ( cmn.IsEventDone( "get_glasspiece" ) and  cmn.IsEventDone( "get_triangle1" ) ) then

    common_impl.HideDeployInv();          

    --end;

  end;
  -- CLK -------------------------------------------------------------------------------------

--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** douglasthings *** () end;
--*********************************************************************************************************************
  function private.douglasthings_init ()

    ObjSet( "obj_deploy_inv_douglasthings_clk_pocket_1", { event_mdown = private.clk_pocket_1 } );
    ObjSet( "obj_deploy_inv_douglasthings_clk_pocket_2", { event_mdown = private.clk_pocket_2 } );
    ObjSet( "obj_deploy_inv_douglasthings_clk_pocket_3", { event_mdown = private.clk_pocket_3 } );
    ObjSet( "obj_deploy_inv_douglasthings_clk_pocket_4", { event_mdown = private.clk_pocket_4 } );

  --------------------------------------------------------------------------------------------
  -- CLK -------------------------------------------------------------------------------------
    function clk_pocket_1_inv_beg ()

      ObjDelete( "obj_deploy_inv_douglasthings_clk_pocket_1" );

    end;
    function clk_pocket_1_inv_end ()
      
      ObjSet( "spr_deploy_inv_douglasthings_lining", { alp = 1 });

    end;
    cmn.AddSubscriber( "clk_pocket_1_inv_beg", clk_pocket_1_inv_beg, "inv_douglasthings" );
    cmn.AddSubscriber( "clk_pocket_1_inv_end", clk_pocket_1_inv_end, "inv_douglasthings" );
    cmn.AddSubscriber( "clk_pocket_1", clk_pocket_1_inv_beg, "inv_douglasthings" );
    cmn.AddSubscriber( "clk_pocket_1", clk_pocket_1_inv_end, "inv_douglasthings" );
  --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_pocket_2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_douglasthings_clk_pocket_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_douglasthings",
        zz_gate = "inv_douglasthings"
    };
    function clk_pocket_2_inv_beg ()

      ObjDelete( "obj_deploy_inv_douglasthings_clk_pocket_2" );

    end;
    function clk_pocket_2_inv_end ()
 
      ObjSet( "spr_deploy_inv_douglasthings_douglascard", { alp = 1, input = true });
      ObjSet( "gfx_deploy_inv_douglasthings_douglascard", { active = true         });

    end;
    cmn.AddSubscriber( "clk_pocket_2_inv_beg", clk_pocket_2_inv_beg, "inv_douglasthings" );
    cmn.AddSubscriber( "clk_pocket_2_inv_end", clk_pocket_2_inv_end, "inv_douglasthings" );
    cmn.AddSubscriber( "clk_pocket_2", clk_pocket_2_inv_beg, "inv_douglasthings" );
    cmn.AddSubscriber( "clk_pocket_2", clk_pocket_2_inv_end, "inv_douglasthings" );
    --------------------------------------------------------------------------------------------
    function clk_pocket_3_inv_beg ()

      ObjDelete( "obj_deploy_inv_douglasthings_clk_pocket_3" );

    end;
    function clk_pocket_3_inv_end ()
 
      ObjSet( "spr_deploy_inv_douglasthings_right_pocket_open", { alp = 1 });
      ObjDelete( "spr_deploy_inv_douglasthings_right_pocket" );

    end;
    cmn.AddSubscriber( "clk_pocket_3_inv_beg", clk_pocket_3_inv_beg, "inv_douglasthings" );
    cmn.AddSubscriber( "clk_pocket_3_inv_end", clk_pocket_3_inv_end, "inv_douglasthings" );
    cmn.AddSubscriber( "clk_pocket_3", clk_pocket_3_inv_beg, "inv_douglasthings" );
    cmn.AddSubscriber( "clk_pocket_3", clk_pocket_3_inv_end, "inv_douglasthings" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_pocket_4" ] = {
        type = "click",
        use_place = "obj_deploy_inv_douglasthings_clk_pocket_4",
        room = "int_deploy_inv",
        zz = "deploy_inv_douglasthings",
        zz_gate = "inv_douglasthings"
    };
    function clk_pocket_4_inv_beg ()

      ObjDelete( "obj_deploy_inv_douglasthings_clk_pocket_4" );

    end;
    function clk_pocket_4_inv_end ()
 
      ObjSet( "spr_deploy_inv_douglasthings_hanky",            { alp = 1, input = true });
      ObjSet( "gfx_deploy_inv_douglasthings_hanky",            { active = true         });
      ObjSet( "spr_deploy_inv_douglasthings_left_pocket_open", { alp = 1               });

      ObjDelete( "spr_deploy_inv_douglasthings_left_pocket"  );

    end;
    cmn.AddSubscriber( "clk_pocket_4_inv_beg", clk_pocket_4_inv_beg, "inv_douglasthings" );
    cmn.AddSubscriber( "clk_pocket_4_inv_end", clk_pocket_4_inv_end, "inv_douglasthings" );
    cmn.AddSubscriber( "clk_pocket_4", clk_pocket_4_inv_beg, "inv_douglasthings" );
    cmn.AddSubscriber( "clk_pocket_4", clk_pocket_4_inv_end, "inv_douglasthings" );

    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_douglascard" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_douglasthings_douglascard",
        room = "int_deploy_inv",
        zz = "deploy_inv_douglasthings",
        zz_gate = "inv_douglasthings"
    };
    function get_douglascard_inv ()

      interface.InventoryItemAdd( "inv_douglascard", "spr_deploy_inv_douglasthings_douglascard" );

      if ( cmn.IsEventDone( "get_hanky" ) ) then

        interface.InventoryItemRemove( "inv_douglasthings" );

        if not cmn.IsEventDone( "clk_pocket_1" ) then

          cmn.SetEventDone( "clk_pocket_1" );

        end;

        if not cmn.IsEventDone( "clk_pocket_3" ) then

          cmn.SetEventDone( "clk_pocket_3" );

        end;

      end;

    end;
    function get_douglascard_inv_zz ()

      ObjDelete( "gfx_deploy_inv_douglasthings_douglascard" );

    end;
    cmn.AddSubscriber( "get_douglascard", get_douglascard_inv );
    cmn.AddSubscriber( "get_douglascard", get_douglascard_inv_zz, "inv_douglasthings" );

    --------------------------------------------------------------------------------------------

    common_impl.hint[ "get_hanky" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_douglasthings_hanky",
        room = "int_deploy_inv",
        zz = "deploy_inv_douglasthings",
        zz_gate = "inv_douglasthings"
    };
    function get_hanky_inv ()

      interface.InventoryItemAdd( "inv_hanky", "spr_deploy_inv_douglasthings_hanky_full" );

      if ( cmn.IsEventDone( "get_douglascard" ) ) then

        interface.InventoryItemRemove( "inv_douglasthings" );

        if not cmn.IsEventDone( "clk_pocket_1" ) then

          cmn.SetEventDone( "clk_pocket_1" );

        end;

        if not cmn.IsEventDone( "clk_pocket_3" ) then

          cmn.SetEventDone( "clk_pocket_3" );

        end;

      end;

    end;
    function get_hanky_inv_zz ()

      ObjSet( "spr_deploy_inv_douglasthings_hanky_full", { alp = 1 } );
      ObjDelete( "spr_deploy_inv_douglasthings_hanky" );

    end;
    cmn.AddSubscriber( "get_hanky", get_hanky_inv );
    cmn.AddSubscriber( "get_hanky", get_hanky_inv_zz, "inv_douglasthings" );
    --------------------------------------------------------------------------------------------

  end;

  -- CLK -------------------------------------------------------------------------------------
  function private.clk_pocket_1 ()

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "clk_pocket_1" );
      cmn.CallEventHandler( "clk_pocket_1_inv_end", "inv_douglasthings" );
    
    end;
  
    cmn.Lock( true );
    cmn.CallEventHandler( "clk_pocket_1_inv_beg", "inv_douglasthings" );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_pocket", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_douglasthings_lining", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0,
      0.3, 0, 1,  
    } );

  end;
  --------------------------------------------------------------------------------------------
  function private.clk_pocket_2 ()

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "clk_pocket_2" );
      cmn.CallEventHandler( "clk_pocket_2_inv_end", "inv_douglasthings" );
    
    end;
  
    cmn.Lock( true );
    cmn.CallEventHandler( "clk_pocket_2_inv_beg", "inv_douglasthings" );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_pocket", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_douglasthings_douglascard", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0,
      0.3, 0, 1,  
    } );

  end;
  --------------------------------------------------------------------------------------------
  function private.clk_pocket_3 ()

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "clk_pocket_3" );
      cmn.CallEventHandler( "clk_pocket_3_inv_end", "inv_douglasthings" );
    
    end;
  
    cmn.Lock( true );
    cmn.CallEventHandler( "clk_pocket_3_inv_beg", "inv_douglasthings" );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_pocket", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_douglasthings_right_pocket", "alp", 0, 0, "", 
    { 
      0.0, 0, 1,
      0.3, 0, 0,  
    } );
    ObjAnimate( "spr_deploy_inv_douglasthings_right_pocket_open", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0,
      0.3, 0, 1,  
    } );

  end;
  --------------------------------------------------------------------------------------------
  function private.clk_pocket_4 ()

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "clk_pocket_4" );
      cmn.CallEventHandler( "clk_pocket_4_inv_end", "inv_douglasthings" );
    
    end;
  
    cmn.Lock( true );
    cmn.CallEventHandler( "clk_pocket_4_inv_beg", "inv_douglasthings" );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_pocket", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_douglasthings_left_pocket", "alp", 0, 0, "", 
    { 
      0.0, 0, 1,
      0.3, 0, 0,  
    } );
    ObjAnimate( "spr_deploy_inv_douglasthings_left_pocket_open", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0,
      0.3, 0, 1,  
    } );

  end;

  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- GET -------------------------------------------------------------------------------------
  function private.get_douglascard ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_douglascard" );
    cmn.CallEventHandler( "get_douglascard", "inv_douglasthings" );
    
    if ( cmn.IsEventDone( "get_hanky" ) ) then

      common_impl.HideDeployInv();          

    end;

    if ( GetCurrentRoom() == "rm_corridorelevator" ) then

      common_impl.HideDeployInv();

      rm_corridorelevator.see_flashback_douglas();

    end;

  end;

  --------------------------------------------------------------------------------------------

  function private.get_hanky ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_hanky" );
    cmn.CallEventHandler( "get_hanky", "inv_douglasthings" );
    
    if ( cmn.IsEventDone( "get_douglascard" ) ) then

      common_impl.HideDeployInv();          

    end;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** voodoodoll *** () end;
--*********************************************************************************************************************
  function private.voodoodoll_init ()

    ObjMultiSet({ 
      { "spr_deploy_inv_voodoodoll_pin_1",       { event_mdown = private.clk_voodoodollpin_1      }},
      { "obj_deploy_inv_voodoodoll_clk_pin_all", { event_mdown = private.clk_voodoodollpin_all    }},
      { "obj_deploy_inv_voodoodoll_get_pin",     { event_mdown = private.get_lockpickset          }},
    });

  --------------------------------------------------------------------------------------------
  -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_voodoodollpin_1" ] = {
        type = "click",
        use_place = "spr_deploy_inv_voodoodoll_pin_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_voodoodoll",
        zz_gate = "inv_voodoodoll"
    };
    function clk_voodoodollpin_1_inv_beg ()

    end;
    function clk_voodoodollpin_1_inv_end ()
      
      ObjDelete( "spr_deploy_inv_voodoodoll_pin_1_shadow" );
      ObjDelete( "spr_deploy_inv_voodoodoll_pin_1"        );

      ObjMultiSet({ 
        { "spr_deploy_inv_voodoodoll_pin_key_1",   { alp = 1               }},
        { "obj_deploy_inv_voodoodoll_clk_pin_all", { alp = 1, input = true }},
      });

    end;
    cmn.AddSubscriber( "clk_voodoodollpin_1_inv_beg", clk_voodoodollpin_1_inv_beg, "inv_voodoodoll" );
    cmn.AddSubscriber( "clk_voodoodollpin_1_inv_end", clk_voodoodollpin_1_inv_end, "inv_voodoodoll" );
    cmn.AddSubscriber( "clk_voodoodollpin_1",         clk_voodoodollpin_1_inv_beg, "inv_voodoodoll" );
    cmn.AddSubscriber( "clk_voodoodollpin_1",         clk_voodoodollpin_1_inv_end, "inv_voodoodoll" );


--------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_voodoodollpin_all" ] = {
        type = "click",
        use_place = "obj_deploy_inv_voodoodoll_clk_pin_all",
        room = "int_deploy_inv",
        zz = "deploy_inv_voodoodoll",
        zz_gate = "inv_voodoodoll"
    };
    function clk_voodoodollpin_all_inv_beg ()

      ObjDelete( "obj_deploy_inv_voodoodoll_clk_pin_all" );

    end;
    function clk_voodoodollpin_all_inv_end ()

      ObjMultiSet({ 
        { "spr_deploy_inv_voodoodoll_pin_key_1", { res = "assets/levels/level2/inv_deploy/inv_voodoodoll/layers/pin_key_9" }},
        { "obj_deploy_inv_voodoodoll_get_pin"  , { input = true }}
      });

    end;
    cmn.AddSubscriber( "clk_voodoodollpin_all_inv_beg", clk_voodoodollpin_all_inv_beg, "inv_voodoodoll" );
    cmn.AddSubscriber( "clk_voodoodollpin_all_inv_end", clk_voodoodollpin_all_inv_end, "inv_voodoodoll" );
    cmn.AddSubscriber( "clk_voodoodollpin_all",         clk_voodoodollpin_all_inv_beg, "inv_voodoodoll" );
    cmn.AddSubscriber( "clk_voodoodollpin_all",         clk_voodoodollpin_all_inv_end, "inv_voodoodoll" );
    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_lockpickset" ] = {
        type = "get",
        get_obj = "obj_deploy_inv_voodoodoll_get_pin",
        room = "int_deploy_inv",
        zz = "deploy_inv_voodoodoll",
        zz_gate = "inv_voodoodoll"
    };
    function get_lockpickset_inv ()

      interface.InventoryItemAdd( "inv_lockpickset", "obj_deploy_inv_voodoodoll_get_pin" );
      interface.InventoryItemRemove( "inv_voodoodoll" );

    end;
    function get_lockpickset_inv_zz ()

      ObjDelete( "gfx_deploy_inv_voodoodoll_lockpickset" );

    end;
    cmn.AddSubscriber( "get_lockpickset", get_lockpickset_inv );
    cmn.AddSubscriber( "get_lockpickset", get_lockpickset_inv_zz, "inv_voodoodoll" );

    --------------------------------------------------------------------------------------------

  end;

  -- CLK -------------------------------------------------------------------------------------

  function private.clk_voodoodollpin_1 ()

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "clk_voodoodollpin_1" );
      cmn.CallEventHandler( "clk_voodoodollpin_1_inv_end", "inv_voodoodoll" );
    
    end;
  
    cmn.Lock( true );
    cmn.CallEventHandler( "clk_voodoodollpin_1_inv_beg", "inv_voodoodoll" );

    ObjAnimate( "spr_deploy_inv_voodoodoll_pin_1", "pos_xy", 0, 0, "", 
    { 
      0.0, 0,  -8, -123,
      0.6, 0, -83, -184,  
    } );
    ObjAnimate( "spr_deploy_inv_voodoodoll_pin_1_shadow", "alp", 0, 0, "", 
    { 
      0.0, 0, 1,
      0.6, 0, 0,  
    } );

    ObjAnimate( "spr_deploy_inv_voodoodoll_pin_1", "alp", 0, 0, "", 
    { 
      0.0, 0, 1,
      0.6, 0, 1,
      0.9, 0, 0,   
    } );
    ObjAnimate( "spr_deploy_inv_voodoodoll_pin_key_1", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0,
      0.6, 0, 0,
      0.9, 0, 1,   
    } );

  end;

  --------------------------------------------------------------------------------------------
  function private.clk_voodoodollpin_all ()

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "clk_voodoodollpin_all" );
      cmn.CallEventHandler( "clk_voodoodollpin_all_inv_end", "inv_voodoodoll" );
    
    end;
  
    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_clip", 0, "", 0 );
    cmn.CallEventHandler( "clk_voodoodollpin_all_inv_beg", "inv_voodoodoll" );

    func_end();

  end;

  --------------------------------------------------------------------------------------------
  -- GET -------------------------------------------------------------------------------------
  function private.get_lockpickset ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_lockpickset" );
    cmn.CallEventHandler( "get_lockpickset", "inv_voodoodoll" );
    
    common_impl.HideDeployInv();          

  end;

  --------------------------------------------------------------------------------------------
  -- ANIM ------------------------------------------------------------------------------------
  function private.anim_clk_voodoodollpin_2 ()

    local func_end = function ()

      cmn.Lock( false );

    end;

    cmn.Lock( true );

    ObjAnimate( "spr_deploy_inv_voodoodoll_pin_2", "pos_xy", 0, 0, func_end, 
    { 
      0.0, 0, 31, -178,
      0.3, 0, 27, -188,
      0.6, 0, 31, -178,  
    } );
    
  end;
  --------------------------------------------------------------------------------------------
  function private.anim_clk_voodoodollpin_3 ()

    local func_end = function ()

      cmn.Lock( false );

    end;

    cmn.Lock( true );

    ObjAnimate( "spr_deploy_inv_voodoodoll_pin_3", "pos_xy", 0, 0, func_end, 
    { 
      0.0, 0, 155, -125,
      0.3, 0, 159, -132,
      0.6, 0, 155, -125,  
    } );

  end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------

--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** registrationentries *** () end;
--*********************************************************************************************************************
  function private.registrationentries_init ()

    ObjSet( "obj_deploy_inv_registrationentries_clk_registrationentries",     { event_mdown = private.clk_registrationentries } );
    --------------------------------------------------------------------------------------------
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_registrationentries" ] = {
        type = "click",
        use_place = "obj_deploy_inv_registrationentries_clk_registrationentries",
        room = "int_deploy_inv",
        zz = "deploy_inv_registrationentries",
        zz_gate = "inv_registrationentries"
    };
    function clk_registrationentries_beg ()

      ObjDelete( "obj_deploy_inv_registrationentries_clk_registrationentries" )

    end;
    function clk_registrationentries_end ()

      ObjSet( "spr_deploy_inv_registrationentries_page", { alp = 1 } );
      ObjDelete( "spr_deploy_inv_registrationentries_cover" );
      ObjSet( "spr_deploy_inv_registrationentries_douglasamulet",  { alp = 1, input = true, active = true } );
      ObjSet( "obj_deploy_inv_registrationentries_bbt_registrationentries", { input = true, active = true } );
 
    end;
    cmn.AddSubscriber( "clk_registrationentries_beg", clk_registrationentries_beg, "inv_registrationentries" );
    cmn.AddSubscriber( "clk_registrationentries_end", clk_registrationentries_end, "inv_registrationentries" );
    cmn.AddSubscriber( "clk_registrationentries", clk_registrationentries_beg, "inv_registrationentries" );
    cmn.AddSubscriber( "clk_registrationentries", clk_registrationentries_end, "inv_registrationentries" );
    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_douglasamulet" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_registrationentries_douglasamulet",
        room = "int_deploy_inv",
        zz = "deploy_inv_registrationentries",
        zz_gate = "inv_registrationentries"
    };
    function get_douglasamulet_inv ()

      interface.InventoryItemAdd( "inv_douglasamulet", "spr_deploy_inv_registrationentries_douglasamulet" );
      interface.InventoryItemRemove( "inv_registrationentries" );

    end;
    function get_douglasamulet_inv_zz ()

      ObjDelete( "gfx_deploy_inv_registrationentries_douglasamulet" );

    end;
    cmn.AddSubscriber( "get_douglasamulet", get_douglasamulet_inv );
    cmn.AddSubscriber( "get_douglasamulet", get_douglasamulet_inv_zz, "inv_registrationentries" );

    --------------------------------------------------------------------------------------------

  end;
  --------------------------------------------------------------------------------------------
  ---CLK--------------------------------------------------------------------------------------
  function private.clk_registrationentries()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );

      cmn.CallEventHandler( "clk_registrationentries_end", "inv_registrationentries" );
      cmn.SetEventDone( "clk_registrationentries" );

    end;

    cmn.CallEventHandler( "clk_registrationentries_beg", "inv_registrationentries" );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_book", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_registrationentries_cover", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 1, 
      0.3, 0, 0 
    } );
    
    ObjAnimate( "spr_deploy_inv_registrationentries_page", "alp", 0, 0, "", 
    { 
      0.0, 0, 0, 
      0.3, 0, 1 
    } );

    ObjAnimate( "spr_deploy_inv_registrationentries_douglasamulet", "alp", 0, 0, "", 
    { 
      0.0, 0, 0, 
      0.3, 0, 1 
    } );

  end;
  -- GET -------------------------------------------------------------------------------------
  function private.get_douglasamulet ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_douglasamulet" );
    cmn.CallEventHandler( "get_douglasamulet", "inv_registrationentries" );
    
    --common_impl.HideDeployInv();          

  end;

  --------------------------------------------------------------------------------------------

--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** flashlight *** () end;
--*********************************************************************************************************************
  function private.flashlight_init ()

    ObjSet( "obj_deploy_inv_flashlight_clk_button",     { event_mdown = private.clk_button_flashlight } );
    ObjSet( "obj_deploy_inv_flashlight_clk_lock_open",  { event_mdown = private.clk_flashlight_open } );
    ObjSet( "obj_deploy_inv_flashlight_clk_lock_close", { event_mdown = private.clk_flashlight_close } );

    --------------------------------------------------------------------------------------------
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_flashlight_open" ] = {
        type = "click",
        use_place = "obj_deploy_inv_flashlight_clk_lock_open",
        room = "int_deploy_inv",
        zz = "deploy_inv_flashlight",
        zz_gate = "inv_flashlight"
    };
    function clk_flashlight_open_beg ()

      ObjDelete( "obj_deploy_inv_flashlight_clk_lock_open" )

    end;
    function clk_flashlight_open_end ()

      ObjSet( "spr_deploy_inv_flashlight_open_door", { alp = 1 } );
      ObjSet( "obj_deploy_inv_flashlight_closed_door", { alp = 0 } );
      ObjSet( "obj_deploy_inv_flashlight_use_battery1_2", { input = true, active = true } );
      ObjSet( "obj_deploy_inv_flashlight_use_battery2_2", { input = true, active = true } );
      ObjSet( "obj_deploy_inv_flashlight_clk_button", { input = false, active = false } );
      ObjSet( "obj_deploy_inv_flashlight_use_battery_2", { input = true } );

    end;
    cmn.AddSubscriber( "clk_flashlight_open_beg", clk_flashlight_open_beg, "inv_flashlight" );
    cmn.AddSubscriber( "clk_flashlight_open_end", clk_flashlight_open_end, "inv_flashlight" );
    cmn.AddSubscriber( "clk_flashlight_open", clk_flashlight_open_beg, "inv_flashlight" );
    cmn.AddSubscriber( "clk_flashlight_open", clk_flashlight_open_end, "inv_flashlight" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_flashlight_close" ] = {
        type = "click",
        use_place = "obj_deploy_inv_flashlight_clk_lock_close",
        room = "int_deploy_inv",
        zz = "deploy_inv_flashlight",
        zz_gate = "inv_flashlight"
    };
    function clk_flashlight_close_beg ()

      ObjDelete( "obj_deploy_inv_flashlight_clk_lock_close" )

    end;
    function clk_flashlight_close_end ()

      ObjSet( "spr_deploy_inv_flashlight_open_door", { alp = 0 } );
      ObjSet( "obj_deploy_inv_flashlight_closed_door", { alp = 1 } );
      ObjSet( "obj_deploy_inv_flashlight_clk_button", { input = true, active = true } );

    end;
    cmn.AddSubscriber( "clk_flashlight_close_beg", clk_flashlight_close_beg, "inv_flashlight" );
    cmn.AddSubscriber( "clk_flashlight_close_end", clk_flashlight_close_end, "inv_flashlight" );
    cmn.AddSubscriber( "clk_flashlight_close", clk_flashlight_close_beg, "inv_flashlight" );
    cmn.AddSubscriber( "clk_flashlight_close", clk_flashlight_close_end, "inv_flashlight" );
     --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_button_flashlight" ] = {
        type = "click",
        use_place = "obj_deploy_inv_flashlight_clk_button",
        room = "int_deploy_inv",
        zz = "deploy_inv_flashlight",
        zz_gate = "inv_flashlight"
    };
    function clk_button_flashlight_beg ()

      ObjDelete( "obj_deploy_inv_flashlight_clk_button" )

    end;
    function clk_button_flashlight_end ()

      ObjSet( "spr_deploy_inv_flashlight_light", { alp = 1 } );
      ObjSet( "obj_deploy_inv_flashlight_get_flashlight", { input = true, active = true } );
      ObjSet( "gfx_deploy_inv_flashlight_hookedrope_clone", { active = true } );

    end;
    cmn.AddSubscriber( "clk_button_flashlight_beg", clk_button_flashlight_beg, "inv_flashlight" );
    cmn.AddSubscriber( "clk_button_flashlight_end", clk_button_flashlight_end, "inv_flashlight" );
    cmn.AddSubscriber( "clk_button_flashlight", clk_button_flashlight_beg, "inv_flashlight" );
    cmn.AddSubscriber( "clk_button_flashlight", clk_button_flashlight_end, "inv_flashlight" );
    --------------------------------------------------------------------------------------------
    -- USE -------------------------------------------------------------------------------------
    common_impl.hint[ "use_battery_2" ] = {
        type = "use",
        inv_obj = "inv_battery",
        use_place = "obj_deploy_inv_flashlight_use_battery_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_flashlight",
        zz_gate = "inv_flashlight"
    };    
    local use_battery_2_inv = function ()
    
      interface.InventoryItemRemove( "inv_battery" );
    
    end;
    function use_battery_2_beg ()
      
      ObjDelete( "obj_deploy_inv_flashlight_use_battery_2" );

    end;
    function use_battery_2_end ()

      ObjSet( "spr_deploy_inv_flashlight_battery_1", { alp = 1 } );
      ObjSet( "spr_deploy_inv_flashlight_battery_2", { alp = 1 } );

      ObjSet( "obj_deploy_inv_flashlight_clk_lock_close", { input = true  } );

    end;
    cmn.AddSubscriber( "use_battery_2", use_battery_2_beg );
    cmn.AddSubscriber( "use_battery_2", use_battery_2_inv );
    cmn.AddSubscriber( "use_battery_2", use_battery_2_end, "inv_flashlight" );
    cmn.AddSubscriber( "use_battery_2_beg", use_battery_2_beg );
    cmn.AddSubscriber( "use_battery_2_inv", use_battery_2_inv, "inv_flashlight" );
    cmn.AddSubscriber( "use_battery_2_end", use_battery_2_end, "inv_flashlight" );
    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_workingflashlight" ] = {
        type = "get",
        get_obj = "obj_deploy_inv_flashlight_closed_door",
        room = "int_deploy_inv",
        zz = "deploy_inv_flashlight",
        zz_gate = "inv_flashlight"
    };
    function get_workingflashlight_inv ()

      interface.InventoryItemAdd( "inv_workingflashlight", "obj_deploy_inv_flashlight_closed_door" );
      interface.InventoryItemRemove( "inv_flashlight" );

    end;
    function get_workingflashlight_inv_zz ()


      ObjDelete( "spr_deploy_inv_flashlight_closed_door" );
      ObjDelete( "spr_deploy_inv_flashlight_body" );
      ObjDelete( "gfx_deploy_inv_flashlight_workingflashlight" );

    end;
    cmn.AddSubscriber( "get_workingflashlight", get_workingflashlight_inv );
    cmn.AddSubscriber( "get_workingflashlight", get_workingflashlight_inv_zz, "inv_flashlight" );
    --------------------------------------------------------------------------------------------

  end;
  -- CLK ---------------------------------------------------------------------------------------
  function private.clk_button_flashlight()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );

      cmn.CallEventHandler( "clk_button_flashlight_end", "inv_flashlight" );
      cmn.SetEventDone( "clk_button_flashlight" );

    end;

    local func_continue = function ()

      if ( cmn.IsEventDone( "clk_flashlight_close" ) ) then

        cmn.CallEventHandler( "clk_button_flashlight_beg", "inv_flashlight" );
        ObjAnimate( "spr_deploy_inv_flashlight_light", "alp", 0, 0, func_end, { 0, 0, 0, 0.2, 3, 1 } );

      else

        cmn.Lock( false );

      end;

    end;

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk6", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_flashlight_button", "pos_x", 0, 0, func_continue, 
    { 
      0.0, 0, 152, 
      0.1, 0, 148, 
      0.2, 0, 152 
    } );

  end;  
  --------------------------------------------------------------------------------------------
  function private.clk_flashlight_open()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );

      cmn.CallEventHandler( "clk_flashlight_open_end", "inv_flashlight" );
      cmn.SetEventDone( "clk_flashlight_open" );

    end;

    cmn.CallEventHandler( "clk_flashlight_open_beg", "inv_flashlight" );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_flashlight_open_door", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0, 
      0.1, 0, 0, 
      0.3, 0, 1 
    } );
    
    ObjAnimate( "obj_deploy_inv_flashlight_closed_door", "alp", 0, 0, "", 
    { 
      0.0, 0, 1, 
      0.3, 0, 0 
    } );

  end;
  --------------------------------------------------------------------------------------------
  function private.clk_flashlight_close()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );

      cmn.CallEventHandler( "clk_flashlight_close_end", "inv_flashlight" );
      cmn.SetEventDone( "clk_flashlight_close" );

    end;

    cmn.CallEventHandler( "clk_flashlight_close_beg", "inv_flashlight" );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_flashlight_open_door", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 1, 
      0.3, 0, 0 
    } );
    
    ObjAnimate( "obj_deploy_inv_flashlight_closed_door", "alp", 0, 0, "", 
    { 
      0.0, 0, 0, 
      0.1, 0, 0,
      0.3, 0, 1 
    } );

  end;
  -- USE ---------------------------------------------------------------------------------------
  function public.use_battery_2 ()

    local item = "inv_battery";

    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_flashlight_use_battery_2", "deploy_inv_flashlight" ) ) and ( cmn.IsEventDone( "clk_flashlight_open" ) )  then

      cmn.CallEventHandler( "use_battery_2_beg", "inv_flashlight" );
      cmn.CallEventHandler( "use_battery_2_inv", "inv_flashlight" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_battery_2" );
        cmn.CallEventHandler( "use_battery_2_end", "inv_flashlight" );
        
      end;

      cmn.Lock( true );

      cmn.ItemFly( "spr_deploy_inv_flashlight_battery_1", func_end, 2.4 );
      cmn.ItemFly( "spr_deploy_inv_flashlight_battery_2", nil, 3.14 );

      return true;  

    end;

    return false;

  end;
  -- GET -------------------------------------------------------------------------------------
  function private.get_workingflashlight ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_workingflashlight" );
    cmn.CallEventHandler( "get_workingflashlight", "inv_flashlight" );
    
    --if ( cmn.IsEventDone( "get_glasspiece" ) and  cmn.IsEventDone( "get_triangle1" ) ) then

    common_impl.HideDeployInv();          

    --end;

  end;

--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** camera *** () end;
--*********************************************************************************************************************
  function private.camera_init ()
    ObjSet( "obj_deploy_inv_camera_clk_button", { event_mdown = private.clk_camera_button } );
    --------------------------------------------------------------------------------------------
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_camera_button" ] = {
        type = "click",
        use_place = "obj_deploy_inv_camera_clk_button",
        room = "int_deploy_inv",
        zz = "deploy_inv_camera",
        zz_gate = "inv_camera"
    };
    function clk_camera_button_inv_beg ()

      ObjDelete( "obj_deploy_inv_camera_clk_button" )

    end;
    function clk_camera_button_inv_end ()

      ObjSet( "spr_deploy_inv_camera_button", { pos_x = -30, pos_y = -68 } );
      ObjSet( "spr_deploy_inv_camera_camera_cover", { pos_x = -109, pos_y = 75, input = true } );
      ObjSet( "spr_deploy_inv_camera_bluewire", { input = true, active = true } );

    end;
    cmn.AddSubscriber( "clk_camera_button_inv_beg", clk_camera_button_inv_beg, "inv_camera" );
    cmn.AddSubscriber( "clk_camera_button_inv_end", clk_camera_button_inv_end, "inv_camera" );
    cmn.AddSubscriber( "clk_camera_button", clk_camera_button_inv_beg, "inv_camera" );
    cmn.AddSubscriber( "clk_camera_button", clk_camera_button_inv_end, "inv_camera" );
    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_bluewire" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_camera_bluewire",
        room = "int_deploy_inv",
        zz = "deploy_inv_camera",
        zz_gate = "inv_camera"
    };
    function get_bluewire_inv ()

      interface.InventoryItemAdd( "inv_bluewire", "spr_deploy_inv_camera_bluewire" );
      interface.InventoryItemRemove( "inv_camera" );

    end;
    function get_bluewire_inv_zz ()

      ObjDelete( "gfx_deploy_inv_camera_bluewire" );

    end;
    cmn.AddSubscriber( "get_bluewire", get_bluewire_inv );
    cmn.AddSubscriber( "get_bluewire", get_bluewire_inv_zz, "inv_camera" );

    --------------------------------------------------------------------------------------------

  end;
  -- CLK -------------------------------------------------------------------------------------
  function private.clk_camera_button ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_camera_button" );
      cmn.CallEventHandler( "clk_camera_button_inv_end", "inv_camera" );

    end;

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_slide", 0, "", 0 );

    cmn.CallEventHandler( "clk_camera_button_inv_beg", "inv_camera" );

    ObjAnimate( "spr_deploy_inv_camera_button", "pos_xy", 0, 0, "", 
    { 
      0.0, 0, -49, -66, 
      0.3, 2, -30, -68 
    } );
    ObjAnimate( "spr_deploy_inv_camera_camera_cover", "pos_xy", 0, 0, func_end, 
    { 
      0.0, 0, -91, -23,
      0.4, 0, -91, -23, 
      0.9, 3, -109, 75 
    } );
    

  end;
  -- GET -------------------------------------------------------------------------------------
  function private.get_bluewire ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_bluewire" );
    cmn.CallEventHandler( "get_bluewire", "inv_camera" );
    
    common_impl.HideDeployInv();          

  end;

--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** patientsprofile *** () end;
--*********************************************************************************************************************
  function private.patientsprofile_init ()
    ObjSet( "obj_deploy_inv_patientsprofile_clk_profile", { event_mdown = private.clk_profile } );
    ObjSet( "obj_deploy_inv_patientsprofile_clk_note", { event_mdown = private.clk_note } );
    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_profile" ] = {
        type = "click",
        use_place = "obj_deploy_inv_patientsprofile_clk_profile",
        room = "int_deploy_inv",
        zz = "deploy_inv_patientsprofile",
        zz_gate = "inv_patientsprofile"
    };
    function clk_profile_inv_beg ()

      ObjDelete( "obj_deploy_inv_patientsprofile_clk_profile" )

    end;
    function clk_profile_inv_end ()

      ObjDelete( "spr_deploy_inv_patientsprofile_closecard" );
      ObjSet( "spr_deploy_inv_patientsprofile_opencard", { alp = 1 } );
      ObjSet( "obj_deploy_inv_patientsprofile_clk_note", { input = true } );

    end;
    cmn.AddSubscriber( "clk_profile_inv_end", clk_profile_inv_end, "inv_patientsprofile" );
    cmn.AddSubscriber( "clk_profile_inv_beg", clk_profile_inv_beg, "inv_patientsprofile" );
    cmn.AddSubscriber( "clk_profile", clk_profile_inv_end, "inv_patientsprofile" );
    cmn.AddSubscriber( "clk_profile", clk_profile_inv_beg, "inv_patientsprofile" );
    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_note" ] = {
        type = "click",
        use_place = "obj_deploy_inv_patientsprofile_clk_note",
        room = "int_deploy_inv",
        zz = "deploy_inv_patientsprofile",
        zz_gate = "inv_patientsprofile"
    };
    function clk_note_inv_beg ()

      ObjDelete( "obj_deploy_inv_patientsprofile_clk_note" )

    end;
    function clk_note_inv_end ()

      ObjDelete( "spr_deploy_inv_patientsprofile_opencard" );
      ObjSet( "obj_deploy_inv_patientsprofile_note", { input = true, pos_x = 0, pos_y = 0, scale_x = 1, scale_y = 1, ang = 0, alp = 1 } );

    end;
    cmn.AddSubscriber( "clk_note_inv_beg", clk_note_inv_beg, "inv_patientsprofile" );
    cmn.AddSubscriber( "clk_note_inv_end", clk_note_inv_end, "inv_patientsprofile" );
    cmn.AddSubscriber( "clk_note", clk_note_inv_beg, "inv_patientsprofile" );
    cmn.AddSubscriber( "clk_note", clk_note_inv_end, "inv_patientsprofile" );
    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_scotchtapepiece" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_patientsprofile_scotchtapepiece",
        room = "int_deploy_inv",
        zz = "deploy_inv_patientsprofile",
        zz_gate = "inv_patientsprofile"
    };
    function get_scotchtapepiece_inv ()

      interface.InventoryItemAdd( "inv_scotchtapepiece", "spr_deploy_inv_patientsprofile_scotchtapepiece" );
      interface.InventoryItemRemove( "inv_patientsprofile" );

    end;
    function get_scotchtapepiece_inv_zz ()

      ObjDelete( "gfx_deploy_inv_patientsprofile_scotchtapepiece" );

    end;
    cmn.AddSubscriber( "get_scotchtapepiece", get_scotchtapepiece_inv );
    cmn.AddSubscriber( "get_scotchtapepiece", get_scotchtapepiece_inv_zz, "inv_patientsprofile" );

    --------------------------------------------------------------------------------------------

  end;
  -- CLK -------------------------------------------------------------------------------------
  function private.clk_profile ()

    --common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_profile" );
      cmn.CallEventHandler( "clk_profile_inv_end", "inv_patientsprofile" );

    end;

    cmn.CallEventHandler( "clk_profile_inv_beg", "inv_patientsprofile" );

    ObjAnimate( "spr_deploy_inv_patientsprofile_closecard", "pos_x", 0, 0, "", { 0, 0, 1, 0.3, 0, 182 } );
    
    ObjAnimate( "spr_deploy_inv_patientsprofile_closecard", "alp", 0, 0, "", { 0, 0, 1, 0.3, 0, 1, 0.5, 0, 0 } );
    ObjAnimate( "spr_deploy_inv_patientsprofile_opencard", "alp", 0, 0, func_end, { 0, 0, 0, 0.3, 0, 0, 0.5, 0, 1 } );

  end;
  --------------------------------------------------------------------------------------------
  function private.clk_note ()

    --common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_note" );
      cmn.CallEventHandler( "clk_note_inv_end", "inv_patientsprofile" );

    end;

    cmn.CallEventHandler( "clk_note_inv_beg", "inv_patientsprofile" );

    ObjAnimate( "spr_deploy_inv_patientsprofile_opencard", "alp", 0, 0, "", { 0, 0, 1, 0.3, 0, 1, 0.5, 0, 0 } );
    
    ObjAnimate( "obj_deploy_inv_patientsprofile_note", "alp", 0, 0, "", { 0, 0, 0, 0.1, 0, 1 } );
    ObjAnimate( "obj_deploy_inv_patientsprofile_note", "pos_xy", 0, 0, "", 
    { 
      0.0, 0, 170, 40, 
      0.1, 0, 170, 40,
      0.6, 3, 0, 0
    } );
    ObjAnimate( "obj_deploy_inv_patientsprofile_note", "scale_xy", 0, 0, "", 
    { 
      0.0, 0, 0.34, 0.34, 
      0.1, 0, 0.34, 0.34,
      0.6, 3, 1, 1
    } );
    ObjAnimate( "obj_deploy_inv_patientsprofile_note", "ang", 0, 0, func_end, 
    { 
      0.0, 0, -0.33, 
      0.1, 0, -0.33,
      0.6, 3, 0
    } );

  end;
  -- GET -------------------------------------------------------------------------------------
  function private.get_scotchtapepiece ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_scotchtapepiece" );
    cmn.CallEventHandler( "get_scotchtapepiece", "inv_patientsprofile" );
    
    common_impl.HideDeployInv();          

  end;


--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** videotape *** () end;
--*********************************************************************************************************************
  function private.videotape_init ()
    ObjSet( "obj_deploy_inv_videotape_clk_videocassette", { event_mdown = private.clk_videotape } );
    --------------------------------------------------------------------------------------------
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_videotape" ] = {
        type = "click",
        use_place = "obj_deploy_inv_videotape_clk_videocassette",
        room = "int_deploy_inv",
        zz = "deploy_inv_videotape",
        zz_gate = "inv_videotape"
    };
    function clk_videotape_inv_beg ()

      ObjDelete( "obj_deploy_inv_videotape_clk_videocassette" );

    end;
    function clk_videotape_inv_end ()

      ObjSet( "spr_deploy_inv_videotape_dnainfinityamulet2", { input = true, active = true } );
      ObjSet( "spr_deploy_inv_videotape_videocassette_2", { pos_x = -99, pos_y = 207, ang = -0.47 } );
      ObjSet( "spr_deploy_inv_videotape_videocassette_3", { pos_x = -315, pos_y = 127, ang = 0.26 } );
      ObjSet( "spr_deploy_inv_videotape_videocassette_4", { alp = 1 } );

    end;
    cmn.AddSubscriber( "clk_videotape_inv_beg", clk_videotape_inv_beg, "inv_videotape" );
    cmn.AddSubscriber( "clk_videotape_inv_end", clk_videotape_inv_end, "inv_videotape" );
    cmn.AddSubscriber( "clk_videotape", clk_videotape_inv_beg, "inv_videotape" );
    cmn.AddSubscriber( "clk_videotape", clk_videotape_inv_end, "inv_videotape" );
    --------------------------------------------------------------------------------------------
    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_dnainfinityamulet2" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_videotape_dnainfinityamulet2",
        room = "int_deploy_inv",
        zz = "deploy_inv_videotape",
        zz_gate = "inv_videotape"
    };
    function get_dnainfinityamulet2_inv ()

      interface.InventoryItemAdd( "inv_dnainfinityamulet2", "spr_deploy_inv_videotape_dnainfinityamulet2" );
      interface.InventoryItemRemove( "inv_videotape" );

    end;
    function get_dnainfinityamulet2_inv_zz ()

      ObjDelete( "gfx_deploy_inv_videotape_dnainfinityamulet2" );

    end;
    cmn.AddSubscriber( "get_dnainfinityamulet2", get_dnainfinityamulet2_inv );
    cmn.AddSubscriber( "get_dnainfinityamulet2", get_dnainfinityamulet2_inv_zz, "inv_videotape" );

    --------------------------------------------------------------------------------------------
    
  end;
  -- CLK -------------------------------------------------------------------------------------
  function private.clk_videotape ()

    --common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "clk_videotape" );
      cmn.CallEventHandler( "clk_videotape_inv_end", "inv_videotape" );
    
    end;
  
    cmn.Lock( true );
    
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_videocassete", 0, "", 0 );

    cmn.CallEventHandler( "clk_videotape_inv_beg", "inv_videotape" );

    ObjAnimate( "spr_deploy_inv_videotape_videocassette_2", "pos_xy", 0, 0, "", 
    { 
      0.0, 0, 27, -12,
      0.6, 2, -99, 207 
    } );
    ObjAnimate( "spr_deploy_inv_videotape_videocassette_2", "ang", 0, 0, "", 
    { 
      0.0, 0, 0,
      0.6, 2, -0.47 
    } );

    ObjAnimate( "spr_deploy_inv_videotape_videocassette_3", "pos_xy", 0, 0, "", 
    { 
      0.0, 0, -18, -170,
      0.6, 2, -315, 127 
    } );
    ObjAnimate( "spr_deploy_inv_videotape_videocassette_3", "ang", 0, 0, func_end, 
    { 
      0.0, 0, 0,
      0.6, 2, 0.26 
    } );

    ObjAnimate( "spr_deploy_inv_videotape_videocassette_4", "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      0.6, 2, 1 
    } );

  end;
  -- GET -------------------------------------------------------------------------------------
  function private.get_dnainfinityamulet2 ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_dnainfinityamulet2" );
    cmn.CallEventHandler( "get_dnainfinityamulet2", "inv_videotape" );
    
    common_impl.HideDeployInv();          

  end;