-- name=rm_archives
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_archives";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_sealedcase", "room_hub" );
  ObjAttach( "zz_videoplayer", "room_hub" );
  ObjAttach( "zz_surveillancecamera", "room_hub" );
  private.Init_Subroom();
  private.InitVideoplayer();

  ObjMultiSet( { 
    { "spr_sealedcase_volumecontrol",             { event_mdown = private.get_volumecontrol } },
    { "spr_videoplayer_videotape",                { event_mdown = private.get_videotape     } },
    { "spr_videoplayer_button1",                  { event_mdown = private.get_button1       } },
    { "spr_surveillancecamera_button2",           { event_mdown = private.get_button2       } },
    { "spr_surveillancecamera_chip",              { event_mdown = private.get_chip          } },
    { "spr_sealedcase_mapsheet",                  { event_mdown = private.get_mapsheet_2          } },


    { "spr_archives_collect_morph_item",          { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_2_6" );                       end } },
    { "obj_videoplayer_use_cork",                 { event_mdown = function () private.ClkPanel(); common_impl.ShowBbt( 'bbt_videoplayer_use_cork' );          end } },
    { "obj_videoplayer_use_volumecontrol",        { event_mdown = function () private.ClkPanel(); common_impl.ShowBbt( 'bbt_videoplayer_use_volumecontrol' ); end } },

  } );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_archives = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "gho_archives_archivedata",
      "gmg_archives_superpuzzle2",
      "gzz_archives_sealedcase",
      "gzz_archives_videoplayer",
      "gzz_archives_surveillancecamera"
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_sealedcase",
      "zz_videoplayer",
      "zz_surveillancecamera",
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_archives", update_game_mode_archives, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_archives = function ()

  local effects_table = 
  {
    "obj_archives_anim",
    "anm_videoplayer_noise",
    "anm_surveillancecamera_light" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_archives", update_performance_mode_archives, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_archives () end;
  --------------------------------------------------------------------------------------------
  local opn_archives_map = function ()

    common_impl.VisitMapRoom( "archives" );

  end;
  cmn.AddSubscriber( "opn_archives", opn_archives_map );
  --------------------------------------------------------------------------------------------
  -- function get_volumecontrol () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_volumecontrol" ] = {
    type = "get",
    get_obj = "spr_sealedcase_volumecontrol",
    room = private.room_objname,
    zz = "zz_sealedcase",
    zz_gate = "gzz_archives_sealedcase"
  };
  
  local get_volumecontrol_inv = function ()
  
    interface.InventoryItemAdd( "inv_volumecontrol", "spr_sealedcase_volumecontrol" );
  
  end;
  
  local get_volumecontrol_closezz = function ()

    ObjDelete( "spr_archives_sealedcase_part_1" );
    ObjDelete( "spr_sealedcase_volumecontrol_shadow" );
    ObjDelete( "gfx_sealedcase_volumecontrol" );
  
  end;
  
  cmn.AddSubscriber( "get_volumecontrol", get_volumecontrol_inv );
  cmn.AddSubscriber( "get_volumecontrol", get_volumecontrol_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_videotape () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_videotape" ] = {
    type = "get",
    get_obj = "spr_videoplayer_videotape",
    room = private.room_objname,
    zz = "zz_videoplayer",
    zz_gate = "gzz_archives_videoplayer"
  };
  
  local get_videotape_inv = function ()
  
    interface.InventoryItemAdd( "inv_videotape", "spr_videoplayer_videotape" );
    ObjSet( "inv_videotape", { drag = false } ); 
    cmn.SetInvPlusRGB( "videotape", true ); 

  end;
  
  local get_videotape_closezz = function ()
  
    ObjDelete( "gfx_videoplayer_videotape" );
    ObjDelete( "spr_videoplayer_casette_slot2" );
    ObjDelete( "spr_videoplayer_casette_patch" );
    ObjSet( "obj_videoplayer_use_hint", { input = true } );

    ObjDelete( "spr_archives_videoplayer_cassete" );
  
  end;
  
  cmn.AddSubscriber( "get_videotape", get_videotape_inv );
  cmn.AddSubscriber( "get_videotape", get_videotape_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_button1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_button1" ] = {
    type = "get",
    get_obj = "spr_videoplayer_button1",
    room = private.room_objname,
    zz = "zz_videoplayer",
    zz_gate = "gzz_archives_videoplayer"
  };
  
  local get_button1_inv = function ()
  
    interface.InventoryItemAdd( "inv_button1", "spr_videoplayer_button1" );
  
  end;
  
  local get_button1_closezz = function ()
  
    ObjDelete( "gfx_videoplayer_button1" );
  
  end;
  
  cmn.AddSubscriber( "get_button1", get_button1_inv );
  cmn.AddSubscriber( "get_button1", get_button1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_button2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_button2" ] = {
    type = "get",
    get_obj = "spr_surveillancecamera_button2",
    room = private.room_objname,
    zz = "zz_surveillancecamera",
    zz_gate = "gzz_archives_surveillancecamera"
  };
  
  local get_button2_inv = function ()
  
    interface.InventoryItemAdd( "inv_button2", "spr_surveillancecamera_button2" );
  
  end;
  
  local get_button2_closezz = function ()
  
    ObjDelete( "gfx_surveillancecamera_button2" );
    ObjDelete( "spr_surveillancecamera_button2_shadow" );
    ObjDelete( "spr_archives_surveillancecamera_button" );
  
  end;
  
  cmn.AddSubscriber( "get_button2", get_button2_inv );
  cmn.AddSubscriber( "get_button2", get_button2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_chip () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_chip" ] = {
    type = "get",
    get_obj = "spr_surveillancecamera_chip",
    room = private.room_objname,
    zz = "zz_surveillancecamera",
    zz_gate = "gzz_archives_surveillancecamera"
  };
  
  local get_chip_inv = function ()
  
    interface.InventoryItemAdd( "inv_chip", "spr_surveillancecamera_chip" );
  
  end;
  
  local get_chip_closezz = function ()
  
    ObjDelete( "gfx_surveillancecamera_chip" );
    ObjDelete( "gzz_archives_surveillancecamera" );
    ObjDelete( "spr_surveillancecamera_chip_shadow" );
    ObjDelete( "spr_surveillancecamera_chip_over" );

  end;
  
  cmn.AddSubscriber( "get_chip", get_chip_inv );
  cmn.AddSubscriber( "get_chip", get_chip_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mapsheet_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_mapsheet_2" ] = {
    type = "get",
    get_obj = "spr_sealedcase_mapsheet",
    room = private.room_objname,
    zz = "zz_sealedcase",
    zz_gate = "gzz_archives_sealedcase"
  };
  
  local get_mapsheet_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_mapsheet_2", "spr_sealedcase_mapsheet" );
  
  end;
  
  local get_mapsheet_2_closezz = function ()
  
    ObjDelete( "gfx_sealedcase_mapsheet" );
    ObjDelete( "spr_archives_sealedcase_part_2" );

  end;
  
  cmn.AddSubscriber( "get_mapsheet_2", get_mapsheet_2_inv );
  cmn.AddSubscriber( "get_mapsheet_2", get_mapsheet_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2_6 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2_6 = function ()
  
    ObjDelete( "obj_archives_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_2_6", get_collect_morph_item_2_6, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_seal1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_seal1" ] = {
    type = "use",
    inv_obj = "inv_seal1",
    use_place = "obj_sealedcase_use_seal1",
    room = private.room_objname,
    zz = "zz_sealedcase",
    zz_gate = "gzz_archives_sealedcase"
  };
  local use_seal1_inv = function ()
  
    interface.InventoryItemRemove( "inv_seal1" );
  
  end;
  local use_seal1_beg = function ()
  
    ObjDelete( "obj_sealedcase_use_seal1" );
  
  end;
  local use_seal1_end = function ()

    ObjSet( "spr_sealedcase_seal1", { alp = 1 } );
    ObjSet( "spr_sealedcase_light_door_1", { alp = 1 } );

    ObjSet( "spr_archives_sealedcase_1", { alp = 1 } );
  
    if ( cmn.IsEventDone( "use_seal2" ) and  
         cmn.IsEventDone( "use_seal3" ) ) then

      ObjDelete( "gzz_archives_sealedcase" );
      ObjSet( "gmg_archives_superpuzzle2", { input = true, active = true } );

      ObjSet( "spr_sealedcase_door2_shadow", { alp = 1 } );
      ObjSet( "spr_sealedcase_door1",        { pos_x = -174, pos_y = 95 } );

      ObjSet( "spr_archives_superpuzzle", { alp = 1 } );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_seal1", use_seal1_beg, private.room_objname );
  cmn.AddSubscriber( "use_seal1", use_seal1_inv );
  cmn.AddSubscriber( "use_seal1", use_seal1_end, private.room_objname );
  cmn.AddSubscriber( "use_seal1_inv", use_seal1_inv, private.room_objname );
  cmn.AddSubscriber( "use_seal1_beg", use_seal1_beg, private.room_objname );
  cmn.AddSubscriber( "use_seal1_end", use_seal1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_seal2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_seal2" ] = {
    type = "use",
    inv_obj = "inv_seal2",
    use_place = "obj_sealedcase_use_seal2",
    room = private.room_objname,
    zz = "zz_sealedcase",
    zz_gate = "gzz_archives_sealedcase"
  };
  local use_seal2_inv = function ()
  
    interface.InventoryItemRemove( "inv_seal2" );
  
  end;
  local use_seal2_beg = function ()
  
    ObjDelete( "obj_sealedcase_use_seal2" );
  
  end;
  local use_seal2_end = function ()
  
    ObjSet( "spr_sealedcase_seal2", { alp = 1 } );

    ObjSet( "spr_archives_sealedcase_2", { alp = 1 } );
    ObjSet( "spr_sealedcase_light_door_2", { alp = 1 } );

    if ( cmn.IsEventDone( "use_seal1" ) and  
         cmn.IsEventDone( "use_seal3" ) ) then

      ObjDelete( "gzz_archives_sealedcase" );
      ObjSet( "gmg_archives_superpuzzle2", { input = true, active = true } );

      ObjSet( "spr_sealedcase_door2_shadow", { alp = 1 } );
      ObjSet( "spr_sealedcase_door1",        { pos_x = -174, pos_y = 95 } );

      ObjSet( "spr_archives_superpuzzle", { alp = 1 } );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_seal2", use_seal2_beg, private.room_objname );
  cmn.AddSubscriber( "use_seal2", use_seal2_inv );
  cmn.AddSubscriber( "use_seal2", use_seal2_end, private.room_objname );
  cmn.AddSubscriber( "use_seal2_inv", use_seal2_inv, private.room_objname );
  cmn.AddSubscriber( "use_seal2_beg", use_seal2_beg, private.room_objname );
  cmn.AddSubscriber( "use_seal2_end", use_seal2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_seal3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_seal3" ] = {
    type = "use",
    inv_obj = "inv_seal3",
    use_place = "obj_sealedcase_use_seal3",
    room = private.room_objname,
    zz = "zz_sealedcase",
    zz_gate = "gzz_archives_sealedcase"
  };
  local use_seal3_inv = function ()
  
    interface.InventoryItemRemove( "inv_seal3" );
  
  end;
  local use_seal3_beg = function ()
  
    ObjDelete( "obj_sealedcase_use_seal3" );
  
  end;
  local use_seal3_end = function ()
  
    ObjSet( "spr_sealedcase_seal3", { alp = 1 } );
    ObjSet( "spr_sealedcase_light_door_3", { alp = 1 } );

    ObjSet( "spr_archives_sealedcase_3", { alp = 1 } );

    if ( cmn.IsEventDone( "use_seal1" ) and  
         cmn.IsEventDone( "use_seal2" ) ) then

      ObjDelete( "gzz_archives_sealedcase" );
      ObjSet( "gmg_archives_superpuzzle2", { input = true, active = true } );

      ObjSet( "spr_sealedcase_door2_shadow", { alp = 1 } );
      ObjSet( "spr_sealedcase_door1",        { pos_x = -174, pos_y = 95 } );

      ObjSet( "spr_archives_superpuzzle", { alp = 1 } );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_seal3", use_seal3_beg, private.room_objname );
  cmn.AddSubscriber( "use_seal3", use_seal3_inv );
  cmn.AddSubscriber( "use_seal3", use_seal3_end, private.room_objname );
  cmn.AddSubscriber( "use_seal3_inv", use_seal3_inv, private.room_objname );
  cmn.AddSubscriber( "use_seal3_beg", use_seal3_beg, private.room_objname );
  cmn.AddSubscriber( "use_seal3_end", use_seal3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hint () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hint" ] = {
    type = "use",
    inv_obj = "inv_hint",
    use_place = "obj_videoplayer_use_hint",
    room = private.room_objname,
    zz = "zz_videoplayer",
    zz_gate = "gzz_archives_videoplayer"
  };
  local use_hint_inv = function ()
  
    interface.InventoryItemRemove( "inv_hint" );
  
  end;
  local use_hint_beg = function ()
  
    ObjDelete( "obj_videoplayer_use_hint" );
  
  end;
  local use_hint_end = function ()

    ObjMultiSet( { 
      { "spr_videoplayer_hint",             { alp = 1 } },
      { "spr_archives_videoplayer_hint",    { alp = 1 } },
      { "obj_videoplayer_mmg",              { input = true } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hint", use_hint_beg, private.room_objname );
  cmn.AddSubscriber( "use_hint", use_hint_inv );
  cmn.AddSubscriber( "use_hint", use_hint_end, private.room_objname );
  cmn.AddSubscriber( "use_hint_inv", use_hint_inv, private.room_objname );
  cmn.AddSubscriber( "use_hint_beg", use_hint_beg, private.room_objname );
  cmn.AddSubscriber( "use_hint_end", use_hint_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_volumecontrol () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_volumecontrol" ] = {
    type = "use",
    inv_obj = "inv_volumecontrol",
    use_place = "obj_videoplayer_use_volumecontrol",
    room = private.room_objname,
    zz = "zz_videoplayer",
    zz_gate = "gzz_archives_videoplayer"
  };
  local use_volumecontrol_inv = function ()
  
    interface.InventoryItemRemove( "inv_volumecontrol" );
  
  end;
  local use_volumecontrol_beg = function ()
  
    ObjDelete( "obj_videoplayer_use_volumecontrol" );
  
  end;
  local use_volumecontrol_end = function ()

    ObjSet( "spr_videoplayer_panel_regulator", { alp = 1 } );

    ObjSet( "spr_archives_videoplayer_panel_regulator", { alp = 1 } );

    if ( cmn.IsEventDone( "use_cork" ) ) then

      ObjSet( "spr_videoplayer_button1", { input = true } );
      ObjSet( "gfx_videoplayer_button1", { active = true } );

      ObjSet( "obj_videoplayer_use_chip", { input = true } );
      ObjDelete( "spr_videoplayer_panel" );
      ObjDelete( "anm_videoplayer_panel" );

      ObjDelete( "spr_archives_videoplayer_panel" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_volumecontrol", use_volumecontrol_beg, private.room_objname );
  cmn.AddSubscriber( "use_volumecontrol", use_volumecontrol_inv );
  cmn.AddSubscriber( "use_volumecontrol", use_volumecontrol_end, private.room_objname );
  cmn.AddSubscriber( "use_volumecontrol_inv", use_volumecontrol_inv, private.room_objname );
  cmn.AddSubscriber( "use_volumecontrol_beg", use_volumecontrol_beg, private.room_objname );
  cmn.AddSubscriber( "use_volumecontrol_end", use_volumecontrol_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cork () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cork" ] = {
    type = "use",
    inv_obj = "inv_cork",
    use_place = "obj_videoplayer_use_cork",
    room = private.room_objname,
    zz = "zz_videoplayer",
    zz_gate = "gzz_archives_videoplayer"
  };
  local use_cork_inv = function ()
  
    interface.InventoryItemRemove( "inv_cork" );
  
  end;
  local use_cork_beg = function ()
  
    ObjDelete( "obj_videoplayer_use_cork" );
  
  end;
  local use_cork_end = function ()
  
    ObjSet( "spr_videoplayer_panel_cork", { alp = 1 } );

    ObjSet( "spr_archives_videoplayer_panel_regulator", { alp = 1 } );

    if ( cmn.IsEventDone( "use_volumecontrol" ) ) then

      ObjSet( "spr_videoplayer_button1", { input = true } );
      ObjSet( "gfx_videoplayer_button1", { active = true } );

      ObjSet( "obj_videoplayer_use_chip", { input = true } );
      ObjDelete( "spr_videoplayer_panel" );
      ObjDelete( "anm_videoplayer_panel" );

      ObjDelete( "spr_archives_videoplayer_panel" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cork", use_cork_beg, private.room_objname );
  cmn.AddSubscriber( "use_cork", use_cork_inv );
  cmn.AddSubscriber( "use_cork", use_cork_end, private.room_objname );
  cmn.AddSubscriber( "use_cork_inv", use_cork_inv, private.room_objname );
  cmn.AddSubscriber( "use_cork_beg", use_cork_beg, private.room_objname );
  cmn.AddSubscriber( "use_cork_end", use_cork_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chip () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chip" ] = {
    type = "use",
    inv_obj = "inv_chip",
    use_place = "obj_videoplayer_use_chip",
    room = private.room_objname,
    zz = "zz_videoplayer",
    zz_gate = "gzz_archives_videoplayer"
  };
  local use_chip_inv = function ()
  
    interface.InventoryItemRemove( "inv_chip" );
  
  end;
  local use_chip_beg = function ()
  
    ObjDelete( "obj_videoplayer_use_chip" );
  
  end;
  local use_chip_end = function ()

    ObjSet( "spr_videoplayer_videotape", { alp = 1, input = true } );
    ObjSet( "gfx_videoplayer_videotape", { active = true } );

    ObjSet( "spr_videoplayer_casette_slot2", { alp = 1 } );
    ObjSet( "spr_videoplayer_casette_patch", { alp = 1 } );
    ObjDelete( "anm_videoplayer_cassete" );
    ObjSet( "spr_videoplayer_chip", { alp = 1 } );
    ObjSet( "anm_videoplayer_noise", { alp = 1, active = true } );

    ObjSet( "spr_archives_videoplayer_chip", { alp = 1 } );
    ObjSet( "spr_archives_videoplayer_screen", { alp = 1 } );
    ObjSet( "spr_archives_videoplayer_cassete", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chip", use_chip_beg, private.room_objname );
  cmn.AddSubscriber( "use_chip", use_chip_inv );
  cmn.AddSubscriber( "use_chip", use_chip_end, private.room_objname );
  cmn.AddSubscriber( "use_chip_inv", use_chip_inv, private.room_objname );
  cmn.AddSubscriber( "use_chip_beg", use_chip_beg, private.room_objname );
  cmn.AddSubscriber( "use_chip_end", use_chip_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pipepiece () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pipepiece" ] = {
    type = "use",
    inv_obj = "inv_pipepiece",
    use_place = "obj_surveillancecamera_use_pipepiece",
    room = private.room_objname,
    zz = "zz_surveillancecamera",
    zz_gate = "gzz_archives_surveillancecamera"
  };
  local use_pipepiece_inv = function ()
  
    interface.InventoryItemRemove( "inv_pipepiece" );
  
  end;
  local use_pipepiece_beg = function ()
  
    ObjDelete( "obj_surveillancecamera_use_pipepiece" );
  
  end;
  local use_pipepiece_end = function ()

    ObjDelete( "anm_surveillancecamera_camera" );
    ObjSet( "obj_surveillancecamera_camera", { alp = 1 } );
    ObjSet( "spr_surveillancecamera_camera_2", { input = true } );
    ObjSet( "gfx_surveillancecamera_chip", { active = true } );

    ObjDelete( "spr_archives_surveillancecamera1" );
    ObjSet( "spr_archives_surveillancecamera2", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pipepiece", use_pipepiece_beg, private.room_objname );
  cmn.AddSubscriber( "use_pipepiece", use_pipepiece_inv );
  cmn.AddSubscriber( "use_pipepiece", use_pipepiece_end, private.room_objname );
  cmn.AddSubscriber( "use_pipepiece_inv", use_pipepiece_inv, private.room_objname );
  cmn.AddSubscriber( "use_pipepiece_beg", use_pipepiece_beg, private.room_objname );
  cmn.AddSubscriber( "use_pipepiece_end", use_pipepiece_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hexkey_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hexkey_2" ] = {
    type = "use",
    inv_obj = "inv_hexkey",
    use_place = "obj_surveillancecamera_use_hexkey_2",
    room = private.room_objname,
    zz = "zz_surveillancecamera",
    zz_gate = "gzz_archives_surveillancecamera"
  };
  local use_hexkey_2_inv = function ()
  
    if cmn.IsEventDone( "use_hexkey_1" ) then 
      interface.InventoryItemRemove( "inv_hexkey" );
    end; 

  end;
  local use_hexkey_2_beg = function ()
  
    ObjDelete( "obj_surveillancecamera_use_hexkey_2" );
  
  end;
  local use_hexkey_2_end = function ()
  
    ObjMultiSet( { 
      { "spr_surveillancecamera_button2", { input = true , alp = 1 }},
      { "gfx_surveillancecamera_button2", { active = true }},
    } );

    ObjDelete( "spr_archives_surveillancecamera_panel" );
    ObjDelete( "vid_surveillancecamera_hexkey" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hexkey_2", use_hexkey_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_hexkey_2", use_hexkey_2_inv );
  cmn.AddSubscriber( "use_hexkey_2", use_hexkey_2_end, private.room_objname );
  cmn.AddSubscriber( "use_hexkey_2_inv", use_hexkey_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_hexkey_2_beg", use_hexkey_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_hexkey_2_end", use_hexkey_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_videoplayer () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_videoplayer" ] =
  {
      type = "win",
      room = private.room_objname,
      zz = "zz_videoplayer",
      zz_gate = "gzz_archives_videoplayer"
  };
  local win_videoplayer = function ()

    if ( cmn.IsEventDone( "win_videoplayer" ) ) then

      ObjDelete( "spr_archives_videoplayer_screen" );
      ObjSet( "gho_archives_archivedata", { input = true, active = true } );
      ObjDelete( "gzz_archives_videoplayer" );
      ObjSet( "spr_archives_videoplayer_ho1", { alp = 1 } );

    end;

  end;
  cmn.AddSubscriber( "win_videoplayer", win_videoplayer, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_outro_lvl2 () end;
  --------------------------------------------------------------------------------------------
  local see_outro_lvl2 = function ()
    
    ObjDelete( "spr_archives_superpuzzle" );

  end;

  cmn.AddSubscriber( "see_outro_lvl2", see_outro_lvl2, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load ()

  --function mmg_videoplayer () end; --------------------------------------------------------------------------
    if ( cmn.IsEventStart( "win_videoplayer" ) ) then

      --blue
      if ( ng_global.progress[ "std" ][ "win_videoplayer" ].state[ "blue" ] == private.win_videoplayer_win[ "blue" ] ) then

        ObjSet( "spr_videoplayer_click_blue", { alp = 1 } );
        private.win_videoplayer_state[ "blue" ] = ng_global.progress[ "std" ][ "win_videoplayer" ].state[ "blue" ];

      else

        ObjSet( "spr_videoplayer_click_blue", { alp = 0 } );
        ng_global.progress[ "std" ][ "win_videoplayer" ].state[ "blue" ] = 0;
        private.win_videoplayer_state[ "blue" ] = ng_global.progress[ "std" ][ "win_videoplayer" ].state[ "blue" ];

      end;
 
      --yellow
      if ( ng_global.progress[ "std" ][ "win_videoplayer" ].state[ "yellow" ] == private.win_videoplayer_win[ "yellow" ] ) then

        ObjSet( "spr_videoplayer_click_yellow", { alp = 1 } );
        private.win_videoplayer_state[ "yellow" ] = ng_global.progress[ "std" ][ "win_videoplayer" ].state[ "yellow" ];

      else

        ObjSet( "spr_videoplayer_click_yellow", { alp = 0 } );
        ng_global.progress[ "std" ][ "win_videoplayer" ].state[ "yellow" ] = 0;
        private.win_videoplayer_state[ "yellow" ] = ng_global.progress[ "std" ][ "win_videoplayer" ].state[ "yellow" ];

      end;

      --green
      if ( ng_global.progress[ "std" ][ "win_videoplayer" ].state[ "green" ] == private.win_videoplayer_win[ "green" ] ) then

        ObjSet( "spr_videoplayer_click_green", { alp = 1 } );
        private.win_videoplayer_state[ "green" ] = ng_global.progress[ "std" ][ "win_videoplayer" ].state[ "green" ];

      else

        ObjSet( "spr_videoplayer_click_green", { alp = 0 } );
        ng_global.progress[ "std" ][ "win_videoplayer" ].state[ "green" ] = 0;
        private.win_videoplayer_state[ "green" ] = ng_global.progress[ "std" ][ "win_videoplayer" ].state[ "green" ];

      end;

      private.win_videoplayer_current_color = ng_global.progress[ "std" ][ "win_videoplayer" ].current_color;

    end;  
  ---------------------------------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function private.Init_Subroom ()

  --*********************************************************************************************************************
  -- function zz_videoplayer () end;
  --*********************************************************************************************************************
    subroom.Define( "zz_videoplayer" );    
    function zz_videoplayer.PreOpen()

    end;
    -------------------------------------------------
    function zz_videoplayer.Open()

      if ( cmn.IsEventStart( "win_videoplayer" ) and not cmn.IsEventDone( "win_videoplayer" ) ) then

        cmn.MiniGameShow( "videoplayer" );
        common_impl.PassingMgStart( "videoplayer" );

      end;

    end;
    -------------------------------------------------
    function zz_videoplayer.PreClose()

      if ( cmn.IsEventStart( "win_videoplayer" ) and not cmn.IsEventDone( "win_videoplayer" ) ) then

        cmn.MiniGameHide( "videoplayer" );

      end;

    end;
    -------------------------------------------------
    function zz_videoplayer.Close()


    end;
    -------------------------------------------------
    function zz_videoplayer.Reset ()

      cmn.Lock( true );
      ObjAnimate( "spr_videoplayer_click_blue", "alp", 0, 0, function () zz_videoplayer.ResetEnd() end, 
      { 
        0.0, 3, ObjGet( "spr_videoplayer_click_blue" ).alp, 
        0.15, 0, 0.6, 
        0.18, 0, 0.6,
        0.20, 0, 0,
        0.29, 0, 0,  
        0.33, 0, 0.6,     
        0.37, 0, 0.6,  
        0.40, 0, 0,
      } ); 
      ObjAnimate( "spr_videoplayer_click_yellow", "alp", 0, 0, "", 
      { 
        0.0, 3, ObjGet( "spr_videoplayer_click_yellow" ).alp, 
        0.15, 0, 0.6, 
        0.18, 0, 0.6,
        0.20, 0, 0,
        0.29, 0, 0,  
        0.33, 0, 0.6,     
        0.37, 0, 0.6,  
        0.40, 0, 0,
      } ); 
      ObjAnimate( "spr_videoplayer_click_green", "alp", 0, 0, "", 
      { 
        0.0, 3, ObjGet( "spr_videoplayer_click_green" ).alp, 
        0.15, 0, 0.6, 
        0.18, 0, 0.6,
        0.20, 0, 0,
        0.29, 0, 0,  
        0.33, 0, 0.6,     
        0.37, 0, 0.6,  
        0.40, 0, 0,
      } ); 

    end;
    -------------------------------------------------  
    function zz_videoplayer.ResetEnd ()

      cmn.Lock( false );
      ng_global.progress[ "std" ][ "win_videoplayer" ].state = { [ "blue" ] = 0,[ "yellow" ] = 0, [ "green" ] = 0 };
      ng_global.progress[ "std" ][ "win_videoplayer" ].current_color = 1;

      private.win_videoplayer_current_color = 1;
      private.win_videoplayer_state = { [ "blue" ] = 0,[ "yellow" ] = 0, [ "green" ] = 0 };
      private.win_videoplayer_win = { [ "blue" ] = 5,[ "yellow" ] = 3, [ "green" ] = 1 };

    end;
    -------------------------------------------------
    function zz_videoplayer.Skip ()

      cmn.Lock( true );
      ObjAnimate( "spr_videoplayer_click_blue", "alp", 0, 0, function () private.WinVideoplayer() end, 
      { 
        0.0, 3, ObjGet( "spr_videoplayer_click_blue" ).alp, 
        0.3, 0, 1, 
      } ); 
      ObjAnimate( "spr_videoplayer_click_yellow", "alp", 0, 0, "", 
      { 
        0.0, 3, ObjGet( "spr_videoplayer_click_yellow" ).alp, 
        0.3, 0, 1, 
      } ); 
      ObjAnimate( "spr_videoplayer_click_green", "alp", 0, 0, "", 
      { 
        0.0, 3, ObjGet( "spr_videoplayer_click_green" ).alp, 
        0.3, 0, 1, 
      } ); 

    end;
    -------------------------------------------------
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_archives();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

  if ( cmn.IsEventDone( "win_superpuzzle2" ) ) and ( not cmn.IsEventDone( "see_outro_lvl2" ) ) then

    private.see_outro_lvl2();

  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "level2/env/aud_lab_env" }, "", 0.5 );

  common_impl.MorphItemMorphing();

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_seal1 ()

  local item = "inv_seal1";

  if cmn.ApplyObj( item, "gzz_archives_sealedcase" ) and ( cmn.IsEventDone( "get_mapsheet_2" ) ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_sealedcase", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_sealedcase_use_seal1" ) ) and ( cmn.IsEventDone( "get_mapsheet_2" ) )  then

    cmn.CallEventHandler( "use_seal1_inv" );
    cmn.CallEventHandler( "use_seal1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_seal1" );
      cmn.CallEventHandler( "use_seal1_end" );

      if ( cmn.IsEventDone( "use_seal2" ) and  
           cmn.IsEventDone( "use_seal3" ) ) then

        common.CloseSubRoom(); 
        cmn.GotoRoom( 'mg_superpuzzle2' );

      end;

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk11", 0, "", 0 );

    if ( cmn.IsEventDone( "use_seal2" ) and  
         cmn.IsEventDone( "use_seal3" ) ) then

      ObjAnimate( "spr_sealedcase_seal1",        "alp",    0, 0, "", { 0,3,0,  0.4,3,1 } );
      ObjAnimate( "spr_sealedcase_light_door_1", "alp", 0, 0, "", 
      { 
        0.0, 3, 0, 
        0.4, 0, 0, 
        0.6, 0, 1 
      } );
      ObjAnimate( "spr_sealedcase_door2_shadow", "alp",    0, 0, "", { 0,3,0, 0.6,3,0, 1.0,3,1 } );
      ObjAnimate( "spr_sealedcase_door1",        "pos_xy", 0, 0, func_end, { 0,3,-105,68, 0.6,3,-105,68, 1.0,3,-174,59,  1.4,3,-174,59 } );

    else

      ObjAnimate( "spr_sealedcase_seal1", "alp", 0, 0, "", { 0,3,0,  0.4,3,1 } );
      ObjAnimate( "spr_sealedcase_light_door_1", "alp", 0, 0, func_end, 
      { 
        0.0, 3, 0, 
        0.4, 0, 0, 
        0.6, 0, 1 
      } );
    
    end;

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_seal2 ()

  local item = "inv_seal2";

  if cmn.ApplyObj( item, "gzz_archives_sealedcase" ) and ( cmn.IsEventDone( "get_mapsheet_2" ) )  then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_sealedcase", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_sealedcase_use_seal2" ) ) and ( cmn.IsEventDone( "get_mapsheet_2" ) )  then

    cmn.CallEventHandler( "use_seal2_inv" );
    cmn.CallEventHandler( "use_seal2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_seal2" );
      cmn.CallEventHandler( "use_seal2_end" );

      if ( cmn.IsEventDone( "use_seal1" ) and 
           cmn.IsEventDone( "use_seal3" ) ) then

        common.CloseSubRoom(); 
        cmn.GotoRoom( 'mg_superpuzzle2' );

      end;

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk11", 0, "", 0 );

    if ( cmn.IsEventDone( "use_seal1" ) and  
         cmn.IsEventDone( "use_seal3" ) ) then

      ObjAnimate( "spr_sealedcase_seal2",        "alp",    0, 0, "", { 0,3,0,  0.4,3,1 } );
      ObjAnimate( "spr_sealedcase_light_door_2", "alp", 0, 0, "", 
      { 
        0.0, 3, 0, 
        0.4, 0, 0, 
        0.6, 0, 1 
      } );
      ObjAnimate( "spr_sealedcase_door2_shadow", "alp",    0, 0, "", { 0,3,0, 0.6,3,0, 1.0,3,1 } );
      ObjAnimate( "spr_sealedcase_door1",        "pos_xy", 0, 0, func_end, { 0,3,-105,68, 0.6,3,-105,68, 1.0,3,-174,59,  1.4,3,-174,59 } );

    else

      ObjAnimate( "spr_sealedcase_seal2", "alp", 0, 0, "", { 0,3,0,  0.4,3,1 } );
      ObjAnimate( "spr_sealedcase_light_door_2", "alp", 0, 0, func_end, 
      { 
        0.0, 3, 0, 
        0.4, 0, 0, 
        0.6, 0, 1 
      } );    

    end;
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_seal3 ()

  local item = "inv_seal3";

  if cmn.ApplyObj( item, "gzz_archives_sealedcase" ) and ( cmn.IsEventDone( "get_mapsheet_2" ) )  then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_sealedcase", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_sealedcase_use_seal3" ) ) and ( cmn.IsEventDone( "get_mapsheet_2" ) )  then

    cmn.CallEventHandler( "use_seal3_inv" );
    cmn.CallEventHandler( "use_seal3_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_seal3" );
      cmn.CallEventHandler( "use_seal3_end" );

      if ( cmn.IsEventDone( "use_seal1" ) and 
           cmn.IsEventDone( "use_seal2" ) ) then

        common.CloseSubRoom(); 
        cmn.GotoRoom( 'mg_superpuzzle2' );

      end;

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk11", 0, "", 0 );

    if ( cmn.IsEventDone( "use_seal1" ) and  
         cmn.IsEventDone( "use_seal2" ) ) then

      ObjAnimate( "spr_sealedcase_seal3",        "alp",    0, 0, "", { 0,3,0,  0.4,3,1 } );   
      ObjAnimate( "spr_sealedcase_light_door_3", "alp", 0, 0, "", 
      { 
        0.0, 3, 0, 
        0.4, 0, 0, 
        0.6, 0, 1 
      } );
      ObjAnimate( "spr_sealedcase_door2_shadow", "alp",    0, 0, "", { 0,3,0, 0.6,3,0, 1.0,3,1 } );
      ObjAnimate( "spr_sealedcase_door1",        "pos_xy", 0, 0, func_end, { 0,3,-105,68, 0.6,3,-105,68, 1.0,3,-174,59,  1.4,3,-174,59 } );

    else

      ObjAnimate( "spr_sealedcase_seal3", "alp", 0, 0, "", { 0,3,0,  0.4,3,1 } );
      ObjAnimate( "spr_sealedcase_light_door_3", "alp", 0, 0, func_end, 
      { 
        0.0, 3, 0, 
        0.4, 0, 0, 
        0.6, 0, 1 
      } );    

    end;
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_hint ()

  local item = "inv_hint";

  if cmn.ApplyObj( item, "gzz_archives_videoplayer" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_videoplayer", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_videoplayer_use_hint" ) ) then

    cmn.CallEventHandler( "use_hint_inv" );
    cmn.CallEventHandler( "use_hint_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_hint" );
      cmn.CallEventHandler( "use_hint_end" );

      private.InitVideoplayerStart();

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "aud_paper", 0, "", 0 );

    cmn.ItemFly( "spr_videoplayer_hint", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_volumecontrol ()

  local item = "inv_volumecontrol";

  if cmn.ApplyObj( item, "gzz_archives_videoplayer" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_videoplayer", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_videoplayer_use_volumecontrol" ) ) then

    cmn.CallEventHandler( "use_volumecontrol_inv" );
    cmn.CallEventHandler( "use_volumecontrol_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_volumecontrol" );
      cmn.CallEventHandler( "use_volumecontrol_end" );

    end;

    local func_anim = function ()

      ObjSet( "spr_videoplayer_panel", { alp = 0 } );
      ObjSet( "anm_videoplayer_panel", { alp = 1 } );
      AnimPlay( "anm_videoplayer_panel", "DoAnim", func_end );

    end;

    local func = func_end;

    cmn.Lock( true );

    if cmn.IsEventDone( "use_cork" ) then

      func = func_anim;

    end;

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk6", 0, "", 0 );

    cmn.ItemFly( "spr_videoplayer_panel_regulator", func );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_cork ()

  local item = "inv_cork";

  if cmn.ApplyObj( item, "gzz_archives_videoplayer" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_videoplayer", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_videoplayer_use_cork" ) ) then

    cmn.CallEventHandler( "use_cork_inv" );
    cmn.CallEventHandler( "use_cork_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_cork" );
      cmn.CallEventHandler( "use_cork_end" );

    end;

    local func_anim = function ()

      ObjSet( "spr_videoplayer_panel", { alp = 0 } );
      ObjSet( "anm_videoplayer_panel", { alp = 1 } );
      AnimPlay( "anm_videoplayer_panel", "DoAnim", func_end );

    end;

    local func = func_end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_cork", 0, "", 0 );

    if cmn.IsEventDone( "use_volumecontrol" ) then

      func = func_anim;

    end;

    cmn.ItemFly( "spr_videoplayer_panel_cork", func );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_chip ()

  local item = "inv_chip";

  if cmn.ApplyObj( item, "gzz_archives_videoplayer" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_videoplayer", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_videoplayer_use_chip" ) ) then

    cmn.CallEventHandler( "use_chip_inv" );
    cmn.CallEventHandler( "use_chip_beg" );

    local func_anim = function ()

      local func_end = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_chip" );
        cmn.CallEventHandler( "use_chip_end" );

      end;

      ObjSet( "anm_videoplayer_noise", { alp = 1, active = true } );
      AnimPlay( "anm_videoplayer_cassete", "cassete", func_end );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_plate_archive", 0, "", 0 );

    cmn.ItemFly( "spr_videoplayer_chip", func_anim );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_pipepiece ()

  local item = "inv_pipepiece";

  if cmn.ApplyObj( item, "gzz_archives_surveillancecamera" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_surveillancecamera", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_surveillancecamera_use_pipepiece" ) ) then

    cmn.CallEventHandler( "use_pipepiece_inv" );
    cmn.CallEventHandler( "use_pipepiece_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_pipepiece" );
      cmn.CallEventHandler( "use_pipepiece_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_break_camera", 0, "", 0 );

    AnimPlay( "anm_surveillancecamera_camera", "DoAnim", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_hexkey_2 ()

  local item = "inv_hexkey";

  if cmn.ApplyObj( item, "gzz_archives_surveillancecamera" ) and ( not cmn.IsEventDone( "use_hexkey_2" ) ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_surveillancecamera", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_surveillancecamera_use_hexkey_2" ) ) and ( not cmn.IsEventDone( "use_hexkey_2" ) ) then

    cmn.CallEventHandler( "use_hexkey_2_inv" );
    cmn.CallEventHandler( "use_hexkey_2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_hexkey_2" );
      cmn.CallEventHandler( "use_hexkey_2_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_wrench1", 0, "", 0 );

    VidPlay( "vid_surveillancecamera_hexkey" , func_end );
    
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_volumecontrol ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_volumecontrol" );
  cmn.CallEventHandler( "get_volumecontrol" );

end;
--------------------------------------------------------------------------------------------
function private.get_videotape ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_videotape" );
  cmn.CallEventHandler( "get_videotape" );

end;
--------------------------------------------------------------------------------------------
function private.get_button1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_button1" );
  cmn.CallEventHandler( "get_button1" );

end;
--------------------------------------------------------------------------------------------
function private.get_button2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_button2" );
  cmn.CallEventHandler( "get_button2" );

end;
--------------------------------------------------------------------------------------------
function private.get_chip ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_chip" );
  cmn.CallEventHandler( "get_chip" );

  common.CloseSubRoom(); 

end;
--------------------------------------------------------------------------------------------
function private.get_mapsheet_2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_mapsheet_2" );
  cmn.CallEventHandler( "get_mapsheet_2" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************

--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG VIDEOPLAYER *** () end;
--*********************************************************************************************************************
  function private.InitVideoplayerStart ()

    ng_global.progress[ "std" ][ "win_videoplayer" ].state = { [ "blue" ] = 0,[ "yellow" ] = 0, [ "green" ] = 0 };
    ng_global.progress[ "std" ][ "win_videoplayer" ].win_state = { [ "blue" ] = 5,[ "yellow" ] = 3, [ "green" ] = 1 };
    ng_global.progress[ "std" ][ "win_videoplayer" ].current_color = 1;

    cmn.MiniGameShow( "videoplayer" );
    common_impl.PassingMgStart( "videoplayer" );

  end;
  --------------------------------------------------------------------------------------------
  function private.InitVideoplayer ()

    private.win_videoplayer_state = { [ "blue" ] = 0,[ "yellow" ] = 0, [ "green" ] = 0 };
    private.win_videoplayer_win = { [ "blue" ] = 5,[ "yellow" ] = 3, [ "green" ] = 1 };
    private.win_videoplayer_current_color = 1;
    private.win_videoplayer_color = { "blue", "green", "yellow" };

    ObjMultiSet( {  
      { "obj_videoplayer_click_blue",       { event_mdown  = function () private.ClkTVButton( "blue" ); end,
                                              event_menter = function () common_impl.SetCursor( CURSOR_HAND );  end,
                                              event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end } 
      },
      { "obj_videoplayer_click_yellow",     { event_mdown  = function () private.ClkTVButton( "yellow" ); end,
                                              event_menter = function () common_impl.SetCursor( CURSOR_HAND );  end,
                                              event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end } 
      },
      { "obj_videoplayer_click_green",      { event_mdown  = function () private.ClkTVButton( "green" ); end,
                                              event_menter = function () common_impl.SetCursor( CURSOR_HAND );  end,
                                              event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end } 
      },
    } );    

  end;
  --------------------------------------------------------------------------------------------
  function private.ClkTVButton ( color ) 

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk6", 0, "", 0 );

    local func_end = function ()

      local cur = private.win_videoplayer_current_color;
      
      if ( color == private.win_videoplayer_color[ cur ] ) then

        private.ClkTVButtonEnd( color );        

      else

        common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

        zz_videoplayer.Reset();       

      end;

    end;

    if ( private.win_videoplayer_state[ color ] + 1 == private.win_videoplayer_win[ color ] ) then

      cmn.Lock( true );
      ObjAnimate( "spr_videoplayer_click_"..color, "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0, 
        0.3, 0, 1,
      } ); 

    else  

      cmn.Lock( true );
      ObjAnimate( "spr_videoplayer_click_"..color, "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0, 
        0.2, 0, 1, 
        0.4, 0, 0 
      } ); 

    end; 
    ObjAnimate( "obj_videoplayer_noise1", "alp", 0, 0, "", 
    { 
      0.0, 0, 0, 
      0.1, 0, 1, 
      0.2, 0, 1, 
      0.3, 0, 0, 
    } );  

  end;
  --------------------------------------------------------------------------------------------
  function private.ClkTVButtonEnd ( color ) 

    private.win_videoplayer_state[ color ] = private.win_videoplayer_state[ color ] + 1;
 
    if ( private.win_videoplayer_state[ color ] == private.win_videoplayer_win[ color ] ) then

      private.win_videoplayer_current_color = private.win_videoplayer_current_color + 1;

    end;

    local type = private.VideoplayerIsWin();
    
    if ( type == 1 ) then

      private.WinVideoplayer();

    elseif ( type == 2 ) then

      zz_videoplayer.Reset();

    elseif ( type == 3 ) then

      private.VideoplayerSaveVar();

    end;

  end;
  --------------------------------------------------------------------------------------------
  function private.VideoplayerSaveVar ()

    cmn.Lock( false );
    ng_global.progress[ "std" ][ "win_videoplayer" ].state[ "blue" ] = private.win_videoplayer_state[ "blue" ]; 
    ng_global.progress[ "std" ][ "win_videoplayer" ].state[ "yellow" ] = private.win_videoplayer_state[ "yellow" ]; 
    ng_global.progress[ "std" ][ "win_videoplayer" ].state[ "green" ] = private.win_videoplayer_state[ "green" ]; 

    ng_global.progress[ "std" ][ "win_videoplayer" ].current_color = private.win_videoplayer_current_color;

  end;
  --------------------------------------------------------------------------------------------
  function private.VideoplayerIsWin ()

    local bool = -1;

    if ( private.win_videoplayer_state[ "blue" ] == private.win_videoplayer_win[ "blue" ] and 
         private.win_videoplayer_state[ "yellow" ] == private.win_videoplayer_win[ "yellow" ] and 
         private.win_videoplayer_state[ "green" ] == private.win_videoplayer_win[ "green" ] ) then

      bool = 1;

    elseif ( private.win_videoplayer_state[ "blue" ] > private.win_videoplayer_win[ "blue" ] or 
             private.win_videoplayer_state[ "yellow" ] > private.win_videoplayer_win[ "yellow" ] or 
             private.win_videoplayer_state[ "green" ] > private.win_videoplayer_win[ "green" ] ) then

      bool = 2;

    else 

      bool = 3;

    end;

    return bool;

  end;
  --------------------------------------------------------------------------------------------
  function private.WinVideoplayer ()

    cmn.Lock( false );
    ng_global.progress[ "std" ][ "win_videoplayer" ].state = { [ "blue" ] = 5,[ "yellow" ] = 3, [ "green" ] = 1 };
    common.CloseSubRoom(); 

    cmn.MiniGameHide( "videoplayer" );
    common_impl.PassingMgWin( "videoplayer"); 

    cmn.SetEventDone( "win_videoplayer" );
    cmn.CallEventHandler( "win_videoplayer" );      

  end;
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_archives ()

  if not ( cmn.IsEventDone( "opn_archives" ) ) then

    common_impl.ShowBbt( "bbt_archives_opn_archives" );

    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "find_archived_data" );

    cmn.SetEventDone( "opn_archives" );

  end; 

  cmn.CallEventHandler( "opn_archives" );

end;
--------------------------------------------------------------------------------------------
function private.see_outro_lvl2 ()

  local func_end = function ()

    cmn.SetEventDone( "see_outro_lvl2" );
    cmn.CallEventHandler( "see_outro_lvl2" );

    common_impl.StopAudio( "sfx", "level2/sfx/aud_outro_lvl2", 0.2 );
    common_impl.StopAudio( "voc", "level2/voc/aud_outro_lvl2_voc", 0.2 );

    SetCursor(CURSOR_DEFAULT);
    local prg = ng_global.currentprogress;
    ng_global.progress[ prg ].common.chapter = "level3";
    ng_global.progress[ prg ].common.currentroom = nil;
    local level = ng_global.progress[ prg ].common.chapter;

    common.LevelSwitch( level );

  end;

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_outro_lvl2", 0, "", 0 );
  common_impl.PlayAudio( "voc", "level2/voc/aud_outro_lvl2_voc", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_archives_outro_lvl2", func_end );

end;

--------------------------------------------------------------------------------------------
function private.ClkPanel ()

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk9", 0, "", 0 );

  ObjAnimate( "spr_videoplayer_panel", "ang", 0, 0, function() cmn.Lock( false ) end, { 0, 0, 0,   0.1, 3, -0.01,   0.2, 3, 0 } );

end;



--*********************************************************************************************************************