-- name=rm_childrensroom
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_childrensroom";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_dollhouse", "room_hub" );
  ObjAttach( "zz_dolls", "room_hub" );
  ObjAttach( "zz_pram", "room_hub" );
  private.Init_Subroom();
  private.InitAnimations();

  ObjMultiSet( { 
    { "spr_dollhouse_trianglekey",                    { event_mdown = private.get_trianglekey   } },
    { "spr_dollhouse_dollhead",                       { event_mdown = private.get_dollhead      } },
    { "spr_dollhouse_dummyshand",                     { event_mdown = private.get_dummyshand    } },
    { "spr_dolls_dollhousepart",                      { event_mdown = private.get_dollhousepart } },
    { "spr_dolls_tuner",                              { event_mdown = private.get_tuner         } },
    { "spr_dolls_voodoodoll",                         { event_mdown = private.get_voodoodoll    } },
    { "spr_pram_plate",                               { event_mdown = private.get_plate         } },
    { "spr_pram_handle",                              { event_mdown = private.get_handle        } },
    { "obj_pram_clk_blanket",                         { event_mdown = private.clk_blanket       } },
    { "obj_dolls_clk_tuner_1",                        { event_mdown = private.clk_tuner_1       } },
    { "obj_dolls_clk_tuner_2",                        { event_mdown = private.clk_tuner_2       } },
    { "obj_dollhouse_use_antirust_2_1",               { event_mdown = private.UseAntirust_2_1   } },
    { "obj_dollhouse_clk_dollhead",                   { event_mdown = private.clk_dollhead      } },
    { "obj_dollhouse_use_dollhousepart",              { event_mdown = private.UseDollhousepart  } },
    { "obj_dollhouse_use_lockpickset",                { event_mdown = private.UseLockpickset    } },
    { "obj_pram_clk_tv",                              { event_mdown = private.ClkTV             } },
    { "obj_dolls_use_handle",                         { event_mdown = private.ClkDollCloseCover } },
    { "obj_dolls_clk_handle",                         { event_mdown = private.clk_handle        } },

    { "spr_collect2_item_2_1",                        { event_mdown = private.get_collect2_item_2_1 } }, 
    { "spr_childrensroom_collect_item",               { event_mdown = function () common_impl.GetCollectItem( "get_collect_item_2_1" ); end } },
    { "spr_childrensroom_collect_morph_item",         { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_2_2" ); end } },
  } );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_childrensroom = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "gho_childrensroom_indollhouse",
      "gzz_childrensroom_dollhouse",
      "gzz_childrensroom_dolls",
      "gzz_childrensroom_pram"
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_dollhouse",
      "zz_dolls",
      "zz_pram",
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_childrensroom", update_game_mode_childrensroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_childrensroom = function ()

  local effects_table = 
  {
    "anm_childrensroom_clouds",
    "anm_childrensroom_pram_tv_glow",
    "anm_childrensroom_dolls_flag",
    "anm_childrensroom_dollhouse_clown_static_with_head",
    "anm_childrensroom_dollhouse_clown_static_no_head",
    "anm_childrensroom_dollhouse_clown_static_no_arm",
    "anm_childrensroom_clown",
    "anm_childrensroom_horse_airplane",
    "anm_dolls_voodoodoll_2",
    "anm_pram_tv_light",
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_childrensroom", update_performance_mode_childrensroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_childrensroom () end;
  --------------------------------------------------------------------------------------------
  local opn_childrensroom_map = function ()

    common_impl.VisitMapRoom( "childrensroom" );

  end;
  cmn.AddSubscriber( "opn_childrensroom", opn_childrensroom_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_trianglekey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_trianglekey" ] = {
    type = "get",
    get_obj = "spr_dollhouse_trianglekey",
    room = private.room_objname,
    zz = "zz_dollhouse",
    zz_gate = "gzz_childrensroom_dollhouse"
  };
  
  local get_trianglekey_inv = function ()
  
    interface.InventoryItemAdd( "inv_trianglekey", "spr_dollhouse_trianglekey" );
  
  end;
  
  local get_trianglekey_closezz = function ()
  
    ObjDelete( "gfx_dollhouse_trianglekey" );
    ObjDelete( "spr_dollhouse_key_shadow" );

    ObjDelete( "spr_childrensroom_dollhouse_key" );
  
  end;
  
  cmn.AddSubscriber( "get_trianglekey", get_trianglekey_inv );
  cmn.AddSubscriber( "get_trianglekey", get_trianglekey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_dollhead () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_dollhead" ] = {
    type = "get",
    get_obj = "spr_dollhouse_dollhead",
    room = private.room_objname,
    zz = "zz_dollhouse",
    zz_gate = "gzz_childrensroom_dollhouse"
  };
  
  local get_dollhead_inv = function ()
  
    interface.InventoryItemAdd( "inv_dollhead", "spr_dollhouse_dollhead" );
  
  end;

  local get_dollhead_closezz = function ()

    ObjSet( "spr_dollhouse_dollhead", { alp = 1 } );

    ObjDelete( "gfx_dollhouse_dollhead" );
    ObjDelete( "spr_dollhouse_hand_shadow" );
    ObjSet( "obj_dollhouse_use_plate", { input = true } );

    ObjDelete( "spr_childrensroom_dollhouse_doll_head" );

    ObjDelete( "anm_dollhouse_anm_clown_static_with_head" );
    ObjDelete( "anm_childrensroom_dollhouse_clown_static_with_head" );

    ObjSet( "anm_dollhouse_anm_clown_static_no_head", { alp = 1 } );
    ObjSet( "anm_childrensroom_dollhouse_clown_static_no_head", { alp = 1, playing = true } );
  
  end;
  
  cmn.AddSubscriber( "get_dollhead", get_dollhead_inv );
  cmn.AddSubscriber( "get_dollhead", get_dollhead_closezz, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_dummyshand () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_dummyshand" ] = {
    type = "get",
    get_obj = "spr_dollhouse_dummyshand",
    room = private.room_objname,
    zz = "zz_dollhouse",
    zz_gate = "gzz_childrensroom_dollhouse"
  };
  
  local get_dummyshand_inv = function ()
  
    interface.InventoryItemAdd( "inv_dummyshand", "spr_dollhouse_dummyshand" );
  
  end;
  
  local get_dummyshand_closezz = function ()
  
    ObjDelete( "gfx_dollhouse_dummyshand" );

    ObjDelete( "spr_childrensroom_dollhouse_doll_hand" );

  end;
  
  cmn.AddSubscriber( "get_dummyshand", get_dummyshand_inv );
  cmn.AddSubscriber( "get_dummyshand", get_dummyshand_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_dollhousepart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_dollhousepart" ] = {
    type = "get",
    get_obj = "spr_dolls_dollhousepart",
    room = private.room_objname,
    zz = "zz_dolls",
    zz_gate = "gzz_childrensroom_dolls"
  };
  
  local get_dollhousepart_inv = function ()
  
    interface.InventoryItemAdd( "inv_dollhousepart", "spr_dolls_dollhousepart" );
  
  end;
  
  local get_dollhousepart_closezz = function ()
  
    ObjDelete( "gfx_dolls_dollhousepart" );

    ObjDelete( "spr_childrensroom_dolls_openbody_dollhousepart" );
  
  end;
  
  cmn.AddSubscriber( "get_dollhousepart", get_dollhousepart_inv );
  cmn.AddSubscriber( "get_dollhousepart", get_dollhousepart_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tuner () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tuner" ] = {
    type = "get",
    get_obj = "spr_dolls_tuner",
    room = private.room_objname,
    zz = "zz_dolls",
    zz_gate = "gzz_childrensroom_dolls"
  };
  
  local get_tuner_inv = function ()
  
    interface.InventoryItemAdd( "inv_tuner", "spr_dolls_tuner" );
  
  end;
  
  local get_tuner_closezz = function ()
  
    ObjDelete( "gfx_dolls_tuner" );
    ObjDelete( "spr_dolls_tuner_shadow" );
  
  end;
    
  cmn.AddSubscriber( "get_tuner", get_tuner_inv );
  cmn.AddSubscriber( "get_tuner", get_tuner_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_voodoodoll () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_voodoodoll" ] = {
    type = "get",
    get_obj = "spr_dolls_voodoodoll",
    room = private.room_objname,
    zz = "zz_dolls",
    zz_gate = "gzz_childrensroom_dolls"
  };
  
  local get_voodoodoll_inv = function ()
  
    interface.InventoryItemAdd( "inv_voodoodoll", "spr_dolls_voodoodoll" );
  
    ObjSet( "inv_voodoodoll", { drag = false } );

  end;
  
  local get_voodoodoll_closezz = function ()

    ObjSet( "spr_dolls_voodoodoll", { alp = 1 } );

    ObjDelete( "anm_dolls_voodoodoll_2" );
    ObjDelete( "gfx_dolls_voodoodoll" );
    ObjDelete( "gzz_childrensroom_dolls" );
  
  end;
  
  cmn.AddSubscriber( "get_voodoodoll", get_voodoodoll_inv );
  cmn.AddSubscriber( "get_voodoodoll", get_voodoodoll_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_plate () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_plate" ] = {
    type = "get",
    get_obj = "spr_pram_plate",
    room = private.room_objname,
    zz = "zz_pram",
    zz_gate = "gzz_childrensroom_pram"
  };
  
  local get_plate_inv = function ()
  
    interface.InventoryItemAdd( "inv_plate", "spr_pram_plate" );
  
  end;
  
  local get_plate_closezz = function ()
  
    ObjDelete( "gfx_pram_plate" );

    ObjDelete( "spr_childrensroom_pram_chip" );
  
  end;
  
  cmn.AddSubscriber( "get_plate", get_plate_inv );
  cmn.AddSubscriber( "get_plate", get_plate_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_handle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_handle" ] = {
    type = "get",
    get_obj = "spr_pram_handle",
    room = private.room_objname,
    zz = "zz_pram",
    zz_gate = "gzz_childrensroom_pram"
  };
  
  local get_handle_inv = function ()
  
    interface.InventoryItemAdd( "inv_handle", "spr_pram_handle" );
  
  end;
  
  local get_handle_closezz = function ()
  
    ObjDelete( "gfx_pram_handle" );

    if ( cmn.IsGetCollect2( "get_collect2_item_2_1" ) ) then

      ObjDelete( "gzz_childrensroom_pram" );  

    end;

  end;
  
  cmn.AddSubscriber( "get_handle", get_handle_inv );
  cmn.AddSubscriber( "get_handle", get_handle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_2_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_2_1 = function ()
  
    ObjDelete( "obj_collect2_item_2_1" );
    if ( cmn.IsEventDone( "get_handle" ) ) then

      ObjDelete( "gzz_childrensroom_pram" );
  
    end;

  end;    
  cmn.AddSubscriber( "get_collect2_item_2_1", get_collect2_item_2_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_2_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_2_1 = function ()
  
    ObjDelete( "obj_childrensroom_collect" );
  
  end;    
  cmn.AddSubscriber( "get_collect_item_2_1", get_collect_item_2_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2_2 = function ()
  
    ObjDelete( "obj_childrensroom_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_2_2", get_collect_morph_item_2_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_antirust_2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_antirust_2_1" ] = {
    type = "use",
    inv_obj = "inv_antirust_2",
    use_place = "obj_dollhouse_use_antirust_2_1",
    room = private.room_objname,
    zz = "zz_dollhouse",
    zz_gate = "gzz_childrensroom_dollhouse"
  };
  local use_antirust_2_1_inv = function ()
  

  end;
  local use_antirust_2_1_beg = function ()
  
    ObjDelete( "obj_dollhouse_use_antirust_2_1" );

    ObjDelete( "obj_dollhouse_rust" );
    ObjDelete( "obj_dollhouse_flap_close" );
    ObjSet( "obj_dollhouse_flap_close_antirust", { alp = 1 } );
  
  end;
  local use_antirust_2_1_end = function ()

    ObjDelete( "vid_dollhouse_antirust" );
    ObjSet( "obj_dollhouse_clk_dollhead", { input = true, active = true } );

    --ObjDelete( "spr_childrensroom_dollhouse_sash_close1" );
    --ObjSet( "spr_childrensroom_dollhouse_doll_body", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_antirust_2_1", use_antirust_2_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_antirust_2_1", use_antirust_2_1_inv );
  cmn.AddSubscriber( "use_antirust_2_1", use_antirust_2_1_end, private.room_objname );
  cmn.AddSubscriber( "use_antirust_2_1_inv", use_antirust_2_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_antirust_2_1_beg", use_antirust_2_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_antirust_2_1_end", use_antirust_2_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_dollhousepart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_dollhousepart" ] = {
    type = "use",
    inv_obj = "inv_dollhousepart",
    use_place = "obj_dollhouse_use_dollhousepart",
    room = private.room_objname,
    zz = "zz_dollhouse",
    zz_gate = "gzz_childrensroom_dollhouse"
  };
  local use_dollhousepart_inv = function ()
  
    interface.InventoryItemRemove( "inv_dollhousepart" );
  
  end;
  local use_dollhousepart_beg = function ()
  
    ObjDelete( "obj_dollhouse_use_dollhousepart" );
  
  end;
  local use_dollhousepart_end = function ()

    ObjSet( "spr_dollhouse_house_part", { alp = 1 } );
    ObjSet( "spr_dollhouse_closed_window2_right", { pos_x = 3, pos_y = -78 } );
    ObjSet( "spr_dollhouse_closed_window2_left", { pos_x = -251, pos_y = -112 } );
    ObjSet( "spr_dollhouse_trianglekey", { input = true, active = true } );

    ObjDelete( "spr_childrensroom_dollhouse_sash_close2" );
    ObjSet( "spr_childrensroom_dollhouse_sash_open2", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_dollhousepart", use_dollhousepart_beg, private.room_objname );
  cmn.AddSubscriber( "use_dollhousepart", use_dollhousepart_inv );
  cmn.AddSubscriber( "use_dollhousepart", use_dollhousepart_end, private.room_objname );
  cmn.AddSubscriber( "use_dollhousepart_inv", use_dollhousepart_inv, private.room_objname );
  cmn.AddSubscriber( "use_dollhousepart_beg", use_dollhousepart_beg, private.room_objname );
  cmn.AddSubscriber( "use_dollhousepart_end", use_dollhousepart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_plate () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_plate" ] = {
    type = "use",
    inv_obj = "inv_plate",
    use_place = "obj_dollhouse_use_plate",
    room = private.room_objname,
    zz = "zz_dollhouse",
    zz_gate = "gzz_childrensroom_dollhouse"
  };
  local use_plate_inv = function ()
  
    interface.InventoryItemRemove( "inv_plate" );
  
  end;
  local use_plate_beg = function ()
  
    ObjDelete( "obj_dollhouse_use_plate" );
  
  end;
  local use_plate_end = function ()

    ObjDelete( "anm_dollhouse_anm_clown_static_no_head" );
    ObjDelete( "anm_childrensroom_dollhouse_clown_static_no_head" );

    ObjDelete( "anm_dollhouse_clown_drop_hand"          );
    ObjSet( "anm_dollhouse_anm_clown_static_no_arm", { alp = 1 } );
    ObjSet( "anm_childrensroom_dollhouse_clown_static_no_arm", { alp = 1, playing = true } );
    ObjSet( "spr_dollhouse_dummyshand",              { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_plate", use_plate_beg, private.room_objname );
  cmn.AddSubscriber( "use_plate", use_plate_inv );
  cmn.AddSubscriber( "use_plate", use_plate_end, private.room_objname );
  cmn.AddSubscriber( "use_plate_inv", use_plate_inv, private.room_objname );
  cmn.AddSubscriber( "use_plate_beg", use_plate_beg, private.room_objname );
  cmn.AddSubscriber( "use_plate_end", use_plate_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lockpickset () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lockpickset" ] = {
    type = "use",
    inv_obj = "inv_lockpickset",
    use_place = "obj_dollhouse_use_lockpickset",
    room = private.room_objname,
    zz = "zz_dollhouse",
    zz_gate = "gzz_childrensroom_dollhouse"
  };
  local use_lockpickset_inv = function ()
  
    interface.InventoryItemRemove( "inv_lockpickset" );
  
  end;
  local use_lockpickset_beg = function ()
  
    ObjDelete( "obj_dollhouse_use_lockpickset" );
    ObjDelete( "gzz_childrensroom_dollhouse" );

  end;
  local use_lockpickset_end = function ()
  
    ObjDelete( "spr_dollhouse_door" );
    ObjSet( "spr_dollhouse_door_opened", { alp = 1 } );
    ObjSet( "gho_childrensroom_indollhouse", { input = true, active = true } );

    ObjSet( "spr_childrensroom_ho", { alp = 1 } );

    ObjDelete( "anm_dollhouse_latchkey" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lockpickset", use_lockpickset_beg, private.room_objname );
  cmn.AddSubscriber( "use_lockpickset", use_lockpickset_inv );
  cmn.AddSubscriber( "use_lockpickset", use_lockpickset_end, private.room_objname );
  cmn.AddSubscriber( "use_lockpickset_inv", use_lockpickset_inv, private.room_objname );
  cmn.AddSubscriber( "use_lockpickset_beg", use_lockpickset_beg, private.room_objname );
  cmn.AddSubscriber( "use_lockpickset_end", use_lockpickset_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_dollhead () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_dollhead" ] = {
    type = "use",
    inv_obj = "inv_dollhead",
    use_place = "obj_dolls_use_dollhead",
    room = private.room_objname,
    zz = "zz_dolls",
    zz_gate = "gzz_childrensroom_dolls"
  };
  local use_dollhead_inv = function ()
  
    interface.InventoryItemRemove( "inv_dollhead" );
  
  end;
  local use_dollhead_beg = function ()
  
    ObjDelete( "obj_dolls_use_dollhead" );
  
  end;
  local use_dollhead_end = function ()
  
    ObjSet( "spr_dolls_dollhousepart", { input = true, active = true, visible = true } );
    ObjSet( "gfx_dolls_dollhousepart", { active = true } );
    ObjSet( "spr_dolls_close_doll", { ang = -0.88 } );
    ObjSet( "spr_dolls_dollhead", { alp = 1 } );
    ObjSet( "spr_dolls_spring_1", { alp = 1 } );
    ObjSet( "spr_dolls_spring_2", { alp = 1 } );

    ObjDelete( "anm_dolls_springs" );

    ObjSet( "spr_childrensroom_dolls_head", { alp = 1 } );
    ObjSet( "spr_childrensroom_dolls_openbody", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_dollhead", use_dollhead_beg, private.room_objname );
  cmn.AddSubscriber( "use_dollhead", use_dollhead_inv );
  cmn.AddSubscriber( "use_dollhead", use_dollhead_end, private.room_objname );
  cmn.AddSubscriber( "use_dollhead_inv", use_dollhead_inv, private.room_objname );
  cmn.AddSubscriber( "use_dollhead_beg", use_dollhead_beg, private.room_objname );
  cmn.AddSubscriber( "use_dollhead_end", use_dollhead_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hanky () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hanky" ] = {
    type = "use",
    inv_obj = "inv_hanky",
    use_place = "obj_dolls_use_hanky",
    room = private.room_objname,
    zz = "zz_dolls",
    zz_gate = "gzz_childrensroom_dolls"
  };
  local use_hanky_inv = function ()
  
    interface.InventoryItemRemove( "inv_hanky" );
  
  end;
  local use_hanky_beg = function ()
  
    ObjDelete( "obj_dolls_use_hanky" );
  
  end;
  local use_hanky_end = function ()

    ObjSet( "spr_dolls_tuner", { input = true, active = true } );

    ObjDelete( "spr_dolls_web_tuner" );
    ObjDelete( "spr_dolls_spider" );
    ObjDelete( "anm_dolls_hanky" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hanky", use_hanky_beg, private.room_objname );
  cmn.AddSubscriber( "use_hanky", use_hanky_inv );
  cmn.AddSubscriber( "use_hanky", use_hanky_end, private.room_objname );
  cmn.AddSubscriber( "use_hanky_inv", use_hanky_inv, private.room_objname );
  cmn.AddSubscriber( "use_hanky_beg", use_hanky_beg, private.room_objname );
  cmn.AddSubscriber( "use_hanky_end", use_hanky_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_handle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_handle" ] = {
    type = "use",
    inv_obj = "inv_handle",
    use_place = "obj_dolls_use_handle",
    room = private.room_objname,
    zz = "zz_dolls",
    zz_gate = "gzz_childrensroom_dolls"
  };
  local use_handle_inv = function ()
  
    interface.InventoryItemRemove( "inv_handle" );
  
  end;
  local use_handle_beg = function ()
  
    ObjDelete( "obj_dolls_use_handle" );

  end;
  local use_handle_end = function ()
  
  ObjMultiSet( { 
    { "obj_dolls_clk_handle", { input = true, active = true }  },
    { "spr_dolls_handle",     { alp = 1                     }  },

  } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_handle", use_handle_beg, private.room_objname );
  cmn.AddSubscriber( "use_handle", use_handle_inv );
  cmn.AddSubscriber( "use_handle", use_handle_end, private.room_objname );
  cmn.AddSubscriber( "use_handle_inv", use_handle_inv, private.room_objname );
  cmn.AddSubscriber( "use_handle_beg", use_handle_beg, private.room_objname );
  cmn.AddSubscriber( "use_handle_end", use_handle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_dummyshand () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_dummyshand" ] = {
    type = "use",
    inv_obj = "inv_dummyshand",
    use_place = "obj_pram_use_dummyshand",
    room = private.room_objname,
    zz = "zz_pram",
    zz_gate = "gzz_childrensroom_pram"
  };
  local use_dummyshand_inv = function ()
  
    interface.InventoryItemRemove( "inv_dummyshand" );
  
  end;
  local use_dummyshand_beg = function ()
  
    ObjDelete( "obj_pram_use_dummyshand" );
  
  end;
  local use_dummyshand_end = function ()
  
    ObjSet( "spr_pram_handle", { alp = 1, input = true, active = true } );
    ObjSet( "anm_pram_hand", { alp = 0, input = true } );    
    ObjSet( "spr_pram_scorpions_patch", { alp = 1 } );


  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_dummyshand", use_dummyshand_beg, private.room_objname );
  cmn.AddSubscriber( "use_dummyshand", use_dummyshand_inv );
  cmn.AddSubscriber( "use_dummyshand", use_dummyshand_end, private.room_objname );
  cmn.AddSubscriber( "use_dummyshand_inv", use_dummyshand_inv, private.room_objname );
  cmn.AddSubscriber( "use_dummyshand_beg", use_dummyshand_beg, private.room_objname );
  cmn.AddSubscriber( "use_dummyshand_end", use_dummyshand_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tuner () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tuner" ] = {
    type = "use",
    inv_obj = "inv_tuner",
    use_place = "obj_pram_use_tuner",
    room = private.room_objname,
    zz = "zz_pram",
    zz_gate = "gzz_childrensroom_pram"
  };
  local use_tuner_inv = function ()
  
    interface.InventoryItemRemove( "inv_tuner" );
  
  end;
  local use_tuner_beg = function ()
  
    ObjDelete( "obj_pram_use_tuner" );
  
  end;
  local use_tuner_end = function ()
  
    ObjMultiSet( { 
      { "obj_pram_broken_tv",          { alp = 1, input = true } },
      { "spr_pram_tuner",              { alp = 1               } },
      { "spr_childrensroom_pram_tv_2", { alp = 1               } },
    } );

    ObjDelete( "obj_pram_clk_tv" );
    ObjDelete( "vid_parm_tv_noise" );
    ObjDelete( "anm_pram_tv" );

    ObjDelete( "anm_pram_tv_light" );
    ObjDelete( "anm_childrensroom_pram_tv_glow" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tuner", use_tuner_beg, private.room_objname );
  cmn.AddSubscriber( "use_tuner", use_tuner_inv );
  cmn.AddSubscriber( "use_tuner", use_tuner_end, private.room_objname );
  cmn.AddSubscriber( "use_tuner_inv", use_tuner_inv, private.room_objname );
  cmn.AddSubscriber( "use_tuner_beg", use_tuner_beg, private.room_objname );
  cmn.AddSubscriber( "use_tuner_end", use_tuner_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_blanket () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_blanket" ] = {
    type = "click",
    use_place = "obj_pram_clk_blanket",
    room = private.room_objname,
    zz = "zz_pram",
    zz_gate = "gzz_childrensroom_pram"
  };

  local clk_blanket_beg = function ()
  
    ObjDelete( "obj_pram_clk_blanket" );
  
  end;
  local clk_blanket_end = function ()

    ObjSet( "obj_pram_use_dummyshand", { active = true, input = true } );
    ObjDelete( "anm_pram_blanket" );

    ObjSet( "spr_childrensroom_pram_cover", { alp = 1 } )

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_blanket", clk_blanket_beg, private.room_objname );
  cmn.AddSubscriber( "clk_blanket", clk_blanket_end, private.room_objname );
  cmn.AddSubscriber( "clk_blanket_beg", clk_blanket_beg, private.room_objname );
  cmn.AddSubscriber( "clk_blanket_end", clk_blanket_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_dollhead () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_dollhead" ] = {
    type = "click",
    use_place = "obj_dollhouse_clk_dollhead",
    room = private.room_objname,
    zz = "zz_dollhouse",
    zz_gate = "gzz_childrensroom_dollhouse"
  };

  local clk_dollhead_beg = function ()
  
    ObjDelete( "obj_dollhouse_clk_dollhead" );

    ObjDelete( "obj_dollhouse_flap_close_antirust" );
  
  end;
  local clk_dollhead_end = function ()

    ObjMultiSet( { 
      { "spr_dollhouse_dollhead",                               { input = true, active = true } },
      { "spr_dollhouse_opened_window1",                         { alp = 1                     } },
      { "anm_dollhouse_anm_clown_static_with_head",             { alp = 1                     } },
      { "anm_childrensroom_dollhouse_clown_static_with_head",   { alp = 1, playing = true     } },
    } );

    ObjDelete( "anm_dollhouse_clown_boo" );
    ObjDelete( "spr_childrensroom_dollhouse_sash_close1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_dollhead", clk_dollhead_beg, private.room_objname );
  cmn.AddSubscriber( "clk_dollhead", clk_dollhead_end, private.room_objname );
  cmn.AddSubscriber( "clk_dollhead_beg", clk_dollhead_beg, private.room_objname );
  cmn.AddSubscriber( "clk_dollhead_end", clk_dollhead_end, private.room_objname );

 --------------------------------------------------------------------------------------------
  -- function clk_handle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_handle" ] = {
    type = "click",
    use_place = "obj_dolls_clk_handle",
    room = private.room_objname,
    zz = "zz_dolls",
    zz_gate = "gzz_childrensroom_dolls"
  };

  local clk_handle_beg = function ()
  
    ObjDelete( "obj_dolls_clk_handle" );
    ObjSet( "spr_dolls_handle", { alp = 0 });
  
  end;
  local clk_handle_end = function ()

    ObjDelete( "anm_dolls_handle"     );
    ObjDelete( "anm_dolls_voodoodoll" );
    ObjDelete( "spr_dolls_close_cover" );

    ObjMultiSet( { 
      { "anm_dolls_voodoodoll_2",    { active = true, alp = 1 } },
      { "obj_dolls_open",            { input = true, active = true, alp = 1 } },
      { "spr_dolls_handle",          { alp = 1 } },
      { "spr_dolls_voodoodoll_over", { alp = 1 } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_handle",     clk_handle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_handle",     clk_handle_end, private.room_objname );
  cmn.AddSubscriber( "clk_handle_beg", clk_handle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_handle_end", clk_handle_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function see_childrensroom_scare_1 () end;
  --------------------------------------------------------------------------------------------
  local see_childrensroom_scare_1 = function ()

    ObjDelete( "anm_childrensroom_clown"   );
    ObjDelete( "anm_childrensroom_clown_2" );

    ObjSet( "spr_childrensroom_clown", { alp = 1 } );

  end;
  cmn.AddSubscriber( "see_childrensroom_scare_1", see_childrensroom_scare_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_parm_masked_man () end;
  --------------------------------------------------------------------------------------------
  local see_parm_masked_man = function ()

    ObjDelete( "vid_parm_masked_man" );
    ObjSet( "anm_pram_tv_light", { alp = 1 } );

  end;
  cmn.AddSubscriber( "see_parm_masked_man", see_parm_masked_man, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()

  --*******************************************************************************************************************
  --*** function zz_dolls () end ****
  -- зз куклы
    subroom.Define( "zz_dolls" );
    function zz_dolls.Open ()
    end;
    -------------------------------------------------
    function zz_dolls.PreOpen ()
    end;
    -------------------------------------------------
    function zz_dolls.PreClose ()
    end;
    -------------------------------------------------
    function zz_dolls.Close ()

      if ( cmn.IsEventDone( "get_tuner" ) and not cmn.IsEventDone( "see_childrensroom_scare_1" ) ) then

        private.ChildrensroomScare_1();

      end;

    end;
  --*******************************************************************************************************************
  --*** function zz_pram () end ****
  -- зз куклы
    subroom.Define( "zz_pram" );
    function zz_pram.Open ()

      if not ( cmn.IsEventDone( "see_parm_masked_man" ) ) then

        private.see_parm_masked_man();

      end;

    end;
    -------------------------------------------------
    function zz_pram.PreOpen ()

      if ( cmn.IsEventDone( "clk_blanket" ) ) then

        common_impl.PlayAudio( "env", "level2/env/aud_scorpion_env", 1, "", 0 );

      end;

    end;
    -------------------------------------------------
    function zz_pram.PreClose ()

      if ( cmn.IsEventDone( "clk_blanket" ) ) then

        common_impl.StopAudio( "env", "level2/env/aud_scorpion_env", 0.2 );

      end;

    end;
    -------------------------------------------------
    function zz_pram.Close ()
    end;

 --*******************************************************************************************************************
  --*** function zz_dollhouse () end ****

    subroom.Define( "zz_dollhouse" );
    function zz_dollhouse.Open ()
    end;
    -------------------------------------------------
    function zz_dollhouse.PreOpen ()

      if ( cmn.IsEventDone( "use_plate" ) ) then

        AnimPlay( "anm_dollhouse_anm_clown_static_no_arm", "no_arm", "" );
      
      elseif ( cmn.IsEventDone( "get_dollhead" ) ) then

        AnimPlay( "anm_dollhouse_anm_clown_static_no_head", "no_head", "" );

      elseif ( cmn.IsEventDone( "clk_dollhead" ) ) then

        AnimPlay( "anm_dollhouse_anm_clown_static_with_head", "with_head", "" );

      end;

    end;
    -------------------------------------------------
    function zz_dollhouse.PreClose ()
    end;
    -------------------------------------------------
    function zz_dollhouse.Close ()
    end;

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_childrensroom();

  if ( cmn.IsEventDone( "get_tuner" ) and not cmn.IsEventDone( "see_childrensroom_scare_1" ) ) then

    private.ChildrensroomScare_1 ();

  end;

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "level2/env/aud_childrensroom_env" }, "", 0.5 );

  common_impl.CollectItemMorphing();
  common_impl.MorphItemMorphing();

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_antirust_2_1 ()

  local item = "inv_antirust_2";

  if cmn.ApplyObj( item, "gzz_childrensroom_dollhouse" ) and ( not cmn.IsEventDone( "use_antirust_2_1" ) ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_dollhouse", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_dollhouse_use_antirust_2_1" ) ) and ( not cmn.IsEventDone( "use_antirust_2_1" ) ) then

    cmn.CallEventHandler( "use_antirust_2_1_inv" );
    cmn.CallEventHandler( "use_antirust_2_1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_antirust_2_1" );
      cmn.CallEventHandler( "use_antirust_2_1_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_spray1", 0, "", 0 );

    ObjSet( "vid_dollhouse_antirust", { alp = 1 } );
    VidPlay( "vid_dollhouse_antirust", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_dollhousepart ()

  local item = "inv_dollhousepart";

  if cmn.ApplyObj( item, "gzz_childrensroom_dollhouse" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_dollhouse", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_dollhouse_use_dollhousepart" ) ) then

    cmn.CallEventHandler( "use_dollhousepart_inv" );
    cmn.CallEventHandler( "use_dollhousepart_beg" );

    local func_end = function ()

      private.use_dollhousepart_end();

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_flower_door", 0, "", 0 );
    cmn.ItemFly( "spr_dollhouse_house_part", func_end, -1.2 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function private.use_dollhousepart_end ()

  local func_end = function()

    cmn.Lock( false );

    cmn.SetEventDone( "use_dollhousepart" );
    cmn.CallEventHandler( "use_dollhousepart_end" );

  end;

  cmn.Lock( true );
  ObjAnimate( "spr_dollhouse_closed_window2_left", "pos_xy", 0, 0, func_end,
  { 
    0.0, 3, ObjGet( "spr_dollhouse_closed_window2_left" ).pos_x, ObjGet( "spr_dollhouse_closed_window2_left" ).pos_y,
    0.3, 3, -251, -112
  } );
  ObjAnimate( "spr_dollhouse_closed_window2_right", "pos_xy", 0, 0, func_end,
  { 
    0.0, 3, ObjGet( "spr_dollhouse_closed_window2_right" ).pos_x, ObjGet( "spr_dollhouse_closed_window2_right" ).pos_y,
    0.3, 3, 3, -78
  } );

end;
--------------------------------------------------------------------------------------------
function public.use_plate ()

  local item = "inv_plate";

  if cmn.ApplyObj( item, "gzz_childrensroom_dollhouse" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_dollhouse", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_dollhouse_use_plate" ) ) then

    cmn.CallEventHandler( "use_plate_inv" );
    cmn.CallEventHandler( "use_plate_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_plate" );
      cmn.CallEventHandler( "use_plate_end" );

      ObjSet( "anm_dollhouse_anm_clown_static_no_arm", { alp = 1 } );
      AnimPlay( "anm_dollhouse_anm_clown_static_no_arm", "no_arm", "" );

      private.get_dummyshand();

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_plate", 0, "", 0 );

    AnimStop("anm_dollhouse_anm_clown_static_no_head");
    ObjSet( "anm_dollhouse_anm_clown_static_no_head", { alp = 0 } );

    ObjSet( "anm_dollhouse_clown_drop_hand", { alp = 1 } );
    AnimPlay( "anm_dollhouse_clown_drop_hand", "DoAnim", func_end)
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_lockpickset ()

  local item = "inv_lockpickset";

  if cmn.ApplyObj( item, "gzz_childrensroom_dollhouse" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_dollhouse", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_dollhouse_use_lockpickset" ) ) then

    cmn.CallEventHandler( "use_lockpickset_inv" );
    cmn.CallEventHandler( "use_lockpickset_beg" );

    local func_end = function ()

      local func_end_2 = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_lockpickset" );
        cmn.CallEventHandler( "use_lockpickset_end" );

        common.CloseSubRoom();

      end;

      ObjAnimate( "spr_dollhouse_door", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_dollhouse_door" ).alp,
        0.3, 0, 0,
      } );
      ObjAnimate( "spr_dollhouse_door_opened", "alp", 0, 0, func_end_2,
      { 
        0.0, 0, ObjGet( "spr_dollhouse_door_opened" ).alp,
        0.3, 0, 1,
      } );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_picklock", 0, "", 0 );

    ObjSet( "anm_dollhouse_latchkey", { alp = 1 } );
    AnimPlay( "anm_dollhouse_latchkey" , "DoAnim" , func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_dollhead ()

  local item = "inv_dollhead";

  if cmn.ApplyObj( item, "gzz_childrensroom_dolls" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_dolls", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_dolls_use_dollhead" ) ) then

    cmn.CallEventHandler( "use_dollhead_inv" );
    cmn.CallEventHandler( "use_dollhead_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_dollhead" );
      cmn.CallEventHandler( "use_dollhead_end" );

    end;

    local func_continue = function ()

      AnimPlay( "anm_dolls_springs", "anim_open_doll_springs", func_end )

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_dollhead", 0, "", 0 );

    ObjAnimate( "spr_dolls_close_doll", "ang", 0, 0, func_continue,
    { 
      0.0, 0, ObjGet( "spr_dolls_close_doll" ).ang,
      1.0, 0, ObjGet( "spr_dolls_close_doll" ).ang,
      1.3, 0, -0.88
    } );

    cmn.ItemFly( "spr_dolls_dollhead", nil, 0 );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_hanky ()

  local item = "inv_hanky";

  if cmn.ApplyObj( item, "gzz_childrensroom_dolls" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_dolls", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_dolls_use_hanky" ) ) then

    cmn.CallEventHandler( "use_hanky_inv" );
    cmn.CallEventHandler( "use_hanky_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_hanky" );
      cmn.CallEventHandler( "use_hanky_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_spider", 0, "", 0 );

    ObjAnimate( "spr_dolls_web_tuner", "alp", 0, 0, "", { 0, 0, 1,   1.35, 0, 1,   1.5, 0, 0 } );
    ObjAnimate( "spr_dolls_spider", "alp", 0, 0, "", { 0, 0, 1,   1.5, 0, 1,   1.5, 0, 0 } );
    AnimPlay( "anm_dolls_hanky", "DoAnim", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_handle ()

  local item = "inv_handle";

  if ( cmn.ApplyObj( item, "gzz_childrensroom_dolls" ) )then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_dolls", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_dolls_use_handle" ) ) then

    cmn.CallEventHandler( "use_handle_inv" );
    cmn.CallEventHandler( "use_handle_beg" );

    local func_end = function ()

      cmn.Lock( false );

      common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk9", 0, "", 0 );

      cmn.SetEventDone( "use_handle" );
      cmn.CallEventHandler( "use_handle_end" );

    end;

    cmn.Lock( true );

    cmn.ItemFly( "spr_dolls_handle", func_end, 2.3 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_dummyshand ()

  local item = "inv_dummyshand";

  if ( cmn.ApplyObj( item, "gzz_childrensroom_pram" )  and cmn.IsEventDone( "clk_blanket" ) ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_pram", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_pram_use_dummyshand" ) and cmn.IsEventDone( "clk_blanket" ) ) then

    cmn.CallEventHandler( "use_dummyshand_inv" );
    cmn.CallEventHandler( "use_dummyshand_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_dummyshand" );
      cmn.CallEventHandler( "use_dummyshand_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_hand_scorpion", 0, "", 0 );

    ObjSet( "spr_pram_handle_shadow", { alp = 0 } );
    ObjSet( "anm_pram_hand", { alp = 1 } );
    ObjSet( "vid_pram_scorpion", { pos_z = 9 } );
    ObjSet( "anm_pram_hand", { pos_z = 11 } );
    AnimPlay( "anm_pram_hand", "hand", func_end );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_tuner ()

  local item = "inv_tuner";

  if cmn.ApplyObj( item, "gzz_childrensroom_pram" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_pram", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_pram_use_tuner" ) ) then

    cmn.CallEventHandler( "use_tuner_inv" );
    cmn.CallEventHandler( "use_tuner_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_tuner" );
      cmn.CallEventHandler( "use_tuner_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_antenna", 0, "", 0 );

    AnimPlay( "anm_pram_tv", "DoAnim", func_end );

    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_trianglekey ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_trianglekey" );
  cmn.CallEventHandler( "get_trianglekey" );

end;
--------------------------------------------------------------------------------------------
function private.get_dollhead ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_dollhead" );
  cmn.CallEventHandler( "get_dollhead" );

  AnimStop("anm_dollhouse_anm_clown_static_with_head");
  ObjSet( "anm_dollhouse_anm_clown_static_with_head", { alp = 0 } );

  ObjSet( "anm_dollhouse_anm_clown_static_no_head", { alp = 1 } );
  AnimPlay( "anm_dollhouse_anm_clown_static_no_head", "no_head", "" );

end;
--------------------------------------------------------------------------------------------
function private.get_dummyshand ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_dummyshand" );
  cmn.CallEventHandler( "get_dummyshand" );

end;
--------------------------------------------------------------------------------------------
function private.get_dollhousepart ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_dollhousepart" );
  cmn.CallEventHandler( "get_dollhousepart" );

end;
--------------------------------------------------------------------------------------------
function private.get_tuner ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_tuner" );
  cmn.CallEventHandler( "get_tuner" );
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_voodoodoll ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_voodoodoll" );
  cmn.CallEventHandler( "get_voodoodoll" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_plate ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_plate" );
  cmn.CallEventHandler( "get_plate" );

end;
--------------------------------------------------------------------------------------------
function private.get_handle ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_handle" );
  cmn.CallEventHandler( "get_handle" );
  
  if ( cmn.IsGetCollect2( "get_collect2_item_2_1" ) ) then

    common.CloseSubRoom(); 

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_2_1 ()

  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_2_1" ); 

    if ( cmn.IsEventDone( "get_handle" ) ) then

      common.CloseSubRoom(); 

    end;

  end;

  common_impl.PlayEffectHO( "spr_collect2_item_2_1", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_2_1" );  

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_blanket ()

  cmn.CallEventHandler( "clk_blanket_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_blanket" );
    cmn.CallEventHandler( "clk_blanket_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_cloth", 0, "", 0 );
  common_impl.PlayAudio( "env", "level2/env/aud_scorpion_env", 1, "", 0 );

  AnimPlay( "anm_pram_blanket", "blanket", func_end );

end;
--------------------------------------------------------------------------------------------
function private.clk_dollhead ()

  cmn.CallEventHandler( "clk_dollhead_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_dollhead" );
      cmn.CallEventHandler( "clk_dollhead_end" );
      
      ObjSet( "anm_dollhouse_clown_boo", { alp = 0 } );
      ObjSet( "anm_dollhouse_anm_clown_static_with_head", { alp = 1 } );
      AnimPlay( "anm_dollhouse_anm_clown_static_with_head", "with_head", "" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_clown", 0, "", 0 );
    
    ObjSet( "anm_dollhouse_clown_boo", { alp = 1 } );
    AnimPlay( "anm_dollhouse_clown_boo", "DoAnim", func_end );
  
end;
--------------------------------------------------------------------------------------------

function private.clk_handle ()

  cmn.CallEventHandler( "clk_handle_beg" );

  local func_end_3 = function ()

    local func_end_2 = function ()

      local func_end = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "clk_handle" );
        cmn.CallEventHandler( "clk_handle_end" );

      end;

      ObjSet( "anm_dolls_voodoodoll", { alp = 1 } );
      AnimPlay( "anm_dolls_voodoodoll", "anim_voodoodoll", func_end );

    end;

    cmn.Lock( true );

    ObjAnimate( "spr_dolls_close_cover", "alp", 0, 0, func_end_2,
    { 
      0.0, 0, ObjGet( "spr_dolls_close_cover" ).alp,
      0.3, 0, 0
    } );
    ObjAnimate( "obj_dolls_open", "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "obj_dolls_open" ).alp,
      0.3, 0, 1
    } );

  end;

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_handle_safe", 0, "", 0 );

  ObjSet( "anm_dolls_handle", { alp = 1 } );
  AnimPlay( "anm_dolls_handle", "anim_handle", func_end_3 );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_childrensroom ()

  if not ( cmn.IsEventDone( "opn_childrensroom" ) ) then

    common_impl.ShowBbt( "bbt_childrensroom_opn_childrensroom" );

    private.ZoomChildrensroomClown();

    cmn.SetEventDone( "opn_childrensroom" );

  end;

  cmn.CallEventHandler( "opn_childrensroom" ); 

end;
--------------------------------------------------------------------------------------------
function private.see_parm_masked_man ()

  local func_end = function ()

    common_impl.ShowBbt( "bbt_childrensroom_see_parm_masked_man" );

    cmn.Lock( false );
    cmn.SetEventDone( "see_parm_masked_man" );
    cmn.CallEventHandler( "see_parm_masked_man" );

  end;
  
  cmn.Lock( true );

  common_impl.ShowBbt( "bbt_pram_see_parm_masked_man_sub" );

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_pram_masked_man", 0, "", 0 );
  common_impl.PlayAudio( "voc", "level2/voc/aud_pram_masked_man_voc", 0, "", 0 );

  ObjSet( "anm_pram_tv_light", { alp = 0 } );
  ObjSet( "vid_parm_masked_man", { alp = 1 } );
  VidPlay( "vid_parm_masked_man", func_end );

end;
--*********************************************************************************************************************
function private.ChildrensroomScare_1 ()

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "see_childrensroom_scare_1" );
    cmn.CallEventHandler( "see_childrensroom_scare_1" );

    cmn.PlayMusDanger();
    cmn.PlayMusEnv();

  end;

  cmn.StopMusEnv();

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_head_clown", 0, "", 0 );
  ObjSet( "anm_childrensroom_clown",   { active = false, visible = false, alp = 0 } );
  ObjSet( "anm_childrensroom_clown_2", { active = true,  visible = true,  alp = 1 } );

  cmn.Lock( true );
  AnimPlay( "anm_childrensroom_clown_2", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.ZoomChildrensroomClown()

  local func_end = function ()

    cmn.Lock( false );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_scary_zoom", 0, "", 0 );

  ObjAnimate( "obj_childrensroom_center", "scale_xy", 0, 0, func_end,
  { 
    0.0, 0, 1, 1,
    0.5, 0, 2, 2,
    1.5, 0, 2, 2,
    2.0, 0, 1, 1,
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.ClkTV ()

  local func_end = function ()

    cmn.Lock( false );
    ObjSet( "vid_parm_tv_noise", { alp = 0 } );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_thumbler", 0, "", 0 );

  ObjSet(  "vid_parm_tv_noise", { alp = 1 } );
  VidPlay( "vid_parm_tv_noise", func_end );  

end;
--------------------------------------------------------------------------------------------
function private.UseAntirust_2_1 ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( "bbt_dollhouse_use_antirust_2_1" );

  end;

  cmn.Lock( true );

  local rnd = math.random(2,3);
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk"..rnd, 0, "", 0 );
  
  ObjAnimate( "spr_dollhouse_flap_right", "pos_xy", 0, 0, "",
  { 
    0.00, 0, ObjGet( "spr_dollhouse_flap_right" ).pos_x,     ObjGet( "spr_dollhouse_flap_right" ).pos_y,
    0.15, 0, ObjGet( "spr_dollhouse_flap_right" ).pos_x + 3, ObjGet( "spr_dollhouse_flap_right" ).pos_y,
    0.30, 0, ObjGet( "spr_dollhouse_flap_right" ).pos_x,     ObjGet( "spr_dollhouse_flap_right" ).pos_y,
  } );
  ObjAnimate( "spr_dollhouse_flap_left", "pos_xy", 0, 0, func_end,
  { 
    0.00, 0, ObjGet( "spr_dollhouse_flap_left" ).pos_x,     ObjGet( "spr_dollhouse_flap_left" ).pos_y,
    0.15, 0, ObjGet( "spr_dollhouse_flap_left" ).pos_x - 3, ObjGet( "spr_dollhouse_flap_left" ).pos_y,
    0.30, 0, ObjGet( "spr_dollhouse_flap_left" ).pos_x,     ObjGet( "spr_dollhouse_flap_left" ).pos_y,
  } );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function private.UseDollhousepart ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_dollhouse_use_dollhousepart' );

  end;

  cmn.Lock( true );

  local rnd = math.random(2,3);
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk"..rnd, 0, "", 0 );

  ObjAnimate( "spr_dollhouse_closed_window2_left", "pos_xy", 0, 0, "",
  { 
    0.00, 0, ObjGet( "spr_dollhouse_closed_window2_left" ).pos_x,     ObjGet( "spr_dollhouse_closed_window2_left" ).pos_y,
    0.15, 0, ObjGet( "spr_dollhouse_closed_window2_left" ).pos_x - 2, ObjGet( "spr_dollhouse_closed_window2_left" ).pos_y - 1,
    0.30, 0, ObjGet( "spr_dollhouse_closed_window2_left" ).pos_x,     ObjGet( "spr_dollhouse_closed_window2_left" ).pos_y,
  } );
  ObjAnimate( "spr_dollhouse_closed_window2_right", "pos_xy", 0, 0, func_end,
  { 
    0.00, 0, ObjGet( "spr_dollhouse_closed_window2_right" ).pos_x,     ObjGet( "spr_dollhouse_closed_window2_right" ).pos_y,
    0.15, 0, ObjGet( "spr_dollhouse_closed_window2_right" ).pos_x + 2, ObjGet( "spr_dollhouse_closed_window2_right" ).pos_y,
    0.30, 0, ObjGet( "spr_dollhouse_closed_window2_right" ).pos_x,     ObjGet( "spr_dollhouse_closed_window2_right" ).pos_y,
  } );

end;
--------------------------------------------------------------------------------------------
function private.UseLockpickset ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_dollhouse_use_lockpickset' );

  end;

  cmn.Lock( true );

  local rnd = math.random(2,3);
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk"..rnd, 0, "", 0 );

  ObjAnimate( "spr_dollhouse_door", "pos_xy", 0, 0, func_end,
  { 
    0.00, 0, ObjGet( "spr_dollhouse_door" ).pos_x,     ObjGet( "spr_dollhouse_door" ).pos_y,
    0.15, 0, ObjGet( "spr_dollhouse_door" ).pos_x - 6, ObjGet( "spr_dollhouse_door" ).pos_y,
    0.30, 0, ObjGet( "spr_dollhouse_door" ).pos_x,     ObjGet( "spr_dollhouse_door" ).pos_y,
  } );

end;
--------------------------------------------------------------------------------------------

function private.ClkDollCloseCover ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_dolls_use_handle' );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

  ObjAnimate( "spr_dolls_close_cover", "pos_xy", 0, 0, func_end,
  { 
    0.0, 0, ObjGet( "spr_dolls_close_cover" ).pos_x, ObjGet( "spr_dolls_close_cover" ).pos_y,
    0.2, 0, ObjGet( "spr_dolls_close_cover" ).pos_x, ObjGet( "spr_dolls_close_cover" ).pos_y + 2,
    0.4, 0, ObjGet( "spr_dolls_close_cover" ).pos_x, ObjGet( "spr_dolls_close_cover" ).pos_y,
  } );

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** ANIM *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.InitAnimations ()

  

end;