-- name=rm_corridorelevator
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_corridorelevator";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_utilityroom", "room_hub" );
  ObjAttach( "zz_metalcase", "room_hub" );
  ObjAttach( "zz_elevator", "room_hub" );
  private.InitAnimations();
  private.Init_Subroom();
  private.InitElevator();

  public.open_metalcase = false;
  
  ObjMultiSet({ 
    { "spr_utilityroom_valve_2",                      { event_mdown = private.get_valve_2 } },
    { "spr_utilityroom_stepladder",                   { event_mdown = private.get_stepladder } },
    { "spr_utilityroom_hook_1",                       { event_mdown = private.get_hook_1 } },
    { "spr_utilityroom_redwire",                      { event_mdown = private.get_redwire } },
    { "spr_metalcase_battery1",                       { event_mdown = private.get_battery1 } },
    { "spr_elevator_battery2",                        { event_mdown = private.get_battery2 } },
    { "spr_elevator_douglasthings",                   { event_mdown = private.get_douglasthings } },
    { "obj_metalcase_use_trianglekey",                { event_mdown = private.UseTrianglekey } },
    { "obj_corridorelevator_clk_rightwall",           { event_mdown = private.clk_rightwall } },
    { "obj_utilityroom_clk_valve_2",                  { event_mdown = private.clk_valve_2 } },
    { "obj_utilityroom_clk_lever",                    { event_mdown = private.clk_lever } },
    { "obj_utilityroom_clk_roller",                   { event_mdown = private.clk_roller } },
    { "obj_utilityroom_use_roller",                   { event_mdown = private.UseRoller } },
    { "obj_metalcase_clk_battery1",                   { event_mdown = private.clk_battery1 } },
    { "obj_metalcase_clk_trianglekey",                { event_mdown = private.clk_trianglekey } },
    { "obj_elevator_clk_douglasthings",               { event_mdown = private.clk_douglasthings } },
    { "obj_elevator_clk_button_elevator",             { event_mdown = private.clk_button_elevator } },
    { "obj_elevator_use_kevinscard",                  { event_mdown = private.UseKevinscard } },
    { "obj_elevator_use_douglascard",                 { event_mdown = private.UseDouglascard } },
    { "spr_metalcase_roller",                         { event_mdown = private.get_roller } },
    { "obj_corridorelevator_clk_valve_metalcase",     { event_mdown = private.clk_valve_metalcase } },

    { "spr_collect2_item_2_3",                        { event_mdown = private.get_collect2_item_2_3 } },
    { "spr_corridorelevator_collect_morph_item",      { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_2_1" ); end } },

  } );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_corridorelevator = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "gmg_corridorelevator_metalcases",
      "gzz_corridorelevator_utilityroom",
      "gzz_corridorelevator_metalcase",
      "gzz_corridorelevator_elevator",
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_utilityroom",
      "zz_metalcase",
      "zz_elevator",
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_corridorelevator", update_game_mode_corridorelevator, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_corridorelevator = function ()

  local effects_table = 
  {
    "obj_corridorelevator_anim"
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_corridorelevator", update_performance_mode_corridorelevator, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function beg_levele2 () end;
  --------------------------------------------------------------------------------------------
  local beg_levele2 = function ()

    interface.InventoryItemAdd( "inv_antirust_2" );
    interface.InventoryItemAdd( "inv_rope_2" );
    interface.InventoryItemAdd( "inv_cork" );
    interface.InventoryItemAdd( "inv_glassfigurine_2" );

  end;

  cmn.AddSubscriber( "beg_levele2", beg_levele2 );
  --------------------------------------------------------------------------------------------
  -- function opn_corridorelevator () end;
  --------------------------------------------------------------------------------------------
  local opn_corridorelevator_map = function ()

    common_impl.VisitMapRoom( "corridorelevator" );

  end;

  cmn.AddSubscriber( "opn_corridorelevator", opn_corridorelevator_map );

  --------------------------------------------------------------------------------------------
  -- function get_valve_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_valve_2" ] = {
    type = "get",
    get_obj = "spr_utilityroom_valve_2",
    room = private.room_objname,
    zz = "zz_utilityroom",
    zz_gate = "gzz_corridorelevator_utilityroom"
  };
  
  local get_valve_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_valve_2", "spr_utilityroom_valve_2" );
  
  end;
  
  local get_valve_2_closezz = function ()
  
    ObjDelete( "gfx_utilityroom_valve_2" );
    ObjDelete( "spr_utilityroom_valve_2shadow" );

    ObjDelete( "spr_corridorelevator_utilityroom_valve_2" );
  
  end;
  
  cmn.AddSubscriber( "get_valve_2", get_valve_2_inv );
  cmn.AddSubscriber( "get_valve_2", get_valve_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stepladder () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stepladder" ] = {
    type = "get",
    get_obj = "spr_utilityroom_stepladder",
    room = private.room_objname,
    zz = "zz_utilityroom",
    zz_gate = "gzz_corridorelevator_utilityroom"
  };
  
  local get_stepladder_inv = function ()
  
    interface.InventoryItemAdd( "inv_stepladder", "spr_utilityroom_stepladder" );
  
  end;
  
  local get_stepladder_closezz = function ()
  
    ObjDelete( "gfx_utilityroom_stepladder" );
    ObjDelete( "spr_utilityroom_stepladder_shadow" );
    ObjSet( "obj_utilityroom_clk_roller", { active = true, input = true } );

    ObjDelete( "spr_corridorelevator_utilityroom_stepladder" );
  
  end;
  
  cmn.AddSubscriber( "get_stepladder", get_stepladder_inv );
  cmn.AddSubscriber( "get_stepladder", get_stepladder_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hook_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hook_1" ] = {
    type = "get",
    get_obj = "spr_utilityroom_hook_1",
    room = private.room_objname,
    zz = "zz_utilityroom",
    zz_gate = "gzz_corridorelevator_utilityroom"
  };
  
  local get_hook_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_hook_1", "spr_utilityroom_hook_1" );
  
    ObjSet( "inv_hook_1", { drag = false } );

  end;
  
  local get_hook_1_closezz = function ()
  
    ObjDelete( "gfx_utilityroom_hook_1" );
    ObjDelete( "spr_utilityroom_hook1_shadow" );
  
    if ( cmn.IsEventDone( "get_redwire" ) ) then

      ObjDelete( "gzz_corridorelevator_utilityroom" );

    end

  end;
  
  cmn.AddSubscriber( "get_hook_1", get_hook_1_inv );
  cmn.AddSubscriber( "get_hook_1", get_hook_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_redwire () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_redwire" ] = {
    type = "get",
    get_obj = "spr_utilityroom_redwire",
    room = private.room_objname,
    zz = "zz_utilityroom",
    zz_gate = "gzz_corridorelevator_utilityroom"
  };
  
  local get_redwire_inv = function ()
  
    interface.InventoryItemAdd( "inv_redwire", "spr_utilityroom_redwire" );
  
  end;
  
  local get_redwire_closezz = function ()
  
    ObjDelete( "gfx_utilityroom_redwire" );
    ObjDelete( "spr_utilityroom_redwire_shadow" );
  
    if ( cmn.IsEventDone( "get_hook_1" ) ) then

      ObjDelete( "gzz_corridorelevator_utilityroom" );

    end

  end;
  
  cmn.AddSubscriber( "get_redwire", get_redwire_inv );
  cmn.AddSubscriber( "get_redwire", get_redwire_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_battery1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_battery1" ] = {
    type = "get",
    get_obj = "spr_metalcase_battery1",
    room = private.room_objname,
    zz = "zz_metalcase",
    zz_gate = "gzz_corridorelevator_metalcase"
  };
  
  local get_battery1_inv = function ()
  
    ObjSet( "inv_battery", { frame = ObjGet( "inv_battery" ).frame + 1 } );
    interface.InventoryItemAdd( "inv_battery", "spr_metalcase_battery1" );
  
  end;
  
  local get_battery1_closezz = function ()
  
    ObjDelete( "gfx_metalcase_battery1" );
    ObjDelete( "spr_metalcase_battery1_shadow" );
    ObjDelete( "spr_metalcase_battery_layer" );
    ObjSet( "obj_metalcase_clk_box_up", { input = true } );

--    if ( cmn.IsEventDone( "get_roller" ) ) then
--
--      ObjDelete( "gzz_corridorelevator_metalcase" );    
--
--    end;
  
  end;
  
  cmn.AddSubscriber( "get_battery1", get_battery1_inv );
  cmn.AddSubscriber( "get_battery1", get_battery1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_battery2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_battery2" ] = {
    type = "get",
    get_obj = "spr_elevator_battery2",
    room = private.room_objname,
    zz = "zz_elevator",
    zz_gate = "gzz_corridorelevator_elevator"
  };
  
  local get_battery2_inv = function ()
  
    ObjSet( "inv_battery", { frame = ObjGet( "inv_battery" ).frame + 1 } );
    interface.InventoryItemAdd( "inv_battery", "spr_elevator_battery2" );
  
  end;
  
  local get_battery2_closezz = function ()
  
    ObjDelete( "gfx_elevator_battery2" );
  
  end;
  
  cmn.AddSubscriber( "get_battery2", get_battery2_inv );
  cmn.AddSubscriber( "get_battery2", get_battery2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_douglasthings () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_douglasthings" ] = {
    type = "get",
    get_obj = "spr_elevator_douglasthings",
    room = private.room_objname,
    zz = "zz_elevator",
    zz_gate = "gzz_corridorelevator_elevator"
  };
  
  local get_douglasthings_inv = function ()
  
    interface.InventoryItemAdd( "inv_douglasthings", "spr_elevator_douglasthings" );
    ObjSet( "inv_douglasthings", { drag = false } );  

  end;
  
  local get_douglasthings_closezz = function ()
  
    ObjDelete( "gfx_elevator_douglasthings" );
    ObjDelete( "spr_elevator_jacket_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_douglasthings", get_douglasthings_inv );
  cmn.AddSubscriber( "get_douglasthings", get_douglasthings_closezz, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_roller () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_roller" ] = {
    type = "get",
    get_obj = "spr_metalcase_roller",
    room = private.room_objname,
    zz = "zz_metalcase",
    zz_gate = "gzz_corridorelevator_metalcase" 
  };
  
  local get_roller_inv = function ()
  
    interface.InventoryItemAdd( "inv_roller", "spr_metalcase_roller_2" );
  
  end;
  
  local get_roller_closezz = function ()

    ObjDelete( "gfx_metalcase_roller" );  
    ObjDelete( "spr_metalcase_roller" );

    --if ( cmn.IsEventDone( "get_battery1" ) ) then 
    --  ObjDelete( "gzz_corridorelevator_metalcase" );  
    --end;
    
  end;
    
  cmn.AddSubscriber( "get_roller", get_roller_inv );
  cmn.AddSubscriber( "get_roller", get_roller_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_2_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_2_3 = function ()
  
    ObjDelete( "obj_collect2_item_2_3" );
  
  end;    
  cmn.AddSubscriber( "get_collect2_item_2_3", get_collect2_item_2_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2_1 = function ()
  
    ObjDelete( "obj_corridorelevator_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_2_1", get_collect_morph_item_2_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_battery_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_battery_1" ] = {
    type = "use",
    inv_obj = "inv_battery",
    use_place = "obj_utilityroom_use_battery_1",
    room = private.room_objname,
    zz = "zz_utilityroom",
    zz_gate = "gzz_corridorelevator_utilityroom"
  };
  local use_battery_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_battery" );    
  
  end;
  local use_battery_1_beg = function ()
  
    ObjDelete( "obj_utilityroom_use_battery_1" );
  
  end;
  local use_battery_1_end = function ()
  
    ObjSet( "spr_utilityroom_battery_1", { alp = 1 } );
    ObjSet( "spr_utilityroom_battery_2", { alp = 1 } );

    ObjDelete( "spr_utilityroom_dark" );
    ObjDelete( "spr_utilityroom_light_battery_red" );
    ObjSet( "spr_utilityroom_light_battery_green", { alp = 1 } );
    ObjSet( "obj_utilityroom_light", { input = true } );
    ObjSet( "spr_utilityroom_light_all", { visible = true } );
    ObjDelete( "anm_utilityroom_light" );
    ObjSet( "obj_utilityroom_indicator", { alp = 1 } );

    ObjDelete( "spr_corridorelevator_utilityroom_dark" );
    ObjSet( "spr_corridorelevator_utilityroom_light", { alp = 1 } );

  end;
  local use_battery_1_inv_end = function ()
  
    interface.InventoryItemAdd( "inv_battery", "spr_utilityroom_battery_1" );
    interface.InventoryItemAdd( "inv_battery", "spr_utilityroom_battery_2" );
    ObjSet( "inv_battery", { frame = 2 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_battery_1", use_battery_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_battery_1", use_battery_1_inv );
  cmn.AddSubscriber( "use_battery_1", use_battery_1_end, private.room_objname );
  cmn.AddSubscriber( "use_battery_1", use_battery_1_inv_end );
  cmn.AddSubscriber( "use_battery_1_inv", use_battery_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_battery_1_beg", use_battery_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_battery_1_end", use_battery_1_end, private.room_objname );
  cmn.AddSubscriber( "use_battery_1_end", use_battery_1_inv_end, private.room_objname );
  -------------------------------------------------------------------------------------------
  -- function use_roller () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_roller" ] = {
    type = "use",
    inv_obj = "inv_roller",
    use_place = "obj_utilityroom_use_roller",
    room = private.room_objname,
    zz = "zz_utilityroom",
    zz_gate = "gzz_corridorelevator_utilityroom"
  };
  local use_roller_inv = function ()
  
    interface.InventoryItemRemove( "inv_roller" );
  
  end;
  local use_roller_beg = function ()
  
    ObjDelete( "obj_utilityroom_use_roller" );
  
  end;
  local use_roller_end = function ()
  
    ObjDelete( "spr_utilityroom_roller" );
    ObjSet( "vid_utilityroom_cogwheel", { alp = 1 } );
    ObjSet( "obj_utilityroom_clk_lever", { input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_roller", use_roller_beg, private.room_objname );
  cmn.AddSubscriber( "use_roller", use_roller_inv );
  cmn.AddSubscriber( "use_roller", use_roller_end, private.room_objname );
  cmn.AddSubscriber( "use_roller_inv", use_roller_inv, private.room_objname );
  cmn.AddSubscriber( "use_roller_beg", use_roller_beg, private.room_objname );
  cmn.AddSubscriber( "use_roller_end", use_roller_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_trianglekey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_trianglekey" ] = {
    type = "use",
    inv_obj = "inv_trianglekey",
    use_place = "obj_metalcase_use_trianglekey",
    room = private.room_objname,
    zz = "zz_metalcase",
    zz_gate = "gzz_corridorelevator_metalcase"
  };
  local use_trianglekey_inv = function ()
  
    interface.InventoryItemRemove( "inv_trianglekey" );
  
  end;
  local use_trianglekey_beg = function ()
  
    ObjDelete( "obj_metalcase_use_trianglekey" );
  
  end;
  local use_trianglekey_end = function ()
      
    ObjSet( "spr_metalcase_key", { alp = 1 } );
    ObjSet( "spr_metalcase_key_layer", { alp = 1 } );
    ObjSet( "obj_metalcase_clk_trianglekey", { input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_trianglekey", use_trianglekey_beg, private.room_objname );
  cmn.AddSubscriber( "use_trianglekey", use_trianglekey_inv );
  cmn.AddSubscriber( "use_trianglekey", use_trianglekey_end, private.room_objname );
  cmn.AddSubscriber( "use_trianglekey_inv", use_trianglekey_inv, private.room_objname );
  cmn.AddSubscriber( "use_trianglekey_beg", use_trianglekey_beg, private.room_objname );
  cmn.AddSubscriber( "use_trianglekey_end", use_trianglekey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hookedrope () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hookedrope" ] = {
    type = "use",
    inv_obj = "inv_hookedrope",
    use_place = "obj_elevator_use_hookedrope",
    room = private.room_objname,
    zz = "zz_elevator",
    zz_gate = "gzz_corridorelevator_elevator"
  };
  local use_hookedrope_inv = function ()
  
    interface.InventoryItemRemove( "inv_hookedrope" );
  
  end;
  local use_hookedrope_beg = function ()
  
    ObjDelete( "obj_elevator_use_hookedrope" );
  
  end;
  local use_hookedrope_end = function ()
  
    ObjSet( "obj_elevator_mmg", { input = true, alp = 1 } );
    ObjSet( "spr_elevator_grid", { alp = 1 } );
    --ObjSet( "spr_elevator_douglasthings", { input = true, active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hookedrope", use_hookedrope_beg, private.room_objname );
  cmn.AddSubscriber( "use_hookedrope", use_hookedrope_inv );
  cmn.AddSubscriber( "use_hookedrope", use_hookedrope_end, private.room_objname );
  cmn.AddSubscriber( "use_hookedrope_inv", use_hookedrope_inv, private.room_objname );
  cmn.AddSubscriber( "use_hookedrope_beg", use_hookedrope_beg, private.room_objname );
  cmn.AddSubscriber( "use_hookedrope_end", use_hookedrope_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_kevinscard () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_kevinscard" ] = {
    type = "use",
    inv_obj = "inv_kevinscard",
    use_place = "obj_elevator_use_kevinscard",
    room = private.room_objname,
    zz = "zz_elevator",
    zz_gate = "gzz_corridorelevator_elevator"
  };
  local use_kevinscard_inv = function ()
  
    interface.InventoryItemRemove( "inv_kevinscard" );
  
  end;
  local use_kevinscard_beg = function ()
  
    ObjDelete( "obj_elevator_use_kevinscard" );
  
  end;
  local use_kevinscard_end = function ()
  
    if ( cmn.IsEventDone( "use_douglascard" ) ) then

      ObjSet( "obj_elevator_clk_button_elevator", { input = true } );
      ObjSet( "spr_elevator_card_1", { pos_x = 303, pos_y = -172 } );
      ObjSet( "spr_elevator_card_2", { pos_x = 256, pos_y = 15 } );

      ObjSet( "spr_corridorelevator_elevator_slot_open", { alp = 1 } );

    end;

    ObjSet( "spr_elevator_kevin_reynolds", { alp = 1 } );

    ObjSet( "spr_corridorelevator_elevator_slot_2_card", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_kevinscard", use_kevinscard_beg, private.room_objname );
  cmn.AddSubscriber( "use_kevinscard", use_kevinscard_inv );
  cmn.AddSubscriber( "use_kevinscard", use_kevinscard_end, private.room_objname );
  cmn.AddSubscriber( "use_kevinscard_inv", use_kevinscard_inv, private.room_objname );
  cmn.AddSubscriber( "use_kevinscard_beg", use_kevinscard_beg, private.room_objname );
  cmn.AddSubscriber( "use_kevinscard_end", use_kevinscard_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_douglascard () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_douglascard" ] = {
    type = "use",
    inv_obj = "inv_douglascard",
    use_place = "obj_elevator_use_douglascard",
    room = private.room_objname,
    zz = "zz_elevator",
    zz_gate = "gzz_corridorelevator_elevator"
  };
  local use_douglascard_inv = function ()
  
    interface.InventoryItemRemove( "inv_douglascard" );
  
  end;
  local use_douglascard_beg = function ()
  
    ObjDelete( "obj_elevator_use_douglascard" );
  
  end;
  local use_douglascard_end = function ()
  
    if ( cmn.IsEventDone( "use_kevinscard" ) ) then

      ObjSet( "obj_elevator_clk_button_elevator", { input = true } );
      ObjSet( "spr_elevator_card_1", { pos_x = 303, pos_y = -172 } );
      ObjSet( "spr_elevator_card_2", { pos_x = 256, pos_y = 15 } );

      ObjSet( "spr_corridorelevator_elevator_slot_open", { alp = 1 } );

    end;

    ObjSet( "spr_elevator_douglas_will", { alp = 1 } );

    ObjSet( "spr_corridorelevator_elevator_slot_1_card", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_douglascard", use_douglascard_beg, private.room_objname );
  cmn.AddSubscriber( "use_douglascard", use_douglascard_inv );
  cmn.AddSubscriber( "use_douglascard", use_douglascard_end, private.room_objname );
  cmn.AddSubscriber( "use_douglascard_inv", use_douglascard_inv, private.room_objname );
  cmn.AddSubscriber( "use_douglascard_beg", use_douglascard_beg, private.room_objname );
  cmn.AddSubscriber( "use_douglascard_end", use_douglascard_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_valve_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_valve_2" ] = {
    type = "use",
    inv_obj = "inv_valve_2",
    use_place = "obj_corridorelevator_use_valve_2",
    room = private.room_objname
  };
  local use_valve_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_valve_2" );
  
  end;
  local use_valve_2_beg = function ()
  
    ObjDelete( "obj_corridorelevator_use_valve_2" );
  
  end;
  local use_valve_2_end = function ()

    ObjSet( "spr_corridorelevator_metalcase_door_valve_1", { alp = 1 } );
    ObjSet( "obj_corridorelevator_clk_valve_metalcase", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_valve_2", use_valve_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_valve_2", use_valve_2_inv );
  cmn.AddSubscriber( "use_valve_2", use_valve_2_end, private.room_objname );
  cmn.AddSubscriber( "use_valve_2_inv", use_valve_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_valve_2_beg", use_valve_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_valve_2_end", use_valve_2_end, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS CLK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_rightwall () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_rightwall" ] = {
    type = "click",
    use_place = "obj_corridorelevator_clk_rightwall",
    room = private.room_objname,
  };

  local clk_rightwall_beg = function ()
  
    ObjDelete( "obj_corridorelevator_clk_rightwall" );
  
  end;
  local clk_rightwall_end = function ()

    ObjDelete( "anm_corridorelevator_doors" );
    ObjSet( "gzz_corridorelevator_utilityroom", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_rightwall", clk_rightwall_beg, private.room_objname );
  cmn.AddSubscriber( "clk_rightwall", clk_rightwall_end, private.room_objname );
  cmn.AddSubscriber( "clk_rightwall_beg", clk_rightwall_beg, private.room_objname );
  cmn.AddSubscriber( "clk_rightwall_end", clk_rightwall_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_valve_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_valve_2" ] = {
    type = "click",
    use_place = "obj_utilityroom_clk_valve_2",
    room = private.room_objname,
    zz = "zz_utilityroom",
    zz_gate = "gzz_corridorelevator_utilityroom"
  };

  local clk_valve_2_beg = function ()
  
    ObjDelete( "obj_utilityroom_clk_valve_2" );
  
  end;
  local clk_valve_2_end = function ()

    ObjSet( "spr_utilityroom_valve_2", { input = true } );
    ObjSet( "gfx_utilityroom_valve_2", { active = true } );
    ObjDelete( "spr_utilityroom_web_valve" );

    ObjDelete( "spr_corridorelevator_utilityroom_valve_2_web" );
    ObjSet( "spr_corridorelevator_utilityroom_valve_2", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_valve_2", clk_valve_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_valve_2", clk_valve_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_valve_2_beg", clk_valve_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_valve_2_end", clk_valve_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_lever () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_lever" ] = {
    type = "click",
    use_place = "obj_utilityroom_clk_lever",
    room = private.room_objname,
    zz = "zz_utilityroom",
    zz_gate = "gzz_corridorelevator_utilityroom"
  };

  local clk_lever_beg = function ()
  
    ObjDelete( "obj_utilityroom_clk_lever" );
  
  end;
  local clk_lever_end = function ()

    ObjSet( "obj_utilityroom_opn_door", { input = true } );
    ObjSet( "obj_utilityroom_lever", { pos_x = 98, pos_y = 8 } );
    ObjSet( "spr_utilityroom_close_door1", { pos_x = 140, pos_y = -66 } );
    ObjSet( "spr_utilityroom_close_door2", { pos_x = 135, pos_y = 350 } );

    ObjDelete( "spr_corridorelevator_utilityroom_door_close" );
    ObjSet( "spr_corridorelevator_utilityroom_door_open", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_lever", clk_lever_beg, private.room_objname );
  cmn.AddSubscriber( "clk_lever", clk_lever_end, private.room_objname );
  cmn.AddSubscriber( "clk_lever_beg", clk_lever_beg, private.room_objname );
  cmn.AddSubscriber( "clk_lever_end", clk_lever_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_roller () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_roller" ] = {
    type = "click",
    use_place = "obj_utilityroom_clk_roller",
    room = private.room_objname,
    zz = "zz_utilityroom",
    zz_gate = "gzz_corridorelevator_utilityroom"
  };

  local clk_roller_beg = function ()
  
    ObjDelete( "obj_utilityroom_clk_roller" );
  
  end;
  local clk_roller_end = function ()

    ObjDelete( "spr_utilityroom_roller_broken" );
    ObjSet( "obj_utilityroom_use_roller", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_roller", clk_roller_beg, private.room_objname );
  cmn.AddSubscriber( "clk_roller", clk_roller_end, private.room_objname );
  cmn.AddSubscriber( "clk_roller_beg", clk_roller_beg, private.room_objname );
  cmn.AddSubscriber( "clk_roller_end", clk_roller_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_battery1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_battery1" ] = {
    type = "click",
    use_place = "obj_metalcase_clk_battery1",
    room = private.room_objname,
    zz = "zz_metalcase",
    zz_gate = "gzz_corridorelevator_metalcase"
  };
  local clk_battery1_beg = function ()

    ObjDelete( "obj_metalcase_clk_battery1" );

  end;
  local clk_battery1_end = function ()

    ObjDelete( "spr_metalcase_box_up" );
    ObjSet( "spr_metalcase_paper", { input = true } );
    ObjSet( "spr_metalcase_battery1", { input = true } );
    ObjSet( "gfx_metalcase_battery1", { active = true } );

    ObjDelete( "spr_corridorelevator_metalcase_box_1" );

    ObjSet( "obj_collect2_item_2_3", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_battery1", clk_battery1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_battery1", clk_battery1_end, private.room_objname );
  cmn.AddSubscriber( "clk_battery1_beg", clk_battery1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_battery1_end", clk_battery1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_trianglekey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_trianglekey" ] = {
    type = "click",
    use_place = "obj_metalcase_clk_trianglekey",
    room = private.room_objname,
    zz = "zz_metalcase",
    zz_gate = "gzz_corridorelevator_metalcase"
  };
  local clk_trianglekey_beg = function ()

    ObjDelete( "obj_metalcase_clk_trianglekey" );

  end;
  local clk_trianglekey_end = function ()

    ObjSet( "gzz_corridorelevator_metalcase", { input = false, active = false, visible = false } );
    ObjSet( "gmg_corridorelevator_metalcases", { input = true, active = true } );

    ObjDelete( "spr_metalcase_box_down" );
    ObjSet( "spr_metalcase_mg_cover", { alp = 1 } );

    ObjDelete( "spr_corridorelevator_metalcase_box_2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_trianglekey", clk_trianglekey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_trianglekey", clk_trianglekey_end, private.room_objname );
  cmn.AddSubscriber( "clk_trianglekey_beg", clk_trianglekey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_trianglekey_end", clk_trianglekey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_douglasthings () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_douglasthings" ] = {
    type = "click",
    use_place = "obj_elevator_clk_douglasthings",
    room = private.room_objname,
    zz = "zz_elevator",
    zz_gate = "gzz_corridorelevator_elevator"
  };
  local clk_douglasthings_beg = function ()

    ObjDelete( "obj_elevator_clk_douglasthings" );

  end;
  local clk_douglasthings_end = function ()

    ObjSet( "gfx_elevator_douglasthings", { active = false } );
    ObjSet( "spr_elevator_douglasthings", { pos_x = -150, pos_z = -9, scale_x = 0.42, scale_y = 0.42 } );
    ObjSet( "spr_elevator_jacket_shadow", { pos_x = -150, pos_z = -10, scale_x = 0.42, scale_y = 0.42 } );
    ObjSet( "spr_elevator_jacket", { pos_x = -150, pos_z = -9, scale_x = 0.42, scale_y = 0.42 } );
    ObjDelete( "spr_elevator_doors_1" );
    ObjDelete( "spr_elevator_doors_2" );
    ObjSet( "obj_elevator_use_hookedrope", { input = true } );

    ObjDelete( "spr_corridorelevator_elevator_clothes" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_douglasthings", clk_douglasthings_beg, private.room_objname );
  cmn.AddSubscriber( "clk_douglasthings", clk_douglasthings_end, private.room_objname );
  cmn.AddSubscriber( "clk_douglasthings_beg", clk_douglasthings_beg, private.room_objname );
  cmn.AddSubscriber( "clk_douglasthings_end", clk_douglasthings_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_button_elevator () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_button_elevator" ] = {
    type = "click",
    use_place = "obj_elevator_clk_button_elevator",
    room = private.room_objname,
    zz = "zz_elevator",
    zz_gate = "gzz_corridorelevator_elevator"
  };
  local clk_button_elevator_beg = function ()

    ObjDelete( "obj_elevator_clk_button_elevator" );

  end;
  local clk_button_elevator_end = function ()

    ObjDelete( "gzz_corridorelevator_elevator" );

    ObjSet( "grm_corridorelevator_lowerlevel", { input = true, active = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_corridorelevator_lowerlevel_focus");
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_button_elevator", clk_button_elevator_beg, private.room_objname );
  cmn.AddSubscriber( "clk_button_elevator", clk_button_elevator_end, private.room_objname );
  cmn.AddSubscriber( "clk_button_elevator_beg", clk_button_elevator_beg, private.room_objname );
  cmn.AddSubscriber( "clk_button_elevator_end", clk_button_elevator_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_valve_metalcase () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_valve_metalcase" ] = {
    type = "click",
    use_place = "obj_corridorelevator_clk_valve_metalcase",
    room = private.room_objname,
  };
  local clk_valve_metalcase_beg = function ()

    ObjDelete( "obj_corridorelevator_clk_valve_metalcase" );

  end;
  local clk_valve_metalcase_end = function ()

    ObjSet( "gzz_corridorelevator_metalcase", { input = true, active = true } );

    ObjDelete( "obj_corridorelevator_metalcase_door" );
    ObjDelete( "spr_corridorelevator_metalcase_door_open_1" );
    ObjSet( "spr_corridorelevator_metalcase_door_open_2", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_valve_metalcase", clk_valve_metalcase_beg, private.room_objname );
  cmn.AddSubscriber( "clk_valve_metalcase", clk_valve_metalcase_end, private.room_objname );
  cmn.AddSubscriber( "clk_valve_metalcase_beg", clk_valve_metalcase_beg, private.room_objname );
  cmn.AddSubscriber( "clk_valve_metalcase_end", clk_valve_metalcase_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_elevator () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_elevator" ] =
  {
      type = "win",
      room = private.room_objname,
      zz = "zz_elevator",
      zz_gate = "gzz_corridorelevator_elevator"
  };
  local win_elevator = function ()

    if ( cmn.IsEventDone( "win_elevator" ) ) then
    
      ObjDelete( "obj_elevator_mmg" );
      ObjDelete( "spr_elevator_grid" );
      ObjDelete( "tmr_elevator_hand" );
      ObjDelete( "spr_elevator_hand" );
      ObjDelete( "spr_elevator_jacket" );

      ObjMultiSet({ 
        { "tmr_elevator_hand",     { playing = false } },
        { "spr_elevator_jacket_3", { alp = 1         } },
      } );

    end;

  end;

  cmn.AddSubscriber( "win_elevator", win_elevator, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_corridorelevator_2 () end;
  --------------------------------------------------------------------------------------------
  local see_corridorelevator_2 = function ()
    
    --

  end;

  cmn.AddSubscriber( "see_corridorelevator_2", see_corridorelevator_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_flashback_douglas () end;
  --------------------------------------------------------------------------------------------
  local see_flashback_douglas = function ()
    
    --

  end;

  cmn.AddSubscriber( "see_flashback_douglas", see_flashback_douglas, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load ()

  --function mmg_elevator () end; --------------------------------------------------------------------------
  if ( cmn.IsEventStart( "win_elevator" ) and not cmn.IsEventDone( "win_elevator" ) ) then  

    if ( ng_global.progress[ "std" ][ "win_elevator" ].state[ 1 ] == 0 and
         ng_global.progress[ "std" ][ "win_elevator" ].state[ 2 ] == 0 ) then

    else

      local i = ng_global.progress[ "std" ][ "win_elevator" ].state[ 1 ];
      local j = ng_global.progress[ "std" ][ "win_elevator" ].state[ 2 ];

      local start_x =  i - 1;
      local start_y =  j - 1;
      local finish_x = i + 1;
      local finish_y = j + 1;
      if ( start_x < 1 ) then start_x = 1 end;
      if ( start_y < 1 ) then start_y = 1 end;
      if ( finish_x > private.win_elevator_grid_size[ 1 ] ) then finish_x = private.win_elevator_grid_size[ 1 ] end;
      if ( finish_y > private.win_elevator_grid_size[ 2 ] ) then finish_y = private.win_elevator_grid_size[ 2 ] end;

      for x = start_x, finish_x do

        for y = start_y, finish_y do

          if not ( x == i and y == j ) then 

            local work_x = math.abs( x - private.win_elevator_dot_win[ 1 ] );
            local work_y = math.abs( y - private.win_elevator_dot_win[ 2 ] );
            local work = work_x ;

            if ( work_y > work) then

              work = work_y;

            end;  
 
            if ( work == 0 ) then
          
              --ObjSet( "spr_elevator_sight_dot_"..x.."_"..y, { color_r = 0, color_g = 1, color_b = 0 } );
              ObjSet( "spr_elevator_sight_dot_"..x.."_"..y, { res = "assets/levels/level2/rm_corridorelevator/zz_elevator/layers/sight_3" } );

            elseif ( work == 1 or work == 2 ) then

              --ObjSet( "spr_elevator_sight_dot_"..x.."_"..y, { color_r = 1, color_g = 1, color_b = 0 } );
             ObjSet( "spr_elevator_sight_dot_"..x.."_"..y, { res = "assets/levels/level2/rm_corridorelevator/zz_elevator/layers/sight_2" } );

            elseif ( work > 2 ) then 
     
              --ObjSet( "spr_elevator_sight_dot_"..x.."_"..y, { color_r = 1, color_g = 0, color_b = 0 } );   
             ObjSet( "spr_elevator_sight_dot_"..x.."_"..y, { res = "assets/levels/level2/rm_corridorelevator/zz_elevator/layers/sight_1" } );   

            end; 

            ObjSet( "spr_elevator_sight_dot_"..x.."_"..y, { alp = 1 } );

          end;    

        end;

      end;

    end;

    ObjSet( "spr_elevator_hand", { pos_x = -276, pos_y = 204 } );
    private.TmrHand();

  end;

end;
--*********************************************************************************************************************
function private.Init_Subroom ()
  --*******************************************************************************************************************
  --*** function zz_metalcase () end ****
  -- зз стена со светильником
    subroom.Define( "zz_metalcase" );
    function zz_metalcase.Open ()
    end;
    -------------------------------------------------
    function zz_metalcase.PreOpen ()

      if not ( ng_global.progress[ "std" ][ "get_battery1" ].clk_box_up ) then

        ng_global.progress[ "std" ][ "get_battery1" ].clk_box_up = 1;

      end;

    end;  
    -------------------------------------------------
    function zz_metalcase.PreClose ()

    end; 
    -------------------------------------------------
    function zz_metalcase.Close ()

        cmn.NoteScaleClose( { "spr_metalcase_paper" } ); 

    end; 

  --*******************************************************************************************************************
  --*** function zz_elevator () end ****
  -- зз лифт
    subroom.Define( "zz_elevator" );
    -------------------------------------------------
    function zz_elevator.PreOpen ()   
    end;
    -------------------------------------------------
    function zz_elevator.Open ()

      if ( cmn.IsEventStart( "win_elevator" ) and not cmn.IsEventDone( "win_elevator" ) ) then

        cmn.MiniGameShow( "elevator" );
        common_impl.PassingMgStart( "elevator" );

      end;

    end; 
    -------------------------------------------------
    function zz_elevator.PreClose ()   

      if ( cmn.IsEventStart( "win_elevator" ) and not cmn.IsEventDone( "win_elevator" ) ) then

        cmn.MiniGameHide( "elevator" );
        common_impl.PassingMgStop( "elevator" );

      end;

    end;
    -------------------------------------------------
    function zz_elevator.Close ()
    end;
    -------------------------------------------------
    function zz_elevator.Reset ()

      local func_end = function () 

        cmn.Lock( false );
        for x = 1, private.win_elevator_grid_size[ 1 ] do

          for y = 1, private.win_elevator_grid_size[ 2 ] do

            ObjSet( "spr_elevator_sight_dot_"..x.."_"..y, { color_r = 1, color_g = 1, color_b = 1 } );

          end;

        end;

        ng_global.progress[ "std" ][ "win_elevator" ].state[ 1 ] = 0;
        ng_global.progress[ "std" ][ "win_elevator" ].state[ 2 ] = 0;

      end;

      for x = 1, private.win_elevator_grid_size[ 1 ] do

        for y = 1, private.win_elevator_grid_size[ 2 ] do

          ObjAnimate( "spr_elevator_sight_dot_"..x.."_"..y, "alp", 0, 0, "",
          { 
            0.00, 0, ObjGet( "spr_elevator_sight_dot_"..x.."_"..y ).alp,
            0.15, 0, 0
          } );

        end; 

      end; 

      cmn.Lock( true );
      ObjAnimate( "zz_elevator", "alp", 0, 0, func_end,
      { 
        0.00, 0, ObjGet( "zz_elevator" ).alp,
        0.15, 0, ObjGet( "zz_elevator" ).alp,
      } );

    end;
    -------------------------------------------------
    function zz_elevator.Skip ()

      for x = 1, private.win_elevator_grid_size[ 1 ] do

        for y = 1, private.win_elevator_grid_size[ 2 ] do

          ObjAnimate( "spr_elevator_sight_dot_"..x.."_"..y, "alp", 0, 0, "",
          { 
            0.00, 0, ObjGet( "spr_elevator_sight_dot_"..x.."_"..y ).alp,
            0.15, 0, 0
          } );

        end; 

      end; 

      cmn.Lock( true );
      local name = "spr_elevator_sight_dot_"..private.win_elevator_dot_win[ 1 ].."_"..private.win_elevator_dot_win[ 2 ];
      ObjSet( name, { color_r = 0, color_g = 1, color_b = 0 } );
      ObjAnimate( name, "alp", 0, 0, function () private.WinAnimElevator()  end,
      { 
        0.00, 0, ObjGet( name ).alp,
        0.15, 0, 1,
        0.5,  0, 1
      } );

    end;
    -------------------------------------------------

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_corridorelevator();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

  if ( cmn.IsEventDone( "win_indollhouse" ) ) and ( not cmn.IsEventDone( "see_corridorelevator_2" ) ) then

    private.see_corridorelevator_2();

  end;

  if ( cmn.IsEventDone( "get_douglascard" ) ) and ( not cmn.IsEventDone( "see_flashback_douglas" ) ) then

    public.see_flashback_douglas();

  end;

  local func_end = function ()

    local pos_beg = { ObjGet( "gzz_corridorelevator_metalcase" ).pos_x, ObjGet( "gzz_corridorelevator_metalcase" ).pos_y }
    cmn.GotoSubRoom( "zz_metalcase", pos_beg, { 512, 360 } );

  end;

  if public.open_metalcase then

    public.open_metalcase = false;
    ObjAnimate( "rm_corridorelevator", "alp", 0, 0, func_end, { 0, 0, 1,   0.01, 0, 1 } );

  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();

  common_impl.EnvPlay( { "level2/env/aud_corridorelevator_env" }, "", 0.5 );

  if ( not cmn.IsEventDone( "beg_levele2" ) ) then

    cmn.SetEventDone( "beg_levele2" );
    cmn.CallEventHandler( "beg_levele2" ); 
  
  end;

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_battery_1 ()

  local item = "inv_battery";

  if cmn.ApplyObj( item, "gzz_corridorelevator_utilityroom" ) and ( not cmn.IsEventDone( "use_battery_1" ) ) and cmn.IsEventDone( "get_battery1" ) and cmn.IsEventDone( "get_battery2" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_utilityroom", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_utilityroom_use_battery_1" ) ) and ( not cmn.IsEventDone( "use_battery_1" ) ) and cmn.IsEventDone( "get_battery1" ) and cmn.IsEventDone( "get_battery2" ) then

    cmn.CallEventHandler( "use_battery_1_inv" );
    cmn.CallEventHandler( "use_battery_1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_battery_1" );
      cmn.CallEventHandler( "use_battery_1_end" );

      ObjAnimate( "spr_utilityroom_light_all", "alp", 1, 0, "", 
      { 
        0.0, 0, 1.0,
        1.2, 0, 0.5,
        2.0, 0, 0.9,
        3.0, 0, 0.55,
        4.0, 3, 1.0
      } );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_battery1", 0, "", 0 );

    AnimPlay( "anm_utilityroom_light", "DoAnim", "" );
    ObjSet( "spr_utilityroom_light_all", { visible = true } );

    cmn.Lock( true );
    ObjAnimate( "spr_utilityroom_battery_1", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0,
      0.3, 0, 1.0
    } );

    ObjAnimate( "spr_utilityroom_battery_2", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0,
      0.2, 0, 0.0,
      0.5, 0, 1.0,
    } );

    ObjAnimate( "spr_utilityroom_light_battery_red", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0,
      0.5, 0, 1.0,
      0.6, 0, 0.0,
      0.9, 0, 0.0,
      1.0, 0, 1.0,
      1.5, 0, 1.0,
      1.6, 0, 0.0,
    } );
    ObjAnimate( "spr_utilityroom_light_battery_green", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0,
      1.5, 0, 0.0,
      1.6, 0, 1.0
    } );
    ObjAnimate( "spr_utilityroom_dark", "alp", 0, 0, func_end,
    { 
      0.0, 0, 1.0,
      1.6, 0, 1.0,
      2.1, 0, 0.3,
      2.2, 0, 0.9,
      2.7, 0, 0.0
    } );

    ObjAnimate( "spr_utilityroom_light_all", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0,
      1.6, 0, 0.0,
      2.1, 0, 0.9,
      2.2, 0, 0.1,
      2.7, 0, 0.0
    } );

    return true;

  end;
    
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_roller ()

  local item = "inv_roller";

  if cmn.ApplyObj( item, "gzz_corridorelevator_utilityroom" ) and cmn.IsEventDone( "clk_roller" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_utilityroom", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_utilityroom_use_roller" ) and cmn.IsEventDone( "clk_roller" ) ) then

    cmn.CallEventHandler( "use_roller_inv" );
    cmn.CallEventHandler( "use_roller_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_roller" );
      cmn.CallEventHandler( "use_roller_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_gear_corridor", 0, "", 0 );

    cmn.ItemFly( "spr_utilityroom_roller", func_end, 1.5 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_trianglekey ()

  local item = "inv_trianglekey";

  if cmn.ApplyObj( item, "gzz_corridorelevator_metalcase" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_metalcase", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_metalcase_use_trianglekey" ) ) then

    cmn.CallEventHandler( "use_trianglekey_inv" );
    cmn.CallEventHandler( "use_trianglekey_beg" );

    local func_end = function ()

      cmn.Lock( false );

      common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk9", 0, "", 0 );

      cmn.SetEventDone( "use_trianglekey" );
      cmn.CallEventHandler( "use_trianglekey_end" );

    end;

    cmn.Lock( true );


    ObjSet( "spr_metalcase_key_layer", { alp = 1 } );
    cmn.ItemFly( "spr_metalcase_key", func_end, 1.8, 100 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_hookedrope ()

  local item = "inv_hookedrope";

  if ( cmn.ApplyObj( item, "gzz_corridorelevator_elevator" ) and cmn.IsEventDone( "clk_douglasthings" ) ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_elevator", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_elevator_use_hookedrope" ) and cmn.IsEventDone( "clk_douglasthings" ) ) then

    cmn.CallEventHandler( "use_hookedrope_inv" );
    cmn.CallEventHandler( "use_hookedrope_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_hookedrope" );
      cmn.CallEventHandler( "use_hookedrope_end" );
      private.InitElevatorStart();

    end;

    cmn.Lock( true );

    --common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_hookedrope", 0, "", 0 );
    ObjAnimate( "obj_elevator_mmg", "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "obj_elevator_mmg" ).alp,
      0.5, 0, 1
    } );
    ObjAnimate( "spr_elevator_grid", "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_elevator_grid" ).alp,
      0.5, 0, 1
    } );
    ObjAnimate( "spr_elevator_hand", "pos_xy", 0, 0, func_end,
    { 
      0.0, 0, ObjGet( "spr_elevator_hand" ).pos_x, ObjGet( "spr_elevator_hand" ).pos_y,
      0.5, 0, -276, 204
    } );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_kevinscard ()

  local item = "inv_kevinscard";

  if cmn.ApplyObj( item, "gzz_corridorelevator_elevator" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_elevator", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_elevator_use_kevinscard" ) ) then

    cmn.CallEventHandler( "use_kevinscard_inv" );
    cmn.CallEventHandler( "use_kevinscard_beg" );

    local func_end = function ()

      public.use_kevinscard_end();

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_card", 0, "", 0 );

    cmn.ItemFly( "spr_elevator_kevin_reynolds", func_end, -1.51 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_kevinscard_end ()

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "use_kevinscard" );
    cmn.CallEventHandler( "use_kevinscard_end" );

  end;

  if ( cmn.IsEventDone( "use_douglascard" ) ) then

    cmn.Lock( true );


    common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_slide", 0, "", 0 );

    ObjAnimate( "spr_elevator_card_1", "pos_xy", 0, 0, "",
    { 
      0.0, 3, ObjGet( "spr_elevator_card_1" ).pos_x, ObjGet( "spr_elevator_card_1" ).pos_y,
      0.5, 3, 303, -172
    } );
    ObjAnimate( "spr_elevator_card_2", "pos_xy", 0, 0, func_end,
    { 
      0.0, 3, ObjGet( "spr_elevator_card_2" ).pos_x, ObjGet( "spr_elevator_card_2" ).pos_y,
      0.5, 3, 256, 15
    } );

  else

    func_end();

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_douglascard ()

  local item = "inv_douglascard";

  if cmn.ApplyObj( item, "gzz_corridorelevator_elevator" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_elevator", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_elevator_use_douglascard" ) ) then

    cmn.CallEventHandler( "use_douglascard_inv" );
    cmn.CallEventHandler( "use_douglascard_beg" );

    local func_end = function ()

      public.use_douglascard_end();

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_card", 0, "", 0 );

    cmn.ItemFly( "spr_elevator_douglas_will", func_end, -1.51 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_douglascard_end ()

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "use_douglascard" );
    cmn.CallEventHandler( "use_douglascard_end" );

  end;

  if ( cmn.IsEventDone( "use_kevinscard" ) ) then

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_slide", 0, "", 0 );

    ObjAnimate( "spr_elevator_card_1", "pos_xy", 0, 0, "",
    { 
      0.0, 3, ObjGet( "spr_elevator_card_1" ).pos_x, ObjGet( "spr_elevator_card_1" ).pos_y,
      0.5, 3, 303, -172
    } );
    ObjAnimate( "spr_elevator_card_2", "pos_xy", 0, 0, func_end,
    { 
      0.0, 3, ObjGet( "spr_elevator_card_2" ).pos_x, ObjGet( "spr_elevator_card_2" ).pos_y,
      0.5, 3, 256, 15
    } );

  else

    func_end();

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_valve_2 ()

  local item = "inv_valve_2";

  if ( cmn.ApplyObj( item, "obj_corridorelevator_use_valve_2" ) ) then

    cmn.CallEventHandler( "use_valve_2_inv" );
    cmn.CallEventHandler( "use_valve_2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_valve_2" );
      cmn.CallEventHandler( "use_valve_2_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_courtyard_clk_valve", 0, "", 0 );

    ObjAnimate( "spr_corridorelevator_metalcase_door_valve_1", "alp", 0, 0, func_end,
    { 
      0.0, 3, ObjGet( "spr_corridorelevator_metalcase_door_valve_1" ).alp,
      0.3, 3, 1
    } );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_stepladder ()

  local item = "inv_stepladder";

  if ( cmn.ApplyObj( item, "obj_elevator_use_hookedrope" ) ) then

    common_impl.ShowBbt( "bbt_corridorelevator_wrong_use_stepladder" );    
    common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
function private.get_valve_2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_valve_2" );
  cmn.CallEventHandler( "get_valve_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_stepladder ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_stepladder" );
  cmn.CallEventHandler( "get_stepladder" );

end;
--------------------------------------------------------------------------------------------
function private.get_hook_1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_hook_1" );
  cmn.CallEventHandler( "get_hook_1" );

  if ( cmn.IsEventDone( "get_redwire" ) ) then

    common.CloseSubRoom(); 

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_redwire ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_redwire" );
  cmn.CallEventHandler( "get_redwire" );

  if ( cmn.IsEventDone( "get_hook_1" ) ) then

    common.CloseSubRoom(); 

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_battery1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_battery1" );
  cmn.CallEventHandler( "get_battery1" );

  if ( cmn.IsEventDone( "get_roller" ) ) then

    common.CloseSubRoom();     

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_battery2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_battery2" );
  cmn.CallEventHandler( "get_battery2" );

end;
--------------------------------------------------------------------------------------------
function private.get_douglasthings ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_douglasthings" );
  cmn.CallEventHandler( "get_douglasthings" );

end;

--------------------------------------------------------------------------------------------
function private.get_roller ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_roller" );
  cmn.CallEventHandler( "get_roller" );

--  if ( cmn.IsEventDone( "get_battery1" ) ) then
--
--    common.CloseSubRoom();     
--
--  end;

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_2_3 ()

  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_2_3" ); 

  end;

  common_impl.PlayEffectHO( "spr_collect2_item_2_3", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_2_3" );  

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_rightwall ()

  cmn.CallEventHandler( "clk_rightwall_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_rightwall" );
    cmn.CallEventHandler( "clk_rightwall_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_door_corridor", 0, "", 0 );

  AnimPlay( "anm_corridorelevator_doors", "DoAnim", func_end );

end;
--------------------------------------------------------------------------------------------
function private.clk_valve_2 ()

  cmn.CallEventHandler( "clk_valve_2_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_valve_2" );
    cmn.CallEventHandler( "clk_valve_2_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_net", 0, "", 0 );

  ObjAnimate( "spr_utilityroom_web_valve", "alp", 0, 0, func_end,
  { 
    0.0, 0, ObjGet( "spr_utilityroom_web_valve" ).alp,
    0.3, 0, 0
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_lever ()

  local func_anim = function ()

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_lever" );
      cmn.CallEventHandler( "clk_lever_end" );

    end;

    VidPlay( "vid_utilityroom_cogwheel", func_end );

    ObjAnimate( "spr_utilityroom_close_door1", "pos_xy", 0, 0, "",
    { 
      0.0, 3, ObjGet( "spr_utilityroom_close_door1" ).pos_x, ObjGet( "spr_utilityroom_close_door1" ).pos_y,
      4.0, 3, 140, -66  
    } );
    ObjAnimate( "spr_utilityroom_close_door2", "pos_xy", 0, 0, "",
    { 
      0.0, 3, ObjGet( "spr_utilityroom_close_door2" ).pos_x, ObjGet( "spr_utilityroom_close_door2" ).pos_y,
      4.0, 3, 135, 350 
    } );

  end;

  cmn.Lock( true );

  cmn.CallEventHandler( "clk_lever_beg" );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_lever_opn_door", 0, "", 0 );

  ObjAnimate( "obj_utilityroom_lever", "pos_xy", 0, 0, func_anim,
  { 
    0.0, 2, ObjGet( "obj_utilityroom_lever" ).pos_x, ObjGet( "obj_utilityroom_lever" ).pos_y,
    0.6, 2, 98, 8  
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_roller ()

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_roller" );
    cmn.CallEventHandler( "clk_roller_end" );

  end;

  cmn.Lock( true );

  cmn.CallEventHandler( "clk_roller_beg" );

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_fall_gear", 0, "", 0 );

  local p_x = ObjGet( "obj_utilityroom_lever" ).pos_x;
  ObjAnimate( "obj_utilityroom_lever", "pos_x", 0, 0, "",
  { 
    0.0, 2, p_x,
    0.2, 2, p_x + 10,   
    0.4, 2, p_x
  } );

  ObjAnimate( "spr_utilityroom_close_door1", "pos_y", 0, 0, "",
  { 
    0.0, 0, ObjGet( "spr_utilityroom_close_door1" ).pos_y,
    0.2, 0, ObjGet( "spr_utilityroom_close_door1" ).pos_y - 5,   
    0.4, 0, ObjGet( "spr_utilityroom_close_door1" ).pos_y
  } );

  ObjAnimate( "spr_utilityroom_close_door2", "pos_y", 0, 0, "",
  { 
    0.0, 0, ObjGet( "spr_utilityroom_close_door2" ).pos_y,
    0.2, 0, ObjGet( "spr_utilityroom_close_door2" ).pos_y + 5,   
    0.4, 0, ObjGet( "spr_utilityroom_close_door2" ).pos_y
  } );

  --ObjSet( "spr_utilityroom_roller_broken", { pos_z = 4 } );
  ObjAnimate( "spr_utilityroom_roller_broken", "pos_y", 0, 0, func_end,
  { 
    0.0, 0, 55,
    0.4, 0, 55,
    1.0, 0, 353  
  } );

end;
--*********************************************************************************************************************
function private.clk_battery1 ()

  cmn.CallEventHandler( "clk_battery1_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_battery1" );
    cmn.CallEventHandler( "clk_battery1_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_slide", 0, "", 0 );

  ObjAnimate( "spr_metalcase_box_up", "pos_xy", 0, 0, func_end,
  { 
    0.0, 0, ObjGet( "spr_metalcase_box_up" ).pos_x, ObjGet( "spr_metalcase_box_up" ).pos_y,
    0.3, 0, -636, 47
  } );

end;
--*********************************************************************************************************************
function private.clk_trianglekey ()

  cmn.CallEventHandler( "clk_trianglekey_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_trianglekey" );
    cmn.CallEventHandler( "clk_trianglekey_end" );

    common.CloseSubRoom();
    cmn.GotoRoom( "mg_metalcases" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_triangle_key", 0, "", 0 );

  ObjAnimate( "spr_metalcase_key", "alp", 0, 0, "",
  { 
    0.0, 0, ObjGet( "spr_metalcase_key" ).alp,
    0.3, 0, 0
  } ); 

  ObjAnimate( "spr_metalcase_key2", "alp", 0, 0, "",
  { 
    0.0, 0, ObjGet( "spr_metalcase_key2" ).alp,
    0.3, 0, 1,
    0.5, 0, 1,
  } );   


  ObjAnimate( "spr_metalcase_box_down", "alp", 0, 0, "",
  { 
    0.0, 2, ObjGet( "spr_metalcase_box_down" ).alp,
    0.8, 2, 1,
    1.1, 2, 0,
  } ); 

  ObjAnimate( "spr_metalcase_mg_cover", "alp", 0, 0, func_end,
  { 
    0.0, 1, ObjGet( "spr_metalcase_mg_cover" ).alp,
    0.5, 1, 0,
    1.1, 1, 1,
    2.0, 1, 1,
  } ); 

end;
--*********************************************************************************************************************
function private.clk_douglasthings ()

  cmn.CallEventHandler( "clk_douglasthings_beg" );

  local func_end = function ()

    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "get_masked_man" );

    common_impl.ShowBbt( "bbt_elevator_clk_douglasthings" );

    cmn.Lock( false );
    cmn.SetEventDone( "clk_douglasthings" );
    cmn.CallEventHandler( "clk_douglasthings_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_elevator_clk", 0, "", 0 );

  ObjAnimate( "spr_elevator_doors_1", "pos_xy", 0, 0, "",
  { 
    0.0, 3, ObjGet( "spr_elevator_doors_1" ).pos_x, ObjGet( "spr_elevator_doors_1" ).pos_y,
    0.4, 3, 155, 47
  } ); 
  ObjAnimate( "spr_elevator_doors_2", "pos_xy", 0, 0, "",
  { 
    0.0, 3, ObjGet( "spr_elevator_doors_2" ).pos_x, ObjGet( "spr_elevator_doors_2" ).pos_y,
    0.4, 3, -399, 66
  } );   
  ObjAnimate( "spr_elevator_douglasthings", "scale_xy", 0, 0, "",
  { 
    0.0, 1, ObjGet( "spr_elevator_douglasthings" ).scale_x, ObjGet( "spr_elevator_douglasthings" ).scale_y,
    0.1, 1, ObjGet( "spr_elevator_douglasthings" ).scale_x, ObjGet( "spr_elevator_douglasthings" ).scale_y,
    0.4, 1, 0.42, 0.42
  } );
  ObjAnimate( "spr_elevator_douglasthings", "pos_xy", 0, 0, "",
  { 
    0.0, 1, ObjGet( "spr_elevator_douglasthings" ).pos_x, ObjGet( "spr_elevator_douglasthings" ).pos_y,
    0.1, 1, ObjGet( "spr_elevator_douglasthings" ).pos_x, ObjGet( "spr_elevator_douglasthings" ).pos_y,
    0.4, 1, -150, ObjGet( "spr_elevator_douglasthings" ).pos_y,
  } );
  ObjAnimate( "spr_elevator_jacket", "scale_xy", 0, 0, "",
  { 
    0.0, 1, ObjGet( "spr_elevator_jacket" ).scale_x, ObjGet( "spr_elevator_jacket" ).scale_y,
    0.1, 1, ObjGet( "spr_elevator_jacket" ).scale_x, ObjGet( "spr_elevator_jacket" ).scale_y,
    0.4, 1, 0.42, 0.42
  } );  
  ObjAnimate( "spr_elevator_jacket", "pos_xy", 0, 0, "",
  { 
    0.0, 1, ObjGet( "spr_elevator_jacket" ).pos_x, ObjGet( "spr_elevator_jacket" ).pos_y,
    0.1, 1, ObjGet( "spr_elevator_jacket" ).pos_x, ObjGet( "spr_elevator_jacket" ).pos_y,
    0.4, 1, -150, ObjGet( "spr_elevator_jacket" ).pos_y,
  } ); 
  ObjAnimate( "spr_elevator_jacket_shadow", "scale_xy", 0, 0, "",
  { 
    0.0, 1, ObjGet( "spr_elevator_jacket_shadow" ).scale_x, ObjGet( "spr_elevator_jacket_shadow" ).scale_y,
    0.1, 1, ObjGet( "spr_elevator_jacket_shadow" ).scale_x, ObjGet( "spr_elevator_jacket_shadow" ).scale_y,
    0.4, 1, 0.42, 0.42
  } );  
  ObjAnimate( "spr_elevator_jacket_shadow", "pos_xy", 0, 0, func_end,
  { 
    0.0, 1, ObjGet( "spr_elevator_jacket_shadow" ).pos_x, ObjGet( "spr_elevator_jacket_shadow" ).pos_y,
    0.1, 1, ObjGet( "spr_elevator_jacket_shadow" ).pos_x, ObjGet( "spr_elevator_jacket_shadow" ).pos_y,
    0.4, 1, -150, ObjGet( "spr_elevator_jacket_shadow" ).pos_y,
  } );  

end;
--*********************************************************************************************************************
function private.clk_button_elevator ()

  cmn.CallEventHandler( "clk_button_elevator_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_button_elevator" );
    cmn.CallEventHandler( "clk_button_elevator_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_lift_button", 0, "", 0 );

  func_end();
  common.CloseSubRoom();   
  --ObjAnimate( "spr_elevator_doors_1", "pos_xy", 0, 0, "",
  --{ 
  --  0.0, 3, ObjGet( "spr_elevator_doors_1" ).pos_x, ObjGet( "spr_elevator_doors_1" ).pos_y,
  --  0.4, 3, 155, 47
  --} ); 

end;
--*********************************************************************************************************************
function private.clk_valve_metalcase ()

  cmn.CallEventHandler( "clk_valve_metalcase_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_valve_metalcase" );
    cmn.CallEventHandler( "clk_valve_metalcase_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_valve_corridor", 0, "", 0 );

  ObjAnimate( "spr_corridorelevator_metalcase_door_valve_1", "alp", 0, 0, "", 
  {
    0.0, 0, ObjGet( "spr_corridorelevator_metalcase_door_valve_1" ).alp,
    0.3, 0, 1,
    0.5, 0, 1,
    0.6, 0, 0,
    0.7, 0, 0,
    0.8, 0, 1,
    0.9, 0, 1,
    1.0, 0, 0,
    1.1, 0, 0,
    1.2, 0, 1,
    1.5, 0, 1
  } );

  ObjAnimate( "spr_corridorelevator_metalcase_door_valve_2", "alp", 0, 0, "", 
  {
    0.0, 0, 0,
    0.5, 0, 0,
    0.6, 0, 1,
    0.7, 0, 1,
    0.8, 0, 0,
    0.9, 0, 0,
    1.0, 0, 1,
    1.1, 0, 1,
    1.2, 0, 0
  } );

  ObjAnimate( "obj_corridorelevator_metalcase_door", "alp", 0, 0, "", 
  {
    0.0, 0, 1,
    1.5, 0, 1,
    1.7, 0, 0,
  } );

  ObjAnimate( "spr_corridorelevator_metalcase_door_open_1", "alp", 0, 0, "", 
  {
    0.0, 0, 0,
    1.5, 0, 0,
    1.7, 0, 1,
  } );

  ObjAnimate( "spr_corridorelevator_metalcase_door_open_2", "alp", 0, 0, func_end, 
  {
    0.0, 0, 0,
    1.7, 0, 0,
    2.0, 0, 1,
  } );  

end;
--*********************************************************************************************************************
-- function *** MMG_ELEVATOR *** () end;
--*********************************************************************************************************************
  function private.InitElevatorStart ()

    ng_global.progress[ "std" ][ "win_elevator" ].state = { 0,0 };
    cmn.MiniGameShow( "elevator" );
    common_impl.PassingMgStart( "elevator" );
    private.TmrHand();

  end;
  --------------------------------------------------------------------------------------------
  function private.InitElevator ()

    private.win_elevator_dot_win = { 4, 3 };
    private.win_elevator_grid_size = { 8, 7 } ;

    ObjMultiSet( { 
      { "tmr_elevator_hand",                     { endtrig = private.TmrHand, time = 0.3 } },
    } );

    for i = 1, private.win_elevator_grid_size[ 1 ] do

      for j = 1, private.win_elevator_grid_size[ 2 ] do

        local name = "spr_elevator_sight_"..i.."_"..j; 
        ObjCreate( name, "spr" );
        ObjAttach( name, "obj_elevator_field_"..i.."_"..j );
        ObjSet( name, 
        { 
          res = "assets/levels/level2/rm_corridorelevator/zz_elevator/layers/sight",
          alp = 0,
          input = false,
        } );    

        name = "spr_elevator_sight_red_"..i.."_"..j; 
        ObjCreate( name, "spr" );
        ObjAttach( name, "obj_elevator_field_"..i.."_"..j );
        ObjSet( name, 
        { 
          pos_z = 5,
          res = "assets/levels/level2/rm_corridorelevator/zz_elevator/layers/sight_red",
          alp = 0,
          input = false,
        } ); 

        name = "spr_elevator_sight_green_"..i.."_"..j; 
        ObjCreate( name, "spr" );
        ObjAttach( name, "obj_elevator_field_"..i.."_"..j );
        ObjSet( name, 
        { 
          pos_z = 5,
          res = "assets/levels/level2/rm_corridorelevator/zz_elevator/layers/sight_green",
          alp = 0,
          input = false,
        } );  

        name = "spr_elevator_sight_dot_"..i.."_"..j; 
        ObjCreate( name, "spr" );
        ObjAttach( name, "obj_elevator_field_"..i.."_"..j );
        ObjSet( name, 
        { 
          pos_z = -5,
          res = "assets/levels/level2/rm_corridorelevator/zz_elevator/layers/gray_dot_light",
          alp = 0,
          input = false,
        } );     
 
        ObjSet( "obj_elevator_field_"..i.."_"..j, 
        {
          event_mdown  = function () private.ClkHook( i, j ) end,
          event_menter = function () private.SightShow( i, j ) end,
          event_mleave = function () private.SightHide( i, j ) end, 
        } );

      end;

    end;

  end;
  --------------------------------------------------------------------------------------------  
  function private.ClkHook ( i, j )

    local func_end = function ()


      if ( private.win_elevator_dot_win[ 1 ] == i and private.win_elevator_dot_win[ 2 ] == j ) then

        private.WinAnimElevator();

      else 

        for x = 1, private.win_elevator_grid_size[ 1 ] do

          for y = 1, private.win_elevator_grid_size[ 2 ] do

            ObjSet( "spr_elevator_sight_dot_"..x.."_"..y, { color_r = 1, color_g = 1, color_b = 1 } );

          end;

        end;

        private.MakeRoundColor( i, j );  

      end;     

    end;

    for x = 1, private.win_elevator_grid_size[ 1 ] do

      for y = 1, private.win_elevator_grid_size[ 2 ] do

        ObjAnimate( "spr_elevator_sight_dot_"..x.."_"..y, "alp", 0, 0, "",
        { 
          0.00, 0, ObjGet( "spr_elevator_sight_dot_"..x.."_"..y ).alp,
          0.15, 0, 0
        } );

      end; 

    end; 

    cmn.Lock( true );
    ObjAnimate( "zz_elevator", "alp", 0, 0, func_end,
    { 
      0.00, 0, ObjGet( "zz_elevator" ).alp,
      0.15, 0, ObjGet( "zz_elevator" ).alp,
    } );
    ObjAnimate( "spr_elevator_sight_green_"..i.."_"..j, "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_elevator_sight_green_"..i.."_"..j ).alp,
      0.1, 0, 1,
      0.2, 0, 0
    } ); 
    --ObjAnimate( "spr_elevator_hoock_1", "pos_xy", 0, 0, "",
    --{ 
    --  0.0, 0, -17, -32,
    --  0.1, 0, 23,-59,
    --  0.2, 0, -17, -32,
    --} ); 

  end;
  --------------------------------------------------------------------------------------------
  function private.MakeRoundColor ( i, j )
    
    local start_x =  i - 1;
    local start_y =  j - 1;
    local finish_x = i + 1;
    local finish_y = j + 1;
    if ( start_x < 1 ) then start_x = 1 end;
    if ( start_y < 1 ) then start_y = 1 end;
    if ( finish_x > private.win_elevator_grid_size[ 1 ] ) then finish_x = private.win_elevator_grid_size[ 1 ] end;
    if ( finish_y > private.win_elevator_grid_size[ 2 ] ) then finish_y = private.win_elevator_grid_size[ 2 ] end;

    for x = start_x, finish_x do

      for y = start_y, finish_y do

        if not ( x == i and y == j ) then 

          local work_x = math.abs( x - private.win_elevator_dot_win[ 1 ] );
          local work_y = math.abs( y - private.win_elevator_dot_win[ 2 ] );
          local work = work_x ;

          if ( work_y > work) then

            work = work_y;

          end;   

          if ( work == 0 ) then
        
            --ObjSet( "spr_elevator_sight_dot_"..x.."_"..y, { color_r = 0, color_g = 1, color_b = 0 } );
            ObjSet( "spr_elevator_sight_dot_"..x.."_"..y, { res = "assets/levels/level2/rm_corridorelevator/zz_elevator/layers/sight_3" } );

          elseif ( work == 1 or work == 2 ) then

            --ObjSet( "spr_elevator_sight_dot_"..x.."_"..y, { color_r = 1, color_g = 1, color_b = 0 } );
           ObjSet( "spr_elevator_sight_dot_"..x.."_"..y, { res = "assets/levels/level2/rm_corridorelevator/zz_elevator/layers/sight_2" } );

          elseif ( work > 2 ) then 
   
            --ObjSet( "spr_elevator_sight_dot_"..x.."_"..y, { color_r = 1, color_g = 0, color_b = 0 } );   
           ObjSet( "spr_elevator_sight_dot_"..x.."_"..y, { res = "assets/levels/level2/rm_corridorelevator/zz_elevator/layers/sight_1" } );   

          end; 

          ObjAnimate( "spr_elevator_sight_dot_"..x.."_"..y, "alp", 0, 0, "",
          { 
            0.00, 0, ObjGet( "spr_elevator_sight_dot_"..x.."_"..y ).alp,
            0.15, 0, 1
          } ); 

        end;    

      end;

    end;
    
    ObjAnimate( "zz_elevator", "alp", 0, 0, function() private.ClkHookEnd( i, j ); end,
    { 
      0.00, 0, ObjGet( "zz_elevator" ).alp,
      0.15, 0, ObjGet( "zz_elevator" ).alp,
    } );

  end;
  --------------------------------------------------------------------------------------------
  function private.ClkHookEnd ( i, j )

    cmn.Lock( false );
    ng_global.progress[ "std" ][ "win_elevator" ].state[ 1 ] = i;
    ng_global.progress[ "std" ][ "win_elevator" ].state[ 2 ] = j;

  end;
  --------------------------------------------------------------------------------------------
  function private.SightShow ( i, j )

    common_impl.SetCursor( CURSOR_NULL );
    local name = "spr_elevator_sight_"..i.."_"..j; 
    ObjAnimate( name, "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( name ).alp,
      0.1, 0, 1
    } ); 

  end;
  --------------------------------------------------------------------------------------------
  function private.SightHide ( i, j )

    common_impl.SetCursor( CURSOR_DEFAULT );
    local name = "spr_elevator_sight_"..i.."_"..j; 
    ObjAnimate( name, "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( name ).alp,
      0.1, 0, 0
    } ); 

  end;
  --------------------------------------------------------------------------------------------
  function private.TmrHand ()

    local pos = GetZoomCursorPos();
    local pcx = pos[ 1 ];
    local pcy = pos[ 2 ];
    local eyes_posx = math.floor(pcx / 10 ) - 350;
    local eyes_posy = math.floor(pcy / 60 ) + 200;
    local eyex = ObjGet("spr_elevator_hand").pos_x;
    local eyey = ObjGet("spr_elevator_hand").pos_y;

    ObjAnimate("spr_elevator_hand", "pos_xy", 0, 0, function () ObjSet("tmr_elevator_hand", { endtrig = private.TmrHand, time = 0.01, playing = true } ); end, 
    {
      0.0, 0,      eyex,       eyey, 
      0.2, 0, eyes_posx,  eyes_posy
    } );

  end;
  --------------------------------------------------------------------------------------------
  function private.WinAnimElevator ()

    local func_end = function ()

      cmn.Lock( false );
      private.WinElevator();

    end;

    cmn.Lock( true );
    ObjAnimate( "obj_elevator_mmg", "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "obj_elevator_mmg" ).alp,
      0.3, 0, 0
    } );    
    ObjAnimate( "spr_elevator_grid", "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_elevator_grid" ).alp,
      0.3, 0, 0
    } ); 
    ObjAnimate( "spr_elevator_hand", "pos_xy", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_elevator_hand" ).pos_x, ObjGet( "spr_elevator_hand" ).pos_y,
      0.3, 0, -347, 438
    } ); 
    ObjAnimate( "spr_elevator_hand", "pos_xy", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_elevator_hand" ).pos_x, ObjGet( "spr_elevator_hand" ).pos_y,
      0.3, 0, -347, 438
    } );  
 
    ObjSet( "spr_elevator_douglasthings", { pos_z = 6 } );
    ObjAnimate( "spr_elevator_douglasthings", "scale_xy", 0, 0, func_end,
    { 
      0.0, 1, ObjGet( "spr_elevator_douglasthings" ).scale_x, ObjGet( "spr_elevator_douglasthings" ).scale_y,
      0.3, 1, 1, 1
    } );   

  end;
  --------------------------------------------------------------------------------------------
  function private.WinElevator ()

    cmn.Lock( false );  
  
    cmn.MiniGameHide( "elevator" );
    common_impl.PassingMgWin( "elevator" );
    cmn.SetEventDone( "win_elevator" );
    cmn.CallEventHandler( "win_elevator" );

    private.get_douglasthings();

  end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_corridorelevator ()

  if not ( cmn.IsEventDone( "opn_corridorelevator" ) ) then

    common_impl.ShowBbt( "bbt_corridorelevator_opn_corridorelevator" );
    interface.KeyTaskAdd( "get_to_lower" );

    cmn.SetEventDone( "opn_corridorelevator" );

    cmn.SetEventDone( "opn_bar_2" );
    cmn.CallEventHandler( "opn_bar_2" ); 

    cmn.SetEventDone( "opn_hall_2" );
    cmn.CallEventHandler( "opn_hall_2" ); 

    cmn.SetEventDone( "opn_courtyard_2" );
    cmn.CallEventHandler( "opn_courtyard_2" ); 

    cmn.SetEventDone( "opn_lounge_2" );
    cmn.CallEventHandler( "opn_lounge_2" ); 

  end;

  cmn.CallEventHandler( "opn_corridorelevator" ); 

end;
--------------------------------------------------------------------------------------------
function private.see_corridorelevator_2 ()

  local func_end = function ()

    cmn.SetEventDone( "see_corridorelevator_2" );
    cmn.CallEventHandler( "see_corridorelevator_2" );

    cmn.PlayMusDanger();
    common_impl.ShowBbt( "bbt_corridorelevator_see_corridorelevator_2" );

  end;

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_corridor_the_elevator", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_corridorelevator_corridorelevator_2", func_end );

end;
--------------------------------------------------------------------------------------------
function public.see_flashback_douglas () --public для вызова из инвентаря

  local func_end = function ()

    cmn.SetEventDone( "see_flashback_douglas" );
    cmn.CallEventHandler( "see_flashback_douglas" );

    common_impl.StopAudio( "sfx", "level2/sfx/aud_flashback_douglas", 0.2 );
    common_impl.StopAudio( "voc", "level2/voc/aud_flashback_douglas_voc", 0.2 );

    common_impl.ShowBbt( "bbt_corridorelevator_see_flashback_douglas" );

  end;

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_flashback_douglas", 0, "", 0 );
  common_impl.PlayAudio( "voc", "level2/voc/aud_flashback_douglas_voc", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_corridorelevator_flashback_douglas", func_end );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_elevator_light_1", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,    
    2.5, 0, 0.5,   
    5.0, 0, 1  
  } );

  --if ( cmn.IsEventDone( "use_battery_1" ) ) then

    ObjAnimate( "spr_utilityroom_light_all", "alp", 1, 0, "", 
    { 
      0.0, 0, 1.0,
      1.2, 0, 0.5,
      2.0, 0, 0.9,
      3.0, 0, 0.55,
      4.0, 3, 1.0
    } );

  --end;

end;
--
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.UseTrianglekey ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( "bbt_metalcase_use_trianglekey" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

  ObjAnimate( "spr_metalcase_box_down", "pos_xy", 0, 0, func_end,
  { 
    0.0, 0, -3, 175,
    0.2, 0, -1, 177,
    0.4, 0, -3, 175,
  } );  

end;
--*********************************************************************************************************************
function private.UseKevinscard ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( "bbt_elevator_use_kevinscard" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk9", 0, "", 0 );

  ObjAnimate( "spr_elevator_card_2", "pos_xy", 0, 0, "",
  { 
    0.0, 0, ObjGet( "spr_elevator_card_2" ).pos_x, ObjGet( "spr_elevator_card_2" ).pos_y,
    0.2, 0, ObjGet( "spr_elevator_card_2" ).pos_x, ObjGet( "spr_elevator_card_2" ).pos_y + 5,
    0.4, 0, ObjGet( "spr_elevator_card_2" ).pos_x, ObjGet( "spr_elevator_card_2" ).pos_y,
  } ); 
  ObjAnimate( "spr_elevator_card_1", "pos_xy", 0, 0, func_end,
  { 
    0.0, 0, ObjGet( "spr_elevator_card_1" ).pos_x, ObjGet( "spr_elevator_card_1" ).pos_y,
    0.2, 0, ObjGet( "spr_elevator_card_1" ).pos_x, ObjGet( "spr_elevator_card_1" ).pos_y - 5,
    0.4, 0, ObjGet( "spr_elevator_card_1" ).pos_x, ObjGet( "spr_elevator_card_1" ).pos_y,
  } ); 

end;
--*********************************************************************************************************************
function private.UseDouglascard ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( "bbt_elevator_use_douglascard" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk9", 0, "", 0 );

  ObjAnimate( "spr_elevator_card_2", "pos_xy", 0, 0, "",
  { 
    0.0, 0, ObjGet( "spr_elevator_card_2" ).pos_x, ObjGet( "spr_elevator_card_2" ).pos_y,
    0.2, 0, ObjGet( "spr_elevator_card_2" ).pos_x, ObjGet( "spr_elevator_card_2" ).pos_y + 5,
    0.4, 0, ObjGet( "spr_elevator_card_2" ).pos_x, ObjGet( "spr_elevator_card_2" ).pos_y,
  } ); 
  ObjAnimate( "spr_elevator_card_1", "pos_xy", 0, 0, func_end,
  { 
    0.0, 0, ObjGet( "spr_elevator_card_1" ).pos_x, ObjGet( "spr_elevator_card_1" ).pos_y,
    0.2, 0, ObjGet( "spr_elevator_card_1" ).pos_x, ObjGet( "spr_elevator_card_1" ).pos_y - 5,
    0.4, 0, ObjGet( "spr_elevator_card_1" ).pos_x, ObjGet( "spr_elevator_card_1" ).pos_y,
  } ); 

end;
--*********************************************************************************************************************
function private.UseRoller ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( "bbt_utilityroom_use_roller" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk10", 0, "", 0 );

  local p_x = ObjGet( "obj_utilityroom_lever" ).pos_x;
  ObjAnimate( "obj_utilityroom_lever", "pos_x", 0, 0, func_end,
  { 
    0.0, 2, p_x,
    0.2, 2, p_x + 10,   
    0.4, 2, p_x
  } );

  ObjAnimate( "spr_utilityroom_close_door1", "pos_y", 0, 0, "",
  { 
    0.0, 0, ObjGet( "spr_utilityroom_close_door1" ).pos_y,
    0.2, 0, ObjGet( "spr_utilityroom_close_door1" ).pos_y - 5,   
    0.4, 0, ObjGet( "spr_utilityroom_close_door1" ).pos_y
  } );

  ObjAnimate( "spr_utilityroom_close_door2", "pos_y", 0, 0, "",
  { 
    0.0, 0, ObjGet( "spr_utilityroom_close_door2" ).pos_y,
    0.2, 0, ObjGet( "spr_utilityroom_close_door2" ).pos_y + 5,   
    0.4, 0, ObjGet( "spr_utilityroom_close_door2" ).pos_y
  } );

end;
--*********************************************************************************************************************


