-- name=rm_courtyard_2
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_courtyard_2";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  
  ObjMultiSet({ 
    { "obj_courtyard_2_clk_arrow",                  { event_mdown = private.ClkNeonBar } },
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_courtyard_2 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gmg_courtyard_2_",
    "gzz_courtyard_2_"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_courtyard_2", update_game_mode_courtyard_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_courtyard_2 = function ()

  local effects_table = 
  {
    "obj_courtyard_2_anim",

    "anm_courtyard_2_white_noise",
    "anm_courtyard_2_newspaper", 
    "anm_courtyard_2_sky",
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_courtyard_2", update_performance_mode_courtyard_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_courtyard_2 () end;
  --------------------------------------------------------------------------------------------
  local opn_courtyard_2_map = function ()

    common_impl.VisitMapRoom( "courtyard" );

  end;
  cmn.AddSubscriber( "opn_courtyard_2", opn_courtyard_2_map );
  
  --------------------------------------------------------------------------------------------
  -- function use_stepladder () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_stepladder" ] = {
    type = "use",
    inv_obj = "inv_stepladder",
    use_place = "obj_courtyard_2_use_stepladder",
    room = private.room_objname,
  };
  local use_stepladder_inv = function ()
  
    interface.InventoryItemRemove( "inv_stepladder" );
  
  end;
  local use_stepladder_beg = function ()
  
    ObjDelete( "obj_courtyard_2_use_stepladder" );
  
  end;
  local use_stepladder_end = function ()
  
    ObjSet( "spr_courtyard_2_staircase", { alp = 1 } );
    ObjSet( "spr_courtyard_2_staircase_1", { alp = 1 } );
    ObjDelete( "anm_courtyard_2_staircase" );
    ObjSet( "grm_courtyard_2_childrensroom", { input = true, active = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_courtyard_2_childrensroom_focus");
    end;    
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_stepladder", use_stepladder_beg, private.room_objname );
  cmn.AddSubscriber( "use_stepladder", use_stepladder_inv );
  cmn.AddSubscriber( "use_stepladder", use_stepladder_end, private.room_objname );
  cmn.AddSubscriber( "use_stepladder_inv", use_stepladder_inv, private.room_objname );
  cmn.AddSubscriber( "use_stepladder_beg", use_stepladder_beg, private.room_objname );
  cmn.AddSubscriber( "use_stepladder_end", use_stepladder_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_courtyard_3 () end;
  --------------------------------------------------------------------------------------------
  local see_courtyard_3 = function ()
    
    --

  end;

  cmn.AddSubscriber( "see_courtyard_3", see_courtyard_3, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_courtyard_2();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

  if ( cmn.IsEventDone( "get_stepladder" ) ) and ( not cmn.IsEventDone( "see_courtyard_3" ) ) then

    private.see_courtyard_3();

  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_stepladder ()

  local item = "inv_stepladder";

  if ( cmn.ApplyObj( item, "obj_courtyard_2_use_stepladder" ) ) then

    cmn.CallEventHandler( "use_stepladder_inv" );
    cmn.CallEventHandler( "use_stepladder_beg" );

    local func_anim = function ()

      local func_end = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_stepladder" );
        cmn.CallEventHandler( "use_stepladder_end" );

      end;

      ObjSet( "anm_courtyard_2_staircase", { alp = 1 } )
      AnimPlay( "anm_courtyard_2_staircase", "DoAnim", func_end )

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_ladder", 0, "", 0 );

    cmn.ItemFly( "spr_courtyard_2_staircase", func_anim );
    
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_courtyard_2 ()

  if not ( cmn.IsEventDone( "opn_courtyard_2" ) ) then

    cmn.SetEventDone( "opn_courtyard_2" );

  end; 
    
  cmn.CallEventHandler( "opn_courtyard_2" );

end;
--------------------------------------------------------------------------------------------
function private.see_courtyard_3 ()

  local func_end = function ()

    common_impl.ShowBbt( "bbt_courtyard_2_see_courtyard_3" );

    cmn.SetEventDone( "see_courtyard_3" );
    cmn.CallEventHandler( "see_courtyard_3" );

    cmn.PlayMusDanger();

  end;

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_scary_sniper", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_courtyard_2_courtyard_3", func_end );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.ClkNeonBar ()
  
  local func_end = function ()

    cmn.Lock( false );

    ObjSet( "spr_courtyard_2_arrow1", { alp = 0 } );
    ObjSet( "spr_courtyard_2_arrow2", { alp = 0 } );
    ObjSet( "spr_courtyard_2_arrow3", { alp = 1 } );
    ObjSet( "spr_courtyard_2_coctail", { alp = 1 } );

  end;

  cmn.Lock( true );
  ObjSet( "spr_courtyard_2_arrow1", { alp = 0 } );
  ObjSet( "spr_courtyard_2_arrow2", { alp = 0 } );
  ObjSet( "spr_courtyard_2_arrow3", { alp = 0 } );
  ObjSet( "spr_courtyard_2_coctail", { alp = 0 } );

  ObjAnimate( "spr_courtyard_2_arrow1", "alp", 0, 0, "",
  { 
    0.0, 0, 0, 
    0.1, 0, 1,
    0.5, 0, 1,
    0.6, 0, 0
  } );
  ObjAnimate( "spr_courtyard_2_arrow2", "alp", 0, 0, "",
  { 
    0.0, 0, 0, 
    0.5, 0, 0,
    0.6, 0, 1,
    0.9, 0, 1,
    1.0, 0, 0
  } );
  ObjAnimate( "spr_courtyard_2_arrow3", "alp", 0, 0, "",
  { 
    0.0, 0, 0, 
    0.8, 0, 0,
    0.9, 0, 1
  } );
  ObjAnimate( "spr_courtyard_2_coctail", "alp", 0, 0, "",
  { 
    0.0, 0, 0, 
    0.7, 0, 0,
    0.7, 0, 1,
    0.9, 0, 1,
    0.9, 0, 0,
    1.1, 0, 0,
    1.1, 0, 1
  } );
  ObjAnimate( "rm_courtyard_2", "alp", 0, 0, func_end,
  { 
    0.0, 0, 1, 
    1.1, 0, 1
  } );

end;