-- name=rm_hall_2
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_hall_2";
  --------------------------------------------------------------------------------------------

  private.InitAnimations();
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_hall = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "grm_hall_porch",
    "grm_hall_courtyard",
    "gzz_hall_bodyguardthings",
    "gzz_hall_reception",
    "gzz_hall_windowsill",
    "gzz_hall_lampwall",
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_hall", update_game_mode_hall, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_hall = function ()

  local effects_table = 
  {
    "anm_hall_2_states_zz_lampwall_light" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_hall", update_performance_mode_hall, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_hall_2 () end;
  --------------------------------------------------------------------------------------------
  local opn_hall_2_map = function ()

    common_impl.VisitMapRoom( "hall" );

  end;
  cmn.AddSubscriber( "opn_hall_2", opn_hall_2_map );

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_hall_2();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();

  common_impl.EnvPlay( { "level1/env/aud_hall_env" }, "", 0.5 );
  --cmn.PlayMusEnv();

end;
--*********************************************************************************************************************
function public.Close ()

  cmn.NoteScaleClose( { "spr_hall_2_placat" } ); 

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_hall_2()

  if not ( cmn.IsEventDone( "opn_hall_2" ) ) then

    cmn.SetEventDone( "opn_hall_2" );

  end;

  cmn.CallEventHandler( "opn_hall_2" ); 

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** ANIMATIONS *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_hall_light_1", "alp",1,0, "", { 0, 3, 0.1,    0.5, 3, 1,    1.3, 3, 0.4,    2.0, 3, 1,    3.2, 3, 0.1 } );
  ObjAnimate( "spr_hall_light_2", "alp",1,0, "", { 0, 3, 1,    0.4, 3, 0.3,    1.2, 3, 1,    1.5, 3, 0.4,    2.8, 3, 1 } );
  ObjAnimate( "spr_hall_light_3", "alp",1,0, "", { 0, 3, 0.2,    0.7, 3, 0.3,    1.9, 3, 0.1,    2.4, 3, 0.3,    3.6, 3, 0.2 } );
  ObjAnimate( "spr_hall_light_4", "alp",1,0, "", { 0, 3, 0.7,    0.9, 3, 0.1,    2.2, 3, 0.4,    4.0, 3, 1,    5.1, 3, 0.7 } );

  ObjAnimate( "spr_hall_reception_light", "alp", 1, 0, "",
    { 
      0.0, 0, 1, 
      1.6, 0, 0.4,
      1.7, 0, 0,
      1.8, 0, 1,
    } );   

end;
--*********************************************************************************************************************









