-- name=rm_lab
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_lab";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_masterswitch", "room_hub" );
  ObjAttach( "zz_accesspanel", "room_hub" );
  ObjAttach( "zz_distillatingstill", "room_hub" );
  ObjAttach( "zz_labdesk", "room_hub" );
  private.Init_Subroom();
  private.InitAnimations();
  private.GasmaskInit();
  private.PasswordInit();
  private.LabdeskInit();

  ObjMultiSet({ 
    { "spr_masterswitch_fridgehandle3",           { event_mdown = private.get_fridgehandle3              } },
    { "spr_accesspanel_patientsprofile",          { event_mdown = private.get_patientsprofile            } },
    { "spr_accesspanel_hexkey",                   { event_mdown = private.get_hexkey                     } },
    { "spr_distillatingstill_coin2",              { event_mdown = private.get_coin2                      } },
    { "spr_distillatingstill_fingerprint",        { event_mdown = private.get_fingerprint                } },
    { "spr_labdesk_fridgehandle4",                { event_mdown = private.get_fridgehandle4              } },
    { "spr_labdesk_filehandle",                   { event_mdown = private.get_filehandle                 } },
    { "spr_labdesk_labassistantskey",             { event_mdown = private.get_labassistantskey           } },
    { "obj_lab_clk_emergency_alarm",              { event_mdown = private.clk_emergency_alarm            } },
    { "obj_distillatingstill_clk_distillatingstill_button_1", 
                                                  { event_mdown = private.clk_distillatingstill_button_1 } },
    { "obj_distillatingstill_clk_distillatingstill_button_2", 
                                                  { event_mdown = private.clk_distillatingstill_button_2 } },

    { "obj_accesspanel_clk_flap_wire",            { event_mdown = private.clk_flap_wire                  } },
    { "obj_accesspanel_clk_labassistantskey",     { event_mdown = private.clk_labassistantskey           } },
    { "obj_masterswitch_clk_masterswitch",        { event_mdown = private.clk_masterswitch               } },

    { "obj_lab_clk_closed_door",                  { event_mdown = private.ClkLabClosedDoor               } },
    { "spr_accesspanel_cover_1",                  { event_mdown = private.ClkAccesspanelCover            } },
    { "obj_labdesk_use_accesspassword",           { event_mdown = private.AnimGameDoor                   } },
    { "obj_distillatingstill_use_hexkey_1",       { event_mdown = private.AnimCoverPrint                 } },

    { "spr_collect2_item_2_2",                    { event_mdown = private.get_collect2_item_2_2          } },

    { "spr_lab_collect_item",                     { event_mdown = function () common_impl.GetCollectItem( "get_collect_item_2_3" );     end } },
    { "spr_lab_collect_morph_item",               { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_2_5" ); end } },

  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_lab = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "gho_lab_experimentroom",
      "gmg_lab_distillatingstill",
      "gzz_lab_masterswitch",
      "gzz_lab_accesspanel",
      "gzz_lab_distillatingstill",
      "gzz_lab_labdesk",
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_masterswitch",
      "zz_accesspanel",
      "zz_distillatingstill",
      "zz_labdesk",
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_lab", update_game_mode_lab, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_lab = function ()

  local effects_table = 
  {
    "obj_lab_anim",
    "anm_masterswitch_light", 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_lab", update_performance_mode_lab, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_lab () end;
  --------------------------------------------------------------------------------------------
  local opn_lab_map = function ()

    common_impl.VisitMapRoom( "lab" );

  end;
  cmn.AddSubscriber( "opn_lab", opn_lab_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_fridgehandle3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fridgehandle3" ] = {
    type = "get",
    get_obj = "spr_masterswitch_fridgehandle3",
    room = private.room_objname,
    zz = "zz_masterswitch",
    zz_gate = "gzz_lab_masterswitch"
  };
  
  local get_fridgehandle3_inv = function ()
  
    interface.InventoryItemAdd( "inv_fridgehandle3", "spr_masterswitch_fridgehandle3" );
  
  end;
  
  local get_fridgehandle3_closezz = function ()
  
    ObjDelete( "gfx_masterswitch_fridgehandle3" );
    ObjDelete( "spr_masterswitch_fridgehandle3_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_fridgehandle3", get_fridgehandle3_inv );
  cmn.AddSubscriber( "get_fridgehandle3", get_fridgehandle3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_patientsprofile () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_patientsprofile" ] = {
    type = "get",
    get_obj = "spr_accesspanel_patientsprofile",
    room = private.room_objname,
    zz = "zz_accesspanel",
    zz_gate = "gzz_lab_accesspanel"
  };
  
  local get_patientsprofile_inv = function ()
  
    interface.InventoryItemAdd( "inv_patientsprofile", "spr_accesspanel_patientsprofile_2" );
    ObjSet( "inv_patientsprofile", { drag = false } );  

  end;
  
  local get_patientsprofile_closezz = function ()
  
    ObjDelete( "gfx_accesspanel_patientsprofile" );
    ObjDelete( "spr_accesspanel_patientsprofile" );
    ObjSet( "spr_accesspanel_patientsprofile_2", { alp = 1 } );

  end;
  
  cmn.AddSubscriber( "get_patientsprofile", get_patientsprofile_inv );
  cmn.AddSubscriber( "get_patientsprofile", get_patientsprofile_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hexkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hexkey" ] = {
    type = "get",
    get_obj = "spr_accesspanel_hexkey",
    room = private.room_objname,
    zz = "zz_accesspanel",
    zz_gate = "gzz_lab_accesspanel"
  };
  
  local get_hexkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_hexkey", "spr_accesspanel_hexkey" );
  
  end;
  
  local get_hexkey_closezz = function ()
  
    ObjDelete( "gfx_accesspanel_hexkey" );
    ObjDelete( "spr_accesspanel_hexkey_shadow" );  

  end;
  
  cmn.AddSubscriber( "get_hexkey", get_hexkey_inv );
  cmn.AddSubscriber( "get_hexkey", get_hexkey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coin2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_coin2" ] = {
    type = "get",
    get_obj = "spr_distillatingstill_coin2",
    room = private.room_objname,
    zz = "zz_distillatingstill",
    zz_gate = "gzz_lab_distillatingstill"
  };
  
  local get_coin2_inv = function ()
  
    interface.InventoryItemAdd( "inv_coin2", "spr_distillatingstill_coin2" );
  
  end;
  
  local get_coin2_closezz = function ()
  
    ObjDelete( "gfx_distillatingstill_coin2" );
  
  end;
  
  cmn.AddSubscriber( "get_coin2", get_coin2_inv );
  cmn.AddSubscriber( "get_coin2", get_coin2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fingerprint () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fingerprint" ] = {
    type = "get",
    get_obj = "spr_distillatingstill_fingerprint",
    room = private.room_objname,
    zz = "zz_distillatingstill",
    zz_gate = "gzz_lab_distillatingstill"
  };
  
  local get_fingerprint_inv = function ()
  
    interface.InventoryItemAdd( "inv_fingerprint", "spr_distillatingstill_fingerprint" );
  
  end;
  
  local get_fingerprint_closezz = function ()
  
    ObjSet( "spr_distillatingstill_fingerprint", { alp = 1 } );
    ObjDelete( "gfx_distillatingstill_fingerprint" );
    ObjDelete( "spr_distillatingstill_cover_print" );

  end;
  
  cmn.AddSubscriber( "get_fingerprint", get_fingerprint_inv );
  cmn.AddSubscriber( "get_fingerprint", get_fingerprint_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fridgehandle4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fridgehandle4" ] = {
    type = "get",
    get_obj = "spr_labdesk_fridgehandle4",
    room = private.room_objname,
    zz = "zz_labdesk",
    zz_gate = "gzz_lab_labdesk"
  };
  
  local get_fridgehandle4_inv = function ()
  
    ObjSet( "spr_labdesk_fridgehandle4", { alp = 1 } );
    interface.InventoryItemAdd( "inv_fridgehandle4", "spr_labdesk_fridgehandle4" );
  
  end;
  
  local get_fridgehandle4_closezz = function ()
  
    ObjDelete( "spr_labdesk_refrigerator_handle_4_shadow" );
    ObjDelete( "gfx_labdesk_fridgehandle4" );
    ObjDelete( "gzz_lab_labdesk" );
  
  end;
  
  cmn.AddSubscriber( "get_fridgehandle4", get_fridgehandle4_inv );
  cmn.AddSubscriber( "get_fridgehandle4", get_fridgehandle4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_filehandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_filehandle" ] = {
    type = "get",
    get_obj = "spr_labdesk_filehandle",
    room = private.room_objname,
    zz = "zz_labdesk",
    zz_gate = "gzz_lab_labdesk"
  };
  
  local get_filehandle_inv = function ()
  
    ObjSet( "spr_labdesk_filehandle", { alp = 1 } );
    interface.InventoryItemAdd( "inv_filehandle", "spr_labdesk_filehandle" );
  
  end;
  
  local get_filehandle_closezz = function ()
  
    ObjDelete( "spr_labdesk_breaker_handle_shadow" );
    ObjDelete( "gfx_labdesk_filehandle" );
  
  end;
  
  cmn.AddSubscriber( "get_filehandle", get_filehandle_inv );
  cmn.AddSubscriber( "get_filehandle", get_filehandle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_labassistantskey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_labassistantskey" ] = {
    type = "get",
    get_obj = "spr_labdesk_labassistantskey",
    room = private.room_objname,
    zz = "zz_labdesk",
    zz_gate = "gzz_lab_labdesk"
  };
  
  local get_labassistantskey_inv = function ()
  
    ObjSet( "spr_labdesk_labassistantskey", { alp = 1 } );
    interface.InventoryItemAdd( "inv_labassistantskey", "spr_labdesk_labassistantskey" );
  
  end;
  
  local get_labassistantskey_closezz = function ()
  
    ObjDelete( "spr_labdesk_labkey_shadow" )
    ObjDelete( "gfx_labdesk_labassistantskey" );

  end;
  
  cmn.AddSubscriber( "get_labassistantskey", get_labassistantskey_inv );
  cmn.AddSubscriber( "get_labassistantskey", get_labassistantskey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_2_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_2_3 = function ()
  
    ObjDelete( "obj_lab_collect" );
  
  end;    
  cmn.AddSubscriber( "get_collect_item_2_3", get_collect_item_2_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_2_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_2_2 = function ()
  
    ObjDelete( "obj_collect2_item_2_2" );

    if ( cmn.IsEventDone( "clk_masterswitch" ) ) then

      ObjDelete( "gzz_lab_masterswitch" );

    end;
  
  end;    
  cmn.AddSubscriber( "get_collect2_item_2_2", get_collect2_item_2_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2_5 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2_5 = function ()
  
    ObjDelete( "obj_lab_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_2_5", get_collect_morph_item_2_5, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_masterswitch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_masterswitch" ] = {
    type = "use",
    inv_obj = "inv_masterswitch",
    use_place = "obj_masterswitch_use_masterswitch",
    room = private.room_objname,
    zz = "zz_masterswitch",
    zz_gate = "gzz_lab_masterswitch"
  };
  local use_masterswitch_inv = function ()
  
    interface.InventoryItemRemove( "inv_masterswitch" );
  
  end;
  local use_masterswitch_beg = function ()
  
    ObjDelete( "obj_masterswitch_use_masterswitch" );
  
  end;
  local use_masterswitch_end = function ()
  
    ObjMultiSet({ 
      { "obj_masterswitch_clk_masterswitch",  { input = true } },
      { "spr_masterswitch_masterswitch_open", { alp = 1      } },
    });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_masterswitch", use_masterswitch_beg, private.room_objname );
  cmn.AddSubscriber( "use_masterswitch", use_masterswitch_inv );
  cmn.AddSubscriber( "use_masterswitch", use_masterswitch_end, private.room_objname );
  cmn.AddSubscriber( "use_masterswitch_inv", use_masterswitch_inv, private.room_objname );
  cmn.AddSubscriber( "use_masterswitch_beg", use_masterswitch_beg, private.room_objname );
  cmn.AddSubscriber( "use_masterswitch_end", use_masterswitch_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_redwire () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_redwire" ] = {
    type = "use",
    inv_obj = "inv_redwire",
    use_place = "obj_accesspanel_use_redwire",
    room = private.room_objname,
    zz = "zz_accesspanel",
    zz_gate = "gzz_lab_accesspanel"
  };
  local use_redwire_inv = function ()
  
    interface.InventoryItemRemove( "inv_redwire" );
  
  end;
  local use_redwire_beg = function ()
  
    ObjDelete( "obj_accesspanel_use_redwire" );
  
  end;
  local use_redwire_end = function ()
  
    ObjSet( "spr_accesspanel_wire_red", { alp = 1 } );
    ObjDelete( "spr_accesspanel_broken_wire_red" );

    if ( cmn.IsEventDone( "use_bluewire" ) ) then

      ObjSet( "spr_accesspanel_scanner_light", { alp = 1 } );

      ObjSet( "spr_accesspanel_hexkey",      { input = true, active = true } );
      ObjDelete( "spr_accesspanel_cover_1" );
      ObjSet( "obj_accesspanel_use_labassistantskey", { input = true } );

      ObjDelete( "spr_lab_accesspanel_cover_1" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_redwire", use_redwire_beg, private.room_objname );
  cmn.AddSubscriber( "use_redwire", use_redwire_inv );
  cmn.AddSubscriber( "use_redwire", use_redwire_end, private.room_objname );
  cmn.AddSubscriber( "use_redwire_inv", use_redwire_inv, private.room_objname );
  cmn.AddSubscriber( "use_redwire_beg", use_redwire_beg, private.room_objname );
  cmn.AddSubscriber( "use_redwire_end", use_redwire_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bluewire () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bluewire" ] = {
    type = "use",
    inv_obj = "inv_bluewire",
    use_place = "obj_accesspanel_use_bluewire",
    room = private.room_objname,
    zz = "zz_accesspanel",
    zz_gate = "gzz_lab_accesspanel"
  };
  local use_bluewire_inv = function ()
  
    interface.InventoryItemRemove( "inv_bluewire" );
  
  end;
  local use_bluewire_beg = function ()
  
    ObjDelete( "obj_accesspanel_use_bluewire" );
  
  end;
  local use_bluewire_end = function ()
  
    ObjSet( "spr_accesspanel_wire_blue", { alp = 1 } );
    ObjDelete( "spr_accesspanel_broken_wire_blue" );

    if ( cmn.IsEventDone( "use_redwire" ) ) then

      ObjSet( "spr_accesspanel_scanner_light", { alp = 1 } );

      ObjSet( "spr_accesspanel_hexkey",      { input = true, active = true } );
      ObjDelete( "spr_accesspanel_cover_1" );
      ObjSet( "obj_accesspanel_use_labassistantskey", { input = true } );

      ObjDelete( "spr_lab_accesspanel_cover_1" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bluewire", use_bluewire_beg, private.room_objname );
  cmn.AddSubscriber( "use_bluewire", use_bluewire_inv );
  cmn.AddSubscriber( "use_bluewire", use_bluewire_end, private.room_objname );
  cmn.AddSubscriber( "use_bluewire_inv", use_bluewire_inv, private.room_objname );
  cmn.AddSubscriber( "use_bluewire_beg", use_bluewire_beg, private.room_objname );
  cmn.AddSubscriber( "use_bluewire_end", use_bluewire_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_labassistantskey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_labassistantskey" ] = {
    type = "use",
    inv_obj = "inv_labassistantskey",
    use_place = "obj_accesspanel_use_labassistantskey",
    room = private.room_objname,
    zz = "zz_accesspanel",
    zz_gate = "gzz_lab_accesspanel"
  };
  local use_labassistantskey_inv = function ()
  
    interface.InventoryItemRemove( "inv_labassistantskey" );
  
  end;
  local use_labassistantskey_beg = function ()
  
    ObjDelete( "obj_accesspanel_use_labassistantskey" );
  
  end;
  local use_labassistantskey_end = function ()

    ObjSet( "obj_accesspanel_clk_labassistantskey", { input = true } );
    ObjSet( "spr_accesspanel_key", { alp = 1 } );  

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_labassistantskey", use_labassistantskey_beg, private.room_objname );
  cmn.AddSubscriber( "use_labassistantskey", use_labassistantskey_inv );
  cmn.AddSubscriber( "use_labassistantskey", use_labassistantskey_end, private.room_objname );
  cmn.AddSubscriber( "use_labassistantskey_inv", use_labassistantskey_inv, private.room_objname );
  cmn.AddSubscriber( "use_labassistantskey_beg", use_labassistantskey_beg, private.room_objname );
  cmn.AddSubscriber( "use_labassistantskey_end", use_labassistantskey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fingerprint () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fingerprint" ] = {
    type = "use",
    inv_obj = "inv_fingerprint",
    use_place = "obj_accesspanel_use_fingerprint",
    room = private.room_objname,
    zz = "zz_accesspanel",
    zz_gate = "gzz_lab_accesspanel"
  };
  local use_fingerprint_inv = function ()
  
    interface.InventoryItemRemove( "inv_fingerprint" );
  
  end;
  local use_fingerprint_beg = function ()
  
    ObjDelete( "obj_accesspanel_use_fingerprint" );
  
  end;
  local use_fingerprint_end = function ()
  
    ObjSet( "grm_lab_archives", { input = true, active = true, visible = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_lab_archives_focus");
    end;    
    ObjDelete( "gzz_lab_accesspanel" );  

    ObjSet( "spr_accesspanel_imprint", { alp = 1 } );
    ObjSet( "spr_accesspanel_scanner_light_green", { alp = 1 } );
    ObjSet( "spr_accesspanel_door_open", { alp = 1 } );

    ObjDelete( "spr_accesspanel_scanner_light_red" );

    ObjDelete( "spr_lab_accesspanel_light_red" );
    ObjDelete( "anm_lab_door" );
    ObjDelete( "obj_lab_clk_closed_door" );
    ObjSet( "spr_lab_accesspanel_light_green", { alp = 1 } )

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fingerprint", use_fingerprint_beg, private.room_objname );
  cmn.AddSubscriber( "use_fingerprint", use_fingerprint_inv );
  cmn.AddSubscriber( "use_fingerprint", use_fingerprint_end, private.room_objname );
  cmn.AddSubscriber( "use_fingerprint_inv", use_fingerprint_inv, private.room_objname );
  cmn.AddSubscriber( "use_fingerprint_beg", use_fingerprint_beg, private.room_objname );
  cmn.AddSubscriber( "use_fingerprint_end", use_fingerprint_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_scotchtapepiece () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_scotchtapepiece" ] = {
    type = "use",
    inv_obj = "inv_scotchtapepiece",
    use_place = "obj_distillatingstill_use_scotchtapepiece",
    room = private.room_objname,
    zz = "zz_distillatingstill",
    zz_gate = "gzz_lab_distillatingstill"
  };
  local use_scotchtapepiece_inv = function ()
  
    interface.InventoryItemRemove( "inv_scotchtapepiece" );
  
  end;
  local use_scotchtapepiece_beg = function ()
  
    ObjDelete( "obj_distillatingstill_use_scotchtapepiece" );
  
  end;
  local use_scotchtapepiece_end = function ()

    ObjDelete( "anm_distillatingstill_handprint_copy" );
    ObjSet( "spr_distillatingstill_cover", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_scotchtapepiece", use_scotchtapepiece_beg, private.room_objname );
  cmn.AddSubscriber( "use_scotchtapepiece", use_scotchtapepiece_inv );
  cmn.AddSubscriber( "use_scotchtapepiece", use_scotchtapepiece_end, private.room_objname );
  cmn.AddSubscriber( "use_scotchtapepiece_inv", use_scotchtapepiece_inv, private.room_objname );
  cmn.AddSubscriber( "use_scotchtapepiece_beg", use_scotchtapepiece_beg, private.room_objname );
  cmn.AddSubscriber( "use_scotchtapepiece_end", use_scotchtapepiece_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hexkey_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hexkey_1" ] = {
    type = "use",
    inv_obj = "inv_hexkey",
    use_place = "obj_distillatingstill_use_hexkey_1",
    room = private.room_objname,
    zz = "zz_distillatingstill",
    zz_gate = "gzz_lab_distillatingstill"
  };
  local use_hexkey_1_inv = function ()
  
    if cmn.IsEventDone( "use_hexkey_2" ) then 
      interface.InventoryItemRemove( "inv_hexkey" );
    end; 
  
  end;
  local use_hexkey_1_beg = function ()
  
    ObjDelete( "obj_distillatingstill_use_hexkey_1" );
  
  end;
  local use_hexkey_1_end = function ()

    ObjMultiSet({ 
      { "spr_distillatingstill_coin2",               { input = true  }},
      { "gfx_distillatingstill_coin2",               { active = true }},

      { "obj_distillatingstill_use_scotchtapepiece", { input = true }},
      { "obj_distillatingstill_use_button1",         { input = true }},
      { "obj_distillatingstill_use_button2",         { input = true }},

      { "spr_distillatingstill_cover",               { alp = 0, pos_x = -149, pos_y = 284 }},
      { "spr_lab_distillatingstill_cover",           {          pos_x =  166, pos_y = 668 }},
      { "anm_distillatingstill_handprint_copy",      { alp = 1                            }},
    });

    ObjDelete( "vid_distillatingstill_hexkey" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hexkey_1", use_hexkey_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_hexkey_1", use_hexkey_1_inv );
  cmn.AddSubscriber( "use_hexkey_1", use_hexkey_1_end, private.room_objname );
  cmn.AddSubscriber( "use_hexkey_1_inv", use_hexkey_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_hexkey_1_beg", use_hexkey_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_hexkey_1_end", use_hexkey_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_button1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_button1" ] = {
    type = "use",
    inv_obj = "inv_button1",
    use_place = "obj_distillatingstill_use_button1",
    room = private.room_objname,
    zz = "zz_distillatingstill",
    zz_gate = "gzz_lab_distillatingstill"
  };
  local use_button1_inv = function ()
  
    interface.InventoryItemRemove( "inv_button1" );
  
  end;
  local use_button1_beg = function ()
  
    ObjDelete( "obj_distillatingstill_use_button1" );
  
  end;
  local use_button1_end = function ()

    ObjSet( "spr_distillatingstill_game_cover_button_1", { alp = 1 } );
    ObjSet( "obj_distillatingstill_clk_distillatingstill_button_1", { input = true } );

    ObjSet( "spr_lab_distillatingstill_button_1", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_button1", use_button1_beg, private.room_objname );
  cmn.AddSubscriber( "use_button1", use_button1_inv );
  cmn.AddSubscriber( "use_button1", use_button1_end, private.room_objname );
  cmn.AddSubscriber( "use_button1_inv", use_button1_inv, private.room_objname );
  cmn.AddSubscriber( "use_button1_beg", use_button1_beg, private.room_objname );
  cmn.AddSubscriber( "use_button1_end", use_button1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_button2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_button2" ] = {
    type = "use",
    inv_obj = "inv_button2",
    use_place = "obj_distillatingstill_use_button2",
    room = private.room_objname,
    zz = "zz_distillatingstill",
    zz_gate = "gzz_lab_distillatingstill"
  };
  local use_button2_inv = function ()
  
    interface.InventoryItemRemove( "inv_button2" );
  
  end;
  local use_button2_beg = function ()
  
    ObjDelete( "obj_distillatingstill_use_button2" );
  
  end;
  local use_button2_end = function ()
  
    ObjSet( "spr_distillatingstill_game_cover_button_2", { alp = 1 } );
    ObjSet( "obj_distillatingstill_clk_distillatingstill_button_2", { input = true } );

    ObjSet( "spr_lab_distillatingstill_button_2", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_button2", use_button2_beg, private.room_objname );
  cmn.AddSubscriber( "use_button2", use_button2_inv );
  cmn.AddSubscriber( "use_button2", use_button2_end, private.room_objname );
  cmn.AddSubscriber( "use_button2_inv", use_button2_inv, private.room_objname );
  cmn.AddSubscriber( "use_button2_beg", use_button2_beg, private.room_objname );
  cmn.AddSubscriber( "use_button2_end", use_button2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_dnainfinityamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_dnainfinityamulet2" ] = {
    type = "use",
    inv_obj = "inv_dnainfinityamulet2",
    use_place = "obj_labdesk_use_dnainfinityamulet2",
    room = private.room_objname,
    zz = "zz_labdesk",
    zz_gate = "gzz_lab_labdesk"
  };
  local use_dnainfinityamulet2_inv = function ()
  
    interface.InventoryItemRemove( "inv_dnainfinityamulet2" );
  
  end;
  local use_dnainfinityamulet2_beg = function ()
  
    ObjDelete( "obj_labdesk_use_dnainfinityamulet2" );
  
  end;
  local use_dnainfinityamulet2_end = function ()
  
    ObjSet( "spr_labdesk_fridgehandle4", { input = true, active = true } );
    ObjSet( "gfx_labdesk_fridgehandle4", { active = true } ); 
    ObjSet( "spr_labdesk_box_lft", { pos_y = 232 } );

    ObjSet( "spr_lab_labdesk_lft_box", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_dnainfinityamulet2", use_dnainfinityamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_dnainfinityamulet2", use_dnainfinityamulet2_inv );
  cmn.AddSubscriber( "use_dnainfinityamulet2", use_dnainfinityamulet2_end, private.room_objname );
  cmn.AddSubscriber( "use_dnainfinityamulet2_inv", use_dnainfinityamulet2_inv, private.room_objname );
  cmn.AddSubscriber( "use_dnainfinityamulet2_beg", use_dnainfinityamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_dnainfinityamulet2_end", use_dnainfinityamulet2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_dnainfinityamulet1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_dnainfinityamulet1" ] = {
    type = "use",
    inv_obj = "inv_dnainfinityamulet1",
    use_place = "obj_labdesk_use_dnainfinityamulet1",
    room = private.room_objname,
    zz = "zz_labdesk",
    zz_gate = "gzz_lab_labdesk"
  };
  local use_dnainfinityamulet1_inv = function ()
  
    interface.InventoryItemRemove( "inv_dnainfinityamulet1" );
  
  end;
  local use_dnainfinityamulet1_beg = function ()
  
    ObjDelete( "obj_labdesk_use_dnainfinityamulet1" );
  
  end;
  local use_dnainfinityamulet1_end = function ()
  
    ObjSet( "spr_labdesk_filehandle", { input = true, active = true } );
    ObjSet( "gfx_labdesk_filehandle", { active = true } );
    ObjSet( "spr_labdesk_box_rgt", { pos_y = 232 } );

    ObjSet( "spr_lab_labdesk_rgt_box", { alp = 1 } );

  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_dnainfinityamulet1", use_dnainfinityamulet1_beg, private.room_objname );
  cmn.AddSubscriber( "use_dnainfinityamulet1", use_dnainfinityamulet1_inv );
  cmn.AddSubscriber( "use_dnainfinityamulet1", use_dnainfinityamulet1_end, private.room_objname );
  cmn.AddSubscriber( "use_dnainfinityamulet1_inv", use_dnainfinityamulet1_inv, private.room_objname );
  cmn.AddSubscriber( "use_dnainfinityamulet1_beg", use_dnainfinityamulet1_beg, private.room_objname );
  cmn.AddSubscriber( "use_dnainfinityamulet1_end", use_dnainfinityamulet1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_accesspassword () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_accesspassword" ] = {
    type = "use",
    inv_obj = "inv_accesspassword",
    use_place = "obj_labdesk_use_accesspassword",
    room = private.room_objname,
    zz = "zz_labdesk",
    zz_gate = "gzz_lab_labdesk"
  };
  local use_accesspassword_inv = function ()
  
    interface.InventoryItemRemove( "inv_accesspassword" );
  
  end;
  local use_accesspassword_beg = function ()
  
    ObjDelete( "obj_labdesk_use_accesspassword" );
  
  end;
  local use_accesspassword_end = function ()
  
    ObjSet( "spr_labdesk_accesspassword", { alp = 1 } );
    ObjSet( "obj_labdesk_password", { input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_accesspassword", use_accesspassword_beg, private.room_objname );
  cmn.AddSubscriber( "use_accesspassword", use_accesspassword_inv );
  cmn.AddSubscriber( "use_accesspassword", use_accesspassword_end, private.room_objname );
  cmn.AddSubscriber( "use_accesspassword_inv", use_accesspassword_inv, private.room_objname );
  cmn.AddSubscriber( "use_accesspassword_beg", use_accesspassword_beg, private.room_objname );
  cmn.AddSubscriber( "use_accesspassword_end", use_accesspassword_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gasmask () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gasmask" ] = {
    type = "use",
    inv_obj = "inv_gasmask",
    use_place = "obj_lab_use_gasmask",
    room = private.room_objname
  };
  local use_gasmask_inv = function ()
  
    interface.InventoryItemRemove( "inv_gasmask" );
  
  end;
  local use_gasmask_beg = function ()
  
    ObjDelete( "obj_lab_use_gasmask" );
  
  end;
  local use_gasmask_end = function ()
  
    ObjSet( "obj_lab_mmg_gasmask", { input = true } );

    ObjSet( "anm_lab_light_gasmask", { alp = 1, playing = true } );
    ObjSet( "anm_lab_steam", { playing = true, alp = 1 } );
    ObjSet( "anm_lab_use_gasmask", { alp = 1, frame = 500 } );

    ObjSet( "spr_lab_gasmask_back", { alp = 1 } );
    ObjDelete( "anm_lab_red_light" );

    ObjSet( "obj_lab_scene", { pos_x = -219, pos_y = -16, scale_x = 1.2, scale_y = 1.2 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gasmask", use_gasmask_beg, private.room_objname );
  cmn.AddSubscriber( "use_gasmask", use_gasmask_inv );
  cmn.AddSubscriber( "use_gasmask", use_gasmask_end, private.room_objname );
  cmn.AddSubscriber( "use_gasmask_inv", use_gasmask_inv, private.room_objname );
  cmn.AddSubscriber( "use_gasmask_beg", use_gasmask_beg, private.room_objname );
  cmn.AddSubscriber( "use_gasmask_end", use_gasmask_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_emergency_alarm () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_emergency_alarm" ] = {
    type = "click",
    use_place = "obj_lab_clk_emergency_alarm",
    room = private.room_objname,
  --  zz = "zz_surveillancecamera",
  --  zz_gate = "gzz_archives_surveillancecamera"
  };
  local clk_emergency_alarm_beg = function ()
  
    ObjDelete( "obj_lab_clk_emergency_alarm" );

  end;
  local clk_emergency_alarm = function ()
  
    ObjDelete( "obj_lab_clk_emergency_alarm" );

    ObjMultiSet({ 
      { "anm_lab_red_light",   { playing = true, alp = 1     } },
      { "obj_lab_use_gasmask", { input = true, active = true } },
      { "vid_lab_gas_2", { playing = true, alp = 1 } }
    });

    ObjDelete( "vid_lab_gas_1" );

  end;
  
  cmn.AddSubscriber( "clk_emergency_alarm_beg", clk_emergency_alarm_beg, private.room_objname );
  cmn.AddSubscriber( "clk_emergency_alarm",     clk_emergency_alarm,     private.room_objname );
  cmn.AddSubscriber( "clk_emergency_alarm",     clk_emergency_alarm_beg, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_flap_wire () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_flap_wire" ] = {
    type = "click",
    use_place = "obj_accesspanel_clk_flap_wire",
    room = private.room_objname,
    zz = "zz_accesspanel",
    zz_gate = "gzz_lab_accesspanel"
  };

  local clk_flap_wire = function ()
  
    ObjDelete( "obj_accesspanel_clk_flap_wire" );
    ObjDelete( "spr_accesspanel_cover" );
    ObjSet( "obj_accesspanel_use_redwire",  { input = 1 } );
    ObjSet( "obj_accesspanel_use_bluewire", { input = 1 } );
    ObjSet( "spr_accesspanel_cover_open",   { alp = 1 } );

    ObjDelete( "spr_lab_accesspanel_cover" );
    ObjSet( "spr_lab_accesspanel_cover_open", { alp = 1 } );

  end;
  
  cmn.AddSubscriber( "clk_flap_wire",     clk_flap_wire,     private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_labassistantskey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_labassistantskey" ] = {
    type = "click",
    use_place = "obj_accesspanel_clk_labassistantskey",
    room = private.room_objname,
    zz = "zz_accesspanel",
    zz_gate = "gzz_lab_accesspanel"
  };

  local clk_labassistantskey = function ()
  
    ObjDelete( "obj_accesspanel_clk_labassistantskey" );
    ObjDelete( "spr_accesspanel_key" );
    ObjSet( "spr_accesspanel_patientsprofile", { input = true, alp = 1 } );
    ObjSet( "spr_accesspanel_key_1",   { alp = 1 } );
    ObjSet( "gfx_accesspanel_patientsprofile", { active = true } );

  end;
  
  cmn.AddSubscriber( "clk_labassistantskey",     clk_labassistantskey,     private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_masterswitch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_masterswitch" ] = {
    type = "click",
    use_place = "obj_masterswitch_clk_masterswitch",
    room = private.room_objname,
    zz = "zz_masterswitch",
    zz_gate = "gzz_lab_masterswitch"
  };

  local clk_masterswitch = function ()
  
    if ( cmn.IsGetCollect2( "get_collect2_item_2_2" ) ) then

      ObjDelete( "gzz_lab_masterswitch" );      

    else

      ObjSet( "gzz_lab_masterswitch", { input = false, visible = false, active = false } );

    end;

    ObjSet( "gho_lab_experimentroom", { input = true, active = true } );

    ObjSet( "spr_lab_masterswitch_1", { alp = 1 } );
    ObjSet( "spr_lab_masterswitch_2", { alp = 1 } );
    ObjDelete( "obj_masterswitch_clk_masterswitch" );

  end;
  
  cmn.AddSubscriber( "clk_masterswitch",     clk_masterswitch,     private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_distillatingstill_button_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_distillatingstill_button_1" ] = {
    type = "click",
    use_place = "obj_distillatingstill_clk_distillatingstill_button_1",
    room = private.room_objname,
    zz = "zz_distillatingstill",
    zz_gate = "gzz_lab_distillatingstill"
  };

  local clk_distillatingstill_button_1_beg = function ()

    ObjDelete( "obj_reception_clk_reception_paperclip_1" );
    ObjDelete( "spr_distillatingstill_game_cover_button_1" );
    ObjSet( "spr_distillatingstill_game_cover_button_1_on", { alp = 1 } );
  
  end;
  local clk_distillatingstill_button_1_end = function ()

    ObjSet( "spr_distillatingstill_lamp1_light", { alp = 1 } );

    if ( cmn.IsEventDone( "clk_distillatingstill_button_2" ) ) then

      ObjSet( "gmg_lab_distillatingstill", { input = true, active = true, visible = true } );
      ObjDelete( "gzz_lab_distillatingstill" );

      ObjDelete( "spr_lab_distillatingstill_undercover" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_distillatingstill_button_1", clk_distillatingstill_button_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_distillatingstill_button_1", clk_distillatingstill_button_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_distillatingstill_button_1_beg", clk_distillatingstill_button_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_distillatingstill_button_1_end", clk_distillatingstill_button_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_distillatingstill_button_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_distillatingstill_button_2" ] = {
    type = "click",
    use_place = "obj_distillatingstill_clk_distillatingstill_button_2",
    room = private.room_objname,
    zz = "zz_distillatingstill",
    zz_gate = "gzz_lab_distillatingstill"
  };

  local clk_distillatingstill_button_2_beg = function ()

    ObjDelete( "obj_reception_clk_reception_paperclip_2" );
    ObjDelete( "spr_distillatingstill_game_cover_button_2" );
    ObjSet( "spr_distillatingstill_game_cover_button_2_on", { alp = 1 } );
  
  end;
  local clk_distillatingstill_button_2_end = function ()

    ObjSet( "spr_distillatingstill_lamp2_light", { alp = 1 } );

    if ( cmn.IsEventDone( "clk_distillatingstill_button_1" ) ) then

      ObjSet( "gmg_lab_distillatingstill", { input = true, active = true, visible = true } );
      ObjDelete( "gzz_lab_distillatingstill" );  

      ObjDelete( "spr_lab_distillatingstill_undercover" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_distillatingstill_button_2", clk_distillatingstill_button_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_distillatingstill_button_2", clk_distillatingstill_button_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_distillatingstill_button_2_beg", clk_distillatingstill_button_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_distillatingstill_button_2_end", clk_distillatingstill_button_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_gasmask () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_gasmask" ] = {
    type = "click",
    use_place = "obj_lab_mmg_gasmask",
    room = private.room_objname
  };
  local win_gasmask = function ()
  
    for i = 1, 4 do

      ObjDelete( "obj_lab_clk_button_"..i );
      ObjSet( "spr_lab_button_"..i.."_press", { alp = 1 } );

    end;

    ObjDelete( "tmr_lab_anim" );
    ObjDelete( "vid_lab_gas_2" );
    ObjDelete( "vid_lab_gas_3" );

    ObjDelete( "anm_lab_use_gasmask" );
    ObjDelete( "anm_lab_light_gasmask" );
    ObjDelete( "anm_lab_steam" );
    ObjDelete( "tmr_lab_mmg_timer" );

    ObjDelete( "spr_lab_misted_glass" );
    ObjDelete( "spr_lab_gasmask_back" );
    
    ObjSet( "obj_lab_mmg_gasmask", { input = false } );
    ObjSet( "obj_lab_clk_closed_door", { input = true } );

    ObjSet( "obj_lab_scene", { pos_x = 0, pos_y = 0, scale_x = 1, scale_y = 1 } );

    ObjSet( "gzz_lab_masterswitch",      { input = true, active = true, visible = true } );
    ObjSet( "gzz_lab_accesspanel",       { input = true, active = true, visible = true } );
    ObjSet( "gzz_lab_distillatingstill", { input = true, active = true, visible = true } );
    ObjSet( "gzz_lab_labdesk",           { input = true, active = true, visible = true } );

    ObjSet( "obj_lab_objects", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_gasmask", win_gasmask, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_password () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_password" ] = {
    type = "click",
    use_place = "spr_labdesk_code_up_side",
    room = private.room_objname,
    zz = "zz_labdesk",
    zz_gate = "gzz_lab_labdesk"
  };
  local win_password = function ()
  
    if ( cmn.IsEventDone( "win_password" ) ) then

      ObjDelete( "obj_labdesk_password" );

      ObjSet( "obj_labdesk_minigame", { input = true } );
      ObjSet( "spr_lab_labdesk_game_open", { alp = 1 } );

    else

      for i = 1, 4 do

        local diff = ng_global.progress[ "std" ][ "win_password" ].state[ i ] - private.start_state[ i ];
        ObjSet( "obj_labdesk_password_line_"..i, { pos_x = private.start_pos[ i ] - 47 * diff } );

      end;

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_password", win_password, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_labdesk () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_labdesk" ] = {
    type = "click",
    use_place = "spr_labdesk_paper",
    room = private.room_objname,
    zz = "zz_labdesk",
    zz_gate = "gzz_lab_labdesk"
  };
  local win_labdesk = function ()
  
    if ( cmn.IsEventDone( "win_labdesk" ) ) then

      ObjDelete( "spr_labdesk_labkey_over" );
      ObjDelete( "obj_labdesk_minigame_checkers" );
      ObjDelete( "obj_labdesk_minigame_cells" );

      ObjSet( "spr_labdesk_labassistantskey", { input = true, active = true } );

    else

      for i = 1, 10 do

        local id = ng_global.progress[ "std" ][ "win_labdesk" ].state[ i ];
        ObjSet( "spr_labdesk_checker_"..i, { pos_x = private.positions[ id ][ 1 ], pos_y = private.positions[ id ][ 2 ] } );
        private.checkers_state[ i ] = ng_global.progress[ "std" ][ "win_labdesk" ].state[ i ];

      end;

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_labdesk", win_labdesk, private.room_objname );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()

  subroom.Define( "zz_labdesk" );
  function zz_labdesk.Open ()
  end;
  -------------------------------------------------
  function zz_labdesk.PreOpen ()

    if ( cmn.IsEventDone( "win_password" ) ) and ( not cmn.IsEventDone( "win_labdesk" ) ) then

      cmn.MiniGameShow( "labdesk" );
      common_impl.PassingMgStart( "labdesk" );

    end;

  end;
  -------------------------------------------------
  function zz_labdesk.PreClose ()

    if ( cmn.IsEventDone( "win_password" ) ) and ( not cmn.IsEventDone( "win_labdesk" ) ) then

      cmn.MiniGameHide( "labdesk" );
      common_impl.PassingMgStop( "labdesk" );

    end;
  
  end;
  -------------------------------------------------
  function zz_labdesk.Close ()
  end;
  --------------------------------------------------------------------------------------------  
  function zz_labdesk.Reset ()

    for i = 1, 10 do

      ng_global.progress[ "std" ][ "win_labdesk" ].state[ i ] = private.checkers_start_state[ i ];
      private.checkers_state[ i ] = private.checkers_start_state[ i ];

      local id = private.checkers_state[ i ];
      ObjSet( "spr_labdesk_checker_"..i, { pos_x = private.positions[ id ][ 1 ], pos_y = private.positions[ id ][ 2 ] } );

    end;

  end;
  --------------------------------------------------------------------------------------------  
  function zz_labdesk.Skip ()

     private.LabdeskWin();

  end;

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_lab();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

  if ( cmn.IsEventDone( "use_gasmask" ) and ( not  cmn.IsEventDone( "win_gasmask" ) ) ) then

    private.GaskmaskCheckTimer( true );
    private.BackAnim()

  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "level2/env/aud_lab_env" }, "", 0.5 );

  if cmn.IsEventDone( "clk_emergency_alarm" ) and not cmn.IsEventDone( "win_gasmask" ) then

    common_impl.PlayAudio( "env", "level2/env/aud_alarm_beep_env", 1, "", 0 );

  end;

  if cmn.IsEventDone( "use_gasmask" ) and not cmn.IsEventDone( "win_gasmask" ) then

    common_impl.PlayAudio( "env", "level2/env/aud_mask_env", 1, "", 0 );

  end;

  common_impl.CollectItemMorphing();
  common_impl.MorphItemMorphing();

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_masterswitch ()

  local item = "inv_masterswitch";

  if cmn.ApplyObj( item, "gzz_lab_masterswitch" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_masterswitch", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_masterswitch_use_masterswitch" ) ) then

    cmn.CallEventHandler( "use_masterswitch_inv" );
    cmn.CallEventHandler( "use_masterswitch_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_masterswitch" );
      cmn.CallEventHandler( "use_masterswitch_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk9", 0, "", 0 );

    cmn.ItemFly( "spr_masterswitch_masterswitch_open", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_redwire ()

  local item = "inv_redwire";

  if cmn.ApplyObj( item, "gzz_lab_accesspanel" ) and ( cmn.IsEventDone( "clk_flap_wire" ) ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_accesspanel", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_accesspanel_use_redwire" ) ) and ( cmn.IsEventDone( "clk_flap_wire" ) ) then

    cmn.CallEventHandler( "use_redwire_inv" );
    cmn.CallEventHandler( "use_redwire_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_redwire" );
      cmn.CallEventHandler( "use_redwire_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );

    if ( cmn.IsEventDone( "use_bluewire" ) ) then

      common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_slide", 0, "", 0 );

      ObjAnimate( "spr_accesspanel_wire_red", "alp",  0, 0, func_end, 
      { 
        0.0, 3, 0,  
        0.4, 3, 0,
        0.8, 3, 1, 
      } );
      ObjAnimate( "spr_accesspanel_broken_wire_red", "alp",   0, 0, "", 
      { 
        0,3,1,  
        0.4,3,0 
      } );
      ObjAnimate( "spr_accesspanel_broken_wire_red", "pos_xy",   0, 0, "", 
      { 
        0.0, 3, ObjGet( "spr_accesspanel_broken_wire_red" ).pos_x, ObjGet( "spr_accesspanel_broken_wire_red" ).pos_y,  
        0.4, 3,ObjGet( "spr_accesspanel_broken_wire_red" ).pos_x, ObjGet( "spr_accesspanel_broken_wire_red" ).pos_y + 30, 
      } );
      ObjAnimate( "spr_accesspanel_cover_1",  "pos_y", 0, 0, "", 
      { 
        0.0, 3, 118,  
        0.4, 3, 118,  
        0.8, 3, 310 
      } );
      ObjAnimate( "spr_accesspanel_scanner_light", "alp",   0, 0, "", 
      { 
        0.0, 0, 0,  
        0.3, 0, 0, 
        0.8, 0, 1 
      } );

    else

      ObjAnimate( "spr_accesspanel_wire_red", "alp", 0, 0, func_end, 
      { 
        0.0, 3, 0,  
        0.4, 3, 0,
        0.8, 3, 1, 
      } );
      ObjAnimate( "spr_accesspanel_broken_wire_red", "alp", 0, 0, "", 
      { 
        0.0, 3, 1,  
        0.4, 3, 0 
      } );
      ObjAnimate( "spr_accesspanel_broken_wire_red", "pos_xy",   0, 0, "", 
      { 
        0.0, 3, ObjGet( "spr_accesspanel_broken_wire_red" ).pos_x, ObjGet( "spr_accesspanel_broken_wire_red" ).pos_y,  
        0.4, 3,ObjGet( "spr_accesspanel_broken_wire_red" ).pos_x, ObjGet( "spr_accesspanel_broken_wire_red" ).pos_y + 30, 
      } );
    
    end;

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_bluewire ()

  local item = "inv_bluewire";

  if cmn.ApplyObj( item, "gzz_lab_accesspanel" ) and ( cmn.IsEventDone( "clk_flap_wire" ) ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_accesspanel", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_accesspanel_use_bluewire" ) ) and ( cmn.IsEventDone( "clk_flap_wire" ) ) then

    cmn.CallEventHandler( "use_bluewire_inv" );
    cmn.CallEventHandler( "use_bluewire_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_bluewire" );
      cmn.CallEventHandler( "use_bluewire_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );

    if ( cmn.IsEventDone( "use_redwire" ) ) then

      common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_slide", 0, "", 0 );

      ObjAnimate( "spr_accesspanel_wire_blue",  "alp",  0, 0, func_end, 
      { 
        0.0, 3, 0,  
        0.4, 3, 0,
        0.8, 3, 1,  
      } );
      ObjAnimate( "spr_accesspanel_broken_wire_blue", "alp", 0, 0, "", { 0,3,1,  0.4,3,0 } );

      ObjAnimate( "spr_accesspanel_cover_1",          "pos_y", 0, 0, "", 
      { 
        0.0, 3, 118,  
        0.4, 3, 118, 
        0.8, 3, 310
      } );

      ObjAnimate( "spr_accesspanel_broken_wire_blue", "pos_xy",   0, 0, "", 
      { 
        0.0, 3, ObjGet( "spr_accesspanel_broken_wire_blue" ).pos_x, ObjGet( "spr_accesspanel_broken_wire_blue" ).pos_y,  
        0.4, 3,ObjGet( "spr_accesspanel_broken_wire_blue" ).pos_x, ObjGet( "spr_accesspanel_broken_wire_blue" ).pos_y + 30, 
      } );

      ObjAnimate( "spr_accesspanel_scanner_light", "alp",   0, 0, "", 
      { 
        0.0, 0, 0,
        0.3, 0, 0,   
        0.8, 0, 1 
      } );

    else

      ObjAnimate( "spr_accesspanel_wire_blue",  "alp", 0, 0, func_end, 
      { 
        0.0, 3, 0,  
        0.4, 3, 0,
        0.8, 3, 1,  
      } );
      ObjAnimate( "spr_accesspanel_broken_wire_blue", "alp", 0, 0, "", { 0,3,1,  0.4,3,0 } );
      ObjAnimate( "spr_accesspanel_broken_wire_blue", "pos_xy",   0, 0, "", 
      { 
        0.0, 3, ObjGet( "spr_accesspanel_broken_wire_blue" ).pos_x, ObjGet( "spr_accesspanel_broken_wire_blue" ).pos_y,  
        0.4, 3,ObjGet( "spr_accesspanel_broken_wire_blue" ).pos_x, ObjGet( "spr_accesspanel_broken_wire_blue" ).pos_y + 30, 
      } );

    end;

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_labassistantskey ()

  local item = "inv_labassistantskey";

  if cmn.ApplyObj( item, "gzz_lab_accesspanel" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_accesspanel", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_accesspanel_use_labassistantskey" ) ) then

    cmn.CallEventHandler( "use_labassistantskey_inv" );
    cmn.CallEventHandler( "use_labassistantskey_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_labassistantskey" );
      cmn.CallEventHandler( "use_labassistantskey_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_key_use", 0, "", 0 );

    ObjAnimate( "spr_accesspanel_key", "alp", 0, 0, func_end, { 0,3,0,  0.4,3,1 } );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_fingerprint ()

  local item = "inv_fingerprint";

  if cmn.ApplyObj( item, "gzz_lab_accesspanel" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_accesspanel", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_accesspanel_use_fingerprint" ) ) then

    cmn.CallEventHandler( "use_fingerprint_inv" );
    cmn.CallEventHandler( "use_fingerprint_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_fingerprint" );
      cmn.CallEventHandler( "use_fingerprint_end" );

      common.CloseSubRoom(); 

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_imprint", 0, "", 0 );

    ObjSet( "spr_accesspanel_scanner_light_red", { visible = false } );

    ObjAnimate( "spr_accesspanel_imprint",             "alp", 0, 0, "", { 0,3,0,  0.4,3,1 } );
    ObjAnimate( "spr_accesspanel_scanner_light_green", "alp", 0, 0, "", { 0,3,0,  0.4,3,0,  0.8,3,1 } );
    ObjAnimate( "spr_accesspanel_door_open",           "alp", 0, 0, func_end, { 0,3,0,  1.0,3,0,  1.4,3,1,  1.8,3,1 } );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_scotchtapepiece ()

  local item = "inv_scotchtapepiece";

  if cmn.ApplyObj( item, "gzz_lab_distillatingstill" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_distillatingstill", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_distillatingstill_use_scotchtapepiece" ) ) then

    cmn.CallEventHandler( "use_scotchtapepiece_inv" );
    cmn.CallEventHandler( "use_scotchtapepiece_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_scotchtapepiece" );
      cmn.CallEventHandler( "use_scotchtapepiece_end" );

      private.get_fingerprint();

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_tape", 0, "", 0 );

    AnimPlay( "anm_distillatingstill_handprint_copy", "DoAnim", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_hexkey_1 ()

  local item = "inv_hexkey";

  if cmn.ApplyObj( item, "gzz_lab_distillatingstill" ) and ( not cmn.IsEventDone( "use_hexkey_1" ) ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_distillatingstill", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_distillatingstill_use_hexkey_1" ) ) and ( not cmn.IsEventDone( "use_hexkey_1" ) ) then

    cmn.CallEventHandler( "use_hexkey_1_inv" );
    cmn.CallEventHandler( "use_hexkey_1_beg" );

    local func_end_2 = function ()

      local func_end = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_hexkey_1" );
        cmn.CallEventHandler( "use_hexkey_1_end" );

      end;

      cmn.Lock( true );

      ObjAnimate( "spr_distillatingstill_cover", "pos_xy", 0, 0, func_end, { 0, 0, 108, -26,   0.5, 3, -149, 284 } );

    end;

    cmn.Lock( true );
    
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_wrench", 0, "", 0 );

    VidPlay( "vid_distillatingstill_hexkey" , func_end_2 );
    

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_button1 ()

  local item = "inv_button1";

  if cmn.ApplyObj( item, "gzz_lab_distillatingstill" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_distillatingstill", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_distillatingstill_use_button1" ) ) then

    cmn.CallEventHandler( "use_button1_inv" );
    cmn.CallEventHandler( "use_button1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_button1" );
      cmn.CallEventHandler( "use_button1_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk6", 0, "", 0 );

    cmn.ItemFly( "spr_distillatingstill_game_cover_button_1", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_button2 ()

  local item = "inv_button2";

  if cmn.ApplyObj( item, "gzz_lab_distillatingstill" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_distillatingstill", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_distillatingstill_use_button2" ) ) then

    cmn.CallEventHandler( "use_button2_inv" );
    cmn.CallEventHandler( "use_button2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_button2" );
      cmn.CallEventHandler( "use_button2_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk6", 0, "", 0 );

    cmn.ItemFly( "spr_distillatingstill_game_cover_button_2", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_dnainfinityamulet1 ()

  local item = "inv_dnainfinityamulet1";

  if cmn.ApplyObj( item, "gzz_lab_labdesk" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_labdesk", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_labdesk_use_dnainfinityamulet1" ) ) then

    cmn.CallEventHandler( "use_dnainfinityamulet1_inv" );
    cmn.CallEventHandler( "use_dnainfinityamulet1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_dnainfinityamulet1" );
      cmn.CallEventHandler( "use_dnainfinityamulet1_end" );

    end;

    local func_continue = function ()

      ObjAnimate( "spr_labdesk_box_rgt", "pos_y", 0, 0, func_end, { 0, 0, 89, 0.4, 3, 232 } );

    end;
  
    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_amulet", 0, "", 0 );

    cmn.ItemFly( "spr_labdesk_box_rgt_amulet", func_continue, 2.4 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_dnainfinityamulet2 ()

  local item = "inv_dnainfinityamulet2";

  if cmn.ApplyObj( item, "gzz_lab_labdesk" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_labdesk", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_labdesk_use_dnainfinityamulet2" ) ) then

    cmn.CallEventHandler( "use_dnainfinityamulet2_inv" );
    cmn.CallEventHandler( "use_dnainfinityamulet2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_dnainfinityamulet2" );
      cmn.CallEventHandler( "use_dnainfinityamulet2_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_amulet", 0, "", 0 );

    local func_continue = function ()

      ObjAnimate( "spr_labdesk_box_lft", "pos_y", 0, 0, func_end, { 0, 0, 89, 0.4, 3, 232 } );

    end;

    cmn.ItemFly( "spr_labdesk_box_lft_amulet", func_continue, -2.4 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_accesspassword ()

  local item = "inv_accesspassword";

  if cmn.ApplyObj( item, "gzz_lab_labdesk" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_labdesk", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_labdesk_use_accesspassword" ) ) then

    cmn.CallEventHandler( "use_accesspassword_inv" );
    cmn.CallEventHandler( "use_accesspassword_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_accesspassword" );
      cmn.CallEventHandler( "use_accesspassword_end" );

      ng_global.progress[ "std" ][ "win_password" ].state = {};
      ng_global.progress[ "std" ][ "win_password" ].start = 1;
      for i = 1, 4 do

        ng_global.progress[ "std" ][ "win_password" ].state[ i ] = private.start_state[ i ];

      end;

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "aud_paper", 0, "", 0 );
    cmn.ItemFly( "spr_labdesk_accesspassword", func_end );
  
  return true;

  end;
  
  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_gasmask ()

  local item = "inv_gasmask";

  if ( cmn.ApplyObj( item, "obj_lab_use_gasmask" ) and ( cmn.IsEventDone( "clk_emergency_alarm" ) )  ) then

    cmn.Lock( true );

    cmn.CallEventHandler( "use_gasmask_inv" );
    cmn.CallEventHandler( "use_gasmask_beg" );

    local func_end = function ()

      private.use_gasmask_end();

    end;

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_mask", 0, "", 0 );
    common_impl.PlayAudio( "env", "level2/env/aud_mask_env", 1, "", 0 );

    ObjSet( "anm_lab_put_on_mask", { alp = 1 } );
    AnimPlay( "anm_lab_put_on_mask", "DoAnim", func_end );

    ObjAnimate( "anm_lab_red_light", "alp", 0, 0, "", 
    { 
      0.0, 0, 0, 
      0.3, 0, 1 
    } );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function private.use_gasmask_end ()

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "use_gasmask" );
    cmn.CallEventHandler( "use_gasmask_end" );

    AnimPlay( "anm_lab_light_gasmask", "DoAnim", "" );
    private.GaskmaskCheckTimer( true );

    private.BackAnim();
    common_impl.ShowBbt( "bbt_lab_use_gasmask_end" );

  end;
  
  ObjSet( "anm_lab_put_on_mask", { alp = 0 } );
  ObjSet( "anm_lab_use_gasmask", { alp = 1 } );

  ObjAnimate( "obj_lab_scene", "scale_xy", 0, 0, func_end, 
  { 
    0.0, 0, 1, 1,   
    0.3, 3, 1.2, 1.2 
  } );
  ObjAnimate( "obj_lab_scene", "pos_xy", 0, 0, "", 
  { 
    0.0, 0, 0, 0,   
    0.3, 3, -219, -16 
  } );
  --ObjAnimate( "anm_lab_use_gasmask",   "alp", 0, 0, func_end, 
  --{ 
  --  0.0, 0, 0, 
  --  0.3, 0, 1 
  --} );
  --ObjAnimate( "anm_lab_light_gasmask", "alp", 0, 0, "", 
  --{ 
  --  0.0, 0, 0, 
  --  0.3, 0, 1 
  --} );

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_fridgehandle3 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_fridgehandle3" );
  cmn.CallEventHandler( "get_fridgehandle3" );

end;
--------------------------------------------------------------------------------------------
function private.get_patientsprofile ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_patientsprofile" );
  cmn.CallEventHandler( "get_patientsprofile" );

end;
--------------------------------------------------------------------------------------------
function private.get_hexkey ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_hexkey" );
  cmn.CallEventHandler( "get_hexkey" );

end;
--------------------------------------------------------------------------------------------
function private.get_coin2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_coin2" );
  cmn.CallEventHandler( "get_coin2" );

end;
--------------------------------------------------------------------------------------------
function private.get_fingerprint ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_fingerprint" );
  cmn.CallEventHandler( "get_fingerprint" );

end;
--------------------------------------------------------------------------------------------
function private.get_fridgehandle4 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_fridgehandle4" );
  cmn.CallEventHandler( "get_fridgehandle4" );

  common.CloseSubRoom(); 

end;
--------------------------------------------------------------------------------------------
function private.get_filehandle ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_filehandle" );
  cmn.CallEventHandler( "get_filehandle" );
    if port.isPortable()==1 then
      iOS_RateMe();
    end;
    
end;
--------------------------------------------------------------------------------------------
function private.get_labassistantskey ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_labassistantskey" );
  cmn.CallEventHandler( "get_labassistantskey" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_2_2 ()
  
  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_2_2" ); 

    if ( cmn.IsEventDone( "clk_masterswitch" ) ) then

      common.CloseSubRoom(); 

    end;

  end;

  common_impl.PlayEffectHO( "spr_collect2_item_2_2", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_2_2" );    

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_emergency_alarm ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( "bbt_lab_clk_emergency_alarm" );

    cmn.SetEventDone( "clk_emergency_alarm" );
    cmn.CallEventHandler( "clk_emergency_alarm" );

  end;

  cmn.Lock( true )

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_alarm_beep", 0, "", 0 );
  common_impl.PlayAudio( "mus", "aud_danger2_mus",           0, "", 0 );
  common_impl.PlayAudio( "env", "level2/env/aud_alarm_beep_env", 1, "", 0 );

  ObjAnimate( "anm_lab_red_light", "alp", 0, 0, "", 
  { 
    0.0, 0, 0, 
    0.3, 0, 1 
  } );

  AnimPlay( "anm_lab_red_light", "DoAnim", "" );

  ObjSet(  "vid_lab_gas_1", { alp = 1 } );
  VidPlay( "vid_lab_gas_1", func_end );

end;
--*********************************************************************************************************************
function private.clk_flap_wire ()

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_flap_wire" );
    cmn.CallEventHandler( "clk_flap_wire" );

  end;

  cmn.Lock( true );  

  ObjAnimate( "spr_accesspanel_cover",      "alp", 0, 0, func_end, { 0,3,1,  0.4,3,0 } );
  ObjAnimate( "spr_accesspanel_cover_open", "alp", 0, 0, "",       { 0,3,0,  0.4,3,1 } );

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_slide", 0, "", 0 );

end;
--*********************************************************************************************************************
function private.clk_labassistantskey ()

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_labassistantskey" );
    cmn.CallEventHandler( "clk_labassistantskey" );

  end;

  cmn.Lock( true );  

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_key_lab", 0, "", 0 );

  ObjAnimate( "spr_accesspanel_key",                "alp", 0, 0, "",       { 0,3,1,  0.4,3,0           } );
  ObjAnimate( "spr_accesspanel_key_1",              "alp", 0, 0, "",       { 0,3,0,  0.4,3,1           } );
  ObjAnimate( "spr_accesspanel_patientsprofile",    "alp", 0, 0, func_end, { 0,3,0,  0.4,3,0,  0.8,3,1 } );

end;
--*********************************************************************************************************************
function private.clk_masterswitch ()

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_masterswitch" );
    cmn.CallEventHandler( "clk_masterswitch" );

    common.CloseSubRoom(); 

  end;

  cmn.Lock( true );  

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_lever", 0, "", 0 );

  ObjAnimate( "spr_masterswitch_masterswitch_open",     "alp", 0, 0, "",       { 0,3,1,  0.4,3,0           } );
  ObjAnimate( "spr_masterswitch_masterswitch_close",    "alp", 0, 0, "",       { 0,3,0,  0.4,3,1           } );
  ObjAnimate( "spr_masterswitch_door",                  "alp", 0, 0, func_end, { 0,3,1,  0.4,3,1,  0.8,3,0 } );

end;
--------------------------------------------------------------------------------------------
function private.clk_distillatingstill_button_1 ()

  cmn.CallEventHandler( "clk_distillatingstill_button_1_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_distillatingstill_button_1" );
    cmn.CallEventHandler( "clk_distillatingstill_button_1_end" );

    if ( cmn.IsEventDone( "clk_distillatingstill_button_2" ) ) then

      common.CloseSubRoom();
      cmn.GotoRoom( 'mg_distillatingstill' )

    end;

  end;

  local func_anim = function ()

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_slide", 0, "", 0 );

    ObjAnimate( "spr_distillatingstill_game_cover", "pos_xy", 0, 0, func_end, { 0, 0, 97, -30,   0.5, 3, 182, 163 } );

  end;

  local func = func_end;

  if cmn.IsEventDone( "clk_distillatingstill_button_2" ) then

    func = func_anim;

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_button_number", 0, "", 0 );

  ObjAnimate( "spr_distillatingstill_lamp1_light", "alp", 0, 0, func, { 0, 0, 0,   0.3, 0, 1 } );

end;
--------------------------------------------------------------------------------------------
function private.clk_distillatingstill_button_2 ()

  cmn.CallEventHandler( "clk_distillatingstill_button_2_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_distillatingstill_button_2" );
    cmn.CallEventHandler( "clk_distillatingstill_button_2_end" );

    if ( cmn.IsEventDone( "clk_distillatingstill_button_1" ) ) then

      common.CloseSubRoom();
      cmn.GotoRoom( 'mg_distillatingstill' )

    end;

  end;

  local func_anim = function ()

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_slide", 0, "", 0 );

    ObjAnimate( "spr_distillatingstill_game_cover", "pos_xy", 0, 0, func_end, { 0, 0, 97, -30,   0.5, 3, 182, 163 } );

  end;

  local func = func_end;

  if cmn.IsEventDone( "clk_distillatingstill_button_1" ) then

    func = func_anim;

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_button_number", 0, "", 0 );

  ObjAnimate( "spr_distillatingstill_lamp2_light", "alp", 0, 0, func, { 0, 0, 0,   0.3, 0, 1 } );

end;
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_lab ()

  if not ( cmn.IsEventDone( "opn_lab" ) ) then

    common_impl.ShowBbt( "bbt_lab_opn_lab" );

    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "get_into_archives" );

    cmn.SetEventDone( "opn_lab" );

  end;

  cmn.CallEventHandler( "opn_lab" ); 

end;
--*********************************************************************************************************************
function private.ClkLabClosedDoor()

  cmn.Lock( true );
  --common_impl.ShowBbt( 'bbt_distillatingstill_use_hexkey_1' );

  AnimPlay( "anm_lab_door", "DoAnim", function () cmn.Lock( false ); end );

end;

--*********************************************************************************************************************
function private.ClkAccesspanelCover()

  cmn.Lock( true );

  common_impl.ShowBbt( 'bbt_accesspanel_clk_cover_1' );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

  ObjAnimate( "spr_accesspanel_cover_1", "pos_xy", 0, 0, function() cmn.Lock( false ); end, 
  { 0,   0, 91, 118,
    0.2, 0, 94, 118,   
    0.4, 0, 91, 118,
    0.6, 0, 88, 118,
    0.8, 0, 91, 118,    
  } )

end;
--*********************************************************************************************************************


--*********************************************************************************************************************
-- function *** MMG GASMASK *** () end;
--*********************************************************************************************************************
  function private.GasmaskInit ()

  private.win_chain = { 3, 2, 1, 4 };
  private.current_clk = 0;

  for i = 1, 4 do

    ObjSet( "obj_lab_clk_button_"..i, 
    {
      event_mdown = function () private.GasmaskButtonClick ( i ); end,
      event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end
    } );

  end;

  function private.GasmaskButtonClick ( button )

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      ObjSet( "obj_lab_clk_button_"..button, { input = false } );
      private.current_clk = private.current_clk + 1;

      local state_mg = private.GasmaskIsWin( button );
      if ( state_mg == nil ) then

        common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

        private.GasmaskReset();

      elseif ( state_mg == true ) then

        private.GasmaskWin();

      end;

    end;

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk6", 0, "", 0 );

    ObjAnimate( "spr_lab_button_"..button.."_press", "alp" , 0, 0, func_end, { 0, 0, 0, 0.1, 0, 1 } );

  end;
  --------------------------------------------------------------------------------------------
  function private.GasmaskIsWin ( button )

    if ( button == private.win_chain[ private.current_clk ] ) then

      if ( private.current_clk == 4 ) then

        return true;

      end;

      return false;

    end;

    return nil;

  end;
  --------------------------------------------------------------------------------------------
  function private.GasmaskWin ()

    cmn.Lock( true );

    local func_end = function ()

      common_impl.StopAudio( "env", "level2/env/aud_alarm_beep_env" );
      common_impl.StopAudio( "env", "level2/env/aud_mask_env"       );

      private.GasmaskWin_End();

    end;

    ObjSet( "tmr_lab_anim", { active = false, playing = false } );

    local pos_x = ObjGet( "obj_lab_scene" ).pos_x;
    local pos_y = ObjGet( "obj_lab_scene" ).pos_y;

    ObjAnimate( "obj_lab_scene", "scale_xy", 0, 0, func_end, { 0, 0, 1.2, 1.2,   0.3, 3, 1, 1 } );
    ObjAnimate( "obj_lab_scene", "pos_xy", 0, 0, "", { 0, 0, pos_x, pos_y,   0.3, 3, 0, 0 } );

    ObjAnimate( "anm_lab_steam", "alp", 0, 0, "", { 0, 0, 1, 0.3, 3, 0 } );
    ObjAnimate( "anm_lab_light_gasmask", "alp", 0, 0, "", { 0, 0, 1, 0.3, 3, 0 } );
    --ObjAnimate( "anm_lab_use_gasmask", "alp", 0, 0, "", { 0, 0, 1, 0.3, 3, 1, 0.6, 0, 0 } );

    ObjSet( "tmr_lab_mmg_timer", { playing = false } );

  end;
  --------------------------------------------------------------------------------------------
  function private.GasmaskWin_End ()

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "win_gasmask" );
      cmn.CallEventHandler( "win_gasmask" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_take_off_mask", 0, "", 0 );

    ObjAnimate( "anm_lab_steam", "alp", 0, 0, "", 
    { 
      0.0, 0, 1, 
      0.3, 0, 0 
    } );
    ObjAnimate( "anm_lab_light_gasmask", "alp", 0, 0, "", 
    { 
      0.0, 0, 1, 
      0.3, 0, 0 
    } );
    ObjAnimate( "obj_lab_mmg_gasmask", "alp", 0, 0, "", 
    { 
      0.0, 0, 1, 
      0.3, 0, 0 
    } );
    ObjAnimate( "anm_lab_red_light", "alp", 0, 0, "", 
    { 
      0.0, 0, 1, 
      0.3, 0, 0 
    } );
    ObjAnimate( "anm_lab_light", "alp", 0, 0, "", 
    { 
      0.0, 0, 1, 
      0.3, 0, 0 
    } );
    ObjAnimate( "spr_lab_misted_glass", "alp", 0, 0, "", 
    { 
      0.0, 0, 1, 
      0.3, 0, 0 
    } );

    ObjSet( "vid_lab_gas_2", { alp = 0 } );
    ObjSet( "vid_lab_gas_3", { alp = 1 } );
    ObjSet( "spr_lab_gasmask_back", { alp = 0 } );
    ObjSet( "anm_lab_use_gasmask", { active = false, alp = 0 } );
    ObjSet( "anm_lab_put_off_mask", { alp = 1 } );
    VidPlay( "vid_lab_gas_3", func_end );
    AnimPlay( "anm_lab_put_off_mask", "DoAnim", "" );

  end;
  --------------------------------------------------------------------------------------------
  function private.GasmaskReset ()

    for i = 1, 4 do

      local alp = ObjGet( "spr_lab_button_"..i.."_press" ).alp;
      ObjAnimate( "spr_lab_button_"..i.."_press", "alp", 0, 0, "", { 0, 0, alp, 0.05, 0, 0 } );
      ObjSet( "obj_lab_clk_button_"..i, { input = true } );

    end;

    private.current_clk = 0;

  end;
  --------------------------------------------------------------------------------------------  
  function private.GaskmaskCheckTimer ( first_play )

    local time_reset = 7;

    if ( first_play ) then

      ObjSet( "tmr_lab_mmg_timer", { playing = true, time = time_reset, endtrig = function () private.GaskmaskCheckTimer() end } )

      ObjAnimate( "spr_lab_misted_glass", "alp", 0, 0, "", { 0.0, 0, 0,   time_reset, 0, 1 } );

    else

      cmn.Lock( true );

      common_impl.PlayAudio( "sfx", "level2/sfx/aud_mask_rub", 0, "", 0 );

      private.GasmaskReset();
      ObjSet( "anm_lab_use_gasmask", { frame = 0 } );
      AnimPlay( "anm_lab_use_gasmask", "DoAnim", function () private.GaskmaskCheckTimer( true ); cmn.Lock( false ); end );

      ObjSet("spr_lab_misted_glass", { alp = 0} );

    end;    

  end;
  --------------------------------------------------------------------------------------------  

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** MMG PASSWORD *** () end;
--*********************************************************************************************************************
function private.PasswordInit ()

  private.start_state = { 6, 7, 4, 6 };
  private.right_pass = { 3, 9, 5, 7 };
  private.width_cell = 47;
  
  private.start_pos = {};
  for i = 1, 4 do

    private.start_pos[ i ] = ObjGet( "obj_labdesk_password_line_"..i ).pos_x;
    ObjSet( "obj_labdesk_password_button_"..i,
    {
      event_mdown = function () private.PasswordClick ( i ); end,
      event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end
    } );
  
  end;
  --------------------------------------------------------------------------------------------  
  function private.PasswordClick ( line )

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_button_number", 0, "", 0 );

    local func_end = function ()

      if ( private.PasswordIsWin( line ) ) then

        private.PasswordWin();

      else

        cmn.Lock( false );
        ng_global.progress[ "std" ][ "win_password" ].state[ line ] = ng_global.progress[ "std" ][ "win_password" ].state[ line ] + 1;

        if ( ng_global.progress[ "std" ][ "win_password" ].state[ line ] == 12 ) then

          ng_global.progress[ "std" ][ "win_password" ].state[ line ] = 2;
          local s_x = ObjGet( "obj_labdesk_password_line_"..line ).pos_x;
          ObjSet( "obj_labdesk_password_line_"..line, { pos_x = s_x + 470 } );

        end;
  
      end;

    end;

    local s_x = ObjGet( "obj_labdesk_password_line_"..line ).pos_x;
    ObjAnimate( "obj_labdesk_password_line_"..line, "pos_x", 0, 0, func_end, { 0, 0, s_x, 0.3, 0, s_x - private.width_cell } );

  end;
  --------------------------------------------------------------------------------------------  
  function private.PasswordIsWin ( line )

    local wrong_lines = {};

    for i = 1, 4 do

      if ( ng_global.progress[ "std" ][ "win_password" ].state[ i ] ~= private.right_pass[ i ] ) then

        table.insert( wrong_lines, i );

      end;

    end;

    if ( #wrong_lines == 1 ) then
      
      if ( wrong_lines[ 1 ] == line ) and ( ( private.right_pass[ line ] - ng_global.progress[ "std" ][ "win_password" ].state[ line ] ) == 1  ) then

        return true;

      end;

    end;

    return false;

  end;
  --------------------------------------------------------------------------------------------  
  function private.PasswordWin ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "win_password" );
      cmn.CallEventHandler( "win_password" );

      cmn.MiniGameShow( "labdesk" );
      common_impl.PassingMgStart( "labdesk" );

      ng_global.progress[ "std" ][ "win_labdesk" ].state = {};
      for i = 1, 10 do

        ng_global.progress[ "std" ][ "win_labdesk" ].state[ i ] = private.checkers_start_state[ i ];

      end;

    end;

    ObjAnimate( "obj_labdesk_password", "alp", 0, 0, func_end, { 0, 0, 1, 0.4, 3, 0 } );
  
  end;
  --------------------------------------------------------------------------------------------  

end;
--*********************************************************************************************************************
-- function *** MMG LABDESK *** () end;
--*********************************************************************************************************************
function private.LabdeskInit ()

  private.BLUE  = 1;
  private.RED   = 2;
  private.CLEAR = 3;
  private.current_checker = nil;

  private.neighbors   = 
  {
    { 2, 4, 10 }, { 1, 3, 5 }, { 2, 6, 15 },
    { 1, 7, 5, 11 }, { 2, 4, 6, 8 }, { 3, 5, 9, 14 },
    { 4, 8, 12 }, { 5, 7, 9, }, { 6, 8, 13 },
    { 1, 11, 22 }, { 4, 10, 12, 19 }, { 7, 11, 16 }, { 9, 14, 18 }, { 6, 13, 15, 21 }, { 3, 14, 24 },
    { 12, 17, 19 }, { 16, 18, 20 }, { 13, 17, 21 },
    { 11, 16, 20, 22 }, { 17, 19, 21, 23 }, { 14, 18, 20, 24 },
    { 10, 19, 23 }, { 20, 22, 24 }, { 15, 21, 23 }
  };


  private.checkers_state       = { 10, 22, 19, 16, 4, 7, 21, 8, 14, 6 };
  private.checkers_start_state = { 10, 22, 19, 16, 4, 7, 21, 8, 14, 6 };
  private.checkers_win_state   = 
  { 
    1, 0, 2, 
    2, 0, 1, 
    0, 0, 0, 
    2, 0, 0, 0, 0, 1, 
    0, 0, 0,
    2, 0, 1, 
    1, 0, 2 
  };
  
  private.checkers    = { 1, 2, 2, 2, 1, 1, 2, 1, 1, 2 };
  private.positions   = 
  {
    { -256, -236 }, { 7, -236 }, { 268, -232 },
    { -204, -195 }, { 6, -198 }, { 215, -198 },
    { -150, -161 }, { 7, -161 }, { 163, -161 },
    { -283, -92 },  { -222, -91 }, { -157, -91 }, {  170, -90 }, {  230, -90 }, {  284, -90 },
    { -166, -17 },  { 3, -12 }, { 175, -13 },
    { -239, 29 }, { 5, 33 }, { 245, 32 },
    { -310, 82 }, { 6, 83 }, { 318, 81 }  
  };

  for i = 1, 10 do

    ObjSet( "spr_labdesk_checker_"..i,
    {
      input = true,
      event_mdown = function () private.LabdeskCheckerClk ( i ); end,
      event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end
    } );

  end;

  for i = 1, 24 do

    ObjSet( "obj_labdesk_minigame_cell_"..i,
    {
      input = false,
      event_mdown = function () private.LabdeskCellClk ( i ); end,
      event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end
    } );

  end;
  --------------------------------------------------------------------------------------------  
  function private.LabdeskCheckerClk ( id )

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_menter1", 0, "", 0 );

    if ( private.current_checker ) then

      ObjDelete( "spr_labdesk_checker_"..private.current_checker.."_light" );
    
      if ( private.current_checker == id ) then

        private.current_checker = nil;
        private.LabdeskSetCells( false );

      else
        
        private.current_checker = id;

        ObjClone( "spr_labdesk_checker_"..id, "_light", 1, "spr_labdesk_checker_"..id );
        ObjSet( "spr_labdesk_checker_"..id.."_light", { blendmode = 2, input = false, pos_x = 0, pos_y = 0 } );

      end;

    else

      private.current_checker = id;

      ObjClone( "spr_labdesk_checker_"..id, "_light", 1, "spr_labdesk_checker_"..id );
      ObjSet( "spr_labdesk_checker_"..id.."_light", { blendmode = 2, input = false, pos_x = 0, pos_y = 0 } );

      private.LabdeskSetCells( true );

    end;

  end;
  --------------------------------------------------------------------------------------------  
  function private.LabdeskSetCells ( active )

     for i = 1, 24 do

      ObjSet( "obj_labdesk_minigame_cell_"..i, { input = active } );

    end;

  end;
  --------------------------------------------------------------------------------------------  
  function private.LabdeskCellClk ( id )

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_button_number", 0, "", 0 );

    local is_neighbor = false;
    for i = 1, #private.neighbors[ id ] do

      if ( private.neighbors[ id ][ i ] == private.checkers_state[ private.current_checker ] ) then

        is_neighbor = true;

      end;

    end;

    if ( is_neighbor ) then --AK> ВОЗМОЖНО придется добавить проверку на занятость ячейки
      
      local func_end = function ()

        cmn.Lock( false );

        private.checkers_state[ private.current_checker ] = id;
        private.current_checker = nil; 
        private.LabdeskSetCells( false );

        if ( private.LabdeskIsWin() ) then
        
          private.LabdeskWin();

        else

          private.LabdeskSaveVar();

        end;
      
      end;

      cmn.Lock( true );

      ObjDelete( "spr_labdesk_checker_"..private.current_checker.."_light" );

      local obj = ObjGet( "spr_labdesk_checker_"..private.current_checker )
      ObjAnimate( "spr_labdesk_checker_"..private.current_checker, "pos_xy", 0, 0, func_end, 
      {  
        0.0, 0, obj.pos_x, obj.pos_y,
        0.4, 3, private.positions[ id ][ 1 ], private.positions[ id ][ 2 ]
      } );

    end;

  end;
  --------------------------------------------------------------------------------------------  
  function private.LabdeskIsWin ()

    for i = 1, 24 do

      local cell_state = 0;

      for j = 1, 10 do

        if ( private.checkers_state[ j ] == i ) then
          cell_state = private.checkers[ j ];
          break;
        end;

      end;

      if ( private.checkers_win_state[ i ] ~=  cell_state ) then

        return false;
      
      end;

    end;

    return true;

  end;
  --------------------------------------------------------------------------------------------  
  function private.LabdeskWin ()

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

    local func_end = function ()

      cmn.Lock( false );

      cmn.MiniGameHide( "labdesk" );
      common_impl.PassingMgWin( "labdesk" );
      cmn.SetEventDone( "win_labdesk" );
      cmn.CallEventHandler( "win_labdesk" );

    end;

    ObjAnimate( "obj_labdesk_minigame_checkers", "alp", 0, 0, "", 
    { 
      0.0, 0, 1, 
      0.3, 1, 0 
    } );

    ObjAnimate( "spr_labdesk_labkey_over", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 1, 
      0.3, 0, 1, 
      0.6, 3, 0 
    } );

  end;
  --------------------------------------------------------------------------------------------  
  function private.LabdeskSaveVar ()

    for i = 1, 10 do

      ng_global.progress[ "std" ][ "win_labdesk" ].state[ i ] = private.checkers_state[ i ];

    end;

  end;
  -------------------------------------------------------------------------------------------  

end;
--*********************************************************************************************************************
-- function *** ANIM *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.InitAnimations ()

  ObjAnimate( "spr_masterswitch_light", "alp", 1, 0, "", { 0, 0, 1,    2, 0, 0.5,   4, 0, 1  } );

  --ObjAnimate( "spr_accesspanel_scanner_light",     "alp", 1, 0, "", { 0, 0, 1,    0.7, 0, 0.5,   1.45, 0, 1  } );
  ObjAnimate( "spr_accesspanel_scanner_light_red", "alp", 1, 0, "", { 0, 0, 1,    0.5, 0, 0.5,   1.1,  0, 1  } );

end;
--------------------------------------------------------------------------------------------

function private.AnimGameDoor ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_labdesk_use_accesspassword' );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk3", 0, "", 0 );

  ObjAnimate( "spr_labdesk_gamedoor_lft", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 0, -171, -88, 
    0.3, 0, -173, -88,
    0.6, 0, -171, -88, 
  } );
  ObjAnimate( "spr_labdesk_gamedoor_rgt", "pos_xy", 0, 0, "", 
  { 
    0.0, 0, 117, -88, 
    0.3, 0, 120, -88,
    0.6, 0, 117, -88, 
  } );

  ObjAnimate( "obj_labdesk_password_code", "pos_xy", 0, 0, "", 
  { 
    0.0, 0, 0, 0, 
    0.3, 0, 3, 0,
    0.6, 0, 0, 0,  
  } );
  ObjAnimate( "obj_labdesk_password_buttons", "pos_xy", 0, 0, "", 
  { 
    0.0, 0, 0, 0, 
    0.3, 0, 3, 0,
    0.6, 0, 0, 0, 
  } );
  ObjAnimate( "spr_labdesk_code_up_side", "pos_xy", 0, 0, "", 
  { 
    0.0, 0, -12, -106, 
    0.3, 0,  -9, -106,
    0.6, 0, -12, -106, 
  } );

end;
--------------------------------------------------------------------------------------------
function private.AnimCoverPrint()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_distillatingstill_use_hexkey_1' );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

  ObjAnimate( "spr_distillatingstill_cover", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 0, 108, -26, 
    0.2, 0, 111, -26,
    0.4, 0, 108, -26, 
  } );
  ObjAnimate( "vid_distillatingstill_hexkey", "pos_xy", 0, 0, "", 
  { 
    0.0, 0, 2, 6, 
    0.2, 0, 3, 6,
    0.4, 0, 2, 6, 
  } );

end;
--------------------------------------------------------------------
local anim_obj = {
                  { "obj_lab_scene",             -219, -16, -20, 0}
                };

local x = 0;
local y = 0;
--------------------------------------------------------------------------------------------
function private.BackAnim()

  ObjSet( "tmr_lab_anim", { endtrig = private.BackAnim, time = 1/60, playing = true } );

  local res = cmn.AnimForCur( anim_obj, x, y );

  x = res[ 1 ];
  y = res[ 2 ];

end;
--------------------------------------------------------------------------------------------