-- name=rm_lounge_2
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_lounge_2";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_lounge = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gmg_lounge_",
    "gzz_lounge_"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_lounge", update_game_mode_lounge, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_lounge = function ()

  local effects_table = 
  {
    "anm_lounge_2_tv",
    "anm_lounge_2_spark" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_lounge", update_performance_mode_lounge, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_lounge () end;
  --------------------------------------------------------------------------------------------
  local opn_lounge_2_map = function ()

    common_impl.VisitMapRoom( "lounge" );

  end;
  cmn.AddSubscriber( "opn_lounge_2", opn_lounge_2_map );
  
end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_lounge_2();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();

  ObjSet( "spr_lounge_light_lamp1", { alp = 0 } );
  private.AnimMouseHoleLight();

end;
--*********************************************************************************************************************
function public.Close ()

  cmn.NoteScaleClose( { "spr_lounge_2_blank_form", "spr_lounge_2_drawing" } );

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_lounge_2 ()

  if not ( cmn.IsEventDone( "opn_lounge_2" ) ) then

    cmn.SetEventDone( "opn_lounge_2" );

  end;

  cmn.CallEventHandler( "opn_lounge_2" ); 

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** ANIMATIONS *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.AnimMouseHoleLight ()

  ObjAnimate( "spr_lounge_light_lamp1", "alp",1,0, "", 
  { 
    0.0, 3, 0.0, 
    1.5, 3, 0.5, 
    3.0, 3, 0.0, 
    5.0, 3, 1, 
    7.0, 3, 0.0 
  } );

end;
--*********************************************************************************************************************





