-- name=rm_lowerlevel
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_lowerlevel";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_receptiondesk", "room_hub" );
  ObjAttach( "zz_coldstoragebox", "room_hub" );
  ObjAttach( "zz_wheelchair", "room_hub" );
  ObjAttach( "zz_darkcorner", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
    { "spr_receptiondesk_fridgehandle1",              { event_mdown = private.get_fridgehandle1       } },
    { "spr_coldstoragebox_gasmask",                   { event_mdown = private.get_gasmask             } },
    { "spr_coldstoragebox_registrationentries",       { event_mdown = private.get_registrationentries } },
    { "spr_coldstoragebox_wheelchairwheel",           { event_mdown = private.get_wheelchairwheel     } },
    { "spr_coldstoragebox_cheese",                    { event_mdown = private.get_cheese              } },
    { "spr_coldstoragebox_pipepiece",                 { event_mdown = private.get_pipepiece           } },
    { "spr_coldstoragebox_hint",                      { event_mdown = private.get_hint                } },
    { "spr_wheelchair_receptionroomkey",              { event_mdown = private.get_receptionroomkey    } },
    { "spr_darkcorner_fridgehandle2",                 { event_mdown = private.get_fridgehandle2       } },
    { "spr_darkcorner_file",                          { event_mdown = private.get_file                } },
    { "spr_darkcorner_masterswitch",                  { event_mdown = private.get_masterswitch        } },
    { "spr_coldstoragebox_seal2",                     { event_mdown = private.get_seal2               } },

    { "obj_coldstoragebox_clk_fridgehandle1",         { event_mdown = private.clk_fridgehandle1       } },
    { "obj_coldstoragebox_clk_fridgehandle3",         { event_mdown = private.clk_fridgehandle3       } },
    { "obj_receptiondesk_clk_receptionroomkey",       { event_mdown = private.clk_receptionroomkey    } },

    { "obj_receptiondesk_use_receptionroomkey",       { event_mdown = private.ClkReceptiondeskHandle  } },
    { "obj_darkcorner_use_filehandle",                { event_mdown = private.ClkDarccornerFile       } },

    { "obj_coldstoragebox_use_fridgehandle1",         { event_mdown = private.UseFridgehandle1        } },
    { "obj_coldstoragebox_use_fridgehandle2",         { event_mdown = private.UseFridgehandle2        } },
    { "obj_coldstoragebox_use_fridgehandle3",         { event_mdown = private.UseFridgehandle3        } },
    { "obj_coldstoragebox_use_fridgehandle4",         { event_mdown = private.UseFridgehandle4        } },
    { "obj_coldstoragebox_use_file",                  { event_mdown = private.UseFile                 } },

    { "obj_wheelchair_use_wheelchairwheel",           { event_mdown = private.ClkWheelchairStretcher  } },

    { "spr_collect2_item_2_4",                        { event_mdown = private.get_collect2_item_2_4   } },
    { "spr_lowerlevel_collect_morph_item",            { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_2_3" ); end } },

  } );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_lowerlevel = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "grm_lowerlevel_corridorelevator",
      "grm_lowerlevel_receptionroom",
      "grm_lowerlevel_lab",

      "gzz_lowerlevel_coldstoragebox",
      "gzz_lowerlevel_receptiondesk",
      "gzz_lowerlevel_wheelchair",
      "gzz_lowerlevel_darkcorner",
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_receptiondesk",
      "zz_coldstoragebox",
      "zz_wheelchair",
      "zz_darkcorner",
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_lowerlevel", update_game_mode_lowerlevel, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_lowerlevel = function ()

  local effects_table = 
  {
    "obj_lowerlevel_anim",
    "anm_lowerlevel_lowerlevel_1",
    "anm_lowerlevel_zz_light",

    "anm_wheelchair_cogwheel", 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_lowerlevel", update_performance_mode_lowerlevel, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_lowerlevel () end;
  --------------------------------------------------------------------------------------------
  local opn_lowerlevel_map = function ()

    common_impl.VisitMapRoom( "lowerlevel" );

  end;
  cmn.AddSubscriber( "opn_lowerlevel", opn_lowerlevel_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_fridgehandle1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fridgehandle1" ] = {
    type = "get",
    get_obj = "spr_receptiondesk_fridgehandle1",
    room = private.room_objname,
    zz = "zz_receptiondesk",
    zz_gate = "gzz_lowerlevel_receptiondesk"
  };
  
  local get_fridgehandle1_inv = function ()
  
    interface.InventoryItemAdd( "inv_fridgehandle1", "spr_receptiondesk_fridgehandle1" );
  
  end;

  local get_fridgehandle1_beg = function ()
  
    ObjDelete( "gfx_receptiondesk_fridgehandle1" );
    ObjDelete( "spr_receptiondesk_fridgehandle1_shadow" );
  
  end;
  
  local get_fridgehandle1_closezz = function ()
  
    ObjDelete( "spr_lowerlevel_fridgehandle1rusty" );
    ObjDelete( "spr_lowerlevel_door_close_key" );
  
  end;
  
  cmn.AddSubscriber( "get_fridgehandle1_beg", get_fridgehandle1_inv );
  cmn.AddSubscriber( "get_fridgehandle1_beg", get_fridgehandle1_beg, private.room_objname );
  cmn.AddSubscriber( "get_fridgehandle1_end", get_fridgehandle1_closezz, private.room_objname );
  cmn.AddSubscriber( "get_fridgehandle1", get_fridgehandle1_inv );
  cmn.AddSubscriber( "get_fridgehandle1", get_fridgehandle1_beg, private.room_objname );
  cmn.AddSubscriber( "get_fridgehandle1", get_fridgehandle1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gasmask () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_gasmask" ] = {
    type = "get",
    get_obj = "spr_coldstoragebox_gasmask",
    room = private.room_objname,
    zz = "zz_coldstoragebox",
    zz_gate = "gzz_lowerlevel_coldstoragebox"
  };
  
  local get_gasmask_inv = function ()
  
    interface.InventoryItemAdd( "inv_gasmask", "spr_coldstoragebox_gasmask" );
  
  end;
  
  local get_gasmask_closezz = function ()
  
    ObjDelete( "gfx_coldstoragebox_gasmask" );
  
  end;
  
  cmn.AddSubscriber( "get_gasmask", get_gasmask_inv );
  cmn.AddSubscriber( "get_gasmask", get_gasmask_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_registrationentries () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_registrationentries" ] = {
    type = "get",
    get_obj = "spr_coldstoragebox_registrationentries",
    room = private.room_objname,
    zz = "zz_coldstoragebox",
    zz_gate = "gzz_lowerlevel_coldstoragebox"
  };
  
  local get_registrationentries_inv = function ()
  
    interface.InventoryItemAdd( "inv_registrationentries", "spr_coldstoragebox_registrationentries" );
    ObjSet( "inv_registrationentries", { drag = false } );  

  end;
  
  local get_registrationentries_closezz = function ()

    ObjDelete( "gfx_coldstoragebox_registrationentries"            );
    ObjDelete( "spr_lowerlevel_coldstoragebox_registrationentries" );
  
  end;
  
  cmn.AddSubscriber( "get_registrationentries", get_registrationentries_inv );
  cmn.AddSubscriber( "get_registrationentries", get_registrationentries_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wheelchairwheel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wheelchairwheel" ] = {
    type = "get",
    get_obj = "spr_coldstoragebox_wheelchairwheel",
    room = private.room_objname,
    zz = "zz_coldstoragebox",
    zz_gate = "gzz_lowerlevel_coldstoragebox"
  };
  
  local get_wheelchairwheel_inv = function ()
  
    interface.InventoryItemAdd( "inv_wheelchairwheel", "spr_coldstoragebox_wheelchairwheel" );
  
  end;
  
  local get_wheelchairwheel_closezz = function ()
  
    ObjDelete( "gfx_coldstoragebox_wheelchairwheel"        );
    ObjDelete( "spr_coldstoragebox_wheelchairwheel_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_wheelchairwheel", get_wheelchairwheel_inv );
  cmn.AddSubscriber( "get_wheelchairwheel", get_wheelchairwheel_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cheese () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cheese" ] = {
    type = "get",
    get_obj = "spr_coldstoragebox_cheese",
    room = private.room_objname,
    zz = "zz_coldstoragebox",
    zz_gate = "gzz_lowerlevel_coldstoragebox"
  };
  
  local get_cheese_inv = function ()
  
    interface.InventoryItemAdd( "inv_cheese", "spr_coldstoragebox_cheese" );
  
  end;
  
  local get_cheese_closezz = function ()
  
    ObjDelete( "gfx_coldstoragebox_cheese"            );
    ObjDelete( "spr_lowerlevel_coldstoragebox_cheese" );
  
  end;
  
  cmn.AddSubscriber( "get_cheese", get_cheese_inv );
  cmn.AddSubscriber( "get_cheese", get_cheese_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pipepiece () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pipepiece" ] = {
    type = "get",
    get_obj = "spr_coldstoragebox_pipepiece",
    room = private.room_objname,
    zz = "zz_coldstoragebox",
    zz_gate = "gzz_lowerlevel_coldstoragebox"
  };
  
  local get_pipepiece_inv = function ()
  
    interface.InventoryItemAdd( "inv_pipepiece", "spr_coldstoragebox_pipepiece" );
  
  end;
  
  local get_pipepiece_closezz = function ()
  
    --ObjDelete( "fx_coldstoragebox_smoke" );
    ObjSet( "fx_coldstoragebox_smoke", { pos_x = -30, pos_y = 320 } );
    ObjDelete( "gfx_coldstoragebox_pipepiece"       );
    ObjDelete( "spr_lowerlevel_coldstoragebox_pipe" );
  
  end;
  
  cmn.AddSubscriber( "get_pipepiece", get_pipepiece_inv );
  cmn.AddSubscriber( "get_pipepiece", get_pipepiece_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hint () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hint" ] = {
    type = "get",
    get_obj = "spr_coldstoragebox_hint",
    room = private.room_objname,
    zz = "zz_coldstoragebox",
    zz_gate = "gzz_lowerlevel_coldstoragebox"
  };
  
  local get_hint_inv = function ()
  
    interface.InventoryItemAdd( "inv_hint", "spr_coldstoragebox_hint" );
  
  end;
  
  local get_hint_closezz = function ()
  
    ObjDelete( "gfx_coldstoragebox_hint" );
    ObjDelete( "spr_lowerlevel_coldstoragebox_hint" );
  
    if ( cmn.IsEventDone( "get_seal2" ) ) then

      ObjDelete( "gzz_lowerlevel_coldstoragebox" );
    
    end;

  end;
  
  cmn.AddSubscriber( "get_hint", get_hint_inv );
  cmn.AddSubscriber( "get_hint", get_hint_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_receptionroomkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_receptionroomkey" ] = {
    type = "get",
    get_obj = "spr_wheelchair_receptionroomkey",
    room = private.room_objname,
    zz = "zz_wheelchair",
    zz_gate = "gzz_lowerlevel_wheelchair"
  };
  
  local get_receptionroomkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_receptionroomkey", "spr_wheelchair_receptionroomkey" );
  
  end;
  
  local get_receptionroomkey_closezz = function ()
  
    ObjDelete( "gfx_wheelchair_receptionroomkey" );    

    ObjDelete( "spr_lowerlevel_mannequin_key" );   
  
  end;
  
  cmn.AddSubscriber( "get_receptionroomkey_beg", get_receptionroomkey_inv );
  cmn.AddSubscriber( "get_receptionroomkey", get_receptionroomkey_inv );
  cmn.AddSubscriber( "get_receptionroomkey_end", get_receptionroomkey_closezz, private.room_objname );
  cmn.AddSubscriber( "get_receptionroomkey", get_receptionroomkey_closezz, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_fridgehandle2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fridgehandle2" ] = {
    type = "get",
    get_obj = "spr_darkcorner_fridgehandle2",
    room = private.room_objname,
    zz = "zz_darkcorner",
    zz_gate = "gzz_lowerlevel_darkcorner"
  };
  
  local get_fridgehandle2_inv = function ()
  
    interface.InventoryItemAdd( "inv_fridgehandle2", "spr_darkcorner_fridgehandle2" );
  
  end;
  
  local get_fridgehandle2_closezz = function ()
  
    ObjDelete( "gfx_darkcorner_fridgehandle2"        );
    ObjDelete( "spr_darkcorner_fridgehandle2_over"   );
    ObjDelete( "spr_darkcorner_fridgehandle2_shadow" );

    ObjDelete( "spr_lowerlevel_fridgehandle"         );
  
  end;
  
  cmn.AddSubscriber( "get_fridgehandle2", get_fridgehandle2_inv );
  cmn.AddSubscriber( "get_fridgehandle2", get_fridgehandle2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_file () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_file" ] = {
    type = "get",
    get_obj = "spr_darkcorner_file",
    room = private.room_objname,
    zz = "zz_darkcorner",
    zz_gate = "gzz_lowerlevel_darkcorner"
  };
  
  local get_file_inv = function ()
  
    interface.InventoryItemAdd( "inv_file", "spr_darkcorner_file" );
  
  end;
  
  local get_file_closezz = function ()
  
    ObjDelete( "gfx_darkcorner_file"       );

    if ( cmn.IsGetCollect2( "get_collect2_item_2_4" ) ) then

      ObjDelete( "gzz_lowerlevel_darkcorner" );

    end;

    ObjDelete( "spr_darkcorner_fileshadow" );
    ObjDelete( "spr_lowerlevel_file"       );
  
  end;
  
  cmn.AddSubscriber( "get_file", get_file_inv );
  cmn.AddSubscriber( "get_file", get_file_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_masterswitch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_masterswitch" ] = {
    type = "get",
    get_obj = "spr_darkcorner_masterswitch",
    room = private.room_objname,
    zz = "zz_darkcorner",
    zz_gate = "gzz_lowerlevel_darkcorner"
  };
  
  local get_masterswitch_inv = function ()
  
    interface.InventoryItemAdd( "inv_masterswitch", "spr_darkcorner_masterswitch" );
  
  end;
  
  local get_masterswitch_closezz = function ()
  
    ObjDelete( "gfx_darkcorner_masterswitch"        );
    ObjDelete( "spr_darkcorner_masterswitch_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_masterswitch", get_masterswitch_inv );
  cmn.AddSubscriber( "get_masterswitch", get_masterswitch_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_seal2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_seal2" ] = {
    type = "get",
    get_obj = "spr_coldstoragebox_seal2",
    room = private.room_objname,
    zz = "zz_coldstoragebox",
    zz_gate = "gzz_lowerlevel_coldstoragebox"
  };
  
  local get_seal2_inv = function ()
  
    interface.InventoryItemAdd( "inv_seal2", "spr_coldstoragebox_seal2" );
  
  end;
  
  local get_seal2_closezz = function ()
  
    ObjDelete( "gfx_coldstoragebox_seal2" );
  
    if ( cmn.IsEventDone( "get_hint" ) ) then

      ObjDelete( "gzz_lowerlevel_coldstoragebox" );
    
    end;

  end;
  
  cmn.AddSubscriber( "get_seal2", get_seal2_inv );
  cmn.AddSubscriber( "get_seal2", get_seal2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_2_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_2_4 = function ()

    if ( cmn.IsEventDone( "get_file" ) ) then

      ObjDelete( "gzz_lowerlevel_darkcorner" );

    end;

    ObjDelete( "obj_collect2_item_2_4" );
  
  end;    
  cmn.AddSubscriber( "get_collect2_item_2_4", get_collect2_item_2_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2_3 = function ()
  
    ObjDelete( "obj_lowerlevel_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_2_3", get_collect_morph_item_2_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_antirust_2_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_antirust_2_2" ] = {
    type = "use",
    inv_obj = "inv_antirust_2",
    use_place = "obj_receptiondesk_use_antirust_2_2",
    room = private.room_objname,
    zz = "zz_receptiondesk",
    zz_gate = "gzz_lowerlevel_receptiondesk"
  };
  local use_antirust_2_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_antirust_2" );
  
  end;
  local use_antirust_2_2_beg = function ()
  
    ObjDelete( "obj_receptiondesk_use_antirust_2_2" );
  
  end;
  local use_antirust_2_2_end = function ()
  
    ObjMultiSet({ 
      { "spr_receptiondesk_fridgehandle1", { input = true  } },
      { "gfx_receptiondesk_fridgehandle1", { active = true } },
      { "spr_receptiondesk_wet",           { alp = 1       } },
    } );

    ObjDelete( "spr_receptiondesk_fridgehandle1_rusty" );
    ObjDelete( "vid_receptiondesk_antirust"            );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_antirust_2_2", use_antirust_2_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_antirust_2_2", use_antirust_2_2_inv );
  cmn.AddSubscriber( "use_antirust_2_2", use_antirust_2_2_end, private.room_objname );
  cmn.AddSubscriber( "use_antirust_2_2_inv", use_antirust_2_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_antirust_2_2_beg", use_antirust_2_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_antirust_2_2_end", use_antirust_2_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_receptionroomkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_receptionroomkey" ] = {
    type = "use",
    inv_obj = "inv_receptionroomkey",
    use_place = "obj_receptiondesk_use_receptionroomkey",
    room = private.room_objname,
    zz = "zz_receptiondesk",
    zz_gate = "gzz_lowerlevel_receptiondesk"
  };
  local use_receptionroomkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_receptionroomkey" );
  
  end;
  local use_receptionroomkey_beg = function ()
  
    ObjDelete( "obj_receptiondesk_use_receptionroomkey" );
  
  end;
  local use_receptionroomkey_end = function ()

    ObjMultiSet({ 
      { "obj_receptiondesk_door_key",     { alp = 1                     }},
      { "obj_receptiondesk_clk_receptionroomkey", { input = true, active = true }},
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_receptionroomkey", use_receptionroomkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_receptionroomkey", use_receptionroomkey_inv );
  cmn.AddSubscriber( "use_receptionroomkey", use_receptionroomkey_end, private.room_objname );
  cmn.AddSubscriber( "use_receptionroomkey_inv", use_receptionroomkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_receptionroomkey_beg", use_receptionroomkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_receptionroomkey_end", use_receptionroomkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fridgehandle1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fridgehandle1" ] = {
    type = "use",
    inv_obj = "inv_fridgehandle1",
    use_place = "obj_coldstoragebox_use_fridgehandle1",
    room = private.room_objname,
    zz = "zz_coldstoragebox",
    zz_gate = "gzz_lowerlevel_coldstoragebox"
  };
  local use_fridgehandle1_inv = function ()
  
    interface.InventoryItemRemove( "inv_fridgehandle1" );
  
  end;
  local use_fridgehandle1_beg = function ()
  
    ObjDelete( "obj_coldstoragebox_use_fridgehandle1" );
    ObjSet( "spr_coldstoragebox_overkey1" , { alp = 1 });
  
  end;
  local use_fridgehandle1_end = function ()
  
    ObjMultiSet({ 
      { "obj_coldstoragebox_clk_fridgehandle1",              { input = true, active = true }},
      { "spr_coldstoragebox_box1_2",                         { alp = 1                     }},
      { "spr_lowerlevel_coldstoragebox_box4",                { alp = 1                     }},
      { "spr_lowerlevel_coldstoragebox_registrationentries", { alp = 1                     }},   
    });

    ObjDelete( "spr_coldstoragebox_key1"     );
    ObjDelete( "spr_coldstoragebox_key1_2"   );
    ObjDelete( "spr_coldstoragebox_box1"     );
    ObjDelete( "spr_coldstoragebox_overkey1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fridgehandle1", use_fridgehandle1_beg, private.room_objname );
  cmn.AddSubscriber( "use_fridgehandle1", use_fridgehandle1_inv );
  cmn.AddSubscriber( "use_fridgehandle1", use_fridgehandle1_end, private.room_objname );
  cmn.AddSubscriber( "use_fridgehandle1_inv", use_fridgehandle1_inv, private.room_objname );
  cmn.AddSubscriber( "use_fridgehandle1_beg", use_fridgehandle1_beg, private.room_objname );
  cmn.AddSubscriber( "use_fridgehandle1_end", use_fridgehandle1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fridgehandle2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fridgehandle2" ] = {
    type = "use",
    inv_obj = "inv_fridgehandle2",
    use_place = "obj_coldstoragebox_use_fridgehandle2",
    room = private.room_objname,
    zz = "zz_coldstoragebox",
    zz_gate = "gzz_lowerlevel_coldstoragebox"
  };
  local use_fridgehandle2_inv = function ()
  
    interface.InventoryItemRemove( "inv_fridgehandle2" );
  
  end;
  local use_fridgehandle2_beg = function ()
  
    ObjDelete( "obj_coldstoragebox_use_fridgehandle2" );
    ObjSet( "spr_coldstoragebox_overkey2" , { alp = 1 });
  
  end;
  local use_fridgehandle2_end = function ()
  
    ObjMultiSet({ 
      { "spr_coldstoragebox_gasmask",           { input = true, active = true }},
      { "spr_coldstoragebox_wheelchairwheel",   { input = true, active = true }},
      { "spr_coldstoragebox_box2_2",            { alp = 1                     }}, 
      { "spr_lowerlevel_coldstoragebox_box3",   { alp = 1                     }},  
    });

    ObjDelete( "spr_coldstoragebox_key2"     );
    ObjDelete( "spr_coldstoragebox_key2_2"   );
    ObjDelete( "spr_coldstoragebox_box2"     );
    ObjDelete( "spr_coldstoragebox_overkey2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fridgehandle2", use_fridgehandle2_beg, private.room_objname );
  cmn.AddSubscriber( "use_fridgehandle2", use_fridgehandle2_inv );
  cmn.AddSubscriber( "use_fridgehandle2", use_fridgehandle2_end, private.room_objname );
  cmn.AddSubscriber( "use_fridgehandle2_inv", use_fridgehandle2_inv, private.room_objname );
  cmn.AddSubscriber( "use_fridgehandle2_beg", use_fridgehandle2_beg, private.room_objname );
  cmn.AddSubscriber( "use_fridgehandle2_end", use_fridgehandle2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fridgehandle3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fridgehandle3" ] = {
    type = "use",
    inv_obj = "inv_fridgehandle3",
    use_place = "obj_coldstoragebox_use_fridgehandle3",
    room = private.room_objname,
    zz = "zz_coldstoragebox",
    zz_gate = "gzz_lowerlevel_coldstoragebox"
  };
  local use_fridgehandle3_inv = function ()
  
    interface.InventoryItemRemove( "inv_fridgehandle3" );
  
  end;
  local use_fridgehandle3_beg = function ()
  
    ObjDelete( "obj_coldstoragebox_use_fridgehandle3" );
    ObjSet( "spr_coldstoragebox_overkey3" , { alp = 1 });
  
  end;
  local use_fridgehandle3_end = function ()
  
   ObjMultiSet({ 
     { "obj_coldstoragebox_clk_fridgehandle3", { input = true, active = true }},
     { "spr_coldstoragebox_box3_2",            { alp = 1                     }},
     { "spr_lowerlevel_coldstoragebox_box1",   { alp = 1                     }},
     { "spr_lowerlevel_coldstoragebox_cheese", { alp = 1                     }},  
   });

   ObjDelete( "spr_coldstoragebox_key3"     );
   ObjDelete( "spr_coldstoragebox_key3_2"   );
   ObjDelete( "spr_coldstoragebox_box3"     );
   ObjDelete( "spr_coldstoragebox_overkey3" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fridgehandle3", use_fridgehandle3_beg, private.room_objname );
  cmn.AddSubscriber( "use_fridgehandle3", use_fridgehandle3_inv );
  cmn.AddSubscriber( "use_fridgehandle3", use_fridgehandle3_end, private.room_objname );
  cmn.AddSubscriber( "use_fridgehandle3_inv", use_fridgehandle3_inv, private.room_objname );
  cmn.AddSubscriber( "use_fridgehandle3_beg", use_fridgehandle3_beg, private.room_objname );
  cmn.AddSubscriber( "use_fridgehandle3_end", use_fridgehandle3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_file () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_file" ] = {
    type = "use",
    inv_obj = "inv_file",
    use_place = "obj_coldstoragebox_use_file",
    room = private.room_objname,
    zz = "zz_coldstoragebox",
    zz_gate = "gzz_lowerlevel_coldstoragebox"
  };
  local use_file_inv = function ()
  
    interface.InventoryItemRemove( "inv_file" );
  
  end;
  local use_file_beg = function ()
  
    ObjDelete( "obj_coldstoragebox_use_file" );
  
  end;
  local use_file_end = function ()
  
    ObjDelete( "anm_coldstoragebox_pipe" );
    ObjSet( "spr_coldstoragebox_pipepiece", { input = true } );
    ObjSet( "gfx_coldstoragebox_pipepiece", { active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_file", use_file_beg, private.room_objname );
  cmn.AddSubscriber( "use_file", use_file_inv );
  cmn.AddSubscriber( "use_file", use_file_end, private.room_objname );
  cmn.AddSubscriber( "use_file_inv", use_file_inv, private.room_objname );
  cmn.AddSubscriber( "use_file_beg", use_file_beg, private.room_objname );
  cmn.AddSubscriber( "use_file_end", use_file_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fridgehandle4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fridgehandle4" ] = {
    type = "use",
    inv_obj = "inv_fridgehandle4",
    use_place = "obj_coldstoragebox_use_fridgehandle4",
    room = private.room_objname,
    zz = "zz_coldstoragebox",
    zz_gate = "gzz_lowerlevel_coldstoragebox"
  };
  local use_fridgehandle4_inv = function ()
  
    interface.InventoryItemRemove( "inv_fridgehandle4" );
  
  end;
  local use_fridgehandle4_beg = function ()
  
    ObjDelete( "obj_coldstoragebox_use_fridgehandle4" );
    ObjSet( "spr_coldstoragebox_overkey4" , { alp = 1 });
  
  end;
  local use_fridgehandle4_end = function ()
  
    ObjMultiSet({ 
      { "spr_coldstoragebox_hint",            { input = true, active = true }},
      { "spr_coldstoragebox_seal2",           { input = true, active = true }},
      { "spr_coldstoragebox_box4_2",          { alp = 1                     }},
      { "spr_lowerlevel_coldstoragebox_box2", { alp = 1                     }},
      { "spr_lowerlevel_coldstoragebox_hint", { alp = 1                     }},
    });

    ObjDelete( "spr_coldstoragebox_key4"     );
    ObjDelete( "spr_coldstoragebox_key4_2"   );
    ObjDelete( "spr_coldstoragebox_box4"     );
    ObjDelete( "spr_coldstoragebox_overkey4" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fridgehandle4", use_fridgehandle4_beg, private.room_objname );
  cmn.AddSubscriber( "use_fridgehandle4", use_fridgehandle4_inv );
  cmn.AddSubscriber( "use_fridgehandle4", use_fridgehandle4_end, private.room_objname );
  cmn.AddSubscriber( "use_fridgehandle4_inv", use_fridgehandle4_inv, private.room_objname );
  cmn.AddSubscriber( "use_fridgehandle4_beg", use_fridgehandle4_beg, private.room_objname );
  cmn.AddSubscriber( "use_fridgehandle4_end", use_fridgehandle4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_douglasamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_douglasamulet" ] = {
    type = "use",
    inv_obj = "inv_douglasamulet",
    use_place = "obj_wheelchair_use_douglasamulet",
    room = private.room_objname,
    zz = "zz_wheelchair",
    zz_gate = "gzz_lowerlevel_wheelchair"
  };
  local use_douglasamulet_inv = function ()
  
    interface.InventoryItemRemove( "inv_douglasamulet" );
  
  end;
  local use_douglasamulet_beg = function ()
  
    ObjDelete( "obj_wheelchair_use_douglasamulet" );
  
  end;
  local use_douglasamulet_end = function ()
  
    ObjDelete( "spr_lowerlevel_mannequin_2" );

    ObjMultiSet({ 
      { "spr_wheelchair_receptionroomkey", { input = true, active = true         }},
     
      { "spr_wheelchair_head_4",           { alp = 1, pos_x = -172 , pos_y = -26 }},
      { "spr_wheelchair_head_2",           {          pos_x = -268 , pos_y = -92 }},
      { "spr_wheelchair_head_3",           {          pos_x = -162 , pos_y = -53 }},

      { "spr_lowerlevel_mannequin",        { alp = 1                             }},
      { "spr_lowerlevel_mannequin_key",    { alp = 1                             }},
    });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_douglasamulet", use_douglasamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_douglasamulet", use_douglasamulet_inv );
  cmn.AddSubscriber( "use_douglasamulet", use_douglasamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_douglasamulet_inv", use_douglasamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_douglasamulet_beg", use_douglasamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_douglasamulet_end", use_douglasamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wheelchairwheel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wheelchairwheel" ] = {
    type = "use",
    inv_obj = "inv_wheelchairwheel",
    use_place = "obj_wheelchair_use_wheelchairwheel",
    room = private.room_objname,
    zz = "zz_wheelchair",
    zz_gate = "gzz_lowerlevel_wheelchair"
  };
  local use_wheelchairwheel_inv = function ()
  
    interface.InventoryItemRemove( "inv_wheelchairwheel" );
  
  end;
  local use_wheelchairwheel_beg = function ()
  
    ObjDelete( "obj_wheelchair_use_wheelchairwheel" );
  
  end;
  local use_wheelchairwheel_end = function ()
        
    ObjDelete( "gzz_lowerlevel_wheelchair"  );
    ObjDelete( "spr_lowerlevel_mannequin_3" );
    ObjDelete( "spr_lowerlevel_mannequin"   );

    ObjDelete( "spr_coldstoragebox_wheelchairwheel_shadow" );

    ObjMultiSet({ 
      { "grm_lowerlevel_lab",        { input = true, active = true }},
      { "spr_lowerlevel_doors_open", { alp = 1                     }},
    });
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_lowerlevel_lab_focus");
    end;  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wheelchairwheel", use_wheelchairwheel_beg, private.room_objname );
  cmn.AddSubscriber( "use_wheelchairwheel", use_wheelchairwheel_inv );
  cmn.AddSubscriber( "use_wheelchairwheel", use_wheelchairwheel_end, private.room_objname );
  cmn.AddSubscriber( "use_wheelchairwheel_inv", use_wheelchairwheel_inv, private.room_objname );
  cmn.AddSubscriber( "use_wheelchairwheel_beg", use_wheelchairwheel_beg, private.room_objname );
  cmn.AddSubscriber( "use_wheelchairwheel_end", use_wheelchairwheel_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_workingflashlight_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_workingflashlight_1" ] = {
    type = "use",
    inv_obj = "inv_workingflashlight",
    use_place = "obj_darkcorner_use_workingflashlight_1",
    room = private.room_objname,
    zz = "zz_darkcorner",
    zz_gate = "gzz_lowerlevel_darkcorner"
  };
  local use_workingflashlight_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_workingflashlight" );
  
  end;
  local use_workingflashlight_1_beg = function ()
  
    ObjDelete( "obj_darkcorner_use_workingflashlight_1" );
  
  end;
  local use_workingflashlight_1_end = function ()
  
    ObjDelete( "anm_darkcorner_rat"                     );
    ObjDelete( "vid_darkcorner_rat"                     );
    ObjDelete( "spr_lowerlevel_darkcorner_light_rateye" );

    ObjMultiSet({ 
      { "spr_darkcorner_fridgehandle2",    { input = true, active = true }},
      { "spr_darkcorner_light",            { alp = 1                     }},
      { "spr_darkcorner_flashlight",       { alp = 1                     }},

      { "obj_darkcorner_use_filehandle",   { input = true, active = true }},
      { "obj_darkcorner_use_surgicalclip", { input = true, active = true }},

      { "spr_lowerlevel_file",             { alp = 1                     }},
      { "spr_lowerlevel_fridgehandle",     { alp = 1                     }},
      { "anm_lowerlevel_zz_light",         { alp = 1, active = true      }},
      { "obj_collect2_item_2_4",           { input = true                }},
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_workingflashlight_1", use_workingflashlight_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_workingflashlight_1", use_workingflashlight_1_inv );
  cmn.AddSubscriber( "use_workingflashlight_1", use_workingflashlight_1_end, private.room_objname );
  cmn.AddSubscriber( "use_workingflashlight_1_inv", use_workingflashlight_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_workingflashlight_1_beg", use_workingflashlight_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_workingflashlight_1_end", use_workingflashlight_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_surgicalclip () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_surgicalclip" ] = {
    type = "use",
    inv_obj = "inv_surgicalclip",
    use_place = "obj_darkcorner_use_surgicalclip",
    room = private.room_objname,
    zz = "zz_darkcorner",
    zz_gate = "gzz_lowerlevel_darkcorner"
  };
  local use_surgicalclip_inv = function ()
  
    interface.InventoryItemRemove( "inv_surgicalclip" );

  end;
  local use_surgicalclip_beg = function ()
  
    ObjDelete( "obj_darkcorner_use_surgicalclip" );

    ObjSet( "spr_darkcorner_masterswitch",        { alp = 0 } );
    ObjSet( "spr_darkcorner_masterswitch_shadow", { alp = 0 } );
    ObjSet( "vid_darkcorner_med_clip", { alp = 1 } );
  
  end;
  local use_surgicalclip_end = function ()
  
    ObjSet( "spr_darkcorner_masterswitch",        { pos_x = 399 , pos_y = 286, alp = 1, input = true, active = true } );
    ObjSet( "spr_darkcorner_masterswitch_shadow", { pos_x = 399 , pos_y = 286, alp = 1 } );

    ObjDelete( "vid_darkcorner_med_clip" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_surgicalclip", use_surgicalclip_beg, private.room_objname );
  cmn.AddSubscriber( "use_surgicalclip", use_surgicalclip_inv );
  cmn.AddSubscriber( "use_surgicalclip", use_surgicalclip_end, private.room_objname );
  cmn.AddSubscriber( "use_surgicalclip_inv", use_surgicalclip_inv, private.room_objname );
  cmn.AddSubscriber( "use_surgicalclip_beg", use_surgicalclip_beg, private.room_objname );
  cmn.AddSubscriber( "use_surgicalclip_end", use_surgicalclip_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_filehandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_filehandle" ] = {
    type = "use",
    inv_obj = "inv_filehandle",
    use_place = "obj_darkcorner_use_filehandle",
    room = private.room_objname,
    zz = "zz_darkcorner",
    zz_gate = "gzz_lowerlevel_darkcorner"
  };
  local use_filehandle_inv = function ()
  
    interface.InventoryItemRemove( "inv_filehandle" );
  
  end;
  local use_filehandle_beg = function ()
  
    ObjDelete( "obj_darkcorner_use_filehandle" );
  
  end;
  local use_filehandle_end = function ()
  
    ObjMultiSet({ 
      { "spr_darkcorner_file",       { input = true, active = true }},  
      { "gfx_darkcorner_file",       { active = true }},  
      { "spr_darkcorner_filehandle", { alp = 1 }},
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_filehandle", use_filehandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_filehandle", use_filehandle_inv );
  cmn.AddSubscriber( "use_filehandle", use_filehandle_end, private.room_objname );
  cmn.AddSubscriber( "use_filehandle_inv", use_filehandle_inv, private.room_objname );
  cmn.AddSubscriber( "use_filehandle_beg", use_filehandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_filehandle_end", use_filehandle_end, private.room_objname );

 --------------------------------------------------------------------------------------------
  -- function clk_fridgehandle1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_fridgehandle1" ] = {
    type = "click",
    use_place = "obj_coldstoragebox_clk_fridgehandle1",
    room = private.room_objname,
    zz = "zz_coldstoragebox",
    zz_gate = "gzz_lowerlevel_coldstoragebox"
  };

  local clk_fridgehandle1_beg = function ()

    ObjDelete( "obj_coldstoragebox_clk_fridgehandle1" );
  
  end;
  local clk_fridgehandle1_end = function ()

    ObjMultiSet({ 
      { "spr_coldstoragebox_medicine3",           { pos_x = 129, pos_y = 174    }},  
      { "spr_coldstoragebox_registrationentries", { input = true, active = true }},
    });


  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_fridgehandle1", clk_fridgehandle1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_fridgehandle1", clk_fridgehandle1_end, private.room_objname );
  cmn.AddSubscriber( "clk_fridgehandle1_beg", clk_fridgehandle1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_fridgehandle1_end", clk_fridgehandle1_end, private.room_objname );
  --------------------------------------------------------------------------------------------

  --------------------------------------------------------------------------------------------
  -- function clk_fridgehandle3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_fridgehandle3" ] = {
    type = "click",
    use_place = "obj_coldstoragebox_clk_fridgehandle3",
    room = private.room_objname,
    zz = "zz_coldstoragebox",
    zz_gate = "gzz_lowerlevel_coldstoragebox"
  };

  local clk_fridgehandle3_beg = function ()

    ObjDelete( "obj_coldstoragebox_clk_fridgehandle3" );
  
  end;
  local clk_fridgehandle3_end = function ()

    ObjMultiSet({ 
      { "spr_coldstoragebox_medicine", { pos_x = -20, pos_y = -60    }},
      { "spr_coldstoragebox_cheese",   { input = true, active = true }},  
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_fridgehandle3", clk_fridgehandle3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_fridgehandle3", clk_fridgehandle3_end, private.room_objname );
  cmn.AddSubscriber( "clk_fridgehandle3_beg", clk_fridgehandle3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_fridgehandle3_end", clk_fridgehandle3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_receptionroomkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_receptionroomkey" ] = {
    type = "click",
    use_place = "obj_receptiondesk_clk_receptionroomkey",
    room = private.room_objname,
    zz = "zz_receptiondesk",
    zz_gate = "gzz_lowerlevel_receptiondesk"
  };

  local clk_receptionroomkey_beg = function ()

    ObjDelete( "obj_receptiondesk_clk_receptionroomkey" );
    ObjDelete( "obj_receptiondesk_door" );
    ObjDelete( "spr_receptiondesk_wet" );
  
  end;
  local clk_receptionroomkey_end = function ()

    ObjDelete( "gzz_lowerlevel_receptiondesk" );

    ObjMultiSet({ 
      { "spr_lowerlevel_open_door",     { alp = 1                     }},
      { "grm_lowerlevel_receptionroom", { input = true, active = true }},
    });
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_lowerlevel_receptionroom_focus");
    end;    

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_receptionroomkey", clk_receptionroomkey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_receptionroomkey", clk_receptionroomkey_end, private.room_objname );
  cmn.AddSubscriber( "clk_receptionroomkey_beg", clk_receptionroomkey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_receptionroomkey_end", clk_receptionroomkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function see_lowerlevel_masked () end;
  --------------------------------------------------------------------------------------------
  local see_lowerlevel_masked_end = function ()



  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "see_lowerlevel_masked",     see_lowerlevel_masked_end, private.room_objname );
  cmn.AddSubscriber( "see_lowerlevel_masked_end", see_lowerlevel_masked_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function see_lowerlevel_lowerlevel () end;
  --------------------------------------------------------------------------------------------
  local see_lowerlevel_lowerlevel_end = function ()

    ObjDelete( "anm_lowerlevel_lowerlevel_1" );
    ObjSet( "obj_lowerlevel_lowerlevel_1", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "see_lowerlevel_lowerlevel",     see_lowerlevel_lowerlevel_end, private.room_objname );
  cmn.AddSubscriber( "see_lowerlevel_lowerlevel_end", see_lowerlevel_lowerlevel_end, private.room_objname );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()

    subroom.Define( "zz_receptiondesk" );
    subroom.Define( "zz_wheelchair" );

    function zz_receptiondesk.PreOpen()

    end;

    function zz_receptiondesk.Open()

    end;

    function zz_receptiondesk.PreClose()

    end;

    function zz_receptiondesk.Close()

      if cmn.IsEventDone( "get_fridgehandle1" ) and not cmn.IsEventDone( "see_lowerlevel_masked" ) then
      
        private.see_lowerlevel_masked();

      end;

    end;
    
    ----------------------------------------------------------------------------

    function zz_wheelchair.PreOpen()

      if ( cmn.IsEventDone( "use_douglasamulet" )) then

        common_impl.PlayAudio( "env", "level2/env/aud_wheelchair_env", 1, "", 0 );

      end;

    end;

    function zz_wheelchair.Open()

    end;

    function zz_wheelchair.PreClose()

      if ( cmn.IsEventDone( "use_douglasamulet" )) then

        common_impl.StopAudio( "env", "level2/env/aud_wheelchair_env", 0.2 );

      end;

    end;

    function zz_wheelchair.Close()

      if cmn.IsEventDone( "get_receptionroomkey" ) and not cmn.IsEventDone( "see_lowerlevel_lowerlevel" ) then

        private.see_lowerlevel_lowerlevel();

      end;

    end;

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_lowerlevel();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

  if cmn.IsEventDone( "get_receptionroomkey" ) and not cmn.IsEventDone( "see_lowerlevel_lowerlevel" ) then

    private.see_lowerlevel_lowerlevel();

  end;

  if cmn.IsEventDone( "get_fridgehandle1" ) and not cmn.IsEventDone( "see_lowerlevel_masked" ) then
  
    private.see_lowerlevel_masked();

  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "level2/env/aud_lowerlevel_env" }, "", 0.5 );

  common_impl.MorphItemMorphing();

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_antirust_2_2 ()

  local item = "inv_antirust_2";

  if cmn.ApplyObj( item, "gzz_lowerlevel_receptiondesk" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_receptiondesk", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_receptiondesk_use_antirust_2_2" ) ) then

    cmn.CallEventHandler( "use_antirust_2_2_inv" );
    cmn.CallEventHandler( "use_antirust_2_2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_antirust_2_2" );
      cmn.CallEventHandler( "use_antirust_2_2_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_spray2", 0, "", 0 );

    VidPlay( "vid_receptiondesk_antirust", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_receptionroomkey ()

  local item = "inv_receptionroomkey";

  if cmn.ApplyObj( item, "gzz_lowerlevel_receptiondesk" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_receptiondesk", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_receptiondesk_use_receptionroomkey" ) ) then

    cmn.CallEventHandler( "use_receptionroomkey_inv" );
    cmn.CallEventHandler( "use_receptionroomkey_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_receptionroomkey" );
      cmn.CallEventHandler( "use_receptionroomkey_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_key_in_door", 0, "", 0 );

    cmn.ItemFly( "obj_receptiondesk_door_key", func_end, 1.57 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_fridgehandle1 ()

  local item = "inv_fridgehandle1";

  if cmn.ApplyObj( item, "gzz_lowerlevel_coldstoragebox" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_coldstoragebox", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_coldstoragebox_use_fridgehandle1" ) ) then

    cmn.CallEventHandler( "use_fridgehandle1_inv" );
    cmn.CallEventHandler( "use_fridgehandle1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_fridgehandle1" );
      cmn.CallEventHandler( "use_fridgehandle1_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_key_lower_level", 0, "", 0 );

    ObjAnimate( "spr_coldstoragebox_key1", "pos_xy", 0, 0, "", 
    { 
      0,   0, 310, 184, 
      0.3, 0, 310, 184,
      0.6, 0, 267, 184, 
    } );
    ObjAnimate( "spr_coldstoragebox_key1", "alp", 0, 0, "", 
    { 
      0,   0, 0, 
      0.3, 0, 1,
      0.6, 0, 1, 
      0.9, 0, 0, 
    } );
    ObjAnimate( "spr_coldstoragebox_key1_2", "alp", 0, 0, "", 
    { 
      0,   0, 0, 
      0.3, 0, 0,
      0.6, 0, 0,
      0.9, 0, 1, 
      1.2, 0, 0, 
    } );

    ObjAnimate( "spr_coldstoragebox_box1", "alp", 0, 0, "", 
    { 
      0,   0, 1, 
      0.9, 0, 1,
      1.2, 0, 0, 
    } );
    ObjAnimate( "spr_coldstoragebox_overkey1", "alp", 0, 0, "", 
    { 
      0,   0, 1, 
      0.9, 0, 1,
      1.2, 0, 0, 
    } );
    ObjAnimate( "spr_coldstoragebox_box1_2", "alp", 0, 0, func_end, 
    { 
      0,   0, 0, 
      0.9, 0, 0,
      1.2, 0, 1, 
    } );

    --cmn.ItemFly( "spr", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_fridgehandle2 ()

  local item = "inv_fridgehandle2";

  if cmn.ApplyObj( item, "gzz_lowerlevel_coldstoragebox" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_coldstoragebox", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_coldstoragebox_use_fridgehandle2" ) ) then

    cmn.CallEventHandler( "use_fridgehandle2_inv" );
    cmn.CallEventHandler( "use_fridgehandle2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_fridgehandle2" );
      cmn.CallEventHandler( "use_fridgehandle2_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_key_lower_level", 0, "", 0 );

    ObjAnimate( "spr_coldstoragebox_key2", "pos_xy", 0, 0, "", 
    { 
      0,   0,  79, 198, 
      0.3, 0,  79, 198,
      0.6, 0, -31, 198, 
    } );
    ObjAnimate( "spr_coldstoragebox_key2", "alp", 0, 0, "", 
    { 
      0,   0, 0, 
      0.3, 0, 1,
      0.6, 0, 1, 
      0.9, 0, 0, 
    } );
    ObjAnimate( "spr_coldstoragebox_key2_2", "alp", 0, 0, "", 
    { 
      0,   0, 0, 
      0.3, 0, 0,
      0.6, 0, 0,
      0.9, 0, 1, 
      1.2, 0, 0, 
    } );

    ObjAnimate( "spr_coldstoragebox_box2", "alp", 0, 0, "", 
    { 
      0,   0, 1, 
      0.9, 0, 1,
      1.2, 0, 0, 
    } );
    ObjAnimate( "spr_coldstoragebox_overkey2", "alp", 0, 0, "", 
    { 
      0,   0, 1, 
      0.9, 0, 1,
      1.2, 0, 0, 
    } );
    ObjAnimate( "spr_coldstoragebox_box2_2", "alp", 0, 0, func_end, 
    { 
      0,   0, 0, 
      0.9, 0, 0,
      1.2, 0, 1, 
    } );

    --cmn.ItemFly( "spr", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_fridgehandle3 ()

  local item = "inv_fridgehandle3";

  if cmn.ApplyObj( item, "gzz_lowerlevel_coldstoragebox" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_coldstoragebox", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_coldstoragebox_use_fridgehandle3" ) ) then

    cmn.CallEventHandler( "use_fridgehandle3_inv" );
    cmn.CallEventHandler( "use_fridgehandle3_beg" );

    local func_vid = function ()

      local func_end = function ()

        cmn.Lock( false );

        common_impl.StopAudio( "voc", "level2/voc/aud_kevin_in_refrigerator_voc", 0.5 );
        common_impl.StopAudio( "sfx", "level2/sfx/aud_kevin_in_refrigerator", 0.5 );

        common_impl.PlayAudio( "mus", "aud_danger1_mus", 0, "", 0 );

        cmn.SetEventDone( "use_fridgehandle3" );
        cmn.CallEventHandler( "use_fridgehandle3_end" );

        common_impl.ShowBbt( "bbt_lowerlevel_use_fridgehandle3" );

      end;

      common_impl.PlayAudio( "sfx", "level2/sfx/aud_kevin_in_refrigerator", 0, "", 0 );
      common_impl.PlayAudio( "voc", "level2/voc/aud_kevin_in_refrigerator_voc", 0, "", 0 );
      cmn.PlayDialogVideo ( "vid_lowerlevel_in_refrigerator", func_end );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_key_lower_level", 0, "", 0 );

    ObjAnimate( "spr_coldstoragebox_key3", "pos_xy", 0, 0, "", 
    { 
      0,   0,  93, -78, 
      0.3, 0,  93, -78,
      0.6, 0, -28, -78, 
    } );
    ObjAnimate( "spr_coldstoragebox_key3", "alp", 0, 0, "", 
    { 
      0,   0, 0, 
      0.3, 0, 1,
      0.6, 0, 1, 
      0.9, 0, 0, 
    } );
    ObjAnimate( "spr_coldstoragebox_key3_2", "alp", 0, 0, "", 
    { 
      0,   0, 0, 
      0.3, 0, 0,
      0.6, 0, 0,
      0.9, 0, 1, 
      1.2, 0, 0, 
    } );

    ObjAnimate( "spr_coldstoragebox_box3", "alp", 0, 0, "", 
    { 
      0,   0, 1, 
      0.9, 0, 1,
      1.2, 0, 0, 
    } );
    ObjAnimate( "spr_coldstoragebox_overkey3", "alp", 0, 0, "", 
    { 
      0,   0, 1, 
      0.9, 0, 1,
      1.2, 0, 0, 
    } );
    ObjAnimate( "spr_coldstoragebox_box3_2", "alp", 0, 0, func_vid, 
    { 
      0,   0, 0, 
      0.9, 0, 0,
      1.2, 0, 1, 
    } );

    --cmn.ItemFly( "spr", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_file ()

  local item = "inv_file";

  if cmn.ApplyObj( item, "gzz_lowerlevel_coldstoragebox" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_coldstoragebox", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_coldstoragebox_use_file" ) ) then

    cmn.CallEventHandler( "use_file_inv" );
    cmn.CallEventHandler( "use_file_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_file" );
      cmn.CallEventHandler( "use_file_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_file", 0, "", 0 );

    ObjSet( "anm_coldstoragebox_pipe", { alp = 1 } );
    AnimPlay( "anm_coldstoragebox_pipe", "DoAnim", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_fridgehandle4 ()

  local item = "inv_fridgehandle4";

  if cmn.ApplyObj( item, "gzz_lowerlevel_coldstoragebox" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_coldstoragebox", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_coldstoragebox_use_fridgehandle4" ) ) then

    cmn.CallEventHandler( "use_fridgehandle4_inv" );
    cmn.CallEventHandler( "use_fridgehandle4_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_fridgehandle4" );
      cmn.CallEventHandler( "use_fridgehandle4_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_key_lower_level", 0, "", 0 );

    ObjAnimate( "spr_coldstoragebox_key4", "pos_xy", 0, 0, "", 
    { 
      0,   0, 306, -72, 
      0.3, 0, 306, -72,
      0.6, 0, 268, -72, 
    } );
    ObjAnimate( "spr_coldstoragebox_key4", "alp", 0, 0, "", 
    { 
      0,   0, 0, 
      0.3, 0, 1,
      0.6, 0, 1, 
      0.9, 0, 0, 
    } );
    ObjAnimate( "spr_coldstoragebox_key4_2", "alp", 0, 0, "", 
    { 
      0,   0, 0, 
      0.3, 0, 0,
      0.6, 0, 0,
      0.9, 0, 1, 
      1.2, 0, 0, 
    } );

    ObjAnimate( "spr_coldstoragebox_box4", "alp", 0, 0, "", 
    { 
      0,   0, 1, 
      0.9, 0, 1,
      1.2, 0, 0, 
    } );
    ObjAnimate( "spr_coldstoragebox_overkey4", "alp", 0, 0, "", 
    { 
      0,   0, 1, 
      0.9, 0, 1,
      1.2, 0, 0, 
    } );
    ObjAnimate( "spr_coldstoragebox_box4_2", "alp", 0, 0, func_end, 
    { 
      0,   0, 0, 
      0.9, 0, 0,
      1.2, 0, 1, 
    } );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_douglasamulet ()

  local item = "inv_douglasamulet";

  if cmn.ApplyObj( item, "gzz_lowerlevel_wheelchair" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wheelchair", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_wheelchair_use_douglasamulet" ) ) then

    cmn.CallEventHandler( "use_douglasamulet_inv" );
    cmn.CallEventHandler( "use_douglasamulet_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_douglasamulet" );
      cmn.CallEventHandler( "use_douglasamulet_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_eye", 0, "", 0 );
    common_impl.PlayAudio( "env", "level2/env/aud_wheelchair_env", 1, "", 0 );

    ObjAnimate( "spr_wheelchair_head_4", "alp", 0, 0, func_end, 
    { 
      0,   0, 0, 
      0.3, 0, 1,
      0.6, 0, 1, 
    } );
    ObjAnimate( "spr_wheelchair_head_4", "pos_xy", 0, 0, "", 
    { 
      0,   0, -228, -43, 
      0.3, 0, -228, -43,
      0.6, 0, -172, -26,       
    } );
    ObjAnimate( "spr_wheelchair_head_2", "pos_xy", 0, 0, "", 
    { 
      0,   0, -254, -82, 
      0.3, 0, -254, -82,
      0.6, 0, -268, -92,  
    } );
    ObjAnimate( "spr_wheelchair_head_3", "pos_xy", 0, 0, "", 
    { 
      0,   0, -218, -71, 
      0.3, 0, -218, -71,
      0.6, 0, -162, -53,   
    } );
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_wheelchairwheel ()

  local item = "inv_wheelchairwheel";

  if cmn.ApplyObj( item, "gzz_lowerlevel_wheelchair" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wheelchair", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_wheelchair_use_wheelchairwheel" ) ) then

    cmn.CallEventHandler( "use_wheelchairwheel_inv" );
    cmn.CallEventHandler( "use_wheelchairwheel_beg" );

    local func_end = function ()

      common_impl.ShowBbt( "bbt_lowerlevel_lowerlevel_hospital_bed_move" );

      cmn.SetEventDone( "use_wheelchairwheel" );
      cmn.CallEventHandler( "use_wheelchairwheel_end" );

    end;

    local func_step_2 = function ()

      cmn.Lock( false );

      common.CloseSubRoom(); 

      cmn.PlayDialogVideo( "vid_lowerlevel_hospital_bed_move", func_end );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_wheel", 0, "", 0 );

    ObjAnimate( "spr_wheelchair_head_5", "alp", 0, 0, func_step_2, 
    { 
      0,   0, 0, 
      0.3, 0, 1, 
    } );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_workingflashlight_1 ()

  local item = "inv_workingflashlight";

  if cmn.ApplyObj( item, "gzz_lowerlevel_darkcorner" ) and ( not cmn.IsEventDone( "use_workingflashlight_1" ) ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_darkcorner", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_darkcorner_use_workingflashlight_1" ) ) and ( not cmn.IsEventDone( "use_workingflashlight_1" ) ) then

    cmn.CallEventHandler( "use_workingflashlight_1_inv" );
    cmn.CallEventHandler( "use_workingflashlight_1_beg" );

    local func_end = function ()

      local func_end_2 = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_workingflashlight_1" );
        cmn.CallEventHandler( "use_workingflashlight_1_end" );

      end;

      VidPlay( "vid_darkcorner_rat", func_end_2 );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_light", 0, "", 0 );

    ObjAnimate( "anm_darkcorner_rat", "alp", 0, 0, func_end, 
    { 
      0,   0, 1, 
      0.3, 0, 0, 
    } );
    ObjAnimate( "spr_darkcorner_flashlight", "alp", 0, 0, func_end, 
    { 
      0,   0, 0, 
      0.3, 0, 1, 
    } );
    ObjAnimate( "spr_darkcorner_light", "alp", 0, 0, func_end, 
    { 
      0,   0, 0, 
      0.3, 0, 1, 
    } );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_surgicalclip ()

  local item = "inv_surgicalclip";

  if cmn.ApplyObj( item, "gzz_lowerlevel_darkcorner" ) and ( not cmn.IsEventDone( "use_surgicalclip" ) ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_darkcorner", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_darkcorner_use_surgicalclip" ) ) and ( not cmn.IsEventDone( "use_surgicalclip" ) ) then

    cmn.CallEventHandler( "use_surgicalclip_inv" );
    cmn.CallEventHandler( "use_surgicalclip_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_surgicalclip" );
      cmn.CallEventHandler( "use_surgicalclip_end" );

      private.get_masterswitch();

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_clip", 0, "", 0 );

    ObjSet( "vid_darkcorner_med_clip", { alp = 1 } );
    VidPlay( "vid_darkcorner_med_clip", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_filehandle ()

  local item = "inv_filehandle";

  if cmn.ApplyObj( item, "gzz_lowerlevel_darkcorner" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_darkcorner", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_darkcorner_use_filehandle" ) ) then

    cmn.CallEventHandler( "use_filehandle_inv" );
    cmn.CallEventHandler( "use_filehandle_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_filehandle" );
      cmn.CallEventHandler( "use_filehandle_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk4", 0, "", 0 );

    ObjAnimate( "spr_darkcorner_filehandle", "alp", 0, 0, func_end, 
    { 
      0,   0, 0, 
      0.3, 0, 1, 
    } );
  
  return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_fridgehandle1 ()

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "get_fridgehandle1" );
    cmn.CallEventHandler( "get_fridgehandle1_end" );

  end;

  common.CloseSubRoom();

  cmn.Lock( true );

  cmn.CallEventHandler( "get_fridgehandle1_beg" );

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  func_end();

end;
--------------------------------------------------------------------------------------------
function private.get_gasmask ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_gasmask" );
  cmn.CallEventHandler( "get_gasmask" );

end;
--------------------------------------------------------------------------------------------
function private.get_registrationentries ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_registrationentries" );
  cmn.CallEventHandler( "get_registrationentries" );

end;
--------------------------------------------------------------------------------------------
function private.get_wheelchairwheel ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_wheelchairwheel" );
  cmn.CallEventHandler( "get_wheelchairwheel" );

end;
--------------------------------------------------------------------------------------------
function private.get_cheese ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_cheese" );
  cmn.CallEventHandler( "get_cheese" );

end;
--------------------------------------------------------------------------------------------
function private.get_pipepiece ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_pipepiece" );
  cmn.CallEventHandler( "get_pipepiece" );

end;
--------------------------------------------------------------------------------------------
function private.get_hint ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_hint" );
  cmn.CallEventHandler( "get_hint" );

  if ( cmn.IsEventDone( "get_seal2" ) ) then

    common.CloseSubRoom(); 
  
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_receptionroomkey ()

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "get_receptionroomkey" );
    cmn.CallEventHandler( "get_receptionroomkey" );

  end;

  common.CloseSubRoom();

  cmn.Lock( true );

  cmn.CallEventHandler( "get_receptionroomkey_beg" );

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  func_end();

end;
--------------------------------------------------------------------------------------------
function private.get_fridgehandle2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_fridgehandle2" );
  cmn.CallEventHandler( "get_fridgehandle2" );

end;
--------------------------------------------------------------------------------------------
function private.get_file ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_file" );
  cmn.CallEventHandler( "get_file" );

  if ( cmn.IsGetCollect2( "get_collect2_item_2_4" ) ) then

    common.CloseSubRoom(); 

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_masterswitch ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_masterswitch" );
  cmn.CallEventHandler( "get_masterswitch" );

end;
--------------------------------------------------------------------------------------------
function private.get_seal2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_seal2" );
  cmn.CallEventHandler( "get_seal2" );

  if ( cmn.IsEventDone( "get_hint" ) ) then

    common.CloseSubRoom(); 
  
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_2_4 ()

  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_2_4" ); 

    if ( cmn.IsEventDone( "get_file" ) ) then

      common.CloseSubRoom(); 

    end;

  end;

  common_impl.PlayEffectHO( "spr_collect2_item_2_4", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_2_4" );  

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************

--------------------------------------------------------------------------------------------
function private.see_lowerlevel_masked ()

  local func_end = function ()

    common_impl.ShowBbt( "bbt_lowerlevel_see_lowerlevel_masked" );

    cmn.SetEventDone( "see_lowerlevel_masked" );
    cmn.CallEventHandler( "see_lowerlevel_masked_end" );

    common_impl.StopAudio( "sfx", "level2/sfx/aud_lowerlevel_masked_man", 0.5 );
    common_impl.StopAudio( "voc", "level2/voc/aud_lowerlevel_masked_man_voc", 0.5 );

  end;

  cmn.PlayDialogVideo ( "vid_lowerlevel_masked_man", func_end );

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_lowerlevel_masked_man", 0, "", 0 );
  common_impl.PlayAudio( "voc", "level2/voc/aud_lowerlevel_masked_man_voc", 0, "", 0 );

end;
--------------------------------------------------------------------------------------------
function private.see_lowerlevel_lowerlevel ()

  local func_end = function ()

    cmn.Lock( false );

    common_impl.ShowBbt( "bbt_lowerlevel_lowerlevel" );
    cmn.SetEventDone( "see_lowerlevel_lowerlevel" );
    cmn.CallEventHandler( "see_lowerlevel_lowerlevel_end" );

    cmn.PlayMusDanger();
    cmn.PlayMusEnv();

  end;

  cmn.Lock( true );
  cmn.StopMusEnv();

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_scare_sharp", 0, "", 0 );

  ObjAnimate( "rm_lowerlevel", "scale_xy", 0, 0, "", { 0, 0, 1, 1,   0.4, 3, 1.3, 1.3,   2.4, 0, 1.3, 1.3,   2.8, 3, 1, 1 } );
  ObjAnimate( "rm_lowerlevel", "pos_xy", 0, 0, func_end, { 0, 0, 0, 0,   0.4, 3, -266, -111,   2.4, 0, -266, -111,   2.8, 3, 0, 0 } );

  ObjSet( "anm_lowerlevel_lowerlevel_1", { active = true,  visible = true } );
  AnimPlay( "anm_lowerlevel_lowerlevel_1", "DoAnim", "" );

end;

--------------------------------------------------------------------------------------------
function private.clk_fridgehandle1 ()

  cmn.CallEventHandler( "clk_fridgehandle1_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_fridgehandle1" );
    cmn.CallEventHandler( "clk_fridgehandle1_end" );

  end;

  cmn.Lock( true );
  
  ObjAnimate( "spr_coldstoragebox_medicine3", "pos_xy", 0, 0, func_end, 
  { 
    0,   0, 154, 175, 
    0.3, 0, 129, 174,
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_fridgehandle3 ()

  cmn.CallEventHandler( "clk_fridgehandle3_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_fridgehandle3" );
    cmn.CallEventHandler( "clk_fridgehandle3_end" );

  end;

  cmn.Lock( true );
  
  ObjAnimate( "spr_coldstoragebox_medicine", "pos_xy", 0, 0, func_end, 
  { 
    0,   0, -46, -68, 
    0.3, 0, -20, -60,
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_receptionroomkey ()

  cmn.CallEventHandler( "clk_receptionroomkey_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_receptionroomkey" );
    cmn.CallEventHandler( "clk_receptionroomkey_end" );

    common.CloseSubRoom();

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_key_in_door", 0, "", 0 );

  ObjSet( "anm_receptiondesk_keyreceptionroom", { alp = 1 } );
  AnimPlay( "anm_receptiondesk_keyreceptionroom", "DoAnim", func_end )

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_lowerlevel ()

  if not ( cmn.IsEventDone( "opn_lowerlevel" ) ) then

    common_impl.ShowBbt( "bbt_lowerlevel_opn_lowerlevel" );

    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "get_into_lab" );

    cmn.SetEventDone( "opn_lowerlevel" );

  end;

  cmn.CallEventHandler( "opn_lowerlevel" ); 

end;
--*********************************************************************************************************************
function private.ClkReceptiondeskHandle ()

  common_impl.ShowBbt( 'bbt_receptiondesk_use_receptionroomkey' );

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_handle_door", 0, "", 0 );

  ObjAnimate( "spr_receptiondesk_doorhandle", "ang", 0, 0, function() cmn.Lock( false ) end, { 0, 0, 0,   0.3, 3, 0.1,   0.6, 3, 0 } );

end;
--*********************************************************************************************************************
function private.ClkDarccornerFile ()

  common_impl.ShowBbt( "bbt_darkcorner_use_filehandle" );

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

  ObjAnimate( "spr_darkcorner_file", "ang", 0, 0, function() cmn.Lock( false ) end, { 0, 0, 0,   0.3, 3, -0.1,   0.6, 3, 0 } );

end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
function private.UseFridgehandle1 ()

  local func_end = function ()

    cmn.Lock( false )
    common_impl.ShowBbt( "bbt_coldstoragebox_use_fridgehandle1" );

  end;

  cmn.Lock( true );

  local rnd = math.random( 1,3 );

      if rnd == 1 then common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk2",  0, "", 0 );
  elseif rnd == 2 then common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk3",  0, "", 0 );
  elseif rnd == 3 then common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk10", 0, "", 0 );
  end;

  ObjAnimate( "spr_coldstoragebox_box1", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 0, ObjGet( "spr_coldstoragebox_box1" ).pos_x,      ObjGet( "spr_coldstoragebox_box1" ).pos_y,  
    0.2, 0, ObjGet( "spr_coldstoragebox_box1" ).pos_x - 2,  ObjGet( "spr_coldstoragebox_box1" ).pos_y + 2, 
    0.4, 0, ObjGet( "spr_coldstoragebox_box1" ).pos_x,      ObjGet( "spr_coldstoragebox_box1" ).pos_y,   
  } );

end;
--------------------------------------------------------------------------------------------
function private.UseFridgehandle2 ()

  local func_end = function ()

    cmn.Lock( false )
    common_impl.ShowBbt( "bbt_coldstoragebox_use_fridgehandle2" );

  end;

  cmn.Lock( true );

  local rnd = math.random( 1,3 );

      if rnd == 1 then common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk2",  0, "", 0 );
  elseif rnd == 2 then common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk3",  0, "", 0 );
  elseif rnd == 3 then common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk10", 0, "", 0 );
  end;

  ObjAnimate( "spr_coldstoragebox_box2", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 0, ObjGet( "spr_coldstoragebox_box2" ).pos_x,     ObjGet( "spr_coldstoragebox_box2" ).pos_y,  
    0.2, 0, ObjGet( "spr_coldstoragebox_box2" ).pos_x + 2, ObjGet( "spr_coldstoragebox_box2" ).pos_y + 2, 
    0.4, 0, ObjGet( "spr_coldstoragebox_box2" ).pos_x,     ObjGet( "spr_coldstoragebox_box2" ).pos_y,   
  } );

end;
--------------------------------------------------------------------------------------------
function private.UseFridgehandle3 ()

  local func_end = function ()

    cmn.Lock( false )
    common_impl.ShowBbt( "bbt_coldstoragebox_use_fridgehandle3" );

  end;

  cmn.Lock( true );

  local rnd = math.random( 1,3 );

      if rnd == 1 then common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk2",  0, "", 0 );
  elseif rnd == 2 then common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk3",  0, "", 0 );
  elseif rnd == 3 then common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk10", 0, "", 0 );
  end;

  ObjAnimate( "spr_coldstoragebox_box3", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 0, ObjGet( "spr_coldstoragebox_box3" ).pos_x,     ObjGet( "spr_coldstoragebox_box3" ).pos_y,  
    0.2, 0, ObjGet( "spr_coldstoragebox_box3" ).pos_x - 2, ObjGet( "spr_coldstoragebox_box3" ).pos_y - 2, 
    0.4, 0, ObjGet( "spr_coldstoragebox_box3" ).pos_x,     ObjGet( "spr_coldstoragebox_box3" ).pos_y,   
  } );

end;
--------------------------------------------------------------------------------------------
function private.UseFridgehandle4 ()

  local func_end = function ()

    cmn.Lock( false )
    common_impl.ShowBbt( "bbt_coldstoragebox_use_fridgehandle4" );

  end;

  cmn.Lock( true );

  local rnd = math.random( 1,3 );

      if rnd == 1 then common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk2",  0, "", 0 );
  elseif rnd == 2 then common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk3",  0, "", 0 );
  elseif rnd == 3 then common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk10", 0, "", 0 );
  end;

  ObjAnimate( "spr_coldstoragebox_box4", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 0, ObjGet( "spr_coldstoragebox_box4" ).pos_x,     ObjGet( "spr_coldstoragebox_box4" ).pos_y,  
    0.2, 0, ObjGet( "spr_coldstoragebox_box4" ).pos_x + 2, ObjGet( "spr_coldstoragebox_box4" ).pos_y + 2, 
    0.4, 0, ObjGet( "spr_coldstoragebox_box4" ).pos_x,     ObjGet( "spr_coldstoragebox_box4" ).pos_y,   
  } );

end;
--*********************************************************************************************************************
function private.ClkWheelchairStretcher ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_wheelchair_use_wheelchairwheel' );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk3", 0, "", 0 );

  ObjAnimate( "obj_wheelchair_stretcher", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 0, 0,  0,  
    0.2, 0, 5, -5, 
    0.4, 0, 0,  0,   
  } );

end;
--*********************************************************************************************************************
function private.UseFile ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_coldstoragebox_use_file' );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk3", 0, "", 0 );

  ObjAnimate( "spr_coldstoragebox_pipepiece", "ang", 0, 0, func_end, 
  { 
    0.0, 0, 0,  
    0.2, 0, 0.02, 
    0.4, 0, 0,   
  } );

end;
--*********************************************************************************************************************




