-- name=rm_receptionroom
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_receptionroom";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_officedesk", "room_hub" );
  ObjAttach( "zz_ratcage", "room_hub" );
  ObjAttach( "zz_vendingmachine", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
    { "spr_officedesk_flashlight",            { event_mdown = private.get_flashlight         } },
    { "spr_officedesk_surgicalclip",          { event_mdown = private.get_surgicalclip       } },
    { "spr_ratcage_coin1",                    { event_mdown = private.get_coin1              } },
    { "spr_ratcage_accesspassword",           { event_mdown = private.get_accesspassword     } },
    { "spr_vendingmachine_bronzewhorl",       { event_mdown = private.get_bronzewhorl        } },
    { "spr_vendingmachine_switch_2",          { event_mdown = private.get_switch_2           } },

    { "obj_ratcage_clk_switch_2",             { event_mdown = private.clk_switch_2           } },
    { "obj_officedesk_clk_bronzewhorl",       { event_mdown = private.clk_bronzewhorl        } },

    { "obj_ratcage_use_cheese",               { event_mdown = private.RatcageClick           } },
    { "obj_ratcage_use_cheese_2",             { event_mdown = private.RatcageFeedbackAnim    } },
    { "obj_officedesk_use_bronzewhorl",       { event_mdown = private.OfficedeskFeedbackAnim } },
    { "obj_vendingmachine_clk_coin",          { event_mdown = private.VendingmachineClick    } },

    { "spr_collect2_item_2_5",                { event_mdown = private.get_collect2_item_2_5  } },

    { "spr_receptionroom_collect_item",       { event_mdown = function () common_impl.GetCollectItem( "get_collect_item_2_2" );     end } },
    { "spr_receptionroom_collect_morph_item", { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_2_4" ); end } },
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_receptionroom = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "gzz_receptionroom_officedesk",
      "gzz_receptionroom_ratcage",
      "gzz_receptionroom_vendingmachine",
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_ratcage",
      "zz_officedesk",
      "zz_vendingmachine"
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_receptionroom", update_game_mode_receptionroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_receptionroom = function ()

  local effects_table = 
  {
    "obj_receptionroom_anim",
    "anm_receptionroom_rat",
    "anm_vendingmachine_arrow", 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_receptionroom", update_performance_mode_receptionroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_receptionroom () end;
  --------------------------------------------------------------------------------------------
  local opn_receptionroom_map = function ()

    common_impl.VisitMapRoom( "receptionroom" );

  end;
  cmn.AddSubscriber( "opn_receptionroom", opn_receptionroom_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_flashlight () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_flashlight" ] = {
    type = "get",
    get_obj = "spr_officedesk_flashlight",
    room = private.room_objname,
    zz = "zz_officedesk",
    zz_gate = "gzz_receptionroom_officedesk"
  };
  
  local get_flashlight_inv = function ()
  
    interface.InventoryItemAdd( "inv_flashlight", "spr_officedesk_flashlight" );
    ObjSet( "inv_flashlight", { drag = false } );  

  end;
  
  local get_flashlight_closezz = function ()
  
    ObjDelete( "gfx_officedesk_flashlight" );
    ObjDelete( "spr_receptionroom_states_zz_officedesk_latern" );
  
  end;
  
  cmn.AddSubscriber( "get_flashlight", get_flashlight_inv );
  cmn.AddSubscriber( "get_flashlight", get_flashlight_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_surgicalclip () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_surgicalclip" ] = {
    type = "get",
    get_obj = "spr_officedesk_surgicalclip",
    room = private.room_objname,
    zz = "zz_officedesk",
    zz_gate = "gzz_receptionroom_officedesk"
  };
  
  local get_surgicalclip_inv = function ()
  
    interface.InventoryItemAdd( "inv_surgicalclip", "spr_officedesk_surgicalclip" );
  
  end;
  
  local get_surgicalclip_closezz = function ()
  
    ObjDelete( "gfx_officedesk_surgicalclip" );

  end;
  
  cmn.AddSubscriber( "get_surgicalclip", get_surgicalclip_inv );
  cmn.AddSubscriber( "get_surgicalclip", get_surgicalclip_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coin1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_coin1" ] = {
    type = "get",
    get_obj = "spr_ratcage_coin1",
    room = private.room_objname,
    zz = "zz_ratcage",
    zz_gate = "gzz_receptionroom_ratcage"
  };
  
  local get_coin1_inv = function ()
  
    interface.InventoryItemAdd( "inv_coin1", "spr_ratcage_coin1" );
  
  end;
  
  local get_coin1_closezz = function ()
  
    ObjDelete( "gfx_ratcage_coin1" );
    ObjDelete( "spr_receptionroom_states_zz_ratcage_coin" ); 

  end;
  
  cmn.AddSubscriber( "get_coin1", get_coin1_inv );
  cmn.AddSubscriber( "get_coin1", get_coin1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_accesspassword () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_accesspassword" ] = {
    type = "get",
    get_obj = "spr_ratcage_accesspassword",
    room = private.room_objname,
    zz = "zz_ratcage",
    zz_gate = "gzz_receptionroom_ratcage"
  };
  
  local get_accesspassword_inv = function ()
  
    interface.InventoryItemAdd( "inv_accesspassword", "spr_ratcage_accesspassword" );
  
  end;
  
  local get_accesspassword_closezz = function ()
  
    ObjDelete( "gfx_ratcage_accesspassword" );
    ObjDelete( "gzz_receptionroom_ratcage" );  

  end;
  
  cmn.AddSubscriber( "get_accesspassword", get_accesspassword_inv );
  cmn.AddSubscriber( "get_accesspassword", get_accesspassword_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bronzewhorl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bronzewhorl" ] = {
    type = "get",
    get_obj = "spr_vendingmachine_bronzewhorl",
    room = private.room_objname,
    zz = "zz_vendingmachine",
    zz_gate = "gzz_receptionroom_vendingmachine"
  };
  
  local get_bronzewhorl_inv = function ()

    interface.InventoryItemAdd( "inv_bronzewhorl", "spr_vendingmachine_bronzewhorl_2" );
  
  end;
  
  local get_bronzewhorl_closezz = function ()
  
    ObjSet( "spr_vendingmachine_bronzewhorl_2", { alp = 1, visible = true } );
    ObjDelete( "spr_vendingmachine_bronzewhorl" );
    ObjDelete( "gfx_vendingmachine_bronzewhorl" );
  
  end;
  
  cmn.AddSubscriber( "get_bronzewhorl", get_bronzewhorl_inv );
  cmn.AddSubscriber( "get_bronzewhorl_beg", get_bronzewhorl_inv );
  cmn.AddSubscriber( "get_bronzewhorl", get_bronzewhorl_closezz, private.room_objname );
  cmn.AddSubscriber( "get_bronzewhorl_end", get_bronzewhorl_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_switch_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_switch_2" ] = {
    type = "get",
    get_obj = "spr_vendingmachine_switch_2",
    room = private.room_objname,
    zz = "zz_vendingmachine",
    zz_gate = "gzz_receptionroom_vendingmachine"
  };
  
  local get_switch_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_switch_2", "spr_vendingmachine_switcher_2" );
  
  end;
  
  local get_switch_2_closezz = function ()
  
    ObjSet( "spr_vendingmachine_switcher_2", { alp = 1, visible = true } );
    ObjDelete( "spr_vendingmachine_switch_2" );
    ObjDelete( "gfx_vendingmachine_switch_2" );

    if ( cmn.IsGetCollect2( "get_collect2_item_2_5" ) ) then

      ObjDelete( "gzz_receptionroom_vendingmachine" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_switch_2", get_switch_2_inv );
  cmn.AddSubscriber( "get_switch_2", get_switch_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_2_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_2_2 = function ()
  
    ObjDelete( "obj_receptionroom_collect" );
  
  end;    
  cmn.AddSubscriber( "get_collect_item_2_2", get_collect_item_2_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_2_5 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_2_5 = function ()
  
    ObjDelete( "obj_collect2_item_2_5" );

    if ( cmn.IsEventDone( "get_switch_2" ) ) then

      ObjDelete( "gzz_receptionroom_vendingmachine" );

    end;
  
  end;    
  cmn.AddSubscriber( "get_collect2_item_2_5", get_collect2_item_2_5, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2_4 = function ()
  
    ObjDelete( "obj_receptionroom_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_2_4", get_collect_morph_item_2_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_switch_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_switch_2" ] = {
    type = "click",
    use_place = "obj_ratcage_clk_switch_2",
    room = private.room_objname,
    zz = "zz_ratcage",
    zz_gate = "gzz_receptionroom_ratcage"
  };

  local clk_switch_2_beg = function ()

    ObjDelete( "obj_ratcage_clk_switch_2" );
  
  end;
  local clk_switch_2_end = function ()

    ObjSet( "spr_ratcage_accesspassword", { input = true } );
    ObjSet( "gfx_ratcage_accesspassword", { active  = true } );
    ObjDelete( "vid_ratcage_rat_dissappear" );
    ObjDelete( "anm_ratcage_rat" );
    ObjDelete( "spr_ratcage_door" );
    ObjSet( "spr_ratcage_switch", { pos_x = 28, pos_y = 13 } );
--------------
    ObjDelete( "anm_receptionroom_rat" );
    ObjDelete( "spr_receptionroom_states_zz_ratcage_door" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_switch_2", clk_switch_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_switch_2", clk_switch_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_switch_2_beg", clk_switch_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_switch_2_end", clk_switch_2_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_bronzewhorl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_bronzewhorl" ] = {
    type = "click",
    use_place = "obj_officedesk_clk_bronzewhorl",
    room = private.room_objname,
    zz = "zz_officedesk",
    zz_gate = "gzz_receptionroom_officedesk"
  };

  local clk_bronzewhorl_beg = function ()

    ObjDelete( "obj_officedesk_clk_bronzewhorl" );
  
  end;
  local clk_bronzewhorl_end = function ()

    ObjMultiSet({ 
      { "gfx_officedesk_surgicalclip",              { active = true                          }},
      { "spr_officedesk_box_open",                  { pos_x = 65, pos_y = 158, input = true }},

      { "spr_receptionroom_officedesk_officedesk",  { alp = 1                                }},
    });

    ObjDelete( "spr_receptionroom_officedesk_officedesk2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_bronzewhorl", clk_bronzewhorl_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bronzewhorl", clk_bronzewhorl_end, private.room_objname );
  cmn.AddSubscriber( "clk_bronzewhorl_beg", clk_bronzewhorl_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bronzewhorl_end", clk_bronzewhorl_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_coin_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_coin_1" ] = {
    type = "click",
    use_place = "obj_vendingmachine_clk_coin",
    room = private.room_objname,
    zz = "zz_vendingmachine",
    zz_gate = "gzz_receptionroom_vendingmachine"
  };

  local clk_coin_1_beg = function ()
  
  end;
  local clk_coin_1_end = function ()

    ObjSet( "spr_vendingmachine_button_light", { visible = false } );
    ObjSet( "spr_vendingmachine_bronzewhorl", { pos_y = -1, input = true } );
    ObjSet( "gfx_vendingmachine_bronzewhorl", { active = true } );
    ObjSet( "obj_vendingmachine_clk_coin", { event_mdown = private.VendingmachineClick } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_coin_1", clk_coin_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_coin_1", clk_coin_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_coin_1_beg", clk_coin_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_coin_1_end", clk_coin_1_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_coin_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_coin_2" ] = {
    type = "click",
    use_place = "obj_vendingmachine_clk_coin",
    room = private.room_objname,
    zz = "zz_vendingmachine",
    zz_gate = "gzz_receptionroom_vendingmachine"
  };

  local clk_coin_2_beg = function ()
  
  end;
  local clk_coin_2_end = function ()

    ObjSet( "spr_vendingmachine_button_light", { visible = false } );
    ObjSet( "spr_vendingmachine_switch_2", { pos_y = 44, input = true } );
    ObjSet( "gfx_vendingmachine_switch_2", { active = true } );
    ObjSet( "obj_vendingmachine_clk_coin", { event_mdown = private.VendingmachineClick } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_coin_2", clk_coin_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_coin_2", clk_coin_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_coin_2_beg", clk_coin_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_coin_2_end", clk_coin_2_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function see_receptionroom_horror () end;
  --------------------------------------------------------------------------------------------
  local see_receptionroom_horror = function ()

  end;

  cmn.AddSubscriber( "see_receptionroom_horror", see_receptionroom_horror, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_bronzewhorl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bronzewhorl" ] = {
    type = "use",
    inv_obj = "inv_bronzewhorl",
    use_place = "obj_officedesk_use_bronzewhorl",
    room = private.room_objname,
    zz = "zz_officedesk",
    zz_gate = "gzz_receptionroom_officedesk"
  };
  local use_bronzewhorl_inv = function ()
  
    interface.InventoryItemRemove( "inv_bronzewhorl" );
  
  end;
  local use_bronzewhorl_beg = function ()
  
    ObjDelete( "obj_officedesk_use_bronzewhorl" );
  
  end;
  local use_bronzewhorl_end = function ()
  
    ObjMultiSet({ 
      { "obj_officedesk_clk_bronzewhorl",           { input = true            }},
      { "spr_officedesk_box_open",                  { pos_x = -2, pos_y = 112 }},
      { "spr_receptionroom_officedesk_officedesk2", { alp = 1                 }},
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bronzewhorl", use_bronzewhorl_beg, private.room_objname );
  cmn.AddSubscriber( "use_bronzewhorl", use_bronzewhorl_inv );
  cmn.AddSubscriber( "use_bronzewhorl", use_bronzewhorl_end, private.room_objname );
  cmn.AddSubscriber( "use_bronzewhorl_inv", use_bronzewhorl_inv, private.room_objname );
  cmn.AddSubscriber( "use_bronzewhorl_beg", use_bronzewhorl_beg, private.room_objname );
  cmn.AddSubscriber( "use_bronzewhorl_end", use_bronzewhorl_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cheese () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cheese" ] = {
    type = "use",
    inv_obj = "inv_cheese",
    use_place = "obj_ratcage_use_cheese",
    room = private.room_objname,
    zz = "zz_ratcage",
    zz_gate = "gzz_receptionroom_ratcage"
  };
  local use_cheese_inv = function ()
  
    interface.InventoryItemRemove( "inv_cheese" );
  
  end;
  local use_cheese_beg = function ()
  
    ObjDelete( "obj_ratcage_use_cheese" );
    ObjDelete( "obj_ratcage_use_cheese_2" );
  
  end;
  local use_cheese_end = function ()
  
    ObjDelete( "anm_ratcage_click" );
    ObjDelete( "anm_ratcage_eat" );
    ObjSet( "spr_ratcage_coin1", { alp = 1, visible = true, input = true } );
    ObjSet( "gfx_ratcage_coin1", { active  = true } );
--------------
    ObjSet( "spr_receptionroom_states_zz_ratcage_coin", { alp = 1, visible = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cheese", use_cheese_beg, private.room_objname );
  cmn.AddSubscriber( "use_cheese", use_cheese_inv );
  cmn.AddSubscriber( "use_cheese", use_cheese_end, private.room_objname );
  cmn.AddSubscriber( "use_cheese_inv", use_cheese_inv, private.room_objname );
  cmn.AddSubscriber( "use_cheese_beg", use_cheese_beg, private.room_objname );
  cmn.AddSubscriber( "use_cheese_end", use_cheese_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_switch_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_switch_2" ] = {
    type = "use",
    inv_obj = "inv_switch_2",
    use_place = "obj_ratcage_use_switch_2",
    room = private.room_objname,
    zz = "zz_ratcage",
    zz_gate = "gzz_receptionroom_ratcage"
  };
  local use_switch_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_switch_2" );
  
  end;
  local use_switch_2_beg = function ()
  
    ObjDelete( "obj_ratcage_use_switch_2" );
  
  end;
  local use_switch_2_end = function ()

    ObjSet( "spr_ratcage_switch_base", { alp = 1, visible = true } );
    ObjSet( "obj_ratcage_clk_switch_2", { input = true } );
--------------
    ObjSet( "spr_receptionroom_states_zz_ratcage_switch", { alp = 1, visible = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_switch_2", use_switch_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_switch_2", use_switch_2_inv );
  cmn.AddSubscriber( "use_switch_2", use_switch_2_end, private.room_objname );
  cmn.AddSubscriber( "use_switch_2_inv", use_switch_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_switch_2_beg", use_switch_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_switch_2_end", use_switch_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_coin1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_coin1" ] = {
    type = "use",
    inv_obj = "inv_coin1",
    use_place = "obj_vendingmachine_use_coin1",
    room = private.room_objname,
    zz = "zz_vendingmachine",
    zz_gate = "gzz_receptionroom_vendingmachine"
  };
  local use_coin1_inv = function ()
  
    interface.InventoryItemRemove( "inv_coin1" );
  
  end;
  local use_coin1_beg = function ()
  
    ObjDelete( "obj_vendingmachine_use_coin1" );
  
  end;
  local use_coin1_end = function ()
  
    ObjSet( "spr_vendingmachine_button_light", { visible = true } );
    ObjDelete( "spr_vendingmachine_coin_1" );
    ObjSet( "obj_vendingmachine_clk_coin", { event_mdown = private.clk_coin_1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_coin1", use_coin1_beg, private.room_objname );
  cmn.AddSubscriber( "use_coin1", use_coin1_inv );
  cmn.AddSubscriber( "use_coin1", use_coin1_end, private.room_objname );
  cmn.AddSubscriber( "use_coin1_inv", use_coin1_inv, private.room_objname );
  cmn.AddSubscriber( "use_coin1_beg", use_coin1_beg, private.room_objname );
  cmn.AddSubscriber( "use_coin1_end", use_coin1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_coin2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_coin2" ] = {
    type = "use",
    inv_obj = "inv_coin2",
    use_place = "obj_vendingmachine_use_coin2",
    room = private.room_objname,
    zz = "zz_vendingmachine",
    zz_gate = "gzz_receptionroom_vendingmachine"
  };
  local use_coin2_inv = function ()
  
    interface.InventoryItemRemove( "inv_coin2" );
  
  end;
  local use_coin2_beg = function ()
  
    ObjDelete( "obj_vendingmachine_use_coin2" );
  
  end;
  local use_coin2_end = function ()
  
    ObjSet( "spr_vendingmachine_button_light", { visible = true } );
    ObjDelete( "spr_vendingmachine_coin_2" );
    ObjSet( "obj_vendingmachine_clk_coin", { event_mdown = private.clk_coin_2 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_coin2", use_coin2_beg, private.room_objname );
  cmn.AddSubscriber( "use_coin2", use_coin2_inv );
  cmn.AddSubscriber( "use_coin2", use_coin2_end, private.room_objname );
  cmn.AddSubscriber( "use_coin2_inv", use_coin2_inv, private.room_objname );
  cmn.AddSubscriber( "use_coin2_beg", use_coin2_beg, private.room_objname );
  cmn.AddSubscriber( "use_coin2_end", use_coin2_end, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()

  --*********************************************************************************************************************
  -- function zz_officedesk () end зз стена со светильником
    subroom.Define( "zz_officedesk" );
    function zz_officedesk.Open ()

    end;  
    -------------------------------------------------
    function zz_officedesk.PreOpen ()

    end;  
    -------------------------------------------------
    function zz_officedesk.PreClose ()

    end; 
    ------------------------------------------------- 
    function zz_officedesk.Close ()
      
      if ( cmn.IsEventDone( "clk_bronzewhorl" ) ) then  

        cmn.NoteScaleClose( { "spr_officedesk_paper" }, { "spr_officedesk_paper_big" } );

      end;
     
    end;
 --*********************************************************************************************************************
  -- function zz_ratcage () end 
    subroom.Define( "zz_ratcage" );
    function zz_ratcage.Open ()

    end;  
    -------------------------------------------------
    function zz_ratcage.PreOpen ()

      if ( not cmn.IsEventDone( "clk_switch_2" ) ) then  

        common_impl.PlayAudio( "env", "level2/env/aud_rat_env", 1, "", 0 );

      end;
      
    end;  
    -------------------------------------------------
    function zz_ratcage.PreClose ()

      if ( not cmn.IsEventDone( "clk_switch_2" ) ) then  

        common_impl.StopAudio( "env", "level2/env/aud_rat_env", 0.2 );

      end;

    end; 
    ------------------------------------------------- 
    function zz_ratcage.Close ()

      if cmn.IsEventDone( "get_coin1" ) and 
      not cmn.IsEventDone( "see_receptionroom_horror" ) then 
        private.SeeHorror();
      end; 

    end;

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_receptionroom();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

  if ( cmn.IsEventDone( "get_coin1" ) and not cmn.IsEventDone( "see_receptionroom_horror" ) ) then 

    private.SeeHorror();

  end; 

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "level2/env/aud_receptionroom_env" }, "", 0.5 );

  common_impl.CollectItemMorphing();
  common_impl.MorphItemMorphing();

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_bronzewhorl ()

  local item = "inv_bronzewhorl";

  if cmn.ApplyObj( item, "gzz_receptionroom_officedesk" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_officedesk", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_officedesk_use_bronzewhorl" ) ) then

    cmn.CallEventHandler( "use_bronzewhorl_inv" );
    cmn.CallEventHandler( "use_bronzewhorl_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_bronzewhorl" );
      cmn.CallEventHandler( "use_bronzewhorl_end" );

    end;

    local func_end_2 = function ()

      ObjAnimate( "spr_officedesk_box_open", "pos_xy",0,0, func_end, { 0, 3, -38, 97,    0.4, 3, -2, 112 } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_figure", 0, "", 0 );

    cmn.ItemFly( "spr_officedesk_box_swirl", func_end_2, 2.09 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_cheese ()

  local item = "inv_cheese";

  if cmn.ApplyObj( item, "gzz_receptionroom_ratcage" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ratcage", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_ratcage_use_cheese" ) ) then

    cmn.CallEventHandler( "use_cheese_inv" );
    cmn.CallEventHandler( "use_cheese_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_cheese" );
      cmn.CallEventHandler( "use_cheese_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_cheese", 0, "", 0 );

  local func_end_3 = function ()

    ObjAnimate( "anm_ratcage_eat", "alp",0,0, "", { 0, 0, 1,    0.1, 0, 1,    0.3, 0, 0 } );
    ObjAnimate( "anm_ratcage_rat", "alp",0,0, func_end, { 0, 0, 0,    0.3, 0, 1 } );

    ObjSet( "spr_ratcage_coin1", { alp = 0, visible = true } );
    ObjAnimate( "spr_ratcage_coin1", "alp",0,0, "", { 0, 0, 0,    0.3, 0, 1 } );

    AnimPlay( "anm_ratcage_rat", "rat", "" );

  end;

  local func_end_2 = function ()

    AnimStop( "anm_ratcage_rat" );
    AnimPlay( "anm_ratcage_eat", "eat", func_end_3 );

  end;

  ObjAnimate( "anm_ratcage_rat", "alp",0,0, "", { 0, 0, 1,    0.1, 0, 1,    0.3, 0, 0 } );
  ObjAnimate( "anm_ratcage_eat", "alp",0,0, func_end_2, { 0, 0, 0,    0.3, 0, 1  } );
  
  return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_switch_2 ()

  local item = "inv_switch_2";

  if cmn.ApplyObj( item, "gzz_receptionroom_ratcage" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ratcage", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_ratcage_use_switch_2" ) ) then

    cmn.CallEventHandler( "use_switch_2_inv" );
    cmn.CallEventHandler( "use_switch_2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_switch_2" );
      cmn.CallEventHandler( "use_switch_2_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk9", 0, "", 0 );

  cmn.ItemFly( "spr_ratcage_switch_base", func_end );
  
  return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_coin1 ()

  local item = "inv_coin1";

  if cmn.ApplyObj( item, "gzz_receptionroom_vendingmachine" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_vendingmachine", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_vendingmachine_use_coin1" ) ) then

    cmn.CallEventHandler( "use_coin1_inv" );
    cmn.CallEventHandler( "use_coin1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_coin1" );
      cmn.CallEventHandler( "use_coin1_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_coin", 0, "", 0 );

  ObjAnimate( "spr_vendingmachine_coin_1", "pos_xy",0,0, func_end, { 0, 3, -414, 198,    0.5, 3, -239, -9,    0.8, 3, -166, -9 } );
  ObjAnimate( "spr_vendingmachine_coin_1", "scale_xy",0,0, "", { 0, 3, 1, 1,    0.5, 3, 0.45, 0.45 } );
 
  return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_coin2 ()

  local item = "inv_coin2";

  if cmn.ApplyObj( item, "gzz_receptionroom_vendingmachine" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_vendingmachine", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_vendingmachine_use_coin2" ) ) then

    cmn.CallEventHandler( "use_coin2_inv" );
    cmn.CallEventHandler( "use_coin2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_coin2" );
      cmn.CallEventHandler( "use_coin2_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_coin", 0, "", 0 );

  ObjAnimate( "spr_vendingmachine_coin_2", "pos_xy",0,0, func_end, { 0, 3, 411, 203,    0.5, 3, 267, -5,    0.8, 3, 179, -5 } );
  ObjAnimate( "spr_vendingmachine_coin_2", "scale_xy",0,0, "", { 0, 3, 1, 1,    0.5, 3, 0.45, 0.45 } );
  
  return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_flashlight ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_flashlight" );
  cmn.CallEventHandler( "get_flashlight" );

end;
--------------------------------------------------------------------------------------------
function private.get_surgicalclip ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_surgicalclip" );
  cmn.CallEventHandler( "get_surgicalclip" );

end;
--------------------------------------------------------------------------------------------
function private.get_coin1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_coin1" );
  cmn.CallEventHandler( "get_coin1" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_accesspassword ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_accesspassword" );
  cmn.CallEventHandler( "get_accesspassword" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_bronzewhorl ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_bronzewhorl" );
  cmn.CallEventHandler( "get_bronzewhorl" );

end;
--------------------------------------------------------------------------------------------
function private.get_switch_2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_switch_2" );
  cmn.CallEventHandler( "get_switch_2" );

  if ( cmn.IsGetCollect2( "get_collect2_item_2_5" ) ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_2_5 ()

  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_2_5" ); 

    if ( cmn.IsEventDone( "get_switch_2" ) ) then

      common.CloseSubRoom(); 

    end;

  end;

  common_impl.PlayEffectHO( "spr_collect2_item_2_5", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_2_5" ); 

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************

function private.clk_switch_2 ()

  cmn.CallEventHandler( "clk_switch_2_beg" );

  local func_end_2 = function ()

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_switch_2" );
      cmn.CallEventHandler( "clk_switch_2_end" );

    end;

    ObjAnimate( "anm_ratcage_rat", "alp",0,0, "", { 0, 0, 1,     0.1, 0, 1,    0.3, 0, 0 } );
    ObjAnimate( "spr_ratcage_door", "alp",0,0, "", { 0, 0, 1,     0.1, 0, 1,    0.3, 0, 0 } );

    ObjAnimate( "spr_ratcage_rat_shadow", "alp",0,0, "", 
    { 
      0.0, 0, 1,     
      0.1, 0, 1,    
      0.3, 0, 0 
    } );

    ObjSet( "vid_ratcage_rat_dissappear", { alp = 0, visible = true } );
    ObjAnimate( "vid_ratcage_rat_dissappear", "alp",0,0, "", { 0, 0, 0,    0.3, 0, 1 } );
    VidPlay( "vid_ratcage_rat_dissappear", func_end );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_jump_rat", 0, "", 0 );
  common_impl.StopAudio( "env", "level2/env/aud_rat_env", 0.2 );

  ObjAnimate( "spr_ratcage_switch", "pos_xy",0,0, func_end_2, { 0, 3, 49, 19,    0.6, 3, 28, 13 } );

end;

--------------------------------------------------------------------------------------------

function private.clk_bronzewhorl ()

  cmn.CallEventHandler( "clk_bronzewhorl_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_bronzewhorl" );
    cmn.CallEventHandler( "clk_bronzewhorl_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_drawer", 0, "", 0 );

  ObjAnimate( "spr_officedesk_box_open", "pos_xy",0,0, func_end, { 0, 3, -2, 112,    0.6, 3, 65, 158 } );

end;

--------------------------------------------------------------------------------------------

function private.clk_coin_1 ()

  cmn.CallEventHandler( "clk_coin_1_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_coin_1" );
    cmn.CallEventHandler( "clk_coin_1_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_tumbler", 0, "", 0 );

  ObjAnimate( "spr_vendingmachine_button_on", "alp",0,0, "", { 0, 0, 0,    0.1, 0, 1,    0.2, 0, 0  } );
  ObjAnimate( "spr_vendingmachine_button_off", "alp",0,0, "", { 0, 0, 1,    0.1, 0, 0,    0.2, 0, 1 } );

  ObjAnimate( "spr_vendingmachine_bronzewhorl", "pos_y",0,0, func_end, { 0, 2, -263,    0.6, 2, -1 } );

end;

--------------------------------------------------------------------------------------------

function private.clk_coin_2 ()

  cmn.CallEventHandler( "clk_coin_2_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_coin_2" );
    cmn.CallEventHandler( "clk_coin_2_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_tumbler", 0, "", 0 );

  ObjAnimate( "spr_vendingmachine_button_on", "alp",0,0, "", { 0, 0, 0,    0.1, 0, 1,    0.2, 0, 0  } );
  ObjAnimate( "spr_vendingmachine_button_off", "alp",0,0, "", { 0, 0, 1,    0.1, 0, 0,    0.2, 0, 1 } );

  ObjAnimate( "spr_vendingmachine_switch_2", "pos_y",0,0, func_end, { 0, 2, -219,    0.6, 2, 44 } );

end;

--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_receptionroom ()

  if not ( cmn.IsEventDone( "opn_receptionroom" ) ) then

    common_impl.ShowBbt( "bbt_receptionroom_opn_receptionroom" );

    cmn.SetEventDone( "opn_receptionroom" );

  end;

  cmn.CallEventHandler( "opn_receptionroom" ); 

end;
--*********************************************************************************************************************

function private.SeeHorror ()

  local func_end = function ()

    common_impl.ShowBbt( "bbt_receptionroom_see_receptionroom_horror" );

    cmn.SetEventDone( "see_receptionroom_horror" );
    cmn.CallEventHandler( "see_receptionroom_horror" );

    common_impl.StopAudio( "sfx", "level2/sfx/aud_receptionroom_horror", 0.2 );
    common_impl.StopAudio( "voc", "level2/voc/aud_receptionroom_horror_voc", 0.2 );

    cmn.PlayMusDanger();

  end;

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_receptionroom_horror", 0, "", 0 );
  common_impl.PlayAudio( "voc", "level2/voc/aud_receptionroom_horror_voc", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_receptionroom_horror", func_end );

end;

--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************

  ObjAnimate( "spr_ratcage_light",               "alp",1,0, "", { 0, 3, 0.7,  1.5, 3, 0.1,      3, 3, 0.4,      5, 3, 1,        6, 3, 0.7 } );
  ObjAnimate( "spr_vendingmachine_button_light", "alp",1,0, "", { 0, 3, 1,    0.4, 3, 0.2,    1.0, 3, 0.8,    1.5, 3, 0.3,    2.3, 3, 1   } );

--*********************************************************************************************************************
-- function *** FEEDBACK ANIMATION *** () end;
--*********************************************************************************************************************

function private.RatcageClick ()

  local func_end_2 = function ()

    cmn.Lock( false );

    ObjAnimate( "anm_ratcage_click", "alp",0,0, "", { 0, 0, 1,    0.1, 0, 1,    0.3, 0, 0 } );
    ObjAnimate( "anm_ratcage_rat",   "alp",0,0, "", { 0, 0, 0,    0.3, 0, 1               } );

    AnimPlay( "anm_ratcage_rat", "rat", "" );

  end;

  local func_end = function ()

    AnimStop( "anm_ratcage_rat" );
    AnimPlay( "anm_ratcage_click", "click", func_end_2 );

  end;

  cmn.Lock( true );
  common_impl.ShowBbt( "bbt_ratcage_use_cheese" );

  ObjAnimate( "anm_ratcage_rat", "alp",0,0, "", { 0, 0, 1,    0.1, 0, 1,    0.3, 0, 0 } );
  ObjAnimate( "anm_ratcage_click", "alp",0,0, func_end, { 0, 0, 0,    0.3, 0, 1 } );

end;

--*********************************************************************************************************************

function private.RatcageFeedbackAnim()

  common_impl.ShowBbt( "bbt_ratcage_use_cheese" );

  local obj = "spr_ratcage_door";
  local x_start = ObjGet( obj ).pos_x;
  local y_start = ObjGet( obj ).pos_y;

  local time = 0.3;
  local dx = 1;
  local dy = -1;

  ObjSet( "obj_ratcage_use_cheese_2", { input = false } );

  local func_end = function ()

    ObjSet( "obj_ratcage_use_cheese_2", { input = true } );

  end;

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

  ObjAnimate( obj, "pos_x",0,0, "",       { 0,0,x_start, time/4,0,x_start+dx, 3/4*time,0,x_start-dx, time,0,x_start } ); 
  ObjAnimate( obj, "pos_y",0,0, func_end, { 0,0,y_start, time/4,0,y_start+dy, 3/4*time,0,y_start-dy, time,0,y_start });  

end;

--*********************************************************************************************************************

function private.OfficedeskFeedbackAnim()

  common_impl.ShowBbt( "bbt_officedesk_use_bronzewhorl" );

  local obj = "spr_officedesk_box_open";
  local x_start = ObjGet( obj ).pos_x;
  local y_start = ObjGet( obj ).pos_y;

  local time = 0.3;
  local dx = 1;
  local dy = -1;

  ObjSet( "obj_officedesk_use_bronzewhorl", { input = false } );

  local func_end = function ()

    ObjSet( "obj_officedesk_use_bronzewhorl", { input = true } );

  end;

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk2", 0, "", 0 );

  ObjAnimate( obj, "pos_x",0,0, "",       { 0,0,x_start, time/4,0,x_start+dx, 3/4*time,0,x_start-dx, time,0,x_start }); 
  ObjAnimate( obj, "pos_y",0,0, func_end, { 0,0,y_start, time/4,0,y_start+dy, 3/4*time,0,y_start-dy, time,0,y_start });  

end;

--*********************************************************************************************************************

function private.VendingmachineClick()

  ObjSet( "obj_vendingmachine_clk_coin", { input = false } );

  local func_end = function ()

    ObjSet( "obj_vendingmachine_clk_coin", { input = true } );

  end;
  
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_tumbler", 0, "", 0 );

  ObjAnimate( "spr_vendingmachine_button_on",  "alp",0,0, "",       { 0, 0, 0,    0.1, 0, 1,    0.2, 0, 0 } );
  ObjAnimate( "spr_vendingmachine_button_off", "alp",0,0, func_end, { 0, 0, 1,    0.1, 0, 0,    0.2, 0, 1 } );

end;

--*********************************************************************************************************************










