-- name=ho_behindmirror
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "behindmirror" );
  game.relations[ "ho_behindmirror" ].exitroom = "rm_terenceroom";
  private.room_objname = "ho_behindmirror";
  private.cout_piece = 12;
  private.cout_items = 12;
  private.find_final_object = "str_behindmirror_final_object";
  --------------------------------------------------------------------------------------------------
   local table_multiset = {};

   table.insert( table_multiset, { "spr_behindmirror_blood",             { event_mdown = function() private.TaskComplete( "blood",              1 ) end } } );
   table.insert( table_multiset, { "spr_behindmirror_microscope",        { event_mdown = function() private.TaskComplete( "microscope",         2 ) end } } );
   table.insert( table_multiset, { "spr_behindmirror_suitcase",          { event_mdown = function() private.TaskComplete( "suitcase",           3 ) end } } );
   table.insert( table_multiset, { "spr_behindmirror_film_cassette",     { event_mdown = function() private.TaskComplete( "film_cassette",      4 ) end } } );
   table.insert( table_multiset, { "spr_behindmirror_molecule",          { event_mdown = function() private.TaskComplete( "molecule",           5 ) end } } );
   table.insert( table_multiset, { "spr_behindmirror_brain",             { event_mdown = function() private.TaskComplete( "brain",              6 ) end } } );
   table.insert( table_multiset, { "spr_behindmirror_butterfly",         { event_mdown = function() private.TaskComplete( "butterfly",          7 ) end } } );
   table.insert( table_multiset, { "spr_behindmirror_prism",             { event_mdown = function() private.TaskComplete( "prism",              8 ) end } } );
   table.insert( table_multiset, { "spr_behindmirror_respirator",        { event_mdown = function() private.TaskComplete( "respirator",         9 ) end } } );
   table.insert( table_multiset, { "spr_behindmirror_sunglasses",        { event_mdown = function() private.TaskComplete( "sunglasses",        10 ) end } } );
   table.insert( table_multiset, { "spr_behindmirror_skeleton",          { event_mdown = function() private.TaskComplete( "skeleton",          11 ) end } } );
   table.insert( table_multiset, { "spr_behindmirror_slide_photography", { event_mdown = function() private.TaskComplete( "slide_photography", 12 ) end } } );

   table.insert( table_multiset, { "spr_behindmirror_adjustmentcontrol", { event_mdown = function() private.get_adjustmentcontrol() end } } );

  for i = 1, private.cout_piece do

    table.insert( table_multiset, { "spr_behindmirror_piece_"..i, 
                                  { 
                                    event_mdown  = function () private.ClkPiece( i ) end,
                                    event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end,
                                    event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end  
                                  } } );
  end;

  private.item_list_with_piece = { "slide_photography",  "film_cassette",  "sunglasses",  "respirator",  "microscope",  "butterfly",
                                   "skeleton",           "suitcase",       "molecule",    "brain",       "blood",       "prism",
                                 };  

  ObjMultiSet( table_multiset );
  --------------------------------------------------------------------------------------------
  -- function win_behindmirror () end;
  --------------------------------------------------------------------------------------------  
  common_impl.hint[ "win_behindmirror" ] = {
      type = "win",
      room = "rm_terenceroom",
      zz = private.room_objname,
      zz_gate = "gho_terenceroom_behindmirror"
  };
  
  local win_behindmirror_inv = function ()

    if ( cmn.IsEventDone( "win_behindmirror" ) ) then

       interface.InventoryItemAdd( "inv_adjustmentcontrol", "spr_behindmirror_win" );

    end;

  end;

  local win_behindmirror_loc = function ()

    if ( cmn.IsEventDone( "win_behindmirror" ) ) then

       ObjDelete( "gho_terenceroom_behindmirror" );

    end;

  end;
  cmn.AddSubscriber( "win_behindmirror", win_behindmirror_inv );
  cmn.AddSubscriber( "win_behindmirror", win_behindmirror_loc, "rm_terenceroom" );
  --------------------------------------------------------------------------------------------------
  local start_behindmirror_func = function ()

    if ( cmn.IsEventStart( "win_behindmirror" ) ) then

      local ho_found = ng_global.progress[ "std" ][ "win_behindmirror" ].found;

      for i = 1, #ho_found, 1 do

        ObjDelete( ho_found[ i ][ "object" ] );

      end;

    end;

  end;
  cmn.AddSubscriber( "win_behindmirror", start_behindmirror_func, private.room_objname );  
end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();
  common_impl.EnvPlay( { "mus_env/aud_ho_mus_env" }, "", 0.5 );

  if ( not cmn.IsEventDone( "opn_behindmirror" ) ) then
  
    cmn.InitHo( "behindmirror" );
    cmn.SetEventDone( "opn_behindmirror" );
    ng_global.progress[ "std" ][ "win_behindmirror" ].pieces = { };
    ng_global.progress[ "std" ][ "win_behindmirror" ].puzzles = { };

    for i = 1, private.cout_piece do
  
      ng_global.progress[ "std" ][ "win_behindmirror" ].pieces[ i ] = 0;
      ng_global.progress[ "std" ][ "win_behindmirror" ].puzzles[ i ] = 0;

    end;

    ng_global.progress[ "std" ][ "win_behindmirror" ].objects_counter = private.cout_piece;
    ng_global.progress[ "std" ][ "win_behindmirror" ].puzzle_counter = private.cout_piece;
    ng_global.progress[ "std" ][ "win_behindmirror" ].item_counter = private.cout_items;
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "blood",              1, 0, { { "spr_behindmirror_blood"             } } );
  interface.TaskPanelTaskAdd( ho_items, "butterfly",          1, 0, { { "spr_behindmirror_butterfly"         } } );
  interface.TaskPanelTaskAdd( ho_items, "film_cassette",      1, 0, { { "spr_behindmirror_film_cassette"     } } );
  interface.TaskPanelTaskAdd( ho_items, "microscope",         1, 0, { { "spr_behindmirror_microscope"        } } );
  interface.TaskPanelTaskAdd( ho_items, "prism",              1, 0, { { "spr_behindmirror_prism"             } } );
  interface.TaskPanelTaskAdd( ho_items, "skeleton",           1, 0, { { "spr_behindmirror_skeleton"          } } );
  interface.TaskPanelTaskAdd( ho_items, "slide_photography",  1, 0, { { "spr_behindmirror_slide_photography" } } );
  interface.TaskPanelTaskAdd( ho_items, "suitcase",           1, 0, { { "spr_behindmirror_audiocassette"     } } );
  interface.TaskPanelTaskAdd( ho_items, "respirator",         1, 0, { { "spr_behindmirror_thermometer"       } } );
  interface.TaskPanelTaskAdd( ho_items, "sunglasses",         1, 0, { { "spr_behindmirror_sunglasses"        } } );
  interface.TaskPanelTaskAdd( ho_items, "brain",              1, 0, { { "spr_behindmirror_brain"             } } );
  interface.TaskPanelTaskAdd( ho_items, "molecule",           1, 0, { { "spr_behindmirror_molecule"          } } );

  interface.TaskPanelTaskAdd( ho_items, "piece_1",            1, 0, { { "spr_behindmirror_piece_1"  } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_2",            1, 0, { { "spr_behindmirror_piece_2"  } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_3",            1, 0, { { "spr_behindmirror_piece_3"  } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_4",            1, 0, { { "spr_behindmirror_piece_4"  } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_5",            1, 0, { { "spr_behindmirror_piece_5"  } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_6",            1, 0, { { "spr_behindmirror_piece_6"  } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_7",            1, 0, { { "spr_behindmirror_piece_7"  } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_8",            1, 0, { { "spr_behindmirror_piece_8"  } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_9",            1, 0, { { "spr_behindmirror_piece_9"  } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_10",           1, 0, { { "spr_behindmirror_piece_10" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_11",           1, 0, { { "spr_behindmirror_piece_11" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_12",           1, 0, { { "spr_behindmirror_piece_12" } } );

  interface.TaskPanelTaskAdd( ho_items, "adjustmentcontrol",  1, 0, { { "spr_behindmirror_adjustmentcontrol" } } );  
  
  interface.TaskPanelShow( ho_items );

  for i = 1, #ng_global.progress[ "std" ][ "win_behindmirror" ].pieces do

    if ( ng_global.progress[ "std" ][ "win_behindmirror" ].pieces[ i ] == 1 ) then

      ObjSet( "spr_behindmirror_piece_"..i, { input = true  } );
      --ObjSet( "gfx_behindmirror_piece_"..i, { active = true } );

    end;   

  end;

  for i = 1, #ng_global.progress[ "std" ][ "win_behindmirror" ].puzzles do

    if ( ng_global.progress[ "std" ][ "win_behindmirror" ].puzzles[ i ] == 1 ) then

      ObjDelete( "spr_behindmirror_piece_"..i );

      ObjSet( "spr_behindmirror_piece_"..i.."_button", { alp = 1 } );

    end;   

  end;
 
  if ( ng_global.progress[ "std" ][ "win_behindmirror" ].item_counter == 0 ) then

    ObjAttach( "txt_behindmirror_task", "int_taskpanel_impl");
    ObjSet( "obj_int_taskpanel", { alp = 0 } );

    if ( ng_global.progress[ "std" ][ "win_behindmirror" ].puzzle_counter == 0 ) then

      ObjMultiSet( {
        { "spr_behindmirror_adjustmentcontrol", { alp = 1, input = true                     } },
        { "txt_behindmirror_task",              { alp = 1, text = private.find_final_object } },
        { "spr_behindmirror_adjustmentcontrol_over3", { pos_x = 845, pos_y = 350 } },
        { "spr_behindmirror_adjustmentcontrol", { pos_x = 830, pos_y = 320, alp = 1 } },
      } );

    else 

      ObjSet( "txt_behindmirror_task", { alp = 1, param0 = ng_global.progress[ "std" ][ "win_behindmirror" ].puzzle_counter } );
         
    end;

  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();

--  if cmn.IsEventStart( "see_tutorial" ) then
--
--    common_impl.TutorialShow( "tutorial_page_6" );
--
--  end;

end;
--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  ObjAttach( "txt_behindmirror_task", "ho_behindmirror");
  common_impl.PassingHoStop();

end;
--*********************************************************************************************************************
function public.HoComplete ()

  common_impl.PassingHoWin();

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete ( task_name, piece_number, object )
  
  local find_obj = "spr_behindmirror_"..task_name;
  if ( object ) then

    find_obj = object;

  end;

  cmn.HoTaskFind( find_obj, task_name );
  
  ng_global.progress[ "std" ][ "win_behindmirror" ].item_counter = ng_global.progress[ "std" ][ "win_behindmirror" ].item_counter - 1;

  if ( piece_number ) then

    ObjSet( "spr_behindmirror_piece_"..piece_number, { input = true } );
    --ObjSet( "gfx_behindmirror_piece_"..piece_number, { active = true } );
    ng_global.progress[ "std" ][ "win_behindmirror" ].pieces[ piece_number ] = 1;

  end;

  if ( ng_global.progress[ "std" ][ "win_behindmirror" ].item_counter == 0 ) then

    ObjAttach( "txt_behindmirror_task", "int_taskpanel_impl");
    ObjSet( "obj_int_taskpanel",      { alp = 0 } );
    ObjSet( "txt_behindmirror_task",  { alp = 1, param0 = ng_global.progress["std"]["win_behindmirror"].puzzle_counter } );
    ObjSet( "obj_behindmirror_piece", { input = true } );
    
  end;
 
end;
--------------------------------------------------------------------------------------------
function private.ClkPiece ( id )

  local old_coords = ObjGet( "spr_behindmirror_piece_"..id );
  local new_coords = ObjGet( "spr_behindmirror_piece_"..id.."_complete" );

  ObjSet( "spr_behindmirror_piece_"..id, { pos_z = 5, input = false } );

  local func_end = function()

    ng_global.progress[ "std" ][ "win_behindmirror" ].puzzle_counter = ng_global.progress[ "std" ][ "win_behindmirror" ].puzzle_counter - 1;
    ng_global.progress[ "std" ][ "win_behindmirror" ].puzzles[ id ] = 1;
    ObjSet( "txt_behindmirror_task", { param0 = ng_global.progress[ "std" ][ "win_behindmirror" ].puzzle_counter } );

      cmn.HoTaskFind( "spr_behindmirror_piece_"..id.."_complete", "piece_"..id );
      ObjSet( "spr_behindmirror_piece_"..id.."_button", { alp = 1 } );
      ObjDelete( "spr_behindmirror_piece_"..id );

    if ( ng_global.progress[ "std" ][ "win_behindmirror" ].puzzle_counter == 0 ) then

      local func_end = function ()

        cmn.Lock( false );
        ObjSet( "spr_behindmirror_adjustmentcontrol", { alp = 1, input = true } );
        ObjSet( "txt_behindmirror_task", { text = private.find_final_object } );

      end;


      cmn.Lock( true );
      ObjAnimate( "spr_behindmirror_adjustmentcontrol_over3", "pos_xy", 0, 0, "", 
      { 
        0.0, 0, ObjGet( "spr_behindmirror_adjustmentcontrol_over3" ).pos_x, ObjGet( "spr_behindmirror_adjustmentcontrol_over3" ).pos_y,  
        0.3, 0, 845, 350, 
      }  );
      ObjAnimate( "spr_behindmirror_adjustmentcontrol", "alp", 0, 0, "", 
      { 
        0.0, 0, ObjGet( "spr_behindmirror_adjustmentcontrol" ).alp,
        0.3, 0, 1 
      }  );
      ObjAnimate( "spr_behindmirror_adjustmentcontrol", "pos_xy", 0, 0, func_end, 
      { 
        0.0, 0, ObjGet( "spr_behindmirror_adjustmentcontrol" ).pos_x, ObjGet( "spr_behindmirror_adjustmentcontrol" ).pos_y,  
        0.3, 0, 830, 320, 
      }  );

    end;
    
  end;

  common_impl.StopAudio( "sfx", "aud_hide_sfx", 0 );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_ho_clk1", 0, "", 0 );

  ObjAnimate( "spr_behindmirror_piece_"..id, "pos_xy", 0, 0, func_end, 
  { 
    0.0, 0, old_coords.pos_x, old_coords.pos_y,   
    0.5, 0, new_coords.pos_x, new_coords.pos_y 
  } );

  ObjAnimate( "spr_behindmirror_piece_"..id, "scale_xy", 0, 0, "", 
  { 
    0.0, 0, ObjGet( "spr_behindmirror_piece_"..id ).scale_x, ObjGet( "spr_behindmirror_piece_"..id ).scale_y,   
    0.5, 0, 0, 0 
  } );

  ObjAnimate( "spr_behindmirror_piece_"..id, "alp", 0, 0, "", 
  { 
    0.0, 0, 1, 
    0.3, 0, 1, 
    0.5, 0, 0 
  } );  

  ObjAnimate( "spr_behindmirror_piece_"..id.."_complete", "alp", 0, 0, "", 
  { 
    0.0, 0, 0, 
    0.3, 0, 0, 
    0.5, 0, 1 
  } );  

end;
--------------------------------------------------------------------------------------------
function private.get_adjustmentcontrol ()

  cmn.HoTaskFind( "spr_behindmirror_adjustmentcontrol", "adjustmentcontrol" );

end;
--*********************************************************************************************************************