-- name=ho_burntwall
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "burntwall" );
  game.relations[ "ho_burntwall" ].exitroom = "rm_secondfloor";
  --------------------------------------------------------------------------------------------------

  private.BANDAID_COUNT = 6;
  private.COAL_COUNT = 5;
  private.PILLS_COUNT = 6;
  private.MEDAILLON_COUNT = 1;

  --------------------------------------------------------------------------------------------------

  ObjAnimate( "spr_ho_burntwall_light_coal", "alp",1,0, "", { 0, 3, 1,    0.6, 3, 0.3,    1.5, 3, 0.8,    2.2, 3, 0.2,    3.5, 3, 1 } );

  --------------------------------------------------------------------------------------------------

  ObjMultiSet( {
  
    { "spr_ho_burntwall_band_aid_1",    { event_mdown = function() private.TaskComplete( "spr_ho_burntwall_band_aid_1", "band_aid_1" ); end } },
    { "spr_ho_burntwall_band_aid_2",    { event_mdown = function() private.TaskComplete( "spr_ho_burntwall_band_aid_2", "band_aid_2" ); end } },
    { "spr_ho_burntwall_band_aid_3",    { event_mdown = function() private.TaskComplete( "spr_ho_burntwall_band_aid_3", "band_aid_3" ); end } },
    { "spr_ho_burntwall_band_aid_4",    { event_mdown = function() private.TaskComplete( "spr_ho_burntwall_band_aid_4", "band_aid_4" ); end } },
    { "spr_ho_burntwall_band_aid_5",    { event_mdown = function() private.TaskComplete( "spr_ho_burntwall_band_aid_5", "band_aid_5" ); end } },
    { "spr_ho_burntwall_band_aid_6",    { event_mdown = function() private.TaskComplete( "spr_ho_burntwall_band_aid_6", "band_aid_6" ); end } },

    { "spr_ho_burntwall_coal_1",        { event_mdown = function() private.TaskComplete( "spr_ho_burntwall_coal_1", "coal_1" ); end } },
    { "spr_ho_burntwall_coal_2",        { event_mdown = function() private.TaskComplete( "spr_ho_burntwall_coal_2", "coal_2" ); end } },
    { "spr_ho_burntwall_coal_3",        { event_mdown = function() private.TaskComplete( "spr_ho_burntwall_coal_3", "coal_3" ); end } },
    { "spr_ho_burntwall_coal_4",        { event_mdown = function() private.TaskComplete( "spr_ho_burntwall_coal_4", "coal_4" ); end } },
    { "spr_ho_burntwall_coal_5",        { event_mdown = function() private.TaskComplete( "spr_ho_burntwall_coal_5", "coal_5" ); end } },

    { "spr_ho_burntwall_pills_1",       { event_mdown = function() private.TaskComplete( "spr_ho_burntwall_pills_1", "pills_1" ); end } },
    { "spr_ho_burntwall_pills_2",       { event_mdown = function() private.TaskComplete( "spr_ho_burntwall_pills_2", "pills_2" ); end } },
    { "spr_ho_burntwall_pills_3",       { event_mdown = function() private.TaskComplete( "spr_ho_burntwall_pills_3", "pills_3" ); end } },
    { "spr_ho_burntwall_pills_4",       { event_mdown = function() private.TaskComplete( "spr_ho_burntwall_pills_4", "pills_4" ); end } },
    { "spr_ho_burntwall_pills_5",       { event_mdown = function() private.TaskComplete( "spr_ho_burntwall_pills_5", "pills_5" ); end } },
    { "spr_ho_burntwall_pills_6",       { event_mdown = function() private.TaskComplete( "spr_ho_burntwall_pills_6", "pills_6" ); end } },

    { "spr_ho_burntwall_medallion_1",   { event_mdown = function() private.get_medallion(); end } },

  } );
  
  --------------------------------------------------------------------------------------------------

  common_impl.hint[ "win_burntwall" ] = {
      type = "win",
      room = "rm_secondfloor",
      zz = "ho_burntwall",
      zz_gate = "gho_secondfloor_burntwall"
  };
  
  local win_burntwall_func = function ()

    if ( cmn.IsEventDone( "win_burntwall" ) ) then

      interface.InventoryItemAdd( "inv_terencemedallion", "spr_burntwall_win" );
      ObjSet( "inv_terencemedallion", { drag = false } );
      ObjDelete( "gho_secondfloor_burntwall" );

    end;

  end;
  cmn.AddSubscriber( "win_burntwall", win_burntwall_func );
  --------------------------------------------------------------------------------------------------
  local start_burntwall_func = function ()

    if ( cmn.IsEventStart( "win_burntwall" ) ) then

      local ho_found = ng_global.progress[ ng_global.currentprogress ][ "win_burntwall" ].found;

      for i = 1, #ho_found, 1 do

        ObjDelete( ho_found[ i ][ "object" ] );

      end;
-------------------------------------
-------------------------------------
      private.TaskPanel(); 
-------------------------------------
-------------------------------------
      local curStageObjects = private.GettingStageTypeForUpdate();
      local countCurStageObjects = 0;

      if curStageObjects == "band_aid" then 
        countCurStageObjects = private.BANDAID_COUNT;

      elseif curStageObjects == "coal" then 
        countCurStageObjects = private.COAL_COUNT;

      elseif curStageObjects == "pills" then 
        countCurStageObjects = private.PILLS_COUNT;

      elseif curStageObjects == "medallion" then 
        countCurStageObjects = private.MEDAILLON_COUNT;

      end;

      for i = 1, countCurStageObjects, 1 do 

        local curObject = "spr_ho_burntwall_"..curStageObjects.."_"..i;
        
        if private.IsTaskObjectExist( curObject ) then  

          ObjSet( curObject, { input = true } );

        end;

      end;

    end;

  end;
  cmn.AddSubscriber( "win_burntwall", start_burntwall_func, "ho_burntwall" );  

end;


--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();
  common_impl.EnvPlay( { "mus_env/aud_ho_mus_env" }, "", 0.5 );

  ObjSet( "obj_int_taskpanel", { alp = 0, visible = false } );
  --ObjSet( "obj_int_taskpanel_ho_burntwall", { pos_x = -10, pos_y = 22 } );
  ObjAttach( "obj_int_taskpanel_ho_burntwall", "int_taskpanel_impl" );

  if ( not cmn.IsEventDone( "opn_burntwall" ) ) then
  
    cmn.InitHo( "burntwall" );
    cmn.SetEventDone( "opn_burntwall" );

    local COUNT_OBJECTS_OF_DEFAULT_STAGE = 6;
    local NAME_OBJECTS_OF_DEFAULT_STAGE = "band_aid";

    for i = 1, COUNT_OBJECTS_OF_DEFAULT_STAGE, 1 do 

      local curObject = "spr_ho_burntwall_"..NAME_OBJECTS_OF_DEFAULT_STAGE.."_"..i;
      ObjSet( curObject, { input = true } );

    end;
------------------------------------
------------------------------------
    local COLOR_R = 0.7804;
    local COLOR_G = 0.60392;
    local COLOR_B = 0.42352;

    ObjSet( "txt_ho_burntwall_taskpanel",
    {
       text   = "str_int_taskpanel_pattern_sequence",
       param0 = COLOR_R,
       param1 = COLOR_G,
       param2 = COLOR_B,
       param3 = StringGet( "str_taskpanel_sequence_ho_burntwall_1" ),
       param4 = private.BANDAID_COUNT
     } );
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "band_aid_1",     1, 0, { { "spr_ho_burntwall_band_aid_1"     } } );
  interface.TaskPanelTaskAdd( ho_items, "band_aid_2",     1, 0, { { "spr_ho_burntwall_band_aid_2"     } } );
  interface.TaskPanelTaskAdd( ho_items, "band_aid_3",     1, 0, { { "spr_ho_burntwall_band_aid_3"     } } );
  interface.TaskPanelTaskAdd( ho_items, "band_aid_4",     1, 0, { { "spr_ho_burntwall_band_aid_4"     } } );
  interface.TaskPanelTaskAdd( ho_items, "band_aid_5",     1, 0, { { "spr_ho_burntwall_band_aid_5"     } } );
  interface.TaskPanelTaskAdd( ho_items, "band_aid_6",     1, 0, { { "spr_ho_burntwall_band_aid_6"     } } );

  interface.TaskPanelTaskAdd( ho_items, "coal_1",         1, 0, { { "spr_ho_burntwall_coal_1"         } } );
  interface.TaskPanelTaskAdd( ho_items, "coal_2",         1, 0, { { "spr_ho_burntwall_coal_2"         } } );
  interface.TaskPanelTaskAdd( ho_items, "coal_3",         1, 0, { { "spr_ho_burntwall_coal_3"         } } );
  interface.TaskPanelTaskAdd( ho_items, "coal_4",         1, 0, { { "spr_ho_burntwall_coal_4"         } } );
  interface.TaskPanelTaskAdd( ho_items, "coal_5",         1, 0, { { "spr_ho_burntwall_coal_5"         } } );

  interface.TaskPanelTaskAdd( ho_items, "pills_1",        1, 0, { { "spr_ho_burntwall_pills_1"        } } );
  interface.TaskPanelTaskAdd( ho_items, "pills_2",        1, 0, { { "spr_ho_burntwall_pills_2"        } } );
  interface.TaskPanelTaskAdd( ho_items, "pills_3",        1, 0, { { "spr_ho_burntwall_pills_3"        } } );
  interface.TaskPanelTaskAdd( ho_items, "pills_4",        1, 0, { { "spr_ho_burntwall_pills_4"        } } );
  interface.TaskPanelTaskAdd( ho_items, "pills_5",        1, 0, { { "spr_ho_burntwall_pills_5"        } } );
  interface.TaskPanelTaskAdd( ho_items, "pills_6",        1, 0, { { "spr_ho_burntwall_pills_6"        } } );
  interface.TaskPanelTaskAdd( ho_items, "medallion",      1, 0, { { "spr_ho_burntwall_medallion_1"    } } );

  interface.TaskPanelShow( ho_items );

end;


--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();

end;


--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();

end;


--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  common_impl.PassingHoStop();
  ObjSet( "obj_int_taskpanel", { alp = 1, visible = true } );
  ObjDetach( "obj_int_taskpanel_ho_burntwall" );

end;


--*********************************************************************************************************************
function public.HoComplete ()

  common_impl.PassingHoWin();
  
end;


--*********************************************************************************************************************
function private.IsTaskObjectExist( taskObject )

  local result = true;
  local ho_found = ng_global.progress[ ng_global.currentprogress ][ "win_burntwall" ].found;

  for i = 1, #ho_found, 1 do

    if taskObject == ho_found[ i ][ "object" ] then 

      result = false;
      break;

    end; 

  end;

  return result; 

end;


--*********************************************************************************************************************
function private.GettingStageTypeForUpdate()

  local countFoundObjects = #ng_global.progress[ ng_global.currentprogress ][ "win_burntwall" ].found;  
  local result = "band_aid";

  if ( countFoundObjects < private.BANDAID_COUNT ) then 

    result = "band_aid";

  elseif ( countFoundObjects >= private.BANDAID_COUNT and 
  countFoundObjects < private.BANDAID_COUNT + private.COAL_COUNT ) then 

    result = "coal";

  elseif ( countFoundObjects >= private.BANDAID_COUNT + private.COAL_COUNT and 
    countFoundObjects < private.BANDAID_COUNT + private.COAL_COUNT + private.PILLS_COUNT ) then 

    result = "pills";

  elseif ( countFoundObjects >= private.BANDAID_COUNT + private.COAL_COUNT + private.PILLS_COUNT ) then 

    result = "medallion";

  end; 

  return result; 

end;


--*********************************************************************************************************************
function private.GettingStageType()

  local countFoundObjects = #ng_global.progress[ ng_global.currentprogress ][ "win_burntwall" ].found;  
  local result = nil;

  if ( countFoundObjects == private.BANDAID_COUNT ) then 

    result = "coal";

  elseif ( countFoundObjects == private.BANDAID_COUNT + private.COAL_COUNT ) then 

    result = "pills";

  elseif ( countFoundObjects == private.BANDAID_COUNT + private.COAL_COUNT + private.PILLS_COUNT ) then

    result = "medallion";

  end; 

  return result; 

end;


--*********************************************************************************************************************
function private.TaskComplete( taskObject, task )

  cmn.HoTaskFind( taskObject, task );
  private.TaskPanel();

  local nextStageObjects = private.GettingStageType();
  
  if nextStageObjects then 

    local countNextStageObjects = 0;

    if nextStageObjects == "coal" then 
      countNextStageObjects = private.COAL_COUNT;

    elseif nextStageObjects == "pills" then 
      countNextStageObjects = private.PILLS_COUNT;

    elseif nextStageObjects == "medallion" then 
      countNextStageObjects = private.MEDAILLON_COUNT;

    end;   

    for i = 1, countNextStageObjects, 1 do 

      local nextObject = "spr_ho_burntwall_"..nextStageObjects.."_"..i;
      ObjSet( nextObject, { input = true } );

    end;

  end;

end;


--*********************************************************************************************************************
function private.TaskPanel () 
 
  local count = 0;
  local tasktext = "";


  local COLOR_R = 0.7804;
  local COLOR_G = 0.60392;
  local COLOR_B = 0.42352;

  local curStage = private.GettingStageTypeForUpdate();
  local countFoundObjects = #ng_global.progress[ ng_global.currentprogress ][ "win_burntwall" ].found; 

  if ( curStage == "band_aid" ) then 

    count = private.BANDAID_COUNT - countFoundObjects;
    tasktext = "str_taskpanel_sequence_ho_burntwall_1";

  elseif ( curStage == "coal" ) then 

    count = private.COAL_COUNT - ( countFoundObjects - private.BANDAID_COUNT );
    tasktext = "str_taskpanel_sequence_ho_burntwall_2";

  elseif ( curStage == "pills" ) then 

    count = private.PILLS_COUNT - ( countFoundObjects - private.BANDAID_COUNT - private.COAL_COUNT );
    tasktext = "str_taskpanel_sequence_ho_burntwall_3";

  elseif ( curStage == "medallion" ) then 

    count = "";
    tasktext = "str_taskpanel_sequence_ho_burntwall_4";

  end;

  ObjSet( "txt_ho_burntwall_taskpanel",
  {
     text   = "str_int_taskpanel_pattern_sequence",
     param0 = COLOR_R,
     param1 = COLOR_G,
     param2 = COLOR_B,
     param3 = StringGet( tasktext ),
     param4 = count
   } );

end;


--*********************************************************************************************************************
function private.get_medallion () 

  cmn.HoTaskFind( "spr_ho_burntwall_medallion_1", "medallion" );  

end;
--*********************************************************************************************************************












