-- name=ho_engineerbox
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "engineerbox" );
  game.relations[ "ho_engineerbox" ].exitroom = "rm_powerunit";

  ObjAnimate( "spr_ho_engineerbox_light", "alp",1,0, "", { 0, 3, 0.7,    1.5, 3, 0.1,    3, 3, 0.4,    5, 3, 1,    6, 3, 0.7 } );

  private.room_objname = "ho_engineerbox";
  private.task_name = "win_engineerbox";
  private.win = 6;

  private.coordinates = { 
                            spr_ho_engineerbox_brush1_cover = { old = { pos_x = 33, pos_y = 433 }, new = { pos_x = -49, pos_y = 409 } },
                            spr_ho_engineerbox_brush2_cover = { old = { pos_x = 632, pos_y = 588 }, new = { pos_x = 638, pos_y = 639 } },
                            spr_ho_engineerbox_pliers1_cover = { old = { pos_x = 398, pos_y = 129 }, new = { pos_x = 355, pos_y = 126 } },
                            spr_ho_engineerbox_pliers2_cover = { old = { pos_x = 382, pos_y = 572 }, new = { pos_x = 310, pos_y = 553 } },
                            spr_ho_engineerbox_rope2_cover = { old = { pos_x = 577, pos_y = 299 }, new = { pos_x = 482, pos_y = 334 } },
                            spr_ho_engineerbox_screwdriver1_cover = { old = { pos_x = 94, pos_y = 166 }, new = { pos_x = 151, pos_y = 144 } },
                            spr_ho_engineerbox_screwdriver2_cover = { old = { pos_x = 540, pos_y = 463 }, new = { pos_x = 616, pos_y = 466 } },
                            spr_ho_engineerbox_tape_measure1_cover = { old = { pos_x = 310, pos_y = 255 }, new = { pos_x = 233, pos_y = 268 } },
                            spr_ho_engineerbox_tape_measure2_cover = { old = { pos_x = 846, pos_y = 317 }, new = { pos_x = 761, pos_y = 335 } },
                            spr_ho_engineerbox_vise1_cover = { old = { pos_x = 261, pos_y = 81 }, new = { pos_x = 176, pos_y = 63 } },
                            spr_ho_engineerbox_vise2_cover = { old = { pos_x = 804, pos_y = 174 }, new = { pos_x = 885, pos_y = 166 } }
                        };

  --------------------------------------------------------------------------------------------------
  
  ObjMultiSet( {

    { "spr_ho_engineerbox_brush1_cover",        { input = 1, event_mdown = function() private.TaskComplete( "spr_ho_engineerbox_brush1_cover", "brush" ) end } },
    { "spr_ho_engineerbox_brush2_cover",        { input = 1, event_mdown = function() private.TaskComplete( "spr_ho_engineerbox_brush2_cover", "brush" ) end } },
    { "spr_ho_engineerbox_pliers1_cover",       { input = 1, event_mdown = function() private.TaskComplete( "spr_ho_engineerbox_pliers1_cover", "pliers" ) end } },
    { "spr_ho_engineerbox_pliers2_cover",       { input = 1, event_mdown = function() private.TaskComplete( "spr_ho_engineerbox_pliers2_cover", "pliers" ) end } },
    { "spr_ho_engineerbox_rope1_cover",         { input = 1, event_mdown = function() private.TaskComplete( "spr_ho_engineerbox_rope1_cover", "rope" ) end } },
    { "spr_ho_engineerbox_rope2_cover",         { input = 1, event_mdown = function() private.TaskComplete( "spr_ho_engineerbox_rope2_cover", "rope" ) end } },
    { "spr_ho_engineerbox_screwdriver1_cover",  { input = 1, event_mdown = function() private.TaskComplete( "spr_ho_engineerbox_screwdriver1_cover", "screwdriver" ) end } },
    { "spr_ho_engineerbox_screwdriver2_cover",  { input = 1, event_mdown = function() private.TaskComplete( "spr_ho_engineerbox_screwdriver2_cover", "screwdriver" ) end } },
    { "spr_ho_engineerbox_tape_measure1_cover", { input = 1, event_mdown = function() private.TaskComplete( "spr_ho_engineerbox_tape_measure1_cover","tape_measure" ) end } },
    { "spr_ho_engineerbox_tape_measure2_cover", { input = 1, event_mdown = function() private.TaskComplete( "spr_ho_engineerbox_tape_measure2_cover", "tape_measure" ) end } },
    { "spr_ho_engineerbox_vise1_cover",         { input = 1, event_mdown = function() private.TaskComplete( "spr_ho_engineerbox_vise1_cover", "vise" ) end } },
    { "spr_ho_engineerbox_vise2_cover",         { input = 1, event_mdown = function() private.TaskComplete( "spr_ho_engineerbox_vise2_cover", "vise" ) end } },
    { "spr_ho_engineerbox_boltcutterpart",      { input = 0, event_mdown = function() private.TaskComplete( "spr_ho_engineerbox_boltcutterpart", "boltcutterpart" ) end } }
    
  } );
  
  common_impl.hint[ "win_engineerbox" ] = {
      type = "win",
      room = "rm_powerunit",
      zz = "ho_engineerbox",
      zz_gate = "gho_powerunit_engineerbox"
  };
  
  local win_engineerbox_func = function ()

    if ( cmn.IsEventDone( "win_engineerbox" ) ) then

      interface.InventoryItemAdd( "inv_boltcutterpart2", "spr_engineerbox_win" );
      interface.InventoryItemRemove( "inv_boltcutterpart1" );
      ObjSet( "inv_boltcutterpart2", { drag = false } );
      ObjDelete( "gho_powerunit_engineerbox" );

    end;

  end;
  cmn.AddSubscriber( "win_engineerbox", win_engineerbox_func );
  --------------------------------------------------------------------------------------------------
  local start_engineerbox_func = function ()

    if ( cmn.IsEventStart( "win_engineerbox" ) ) then

      local ho_found = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found;

      for i = 1, #ho_found, 1 do

        ObjDelete( ho_found[ i ][ "object" ] );

      end;
-------------------------------------
-------------------------------------
      local foundCouples = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples;
      local nameTaskObjects = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].name_task_objects;

      if #foundCouples > 0 then 

        local lastCouple = foundCouples[#foundCouples];
        if #lastCouple == 1 then

          local taskPanelObject = "spr_ho_engineerbox_"..lastCouple[1].."_shadow1";
          ObjAttach( taskPanelObject, "obj_int_taskpanel_ho_engineerbox" ); 
          ObjSet( taskPanelObject, { pos_x = -150, pos_y = 22 } );

          ObjSet( "txt_ho_engineerbox_taskpanel", { scale_x = 0, scale_y = 0 } );

        else 

          ObjSet( "txt_ho_engineerbox_taskpanel", { scale_x = 1, scale_y = 1 } );

        end; 

        if ( #foundCouples == private.win and #lastCouple == 2 ) then 

          ObjAttach( "spr_ho_engineerbox_boltcutterpart_shadow", "obj_int_taskpanel_ho_engineerbox" ); 
          ObjSet( "spr_ho_engineerbox_boltcutterpart_shadow", { pos_x = -5, pos_y = 22 } );
          ObjSet( "spr_ho_engineerbox_boltcutterpart", { input = true } );

        end;

      end;
-------------------------------------
-------------------------------------
      for i = 1, #foundCouples, 1 do 

        local curCoupleObject = foundCouples[i];
        local curCoupleCover = nameTaskObjects[i];

        for j = 1, #curCoupleObject, 1 do 

          local task = curCoupleObject[j];
          local taskObject = "spr_ho_engineerbox_"..task..j;

          if #curCoupleObject == 2 then
            ObjDelete( taskObject );
          end;

          local taskObjectCover = curCoupleCover[j];
          ObjSet( taskObjectCover, { input = false } );

          if taskObjectCover == "spr_ho_engineerbox_rope1_cover" then
    
            ObjSet( "spr_ho_engineerbox_rope1_cover", { alp = 1 } );
            ObjSet( "spr_ho_engineerbox_rope1_up", { alp = 1 } );
            ObjSet( "spr_ho_engineerbox_rope1_up_2", { alp = 0 } );

          else 

            local taskObjectCoverX = private.coordinates[ taskObjectCover ].new.pos_x;
            local taskObjectCoverY = private.coordinates[ taskObjectCover ].new.pos_y;

            ObjSet( taskObjectCover, { pos_x = taskObjectCoverX, pos_y = taskObjectCoverY } );

          end;

        end; 

      end;

    end;

  end;
  cmn.AddSubscriber( "win_engineerbox", start_engineerbox_func, "ho_engineerbox" );  

end;


--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();
  common_impl.EnvPlay( { "mus_env/aud_ho_mus_env" }, "", 0.5 );

  if ( not cmn.IsEventDone( "opn_engineerbox" ) ) then
  
    cmn.InitHo( "engineerbox" );
    cmn.SetEventDone( "opn_engineerbox" );
    ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples = {};
    ng_global.progress[ ng_global.currentprogress ][ private.task_name ].name_task_objects = {};

  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "brush1",          1, 0, { { "spr_ho_engineerbox_brush1_cover", "spr_ho_engineerbox_brush2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "brush2",          1, 0, { { "spr_ho_engineerbox_brush2_cover", "spr_ho_engineerbox_brush1_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "pliers1",         1, 0, { { "spr_ho_engineerbox_pliers1_cover", "spr_ho_engineerbox_pliers2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "pliers2",         1, 0, { { "spr_ho_engineerbox_pliers2_cover", "spr_ho_engineerbox_pliers1_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "rope1",           1, 0, { { "spr_ho_engineerbox_rope1_cover", "spr_ho_engineerbox_rope2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "rope2",           1, 0, { { "spr_ho_engineerbox_rope2_cover", "spr_ho_engineerbox_rope1_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "screwdriver1",    1, 0, { { "spr_ho_engineerbox_screwdriver1_cover", "spr_ho_engineerbox_screwdriver2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "screwdriver2",    1, 0, { { "spr_ho_engineerbox_screwdriver2_cover", "spr_ho_engineerbox_screwdriver1_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "tape_measure1",   1, 0, { { "spr_ho_engineerbox_tape_measure1_cover", "spr_ho_engineerbox_tape_measure2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "tape_measure2",   1, 0, { { "spr_ho_engineerbox_tape_measure2_cover", "spr_ho_engineerbox_tape_measure1_cover"  } } );
  interface.TaskPanelTaskAdd( ho_items, "vise1",           1, 0, { { "spr_ho_engineerbox_vise1_cover", "spr_ho_engineerbox_vise2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "vise2",           1, 0, { { "spr_ho_engineerbox_vise2_cover", "spr_ho_engineerbox_vise1_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "boltcutterpart",  1, 0, { { "spr_ho_engineerbox_boltcutterpart" } } );

  ObjAttach( "obj_int_taskpanel_ho_engineerbox", "int_taskpanel_impl" ); 
  private.TaskPanelUpdate(); 
  interface.TaskPanelShow( ho_items );

end;


--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();

end;


--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();

end;


--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  common_impl.PassingHoStop();
  ObjSet( "obj_int_taskpanel", { alp = 1, visible = true } );
  ObjDetach( "obj_int_taskpanel_ho_engineerbox" );

end;


--*********************************************************************************************************************
function public.HoComplete ()

  common_impl.PassingHoWin();
  
end;


--*********************************************************************************************************************
function private.TaskComplete( sender, task ) 

  local EMPTY_PROGRESS = 0;
  local ACTIVATE_WIN_OBJECT = 6;
  local NOT_COMPLETED_COUPLE = 1;
  local COMPLETED_COUPLE = 2;

  local foundCouples = {};
  foundCouples = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples;
  local countFoundCouples = #foundCouples;

  local nameTaskObjects = {};
  nameTaskObjects = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].name_task_objects;

  if countFoundCouples == EMPTY_PROGRESS then
 
    local foundTask = { task };
    table.insert( foundCouples, foundTask );

    local foundObjectTask = { sender };
    table.insert( nameTaskObjects, foundObjectTask );

    private.AnimCoveringObjects( sender, "FIRST_OBJECT_OF_COUPLE", task );
    private.TaskPanel( "NOT_COMPLETED_COUPLE", task );
    ObjSet( sender, { input = false } );

    cmn.Lock( true );
    ObjSet( "ho_engineerbox", { input = false } );

  else 

    local lastCouple = foundCouples[countFoundCouples];
    local sizeLastCouple = #lastCouple;

    if sizeLastCouple == COMPLETED_COUPLE then   

      if countFoundCouples == ACTIVATE_WIN_OBJECT then 

        local taskObjectNameWin = "spr_ho_engineerbox_"..task;
        cmn.HoTaskFind( taskObjectNameWin, task );
        private.TaskPanel( "WINNING", "boltcutterpart" );

      else 

        local foundTask = { task };
        table.insert( foundCouples, foundTask );

        local foundObjectTask = { sender };
        table.insert( nameTaskObjects, foundObjectTask );

        private.AnimCoveringObjects( sender, "FIRST_OBJECT_OF_COUPLE", task );
        private.TaskPanel( "NOT_COMPLETED_COUPLE", task );
        ObjSet( sender, { input = false } );

        cmn.Lock( true );
        ObjSet( "ho_engineerbox", { input = false } );

      end;

    elseif sizeLastCouple == NOT_COMPLETED_COUPLE then  

      local firstObject = lastCouple[1];
      local lastObjectTask = nameTaskObjects[#nameTaskObjects];
      local prevSender = lastObjectTask[1];

      if firstObject == task then 

        table.insert( lastCouple, task );
        table.insert( lastObjectTask, sender );

        local taskObjectName_1 = "spr_ho_engineerbox_"..task.."1";
        local task_1 = task.."1";
        cmn.HoTaskFind( taskObjectName_1, task_1 );
        common_impl.StopAudio( "sfx", "aud_hide_sfx", 0 );

        local taskObjectName_2 = "spr_ho_engineerbox_"..task.."2";
        local task_2 = task.."2";
        cmn.HoTaskFind( taskObjectName_2, task_2 );

        private.AnimCoveringObjects( sender, "SECOND_OBJECT_OF_RIGHT_COUPLE", task );
        private.TaskPanel( "RIGHT_COMPLETED_COUPLE", task );
        ObjSet( sender, { input = false } );

        cmn.Lock( true );
        ObjSet( "ho_engineerbox", { input = false } );

        if countFoundCouples == ACTIVATE_WIN_OBJECT then 

          ObjSet( "spr_ho_engineerbox_boltcutterpart", { input = true } );

          local func_end_win = function () 
            private.TaskPanel( "ACTIVATE_WIN_OBJECT", "boltcutterpart" );
          end;

          ObjAnimate( "obj_ho_engineerbox_items", "alp",0,0, func_end_win, { 0, 0, 1,    0.7, 0, 1 } );

        end;

      else 

        table.remove ( foundCouples );
        table.remove ( nameTaskObjects );

        private.AnimCoveringObjects( sender, "SECOND_OBJECT_OF_WRONG_COUPLE", task, prevSender );
        private.TaskPanel( "WRONG_COMPLETED_COUPLE", firstObject );
        ObjSet( prevSender, { input = true } );

        cmn.Lock( true );
        ObjSet( "ho_engineerbox", { input = false } );

      end;

    end;

  end;

  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples = foundCouples;
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].name_task_objects = nameTaskObjects;

end;


--*********************************************************************************************************************
function private.GettingMoveType( taskObject ) 

  local result = "MOVE_XY";
  
  if taskObject == "spr_ho_engineerbox_rope1_cover" then

    result = "MOVE_ALPHA";

  end;

  return result;

end;


--*********************************************************************************************************************
function private.MoveCoveringObjects( taskObject, moveType, direction ) 

  if moveType == "MOVE_XY" then 

    local oldX = private.coordinates[ taskObject ].old.pos_x;
    local oldY = private.coordinates[ taskObject ].old.pos_y;

    local newX = private.coordinates[ taskObject ].new.pos_x;
    local newY = private.coordinates[ taskObject ].new.pos_y;

    local beginX = 0;
    local beginY = 0;

    local endX = 0;
    local endY = 0;

    if direction == "OLD_TO_NEW" then 

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide2", 0, "", 0 );

      beginX = oldX;
      beginY = oldY;

      endX = newX;
      endY = newY;

    elseif direction == "NEW_TO_OLD" then 

      common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

      beginX = newX;
      beginY = newY;

      endX = oldX;
      endY = oldY;


    end;

    --ObjAnimate( taskObject, "pos_xy",0,0, func_end, { 0, 3, beginX, beginY,    0.4, 3, endX, endY } );
    ObjAnimate( taskObject, "pos_xy",0,0, "", { 0, 3, beginX, beginY,    0.4, 3, endX, endY } );

  elseif moveType == "MOVE_ALPHA" then

    local beginState = 0;
    local endState = 0;

    if direction == "OLD_TO_NEW" then 

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_paper", 0, "", 0 );

      beginState = 0;
      endState = 1;

    elseif direction == "NEW_TO_OLD" then 

      beginState = 1;
      endState = 0;

    end;

    ObjAnimate( "spr_ho_engineerbox_rope1_cover", "alp",0,0, "", { 0, 3, beginState,    0.4, 3, endState } );
    ObjAnimate( "spr_ho_engineerbox_rope1_up", "alp",0,0, "", { 0, 3, beginState,    0.4, 3, endState } );
    ObjAnimate( "spr_ho_engineerbox_rope1_up_2", "alp",0,0, "", { 0, 3, endState,    0.4, 3, beginState } );

  end;
  
end;


--*********************************************************************************************************************
function private.AnimCoveringObjects( sender, animType, task, prevSender ) 

  local func_end_block = function () 

    cmn.Lock( false );
    ObjSet( "ho_engineerbox", { input = true } );

  end;

  if animType == "FIRST_OBJECT_OF_COUPLE" then 

    private.MoveCoveringObjects( sender, private.GettingMoveType( sender ), "OLD_TO_NEW" );
    ObjAnimate( "obj_ho_engineerbox_covers", "scale_x",0,0, func_end_block, { 0, 0, 1,    0.5, 0, 1 } );

  elseif animType == "SECOND_OBJECT_OF_RIGHT_COUPLE" then 

    private.MoveCoveringObjects( sender, private.GettingMoveType( sender ), "OLD_TO_NEW" );
    ObjAnimate( "obj_ho_engineerbox_covers", "scale_x",0,0, func_end_block, { 0, 0, 1,    0.5, 0, 1 } );

  elseif animType == "SECOND_OBJECT_OF_WRONG_COUPLE" then 

    local func_end = function () 

      if prevSender then 
        private.MoveCoveringObjects( prevSender, private.GettingMoveType( prevSender ), "NEW_TO_OLD" );
        private.MoveCoveringObjects( sender, private.GettingMoveType( sender ), "NEW_TO_OLD" ); 
      end;

    end;

    private.MoveCoveringObjects( sender, private.GettingMoveType( sender ), "OLD_TO_NEW" );
    ObjAnimate( "obj_ho_engineerbox_covers", "alp",0,0, func_end, { 0, 0, 1,    0.4, 0, 1 } );
    ObjAnimate( "obj_ho_engineerbox_covers", "scale_x",0,0, func_end_block, { 0, 0, 1,    1.0, 0, 1 } );

  end; 

end;


--*********************************************************************************************************************
function private.TaskPanelUpdate() 

  ObjSet( "obj_int_taskpanel", { alp = 0, visible = false } );

  ObjSet( "txt_ho_engineerbox_taskpanel", { pos_x = -10, pos_y = 22 } );
  ObjAttach( "txt_ho_engineerbox_taskpanel", "obj_int_taskpanel_ho_engineerbox" );

  foundCouples = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples;
  local count = 6 - #foundCouples;

  local COLOR_R = 0.7804;
  local COLOR_G = 0.60392;
  local COLOR_B = 0.42352;

  ObjSet( "txt_ho_engineerbox_taskpanel",
  {
     text   = "str_int_taskpanel_pattern_couples",
     param0 = COLOR_R,
     param1 = COLOR_G,
     param2 = COLOR_B,
     param3 = StringGet( "str_taskpanel_couple_ho" ),
     param4 = count
   } );

  if count == 0 then 
  
    ObjSet( "txt_ho_engineerbox_taskpanel", { alp = 0 } );

  end;

end;


--*********************************************************************************************************************
function private.TaskPanel( animType, curTask ) 

  local OBJECT_Y = 22;
  local OBJECT_LEFT_X = -150;
  local OBJECT_MIDDLE_X = -5;
  local OBJECT_RIGHT_X = 145;

  if animType == "NOT_COMPLETED_COUPLE" then 

    local taskPanelObject = "spr_ho_engineerbox_"..curTask.."_shadow1";
    ObjAttach( taskPanelObject, "obj_int_taskpanel_ho_engineerbox" ); 

    ObjSet( taskPanelObject, { pos_x = OBJECT_LEFT_X, pos_y = OBJECT_Y } );
    ObjAnimate( taskPanelObject, "alp",0,0, "", { 0, 3, 0,    0.3, 3, 1 } );

    ObjAnimate( "txt_ho_engineerbox_taskpanel", "scale_xy",0,0, "", { 0, 3, 1, 1,    0.3, 3, 0, 0 } );

  elseif animType == "RIGHT_COMPLETED_COUPLE" then 

    local taskPanelObject_1 = "spr_ho_engineerbox_"..curTask.."_shadow1";
    local taskPanelObject_2 = "spr_ho_engineerbox_"..curTask.."_shadow2";
    ObjAttach( taskPanelObject_2, "obj_int_taskpanel_ho_engineerbox" ); 

    local func_end = function () 

      ObjAnimate( taskPanelObject_1, "alp",0,0, "", { 0, 3, 1,    0.3, 3, 0 } );
      ObjAnimate( taskPanelObject_2, "alp",0,0, "", { 0, 3, 1,    0.3, 3, 0 } );
------------------------------
------------------------------
      local fxTaskPanelObject = "fx_spr_ho_engineerbox_"..curTask;
      local pos = GetObjPosByObj( taskPanelObject_1, "obj_int_taskpanel_ho_engineerbox" );
      ObjCreate( fxTaskPanelObject, "partsys" );
      ObjSet( fxTaskPanelObject,
      {
        res = "assets/interface/resources/ho_collect_effect",
        blendmode = 2, color_r = 0.8, color_g = 0.4, color_b = 1, 
        alp = 1, visible = 1, pos_x = pos[1], pos_y = pos[2], pos_z = 1, input = 0
      } );

      local func_end_fx = function () 
        ObjDelete( fxTaskPanelObject );
      end;

      ObjAttach( fxTaskPanelObject, "obj_int_taskpanel_ho_engineerbox" );
      ObjAnimate( fxTaskPanelObject, "alp", 0, 0, func_end_fx, { 0, 0, 1,    0.4, 0, 1,    0.7, 0, 0 } );
------------------------------
------------------------------
      private.TaskPanelUpdate();
      ObjAnimate( "txt_ho_engineerbox_taskpanel", "scale_xy",0,0, "", { 0, 3, 0, 0,    0.3, 3, 1, 1 } );

    end;

    ObjSet( taskPanelObject_2, { pos_x = OBJECT_RIGHT_X, pos_y = OBJECT_Y } );
    ObjAnimate( taskPanelObject_2, "alp",0,0, "", { 0, 3, 0,    0.3, 3, 1 } );

    ObjAnimate( taskPanelObject_1, "pos_x",0,0, "", { 0, 3, OBJECT_LEFT_X,    0.3, 3, OBJECT_LEFT_X,    0.7, 3, OBJECT_MIDDLE_X } );
    ObjAnimate( taskPanelObject_2, "pos_x",0,0, func_end, { 0, 3, OBJECT_RIGHT_X,    0.3, 3, OBJECT_RIGHT_X,    0.7, 3, OBJECT_MIDDLE_X } );   

  elseif animType == "WRONG_COMPLETED_COUPLE" then 

    local taskPanelObject = "spr_ho_engineerbox_"..curTask.."_shadow1";

    local func_end = function () 

      ObjDetach( taskPanelObject );

    end;

    ObjAnimate( taskPanelObject, "alp",0,0, func_end, { 0, 3, 1,    0.3, 3, 0 } );

    private.TaskPanelUpdate();
    ObjAnimate( "txt_ho_engineerbox_taskpanel", "scale_xy",0,0, "", { 0, 3, 0, 0,    0.3, 3, 1, 1 } );

  elseif animType == "ACTIVATE_WIN_OBJECT" then 

    local taskPanelObject = "spr_ho_engineerbox_"..curTask.."_shadow";
    ObjAttach( taskPanelObject, "obj_int_taskpanel_ho_engineerbox" ); 

    ObjSet( taskPanelObject, { pos_x = OBJECT_MIDDLE_X, pos_y = OBJECT_Y } );
    ObjAnimate( taskPanelObject, "alp",0,0, "", { 0, 3, 0,    0.3, 3, 1 } );

  elseif animType == "WINNING" then 

    local taskPanelObject = "spr_ho_engineerbox_"..curTask.."_shadow";
    ObjAnimate( taskPanelObject, "alp",0,0, "", { 0, 3, 1,    0.3, 3, 0 } );

  end;

end;


















