-- name=level3

function public.Start ( param )

  interface.WidgetAdd( InterfaceWidget_Pause, 10000000 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 20 );

  if IsCollectorsEdition() then

    interface.WidgetAdd( InterfaceWidget_BtnGuide, 20 );

  end;

  interface.WidgetAdd( InterfaceWidget_BtnHint, 11  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 12 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 27 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 27 );

  --interface.WidgetAdd( InterfaceWidget_TaskHeader );
  interface.WidgetAdd( InterfaceWidget_Inventory, 9 );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 10 );

  interface.WidgetAdd( InterfaceWidget_Effects, 11 );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 11 );

  interface.WidgetAdd( InterfaceWidget_DialogHo, 19 );

  interface.ButtonLockAdd();
  interface.LockAdd();

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8);

  interface.WidgetAdd( InterfaceWidget_ItemPanel );
  interface.WidgetAdd( InterfaceWidget_Popup, 27 );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog, 26 );

  interface.WidgetAdd( InterfaceWidget_DialogVideo, 26 );
  interface.WidgetAdd( InterfaceWidget_DialogStory );
  interface.WidgetAdd( InterfaceWidget_DialogCharacter, 8 );

  interface.WidgetAdd( InterfaceWidget_StrategyGuide, 28 );
  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial );

  interface.WidgetAdd( InterfaceWidget_Map, 26  );

  interface.PanelNotificationAdd();
  interface.DeployInvAdd( 9 );
  interface.DialogHintAdd();
  interface.ButtonTaskAdd( 1 );
  interface.DialogTaskAdd( 20 );  
  interface.DiaryAdd( 28 );
  
  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    interface.BtnCollectibles2Add( 18 );
    interface.BtnCollectiblesAdd( 18 );
    interface.AchievementsAdd( 18 );
    interface.BtnMorphAdd( 18 );

  end;

  private.Init();
  ModLoad( "assets/levels/level3/mod_level3_inv" );
  level3_inv.Init();

  common.LevelLoad( "level3", "std", "rm_archives_3", param, private.menu_moduls );
  common_impl.Collectibles2Load();

  --private.TutorialSetParams();
  interface.KeyUpdate();

  cmn.PlayMusEnv();

end;
    
function private.Init ()

  game = {};
  game.room_names =
  {
  "rm_archives_3"
  ,"rm_ventilationshaft"
  ,"mg_minelabyrinth"
  ,"rm_powerunit"
  ,"ho_engineerbox"
  ,"rm_terenceroom"
  ,"rm_secondfloor"
  ,"mg_transformer"
  ,"ho_behindmirror"
  ,"rm_examroom"
  ,"ho_burntwall"
  ,"rm_tortureroom"
  ,"rm_credits"
  };

  game.progress_names_room =
  {

    -- rm_archives_3
   { "beg_level3" } 
  ,{ "see_intro_3" } 
  ,{ "opn_archives_3" } 

  ,{ "use_mapsheet",                        "opn_archives_3",            { "opn_archives_3" } }
  ,{ "opn_minelabyrinth" }
  ,{ "win_minelabyrinth"}  --            "rm_archives_3",             { "opn_archives_3 "} }

    -- rm_ventilationshaft
  ,{ "opn_ventilationshaft" } 
  ,{ "get_horizontaljack",                  "rm_ventilationshaft",       { "opn_ventilationshaft" }  }
  ,{ "use_horizontaljack",                  "rm_ventilationshaft",       { "get_horizontaljack" }  }
  ,{ "get_boltcutterpart1",                 "rm_ventilationshaft",       { "use_horizontaljack" }  }
  ,{ "get_emergencybutton",                 "rm_ventilationshaft",       { "use_horizontaljack" }  }
  ,{ "use_emergencybutton",                 "rm_ventilationshaft",       { "get_emergencybutton" }  }
  ,{ "clk_emergencydoor",                   "rm_ventilationshaft",       { "use_emergencybutton" }  }
  ,{ "get_symbolset",                       "rm_ventilationshaft",       { "clk_emergencydoor" }  }
  ,{ "get_code1",                           "rm_ventilationshaft",       { "clk_emergencydoor" }  }
  ,{ "see_ventilationshaft_mine"  }
  ,{ "use_symbolset",                       "rm_ventilationshaft",       { "get_symbolset" }  }
  ,{ "win_keypad",                          "rm_ventilationshaft",       { "use_symbolset" }  }
  ,{ "get_sliderule",                       "rm_ventilationshaft",       { "win_keypad" }  }
  ,{ "use_sliderule",                       "rm_ventilationshaft",       { "get_sliderule" }  }
  ,{ "get_copperlogo",                      "rm_ventilationshaft",       { "use_sliderule" }  }
  ,{ "use_copperlogo",                      "rm_ventilationshaft",       { "get_copperlogo" }  }
  ,{ "get_cable",                           "rm_ventilationshaft",       { "use_copperlogo" }  }
  ,{ "clk_block_door",                      "rm_ventilationshaft",       { "opn_ventilationshaft" } }
  ,{ "use_cable",                           "rm_ventilationshaft",       { "clk_block_door", "get_cable" }  }


    -- rm_powerunit
  ,{ "opn_powerunit" } 
  ,{ "opn_zz_grid",                         "rm_powerunit",              { "opn_powerunit" } }
  ,{ "clk_grid_cover",                      "rm_powerunit",              { "opn_zz_grid" }  }
  ,{ "get_spinner",                         "rm_powerunit",              { "clk_grid_cover" }  }
  ,{ "use_spinner",                         "rm_powerunit",              { "get_spinner" }  }
  ,{ "clk_spinner",                         "rm_powerunit",              { "use_spinner" }  }
  ,{ "get_key",                             "rm_powerunit",              { "clk_spinner" }  }
  ,{ "use_key",                             "rm_ventilationshaft",       { "get_key" }  }
  ,{ "get_wirereel",                        "rm_ventilationshaft",       { "use_key" }  }
  ,{ "clk_wire_1",              }
  ,{ "clk_wire_2",              }
  ,{ "clk_wire_3",              }
  ,{ "get_wirepiece",           }
  ,{ "use_wirepiece",                       "rm_ventilationshaft",       { "get_wirepiece" }  }
  ,{ "get_pliers",                          "rm_ventilationshaft",       { "use_wirepiece" }  }
  ,{ "see_scare_powerunit_mannequin",       "rm_powerunit",              { "get_pliers" }  }
  ,{ "clk_scare_powerunit_mannequin",       "rm_powerunit",              { "see_scare_powerunit_mannequin" }  }
  ,{ "use_pliers",                          "rm_powerunit",              { "get_pliers" }  }
  ,{ "get_nozzle",                          "rm_powerunit",              { "use_pliers" }  }
  ,{ "use_nozzle",                          "rm_powerunit",              { "get_nozzle" }  }
  ,{ "get_flatmetalware",                   "rm_powerunit",              { "use_nozzle" }  }
  ,{ "get_pump",                            "rm_powerunit",              { "opn_powerunit" }  }
  ,{ "use_flatmetalware",                   "rm_powerunit",              { "get_flatmetalware" }  }
  ,{ "clk_flatmetalware_1",                 "rm_powerunit",              { "use_flatmetalware" }  }
  ,{ "clk_flatmetalware_2",                 "rm_powerunit",              { "clk_flatmetalware_1" }  }
  ,{ "get_phonedial",                       "rm_powerunit",              { "clk_flatmetalware_2" }  }
  ,{ "use_phonedial",                       "rm_powerunit",              { "get_phonedial" }  }
  ,{ "get_spring_lvl3",                     "rm_powerunit",              { "use_phonedial" }  }
  ,{ "use_spring_lvl3",                     "rm_powerunit",              { "get_spring_lvl3" }  }
  ,{ "clk_engineerbox_button",              "rm_powerunit",              { "use_spring_lvl3" }  }

  ,{ "opn_engineerbox" } 
  ,{ "win_engineerbox",                     "rm_powerunit",              { "clk_engineerbox_button" }  }

  ,{ "clk_boltcutter" }
  ,{ "get_boltcutter" }
  ,{ "use_boltcutter",                      "rm_powerunit",              { "get_boltcutter" }  }
  ,{ "get_ironcase",                        "rm_powerunit",              { "use_boltcutter" }  }
  ,{ "clk_ironcase" }
  ,{ "clk_ironcase_trash" }
  ,{ "get_glue",          }
  ,{ "get_patch",          }
  ,{ "use_patch",                           "rm_ventilationshaft",       { "get_patch" }  }
  ,{ "use_glue",                            "rm_ventilationshaft",       { "use_patch", "get_glue" }  }
  ,{ "use_pump",                            "rm_ventilationshaft",       { "use_glue", "get_pump" }  }
  ,{ "get_inflatedmattress",                "rm_ventilationshaft",       { "use_pump" }  }
  ,{ "use_inflatedmattress",                "rm_powerunit",              { "get_inflatedmattress" }  }

    -- rm_terenceroom 
  ,{ "opn_terenceroom" }
  ,{ "clk_terenceroom_folder" }
  ,{ "get_hook_lvl3",                       "rm_terenceroom",            { "opn_terenceroom" }  }
  ,{ "see_scare_terenceroom_1" }
  ,{ "use_hook_lvl3",                       "rm_terenceroom",            { "get_hook_lvl3" }  }
  ,{ "get_terencetie",                      "rm_terenceroom"  }
  ,{ "clk_tie" }  
  ,{ "get_tieclip", }
  ,{ "use_tieclip",                         "rm_terenceroom",            { "get_tieclip" }  }
  ,{ "clk_tieclip",                         "rm_terenceroom",            { "use_tieclip" }  }
  ,{ "get_oilcan",                          "rm_terenceroom",            { "clk_tieclip" }  }
  ,{ "use_oilcan",                          "rm_terenceroom",            { "get_oilcan" }  }
  ,{ "get_bronzeamulet",                    "rm_terenceroom",            { "use_oilcan" }  }
  ,{ "use_bronzeamulet",                    "rm_ventilationshaft",       { "get_bronzeamulet" }  }
  ,{ "get_wrench",                          "rm_ventilationshaft",       { "use_bronzeamulet" }  }
  ,{ "get_smallslider1",                    "rm_ventilationshaft",       { "use_bronzeamulet" }  }
  ,{ "use_wrench1",                         "rm_ventilationshaft",       { "get_wrench" }  }
  ,{ "get_screw1",                          "rm_ventilationshaft",       { "use_wrench1" }  }
  ,{ "use_wrench2",                         "rm_powerunit",              { "get_wrench" }  }
  ,{ "get_screw2",                          "rm_powerunit",              { "use_wrench2" }  }
  ,{ "use_screw",                           "rm_powerunit",              { "get_screw1", "get_screw2" }  }
 
  ,{ "win_transformer",                     "rm_powerunit",              { "use_screw" }  }

  ,{ "after_win_transformer",               "rm_powerunit",              { "win_transformer" }  }
  ,{ "get_mechanismpart",                   "rm_powerunit",              { "win_transformer" }  }
  ,{ "use_mechanismpart",                   "rm_terenceroom",            { "get_mechanismpart" }  }
  ,{ "get_scissors",                        "rm_terenceroom",            { "use_mechanismpart" }  }
  ,{ "see_terenceroom_mirror" }
  ,{ "use_scissors",                        "rm_terenceroom",            { "get_scissors" }  }
  ,{ "clk_pillow",                          "rm_terenceroom",            { "use_scissors" }  }
  ,{ "clk_photobox",                        "rm_terenceroom",            { "clk_pillow" }  }
  ,{ "get_terencediary",                    "rm_terenceroom",            { "clk_photobox" }  }
  ,{ "use_glassfigurine", }
  ,{ "clk_diary_page1", }
  ,{ "clk_diary_page2", }
  ,{ "get_photopart1", }
  ,{ "get_drawerkey", }
  ,{ "use_drawerkey",                       "rm_terenceroom",            { "get_drawerkey" }  }
  ,{ "clk_drawerkey",                       "rm_terenceroom",            { "use_drawerkey" }  }
  ,{ "get_tap",                             "rm_terenceroom",            { "clk_drawerkey" }  }
  ,{ "use_tap",                             "rm_terenceroom",            { "get_tap" }  }
  ,{ "win_showerroom",                      "rm_terenceroom",            { "use_tap" }  }
  ,{ "get_code2",                           "rm_terenceroom",            { "win_showerroom" }  }
  ,{ "use_code1",                           "rm_powerunit",              { "get_code1" }  }
  ,{ "use_code2",                           "rm_powerunit",              { "get_code2" }  }
  ,{ "win_codephone",                       "rm_powerunit",              { "use_code1", "use_code2" }  }
  ,{ "get_remotecontrol",                   "rm_powerunit",              { "win_codephone" }  }

  ,{ "clk_remotecontrol_cover", }
  ,{ "clk_secondfloorbutton_1", }
  ,{ "clk_secondfloorbutton_2", }
  ,{ "get_secondfloorbutton",   }
  ,{ "use_secondfloorbutton",               "rm_terenceroom",            { "get_secondfloorbutton" }  }
  ,{ "clk_secondfloorbutton",               "rm_terenceroom",            { "use_secondfloorbutton" }  }

    -- rm_secondfloor 
  ,{ "opn_secondfloor" } 
  ,{ "clk_secondfloor_door",                "rm_secondfloor",            { "opn_secondfloor" }  }
  ,{ "use_hook_lvl3_2",                     "rm_secondfloor",            { "opn_secondfloor" }  }
  ,{ "get_moleculeamulet1",                 "rm_secondfloor",            { "use_hook_lvl3_2" }  }
  ,{ "use_moleculeamulet1",                 "rm_secondfloor",            { "get_moleculeamulet1" }  }
  ,{ "get_tobiaswallet",                    "rm_secondfloor",            { "use_moleculeamulet1" }  }

  ,{ "clk_tobiaswallet",          }
  ,{ "clk_tobiaswallet_photo",    }
  ,{ "clk_tobiaswallet_photo_1",  }
  ,{ "get_tobiascode",            }
  ,{ "use_tobiascode",                      "rm_secondfloor",            { "get_tobiascode" }  }
  ,{ "win_tobiasplans",                     "rm_secondfloor",            { "use_tobiascode" }  }
  ,{ "get_sledgehammer",                    "rm_secondfloor",            { "win_tobiasplans" }  }
  ,{ "use_sledgehammer",                    "rm_terenceroom",            { "get_sledgehammer" }  }

  ,{ "opn_behindmirror" } 
  ,{ "win_behindmirror",                    "rm_terenceroom",            { "use_sledgehammer" }  }

  ,{ "use_adjustmentcontrol",               "rm_secondfloor",            { "win_behindmirror" }  }
  ,{ "get_metalbasrelief",                  "rm_secondfloor",            { "use_adjustmentcontrol" }  }
  ,{ "see_scare_secondfloor_1",             "rm_secondfloor",            { "get_metalbasrelief" }  }
  ,{ "use_metalbasrelief",                  "rm_secondfloor",            { "see_scare_secondfloor_1" }  }
  ,{ "get_moleculeamulet2",                 "rm_secondfloor",            { "use_metalbasrelief" }  }
  ,{ "use_moleculeamulet2",                 "rm_secondfloor",            { "get_moleculeamulet2" }  }
  ,{ "get_tobiaskey",                       "rm_secondfloor",            { "use_moleculeamulet2" }  }
  ,{ "use_tobiaskey",                       "rm_secondfloor",            { "get_tobiaskey" }  }
  ,{ "clk_tobiasbox",                       "rm_secondfloor",            { "use_tobiaskey" } }
  ,{ "get_watch",                           "rm_secondfloor",            { "clk_tobiasbox" }  }
  ,{ "clk_watch_back",      }
  ,{ "clk_watch_cover",     }
  ,{ "get_smallslider2",    }
  ,{ "use_smallslider1",                    "rm_secondfloor",            { "use_metalbasrelief", "get_smallslider1" }  }
  ,{ "use_smallslider2",                    "rm_secondfloor",            { "use_metalbasrelief", "get_smallslider2" }  }
  ,{ "win_examroomdoor",                    "rm_secondfloor",            { "use_smallslider1", "use_smallslider2" }  }

    -- rm_examroom 
  ,{ "opn_examroom" } 
  ,{ "see_scare_trap",                      "rm_examroom",               { "opn_examroom" }  }
  ,{ "get_ropetrap",                        "rm_examroom",               { "see_scare_trap" }  }
  ,{ "clk_brokenfork",                      "rm_examroom",               { "opn_examroom" }  }
  ,{ "get_brokenfork",                      "rm_examroom",               { "clk_brokenfork" }  }
  ,{ "use_brokenfork",                      "rm_examroom",               { "get_brokenfork" }  }
  ,{ "see_monitors_threat_professor",       "rm_examroom",               { "use_brokenfork" }  }
  ,{ "get_sensor",                          "rm_examroom",               { "see_monitors_threat_professor" }  }
  ,{ "see_terence_appear",                  "rm_secondfloor",            { "get_sensor" }  }
  ,{ "use_sensor",                          "rm_secondfloor",            { "get_sensor" }  }
  ,{ "win_tube",                            "rm_secondfloor",            { "use_sensor" }  }
  ,{ "get_leadedbox",                       "rm_secondfloor",            { "win_tube" }  }

  ,{ "clk_leadedbox", }
  ,{ "get_photopart2",          }
  ,{ "get_tobiaspermit",          }
  ,{ "use_photopart1",                      "rm_terenceroom",            { "get_photopart1" }  }
  ,{ "use_photopart2",                      "rm_terenceroom",            { "get_photopart2" }  }
  ,{ "get_tile",                            "rm_terenceroom",            { "use_photopart1", "use_photopart2" }  }
  ,{ "use_tile",                            "rm_terenceroom",            { "get_tile" }  }
  ,{ "get_tweezers",                        "rm_terenceroom",            { "use_tile" }  }

  ,{ "clk_paper_amulet3",                   "rm_examroom",               { "opn_examroom" } }
  ,{ "clk_web_amulet3",                     "rm_examroom",               { "clk_paper_amulet3" } }  
  ,{ "use_tweezers",                        "rm_examroom",               { "clk_web_amulet3", "get_tweezers" }  }
  ,{ "get_moleculeamulet3",                 "rm_examroom",               { "use_tweezers" }  }
  ,{ "use_moleculeamulet3",                 "rm_secondfloor",            { "get_moleculeamulet3" }  }
  ,{ "get_engravedknife",                   "rm_secondfloor",            { "use_moleculeamulet3" }  }
  ,{ "get_fireextinguisherhead",          }
  ,{ "use_engravedknife",          }
  ,{ "clk_ropetrap_1", }
  ,{ "clk_ropetrap_2", }
  ,{ "get_lasso",          }
  ,{ "use_fireextinguisherhead",            "rm_secondfloor",            { "get_fireextinguisherhead" }  }
  ,{ "get_fireextinguisher",                "rm_secondfloor",            { "use_fireextinguisherhead" }  }
  ,{ "use_fireextinguisher",                "rm_secondfloor",            { "get_fireextinguisher" }  }
  ,{ "use_lasso",                           "rm_secondfloor",            { "use_fireextinguisher" }  }

  ,{ "opn_burntwall" } 
  ,{ "win_burntwall",                       "rm_secondfloor",            { "opn_burntwall" }  }

  ,{ "clk_terencemedallion",       }
  ,{ "get_terencepermit",          }
  ,{ "clk_socket",                          "rm_secondfloor",            { "use_lasso" }  }
  ,{ "use_tobiaspermit",                    "rm_secondfloor",            { "get_tobiaspermit" }  }
  ,{ "use_terencepermit",                   "rm_secondfloor",            { "get_terencepermit" }  }
  ,{ "clk_slots",                           "rm_secondfloor",            { "use_tobiaspermit", "use_terencepermit" }  }

  ,{ "opn_tortureroom" } 
  ,{ "win_electricalpanel_1",               "rm_tortureroom",            { "opn_tortureroom" }  }
  ,{ "get_handlebox1",                      "rm_tortureroom",            { "win_electricalpanel_1" }  }
  ,{ "use_handlebox1",                      "rm_tortureroom",            { "get_handlebox1" }  }
  ,{ "clk_doorbox1",                        "rm_tortureroom",            { "use_handlebox1" }  }
  ,{ "win_boxes_1",                         "rm_tortureroom",            { "clk_doorbox1" }  }
  ,{ "get_cane",                            "rm_tortureroom",            { "win_boxes_1" }  }
  ,{ "clk_cane" }
  ,{ "get_decomposedcane" }
  ,{ "use_decomposedcane",                  "rm_tortureroom",            { "get_decomposedcane" }  }
  ,{ "win_lines",                           "rm_tortureroom",            { "use_decomposedcane" }  }
  ,{ "get_diod",                            "rm_tortureroom",            { "win_lines" }  }
  ,{ "use_diod",                            "rm_tortureroom",            { "get_diod" }  }
  ,{ "win_electricalpanel_2",               "rm_tortureroom",            { "use_diod" }  }
  ,{ "get_handlebox2",                      "rm_tortureroom",            { "win_electricalpanel_2" }  }
  ,{ "use_handlebox2",                      "rm_tortureroom",            { "get_handlebox2" }  }
  ,{ "clk_doorbox2",                        "rm_tortureroom",            { "use_handlebox2" }  }
  ,{ "win_boxes_2",                         "rm_tortureroom",            { "clk_doorbox2" }  }
  ,{ "get_hammerbox",                       "rm_tortureroom",            { "win_boxes_2" }  }
  ,{ "use_hammerbox",                       "rm_tortureroom",            { "get_hammerbox" }  }
  ,{ "win_keystv",                          "rm_tortureroom",            { "use_hammerbox" }  }
  ,{ "get_levermonitor",                    "rm_tortureroom",            { "win_keystv" }  }
  ,{ "use_levermonitor",                    "rm_tortureroom",            { "get_levermonitor" }  }
  ,{ "win_levers",                          "rm_tortureroom",            { "use_levermonitor" }  }
  ,{ "get_fuselev",                         "rm_tortureroom",            { "win_levers" }  }
  ,{ "use_fuselev",                         "rm_tortureroom",            { "get_fuselev" }  }
  ,{ "get_combinationnumbers",              "rm_tortureroom",            { "use_fuselev" }  }
  ,{ "use_combinationnumbers",              "rm_tortureroom",            { "get_combinationnumbers" }  }
  ,{ "win_levers_2",                        "rm_tortureroom",            { "use_combinationnumbers" }  }
  ,{ "win_ventilationbox",                  "rm_tortureroom",            { "win_levers_2" }  }
  ,{ "get_emergencyswitch",                 "rm_tortureroom",            { "win_ventilationbox" }  }
  ,{ "use_emergencyswitch",                 "rm_tortureroom",            { "get_emergencyswitch" }  }
  ,{ "clk_emergencyswitch",                 "rm_tortureroom",            { "use_emergencyswitch" }  }
  ,{ "get_pepper_spray",                    "rm_tortureroom",            { "clk_emergencyswitch" }  }
  ,{ "see_outro_3",                          "rm_tortureroom",            { "clk_emergencyswitch" }  }

  ,{ "get_collect_item_3_1" }
  ,{ "get_collect_item_3_2" }
  ,{ "get_collect_item_3_3" }
  ,{ "get_collect_morph_item_3_1" }
  ,{ "get_collect_morph_item_3_2" }
  ,{ "get_collect_morph_item_3_3" }
  ,{ "get_collect_morph_item_3_4" }
  ,{ "get_collect_morph_item_3_5" }

  };
  
  game.progress_names = {};
  for i = 1, #game.progress_names_room do
    game.progress_names[ i ] = game.progress_names_room[ i ][ 1 ];
  end;

  game.relations = {};

  private.menu_moduls = {
    "rm_credits"
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {
      "rm_collectibles2",
      "rm_collectibles",
      "rm_achievements",
    }

    for i = 1, #menu_moduls_ce do

      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );

    end;

  end;

end;

function private.TutorialSetParams ()

  if not ng_global.progress[ "std" ][ "see_tutorial" ] then

    ng_global.progress[ "std" ][ "see_tutorial" ] = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].done  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].start = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].state.no  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state.currentpage = "tutorial_page_1";
    ng_global.progress[ "std" ][ "see_tutorial" ].func = function()
      --
    end;

  end;

end;