-- name=level3_inv
--*********************************************************************************************************************
function public.Init ()
  if port.isPortable() == 1 then
    port.InventoryPopupInit("level3_inv_hub");
    port.VideoResizeInRoom("level3_inv");
  end;
  private.wirereel_init();
  private.boltcutterpart2_init();
  private.ironcase_init();
  private.terencetie_init();
  private.terencediary_init();
  private.remotecontrol_init();
  private.tobiaswallet_init();
  private.watch_init();
  private.leadedbox_init();
  private.ropetrap_init();
  private.terencemedallion_init();
  private.cane_init();
----------------------------------------------------------------------------------------
  -- sound on all inventory objects during dragging for conteiner inventory_hub
----------------------------------------------------------------------------------------
  local invRelationsHub3 = ObjGetRelations( "level3_inv_hub" );

  if invRelationsHub3.childs then
    
    for i = 1, #invRelationsHub3.childs, 1 do 
      
      local invCurrent = invRelationsHub3.childs[i];
      ObjSet( invCurrent, { event_startdrag = cmn.GetInvObjectSfx } );
      
    end;
    
  end;

end;
--*********************************************************************************************************************
function private.StringDivide ( string )  

  local table = { };
  local id = 1;
  local il = 1;

  for i = 1, string.len( string ) do

    if ( string.sub( string, i, i ) == "_" ) then

      table[ id ] = string.sub( string, il, i - 1 );
      il = i + 1;
      id = id + 1;

    end

    if ( i == string.len( string ) ) then

      table[id] = string.sub( string, il, i );
      il = i + 1;
      id = id + 1;

    end

  end

  return table;

end;
--*********************************************************************************************************************
function private.ObjIntersectCheck ( obj_to_apply, obj_to_check, obj_complex_inv )

  local obj_complex_inv = obj_complex_inv or "deploy_inv_"..private.StringDivide( obj_to_check )[4];  
  
  return interface.GetCurrentInv() == obj_complex_inv and ObjIntersect( obj_to_apply, obj_to_check );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** wirereel *** () end;
--*********************************************************************************************************************
  function private.wirereel_init ()

    --------------------------------------------------------------------------------------------
    ObjMultiSet({ 
      { "spr_deploy_inv_wirereel_wirepiece", { event_mdown = private.get_wirepiece } },  
      { "obj_deploy_inv_wirereel_clk_wire_1", { event_mdown = private.clk_wire_1 } }, 
      { "obj_deploy_inv_wirereel_clk_wire_2", { event_mdown = private.clk_wire_2 } }, 
      { "obj_deploy_inv_wirereel_clk_wire_3", { event_mdown = private.clk_wire_3 } },         
    });
    --------------------------------------------------------------------------------------------
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_wire_1" ] = {
        type = "click",
        use_place = "obj_deploy_inv_wirereel_clk_wire_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_wirereel",
        zz_gate = "inv_wirereel"
    };
    function clk_wire_1_beg ()

      ObjDelete( "obj_deploy_inv_wirereel_clk_wire_1" )

    end;
    function clk_wire_1_end ()

      ObjSet( "spr_deploy_inv_wirereel_wire_1", { alp = 1 } );
      ObjSet( "obj_deploy_inv_wirereel_clk_wire_2", { input = true } );
      
    end;
    cmn.AddSubscriber( "clk_wire_1_beg", clk_wire_1_beg, "inv_wirereel" );
    cmn.AddSubscriber( "clk_wire_1_end", clk_wire_1_end, "inv_wirereel" );
    cmn.AddSubscriber( "clk_wire_1", clk_wire_1_beg, "inv_wirereel" );
    cmn.AddSubscriber( "clk_wire_1", clk_wire_1_end, "inv_wirereel" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_wire_2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_wirereel_clk_wire_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_wirereel",
        zz_gate = "inv_wirereel"
    };
    function clk_wire_2_beg ()

      ObjDelete( "obj_deploy_inv_wirereel_clk_wire_2" )

    end;
    function clk_wire_2_end ()

      ObjSet( "spr_deploy_inv_wirereel_wire_2", { alp = 1 } );
      ObjSet( "obj_deploy_inv_wirereel_clk_wire_3", { input = true } );
      
    end;
    cmn.AddSubscriber( "clk_wire_2_beg", clk_wire_2_beg, "inv_wirereel" );
    cmn.AddSubscriber( "clk_wire_2_end", clk_wire_2_end, "inv_wirereel" );
    cmn.AddSubscriber( "clk_wire_2", clk_wire_2_beg, "inv_wirereel" );
    cmn.AddSubscriber( "clk_wire_2", clk_wire_2_end, "inv_wirereel" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_wire_3" ] = {
        type = "click",
        use_place = "obj_deploy_inv_wirereel_clk_wire_3",
        room = "int_deploy_inv",
        zz = "deploy_inv_wirereel",
        zz_gate = "inv_wirereel"
    };
    function clk_wire_3_beg ()

      ObjDelete( "obj_deploy_inv_wirereel_clk_wire_3" );

    end;
    function clk_wire_3_end ()

      ObjSet( "spr_deploy_inv_wirereel_wirepiece", { alp = 1, input = true } );
      
    end;
    cmn.AddSubscriber( "clk_wire_3_beg", clk_wire_3_beg, "inv_wirereel" );
    cmn.AddSubscriber( "clk_wire_3_end", clk_wire_3_end, "inv_wirereel" );
    cmn.AddSubscriber( "clk_wire_3", clk_wire_3_beg, "inv_wirereel" );
    cmn.AddSubscriber( "clk_wire_3", clk_wire_3_end, "inv_wirereel" );
    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_wirepiece" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_wirereel_wirepiece",
        room = "int_deploy_inv",
        zz = "deploy_inv_wirereel",
        zz_gate = "inv_wirereel"
    };

    function get_wirepiece_inv ()
      
      interface.InventoryItemAdd( "inv_wirepiece", "spr_deploy_inv_wirereel_wirepiece" );
      interface.InventoryItemRemove( "inv_wirereel" );

    end;
    cmn.AddSubscriber( "get_wirepiece", get_wirepiece_inv );
    --------------------------------------------------------------------------------------------

  end;

 --------------------------------------------------------------------------------------------
  function private.clk_wire_1 ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_wire_1" );
      cmn.CallEventHandler( "clk_wire_1_end", "inv_wirereel" );

    end;

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_clk_hank", 0, "", 0 );

    cmn.CallEventHandler( "clk_wire_1_beg", "inv_wirereel" );

    ObjAnimate( "spr_deploy_inv_wirereel_wire_1", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0, 
      0.3, 3, 1 
    } );

  end;
  --------------------------------------------------------------------------------------------
  function private.clk_wire_2 ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_wire_2" );
      cmn.CallEventHandler( "clk_wire_2_end", "inv_wirereel" );

    end;

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_clk_hank", 0, "", 0 );

    cmn.CallEventHandler( "clk_wire_2_beg", "inv_wirereel" );

    ObjAnimate( "spr_deploy_inv_wirereel_wire_2", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0, 
      0.3, 3, 1 
    } );

  end;
  --------------------------------------------------------------------------------------------
  function private.clk_wire_3 ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_wire_3" );
      cmn.CallEventHandler( "clk_wire_3_end", "inv_wirereel" );

    end;

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_clk_hank", 0, "", 0 );

    cmn.CallEventHandler( "clk_wire_3_beg", "inv_wirereel" );

    ObjAnimate( "spr_deploy_inv_wirereel_wirepiece", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0, 
      0.3, 3, 1 
    } );

    ObjAnimate( "spr_deploy_inv_wirereel_wire_2", "alp", 0, 0, "", 
    { 
      0.0, 0, 1, 
      0.3, 3, 0 
    } );

  end;
  ---------------------------------------------------------------------------------------------
  function private.get_wirepiece ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_wirepiece" );
    cmn.CallEventHandler( "get_wirepiece", "inv_wirereel" );
    common_impl.HideDeployInv();

  end;

--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** boltcutterpart2 *** () end;
--*********************************************************************************************************************

  function private.boltcutterpart2_init ()

    --------------------------------------------------------------------------------------------
    ObjMultiSet({ 
      { "spr_deploy_inv_boltcutterpart2_boltcutter_1", { event_mdown = private.get_boltcutter } },   
      { "obj_deploy_inv_boltcutterpart2_clk_boltcutter", { event_mdown = private.clk_boltcutter } },        
    });
    --------------------------------------------------------------------------------------------
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_boltcutter" ] = {
        type = "click",
        use_place = "obj_deploy_inv_boltcutterpart2_clk_boltcutter",
        room = "int_deploy_inv",
        zz = "deploy_inv_boltcutterpart2",
        zz_gate = "inv_boltcutterpart2"
    };
    function clk_boltcutter_beg ()

      ObjDelete( "obj_deploy_inv_boltcutterpart2_clk_boltcutter" )

    end;
    function clk_boltcutter_end ()

      ObjSet( "spr_deploy_inv_boltcutterpart2_boltcutter_2", { pos_x = -38, pos_y = 94 } );
      ObjSet( "spr_deploy_inv_boltcutterpart2_boltcutter_3", { alp = 1 } );
      ObjSet( "spr_deploy_inv_boltcutterpart2_boltcutter_1", { input = true, active = true } );
      ObjSet( "spr_deploy_inv_boltcutterpart2_boltcutter_4", { alp = 1 } );
      ObjSet( "gfx_deploy_inv_boltcutterpart2_boltcutter", { active = true } );
      
    end;
    cmn.AddSubscriber( "clk_boltcutter_beg", clk_boltcutter_beg, "inv_boltcutterpart2" );
    cmn.AddSubscriber( "clk_boltcutter_end", clk_boltcutter_end, "inv_boltcutterpart2" );
    cmn.AddSubscriber( "clk_boltcutter", clk_boltcutter_beg, "inv_boltcutterpart2" );
    cmn.AddSubscriber( "clk_boltcutter", clk_boltcutter_end, "inv_boltcutterpart2" );
    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_boltcutter" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_boltcutterpart2_boltcutter",
        room = "int_deploy_inv",
        zz = "deploy_inv_boltcutterpart2",
        zz_gate = "inv_boltcutterpart2"
    };

    function get_boltcutter_inv ()
      
      interface.InventoryItemAdd( "inv_boltcutter", "spr_deploy_inv_boltcutterpart2_boltcutter_1" );
      interface.InventoryItemRemove( "inv_boltcutterpart2" );

    end;
    cmn.AddSubscriber( "get_boltcutter", get_boltcutter_inv );
    --------------------------------------------------------------------------------------------

  end; 

  --------------------------------------------------------------------------------------------
  function private.clk_boltcutter ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_boltcutter" );
      cmn.CallEventHandler( "clk_boltcutter_end", "inv_boltcutterpart2" );

    end;

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_click", 0, "", 0 );

    cmn.CallEventHandler( "clk_boltcutter_beg", "inv_boltcutterpart2" );

    ObjAnimate( "spr_deploy_inv_boltcutterpart2_boltcutter_3", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0, 
      0.4, 3, 0,
      0.7, 3, 1 
    } );
    ObjAnimate( "spr_deploy_inv_boltcutterpart2_boltcutter_4", "alp", 0, 0, "", 
    { 
      0.0, 0, 0, 
      0.4, 3, 0,
      0.7, 3, 1 
    } );
    ObjAnimate( "spr_deploy_inv_boltcutterpart2_boltcutter_2", "pos_xy", 0, 0, "", 
    { 
      0.0, 0, -76, 167,
      0.4, 3, -38, 94
    } );

  end;
  ---------------------------------------------------------------------------------------------
  function private.get_boltcutter ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_boltcutter" );
    cmn.CallEventHandler( "get_boltcutter", "inv_boltcutterpart2" );
    common_impl.HideDeployInv();

  end;

--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** ironcase *** () end;
--*********************************************************************************************************************

  function private.ironcase_init ()

    --------------------------------------------------------------------------------------------
    ObjMultiSet({ 
      { "spr_deploy_inv_ironcase_patch", { event_mdown = private.get_patch } },
      { "spr_deploy_inv_ironcase_glue", { event_mdown = private.get_glue } },  
      { "obj_deploy_inv_ironcase_clk_ironcase", { event_mdown = private.clk_ironcase } },  
      { "obj_deploy_inv_ironcase_clk_ironcase_trash", { event_mdown = private.clk_ironcase_trash } },           
    });

    --------------------------------------------------------------------------------------------
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_ironcase" ] = {
        type = "click",
        use_place = "obj_deploy_inv_ironcase_clk_ironcase",
        room = "int_deploy_inv",
        zz = "deploy_inv_ironcase",
        zz_gate = "inv_ironcase"
    };
    function clk_ironcase_beg ()

      ObjDelete( "obj_deploy_inv_ironcase_clk_ironcase" )

    end;
    function clk_ironcase_end ()

      ObjDelete( "spr_deploy_inv_ironcase_box_close" );
      ObjSet( "spr_deploy_inv_ironcase_box_open", { alp = 1 } );
      ObjSet( "spr_deploy_inv_ironcase_lock", { alp = 1 } );
      ObjSet( "obj_deploy_inv_ironcase_clk_ironcase_trash", { input = true } );
      
    end;
    cmn.AddSubscriber( "clk_ironcase_beg", clk_ironcase_beg, "inv_ironcase" );
    cmn.AddSubscriber( "clk_ironcase_end", clk_ironcase_end, "inv_ironcase" );
    cmn.AddSubscriber( "clk_ironcase", clk_ironcase_beg, "inv_ironcase" );
    cmn.AddSubscriber( "clk_ironcase", clk_ironcase_end, "inv_ironcase" );

    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_ironcase_trash" ] = {
        type = "click",
        use_place = "obj_deploy_inv_ironcase_clk_ironcase_trash",
        room = "int_deploy_inv",
        zz = "deploy_inv_ironcase",
        zz_gate = "inv_ironcase"
    };
    function clk_ironcase_trash_beg ()

      ObjDelete( "obj_deploy_inv_ironcase_clk_ironcase_trash" )

    end;
    function clk_ironcase_trash_end ()

      ObjSet( "spr_deploy_inv_ironcase_glue", { input = true, active = true } );
      ObjSet( "spr_deploy_inv_ironcase_patch", { input = true, active = true } );
      ObjDelete( "obj_deploy_inv_ironcase_trash" );
      
    end;
    cmn.AddSubscriber( "clk_ironcase_trash_beg", clk_ironcase_trash_beg, "inv_ironcase" );
    cmn.AddSubscriber( "clk_ironcase_trash_end", clk_ironcase_trash_end, "inv_ironcase" );
    cmn.AddSubscriber( "clk_ironcase_trash", clk_ironcase_trash_beg, "inv_ironcase" );
    cmn.AddSubscriber( "clk_ironcase_trash", clk_ironcase_trash_end, "inv_ironcase" );

    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_glue" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_ironcase_glue",
        room = "int_deploy_inv",
        zz = "deploy_inv_ironcase",
        zz_gate = "inv_ironcase"
    };

    function get_glue_inv ()
      
      interface.InventoryItemAdd( "inv_glue", "spr_deploy_inv_ironcase_glue" );

      if cmn.IsEventDone( "get_patch" ) then 
        interface.InventoryItemRemove( "inv_ironcase" );
      end;

    end;
    cmn.AddSubscriber( "get_glue", get_glue_inv );
    --------------------------------------------------------------------------------------------
    --------------------------------------------------------------------------------------
    common_impl.hint[ "get_patch" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_ironcase_patch",
        room = "int_deploy_inv",
        zz = "deploy_inv_ironcase",
        zz_gate = "inv_ironcase"
    };

    function get_patch_inv ()
      
      interface.InventoryItemAdd( "inv_patch", "spr_deploy_inv_ironcase_patch" );

      if cmn.IsEventDone( "get_glue" ) then 
        interface.InventoryItemRemove( "inv_ironcase" );
      end;

    end;
    cmn.AddSubscriber( "get_patch", get_patch_inv );
    --------------------------------------------------------------------------------------------

  end; 

  --------------------------------------------------------------------------------------------
  function private.clk_ironcase ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_ironcase" );
      cmn.CallEventHandler( "clk_ironcase_end", "inv_ironcase" );

    end;

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_lever", 0, "", 0 );

    cmn.CallEventHandler( "clk_ironcase_beg", "inv_ironcase" );

    ObjAnimate( "spr_deploy_inv_ironcase_box_open", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0, 
      0.3, 3, 1 
    } );
    ObjAnimate( "spr_deploy_inv_ironcase_box_close", "alp", 0, 0, "", 
    { 
      0.0, 0, 1, 
      0.3, 3, 0 
    } );
    ObjAnimate( "spr_deploy_inv_ironcase_lock", "alp", 0, 0, "", 
    { 
      0.0, 0, 0, 
      0.3, 3, 1 
    } );

  end;
  --------------------------------------------------------------------------------------------
  function private.clk_ironcase_trash ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_ironcase_trash" );
      cmn.CallEventHandler( "clk_ironcase_trash_end", "inv_ironcase" );

    end;

    common_impl.PlayAudio( "sfx", "aud_remove_clk2", 0, "", 0 );

    cmn.CallEventHandler( "clk_ironcase_trash_beg", "inv_ironcase" );

    ObjAnimate( "spr_deploy_inv_ironcase_bottle", "alp", 0, 0, "", 
    { 
      0.0, 0, 1, 
      0.3, 3, 0 
    } );
    ObjAnimate( "spr_deploy_inv_ironcase_tablets", "alp", 0, 0, "", 
    { 
      0.0, 0, 1, 
      0.3, 3, 0 
    } );

    ObjAnimate( "spr_deploy_inv_ironcase_bandage", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 1,
      0.3, 0, 1, 
      0.6, 3, 0 
    } );

  end;
  ---------------------------------------------------------------------------------------------
  function private.get_glue ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_glue" );
    cmn.CallEventHandler( "get_glue", "inv_ironcase" );

    if cmn.IsEventDone( "get_patch" ) then 
      common_impl.HideDeployInv();
    end;

  end;

  ---------------------------------------------------------------------------------------------
  function private.get_patch ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_patch" );
    cmn.CallEventHandler( "get_patch", "inv_ironcase" );

    if cmn.IsEventDone( "get_glue" ) then 
      common_impl.HideDeployInv();
    end;

  end;

--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** terencetie *** () end;
--*********************************************************************************************************************

  function private.terencetie_init ()

    --------------------------------------------------------------------------------------------
    ObjMultiSet({ 
      { "spr_deploy_inv_terencetie_tieclip", { event_mdown = private.get_tieclip } },
      { "obj_deploy_inv_terencetie_clk_tie", { event_mdown = private.clk_tie } },         
    });

    --------------------------------------------------------------------------------------------
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_tie" ] = {
        type = "click",
        use_place = "obj_deploy_inv_terencetie_clk_tie",
        room = "int_deploy_inv",
        zz = "deploy_inv_terencetie",
        zz_gate = "inv_terencetie"
    };
    function clk_tie_beg ()

      ObjDelete( "obj_deploy_inv_terencetie_clk_tie" )

    end;
    function clk_tie_end ()

      ObjDelete( "spr_deploy_inv_terencetie_tie" );
      ObjSet( "spr_deploy_inv_terencetie_tie_open", { alp = 1 } );
      ObjSet( "obj_deploy_inv_terencetie_tieclip", { alp = 1, input = true } );
      
    end;
    cmn.AddSubscriber( "clk_tie_beg", clk_tie_beg, "inv_terencetie" );
    cmn.AddSubscriber( "clk_tie_end", clk_tie_end, "inv_terencetie" );
    cmn.AddSubscriber( "clk_tie", clk_tie_beg, "inv_terencetie" );
    cmn.AddSubscriber( "clk_tie", clk_tie_end, "inv_terencetie" );
    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_tieclip" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_terencetie_tieclip",
        room = "int_deploy_inv",
        zz = "deploy_inv_terencetie",
        zz_gate = "inv_terencetie"
    };

    function get_tieclip_inv ()
      
      ObjSet( "spr_deploy_inv_terencetie_tieclip2", { alp = 1 } );
      interface.InventoryItemAdd( "inv_tieclip", "obj_deploy_inv_terencetie_tieclip" );
      interface.InventoryItemRemove( "inv_terencetie" );

    end;
    cmn.AddSubscriber( "get_tieclip", get_tieclip_inv );
    --------------------------------------------------------------------------------------------

  end; 
  --------------------------------------------------------------------------------------------
  function private.clk_tie ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_tie" );
      cmn.CallEventHandler( "clk_tie_end", "inv_terencetie" );

    end;

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_cloth1", 0, "", 0 );

    cmn.CallEventHandler( "clk_tie_beg", "inv_terencetie" );

    ObjAnimate( "spr_deploy_inv_terencetie_tie", "alp", 0, 0, "", 
    { 
      0.0, 0, 1, 
      0.3, 3, 0 
    } );
    ObjAnimate( "obj_deploy_inv_terencetie_tieclip", "alp", 0, 0, "", 
    { 
      0.0, 0, 0, 
      0.3, 3, 1 
    } );

    ObjAnimate( "spr_deploy_inv_terencetie_tie_open", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0,
      0.3, 0, 1 
    } );

  end;
  ---------------------------------------------------------------------------------------------
  function private.get_tieclip ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_tieclip" );
    cmn.CallEventHandler( "get_tieclip", "inv_terencetie" );
    common_impl.HideDeployInv();

  end;

--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** terencediary *** () end;
--*********************************************************************************************************************

  function private.terencediary_init ()

    --------------------------------------------------------------------------------------------
    ObjMultiSet({ 
      { "spr_deploy_inv_terencediary_photopart1", { event_mdown = private.get_photopart1 } }, 
      { "spr_deploy_inv_terencediary_drawerkey", { event_mdown = private.get_drawerkey } },       
      { "obj_deploy_inv_terencediary_clk_page", { event_mdown = private.clk_page } },   
    });
    --------------------------------------------------------------------------------------------
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_diary_page1" ] = {
        type = "click",
        use_place = "obj_deploy_inv_terencediary_clk_page",
        room = "int_deploy_inv",
        zz = "deploy_inv_terencediary",
        zz_gate = "inv_terencediary"
    };
    function clk_diary_page1_beg ()

      --

    end;
    function clk_diary_page1_end ()

      ObjDelete( "obj_deploy_inv_terencediary_page_1" );
      ObjSet( "obj_deploy_inv_terencediary_page_1", { alp = 1 } );
      
    end;
    cmn.AddSubscriber( "clk_diary_page1_beg", clk_diary_page1_beg, "inv_terencediary" );
    cmn.AddSubscriber( "clk_diary_page1_end", clk_diary_page1_end, "inv_terencediary" );
    cmn.AddSubscriber( "clk_diary_page1", clk_diary_page1_beg, "inv_terencediary" );
    cmn.AddSubscriber( "clk_diary_page1", clk_diary_page1_end, "inv_terencediary" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_diary_page2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_terencediary_clk_page",
        room = "int_deploy_inv",
        zz = "deploy_inv_terencediary",
        zz_gate = "inv_terencediary"
    };
    function clk_diary_page2_beg ()

      ObjDelete( "obj_deploy_inv_terencediary_clk_page" );

    end;
    function clk_diary_page2_end ()

      ObjDelete( "obj_deploy_inv_terencediary_page_2" );
      ObjSet( "obj_deploy_inv_terencediary_page_3", { alp = 1, input = true } );
      ObjSet( "spr_deploy_inv_terencediary_photopart1", { input = true } );
      ObjSet( "spr_deploy_inv_terencediary_drawerkey", { input = true } );
      
    end;
    cmn.AddSubscriber( "clk_diary_page2_beg", clk_diary_page2_beg, "inv_terencediary" );
    cmn.AddSubscriber( "clk_diary_page2_end", clk_diary_page2_end, "inv_terencediary" );
    cmn.AddSubscriber( "clk_diary_page2", clk_diary_page2_beg, "inv_terencediary" );
    cmn.AddSubscriber( "clk_diary_page2", clk_diary_page2_end, "inv_terencediary" );
    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_photopart1" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_terencediary_photopart1",
        room = "int_deploy_inv",
        zz = "deploy_inv_terencediary",
        zz_gate = "inv_terencediary"
    };

    function get_photopart1_inv ()
      
      interface.InventoryItemAdd( "inv_photopart1", "spr_deploy_inv_terencediary_photopart1" );

      if cmn.IsEventDone( "get_drawerkey" ) then 
        interface.InventoryItemRemove( "inv_terencediary" );
      end; 

    end;
    cmn.AddSubscriber( "get_photopart1", get_photopart1_inv );

    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------

    common_impl.hint[ "get_drawerkey" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_terencediary_drawerkey",
        room = "int_deploy_inv",
        zz = "deploy_inv_terencediary",
        zz_gate = "inv_terencediary"
    };

    function get_drawerkey_inv ()
      
      interface.InventoryItemAdd( "inv_drawerkey", "spr_deploy_inv_terencediary_drawerkey" );
      if cmn.IsEventDone( "get_photopart1" ) then 
        interface.InventoryItemRemove( "inv_terencediary" );
      end;

    end;
    cmn.AddSubscriber( "get_drawerkey", get_drawerkey_inv );

    --------------------------------------------------------------------------------------------
    -- USE -------------------------------------------------------------------------------------

    common_impl.hint[ "use_glassfigurine" ] = {
        type = "use",
        inv_obj = "inv_glassfigurine",
        use_place = "obj_deploy_inv_terencediary_use_glassfigurine",
        room = "int_deploy_inv",
        zz = "deploy_inv_terencediary",
        zz_gate = "inv_terencediary"
    };    
    function use_glassfigurine_beg ()
      
      ObjDelete( "obj_deploy_inv_terencediary_use_glassfigurine" );
      interface.InventoryItemRemove( "inv_glassfigurine" );

    end;
    function use_glassfigurine_end ()
      
      ObjSet( "obj_deploy_inv_terencediary_clk_page", { input = true } );
      ObjSet( "spr_deploy_inv_terencediary_back_open", { alp = 1 } );
      ObjSet( "obj_deploy_inv_terencediary_page_1", { alp = 1 } );
      ObjDelete( "spr_deploy_inv_terencediary_back" );

    end;
    cmn.AddSubscriber( "use_glassfigurine", use_glassfigurine_beg );
    cmn.AddSubscriber( "use_glassfigurine", use_glassfigurine_end, "inv_terencediary" );
    cmn.AddSubscriber( "use_glassfigurine_beg", use_glassfigurine_beg );
    cmn.AddSubscriber( "use_glassfigurine_end", use_glassfigurine_end, "inv_terencediary" );

  end; 

  ---------------------------------------------------------------------------------------------

  function private.get_photopart1 ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_photopart1" );
    cmn.CallEventHandler( "get_photopart1", "inv_terencediary" );

    if cmn.IsEventDone( "get_drawerkey" ) then 
      common_impl.HideDeployInv();
    end;

  end;

  ---------------------------------------------------------------------------------------------

  function private.get_drawerkey ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_drawerkey" );
    cmn.CallEventHandler( "get_drawerkey", "inv_terencediary" );

    if cmn.IsEventDone( "get_photopart1" ) then 
      common_impl.HideDeployInv();
    end;

  end;
  ---------------------------------------------------------------------------------------------
  -- USE ---------------------------------------------------------------------------------------
  function public.use_glassfigurine ()

    local item = "inv_glassfigurine";

    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_terencediary_use_glassfigurine" ) )  then

      cmn.CallEventHandler( "use_glassfigurine_beg" );

      local func_end = function ()
        
        cmn.Lock( false );

        common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_book", 0, "", 0 );

        cmn.SetEventDone( "use_glassfigurine" );
        cmn.CallEventHandler( "use_glassfigurine_end", "inv_terencediary" );
        
      end;

      cmn.Lock( true );

      common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );

      local func_continue = function ()

        ObjAnimate( "spr_deploy_inv_terencediary_back", "alp", 0, 0, "", { 0, 0, 1, 0.3, 0, 0 } );    
        ObjAnimate( "spr_deploy_inv_terencediary_back_open", "alp", 0, 0, "", { 0, 0, 0, 0.3, 0, 1 } );
        ObjAnimate( "obj_deploy_inv_terencediary_page_1", "alp", 0, 0, func_end, { 0, 0, 0, 0.3, 0, 1 } );

      end;

      cmn.ItemFly( "spr_deploy_inv_terencediary_amulet", func_continue, 0 );

      return true; 

    end;

    return false;

  end;
  --------------------------------------------------------------------------------------------
  function private.clk_page ()

    local event = "clk_diary_page1";
    local page = 1;
    if ( cmn.IsEventDone( "clk_diary_page1" ) ) then
      event = "clk_diary_page2";
      page = 2;
    end;

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( event );
      cmn.CallEventHandler( event.."_end", "inv_terencediary" );

    end;

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_page", 0, "", 0 );

    cmn.CallEventHandler( event.."_beg", "inv_terencediary" );

    ObjAnimate( "obj_deploy_inv_terencediary_page_"..page, "alp", 0, 0, "", 
    { 
      0.0, 0, 1, 
      0.3, 3, 0 
    } );
     ObjAnimate( "obj_deploy_inv_terencediary_page_"..( page + 1 ), "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0, 
      0.3, 3, 1 
    } );

  end;

--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** remotecontrol *** () end;
--*********************************************************************************************************************

  function private.remotecontrol_init ()

    --------------------------------------------------------------------------------------------
    ObjMultiSet({ 
      { "spr_deploy_inv_remotecontrol_secondfloorbutton",       { event_mdown = private.get_secondfloorbutton   } },

      { "obj_deploy_inv_remotecontrol_clk_cover",               { event_mdown = private.clk_remotecontrol_cover } },
      { "obj_deploy_inv_remotecontrol_clk_secondfloorbutton_1", { event_mdown = private.clk_secondfloorbutton_1 } },
      { "obj_deploy_inv_remotecontrol_clk_secondfloorbutton_2", { event_mdown = private.clk_secondfloorbutton_2 } },          
    });

    --------------------------------------------------------------------------------------------
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_remotecontrol_cover" ] = {
        type = "click",
        use_place = "obj_deploy_inv_remotecontrol_clk_cover",
        room = "int_deploy_inv",
        zz = "deploy_inv_remotecontrol",
        zz_gate = "inv_remotecontrol"
    };
    function clk_remotecontrol_cover_beg ()

      ObjDelete( "obj_deploy_inv_remotecontrol_clk_cover" );

    end;
    function clk_remotecontrol_cover_end ()

      ObjDelete( "spr_deploy_inv_remotecontrol_cover"      );
      ObjDelete( "anm_deploy_inv_remotecontrol_open_cover" );

      ObjSet( "obj_deploy_inv_remotecontrol_clk_secondfloorbutton_1", { input = true, active = true  } );

    end;
    cmn.AddSubscriber( "clk_remotecontrol_cover_beg", clk_remotecontrol_cover_beg, "inv_remotecontrol" );
    cmn.AddSubscriber( "clk_remotecontrol_cover_end", clk_remotecontrol_cover_end, "inv_remotecontrol" );
    cmn.AddSubscriber( "clk_remotecontrol_cover",     clk_remotecontrol_cover_beg, "inv_remotecontrol" );
    cmn.AddSubscriber( "clk_remotecontrol_cover",     clk_remotecontrol_cover_end, "inv_remotecontrol" );

    --------------------------------------------------------------------------------------------
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_secondfloorbutton_1" ] = {
        type = "click",
        use_place = "obj_deploy_inv_remotecontrol_clk_secondfloorbutton_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_remotecontrol",
        zz_gate = "inv_remotecontrol"
    };
    function clk_secondfloorbutton_1_beg ()

      ObjDelete( "obj_deploy_inv_remotecontrol_clk_secondfloorbutton_1" );

    end;
    function clk_secondfloorbutton_1_end ()

      ObjSet( "obj_deploy_inv_remotecontrol_clk_secondfloorbutton_2", { input = true, active = true  } );

    end;
    cmn.AddSubscriber( "clk_secondfloorbutton_1_beg", clk_secondfloorbutton_1_beg, "inv_remotecontrol" );
    cmn.AddSubscriber( "clk_secondfloorbutton_1_end", clk_secondfloorbutton_1_end, "inv_remotecontrol" );
    cmn.AddSubscriber( "clk_secondfloorbutton_1",     clk_secondfloorbutton_1_beg, "inv_remotecontrol" );
    cmn.AddSubscriber( "clk_secondfloorbutton_1",     clk_secondfloorbutton_1_end, "inv_remotecontrol" );

    --------------------------------------------------------------------------------------------
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_secondfloorbutton_2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_remotecontrol_clk_secondfloorbutton_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_remotecontrol",
        zz_gate = "inv_remotecontrol"
    };
    function clk_secondfloorbutton_2_beg ()

      ObjDelete( "obj_deploy_inv_remotecontrol_clk_secondfloorbutton_2" );

    end;
    function clk_secondfloorbutton_2_end ()

      ObjMultiSet({ 
        { "spr_deploy_inv_remotecontrol_secondfloorbutton", { input = true  } },
        { "gfx_deploy_inv_remotecontrol_secondfloorbutton", { active = true } },        
      });

    end;
    cmn.AddSubscriber( "clk_secondfloorbutton_2_beg", clk_secondfloorbutton_2_beg, "inv_remotecontrol" );
    cmn.AddSubscriber( "clk_secondfloorbutton_2_end", clk_secondfloorbutton_2_end, "inv_remotecontrol" );
    cmn.AddSubscriber( "clk_secondfloorbutton_2",     clk_secondfloorbutton_2_beg, "inv_remotecontrol" );
    cmn.AddSubscriber( "clk_secondfloorbutton_2",     clk_secondfloorbutton_2_end, "inv_remotecontrol" );

    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_secondfloorbutton" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_remotecontrol_secondfloorbutton",
        room = "int_deploy_inv",
        zz = "deploy_inv_remotecontrol",
        zz_gate = "inv_remotecontrol"
    };

    function get_secondfloorbutton_inv ()
      
      interface.InventoryItemAdd( "inv_secondfloorbutton", "spr_deploy_inv_remotecontrol_secondfloorbutton" );
      interface.InventoryItemRemove( "inv_remotecontrol" );

    end;
    cmn.AddSubscriber( "get_secondfloorbutton", get_secondfloorbutton_inv );
    --------------------------------------------------------------------------------------------

  end; 

  ---------------------------------------------------------------------------------------------
  ---------------------------------------------------------------------------------------------
  function private.clk_remotecontrol_cover ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "clk_remotecontrol_cover" );
      cmn.CallEventHandler( "clk_remotecontrol_cover_end", "inv_remotecontrol" );

    end;

    cmn.CallEventHandler( "clk_remotecontrol_cover_beg", "inv_remotecontrol" );

    AnimPlay( "anm_deploy_inv_remotecontrol_open_cover", "DoAnim", func_end)

  end;
  ---------------------------------------------------------------------------------------------
  function private.clk_secondfloorbutton_1 ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_secondfloorbutton_1" );
      cmn.CallEventHandler( "clk_secondfloorbutton_1_end", "inv_remotecontrol" );

    end;

    cmn.CallEventHandler( "clk_secondfloorbutton_1_beg", "inv_remotecontrol" );

    ObjAnimate( "spr_deploy_inv_remotecontrol_secondfloorbutton", "pos_xy", 0, 0, func_end, 
    { 
      0.0, 0, 22, -22,
      0.2, 0, 26, -26,
      0.4, 0, 22, -22,
      0.6, 0, 18, -18,
      0.8, 0, 22, -22,
    } );

  end;

  ---------------------------------------------------------------------------------------------
  function private.clk_secondfloorbutton_2 ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_secondfloorbutton_2" );
      cmn.CallEventHandler( "clk_secondfloorbutton_2_end", "inv_remotecontrol" );

    end;

    cmn.CallEventHandler( "clk_secondfloorbutton_2_beg", "inv_remotecontrol" );

    ObjAnimate( "spr_deploy_inv_remotecontrol_secondfloorbutton", "pos_xy", 0, 0, func_end, 
    { 
      0.0, 0, 22, -22,
      0.2, 0, 24, -20,
      0.4, 0, 22, -22,
      0.6, 0, 16, -24,
      0.8, 0, 22, -22,
    } );

  end;
  ---------------------------------------------------------------------------------------------
  function private.get_secondfloorbutton ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_secondfloorbutton" );
    cmn.CallEventHandler( "get_secondfloorbutton", "inv_remotecontrol" );
    common_impl.HideDeployInv();

  end;

--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** tobiaswallet *** () end;
--*********************************************************************************************************************

  function private.tobiaswallet_init ()

    --------------------------------------------------------------------------------------------
    ObjMultiSet({ 
      { "spr_deploy_inv_tobiaswallet_tobiascode", { event_mdown = private.get_tobiascode } }, 

      { "obj_deploy_inv_tobiaswallet_clk_tobiaswallet",         { event_mdown = private.clk_tobiaswallet         } },  
      { "obj_deploy_inv_tobiaswallet_clk_tobiaswallet_photo",   { event_mdown = private.clk_tobiaswallet_photo   } },
      { "obj_deploy_inv_tobiaswallet_clk_tobiaswallet_photo_1", { event_mdown = private.clk_tobiaswallet_photo_1 } },
 
      { "obj_deploy_inv_tobiaswallet_clk_tobiaswallet_cutaway",   { event_mdown = private.clk_tobiaswallet_cutaway   } },
      { "obj_deploy_inv_tobiaswallet_clk_tobiaswallet_cutaway_1", { event_mdown = private.clk_tobiaswallet_cutaway_1 } },   
   
      { "obj_deploy_inv_tobiaswallet_clk_tobiaswallet_moneys",    { event_mdown = private.clk_tobiaswallet_moneys    } },
      { "obj_deploy_inv_tobiaswallet_clk_tobiaswallet_moneys_1",  { event_mdown = private.clk_tobiaswallet_moneys_1  } },  
         
    });

    --------------------------------------------------------------------------------------------
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_tobiaswallet" ] = {
        type = "click",
        use_place = "obj_deploy_inv_tobiaswallet_clk_tobiaswallet",
        room = "int_deploy_inv",
        zz = "deploy_inv_tobiaswallet",
        zz_gate = "inv_tobiaswallet"
    };
    function clk_tobiaswallet_beg ()

      ObjDelete( "obj_deploy_inv_tobiaswallet_clk_tobiaswallet" );

    end;
    function clk_tobiaswallet_end ()

      ObjDelete( "spr_deploy_inv_tobiaswallet_tobiaswallet" );

      ObjMultiSet({ 
        { "obj_deploy_inv_tobiaswallet_tobiaswallet_open" ,        { alp = 1                     } },
        { "obj_deploy_inv_tobiaswallet_clk_tobiaswallet_photo" ,   { input = true, active = true } },
        { "obj_deploy_inv_tobiaswallet_clk_tobiaswallet_moneys" ,  { input = true, active = true } },
        { "obj_deploy_inv_tobiaswallet_clk_tobiaswallet_cutaway" , { input = true, active = true } },
      });

    end;
    cmn.AddSubscriber( "clk_tobiaswallet_beg", clk_tobiaswallet_beg, "inv_tobiaswallet" );
    cmn.AddSubscriber( "clk_tobiaswallet_end", clk_tobiaswallet_end, "inv_tobiaswallet" );
    cmn.AddSubscriber( "clk_tobiaswallet",     clk_tobiaswallet_beg, "inv_tobiaswallet" );
    cmn.AddSubscriber( "clk_tobiaswallet",     clk_tobiaswallet_end, "inv_tobiaswallet" );

    --------------------------------------------------------------------------------------------
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_tobiaswallet_photo" ] = {
        type = "click",
        use_place = "obj_deploy_inv_tobiaswallet_clk_tobiaswallet_photo",
        room = "int_deploy_inv",
        zz = "deploy_inv_tobiaswallet",
        zz_gate = "inv_tobiaswallet"
    };
    function clk_tobiaswallet_photo_beg ()

      ObjDelete( "obj_deploy_inv_tobiaswallet_clk_tobiaswallet_photo" );

    end;
    function clk_tobiaswallet_photo_end ()

      ObjMultiSet({ 
        { "spr_deploy_inv_tobiaswallet_photo" ,                   { pos_x = -215, pos_y = -93,  } },
        { "obj_deploy_inv_tobiaswallet_clk_tobiaswallet_photo_1", { input = true, active = true } },
      });

    end;
    cmn.AddSubscriber( "clk_tobiaswallet_photo_beg", clk_tobiaswallet_photo_beg, "inv_tobiaswallet" );
    cmn.AddSubscriber( "clk_tobiaswallet_photo_end", clk_tobiaswallet_photo_end, "inv_tobiaswallet" );
    cmn.AddSubscriber( "clk_tobiaswallet_photo",     clk_tobiaswallet_photo_beg, "inv_tobiaswallet" );
    cmn.AddSubscriber( "clk_tobiaswallet_photo",     clk_tobiaswallet_photo_end, "inv_tobiaswallet" );

    --------------------------------------------------------------------------------------------
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_tobiaswallet_photo_1" ] = {
        type = "click",
        use_place = "obj_deploy_inv_tobiaswallet_clk_tobiaswallet_photo_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_tobiaswallet",
        zz_gate = "inv_tobiaswallet"
    };
    function clk_tobiaswallet_photo_1_beg ()

      ObjDelete( "obj_deploy_inv_tobiaswallet_clk_tobiaswallet_photo_1" );

    end;
    function clk_tobiaswallet_photo_1_end ()

      ObjDelete( "spr_deploy_inv_tobiaswallet_photo" );
      ObjSet( "spr_deploy_inv_tobiaswallet_tobiascode", { alp = 1, input = true, active = true } )

    end;
    cmn.AddSubscriber( "clk_tobiaswallet_photo_1_beg", clk_tobiaswallet_photo_1_beg, "inv_tobiaswallet" );
    cmn.AddSubscriber( "clk_tobiaswallet_photo_1_end", clk_tobiaswallet_photo_1_end, "inv_tobiaswallet" );
    cmn.AddSubscriber( "clk_tobiaswallet_photo_1",     clk_tobiaswallet_photo_1_beg, "inv_tobiaswallet" );
    cmn.AddSubscriber( "clk_tobiaswallet_photo_1",     clk_tobiaswallet_photo_1_end, "inv_tobiaswallet" );

    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_tobiascode" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_tobiaswallet_tobiascode",
        room = "int_deploy_inv",
        zz = "deploy_inv_tobiaswallet",
        zz_gate = "inv_tobiaswallet"
    };

    function get_tobiascode_inv ()
      
      interface.InventoryItemAdd( "inv_tobiascode", "spr_deploy_inv_tobiaswallet_tobiascode" );
      interface.InventoryItemRemove( "inv_tobiaswallet" );

    end;
    cmn.AddSubscriber( "get_tobiascode", get_tobiascode_inv );
    --------------------------------------------------------------------------------------------

    --------------------------------------------------------------------------------------------
    --------------------------------------------------------------------------------------------
    function clk_tobiaswallet_cutaway_beg ()

      ObjSet( "obj_deploy_inv_tobiaswallet_clk_tobiaswallet_cutaway", { input = false, active = false } );

    end;
    function clk_tobiaswallet_cutaway_end ()

      ObjMultiSet({ 
        { "obj_deploy_inv_tobiaswallet_clk_tobiaswallet_cutaway_1" , { input = true, active = true } },
        { "spr_deploy_inv_tobiaswallet_cutaway" ,                    { pos_x = 210 , pos_y = -116 } },
      });

    end;
    cmn.AddSubscriber( "clk_tobiaswallet_cutaway_beg", clk_tobiaswallet_cutaway_beg, "inv_tobiaswallet" );
    cmn.AddSubscriber( "clk_tobiaswallet_cutaway_end", clk_tobiaswallet_cutaway_end, "inv_tobiaswallet" );
    cmn.AddSubscriber( "clk_tobiaswallet_cutaway",     clk_tobiaswallet_cutaway_beg, "inv_tobiaswallet" );
    cmn.AddSubscriber( "clk_tobiaswallet_cutaway",     clk_tobiaswallet_cutaway_end, "inv_tobiaswallet" );

    --------------------------------------------------------------------------------------------
    --------------------------------------------------------------------------------------------
    function clk_tobiaswallet_cutaway_1_beg ()

      ObjSet( "obj_deploy_inv_tobiaswallet_clk_tobiaswallet_cutaway_1", { input = false, active = false } );

    end;
    function clk_tobiaswallet_cutaway_1_end ()

      ObjMultiSet({ 
        { "obj_deploy_inv_tobiaswallet_clk_tobiaswallet_cutaway" , { input = true, active = true } },
        { "spr_deploy_inv_tobiaswallet_cutaway" ,                  { pos_x = 228 , pos_y = 5     } },
      });

    end;
    cmn.AddSubscriber( "clk_tobiaswallet_cutaway_1_beg", clk_tobiaswallet_cutaway_1_beg, "inv_tobiaswallet" );
    cmn.AddSubscriber( "clk_tobiaswallet_cutaway_1_end", clk_tobiaswallet_cutaway_1_end, "inv_tobiaswallet" );
    cmn.AddSubscriber( "clk_tobiaswallet_cutaway_1",     clk_tobiaswallet_cutaway_1_beg, "inv_tobiaswallet" );
    cmn.AddSubscriber( "clk_tobiaswallet_cutaway_1",     clk_tobiaswallet_cutaway_1_end, "inv_tobiaswallet" );

    --------------------------------------------------------------------------------------------
    --------------------------------------------------------------------------------------------
    function clk_tobiaswallet_moneys_beg ()

      ObjSet( "obj_deploy_inv_tobiaswallet_clk_tobiaswallet_moneys", { input = false, active = false } );

    end;
    function clk_tobiaswallet_moneys_end ()

      ObjMultiSet({ 
        { "obj_deploy_inv_tobiaswallet_clk_tobiaswallet_moneys_1" , { input = true, active = true } },
        { "obj_deploy_inv_tobiaswallet_moneys" ,                    { alp = 1                     } },
      });

    end;
    cmn.AddSubscriber( "clk_tobiaswallet_moneys_beg", clk_tobiaswallet_moneys_beg, "inv_tobiaswallet" );
    cmn.AddSubscriber( "clk_tobiaswallet_moneys_end", clk_tobiaswallet_moneys_end, "inv_tobiaswallet" );
    cmn.AddSubscriber( "clk_tobiaswallet_moneys",     clk_tobiaswallet_moneys_beg, "inv_tobiaswallet" );
    cmn.AddSubscriber( "clk_tobiaswallet_moneys",     clk_tobiaswallet_moneys_end, "inv_tobiaswallet" );

    --------------------------------------------------------------------------------------------
    --------------------------------------------------------------------------------------------
    function clk_tobiaswallet_moneys_1_beg ()

      ObjSet( "obj_deploy_inv_tobiaswallet_clk_tobiaswallet_moneys_1", { input = false, active = false } );

    end;
    function clk_tobiaswallet_moneys_1_end ()

      ObjMultiSet({ 
        { "obj_deploy_inv_tobiaswallet_clk_tobiaswallet_moneys" , { input = true, active = true } },
        { "obj_deploy_inv_tobiaswallet_moneys" ,                  { alp = 0                     } },
      });

    end;
    cmn.AddSubscriber( "clk_tobiaswallet_moneys_1_beg", clk_tobiaswallet_moneys_1_beg, "inv_tobiaswallet" );
    cmn.AddSubscriber( "clk_tobiaswallet_moneys_1_end", clk_tobiaswallet_moneys_1_end, "inv_tobiaswallet" );
    cmn.AddSubscriber( "clk_tobiaswallet_moneys_1",     clk_tobiaswallet_moneys_1_beg, "inv_tobiaswallet" );
    cmn.AddSubscriber( "clk_tobiaswallet_moneys_1",     clk_tobiaswallet_moneys_1_end, "inv_tobiaswallet" );

    --------------------------------------------------------------------------------------------
    --------------------------------------------------------------------------------------------

  end; 

  ---------------------------------------------------------------------------------------------
  function private.clk_tobiaswallet ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_tobiaswallet" );
      cmn.CallEventHandler( "clk_tobiaswallet_end", "inv_tobiaswallet" );

    end;

    cmn.CallEventHandler( "clk_tobiaswallet_beg", "inv_tobiaswallet" );

    ObjAnimate( "spr_deploy_inv_tobiaswallet_tobiaswallet", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 1, 
      0.3, 3, 0 
    } );
    ObjAnimate( "obj_deploy_inv_tobiaswallet_tobiaswallet_open", "alp", 0, 0, "", 
    { 
      0.0, 0, 0, 
      0.3, 3, 1 
    } );

  end;
  ---------------------------------------------------------------------------------------------
  function private.clk_tobiaswallet_photo ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_tobiaswallet_photo" );
      cmn.CallEventHandler( "clk_tobiaswallet_photo_end", "inv_tobiaswallet" );

    end;

    cmn.CallEventHandler( "clk_tobiaswallet_photo_beg", "inv_tobiaswallet" );

    ObjAnimate( "spr_deploy_inv_tobiaswallet_photo", "pos_xy", 0, 0, func_end, 
    { 
      0.0, 0, -188,  54, 
      0.3, 0, -215, -93, 
    } );

  end;
  ---------------------------------------------------------------------------------------------
  function private.clk_tobiaswallet_photo_1 ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_tobiaswallet_photo_1" );
      cmn.CallEventHandler( "clk_tobiaswallet_photo_1_end", "inv_tobiaswallet" );

    end;

    cmn.CallEventHandler( "clk_tobiaswallet_photo_1_beg", "inv_tobiaswallet" );

    ObjAnimate( "spr_deploy_inv_tobiaswallet_photo", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 1, 
      0.3, 0, 0, 
    } );

    ObjAnimate( "spr_deploy_inv_tobiaswallet_tobiascode", "alp", 0, 0, "", 
    { 
      0.0, 0, 0, 
      0.3, 0, 1, 
    } );

  end;
  ---------------------------------------------------------------------------------------------
  function private.get_tobiascode ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_tobiascode" );
    cmn.CallEventHandler( "get_tobiascode", "inv_tobiaswallet" );
    common_impl.HideDeployInv();

  end;

  ---------------------------------------------------------------------------------------------
  ---------------------------------------------------------------------------------------------
  ---------------------------------------------------------------------------------------------
  function private.clk_tobiaswallet_cutaway ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.CallEventHandler( "clk_tobiaswallet_cutaway_end", "inv_tobiaswallet" );

    end;

    cmn.CallEventHandler( "clk_tobiaswallet_cutaway_beg", "inv_tobiaswallet" );

    ObjAnimate( "spr_deploy_inv_tobiaswallet_cutaway", "pos_xy", 0, 0, func_end, 
    { 
      0.0, 0, 228,    5, 
      0.3, 0, 210, -116, 
    } );

  end;
  ---------------------------------------------------------------------------------------------
  function private.clk_tobiaswallet_cutaway_1 ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.CallEventHandler( "clk_tobiaswallet_cutaway_1_end", "inv_tobiaswallet" );

    end;

    cmn.CallEventHandler( "clk_tobiaswallet_cutaway_1_beg", "inv_tobiaswallet" );

    ObjAnimate( "spr_deploy_inv_tobiaswallet_cutaway", "pos_xy", 0, 0, func_end, 
    { 
      0.0, 0, 210, -116,
      0.3, 0, 228,    5,  
    } );

  end;
  ---------------------------------------------------------------------------------------------
  function private.clk_tobiaswallet_moneys ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.CallEventHandler( "clk_tobiaswallet_moneys_end", "inv_tobiaswallet" );

    end;

    cmn.CallEventHandler( "clk_tobiaswallet_moneys_beg", "inv_tobiaswallet" );

    ObjAnimate( "obj_deploy_inv_tobiaswallet_moneys", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0,
      0.3, 0, 1,  
    } );

  end;
  ---------------------------------------------------------------------------------------------
  function private.clk_tobiaswallet_moneys_1 ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.CallEventHandler( "clk_tobiaswallet_moneys_1_end", "inv_tobiaswallet" );

    end;

    cmn.CallEventHandler( "clk_tobiaswallet_moneys_1_beg", "inv_tobiaswallet" );

    ObjAnimate( "obj_deploy_inv_tobiaswallet_moneys", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 1,
      0.3, 0, 0,  
    } );

  end;

--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** watch *** () end;
--*********************************************************************************************************************

  function private.watch_init ()

    --------------------------------------------------------------------------------------------
    ObjMultiSet({ 
      { "spr_deploy_inv_watch_smallslider2",     { event_mdown = private.get_smallslider2 } },

      { "obj_deploy_inv_watch_clk_watch_back" ,  { event_mdown = private.clk_watch_back   } },
      { "obj_deploy_inv_watch_clk_watch_cover" , { event_mdown = private.clk_watch_cover  } },          
    });

    --------------------------------------------------------------------------------------------
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_watch_back" ] = {
          type = "click",
          use_place = "obj_deploy_inv_watch_clk_watch_back",
          room = "int_deploy_inv",
          zz = "deploy_inv_watch",
          zz_gate = "inv_watch"
      };
      function clk_watch_back_beg ()

        ObjDelete( "obj_deploy_inv_watch_clk_watch_back" );

      end;
      function clk_watch_back_end ()

        ObjDelete( "spr_deploy_inv_watch_watch" );

        ObjMultiSet({ 
          { "obj_deploy_inv_watch_back" ,             { alp = 1                     } },
          { "obj_deploy_inv_watch_clk_watch_cover" ,  { input = true, active = true } },
        });

      end;
      cmn.AddSubscriber( "clk_watch_back_beg", clk_watch_back_beg, "inv_watch" );
      cmn.AddSubscriber( "clk_watch_back_end", clk_watch_back_end, "inv_watch" );
      cmn.AddSubscriber( "clk_watch_back",     clk_watch_back_beg, "inv_watch" );
      cmn.AddSubscriber( "clk_watch_back",     clk_watch_back_end, "inv_watch" );

    --------------------------------------------------------------------------------------------
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_watch_cover" ] = {
          type = "click",
          use_place = "obj_deploy_inv_watch_clk_watch_cover",
          room = "int_deploy_inv",
          zz = "deploy_inv_watch",
          zz_gate = "inv_watch"
      };
      function clk_watch_cover_beg ()

        ObjDelete( "obj_deploy_inv_watch_clk_watch_cover" );

      end;
      function clk_watch_cover_end ()

        ObjMultiSet({ 
          { "spr_deploy_inv_watch_cover" ,       { pos_x = 245, pos_y = 103    } },
          { "spr_deploy_inv_watch_smallslider2", { input = true, active = true } },
        });        

      end;
      cmn.AddSubscriber( "clk_watch_cover_beg", clk_watch_cover_beg, "inv_watch" );
      cmn.AddSubscriber( "clk_watch_cover_end", clk_watch_cover_end, "inv_watch" );
      cmn.AddSubscriber( "clk_watch_cover",     clk_watch_cover_beg, "inv_watch" );
      cmn.AddSubscriber( "clk_watch_cover",     clk_watch_cover_end, "inv_watch" );

    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_smallslider2" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_watch_smallslider2",
        room = "int_deploy_inv",
        zz = "deploy_inv_watch",
        zz_gate = "inv_watch"
    };

    function get_smallslider2_inv ()
      
      interface.InventoryItemAdd( "inv_smallslider2", "spr_deploy_inv_watch_smallslider2" );
      interface.InventoryItemRemove( "inv_watch" );

    end;
    cmn.AddSubscriber( "get_smallslider2", get_smallslider2_inv );
    --------------------------------------------------------------------------------------------

  end; 

  ---------------------------------------------------------------------------------------------
  function private.get_smallslider2 ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_smallslider2" );
    cmn.CallEventHandler( "get_smallslider2", "inv_watch" );
    common_impl.HideDeployInv();

  end;

 --------------------------------------------------------------------------------------------
  function private.clk_watch_back ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_watch_back" );
      cmn.CallEventHandler( "clk_watch_back_end", "inv_watch" );

    end;

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk7", 0, "", 0 );

    cmn.CallEventHandler( "clk_watch_back_beg", "inv_watch" );

    ObjAnimate( "spr_deploy_inv_watch_watch", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 1, 
      0.3, 3, 0 
    } );
    ObjAnimate( "obj_deploy_inv_watch_back", "alp", 0, 0, "", 
    { 
      0.0, 0, 0, 
      0.3, 3, 1 
    } );

  end;

 --------------------------------------------------------------------------------------------
  function private.clk_watch_cover ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_watch_cover" );
      cmn.CallEventHandler( "clk_watch_cover_end", "inv_watch" );

    end;

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

    cmn.CallEventHandler( "clk_watch_cover_beg", "inv_watch" );

    ObjAnimate( "spr_deploy_inv_watch_cover", "pos_xy", 0, 0, func_end, 
    { 
      0.0, 0, -96, -130, 
      0.5, 0, 245,  103,
    } );

  end;

--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** leadedbox *** () end;
--*********************************************************************************************************************

  function private.leadedbox_init ()

    --------------------------------------------------------------------------------------------
    ObjMultiSet({ 
      { "spr_deploy_inv_leadedbox_photopart2",    { event_mdown = private.get_photopart2   } },  
      { "spr_deploy_inv_leadedbox_tobiaspermit",  { event_mdown = private.get_tobiaspermit } },

      { "obj_deploy_inv_leadedbox_clk_leadedbox", { event_mdown = private.clk_leadedbox    } },           
    });

    --------------------------------------------------------------------------------------------
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_leadedbox" ] = {
          type = "click",
          use_place = "obj_deploy_inv_leadedbox_clk_leadedbox",
          room = "int_deploy_inv",
          zz = "deploy_inv_leadedbox",
          zz_gate = "inv_leadedbox"
      };
      function clk_leadedbox_beg ()

        ObjDelete( "obj_deploy_inv_leadedbox_clk_leadedbox" );

      end;
      function clk_leadedbox_end ()

        ObjMultiSet({ 
          { "obj_deploy_inv_leadedbox_open",       { alp = 1                     } }, 
          { "spr_deploy_inv_leadedbox_photopart2", { input = true, active = true } },           
        });        
        
        ObjDelete( "spr_deploy_inv_leadedbox_close" );

      end;
      cmn.AddSubscriber( "clk_leadedbox_beg", clk_leadedbox_beg, "inv_leadedbox" );
      cmn.AddSubscriber( "clk_leadedbox_end", clk_leadedbox_end, "inv_leadedbox" );
      cmn.AddSubscriber( "clk_leadedbox",     clk_leadedbox_beg, "inv_leadedbox" );
      cmn.AddSubscriber( "clk_leadedbox",     clk_leadedbox_end, "inv_leadedbox" );
    --------------------------------------------------------------------------------------------
    --------------------------------------------------------------------------------------------

    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_photopart2" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_leadedbox_photopart2",
        room = "int_deploy_inv",
        zz = "deploy_inv_leadedbox",
        zz_gate = "inv_leadedbox"
    };

    function get_photopart2_inv ()
      
      interface.InventoryItemAdd( "inv_photopart2", "spr_deploy_inv_leadedbox_photopart2" );

    end;
    function get_photopart2_inv_zz ()

      ObjSet( "spr_deploy_inv_leadedbox_tobiaspermit", { input = true, active = true } );

    end;

    cmn.AddSubscriber( "get_photopart2", get_photopart2_inv );
    cmn.AddSubscriber( "get_photopart2", get_photopart2_inv_zz, "inv_leadedbox" );
    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_tobiaspermit" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_leadedbox_tobiaspermit",
        room = "int_deploy_inv",
        zz = "deploy_inv_leadedbox",
        zz_gate = "inv_leadedbox"
    };

    function get_tobiaspermit_inv ()
      
      interface.InventoryItemAdd( "inv_tobiaspermit", "spr_deploy_inv_leadedbox_tobiaspermit" );
      interface.InventoryItemRemove( "inv_leadedbox" );


    end;
    cmn.AddSubscriber( "get_tobiaspermit", get_tobiaspermit_inv );

  end; 

  ---------------------------------------------------------------------------------------------
  function private.get_photopart2 ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_photopart2" );
    cmn.CallEventHandler( "get_photopart2", "inv_leadedbox" );

  end;

  ---------------------------------------------------------------------------------------------
  function private.get_tobiaspermit ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_tobiaspermit" );
    cmn.CallEventHandler( "get_tobiaspermit", "inv_leadedbox" );

    common_impl.HideDeployInv();

  end;
 --------------------------------------------------------------------------------------------
  function private.clk_leadedbox ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_leadedbox" );
      cmn.CallEventHandler( "clk_leadedbox_end", "inv_leadedbox" );

    end;

    cmn.CallEventHandler( "clk_leadedbox_beg", "inv_leadedbox" );

    ObjAnimate( "spr_deploy_inv_leadedbox_close", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 1, 
      0.3, 3, 0 
    } );
    ObjAnimate( "obj_deploy_inv_leadedbox_open", "alp", 0, 0, "", 
    { 
      0.0, 0, 0, 
      0.3, 3, 1 
    } );

  end;

--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** ropetrap *** () end;
--*********************************************************************************************************************

  function private.ropetrap_init ()

    --------------------------------------------------------------------------------------------
    ObjMultiSet({ 
      { "spr_deploy_inv_ropetrap_lasso",                { event_mdown = private.get_lasso                } },  
      { "spr_deploy_inv_ropetrap_fireextinguisherhead", { event_mdown = private.get_fireextinguisherhead } },

      { "obj_deploy_inv_ropetrap_clk_rope_1",           { event_mdown = private.clk_ropetrap_1           } },
      { "obj_deploy_inv_ropetrap_clk_rope_2",           { event_mdown = private.clk_ropetrap_2           } },        
    });

    --------------------------------------------------------------------------------------------
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_ropetrap_1" ] = {
          type = "click",
          use_place = "obj_deploy_inv_ropetrap_clk_rope_1",
          room = "int_deploy_inv",
          zz = "deploy_inv_ropetrap",
          zz_gate = "inv_ropetrap"
      };
      function clk_ropetrap_1_beg ()

        ObjDelete( "obj_deploy_inv_ropetrap_clk_rope_1" );

      end;
      function clk_ropetrap_1_end ()
  
        ObjMultiSet({ 
          { "spr_deploy_inv_ropetrap_rope",       { alp = 1                     } },  
          { "obj_deploy_inv_ropetrap_clk_rope_2", { input = true, active = true } },
       
        });

        ObjDelete( "spr_deploy_inv_ropetrap_ropetrap2" );
        ObjDelete( "spr_deploy_inv_ropetrap_ropetrap3" );       

      end;
      cmn.AddSubscriber( "clk_ropetrap_1_beg", clk_ropetrap_1_beg, "inv_ropetrap" );
      cmn.AddSubscriber( "clk_ropetrap_1_end", clk_ropetrap_1_end, "inv_ropetrap" );
      cmn.AddSubscriber( "clk_ropetrap_1",     clk_ropetrap_1_beg, "inv_ropetrap" );
      cmn.AddSubscriber( "clk_ropetrap_1",     clk_ropetrap_1_end, "inv_ropetrap" );

    --------------------------------------------------------------------------------------------
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_ropetrap_2" ] = {
          type = "click",
          use_place = "obj_deploy_inv_ropetrap_clk_rope_2",
          room = "int_deploy_inv",
          zz = "deploy_inv_ropetrap",
          zz_gate = "inv_ropetrap"
      };
      function clk_ropetrap_2_beg ()

        ObjDelete( "obj_deploy_inv_ropetrap_clk_rope_2" );

      end;
      function clk_ropetrap_2_end ()

        ObjSet( "spr_deploy_inv_ropetrap_lasso", { alp = 1, input = true, active = true } );
        
        ObjDelete( "spr_deploy_inv_ropetrap_rope" );

      end;
      cmn.AddSubscriber( "clk_ropetrap_2_beg", clk_ropetrap_2_beg, "inv_ropetrap" );
      cmn.AddSubscriber( "clk_ropetrap_2_end", clk_ropetrap_2_end, "inv_ropetrap" );
      cmn.AddSubscriber( "clk_ropetrap_2",     clk_ropetrap_2_beg, "inv_ropetrap" );
      cmn.AddSubscriber( "clk_ropetrap_2",     clk_ropetrap_2_end, "inv_ropetrap" );

    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_lasso" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_ropetrap_lasso",
        room = "int_deploy_inv",
        zz = "deploy_inv_ropetrap",
        zz_gate = "inv_ropetrap"
    };

    function get_lasso_inv ()
      
      interface.InventoryItemAdd( "inv_lasso", "spr_deploy_inv_ropetrap_lasso" );
      interface.InventoryItemRemove( "inv_ropetrap" ); 

    end;
    cmn.AddSubscriber( "get_lasso", get_lasso_inv );
    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_fireextinguisherhead" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_ropetrap_fireextinguisherhead",
        room = "int_deploy_inv",
        zz = "deploy_inv_ropetrap",
        zz_gate = "inv_ropetrap"
    };

    function get_fireextinguisherhead_inv ()
      
      interface.InventoryItemAdd( "inv_fireextinguisherhead", "spr_deploy_inv_ropetrap_fireextinguisherhead" );
      if not cmn.IsEventDone( "get_engravedknife" ) then 
        cmn.SetInvPlusRGB( "ropetrap", false ); 
      end;

    end;
    function get_fireextinguisherhead_inv_zz ()

      ObjSet( "obj_deploy_inv_ropetrap_use_engravedknife", { input = true, active = true } );
      ObjDelete( "spr_deploy_inv_ropetrap_fireextinguisherhead_over" );

    end;

    cmn.AddSubscriber( "get_fireextinguisherhead", get_fireextinguisherhead_inv );
    cmn.AddSubscriber( "get_fireextinguisherhead", get_fireextinguisherhead_inv_zz, "inv_ropetrap" );

    --------------------------------------------------------------------------------------------
    -- USE -------------------------------------------------------------------------------------

    common_impl.hint[ "use_engravedknife" ] = {
        type = "use",
        inv_obj = "inv_engravedknife",
        use_place = "obj_deploy_inv_ropetrap_use_engravedknife",
        room = "int_deploy_inv",
        zz = "deploy_inv_ropetrap",
        zz_gate = "inv_ropetrap"
    };    
    function use_engravedknife_beg ()  
    
      ObjDelete( "obj_deploy_inv_ropetrap_use_engravedknife" ); 
      interface.InventoryItemRemove( "inv_engravedknife" );

      ObjMultiSet({
        { "spr_deploy_inv_ropetrap_ropetrap3", { alp = 0 } }, 
        { "anm_deploy_inv_ropetrap_rope",      { alp = 1 } },        
      });
      ObjDelete( "spr_deploy_inv_ropetrap_ropetrap" );

    end;

    function use_engravedknife_end ()
     
      ObjMultiSet({ 
        { "spr_deploy_inv_ropetrap_ropetrap2",  { alp = 1                     } },
        { "spr_deploy_inv_ropetrap_ropetrap3",  { alp = 1                     } },
        { "obj_deploy_inv_ropetrap_clk_rope_1", { input = true, active = true } },        
      });
      
      ObjDelete( "anm_deploy_inv_ropetrap_rope" );

    end;
    cmn.AddSubscriber( "use_engravedknife", use_engravedknife_beg );
    cmn.AddSubscriber( "use_engravedknife", use_engravedknife_end, "inv_ropetrap" );
    cmn.AddSubscriber( "use_engravedknife_beg", use_engravedknife_beg );
    cmn.AddSubscriber( "use_engravedknife_end", use_engravedknife_end, "inv_ropetrap" );

  end; 
  ---------------------------------------------------------------------------------------------

  function private.get_lasso ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_lasso" );
    cmn.CallEventHandler( "get_lasso", "inv_ropetrap" );

    if cmn.IsEventDone( "get_fireextinguisherhead" ) then 
      common_impl.HideDeployInv();
    end;

  end;

  ---------------------------------------------------------------------------------------------

  function private.get_fireextinguisherhead ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_fireextinguisherhead" );
    cmn.CallEventHandler( "get_fireextinguisherhead", "inv_ropetrap" );

    if cmn.IsEventDone( "get_lasso" ) then 
      common_impl.HideDeployInv();
    end;

  end;

  ---------------------------------------------------------------------------------------------
  -- USE ---------------------------------------------------------------------------------------
  function public.use_engravedknife ()

    local item = "inv_engravedknife";

    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_ropetrap_use_engravedknife" ) and cmn.IsEventDone( "get_fireextinguisherhead" ) )  then

      cmn.CallEventHandler( "use_engravedknife_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_engravedknife" );
        cmn.CallEventHandler( "use_engravedknife_end", "inv_ropetrap" );
        
      end;

      cmn.Lock( true );

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_engravedknife", 0, "", 0 );

      AnimPlay( "anm_deploy_inv_ropetrap_rope", "DoAnim", func_end );

      return true; 

    end;

    return false;

  end;

  ---------------------------------------------------------------------------------------------
  -- CLK ---------------------------------------------------------------------------------------

  function private.clk_ropetrap_1 ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_ropetrap_1" );
      cmn.CallEventHandler( "clk_ropetrap_1_end", "inv_ropetrap" );

    end;

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_clk_rope", 0, "", 0 );

    cmn.CallEventHandler( "clk_ropetrap_1_beg", "inv_ropetrap" );

    ObjAnimate( "spr_deploy_inv_ropetrap_rope", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0, 
      0.3, 3, 1 
    } );
    ObjAnimate( "spr_deploy_inv_ropetrap_ropetrap2", "alp", 0, 0, "", 
    { 
      0.0, 0, 1, 
      0.3, 3, 0 
    } );
    ObjAnimate( "spr_deploy_inv_ropetrap_ropetrap3", "alp", 0, 0, "", 
    { 
      0.0, 0, 1, 
      0.3, 3, 0 
    } );

  end;

  ---------------------------------------------------------------------------------------------
  function private.clk_ropetrap_2 ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_ropetrap_2" );
      cmn.CallEventHandler( "clk_ropetrap_2_end", "inv_ropetrap" );

    end;

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_clk_rope", 0, "", 0 );

    cmn.CallEventHandler( "clk_ropetrap_2_beg", "inv_ropetrap" );

    ObjAnimate( "spr_deploy_inv_ropetrap_lasso", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0, 
      0.3, 3, 1 
    } );
    ObjAnimate( "spr_deploy_inv_ropetrap_rope", "alp", 0, 0, "", 
    { 
      0.0, 0, 1, 
      0.3, 3, 0 
    } );

  end;
  ---------------------------------------------------------------------------------------------
  ---------------------------------------------------------------------------------------------

--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** terencemedallion *** () end;
--*********************************************************************************************************************

  function private.terencemedallion_init ()

    --------------------------------------------------------------------------------------------
    ObjMultiSet({ 
      { "spr_deploy_inv_terencemedallion_terencepermit", { event_mdown = private.get_terencepermit    } },
      { "obj_deploy_inv_terencemedallion_clk",           { event_mdown = private.clk_terencemedallion } },            
    });

    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_terencepermit" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_terencemedallion_terencepermit",
        room = "int_deploy_inv",
        zz = "deploy_inv_terencemedallion",
        zz_gate = "inv_terencemedallion"
    };

    function get_terencepermit_inv ()
      
      interface.InventoryItemAdd( "inv_terencepermit", "spr_deploy_inv_terencemedallion_terencepermit" );
      interface.InventoryItemRemove( "inv_terencemedallion" );

    end;
    cmn.AddSubscriber( "get_terencepermit", get_terencepermit_inv );
    --------------------------------------------------------------------------------------------
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_terencemedallion" ] = {
          type = "click",
          use_place = "obj_deploy_inv_terencemedallion_clk",
          room = "int_deploy_inv",
          zz = "deploy_inv_terencemedallion",
          zz_gate = "inv_terencemedallion"
      };
      function clk_terencemedallion_beg ()

        ObjDelete( "obj_deploy_inv_terencemedallion_clk" );

      end;
      function clk_terencemedallion_end ()

        ObjMultiSet({ 
          { "spr_deploy_inv_terencemedallion_cover_open",     { alp = 1                              } },
          { "spr_deploy_inv_terencemedallion_terencepermit",  { alp = 1, input = true, active = true } },            
        });        

        ObjDelete( "spr_deploy_inv_terencemedallion_cover" );

      end;
      cmn.AddSubscriber( "clk_terencemedallion_beg", clk_terencemedallion_beg, "inv_terencemedallion" );
      cmn.AddSubscriber( "clk_terencemedallion_end", clk_terencemedallion_end, "inv_terencemedallion" );
      cmn.AddSubscriber( "clk_terencemedallion",     clk_terencemedallion_beg, "inv_terencemedallion" );
      cmn.AddSubscriber( "clk_terencemedallion",     clk_terencemedallion_end, "inv_terencemedallion" );
    --------------------------------------------------------------------------------------------
    --------------------------------------------------------------------------------------------
  end; 

  ---------------------------------------------------------------------------------------------
  function private.get_terencepermit ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_terencepermit" );
    cmn.CallEventHandler( "get_terencepermit", "inv_terencemedallion" );
    common_impl.HideDeployInv();

  end;
 --------------------------------------------------------------------------------------------
  function private.clk_terencemedallion ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_terencemedallion" );
      cmn.CallEventHandler( "clk_terencemedallion_end", "inv_terencemedallion" );

    end;

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

    cmn.CallEventHandler( "clk_terencemedallion_beg", "inv_terencemedallion" );

    ObjAnimate( "spr_deploy_inv_terencemedallion_cover", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 1, 
      0.3, 3, 0 
    } );
    ObjAnimate( "spr_deploy_inv_terencemedallion_cover_open", "alp", 0, 0, "", 
    { 
      0.0, 0, 0, 
      0.3, 3, 1 
    } );
    ObjAnimate( "spr_deploy_inv_terencemedallion_terencepermit", "alp", 0, 0, "", 
    { 
      0.0, 0, 0, 
      0.3, 3, 1 
    } );

  end;

--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** cane *** () end;
--*********************************************************************************************************************

  function private.cane_init ()

    --------------------------------------------------------------------------------------------
    ObjMultiSet({ 
      { "spr_deploy_inv_cane_cane_1",   { event_mdown = private.get_decomposedcane } },    
      { "obj_deploy_inv_cane_clk_cane", { event_mdown = private.clk_cane           } },                
    });

    --------------------------------------------------------------------------------------------
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_decomposedcane" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_cane_cane_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_cane",
        zz_gate = "inv_cane"
    };

    function get_decomposedcane_inv ()
      
      interface.InventoryItemAdd( "inv_decomposedcane", "spr_deploy_inv_cane_cane_1" );
      interface.InventoryItemRemove( "inv_cane" );

    end;

    function get_decomposedcane_loc ()
      
      ObjSet( "spr_tortureroom_monitorscreen_tv_up_light", { alp = 1 } );

    end;

    cmn.AddSubscriber( "get_decomposedcane", get_decomposedcane_inv );
    cmn.AddSubscriber( "get_decomposedcane", get_decomposedcane_loc, "rm_tortureroom" );

    --------------------------------------------------------------------------------------------
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_cane" ] = {
          type = "click",
          use_place = "obj_deploy_inv_cane_clk_cane",
          room = "int_deploy_inv",
          zz = "deploy_inv_cane",
          zz_gate = "inv_cane"
      };
      function clk_cane_beg ()

        ObjDelete( "obj_deploy_inv_cane_clk_cane" );

      end;
      function clk_cane_end ()

        ObjMultiSet({ 
          { "spr_deploy_inv_cane_cane_1",  { input  = true } }, 
          { "gfx_deploy_inv_cane_cane_1",  { active = true } },                       
        });        

        ObjDelete( "spr_deploy_inv_cane_cane_2" );

      end;
      cmn.AddSubscriber( "clk_cane_beg", clk_cane_beg, "inv_cane" );
      cmn.AddSubscriber( "clk_cane_end", clk_cane_end, "inv_cane" );
      cmn.AddSubscriber( "clk_cane",     clk_cane_beg, "inv_cane" );
      cmn.AddSubscriber( "clk_cane",     clk_cane_end, "inv_cane" );
    --------------------------------------------------------------------------------------------
    --------------------------------------------------------------------------------------------

  end; 
  ---------------------------------------------------------------------------------------------
  function private.get_decomposedcane ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_decomposedcane" );
    cmn.CallEventHandler( "get_decomposedcane", "inv_cane" );
    cmn.CallEventHandler( "get_decomposedcane", "rm_tortureroom" );
    common_impl.HideDeployInv();

  end;
 --------------------------------------------------------------------------------------------
  function private.clk_cane ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );
      
      cmn.SetEventDone( "clk_cane" );
      cmn.CallEventHandler( "clk_cane_end", "inv_cane" );

    end;

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_opn_cover", 0, "", 0 );

    cmn.CallEventHandler( "clk_cane_beg", "inv_cane" );

    ObjAnimate( "spr_deploy_inv_cane_cane_2", "pos_xy", 0, 0, "", 
    { 
      0.0, 0, 269, -217, 
      0.6, 3, 394, -279 
    } );

    ObjAnimate( "spr_deploy_inv_cane_cane_2", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 1, 
      0.6, 3, 1, 
      1.0, 3, 0  
    } );

  end;
--*********************************************************************************************************************







