-- name=rm_archives_3
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_archives_3";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  
  --ObjMultiSet({ 
  --});
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_archives_3 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gmg_archives_3_minelabyrinth",
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_archives_3", update_game_mode_archives_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_archives_3 = function ()

    local effects_table = 
    {
      "obj_archives_3_anim",
      "vid_archives_3_videoplayer_tv",
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_archives_3", update_performance_mode_archives_3, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_archives_3 () end;
  --------------------------------------------------------------------------------------------
  local opn_archives_3_map = function ()

    common_impl.VisitMapRoom( "archives" );

  end;
  cmn.AddSubscriber( "opn_archives_3", opn_archives_3_map );

  --------------------------------------------------------------------------------------------
  -- function beg_level3 () end;
  --------------------------------------------------------------------------------------------
  local beg_level3 = function ()
  
    interface.InventoryItemAdd( "inv_glassfigurine" );
    interface.InventoryItemAdd( "inv_mapsheet" );
  
  end;
  cmn.AddSubscriber( "beg_level3", beg_level3 );

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_archives_3();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  if ( not cmn.IsEventDone( "see_intro_3" ) ) then

    local widget_settings = {}

    if IsCollectorsEdition() then

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu
      }

    else

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnMenu
      }

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 0 );

    end;

    ObjSet( private.room_objname, { color_r = 0, color_g = 0, color_b = 0 } );
    ObjAttach( "tmr_archives_3_intro", private.room_objname );
    ObjSet( "tmr_archives_3_intro",
    {
      time = 0.001,
      playing = true,
      endtrig = function() private.SeeIntro(); end
    } );

  else

    cmn.CallEventHandler( "opn_archives_3" ); 

  end;

  if ( not cmn.IsEventDone( "beg_level3" ) ) then

    cmn.SetEventDone( "beg_level3" );
    cmn.CallEventHandler( "beg_level3" ); 
  
  end;

  common_impl.MorphItemMorphing();

  common_impl.EnvPlay( { "level3/env/aud_tv_archives_env" }, "", 0.5 );

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_archives_3 ()

   

end;
--*********************************************************************************************************************
function private.SeeIntro ()

  ObjDelete( "tmr_archives_3_intro" ); 

  local func_after = function ()

    common_impl.StopAudio( "sfx", "level3/sfx/aud_terenec_tv", 0.2 );
    common_impl.PlayAudio( "mus", "aud_masked_man_theme_mus", 0 );

    ObjSet( private.room_objname, { color_r = 1, color_g = 1, color_b = 1 } );

    cmn.SetEventDone( "see_intro_3" );
    cmn.CallEventHandler( "see_intro_3" );

    cmn.SetEventDone( "opn_archives_3" );
    cmn.CallEventHandler( "opn_archives_3" ); 

    common_impl.ShowBbt( "bbt_archives3_see_intro" );

    interface.KeyTaskAdd( "escape" );

    local widget_settings = {}

    if IsCollectorsEdition() then

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu
      }

    else

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnMenu
      }

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 1, true );

    end;

  end;

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_terenec_tv", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_archives_3_intro", func_after );

end;

--*********************************************************************************************************************