-- name=rm_examroom
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_examroom";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_window", "room_hub" );
  ObjAttach( "zz_monitors", "room_hub" );
  private.Init_Subroom();
  private.InitAnimations();
  
  ObjMultiSet({ 
    { "spr_window_moleculeamulet3",      { event_mdown = private.get_moleculeamulet3    }},
    { "spr_window_brokenfork",           { event_mdown = private.get_brokenfork         }},
    { "spr_monitors_sensor",             { event_mdown = private.get_sensor             }},
    { "spr_examroom_ropetrap",           { event_mdown = private.get_ropetrap           }},

    { "obj_window_clk_web",              { event_mdown = private.clk_web_amulet3        }},
    { "obj_window_clk_paper",            { event_mdown = private.clk_paper_amulet3      }},
    { "obj_window_clk_brokenfork",       { event_mdown = private.clk_brokenfork         }},

    { "obj_window_use_tweezers",         { event_mdown = private.AnimCLkMoleculeAmulet3 }},
    { "obj_monitors_use_brokenfork",     { event_mdown = private.AnimCLkMonitorsSensor  }},

    { "obj_examroom_trap_clk",           { event_mdown = private.TrapScare  }},

    { "spr_collect2_item_3_5",           { event_mdown = private.get_collect2_item_3_5  }},
    { "spr_examroom_collect_morph_item", { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_3_2" ); end }},
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_examroom = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "grm_examroom_secondfloor",
      "gzz_examroom_monitors",
      "gzz_examroom_window",
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_window",
      "zz_monitors",
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_examroom", update_game_mode_examroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_examroom = function ()

  local effects_table = 
  {
    "obj_examroom_anim",
    "vid_monitors_tv_noise",
    "vid_monitors_tv_noise_1",
    "spr_monitors_tv_light",
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_examroom", update_performance_mode_examroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_examroom () end;
  --------------------------------------------------------------------------------------------
  local opn_examroom_map = function ()

    common_impl.VisitMapRoom( "examroom" );

  end;
  cmn.AddSubscriber( "opn_examroom", opn_examroom_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_moleculeamulet3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_moleculeamulet3" ] = {
    type = "get",
    get_obj = "spr_window_moleculeamulet3",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_examroom_window"
  };
  
  local get_moleculeamulet3_inv = function ()
  
    interface.InventoryItemAdd( "inv_moleculeamulet3", "spr_window_moleculeamulet3" );
  
  end;
  
  local get_moleculeamulet3_closezz = function ()
  
    ObjDelete( "gfx_window_moleculeamulet3" );

    if ( cmn.IsGetCollect2( "get_collect2_item_3_5" ) ) then

      ObjDelete( "gzz_examroom_window" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_moleculeamulet3", get_moleculeamulet3_inv );
  cmn.AddSubscriber( "get_moleculeamulet3", get_moleculeamulet3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brokenfork () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_brokenfork" ] = {
    type = "get",
    get_obj = "spr_window_brokenfork",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_examroom_window"
  };
  
  local get_brokenfork_inv = function ()
  
    interface.InventoryItemAdd( "inv_brokenfork", "spr_window_brokenfork" );
  
  end;
  
  local get_brokenfork_closezz = function ()
  
    ObjDelete( "gfx_window_brokenfork"    );
    ObjDelete( "spr_examroom_window_fork" );
  
  end;
  
  cmn.AddSubscriber( "get_brokenfork", get_brokenfork_inv );
  cmn.AddSubscriber( "get_brokenfork", get_brokenfork_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sensor () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sensor" ] = {
    type = "get",
    get_obj = "spr_monitors_sensor",
    room = private.room_objname,
    zz = "zz_monitors",
    zz_gate = "gzz_examroom_monitors"
  };
  
  local get_sensor_inv = function ()
  
    interface.InventoryItemAdd( "inv_sensor", "spr_monitors_sensor" );
  
  end;
  
  local get_sensor_closezz = function ()

    ObjDelete( "spr_monitors_sensor_shadow" );
    ObjDelete( "gfx_monitors_sensor" );
    ObjDelete( "spr_examroom_monitors2" );

    ObjDelete( "gzz_examroom_monitors" );
  
  end;
  
  cmn.AddSubscriber( "get_sensor", get_sensor_inv );
  cmn.AddSubscriber( "get_sensor", get_sensor_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ropetrap () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ropetrap" ] = {
    type = "get",
    get_obj = "spr_examroom_ropetrap",
    room = private.room_objname
  };
  
  local get_ropetrap_inv = function ()
  
    interface.InventoryItemAdd( "inv_ropetrap", "spr_examroom_ropetrap" );
    ObjSet( "inv_ropetrap", { drag = false } );

  end;
  
  local get_ropetrap_closezz = function ()
  
    ObjDelete( "gfx_examroom_ropetrap" );
  
  end;
  
  cmn.AddSubscriber( "get_ropetrap", get_ropetrap_inv );
  cmn.AddSubscriber( "get_ropetrap", get_ropetrap_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_3_5 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_3_5 = function ()
  
    ObjDelete( "obj_collect2_item_3_5" );

    if ( cmn.IsEventDone( "get_moleculeamulet3" ) ) then

      ObjDelete( "gzz_examroom_window" );

    end;
  
  end;    
  cmn.AddSubscriber( "get_collect2_item_3_5", get_collect2_item_3_5, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_3_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_3_2 = function ()
  
    ObjDelete( "obj_examroom_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_3_2", get_collect_morph_item_3_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tweezers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tweezers" ] = {
    type = "use",
    inv_obj = "inv_tweezers",
    use_place = "obj_window_use_tweezers",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_examroom_window"
  };
  local use_tweezers_inv = function ()
  
    interface.InventoryItemRemove( "inv_tweezers" );
  
  end;
  local use_tweezers_beg = function ()
  
    ObjDelete( "obj_window_use_tweezers" );

    ObjDelete( "spr_window_shadow" );
    ObjDelete( "spr_window_patch"  );

    ObjMultiSet({ 
      { "spr_window_moleculeamulet3", { alp = 0 }},
      { "anm_window_use_tweezers",    { alp = 1 }},
    });
  
  end;
  local use_tweezers_end = function ()
  
    ObjMultiSet({ 
      { "spr_window_moleculeamulet3", { input = true, alp = 1, pos_x = -77, pos_y = 288 }},
      { "gfx_window_moleculeamulet3", { active = true }},
    });

    ObjDelete( "anm_window_use_tweezers" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tweezers", use_tweezers_beg, private.room_objname );
  cmn.AddSubscriber( "use_tweezers", use_tweezers_inv );
  cmn.AddSubscriber( "use_tweezers", use_tweezers_end, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_inv", use_tweezers_inv, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_beg", use_tweezers_beg, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_end", use_tweezers_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_brokenfork () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_brokenfork" ] = {
    type = "use",
    inv_obj = "inv_brokenfork",
    use_place = "obj_monitors_use_brokenfork",
    room = private.room_objname,
    zz = "zz_monitors",
    zz_gate = "gzz_examroom_monitors"
  };
  local use_brokenfork_inv = function ()
  
    interface.InventoryItemRemove( "inv_brokenfork" );
  
  end;
  local use_brokenfork_beg = function ()
  
    ObjDelete( "obj_monitors_use_brokenfork" );
  
  end;
  local use_brokenfork_end = function ()
  
    ObjMultiSet({ 
      { "spr_monitors_sensor",    { alp = 1, input = true  }},
      { "gfx_monitors_sensor",    { active = true }},
      { "spr_examroom_monitors2", { alp = 1       }},
    });

    ObjDelete( "obj_monitors_screws"        );
    ObjDelete( "spr_monitors_screw_patch"   );
    ObjDelete( "obj_monitors_screws_shadow" );
    ObjDelete( "spr_examroom_monitors1"     );
    ObjDelete( "vid_monitors_fork"          );  

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_brokenfork", use_brokenfork_beg, private.room_objname );
  cmn.AddSubscriber( "use_brokenfork", use_brokenfork_inv );
  cmn.AddSubscriber( "use_brokenfork", use_brokenfork_end, private.room_objname );
  cmn.AddSubscriber( "use_brokenfork_inv", use_brokenfork_inv, private.room_objname );
  cmn.AddSubscriber( "use_brokenfork_beg", use_brokenfork_beg, private.room_objname );
  cmn.AddSubscriber( "use_brokenfork_end", use_brokenfork_end, private.room_objname );


  --------------------------------------------------------------------------------------------
  -- function clk_paper_amulet3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_paper_amulet3" ] = {
    type = "click",
    use_place = "obj_window_clk_paper",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_examroom_window"
  };

  local clk_paper_amulet3_beg = function ()
  
    ObjDelete( "obj_window_clk_paper" );
  
  end;
  local clk_paper_amulet3_end = function ()

    ObjMultiSet({ 
      { "obj_window_clk_web", { input = true, active = true }},
      { "spr_window_shadow",  { alp = 1                     }},
    });

    ObjDelete( "spr_window_spiderweb_1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_paper_amulet3",     clk_paper_amulet3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_paper_amulet3",     clk_paper_amulet3_end, private.room_objname );
  cmn.AddSubscriber( "clk_paper_amulet3_beg", clk_paper_amulet3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_paper_amulet3_end", clk_paper_amulet3_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_web_amulet3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_web_amulet3" ] = {
    type = "click",
    use_place = "obj_window_clk_web",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_examroom_window"
  };

  local clk_web_amulet3_beg = function ()
  
    ObjDelete( "obj_window_clk_web" );
  
  end;
  local clk_web_amulet3_end = function ()

    ObjSet( "obj_window_use_tweezers", { input = true, active = true } );

    ObjDelete( "spr_window_spiderweb" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_web_amulet3",     clk_web_amulet3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_web_amulet3",     clk_web_amulet3_end, private.room_objname );
  cmn.AddSubscriber( "clk_web_amulet3_beg", clk_web_amulet3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_web_amulet3_end", clk_web_amulet3_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_brokenfork () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_brokenfork" ] = {
    type = "click",
    use_place = "obj_window_clk_brokenfork",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_examroom_window"
  };

  local clk_brokenfork_beg = function ()
  
    ObjDelete( "obj_window_clk_brokenfork" );
  
  end;
  local clk_brokenfork_end = function ()

    ObjMultiSet({ 
      { "spr_window_brokenfork", { input = true, pos_x = 188, pos_y = 72, ang = -1.21 }},
      { "gfx_window_brokenfork", { active = true                                      }},
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_brokenfork",     clk_brokenfork_beg, private.room_objname );
  cmn.AddSubscriber( "clk_brokenfork",     clk_brokenfork_end, private.room_objname );
  cmn.AddSubscriber( "clk_brokenfork_beg", clk_brokenfork_beg, private.room_objname );
  cmn.AddSubscriber( "clk_brokenfork_end", clk_brokenfork_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_monitors_threat_professor () end;
  --------------------------------------------------------------------------------------------
  local see_monitors_threat_professor = function ()

    ObjDelete( "vid_monitors_tv_noise" );
    ObjSet( "vid_monitors_tv_noise_1", { active = true, visible = true } );

  end;
  cmn.AddSubscriber( "see_monitors_threat_professor", see_monitors_threat_professor, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function see_scare_trap () end;
  --------------------------------------------------------------------------------------------
  local see_scare_trap = function ()

    ObjDelete( "obj_examroom_trap_clk" );
    ObjDelete( "vid_examroom_net" );
    ObjSet( "spr_examroom_ropetrap", { alp = 1, input = true, active = true } );

  end;

  cmn.AddSubscriber( "see_scare_trap", see_scare_trap, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_examroom();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();

  common_impl.EnvPlay( { "level3/env/aud_examroom_env" }, "", 0.5 );

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_tweezers ()

  local item = "inv_tweezers";

  if cmn.ApplyObj( item, "gzz_examroom_window" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_window", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_window_use_tweezers" ) and cmn.IsEventDone( "clk_web_amulet3" )  ) then

    cmn.CallEventHandler( "use_tweezers_inv" );
    cmn.CallEventHandler( "use_tweezers_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_tweezers" );
      cmn.CallEventHandler( "use_tweezers_end" );

      private.get_moleculeamulet3();

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_tweezers", 0, "", 0 );
  AnimPlay( "anm_window_use_tweezers", "DoAnim", func_end );
  
  return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_brokenfork ()

  local item = "inv_brokenfork";

  if cmn.ApplyObj( item, "gzz_examroom_monitors" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_monitors", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_monitors_use_brokenfork" ) ) then

    cmn.CallEventHandler( "use_brokenfork_inv" );
    cmn.CallEventHandler( "use_brokenfork_beg" );

    local func_end = function ()

      local func_end_1 = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_brokenfork" );
        cmn.CallEventHandler( "use_brokenfork_end" );

        private.see_monitors_threat_professor();

      end;
      ObjMultiSet( {
        { "obj_monitors_screws",            { alp = 0 } },
        { "spr_monitors_sensor",            { alp = 0 } },
        { "vid_monitors_fork",              { alp = 1 } },
        { "obj_monitors_screws_shadow",     { alp = 1 } }
      } );

      VidPlay( "vid_monitors_fork", func_end_1 );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_brokenfork", 0, "", 0 );

    ObjAnimate( "obj_monitors_screws", "alp", 0, 0, "", 
    { 0.0, 0, 1,
      0.1, 0, 1,
      0.2, 0, 0,
    } );
    ObjAnimate( "spr_monitors_sensor", "alp", 0, 0, "", 
    { 0.0, 0, 1, 
      0.1, 0, 1,
      0.2, 0, 0,
    } );
    ObjAnimate( "obj_monitors_screws_shadow", "alp", 0, 0, "", 
    { 0.0, 0, 1, 
      0.1, 0, 1,
      0.2, 0, 0,
    } );
    ObjAnimate( "vid_monitors_fork", "alp", 0, 0, func_end, 
    { 0.0, 0, 0, 
      0.1, 0, 1,
      0.2, 0, 1,
    } );
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_moleculeamulet3 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_moleculeamulet3" );
  cmn.CallEventHandler( "get_moleculeamulet3" );

  if ( cmn.IsGetCollect2( "get_collect2_item_3_5" ) ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_brokenfork ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_brokenfork" );
  cmn.CallEventHandler( "get_brokenfork" );

end;
--------------------------------------------------------------------------------------------
function private.get_sensor ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_sensor" );
  cmn.CallEventHandler( "get_sensor" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_ropetrap ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_ropetrap" );
  cmn.CallEventHandler( "get_ropetrap" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_3_5 ()

  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_3_5" ); 

    if ( cmn.IsEventDone( "get_moleculeamulet3" ) ) then

      common.CloseSubRoom();

    end;

  end;

  common_impl.PlayEffectHO( "spr_collect2_item_3_5", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_3_5" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_paper_amulet3 ()

  cmn.CallEventHandler( "clk_paper_amulet3_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_paper_amulet3" );
    cmn.CallEventHandler( "clk_paper_amulet3_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_net", 0, "", 0 );

  ObjAnimate( "spr_window_spiderweb_1", "alp", 0, 0, func_end,
  { 
    0.0, 0, ObjGet( "spr_window_spiderweb_1" ).alp,
    0.3, 0, 0
  } );
  ObjAnimate( "spr_window_shadow", "alp", 0, 0, "",
  { 
    0.0, 0, 0,
    0.3, 0, 1
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_web_amulet3 ()

  cmn.CallEventHandler( "clk_web_amulet3_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_web_amulet3" );
    cmn.CallEventHandler( "clk_web_amulet3_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_net", 0, "", 0 );

  ObjAnimate( "spr_window_spiderweb", "alp", 0, 0, func_end,
  { 
    0.0, 0, ObjGet( "spr_window_spiderweb" ).alp,
    0.3, 0, 0
  } );

end;

--------------------------------------------------------------------------------------------
function private.clk_brokenfork ()

  cmn.CallEventHandler( "clk_brokenfork_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_brokenfork" );
    cmn.CallEventHandler( "clk_brokenfork_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_clk_brokenfork", 0, "", 0 );

  ObjAnimate( "spr_window_brokenfork", "ang", 0, 0, func_end,
  { 
    0.0, 0, 0,
    0.5, 0, -1.21,
  } );

  ObjAnimate( "spr_window_brokenfork", "pos_xy", 0, 0, func_end,
  { 
    0.0, 0,  80, 17,
    0.5, 0, 188, 72
  } );

end;
--------------------------------------------------------------------------------------------


--*********************************************************************************************************************
-- function *** HORRORS *** () end;
--*********************************************************************************************************************

function private.TrapScare () 

  local func_end = function ()

    cmn.SetEventDone( "see_scare_trap" );
    cmn.CallEventHandler( "see_scare_trap" );


    common_impl.StopAudio( "sfx", "level3/sfx/aud_rope_drop", 0.2 );

  end;

  ObjSet( "obj_examroom_trap_clk", { input = false } );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_rope_drop", 0, "", 0 );

  ObjSet( "tmr_examroom_opn_examroom", { playing = false } );

  VidPlay( "vid_examroom_net", func_end );
  
end;


--*********************************************************************************************************************

function private.see_monitors_threat_professor ()

  local func_end = function ()

    common_impl.ShowBbt( "bbt_monitors_threat_professor" );

    cmn.SetEventDone( "see_monitors_threat_professor" );
    cmn.CallEventHandler( "see_monitors_threat_professor" );

    common_impl.StopAudio( "voc", "level3/voc/aud_threat_professor_voc", 0.2 );
    common_impl.StopAudio( "sfx", "level3/sfx/aud_threat_professor", 0.2 );

    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "save_professor_reynolds" );

    local pos_beg = { ObjGet( "gzz_examroom_monitors" ).pos_x, ObjGet( "gzz_examroom_monitors" ).pos_y }
    cmn.GotoSubRoom( "zz_monitors", pos_beg, { 512, 360 } );

  end;
  
  common.CloseSubRoom();

  --common_impl.PlayAudio( "mus", "level3/mus/aud_see_monitors_threat_professor_mus", 0 );

  common_impl.PlayAudio( "voc", "level3/voc/aud_threat_professor_voc", 0, "", 0 );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_threat_professor", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_examroom_monitors_threat_professor", func_end ); 

end;


--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_examroom ()

  if not ( cmn.IsEventDone( "opn_examroom" ) ) then

    cmn.SetEventDone( "opn_examroom" );

    common_impl.ShowBbt( "bbt_examroom_opn_examroom" );

    ObjSet( "tmr_examroom_opn_examroom", { playing = true, time = 3, endtrig = private.TrapScare } );

  end;

  cmn.CallEventHandler( "opn_examroom" ); 

end;

--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** ANIMATIONS *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_examroom_window_light", "alp", 1, 0, "", { 0, 0, 1,    3, 0, 0.7,   6, 0, 1  } );
  ObjAnimate( "spr_examroom_camera_light", "alp", 1, 0, "", { 0, 0, 1,    0.5, 0, 0.5,   1, 0, 1  } );
  ObjAnimate( "spr_examroom_lamp_light", "alp", 1, 0, "", { 0, 0, 1,    1, 0, 0.5,   2, 0, 0.7,   4, 0, 1  } );
  ObjAnimate( "spr_examroom_tv_light", "alp", 1, 0, "", { 0, 0, 1,    2, 0, 0.5,   3, 0, 0.6,   3.5, 0, 0.5,   5, 0, 1  } );

end;
--------------------------------------------------------------------------------------------
function private.AnimCLkMoleculeAmulet3 ()

  local func_end = function ()

    cmn.Lock( false );

  end;

  cmn.Lock( true );

  common_impl.ShowBbt( 'bbt_window_use_tweezers' );

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk9", 0, "", 0 );

  ObjAnimate( "spr_window_moleculeamulet3", "pos_xy", 0, 0, func_end, 
  { 0.0, 0, 249, -66, 
    0.3, 0, 249, -69,
    0.6, 0, 249, -66,
  } );

end;
--------------------------------------------------------------------------------------------
function private.AnimCLkMonitorsSensor()

  cmn.Lock( true );

  common_impl.ShowBbt( 'bbt_monitors_use_brokenfork' );

  ObjAnimate( "spr_monitors_sensor", "pos_xy", 0, 0, function() cmn.Lock( false ); end, 
  { 0.0, 0, -231, -159, 
    0.2, 0, -229, -161,
    0.4, 0, -231, -159,
  } );

  ObjAnimate( "spr_monitors_screw_patch", "pos_xy", 0, 0, "", 
  { 0.0, 0, -201, -153, 
    0.2, 0, -199, -155,
    0.4, 0, -201, -153,
  } );

end;
--*********************************************************************************************************************