-- name=rm_powerunit
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_powerunit";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_grid", "room_hub" );
  ObjAttach( "zz_transformer", "room_hub" );
  ObjAttach( "zz_cordedphone", "room_hub" );
  ObjAttach( "zz_engineerbox", "room_hub" );
  private.Init_Subroom();
  private.InitAnimations();
  private.CordedphneInitDial();

  public.open_transformer = false;
  
  ObjMultiSet({ 
    { "spr_grid_spinner",                       { event_mdown = private.get_spinner                   } },
    { "spr_grid_ironcase",                      { event_mdown = private.get_ironcase                  } },
    { "spr_transformer_key",                    { event_mdown = private.get_key                       } },
    { "spr_transformer_flatmetalware",          { event_mdown = private.get_flatmetalware             } },
    { "spr_cordedphone_nozzle",                 { event_mdown = private.get_nozzle                    } },
    { "spr_cordedphone_screw2",                 { event_mdown = private.get_screw2                    } },
    { "spr_cordedphone_remotecontrol",          { event_mdown = private.get_remotecontrol             } },
    { "spr_cordedphone_spring",                 { event_mdown = private.get_spring_lvl3               } },
    { "spr_powerunit_pump",                     { event_mdown = private.get_pump                      } },
    { "spr_engineerbox_phonedial",              { event_mdown = private.get_phonedial                 } },
    { "spr_zz_transformer_mechanismpart",       { event_mdown = private.get_mechanismpart             } },

    { "obj_grid_clk_cover",                     { event_mdown = private.clk_grid_cover                } },
    { "obj_transformer_clk_spinner",            { event_mdown = private.clk_spinner                   } },
    { "obj_engineerbox_clk_flatmetalware_1",    { event_mdown = private.clk_flatmetalware_1           } },
    { "obj_engineerbox_clk_flatmetalware_2",    { event_mdown = private.clk_flatmetalware_2           } },

    { "obj_powerunit_clk_chair",                { event_mdown = private.ChairClick                    } },
    { "obj_engineerbox_clk_engineerbox_button", { event_mdown = private.ZZEngineerboxButtonClick      } },
    { "obj_engineerbox_use_flatmetalware",      { event_mdown = private.ZZEngineerboxCoverClick       } },
    { "obj_powerunit_scare_mannequin_click",    { event_mdown = private.clk_scare_powerunit_mannequin } },

    { "obj_cordedphone_clk_reciever",           { event_mdown = private.AnimClkReciever               } },
    { "obj_cordedphone_use_pliers",             { event_mdown = private.AnimClkMetalCover             } },

    { "obj_grid_use_boltcutter",                { event_mdown = private.GridFeedbackAnim              } },
    { "obj_transformer_clk_doors_idle",         { event_mdown = private.TransformerDoorsClick         } },
    { "obj_cordedphone_use_wrench",             { event_mdown = private.ZZCordedphoneScrewClick         } },

    { "spr_powerunit_collect_item",             { event_mdown = function () common_impl.GetCollectItem( "get_collect_item_3_3" );     end } },
    { "spr_powerunit_collect_morph_item",       { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_3_5" ); end } },
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_powerunit = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "gho_powerunit_engineerbox",
      "gmg_powerunit_transformer",
      "gzz_powerunit_grid",
      "gzz_powerunit_transformer",
      "gzz_powerunit_cordedphone",
      "gzz_powerunit_engineerbox",
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_cordedphone",
      "zz_grid",
      "zz_transformer",
      "zz_engineerbox",
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    end;
    cmn.AddSubscriber( "update_game_mode_powerunit", update_game_mode_powerunit, private.room_objname );
    --------------------------------------------------------------------------------------------
    -- function UpdatePerfMode () end;
    --------------------------------------------------------------------------------------------
    local update_performance_mode_powerunit = function ()

    local effects_table = 
    {
      "obj_powerunit_anim",
      "anm_zz_transformer_ventilator_loop",
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_powerunit", update_performance_mode_powerunit, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_powerunit () end;
  --------------------------------------------------------------------------------------------
  local opn_powerunit_map = function ()

    common_impl.VisitMapRoom( "powerunit" );

  end;
  cmn.AddSubscriber( "opn_powerunit", opn_powerunit_map );
  
  --------------------------------------------------------------------------------------------
  -- function opn_zz_grid () end;
  --------------------------------------------------------------------------------------------
  local opn_zz_grid = function ()

  end;
  cmn.AddSubscriber( "opn_zz_grid", opn_zz_grid );
  --------------------------------------------------------------------------------------------
  -- function get_spinner () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_spinner" ] = {
    type = "get",
    get_obj = "spr_grid_spinner",
    room = private.room_objname,
    zz = "zz_grid",
    zz_gate = "gzz_powerunit_grid"
  };
  
  local get_spinner_inv = function ()
  
    interface.InventoryItemAdd( "inv_spinner", "spr_grid_spinner" );
  
  end;
  
  local get_spinner_closezz = function ()
  
    ObjDelete( "gfx_grid_spinner" );
    ObjDelete( "spr_grid_spinner_shadow" );
--------------------
    ObjDelete( "spr_powerunit_states_zz_grid_spinner" );
  
  end;
  
  cmn.AddSubscriber( "get_spinner", get_spinner_inv );
  cmn.AddSubscriber( "get_spinner", get_spinner_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ironcase () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ironcase" ] = {
    type = "get",
    get_obj = "spr_grid_ironcase",
    room = private.room_objname,
    zz = "zz_grid",
    zz_gate = "gzz_powerunit_grid"
  };
  
  local get_ironcase_inv = function ()
  
    interface.InventoryItemAdd( "inv_ironcase", "spr_grid_ironcase" );
    ObjSet( "inv_ironcase", { drag = false } );
  
  end;
  
  local get_ironcase_closezz = function ()
  
    ObjDelete( "gfx_grid_ironcase" );
    ObjDelete( "spr_grid_box_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_ironcase", get_ironcase_inv );
  cmn.AddSubscriber( "get_ironcase", get_ironcase_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_key () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_key" ] = {
    type = "get",
    get_obj = "spr_transformer_key",
    room = private.room_objname,
    zz = "zz_transformer",
    zz_gate = "gzz_powerunit_transformer"
  };
  
  local get_key_inv = function ()
  
    interface.InventoryItemAdd( "inv_key", "spr_transformer_key" );
  
  end;
  
  local get_key_closezz = function ()
  
    ObjDelete( "gfx_transformer_key" );
---------------------------
    ObjDelete( "spr_powerunit_states_zz_transformer_button_light" );
  
  end;
  
  cmn.AddSubscriber( "get_key", get_key_inv );
  cmn.AddSubscriber( "get_key", get_key_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_flatmetalware () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_flatmetalware" ] = {
    type = "get",
    get_obj = "spr_transformer_flatmetalware",
    room = private.room_objname,
    zz = "zz_transformer",
    zz_gate = "gzz_powerunit_transformer"
  };
  
  local get_flatmetalware_inv = function ()
  
    interface.InventoryItemAdd( "inv_flatmetalware", "spr_transformer_flatmetalware" );
  
  end;
  
  local get_flatmetalware_closezz = function ()
  
    ObjDelete( "gfx_transformer_flatmetalware" );
  
  end;
  
  cmn.AddSubscriber( "get_flatmetalware", get_flatmetalware_inv );
  cmn.AddSubscriber( "get_flatmetalware", get_flatmetalware_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_nozzle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_nozzle" ] = {
    type = "get",
    get_obj = "spr_cordedphone_nozzle",
    room = private.room_objname,
    zz = "zz_cordedphone",
    zz_gate = "gzz_powerunit_cordedphone"
  };
  
  local get_nozzle_inv = function ()
  
    interface.InventoryItemAdd( "inv_nozzle", "spr_cordedphone_nozzle" );
  
  end;
  
  local get_nozzle_closezz = function ()
  
    ObjDelete( "gfx_cordedphone_nozzle" );
  
  end;
  
  cmn.AddSubscriber( "get_nozzle", get_nozzle_inv );
  cmn.AddSubscriber( "get_nozzle", get_nozzle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_screw2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_screw2" ] = {
    type = "get",
    get_obj = "spr_cordedphone_screw2",
    room = private.room_objname,
    zz = "zz_cordedphone",
    zz_gate = "gzz_powerunit_cordedphone"
  };
  
  local get_screw2_inv = function ()
  
    interface.InventoryItemAdd( "inv_screw", "spr_cordedphone_screw2" );
    ObjSet( "inv_screw", { frame = ObjGet( "inv_screw" ).frame + 1 } );
  
  end;
  
  local get_screw2_closezz = function ()
  
    ObjDelete( "gfx_cordedphone_screw2" );
  
  end;
  
  cmn.AddSubscriber( "get_screw2", get_screw2_inv );
  cmn.AddSubscriber( "get_screw2", get_screw2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_remotecontrol () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_remotecontrol" ] = {
    type = "get",
    get_obj = "spr_cordedphone_remotecontrol",
    room = private.room_objname,
    zz = "zz_cordedphone",
    zz_gate = "gzz_powerunit_cordedphone"
  };
  
  local get_remotecontrol_inv = function ()
  
    ObjSet( "spr_cordedphone_remotecontrol", { visible = true } );
    interface.InventoryItemAdd( "inv_remotecontrol", "spr_cordedphone_remotecontrol" );
    ObjSet( "inv_remotecontrol", { drag = false } );

  end;
  
  local get_remotecontrol_closezz = function ()
  
    ObjDelete( "spr_cordedphone_remotecontrol_shadow" );
    ObjDelete( "gfx_cordedphone_remotecontrol" );
    ObjDelete( "gzz_powerunit_cordedphone" );
  
  end;
  
  cmn.AddSubscriber( "get_remotecontrol", get_remotecontrol_inv );
  cmn.AddSubscriber( "get_remotecontrol", get_remotecontrol_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_spring_lvl3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_spring_lvl3" ] = {
    type = "get",
    get_obj = "spr_cordedphone_spring",
    room = private.room_objname,
    zz = "zz_cordedphone",
    zz_gate = "gzz_powerunit_cordedphone"
  };
  
  local get_spring_lvl3_inv = function ()
  
    interface.InventoryItemAdd( "inv_spring_lvl3", "spr_cordedphone_spring" );
  
  end;
  
  local get_spring_lvl3_closezz = function ()
  
    ObjDelete( "gfx_cordedphone_spring" );
    ObjDelete( "spr_cordedphone_spring_over" );

    ObjDelete( "spr_powerunit_states_zz_cordedphone_phone2" );
  
  end;
  
  cmn.AddSubscriber( "get_spring_lvl3", get_spring_lvl3_inv );
  cmn.AddSubscriber( "get_spring_lvl3", get_spring_lvl3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pump () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pump" ] = {
    type = "get",
    get_obj = "spr_powerunit_pump",
    room = private.room_objname
  };
  
  local get_pump_inv = function ()
  
    interface.InventoryItemAdd( "inv_pump", "spr_powerunit_pump" );
  
  end;
  
  local get_pump_closezz = function ()
  
    ObjDelete( "gfx_powerunit_pump" );
  
  end;
  
  cmn.AddSubscriber( "get_pump", get_pump_inv );
  cmn.AddSubscriber( "get_pump", get_pump_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_phonedial () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_phonedial" ] = {
    type = "get",
    get_obj = "spr_engineerbox_phonedial",
    room = private.room_objname,
    zz = "zz_engineerbox",
    zz_gate = "gzz_powerunit_engineerbox"
  };
  
  local get_phonedial_inv = function ()
  
    interface.InventoryItemAdd( "inv_phonedial", "spr_engineerbox_phonedial" );
  
  end;
  
  local get_phonedial_closezz = function ()
  
    ObjDelete( "gfx_engineerbox_phonedial" );
    ObjDelete( "spr_zz_engineerbox_phonedial_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_phonedial", get_phonedial_inv );
  cmn.AddSubscriber( "get_phonedial", get_phonedial_closezz, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_mechanismpart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_mechanismpart" ] = {
    type = "get",
    get_obj = "spr_zz_transformer_mechanismpart",
    room = private.room_objname,
    zz = "zz_transformer",
    zz_gate = "gzz_powerunit_transformer"
  };
  
  local get_mechanismpart_inv = function ()
  
    interface.InventoryItemAdd( "inv_mechanismpart", "spr_zz_transformer_mechanismpart" );
  
  end;
  
  local get_mechanismpart_closezz = function ()
  
    ObjDelete( "gfx_zz_transformer_mechanismpart" );
    ObjDelete( "gzz_powerunit_transformer" );
  
  end;
  
  cmn.AddSubscriber( "get_mechanismpart", get_mechanismpart_inv );
  cmn.AddSubscriber( "get_mechanismpart", get_mechanismpart_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_3_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_3_3 = function ()
  
    ObjDelete( "obj_powerunit_collect" );
  
  end;    
  cmn.AddSubscriber( "get_collect_item_3_3", get_collect_item_3_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_3_5 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_3_5 = function ()
  
    ObjDelete( "obj_powerunit_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_3_5", get_collect_morph_item_3_5, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_grid_cover () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_grid_cover" ] = {
    type = "click",
    use_place = "obj_grid_clk_cover",
    room = private.room_objname,
    zz = "zz_grid",
    zz_gate = "gzz_powerunit_grid"
  };

  local clk_grid_cover_beg = function ()

    ObjDelete( "obj_grid_clk_cover" );
  
  end;
  local clk_grid_cover_end = function ()

    ObjDelete( "spr_grid_metall" );
    ObjSet( "obj_grid_use_boltcutter", { input = true } );
    ObjSet( "spr_grid_spinner", { input = true } );
--------------------
    ObjDelete( "spr_powerunit_states_zz_grid_metal" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_grid_cover", clk_grid_cover_beg, private.room_objname );
  cmn.AddSubscriber( "clk_grid_cover", clk_grid_cover_end, private.room_objname );
  cmn.AddSubscriber( "clk_grid_cover_beg", clk_grid_cover_beg, private.room_objname );
  cmn.AddSubscriber( "clk_grid_cover_end", clk_grid_cover_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_spinner () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_spinner" ] = {
    type = "click",
    use_place = "obj_transformer_clk_spinner",
    room = private.room_objname,
    zz = "zz_transformer",
    zz_gate = "gzz_powerunit_transformer"
  };

  local clk_spinner_beg = function ()

    ObjDelete( "obj_transformer_clk_spinner" );
  
  end;
  local clk_spinner_end = function ()

    ObjDelete( "spr_zz_transformer_button_close" );
    ObjSet( "spr_transformer_key", { alp = 1, visible = true, input = true } );
    ObjSet( "spr_zz_transformer_regulator", { ang = -1.83 } );
---------------------------
    ObjSet( "spr_powerunit_states_zz_transformer_button_light", { alp = 1, visible = true } );
    ObjDelete( "spr_powerunit_states_zz_transformer_button_dark" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_spinner", clk_spinner_beg, private.room_objname );
  cmn.AddSubscriber( "clk_spinner", clk_spinner_end, private.room_objname );
  cmn.AddSubscriber( "clk_spinner_beg", clk_spinner_beg, private.room_objname );
  cmn.AddSubscriber( "clk_spinner_end", clk_spinner_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_flatmetalware_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_flatmetalware_1" ] = {
    type = "click",
    use_place = "obj_engineerbox_clk_flatmetalware_1",
    room = private.room_objname,
    zz = "zz_engineerbox",
    zz_gate = "gzz_powerunit_engineerbox"
  };

  local clk_flatmetalware_1_beg = function ()

    ObjDelete( "obj_engineerbox_clk_flatmetalware_1" );
  
  end;
  local clk_flatmetalware_1_end = function ()

    ObjSet( "obj_engineerbox_clk_flatmetalware_2", { input = true } );
    ObjSet( "spr_zz_engineerbox_flatmetalware", { ang = 0.17 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_flatmetalware_1", clk_flatmetalware_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_flatmetalware_1", clk_flatmetalware_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_flatmetalware_1_beg", clk_flatmetalware_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_flatmetalware_1_end", clk_flatmetalware_1_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_flatmetalware_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_flatmetalware_2" ] = {
    type = "click",
    use_place = "obj_engineerbox_clk_flatmetalware_2",
    room = private.room_objname,
    zz = "zz_engineerbox",
    zz_gate = "gzz_powerunit_engineerbox"
  };

  local clk_flatmetalware_2_beg = function ()

    ObjDelete( "obj_engineerbox_clk_flatmetalware_2" );
  
  end;
  local clk_flatmetalware_2_end = function ()

    ObjSet( "spr_engineerbox_phonedial", { input = true } );
    ObjSet( "gfx_engineerbox_phonedial", { active = true } );

    ObjSet( "spr_zz_engineerbox_cover_open_shadow", { alp = 1 } );
    ObjSet( "spr_zz_engineerbox_cover", { pos_x = -446, pos_y = -152 } );

    ObjDelete( "spr_zz_engineerbox_flatmetalware" );
    ObjSet( "obj_engineerbox_clk_engineerbox_button", { input = true } );
    ObjSet( "obj_engineerbox_use_spring", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_flatmetalware_2", clk_flatmetalware_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_flatmetalware_2", clk_flatmetalware_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_flatmetalware_2_beg", clk_flatmetalware_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_flatmetalware_2_end", clk_flatmetalware_2_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_engineerbox_button () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_engineerbox_button" ] = {
    type = "click",
    use_place = "obj_engineerbox_clk_engineerbox_button",
    room = private.room_objname,
    zz = "zz_engineerbox",
    zz_gate = "gzz_powerunit_engineerbox"
  };

  local clk_engineerbox_button_beg = function ()

    ObjDelete( "obj_engineerbox_clk_engineerbox_button" );
  
  end;
  local clk_engineerbox_button_end = function ()

    ObjSet( "spr_zz_engineerbox_lock_open", { alp = 1, visible = 1 } );
    ObjSet( "spr_zz_engineerbox_door_open", { alp = 1, visible = 1 } );
    ObjSet( "spr_zz_engineerbox_button", { pos_x = -178, pos_y = -92 } );
---------------------------
    ObjDelete( "gzz_powerunit_engineerbox" );
    ObjSet( "gho_powerunit_engineerbox", { input = true, active = true } );
    ObjSet( "spr_powerunit_states_zz_engineerbox_open", { alp = 1, visible = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_engineerbox_button", clk_engineerbox_button_beg, private.room_objname );
  cmn.AddSubscriber( "clk_engineerbox_button", clk_engineerbox_button_end, private.room_objname );
  cmn.AddSubscriber( "clk_engineerbox_button_beg", clk_engineerbox_button_beg, private.room_objname );
  cmn.AddSubscriber( "clk_engineerbox_button_end", clk_engineerbox_button_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_scare_powerunit_mannequin () end;
  --------------------------------------------------------------------------------------------

  local clk_scare_powerunit_mannequin_beg = function ()

    ObjDelete( "obj_powerunit_scare_mannequin_click" );
  
  end;
  local clk_scare_powerunit_mannequin_end = function ()

    ObjSet( "anm_powerunit_scare_mannequin_click", { alp = 1, frame = 120, pos_z = 15 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_scare_powerunit_mannequin", clk_scare_powerunit_mannequin_beg, private.room_objname );
  cmn.AddSubscriber( "clk_scare_powerunit_mannequin", clk_scare_powerunit_mannequin_end, private.room_objname );
  cmn.AddSubscriber( "clk_scare_powerunit_mannequin_beg", clk_scare_powerunit_mannequin_beg, private.room_objname );
  cmn.AddSubscriber( "clk_scare_powerunit_mannequin_end", clk_scare_powerunit_mannequin_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function see_scare_powerunit_mannequin () end;
  --------------------------------------------------------------------------------------------
  local see_scare_powerunit_mannequin = function ()

    ObjSet( "obj_powerunit_scare_mannequin_click", { input = 1 } );
    ObjSet( "anm_powerunit_scare_mannequin_click", { alp = 1 } );
    ObjDelete( "anm_powerunit_scare_mannequin" );
    ObjDelete( "obj_powerunit_clk_chair" );

  end;

  cmn.AddSubscriber( "see_scare_powerunit_mannequin", see_scare_powerunit_mannequin, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function after_win_transformer () end;
  --------------------------------------------------------------------------------------------
  local after_win_transformer = function ()

    ObjSet( "spr_zz_transformer_mechanismpart", { input = true } );
    ObjDelete( "anm_zz_transformer_mg_open" );
---------------------------
    ObjDelete( "spr_powerunit_states_zz_transformer_mg" );
    ObjSet( "spr_powerunit_states_zz_transformer_win", { alp = 1, visible = true } );

  end;

  cmn.AddSubscriber( "after_win_transformer", after_win_transformer, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_inflatedmattress () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_inflatedmattress" ] = {
    type = "use",
    inv_obj = "inv_inflatedmattress",
    use_place = "obj_grid_use_inflatedmattress",
    room = private.room_objname,
    zz = "zz_grid",
    zz_gate = "gzz_powerunit_grid"
  };
  local use_inflatedmattress_inv = function ()
  
    interface.InventoryItemRemove( "inv_inflatedmattress" );
  
  end;
  local use_inflatedmattress_beg = function ()
  
    ObjDelete( "obj_grid_use_inflatedmattress" );
  
  end;
  local use_inflatedmattress_end = function ()
  
    ObjDelete( "gzz_powerunit_grid" );
    ObjSet( "grm_powerunit_terenceroom", { input = true, visible = true, active = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_powerunit_terenceroom_focus");
    end;  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_inflatedmattress", use_inflatedmattress_beg, private.room_objname );
  cmn.AddSubscriber( "use_inflatedmattress", use_inflatedmattress_inv );
  cmn.AddSubscriber( "use_inflatedmattress", use_inflatedmattress_end, private.room_objname );
  cmn.AddSubscriber( "use_inflatedmattress_inv", use_inflatedmattress_inv, private.room_objname );
  cmn.AddSubscriber( "use_inflatedmattress_beg", use_inflatedmattress_beg, private.room_objname );
  cmn.AddSubscriber( "use_inflatedmattress_end", use_inflatedmattress_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_boltcutter () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_boltcutter" ] = {
    type = "use",
    inv_obj = "inv_boltcutter",
    use_place = "obj_grid_use_boltcutter",
    room = private.room_objname,
    zz = "zz_grid",
    zz_gate = "gzz_powerunit_grid"
  };
  local use_boltcutter_inv = function ()
  
    interface.InventoryItemRemove( "inv_boltcutter" );
  
  end;
  local use_boltcutter_beg = function ()
  
    ObjDelete( "obj_grid_use_boltcutter" );
    ObjDelete( "spr_grid_bolt_1" );
    ObjDelete( "spr_grid_bolt_2" );
    ObjDelete( "spr_grid_patch2" );
  
  end;
  local use_boltcutter_end = function ()
  
    ObjSet( "obj_grid_use_inflatedmattress", { input = true } );
    ObjSet( "spr_grid_ironcase", { input = true } );
    ObjSet( "gfx_grid_ironcase", { active = true } );
    ObjDelete( "spr_grid_grid" );
    ObjDelete( "anm_grid_use_boltcutter" );
--------------------
    ObjDelete( "spr_powerunit_states_zz_grid_grate" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_boltcutter", use_boltcutter_beg, private.room_objname );
  cmn.AddSubscriber( "use_boltcutter", use_boltcutter_inv );
  cmn.AddSubscriber( "use_boltcutter", use_boltcutter_end, private.room_objname );
  cmn.AddSubscriber( "use_boltcutter_inv", use_boltcutter_inv, private.room_objname );
  cmn.AddSubscriber( "use_boltcutter_beg", use_boltcutter_beg, private.room_objname );
  cmn.AddSubscriber( "use_boltcutter_end", use_boltcutter_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_screw () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screw" ] = {
    type = "use",
    inv_obj = "inv_screw",
    use_place = "obj_transformer_use_screw",
    room = private.room_objname,
    zz = "zz_transformer",
    zz_gate = "gzz_powerunit_transformer"
  };
  local use_screw_inv = function ()
  
    interface.InventoryItemRemove( "inv_screw" );
  
  end;
  local use_screw_beg = function ()
  
    ObjDelete( "obj_transformer_use_screw" );
  
  end;
  local use_screw_end = function ()
  
    ObjSet( "spr_zz_transformer_part_1", { alp = 1, visible = true, pos_z = -1 } );
    ObjSet( "spr_zz_transformer_part_lamp_1", { alp = 1, visible = true } );
    ObjSet( "spr_zz_transformer_part_2", { alp = 1, visible = true, pos_z = -1 } );
    ObjSet( "spr_zz_transformer_part_lamp_2", { alp = 1, visible = true } );

    ObjSet( "spr_powerunit_states_zz_transformer_trans_1", { alp = 1, visible = true } );
    ObjSet( "spr_powerunit_states_zz_transformer_trans_2", { alp = 1, visible = true } );

    ObjDelete( "anm_zz_transformer_doors" );
    ObjSet( "gzz_powerunit_transformer", { visible = false, input = false } );
    ObjSet( "gmg_powerunit_transformer", { input = true, visible = true, active = true } );
    ObjDelete( "obj_transformer_clk_doors_idle" );
    ObjDelete( "anm_zz_transformer_doors_iddle" );

    ObjSet( "spr_powerunit_states_zz_transformer_mg", { alp = 1, visible = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_screw", use_screw_beg, private.room_objname );
  cmn.AddSubscriber( "use_screw", use_screw_inv );
  cmn.AddSubscriber( "use_screw", use_screw_end, private.room_objname );
  cmn.AddSubscriber( "use_screw_inv", use_screw_inv, private.room_objname );
  cmn.AddSubscriber( "use_screw_beg", use_screw_beg, private.room_objname );
  cmn.AddSubscriber( "use_screw_end", use_screw_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_spinner () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_spinner" ] = {
    type = "use",
    inv_obj = "inv_spinner",
    use_place = "obj_transformer_use_spinner",
    room = private.room_objname,
    zz = "zz_transformer",
    zz_gate = "gzz_powerunit_transformer"
  };
  local use_spinner_inv = function ()
  
    interface.InventoryItemRemove( "inv_spinner" );
  
  end;
  local use_spinner_beg = function ()
  
    ObjDelete( "obj_transformer_use_spinner" );
  
  end;
  local use_spinner_end = function ()
  
    ObjSet( "spr_zz_transformer_regulator", { alp = 1, visible = true } );
    ObjSet( "obj_transformer_clk_spinner", { input = true } );
---------------------------
    ObjSet( "spr_powerunit_states_zz_transformer_regulator", { alp = 1, visible = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_spinner", use_spinner_beg, private.room_objname );
  cmn.AddSubscriber( "use_spinner", use_spinner_inv );
  cmn.AddSubscriber( "use_spinner", use_spinner_end, private.room_objname );
  cmn.AddSubscriber( "use_spinner_inv", use_spinner_inv, private.room_objname );
  cmn.AddSubscriber( "use_spinner_beg", use_spinner_beg, private.room_objname );
  cmn.AddSubscriber( "use_spinner_end", use_spinner_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_nozzle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_nozzle" ] = {
    type = "use",
    inv_obj = "inv_nozzle",
    use_place = "obj_transformer_use_nozzle",
    room = private.room_objname,
    zz = "zz_transformer",
    zz_gate = "gzz_powerunit_transformer"
  };
  local use_nozzle_inv = function ()
  
    interface.InventoryItemRemove( "inv_nozzle" );
  
  end;
  local use_nozzle_beg = function ()
  
    ObjDelete( "obj_transformer_use_nozzle" );
  
  end;
  local use_nozzle_end = function ()
  
    ObjDelete( "anm_zz_transformer_flatmetalware" );
    ObjSet( "spr_transformer_flatmetalware", { alp = 1, visible = true, input = true } );
    ObjDelete( "spr_transformer_flatmetalware_before" );
    ObjSet( "spr_zz_transformer_ventilator", { alp = 1, visible = true } );
    ObjSet( "spr_transformer_burned", { alp = 1, visible = true } );
    ObjSet( "spr_zz_transformer_regulator_lamp", { alp = 1, visible = true } );
---------------------------
    ObjSet( "spr_powerunit_states_zz_transformer_culler", { alp = 1, visible = true } );
    ObjDelete( "spr_powerunit_states_zz_transformer_flatmetalware" );
    ObjSet( "spr_powerunit_states_zz_transformer_light", { alp = 1, visible = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_nozzle", use_nozzle_beg, private.room_objname );
  cmn.AddSubscriber( "use_nozzle", use_nozzle_inv );
  cmn.AddSubscriber( "use_nozzle", use_nozzle_end, private.room_objname );
  cmn.AddSubscriber( "use_nozzle_inv", use_nozzle_inv, private.room_objname );
  cmn.AddSubscriber( "use_nozzle_beg", use_nozzle_beg, private.room_objname );
  cmn.AddSubscriber( "use_nozzle_end", use_nozzle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pliers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pliers" ] = {
    type = "use",
    inv_obj = "inv_pliers",
    use_place = "obj_cordedphone_use_pliers",
    room = private.room_objname,
    zz = "zz_cordedphone",
    zz_gate = "gzz_powerunit_cordedphone"
  };
  local use_pliers_inv = function ()
  
    interface.InventoryItemRemove( "inv_pliers" );
  
  end;
  local use_pliers_beg = function ()
  
    ObjDelete( "obj_cordedphone_use_pliers" );
  
  end;
  local use_pliers_end = function ()
  
    ObjSet( "spr_cordedphone_nozzle", { input = true, active = true } );
    ObjSet( "obj_cordedphone_use_wrench", { input = true } );
    ObjSet( "spr_cordedphone_metal_opened", { alp = 1 } );
    ObjDelete( "spr_cordedphone_metal_closed" );
    ObjDelete( "vid_cordedphone_pliers" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pliers", use_pliers_beg, private.room_objname );
  cmn.AddSubscriber( "use_pliers", use_pliers_inv );
  cmn.AddSubscriber( "use_pliers", use_pliers_end, private.room_objname );
  cmn.AddSubscriber( "use_pliers_inv", use_pliers_inv, private.room_objname );
  cmn.AddSubscriber( "use_pliers_beg", use_pliers_beg, private.room_objname );
  cmn.AddSubscriber( "use_pliers_end", use_pliers_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wrench2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wrench2" ] = {
    type = "use",
    inv_obj = "inv_wrench",
    use_place = "obj_cordedphone_use_wrench",
    room = private.room_objname,
    zz = "zz_cordedphone",
    zz_gate = "gzz_powerunit_cordedphone"
  };
  local use_wrench2_inv = function ()
  
    if cmn.IsEventDone( "use_wrench1" ) then 
      interface.InventoryItemRemove( "inv_wrench" );
    end; 
  
  end;
  local use_wrench2_beg = function ()
  
    ObjDelete( "obj_cordedphone_use_wrench" );
    ObjDelete( "spr_cordedphone_bolt_over" );
    ObjDelete( "spr_cordedphone_bolt" );
  
  end;
  local use_wrench2_end = function ()
  
    ObjSet( "gfx_cordedphone_screw2", { active = true } );
    ObjSet( "spr_cordedphone_screw2", { input = true, active = true } );
    ObjDelete( "vid_cordedphone_key" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wrench2", use_wrench2_beg, private.room_objname );
  cmn.AddSubscriber( "use_wrench2", use_wrench2_inv );
  cmn.AddSubscriber( "use_wrench2", use_wrench2_end, private.room_objname );
  cmn.AddSubscriber( "use_wrench2_inv", use_wrench2_inv, private.room_objname );
  cmn.AddSubscriber( "use_wrench2_beg", use_wrench2_beg, private.room_objname );
  cmn.AddSubscriber( "use_wrench2_end", use_wrench2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_code1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_code1" ] = {
    type = "use",
    inv_obj = "inv_code1",
    use_place = "obj_cordedphone_use_code1",
    room = private.room_objname,
    zz = "zz_cordedphone",
    zz_gate = "gzz_powerunit_cordedphone"
  };
  local use_code1_inv = function ()
  
    interface.InventoryItemRemove( "inv_code1" );
  
  end;
  local use_code1_beg = function ()
  
    ObjDelete( "obj_cordedphone_use_code1" );
  
  end;
  local use_code1_end = function ()
  
    ObjSet( "spr_cordedphone_code_lft", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_code1", use_code1_beg, private.room_objname );
  cmn.AddSubscriber( "use_code1", use_code1_inv );
  cmn.AddSubscriber( "use_code1", use_code1_end, private.room_objname );
  cmn.AddSubscriber( "use_code1_inv", use_code1_inv, private.room_objname );
  cmn.AddSubscriber( "use_code1_beg", use_code1_beg, private.room_objname );
  cmn.AddSubscriber( "use_code1_end", use_code1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_phonedial () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_phonedial" ] = {
    type = "use",
    inv_obj = "inv_phonedial",
    use_place = "obj_cordedphone_use_phonedial",
    room = private.room_objname,
    zz = "zz_cordedphone",
    zz_gate = "gzz_powerunit_cordedphone"
  };
  local use_phonedial_inv = function ()
  
    interface.InventoryItemRemove( "inv_phonedial" );
  
  end;
  local use_phonedial_beg = function ()
  
    ObjDelete( "obj_cordedphone_use_phonedial" );
  
  end;
  local use_phonedial_end = function ()
  
    ObjSet( "obj_cordedphone_buttons", { input = true } );
    ObjSet( "spr_cordedphone_phonedial", { alp = 1 } );
    ObjSet( "spr_cordedphone_phonedial_shadow", { alp = 1 } );
    ObjSet( "spr_cordedphone_wire", { alp = 1 } );

    ObjDelete( "anm_cordedphone_off_hook" );
    ObjDelete( "anm_cordedphone_hang_up" );
    ObjDelete( "spr_cordedphone_spring_part" );
    ObjDelete( "obj_cordedphone_clk_reciever" );

    ObjSet( "spr_cordedphone_spring", { input = true, active = true } );
    ObjSet( "obj_cordedphone_reciever", { alp = 1, input = true } );

    ObjDelete( "spr_powerunit_states_zz_cordedphone_phone1" );
    ObjSet( "spr_powerunit_states_zz_cordedphone_phone2", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_phonedial", use_phonedial_beg, private.room_objname );
  cmn.AddSubscriber( "use_phonedial", use_phonedial_inv );
  cmn.AddSubscriber( "use_phonedial", use_phonedial_end, private.room_objname );
  cmn.AddSubscriber( "use_phonedial_inv", use_phonedial_inv, private.room_objname );
  cmn.AddSubscriber( "use_phonedial_beg", use_phonedial_beg, private.room_objname );
  cmn.AddSubscriber( "use_phonedial_end", use_phonedial_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_code2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_code2" ] = {
    type = "use",
    inv_obj = "inv_code2",
    use_place = "obj_cordedphone_use_code2",
    room = private.room_objname,
    zz = "zz_cordedphone",
    zz_gate = "gzz_powerunit_cordedphone"
  };
  local use_code2_inv = function ()
  
    interface.InventoryItemRemove( "inv_code2" );
  
  end;
  local use_code2_beg = function ()
  
    ObjDelete( "obj_cordedphone_use_code2" );
  
  end;
  local use_code2_end = function ()

    ObjSet( "spr_cordedphone_code_rgt", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_code2", use_code2_beg, private.room_objname );
  cmn.AddSubscriber( "use_code2", use_code2_inv );
  cmn.AddSubscriber( "use_code2", use_code2_end, private.room_objname );
  cmn.AddSubscriber( "use_code2_inv", use_code2_inv, private.room_objname );
  cmn.AddSubscriber( "use_code2_beg", use_code2_beg, private.room_objname );
  cmn.AddSubscriber( "use_code2_end", use_code2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_flatmetalware () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_flatmetalware" ] = {
    type = "use",
    inv_obj = "inv_flatmetalware",
    use_place = "obj_engineerbox_use_flatmetalware",
    room = private.room_objname,
    zz = "zz_engineerbox",
    zz_gate = "gzz_powerunit_engineerbox"
  };
  local use_flatmetalware_inv = function ()
  
    interface.InventoryItemRemove( "inv_flatmetalware" );
  
  end;
  local use_flatmetalware_beg = function ()
  
    ObjDelete( "obj_engineerbox_use_flatmetalware" );
  
  end;
  local use_flatmetalware_end = function ()
  
    ObjSet( "spr_zz_engineerbox_flatmetalware", { alp = 1, visible = true } );
    ObjSet( "obj_engineerbox_clk_flatmetalware_1", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_flatmetalware", use_flatmetalware_beg, private.room_objname );
  cmn.AddSubscriber( "use_flatmetalware", use_flatmetalware_inv );
  cmn.AddSubscriber( "use_flatmetalware", use_flatmetalware_end, private.room_objname );
  cmn.AddSubscriber( "use_flatmetalware_inv", use_flatmetalware_inv, private.room_objname );
  cmn.AddSubscriber( "use_flatmetalware_beg", use_flatmetalware_beg, private.room_objname );
  cmn.AddSubscriber( "use_flatmetalware_end", use_flatmetalware_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_spring_lvl3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_spring_lvl3" ] = {
    type = "use",
    inv_obj = "inv_spring_lvl3",
    use_place = "obj_engineerbox_use_spring",
    room = private.room_objname,
    zz = "zz_engineerbox",
    zz_gate = "gzz_powerunit_engineerbox"
  };
  local use_spring_lvl3_inv = function ()
  
    interface.InventoryItemRemove( "inv_spring_lvl3" );
  
  end;
  local use_spring_lvl3_beg = function ()
  
    ObjDelete( "obj_engineerbox_use_spring" );
  
  end;
  local use_spring_lvl3_end = function ()

    ObjSet( "obj_engineerbox_clk_engineerbox_button", { event_mdown = private.clk_engineerbox_button } );
    ObjSet( "spr_zz_engineerbox_lock_spring", { alp = 1, visible = true } );
    ObjDelete( "spr_zz_engineerbox_spring" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_spring_lvl3", use_spring_lvl3_beg, private.room_objname );
  cmn.AddSubscriber( "use_spring_lvl3", use_spring_lvl3_inv );
  cmn.AddSubscriber( "use_spring_lvl3", use_spring_lvl3_end, private.room_objname );
  cmn.AddSubscriber( "use_spring_lvl3_inv", use_spring_lvl3_inv, private.room_objname );
  cmn.AddSubscriber( "use_spring_lvl3_beg", use_spring_lvl3_beg, private.room_objname );
  cmn.AddSubscriber( "use_spring_lvl3_end", use_spring_lvl3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_codephone () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_codephone" ] = {
    type = "click",
    use_place = "spr_cordedphone_phonedial",
    room = private.room_objname,
    zz = "zz_cordedphone",
    zz_gate = "gzz_powerunit_cordedphone"
  };

  local win_codephone = function ()

    ObjDelete( "obj_cordedphone_door_closed" );
    ObjSet( "obj_cordedphone_door_opened", { input = true, active = true, alp = 1 } );
    ObjSet( "spr_cordedphone_remotecontrol", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_codephone", win_codephone, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()

  --*********************************************************************************************************************
  -- function zz_cordedphone() end
    subroom.Define( "zz_cordedphone" );
    function zz_cordedphone.Open ()
    end;
    -------------------------------------------------
    function zz_cordedphone.PreOpen ()

    end;
    -------------------------------------------------
    function zz_cordedphone.PreClose ()

    end;
    -------------------------------------------------
    function zz_cordedphone.Close ()
    end;
  --*********************************************************************************************************************
  -- function zz_transformer() end
    subroom.Define( "zz_transformer" );

    function zz_transformer.Open ()

      if ( cmn.IsEventDone( "win_transformer" ) ) and ( not cmn.IsEventDone( "after_win_transformer" ) ) then

        local func_end = function ()

          cmn.Lock( false ) ;
          cmn.SetEventDone( "after_win_transformer" );
          cmn.CallEventHandler( "after_win_transformer" );

        end;

        cmn.Lock( true ) ;
        common_impl.PlayAudio( "sfx", "level3/sfx/aud_after_win_transformer", 0, "", 0 );

        AnimPlay( "anm_zz_transformer_mg_open", "DoAnim", func_end );

      end;

    end;

  --*********************************************************************************************************************
  -- function zz_grid() end
    subroom.Define( "zz_grid" );

    function zz_grid.Open ()

      if not ( cmn.IsEventDone( "opn_zz_grid" ) ) then

        cmn.SetEventDone( "opn_zz_grid" );
        cmn.CallEventHandler( "opn_zz_grid" );

        interface.KeyTaskDone( true );
        interface.KeyTaskAdd( "get_down_hotel_rooms" );


      end;

    end;
    -------------------------------------------------
    function zz_grid.PreOpen ()
    end;
    -------------------------------------------------
    function zz_grid.PreClose ()
    end;
    -------------------------------------------------
    function zz_grid.Close ()
    end;
    --------------------------------------------------------------------------------------------  
  --*********************************************************************************************************************

end;

--*********************************************************************************************************************
function public.Open ()

  private.opn_powerunit();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

  if cmn.IsEventDone( "get_pliers" ) and 
  not cmn.IsEventDone( "see_scare_powerunit_mannequin" ) then 

    private.MannequinScare();

  end;
-----------------
  local func_end = function ()

    local pos_beg = { ObjGet( "gzz_powerunit_transformer" ).pos_x, ObjGet( "gzz_powerunit_transformer" ).pos_y }
    cmn.GotoSubRoom( "zz_transformer", pos_beg, { 512, 360 } );

  end;

  if public.open_transformer then

    public.open_transformer = false;
    ObjAnimate( "rm_powerunit", "alp", 0, 0, func_end, { 0, 0, 1,   0.01, 0, 1 } );

  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.CollectItemMorphing();
  common_impl.MorphItemMorphing();

  common_impl.EnvPlay( { "level3/env/aud_powerunit_env" }, "", 0.5 );

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_inflatedmattress ()

  local item = "inv_inflatedmattress";

  if cmn.ApplyObj( item, "gzz_powerunit_grid" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_grid", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_grid_use_inflatedmattress" ) and 
  cmn.IsEventDone( "use_boltcutter" ) ) then

    cmn.CallEventHandler( "use_inflatedmattress_inv" );
    cmn.CallEventHandler( "use_inflatedmattress_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_inflatedmattress" );
      cmn.CallEventHandler( "use_inflatedmattress_end" );
      common.CloseSubRoom();

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_mattress", 0, "", 0 );

    ObjSet( "anm_grid_use_inflatedmattress", { alp = 0, visible = true } );
    ObjAnimate( "anm_grid_use_inflatedmattress", "alp",0,0, func_end, { 0, 0, 0,    0.3, 0, 1,    1.0, 0, 1,    1.6, 0, 1 } );
    AnimPlay( "anm_grid_use_inflatedmattress", "DoAnim", "" );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_boltcutter ()

  local item = "inv_boltcutter";

  if cmn.ApplyObj( item, "gzz_powerunit_grid" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_grid", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_grid_use_boltcutter" ) ) then

    cmn.CallEventHandler( "use_boltcutter_inv" );
    cmn.CallEventHandler( "use_boltcutter_beg" );

    local func_anim = function ()

      local func_end = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_boltcutter" );
        cmn.CallEventHandler( "use_boltcutter_end" );

      end;

      ObjSet( "anm_grid_use_boltcutter", { alp = 0 } );
      ObjAnimate( "spr_grid_grid", "pos_xy",0,0, func_end, { 0, 3, -32, 26,    0.6, 3, -820, 109 } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_boltcutter", 0, "", 0 );

    ObjSet( "anm_grid_use_boltcutter", { alp = 1 } );
    AnimPlay( "anm_grid_use_boltcutter", "DoAnim", func_anim );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_screw ()

  local item = "inv_screw";

  if cmn.ApplyObj( item, "gzz_powerunit_transformer" ) and cmn.IsEventDone( "get_screw1" ) and cmn.IsEventDone( "get_screw2" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_transformer", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_transformer_use_screw" ) and cmn.IsEventDone( "get_screw1" ) and cmn.IsEventDone( "get_screw2" ) ) then

    cmn.CallEventHandler( "use_screw_inv" );
    cmn.CallEventHandler( "use_screw_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_screw" );
      cmn.CallEventHandler( "use_screw_end" );

      common.CloseSubRoom();
      cmn.GotoRoom( "mg_transformer" );

    end;

    local func_end_2 = function ()

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_opn_mg_transformer", 0, "", 0 );
      AnimPlay( "anm_zz_transformer_doors", "DoAnim", func_end );

    end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_screw", 0, "", 0 );

  cmn.ItemFly( "spr_zz_transformer_part_1", nil, 3.84 );
  ObjSet( "spr_zz_transformer_part_lamp_1", { visible = true } );
  ObjAnimate( "spr_zz_transformer_part_lamp_1", "alp",0,0, func_end_2, { 0, 0, 0,    0.6, 0, 0,    1.0, 0, 1,    1.2, 0, 0.4,    1.5, 0, 1 } );

  cmn.ItemFly( "spr_zz_transformer_part_2", nil, 3.84 );
  ObjSet( "spr_zz_transformer_part_lamp_2", { visible = true } );
  ObjAnimate( "spr_zz_transformer_part_lamp_2", "alp",0,0, "", { 0, 0, 0,    0.6, 0, 0,    1.0, 0, 1,    1.2, 0, 0.4,    1.5, 0, 1 } );  
  
  return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_spinner ()

  local item = "inv_spinner";

  if cmn.ApplyObj( item, "gzz_powerunit_transformer" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_transformer", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_transformer_use_spinner" ) ) then

    cmn.CallEventHandler( "use_spinner_inv" );
    cmn.CallEventHandler( "use_spinner_beg" );

    local func_end = function ()

      cmn.Lock( false );

      common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk11", 0, "", 0 );

      cmn.SetEventDone( "use_spinner" );
      cmn.CallEventHandler( "use_spinner_end" );

    end; 

  cmn.Lock( true );

  cmn.ItemFly( "spr_zz_transformer_regulator", func_end, 3.49 );
  
  return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_nozzle ()

  local item = "inv_nozzle";

  if cmn.ApplyObj( item, "gzz_powerunit_transformer" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_transformer", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_transformer_use_nozzle" ) ) then

    cmn.CallEventHandler( "use_nozzle_inv" );
    cmn.CallEventHandler( "use_nozzle_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_nozzle" );
      cmn.CallEventHandler( "use_nozzle_end" );

    end;

    local func_end_2 = function ()

      ObjSet( "spr_transformer_flatmetalware_before", { alp = 0 } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_fan", 0, "", 0 );

    ObjAnimate( "anm_zz_transformer_flatmetalware", "alp",0,0, func_end_2, { 0, 0, 0,    0.3, 0, 1 } );
    AnimPlay( "anm_zz_transformer_flatmetalware", "DoAnim", func_end );

    ObjSet( "spr_zz_transformer_regulator_lamp", { visible = true } );
    ObjAnimate( "spr_zz_transformer_regulator_lamp", "alp",0,0, "", { 0, 0, 0,    0.6, 0, 0,    1.0, 0, 1,    1.2, 0, 0.4,    1.5, 0, 1 } );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_pliers ()

  local item = "inv_pliers";

  if cmn.ApplyObj( item, "gzz_powerunit_cordedphone" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cordedphone", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_cordedphone_use_pliers" ) ) then

    cmn.CallEventHandler( "use_pliers_inv" );
    cmn.CallEventHandler( "use_pliers_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_pliers" );
      cmn.CallEventHandler( "use_pliers_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_pliers", 0, "", 0 );

  ObjSet( "vid_cordedphone_pliers", { alp = 1 } );
  ObjSet( "spr_cordedphone_metal_closed", { alp = 0 } )
  VidPlay( "vid_cordedphone_pliers", func_end )
  
  return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_wrench2 ()

  local item = "inv_wrench";

  if cmn.ApplyObj( item, "gzz_powerunit_cordedphone" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cordedphone", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_cordedphone_use_wrench" ) ) then

    cmn.CallEventHandler( "use_wrench2_inv" );
    cmn.CallEventHandler( "use_wrench2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_wrench2" );
      cmn.CallEventHandler( "use_wrench2_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_wrench2", 0, "", 0 );

    ObjSet( "vid_cordedphone_key", { alp = 1 } );
    VidPlay( "vid_cordedphone_key", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_code1 ()

  local item = "inv_code1";

  if cmn.ApplyObj( item, "gzz_powerunit_cordedphone" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cordedphone", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_cordedphone_use_code1" ) ) then

    cmn.CallEventHandler( "use_code1_inv" );
    cmn.CallEventHandler( "use_code1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );

      cmn.SetEventDone( "use_code1" );
      cmn.CallEventHandler( "use_code1_end" );

    end;

    cmn.Lock( true );

    cmn.ItemFly( "spr_cordedphone_code_lft", func_end, 0 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_phonedial ()

  local item = "inv_phonedial";

  if cmn.ApplyObj( item, "gzz_powerunit_cordedphone" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cordedphone", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_cordedphone_use_phonedial" ) ) then

    cmn.CallEventHandler( "use_phonedial_inv" );
    cmn.CallEventHandler( "use_phonedial_beg" );

    local func_anim = function ()

      local func_anim1 = function ()

        local func_anim2 = function ()

          local func_end = function ()

            cmn.Lock( false );

            cmn.SetEventDone( "use_phonedial" );
            cmn.CallEventHandler( "use_phonedial_end" );

          end;

          ObjSet( "anm_cordedphone_off_hook", { alp = 0 } );
          AnimPlay( "anm_cordedphone_hang_up", "hang_up", func_end );

        end;

        ObjAnimate( "anm_cordedphone_hang_up", "alp", 0, 0, func_anim2, { 0, 0, 0,   1, 0, 0,   1, 0, 1 }  );

      end;

      AnimPlay( "anm_cordedphone_off_hook", "off_hook", func_anim1 );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_phone_disk", 0, "", 0 );

    ObjSet( "spr_cordedphone_spring_part", { alp = 0 } );
    cmn.ItemFly( "spr_cordedphone_phonedial", func_anim, 0.3 );
    cmn.ItemFly( "spr_cordedphone_phonedial_shadow", nil, 0.3 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_code2 ()

  local item = "inv_code2";

  if cmn.ApplyObj( item, "gzz_powerunit_cordedphone" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cordedphone", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_cordedphone_use_code2" ) ) then

    cmn.CallEventHandler( "use_code2_inv" );
    cmn.CallEventHandler( "use_code2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );

      cmn.SetEventDone( "use_code2" );
      cmn.CallEventHandler( "use_code2_end" );

    end;

    cmn.Lock( true );

    cmn.ItemFly( "spr_cordedphone_code_rgt", func_end, 0 );
      
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_flatmetalware ()

  local item = "inv_flatmetalware";

  if cmn.ApplyObj( item, "gzz_powerunit_engineerbox" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_engineerbox", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_engineerbox_use_flatmetalware" ) ) then

    cmn.CallEventHandler( "use_flatmetalware_inv" );
    cmn.CallEventHandler( "use_flatmetalware_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_flatmetalware" );
      cmn.CallEventHandler( "use_flatmetalware_end" );

    end;

    local func_end_2 = function ()
      ObjSet( "spr_transformer_flatmetalware", { alp = 0 } );
    end; 

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_pick_engineerbox", 0, "", 0 );

    ObjSet( "spr_zz_engineerbox_flatmetalware", { alp = 0, visible = true } );
    ObjAnimate( "spr_zz_engineerbox_flatmetalware", "alp",0,0, func_end, { 0, 0, 0,    0.6, 0, 1 } );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_spring_lvl3 ()

  local item = "inv_spring_lvl3";

  if cmn.ApplyObj( item, "gzz_powerunit_engineerbox" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_engineerbox", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_engineerbox_use_spring" ) and 
  cmn.IsEventDone( "clk_flatmetalware_2" ) ) then

    cmn.CallEventHandler( "use_spring_lvl3_inv" );
    cmn.CallEventHandler( "use_spring_lvl3_beg" );

    local func_end = function ()

      cmn.Lock( false );

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_clk_tumbler", 0, "", 0 );

      cmn.SetEventDone( "use_spring_lvl3" );
      cmn.CallEventHandler( "use_spring_lvl3_end" );

    end;

  cmn.Lock( true );

  cmn.ItemFly( "spr_zz_engineerbox_spring", func_end, 0 );

  return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_spinner ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_spinner" );
  cmn.CallEventHandler( "get_spinner" );

end;
--------------------------------------------------------------------------------------------
function private.get_ironcase ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_ironcase" );
  cmn.CallEventHandler( "get_ironcase" );

end;
--------------------------------------------------------------------------------------------
function private.get_key ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_key" );
  cmn.CallEventHandler( "get_key" );

end;
--------------------------------------------------------------------------------------------
function private.get_flatmetalware ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_flatmetalware" );
  cmn.CallEventHandler( "get_flatmetalware" );

end;
--------------------------------------------------------------------------------------------
function private.get_nozzle ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_nozzle" );
  cmn.CallEventHandler( "get_nozzle" );

end;
--------------------------------------------------------------------------------------------
function private.get_screw2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_screw2" );
  cmn.CallEventHandler( "get_screw2" );

end;
--------------------------------------------------------------------------------------------
function private.get_remotecontrol ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_remotecontrol" );
  cmn.CallEventHandler( "get_remotecontrol" );
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_spring_lvl3 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_spring_lvl3" );
  cmn.CallEventHandler( "get_spring_lvl3" );

end;
--------------------------------------------------------------------------------------------
function private.get_pump ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_pump" );
  cmn.CallEventHandler( "get_pump" );

end;
--------------------------------------------------------------------------------------------
function private.get_phonedial ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_phonedial" );
  cmn.CallEventHandler( "get_phonedial" );

end;
--------------------------------------------------------------------------------------------
function private.get_mechanismpart ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_mechanismpart" );
  cmn.CallEventHandler( "get_mechanismpart" );
  common.CloseSubRoom();

end;

--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************

function private.clk_grid_cover ()

  cmn.CallEventHandler( "clk_grid_cover_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_grid_cover" );
    cmn.CallEventHandler( "clk_grid_cover_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_clk_metal_cover", 0, "", 0 );

  ObjAnimate( "spr_grid_metall", "pos_xy",0,0, func_end, { 0, 3, -119, 25,    0.6, 3, -733, -207 } );

end;

--------------------------------------------------------------------------------------------

function private.clk_spinner ()

  cmn.CallEventHandler( "clk_spinner_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_spinner" );
    cmn.CallEventHandler( "clk_spinner_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_clk_tumbler", 0, "", 0 );

  ObjAnimate( "spr_zz_transformer_regulator", "ang",0,0, "", { 0, 0, 0,    0.4, 0, -1.83 } );

  ObjSet( "spr_transformer_key", { visible = true } );
  ObjAnimate( "spr_transformer_key", "alp",0,0, "", { 0, 1, 0,    0.4, 1, 0,    1.0, 1, 1 } );

  ObjAnimate( "spr_zz_transformer_button_close", "alp",0,0, func_end, { 0, 2, 1,    0.4, 2, 1,    1.0, 2, 0 } );  

end;

--------------------------------------------------------------------------------------------

function private.clk_flatmetalware_1 ()

  cmn.CallEventHandler( "clk_flatmetalware_1_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_flatmetalware_1" );
    cmn.CallEventHandler( "clk_flatmetalware_1_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_pick_engineerbox", 0, "", 0 );

  ObjAnimate( "spr_zz_engineerbox_flatmetalware", "ang",0,0, func_end, { 0, 0, 0.42,    0.4, 0, 0.17 } );

end;

--------------------------------------------------------------------------------------------

function private.clk_flatmetalware_2 ()

  cmn.CallEventHandler( "clk_flatmetalware_2_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_flatmetalware_2" );
    cmn.CallEventHandler( "clk_flatmetalware_2_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_opn_engineerbox", 0, "", 0 );

  ObjAnimate( "spr_zz_engineerbox_flatmetalware", "ang",0,0, "", { 0, 0, 0.17,    0.4, 0, 0.59 } );
  ObjAnimate( "spr_zz_engineerbox_flatmetalware", "alp",0,0, "", { 0, 0, 1,    0.4, 0, 1,    0.7, 0, 0 } );

  ObjAnimate( "spr_zz_engineerbox_cover", "pos_xy",0,0, func_end, { 0, 3, -71, -145,    0.4, 3, -71, -145,    1.0, 3, -446, -152 } );

  ObjAnimate( "spr_zz_engineerbox_cover_open_shadow", "alp",0,0, "", { 0, 0, 0,    0.7, 0, 0,    1.0, 0, 0 } );

end;

--------------------------------------------------------------------------------------------

function private.clk_engineerbox_button ()

  cmn.CallEventHandler( "clk_engineerbox_button_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_engineerbox_button" );
    cmn.CallEventHandler( "clk_engineerbox_button_end" );
    common.CloseSubRoom();

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_opn_ho_engineer", 0, "", 0 );

  ObjAnimate( "spr_zz_engineerbox_button", "pos_xy",0,0, "", { 0, 3, -153, -82,    0.3, 3, -178, -92 } );

  ObjSet( "spr_zz_engineerbox_lock_open", { alp = 0, visible = true } );
  ObjAnimate( "spr_zz_engineerbox_lock_open", "alp",0,0, "", { 0, 0, 0,    0.3, 0, 0,    0.7, 0, 1 } );

  ObjSet( "spr_zz_engineerbox_door_open", { alp = 0, visible = true } );
  ObjAnimate( "spr_zz_engineerbox_door_open", "alp",0,0, func_end, { 0, 0, 0,    0.7, 0, 0,    1.3, 0, 1,    1.6, 0, 1 } );

end;

--------------------------------------------------------------------------------------------

function private.clk_scare_powerunit_mannequin ()

  cmn.CallEventHandler( "clk_scare_powerunit_mannequin_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_scare_powerunit_mannequin" );
    cmn.CallEventHandler( "clk_scare_powerunit_mannequin_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_clk_mannequin", 0, "", 0 );

  AnimPlay( "anm_powerunit_scare_mannequin_click", "bag", func_end );

end;

--*********************************************************************************************************************
-- function *** HORRORS *** () end;
--*********************************************************************************************************************

function private.MannequinScare () 

  local func_end = function ()

    common_impl.ShowBbt( "bbt_powerunit_mannequin" );

    cmn.Lock( false ) ;
    cmn.SetEventDone( "see_scare_powerunit_mannequin" );
    cmn.CallEventHandler( "see_scare_powerunit_mannequin" );

  end;

  cmn.Lock( true ) ;
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_mannequin", 0, "", 0 );

  ObjAnimate( "anm_powerunit_scare_mannequin", "alp",0,0, "", { 0, 0, 0,    0.3, 0, 1 } );
  AnimPlay( "anm_powerunit_scare_mannequin", "fall", func_end );

end;

--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************

function private.InitAnimations ()

  ObjAnimate( "spr_powerunit_env_light", "alp",1,0, "", { 0, 3, 0.7,    1.5, 3, 0.1,    3, 3, 0.4,    5, 3, 1,    6, 3, 0.7 } );
  ObjAnimate( "spr_powerunit_lamp_light", "alp",1,0, "", { 0, 3, 1,    0.6, 3, 0.3,    1.5, 3, 0.8,    2.2, 3, 0.4,    3.5, 3, 1 } );

  ObjAnimate( "spr_cordedphone_light", "alp",1,0, "", { 0, 3, 1,    2, 3, 0.6,    4, 3, 1 } );

end;


--*********************************************************************************************************************
function private.ChairClick ()

  local func_end = function ()

    cmn.Lock( false );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_clk_chair", 0, "", 0 );

  ObjAnimate( "spr_powerunit_chair", "pos_xy",0,0, func_end, { 0, 3, 554, 555,    0.5, 3, 496, 572,    1.3, 3, 608, 543,    1.7, 3, 554, 555  } );

end;

--*********************************************************************************************************************
function private.GridFeedbackAnim()

  common_impl.ShowBbt( "bbt_grid_use_boltcutter" );

  local obj = "spr_grid_grid";
  local obj_click = "obj_grid_use_boltcutter";

  local x_start = ObjGet( obj ).pos_x;
  local y_start = ObjGet( obj ).pos_y;

  local time = 0.3;
  local dx = 1;
  local dy = -1;

  ObjSet( obj_click, { input = false } );
  local func_end = function ()
    ObjSet( obj_click, { input = true } );
  end;

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk3", 0, "", 0 );

  ObjAnimate( obj, "pos_x",0,0, "", { 0,0,x_start, time/4,0,x_start+dx, 3/4*time,0,x_start-dx, time,0,x_start } ); 
  ObjAnimate( obj, "pos_y",0,0, func_end, { 0,0,y_start, time/4,0,y_start+dy, 3/4*time,0,y_start-dy, time,0,y_start });  

end;

--*********************************************************************************************************************
function private.TransformerDoorsClick()

  local func_end = function ()

    cmn.Lock( false );
    ObjSet( "anm_zz_transformer_doors_iddle", { alp = 0 } );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk10", 0, "", 0 );

  ObjSet( "anm_zz_transformer_doors_iddle", { alp = 1 } );
  AnimPlay( "anm_zz_transformer_doors_iddle", "DoAnim", func_end );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.AnimClkReciever()

  local func_end = function ()

    cmn.Lock( false );

    ObjMultiSet({ 
      { "obj_cordedphone_reciever", { alp = 0 } },
      { "spr_cordedphone_wire",     { alp = 0 } },
      { "anm_cordedphone_off_hook", { alp = 1 } },  
    } );

  end;

  cmn.Lock( true );

  ObjMultiSet({ 
    { "obj_cordedphone_reciever", { alp = 1 } },
    { "spr_cordedphone_wire",     { alp = 1 } },
    { "anm_cordedphone_off_hook", { alp = 0 } },  
  } );
  ObjAnimate( "spr_cordedphone_reciever", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 0, ObjGet( "spr_cordedphone_reciever" ).pos_x, ObjGet( "spr_cordedphone_reciever" ).pos_y,    
    0.3, 0, ObjGet( "spr_cordedphone_reciever" ).pos_x, ObjGet( "spr_cordedphone_reciever" ).pos_y - 11,
    0.6, 0, ObjGet( "spr_cordedphone_reciever" ).pos_x, ObjGet( "spr_cordedphone_reciever" ).pos_y, 
    0.9, 0, ObjGet( "spr_cordedphone_reciever" ).pos_x, ObjGet( "spr_cordedphone_reciever" ).pos_y - 4,  
    1.2, 0, ObjGet( "spr_cordedphone_reciever" ).pos_x, ObjGet( "spr_cordedphone_reciever" ).pos_y,    
  } );

end;
--*********************************************************************************************************************
function private.AnimClkMetalCover()

  local func_end = function ()

    cmn.Lock( false );

  end;

  cmn.Lock( true );

  common_impl.ShowBbt( 'bbt_cordedphone_use_pliers' );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

  ObjAnimate( "spr_cordedphone_metal_closed", "pos_xy", 0, 0, func_end, 
    { 0.0, 0, 238, -40,    
      0.3, 0, 238, -43,
      0.6, 0, 238, -40,        
    } );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_powerunit ()

  if not ( cmn.IsEventDone( "opn_powerunit" ) ) then

    cmn.SetEventDone( "opn_powerunit" );

    common_impl.ShowBbt( "bbt_powerunit_opn_powerunit" ); 

  end;

  cmn.CallEventHandler( "opn_powerunit" );

end;

--*********************************************************************************************************************
function private.ZZEngineerboxButtonClick ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( "bbt_powerunit_engineerbox_box" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk4", 0, "", 0 );

  ObjAnimate( "spr_zz_engineerbox_button", "pos_xy",0,0, func_end, { 0, 3, -153, -82,    0.1, 3, -178, -92,    0.2, 3, -153, -82 } );

end;

--*********************************************************************************************************************
function private.ZZEngineerboxCoverClick ()

  common_impl.ShowBbt( "bbt_engineerbox_use_flatmetalware" );

  local obj = "spr_zz_engineerbox_cover";
  local x_start = ObjGet( obj ).pos_x;
  local y_start = ObjGet( obj ).pos_y;

  local time = 0.3;
  local dx = 1;
  local dy = -1;

  ObjSet( "obj_engineerbox_use_flatmetalware", { input = false } );
  local func_end = function ()
    ObjSet( "obj_engineerbox_use_flatmetalware", { input = true } );
  end;

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

  ObjAnimate( obj, "pos_x",0,0, "", { 0,0,x_start, time/4,0,x_start+dx, 3/4*time,0,x_start-dx, time,0,x_start } ); 
  ObjAnimate( obj, "pos_y",0,0, func_end, { 0,0,y_start, time/4,0,y_start+dy, 3/4*time,0,y_start-dy, time,0,y_start });  

end;
--*********************************************************************************************************************
function private.ZZCordedphoneScrewClick ()

  common_impl.ShowBbt( 'bbt_cordedphone_use_wrench' );

  ObjSet( "obj_cordedphone_use_wrench", { input = false } );
  local func_end = function ()
    ObjSet( "obj_cordedphone_use_wrench", { input = true } );
  end;

  --common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

  ObjAnimate( "spr_cordedphone_screw2", "ang", 0, 0, func_end, 
  { 
    0.0, 1, 0,
    0.2, 1, -0.01,
    0.6, 2, 0.01,
    0.8, 2, 0  } ); 

end;
--*********************************************************************************************************************
function private.CordedphneInitDial ()

  private.angles = { -0.2, -0.82, -1.43, -1.97, -2.5, -2.99, -3.52, -4.09, -4.67, -5.25 };

  private.code_mmg = { 9, 1, 1 };
  private.current_num = 1;

  private.code_open = { 8, 5, 6, 1, 9, 3 };

  for i = 1, 10 do

    ObjSet( "obj_cordedphone_button_"..i,
    {
      event_mdown = function () private.CordedphoneButtonClk( i ); end,
      event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end
    } )

  end;

  --------------------------------------------------------------------------------------------

  function private.CordedphoneButtonClk ( num )

    local speed = 0.1;
    local time = -speed * private.angles[ num ];

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_clk_disc", 0, "", 0 );

    local func_end = function ()

      common_impl.StopAudio( "sfx", "level3/sfx/aud_clk_disc", 0.2 );

      local check_flag = private.CordedphoneIsWin( num ); 

      if ( check_flag == true ) then --win

        private.current_num = 1;
        private.CordedphoneWin();

      elseif ( check_flag == false ) then --not win, right button

        cmn.Lock( false );
        private.current_num = private.current_num + 1;

      else --not win, wrong button

        cmn.Lock( false );
        private.current_num = 1;

      end;

    end;

    ObjAnimate( "spr_cordedphone_phonedial", "ang", 0, 0, func_end, 
    {
      0, 0, 0,
      time, 3, private.angles[ num ],
      2*time + 0.2, 3, 0   
    } )

    ObjAnimate( "spr_cordedphone_phonedial_shadow", "ang", 0, 0, "", 
    {
      0, 0, 0,
      time, 3, private.angles[ num ],
      2*time + 0.2, 3, 0   
    } )

  end;

  --------------------------------------------------------------------------------------------

  function private.CordedphoneIsWin ( num )

    if ( cmn.IsEventDone( "use_code1" ) and cmn.IsEventDone( "use_code2" ) and ( not cmn.IsEventDone( "win_codephone" ) ) ) then

      if ( private.code_open[ private.current_num ] == num ) then

        if ( private.current_num == 6 ) then

          return true;
  
        end;

        return false;

      end;

    end;

    return nil;

  end;

  --------------------------------------------------------------------------------------------

  function private.CordedphoneWin ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "win_codephone" );
      cmn.CallEventHandler( "win_codephone" ); 

    end;

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_open", 0, "", 0 );

    ObjAnimate( "obj_cordedphone_door_closed", "alp", 0, 0, "", { 0, 0, 1, 0.3, 0, 0 } );
    ObjAnimate( "obj_cordedphone_door_opened", "alp", 0, 0, func_end, { 0, 0, 0, 0.3, 0, 1 } );

  end;

end;
--*********************************************************************************************************************