-- name=rm_secondfloor
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_secondfloor";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_tube", "room_hub" );
  ObjAttach( "zz_patientsboxes", "room_hub" );
  ObjAttach( "zz_tobiasplans", "room_hub" );
  ObjAttach( "zz_examroomdoor", "room_hub" );
  ObjAttach( "zz_secretwall", "room_hub" );
  private.Init_Subroom();
  private.ExamroomdoorInit();  

  ObjMultiSet( { 
    { "spr_tube_leadedbox",                         { event_mdown = private.get_leadedbox         } },
    { "spr_tube_moleculeamulet1",                   { event_mdown = private.get_moleculeamulet1   } },
    { "spr_tube_metalbasrelief",                    { event_mdown = private.get_metalbasrelief    } },
    { "spr_patientsboxes_tobiaswallet",             { event_mdown = private.get_tobiaswallet      } },
    { "spr_patientsboxes_engravedknife",            { event_mdown = private.get_engravedknife     } },
    { "spr_patientsboxes_fireextinguisher",         { event_mdown = private.get_fireextinguisher  } },
    { "spr_patientsboxes_tobiaskey",                { event_mdown = private.get_tobiaskey         } },
    { "spr_tobiasplans_watch",                      { event_mdown = private.get_watch             } },
    { "spr_tobiasplans_sledgehammer",               { event_mdown = private.get_sledgehammer      } },
    { "spr_examroomdoor_moleculeamulet2",           { event_mdown = private.get_moleculeamulet2   } },
    { "spr_examroomdoor_moleculeamulet2",           { event_mdown = private.get_moleculeamulet2   } },
    { "obj_tobiasplans_use_tobiaskey",              { event_mdown = private.AnimClkTobiaskey      } },

    { "obj_secretwall_clk_socket",                  { event_mdown = private.clk_socket            } },
    { "obj_secretwall_clk_slots",                   { event_mdown = private.clk_slots             } },
    { "obj_secondfloor_door_clk",                   { event_mdown = private.clk_secondfloor_door  } },

    { "obj_examroomdoor_use_metalbasrelief",        { event_mdown = private.ExamroomdoorHandleClick  } },
    { "obj_examroomdoor_clk_door",                  { event_mdown = private.ExamroomdoorHandleClick  } },
    { "obj_secondfloor_terence_appear_clk",         { event_mdown = private.SecondfloorTerenceAppear } },

    { "obj_patientsboxes_use_moleculeamulet1",      { event_mdown = private.AnimClkMoleculeamulet1   } },
    { "obj_patientsboxes_use_moleculeamulet2",      { event_mdown = private.AnimClkMoleculeamulet2   } },
    { "obj_patientsboxes_use_moleculeamulet3",      { event_mdown = private.AnimClkMoleculeamulet3   } },

    { "spr_collect2_item_3_3",                      { event_mdown = private.get_collect2_item_3_3 } },
    { "spr_collect2_item_3_4",                      { event_mdown = private.get_collect2_item_3_4 } },

    { "obj_tube_use_hook",                          { event_mdown = private.UseHook } },
    { "obj_tobiasplans_clk_tobiasbox",              { event_mdown = private.clk_tobiasbox } },

    { "spr_secondfloor_collect_morph_item",         { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_3_4" ); end } },
    { "spr_secondfloor_collect_item",               { event_mdown = function () common_impl.GetCollectItem( "get_collect_item_3_2" );     end } },
  } );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_secondfloor = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "gho_secondfloor_burntwall",
      "gzz_secondfloor_tube",
      "gzz_secondfloor_patientsboxes",
      "gzz_secondfloor_tobiasplans",
      "gzz_secondfloor_examroomdoor",
      "gzz_secondfloor_secretwall",
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_tube",
      "zz_patientsboxes",
      "zz_tobiasplans",
      "zz_examroomdoor",
      "zz_secretwall",
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_secondfloor", update_game_mode_secondfloor, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_secondfloor = function ()

  local effects_table = 
  {
    "obj_secondfloor_anim" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_secondfloor", update_performance_mode_secondfloor, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_secondfloor () end;
  --------------------------------------------------------------------------------------------
  local opn_secondfloor_map = function ()

    common_impl.VisitMapRoom( "secondfloor" );

  end;
  cmn.AddSubscriber( "opn_secondfloor", opn_secondfloor_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_leadedbox () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_leadedbox" ] = {
    type = "get",
    get_obj = "spr_tube_leadedbox",
    room = private.room_objname,
    zz = "zz_tube",
    zz_gate = "gzz_secondfloor_tube"
  };
  
  local get_leadedbox_inv = function ()
  
    interface.InventoryItemAdd( "inv_leadedbox", "spr_tube_leadedbox" );
    ObjSet( "inv_leadedbox", { drag = false } );
  end;
  
  local get_leadedbox_closezz = function ()
  
    ObjDelete( "gfx_tube_leadedbox" );
    ObjDelete( "gzz_secondfloor_tube" );
    ObjDelete( "spr_tube_box_shadow" );  
    ObjDelete( "spr_secondfloor_tube_10" );  

  end;
  
  cmn.AddSubscriber( "get_leadedbox", get_leadedbox_inv );
  cmn.AddSubscriber( "get_leadedbox", get_leadedbox_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_moleculeamulet1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_moleculeamulet1" ] = {
    type = "get",
    get_obj = "spr_tube_moleculeamulet1",
    room = private.room_objname,
    zz = "zz_tube",
    zz_gate = "gzz_secondfloor_tube"
  };
  
  local get_moleculeamulet1_inv = function ()
  
    interface.InventoryItemAdd( "inv_moleculeamulet1", "spr_tube_moleculeamulet1" );
  
  end;
  
  local get_moleculeamulet1_closezz = function ()
  
    ObjDelete( "gfx_tube_moleculeamulet1" );
    ObjDelete( "spr_tube_amulet_2_shadow" );
    ObjDelete( "spr_secondfloor_tube_7" );

  end;
  
  cmn.AddSubscriber( "get_moleculeamulet1", get_moleculeamulet1_inv );
  cmn.AddSubscriber( "get_moleculeamulet1", get_moleculeamulet1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_metalbasrelief () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_metalbasrelief" ] = {
    type = "get",
    get_obj = "spr_tube_metalbasrelief",
    room = private.room_objname,
    zz = "zz_tube",
    zz_gate = "gzz_secondfloor_tube"
  };
  
  local get_metalbasrelief_inv = function ()
  
    interface.InventoryItemAdd( "inv_metalbasrelief", "spr_tube_metalbasrelief" );
  
  end;
  
  local get_metalbasrelief_closezz = function ()
  
    ObjDelete( "gfx_tube_metalbasrelief" );
    ObjDelete( "spr_secondfloor_tube_1" );  

  end;
  
  cmn.AddSubscriber( "get_metalbasrelief", get_metalbasrelief_inv );
  cmn.AddSubscriber( "get_metalbasrelief", get_metalbasrelief_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tobiaswallet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tobiaswallet" ] = {
    type = "get",
    get_obj = "spr_patientsboxes_tobiaswallet",
    room = private.room_objname,
    zz = "zz_patientsboxes",
    zz_gate = "gzz_secondfloor_patientsboxes"
  };
  
  local get_tobiaswallet_inv = function ()
  
    interface.InventoryItemAdd( "inv_tobiaswallet", "spr_patientsboxes_tobiaswallet" );
    ObjSet( "inv_tobiaswallet", { drag = false } );

  end;
  
  local get_tobiaswallet_closezz = function ()
  
    ObjDelete( "gfx_patientsboxes_tobiaswallet" );
    ObjDelete( "spr_secondfloor_patientsboxes_tobiaswallet" );
  
  end;
  
  cmn.AddSubscriber( "get_tobiaswallet", get_tobiaswallet_inv );
  cmn.AddSubscriber( "get_tobiaswallet", get_tobiaswallet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_engravedknife () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_engravedknife" ] = {
    type = "get",
    get_obj = "spr_patientsboxes_engravedknife",
    room = private.room_objname,
    zz = "zz_patientsboxes",
    zz_gate = "gzz_secondfloor_patientsboxes"
  };
  
  local get_engravedknife_inv = function ()
  
    interface.InventoryItemAdd( "inv_engravedknife", "spr_patientsboxes_engravedknife" );
    cmn.SetInvPlusRGB( "ropetrap", true ); 

  end;
  
  local get_engravedknife_closezz = function ()
  
    ObjDelete( "gfx_patientsboxes_engravedknife" );
    ObjDelete( "spr_secondfloor_patientsboxes_knife" );  

    if cmn.IsGetCollect2( "get_collect2_item_3_3" ) and cmn.IsEventDone( "get_fireextinguisher" ) then

      ObjDelete( "gzz_secondfloor_patientsboxes" );

    end;

  end;
  
  cmn.AddSubscriber( "get_engravedknife", get_engravedknife_inv );
  cmn.AddSubscriber( "get_engravedknife", get_engravedknife_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fireextinguisher () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fireextinguisher" ] = {
    type = "get",
    get_obj = "spr_patientsboxes_fireextinguisher",
    room = private.room_objname,
    zz = "zz_patientsboxes",
    zz_gate = "gzz_secondfloor_patientsboxes"
  };
  
  local get_fireextinguisher_inv = function ()
  
    interface.InventoryItemAdd( "inv_fireextinguisher", "spr_patientsboxes_fireextinguisher" );
  
  end;
  
  local get_fireextinguisher_closezz = function ()
  
    ObjDelete( "gfx_patientsboxes_fireextinguisher" );

    if ( cmn.IsGetCollect2( "get_collect2_item_3_3" ) and cmn.IsEventDone( "get_engravedknife" ) ) then

      ObjDelete( "gzz_secondfloor_patientsboxes" );

    end;

    ObjDelete( "spr_secondfloor_patientsboxes_fire_extinguisher" );

  end;
  
  cmn.AddSubscriber( "get_fireextinguisher", get_fireextinguisher_inv );
  cmn.AddSubscriber( "get_fireextinguisher", get_fireextinguisher_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tobiaskey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tobiaskey" ] = {
    type = "get",
    get_obj = "spr_patientsboxes_tobiaskey",
    room = private.room_objname,
    zz = "zz_patientsboxes",
    zz_gate = "gzz_secondfloor_patientsboxes"
  };
  
  local get_tobiaskey_inv = function ()
  
    interface.InventoryItemAdd( "inv_tobiaskey", "spr_patientsboxes_tobiaskey" );
  
  end;
  
  local get_tobiaskey_closezz = function ()
  
    ObjDelete( "gfx_patientsboxes_tobiaskey" );
    ObjDelete( "spr_secondfloor_patientsboxes_tobiaskey" );  

  end;
  
  cmn.AddSubscriber( "get_tobiaskey", get_tobiaskey_inv );
  cmn.AddSubscriber( "get_tobiaskey", get_tobiaskey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_watch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_watch" ] = {
    type = "get",
    get_obj = "spr_tobiasplans_watch",
    room = private.room_objname,
    zz = "zz_tobiasplans",
    zz_gate = "gzz_secondfloor_tobiasplans"
  };
  
  local get_watch_inv = function ()
  
    interface.InventoryItemAdd( "inv_watch", "spr_tobiasplans_watch" );
    ObjSet( "inv_watch", { drag = false } );

  end;
  
  local get_watch_closezz = function ()
  
    ObjDelete( "gfx_tobiasplans_watch" );

    if ( cmn.IsGetCollect2( "get_collect2_item_3_4" ) ) then

      ObjDelete( "gzz_secondfloor_tobiasplans" );

    end;

    ObjDelete( "spr_tobiasplans_watch_shadow" );    

  end;
  
  cmn.AddSubscriber( "get_watch", get_watch_inv );
  cmn.AddSubscriber( "get_watch", get_watch_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sledgehammer () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sledgehammer" ] = {
    type = "get",
    get_obj = "spr_tobiasplans_sledgehammer",
    room = private.room_objname,
    zz = "zz_tobiasplans",
    zz_gate = "gzz_secondfloor_tobiasplans"
  };
  
  local get_sledgehammer_inv = function ()
  
    interface.InventoryItemAdd( "inv_sledgehammer", "spr_tobiasplans_sledgehammer" );
  
  end;
  
  local get_sledgehammer_closezz = function ()
  
    ObjDelete( "gfx_tobiasplans_sledgehammer" );
    ObjDelete( "spr_tobiasplans_sledgehammer_shadow" );  
    ObjDelete( "spr_secondfloor_sledgehammer_layer" );  

  end;
  
  cmn.AddSubscriber( "get_sledgehammer", get_sledgehammer_inv );
  cmn.AddSubscriber( "get_sledgehammer", get_sledgehammer_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_moleculeamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_moleculeamulet2" ] = {
    type = "get",
    get_obj = "spr_examroomdoor_moleculeamulet2",
    room = private.room_objname,
    zz = "zz_examroomdoor",
    zz_gate = "gzz_secondfloor_examroomdoor"
  };
  
  local get_moleculeamulet2_inv = function ()
  
    interface.InventoryItemAdd( "inv_moleculeamulet2", "spr_examroomdoor_moleculeamulet2" );
  
  end;
  
  local get_moleculeamulet2_closezz = function ()
  
    ObjDelete( "gfx_examroomdoor_moleculeamulet2" );
  
  end;
  
  cmn.AddSubscriber( "get_moleculeamulet2", get_moleculeamulet2_inv );
  cmn.AddSubscriber( "get_moleculeamulet2", get_moleculeamulet2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_3_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_3_2 = function ()
  
    ObjDelete( "obj_secondfloor_collect" );
  
  end;    
  cmn.AddSubscriber( "get_collect_item_3_2", get_collect_item_3_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_3_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_3_3 = function ()
  
    ObjDelete( "obj_collect2_item_3_3" );

    if ( cmn.IsEventDone( "get_fireextinguisher" ) and cmn.IsEventDone( "get_engravedknife" ) ) then

      ObjDelete( "gzz_secondfloor_patientsboxes" );

    end;
  
  end;    
  cmn.AddSubscriber( "get_collect2_item_3_3", get_collect2_item_3_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_3_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_3_4 = function ()
  
    ObjDelete( "obj_collect2_item_3_4" );

    if ( cmn.IsEventDone( "get_watch" ) ) then

      ObjDelete( "gzz_secondfloor_tobiasplans" );

    end;
  
  end;    
  cmn.AddSubscriber( "get_collect2_item_3_4", get_collect2_item_3_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_3_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_3_4 = function ()
  
    ObjDelete( "obj_secondfloor_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_3_4", get_collect_morph_item_3_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hook_lvl3_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hook_lvl3_2" ] = {
    type = "use",
    inv_obj = "inv_hook_lvl3",
    use_place = "obj_tube_use_hook",
    room = private.room_objname,
    zz = "zz_tube",
    zz_gate = "gzz_secondfloor_tube"
  };
  local use_hook_lvl3_2_inv = function ()
  
    if cmn.IsEventDone( "use_hook_lvl3" ) then 
      interface.InventoryItemRemove( "inv_hook_lvl3" );
    end; 
  
  end;
  local use_hook_lvl3_2_beg = function ()
  
    ObjDelete( "obj_tube_use_hook" );
  
  end;
  local use_hook_lvl3_2_end = function ()
  
    ObjSet( "spr_tube_amulet_2_shadow", { pos_x = 162, pos_y = -146 } );
    ObjSet( "spr_tube_moleculeamulet1", { input = true, pos_x = 165, pos_y = -184 } );
    ObjSet( "gfx_tube_moleculeamulet1", { active = true } );
    ObjDelete( "spr_tube_hook" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hook_lvl3_2", use_hook_lvl3_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_hook_lvl3_2", use_hook_lvl3_2_inv );
  cmn.AddSubscriber( "use_hook_lvl3_2", use_hook_lvl3_2_end, private.room_objname );
  cmn.AddSubscriber( "use_hook_lvl3_2_inv", use_hook_lvl3_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_hook_lvl3_2_beg", use_hook_lvl3_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_hook_lvl3_2_end", use_hook_lvl3_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_adjustmentcontrol () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_adjustmentcontrol" ] = {
    type = "use",
    inv_obj = "inv_adjustmentcontrol",
    use_place = "obj_tube_use_adjustmentcontrol",
    room = private.room_objname,
    zz = "zz_tube",
    zz_gate = "gzz_secondfloor_tube"
  };
  local use_adjustmentcontrol_inv = function ()
  
    interface.InventoryItemRemove( "inv_adjustmentcontrol" );
  
  end;
  local use_adjustmentcontrol_beg = function ()
  
    ObjDelete( "obj_tube_use_adjustmentcontrol" );
  
  end;
  local use_adjustmentcontrol_end = function ()
  
    ObjSet( "spr_tube_metalbasrelief", { input = true } );
    ObjDelete( "spr_tube_cower_1" );
    ObjSet( "spr_tube_regulator", { alp = 1 } );

    ObjDelete( "spr_secondfloor_tube_2" );
    ObjSet( "spr_secondfloor_tube_9", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_adjustmentcontrol", use_adjustmentcontrol_beg, private.room_objname );
  cmn.AddSubscriber( "use_adjustmentcontrol", use_adjustmentcontrol_inv );
  cmn.AddSubscriber( "use_adjustmentcontrol", use_adjustmentcontrol_end, private.room_objname );
  cmn.AddSubscriber( "use_adjustmentcontrol_inv", use_adjustmentcontrol_inv, private.room_objname );
  cmn.AddSubscriber( "use_adjustmentcontrol_beg", use_adjustmentcontrol_beg, private.room_objname );
  cmn.AddSubscriber( "use_adjustmentcontrol_end", use_adjustmentcontrol_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sensor () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sensor" ] = {
    type = "use",
    inv_obj = "inv_sensor",
    use_place = "obj_tube_use_sensor",
    room = private.room_objname,
    zz = "zz_tube",
    zz_gate = "gzz_secondfloor_tube"
  };
  local use_sensor_inv = function ()
  
    interface.InventoryItemRemove( "inv_sensor" );
  
  end;
  local use_sensor_beg = function ()
  
    ObjDelete( "obj_tube_use_sensor" );
  
  end;
  local use_sensor_end = function ()
  
    ObjSet( "spr_secondfloor_tube_5", { alp = 1 } );
    ObjSet( "spr_secondfloor_tube_4", { pos_y = 368 } );

    ObjSet( "spr_tube_counter_3",     { alp = 1 } );
    ObjSet( "spr_tube_cower_2",       { pos_y = -243 } );  
    ObjSet( "obj_tube_lamps",         { input = true } );
    ObjSet( "spr_tube_handle_1",      { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sensor", use_sensor_beg, private.room_objname );
  cmn.AddSubscriber( "use_sensor", use_sensor_inv );
  cmn.AddSubscriber( "use_sensor", use_sensor_end, private.room_objname );
  cmn.AddSubscriber( "use_sensor_inv", use_sensor_inv, private.room_objname );
  cmn.AddSubscriber( "use_sensor_beg", use_sensor_beg, private.room_objname );
  cmn.AddSubscriber( "use_sensor_end", use_sensor_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fireextinguisherhead () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fireextinguisherhead" ] = {
    type = "use",
    inv_obj = "inv_fireextinguisherhead",
    use_place = "obj_patientsboxes_use_fireextinguisherhead",
    room = private.room_objname,
    zz = "zz_patientsboxes",
    zz_gate = "gzz_secondfloor_patientsboxes"
  };
  local use_fireextinguisherhead_inv = function ()
  
    interface.InventoryItemRemove( "inv_fireextinguisherhead" );
  
  end;
  local use_fireextinguisherhead_beg = function ()
  
    ObjDelete( "obj_patientsboxes_use_fireextinguisherhead" );
  
  end;
  local use_fireextinguisherhead_end = function ()
  
    ObjSet( "spr_patientsboxes_fireextinguisher", { input = true } );
    ObjSet( "gfx_patientsboxes_fireextinguisher", { active = true } );  

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fireextinguisherhead", use_fireextinguisherhead_beg, private.room_objname );
  cmn.AddSubscriber( "use_fireextinguisherhead", use_fireextinguisherhead_inv );
  cmn.AddSubscriber( "use_fireextinguisherhead", use_fireextinguisherhead_end, private.room_objname );
  cmn.AddSubscriber( "use_fireextinguisherhead_inv", use_fireextinguisherhead_inv, private.room_objname );
  cmn.AddSubscriber( "use_fireextinguisherhead_beg", use_fireextinguisherhead_beg, private.room_objname );
  cmn.AddSubscriber( "use_fireextinguisherhead_end", use_fireextinguisherhead_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_moleculeamulet1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_moleculeamulet1" ] = {
    type = "use",
    inv_obj = "inv_moleculeamulet1",
    use_place = "obj_patientsboxes_use_moleculeamulet1",
    room = private.room_objname,
    zz = "zz_patientsboxes",
    zz_gate = "gzz_secondfloor_patientsboxes"
  };
  local use_moleculeamulet1_inv = function ()
  
    interface.InventoryItemRemove( "inv_moleculeamulet1" );
  
  end;
  local use_moleculeamulet1_beg = function ()
  
    ObjDelete( "obj_patientsboxes_use_moleculeamulet1" );
  
  end;
  local use_moleculeamulet1_end = function ()
  
    ObjDelete( "spr_patientsboxes_door_close_1" );
    ObjSet( "spr_patientsboxes_tobiaswallet", { input = true } );

    ObjDelete( "spr_secondfloor_patientsboxes_door_3_close" );
    ObjSet( "spr_secondfloor_patientsboxes_door_3_open", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_moleculeamulet1", use_moleculeamulet1_beg, private.room_objname );
  cmn.AddSubscriber( "use_moleculeamulet1", use_moleculeamulet1_inv );
  cmn.AddSubscriber( "use_moleculeamulet1", use_moleculeamulet1_end, private.room_objname );
  cmn.AddSubscriber( "use_moleculeamulet1_inv", use_moleculeamulet1_inv, private.room_objname );
  cmn.AddSubscriber( "use_moleculeamulet1_beg", use_moleculeamulet1_beg, private.room_objname );
  cmn.AddSubscriber( "use_moleculeamulet1_end", use_moleculeamulet1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_moleculeamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_moleculeamulet2" ] = {
    type = "use",
    inv_obj = "inv_moleculeamulet2",
    use_place = "obj_patientsboxes_use_moleculeamulet2",
    room = private.room_objname,
    zz = "zz_patientsboxes",
    zz_gate = "gzz_secondfloor_patientsboxes"
  };
  local use_moleculeamulet2_inv = function ()
  
    interface.InventoryItemRemove( "inv_moleculeamulet2" );
  
  end;
  local use_moleculeamulet2_beg = function ()
  
    ObjDelete( "obj_patientsboxes_use_moleculeamulet2" );
  
  end;
  local use_moleculeamulet2_end = function ()
  
    ObjDelete( "spr_patientsboxes_door_close_2" );
    ObjSet( "spr_patientsboxes_door_open_up", { alp = 1 } );
    ObjSet( "spr_patientsboxes_tobiaskey",    { input = true } );
  
    ObjDelete( "spr_secondfloor_patientsboxes_door_1_close" );
    ObjSet( "spr_secondfloor_patientsboxes_door_1_open", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_moleculeamulet2", use_moleculeamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_moleculeamulet2", use_moleculeamulet2_inv );
  cmn.AddSubscriber( "use_moleculeamulet2", use_moleculeamulet2_end, private.room_objname );
  cmn.AddSubscriber( "use_moleculeamulet2_inv", use_moleculeamulet2_inv, private.room_objname );
  cmn.AddSubscriber( "use_moleculeamulet2_beg", use_moleculeamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_moleculeamulet2_end", use_moleculeamulet2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_moleculeamulet3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_moleculeamulet3" ] = {
    type = "use",
    inv_obj = "inv_moleculeamulet3",
    use_place = "obj_patientsboxes_use_moleculeamulet3",
    room = private.room_objname,
    zz = "zz_patientsboxes",
    zz_gate = "gzz_secondfloor_patientsboxes"
  };
  local use_moleculeamulet3_inv = function ()
  
    interface.InventoryItemRemove( "inv_moleculeamulet3" );
  
  end;
  local use_moleculeamulet3_beg = function ()
  
    ObjDelete( "obj_patientsboxes_use_moleculeamulet3" );
  
  end;
  local use_moleculeamulet3_end = function ()

    ObjDelete( "spr_patientsboxes_door_close_3" );
    ObjSet( "spr_patientsboxes_door_open_down", { alp = 1 } );
    ObjSet( "spr_patientsboxes_engravedknife",  { input = true } );
  
    ObjDelete( "spr_secondfloor_patientsboxes_door_2_close" );
    ObjSet( "spr_secondfloor_patientsboxes_door_2_open", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_moleculeamulet3", use_moleculeamulet3_beg, private.room_objname );
  cmn.AddSubscriber( "use_moleculeamulet3", use_moleculeamulet3_inv );
  cmn.AddSubscriber( "use_moleculeamulet3", use_moleculeamulet3_end, private.room_objname );
  cmn.AddSubscriber( "use_moleculeamulet3_inv", use_moleculeamulet3_inv, private.room_objname );
  cmn.AddSubscriber( "use_moleculeamulet3_beg", use_moleculeamulet3_beg, private.room_objname );
  cmn.AddSubscriber( "use_moleculeamulet3_end", use_moleculeamulet3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tobiascode () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tobiascode" ] = {
    type = "use",
    inv_obj = "inv_tobiascode",
    use_place = "obj_tobiasplans_use_tobiascode",
    room = private.room_objname,
    zz = "zz_tobiasplans",
    zz_gate = "gzz_secondfloor_tobiasplans"
  };
  local use_tobiascode_inv = function ()
  
    interface.InventoryItemRemove( "inv_tobiascode" );
  
  end;
  local use_tobiascode_beg = function ()
  
    ObjDelete( "obj_tobiasplans_use_tobiascode" );
  
  end;
  local use_tobiascode_end = function ()

    ObjSet( "spr_tobiasplans_paper",        { alp = 1 } );  
    ObjSet( "obj_tobiasplans_buttons",      { input = true } );  

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tobiascode", use_tobiascode_beg, private.room_objname );
  cmn.AddSubscriber( "use_tobiascode", use_tobiascode_inv );
  cmn.AddSubscriber( "use_tobiascode", use_tobiascode_end, private.room_objname );
  cmn.AddSubscriber( "use_tobiascode_inv", use_tobiascode_inv, private.room_objname );
  cmn.AddSubscriber( "use_tobiascode_beg", use_tobiascode_beg, private.room_objname );
  cmn.AddSubscriber( "use_tobiascode_end", use_tobiascode_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tobiaskey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tobiaskey" ] = {
    type = "use",
    inv_obj = "inv_tobiaskey",
    use_place = "obj_tobiasplans_use_tobiaskey",
    room = private.room_objname,
    zz = "zz_tobiasplans",
    zz_gate = "gzz_secondfloor_tobiasplans"
  };
  local use_tobiaskey_inv = function ()
  
    interface.InventoryItemRemove( "inv_tobiaskey" );
  
  end;
  local use_tobiaskey_beg = function ()
  
    ObjDelete( "obj_tobiasplans_use_tobiaskey" );
    
    ObjSet( "spr_tobiasplans_key_patch", { alp = 1 } );
  
  end;
  local use_tobiaskey_end = function ()
  
    ObjSet( "spr_tobiasplans_open_box2",  { alp = 1      } );
    ObjSet( "spr_tobiasplans_key2",       { alp = 1      } );
    ObjSet( "obj_tobiasplans_clk_tobiasbox", { input = true, alp = 1 } );

    ObjDelete( "spr_tobiasplans_key1"  );
    --ObjDelete( "spr_tobiasplans_patch" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tobiaskey", use_tobiaskey_beg, private.room_objname );
  cmn.AddSubscriber( "use_tobiaskey", use_tobiaskey_inv );
  cmn.AddSubscriber( "use_tobiaskey", use_tobiaskey_end, private.room_objname );
  cmn.AddSubscriber( "use_tobiaskey_inv", use_tobiaskey_inv, private.room_objname );
  cmn.AddSubscriber( "use_tobiaskey_beg", use_tobiaskey_beg, private.room_objname );
  cmn.AddSubscriber( "use_tobiaskey_end", use_tobiaskey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_smallslider1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_smallslider1" ] = {
    type = "use",
    inv_obj = "inv_smallslider1",
    use_place = "obj_examroomdoor_use_smallslider1",
    room = private.room_objname,
    zz = "zz_examroomdoor",
    zz_gate = "gzz_secondfloor_examroomdoor"
  };
  local use_smallslider1_inv = function ()
  
    interface.InventoryItemRemove( "inv_smallslider1" );
  
  end;
  local use_smallslider1_beg = function ()
  
    ObjDelete( "obj_examroomdoor_use_smallslider1" );
  
  end;
  local use_smallslider1_end = function ()
  
    ObjSet( "spr_examroomdoor_button_2", { alp = 1, visible = true } );

    if cmn.IsEventDone( "use_smallslider2" ) then
      ObjSet( "obj_examroomdoor_mmg", { input = true } );
    end; 

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_smallslider1", use_smallslider1_beg, private.room_objname );
  cmn.AddSubscriber( "use_smallslider1", use_smallslider1_inv );
  cmn.AddSubscriber( "use_smallslider1", use_smallslider1_end, private.room_objname );
  cmn.AddSubscriber( "use_smallslider1_inv", use_smallslider1_inv, private.room_objname );
  cmn.AddSubscriber( "use_smallslider1_beg", use_smallslider1_beg, private.room_objname );
  cmn.AddSubscriber( "use_smallslider1_end", use_smallslider1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_smallslider2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_smallslider2" ] = {
    type = "use",
    inv_obj = "inv_smallslider2",
    use_place = "obj_examroomdoor_use_smallslider2",
    room = private.room_objname,
    zz = "zz_examroomdoor",
    zz_gate = "gzz_secondfloor_examroomdoor"
  };
  local use_smallslider2_inv = function ()
  
    interface.InventoryItemRemove( "inv_smallslider2" );
  
  end;
  local use_smallslider2_beg = function ()
  
    ObjDelete( "obj_examroomdoor_use_smallslider2" );
  
  end;
  local use_smallslider2_end = function ()
  
    ObjSet( "spr_examroomdoor_button_4", { alp = 1, visible = true } );

    if cmn.IsEventDone( "use_smallslider1" ) then
      ObjSet( "obj_examroomdoor_mmg", { input = true } );
    end; 

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_smallslider2", use_smallslider2_beg, private.room_objname );
  cmn.AddSubscriber( "use_smallslider2", use_smallslider2_inv );
  cmn.AddSubscriber( "use_smallslider2", use_smallslider2_end, private.room_objname );
  cmn.AddSubscriber( "use_smallslider2_inv", use_smallslider2_inv, private.room_objname );
  cmn.AddSubscriber( "use_smallslider2_beg", use_smallslider2_beg, private.room_objname );
  cmn.AddSubscriber( "use_smallslider2_end", use_smallslider2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_metalbasrelief () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_metalbasrelief" ] = {
    type = "use",
    inv_obj = "inv_metalbasrelief",
    use_place = "obj_examroomdoor_use_metalbasrelief",
    room = private.room_objname,
    zz = "zz_examroomdoor",
    zz_gate = "gzz_secondfloor_examroomdoor"
  };
  local use_metalbasrelief_inv = function ()
  
    interface.InventoryItemRemove( "inv_metalbasrelief" );
  
  end;
  local use_metalbasrelief_beg = function ()
  
    ObjDelete( "obj_examroomdoor_use_metalbasrelief" );
  
  end;
  local use_metalbasrelief_end = function ()
  
    ObjSet( "spr_examroomdoor_door", { input = true } );
    ObjSet( "spr_examroomdoor_moleculeamulet2", { input = true } );
    ObjSet( "gfx_examroomdoor_moleculeamulet2", { active = true } );

    ObjSet( "obj_examroomdoor_use_smallslider1", { input = true } );
    ObjSet( "obj_examroomdoor_use_smallslider2", { input = true } );

    ObjDelete( "spr_examroomdoor_lock_close" );
    ObjDelete( "spr_examroomdoor_lock_open1" );
    ObjDelete( "spr_examroomdoor_lock_open1_shadow" );
    ObjDelete( "spr_examroomdoor_lock_open2" );
    ObjDelete( "spr_examroomdoor_lock_open2_shadow" );
------------------
    ObjSet( "spr_secondfloor_door_mmg", { alp = 1, visible = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_metalbasrelief", use_metalbasrelief_beg, private.room_objname );
  cmn.AddSubscriber( "use_metalbasrelief", use_metalbasrelief_inv );
  cmn.AddSubscriber( "use_metalbasrelief", use_metalbasrelief_end, private.room_objname );
  cmn.AddSubscriber( "use_metalbasrelief_inv", use_metalbasrelief_inv, private.room_objname );
  cmn.AddSubscriber( "use_metalbasrelief_beg", use_metalbasrelief_beg, private.room_objname );
  cmn.AddSubscriber( "use_metalbasrelief_end", use_metalbasrelief_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tobiaspermit () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tobiaspermit" ] = {
    type = "use",
    inv_obj = "inv_tobiaspermit",
    use_place = "obj_secretwall_use_tobiaspermit",
    room = private.room_objname,
    zz = "zz_secretwall",
    zz_gate = "gzz_secondfloor_secretwall"
  };
  local use_tobiaspermit_inv = function ()
  
    interface.InventoryItemRemove( "inv_tobiaspermit" );
  
  end;
  local use_tobiaspermit_beg = function ()
  
    ObjDelete( "obj_secretwall_use_tobiaspermit" );

    ObjSet( "anm_secretwall_tobiaspermit", { alp = 1 } );
  
  end;
  local use_tobiaspermit_end = function ()
  
    ObjMultiSet({ 
      { "obj_secretwall_tobiaspermit", { alp = 1 }},
      { "spr_secretwall_light_2",      { alp = 1 }},
    });

    ObjDelete( "anm_secretwall_tobiaspermit" );

    if cmn.IsEventDone( "use_terencepermit" ) then 

      ObjMultiSet({  
        { "spr_secretwall_light_3",   { alp = 1                     }},
        { "obj_secretwall_clk_slots", { input = true, active = true }},    
      });

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tobiaspermit", use_tobiaspermit_beg, private.room_objname );
  cmn.AddSubscriber( "use_tobiaspermit", use_tobiaspermit_inv );
  cmn.AddSubscriber( "use_tobiaspermit", use_tobiaspermit_end, private.room_objname );
  cmn.AddSubscriber( "use_tobiaspermit_inv", use_tobiaspermit_inv, private.room_objname );
  cmn.AddSubscriber( "use_tobiaspermit_beg", use_tobiaspermit_beg, private.room_objname );
  cmn.AddSubscriber( "use_tobiaspermit_end", use_tobiaspermit_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_terencepermit () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_terencepermit" ] = {
    type = "use",
    inv_obj = "inv_terencepermit",
    use_place = "obj_secretwall_use_terencepermit",
    room = private.room_objname,
    zz = "zz_secretwall",
    zz_gate = "gzz_secondfloor_secretwall"
  };
  local use_terencepermit_inv = function ()
  
    interface.InventoryItemRemove( "inv_terencepermit" );
  
  end;
  local use_terencepermit_beg = function ()
  
    ObjDelete( "obj_secretwall_use_terencepermit" );

    ObjSet( "anm_secretwall_terencepermit", { alp = 1 } );
  
  end;
  local use_terencepermit_end = function ()
  
    ObjMultiSet({ 
      { "obj_secretwall_terencepermit", { alp = 1 }},
      { "spr_secretwall_light_1",       { alp = 1 }},
    });

    ObjDelete( "anm_secretwall_terencepermit" );

    if cmn.IsEventDone( "use_tobiaspermit" ) then 

      ObjMultiSet({  
        { "spr_secretwall_light_3",   { alp = 1                     }},
        { "obj_secretwall_clk_slots", { input = true, active = true }},    
      });

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_terencepermit", use_terencepermit_beg, private.room_objname );
  cmn.AddSubscriber( "use_terencepermit", use_terencepermit_inv );
  cmn.AddSubscriber( "use_terencepermit", use_terencepermit_end, private.room_objname );
  cmn.AddSubscriber( "use_terencepermit_inv", use_terencepermit_inv, private.room_objname );
  cmn.AddSubscriber( "use_terencepermit_beg", use_terencepermit_beg, private.room_objname );
  cmn.AddSubscriber( "use_terencepermit_end", use_terencepermit_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lasso () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lasso" ] = {
    type = "use",
    inv_obj = "inv_lasso",
    use_place = "obj_secondfloor_use_lasso",
    room = private.room_objname 
  };
  local use_lasso_inv = function ()
  
    interface.InventoryItemRemove( "inv_lasso" );
  
  end;
  local use_lasso_beg = function ()
  
    ObjDelete( "obj_secondfloor_use_lasso" );
  
  end;
  local use_lasso_end = function ()
  
    ObjSet( "gho_secondfloor_burntwall",  { input = true, active = true } );
    ObjSet( "gzz_secondfloor_secretwall", { input = true, active = true } );
    
    ObjDelete( "vid_secondfloor_neutralization_2_zap" );
    ObjDelete( "spr_secondfloor_patch_shelves" );
    ObjSet( "spr_secondfloor_rope", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lasso", use_lasso_beg, private.room_objname );
  cmn.AddSubscriber( "use_lasso", use_lasso_inv );
  cmn.AddSubscriber( "use_lasso", use_lasso_end, private.room_objname );
  cmn.AddSubscriber( "use_lasso_inv", use_lasso_inv, private.room_objname );
  cmn.AddSubscriber( "use_lasso_beg", use_lasso_beg, private.room_objname );
  cmn.AddSubscriber( "use_lasso_end", use_lasso_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fireextinguisher () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fireextinguisher" ] = {
    type = "use",
    inv_obj = "inv_fireextinguisher",
    use_place = "obj_secondfloor_use_fireextinguisher",
    room = private.room_objname 
  };
  local use_fireextinguisher_inv = function ()
  
    interface.InventoryItemRemove( "inv_fireextinguisher" );
  
  end;
  local use_fireextinguisher_beg = function ()
  
    ObjDelete( "obj_secondfloor_use_fireextinguisher" );
  
  end;
  local use_fireextinguisher_end = function ()
  
    ObjSet( "obj_secondfloor_use_lasso", { input = true } );

    ObjDelete( "vid_secondfloor_terence_loop" );
    ObjDelete( "vid_secondfloor_fire_loop" );
    ObjDelete( "spr_secondfloor_back_fire" );
    ObjDelete( "spr_secondfloor_fire_patch" );
    ObjSet( "vid_secondfloor_neutralization_2_zap", { alp = 1, active = true, visible = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fireextinguisher", use_fireextinguisher_beg, private.room_objname );
  cmn.AddSubscriber( "use_fireextinguisher", use_fireextinguisher_inv );
  cmn.AddSubscriber( "use_fireextinguisher", use_fireextinguisher_end, private.room_objname );
  cmn.AddSubscriber( "use_fireextinguisher_inv", use_fireextinguisher_inv, private.room_objname );
  cmn.AddSubscriber( "use_fireextinguisher_beg", use_fireextinguisher_beg, private.room_objname );
  cmn.AddSubscriber( "use_fireextinguisher_end", use_fireextinguisher_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function win_examroomdoor () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_examroomdoor" ] =
  {
      type = "win",
      room = private.room_objname,
      zz = "zz_examroomdoor",
      zz_gate = "gzz_secondfloor_examroomdoor"
  };
  --------------------------------------------------------------------------------------------
  local win_examroomdoor = function ()

    if ( cmn.IsEventDone( "win_examroomdoor" ) ) then
      
      ObjDelete( "gzz_secondfloor_examroomdoor" );
      ObjDelete( "spr_secondfloor_door_close"   );
      ObjDelete( "spr_examroomdoor_door"        );
    
      ObjMultiSet({ 
        { "grm_secondfloor_examroom",           { input = true, visible = true, active = true }},
        { "obj_secondfloor_open_door_examroom", { alp = 1                                     }},
      });
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_secondfloor_examroom_focus");
    end;
    end;

  end;

  cmn.AddSubscriber( "win_examroomdoor", win_examroomdoor, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function win_tobiasplans () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_tobiasplans" ] =
  {
      type = "win",
      room = private.room_objname,
      zz = "zz_tobiasplans",
      zz_gate = "gzz_secondfloor_tobiasplans"
  };  


  local win_tobiasplans_zz = function ()
  
    if ( cmn.IsEventDone( "win_tobiasplans" ) ) then

      ObjDelete( "spr_tobiasplans_door" );  
      ObjSet( "obj_collect2_item_3_4",         { input  = true } );
      ObjSet( "obj_tobiasplans_use_tobiaskey", { input  = true } );
      ObjSet( "spr_tobiasplans_sledgehammer",  { input  = true } );
      ObjSet( "gfx_tobiasplans_sledgehammer",  { active = true } );
      ObjSet( "spr_tobiasplans_picture1",      { input  = true } );
      ObjSet( "spr_tobiasplans_picture2",      { input  = true } );

      ObjSet( "spr_secondfloor_todiasplane_close", { pos_y  = 396 } );

    else

      if ( ng_global.progress[ "std" ][ "win_tobiasplans" ].index ) then

        private.tobiasplans.index = ng_global.progress[ "std" ][ "win_tobiasplans" ].index;

        for i = 1, #private.tobiasplans.state do
     
          private.tobiasplans.state[ i ] = ng_global.progress[ "std" ][ "win_tobiasplans" ].state[ i ];

          local res = "assets/levels/level3/rm_secondfloor/zz_tobiasplans/layers/figure_"..private.tobiasplans.state[ i ];

          ObjSet( "spr_tobiasplans_number_"..i, { res = res } );

        end;

      end;

    end;

  end;
  
  cmn.AddSubscriber( "win_tobiasplans", win_tobiasplans_zz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_tube () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_tube" ] =
  {
      type = "win",
      room = private.room_objname,
      zz = "zz_tube",
      zz_gate = "gzz_secondfloor_tube"
  };
  
  local win_tube_zz = function ()
  
    if ( cmn.IsEventDone( "win_tube" ) ) then

      ObjSet( "spr_tube_leadedbox",  { input = true } );
      ObjSet( "spr_tube_panel",      { pos_y = 240 } );
      ObjSet( "gfx_tube_leadedbox",  { active = true } );
      ObjSet( "obj_tube_lamps",      { input = false } );
      ObjSet( "spr_tube_handle_1",   { input = false, alp = 0 } );
      ObjSet( "spr_tube_handle_2",   { alp = 1 } );
      ObjSet( "spr_tube_counter_2",  { ang = -4.7 } );
     
      ObjSet( "obj_secondfloor_tube_button",  { alp = 1 } );
      ObjSet( "obj_secondfloor_tube_lamp",    { pos_y = 52 } );
      ObjSet( "spr_secondfloor_tube_3",       { pos_y = 519 } );
      ObjSet( "spr_secondfloor_tube_6",       { alp = 1 } );

      private.LeverStartTube();

    else

      if ( ng_global.progress[ "std" ][ "win_tube" ].state ) then

        local multiset_list = {}

        for i = 1, #private.tube.state do
          
          local pos_x = private.tube.pos[ i ][ 1 ];
          local pos_y = private.tube.pos[ i ][ 2 ];

          table.insert( multiset_list, { "spr_tube_lamp_"..i, { pos_x = pos_x, pos_y = pos_y } } );

          ObjAttach( "spr_tube_lamp_"..i, "obj_tube_lamps" );

          private.tube.state[ i ] = ng_global.progress[ "std" ][ "win_tube" ].state[ i ];

        end;

        for i = 1, #private.tube.state do
          
          local number = private.tube.state[ i ];

          if ( number ~= 0 ) then

            ObjAttach( "spr_tube_lamp_"..number, "obj_tube_lamp_"..i.."_use" );

            table.insert( multiset_list, { "spr_tube_lamp_"..number, { pos_x = 0, pos_y = 0 } } );

          end;

        end;

        ObjMultiSet( multiset_list );

        private.SetLightTube();

        private.tube.levet_start = ng_global.progress[ "std" ][ "win_tube" ].levet_start;

        if ( private.tube.levet_start ) then

          private.LeverStartTube();
          
        end;

      end;

    end;

  end;
  
  cmn.AddSubscriber( "win_tube", win_tube_zz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_socket () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_socket" ] = {
    type = "click",
    use_place = "obj_secretwall_clk_socket",
    room = private.room_objname,
    zz = "zz_secretwall",
    zz_gate = "gzz_secondfloor_secretwall"
  };
  local clk_socket_beg = function ()
  
    ObjDelete( "obj_secretwall_clk_socket" );
  
  end;
  local clk_socket_end = function ()

    ObjMultiSet({ 
      { "spr_secretwall_socket",            { alp = 1                     }},
      { "obj_secretwall_use_tobiaspermit",  { input = true, active = true }},
      { "obj_secretwall_use_terencepermit", { input = true, active = true }},

      { "anm_secretwall_socket", { frame = 100 } },
    });

    --ObjDelete( "anm_secretwall_socket" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_socket",     clk_socket_beg, private.room_objname );
  cmn.AddSubscriber( "clk_socket",     clk_socket_end, private.room_objname );
  cmn.AddSubscriber( "clk_socket_beg", clk_socket_beg, private.room_objname );
  cmn.AddSubscriber( "clk_socket_end", clk_socket_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_slots () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_slots" ] = {
    type = "click",
    use_place = "obj_secretwall_clk_slots",
    room = private.room_objname,
    zz = "zz_secretwall",
    zz_gate = "gzz_secondfloor_secretwall"
  };
  local clk_slots_beg = function ()
  
    ObjDelete( "obj_secretwall_clk_slots" );

    ObjDelete( "spr_secretwall_terencepermit_shadow" );
    ObjDelete( "spr_secretwall_tobiaspermit_shadow"  );
    ObjDelete( "spr_secretwall_tobiaspermit_patch1"  );
    ObjDelete( "spr_secretwall_terencepermit_patch1" );

    ObjMultiSet({ 
      { "anm_secretwall_both",          { alp = 1 }},
      { "spr_secretwall_terencepermit", { alp = 0 }},
      { "spr_secretwall_tobiaspermit",  { alp = 0 }},
    });

  end;
  local clk_slots_end = function ()

    ObjMultiSet({ 
      { "spr_secretwall_terencepermit", { pos_x = -23, pos_y = -65, alp = 1 }},
      { "spr_secretwall_tobiaspermit",  { pos_x =  99, pos_y = -56, alp = 1 }},
      { "spr_secondfloor_door_open",    { alp = 1                           }},

      { "grm_secondfloor_tortureroom",  { input = true, visible = true, active = true }},
    });
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_secondfloor_tortureroom_focus");
    end;
    ObjDelete( "gzz_secondfloor_secretwall" );
    ObjDelete( "spr_secondfloor_doors_grid" );
    --ObjDelete( "anm_secretwall_both" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_slots",     clk_slots_beg, private.room_objname );
  cmn.AddSubscriber( "clk_slots",     clk_slots_end, private.room_objname );
  cmn.AddSubscriber( "clk_slots_beg", clk_slots_beg, private.room_objname );
  cmn.AddSubscriber( "clk_slots_end", clk_slots_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_secondfloor_door () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_secondfloor_door" ] = {
    type = "click",
    use_place = "obj_secondfloor_door_clk",
    room = private.room_objname
  };
  local clk_secondfloor_door_beg = function ()
  
    ObjDelete( "obj_secondfloor_door_clk" );

  end;
  local clk_secondfloor_door_end = function ()

    ObjDelete( "anm_secondfloor_door" );
    ObjSet( "gzz_secondfloor_examroomdoor", { input = true, active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_secondfloor_door",     clk_secondfloor_door_beg, private.room_objname );
  cmn.AddSubscriber( "clk_secondfloor_door",     clk_secondfloor_door_end, private.room_objname );
  cmn.AddSubscriber( "clk_secondfloor_door_beg", clk_secondfloor_door_beg, private.room_objname );
  cmn.AddSubscriber( "clk_secondfloor_door_end", clk_secondfloor_door_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_tobiasbox () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_tobiasbox" ] = {
    type = "click",
    use_place = "obj_tobiasplans_clk_tobiasbox",
    room = private.room_objname,
    zz = "zz_tobiasplans",
    zz_gate = "gzz_secondfloor_tobiasplans"
  };
  local clk_tobiasbox_beg = function ()
  
    ObjDelete( "obj_tobiasplans_clk_tobiasbox" );

  end;
  local clk_tobiasbox_end = function ()

    ObjSet( "spr_tobiasplans_watch",  { alp = 1, input = true } );
    ObjSet( "spr_tobiasplans_open_box",  { alp = 1 } );

    ObjSet( "spr_secondfloor_box_open_layer", { alp = 1 } );

    ObjDelete( "spr_tobiasplans_open_box2" );
    ObjDelete( "spr_tobiasplans_patch" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_tobiasbox",     clk_tobiasbox_beg, private.room_objname );
  cmn.AddSubscriber( "clk_tobiasbox",     clk_tobiasbox_end, private.room_objname );
  cmn.AddSubscriber( "clk_tobiasbox_beg", clk_tobiasbox_beg, private.room_objname );
  cmn.AddSubscriber( "clk_tobiasbox_end", clk_tobiasbox_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_scare_secondfloor_1 () end;
  --------------------------------------------------------------------------------------------
  local see_scare_secondfloor_1 = function ()

    -- some code 

  end;

  cmn.AddSubscriber( "see_scare_secondfloor_1", see_scare_secondfloor_1, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function see_terence_appear () end;
  --------------------------------------------------------------------------------------------
  local see_terence_appear = function ()

    ObjSet( "obj_secondfloor_use_fireextinguisher", { input = true } );

    ObjDelete( "obj_secondfloor_terence_appear_clk" );
    ObjSet( "vid_secondfloor_terence_loop", { alp = 1, active = true, visible = true } );
    ObjSet( "vid_secondfloor_fire_loop", { alp = 1, active = true, visible = true } );
    ObjSet( "spr_secondfloor_fire_patch", { alp = 1 } );
    ObjSet( "spr_secondfloor_back_fire", { alp = 1 } );
    ObjSet( "spr_secondfloor_patch_shelves_down", { alp = 1 } );
    ObjDelete( "spr_secondfloor_doors_grid" );

  end;

  cmn.AddSubscriber( "see_terence_appear", see_terence_appear, private.room_objname );

end;

--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()

  --*******************************************************************************************************************
  --*** function zz_examroomdoor () end ****
    subroom.Define( "zz_examroomdoor" );

    function zz_examroomdoor.Open ()

    end;  

    -------------------------------------------------
    function zz_examroomdoor.PreOpen ()

      if ( cmn.IsEventStart( "win_examroomdoor" ) and not cmn.IsEventDone( "win_examroomdoor" ) ) then

        cmn.MiniGameShow( "examroomdoor" );
        common_impl.PassingMgStart( "examroomdoor" );

      end;

      private.ExamroomdoorLoad();
      private.ExamroomdoorUpdate(); 

    end;  

    -------------------------------------------------
    function zz_examroomdoor.PreClose ()

      if ( cmn.IsEventStart( "win_examroomdoor" ) and not cmn.IsEventDone( "win_examroomdoor" ) ) then

        cmn.MiniGameHide( "examroomdoor" );
        common_impl.PassingMgStop( "examroomdoor" );

      end;

    end; 

    ------------------------------------------------- 
    function zz_examroomdoor.Close ()
           
    end;

    -------------------------------------------------
    function zz_examroomdoor.Reset ()

      private.ExamroomdoorDefault();
      private.ExamroomdoorSave();
      private.ExamroomdoorUpdate();

    end;

    -------------------------------------------------
    function zz_examroomdoor.Skip ()

      private.examroomdoor_state = private.examroomdoor_state_win;
      private.ExamroomdoorSave();
      private.ExamroomdoorUpdate();

    end;
  --*********************************************************************************************************************

  --*********************************************************************************************************************
  -- function zz_tobiasplans () end;
  --*********************************************************************************************************************
    subroom.Define( "zz_tobiasplans" );
    
    private.tobiasplans = {}
    private.tobiasplans.index = 1;
    private.tobiasplans.state = { "0", "0", "0", "0", "0" };
    private.tobiasplans.win_state = { "5", "9", "7", "4", "2" };

    local multiset_list = {}

    local button_list = { "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "c", "sharp" };

    for b = 1, #button_list do
    
      local name = button_list[ b ];

      table.insert( multiset_list, { "obj_tobiasplans_buttons_"..name, { event_mdown = function () private.ClkTobiasplansButton( name ) end } } );

    end;

    ObjMultiSet( multiset_list );

  --*********************************************************************************************************************

    function zz_tobiasplans.PreOpen()

    end;
    -------------------------------------------------
    function zz_tobiasplans.Open()

      if ( cmn.IsEventDone( "use_tobiascode" ) and not cmn.IsEventDone( "win_tobiasplans" ) ) then

        cmn.MiniGameShow( "tobiasplans" );
        common_impl.PassingMgStart( "tobiasplans" );

      end;

    end;
    -------------------------------------------------
    function zz_tobiasplans.PreClose()

      if ( cmn.IsEventDone( "use_tobiascode" ) and not cmn.IsEventDone( "win_tobiasplans" ) ) then

        cmn.MiniGameHide( "tobiasplans" );
        common_impl.PassingMgStop( "tobiasplans" );

      end;

    end;
    -------------------------------------------------
    function zz_tobiasplans.Close()

      cmn.NoteScaleClose( { "spr_tobiasplans_picture1", "spr_tobiasplans_picture2" } );

    end;
    -------------------------------------------------
    function zz_tobiasplans.Reset ()

      ng_global.progress[ "std" ][ "win_tobiasplans" ].state = { "0", "0", "0", "0", "0" };
      private.tobiasplans.state = { "0", "0", "0", "0", "0" };

      for i = 1, #private.tobiasplans.state do
   
        local res = "assets/levels/level3/rm_secondfloor/zz_tobiasplans/layers/figure_0"

        ObjSet( "spr_tobiasplans_number_"..i, { res = res } );

      end;

      private.tobiasplans.index = 1;

    end;
    -------------------------------------------------
    function zz_tobiasplans.Skip ()

      private.WinAnimTobiasplans();

    end;
    -------------------------------------------------

  --*********************************************************************************************************************
  -- function zz_tube () end;
  --*********************************************************************************************************************
    subroom.Define( "zz_tube" );

    private.tube = {};
    private.tube.state = { 0, 0, 0, 0 };
    private.tube.win_state = { 3, 1, 2, 4 };

    private.tube.pos = { {-258,-53 }, {-209,-49}, {-158,-42 }, {-107,-36} };

    local multiset_list = {}

    for i = 1, 4 do
    
      table.insert( multiset_list, { "spr_tube_lamp_"..i, 
      { 
        event_mdown = function () private.ClkTubeButtonForDrag( i ) end,
        event_dragdrop = function () private.DropTubeButton( i ) end,
      } } );

    end;

    table.insert( multiset_list, { "spr_tube_handle_1", { event_mdown = private.ClkHandleTube } } );

    ObjMultiSet( multiset_list );

  --*********************************************************************************************************************

    function zz_tube.PreOpen()

    end;
    -------------------------------------------------
    function zz_tube.Open()

      if ( cmn.IsEventDone( "use_sensor" ) and not cmn.IsEventDone( "win_tube" ) ) then

        cmn.MiniGameShow( "tube" );
        common_impl.PassingMgStart( "tube" );

      end;

    end;
    -------------------------------------------------
    function zz_tube.PreClose()

      if ( cmn.IsEventDone( "use_sensor" ) and not cmn.IsEventDone( "win_tube" ) ) then

        cmn.MiniGameHide( "tube" );
        common_impl.PassingMgStop( "tube" );

      end;

    end;
    -------------------------------------------------
    function zz_tube.Close()

      cmn.NoteScaleClose( { "spr_tube_picture1", "spr_tube_picture2" } );

      if ( cmn.IsEventDone( "get_metalbasrelief" ) and not cmn.IsEventDone( "see_scare_secondfloor_1" ) ) then  
        private.SecondfloorScare_1();
      end;    

    end;
    -------------------------------------------------
    function zz_tube.Reset ()

      ng_global.progress[ "std" ][ "win_tube" ].state = { 0, 0, 0, 0 };
      private.tube.state = { 0, 0, 0, 0 };

      ng_global.progress[ "std" ][ "win_tube" ].levet_start = false;
      private.tube.levet_start = false;

      local multiset_list = {}

      for i = 1, #private.tube.state do
        
        local pos_x = private.tube.pos[ i ][ 1 ];
        local pos_y = private.tube.pos[ i ][ 2 ];

        table.insert( multiset_list, { "spr_tube_lamp_"..i, { pos_x = pos_x, pos_y = pos_y } } );

        ObjAttach( "spr_tube_lamp_"..i, "obj_tube_lamps" );

      end;

      for i = 1, #private.tube.state do
        
        local number = private.tube.state[ i ];

        if ( number ~= 0 ) then

          ObjAttach( "spr_tube_lamp_"..number, "obj_tube_lamp_"..i.."_use" );

          table.insert( multiset_list, { "spr_tube_lamp_"..number, { pos_x = 0, pos_y = 0 } } );

        end;

      end;

      ObjMultiSet( multiset_list );

      private.SetLightTube();

      ObjSet( "spr_tube_handle_red_light", { alp = 1 } );
      ObjSet( "spr_tube_handle_green",     { alp = 0 } );

      ObjSet( "obj_tube_lamps", { input = true } );

    end;
    -------------------------------------------------
    function zz_tube.Skip ()

      private.WinAnimTube();

    end;
    -------------------------------------------------

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_secondfloor();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

  if ( cmn.IsEventDone( "get_metalbasrelief" ) and not cmn.IsEventDone( "see_scare_secondfloor_1" ) ) then  
    private.SecondfloorScare_1();
  end; 

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.CollectItemMorphing();
  common_impl.MorphItemMorphing();

  common_impl.EnvPlay( { "level3/env/aud_secondfloor_env" }, "", 0.5 );

  if ( cmn.IsEventDone( "get_sensor" ) and not cmn.IsEventDone( "see_terence_appear" ) ) then  

    ObjSet( "obj_secondfloor_terence_appear_clk", { input = true } );

  end; 

  if ( cmn.IsEventDone( "see_terence_appear" ) and not cmn.IsEventDone( "use_fireextinguisher" ) ) then  

    common_impl.PlayAudio( "env", "level3/env/aud_fire_env", 1, "", 0 );

  end; 

  if ( cmn.IsEventDone( "use_fireextinguisher" ) and not cmn.IsEventDone( "use_lasso" ) ) then  

    common_impl.PlayAudio( "env", "level3/env/aud_terence_env", 1, "", 0 );

  end; 

end;
--*********************************************************************************************************************
function public.Close ()

  if ( cmn.IsEventDone( "see_terence_appear" ) and not cmn.IsEventDone( "use_fireextinguisher" ) ) then  

    common_impl.StopAudio( "env", "level3/env/aud_fire_env", 0.2 );

  end; 

  if ( cmn.IsEventDone( "use_fireextinguisher" ) and not cmn.IsEventDone( "use_lasso" ) ) then  

    common_impl.StopAudio( "env", "level3/env/aud_terence_env", 0.2 );

  end; 

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_hook_lvl3_2 ()

  local item = "inv_hook_lvl3";

  if cmn.ApplyObj( item, "gzz_secondfloor_tube" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tube", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_tube_use_hook" ) ) then

    cmn.CallEventHandler( "use_hook_lvl3_2_inv" );
    cmn.CallEventHandler( "use_hook_lvl3_2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_hook_lvl3_2" );
      cmn.CallEventHandler( "use_hook_lvl3_2_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_tumbler", 0, "", 0 );

    ObjAnimate( "spr_tube_hook", "alp", 0, 0, func_end, { 0,3,0,  0.4,3,1,  1.0,3,1,  1.2,3,0 } );

    ObjAnimate( "spr_tube_hook",            "pos_xy", 0, 0, "", { 0,3,127,-47,   0.4,3,127,-47,   0.6,3,151,-96,  0.8,3,108,-103,  1.0,3,159,-76 } );
    ObjAnimate( "spr_tube_moleculeamulet1", "pos_xy", 0, 0, "", { 0,3,116,-211,  0.8,3,116,-211,  1.0,3,165,-184 } );
    ObjAnimate( "spr_tube_amulet_2_shadow", "pos_xy", 0, 0, "", { 0,3,110,-179,  0.8,3,110,-179,  1.0,3,162,-146 } );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_adjustmentcontrol ()

  local item = "inv_adjustmentcontrol";

  if cmn.ApplyObj( item, "gzz_secondfloor_tube" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tube", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_tube_use_adjustmentcontrol" ) ) then

    cmn.CallEventHandler( "use_adjustmentcontrol_inv" );
    cmn.CallEventHandler( "use_adjustmentcontrol_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_adjustmentcontrol" );
      cmn.CallEventHandler( "use_adjustmentcontrol_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_adjustmentcontrol", 0, "", 0 );

    ObjAnimate( "spr_tube_regulator", "alp", 0, 0, "", { 0,3,0,  0.4,3,1 } );
    ObjAnimate( "spr_tube_cower_1",   "pos_xy", 0, 0, func_end, { 0,3,151,-32,  0.4,3,151,-32,  0.8,3,158,-32,  1.4,1,158, 357 } );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_sensor ()

  local item = "inv_sensor";

  if cmn.ApplyObj( item, "gzz_secondfloor_tube" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tube", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_tube_use_sensor" ) ) then

    cmn.CallEventHandler( "use_sensor_inv" );
    cmn.CallEventHandler( "use_sensor_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_sensor" );
      cmn.CallEventHandler( "use_sensor_end" );

      cmn.MiniGameShow( "tube" );
      common_impl.PassingMgStart( "tube" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide1", 0, "", 0 );

    ObjAnimate( "spr_tube_counter_3", "alp",   0, 0, "", { 0,3,0,  0.4,3,1 } );
    ObjAnimate( "spr_tube_cower_2",   "pos_y", 0, 0, func_end, { 0,3,57,  0.4,3,57, 1.0,3,-243 } );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_fireextinguisherhead ()

  local item = "inv_fireextinguisherhead";

  if cmn.ApplyObj( item, "gzz_secondfloor_patientsboxes" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_patientsboxes", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_patientsboxes_use_fireextinguisherhead" ) ) then

    cmn.CallEventHandler( "use_fireextinguisherhead_inv" );
    cmn.CallEventHandler( "use_fireextinguisherhead_beg" );

    local func_end = function ()

      cmn.Lock( false );

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_tumbler", 0, "", 0 );

      cmn.SetEventDone( "use_fireextinguisherhead" );
      cmn.CallEventHandler( "use_fireextinguisherhead_end" );

    end;

    cmn.Lock( true );

    cmn.ItemFly( "spr_patientsboxes_fire_extinguisher_handle", func_end, 1.5 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_moleculeamulet1 ()

  local item = "inv_moleculeamulet1";

  if cmn.ApplyObj( item, "gzz_secondfloor_patientsboxes" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_patientsboxes", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_patientsboxes_use_moleculeamulet1" ) ) then

    cmn.CallEventHandler( "use_moleculeamulet1_inv" );
    cmn.CallEventHandler( "use_moleculeamulet1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_moleculeamulet1" );
      cmn.CallEventHandler( "use_moleculeamulet1_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_moleculeamulet", 0, "", 0 );

    ObjAnimate( "spr_patientsboxes_molecule_amulet_1", "alp", 0, 0, "", { 0,3,0,  0.4,3,1 } );
    ObjAnimate( "spr_patientsboxes_door_close_1",      "alp", 0, 0, func_end, { 0,3,1,  0.6,3,1,  1.0,3,0 } );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_moleculeamulet2 ()

  local item = "inv_moleculeamulet2";

  if cmn.ApplyObj( item, "gzz_secondfloor_patientsboxes" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_patientsboxes", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_patientsboxes_use_moleculeamulet2" ) ) then

    cmn.CallEventHandler( "use_moleculeamulet2_inv" );
    cmn.CallEventHandler( "use_moleculeamulet2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_moleculeamulet2" );
      cmn.CallEventHandler( "use_moleculeamulet2_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_moleculeamulet", 0, "", 0 );

    ObjAnimate( "spr_patientsboxes_molecule_amulet_2", "alp", 0, 0, "", { 0,3,0,  0.4,3,1 } );
    ObjAnimate( "spr_patientsboxes_door_close_2",      "alp", 0, 0, "", { 0,3,1,  0.6,3,1,  1.0,3,0 } );
    ObjAnimate( "spr_patientsboxes_door_open_up",      "alp", 0, 0, func_end, { 0,3,0,  0.6,3,0,  1.0,3,1 } );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_moleculeamulet3 ()

  local item = "inv_moleculeamulet3";

  if cmn.ApplyObj( item, "gzz_secondfloor_patientsboxes" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_patientsboxes", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_patientsboxes_use_moleculeamulet3" ) ) then

    cmn.CallEventHandler( "use_moleculeamulet3_inv" );
    cmn.CallEventHandler( "use_moleculeamulet3_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_moleculeamulet3" );
      cmn.CallEventHandler( "use_moleculeamulet3_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_moleculeamulet", 0, "", 0 );

    ObjAnimate( "spr_patientsboxes_molecule_amulet_3", "alp", 0, 0, "", { 0,3,0,  0.4,3,1 } );
    ObjAnimate( "spr_patientsboxes_door_close_3",      "alp", 0, 0, "", { 0,3,1,  0.6,3,1,  1.0,3,0 } );
    ObjAnimate( "spr_patientsboxes_door_open_down",    "alp", 0, 0, func_end, { 0,3,0,  0.6,3,0,  1.0,3,1 } );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_tobiascode ()

  local item = "inv_tobiascode";

  if cmn.ApplyObj( item, "gzz_secondfloor_tobiasplans" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tobiasplans", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_tobiasplans_use_tobiascode" ) ) then

    cmn.CallEventHandler( "use_tobiascode_inv" );
    cmn.CallEventHandler( "use_tobiascode_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_tobiascode" );
      cmn.CallEventHandler( "use_tobiascode_end" );

      cmn.MiniGameShow( "tobiasplans" );
      common_impl.PassingMgStart( "tobiasplans" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "aud_paper", 0, "", 0 );

    ObjAnimate( "spr_tobiasplans_paper", "alp", 0, 0,func_end, { 0,3,0,  0.4,3,1 } );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_tobiaskey ()

  local item = "inv_tobiaskey";

  if cmn.ApplyObj( item, "gzz_secondfloor_tobiasplans" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tobiasplans", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_tobiasplans_use_tobiaskey" ) ) then

    cmn.CallEventHandler( "use_tobiaskey_inv" );
    cmn.CallEventHandler( "use_tobiaskey_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_tobiaskey" );
      cmn.CallEventHandler( "use_tobiaskey_end" );      

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_tobiaskey", 0, "", 0 );

    ObjAnimate( "spr_tobiasplans_key1", "pos_xy", 0, 0, "",       
    { 
      0.0, 0, 10, 147,  
      0.3, 0, 10, 147,  
      0.9, 0, 84, 113 
    } );

    ObjAnimate( "spr_tobiasplans_key1", "alp", 0, 0, "",       
    { 
      0.0, 0, 0,
      0.3, 0, 1,  
      0.9, 0, 1,
      1.2, 0, 0
    } );
    ObjAnimate( "spr_tobiasplans_key2", "alp", 0, 0, "",       
    { 
      0.0, 0, 0,
      0.3, 0, 0,
      0.9, 0, 0,
      1.2, 0, 1
    } );

    ObjAnimate( "spr_tobiasplans_open_box2", "alp", 0, 0, func_end, 
    { 
      0.0, 3, 0,
      1.2, 3, 0,
      1.5, 3, 1
    } );

  return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_smallslider1 ()

  local item = "inv_smallslider1";

  if cmn.ApplyObj( item, "gzz_secondfloor_examroomdoor" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_examroomdoor", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_examroomdoor_use_smallslider1" ) and 
  cmn.IsEventDone( "use_metalbasrelief" ) ) then

    cmn.CallEventHandler( "use_smallslider1_inv" );
    cmn.CallEventHandler( "use_smallslider1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_smallslider1" );
      cmn.CallEventHandler( "use_smallslider1_end" );

      if cmn.IsEventDone( "use_smallslider2" ) then
        cmn.MiniGameShow( "examroomdoor" );
        common_impl.PassingMgStart( "examroomdoor" );
      end; 

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_smallslider", 0, "", 0 );

    ObjSet( "spr_examroomdoor_button_2", { alp = 0, visible = true } );
    ObjAnimate( "spr_examroomdoor_button_2", "alp",0,0, func_end, { 0, 0, 0,    0.6, 0, 1 } );
  
  return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_smallslider2 ()

  local item = "inv_smallslider2";

  if cmn.ApplyObj( item, "gzz_secondfloor_examroomdoor" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_examroomdoor", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_examroomdoor_use_smallslider2" ) and 
  cmn.IsEventDone( "use_metalbasrelief" ) ) then

    cmn.CallEventHandler( "use_smallslider2_inv" );
    cmn.CallEventHandler( "use_smallslider2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_smallslider2" );
      cmn.CallEventHandler( "use_smallslider2_end" );

      if cmn.IsEventDone( "use_smallslider1" ) then
        cmn.MiniGameShow( "examroomdoor" );
        common_impl.PassingMgStart( "examroomdoor" );
      end; 

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_smallslider", 0, "", 0 );

    ObjSet( "spr_examroomdoor_button_4", { alp = 0, visible = true } );
    ObjAnimate( "spr_examroomdoor_button_4", "alp",0,0, func_end, { 0, 0, 0,    0.6, 0, 1 } );
  
  return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_metalbasrelief ()

  local item = "inv_metalbasrelief";

  if ( cmn.ApplyObj( item, "gzz_secondfloor_examroomdoor" ) and cmn.IsEventDone( "clk_secondfloor_door" ) ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_examroomdoor", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_examroomdoor_use_metalbasrelief" ) and cmn.IsEventDone( "clk_secondfloor_door" ) ) then

    cmn.CallEventHandler( "use_metalbasrelief_inv" );
    cmn.CallEventHandler( "use_metalbasrelief_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_metalbasrelief" );
      cmn.CallEventHandler( "use_metalbasrelief_end" );

    end;

    local func_end_2 = function ()

      ObjAnimate( "spr_examroomdoor_lock_close", "alp",0,0, "", { 0, 0, 1,    0.2, 0, 0 } );

      ObjAnimate( "spr_examroomdoor_lock_open1", "pos_y",0,0, "", { 0, 3, -68,    1.2, 3, 194 } );
      ObjAnimate( "spr_examroomdoor_lock_open1_shadow", "pos_y",0,0, "", { 0, 3, -74,    1.2, 3, 212 } );

      ObjAnimate( "spr_examroomdoor_lock_open2", "pos_y",0,0, "", { 0, 3, -87,    1.2, 3, -360 } );
      ObjAnimate( "spr_examroomdoor_lock_open2_shadow", "pos_y",0,0, func_end, { 0, 3, -58,    1.2, 3, -331 } );

    end; 

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_metalbasrelief", 0, "", 0 );

    cmn.ItemFly( "spr_examroomdoor_part_lock", func_end_2, 2.27 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_tobiaspermit ()

  local item = "inv_tobiaspermit";

  if ( cmn.ApplyObj( item, "gzz_secondfloor_secretwall" ) and cmn.IsEventDone( "clk_socket" ) ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_secretwall", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_secretwall_use_tobiaspermit" ) and cmn.IsEventDone( "clk_socket" ) ) then

    cmn.CallEventHandler( "use_tobiaspermit_inv" );
    cmn.CallEventHandler( "use_tobiaspermit_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_tobiaspermit" );
      cmn.CallEventHandler( "use_tobiaspermit_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_terence_permit", 0, "", 0 );
      
    AnimPlay ( "anm_secretwall_tobiaspermit", "tobiaspermit", func_end )  

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_terencepermit ()

  local item = "inv_terencepermit";

  if ( cmn.ApplyObj( item, "gzz_secondfloor_secretwall" ) and cmn.IsEventDone( "clk_socket" ) ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_secretwall", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_secretwall_use_terencepermit" ) and cmn.IsEventDone( "clk_socket" ) ) then

    cmn.CallEventHandler( "use_terencepermit_inv" );
    cmn.CallEventHandler( "use_terencepermit_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_terencepermit" );
      cmn.CallEventHandler( "use_terencepermit_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_terence_permit", 0, "", 0 );
 
  AnimPlay( "anm_secretwall_terencepermit", "terencepermit", func_end );  

  return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_lasso ()

  local item = "inv_lasso";

  if ( cmn.ApplyObj( item, "obj_secondfloor_use_lasso" ) and cmn.IsEventDone( "use_fireextinguisher" ) ) then

    cmn.CallEventHandler( "use_lasso_inv" );
    cmn.CallEventHandler( "use_lasso_beg" );

    local func_end = function ()

      cmn.SetEventDone( "use_lasso" );
      cmn.CallEventHandler( "use_lasso_end" );
      common_impl.StopAudio( "sfx", "level3/sfx/aud_terence_neutralization_3", 0.2 );

      common_impl.PlayAudio( "mus", "aud_lyric_theme_mus", 0 );

    end;

    ObjAnimate( "spr_secondfloor_patch_shelves", "alp", 0, 0, "", { 0,3,1,  0.4,3,0 } );
    ObjAnimate( "spr_secondfloor_patch_shelves_down", "alp", 0, 0, "", { 0,3,0,  0.4,3,1 } );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_terence_neutralization_3", 0, "", 0 );

    cmn.PlayDialogVideo( "vid_secondfloor_neutralization_terence", func_end ); 
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_fireextinguisher ()

  local item = "inv_fireextinguisher";

  if ( cmn.ApplyObj( item, "obj_secondfloor_use_fireextinguisher" ) and cmn.IsEventDone( "see_terence_appear" ) ) then

    cmn.CallEventHandler( "use_fireextinguisher_inv" );
    cmn.CallEventHandler( "use_fireextinguisher_beg" );

    local func_end = function ()

      cmn.SetEventDone( "use_fireextinguisher" );
      cmn.CallEventHandler( "use_fireextinguisher_end" );
      common_impl.StopAudio( "sfx", "level3/sfx/aud_terence_neutralization_2", 0.2 );

      common_impl.PlayAudio( "env", "level3/env/aud_terence_env", 1, "", 0 );

      common_impl.PlayAudio( "mus", "aud_masked_man_theme_mus", 0 );

    end;

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_terence_neutralization_2", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_secondfloor_terence_in_foam", func_end ); 
  
  return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_leadedbox ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_leadedbox" );
  cmn.CallEventHandler( "get_leadedbox" );
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_moleculeamulet1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_moleculeamulet1" );
  cmn.CallEventHandler( "get_moleculeamulet1" );

end;
--------------------------------------------------------------------------------------------
function private.get_metalbasrelief ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_metalbasrelief" );
  cmn.CallEventHandler( "get_metalbasrelief" );

end;
--------------------------------------------------------------------------------------------
function private.get_tobiaswallet ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_tobiaswallet" );
  cmn.CallEventHandler( "get_tobiaswallet" );

end;
--------------------------------------------------------------------------------------------
function private.get_engravedknife ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_engravedknife" );
  cmn.CallEventHandler( "get_engravedknife" );

  if ( cmn.IsGetCollect2( "get_collect2_item_3_3" ) and cmn.IsEventDone( "get_fireextinguisher" ) ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_fireextinguisher ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_fireextinguisher" );
  cmn.CallEventHandler( "get_fireextinguisher" );

  if ( cmn.IsGetCollect2( "get_collect2_item_3_3" ) and cmn.IsEventDone( "get_engravedknife" ) ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_tobiaskey ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_tobiaskey" );
  cmn.CallEventHandler( "get_tobiaskey" );

end;
--------------------------------------------------------------------------------------------
function private.get_watch ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_watch" );
  cmn.CallEventHandler( "get_watch" );

  if ( cmn.IsGetCollect2( "get_collect2_item_3_4" ) ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_sledgehammer ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_sledgehammer" );
  cmn.CallEventHandler( "get_sledgehammer" );

end;
--------------------------------------------------------------------------------------------
function private.get_moleculeamulet2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_moleculeamulet2" );
  cmn.CallEventHandler( "get_moleculeamulet2" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_3_3 ()

  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_3_3" ); 

    if ( cmn.IsEventDone( "get_fireextinguisher" ) ) then

      common.CloseSubRoom();

    end;

  end;

  common_impl.PlayEffectHO( "spr_collect2_item_3_3", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_3_3" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_3_4 ()

  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_3_4" ); 

    if ( cmn.IsEventDone( "get_watch" ) ) then

      common.CloseSubRoom();

    end;

  end;

  common_impl.PlayEffectHO( "spr_collect2_item_3_4", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_3_4" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_socket ()

  cmn.CallEventHandler( "clk_socket_beg" );

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "clk_socket" );
    cmn.CallEventHandler( "clk_socket_end" );

  end;

  cmn.Lock( true );
    
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_tumbler", 0, "", 0 );

  AnimPlay( "anm_secretwall_socket", "socket", func_end)
    
end;
--------------------------------------------------------------------------------------------
function private.clk_secondfloor_door ()

  cmn.CallEventHandler( "clk_secondfloor_door_beg" );

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "clk_secondfloor_door" );
    cmn.CallEventHandler( "clk_secondfloor_door_end" );

  end;

  cmn.Lock( true );
   
  local func_sound = function () common_impl.PlayAudio( "sfx", "level2/sfx/aud_elevator_clk", 0, "", 0 );  end;

  ObjAnimate( "anm_secondfloor_door", "alp", 0, 0, func_sound, { 0, 0, 1, 1.5, 0, 1 } );
  AnimPlay( "anm_secondfloor_door", "click", func_end )
    
end;
--------------------------------------------------------------------------------------------
function private.clk_slots ()

  cmn.CallEventHandler( "clk_slots_beg" );

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "clk_slots" );
    cmn.CallEventHandler( "clk_slots_end" );

    common.CloseSubRoom();

  end;

  cmn.Lock( true );

  AnimPlay( "anm_secretwall_both", "both", func_end );

end;
--------------------------------------------------------------------------------------------
function private.clk_tobiasbox ()

  cmn.CallEventHandler( "clk_tobiasbox_beg" );

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "clk_tobiasbox" );
    cmn.CallEventHandler( "clk_tobiasbox_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_clk_tobiasbox", 0, "", 0 );

  ObjAnimate( "spr_tobiasplans_open_box2", "alp", 0, 0, "",       
  { 
    0.0, 0, 1,
    0.3, 0, 0
  } );
  ObjAnimate( "spr_tobiasplans_patch", "alp", 0, 0, "",       
  { 
    0.0, 0, 1,
    0.3, 0, 0
  } );
  ObjAnimate( "spr_tobiasplans_open_box", "alp", 0, 0, func_end, 
  { 
    0.0, 0, 0,
    0.3, 0, 1
  } );

end;

--*********************************************************************************************************************
-- function *** HORRORS *** () end;
--*********************************************************************************************************************

function private.SecondfloorScare_1 () 

  local func_end = function ()

    cmn.SetEventDone( "see_scare_secondfloor_1" );
    cmn.CallEventHandler( "see_scare_secondfloor_1" );

    common_impl.ShowBbt( "bbt_secondfloor_see_scare_1" );
    common_impl.StopAudio( "sfx", "level3/sfx/aud_secondfloor_scare_1", 0.2 );

  end;

  cmn.PlayDialogVideo( "vid_secondfloor_scare_1", func_end ); 
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_secondfloor_scare_1", 0, "", 0 );
  
end;

--*********************************************************************************************************************

function private.SecondfloorTerenceAppear () 

  local func_end = function ()

    cmn.SetEventDone( "see_terence_appear" );
    cmn.CallEventHandler( "see_terence_appear" );
    common_impl.StopAudio( "sfx", "level3/sfx/aud_see_terence_appear", 0.2 );

    common_impl.PlayAudio( "env", "level3/env/aud_fire_env", 1, "", 0 );

  end;

  ObjSet( "obj_secondfloor_terence_appear_clk", { input = false } );

  common_impl.PlayAudio( "mus", "level3/mus/aud_terence_appearance_1_mus", 0 );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_terence_appearance_1", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_secondfloor_terence_appear", func_end ); 
  
end;


--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************

function private.ExamroomdoorHandleClick()

  common_impl.ShowBbt( "bbt_examroomdoor_use_metalbasrelief" );

  local func_end = function ()
    cmn.Lock( false );  
  end;

  cmn.Lock( true ); 

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_clk_doorhandle2", 0, "", 0 );

  ObjAnimate( "spr_examroomdoor_handle1", "alp",0,0, "", { 0, 0, 1,    0.1, 0, 0,    0.2, 0, 1 } );
  ObjAnimate( "spr_examroomdoor_handle2", "alp",0,0, func_end, { 0, 0, 0,    0.1, 0, 1,    0.2, 0, 0 } );

end;
--*********************************************************************************************************************
function private.AnimClkMoleculeamulet1 ()

  local func_end = function ()

    cmn.Lock( false );  

  end;

  cmn.Lock( true ); 

  common_impl.ShowBbt( 'bbt_patientsboxes_use_moleculeamulet1' );

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk9", 0, "", 0 );

  ObjAnimate( "spr_patientsboxes_door_close_1", "scale_xy", 0, 0, func_end, 
    { 0,   0, 1,    1,    
      0.2, 0, 1.02, 1.02,    
      0.4, 0, 1,    1,
    });

end;
--*********************************************************************************************************************
function private.AnimClkMoleculeamulet2 ()

  local func_end = function ()

    cmn.Lock( false );  

  end;

  cmn.Lock( true ); 

  common_impl.ShowBbt( 'bbt_patientsboxes_use_moleculeamulet2' );

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk9", 0, "", 0 );

  ObjAnimate( "spr_patientsboxes_door_close_2", "pos_xy", 0, 0, func_end, 
    { 0,   0, -131, -159,    
      0.2, 0, -131, -161,    
      0.4, 0, -131, -159,
    });

end;
--*********************************************************************************************************************
function private.AnimClkMoleculeamulet3 ()

  local func_end = function ()

    cmn.Lock( false ); 
 
  end;

  cmn.Lock( true ); 

  common_impl.ShowBbt( 'bbt_patientsboxes_use_moleculeamulet3' );

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk9", 0, "", 0 );

  ObjAnimate( "spr_patientsboxes_door_close_3", "pos_xy", 0, 0, func_end, 
    { 0,   0, -131, 111,    
      0.2, 0, -133, 111,    
      0.4, 0, -131, 111,
    });

end;
--*********************************************************************************************************************
function private.AnimClkTobiaskey ()

  cmn.Lock( true ); 

  common_impl.ShowBbt( 'bbt_tobiasplans_use_tobiaskey' );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk2", 0, "", 0 );

  ObjAnimate( "spr_tobiasplans_close_box", "pos_x", 0, 0, function() cmn.Lock( false ); end, 
    { 0,   0, 103,
      0.2, 3, 104,
      0.4, 3, 103
    });

end;
--*********************************************************************************************************************
function private.UseHook ()

  local func_end = function ()

    cmn.Lock( false ); 
    common_impl.ShowBbt( 'bbt_tube_use_hook' ); 

  end;

  cmn.Lock( true ); 

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk9", 0, "", 0 );

  ObjAnimate( "spr_tube_moleculeamulet1", "pos_xy", 0, 0, func_end, 
  { 0.0,  0, ObjGet( "spr_tube_moleculeamulet1" ).pos_x, ObjGet( "spr_tube_moleculeamulet1" ).pos_y,    
    0.15, 0, ObjGet( "spr_tube_moleculeamulet1" ).pos_x + 3, ObjGet( "spr_tube_moleculeamulet1" ).pos_y + 3,    
    0.3,  0, ObjGet( "spr_tube_moleculeamulet1" ).pos_x, ObjGet( "spr_tube_moleculeamulet1" ).pos_y,
  } );

end;
--*********************************************************************************************************************
-- function *** MMG EXAMROOMDOOR *** () end;
--*********************************************************************************************************************

  private.examroomdoor_state = {};
  private.examroomdoor_state_win = { 1, 3, 2, 1 };  

  local EXAMROOMDOOR_BUTTON_NAME = "spr_examroomdoor_button_";
  local EXAMROOMDOOR_BUTTON_COUNT = 4;

  local EXAMROOMDOOR_TOP_POSITION = -145;
  local EXAMROOMDOOR_MIDDLE_POSITION = -64;
  local EXAMROOMDOOR_BOTTOM_POSITION = 17;

 --*******************************************************************************************************************
  function private.ExamroomdoorDefault ()

    -- 1 - top, 2 -- middle, 3 - bottom 
    private.examroomdoor_state = { 3, 2, 3, 1 };

  end; 
  --*******************************************************************************************************************
  function private.ExamroomdoorLoad ()

    private.examroomdoor_state = ng_global.progress[ "std" ][ "win_examroomdoor" ].state;

    if ( not private.examroomdoor_state ) then

      private.ExamroomdoorDefault();

    end; 

  end;
  --*******************************************************************************************************************
  function private.ExamroomdoorSave ()

    ng_global.progress[ "std" ][ "win_examroomdoor" ].state = private.examroomdoor_state;

  end;
  --*******************************************************************************************************************
  function private.ExamroomdoorInit ()

    for i = 1, EXAMROOMDOOR_BUTTON_COUNT, 1 do

      local curButton = EXAMROOMDOOR_BUTTON_NAME..i;
      ObjSet( curButton, { 
        input = 1,
        event_mdown  = function () private.ExamroomdoorClick( i ); end,
        event_menter = function () private.ExamroomdoorEnter(); end,
        event_mleave = function () private.ExamroomdoorLeave(); end
      } );

    end;

  end;
  --*******************************************************************************************************************
  function private.ExamroomdoorEnter ()
   
    SetCursor( CURSOR_HAND );

  end;
  --*******************************************************************************************************************
  function private.ExamroomdoorLeave ()
   
    SetCursor( CURSOR_DEFAULT );

  end;
  --*******************************************************************************************************************
  function private.GetCoordinatesByPosition ( position )

    local result = EXAMROOMDOOR_TOP_POSITION;

    if position == 1 then 
      result = EXAMROOMDOOR_TOP_POSITION;

    elseif position == 2 then 
      result = EXAMROOMDOOR_MIDDLE_POSITION;

    elseif position == 3 then 
      result = EXAMROOMDOOR_BOTTOM_POSITION;

    end;   

    return result;

  end; 
  --*******************************************************************************************************************
  function private.ExamroomdoorClick ( id )

    local relations     = {  2,   3,  4,   1 };
    local change_states = {  1,  -1,  1,  -1 };

    local id_2 = relations[ id ];

    local func_end = function ()

      cmn.Lock( false );   
      private.ExamroomdoorUpdate();

    end;

    local curButton   = EXAMROOMDOOR_BUTTON_NAME..id;
    local curButton_2 = EXAMROOMDOOR_BUTTON_NAME..id_2;

    local prevPosition = private.examroomdoor_state[ id ];
    local nextPosition = private.examroomdoor_state[ id ] - 1;

    local prevPosition_2 = private.examroomdoor_state[ id_2 ];
    local nextPosition_2 = private.examroomdoor_state[ id_2 ] + change_states[ id ];

    if nextPosition < 1 then 

      nextPosition = 3;

    end;

    if nextPosition_2 < 1 then 

      nextPosition_2 = 3;

    elseif nextPosition_2 > 3 then 

      nextPosition_2 = 1;

    end;

    local oldCoordinate = private.GetCoordinatesByPosition( prevPosition );
    local newCoordinate = private.GetCoordinatesByPosition( nextPosition );

    local oldCoordinate_2 = private.GetCoordinatesByPosition( prevPosition_2 );
    local newCoordinate_2 = private.GetCoordinatesByPosition( nextPosition_2 );

    private.examroomdoor_state[ id ]   = nextPosition;
    private.examroomdoor_state[ id_2 ] = nextPosition_2;

    private.ExamroomdoorSave();

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide", 0, "", 0 ); 

    ObjAnimate( curButton, "pos_y",0,0, func_end, { 0, 2, oldCoordinate,    0.4, 2, newCoordinate } );

    ObjAnimate( curButton_2, "pos_y",0,0, "", { 0, 2, oldCoordinate_2,    0.4, 2, newCoordinate_2 } );

    local curButtonLight = curButton.."_light";
    local curButtonLightAlpha = ObjGet( curButtonLight ).alp;

    local curButtonLight_2 = curButton_2.."_light";
    local curButtonLightAlpha_2 = ObjGet( curButtonLight_2 ).alp;

    if ( private.examroomdoor_state[ id ] == private.examroomdoor_state_win[ id ] ) then 

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_button4", 0, "", 0 );
      ObjAnimate( curButtonLight, "alp",0,0, "", { 0, 2, curButtonLightAlpha,    0.4, 2, 1 } );

    else 

      ObjAnimate( curButtonLight, "alp",0,0, "", { 0, 2, curButtonLightAlpha,    0.4, 2, 0 } );

    end; 

    if ( private.examroomdoor_state[ id_2 ] == private.examroomdoor_state_win[ id_2 ] ) then 

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_button4", 0, "", 0 );
      ObjAnimate( curButtonLight_2, "alp",0,0, "", { 0, 2, curButtonLightAlpha_2,    0.4, 2, 1 } );

    else 

      ObjAnimate( curButtonLight_2, "alp",0,0, "", { 0, 2, curButtonLightAlpha_2,    0.4, 2, 0 } );

    end; 

  end;
  --*******************************************************************************************************************
  function private.ExamroomdoorCheckWin ()

    local count = 0;
    local result = false;

    for i = 1, EXAMROOMDOOR_BUTTON_COUNT, 1 do

      if ( private.examroomdoor_state[i] == private.examroomdoor_state_win[i] ) then 
        count = count + 1;
      end; 

    end;

    if ( count == EXAMROOMDOOR_BUTTON_COUNT ) then 
      result = true; 
    end; 

    return result;

  end;
  --*******************************************************************************************************************
  function private.ExamroomdoorWin ()

    local func_end = function ()

      cmn.Lock( false );   
      cmn.SetEventDone( "win_examroomdoor" );
      cmn.CallEventHandler( "win_examroomdoor" );
      common_impl.PassingMgWin( "examroomdoor" ); 
 
      common.CloseSubRoom();

    end;

    cmn.MiniGameHide( "examroomdoor" );
    cmn.Lock( true ); 

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_win_examroom", 0, "", 0 );

    ObjAnimate( "spr_examroomdoor_handle1", "alp",0,0, "", { 0, 0, 1,    0.1, 0, 0 } );
    ObjAnimate( "spr_examroomdoor_handle2", "alp",0,0, "", { 0, 0, 0,    0.1, 0, 1 } );

    ObjAnimate( "spr_examroomdoor_door", "pos_x",0,0, func_end, { 0, 3, 21,    0.1, 3, 21,    1.3, 3, -700,    1.6, 3, -700 } );  
    ObjAnimate( "spr_examroomdoor_door", "alp",0,0, "", { 0, 0, 1,    0.6, 0, 1,    1.3, 0, 0 } );
    
  end;
 --*******************************************************************************************************************
  function private.ExamroomdoorUpdate ()

    for i = 1, EXAMROOMDOOR_BUTTON_COUNT, 1 do

      local curButton = EXAMROOMDOOR_BUTTON_NAME..i;
      local curButtonPosition = private.examroomdoor_state[i];
      local curButtonCoordinates = private.GetCoordinatesByPosition( curButtonPosition );

      ObjSet( curButton, { pos_y = curButtonCoordinates } );

      local curButtonLight = curButton.."_light";

      if curButtonPosition == private.examroomdoor_state_win[i] then 
        ObjSet( curButtonLight, { alp = 1 } );

      else 
        ObjSet( curButtonLight, { alp = 0 } );

      end; 

    end;

    if private.ExamroomdoorCheckWin() then 
      private.ExamroomdoorWin();
    end; 

  end; 

--*********************************************************************************************************************
--function *** MMG TOBIASPLANS ***()
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.ClkTobiasplansButton( name )

    if ( name == "c" ) then
      
      cmn.Lock( true );
      ObjAnimate( "spr_secondfloor_button_c", "alp", 0, 0, function() cmn.Lock( false ); zz_tobiasplans.Reset(); end, 
      { 
        0.0, 3, 0,
        0.1, 3, 1,
        0.2, 3, 1,
        0.3, 3, 0
      } );

    elseif ( name == "sharp" ) then

      cmn.Lock( true );
      ObjAnimate( "spr_secondfloor_button_sharp", "alp", 0, 0, function() cmn.Lock( false ); end, 
      { 
        0.0, 3, 0,
        0.1, 3, 1,
        0.2, 3, 1,
        0.3, 3, 0
      } );

    else


      local func_end = function()

        cmn.Lock( false );
        local index = private.tobiasplans.index;
        local res = "assets/levels/level3/rm_secondfloor/zz_tobiasplans/layers/figure_"..name

        ObjSet( "spr_tobiasplans_number_"..index, { res = res } );

        private.tobiasplans.state[ index ] = name;

        local flag_win = true;

        for i = 1, #private.tobiasplans.state do

          if ( private.tobiasplans.state[ i ] ~= private.tobiasplans.win_state[ i ] ) then

            flag_win = false;
            break;

          end;

        end;
        
        if ( flag_win ) then

          private.WinAnimTobiasplans();

        else        

          if ( index == #private.tobiasplans.state ) then

            local func_end = function ()

              zz_tobiasplans.Reset();

              common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );  

              ObjSet( "obj_tobiasplans_numbers", { alp = 1 } );

            end;

            ObjAnimate( "obj_tobiasplans_numbers", "alp", 0, 0, func_end, { 0,3,1,  0.2,3,0,  0.1,3,1,  0.6,3,0 } );

          else

            ng_global.progress[ "std" ][ "win_tobiasplans" ].state = {};

            for i = 1, #private.tobiasplans.state do
        
              ng_global.progress[ "std" ][ "win_tobiasplans" ].state[ i ] = private.tobiasplans.state[ i ];

            end;

            private.tobiasplans.index = index + 1;

            ng_global.progress[ "std" ][ "win_tobiasplans" ].index = private.tobiasplans.index;

          end;

        end;

      end;

      cmn.Lock( true );

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_button4", 0, "", 0 );

      ObjAnimate( "spr_secondfloor_button_"..name, "alp", 0, 0, func_end, 
      { 
        0.0, 3, 0,
        0.1, 3, 1,
        0.2, 3, 1,
        0.3, 3, 0
      } );

    end;

  end;
  --*********************************************************************************************************************
  function private.WinAnimTobiasplans ()

    local func_end = function ()

      cmn.Lock( false );

      private.WinTobiasplans();

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_open", 0, "", 0 );

    ObjAnimate( "spr_tobiasplans_door", "alp", 0, 0, func_end, { 0,3,1,  0.4,3,1,  1.0,3,0 } );

  end;
  --*********************************************************************************************************************
  function private.WinTobiasplans ()

    cmn.MiniGameHide( "tobiasplans" );
    common_impl.PassingMgWin( "tobiasplans" );
    cmn.SetEventDone( "win_tobiasplans" );
    cmn.CallEventHandler( "win_tobiasplans" );

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--function *** MMG TUBE()
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.ClkTubeButtonForDrag ( number )

    common_impl.PlayAudio( "sfx", "aud_get_inv_in_hand_sfx", 0, "", 0 );

    ObjSet( "spr_tube_lamp_"..number, { pos_z = 10 } );
    ObjAttach( "spr_tube_lamp_"..number, "zz_tube" );
    ObjSet( "spr_tube_lamp_"..number.."_light", { alp = 0 } );

    for i = 1, 4 do

      if ( private.tube.state[ i ] == number ) then

        ObjSet( "spr_tube_button_"..i.."_green", { alp = 0 } );
        ObjSet( "spr_tube_button_"..i.."_red",   { alp = 0 } );
        break;

      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.DropTubeButton ( number )

    local obj_name = "spr_tube_lamp_"..number;
    local index;
    local value;

    local past_index = 0;

    for i = 1, 4 do

      if ( private.tube.state[ i ] == number ) then

        past_index = i;
        break;

      end;

    end;

    if cmn.ApplyObj( obj_name, "obj_tube_lamp_1_use" ) and ( private.tube.state[ 1 ] == 0 ) then

      ObjAttach( obj_name, "obj_tube_lamp_1_use" );
      ObjSet( obj_name, { pos_x = 0, pos_y = 0 } );

      index = 1;
      value = number;

    elseif cmn.ApplyObj( obj_name, "obj_tube_lamp_2_use" ) and ( private.tube.state[ 2 ] == 0 ) then

      ObjAttach( obj_name, "obj_tube_lamp_2_use" );
      ObjSet( obj_name, { pos_x = 0, pos_y = 0 } );

      index = 2;
      value = number;

    elseif cmn.ApplyObj( obj_name, "obj_tube_lamp_3_use" ) and ( private.tube.state[ 3 ] == 0 ) then

      ObjAttach( obj_name, "obj_tube_lamp_3_use" );
      ObjSet( obj_name, { pos_x = 0, pos_y = 0 } );

      index = 3;
      value = number;

    elseif cmn.ApplyObj( obj_name, "obj_tube_lamp_4_use" ) and ( private.tube.state[ 4 ] == 0 ) then

      ObjAttach( obj_name, "obj_tube_lamp_4_use" );
      ObjSet( obj_name, { pos_x = 0, pos_y = 0 } );

      index = 4;
      value = number;

    elseif cmn.ApplyObj( obj_name, "obj_tube_lamp_5_use" ) then

      local pos_x = private.tube.pos[ number ][ 1 ];
      local pos_y = private.tube.pos[ number ][ 2 ];
      ObjSet( obj_name, { pos_x = pos_x, pos_y = pos_y } );
      ObjAttach( obj_name, "obj_tube_lamps" );

      for i = 1, #private.tube.state do
      
        if ( private.tube.state[ i ] == number ) then

          index = i;
          value = 0;
          break;

        end;

      end;

    else

      if ( past_index ~= 0 ) then

        ObjSet( "spr_tube_lamp_"..number, { pos_z = 2 } );
        ObjAttach( "spr_tube_lamp_"..number, "obj_tube_lamp_"..past_index.."_use" );

      else 

        ObjSet( "spr_tube_lamp_"..number, { pos_z = 2 } );
        ObjAttach( "spr_tube_lamp_"..number, "obj_tube_lamps" );

      end;

    end;
    
    if ( index ) then

      local index_not_light;

      for i = 1, #private.tube.state do
      
        if ( private.tube.state[ i ] == number ) then

          private.tube.state[ i ] = 0;
          index_not_light = i;
          break;

        end;

      end;

      private.tube.state[ index ] = value;

    end;

    private.SetLightTube();

    if ( index ) then

      ng_global.progress[ "std" ][ "win_tube" ].state = {};

      for i = 1, #private.tube.state do

        ng_global.progress[ "std" ][ "win_tube" ].state[ i ] = private.tube.state[ i ]

      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.LeverStartTube ()

    ObjSet( "spr_tube_handle_red_light", { alp = 0 } );
    ObjSet( "spr_tube_handle_green",     { alp = 1 } );

    ng_global.progress[ "std" ][ "win_tube" ].state = {};

    for i = 1, #private.tube.state do

      private.tube.state[ i ] = private.tube.win_state[ i ];
      ng_global.progress[ "std" ][ "win_tube" ].state[ i ] = private.tube.win_state[ i ];

    end;

  end;
  --*********************************************************************************************************************
  function private.ClkHandleTube ()

    ObjAnimate( "obj_tube_lamps_lights", "alp", 0, 0, "", { 0,3,0,  0.2,3,1,  0.6,3,1,  1.0,3,0 } );

    local flag_win = true;

    for i = 1, #private.tube.state do

      if ( private.tube.state[ i ] ~= private.tube.win_state[ i ] ) then

        flag_win = false;
        break;

      end;

    end;
      
    if ( flag_win ) then

      cmn.Lock( true );

      local func_end = function ()

        cmn.Lock( false );

        private.tube.levet_start = true;
        ng_global.progress[ "std" ][ "win_tube" ].levet_start = true;
        
        private.LeverStartTube();

        private.WinAnimTube();

      end;

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_lamp", 0, "", 0 );

      ObjAnimate( "spr_tube_handle_red_light", "alp", 0, 0, "", { 0,3,1,  0.4,3,0 } );
      ObjAnimate( "spr_tube_handle_green",     "alp", 0, 0, func_end, { 0,3,0,  0.4,3,1 } );
      
    else

      local func_end = function ()

        cmn.Lock( false );

      end;

      cmn.Lock( true );

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_clk_lever_tube", 0, "", 0 );

      ObjAnimate( "spr_tube_handle_1", "alp", 0, 0, func_end, { 0,3,1,  0.2,3,0,  0.6,3,0,  1.0,3,1 } );
      ObjAnimate( "spr_tube_handle_2", "alp", 0, 0, "", { 0,3,0,  0.2,3,1,  0.6,3,1,  1.0,3,0 } );

    end;

  end;
  --*********************************************************************************************************************
  function private.WinAnimTube ()

    local func_end = function ()

      cmn.Lock( false );

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_lever", 0, "", 0 );

      private.WinTube();

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_clk_lever_tube", 0, "", 0 );

    ObjAnimate( "spr_tube_handle_1", "alp", 0, 0, "", { 0,3,1,  0.4,3,0 } );
    ObjAnimate( "spr_tube_handle_2", "alp", 0, 0, "", { 0,3,0,  0.4,3,1 } );

    ObjAnimate( "spr_tube_counter_2", "ang", 0, 0, "", { 0,3,0,  0.8,3,-0.94,  1.6,3,-1.82,  2.4,3,-2.69, 3.0,3,-4.7 } );

    ObjAnimate( "spr_tube_panel", "pos_y", 0, 0, func_end, { 0,3,128, 3.0,3,128,  3.6,3,240 } );

  end;
  --*********************************************************************************************************************
  function private.WinTube ()

    ng_global.progress[ "std" ][ "win_tube" ].start_lever = true;

    cmn.MiniGameHide( "tube" );
    common_impl.PassingMgWin( "tube" );
    cmn.SetEventDone( "win_tube" );
    cmn.CallEventHandler( "win_tube" );

  end;
  --*********************************************************************************************************************
  function private.SetLightTube ()

    for i = 1, #private.tube.state do

      ObjSet( "spr_tube_lamp_"..i.."_light",   { alp = 0 } );

    end;

    for i = 1, #private.tube.state do

      local number = private.tube.state[ i ];

      if ( number == 0 ) then

        ObjSet( "spr_tube_button_"..i.."_green", { alp = 0 } );
        ObjSet( "spr_tube_button_"..i.."_red",   { alp = 0 } );

      else

        local res = "assets/levels/level3/rm_secondfloor/zz_tube/anims/light_lamp_"..number;
        ObjSet( "spr_tube_lamp_"..i.."_light", { alp = 1, res = res } );

        if ( number == private.tube.win_state[ i ]) then

          common_impl.PlayAudio( "sfx", "aud_get_inv_in_hand_sfx", 0, "", 0 );

          ObjSet( "spr_tube_button_"..i.."_green", { alp = 1 } );

        else

          common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

          ObjSet( "spr_tube_button_"..i.."_red", { alp = 1 } );

        end;

      end;

    end;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_secondfloor ()

  if not ( cmn.IsEventDone( "opn_secondfloor" ) ) then

    cmn.SetEventDone( "opn_secondfloor" );

    common_impl.ShowBbt( "bbt_secondfloor_opn_secondfloor" );

    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "find_place_tobias" );


  end;

  cmn.CallEventHandler( "opn_secondfloor" ); 

end;
--*********************************************************************************************************************