-- name=rm_terenceroom
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_terenceroom";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_doorpanel", "room_hub" );
  ObjAttach( "zz_bed", "room_hub" );
  ObjAttach( "zz_medicinecabinet", "room_hub" );
  ObjAttach( "zz_showerroom", "room_hub" );
  private.Init_Subroom();
  private.ShowerroomMmgInit();
  private.InitAnimations();
  
  ObjMultiSet({ 
    { "spr_terenceroom_folder_close",           { event_mdown = private.clk_terenceroom_folder } },

    { "spr_doorpanel_hook",                     { event_mdown = private.get_hook_lvl3    } },
    { "spr_bed_terencetie",                     { event_mdown = private.get_terencetie   } },
    { "spr_bed_terencediary",                   { event_mdown = private.get_terencediary } },
    { "spr_bed_tile",                           { event_mdown = private.get_tile         } },
    { "spr_medicinecabinet_scissors",           { event_mdown = private.get_scissors     } },
    { "spr_medicinecabinet_oilcan",             { event_mdown = private.get_oilcan       } },
    { "spr_medicinecabinet_tap",                { event_mdown = private.get_tap          } },
    { "spr_showerroom_bronzeamulet",            { event_mdown = private.get_bronzeamulet } },
    { "spr_showerroom_code2",                   { event_mdown = private.get_code2        } },
    { "spr_showerroom_tweezers",                { event_mdown = private.get_tweezers     } },
    { "obj_showerroom_use_tap",                 { event_mdown = private.AnimTap          } },

    { "obj_doorpanel_clk_secondfloorbutton",    { event_mdown = private.clk_secondfloorbutton } },
    { "obj_bed_clk_pillow",                     { event_mdown = private.clk_pillow            } },
    { "obj_bed_clk_photobox",                   { event_mdown = private.clk_photobox          } },
    { "obj_medicinecabinet_clk_drawerkey",      { event_mdown = private.clk_drawerkey         } },
    { "obj_medicinecabinet_clk_tieclip",        { event_mdown = private.clk_tieclip           } },

    { "spr_bed_paper",                          { event_mdown = private.BedClkPaperOpen             } },
    { "spr_bed_paper_big",                      { event_mdown = private.BedClkPaperClose            } },
    { "spr_showerroom_paper",                   { event_mdown = private.ShowerroomClkPaperOpen      } },
    { "spr_showerroom_paper_big",               { event_mdown = private.ShowerroomClkPaperClose     } },
    { "spr_medicinecabinet_note",               { event_mdown = private.MedicinecabinetClkNote      } },
    { "spr_medicinecabinet_note_big",           { event_mdown = private.MedicinecabinetClkNoteClose } },

    { "spr_collect2_item_3_2",                  { event_mdown = private.get_collect2_item_3_2 } },

    { "obj_medicinecabinet_use_tieclip",        { event_mdown = private.AnimCoverTieclip      } },
    { "obj_medicinecabinet_use_drawerkey",      { event_mdown = private.AnimCoverDrawerkey    } },
    { "obj_bed_use_scissors",                   { event_mdown = private.AnimBedClkCushion     } },

  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_terenceroom = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "gho_terenceroom_behindmirror",
      "gzz_terenceroom_doorpanel",
      "gzz_terenceroom_bed",
      "gzz_terenceroom_medicinecabinet",
      "gzz_terenceroom_showerroom",
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_doorpanel",
      "zz_bed",
      "zz_medicinecabinet",
      "zz_showerroom",
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_terenceroom", update_game_mode_terenceroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_terenceroom = function ()

  local effects_table = 
  {
    "obj_terenceroom_anim",
    "spr_terenceroom_medikalcabinet_green_light",
    "spr_terenceroom_medikalcabinet_red_light",
    "obj_medicinecabinet_light",
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_terenceroom", update_performance_mode_terenceroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_terenceroom () end;
  --------------------------------------------------------------------------------------------
  local opn_terenceroom_map = function ()

    common_impl.VisitMapRoom( "terenceroom" );
    ObjDelete( "anm_terenceroom_collapse" );

  end;
  cmn.AddSubscriber( "opn_terenceroom", opn_terenceroom_map );
  --------------------------------------------------------------------------------------------
  local see_terenceroom_mirror = function ()

    ObjDelete( "anm_terenceroom_light_glass" );
    ObjSet( "anm_terenceroom_use_sledgehammer", { alp = 1 } );
    ObjSet( "obj_terenceroom_use_sledgehammer", { input = true } );

  end;
  cmn.AddSubscriber( "see_terenceroom_mirror", see_terenceroom_mirror );
  
  --------------------------------------------------------------------------------------------
  -- function get_hook_lvl3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hook_lvl3" ] = {
    type = "get",
    get_obj = "spr_doorpanel_hook",
    room = private.room_objname,
    zz = "zz_doorpanel",
    zz_gate = "gzz_terenceroom_doorpanel"
  };
  
  local get_hook_lvl3_inv = function ()
  
    interface.InventoryItemAdd( "inv_hook_lvl3", "spr_doorpanel_hook" );
  
  end;
  
  local get_hook_lvl3_closezz = function ()
  
    ObjDelete( "gfx_doorpanel_hook" );
    ObjDelete( "spr_doorpanel_hook_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_hook_lvl3", get_hook_lvl3_inv );
  cmn.AddSubscriber( "get_hook_lvl3", get_hook_lvl3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_terencetie () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_terencetie" ] = {
    type = "get",
    get_obj = "spr_bed_terencetie",
    room = private.room_objname,
    zz = "zz_bed",
    zz_gate = "gzz_terenceroom_bed"
  };
  
  local get_terencetie_inv = function ()
  
    interface.InventoryItemAdd( "inv_terencetie", "spr_bed_tie" );
    ObjSet( "inv_terencetie", { drag = false } );

  end;
  
  local get_terencetie_closezz = function ()
  
    ObjDelete( "gfx_bed_terencetie" );
    ObjDelete( "obj_bed_tie" );
  
  end;
  
  cmn.AddSubscriber( "get_terencetie", get_terencetie_inv );
  cmn.AddSubscriber( "get_terencetie", get_terencetie_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_terencediary () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_terencediary" ] = {
    type = "get",
    get_obj = "spr_bed_terencediary",
    room = private.room_objname,
    zz = "zz_bed",
    zz_gate = "gzz_terenceroom_bed"
  };
  
  local get_terencediary_inv = function ()
  
    interface.InventoryItemAdd( "inv_terencediary", "spr_bed_terencediary" );
    ObjSet( "inv_terencediary", { drag = false } );

  end;
  
  local get_terencediary_closezz = function ()
  
    ObjDelete( "gfx_bed_terencediary"     );
    ObjDelete( "spr_terenceroom_zz_bed_1" );

    ObjSet( "spr_terenceroom_zz_bed_2", { alp = 1 } );
  
  end;
  
  cmn.AddSubscriber( "get_terencediary", get_terencediary_inv );
  cmn.AddSubscriber( "get_terencediary", get_terencediary_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tile () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tile" ] = {
    type = "get",
    get_obj = "spr_bed_tile",
    room = private.room_objname,
    zz = "zz_bed",
    zz_gate = "gzz_terenceroom_bed"
  };
  
  local get_tile_inv = function ()
  
    interface.InventoryItemAdd( "inv_tile", "spr_bed_tile" );
  
  end;
  
  local get_tile_closezz = function ()
  
    ObjDelete( "gfx_bed_tile"             );
    ObjDelete( "spr_terenceroom_zz_bed_4" );
  
  end;
  
  cmn.AddSubscriber( "get_tile", get_tile_inv );
  cmn.AddSubscriber( "get_tile", get_tile_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_scissors () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_scissors" ] = {
    type = "get",
    get_obj = "spr_medicinecabinet_scissors",
    room = private.room_objname,
    zz = "zz_medicinecabinet",
    zz_gate = "gzz_terenceroom_medicinecabinet"
  };
  
  local get_scissors_inv = function ()
  
    interface.InventoryItemAdd( "inv_scissors", "spr_medicinecabinet_scissors" );
  
  end;
  
  local get_scissors_closezz = function ()
  
    ObjDelete( "gfx_medicinecabinet_scissors"        );
    ObjDelete( "spr_medicinecabinet_scissors_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_scissors", get_scissors_inv );
  cmn.AddSubscriber( "get_scissors", get_scissors_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_oilcan () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_oilcan" ] = {
    type = "get",
    get_obj = "spr_medicinecabinet_oilcan",
    room = private.room_objname,
    zz = "zz_medicinecabinet",
    zz_gate = "gzz_terenceroom_medicinecabinet"
  };
  
  local get_oilcan_inv = function ()
  
    interface.InventoryItemAdd( "inv_oilcan", "spr_medicinecabinet_oilcan" );
  
  end;
  
  local get_oilcan_closezz = function ()
  
    ObjDelete( "gfx_medicinecabinet_oilcan"       );
    ObjDelete( "spr_medicinecabinet_oiler_shadow" );

    ObjDelete( "spr_terenceroom_zz_medicinecabinet_olier" );
  
  end;
  
  cmn.AddSubscriber( "get_oilcan", get_oilcan_inv );
  cmn.AddSubscriber( "get_oilcan", get_oilcan_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tap () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tap" ] = {
    type = "get",
    get_obj = "spr_medicinecabinet_tap",
    room = private.room_objname,
    zz = "zz_medicinecabinet",
    zz_gate = "gzz_terenceroom_medicinecabinet"
  };
  
  local get_tap_inv = function ()
  
    interface.InventoryItemAdd( "inv_tap", "spr_medicinecabinet_tap" );
  
  end;
  
  local get_tap_closezz = function ()
  
    ObjDelete( "gfx_medicinecabinet_tap"          );
    ObjDelete( "spr_medicinecabinet_valve_shadow" );
    ObjDelete( "gzz_terenceroom_medicinecabinet"  );
  
    ObjDelete( "spr_terenceroom_zz_medicinecabinet_valve" );

  end;
  
  cmn.AddSubscriber( "get_tap", get_tap_inv );
  cmn.AddSubscriber( "get_tap", get_tap_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bronzeamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bronzeamulet" ] = {
    type = "get",
    get_obj = "spr_showerroom_bronzeamulet",
    room = private.room_objname,
    zz = "zz_showerroom",
    zz_gate = "gzz_terenceroom_showerroom"
  };
  
  local get_bronzeamulet_inv = function ()
  
    interface.InventoryItemAdd( "inv_bronzeamulet", "spr_showerroom_bronzeamulet" );
  
  end;
  
  local get_bronzeamulet_closezz = function ()
  
    ObjDelete( "gfx_showerroom_bronzeamulet"     );
    ObjDelete( "spr_terenceroom_zz_showerroom_3" );
  
  end;
  
  cmn.AddSubscriber( "get_bronzeamulet", get_bronzeamulet_inv );
  cmn.AddSubscriber( "get_bronzeamulet", get_bronzeamulet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_code2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_code2" ] = {
    type = "get",
    get_obj = "spr_showerroom_code2",
    room = private.room_objname,
    zz = "zz_showerroom",
    zz_gate = "gzz_terenceroom_showerroom"
  };
  
  local get_code2_inv = function ()
  
    interface.InventoryItemAdd( "inv_code2", "spr_showerroom_code2" );
  
  end;
  
  local get_code2_closezz = function ()
  
    ObjDelete( "gfx_showerroom_code2"            );
    ObjDelete( "spr_terenceroom_zz_showerroom_1" );
  
  end;
  
  cmn.AddSubscriber( "get_code2", get_code2_inv );
  cmn.AddSubscriber( "get_code2", get_code2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tweezers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tweezers" ] = {
    type = "get",
    get_obj = "spr_showerroom_tweezers",
    room = private.room_objname,
    zz = "zz_showerroom",
    zz_gate = "gzz_terenceroom_showerroom"
  };
  
  local get_tweezers_inv = function ()
  
    interface.InventoryItemAdd( "inv_tweezers", "spr_showerroom_tweezers" );
  
  end;
  
  local get_tweezers_closezz = function ()
  
    ObjDelete( "gfx_showerroom_tweezers"         );
    ObjDelete( "spr_terenceroom_zz_showerroom_4" );
  
  end;
  
  cmn.AddSubscriber( "get_tweezers", get_tweezers_inv );
  cmn.AddSubscriber( "get_tweezers", get_tweezers_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_3_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_3_2 = function ()
  
    ObjDelete( "obj_collect2_item_3_2" );

  end;    
  cmn.AddSubscriber( "get_collect2_item_3_2", get_collect2_item_3_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_secondfloorbutton () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_secondfloorbutton" ] = {
    type = "use",
    inv_obj = "inv_secondfloorbutton",
    use_place = "obj_doorpanel_use_secondfloorbutton",
    room = private.room_objname,
    zz = "zz_doorpanel",
    zz_gate = "gzz_terenceroom_doorpanel"
  };
  local use_secondfloorbutton_inv = function ()
  
    interface.InventoryItemRemove( "inv_secondfloorbutton" );
  
  end;
  local use_secondfloorbutton_beg = function ()
  
    ObjDelete( "obj_doorpanel_use_secondfloorbutton" );
  
  end;
  local use_secondfloorbutton_end = function ()
  
    ObjSet( "spr_doorpanel_button", { alp = 1 } );
    ObjSet( "obj_doorpanel_clk_secondfloorbutton",  { input = true } );
    ObjSet( "spr_terenceroom_zz_doorpanel_button_layer", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_secondfloorbutton", use_secondfloorbutton_beg, private.room_objname );
  cmn.AddSubscriber( "use_secondfloorbutton", use_secondfloorbutton_inv );
  cmn.AddSubscriber( "use_secondfloorbutton", use_secondfloorbutton_end, private.room_objname );
  cmn.AddSubscriber( "use_secondfloorbutton_inv", use_secondfloorbutton_inv, private.room_objname );
  cmn.AddSubscriber( "use_secondfloorbutton_beg", use_secondfloorbutton_beg, private.room_objname );
  cmn.AddSubscriber( "use_secondfloorbutton_end", use_secondfloorbutton_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_photopart1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_photopart1" ] = {
    type = "use",
    inv_obj = "inv_photopart1",
    use_place = "obj_bed_use_photopart1",
    room = private.room_objname,
    zz = "zz_bed",
    zz_gate = "gzz_terenceroom_bed"
  };
  local use_photopart1_inv = function ()
  
    interface.InventoryItemRemove( "inv_photopart1" );
  
  end;
  local use_photopart1_beg = function ()
  
    ObjDelete( "obj_bed_use_photopart1" );
  
  end;
  local use_photopart1_end = function ()
  
    ObjSet( "spr_bed_photo_lft",        { alp = 1 } );
    ObjSet( "spr_terenceroom_zz_bed_6", { alp = 1 } );

    if ( cmn.IsEventDone( "use_photopart2" ) ) then 

      ObjSet( "spr_bed_tile", { input = true } );
      ObjDelete( "spr_bed_cover_shadow" );
      ObjSet( "spr_bed_box_cover", { pos_x = -128, pos_y = 55 } );

      ObjSet( "spr_terenceroom_zz_bed_5", { pos_x = 493, pos_y = 385 } );

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_photopart1", use_photopart1_beg, private.room_objname );
  cmn.AddSubscriber( "use_photopart1", use_photopart1_inv );
  cmn.AddSubscriber( "use_photopart1", use_photopart1_end, private.room_objname );
  cmn.AddSubscriber( "use_photopart1_inv", use_photopart1_inv, private.room_objname );
  cmn.AddSubscriber( "use_photopart1_beg", use_photopart1_beg, private.room_objname );
  cmn.AddSubscriber( "use_photopart1_end", use_photopart1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_photopart2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_photopart2" ] = {
    type = "use",
    inv_obj = "inv_photopart2",
    use_place = "obj_bed_use_photopart2",
    room = private.room_objname,
    zz = "zz_bed",
    zz_gate = "gzz_terenceroom_bed"
  };
  local use_photopart2_inv = function ()
  
    interface.InventoryItemRemove( "inv_photopart2" );
  
  end;
  local use_photopart2_beg = function ()
  
    ObjDelete( "obj_bed_use_photopart2" );
  
  end;
  local use_photopart2_end = function ()
  
    ObjSet( "spr_bed_photo_rgt",        { alp = 1 } );
    ObjSet( "spr_terenceroom_zz_bed_7", { alp = 1 } );

    if cmn.IsEventDone( "use_photopart1" ) then 
      ObjSet( "spr_bed_tile", { input = true } );
      ObjDelete( "spr_bed_cover_shadow" );
      ObjSet( "spr_bed_box_cover", { pos_x = -128, pos_y = 55 } );

      ObjSet( "spr_terenceroom_zz_bed_5", { pos_x = 493, pos_y = 385 } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_photopart2", use_photopart2_beg, private.room_objname );
  cmn.AddSubscriber( "use_photopart2", use_photopart2_inv );
  cmn.AddSubscriber( "use_photopart2", use_photopart2_end, private.room_objname );
  cmn.AddSubscriber( "use_photopart2_inv", use_photopart2_inv, private.room_objname );
  cmn.AddSubscriber( "use_photopart2_beg", use_photopart2_beg, private.room_objname );
  cmn.AddSubscriber( "use_photopart2_end", use_photopart2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hook_lvl3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hook_lvl3" ] = {
    type = "use",
    inv_obj = "inv_hook_lvl3",
    use_place = "obj_bed_use_hook",
    room = private.room_objname,
    zz = "zz_bed",
    zz_gate = "gzz_terenceroom_bed"
  };
  local use_hook_lvl3_inv = function ()
  
    if cmn.IsEventDone( "use_hook_lvl3_2" ) then 
      interface.InventoryItemRemove( "inv_hook_lvl3" );
    end;   
  
  end;

  local use_hook_lvl3_beg = function ()
  
    ObjDelete( "obj_bed_use_hook" );
    ObjDelete( "spr_bed_patch_3"  );

    ObjSet( "anm_bed_use_hook",   { alp = 1 } );
    ObjSet( "spr_bed_terencetie", { alp = 0 } );
  
  end;
  local use_hook_lvl3_end = function ()
  
    ObjDelete( "spr_bed_tie_over" );

    ObjSet( "spr_bed_terencetie", { input = true, active = true, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hook_lvl3", use_hook_lvl3_beg, private.room_objname );
  cmn.AddSubscriber( "use_hook_lvl3", use_hook_lvl3_inv );
  cmn.AddSubscriber( "use_hook_lvl3", use_hook_lvl3_end, private.room_objname );
  cmn.AddSubscriber( "use_hook_lvl3_inv", use_hook_lvl3_inv, private.room_objname );
  cmn.AddSubscriber( "use_hook_lvl3_beg", use_hook_lvl3_beg, private.room_objname );
  cmn.AddSubscriber( "use_hook_lvl3_end", use_hook_lvl3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_scissors () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_scissors" ] = {
    type = "use",
    inv_obj = "inv_scissors",
    use_place = "obj_bed_use_scissors",
    room = private.room_objname,
    zz = "zz_bed",
    zz_gate = "gzz_terenceroom_bed"
  };
  local use_scissors_inv = function ()
  
    interface.InventoryItemRemove( "inv_scissors" );
  
  end;
  local use_scissors_beg = function ()
  
    ObjDelete( "obj_bed_use_scissors" );

  end;
  local use_scissors_end = function ()
  
    --ObjSet( "spr_bed_terencediary", { input = true } );
  
    ObjSet( "obj_bed_clk_pillow", { input = true } );
    ObjSet( "spr_bed_thread_1", { alp = 1 } );
    ObjSet( "spr_bed_thread_2", { alp = 1 } );

    ObjDelete( "spr_bed_thread_3" );
    ObjDelete( "spr_bed_thread_4" );
    ObjDelete( "vid_bed_scissors" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_scissors", use_scissors_beg, private.room_objname );
  cmn.AddSubscriber( "use_scissors", use_scissors_inv );
  cmn.AddSubscriber( "use_scissors", use_scissors_end, private.room_objname );
  cmn.AddSubscriber( "use_scissors_inv", use_scissors_inv, private.room_objname );
  cmn.AddSubscriber( "use_scissors_beg", use_scissors_beg, private.room_objname );
  cmn.AddSubscriber( "use_scissors_end", use_scissors_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tieclip () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tieclip" ] = {
    type = "use",
    inv_obj = "inv_tieclip",
    use_place = "obj_medicinecabinet_use_tieclip",
    room = private.room_objname,
    zz = "zz_medicinecabinet",
    zz_gate = "gzz_terenceroom_medicinecabinet"
  };
  local use_tieclip_inv = function ()
  
    interface.InventoryItemRemove( "inv_tieclip" );
  
  end;
  local use_tieclip_beg = function ()
  
    ObjDelete( "obj_medicinecabinet_use_tieclip" );
  
  end;
  local use_tieclip_end = function ()
  
    ObjMultiSet({ 
      { "spr_medicinecabinet_clip",        { alp = 1                     }},
      { "obj_medicinecabinet_clk_tieclip", { active = true, input = true }},  
    });  

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tieclip", use_tieclip_beg, private.room_objname );
  cmn.AddSubscriber( "use_tieclip", use_tieclip_inv );
  cmn.AddSubscriber( "use_tieclip", use_tieclip_end, private.room_objname );
  cmn.AddSubscriber( "use_tieclip_inv", use_tieclip_inv, private.room_objname );
  cmn.AddSubscriber( "use_tieclip_beg", use_tieclip_beg, private.room_objname );
  cmn.AddSubscriber( "use_tieclip_end", use_tieclip_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_drawerkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_drawerkey" ] = {
    type = "use",
    inv_obj = "inv_drawerkey",
    use_place = "obj_medicinecabinet_use_drawerkey",
    room = private.room_objname,
    zz = "zz_medicinecabinet",
    zz_gate = "gzz_terenceroom_medicinecabinet"
  };
  local use_drawerkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_drawerkey" );
  
  end;
  local use_drawerkey_beg = function ()
  
    ObjDelete( "obj_medicinecabinet_use_drawerkey" );
  
  end;
  local use_drawerkey_end = function ()
  
    ObjMultiSet({ 
      { "spr_medicinecabinet_key_1",         { alp = 1                     }},
      { "obj_medicinecabinet_clk_drawerkey", { active = true, input = true }},  
    });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_drawerkey", use_drawerkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_drawerkey", use_drawerkey_inv );
  cmn.AddSubscriber( "use_drawerkey", use_drawerkey_end, private.room_objname );
  cmn.AddSubscriber( "use_drawerkey_inv", use_drawerkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_drawerkey_beg", use_drawerkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_drawerkey_end", use_drawerkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mechanismpart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_mechanismpart" ] = {
    type = "use",
    inv_obj = "inv_mechanismpart",
    use_place = "obj_medicinecabinet_use_mechanismpart",
    room = private.room_objname,
    zz = "zz_medicinecabinet",
    zz_gate = "gzz_terenceroom_medicinecabinet"
  };
  local use_mechanismpart_inv = function ()
  
    interface.InventoryItemRemove( "inv_mechanismpart" );
  
  end;
  local use_mechanismpart_beg = function ()
  
    ObjDelete( "obj_medicinecabinet_use_mechanismpart" );
  
  end;
  local use_mechanismpart_end = function ()
  
    ObjMultiSet({ 
      { "spr_medicinecabinet_scissors",     { input = true }},
      { "spr_medicinecabinet_note",         { input = true }},
      { "spr_medicinecabinet_green_light",  { alp = 1      }},
      { "spr_medicinecabinet_cover_3_open", { alp = 1      }},

      { "spr_terenceroom_zz_medicinecabinet_light", {        alp = 1 }},
      { "spr_terenceroom_zz_medicinecabinet_cover_2_open", { alp = 1 }},

      { "spr_terenceroom_medikalcabinet_green_light", { alp = 1 }},   
    });

    ObjDelete( "spr_terenceroom_medikalcabinet_red_light" );
    ObjDelete( "spr_medicinecabinet_red_light" );
    ObjDelete( "spr_medicinecabinet_cover_3"   );
    ObjDelete( "vid_medicinecabinet_mechanism" );

    ObjDelete( "spr_terenceroom_zz_medicinecabinet_cover_2" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mechanismpart", use_mechanismpart_beg, private.room_objname );
  cmn.AddSubscriber( "use_mechanismpart", use_mechanismpart_inv );
  cmn.AddSubscriber( "use_mechanismpart", use_mechanismpart_end, private.room_objname );
  cmn.AddSubscriber( "use_mechanismpart_inv", use_mechanismpart_inv, private.room_objname );
  cmn.AddSubscriber( "use_mechanismpart_beg", use_mechanismpart_beg, private.room_objname );
  cmn.AddSubscriber( "use_mechanismpart_end", use_mechanismpart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tile () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tile" ] = {
    type = "use",
    inv_obj = "inv_tile",
    use_place = "obj_showerroom_use_tile",
    room = private.room_objname,
    zz = "zz_showerroom",
    zz_gate = "gzz_terenceroom_showerroom"
  };
  local use_tile_inv = function ()
  
    interface.InventoryItemRemove( "inv_tile" );
  
  end;
  local use_tile_beg = function ()
  
    ObjDelete( "obj_showerroom_use_tile" );
  
  end;
  local use_tile_end = function ()
  
    ObjSet( "obj_showerroom_hole",             { input = true });
    ObjSet( "spr_terenceroom_zz_showerroom_4", { alp = 1      });

    ObjDelete( "spr_showerroom_tile"             );
    ObjDelete( "spr_showerroom_hole"             );
    ObjDelete( "spr_terenceroom_zz_showerroom_5" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tile", use_tile_beg, private.room_objname );
  cmn.AddSubscriber( "use_tile", use_tile_inv );
  cmn.AddSubscriber( "use_tile", use_tile_end, private.room_objname );
  cmn.AddSubscriber( "use_tile_inv", use_tile_inv, private.room_objname );
  cmn.AddSubscriber( "use_tile_beg", use_tile_beg, private.room_objname );
  cmn.AddSubscriber( "use_tile_end", use_tile_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_oilcan () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_oilcan" ] = {
    type = "use",
    inv_obj = "inv_oilcan",
    use_place = "obj_showerroom_use_oilcan",
    room = private.room_objname,
    zz = "zz_showerroom",
    zz_gate = "gzz_terenceroom_showerroom"
  };
  local use_oilcan_inv = function ()
  
    interface.InventoryItemRemove( "inv_oilcan" );
  
  end;
  local use_oilcan_beg = function ()
  
    ObjDelete( "obj_showerroom_use_oilcan" );
  
  end;
  local use_oilcan_end = function ()
  
    ObjMultiSet({ 
      { "spr_showerroom_valve_2",          { alp = 1                   }},
      { "spr_showerroom_bronzeamulet",     { input = true, alp = 1     }},
      { "spr_terenceroom_zz_showerroom_7", { alp = 1                   }},
      { "spr_terenceroom_zz_showerroom_3", { alp = 1                   }},
    });

    ObjDelete( "anm_showerroom_bronze_amulet" );
    ObjDelete( "vid_showerroom_use_oiler" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_oilcan", use_oilcan_beg, private.room_objname );
  cmn.AddSubscriber( "use_oilcan", use_oilcan_inv );
  cmn.AddSubscriber( "use_oilcan", use_oilcan_end, private.room_objname );
  cmn.AddSubscriber( "use_oilcan_inv", use_oilcan_inv, private.room_objname );
  cmn.AddSubscriber( "use_oilcan_beg", use_oilcan_beg, private.room_objname );
  cmn.AddSubscriber( "use_oilcan_end", use_oilcan_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tap () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tap" ] = {
    type = "use",
    inv_obj = "inv_tap",
    use_place = "obj_showerroom_use_tap",
    room = private.room_objname,
    zz = "zz_showerroom",
    zz_gate = "gzz_terenceroom_showerroom"
  };
  local use_tap_inv = function ()
  
    interface.InventoryItemRemove( "inv_tap" );
  
  end;
  local use_tap_beg = function ()
  
    ObjDelete( "obj_showerroom_use_tap" );
  
  end;
  local use_tap_end = function ()
  
    ObjMultiSet({ 
      { "obj_showerroom_mmg_drag",    { input = true }},
      { "spr_showerroom_valve_4",          { alp = 1 }},
      { "spr_terenceroom_zz_showerroom_8", { alp = 1 }},
    });

    ObjDelete( "spr_showerroom_valve_4_add" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tap", use_tap_beg, private.room_objname );
  cmn.AddSubscriber( "use_tap", use_tap_inv );
  cmn.AddSubscriber( "use_tap", use_tap_end, private.room_objname );
  cmn.AddSubscriber( "use_tap_inv", use_tap_inv, private.room_objname );
  cmn.AddSubscriber( "use_tap_beg", use_tap_beg, private.room_objname );
  cmn.AddSubscriber( "use_tap_end", use_tap_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sledgehammer () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sledgehammer" ] = {
    type = "use",
    inv_obj = "inv_sledgehammer",
    use_place = "obj_terenceroom_use_sledgehammer",
    room = private.room_objname 
  };
  local use_sledgehammer_inv = function ()
  
    interface.InventoryItemRemove( "inv_sledgehammer" );
  
  end;
  local use_sledgehammer_beg = function ()
  
    ObjDelete( "obj_terenceroom_use_sledgehammer" );
  
  end;
  local use_sledgehammer_end = function ()
  
    ObjMultiSet({ 
      { "gho_terenceroom_behindmirror",         { input = true, active = true }},
      { "spr_terenceroom_ho_behindmirror_over", { alp = 1 }},
    });

    ObjDelete( "anm_terenceroom_use_sledgehammer" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sledgehammer", use_sledgehammer_beg, private.room_objname );
  cmn.AddSubscriber( "use_sledgehammer", use_sledgehammer_inv );
  cmn.AddSubscriber( "use_sledgehammer", use_sledgehammer_end, private.room_objname );
  cmn.AddSubscriber( "use_sledgehammer_inv", use_sledgehammer_inv, private.room_objname );
  cmn.AddSubscriber( "use_sledgehammer_beg", use_sledgehammer_beg, private.room_objname );
  cmn.AddSubscriber( "use_sledgehammer_end", use_sledgehammer_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_secondfloorbutton () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_secondfloorbutton" ] = {
    type = "click",
    use_place = "obj_doorpanel_clk_secondfloorbutton",
    room = private.room_objname,
    zz = "zz_doorpanel",
    zz_gate = "gzz_terenceroom_doorpanel"
  };
  local clk_secondfloorbutton_beg = function ()
  
    ObjDelete( "obj_doorpanel_clk_secondfloorbutton" );
  
  end;
  local clk_secondfloorbutton_end = function ()
  
    ObjSet( "grm_terenceroom_secondfloor", { input = true, visible = true, active = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_terenceroom_secondfloor_focus");
    end;
    ObjDelete( "gzz_terenceroom_doorpanel" );

    ObjSet( "spr_terenceroom_zz_doorpanel_door_open",             { alp = 1 } );
    ObjSet( "spr_terenceroom_zz_doorpanel_door_panel_greenlight", { alp = 1 } );
    ObjDelete( "spr_terenceroom_zz_doorpanel_door_panel_redlight" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_secondfloorbutton", clk_secondfloorbutton_beg, private.room_objname );
  cmn.AddSubscriber( "clk_secondfloorbutton", clk_secondfloorbutton_end, private.room_objname );
  cmn.AddSubscriber( "clk_secondfloorbutton_beg", clk_secondfloorbutton_beg, private.room_objname );
  cmn.AddSubscriber( "clk_secondfloorbutton_end", clk_secondfloorbutton_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_pillow () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_pillow" ] = {
    type = "click",
    use_place = "obj_bed_clk_pillow",
    room = private.room_objname,
    zz = "zz_bed",
    zz_gate = "gzz_terenceroom_bed"
  };
  local clk_pillow_beg = function ()
  
    ObjDelete( "obj_bed_clk_pillow" );
  
  end;
  local clk_pillow_end = function ()
  
    ObjSet( "obj_bed_pillow_open",      { input = true, alp = 1 } );
    ObjSet( "obj_bed_clk_photobox",     { input = true } );
    ObjSet( "spr_terenceroom_zz_bed_1", { alp = 1 } );

    ObjDelete( "obj_bed_pillow_closed" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_pillow", clk_pillow_beg, private.room_objname );
  cmn.AddSubscriber( "clk_pillow", clk_pillow_end, private.room_objname );
  cmn.AddSubscriber( "clk_pillow_beg", clk_pillow_beg, private.room_objname );
  cmn.AddSubscriber( "clk_pillow_end", clk_pillow_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_photobox () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_photobox" ] = {
    type = "click",
    use_place = "obj_bed_clk_photobox",
    room = private.room_objname,
    zz = "zz_bed",
    zz_gate = "gzz_terenceroom_bed"
  };
  local clk_photobox_beg = function ()
  
    ObjDelete( "obj_bed_clk_photobox" );
  
  end;
  local clk_photobox_end = function ()
  
    ObjMultiSet({ 
      { "obj_bed_box",              { input = true, pos_x = 0, pos_y = 0, pos_z = 12 }},
      { "obj_bed_use_photopart1",   { input = true }},  
      { "obj_bed_use_photopart2",   { input = true }},
      { "spr_terenceroom_zz_bed_3", { alp = 1      }},
      { "spr_terenceroom_zz_bed_4", { alp = 1      }},
      { "spr_terenceroom_zz_bed_5", { alp = 1      }},  
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_photobox", clk_photobox_beg, private.room_objname );
  cmn.AddSubscriber( "clk_photobox", clk_photobox_end, private.room_objname );
  cmn.AddSubscriber( "clk_photobox_beg", clk_photobox_beg, private.room_objname );
  cmn.AddSubscriber( "clk_photobox_end", clk_photobox_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_showerroom () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_showerroom" ] = {
    type = "click",
    use_place = "obj_showerroom_mmg_drag_1",
    room = private.room_objname,
    zz = "zz_showerroom",
    zz_gate = "gzz_terenceroom_showerroom"
  };
  local win_showerroom = function ()
  
    if ( cmn.IsEventDone( "win_showerroom" ) ) then

      ObjSet( "spr_showerroom_code2",       { input = true } );
      ObjSet( "spr_terenceroom_zz_showerroom_1", { alp = 1 } );

      ObjDelete( "spr_terenceroom_zz_showerroom_2" );

      ObjDelete( "obj_showerroom_mmg_drag" );
      ObjDelete( "spr_showerroom_mmg_cover" );
      ObjDelete( "spr_showerroom_mmg_cover_over" );

    end;

    for i = 1, 4 do

      local ang = -1.55;
      if ( ng_global.progress.std.win_showerroom.state ) then
        ang = ng_global.progress.std.win_showerroom.state.arrows[ i ];
      end

      ObjSet( "spr_showerroom_arrow_"..i, { ang = ang } );

    end;
    
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_showerroom", win_showerroom, private.room_objname );


  --------------------------------------------------------------------------------------------
  -- function clk_drawerkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_drawerkey" ] = {
    type = "click",
    use_place = "obj_medicinecabinet_clk_drawerkey",
    room = private.room_objname,
    zz = "zz_medicinecabinet",
    zz_gate = "gzz_terenceroom_medicinecabinet"
  };
  local clk_drawerkey_beg = function ()
  
    ObjDelete( "obj_medicinecabinet_clk_drawerkey" );
  
  end;
  local clk_drawerkey_end = function ()

    ObjMultiSet({ 
      { "spr_medicinecabinet_cover_1_open",  { alp = 1                     }},
      { "spr_medicinecabinet_tap",           { active = true, input = true }},
 
      { "spr_terenceroom_zz_medicinecabinet_valve", { alp = 1              }}, 
    });

    ObjDelete( "spr_medicinecabinet_key_1"   );
    ObjDelete( "spr_medicinecabinet_key"     );
    ObjDelete( "spr_medicinecabinet_cover_1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_drawerkey",     clk_drawerkey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_drawerkey",     clk_drawerkey_end, private.room_objname );
  cmn.AddSubscriber( "clk_drawerkey_beg", clk_drawerkey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_drawerkey_end", clk_drawerkey_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_tieclip () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_tieclip" ] = {
    type = "click",
    use_place = "obj_medicinecabinet_clk_tieclip",
    room = private.room_objname,
    zz = "zz_medicinecabinet",
    zz_gate = "gzz_terenceroom_medicinecabinet"
  };
  local clk_tieclip_beg = function ()
  
    ObjDelete( "obj_medicinecabinet_clk_tieclip" );
  
  end;
  local clk_tieclip_end = function ()

    ObjMultiSet({ 
      { "spr_medicinecabinet_cover_2_open", { alp = 1                     }},
      { "spr_medicinecabinet_oilcan",       { input = true, active = true }},

      { "spr_terenceroom_zz_medicinecabinet_cover_1_open", { alp = 1      }},
      { "spr_terenceroom_zz_medicinecabinet_olier",        { alp = 1      }},
    });

    ObjDelete( "spr_medicinecabinet_clip"    );
    ObjDelete( "spr_medicinecabinet_clip_1"  );
    ObjDelete( "spr_medicinecabinet_cover_2" );

    ObjDelete( "spr_terenceroom_zz_medicinecabinet_cover_1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_tieclip",     clk_tieclip_beg, private.room_objname );
  cmn.AddSubscriber( "clk_tieclip",     clk_tieclip_end, private.room_objname );
  cmn.AddSubscriber( "clk_tieclip_beg", clk_tieclip_beg, private.room_objname );
  cmn.AddSubscriber( "clk_tieclip_end", clk_tieclip_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_terenceroom_folder () end;
  --------------------------------------------------------------------------------------------

  local clk_terenceroom_folder = function ()

    ObjSet( "obj_terenceroom_folder", { event_mdown = function () cmn.NoteScale( "obj_terenceroom_folder", "spr_terenceroom_folder_open" ) end } );
    ObjDelete( "spr_terenceroom_folder_close" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_terenceroom_folder",     clk_terenceroom_folder, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function see_scare_terenceroom_1 () end;
  --------------------------------------------------------------------------------------------
  local see_scare_terenceroom_1 = function ()

  end;

  cmn.AddSubscriber( "see_scare_terenceroom_1", see_scare_terenceroom_1, private.room_objname );

end;

--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()

  --*********************************************************************************************************************
  -- function zz_doorpanel() end 
    subroom.Define( "zz_doorpanel" );
    function zz_doorpanel.Open ()

      --

    end;  
    -------------------------------------------------
    function zz_doorpanel.PreOpen ()   

    end;  
    -------------------------------------------------
    function zz_doorpanel.PreClose ()

      --

    end; 
    ------------------------------------------------- 
    function zz_doorpanel.Close ()
        
      if ( cmn.IsEventDone( "get_hook_lvl3" ) and ( not cmn.IsEventDone( "see_scare_terenceroom_1" ) ) ) then 

        private.TerenceroomScare_1(); 

      end;
     
    end;

  --*********************************************************************************************************************
  -- function zz_bed() end зз стена со светильником
    subroom.Define( "zz_bed" );
    function zz_bed.Open ()

      --

    end;  
    -------------------------------------------------
    function zz_bed.PreOpen ()   

    end;  
    -------------------------------------------------
    function zz_bed.PreClose ()

      --

    end; 
    ------------------------------------------------- 
    function zz_bed.Close ()
        
      cmn.NoteScaleClose( { "spr_bed_paper" }, { "spr_bed_paper_big" } );
     
    end;

  --*********************************************************************************************************************
  -- function zz_showerroom() end зз стена со светильником
    subroom.Define( "zz_showerroom" );
    function zz_showerroom.Open ()

      if ( cmn.IsEventDone( "use_tap" ) and ( not cmn.IsEventDone( "win_showerroom" ) ) ) then

        cmn.MiniGameShow( "showerroom" );
        common_impl.PassingMgStart( "showerroom" );

      end;

    end;  
    -------------------------------------------------
    function zz_showerroom.PreOpen ()
    end;  
    -------------------------------------------------
    function zz_showerroom.PreClose ()

      if ( cmn.IsEventDone( "use_tap" ) and ( not cmn.IsEventDone( "win_showerroom" ) ) ) then

        cmn.MiniGameHide( "showerroom" );
        common_impl.PassingMgStop( "showerroom" );

      end;

    end; 
    ------------------------------------------------- 
    function zz_showerroom.Close ()
        
      cmn.NoteScaleClose( { "spr_showerroom_paper" }, { "spr_showerroom_paper_big" } );
     
    end;
    -------------------------------------------------
    function zz_showerroom.Reset ()

      private.start_values = { -0.17,-4, -4, 0.92 };

      for i = 1, 4 do

        ObjSet( "spr_showerroom_valve_"..i, { ang = 0 } );
        ObjSet( "spr_showerroom_arrow_"..i, { ang = private.start_values[ i ] } );

      end;

    end;
    -------------------------------------------------
    function zz_showerroom.Skip ()

      local func_end = function () end;

      for i = 1, 4 do

        if ( i == 4 ) then

          func_end = function () private.ShowerroomWin(); end;

        end;

        ObjAnimate( "spr_showerroom_arrow_"..i, "ang", 0, 0, func_end, 
        { 
          0.0, 0, ObjGet( "spr_showerroom_arrow_"..i ).ang, 
          0.3, 0, -1.535 
        } );

        ng_global.progress.std.win_showerroom.state.arrows[ i ] = -1.53;

      end;

    end;

  --*********************************************************************************************************************
  -- function zz_medicinecabinet() end зз стена со светильником
    subroom.Define( "zz_medicinecabinet" );
    function zz_medicinecabinet.Open ()

    end;
    -------------------------------------------------
    function zz_medicinecabinet.PreOpen ()

      if ( not cmn.IsEventDone( "use_mechanismpart" ) ) then

        ObjAnimate( "spr_medicinecabinet_red_light", "alp", 1, 0, "", 
        { 
          0.0, 0, 1,
          1.3, 0, 0, 
          2.6, 0, 1, 
        } );

      else

        ObjAnimate( "spr_medicinecabinet_green_light", "alp", 1, 0, "", 
        { 
          0.0, 0, 1,
          1.3, 0, 0, 
          2.6, 0, 1, 
        } );

      end;

    end;
    -------------------------------------------------
    function zz_medicinecabinet.PreClose ()

    end;
    -------------------------------------------------
    function zz_medicinecabinet.Close ()

      if ( cmn.IsEventDone( "use_mechanismpart" ) ) then

        cmn.NoteScaleClose( { "spr_medicinecabinet_note" }, { "spr_medicinecabinet_note_big" } );

      end;

    end;
    -------------------------------------------------

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_terenceroom();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

  if ( cmn.IsEventDone( "get_scissors" ) and ( not cmn.IsEventDone( "see_terenceroom_mirror" ) ) ) then

    private.see_terenceroom_mirror();

  end;
-----------------------------------------------
  if ( cmn.IsEventDone( "get_hook_lvl3" ) and ( not cmn.IsEventDone( "see_scare_terenceroom_1" ) ) ) then

    private.TerenceroomScare_1(); 

  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();

  common_impl.EnvPlay( { "level2/env/aud_lab_env" }, "", 0.5 );

  if ( not cmn.IsEventDone( "use_mechanismpart" ) ) then

    ObjAnimate( "spr_terenceroom_medikalcabinet_red_light", "alp", 1, 0, "", 
    { 
      0.0, 0, 1,
      1.3, 0, 0, 
      2.6, 0, 1, 
    } );

  else

    ObjAnimate( "spr_terenceroom_medikalcabinet_green_light", "alp", 1, 0, "", 
    { 
      0.0, 0, 1,
      1.3, 0, 0, 
      2.6, 0, 1, 
    } );

  end;

end;
--*********************************************************************************************************************
function public.Close ()

  local spr_big = "spr_terenceroom_folder_close";

  if cmn.IsEventDone( "clk_terenceroom_folder" ) then

    spr_big = "spr_terenceroom_folder_open";

  end;

  cmn.NoteScaleClose( { "obj_terenceroom_folder" }, { spr_big } );

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_secondfloorbutton ()

  local item = "inv_secondfloorbutton";

  if cmn.ApplyObj( item, "gzz_terenceroom_doorpanel" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_doorpanel", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_doorpanel_use_secondfloorbutton" ) ) then

    cmn.CallEventHandler( "use_secondfloorbutton_inv" );
    cmn.CallEventHandler( "use_secondfloorbutton_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_secondfloorbutton" );
      cmn.CallEventHandler( "use_secondfloorbutton_end" );
     -- common.CloseSubRoom();

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_button2", 0, "", 0 );

  cmn.ItemFly( "spr_doorpanel_button", func_end );
  
  return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_photopart1 ()

  local item = "inv_photopart1";

  if cmn.ApplyObj( item, "gzz_terenceroom_bed" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bed", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_bed_use_photopart1" ) ) then

    cmn.CallEventHandler( "use_photopart1_inv" );
    cmn.CallEventHandler( "use_photopart1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );

      cmn.SetEventDone( "use_photopart1" );
      cmn.CallEventHandler( "use_photopart1_end" );

    end;

    local func_continue = function ()

      if ( cmn.IsEventDone( "use_photopart2" ) ) then

        common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide1", 0, "", 0 );

        ObjAnimate( "spr_bed_box_cover", "pos_xy", 0, 0, func_end, 
        { 
          0.0, 2, ObjGet( "spr_bed_box_cover" ).pos_x, ObjGet( "spr_bed_box_cover" ).pos_y,
          0.3, 2, -128, 55
        } );
        ObjAnimate( "spr_bed_cover_shadow", "alp", 0, 0, "", 
        { 
          0.0, 0, ObjGet( "spr_bed_cover_shadow" ).alp,
          0.3, 0, 0
        } );

      else

        func_end();

      end;

    end;

    cmn.Lock( true );

    cmn.ItemFly( "spr_bed_photo_lft", func_continue, 0 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_photopart2 ()

  local item = "inv_photopart2";

  if cmn.ApplyObj( item, "gzz_terenceroom_bed" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bed", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_bed_use_photopart2" ) ) then

    cmn.CallEventHandler( "use_photopart2_inv" );
    cmn.CallEventHandler( "use_photopart2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );

      cmn.SetEventDone( "use_photopart2" );
      cmn.CallEventHandler( "use_photopart2_end" );

    end;

    local func_continue = function ()

      if ( cmn.IsEventDone( "use_photopart1" ) ) then

        common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide1", 0, "", 0 );

        ObjAnimate( "spr_bed_box_cover", "pos_xy", 0, 0, func_end, 
        { 
          0.0, 2, ObjGet( "spr_bed_box_cover" ).pos_x, ObjGet( "spr_bed_box_cover" ).pos_y,
          0.6, 2, -128, 55
        } );
        ObjAnimate( "spr_bed_cover_shadow", "alp", 0, 0, "", 
        { 
          0.0, 0, ObjGet( "spr_bed_cover_shadow" ).alp,
          0.3, 0, 0
        } );

      else

        func_end();

      end;

    end;

    cmn.Lock( true );

    cmn.ItemFly( "spr_bed_photo_rgt", func_continue, 0 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_hook_lvl3 ()

  local item = "inv_hook_lvl3";

  if cmn.ApplyObj( item, "gzz_terenceroom_bed" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bed", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_bed_use_hook" ) ) then

    cmn.CallEventHandler( "use_hook_lvl3_inv" );
    cmn.CallEventHandler( "use_hook_lvl3_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_hook_lvl3" );
      cmn.CallEventHandler( "use_hook_lvl3_end" );

      private.get_terencetie();

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_hook", 0, "", 0 );

    ObjSet( "anm_bed_use_hook", { alp = 1 } );
    AnimPlay( "anm_bed_use_hook", "DoAnim", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_scissors ()

  local item = "inv_scissors";

  if cmn.ApplyObj( item, "gzz_terenceroom_bed" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bed", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_bed_use_scissors" ) ) then

    cmn.CallEventHandler( "use_scissors_inv" );
    cmn.CallEventHandler( "use_scissors_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_scissors" );
      cmn.CallEventHandler( "use_scissors_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_scissors", 0, "", 0 );

    ObjSet( "vid_bed_scissors", { alp = 1 } );
    VidPlay( "vid_bed_scissors", func_end )
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_tieclip ()

  local item = "inv_tieclip";

  if cmn.ApplyObj( item, "gzz_terenceroom_medicinecabinet" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_medicinecabinet", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_medicinecabinet_use_tieclip" ) ) then

    cmn.CallEventHandler( "use_tieclip_inv" );
    cmn.CallEventHandler( "use_tieclip_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_tieclip" );
      cmn.CallEventHandler( "use_tieclip_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

  ObjAnimate( "spr_medicinecabinet_clip", "alp", 0, 0, func_end, 
  { 
    0.0, 0, 0, 
    0.3, 0, 1,
  } );  

  return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_drawerkey ()

  local item = "inv_drawerkey";

  if cmn.ApplyObj( item, "gzz_terenceroom_medicinecabinet" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_medicinecabinet", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_medicinecabinet_use_drawerkey" ) ) then

    cmn.CallEventHandler( "use_drawerkey_inv" );
    cmn.CallEventHandler( "use_drawerkey_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_drawerkey" );
      cmn.CallEventHandler( "use_drawerkey_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_key_use", 0, "", 0 );

  ObjAnimate( "spr_medicinecabinet_key_1", "alp", 0, 0, func_end, 
  { 
    0.0, 0, 0, 
    0.3, 0, 1,
  } );

  return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_mechanismpart ()

  local item = "inv_mechanismpart";

  if cmn.ApplyObj( item, "gzz_terenceroom_medicinecabinet" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_medicinecabinet", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_medicinecabinet_use_mechanismpart" ) ) then

    cmn.CallEventHandler( "use_mechanismpart_inv" );
    cmn.CallEventHandler( "use_mechanismpart_beg" );

    local func_anim = function ()

      local func_end = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_mechanismpart" );
        cmn.CallEventHandler( "use_mechanismpart_end" );

      end;

      ObjSet( "spr_medicinecabinet_cover_3", { alp = 0 } );
      VidPlay( "vid_medicinecabinet_mechanism", func_end );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_mechanismpart", 0, "", 0 );

    ObjAnimate( "vid_medicinecabinet_mechanism", "alp", 0, 0, func_anim, { 0, 0, 0,   0.3, 0, 1 } );  

    ObjAnimate( "spr_medicinecabinet_red_light", "alp", 0, 0, "", 
    { 
      0.0, 0, ObjGet( "spr_medicinecabinet_red_light" ).alp, 
      0.3, 0, 0,
    } );
    ObjAnimate( "spr_medicinecabinet_green_light", "alp", 1, 0, "", 
    { 
      0.0, 0, 0,
      1.3, 0, 1, 
      2.6, 0, 0, 
    } );

    ObjAnimate( "spr_terenceroom_medikalcabinet_green_light", "alp", 1, 0, "", 
    { 
      0.0, 0, 1,
      1.3, 0, 0, 
      2.6, 0, 1, 
    } );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_tile ()

  local item = "inv_tile";

  if cmn.ApplyObj( item, "gzz_terenceroom_showerroom" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_showerroom", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_showerroom_use_tile" ) ) then

    cmn.CallEventHandler( "use_tile_inv" );
    cmn.CallEventHandler( "use_tile_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_tile" );
      cmn.CallEventHandler( "use_tile_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide1", 0, "", 0 );

    local func_continue = function ( )

      ObjDelete( "spr_showerroom_hole" );
      ObjAnimate( "spr_showerroom_tile", "pos_x", 0, 0, func_end, { 0, 0, 6, 0.4, 3, 200 } );

    end;

    cmn.ItemFly( "spr_showerroom_tile", func_continue );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_oilcan ()

  local item = "inv_oilcan";

  if cmn.ApplyObj( item, "gzz_terenceroom_showerroom" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_showerroom", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_showerroom_use_oilcan" ) ) then

    cmn.CallEventHandler( "use_oilcan_inv" );
    cmn.CallEventHandler( "use_oilcan_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_oilcan" );
      cmn.CallEventHandler( "use_oilcan_end" );

    end;

    local func_continue = function ()

      ObjSet( "vid_showerroom_use_oiler", { alp = 0 } )

      ObjAnimate( "spr_showerroom_valve_2", "ang", 0, 0, "", 
      {
        0.0, 0, 0,
        0.1, 0, 0,
        0.2, 0, 0.4,
        0.3, 0, 0  
      } );

      AnimPlay( "anm_showerroom_bronze_amulet", "DoAnim", func_end );
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_oil", 0, "", 0 );

    ObjAnimate( "spr_showerroom_valve_2", "alp", 0, 0, "", { 0, 0, 0, 2, 0, 0, 5, 0, 1 } );
    VidPlay( "vid_showerroom_use_oiler", func_continue )    

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_tap ()

  local item = "inv_tap";

  if cmn.ApplyObj( item, "gzz_terenceroom_showerroom" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_showerroom", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_showerroom_use_tap" ) ) then

    cmn.CallEventHandler( "use_tap_inv" );
    cmn.CallEventHandler( "use_tap_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_tap" );
      cmn.CallEventHandler( "use_tap_end" );

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk7", 0, "", 0 );

      ng_global.progress.std.win_showerroom.state = {};
      ng_global.progress.std.win_showerroom.state.arrows = {};
      ng_global.progress.std.win_showerroom.state.valves = {};

      for i = 1, 4 do

        ng_global.progress.std.win_showerroom.state.valves[ i ] = ObjGet( "spr_showerroom_valve_"..i ).ang;
        ng_global.progress.std.win_showerroom.state.arrows[ i ] = ObjGet( "spr_showerroom_arrow_"..i ).ang;

      end;

      cmn.MiniGameShow( "showerroom" );
      common_impl.PassingMgStart( "showerroom" );

    end;

    cmn.Lock( true );

    cmn.ItemFly( "spr_showerroom_valve_4_add", func_end, 0.3 );
  
  return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_sledgehammer ()

  local item = "inv_sledgehammer";

  if ( cmn.ApplyObj( item, "obj_terenceroom_use_sledgehammer" ) ) then

    cmn.CallEventHandler( "use_sledgehammer_inv" );
    cmn.CallEventHandler( "use_sledgehammer_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_sledgehammer" );
      cmn.CallEventHandler( "use_sledgehammer_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_sledge", 0, "", 0 );

    AnimPlay( "anm_terenceroom_use_sledgehammer", "anim_sledgehammer", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_hook_lvl3 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_hook_lvl3" );
  cmn.CallEventHandler( "get_hook_lvl3" );

end;
--------------------------------------------------------------------------------------------
function private.get_terencetie ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_terencetie" );
  cmn.CallEventHandler( "get_terencetie" );

end;
--------------------------------------------------------------------------------------------
function private.get_terencediary ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_terencediary" );
  cmn.CallEventHandler( "get_terencediary" );

end;
--------------------------------------------------------------------------------------------
function private.get_tile ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_tile" );
  cmn.CallEventHandler( "get_tile" );

end;
--------------------------------------------------------------------------------------------
function private.get_scissors ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_scissors" );
  cmn.CallEventHandler( "get_scissors" );

end;
--------------------------------------------------------------------------------------------
function private.get_oilcan ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_oilcan" );
  cmn.CallEventHandler( "get_oilcan" );

end;
--------------------------------------------------------------------------------------------
function private.get_tap ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_tap" );
  cmn.CallEventHandler( "get_tap" );
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_bronzeamulet ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_bronzeamulet" );
  cmn.CallEventHandler( "get_bronzeamulet" );

end;
--------------------------------------------------------------------------------------------
function private.get_code2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_code2" );
  cmn.CallEventHandler( "get_code2" );

end;
--------------------------------------------------------------------------------------------
function private.get_tweezers ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_tweezers" );
  cmn.CallEventHandler( "get_tweezers" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_3_2 ()

  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_3_2" ); 

  end;

  common_impl.PlayEffectHO( "spr_collect2_item_3_2", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_3_2" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_secondfloorbutton ()

  cmn.CallEventHandler( "clk_secondfloorbutton_beg" );

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "clk_secondfloorbutton" );
    cmn.CallEventHandler( "clk_secondfloorbutton_end" );
    common.CloseSubRoom();

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_clk_button2", 0, "", 0 );

  ObjAnimate( "spr_doorpanel_button", "pos_x", 0, 0, "", { 0, 0, -36, 0.3, 0, -41 } );

  ObjAnimate( "spr_doorpanel_light_red",   "alp", 0, 0, "", { 0, 0, 1, 0.4, 0, 1, 0.7, 0, 0 } );
  ObjAnimate( "spr_doorpanel_light_green", "alp", 0, 0, "", { 0, 0, 0, 0.4, 0, 0, 0.7, 0, 1 } );

  ObjAnimate( "spr_doorpanel_door_open", "alp", 0, 0, func_end, { 0, 0, 0, 0.7, 0, 0, 1.0, 0, 1, 1.5, 0, 1 } );
    
end;
--------------------------------------------------------------------------------------------
function private.clk_pillow ()

  cmn.CallEventHandler( "clk_pillow_beg" );

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "clk_pillow" );
    cmn.CallEventHandler( "clk_pillow_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_cloth1", 0, "", 0 );

  ObjAnimate( "obj_bed_pillow_open", "alp", 0, 0, func_end, { 0, 0, 0, 0.3, 0, 1 } );
  ObjAnimate( "obj_bed_pillow_closed", "alp", 0, 0, "", { 0, 0, 1, 0.3, 0, 0 } );

    
end;
--------------------------------------------------------------------------------------------
function private.clk_photobox ()

  cmn.CallEventHandler( "clk_photobox_beg" );

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "clk_photobox" );
    cmn.CallEventHandler( "clk_photobox_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_clk_pillow", 0, "", 0 );

  ObjAnimate( "obj_bed_box", "pos_z", 0, 0, "", { 0, 0, 0, 0.3, 0, 12 } );
  ObjAnimate( "obj_bed_box", "pos_xy", 0, 0, func_end, { 0, 0, 221, -167, 0.3, 0, 221, -167, 0.6, 0, 0, 0 } );

    
end;
--------------------------------------------------------------------------------------------
function private.clk_drawerkey ()

  cmn.CallEventHandler( "clk_drawerkey_beg" );

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "clk_drawerkey" );
    cmn.CallEventHandler( "clk_drawerkey_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_clk_key", 0, "", 0 );

  ObjAnimate( "spr_medicinecabinet_key_1", "alp", 0, 0, "", 
  { 
    0.0, 0, 1, 
    0.3, 0, 0 
  });
  ObjAnimate( "spr_medicinecabinet_key", "alp", 0, 0, "", 
  { 
    0.0, 0, 0, 
    0.3, 0, 1,
    0.6, 0, 0, 
  });
  ObjAnimate( "spr_medicinecabinet_cover_1", "alp", 0, 0, "", 
  { 
    0.0, 0, 1, 
    0.3, 0, 1,
    0.6, 0, 0, 
  });
  ObjAnimate( "spr_medicinecabinet_cover_1_open", "alp", 0, 0, func_end, 
  { 
    0.0, 0, 0, 
    0.3, 0, 0,
    0.6, 0, 1, 
  });
    
end;
--------------------------------------------------------------------------------------------
function private.clk_tieclip ()

  cmn.CallEventHandler( "clk_tieclip_beg" );

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "clk_tieclip" );
    cmn.CallEventHandler( "clk_tieclip_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_open", 0, "", 0 );

  ObjAnimate( "spr_medicinecabinet_clip", "alp", 0, 0, "", 
  { 
    0.0, 0, 1, 
    0.3, 0, 0 
  });
  ObjAnimate( "spr_medicinecabinet_clip_1", "alp", 0, 0, "", 
  { 
    0.0, 0, 0, 
    0.3, 0, 1,
    0.6, 0, 0, 
  });
  ObjAnimate( "spr_medicinecabinet_cover_2", "alp", 0, 0, "", 
  { 
    0.0, 0, 1, 
    0.3, 0, 1,
    0.6, 0, 0, 
  });
  ObjAnimate( "spr_medicinecabinet_cover_2_open", "alp", 0, 0, func_end, 
  { 
    0.0, 0, 0, 
    0.3, 0, 0,
    0.6, 0, 1, 
  });
    
end;

--------------------------------------------------------------------------------------------
function private.clk_terenceroom_folder ()

  local func_end = function ()

    ObjSet( "spr_terenceroom_folder_open", { input = true } );

    cmn.Lock( false );

    cmn.SetEventDone( "clk_terenceroom_folder" );
    cmn.CallEventHandler( "clk_terenceroom_folder" );

  end;

  cmn.Lock( true );

  ObjAnimate( "spr_terenceroom_folder_open", "alp", 0, 0, func_end, { 0, 0, 0,   0.3, 0, 1 } );

end;


--*********************************************************************************************************************
-- function *** HORRORS *** () end;
--*********************************************************************************************************************

function private.TerenceroomScare_1 () 

  local func_end = function ()

    cmn.SetEventDone( "see_scare_terenceroom_1" );
    cmn.CallEventHandler( "see_scare_terenceroom_1" );

    common_impl.StopAudio( "sfx", "level3/sfx/aud_see_scare_terenceroom_1", 0.2 );

    common_impl.ShowBbt( "bbt_terenceroom_scare_terenceroom_1" ); 

  end;

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_terenceroom_scare_1", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_terenceroom_scare_1", func_end ); 
  
end;


--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_terenceroom ()

  if not ( cmn.IsEventDone( "opn_terenceroom" ) ) then

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "opn_terenceroom" );
      cmn.CallEventHandler( "opn_terenceroom" );

      common_impl.ShowBbt( "bbt_terenceroom_opn_terenceroom" );

      interface.KeyTaskDone( true );
      interface.KeyTaskAdd( "get_out_hotel_room" );
    
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_collapse", 0, "", 0 );

    AnimPlay( "anm_terenceroom_collapse", "DoAnim", func_end );

  else

    cmn.CallEventHandler( "opn_terenceroom" );

  end;

end;
--------------------------------------------------------------------------------------------
function private.see_terenceroom_mirror ()

  local func_end = function ()

    cmn.SetEventDone( "see_terenceroom_mirror" );
    cmn.CallEventHandler( "see_terenceroom_mirror" );

    common_impl.ShowBbt( "bbt_terenceroom_mirror" );  

    common_impl.PlayAudio( "mus", "aud_danger2_mus",           0, "", 0 );

  end;

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_creak_mirror", 0, "", 0 );
  ObjSet( "anm_terenceroom_light_glass", { alp = 0 });
  cmn.PlayDialogVideo( "vid_terenceroom_crack_glass", func_end );

end;
--------------------------------------------------------------------------------------------
function private.MedicinecabinetClkNote ()

  cmn.NoteScale( "spr_medicinecabinet_note" );

end;
--------------------------------------------------------------------------------------------
function private.MedicinecabinetClkNoteClose ()

  cmn.NoteScale( "spr_medicinecabinet_note" );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function private.BedClkPaperOpen ()

  cmn.NoteScale( "spr_bed_paper" );

end;
--------------------------------------------------------------------------------------------
function private.BedClkPaperClose ()

  cmn.NoteScale( "spr_bed_paper" );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function private.ShowerroomClkPaperOpen ()

  cmn.NoteScale( "spr_showerroom_paper" );

end;
--------------------------------------------------------------------------------------------
function private.ShowerroomClkPaperClose ()

  cmn.NoteScale( "spr_showerroom_paper" );

end;
--------------------------------------------------------------------------------------------
function private.ShowerroomMmgInit ()

  private.pos = {};
  private.array = 
  { 
    { { 1, 0.5 }, { 2, -0.3 } }, 
    { { 3, 0.5 }, { 4, -0.4 } }, 
    { { 1, 1.0 }, { 4, -1.0 } }, 
    { { 2, 0.3 }, { 3, -0.5 } } 
  };
  
  for i = 1, 4 do

    ObjSet( "obj_showerroom_mmg_drag_"..i,
    {
      drag = true, realdrag = true,
      event_startdrag = function () private.ShowerroomStartDragValve( i )  end,
      event_drag = function () private.ShowerroomDragValve( i ) end,
      event_dragdrop = function () private.ShowerroomDragDropValve( i ) end,
      event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end
    } )

    private.pos[ i ] = ObjGet( "spr_showerroom_valve_"..i );

  end;

  --------------------------------------------------------------------------------------------

  function private.ShowerroomStartDragValve ( i ) 

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_clk_valve", 1, "", 0 );

    private.coords_begin = GetZoomCursorPos();
    private.coords_begin = { private.coords_begin[ 1 ] - 512, private.coords_begin[ 2 ] - 360 };
    private.dragobj_coords = { private.pos[ i ].pos_x, private.pos[ i ].pos_y };

    private.ang_valve = ObjGet( "spr_showerroom_valve_"..i ).ang;
    private.ang_old   = math.atan2( private.coords_begin[ 1 ] - private.dragobj_coords[ 1 ], private.coords_begin[ 2 ] - private.dragobj_coords[ 2 ] );

  end;

  --------------------------------------------------------------------------------------------

  function private.ShowerroomDragValve ( i ) 

    local cur_pos = GetZoomCursorPos();
    
    if port.isPortable() == 1 then
      if tostring(GetPlatform()) == "ios" and port.isTablet() == 0 then
        cur_pos[2] = cur_pos[2] + 75;
      else
        cur_pos[2] = cur_pos[2] + 50;
      end;
    end;
    
    cur_pos = { cur_pos[ 1 ] - 512, cur_pos[ 2 ] - 360 }; 

    if ( private.coords_begin[ 1 ] ~= cur_pos[ 1 ] ) or ( private.coords_begin[ 2 ] ~= cur_pos[ 2 ] ) then

      local new_ang = math.atan2( cur_pos[1] - private.dragobj_coords[ 1 ], cur_pos[2] - private.dragobj_coords[ 2 ] );
      local diff = new_ang - private.ang_old;

      ObjSet( "spr_showerroom_valve_"..i, { ang = private.ang_valve + diff } ); 

      private.ang_old = new_ang;  
      private.coords_begin = { cur_pos[ 1 ], cur_pos[ 2 ] };
      private.ang_valve = private.ang_valve + diff;

      private.ChangeArrows( i, diff );

    end;

  end;
  --------------------------------------------------------------------------------------------

  function private.ShowerroomDragDropValve ( i ) 

    common_impl.StopAudio( "sfx", "level3/sfx/aud_clk_valve", 0.2 );

    local this_array = private.array[ i ];

    for j = 1,2 do

      local ang = ObjGet( "spr_showerroom_arrow_"..private.array[i][j][1] ).ang;

      if ( ang < - 1.68 ) or ( ang > - 1.38 ) then
      else
        common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_button2", 0, "", 0 );
      end;    

    end;

  end;
  --------------------------------------------------------------------------------------------

  function private.ChangeArrows ( v, diff )

    local this_array = private.array[ v ];

    if ( diff > math.pi ) then diff = diff - math.pi*2 end;
    if ( diff < - math.pi ) then diff = diff + math.pi*2 end;

    for i = 1, #this_array do

      local ang = ObjGet( "spr_showerroom_arrow_"..this_array[ i ][ 1 ] ).ang + diff * this_array[ i ][ 2 ];
      if ( ang > -4 ) and ( ang < 0.92 ) then
        ObjSet( "spr_showerroom_arrow_"..this_array[ i ][ 1 ], { ang = ang } );
      end;

    end;

    if ( private.ShowerroomIsWin() ) then

      private.ShowerroomWin( v );

    else

      private.ShowerroomSaveVar();

    end;  

  end;

  --------------------------------------------------------------------------------------------
  function private.ShowerroomIsWin ()

    local flag = true;

    for i = 1, 4 do

      local ang = ObjGet( "spr_showerroom_arrow_"..i ).ang;
      if ( ang < - 1.68 ) or ( ang > - 1.38 ) then
        flag = false;
      end;
 
    end;

    return flag;

  end;
  --------------------------------------------------------------------------------------------
  function private.ShowerroomSaveVar ()

    for i = 1, 4 do

      ng_global.progress.std.win_showerroom.state.valves[ i ] = ObjGet( "spr_showerroom_valve_"..i ).ang;
      ng_global.progress.std.win_showerroom.state.arrows[ i ] = ObjGet( "spr_showerroom_arrow_"..i ).ang;

    end;

  end;
  --------------------------------------------------------------------------------------------
  function private.ShowerroomWin ( i )

    cmn.Lock( true );
    
    local func_end = function ()

      cmn.Lock( false );

      cmn.MiniGameHide( "showerroom" );
      common_impl.PassingMgWin( "showerroom" );

      cmn.SetEventDone( "win_showerroom" );
      cmn.CallEventHandler( "win_showerroom" );

    end;

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide1", 0, "", 0 );

    if ( i ) then
      ObjStopDrag( "obj_showerroom_mmg_drag_"..i );
    end;
    ObjAnimate( "spr_showerroom_mmg_cover", "pos_x", 0, 0, func_end, { 0, 0, 226, 0.4, 3, 326 } );
 
  end;
  --------------------------------------------------------------------------------------------

end;

--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************

--spr_terenceroom_medikalcabinet_red_light

function private.AnimCoverTieclip ()

  cmn.Lock( true );

  common_impl.ShowBbt( 'bbt_medicinecabinet_use_tieclip' );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_door", 0, "", 0 );

  ObjAnimate( "spr_medicinecabinet_cover_2", "pos_xy", 0, 0, function() cmn.Lock( false ); end, 
  { 
    0.0, 0, 43, -46, 
    0.3, 0, 46, -46, 
    0.6, 0, 43, -46, 
  } );

end;
--------------------------------------------------------------------------------------------
function private.AnimTap ()

  local valve = math.random( 3 );

  if not cmn.IsEventDone( "use_oilcan" ) then

    if valve == 2 then

      valve = 3;

    end;

  end;

  cmn.Lock( true );

  common_impl.ShowBbt( 'bbt_showerroom_use_tap' );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

  ObjAnimate( "spr_showerroom_valve_"..valve, "ang", 0, 0, function() cmn.Lock( false ) end, 
  { 
    0.0, 0, 0,
    0.1, 3, -0.02,
    0.3, 3, 0.02,
    0.4, 3, 0
  } );

end;
--------------------------------------------------------------------------------------------
function private.AnimCoverDrawerkey ()

  common_impl.ShowBbt( 'bbt_medicinecabinet_use_drawerkey' );

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk9", 0, "", 0 );

  ObjAnimate( "spr_medicinecabinet_cover_1", "pos_xy", 0, 0, function() cmn.Lock( false ); end, 
  { 
    0.0, 0, 45, -207, 
    0.3, 0, 48, -207, 
    0.6, 0, 45, -207, 
  } );

end;
--------------------------------------------------------------------------------------------
function private.AnimBedClkCushion ()

  local func_end = function ()

    cmn.Lock( false );

  end;

  cmn.Lock( true );

  common_impl.ShowBbt( 'bbt_bed_use_scissors' );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_cloth1", 0, "", 0 );

  ObjAnimate( "spr_bed_cushion", "ang", 0, 0, func_end, 
  { 
    0.0, 0, 0, 
    0.3, 0, -0.01, 
    0.6, 0, 0, 
    0.9, 0, 0.01, 
    1.2, 0, 0, 
  } );

end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_doorpanel_light_all", "alp", 1, 0, "", { 0, 0, 1,   2, 0, 0.6,   4, 0, 1 } );

end;
--*********************************************************************************************************************