-- name=rm_tortureroom
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_tortureroom";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  
  ObjMultiSet( { 
    { "spr_tortureroom_collect_morph_item",           { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_3_3" ); end } },
    { "spr_electricalpanel_handlebox1",               { event_mdown = private.get_handlebox1 } },
    { "spr_electricalpanel_handlebox2",               { event_mdown = private.get_handlebox2 } },
    { "obj_electricalpanel_get_pepper_spray",         { event_mdown = private.get_pepper_spray } },
    { "obj_electricalpanel_clk_outro_2",              { event_mdown = private.clk_outro_2 } },
    { "spr_boxes_cane",                               { event_mdown = private.get_cane } },
    { "spr_boxes_hammerbox",                          { event_mdown = private.get_hammerbox } },
    { "spr_monitorscreen_diod",                       { event_mdown = private.get_diod } },
    { "spr_monitorscreen_levermonitor",               { event_mdown = private.get_levermonitor } },
    { "spr_levers_fuselev",                           { event_mdown = private.get_fuselev } },
    { "spr_boxes_combinationnumbers",                 { event_mdown = private.get_combinationnumbers } },
    { "spr_ventilationbox_emergencyswitch",           { event_mdown = private.get_emergencyswitch } },

    { "spr_boxes_door_1",                             { event_mdown = private.clk_doorbox1           } },
    { "spr_boxes_door_2",                             { event_mdown = private.clk_doorbox2           } },
    { "spr_electricalpanel_lever",                    { event_mdown = private.clk_emergencyswitch           } },
  } );

  for i = 1,6 do
    
    ObjAnimate( "spr_tortureroom_lamp_"..i, "alp", 1, 0, "", { 0,3,0,  0.4,3,1, 0.8,3,0 } );

  end;

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_tortureroom = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "gzz_tortureroom_electricalpanel",
      "gzz_tortureroom_boxes",
      "gzz_tortureroom_levers",
      "gzz_tortureroom_monitorscreen",
      "gzz_tortureroom_ventilationbox",
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_electricalpanel",
      "zz_boxes",
      "zz_levers",
      "zz_monitorscreen",
      "zz_ventilationbox",
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_tortureroom", update_game_mode_tortureroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_tortureroom = function ()

  local effects_table = 
  {
    "obj_tortureroom_anim" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_tortureroom", update_performance_mode_tortureroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_3_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_3_3 = function ()
  
    ObjDelete( "obj_tortureroom_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_3_3", get_collect_morph_item_3_3, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_handlebox1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_handlebox1" ] = {
    type = "get",
    get_obj = "spr_electricalpanel_handlebox1",
    room = private.room_objname,
    zz = "zz_electricalpanel",
    zz_gate = "gzz_tortureroom_electricalpanel"
  };
  
  local get_handlebox1_inv = function ()
  
    interface.InventoryItemAdd( "inv_handlebox1", "spr_electricalpanel_handlebox1" );

  end;
  
  local get_handlebox1_closezz = function ()
  
    ObjDelete( "gfx_electricalpanel_handlebox1" );
    ObjSet( "spr_tortureroom_boxes_light", { alp = 1 } );

  end;
  
  cmn.AddSubscriber( "get_handlebox1", get_handlebox1_inv );
  cmn.AddSubscriber( "get_handlebox1", get_handlebox1_closezz, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_handlebox2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_handlebox2" ] = {
    type = "get",
    get_obj = "spr_electricalpanel_handlebox2",
    room = private.room_objname,
    zz = "zz_electricalpanel",
    zz_gate = "gzz_tortureroom_electricalpanel"
  };
  
  local get_handlebox2_inv = function ()
  
    interface.InventoryItemAdd( "inv_handlebox2", "spr_electricalpanel_handlebox2" );

  end;
  
  local get_handlebox2_closezz = function ()
  
    ObjDelete( "gfx_electricalpanel_handlebox2" );
    ObjSet( "spr_tortureroom_boxes_light", { alp = 1 } );

  end;
  
  cmn.AddSubscriber( "get_handlebox2", get_handlebox2_inv );
  cmn.AddSubscriber( "get_handlebox2", get_handlebox2_closezz, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_cane () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cane" ] = {
    type = "get",
    get_obj = "spr_boxes_cane",
    room = private.room_objname,
    zz = "zz_boxes",
    zz_gate = "gzz_tortureroom_boxes"
  };
  
  local get_cane_inv = function ()
  
    interface.InventoryItemAdd( "inv_cane", "spr_boxes_cane" );
    ObjSet( "inv_cane", { drag = false } );

  end;
  
  local get_cane_closezz = function ()
  
    ObjDelete( "gfx_boxes_cane" );

  end;
  
  cmn.AddSubscriber( "get_cane", get_cane_inv );
  cmn.AddSubscriber( "get_cane", get_cane_closezz, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_hammerbox () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hammerbox" ] = {
    type = "get",
    get_obj = "spr_boxes_hammerbox",
    room = private.room_objname,
    zz = "zz_boxes",
    zz_gate = "gzz_tortureroom_boxes"
  };
  
  local get_hammerbox_inv = function ()
  
    interface.InventoryItemAdd( "inv_hammerbox", "spr_boxes_hammerbox" );

  end;
  
  local get_hammerbox_closezz = function ()
  
    ObjDelete( "gfx_boxes_hammerbox" );

  end;
  
  local get_hammerbox_closezz_end = function ()
  
    ObjSet( "spr_boxes_back_2", { alp = 1, input = true } );

  end;

  cmn.AddSubscriber( "get_hammerbox", get_hammerbox_inv );
  cmn.AddSubscriber( "get_hammerbox", get_hammerbox_closezz, private.room_objname );
  cmn.AddSubscriber( "get_hammerbox", get_hammerbox_closezz_end, private.room_objname );

  cmn.AddSubscriber( "get_hammerbox_inv", get_hammerbox_inv );
  cmn.AddSubscriber( "get_hammerbox_beg", get_hammerbox_closezz, private.room_objname );
  cmn.AddSubscriber( "get_hammerbox_end", get_hammerbox_closezz_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_diod () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_diod" ] = {
    type = "get",
    get_obj = "spr_monitorscreen_diod",
    room = private.room_objname,
    zz = "zz_monitorscreen",
    zz_gate = "gzz_tortureroom_monitorscreen"
  };
  
  local get_diod_inv = function ()
  
    interface.InventoryItemAdd( "inv_diod", "spr_monitorscreen_diod" );

  end;
  
  local get_diod_closezz = function ()
  
    ObjDelete( "gfx_electricalpanel_diod" );

    ObjSet( "spr_tortureroom_electricalpanel_light", { alp = 1 } );

  end;
  
  cmn.AddSubscriber( "get_diod", get_diod_inv );
  cmn.AddSubscriber( "get_diod", get_diod_closezz, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_levermonitor () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_levermonitor" ] = {
    type = "get",
    get_obj = "spr_monitorscreen_levermonitor",
    room = private.room_objname,
    zz = "zz_monitorscreen",
    zz_gate = "gzz_tortureroom_monitorscreen"
  };
  
  local get_levermonitor_inv = function ()
  
    interface.InventoryItemAdd( "inv_levermonitor", "spr_monitorscreen_levermonitor" );

  end;
  
  local get_levermonitor_closezz = function ()
  
    ObjDelete( "gfx_electricalpanel_levermonitor" );
    ObjDelete( "gzz_tortureroom_monitorscreen" );

    ObjSet( "spr_tortureroom_levers_light", { alp = 1 } );

  end;
  
  cmn.AddSubscriber( "get_levermonitor", get_levermonitor_inv );
  cmn.AddSubscriber( "get_levermonitor", get_levermonitor_closezz, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_fuselev () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fuselev" ] = {
    type = "get",
    get_obj = "spr_levers_fuselev",
    room = private.room_objname,
    zz = "zz_levers",
    zz_gate = "gzz_tortureroom_levers"
  };
  
  local get_fuselev_inv = function ()
  
    interface.InventoryItemAdd( "inv_fuselev", "spr_levers_fuselev" );

  end;
  
  local get_fuselev_closezz = function ()
  
    ObjDelete( "gfx_levers_fuselev" );

    ObjSet( "spr_tortureroom_boxes_light", { alp = 1 } );

  end;
  
  cmn.AddSubscriber( "get_fuselev", get_fuselev_inv );
  cmn.AddSubscriber( "get_fuselev", get_fuselev_closezz, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_combinationnumbers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_combinationnumbers" ] = {
    type = "get",
    get_obj = "spr_boxes_combinationnumbers",
    room = private.room_objname,
    zz = "zz_boxes",
    zz_gate = "gzz_tortureroom_boxes"
  };
  
  local get_combinationnumbers_inv = function ()
  
    interface.InventoryItemAdd( "inv_combinationnumbers", "spr_boxes_combinationnumbers" );

  end;
  
  local get_combinationnumbers_closezz = function ()
  
    ObjDelete( "gfx_boxes_combinationnumbers" );
    ObjDelete( "gzz_tortureroom_boxes" );

    ObjSet( "spr_tortureroom_levers_light", { alp = 1 } );
    ObjSet( "spr_tortureroom_boxes_light", { alp = 0 } );

  end;
  
  cmn.AddSubscriber( "get_combinationnumbers", get_combinationnumbers_inv );
  cmn.AddSubscriber( "get_combinationnumbers", get_combinationnumbers_closezz, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_emergencyswitch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_emergencyswitch" ] = {
    type = "get",
    get_obj = "spr_ventilationbox_emergencyswitch",
    room = private.room_objname,
    zz = "zz_ventilationbox",
    zz_gate = "gzz_tortureroom_ventilationbox"
  };
  
  local get_emergencyswitch_inv = function ()
  
    interface.InventoryItemAdd( "inv_emergencyswitch", "spr_ventilationbox_emergencyswitch" );

  end;
  
  local get_emergencyswitch_closezz = function ()
  
    ObjDelete( "gfx_ventilationbox_emergencyswitch" );
    ObjDelete( "gzz_tortureroom_ventilationbox" );

  end;
  
  cmn.AddSubscriber( "get_emergencyswitch", get_emergencyswitch_inv );
  cmn.AddSubscriber( "get_emergencyswitch", get_emergencyswitch_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pepper_spray () end;
  --------------------------------------------------------------------------------------------

  common_impl.hint[ "get_pepper_spray" ] = {
    type = "click",
    inv_obj = "obj_electricalpanel_clk_outro_2",
    use_place = "obj_electricalpanel_get_pepper_spray",
    room = private.room_objname,
    zz = "zz_electricalpanel",
    zz_gate = "gzz_tortureroom_electricalpanel"
  };

  local get_pepper_spray_inv = function ()
  
    interface.InventoryItemAdd( "inv_pepper_spray", "spr_electricalpanel_pepper_spray" );

  end;
  
  local get_pepper_spray_closezz = function ()
  
    ObjDelete( "gfx_electricalpanel_pepper_spray" );
    ObjDelete( "gzz_tortureroom_electricalpanel" );

    ObjSet( "obj_tortureroom_use_pepper_spray", { input = true } );

  end;
  
  cmn.AddSubscriber( "get_pepper_spray", get_pepper_spray_inv );
  cmn.AddSubscriber( "get_pepper_spray", get_pepper_spray_closezz, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_handlebox1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_handlebox1" ] = {
    type = "use",
    inv_obj = "inv_handlebox1",
    use_place = "obj_boxes_use_handlebox1",
    room = private.room_objname,
    zz = "zz_boxes",
    zz_gate = "gzz_tortureroom_boxes"
  };
  local use_handlebox1_inv = function ()
  
    interface.InventoryItemRemove( "inv_handlebox1" );
  
  end;
  local use_handlebox1_beg = function ()
  
    ObjDelete( "obj_boxes_use_handlebox1" );
  
  end;
  local use_handlebox1_end = function ()
  
    ObjSet( "spr_boxes_handle_1", { alp = 1 } );
    ObjSet( "spr_boxes_door_1", { input = true } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_handlebox1", use_handlebox1_beg, private.room_objname );
  cmn.AddSubscriber( "use_handlebox1", use_handlebox1_inv );
  cmn.AddSubscriber( "use_handlebox1", use_handlebox1_end, private.room_objname );
  cmn.AddSubscriber( "use_handlebox1_inv", use_handlebox1_inv, private.room_objname );
  cmn.AddSubscriber( "use_handlebox1_beg", use_handlebox1_beg, private.room_objname );
  cmn.AddSubscriber( "use_handlebox1_end", use_handlebox1_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_handlebox2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_handlebox2" ] = {
    type = "use",
    inv_obj = "inv_handlebox2",
    use_place = "obj_boxes_use_handlebox2",
    room = private.room_objname,
    zz = "zz_boxes",
    zz_gate = "gzz_tortureroom_boxes"
  };
  local use_handlebox2_inv = function ()
  
    interface.InventoryItemRemove( "inv_handlebox2" );
  
  end;
  local use_handlebox2_beg = function ()
  
    ObjDelete( "obj_boxes_use_handlebox2" );
  
  end;
  local use_handlebox2_end = function ()
  
    ObjSet( "spr_boxes_handle_2", { alp = 1 } );
    ObjSet( "spr_boxes_door_2", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_handlebox2", use_handlebox2_beg, private.room_objname );
  cmn.AddSubscriber( "use_handlebox2", use_handlebox2_inv );
  cmn.AddSubscriber( "use_handlebox2", use_handlebox2_end, private.room_objname );
  cmn.AddSubscriber( "use_handlebox2_inv", use_handlebox2_inv, private.room_objname );
  cmn.AddSubscriber( "use_handlebox2_beg", use_handlebox2_beg, private.room_objname );
  cmn.AddSubscriber( "use_handlebox2_end", use_handlebox2_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_fuselev () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fuselev" ] = {
    type = "use",
    inv_obj = "inv_fuselev",
    use_place = "obj_boxes_use_fuselev",
    room = private.room_objname,
    zz = "zz_boxes",
    zz_gate = "gzz_tortureroom_boxes"
  };
  local use_fuselev_inv = function ()
  
    interface.InventoryItemRemove( "inv_fuselev" );
  
  end;
  local use_fuselev_beg = function ()
  
    ObjDelete( "obj_boxes_use_fuselev" );
  
  end;
  local use_fuselev_end = function ()
  
    ObjDelete( "spr_boxes_fuse" );

    ObjSet( "spr_boxes_fuse_2", { alp = 1 } );
    ObjSet( "spr_boxes_combinationnumbers",   { input = true, pos_y = 4 } );
    ObjSet( "gfx_boxes_combinationnumbers",   { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fuselev", use_fuselev_beg, private.room_objname );
  cmn.AddSubscriber( "use_fuselev", use_fuselev_inv );
  cmn.AddSubscriber( "use_fuselev", use_fuselev_end, private.room_objname );
  cmn.AddSubscriber( "use_fuselev_inv", use_fuselev_inv, private.room_objname );
  cmn.AddSubscriber( "use_fuselev_beg", use_fuselev_beg, private.room_objname );
  cmn.AddSubscriber( "use_fuselev_end", use_fuselev_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_decomposedcane () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_decomposedcane" ] = {
    type = "use",
    inv_obj = "inv_decomposedcane",
    use_place = "obj_monitorscreen_use_decomposedcane",
    room = private.room_objname,
    zz = "zz_monitorscreen",
    zz_gate = "gzz_tortureroom_monitorscreen"
  };
  local use_decomposedcane_inv = function ()
  
    interface.InventoryItemRemove( "inv_decomposedcane" );
  
  end;
  local use_decomposedcane_beg = function ()
  
    ObjDelete( "obj_monitorscreen_use_decomposedcane" );
  
  end;
  local use_decomposedcane_end = function ()

    ObjSet( "spr_monitorscreen_button", { alp = 1 } );
    ObjSet( "spr_monitorscreen_tv_3",   { alp = 1 } );
    ObjSet( "spr_monitorscreen_mg_1",   { alp = 1 } );
    ObjSet( "spr_monitorscreen_back_2", { alp = 1, input = true } );

    ObjDelete( "anm_monitorscreen_monitor" );
    ObjDelete( "spr_monitorscreen_light" );

    ObjSet( "spr_tortureroom_monitorscreen_tv_down", { alp = 1 } );
    ObjDelete( "spr_tortureroom_monitorscreen_tv_up" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_decomposedcane", use_decomposedcane_beg, private.room_objname );
  cmn.AddSubscriber( "use_decomposedcane", use_decomposedcane_inv );
  cmn.AddSubscriber( "use_decomposedcane", use_decomposedcane_end, private.room_objname );
  cmn.AddSubscriber( "use_decomposedcane_inv", use_decomposedcane_inv, private.room_objname );
  cmn.AddSubscriber( "use_decomposedcane_beg", use_decomposedcane_beg, private.room_objname );
  cmn.AddSubscriber( "use_decomposedcane_end", use_decomposedcane_end, private.room_objname );
 --------------------------------------------------------------------------------------------
  -- function use_diod () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_diod" ] = {
    type = "use",
    inv_obj = "inv_diod",
    use_place = "obj_electricalpanel_use_diod",
    room = private.room_objname,
    zz = "zz_electricalpanel",
    zz_gate = "gzz_tortureroom_electricalpanel"
  };
  local use_diod_inv = function ()
  
    interface.InventoryItemRemove( "inv_diod" );
  
  end;
  local use_diod_beg = function ()
  
    ObjDelete( "obj_electricalpanel_use_diod" );
  
  end;
  local use_diod_end = function ()

    ObjSet( "spr_electricalpanel_diod", { alp = 1 } );
    ObjSet( "obj_electricalpanel_mg_2", { alp = 1, input = true } );

    ObjDelete( "spr_electricalpanel_door_2" );

    ObjDelete( "spr_tortureroom_electricalpanel_door" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_diod", use_diod_beg, private.room_objname );
  cmn.AddSubscriber( "use_diod", use_diod_inv );
  cmn.AddSubscriber( "use_diod", use_diod_end, private.room_objname );
  cmn.AddSubscriber( "use_diod_inv", use_diod_inv, private.room_objname );
  cmn.AddSubscriber( "use_diod_beg", use_diod_beg, private.room_objname );
  cmn.AddSubscriber( "use_diod_end", use_diod_end, private.room_objname );
 --------------------------------------------------------------------------------------------
  -- function use_emergencyswitch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_emergencyswitch" ] = {
    type = "use",
    inv_obj = "inv_emergencyswitch",
    use_place = "obj_electricalpanel_use_emergencyswitch",
    room = private.room_objname,
    zz = "zz_electricalpanel",
    zz_gate = "gzz_tortureroom_electricalpanel"
  };
  local use_emergencyswitch_inv = function ()
  
    interface.InventoryItemRemove( "inv_emergencyswitch" );
  
  end;
  local use_emergencyswitch_beg = function ()
  
    ObjDelete( "obj_electricalpanel_use_emergencyswitch" );
  
  end;
  local use_emergencyswitch_end = function ()

    ObjSet( "spr_electricalpanel_lever", { alp = 1, input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_emergencyswitch", use_emergencyswitch_beg, private.room_objname );
  cmn.AddSubscriber( "use_emergencyswitch", use_emergencyswitch_inv );
  cmn.AddSubscriber( "use_emergencyswitch", use_emergencyswitch_end, private.room_objname );
  cmn.AddSubscriber( "use_emergencyswitch_inv", use_emergencyswitch_inv, private.room_objname );
  cmn.AddSubscriber( "use_emergencyswitch_beg", use_emergencyswitch_beg, private.room_objname );
  cmn.AddSubscriber( "use_emergencyswitch_end", use_emergencyswitch_end, private.room_objname );
 --------------------------------------------------------------------------------------------
  -- function use_levermonitor () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_levermonitor" ] = {
    type = "use",
    inv_obj = "inv_levermonitor",
    use_place = "obj_levers_use_levermonitor",
    room = private.room_objname,
    zz = "zz_levers",
    zz_gate = "gzz_tortureroom_levers"
  };
  local use_levermonitor_inv = function ()
  
    interface.InventoryItemRemove( "inv_levermonitor" );
  
  end;
  local use_levermonitor_beg = function ()
  
    ObjDelete( "obj_levers_use_levermonitor" );
  
  end;
  local use_levermonitor_end = function ()

    ObjSet( "spr_levers_lever_3", { alp = 1 } );
    ObjSet( "obj_levers_buttons", { input = true } );

    ObjDelete( "spr_levers_door" );

    ObjSet( "spr_tortureroom_levers_mg",    { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_levermonitor", use_levermonitor_beg, private.room_objname );
  cmn.AddSubscriber( "use_levermonitor", use_levermonitor_inv );
  cmn.AddSubscriber( "use_levermonitor", use_levermonitor_end, private.room_objname );
  cmn.AddSubscriber( "use_levermonitor_inv", use_levermonitor_inv, private.room_objname );
  cmn.AddSubscriber( "use_levermonitor_beg", use_levermonitor_beg, private.room_objname );
  cmn.AddSubscriber( "use_levermonitor_end", use_levermonitor_end, private.room_objname );
--------------------------------------------------------------------------------------------
  -- function use_combinationnumbers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_combinationnumbers" ] = {
    type = "use",
    inv_obj = "inv_combinationnumbers",
    use_place = "obj_levers_use_combinationnumbers",
    room = private.room_objname,
    zz = "zz_levers",
    zz_gate = "gzz_tortureroom_levers"
  };
  local use_combinationnumbers_inv = function ()
  
    interface.InventoryItemRemove( "inv_combinationnumbers" );
  
  end;
  local use_combinationnumbers_beg = function ()
  
    ObjDelete( "obj_levers_use_combinationnumbers" );
  
  end;
  local use_combinationnumbers_end = function ()

    ObjSet( "spr_levers_code",   { alp = 1 } );
    ObjSet( "obj_levers_levers", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_combinationnumbers", use_combinationnumbers_beg, private.room_objname );
  cmn.AddSubscriber( "use_combinationnumbers", use_combinationnumbers_inv );
  cmn.AddSubscriber( "use_combinationnumbers", use_combinationnumbers_end, private.room_objname );
  cmn.AddSubscriber( "use_combinationnumbers_inv", use_combinationnumbers_inv, private.room_objname );
  cmn.AddSubscriber( "use_combinationnumbers_beg", use_combinationnumbers_beg, private.room_objname );
  cmn.AddSubscriber( "use_combinationnumbers_end", use_combinationnumbers_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_doorbox1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_doorbox1" ] = {
    type = "click",
    use_place = "spr_boxes_door_1",
    room = private.room_objname,
    zz = "zz_boxes",
    zz_gate = "gzz_tortureroom_boxes"
  };
  local clk_doorbox1_beg = function ()
  
  end;
  local clk_doorbox1_end = function ()

    ObjDelete( "spr_boxes_door_1" );
    ObjDelete( "spr_tortureroom_boxes_door_1" );

    ObjSet( "obj_boxesl_mg_1_buttons", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_doorbox1",     clk_doorbox1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_doorbox1",     clk_doorbox1_end, private.room_objname );
  cmn.AddSubscriber( "clk_doorbox1_beg", clk_doorbox1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_doorbox1_end", clk_doorbox1_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_doorbox2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_doorbox2" ] = {
    type = "click",
    use_place = "spr_boxes_door_2",
    room = private.room_objname,
    zz = "zz_boxes",
    zz_gate = "gzz_tortureroom_boxes"
  };
  local clk_doorbox2_beg = function ()
  
  end;
  local clk_doorbox2_end = function ()

    ObjDelete( "spr_boxes_door_2" );
    ObjDelete( "spr_tortureroom_boxes_door_2" );

    ObjSet( "obj_boxesl_mg_2_buttons", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_doorbox2",     clk_doorbox2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_doorbox2",     clk_doorbox2_end, private.room_objname );
  cmn.AddSubscriber( "clk_doorbox2_beg", clk_doorbox2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_doorbox2_end", clk_doorbox2_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_emergencyswitch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_emergencyswitch" ] = {
    type = "click",
    use_place = "spr_electricalpanel_lever",
    room = private.room_objname,
    zz = "zz_electricalpanel",
    zz_gate = "gzz_tortureroom_electricalpanel"
  };
  local clk_emergencyswitch_beg = function ()
  
  end;
  local clk_emergencyswitch_end = function ()

    ObjDelete( "spr_electricalpanel_lever" );

    ObjSet( "obj_electricalpanel_get_pepper_spray", { input = true } );
    ObjSet( "obj_electricalpanel_clk_outro_2", { input = true } );
    ObjSet( "spr_electricalpanel_lever_2",     { alp = 1 } );
    ObjSet( "obj_electricalpanel_choice",     { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_emergencyswitch",     clk_emergencyswitch_beg, private.room_objname );
  cmn.AddSubscriber( "clk_emergencyswitch",     clk_emergencyswitch_end, private.room_objname );
  cmn.AddSubscriber( "clk_emergencyswitch_beg", clk_emergencyswitch_beg, private.room_objname );
  cmn.AddSubscriber( "clk_emergencyswitch_end", clk_emergencyswitch_end, private.room_objname );

--------------------------------------------------------------------------------------------
  -- function use_hammerbox () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hammerbox" ] = {
    type = "use",
    inv_obj = "inv_hammerbox",
    use_place = "obj_monitorscreen_use_hammerbox",
    room = private.room_objname,
    zz = "zz_monitorscreen",
    zz_gate = "gzz_tortureroom_monitorscreen"
  };
  local use_hammerbox_inv = function ()
  
    interface.InventoryItemRemove( "inv_hammerbox" );
  
  end;
  local use_hammerbox_beg = function ()
  
    ObjDelete( "obj_monitorscreen_use_hammerbox" );
    ObjDelete( "obj_monitorscreen_tv" );
  
  end;
  local use_hammerbox_end = function ()

    ObjSet( "spr_monitorscreen_cover", { input = true } );

    ObjDelete( "vid_monitorscreen_hammer" );

    ObjSet( "spr_tortureroom_monitorscreen_tv_broken",   { alp = 1 } );
    ObjSet( "spr_tortureroom_monitorscreen_tv_broken_1", { alp = 1 } );
    ObjDelete( "spr_tortureroom_monitorscreen_tv_down" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hammerbox", use_hammerbox_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammerbox", use_hammerbox_inv );
  cmn.AddSubscriber( "use_hammerbox", use_hammerbox_end, private.room_objname );
  cmn.AddSubscriber( "use_hammerbox_inv", use_hammerbox_inv, private.room_objname );
  cmn.AddSubscriber( "use_hammerbox_beg", use_hammerbox_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammerbox_end", use_hammerbox_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_electricalpanel_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_electricalpanel_1" ] =
  {
      type = "win",
      room = private.room_objname,
      zz = "zz_electricalpanel",
      zz_gate = "gzz_tortureroom_electricalpanel"
  };
  --------------------------------------------------------------------------------------------
  local win_electricalpanel_1_zz = function ()
  
    if ( cmn.IsEventDone( "win_electricalpanel_1" ) ) then

      ObjSet( "obj_electricalpanel_mg_1",       { pos_x = -244, input = false } );
      ObjSet( "spr_electricalpanel_handlebox1", { input  = true } );
      ObjSet( "gfx_electricalpanel_handlebox1", { active = true } );
      ObjSet( "obj_electricalpanel_use_diod",   { input  = true } );

      ObjSet( "spr_tortureroom_electricalpanel_mg_1",  { alp = 1 } );
      ObjSet( "spr_tortureroom_electricalpanel_light", { alp = 0 } );

    else

      if ( ng_global.progress[ "std" ][ "win_electricalpanel_1" ].electricalpanel_1_current_list ) then

        for i = 1, #private.electricalpanel_1_current_list do
     
          private.electricalpanel_1_current_list[ i ] = ng_global.progress[ "std" ][ "win_electricalpanel_1" ].electricalpanel_1_current_list[ i ];

          if ( private.electricalpanel_1_current_list[ i ] ) then

            ObjSet( "spr_electricalpanel_mg_1_square_"..i,          { input = false } );
            ObjSet( "spr_electricalpanel_mg_1_square_"..i.."_over", { alp = 0 } );

          end;

        end;

      end;

    end;

  end;
  
  cmn.AddSubscriber( "win_electricalpanel_1", win_electricalpanel_1_zz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_electricalpanel_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_electricalpanel_2" ] =
  {
    type = "win",
    room = private.room_objname,
    zz = "zz_electricalpanel",
    zz_gate = "gzz_tortureroom_electricalpanel"
  };
  --------------------------------------------------------------------------------------------
  local win_electricalpanel_2_zz = function ()
  
    if ( cmn.IsEventDone( "win_electricalpanel_2" ) ) then

      ObjSet( "obj_electricalpanel_mg_2",       { pos_x = 244, input = false } );
      ObjSet( "spr_electricalpanel_handlebox2", { input  = true } );
      ObjSet( "gfx_electricalpanel_handlebox2", { active = true } );

      ObjSet( "obj_electricalpanel_use_emergencyswitch", { input  = true } );

      ObjSet( "spr_tortureroom_electricalpanel_light", { alp = 0 } );

      ObjSet( "spr_tortureroom_lamp_2", { active = false, alp = 1 } );
      ObjSet( "spr_tortureroom_lamp_3", { active = true } );

    else

      if ( ng_global.progress[ "std" ][ "win_electricalpanel_2" ].electricalpanel_2_current_list ) then

        for i = 1, #private.electricalpanel_2_current_list do
     
          private.electricalpanel_2_current_list[ i ] = ng_global.progress[ "std" ][ "win_electricalpanel_2" ].electricalpanel_2_current_list[ i ];

          if ( private.electricalpanel_2_current_list[ i ] ) then

            ObjSet( "spr_electricalpanel_mg_2_square_"..i,            { input = false, alp = 0 } );
            ObjSet( "spr_electricalpanel_mg_2_square_2_"..i.."_over", { alp = 0 } );

          end;

        end;

      end;

    end;

  end;
  
  cmn.AddSubscriber( "win_electricalpanel_2", win_electricalpanel_2_zz, private.room_objname );
 --------------------------------------------------------------------------------------------
  -- function win_boxes_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_boxes_1" ] =
  {
      type = "win",
      room = private.room_objname,
      zz = "zz_boxes",
      zz_gate = "gzz_tortureroom_boxes"
  };
  --------------------------------------------------------------------------------------------
  local win_boxes_1_zz = function ()
  
    if ( cmn.IsEventDone( "win_boxes_1" ) ) then

      ObjSet( "obj_boxes_mg_1_move",     { pos_y = -320 } );
      ObjSet( "obj_boxesl_mg_1_buttons", { input = false } );
      ObjSet( "spr_boxes_cane", { input  = true } );
      ObjSet( "gfx_boxes_cane", { active = true } );

      ObjSet( "spr_tortureroom_boxes_light", { alp = 0 } );

      ObjDelete( "spr_tortureroom_boxes_mg_1" );

      ObjSet( "spr_tortureroom_lamp_1", { active = false, alp = 1 } );
      ObjSet( "spr_tortureroom_lamp_2", { active = true } );

    else

      if ( ng_global.progress[ "std" ][ "win_boxes_1" ].boxes_1_state ) then

        private.boxes_1_state = ng_global.progress[ "std" ][ "win_boxes_1" ].boxes_1_state;

        local pos_y = private.boxes_1_pos_begin + ( private.boxes_1_state - 1 ) * private.boxes_1_pos_step;

        ObjSet( "spr_boxes_arms", { pos_y = pos_y } );

      end;

    end;

  end;
  
  cmn.AddSubscriber( "win_boxes_1", win_boxes_1_zz, private.room_objname );
 --------------------------------------------------------------------------------------------
  -- function win_boxes_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_boxes_2" ] =
  {
      type = "win",
      room = private.room_objname,
      zz = "zz_boxes",
      zz_gate = "gzz_tortureroom_boxes"
  };
  --------------------------------------------------------------------------------------------
  local win_boxes_2_zz = function ()
  
    if ( cmn.IsEventDone( "win_boxes_2" ) ) then

      ObjSet( "obj_boxes_mg_2_move",     { pos_y = 320 } );
      ObjSet( "obj_boxesl_mg_2_buttons", { input = false } );
      ObjSet( "spr_boxes_hammerbox", { input  = true } );
      ObjSet( "gfx_boxes_hammerbox", { active = true } );
      ObjDelete( "spr_tortureroom_boxes_mg_2" );

      ObjSet( "spr_tortureroom_boxes_light", { alp = 0 } );

      ObjSet( "spr_tortureroom_lamp_3", { active = false, alp = 1 } );
      ObjSet( "spr_tortureroom_lamp_4", { active = true } );

    else

      if ( ng_global.progress[ "std" ][ "win_boxes_2" ].boxes_2_current_list ) then

        for i = 1, #private.boxes_2_current_list do
    
          private.boxes_2_current_list[ i ] = ng_global.progress[ "std" ][ "win_boxes_2" ].boxes_2_current_list[ i ];

          local number = private.boxes_2_current_list[ i ];
          local pos    = private.boxes_2_pos[ i ];

          ObjSet ( "spr_boxes_puzzle_"..number, { pos_x = pos[ 1 ], pos_y = pos[ 2 ] } );

        end;

      end;

    end;

  end;
  
  cmn.AddSubscriber( "win_boxes_2", win_boxes_2_zz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_lines () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_lines" ] =
  {
      type = "win",
      room = private.room_objname,
      zz = "zz_monitorscreen",
      zz_gate = "gzz_tortureroom_monitorscreen"
  };
  --------------------------------------------------------------------------------------------
  local win_lines_zz = function ()
  
    if ( cmn.IsEventDone( "win_lines" ) ) then

      ObjDelete( "obj_monitorscreen_mgs" );

      ObjSet( "spr_monitorscreen_tv_4", { alp  = 1 } );
      ObjSet( "spr_monitorscreen_diod", { input  = true, pos_y = 162 } );
      ObjSet( "gfx_monitorscreen_diod", { active = true } );
      ObjSet( "obj_monitorscreen_use_hammerbox", { input  = true } );
      ObjSet( "vid_tortureroom_monitorscreen_tv_down_screen_2", { alp = 1, playing = true, looped = true } );
      ObjDelete( "vid_tortureroom_monitorscreen_tv_down_screen_1" );

    else

      if ( ng_global.progress[ "std" ][ "win_lines" ].lines_state ) then

        private.lines_state = ng_global.progress[ "std" ][ "win_lines" ].lines_state;

        for i = 1, #ng_global.progress[ "std" ][ "win_lines" ].lines_current_list do
     
          private.lines_current_list[ i ] = ng_global.progress[ "std" ][ "win_lines" ].lines_current_list[ i ];

          private.LinesEdgeSet( private.lines_current_list[ i ][ 1 ], private.lines_current_list[ i ][ 2 ] );

        end;

        if ( private.lines_state == 2 ) then

          private.LinesWinState1();

        end;

      end;

    end;

  end;
  
  cmn.AddSubscriber( "win_lines", win_lines_zz, private.room_objname );
 --------------------------------------------------------------------------------------------
  -- function win_keystv () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_keystv" ] =
  {
      type = "win",
      room = private.room_objname,
      zz = "zz_electricalpanel",
      zz_gate = "gzz_tortureroom_electricalpanel"
  };
  --------------------------------------------------------------------------------------------
  local win_keystv_zz = function ()
  
    if ( cmn.IsEventDone( "win_keystv" ) ) then

      ObjDelete( "spr_monitorscreen_cover" );

      ObjSet( "spr_monitorscreen_levermonitor", { input  = true } );
      ObjSet( "gfx_monitorscreen_levermonitor", { active = true } );

    else

      if ( ng_global.progress[ "std" ][ "win_keystv" ].keystv_current_list ) then

        for i = 1, #private.keystv_current_list do
    
          private.keystv_current_list[ i ] = ng_global.progress[ "std" ][ "win_keystv" ].keystv_current_list[ i ];

          local number = private.keystv_current_list[ i ];

          ObjSet( "spr_monitorscreen_key_"..number, { pos_x = private.keystv_pos_x[ i ] } );

        end;

      end;

    end;

  end;
  
  cmn.AddSubscriber( "win_keystv", win_keystv_zz, private.room_objname );
 --------------------------------------------------------------------------------------------
  -- function win_levers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_levers" ] =
  {
      type = "win",
      room = private.room_objname,
      zz = "zz_levers",
      zz_gate = "gzz_tortureroom_levers"
  };
  --------------------------------------------------------------------------------------------
  local win_levers_zz = function ()
  
    if ( cmn.IsEventDone( "win_levers" ) ) then

      ObjSet( "obj_levers_buttons", { input = false } );

      ObjSet( "spr_levers_fuselev", { input  = true, pos_y = -133 } );
      ObjSet( "gfx_levers_fuselev", { active = true } );

      ObjSet( "spr_tortureroom_levers_light", { alp = 0 } );

      ObjSet( "spr_tortureroom_lamp_4", { active = false, alp = 1 } );
      ObjSet( "spr_tortureroom_lamp_5", { active = true } );

    else

      --

    end;

    if ( ng_global.progress[ "std" ][ "win_levers" ].levers_current_list ) then

      for i = 1, #private.levers_current_list do
            
        private.levers_current_list[ i ] = ng_global.progress[ "std" ][ "win_levers" ].levers_current_list[ i ];

        local pos_y = private.levers_current_list[ i ];

        ObjSet( "spr_levers_button_"..i, { pos_y = pos_y } );

      end;

      private.LeversLampSet();

    end;

  end;
  
  cmn.AddSubscriber( "win_levers", win_levers_zz, private.room_objname );
 --------------------------------------------------------------------------------------------
  -- function win_levers_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_levers_2" ] =
  {
      type = "win",
      room = private.room_objname,
      zz = "zz_levers",
      zz_gate = "gzz_tortureroom_levers"
  };
  --------------------------------------------------------------------------------------------
  local win_levers_2_zz = function ()
  
    if ( cmn.IsEventDone( "win_levers_2" ) ) then

      ObjSet( "spr_levers_staircase", { pos_x = -22 } );
      
      ObjSet( "gzz_tortureroom_ventilationbox", { input  = true, active = true } );
      ObjDelete( "gzz_tortureroom_levers" );

      ObjSet( "spr_tortureroom_levers_staircase",     { alp = 1 } );
      ObjSet( "spr_tortureroom_ventilationbox_light", { alp = 1 } );

      ObjSet( "spr_tortureroom_levers_light", { alp = 0 } );

    else

      --

    end;

    if ( ng_global.progress[ "std" ][ "win_levers_2" ].levers_2_current_list ) then

      for i = 1, #private.levers_2_current_list do
            
        private.levers_2_current_list[ i ] = ng_global.progress[ "std" ][ "win_levers_2" ].levers_2_current_list[ i ];

        local pos_y = private.levers_2_current_list[ i ];

        ObjSet( "spr_levers_lever_"..i, { pos_y = pos_y } );

      end;

    end;

  end;
  
  cmn.AddSubscriber( "win_levers_2", win_levers_2_zz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_ventilationbox () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_ventilationbox" ] =
  {
      type = "win",
      room = private.room_objname,
      zz = "zz_ventilationbox",
      zz_gate = "gzz_tortureroom_ventilationbox"
  };
  --------------------------------------------------------------------------------------------
  local win_ventilationbox_zz = function ()
  
    if ( cmn.IsEventDone( "win_ventilationbox" ) ) then

      ObjSet( "spr_ventilationbox_emergencyswitch", { input  = true} );
      ObjSet( "gfx_ventilationbox_emergencyswitch", { active = true } );
      
      ObjDelete( "obj_ventilationbox_mg" );

      ObjSet( "spr_tortureroom_ventilationbox_light", { alp = 0 } );

      ObjSet( "spr_tortureroom_lamp_5", { active = false, alp = 1 } );
      ObjSet( "spr_tortureroom_lamp_6", { active = true } );

    else

      if ( ng_global.progress[ "std" ][ "win_ventilationbox" ].ventilationbox_current_list ) then

        for j = 1, #private.ventilationbox_current_list do
    
          for i = 1, #private.ventilationbox_current_list[ j ] do
      
            private.ventilationbox_current_list[ j ][ i ] = ng_global.progress[ "std" ][ "win_ventilationbox" ].ventilationbox_current_list[ j ][ i ];

            local name = "spr_ventilationbox_square_"..j.."_"..i;

            local type = private.ventilationbox_current_list[ j ][ i ];

            if ( type == 4 or type == 5 or type == 6 ) then

              local color = private.ventilationbox_color[ type - 3 ];

              ObjSet( name, { input = false, alp = 1, res = "assets/levels/level3/rm_tortureroom/zz_ventilationbox/layers/"..color } );

            end;

          end;

        end;

      end;

    end;

  end;
  
  cmn.AddSubscriber( "win_ventilationbox", win_ventilationbox_zz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_tortureroom () end;
  --------------------------------------------------------------------------------------------

  local opn_tortureroom_map = function ()

    common_impl.VisitMapRoom( "tortureroom" );

  end;
  cmn.AddSubscriber( "opn_tortureroom", opn_tortureroom_map );
  --------------------------------------------------------------------------------------------
  -- function see_outro_3 () end;
  --------------------------------------------------------------------------------------------

  common_impl.hint[ "see_outro_3" ] = {
    type = "use",
    inv_obj = "inv_pepper_spray",
    use_place = "obj_tortureroom_use_pepper_spray",
    room = private.room_objname
  };

  local see_outro_3 = function ()



  end;
  cmn.AddSubscriber( "see_outro_3", see_outro_3, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()

  --*********************************************************************************************************************
  -- function zz_electricalpanel () end;
  --*********************************************************************************************************************

    subroom.Define( "zz_electricalpanel" );
    
    private.Electricalpanel1Init();
    private.Electricalpanel2Init();

  --*********************************************************************************************************************

    function zz_electricalpanel.PreOpen()

    end;
    -------------------------------------------------
    function zz_electricalpanel.Open()

      if ( not cmn.IsEventDone( "win_electricalpanel_1" ) ) then

        cmn.MiniGameShow( "electricalpanel_1" );
        common_impl.PassingMgStart( "electricalpanel_1" );

      end;

      if ( cmn.IsEventDone( "use_diod" ) ) and ( not cmn.IsEventDone( "win_electricalpanel_2" ) ) then

        cmn.MiniGameShow( "electricalpanel_2" );
        common_impl.PassingMgStart( "electricalpanel_2" );

      end;

    end;
    -------------------------------------------------
    function zz_electricalpanel.PreClose()

      if ( not cmn.IsEventDone( "win_electricalpanel_1" ) ) then

        cmn.MiniGameHide( "electricalpanel_1" );
        common_impl.PassingMgStop( "electricalpanel_1" );

      end;

      if ( cmn.IsEventDone( "use_diod" ) ) and ( not cmn.IsEventDone( "win_electricalpanel_2" ) ) then

        cmn.MiniGameHide( "electricalpanel_2" );
        common_impl.PassingMgStop( "electricalpanel_2" );

      end;

    end;
    -------------------------------------------------
    function zz_electricalpanel.Close()

    end;
    -------------------------------------------------
    function zz_electricalpanel.Reset ()

      if ( not cmn.IsEventDone( "win_electricalpanel_1" ) ) then

        ng_global.progress[ "std" ][ "win_electricalpanel_1" ].electricalpanel_1_current_list = { false, false, false, false, false, false, false, false, false, false, false, false };

        private.electricalpanel_1_current_list = { false, false, false, false, false, false, false, false, false, false, false, false };
        private.electricalpanel_1_list         = { 1, 2, 3, 4, 5, 6, 1, 2, 3, 4, 5, 6 };
        private.electricalpanel_1_prev_number  = "";
        
        for i = 1, #private.electricalpanel_1_current_list do
     
          ObjSet( "spr_electricalpanel_mg_1_square_"..i,          { input = true } );
          ObjSet( "spr_electricalpanel_mg_1_square_"..i.."_over", { alp = 1 } );

        end;

      end;

      if ( cmn.IsEventDone( "use_diod" ) ) and ( not cmn.IsEventDone( "win_electricalpanel_2" ) ) then

        ng_global.progress[ "std" ][ "win_electricalpanel_2" ].electricalpanel_1_current_list = { false, false, false, false, false, false };

        private.electricalpanel_2_current_list = { false, false, false, false, false, false };
        private.electricalpanel_2_prev_number  = "";
        
        for s = 1, 6 do
          
          ObjSet( "spr_electricalpanel_mg_2_square_"..s, { input = true, alp = 1 } );
          ObjSet( "spr_electricalpanel_mg_2_square_"..s.."_light", { alp = 0 } );

        end;
        
        for i = 1, 3 do
     
          ObjSet( "spr_electricalpanel_mg_2_square_2_"..i.."_over", { alp = 1 } );

        end;

      end;

    end;
    -------------------------------------------------
    function zz_electricalpanel.Skip ()

      if ( not cmn.IsEventDone( "win_electricalpanel_1" ) ) then

        private.Electricalpanel1WinAnim();

      end;

      if ( cmn.IsEventDone( "use_diod" ) ) and ( not cmn.IsEventDone( "win_electricalpanel_2" ) ) then

        private.Electricalpanel2WinAnim();

      end;

    end;

  --*********************************************************************************************************************
  -- function zz_boxes () end;
  --*********************************************************************************************************************

    subroom.Define( "zz_boxes" );
    
    private.Boxes1Init();
    private.Boxes2Init();

  --*********************************************************************************************************************

    function zz_boxes.PreOpen()

    end;
    -------------------------------------------------
    function zz_boxes.Open()

      if ( cmn.IsEventDone( "clk_doorbox1" ) ) and ( not cmn.IsEventDone( "win_boxes_1" ) ) then

        cmn.MiniGameShow( "boxes_1" );
        common_impl.PassingMgStart( "boxes_1" );

      end;

      if ( cmn.IsEventDone( "clk_doorbox2" ) ) and ( not cmn.IsEventDone( "win_boxes_2" ) ) then

        cmn.MiniGameShow( "boxes_2" );
        common_impl.PassingMgStart( "boxes_2" );

      end;

    end;
    -------------------------------------------------
    function zz_boxes.PreClose()

      if ( cmn.IsEventDone( "clk_doorbox1" ) ) and ( not cmn.IsEventDone( "win_boxes_1" ) ) then

        cmn.MiniGameHide( "boxes_1" );
        common_impl.PassingMgStop( "boxes_1" );

      end;

      if ( cmn.IsEventDone( "clk_doorbox2" ) ) and ( not cmn.IsEventDone( "win_boxes_2" ) ) then

        cmn.MiniGameHide( "boxes_2" );
        common_impl.PassingMgStop( "boxes_2" );

      end;

    end;
    -------------------------------------------------
    function zz_boxes.Close()

    end;
    -------------------------------------------------
    function zz_boxes.Reset ()

      if ( cmn.IsEventDone( "clk_doorbox1" ) ) and ( not cmn.IsEventDone( "win_boxes_1" ) ) then

        private.boxes_1_state = 1;
        ng_global.progress[ "std" ][ "win_boxes_1" ].boxes_1_state = 1;

        ObjSet( "spr_boxes_arms", { pos_y = private.boxes_1_pos_begin } );

      end;

      if ( cmn.IsEventDone( "clk_doorbox2" ) ) and ( not cmn.IsEventDone( "win_boxes_2" ) ) then

        private.boxes_2_current_list = { 1, 3, 2, 5, 4, 6 };
        private.boxes_2_prev_number = 0;

        ng_global.progress[ "std" ][ "win_superpuzzle2" ].boxes_2_current_list = { 1, 3, 2, 5, 4, 6 };

        for i = 1, #private.boxes_2_current_list do
              
          local number = private.boxes_2_current_list[ i ];
          local pos_x  = private.pictures_pos[ i ][ 1 ];
          local pos_y  = private.pictures_pos[ i ][ 2 ];
          table.insert( table_multiset, { "spr_boxes_puzzle_"..number, { pos_x = pos_x, pos_y = pos_y } } );

        end;

      end;

    end;
    -------------------------------------------------
    function zz_boxes.Skip ()

      if ( cmn.IsEventDone( "clk_doorbox1" ) ) and ( not cmn.IsEventDone( "win_boxes_1" ) ) then

        private.Boxes1WinAnim();

      end;

      if ( cmn.IsEventDone( "clk_doorbox2" ) ) and ( not cmn.IsEventDone( "win_boxes_2" ) ) then

        local func_end = private.Boxes2WinAnim;

        for i = 1, #private.boxes_2_win_list do

          if ( i ~= 1 ) then

            func_end = "";

          end

          local number = private.boxes_2_win_list[ i ];
          local new    = private.boxes_2_pos[ i ];

          local old = ObjGet( "spr_boxes_puzzle_"..number );

          ObjAnimate( "spr_boxes_puzzle_"..number, "pos_xy", 0, 0, func_end, { 0,3,old.pos_x,old.pos_y,   0.4,3,new[ 1 ],new[ 2 ],   1.0,3,new[ 1 ],new[ 2 ] } );

        end;

      end;

    end;
    -------------------------------------------------

  --*********************************************************************************************************************
  -- function zz_monitorscreen () end;
  --*********************************************************************************************************************

    subroom.Define( "zz_monitorscreen" );
    
    private.LinesInit();
    private.KeystvInit();

  --*********************************************************************************************************************

    function zz_monitorscreen.PreOpen()

    end;
    -------------------------------------------------
    function zz_monitorscreen.Open()

      if ( cmn.IsEventDone( "use_decomposedcane" ) ) and ( not cmn.IsEventDone( "win_lines" ) ) then

        cmn.MiniGameShow( "lines" );
        common_impl.PassingMgStart( "lines" );

      end;

      if ( cmn.IsEventDone( "use_hammerbox" ) ) and ( not cmn.IsEventDone( "win_keystv" ) ) then

        cmn.MiniGameShow( "keystv" );
        common_impl.PassingMgStart( "keystv" );

      end;

    end;
    -------------------------------------------------
    function zz_monitorscreen.PreClose()

      if ( cmn.IsEventDone( "use_decomposedcane" ) ) and ( not cmn.IsEventDone( "win_lines" ) ) then

        cmn.MiniGameHide( "lines" );
        common_impl.PassingMgStop( "lines" );

      end;

      if ( cmn.IsEventDone( "use_hammerbox" ) ) and ( not cmn.IsEventDone( "win_keystv" ) ) then

        cmn.MiniGameHide( "keystv" );
        common_impl.PassingMgStop( "keystv" );

      end;

    end;
    -------------------------------------------------
    function zz_monitorscreen.Close()

    end;
    -------------------------------------------------
    function zz_monitorscreen.Reset ()

      if ( cmn.IsEventDone( "use_decomposedcane" ) ) and ( not cmn.IsEventDone( "win_lines" ) ) then

        ng_global.progress[ "std" ][ "win_lines" ].lines_current_list = {};

        private.lines_current_list  = {};
        private.lines_state         = 1;

        private.lines_prev_number  = "";
        
        for c = 1, 21 do
                  
          ObjSet( "spr_monitorscreen_circle_"..c, { alp = 0 } );

        end;

        for c = 1, 18 do
          
          ObjSet( "spr_monitorscreen_circle_2_"..c, { alp = 0 } );

        end;

        ObjSet( "spr_monitorscreen_mg_1",      { alp = 1 } );
        ObjSet( "obj_monitorscreen_circles",   { alp = 1, input = true } );
        ObjSet( "spr_monitorscreen_mg_2",      { alp = 0 } );
        ObjSet( "obj_monitorscreen_circles_2", { alp = 0, input = false } );

        ObjSet( "spr_monitorscreen_light_mg",   { visible = 0 } );
        ObjSet( "spr_monitorscreen_light_mg_2", { visible = 0 } );

        local childs = ObjGetRelations( "obj_monitorscreen_circles" ).childs;

        for i = 1, #childs do
      
          if ( string.find( childs[ i ], "line_" ) ) then

            ObjDelete( childs[ i ] );

          end;

        end;

        childs = ObjGetRelations( "obj_monitorscreen_circles_2" ).childs;

        for i = 1, #childs do 
      
          if ( string.find( childs[ i ], "line_2_" ) ) then

            ObjDelete( childs[ i ] );

          end;

        end;

      end;

      if ( cmn.IsEventDone( "use_hammerbox" ) ) and ( not cmn.IsEventDone( "win_keystv" ) ) then

        private.keystv_current_list  = { 1, 2, 3, 4 };

        ng_global.progress[ "std" ][ "win_keystv" ].keystv_current_list  = { 1, 2, 3, 4 };

        private.lines_prev_number  = "";

        for i = 1, #private.keystv_current_list do
    
          local number = private.keystv_current_list[ i ];

          ObjSet( "spr_monitorscreen_key_"..number, { pos_x = private.keystv_pos_x[ i ] } );

        end;

      end;

    end;
    -------------------------------------------------
    function zz_monitorscreen.Skip ()

      if ( cmn.IsEventDone( "use_decomposedcane" ) ) and ( not cmn.IsEventDone( "win_lines" ) ) then

        private.LinesWinAnim();

      end;

      if ( cmn.IsEventDone( "use_hammerbox" ) ) and ( not cmn.IsEventDone( "win_keystv" ) ) then

        local func_end = private.KeystvWinAnim;

        for i = 1, #private.keystv_win_list do

          if ( i ~= 1 ) then

            func_end = "";

          end

          local number = private.keystv_win_list[ i ];

          local old_x = ObjGet( "spr_monitorscreen_key_"..number ).pos_x;

          ObjAnimate( "spr_monitorscreen_key_"..number, "pos_x", 0, 0, func_end, { 0,3,old_x,  0.4,3,private.keystv_pos_x[ i ] } );

        end;

      end;

    end;

  --*********************************************************************************************************************
  -- function zz_levers () end;
  --*********************************************************************************************************************

    subroom.Define( "zz_levers" );
    
    private.LeversInit();
    private.Levers2Init();

  --*********************************************************************************************************************

    function zz_levers.PreOpen()

    end;
    -------------------------------------------------
    function zz_levers.Open()

      if ( cmn.IsEventDone( "use_levermonitor" ) ) and ( not cmn.IsEventDone( "win_levers" ) ) then

        cmn.MiniGameShow( "levers" );
        common_impl.PassingMgStart( "levers" );

      end;

      if ( cmn.IsEventDone( "use_combinationnumbers" ) ) and ( not cmn.IsEventDone( "win_levers_2" ) ) then

        cmn.MiniGameShow( "levers_2" );
        common_impl.PassingMgStart( "levers_2" );

      end;

    end;
    -------------------------------------------------
    function zz_levers.PreClose()

      if ( cmn.IsEventDone( "use_levermonitor" ) ) and ( not cmn.IsEventDone( "win_levers" ) ) then

        cmn.MiniGameHide( "levers" );
        common_impl.PassingMgStop( "levers" );

      end;

      if ( cmn.IsEventDone( "use_combinationnumbers" ) ) and ( not cmn.IsEventDone( "win_levers_2" ) ) then

        cmn.MiniGameHide( "levers_2" );
        common_impl.PassingMgStop( "levers_2" );

      end;

    end;
    -------------------------------------------------
    function zz_levers.Close()

    end;
    -------------------------------------------------
    function zz_levers.Reset ()

      if ( cmn.IsEventDone( "use_levermonitor" ) ) and ( not cmn.IsEventDone( "win_levers" ) ) then

        local table_multiset = {};

        private.levers_current_list = { -83, -54, -28, 0, 24 };

        private.levers_first = true;

        ng_global.progress[ "std" ][ "win_levers" ].levers_current_list = { -83, -54, -28, 0, 24 };

        for i = 1, #private.levers_current_list do
              
          local pos_y = private.levers_current_list[ i ];

          table.insert( table_multiset, { "spr_levers_button_"..i, { pos_y = pos_y } } );

        end;

        private.LeversLampSet();

        ObjMultiSet( table_multiset );

      end;

      if ( cmn.IsEventDone( "use_combinationnumbers" ) ) and ( not cmn.IsEventDone( "win_levers_2" ) ) then

        local table_multiset = {};

        private.levers_2_current_list = { 149, 149, 149 };

        private.levers_2_first = true;

        ng_global.progress[ "std" ][ "win_levers_2" ].levers_2_current_list = { 149, 149, 149 };

        for i = 1, #private.levers_2_current_list do
              
          local pos_y = private.levers_2_current_list[ i ];

          table.insert( table_multiset, { "spr_levers_lever_"..i, { pos_y = pos_y } } );

        end;

        ObjMultiSet( table_multiset );

      end;

    end;
    -------------------------------------------------
    function zz_levers.Skip ()

      if ( cmn.IsEventDone( "use_levermonitor" ) ) and ( not cmn.IsEventDone( "win_levers" ) ) then

        private.LeversWinAnim();

      end;

      if ( cmn.IsEventDone( "use_combinationnumbers" ) ) and ( not cmn.IsEventDone( "win_levers_2" ) ) then

        private.Levers2WinAnim();

      end;

    end;
 --*********************************************************************************************************************
  -- function zz_ventilationbox () end;
  --*********************************************************************************************************************

    subroom.Define( "zz_ventilationbox" );
    
    private.VentilationboxInit();

  --*********************************************************************************************************************

    function zz_ventilationbox.PreOpen()

    end;
    -------------------------------------------------
    function zz_ventilationbox.Open()

      if ( not cmn.IsEventDone( "win_ventilationbox" ) ) then

        cmn.MiniGameShow( "ventilationbox" );
        common_impl.PassingMgStart( "ventilationbox" );

      end;

    end;
    -------------------------------------------------
    function zz_ventilationbox.PreClose()

      if ( not cmn.IsEventDone( "win_ventilationbox" ) ) then

        cmn.MiniGameHide( "ventilationbox" );
        common_impl.PassingMgStop( "ventilationbox" );

      end;

    end;
    -------------------------------------------------
    function zz_ventilationbox.Close()

    end;
    -------------------------------------------------
    function zz_ventilationbox.Reset ()

      if ( not cmn.IsEventDone( "win_ventilationbox" ) ) then

        private.ventilationbox_current_list = { 
          { 9, 9, 0, 0, 0, 0, 0, 9 },
          { 1, 0, 0, 9, 9, 9, 0, 0 },
          { 9, 9, 0, 0, 0, 0, 0, 0 },
          { 1, 0, 2, 9, 9, 9, 0, 0 },
          { 9, 0, 3, 9, 9, 3, 0, 0 },
          { 0, 0, 0, 0, 0, 0, 0, 0 },
          { 0, 9, 2, 0, 0, 0, 0, 0 },
          { 0, 0, 0, 0, 0, 0, 0, 0 }
        };

        ng_global.progress[ "std" ][ "win_ventilationbox" ].ventilationbox_current_list = { 
          { 9, 9, 0, 0, 0, 0, 0, 9 },
          { 1, 0, 0, 9, 9, 9, 0, 0 },
          { 9, 9, 0, 0, 0, 0, 0, 0 },
          { 1, 0, 2, 9, 9, 9, 0, 0 },
          { 9, 0, 3, 9, 9, 3, 0, 0 },
          { 0, 0, 0, 0, 0, 0, 0, 0 },
          { 0, 9, 2, 0, 0, 0, 0, 0 },
          { 0, 0, 0, 0, 0, 0, 0, 0 }
        };

        private.ventilationbox_first = true;

        for j = 1, #private.ventilationbox_current_list do
    
          for i = 1, #private.ventilationbox_current_list[ j ] do
      
            local name = "spr_ventilationbox_square_"..j.."_"..i;

            local type = private.ventilationbox_current_list[ j ][ i ];

            if ( type == 0 or type == 1 or type == 2 or type == 3 ) then

              ObjSet( name, { input = true, alp = 0 } );

            end;

          end;

        end;

      end;

    end;
    -------------------------------------------------
    function zz_ventilationbox.Skip ()

      if ( cmn.IsEventDone( "use_levermonitor" ) ) and ( not cmn.IsEventDone( "win_ventilationbox" ) ) then

        private.VentilationboxWinAnim();

      end;

    end;

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_tortureroom();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();

  common_impl.EnvPlay( { "level3/env/aud_tortureroom_env" }, "", 0.5 );
  common_impl.EnvPlay( { "level1/env/aud_electri_env" }, "", 0.5 );

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_handlebox1 ()

  local item = "inv_handlebox1";

  if cmn.ApplyObj( item, "gzz_tortureroom_boxes" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_boxes", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_boxes_use_handlebox1" ) ) then

    cmn.CallEventHandler( "use_handlebox1_inv" );
    cmn.CallEventHandler( "use_handlebox1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_handlebox1" );
      cmn.CallEventHandler( "use_handlebox1_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk3", 0, "", 0 );

    ObjAnimate( "spr_boxes_handle_1", "alp",   0, 0, func_end, { 0,3,0,  0.4,3,1 } );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_handlebox2 ()

  local item = "inv_handlebox2";

  if cmn.ApplyObj( item, "gzz_tortureroom_boxes" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_boxes", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_boxes_use_handlebox2" ) ) then

    cmn.CallEventHandler( "use_handlebox2_inv" );
    cmn.CallEventHandler( "use_handlebox2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_handlebox2" );
      cmn.CallEventHandler( "use_handlebox2_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk3", 0, "", 0 );

    ObjAnimate( "spr_boxes_handle_2", "alp",   0, 0, func_end, { 0,3,0,  0.4,3,1 } );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_fuselev ()

  local item = "inv_fuselev";

  if cmn.ApplyObj( item, "gzz_tortureroom_boxes" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_boxes", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_boxes_use_fuselev" ) ) then

    cmn.CallEventHandler( "use_fuselev_inv" );
    cmn.CallEventHandler( "use_fuselev_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_fuselev" );
      cmn.CallEventHandler( "use_fuselev_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_fuselev", 0, "", 0 );

    ObjAnimate( "spr_boxes_fuse",     "alp",   0, 0, "", { 0,3,0,  0.4,3,1,  0.8,2,1,  1.2,3,0 } );
    ObjAnimate( "spr_boxes_fuse_2",   "alp",   0, 0, "", { 0,3,0,  0.8,3,0,  1.0,2,1 } );
    ObjAnimate( "spr_boxes_combinationnumbers",     "pos_y", 0, 0, func_end, { 0,3,-67,   1.0,3,-67, 1.4,3,4 } );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_decomposedcane ()

  local item = "inv_decomposedcane";

  if cmn.ApplyObj( item, "gzz_tortureroom_monitorscreen" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_monitorscreen", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_monitorscreen_use_decomposedcane" ) ) then

    cmn.CallEventHandler( "use_decomposedcane_inv" );
    cmn.CallEventHandler( "use_decomposedcane_beg" );

    local func_anim = function ()

      local func_end = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_decomposedcane" );
        cmn.CallEventHandler( "use_decomposedcane_end" );

        cmn.MiniGameShow( "lines" );
        common_impl.PassingMgStart( "lines" );

      end;

      ObjAnimate( "spr_monitorscreen_back_2",   "alp",   0, 0, func_end, { 0,3,0,  0.4,3,1 } );
      
      ObjAnimate( "spr_monitorscreen_button",   "alp", 0, 0, "", { 0,3,0,   0.4,3,0,  0.6,3,1 } );
      ObjAnimate( "spr_monitorscreen_light",    "alp", 0, 0, "", { 0,3,1,   0.4,3,1,  0.6,3,0 } );

      ObjAnimate( "spr_monitorscreen_tv_3",   "alp", 0, 0, "", { 0,3,0,   0.4,3,0,  0.6,3,1,  0.8,3,0,  1,3,1 } );
      ObjAnimate( "spr_monitorscreen_mg_1",   "alp", 0, 0, "", { 0,3,0,   1.0,3,0,  1.4,3,1 } );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide_3", 0, "", 0 );

    AnimPlay( "anm_monitorscreen_monitor", "DoAnim", func_anim );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_diod ()

  local item = "inv_diod";

  if cmn.ApplyObj( item, "gzz_tortureroom_electricalpanel" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_electricalpanel", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_electricalpanel_use_diod" ) ) then

    cmn.CallEventHandler( "use_diod_inv" );
    cmn.CallEventHandler( "use_diod_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_diod" );
      cmn.CallEventHandler( "use_diod_end" );

      cmn.MiniGameShow( "electricalpanel_2" );
      common_impl.PassingMgStart( "electricalpanel_2" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_diod", 0, "", 0 );

    ObjAnimate( "spr_electricalpanel_diod",           "alp", 0, 0, "", { 0,3,0,  0.6,3,1 } );
    ObjAnimate( "spr_electricalpanel_door_2_green",   "alp", 0, 0, "", { 0,3,0,   0.6,3,0,  1.0,3,1 } );
    ObjAnimate( "spr_electricalpanel_door_2_red",     "alp", 0, 0, "", { 0,3,1,   0.6,3,1,  1.0,3,0 } );

    ObjAnimate( "spr_electricalpanel_door_2",   "pos_x", 0, 0, func_end, { 0,3,162,   1.0,3,162,  1.5,3,460 } );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_emergencyswitch ()

  local item = "inv_emergencyswitch";

  if cmn.ApplyObj( item, "gzz_tortureroom_electricalpanel" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_electricalpanel", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_electricalpanel_use_emergencyswitch" ) ) then

    cmn.CallEventHandler( "use_emergencyswitch_inv" );
    cmn.CallEventHandler( "use_emergencyswitch_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_emergencyswitch" );
      cmn.CallEventHandler( "use_emergencyswitch_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

    ObjAnimate( "spr_electricalpanel_lever", "alp", 0, 0, func_end, { 0,3,0,  0.6,3,1 } );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_levermonitor ()

  local item = "inv_levermonitor";

  if cmn.ApplyObj( item, "gzz_tortureroom_levers" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_levers", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_levers_use_levermonitor" ) ) then

    cmn.CallEventHandler( "use_levermonitor_inv" );
    cmn.CallEventHandler( "use_levermonitor_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_levermonitor" );
      cmn.CallEventHandler( "use_levermonitor_end" );

      cmn.MiniGameShow( "levers" );
      common_impl.PassingMgStart( "levers" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_levermonitor", 0, "", 0 );

    ObjAnimate( "spr_levers_lever_3",  "alp", 0, 0, "", { 0,3,0,  0.6,3,1 } );
    ObjAnimate( "spr_levers_door",     "ang", 0, 0, "", { 0,3,0,  0.6,3,0,  1.2,3,0.2 } );
    ObjAnimate( "spr_levers_door",     "pos_y", 0, 0, func_end, { 0,3,-33,  0.6,3,-33,  1.2,3,400 } );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_combinationnumbers ()

  local item = "inv_combinationnumbers";

  if cmn.ApplyObj( item, "gzz_tortureroom_levers" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_levers", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_levers_use_combinationnumbers" ) ) then

    cmn.CallEventHandler( "use_combinationnumbers_inv" );
    cmn.CallEventHandler( "use_combinationnumbers_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_combinationnumbers" );
      cmn.CallEventHandler( "use_combinationnumbers_end" );

      cmn.MiniGameShow( "levers_2" );
      common_impl.PassingMgStart( "levers_2" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );

    ObjAnimate( "spr_levers_code",  "alp", 0, 0, func_end, { 0,3,0,  0.6,3,1 } );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_hammerbox ()

  local item = "inv_hammerbox";

  if cmn.ApplyObj( item, "gzz_tortureroom_monitorscreen" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_monitorscreen", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_monitorscreen_use_hammerbox" ) ) then

    cmn.CallEventHandler( "use_hammerbox_inv" );
    cmn.CallEventHandler( "use_hammerbox_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_hammerbox" );
      cmn.CallEventHandler( "use_hammerbox_end" );

      cmn.MiniGameShow( "keystv" );
      common_impl.PassingMgStart( "keystv" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_hammer", 0, "", 0 );

    ObjSet( "vid_monitorscreen_hammer", { alp = 1 } );
    VidPlay( "vid_monitorscreen_hammer", func_end );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_pepper_spray ()

  local item = "inv_pepper_spray";

  if ( cmn.ApplyObj( item, "obj_tortureroom_use_pepper_spray" ) ) then

    interface.InventoryItemRemove( "inv_pepper_spray" );

    private.Outro( 1 )

    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_handlebox1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_handlebox1" );
  cmn.CallEventHandler( "get_handlebox1" );

end;
--------------------------------------------------------------------------------------------
function private.get_handlebox2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_handlebox2" );
  cmn.CallEventHandler( "get_handlebox2" );
  
  
    if port.isPortable()==1 then
      iOS_RateMe();
    end;
end;
--------------------------------------------------------------------------------------------
function private.get_cane ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_cane" );
  cmn.CallEventHandler( "get_cane" );

end;
--------------------------------------------------------------------------------------------
function private.get_hammerbox ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.Lock( true );

  cmn.CallEventHandler( "get_hammerbox_beg" );
  cmn.CallEventHandler( "get_hammerbox_inv" );

  ObjAnimate( "spr_boxes_back_2", "alp", 0, 0, private.get_hammerbox_end, { 0,3,0,  0.4,3,1 } );

end;

function private.get_hammerbox_end ()

  cmn.Lock( false );
  cmn.SetEventDone( "get_hammerbox" );
  cmn.CallEventHandler( "get_hammerbox_end" );

end;
--------------------------------------------------------------------------------------------
function private.get_diod ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_diod" );
  cmn.CallEventHandler( "get_diod" );

end;
--------------------------------------------------------------------------------------------
function private.get_levermonitor ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_levermonitor" );
  cmn.CallEventHandler( "get_levermonitor" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_fuselev ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_fuselev" );
  cmn.CallEventHandler( "get_fuselev" );

end;
--------------------------------------------------------------------------------------------
function private.get_combinationnumbers ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_combinationnumbers" );
  cmn.CallEventHandler( "get_combinationnumbers" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_emergencyswitch ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_emergencyswitch" );
  cmn.CallEventHandler( "get_emergencyswitch" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_pepper_spray ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_pepper_spray" );
  cmn.CallEventHandler( "get_pepper_spray" );

  common.CloseSubRoom();

end;
----
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--------------------------------------------------------------------------------------------
function private.clk_doorbox1 ()

  cmn.CallEventHandler( "clk_doorbox1_beg" );

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "clk_doorbox1" );
    cmn.CallEventHandler( "clk_doorbox1_end" );

    cmn.MiniGameShow( "boxes_1" );
    common_impl.PassingMgStart( "boxes_1" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide1", 0, "", 0 );

  ObjAnimate( "spr_boxes_door_1",   "pos_x", 0, 0, func_end, { 0,3,-18, 0.6,3,-700 } );
    
end;
--------------------------------------------------------------------------------------------
function private.clk_doorbox2 ()

  cmn.CallEventHandler( "clk_doorbox2_beg" );

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "clk_doorbox2" );
    cmn.CallEventHandler( "clk_doorbox2_end" );

    cmn.MiniGameShow( "boxes_2" );
    common_impl.PassingMgStart( "boxes_2" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide1", 0, "", 0 );

  ObjAnimate( "spr_boxes_door_2",   "pos_x", 0, 0, func_end, { 0,3,-18, 0.6,3,-700 } );
    
end;
--------------------------------------------------------------------------------------------
function private.clk_emergencyswitch ()

  cmn.CallEventHandler( "clk_emergencyswitch_beg" );

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "clk_emergencyswitch" );
    cmn.CallEventHandler( "clk_emergencyswitch_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_lever", 0, "", 0 );

  ObjAnimate( "spr_electricalpanel_lever",     "alp", 0, 0, "", { 0,3,1, 0.6,3,0 } );
  ObjAnimate( "spr_electricalpanel_lever_2",   "alp", 0, 0, "", { 0,3,0, 0.6,3,1 } );
  
  ObjAnimate( "obj_electricalpanel_choice",    "alp", 0, 0, func_end, { 0,3,0, 1.0,3,0, 1.6,3,1 } );

end;
----------------------------------------------------------------------------------------
function private.clk_outro_2 ()

  local func_end = function ()

    cmn.Lock( false );

    private.Outro( 2 );

  end;

  cmn.Lock( true );

  ObjAnimate( "spr_electricalpanel_button_2",    "alp", 0, 0, func_end, { 0,3,0,  0.2,3,1,  0.6,3,1 } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
function private.opn_tortureroom ()

  if not ( cmn.IsEventDone( "opn_tortureroom" ) ) then

    cmn.SetEventDone( "opn_tortureroom" );

    common_impl.ShowBbt( "bbt_tortureroom_opn_tortureroom" );

  end;

  cmn.CallEventHandler( "opn_tortureroom" ); 

end;
--*********************************************************************************************************************
function private.Outro ( number ) 

  local func_end = function ()
  
    iOS_RegisterGameplay("level_4"); 
    cmn.SetEventDone( "see_outro_3" );
    cmn.CallEventHandler( "see_outro_3" );

    common_impl.StopAudio( "sfx", "level3/sfx/aud_outro3lvl_var"..number, 0.2 );

    common_impl.StopAudio( "voc", "level3/voc/aud_outro3lvl_var"..number.."_voc", 0.2 );

    cmn.GotoRoom( "rm_credits" );

  end; 
  
  common.CloseSubRoom();

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_outro3lvl_var"..number, 0, "", 0 );

  common_impl.PlayAudio( "voc", "level3/voc/aud_outro3lvl_var"..number.."_voc", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_tortureroom_outro_"..number, func_end ); 
  
end;
--*********************************************************************************************************************
--function *** Mmg Electricalpanel 1 ***()
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.Electricalpanel1Init ()

    private.electricalpanel_1_current_list = { false, false, false, false, false, false, false, false, false, false, false, false };
    private.electricalpanel_1_list         = { 1, 2, 3, 4, 5, 6, 1, 2, 3, 4, 5, 6 };
    private.electricalpanel_1_prev_number  = "";
    
    local table_multiset = {}

    for s = 1, 12 do
      
      table.insert( table_multiset, { "spr_electricalpanel_mg_1_square_"..s, { event_mdown = function () private.Electricalpanel1ClkButton( s ) end } } );

    end;

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.Electricalpanel1ClkButton ( number )

    cmn.Lock( true );

    local func_unlock = function ()

      cmn.Lock( false );

    end;

    local obj_name  = "spr_electricalpanel_mg_1_square_"..number;
    local over_name = "spr_electricalpanel_mg_1_square_"..number.."_over";
   
    local prev_number = private.electricalpanel_1_prev_number;

    if ( private.electricalpanel_1_prev_number == number ) then

      ObjAnimate( obj_name,  "scale_x", 0, 0, func_unlock, { 0,3,1,  0.2,3,0,  0.4,3,1 } );
      ObjAnimate( over_name, "alp", 0, 0, "", { 0,3,0,  0.2,3,0,  0.2,3,1 } );

      private.electricalpanel_1_prev_number = "";

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk6", 0, "", 0 );

    elseif ( prev_number ~= "" ) then

      local obj_name_prev  = "spr_electricalpanel_mg_1_square_"..prev_number;
      local over_name_prev = "spr_electricalpanel_mg_1_square_"..prev_number.."_over";

      if ( private.electricalpanel_1_list[ number ] == private.electricalpanel_1_list[ prev_number ] ) then

        ObjSet( obj_name,      { input = false } );
        ObjSet( obj_name_prev, { input = false } );

        local func_anim_end = function ()

          cmn.Lock( false );

          private.Electricalpanel1ClkButtonEnd( number, prev_number );

        end;

        common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_button2", 0, "", 0 );

        ObjAnimate( obj_name,  "scale_x", 0, 0, func_anim_end, { 0,3,1,  0.2,3,0,  0.4,3,1 } );
        ObjAnimate( over_name, "alp",     0, 0, "",            { 0,3,1,  0.2,3,1,  0.2,3,0 } );

      else

        ObjAnimate( obj_name,  "scale_x", 0, 0, func_unlock, { 0,3,1,  0.2,3,0,  0.4,3,1,  1.0,3,1,  1.2,3,0,  1.4,3,1 } );
        ObjAnimate( over_name, "alp",     0, 0, "",          { 0,3,1,  0.2,3,1,  0.2,3,0,  1.2,3,0,  1.2,3,1 } );

        ObjAnimate( obj_name_prev,  "scale_x", 0, 0, "", { 0,3,1,  1.0,3,1,  1.2,3,0,  1.4,3,1 } );
        ObjAnimate( over_name_prev, "alp",     0, 0, "", { 0,3,0,  1.2,3,0,  1.2,3,1 } );

        common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

      end;

      private.electricalpanel_1_prev_number = "";

    else

      ObjAnimate( obj_name,  "scale_x", 0, 0, func_unlock, { 0,3,1,  0.2,3,0,  0.4,3,1 } );
      ObjAnimate( over_name, "alp", 0, 0, "", { 0,3,1,  0.2,3,1,  0.2,3,0 } );

      private.electricalpanel_1_prev_number = number;

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk6", 0, "", 0 );

    end;

  end;
  --*********************************************************************************************************************
  function private.Electricalpanel1ClkButtonEnd ( number, prev_number )

    private.electricalpanel_1_current_list[ number ]      = true;
    private.electricalpanel_1_current_list[ prev_number ] = true;

    local flag_win = true;
    
    for i = 1, #private.electricalpanel_1_current_list do
      
      if ( not private.electricalpanel_1_current_list[ i ] ) then

        flag_win = false;
        break;

      end

    end;

    if ( flag_win ) then

      private.Electricalpanel1WinAnim();

    else

      ng_global.progress[ "std" ][ "win_electricalpanel_1" ].electricalpanel_1_current_list = {}

      for i = 1, #private.electricalpanel_1_current_list do
    
        ng_global.progress[ "std" ][ "win_electricalpanel_1" ].electricalpanel_1_current_list[ i ] = private.electricalpanel_1_current_list[ i ];

      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.Electricalpanel1WinAnim ()

    local func_end = function ()

      private.Electricalpanel1Win ()

      cmn.Lock( false );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide1", 0, "", 0 );

    ObjAnimate( "obj_electricalpanel_mg_1", "pos_x", 0, 0, func_end, { 0,3,0,  0.8,3,-244 } );

  end;
  --*********************************************************************************************************************
  function private.Electricalpanel1Win ()

    cmn.MiniGameHide( "electricalpanel_1" );
    common_impl.PassingMgWin( "electricalpanel_1" );
    cmn.SetEventDone( "win_electricalpanel_1" );
    cmn.CallEventHandler( "win_electricalpanel_1" );

  end;
--*********************************************************************************************************************
--function *** Mmg Electricalpanel 2 ***()
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.Electricalpanel2Init ()

    private.electricalpanel_2_current_list = { false, false, false, false, false, false };
    private.electricalpanel_2_list         = { 1, 2, 2, 3, 3, 1 };
    private.electricalpanel_2_prev_number  = "";
    
    local table_multiset = {}

    for s = 1, 6 do
      
      table.insert( table_multiset, { "spr_electricalpanel_mg_2_square_"..s, { event_mdown = function () private.Electricalpanel2ClkButton( s ) end } } );

    end;

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.Electricalpanel2ClkButton ( number )

    local func_unlock = function ()

      cmn.Lock( false );

    end;

    local obj_name    = "spr_electricalpanel_mg_2_square_"..number;
    local light_name  = "spr_electricalpanel_mg_2_square_"..number.."_light";

    local prev_number = private.electricalpanel_2_prev_number;

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_menter1", 0, "", 0 );

    if ( private.electricalpanel_2_prev_number == number ) then

      ObjSet( light_name, { alp = 0 } );

      private.electricalpanel_2_prev_number = "";

    elseif ( prev_number ~= "" ) then

      local obj_name_prev   = "spr_electricalpanel_mg_2_square_"..prev_number;
      local light_name_prev = "spr_electricalpanel_mg_2_square_"..prev_number.."_light";

      ObjSet( light_name_prev, { alp = 0 } );

      if ( private.electricalpanel_2_list[ number ] == private.electricalpanel_2_list[ prev_number ] ) then

        cmn.Lock( true );

        ObjSet( obj_name,      { input = false } );
        ObjSet( obj_name_prev, { input = false } );

        local func_anim_end = function ()

          cmn.Lock( false );

          private.Electricalpanel2ClkButtonEnd( number, prev_number );

        end;

        ObjAnimate( obj_name,      "alp", 0, 0, func_anim_end, { 0,3,1,  0.2,3,0 } );
        ObjAnimate( obj_name_prev, "alp", 0, 0, "",            { 0,3,1,  0.2,3,0 } );

        ObjAnimate( "spr_electricalpanel_mg_2_square_2_"..private.electricalpanel_2_list[ number ].."_over", "alp", 0, 0, "", { 0,3,1,  0.2,3,0 } );

        common_impl.PlayAudio( "sfx", "level1/sfx/aud_mmg_code_clk", 0, "", 0 );

      else

        ObjSet( light_name, { alp = 0 } );

        common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

      end;

      private.electricalpanel_2_prev_number = "";

    else

      ObjSet( light_name, { alp = 1 } );

      private.electricalpanel_2_prev_number = number;

    end;

  end;
  --*********************************************************************************************************************
  function private.Electricalpanel2ClkButtonEnd ( number, prev_number )

    private.electricalpanel_2_current_list[ number ]      = true;
    private.electricalpanel_2_current_list[ prev_number ] = true;

    local flag_win = true;
    
    for i = 1, #private.electricalpanel_2_current_list do
      
      if ( not private.electricalpanel_2_current_list[ i ] ) then

        flag_win = false;
        break;

      end

    end;

    if ( flag_win ) then

      private.Electricalpanel2WinAnim();

    else

      ng_global.progress[ "std" ][ "win_electricalpanel_2" ].electricalpanel_2_current_list = {}

      for i = 1, #private.electricalpanel_2_current_list do
    
        ng_global.progress[ "std" ][ "win_electricalpanel_2" ].electricalpanel_2_current_list[ i ] = private.electricalpanel_2_current_list[ i ];

      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.Electricalpanel2WinAnim ()

    local func_end = function ()

      private.Electricalpanel2Win ()

      cmn.Lock( false );

    end;

    cmn.Lock( true );

    ObjAnimate( "obj_electricalpanel_mg_2", "pos_x", 0, 0, func_end, { 0,3,0,  0.8,3,244 } );

  end;
  --*********************************************************************************************************************
  function private.Electricalpanel2Win ()

    cmn.MiniGameHide( "electricalpanel_2" );
    common_impl.PassingMgWin( "electricalpanel_2" );
    cmn.SetEventDone( "win_electricalpanel_2" );
    cmn.CallEventHandler( "win_electricalpanel_2" );

  end;
--*********************************************************************************************************************
--function *** Mmg Boxes 1 ***()
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.Boxes1Init ()

    private.boxes_1_state    = 1;
    private.boxes_1_win_list = { 5, 6, 1 };
    
    private.boxes_1_pos_begin = 0;
    private.boxes_1_pos_step  = -105;

    local table_multiset = {}

    for b = 1, 6 do
      
      table.insert( table_multiset, { "obj_boxesl_mg_1_buttons_"..b, { event_mdown = function () private.Boxes1ClkButton( b ) end } } );

    end;

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.Boxes1ClkButton ( number )

    cmn.Lock( true );

    local func_unlock = function ()

      cmn.Lock( false );

    end;

    if ( number == private.boxes_1_win_list[ private.boxes_1_state ] ) then
 
      local func_end = function ()

        cmn.Lock( false );

        private.Boxes1ClkButtonEnd();

      end;

      common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk11", 0, "", 0 );

      ObjAnimate( "spr_boxes_green_"..number, "alp", 0, 0, func_end, { 0,3,0,  0.4,3,1,  0.8,3,1,  1.2,3,0 } );

      if ( private.boxes_1_state < 3 ) then

        local old_y = ObjGet( "spr_boxes_arms" ).pos_y;
        local new_y = private.boxes_1_pos_begin + ( private.boxes_1_state ) * private.boxes_1_pos_step;
        ObjAnimate( "spr_boxes_arms", "pos_y", 0, 0, "", { 0,3,old_y,  0.4,3,old_y,  0.8,3,new_y } );

      end;

    else
 
      common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

      ObjAnimate( "spr_boxes_red_"..number, "alp", 0, 0, func_unlock, { 0,3,0,  0.4,3,1,  0.8,3,1,  1.2,3,0 } );

    end;

  end;
  --*********************************************************************************************************************
  function private.Boxes1ClkButtonEnd ()

    private.boxes_1_state = private.boxes_1_state + 1;

    if ( private.boxes_1_state == 4 ) then

      private.Boxes1WinAnim();

    else

      ng_global.progress[ "std" ][ "win_boxes_1" ].boxes_1_state = private.boxes_1_state

    end;

  end;
  --*********************************************************************************************************************
  function private.Boxes1WinAnim ()

    local func_end = function ()

      private.Boxes1Win ()

      cmn.Lock( false );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide", 0, "", 0 );

    ObjAnimate( "obj_boxes_mg_1_move", "pos_y", 0, 0, func_end, { 0,3,0,  0.8,3,-320 } );

  end;
  --*********************************************************************************************************************
  function private.Boxes1Win ()

    cmn.MiniGameHide( "boxes_1" );
    common_impl.PassingMgWin( "boxes_1" );
    cmn.SetEventDone( "win_boxes_1" );
    cmn.CallEventHandler( "win_boxes_1" );

  end;
--*********************************************************************************************************************
--function *** Mmg Boxes 2 ***()
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.Boxes2Init ()

    private.boxes_2_prev_number  = 0;
    private.boxes_2_current_list = { 1, 3, 2, 5, 4, 6 };
    
    private.boxes_2_win_list = { 5, 3, 2, 6, 4, 1 };
    private.boxes_2_pos      = { { -97, 128 }, { 15, 128 }, { 127, 128 }, { -97, 216 }, { 15, 216 }, { 127, 216 } };

    local table_multiset = {}

    for b = 1, #private.boxes_2_current_list do
      
      table.insert( table_multiset, { "spr_boxes_puzzle_"..b, { event_mdown = function () private.Boxes2ClkButton( b ) end } } );

      local number = private.boxes_2_current_list[ b ];
      local pos    = private.boxes_2_pos[ b ];

      table.insert( table_multiset, { "spr_boxes_puzzle_"..number, { pos_x = pos[ 1 ], pos_y = pos[ 2 ] } } );

    end;

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.Boxes2ClkButton ( number )

    local cur_name  = "spr_boxes_puzzle_"..number;
    local prev_name = "spr_boxes_puzzle_"..private.boxes_2_prev_number;


    common_impl.PlayAudio( "sfx", "level1/sfx/aud_menter1", 0, "", 0 );

    if ( private.boxes_2_prev_number == 0 ) then

      ObjSet( cur_name.."_light", { alp = 1 } );

      private.boxes_2_prev_number = number;

    elseif ( private.boxes_2_prev_number == number ) then

      ObjSet( cur_name.."_light", { alp = 0 } );

      private.boxes_2_prev_number = 0;

    else

      common_impl.Lock( true );

      local func_end = function ()

        common_impl.Lock( false );

        private.Boxes2ClkEnd( number, private.boxes_2_prev_number );

        private.boxes_2_prev_number = 0;

      end;
  
      local index = private.Boxes2GetPosToArray( number );

      local old_params = ObjGet( prev_name );
      local new_params = ObjGet( cur_name );
      
      ObjSet( prev_name.."_light", { alp = 0 } );

      ObjAnimate( prev_name, "pos_xy", 0, 0, func_end, 
      { 
        0,   3,  old_params.pos_x,  old_params.pos_y,  
        0.4, 3,  new_params.pos_x,  new_params.pos_y
      } );

      ObjAnimate( cur_name, "pos_xy", 0, 0, "", 
      { 
        0,   3,  new_params.pos_x,  new_params.pos_y,  
        0.4, 3,  old_params.pos_x,  old_params.pos_y
      } );

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk6", 0, "", 0 );

    end;  

  end;
  --*********************************************************************************************************************
  function private.Boxes2GetPosToArray ( number )

    for i = 1, #private.boxes_2_current_list do
    
      if ( private.boxes_2_current_list[ i ] == number ) then

        return i;

      end;
  
    end;

  end;
  --*********************************************************************************************************************
  function private.Boxes2AllLightOff ()

    for i = 1, #private.boxes_2_current_list do
    
      ObjSet( "spr_boxes_2_mg_1_picture_"..i.."_light", { alp = 0 } );
  
    end;

  end;
  --*********************************************************************************************************************
  function private.Boxes2ClkEnd ( number, prev_number )

    local index      = private.Boxes2GetPosToArray( number );
    local prev_index = private.Boxes2GetPosToArray( prev_number );

    private.boxes_2_current_list[ index ], private.boxes_2_current_list[ prev_index ] = 
    private.boxes_2_current_list[ prev_index ], private.boxes_2_current_list[ index ];
    
    local flag_win = true;

    for i = 1, #private.boxes_2_win_list do
      
      if ( private.boxes_2_current_list[ i ] ~= private.boxes_2_win_list[ i ] ) then

        flag_win = false;
        break;

      end;

    end;

    if ( flag_win ) then

      private.Boxes2WinAnim();

    else

      ng_global.progress[ "std" ][ "win_boxes_2" ].boxes_2_current_list = {};

      for i = 1, #private.boxes_2_current_list do
    
        ng_global.progress[ "std" ][ "win_boxes_2" ].boxes_2_current_list[ i ] = private.boxes_2_current_list[ i ];

      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.Boxes2WinAnim ()

    local func_end = function ()

      private.Boxes2Win ()

      cmn.Lock( false );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide", 0, "", 0 );

    ObjAnimate( "obj_boxes_mg_2_move", "pos_y", 0, 0, func_end, { 0,3,0,  0.8,3,320 } );

  end;
  --*********************************************************************************************************************
  function private.Boxes2Win ()

    cmn.MiniGameHide( "boxes_2" );
    common_impl.PassingMgWin( "boxes_2" );
    cmn.SetEventDone( "win_boxes_2" );
    cmn.CallEventHandler( "win_boxes_2" );

  end;
--*********************************************************************************************************************
--function *** Mmg Lines ***()
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.LinesInit ()

    private.lines_current_list  = {};
    private.lines_state         = 1;

    private.lines_win_list      = {};
    private.lines_win_list[ 1 ] = { { 19, 1 }, { 3, 20 }, { 11, 3 }, { 7, 11 }, { 7, 9 }, { 5, 9 }, { 19, 11 }, { 13, 19 }, { 17, 13 }, { 15, 13 } };
    private.lines_win_list[ 2 ] = { { 3, 2 }, { 14, 3 }, { 17, 14 }, { 13, 17 }, { 16, 14 }, { 5, 16 }, { 8, 5 }, { 6, 10 } };
    private.lines_prev_number  = "";
    
    local table_multiset = {}

    for c = 1, 21 do
      
      table.insert( table_multiset, { "spr_monitorscreen_circle_"..c, { event_mdown = function () private.LinesClkButton( c ) end } } );

    end;

    for c = 1, 18 do
      
      table.insert( table_multiset, { "spr_monitorscreen_circle_2_"..c, { event_mdown = function () private.LinesClkButton( c ) end } } );

    end;

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.LinesClkButton ( number )

    local prev_number = private.lines_prev_number;

    local obj_name       = "spr_monitorscreen_circle_"..number;
    local obj_name_prev  = "spr_monitorscreen_circle_"..prev_number;
    local light_name     = "spr_monitorscreen_light_mg";

    if ( private.lines_state == 2 ) then

      light_name = "spr_monitorscreen_light_mg_2";
      obj_name   = "spr_monitorscreen_circle_2_"..number;
      obj_name_prev  = "spr_monitorscreen_circle_2_"..prev_number;

    end;

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_click2", 0, "", 0 );

    if ( prev_number == number ) then

      ObjSet( light_name, { visible = false } );

      private.lines_prev_number = "";

    elseif ( prev_number ~= "" ) then

      if ( not private.LinesIsExistEdge( number, prev_number ) ) then

        private.LinesEdgeSet( number, prev_number );

        local func_anim_end = function ()

          cmn.Lock( false );

          private.LinesClkButtonEnd( number, prev_number );

        end;  

        cmn.Lock( true );

        if ( private.lines_state == 1 ) then

          ObjAnimate( "spr_monitorscreen_line_"..prev_number.."_"..number, "alp", 0, 0, func_anim_end, { 0,3,0,  0.2,3,1 } );

        else
  
          ObjAnimate( "spr_monitorscreen_line_2_"..prev_number.."_"..number, "alp", 0, 0, func_anim_end, { 0,3,0,  0.2,3,1 } );

        end;

        common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide_4", 0, "", 0 );

      end;

      ObjSet( light_name, { visible = false } );

      private.lines_prev_number = "";

    else

      local pos = ObjGet( obj_name );
      ObjSet( light_name, { visible = true, pos_x = pos.pos_x, pos_y = pos.pos_y } );

      private.lines_prev_number = number;

    end;

  end;
  --*********************************************************************************************************************
  function private.LinesClkButtonEnd ( number, prev_number )

    table.insert( private.lines_current_list, { number, prev_number } );

    local flag_win = true;
    
    if ( #private.lines_current_list ~= #private.lines_win_list[ private.lines_state ] ) then

      flag_win = false;

    else

      for i = 1, #private.lines_current_list do
        
        local vertex = private.lines_win_list[ private.lines_state ][ i ];
        local exist = private.LinesIsExistEdge ( vertex[ 1 ], vertex[ 2 ] )

        if ( not exist ) then

          flag_win = false;
          break;

        end

      end;

    end;

    if ( flag_win ) then

      if ( private.lines_state == 1 ) then

        local func_end = function ()

          cmn.Lock( false );

          private.lines_state = 2;
          ng_global.progress[ "std" ][ "win_lines" ].lines_state = private.lines_state;

          private.lines_current_list = {};
          ng_global.progress[ "std" ][ "win_lines" ].lines_current_list = {};

          private.LinesWinState1();

        end;

        cmn.Lock( true );

        ObjAnimate( "spr_monitorscreen_mg_1",      "alp", 0, 0, func_end, { 0,3,1,  0.3,3,0 } );
        ObjAnimate( "obj_monitorscreen_circles",   "alp", 0, 0, "", { 0,3,1,  0.3,3,0 } );
        ObjAnimate( "spr_monitorscreen_mg_2",      "alp", 0, 0, "", { 0,3,0,  0.3,3,1 } );
        ObjAnimate( "obj_monitorscreen_circles_2", "alp", 0, 0, "", { 0,3,0,  0.3,3,1 } );

        common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_whoosh", 0, "", 0 );

      else

        private.LinesWinAnim();

      end;

    else

      ng_global.progress[ "std" ][ "win_lines" ].lines_state = private.lines_state;
      ng_global.progress[ "std" ][ "win_lines" ].lines_current_list = {}

      for i = 1, #private.lines_current_list do
    
        ng_global.progress[ "std" ][ "win_lines" ].lines_current_list[ i ] = private.lines_current_list[ i ];

      end;

    end;

  end;

  --*********************************************************************************************************************
  function private.LinesEdgeSet ( number_1, number_2 )

    local obj_name_1   = "spr_monitorscreen_circle_"..number_1;
    local obj_name_2   = "spr_monitorscreen_circle_"..number_2;
    local line_name    = "spr_monitorscreen_line";
    local attach_name  = "obj_monitorscreen_circles";

    if ( private.lines_state == 2 ) then

      obj_name_1 = "spr_monitorscreen_circle_2_"..number_1;
      obj_name_2 = "spr_monitorscreen_circle_2_"..number_2;
      line_name  = "spr_monitorscreen_line_2";
      attach_name  = "obj_monitorscreen_circles_2";

    end;

    ObjSet( obj_name_1, { alp = 1 } );
    ObjSet( obj_name_2, { alp = 1 } );

    local obj_pos_1 = ObjGet( obj_name_1 );

    local obj1 = GetObjPosByObj( obj_name_1 );
    local obj2 = GetObjPosByObj( obj_name_2 );

    local line_params = private.LinesDraw( obj1[ 1 ], obj1[ 2 ], obj2[ 1 ], obj2[ 2 ] );

    ObjClone( line_name, "_"..number_2.."_"..number_1, 0, attach_name );

    ObjSet( line_name.."_"..number_2.."_"..number_1, { 
      alp     = 1, 
      pos_x   = obj_pos_1.pos_x, 
      pos_y   = obj_pos_1.pos_y, 
      ang     = line_params.ang,
      scale_x = line_params.length / 2
    } );

  end;

  --*********************************************************************************************************************
  function private.LinesIsExistEdge ( vertex_1, vertex_2 )

    for i = 1, #private.lines_current_list do
    
      local current_line = private.lines_current_list[ i ];

      if ( current_line[ 1 ] == vertex_1 and current_line[ 2 ] == vertex_2 ) or 
         ( current_line[ 2 ] == vertex_1 and current_line[ 1 ] == vertex_2 ) then

        return true;

      end;

    end;

    return false;

  end;
  --*********************************************************************************************************************
  function private.LinesWinState1 ()

    ObjSet( "spr_monitorscreen_mg_1",      { alp = 0 } );
    ObjSet( "obj_monitorscreen_circles",   { alp = 0, input = false } );
    ObjSet( "spr_monitorscreen_mg_2",      { alp = 1 } );
    ObjSet( "obj_monitorscreen_circles_2", { alp = 1, input = true } );

  end;
  --*********************************************************************************************************************
  function private.LinesWinAnim ()

    local func_end = function ()

      private.LinesWin();

      cmn.Lock( false );

    end;

    cmn.Lock( true );

    ObjAnimate( "spr_monitorscreen_tv_4", "alp", 0, 0, "", { 0,3,0,  0.8,3,1 } );
    ObjAnimate( "obj_monitorscreen_mgs",  "alp", 0, 0, "", { 0,3,1,  0.8,3,0 } );
    ObjAnimate( "spr_monitorscreen_diod", "pos_y", 0, 0, func_end, { 0,3,55,  0.8,3,55,  1.6,3,162 } );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_whoosh", 0, "", 0 );

  end;

  --*********************************************************************************************************************
  function private.LinesWin ()

    cmn.MiniGameHide( "lines" );
    common_impl.PassingMgWin( "lines" );
    cmn.SetEventDone( "win_lines" );
    cmn.CallEventHandler( "win_lines" );

  end;
--********************************************************************************************************************
--********************************************************************************************************************
  function private.LinesDraw ( x_1, y_1, x_2, y_2 )

    local a = x_2 - x_1;
    local b = y_2 - y_1;

    local length = math.sqrt( b * b + a * a );
    local ang =  - math.atan2( b, a );

    return { length = length, ang = ang }

  end;

--*********************************************************************************************************************
--function *** Mmg Keystv ***()
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.KeystvInit ()

    private.keystv_current_list  = { 2, 3, 1, 4 };

    private.keystv_win_list   = { 4, 1, 3, 2 };
    private.keystv_win_list_2 = { 4, 2, 3, 1 };
 
    private.keystv_pos_x = { -104, -43, 27, 97 };

    private.keystv_prev_number = 0;

    local table_multiset = {}

    for k = 1, 4 do
      
      table.insert( table_multiset, { "spr_monitorscreen_key_"..k, { event_mdown = function () private.KeystvClkButton( k ) end } } );

      local number = private.keystv_current_list[ k ];

      ObjSet( "spr_monitorscreen_key_"..number, { pos_x = private.keystv_pos_x[ i ] } );

    end;

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.KeystvClkButton ( number )

    local cur_name = "spr_monitorscreen_key_"..number;

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_menter1", 0, "", 0 );

    if ( private.keystv_prev_number == 0 ) then

      ObjSet( cur_name.."_light", { alp = 1 } );

      private.keystv_prev_number = number;

    elseif ( private.keystv_prev_number == number ) then

      ObjSet( cur_name.."_light", { alp = 0 } );

      private.keystv_prev_number = 0;

    else

      common_impl.Lock( true );

      local prev_name = "spr_monitorscreen_key_"..private.keystv_prev_number;

      local func_end = function ()

        common_impl.Lock( false );

        private.KeystvClkButtonEnd( number, private.keystv_prev_number );

        private.keystv_prev_number = 0;

      end;
  
      local old_params = ObjGet( prev_name );
      local new_params = ObjGet( cur_name );
      
      ObjSet( prev_name.."_light", { alp = 0 } );

      ObjAnimate( prev_name, "pos_x", 0, 0, func_end, 
      { 
        0,   3,  old_params.pos_x,  
        0.4, 3,  new_params.pos_x
      } );

      ObjAnimate( cur_name, "pos_x", 0, 0, "", 
      { 
        0,   3,  new_params.pos_x,  
        0.4, 3,  old_params.pos_x
      } );

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide", 0, "", 0 );

    end;  

  end;
  --*********************************************************************************************************************
  function private.KeystvClkButtonEnd ( number, prev_number )

    local index      = private.KeystvGetPosToArray( number );
    local index_prev = private.KeystvGetPosToArray( prev_number );

    private.keystv_current_list[ index ] = prev_number;
    private.keystv_current_list[ index_prev ] = number;

    local flag_win = true;
    
    for i = 1, #private.keystv_current_list do
      
      if ( private.keystv_current_list[ i ] ~= private.keystv_win_list[ i ] ) then

        flag_win = false;
        break;

      end

    end;

    local flag_win_2 = true;
    
    for i = 1, #private.keystv_current_list do
      
      if ( private.keystv_current_list[ i ] ~= private.keystv_win_list_2[ i ] ) then

        flag_win_2 = false;
        break;

      end

    end;

    if ( flag_win ) or ( flag_win_2 ) then

      private.KeystvWinAnim();

    else

      ng_global.progress[ "std" ][ "win_keystv" ].keystv_current_list = {}

      for i = 1, #private.keystv_current_list do
    
        ng_global.progress[ "std" ][ "win_keystv" ].keystv_current_list[ i ] = private.keystv_current_list[ i ];

      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.KeystvGetPosToArray ( number )

    for i = 1, #private.keystv_current_list do
    
      if ( private.keystv_current_list[ i ] == number ) then

        return i;

      end;
  
    end;

  end;
  --*********************************************************************************************************************
  function private.KeystvWinAnim ()

    local func_end = function ()

      private.KeystvWin();

      cmn.Lock( false );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_win_keystv", 0, "", 0 );

    ObjAnimate( "spr_monitorscreen_key_back", "pos_y", 0, 0, "", { 0,3,-117,  0.6,3,14 } );
    ObjAnimate( "spr_monitorscreen_cover",    "alp", 0, 0, func_end, { 0,3,1,  0.8,3,1,  1.2,3,0 } );

  end;

  --*********************************************************************************************************************
  function private.KeystvWin ()

    cmn.MiniGameHide( "keystv" );
    common_impl.PassingMgWin( "keystv" );
    cmn.SetEventDone( "win_keystv" );
    cmn.CallEventHandler( "win_keystv" );

  end;
--*********************************************************************************************************************
--  function *** Mmg Levers ***() end
--*********************************************************************************************************************
  function private.LeversInit ()

    private.levers_current_list = { -83, -54, -28, 0, 24 };

    private.levers_first = true;

    private.levers_win_list = { -28, 24, -83, -83, -54 };
    
    private.levers_pos_down = 24;
    private.levers_pos_up   = -83;
    
    table_multiset = {};

    for i = 1, #private.levers_current_list do
          
      local pos_y = private.levers_current_list[ i ];

      table.insert( table_multiset, { "spr_levers_button_"..i, { pos_y = pos_y } } );

    end;

    for i = 1, 5 do
          
      table.insert( table_multiset, { "obj_levers_button_"..i.."_drag", { 
        event_drag     = function () private.LeversDrag( i ); end, 
        event_dragdrop = function () private.LeversDragDrop( i ); end 
      } } );
    
    end;

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.LeversDrag ( number )

    local name = "spr_levers_button_"..number;

    if ( private.levers_first ) then

      private.levers_pos_y_begin = {};
      local pos = GetZoomCursorPos();
      

      private.levers_cursor_pos_y_begin = pos[ 2 ];

      for i = 1, #private.levers_current_list do
     
        private.levers_pos_y_begin[ i ] = ObjGet( "spr_levers_button_"..i ).pos_y;

      end;

      private.levers_first = false;

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_well_clk1", 0, "", 0 );

    end;
      local pos = GetZoomCursorPos();

      local cursor_pos_y = pos[ 2 ];

    local delta_pos_y = private.LeversCorrectPos( cursor_pos_y - private.levers_cursor_pos_y_begin + private.levers_pos_y_begin[ number ] );

    ObjSet( name, { pos_y = delta_pos_y } );

  end;
  --*********************************************************************************************************************
  function private.LeversDragDrop ( number )
    
    private.levers_first = true;
    local name = "spr_levers_button_"..number;
    
    local pos = GetZoomCursorPos();
    if  tostring(GetPlatform()) == "android" then
      pos[2] = pos[2] - 100;
    elseif tostring(GetPlatform()) == "ios" then
      if port.isTablet() == 0 then
        pos[2] = pos[2] - 75;
      else
        pos[2] = pos[2] - 50;
      end;
    end;
    local cursor_pos_y = pos[ 2 ];

    local delta_pos_y = private.LeversCorrectPos( cursor_pos_y - private.levers_cursor_pos_y_begin + private.levers_pos_y_begin[ number ] );

    ObjSet( name, { pos_y = delta_pos_y } );
    
    

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_well_clk2", 0, "", 0 );

    for i = 1, #private.levers_current_list do
    
      private.levers_current_list[ i ] = ObjGet( "spr_levers_button_"..i ).pos_y;

    end;

    local flag_win = true;

    for i = 1, #private.levers_win_list do
      
      local delta = math.abs( private.levers_current_list[ i ] - private.levers_win_list[ i ] );

      if ( delta > 20 ) then

        flag_win = false;
        break;

      end;

    end;

    private.LeversLampSet();

    if ( flag_win ) then

      private.LeversWinAnim();

    else

      ng_global.progress[ "std" ][ "win_levers" ].levers_current_list = {};

      for i = 1, #private.levers_current_list do
      
        ng_global.progress[ "std" ][ "win_levers" ].levers_current_list[ i ] = private.levers_current_list[ i ];

      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.LeversCorrectPos ( pos_y, number_correct )

    local old_pos_y = pos_y;

    if ( pos_y < private.levers_pos_up ) then

      pos_y = private.levers_pos_up;

    elseif ( pos_y > private.levers_pos_down ) then

      pos_y = private.levers_pos_down;

    end;

    if ( number_correct ) and 
       ( pos_y == private.levers_pos_up or pos_y == private.levers_pos_down ) then
      local pos = GetZoomCursorPos();
      if private.levers_first == true then
        if  tostring(GetPlatform()) == "android" then
          pos[2] = pos[2] - 100;
        elseif tostring(GetPlatform()) == "ios" then
          if port.isTablet() == 0 then
            pos[2] = pos[2] - 75;
          else
            pos[2] = pos[2] - 50;
          end;
        end;
      end;

      private.levers_cursor_pos_y_begin = pos[ 2 ];

      for i = 1, 3 do
     
        private.levers_pos_y_begin[ i ] = ObjGet( "spr_levers_button_"..i ).pos_y;

      end;

    end;

    return pos_y;

  end;
  --*********************************************************************************************************************
  function private.LeversLampSet ()

    table_multiset = {};

    for i = 1, #private.levers_current_list do
      
      local delta = math.abs( private.levers_current_list[ i ] - private.levers_win_list[ i ] );

      if ( delta < 8 ) then

        table.insert( table_multiset, { "spr_levers_button_"..i.."_green", { alp = 1 } } );   

        table.insert( table_multiset, { "spr_levers_fuse_red_"..i,    { alp = 0 } } );   
        table.insert( table_multiset, { "spr_levers_fuse_green_"..i, { alp = 1 } } );   

        table.insert( table_multiset, { "spr_levers_red_"..i,         { alp = 0 } } );   
        table.insert( table_multiset, { "spr_levers_green_"..i,       { alp = 1 } } );   

      else

        table.insert( table_multiset, { "spr_levers_button_"..i.."_green", { alp = 0 } } );   

        table.insert( table_multiset, { "spr_levers_fuse_red_"..i,    { alp = 1 } } );   
        table.insert( table_multiset, { "spr_levers_fuse_green_"..i, { alp = 0 } } );   

        table.insert( table_multiset, { "spr_levers_red_"..i,         { alp = 1 } } );   
        table.insert( table_multiset, { "spr_levers_green_"..i,       { alp = 0 } } );   

      end;

    end;

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.LeversWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.LeversWin();

    end;

    ObjAnimate( "spr_levers_fuselev", "pos_y", 0, 0, func_end, 
    { 
      0.0, 3, -218,  
      0.6, 3, -133,  
    } );   

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_lamp", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.LeversWin ()

    ng_global.progress[ "std" ][ "win_levers" ].levers_current_list = {};

    for i = 1, #private.levers_current_list do
    
      ng_global.progress[ "std" ][ "win_levers" ].levers_current_list[ i ] = private.levers_win_list[ i ];

    end;

    cmn.MiniGameHide( "levers" );
    common_impl.PassingMgWin( "levers" );
    cmn.SetEventDone( "win_levers" );
    cmn.CallEventHandler( "win_levers" );

  end;
--*********************************************************************************************************************
--  function *** Mmg Levers2 ***() end
--*********************************************************************************************************************
  function private.Levers2Init ()

    private.levers_2_current_list = { 149, 149, 149 };

    private.levers_2_first = true;

    private.levers_2_win_list = { 215, 93, 149 };
    
    private.levers_2_pos_down = 215;
    private.levers_2_pos_up   = 93;
    
    table_multiset = {};

    for i = 1, #private.levers_2_current_list do
          
      local pos_y = private.levers_2_current_list[ i ];

      table.insert( table_multiset, { "spr_levers_lever_"..i, { pos_y = pos_y } } );
  
      table.insert( table_multiset, { "obj_levers_lever_"..i.."_drag", { 
        event_drag     = function () private.Levers2Drag( i ); end, 
        event_dragdrop = function () private.Levers2DragDrop( i ); end 
      } } );
    
    end;

    for i = 1, 5 do
        
    end;

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  private.last_pos_y = nil;
  function private.Levers2Drag ( number )

    local name = "spr_levers_lever_"..number;

    if ( private.levers_2_first ) then

      private.levers_2_pos_y_begin = {};
      local pos = GetZoomCursorPos();
      private.last_pos_y = pos[2];
      --DbgTrace("private.Levers2Drag Start number:"..tostring(number).." pos[2]:"..tostring(pos[2]));

      private.levers_2_cursor_pos_y_begin = pos[ 2 ];

      for i = 1, #private.levers_2_current_list do
     
        private.levers_2_pos_y_begin[ i ] = ObjGet( "spr_levers_lever_"..i ).pos_y;

      end;

      private.levers_2_first = false;

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_well_clk1", 0, "", 0 );

    end;
    
    local pos = GetZoomCursorPos();
    --DbgTrace("private.Levers2Drag Start Drag number:"..tostring(number).." pos[2]:"..tostring(pos[2]).." private.last_pos_y:"..tostring(private.last_pos_y));
    if private.last_pos_y - pos[2] > 80 or private.last_pos_y - pos[2] < -80 then
      pos[2] = private.last_pos_y;
    else
      private.last_pos_y = pos[2];
    end; 
    
    --DbgTrace("private.Levers2Drag Drag number:"..tostring(number).." pos[2]:"..tostring(pos[2]).." private.last_pos_y:"..tostring(private.last_pos_y));
    local cursor_pos_y = pos[ 2 ];

    local delta_pos_y = private.Levers2CorrectPos( cursor_pos_y - private.levers_2_cursor_pos_y_begin + private.levers_2_pos_y_begin[ number ] );

    ObjSet( name, { pos_y = delta_pos_y } );

    if ( number == 1 ) then

      local pos_y_3 = private.Levers2CorrectPos( cursor_pos_y - private.levers_2_cursor_pos_y_begin + private.levers_2_pos_y_begin[ 3 ], 3 );
      --DbgTrace("private.Levers2Drag Drag number = 1 number:"..tostring(number).." pos[2]:"..tostring(pos[2]));
      ObjSet( "spr_levers_lever_3", { pos_y = pos_y_3 } );

    elseif ( number == 3 ) then

      local pos_y_2 = private.Levers2CorrectPos( - cursor_pos_y + private.levers_2_cursor_pos_y_begin + private.levers_2_pos_y_begin[ 2 ], 2 );

      ObjSet( "spr_levers_lever_2", { pos_y = pos_y_2 } );

    end;

  end;
  --*********************************************************************************************************************
  function private.Levers2DragDrop ( number )
    
    private.last_pos_y = nil;
    local pos = GetZoomCursorPos();
    local name = "spr_levers_lever_"..number;
    if  tostring(GetPlatform()) == "android" then
      pos[2] = pos[2] - 100;
    elseif tostring(GetPlatform()) == "ios" then
      if port.isTablet() == 0 then
        pos[2] = pos[2] - 75;
      else
        pos[2] = pos[2] - 50;
      end;
    end;
    local cursor_pos_y = pos[ 2 ];
    private.levers_2_first = true;
    --DbgTrace("private.Levers2DragDrop Stop number:"..tostring(number).." pos[2]:"..tostring(pos[2]));
    local delta_pos_y = private.Levers2CorrectPos( cursor_pos_y - private.levers_2_cursor_pos_y_begin + private.levers_2_pos_y_begin[ number ] );

    ObjSet( name, { pos_y = delta_pos_y } );

    if ( number == 1 ) then

      local pos_y_3 = private.Levers2CorrectPos( cursor_pos_y - private.levers_2_cursor_pos_y_begin + private.levers_2_pos_y_begin[ 3 ], 3 );

      ObjSet( "spr_levers_lever_3", { pos_y = pos_y_3 } );

    elseif ( number == 3 ) then

      local pos_y_2 = private.Levers2CorrectPos( - cursor_pos_y + private.levers_2_cursor_pos_y_begin + private.levers_2_pos_y_begin[ 2 ], 2 );

      ObjSet( "spr_levers_lever_2", { pos_y = pos_y_2 } );

    end;
    
    

    for i = 1, #private.levers_2_current_list do
    
      private.levers_2_current_list[ i ] = ObjGet( "spr_levers_lever_"..i ).pos_y;

    end;

    local flag_win = true;

    for i = 1, #private.levers_2_win_list do
      
      local delta = math.abs( private.levers_2_current_list[ i ] - private.levers_2_win_list[ i ] );

      if ( delta > 8 ) then

        flag_win = false;
        break;

      end;

    end;

    if ( flag_win ) then

      private.Levers2WinAnim();

    else

      ng_global.progress[ "std" ][ "win_levers_2" ].levers_2_current_list = {};

      for i = 1, #private.levers_2_current_list do
      
        ng_global.progress[ "std" ][ "win_levers_2" ].levers_2_current_list[ i ] = private.levers_2_current_list[ i ];

      end;

    end;

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_well_clk2", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.Levers2CorrectPos ( pos_y, number_correct )
    --DbgTrace("private.Levers2CorrectPos cal pos_y:"..tostring(pos_y).." number_correct:"..tostring(number_correct));
    local old_pos_y = pos_y;

    if ( pos_y < private.levers_2_pos_up ) then

      pos_y = private.levers_2_pos_up;

    elseif ( pos_y > private.levers_2_pos_down ) then

      pos_y = private.levers_2_pos_down;

    end;

    if ( number_correct ) and 
       ( pos_y == private.levers_2_pos_up or pos_y == private.levers_2_pos_down ) then
      local pos = GetZoomCursorPos();
      if private.levers_2_first == true then
        if  tostring(GetPlatform()) == "android" then
          pos[2] = pos[2] - 100;
        elseif tostring(GetPlatform()) == "ios" then
          if port.isTablet() == 0 then
            pos[2] = pos[2] - 75;
          else
            pos[2] = pos[2] - 50;
          end;
        end;
        --DbgTrace("private.Levers2CorrectPos Stop drag number:"..tostring(number).." pos[2]:"..tostring(pos[2]));
        
      end;
      DbgTrace("private.Levers2CorrectPos drag number:"..tostring(number).." pos[2]:"..tostring(pos[2]));
      private.levers_2_cursor_pos_y_begin = pos[ 2 ];

      for i = 1, 3 do
     
        private.levers_2_pos_y_begin[ i ] = ObjGet( "spr_levers_lever_"..i ).pos_y;

      end;

    end;

    return pos_y;

  end;
  --*********************************************************************************************************************
  function private.Levers2WinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.Levers2Win();

    end;

    ObjAnimate( "spr_levers_staircase", "pos_y", 0, 0, func_end, 
    { 
      0.0, 3, -600,  
      1.2, 3, -22,  
      2.0, 3, -22,  
    } );   

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide_3", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.Levers2Win ()

    ng_global.progress[ "std" ][ "win_levers_2" ].levers_2_current_list = {};

    for i = 1, #private.levers_2_current_list do
    
      ng_global.progress[ "std" ][ "win_levers_2" ].levers_2_current_list[ i ] = private.levers_2_win_list[ i ];

    end;

    cmn.MiniGameHide( "levers_2" );
    common_impl.PassingMgWin( "levers_2" );
    cmn.SetEventDone( "win_levers_2" );
    cmn.CallEventHandler( "win_levers_2" );

    common.CloseSubRoom();

  end;
--*********************************************************************************************************************
--  function *** Mmg Ventilationbox ***() end
--*********************************************************************************************************************
  function private.VentilationboxInit ()

    private.ventilationbox_current_list = { 
      { 9, 9, 0, 0, 0, 0, 0, 9 },
      { 1, 0, 0, 9, 9, 9, 0, 0 },
      { 9, 9, 0, 0, 0, 0, 0, 0 },
      { 1, 0, 2, 9, 9, 9, 0, 0 },
      { 9, 0, 3, 9, 9, 3, 0, 0 },
      { 0, 0, 0, 0, 0, 0, 0, 0 },
      { 0, 9, 2, 0, 0, 0, 0, 0 },
      { 0, 0, 0, 0, 0, 0, 0, 0 }
    };

    private.ventilationbox_win_list = { 
      { 9, 9, 4, 4, 4, 4, 4, 9 },
      { 4, 4, 4, 9, 9, 9, 4, 4 },
      { 9, 9, 5, 5, 5, 5, 5, 4 },
      { 4, 4, 5, 9, 9, 9, 5, 4 },
      { 9, 4, 6, 9, 9, 6, 5, 4 },
      { 4, 4, 6, 6, 6, 6, 5, 4 },
      { 4, 9, 5, 5, 5, 5, 5, 4 },
      { 4, 4, 4, 4, 4, 4, 4, 4 }
    };
    
    private.ventilationbox_pos_x = -184;
    private.ventilationbox_pos_y = -134;
    
    private.ventilationbox_step_x = 53;
    private.ventilationbox_step_y = 38;

    private.ventilationbox_color = { "red", "green", "yellow" };

    table_multiset = {};

    for j = 1, #private.ventilationbox_current_list do
        
      for i = 1, #private.ventilationbox_current_list[ j ] do
            
        local value = private.ventilationbox_current_list[ j ][ i ];

        if ( value ~= 9 ) then

          local pos_x = private.ventilationbox_pos_x + ( i - 1 ) * private.ventilationbox_step_x;
          local pos_y = private.ventilationbox_pos_y + ( j - 1 ) * private.ventilationbox_step_y;

          ObjClone( "spr_ventilationbox_square", "_"..j.."_"..i, 1, "obj_ventilationbox_mg" );

          table.insert( table_multiset, { "spr_ventilationbox_square_"..j.."_"..i, { 
            pos_x        = pos_x, 
            pos_y        = pos_y,
            visible      = true,
            input        = true,
            event_mdown  = function () private.VentilationboxDown( i, j ); end, 
            event_mup    = function () private.VentilationboxUp(); end,
            event_menter = function () private.VentilationboxEnter( i, j ); end
          } } );
    
        end;

      end;

    end;

    table.insert( table_multiset, { "obj_ventilationbox_out", { 
      event_mup    = function () private.VentilationboxUp(); end,
      event_mleave = function () private.VentilationboxOutLeave(); end
    } } );
    
    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.VentilationboxDown ( i, j )

    local name = "spr_ventilationbox_square_"..j.."_"..i;

    local value = private.ventilationbox_current_list[ j ][ i ];

    if ( value == 1 ) or ( value == 2 ) or ( value == 3 ) then

      local color = private.ventilationbox_color[ value ];

      ObjSet( name, { input = false, alp = 1, res = "assets/levels/level3/rm_tortureroom/zz_ventilationbox/layers/"..color } );

      private.ventilationbox_points = {};
      private.ventilationbox_points[ 1 ] = { i, j };

      private.ventilationbox_type = value;

    end;

  end;
  --*********************************************************************************************************************
  function private.VentilationboxUp ()

    private.ventilationbox_type = nil;

    if ( private.ventilationbox_points ) then

      if ( private.VentilationboxCheckLineEnd() ) then

        local point_beg = private.ventilationbox_points[ 1 ];
        local type_beg  = private.ventilationbox_current_list[ point_beg[ 2 ] ][ point_beg[ 1 ] ];

        for i = 1, #private.ventilationbox_points do
          
          local point = private.ventilationbox_points[ i ];

          private.ventilationbox_current_list[ point[ 2 ] ][ point[ 1 ] ] = type_beg + 3;

        end;    

        private.ventilationbox_points = {};

        private.VentilationboxCheckWin();

      else

        private.VentilationboxResetLine();

      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.VentilationboxEnter ( i, j )

    local name = "spr_ventilationbox_square_"..j.."_"..i;

    if ( private.ventilationbox_type ) then

      local is_neighbor = private.VentilationboxCheck( i, j );

      if ( is_neighbor ) then

        table.insert( private.ventilationbox_points, { i, j } );

        local color = private.ventilationbox_color[ private.ventilationbox_type ];

        ObjSet( name, { input = false, alp = 1, res = "assets/levels/level3/rm_tortureroom/zz_ventilationbox/layers/"..color } );

        if ( private.VentilationboxCheckLineEnd() ) then

          private.VentilationboxUp();

        end;

      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.VentilationboxCheck ( i, j )

    local point = private.ventilationbox_points[ #private.ventilationbox_points ];

    if ( i == point[ 1 ] and math.abs( point[ 2 ] - j ) == 1 ) or  
       ( j == point[ 2 ] and math.abs( point[ 1 ] - i ) == 1 ) then

      local type_first = private.ventilationbox_points[ 1 ];

      if ( private.ventilationbox_current_list[ j ][ i ] == 0 ) or
         ( private.ventilationbox_current_list[ j ][ i ] == private.ventilationbox_type ) then

        common_impl.PlayAudio( "sfx", "level1/sfx/aud_menter1", 0, "", 0 );

        return true;

      end;

    end;

    return false;

  end;
  --*********************************************************************************************************************
  function private.VentilationboxCheckLineEnd ()

    if ( private.ventilationbox_points and #private.ventilationbox_points >= 2 ) then

      local point_beg = private.ventilationbox_points[ 1 ];
      local point_end = private.ventilationbox_points[ #private.ventilationbox_points ];

      local type_beg = private.ventilationbox_current_list[ point_beg[ 2 ] ][ point_beg[ 1 ] ];
      local type_end = private.ventilationbox_current_list[ point_end[ 2 ] ][ point_end[ 1 ] ];

      if ( type_beg == type_end ) then

        common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_lamp", 0, "", 0 );
        return true;

      end;

    end;

    return false;

  end;
  --*********************************************************************************************************************
  function private.VentilationboxResetLine ()

    local tme = 0.05;

    local count_point = #private.ventilationbox_points

    for i = 1, #private.ventilationbox_points do
    
      local point = private.ventilationbox_points[ i ];

      local name = "spr_ventilationbox_square_"..point[ 2 ].."_"..point[ 1 ];

      local delay_time = ( count_point - i ) * tme;
      local anim_time  = delay_time + tme;

      common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

      ObjAnimate( name, "alp", 0, 0, "", { 0,3,1,  delay_time,3,1,  anim_time,3,0 } );

    end;

    local func_end = function ()

      for i = 1, #private.ventilationbox_points do
      
        local point = private.ventilationbox_points[ i ];

        local name = "spr_ventilationbox_square_"..point[ 2 ].."_"..point[ 1 ];

        ObjSet( name, { input = true } );

      end;

      private.ventilationbox_points = {};

      common_impl.Lock( false );

    end;

    common_impl.Lock( true );

    ObjSet( "tmr_ventilationbox_reset", { playing = 1, time = count_point * tme, endtrig = func_end } );

  end;
  --*********************************************************************************************************************
  function private.VentilationboxOutLeave ()

    local pos = GetZoomCursorPos();

    local pos_out = GetObjPosByObj( "obj_ventilationbox_out" );

    pos[ 1 ] = pos[ 1 ] - pos_out[ 1 ];
    pos[ 2 ] = pos[ 2 ] - pos_out[ 2 ];
    
    local border_x = 226; 
    local border_y = 156; 
  
    if ( pos[ 1 ] < -border_x ) or ( pos[ 1 ] > border_x ) or 
       ( pos[ 2 ] < -border_y ) or ( pos[ 2 ] > border_y ) then

      private.VentilationboxUp();

    end;

  end;
  --*********************************************************************************************************************
  function private.VentilationboxCheckWin ()

    local win_flag = true

    for j = 1, #private.ventilationbox_current_list do

      for i = 1, #private.ventilationbox_current_list[ j ] do
  
        if ( private.ventilationbox_current_list[ j ][ i ] ~= private.ventilationbox_win_list[ j ][ i ] ) then

          win_flag = false;
          break;

        end;

      end;

      if ( not win_flag ) then

        break;

      end;

    end;

    if ( win_flag ) then

      private.VentilationboxWinAnim();
    
    else

      ng_global.progress[ "std" ][ "win_ventilationbox" ].ventilationbox_current_list = {};

      for j = 1, #private.ventilationbox_current_list do
  
        ng_global.progress[ "std" ][ "win_ventilationbox" ].ventilationbox_current_list[ j ] = {};

        for i = 1, #private.ventilationbox_current_list[ j ] do
    
          ng_global.progress[ "std" ][ "win_ventilationbox" ].ventilationbox_current_list[ j ][ i ] = private.ventilationbox_current_list[ j ][ i ];

        end;

      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.VentilationboxWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.VentilationboxWin();

    end;

    ObjAnimate( "obj_ventilationbox_mg", "alp", 0, 0, func_end, 
    { 
      0.0, 3, 1,  
      0.6, 3, 0,  
    } );   

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_open", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.VentilationboxWin ()

    cmn.MiniGameHide( "ventilationbox" );
    common_impl.PassingMgWin( "ventilationbox" );
    cmn.SetEventDone( "win_ventilationbox" );
    cmn.CallEventHandler( "win_ventilationbox" );

  end;
--*********************************************************************************************************************