-- name=rm_ventilationshaft
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_ventilationshaft";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_blockeddoor", "room_hub" );
  ObjAttach( "zz_rustywall", "room_hub" );
  ObjAttach( "zz_controlunit", "room_hub" );
  ObjAttach( "zz_screw", "room_hub" );
  private.Init_Subroom();
  private.KeyPadInit();
  private.InitAnimations();
  
  ObjMultiSet({ 
    { "spr_blockeddoor_horizontaljack",           { event_mdown = private.get_horizontaljack      } },
    { "spr_rustywall_boltcutterpart1",            { event_mdown = private.get_boltcutterpart1     } },
    { "spr_rustywall_emergencybutton",            { event_mdown = private.get_emergencybutton     } },
    { "spr_rustywall_pliers",                     { event_mdown = private.get_pliers              } },
    { "spr_rustywall_wrench",                     { event_mdown = private.get_wrench              } },
    { "spr_rustywall_smallslider1",               { event_mdown = private.get_smallslider1        } },
    { "spr_controlunit_cable",                    { event_mdown = private.get_cable               } },
    { "spr_controlunit_sliderule",                { event_mdown = private.get_sliderule           } },
    { "spr_controlunit_wirereel",                 { event_mdown = private.get_wirereel            } },
    { "spr_screw_symbolset",                      { event_mdown = private.get_symbolset           } },
    { "spr_screw_code1",                          { event_mdown = private.get_code1               } },
    { "spr_screw_copperlogo",                     { event_mdown = private.get_copperlogo          } },
    { "spr_screw_screw1",                         { event_mdown = private.get_screw1              } },
    { "spr_ventilationshaft_inflatedmattress",    { event_mdown = private.get_inflatedmattress    } },

    { "spr_blockeddoor_block_door_close",         { event_mdown = private.clk_block_door          } },
    { "obj_screw_clk_door",                       { event_mdown = private.clk_emergencydoor       } },

    { "obj_rustywall_use_horizontaljack",         { event_mdown = private.RustywallClickDoors     } },
    { "obj_rustywall_clk_note",                   { event_mdown = private.RustywallClickNoteSmall } },
    { "obj_rustywall_clk_note_big",               { event_mdown = private.RustywallClickNoteBig   } },
    { "obj_screw_evidence",                       { event_mdown = private.ScrewClkNoteOpen        } },
    { "spr_screw_evidence_big",                   { event_mdown = private.ScrewClkNoteClose       } },

    { "obj_rustywall_use_bronzeamulet",           { event_mdown = private.AnimClkRustywallCover1  } },
    { "obj_rustywall_use_wirepiece",              { event_mdown = private.AnimClkRustywallCover2  } },

    { "spr_collect2_item_3_1",                    { event_mdown = private.get_collect2_item_3_1 } },
    { "spr_ventilationshaft_collect_morph_item",  { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_3_1" ); end } },
    { "spr_ventilationshaft_collect_item",        { event_mdown = function () common_impl.GetCollectItem( "get_collect_item_3_1" );     end } },
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_ventilationshaft = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "gzz_ventilationshaft_blockeddoor",
      "gzz_ventilationshaft_rustywall",
      "gzz_ventilationshaft_controlunit",
      "gzz_ventilationshaft_screw",
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_blockeddoor",
      "zz_rustywall",
      "zz_controlunit",
      "zz_screw",
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_ventilationshaft", update_game_mode_ventilationshaft, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_ventilationshaft = function ()

  local effects_table = 
  {
    "obj_ventilationshaft_anim" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_ventilationshaft", update_performance_mode_ventilationshaft, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_ventilationshaft () end;
  --------------------------------------------------------------------------------------------
  local opn_ventilationshaft_map = function ()

    common_impl.VisitMapRoom( "ventilationshaft" );
    common_impl.LockMapRoom( "archives", true );

  end;
  cmn.AddSubscriber( "opn_ventilationshaft", opn_ventilationshaft_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_horizontaljack () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_horizontaljack" ] = {
    type = "get",
    get_obj = "spr_blockeddoor_horizontaljack",
    room = private.room_objname,
    zz = "zz_blockeddoor",
    zz_gate = "gzz_ventilationshaft_blockeddoor"
  };
  
  local get_horizontaljack_inv = function ()
  
    interface.InventoryItemAdd( "inv_horizontaljack", "spr_blockeddoor_horizontaljack" );
  
  end;
  
  local get_horizontaljack_closezz = function ()
  
    ObjDelete( "spr_ventilationshaft_blockeddoor_2" ); 
    ObjDelete( "gfx_blockeddoor_horizontaljack"     );

    ObjSet( "spr_blockeddoor_rgt_door",                { input = false } );
    ObjSet( "spr_ventilationshaft_blockeddoor_door_1", { pos_x = 441   } );
    ObjSet( "spr_ventilationshaft_blockeddoor_door_2", { pos_x = 377   } );
    ObjSet( "spr_ventilationshaft_blockeddoor_door_2", { pos_x = 376, pos_y = 394 } );

  end;
  
  cmn.AddSubscriber( "get_horizontaljack", get_horizontaljack_inv );
  cmn.AddSubscriber( "get_horizontaljack", get_horizontaljack_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_boltcutterpart1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_boltcutterpart1" ] = {
    type = "get",
    get_obj = "spr_rustywall_boltcutterpart1",
    room = private.room_objname,
    zz = "zz_rustywall",
    zz_gate = "gzz_ventilationshaft_rustywall"
  };
  
  local get_boltcutterpart1_inv = function ()
  
    interface.InventoryItemAdd( "inv_boltcutterpart1", "spr_rustywall_boltcutterpart1" );
  
  end;
  
  local get_boltcutterpart1_closezz = function ()
  
    ObjDelete( "spr_rustywall_boltcutter_shadow"           );
    ObjDelete( "spr_ventilationshaft_rustywall_boltcutter" );
  
  end;
  
  cmn.AddSubscriber( "get_boltcutterpart1", get_boltcutterpart1_inv );
  cmn.AddSubscriber( "get_boltcutterpart1", get_boltcutterpart1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_emergencybutton () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_emergencybutton" ] = {
    type = "get",
    get_obj = "spr_rustywall_emergencybutton",
    room = private.room_objname,
    zz = "zz_rustywall",
    zz_gate = "gzz_ventilationshaft_rustywall"
  };
  
  local get_emergencybutton_inv = function ()
  
    interface.InventoryItemAdd( "inv_emergencybutton", "spr_rustywall_emergencybutton" );
  
  end;
  
  local get_emergencybutton_closezz = function ()
  
    ObjDelete( "spr_rustywall_button_shadow"           );
    ObjDelete( "spr_ventilationshaft_rustywall_button" );
  
  end;
  
  cmn.AddSubscriber( "get_emergencybutton", get_emergencybutton_inv );
  cmn.AddSubscriber( "get_emergencybutton", get_emergencybutton_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pliers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pliers" ] = {
    type = "get",
    get_obj = "spr_rustywall_pliers",
    room = private.room_objname,
    zz = "zz_rustywall",
    zz_gate = "gzz_ventilationshaft_rustywall"
  };
  
  local get_pliers_inv = function ()
  
    interface.InventoryItemAdd( "inv_pliers", "spr_rustywall_pliers" );
  
  end;
  
  local get_pliers_closezz = function ()
  
    ObjDelete( "spr_rustywall_pliers_shadow"           );
    ObjDelete( "spr_ventilationshaft_rustywall_pliers" );
  
  end;
  
  cmn.AddSubscriber( "get_pliers", get_pliers_inv );
  cmn.AddSubscriber( "get_pliers", get_pliers_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wrench () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wrench" ] = {
    type = "get",
    get_obj = "spr_rustywall_wrench",
    room = private.room_objname,
    zz = "zz_rustywall",
    zz_gate = "gzz_ventilationshaft_rustywall"
  };
  
  local get_wrench_inv = function ()
  
    interface.InventoryItemAdd( "inv_wrench", "spr_rustywall_wrench" );
  
  end;
  
  local get_wrench_closezz = function ()
  
    ObjDelete( "spr_rustywall_wrench_shadow"        );
    ObjDelete( "spr_ventilationshaft_rustywall_key" );
  
  end;
  
  cmn.AddSubscriber( "get_wrench", get_wrench_inv );
  cmn.AddSubscriber( "get_wrench", get_wrench_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_smallslider1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_smallslider1" ] = {
    type = "get",
    get_obj = "spr_rustywall_smallslider1",
    room = private.room_objname,
    zz = "zz_rustywall",
    zz_gate = "gzz_ventilationshaft_rustywall"
  };
  
  local get_smallslider1_inv = function ()
  
    interface.InventoryItemAdd( "inv_smallslider1", "spr_rustywall_smallslider1" );
  
  end;
  
  local get_smallslider1_closezz = function ()
  
    ObjDelete( "spr_rustywall_circle_shadow"             );
    ObjDelete( "spr_ventilationshaft_rustywall_button_1" );
  
  end;
  
  cmn.AddSubscriber( "get_smallslider1", get_smallslider1_inv );
  cmn.AddSubscriber( "get_smallslider1", get_smallslider1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cable () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cable" ] = {
    type = "get",
    get_obj = "spr_controlunit_cable",
    room = private.room_objname,
    zz = "zz_controlunit",
    zz_gate = "gzz_ventilationshaft_controlunit"
  };
  
  local get_cable_inv = function ()
  
    interface.InventoryItemAdd( "inv_cable", "spr_controlunit_cable" );
  
  end;
  
  local get_cable_closezz = function ()
  
    ObjDelete( "gfx_controlunit_cable" );
    ObjSet( "spr_controlunit_keypad", { input = false } );
    ObjSet( "obj_controlunit_use_key", { input = true } );
  
  end;
  
  cmn.AddSubscriber( "get_cable", get_cable_inv );
  cmn.AddSubscriber( "get_cable", get_cable_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sliderule () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sliderule" ] = {
    type = "get",
    get_obj = "spr_controlunit_sliderule",
    room = private.room_objname,
    zz = "zz_controlunit",
    zz_gate = "gzz_ventilationshaft_controlunit"
  };
  
  local get_sliderule_inv = function ()
  
    interface.InventoryItemAdd( "inv_sliderule", "spr_controlunit_sliderule" );
  
  end;
  
  local get_sliderule_closezz = function ()
  
    ObjDelete( "gfx_controlunit_sliderule" );
    ObjSet( "obj_controlunit_use_copperlogo", { input = true } );
    ObjSet( "spr_controlunit_open", { input = false } );
    ObjSet( "spr_controlunit_patch", { input = false } );
  
  end;
  
  cmn.AddSubscriber( "get_sliderule", get_sliderule_inv );
  cmn.AddSubscriber( "get_sliderule", get_sliderule_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wirereel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wirereel" ] = {
    type = "get",
    get_obj = "spr_controlunit_wirereel",
    room = private.room_objname,
    zz = "zz_controlunit",
    zz_gate = "gzz_ventilationshaft_controlunit"
  };
  
  local get_wirereel_inv = function ()
  
    interface.InventoryItemAdd( "inv_wirereel", "spr_controlunit_wirereel" );
    ObjSet( "inv_wirereel", { drag = false } );

  end;
  
  local get_wirereel_closezz = function ()
  
    ObjDelete( "gfx_controlunit_wirereel" );

    if ( cmn.IsGetCollect2( "get_collect2_item_3_1" ) ) then

      ObjDelete( "gzz_ventilationshaft_controlunit" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_wirereel", get_wirereel_inv );
  cmn.AddSubscriber( "get_wirereel", get_wirereel_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_symbolset () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_symbolset" ] = {
    type = "get",
    get_obj = "spr_screw_symbolset",
    room = private.room_objname,
    zz = "zz_screw",
    zz_gate = "gzz_ventilationshaft_screw"
  };
  
  local get_symbolset_inv = function ()
  
    interface.InventoryItemAdd( "inv_symbolset", "spr_screw_symbolset" );
  
  end;
  
  local get_symbolset_closezz = function ()
  
    ObjDelete( "gfx_screw_symbolset" );

    if ( cmn.IsEventDone( "get_code1" ) ) then

      ObjSet( "obj_screw_use_wrench", { input = true } );
      ObjSet( "obj_screw_use_sliderule", { input = true } )

    end;
  
  end;
  
  cmn.AddSubscriber( "get_symbolset", get_symbolset_inv );
  cmn.AddSubscriber( "get_symbolset", get_symbolset_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_code1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_code1" ] = {
    type = "get",
    get_obj = "spr_screw_code1",
    room = private.room_objname,
    zz = "zz_screw",
    zz_gate = "gzz_ventilationshaft_screw"
  };
  
  local get_code1_inv = function ()
  
    interface.InventoryItemAdd( "inv_code1", "spr_screw_code1" );
  
  end;
  
  local get_code1_closezz = function ()
  
    ObjDelete( "gfx_screw_code1" );

    if ( cmn.IsEventDone( "get_symbolset" ) ) then

      ObjSet( "obj_screw_use_wrench", { input = true } );
      ObjSet( "obj_screw_use_sliderule", { input = true } )

    end;
  
  end;
  
  cmn.AddSubscriber( "get_code1", get_code1_inv );
  cmn.AddSubscriber( "get_code1", get_code1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_copperlogo () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_copperlogo" ] = {
    type = "get",
    get_obj = "spr_screw_copperlogo",
    room = private.room_objname,
    zz = "zz_screw",
    zz_gate = "gzz_ventilationshaft_screw"
  };
  
  local get_copperlogo_inv = function ()
  
    interface.InventoryItemAdd( "inv_copperlogo", "spr_screw_copperlogo" );
  
  end;
  
  local get_copperlogo_closezz = function ()
  
    ObjDelete( "gfx_screw_copperlogo" );
  
  end;
  
  cmn.AddSubscriber( "get_copperlogo", get_copperlogo_inv );
  cmn.AddSubscriber( "get_copperlogo", get_copperlogo_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_screw1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_screw1" ] = {
    type = "get",
    get_obj = "spr_screw_screw1",
    room = private.room_objname,
    zz = "zz_screw",
    zz_gate = "gzz_ventilationshaft_screw"
  };
  
  local get_screw1_inv = function ()
  
    interface.InventoryItemAdd( "inv_screw", "spr_screw_screw1" );
    ObjSet( "inv_screw", { frame = ObjGet( "inv_screw" ).frame + 1 } );
  
  end;
  
  local get_screw1_closezz = function ()
  
    ObjDelete( "gfx_screw_screw1" );
    ObjDelete( "gzz_ventilationshaft_screw" );
  
  end;
  
  cmn.AddSubscriber( "get_screw1", get_screw1_inv );
  cmn.AddSubscriber( "get_screw1", get_screw1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_inflatedmattress () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_inflatedmattress" ] = {
    type = "get",
    get_obj = "spr_ventilationshaft_inflatedmattress",
    room = private.room_objname 
  };
  
  local get_inflatedmattress_inv = function ()
  
    interface.InventoryItemAdd( "inv_inflatedmattress", "spr_ventilationshaft_inflatedmattress" );
  
  end;
  
  local get_inflatedmattress_closezz = function ()
  
    ObjDelete( "gfx_ventilationshaft_inflatedmattress" );
  
  end;
  
  cmn.AddSubscriber( "get_inflatedmattress", get_inflatedmattress_inv );
  cmn.AddSubscriber( "get_inflatedmattress", get_inflatedmattress_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_3_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_3_1 = function ()
  
    ObjDelete( "obj_ventilationshaft_collect" );
  
  end;    
  cmn.AddSubscriber( "get_collect_item_3_1", get_collect_item_3_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_3_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_3_1 = function ()
  
    ObjDelete( "obj_collect2_item_3_1" );

    if ( cmn.IsEventDone( "get_wirereel" ) ) then

      ObjDelete( "gzz_ventilationshaft_controlunit" );

    end;
  
  end;    
  cmn.AddSubscriber( "get_collect2_item_3_1", get_collect2_item_3_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_3_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_3_1 = function ()
  
    ObjDelete( "obj_ventilationshaft_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_3_1", get_collect_morph_item_3_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cable () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cable" ] = {
    type = "use",
    inv_obj = "inv_cable",
    use_place = "obj_blockeddoor_use_cable",
    room = private.room_objname,
    zz = "zz_blockeddoor",
    zz_gate = "gzz_ventilationshaft_blockeddoor"
  };
  local use_cable_inv = function ()
  
    interface.InventoryItemRemove( "inv_cable" );
  
  end;
  local use_cable_beg = function ()
  
    ObjDelete( "obj_blockeddoor_use_cable" );
  
  end;
  local use_cable_end = function ()

    ObjMultiSet({ 
      { "grm_ventilationshaft_powerunit",          { input = true, visible = true, active = true } },
      { "spr_ventilationshaft_blockeddoor_4",      { alp = 1                                     } },
    });
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_ventilationshaft_powerunit_focus");
    end;
    ObjDelete( "gzz_ventilationshaft_blockeddoor" );

    ObjDelete( "spr_ventilationshaft_blockeddoor_door_1" );
    ObjDelete( "spr_ventilationshaft_blockeddoor_door_2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cable", use_cable_beg, private.room_objname );
  cmn.AddSubscriber( "use_cable", use_cable_inv );
  cmn.AddSubscriber( "use_cable", use_cable_end, private.room_objname );
  cmn.AddSubscriber( "use_cable_inv", use_cable_inv, private.room_objname );
  cmn.AddSubscriber( "use_cable_beg", use_cable_beg, private.room_objname );
  cmn.AddSubscriber( "use_cable_end", use_cable_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_horizontaljack () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_horizontaljack" ] = {
    type = "use",
    inv_obj = "inv_horizontaljack",
    use_place = "obj_rustywall_use_horizontaljack",
    room = private.room_objname,
    zz = "zz_rustywall",
    zz_gate = "gzz_ventilationshaft_rustywall"
  };
  local use_horizontaljack_inv = function ()
  
    interface.InventoryItemRemove( "inv_horizontaljack" );
  
  end;
  local use_horizontaljack_beg = function ()
  
    ObjDelete( "obj_rustywall_use_horizontaljack" );
  
  end;
  local use_horizontaljack_end = function ()

    ObjMultiSet({ 
      { "spr_rustywall_boltcutterpart1",  { input = true  } },
      { "gfx_rustywall_boltcutterpart1",  { active = true  } },
      { "spr_rustywall_emergencybutton",  { input = true  } },
      { "gfx_rustywall_emergencybutton",  { active = true } },

      { "spr_rustywall_door_rgt",         { pos_x = 247   } },
      { "spr_rustywall_door_lft_open",    { alp = 1       } },

      { "obj_rustywall_use_wirepiece",    { input = true  } },
      { "obj_rustywall_use_bronzeamulet", { input = true  } },

      { "obj_ventilationshaft_rustywall", { alp = 1       } },
      { "anm_rustywall_use_wire",         { alp = 1       } }

    });

    ObjDelete( "spr_rustywall_door_lft" );
    ObjDelete( "vid_rustywall_jack" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_horizontaljack", use_horizontaljack_beg, private.room_objname );
  cmn.AddSubscriber( "use_horizontaljack", use_horizontaljack_inv );
  cmn.AddSubscriber( "use_horizontaljack", use_horizontaljack_end, private.room_objname );
  cmn.AddSubscriber( "use_horizontaljack_inv", use_horizontaljack_inv, private.room_objname );
  cmn.AddSubscriber( "use_horizontaljack_beg", use_horizontaljack_beg, private.room_objname );
  cmn.AddSubscriber( "use_horizontaljack_end", use_horizontaljack_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wirepiece () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wirepiece" ] = {
    type = "use",
    inv_obj = "inv_wirepiece",
    use_place = "obj_rustywall_use_wirepiece",
    room = private.room_objname,
    zz = "zz_rustywall",
    zz_gate = "gzz_ventilationshaft_rustywall"
  };
  local use_wirepiece_inv = function ()
  
    interface.InventoryItemRemove( "inv_wirepiece" );
  
  end;
  local use_wirepiece_beg = function ()
  
    ObjDelete( "obj_rustywall_use_wirepiece" );
  
  end;
  local use_wirepiece_end = function ()
  
    ObjMultiSet({ 
      { "spr_rustywall_pliers", { input = true  }},
      { "gfx_rustywall_pliers", { active = true }},
    });

    ObjDelete( "anm_rustywall_use_wire" );
    ObjDelete( "spr_rustywall_cover_bot"                );
    ObjDelete( "spr_ventilationshaft_rustywall_cover_2" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wirepiece", use_wirepiece_beg, private.room_objname );
  cmn.AddSubscriber( "use_wirepiece", use_wirepiece_inv );
  cmn.AddSubscriber( "use_wirepiece", use_wirepiece_end, private.room_objname );
  cmn.AddSubscriber( "use_wirepiece_inv", use_wirepiece_inv, private.room_objname );
  cmn.AddSubscriber( "use_wirepiece_beg", use_wirepiece_beg, private.room_objname );
  cmn.AddSubscriber( "use_wirepiece_end", use_wirepiece_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bronzeamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bronzeamulet" ] = {
    type = "use",
    inv_obj = "inv_bronzeamulet",
    use_place = "obj_rustywall_use_bronzeamulet",
    room = private.room_objname,
    zz = "zz_rustywall",
    zz_gate = "gzz_ventilationshaft_rustywall"
  };
  local use_bronzeamulet_inv = function ()
  
    interface.InventoryItemRemove( "inv_bronzeamulet" );
  
  end;
  local use_bronzeamulet_beg = function ()
  
    ObjDelete( "obj_rustywall_use_bronzeamulet" );
  
  end;
  local use_bronzeamulet_end = function ()
  
    ObjMultiSet({ 
      { "spr_rustywall_wrench",       { input =  true } },
      { "gfx_rustywall_wrench",       { active = true } },
      { "spr_rustywall_smallslider1", { input =  true } },
      { "gfx_rustywall_smallslider1", { active = true } },
      { "obj_rustywall_clk_photo",    { input =  true } },
      { "obj_rustywall_clk_note",     { input =  true } },
    })

    ObjDelete( "spr_rustywall_cover_top"                );
    ObjDelete( "spr_ventilationshaft_rustywall_cover_1" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bronzeamulet", use_bronzeamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_bronzeamulet", use_bronzeamulet_inv );
  cmn.AddSubscriber( "use_bronzeamulet", use_bronzeamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_bronzeamulet_inv", use_bronzeamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_bronzeamulet_beg", use_bronzeamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_bronzeamulet_end", use_bronzeamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_symbolset () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_symbolset" ] = {
    type = "use",
    inv_obj = "inv_symbolset",
    use_place = "obj_controlunit_use_symbolset",
    room = private.room_objname,
    zz = "zz_controlunit",
    zz_gate = "gzz_ventilationshaft_controlunit"
  };
  local use_symbolset_inv = function ()
  
    interface.InventoryItemRemove( "inv_symbolset" );
  
  end;
  local use_symbolset_beg = function ()
  
    ObjDelete( "obj_controlunit_use_symbolset" );
  
  end;
  local use_symbolset_end = function ()
 
    ObjMultiSet({ 
      { "spr_controlunit_keypad",             { input = true } },
      { "spr_controlunit_code",               { alp = 1      } },
      { "spr_ventilationshaft_controlunit_1", { alp = 1      } },
    })
     
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_symbolset", use_symbolset_beg, private.room_objname );
  cmn.AddSubscriber( "use_symbolset", use_symbolset_inv );
  cmn.AddSubscriber( "use_symbolset", use_symbolset_end, private.room_objname );
  cmn.AddSubscriber( "use_symbolset_inv", use_symbolset_inv, private.room_objname );
  cmn.AddSubscriber( "use_symbolset_beg", use_symbolset_beg, private.room_objname );
  cmn.AddSubscriber( "use_symbolset_end", use_symbolset_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_copperlogo () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_copperlogo" ] = {
    type = "use",
    inv_obj = "inv_copperlogo",
    use_place = "obj_controlunit_use_copperlogo",
    room = private.room_objname,
    zz = "zz_controlunit",
    zz_gate = "gzz_ventilationshaft_controlunit"
  };
  local use_copperlogo_inv = function ()
  
    interface.InventoryItemRemove( "inv_copperlogo" );
  
  end;
  local use_copperlogo_beg = function ()
  
    ObjDelete( "obj_controlunit_use_copperlogo" );
  
  end;
  local use_copperlogo_end = function ()
  
    ObjMultiSet({ 
      { "spr_controlunit_cable",  { input = true, active = true } },
      { "spr_controlunit_keypad", { input = true                } },
      { "spr_controlunit_amulet", { alp = 1                     } },

      { "spr_ventilationshaft_controlunit_3", { alp = 1         } },
    })

    ObjDelete( "spr_controlunit_button_1"           );
    ObjDelete( "spr_ventilationshaft_controlunit_2" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_copperlogo", use_copperlogo_beg, private.room_objname );
  cmn.AddSubscriber( "use_copperlogo", use_copperlogo_inv );
  cmn.AddSubscriber( "use_copperlogo", use_copperlogo_end, private.room_objname );
  cmn.AddSubscriber( "use_copperlogo_inv", use_copperlogo_inv, private.room_objname );
  cmn.AddSubscriber( "use_copperlogo_beg", use_copperlogo_beg, private.room_objname );
  cmn.AddSubscriber( "use_copperlogo_end", use_copperlogo_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_key () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_key" ] = {
    type = "use",
    inv_obj = "inv_key",
    use_place = "obj_controlunit_use_key",
    room = private.room_objname,
    zz = "zz_controlunit",
    zz_gate = "gzz_ventilationshaft_controlunit"
  };
  local use_key_inv = function ()
  
    interface.InventoryItemRemove( "inv_key" );
  
  end;
  local use_key_beg = function ()
  
    ObjDelete( "obj_controlunit_use_key" );
  
  end;
  local use_key_end = function ()
  
    ObjSet( "spr_controlunit_wirereel", { input = true } );
    ObjSet( "spr_controlunit_keypad", { input = true, pos_x = -230 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_key", use_key_beg, private.room_objname );
  cmn.AddSubscriber( "use_key", use_key_inv );
  cmn.AddSubscriber( "use_key", use_key_end, private.room_objname );
  cmn.AddSubscriber( "use_key_inv", use_key_inv, private.room_objname );
  cmn.AddSubscriber( "use_key_beg", use_key_beg, private.room_objname );
  cmn.AddSubscriber( "use_key_end", use_key_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_emergencybutton () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_emergencybutton" ] = {
    type = "use",
    inv_obj = "inv_emergencybutton",
    use_place = "obj_screw_use_emergencybutton",
    room = private.room_objname,
    zz = "zz_screw",
    zz_gate = "gzz_ventilationshaft_screw"
  };
  local use_emergencybutton_inv = function ()
  
    interface.InventoryItemRemove( "inv_emergencybutton" );
  
  end;
  local use_emergencybutton_beg = function ()
  
    ObjDelete( "obj_screw_use_emergencybutton" );
  
  end;
  local use_emergencybutton_end = function ()
  
    ObjDelete( "spr_screw_latch_close" );
    ObjDelete( "spr_screw_button_over" );

    ObjMultiSet({ 
      { "spr_screw_button",       { alp = 1      } },
      { "spr_screw_light_button", { alp = 1      } },
      { "spr_screw_door",         { pos_x = 72   } },
      { "obj_screw_clk_door",     { input = true } },

      { "spr_ventilationshaft_screw_emergencybutton",       { alp =  1 } },
      { "spr_ventilationshaft_screw_light_emergencybutton", { alp =  1 } },
    })
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_emergencybutton", use_emergencybutton_beg, private.room_objname );
  cmn.AddSubscriber( "use_emergencybutton", use_emergencybutton_inv );
  cmn.AddSubscriber( "use_emergencybutton", use_emergencybutton_end, private.room_objname );
  cmn.AddSubscriber( "use_emergencybutton_inv", use_emergencybutton_inv, private.room_objname );
  cmn.AddSubscriber( "use_emergencybutton_beg", use_emergencybutton_beg, private.room_objname );
  cmn.AddSubscriber( "use_emergencybutton_end", use_emergencybutton_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wrench1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wrench1" ] = {
    type = "use",
    inv_obj = "inv_wrench",
    use_place = "obj_screw_use_wrench",
    room = private.room_objname,
    zz = "zz_screw",
    zz_gate = "gzz_ventilationshaft_screw"
  };
  local use_wrench1_inv = function ()
  
    if cmn.IsEventDone( "use_wrench2" ) then 
      interface.InventoryItemRemove( "inv_wrench" );
    end; 
  
  end;
  local use_wrench1_beg = function ()
  
    ObjDelete( "obj_screw_use_wrench" );
  
  end;
  local use_wrench1_end = function ()
  
    ObjMultiSet({ 
      { "spr_screw_screw1",   { input = true } },
      { "gfx_screw_screw1",   { active = true } },
      { "obj_screw_evidence", { input = true } },
    })

    ObjDelete( "anm_screw_wheel" );

    ObjDelete( "spr_screw_screw_over" );
    ObjDelete( "spr_ventilationshaft_screw_over" );
    ObjDelete( "vid_screw_key" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wrench1", use_wrench1_beg, private.room_objname );
  cmn.AddSubscriber( "use_wrench1", use_wrench1_inv );
  cmn.AddSubscriber( "use_wrench1", use_wrench1_end, private.room_objname );
  cmn.AddSubscriber( "use_wrench1_inv", use_wrench1_inv, private.room_objname );
  cmn.AddSubscriber( "use_wrench1_beg", use_wrench1_beg, private.room_objname );
  cmn.AddSubscriber( "use_wrench1_end", use_wrench1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sliderule () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sliderule" ] = {
    type = "use",
    inv_obj = "inv_sliderule",
    use_place = "obj_screw_use_sliderule",
    room = private.room_objname,
    zz = "zz_screw",
    zz_gate = "gzz_ventilationshaft_screw"
  };
  local use_sliderule_inv = function ()
  
    interface.InventoryItemRemove( "inv_sliderule" );
  
  end;
  local use_sliderule_beg = function ()
  
    ObjDelete( "obj_screw_use_sliderule" );
  
  end;
  local use_sliderule_end = function ()
  
    ObjSet( "spr_screw_copperlogo", { input = true, alp = 1 } );
    ObjDelete( "spr_screw_copperlogo_shadow" );
    ObjDelete( "anm_screw_sliderruler" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sliderule", use_sliderule_beg, private.room_objname );
  cmn.AddSubscriber( "use_sliderule", use_sliderule_inv );
  cmn.AddSubscriber( "use_sliderule", use_sliderule_end, private.room_objname );
  cmn.AddSubscriber( "use_sliderule_inv", use_sliderule_inv, private.room_objname );
  cmn.AddSubscriber( "use_sliderule_beg", use_sliderule_beg, private.room_objname );
  cmn.AddSubscriber( "use_sliderule_end", use_sliderule_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_glue () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_glue" ] = {
    type = "use",
    inv_obj = "inv_glue",
    use_place = "obj_ventilationshaft_use_glue",
    room = private.room_objname 
  };
  local use_glue_inv = function ()
  
    interface.InventoryItemRemove( "inv_glue" );
  
  end;
  local use_glue_beg = function ()
  
    ObjDelete( "obj_ventilationshaft_use_glue" );
  
  end;
  local use_glue_end = function ()
  
    ObjSet( "obj_ventilationshaft_use_pump", { input = true, visible = true, active = true } );
    ObjSet( "anm_ventilationshaft_matress", { frame = 500 } )
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_glue", use_glue_beg, private.room_objname );
  cmn.AddSubscriber( "use_glue", use_glue_inv );
  cmn.AddSubscriber( "use_glue", use_glue_end, private.room_objname );
  cmn.AddSubscriber( "use_glue_inv", use_glue_inv, private.room_objname );
  cmn.AddSubscriber( "use_glue_beg", use_glue_beg, private.room_objname );
  cmn.AddSubscriber( "use_glue_end", use_glue_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_patch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_patch" ] = {
    type = "use",
    inv_obj = "inv_patch",
    use_place = "obj_ventilationshaft_use_patch",
    room = private.room_objname 
  };
  local use_patch_inv = function ()
  
    interface.InventoryItemRemove( "inv_patch" );
  
  end;
  local use_patch_beg = function ()
  
    ObjDelete( "obj_ventilationshaft_use_patch" );
  
  end;
  local use_patch_end = function ()
  
    ObjSet( "obj_ventilationshaft_use_glue", { input = true, visible = true, active = true } );
    ObjSet( "anm_ventilationshaft_matress", { alp = 1 } );
    ObjDelete( "spr_ventilationshaft_mattress" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_patch", use_patch_beg, private.room_objname );
  cmn.AddSubscriber( "use_patch", use_patch_inv );
  cmn.AddSubscriber( "use_patch", use_patch_end, private.room_objname );
  cmn.AddSubscriber( "use_patch_inv", use_patch_inv, private.room_objname );
  cmn.AddSubscriber( "use_patch_beg", use_patch_beg, private.room_objname );
  cmn.AddSubscriber( "use_patch_end", use_patch_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pump () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pump" ] = {
    type = "use",
    inv_obj = "inv_pump",
    use_place = "obj_ventilationshaft_use_pump",
    room = private.room_objname 
  };
  local use_pump_inv = function ()
  
    interface.InventoryItemRemove( "inv_pump" );
  
  end;
  local use_pump_beg = function ()
  
    ObjDelete( "obj_ventilationshaft_use_pump" );
  
  end;
  local use_pump_end = function ()
  
    ObjSet( "spr_ventilationshaft_inflatedmattress", { input = true, active = true, alp = 1 } );
    ObjDelete( "anm_ventilationshaft_matress" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pump", use_pump_beg, private.room_objname );
  cmn.AddSubscriber( "use_pump", use_pump_inv );
  cmn.AddSubscriber( "use_pump", use_pump_end, private.room_objname );
  cmn.AddSubscriber( "use_pump_inv", use_pump_inv, private.room_objname );
  cmn.AddSubscriber( "use_pump_beg", use_pump_beg, private.room_objname );
  cmn.AddSubscriber( "use_pump_end", use_pump_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_block_door () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_block_door" ] = {
    type = "click",
    use_place = "spr_blockeddoor_block_door_close",
    room = private.room_objname,
    zz = "zz_blockeddoor",
    zz_gate = "gzz_ventilationshaft_blockeddoor" 
  };
  local clk_block_door_beg = function ()
  
    ObjSet( "spr_blockeddoor_block", { input = false } )
  
  end;
  local clk_block_door_end = function ()
  
    ObjMultiSet({ 
      --{ "spr_blockeddoor_block_door_open",    { alp = 1      } },
      { "anm_blockeddoor_doors",                { alp = 1, playing = true  } },
      { "obj_blockeddoor_use_cable",            { input = true } },
      { "spr_ventilationshaft_blockeddoor_3",   { alp = 1      } },
    })

    ObjDelete( "spr_blockeddoor_block_door_close" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_block_door", clk_block_door_beg, private.room_objname );
  cmn.AddSubscriber( "clk_block_door", clk_block_door_end, private.room_objname );
  cmn.AddSubscriber( "clk_block_door_beg", clk_block_door_beg, private.room_objname );
  cmn.AddSubscriber( "clk_block_door_end", clk_block_door_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_emergencydoor () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_emergencydoor" ] = {
    type = "click",
    use_place = "obj_screw_clk_door",
    room = private.room_objname,
    zz = "zz_screw",
    zz_gate = "gzz_ventilationshaft_screw" 
  };
  local clk_emergencydoor_beg = function ()
  
    ObjDelete( "obj_screw_clk_door" )
  
  end;
  local clk_emergencydoor_end = function ()
  
    ObjMultiSet({ 
      { "spr_screw_code1",     { input = true }},
      { "spr_screw_symbolset", { input = true }},
    })

    ObjDelete( "spr_screw_door"                   );
    ObjDelete( "spr_ventilationshaft_screw_grill" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_emergencydoor", clk_emergencydoor_beg, private.room_objname );
  cmn.AddSubscriber( "clk_emergencydoor", clk_emergencydoor_end, private.room_objname );
  cmn.AddSubscriber( "clk_emergencydoor_beg", clk_emergencydoor_beg, private.room_objname );
  cmn.AddSubscriber( "clk_emergencydoor_end", clk_emergencydoor_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_ventilationshaft_mine () end;
  --------------------------------------------------------------------------------------------
  local see_ventilationshaft_mine = function ()

    ObjDelete( "anm_ventilationshaft_mine" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "see_ventilationshaft_mine", see_ventilationshaft_mine, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_keypad () end;
  --------------------------------------------------------------------------------------------

  local win_keypad_array_pos_y = { 18, -73, 11, -3, -16, -27, -38 };

  common_impl.hint[ "win_keypad" ] = {
    type = "click",
    use_place = "spr_controlunit_keypad",
    room = private.room_objname,
    zz = "zz_controlunit",
    zz_gate = "gzz_ventilationshaft_controlunit" 
  };
  local win_keypad_beg = function ()
  
    ObjSet( "spr_controlunit_keypad", { input = false } );
  
  end;
  local win_keypad_end = function ()
  
    ObjMultiSet({ 
      { "spr_controlunit_sliderule", { input = true          }},
      { "spr_controlunit_open",      { alp = 1, input = true }},
      { "spr_controlunit_patch",     { alp = 1, input = true }},
      { "spr_controlunit_door_open", { alp = 1               }},
      { "obj_controlunit_buttons",   { input = false         }},

      { "spr_ventilationshaft_controlunit_2", { alp = 1      }},
    });

    ObjDelete( "spr_controlunit_code" );  
    ObjDelete( "spr_controlunit_scotch" );
  
    ObjDelete( "spr_ventilationshaft_controlunit_1" );

    for i = 1, 7 do

      if ( private.controlunit_pass[ i ] ) then

        ObjSet( "spr_controlunit_button_"..i, { pos_y = win_keypad_array_pos_y[i] + 4 } );
        ObjSet( "spr_controlunit_light_button_"..i, { alp = 1 } );

      end;

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_keypad", win_keypad_beg, private.room_objname );
  cmn.AddSubscriber( "win_keypad", win_keypad_end, private.room_objname );
  cmn.AddSubscriber( "win_keypad_beg", win_keypad_beg, private.room_objname );
  cmn.AddSubscriber( "win_keypad_end", win_keypad_end, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()

  --*********************************************************************************************************************
  -- function zz_rustywall() end зз стена со светильником
  subroom.Define( "zz_rustywall" );
    function zz_rustywall.Open ()

    end;  
    -------------------------------------------------
    function zz_rustywall.PreOpen ()

    end;  
    -------------------------------------------------
    function zz_rustywall.PreClose ()

    end; 
    ------------------------------------------------- 
    function zz_rustywall.Close ()
      
      if ( cmn.IsEventDone( "use_bronzeamulet" ) ) then  

        private.RustywallCloseNoteBig();
  
      end;
     
    end;
   --*********************************************************************************************************************
  -- function zz_screw() end зз стена со светильником
    subroom.Define( "zz_screw" );
    function zz_screw.Open ()

    end;  
    -------------------------------------------------
    function zz_screw.PreOpen ()

      if ( not cmn.IsEventDone( "use_wrench1" ) ) then
        ObjSet( "obj_screw_evidence", { input = false } )
      end;

    end;  
    -------------------------------------------------
    function zz_screw.PreClose ()

    end; 
    ------------------------------------------------- 
    function zz_screw.Close ()
        
      cmn.NoteScaleClose( { "obj_screw_evidence" }, { "spr_screw_evidence_big" } );

      if cmn.IsEventDone( "get_code1" ) and not cmn.IsEventDone( "see_ventilationshaft_mine" ) then

        private.see_ventilationshaft_mine();

      end;
     
    end;
  --*********************************************************************************************************************
  -- function zz_blockeddoor() end зз стена со светильником
  subroom.Define( "zz_blockeddoor" );
    function zz_blockeddoor.Open ()

    end;  
    -------------------------------------------------
    function zz_blockeddoor.PreOpen ()

      if ( cmn.IsEventDone( "get_horizontaljack" ) ) then  

        ObjSet( "spr_blockeddoor_lft_door", { pos_x = -263, pos_y = 0 } );

      end;

    end;  
    -------------------------------------------------
    function zz_blockeddoor.PreClose ()

    end; 
    ------------------------------------------------- 
    function zz_blockeddoor.Close ()
      
    end;

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_ventilationshaft();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.CollectItemMorphing();
  common_impl.MorphItemMorphing();

  common_impl.EnvPlay( { "level3/env/aud_ventilationshaft_env" }, "", 0.5 );

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_cable ()

  local item = "inv_cable";

  if ( cmn.ApplyObj( item, "gzz_ventilationshaft_blockeddoor" ) and cmn.IsEventDone( "clk_block_door") ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_blockeddoor", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_blockeddoor_use_cable" ) and ( cmn.IsEventDone( "clk_block_door" ) ) ) then

    cmn.CallEventHandler( "use_cable_inv" );
    cmn.CallEventHandler( "use_cable_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_cable" );
      cmn.CallEventHandler( "use_cable_end" );
      common.CloseSubRoom(); 

    end;

    local func_continue = function ()

      ObjAnimate( "spr_blockeddoor_wire_2", "alp", 0, 0, "", { 0, 0, 0, 0.3, 0, 1 } );
      ObjAnimate( "spr_blockeddoor_light", "alp", 0, 0, "", { 0, 0, 0, 0.3, 0, 0, 0.5, 0, 1 } );

      ObjAnimate( "spr_blockeddoor_rgt_door", "pos_x", 0, 0, "", 
      {
        0.0, 0, 3,
        0.5, 3, 3,
        0.7, 3, 43
      } );
      ObjAnimate( "spr_blockeddoor_lft_door", "pos_x", 0, 0, func_end, 
      {
        0.0, 0, -291,
        0.5, 3, -291,
        0.7, 3, -330
      } );
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_opn_elevator", 0, "", 0 );
    cmn.ItemFly( "spr_blockeddoor_wire_1", func_continue, 0 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_horizontaljack ()

  local item = "inv_horizontaljack";

  if cmn.ApplyObj( item, "gzz_ventilationshaft_rustywall" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_rustywall", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_rustywall_use_horizontaljack" ) ) then

    cmn.CallEventHandler( "use_horizontaljack_inv" );
    cmn.CallEventHandler( "use_horizontaljack_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_horizontaljack" );
      cmn.CallEventHandler( "use_horizontaljack_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_jack", 0, "", 0 );

    ObjSet( "vid_rustywall_jack", { alp = 1 } );
    VidPlay( "vid_rustywall_jack", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_wirepiece ()

  local item = "inv_wirepiece";

  if ( cmn.ApplyObj( item, "gzz_ventilationshaft_rustywall" ) ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_rustywall", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_rustywall_use_wirepiece" ) ) then

    cmn.CallEventHandler( "use_wirepiece_inv" );
    cmn.CallEventHandler( "use_wirepiece_beg" );

    local func_end = function ()

      local func_end_1 = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_wirepiece" );
        cmn.CallEventHandler( "use_wirepiece_end" );

      end;

      ObjSet( "anm_rustywall_use_wire", { alp = 0 } );
      ObjAnimate( "spr_rustywall_cover_bot", "alp", 0, 0, func_end_1, 
      { 
        0.0, 0, 1, 
        0.3, 0, 0 
      } );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_picklock", 0, "", 0 );

    --func_end();
    AnimPlay( "anm_rustywall_use_wire", "DoAnim", func_end );
    --cmn.ItemFly( "spr", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_bronzeamulet ()

  local item = "inv_bronzeamulet";

  if cmn.ApplyObj( item, "gzz_ventilationshaft_rustywall" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_rustywall", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_rustywall_use_bronzeamulet" ) ) then

    cmn.CallEventHandler( "use_bronzeamulet_inv" );
    cmn.CallEventHandler( "use_bronzeamulet_beg" );

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_bronzeamulet" );
      cmn.CallEventHandler( "use_bronzeamulet_end" );

    end;

    local func_continue = function ()

      ObjAnimate( "spr_rustywall_cover_top", "pos_y", 0, 0, func_end, { 0, 0, -206, 0.4, 2, -393 } );

    end;

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_bronzeamulet", 0, "", 0 );

    cmn.ItemFly( "spr_rustywall_ethernity", func_continue, 0 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_symbolset ()

  local item = "inv_symbolset";

  if cmn.ApplyObj( item, "gzz_ventilationshaft_controlunit" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_controlunit", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_controlunit_use_symbolset" ) ) then

    cmn.CallEventHandler( "use_symbolset_inv" );
    cmn.CallEventHandler( "use_symbolset_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_symbolset" );
      cmn.CallEventHandler( "use_symbolset_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "aud_paper", 0, "", 0 );

    cmn.ItemFly( "spr_controlunit_code", func_end, -3.14 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_copperlogo ()

  local item = "inv_copperlogo";

  if cmn.ApplyObj( item, "gzz_ventilationshaft_controlunit" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_controlunit", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_controlunit_use_copperlogo" ) ) then

    cmn.CallEventHandler( "use_copperlogo_inv" );
    cmn.CallEventHandler( "use_copperlogo_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_copperlogo" );
      cmn.CallEventHandler( "use_copperlogo_end" );

    end;

    local func_continue = function ()

      ObjSet( "spr_controlunit_button_1", { pos_z = 20 } );

      local curX = ObjGet( "spr_controlunit_button_1" ).pos_x;
      local curY = ObjGet( "spr_controlunit_button_1" ).pos_y;

      ObjAnimate( "spr_controlunit_button_1", "pos_xy",0,0, func_end, { 0, 1, curX, curY,    0.2, 1, -48, -7,    0.7, 2, -161, 193  } );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_e", 0, "", 0 );

    cmn.ItemFly( "spr_controlunit_amulet", func_continue, 1.34, 200 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_key ()

  local item = "inv_key";

  if cmn.ApplyObj( item, "gzz_ventilationshaft_controlunit" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_controlunit", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_controlunit_use_key" ) ) then

    cmn.CallEventHandler( "use_key_inv" );
    cmn.CallEventHandler( "use_key_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_key" );
      cmn.CallEventHandler( "use_key_end" );

    end;

    local func_continue = function ()

      ObjAnimate( "spr_controlunit_keypad", "pos_x", 0, 0, func_end, { 0, 0, -130, 0.4, 0, -230 } )

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_key", 0, "", 0 );

    cmn.ItemFly( "spr_controlunit_button_used", func_continue );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_emergencybutton ()

  local item = "inv_emergencybutton";

  if cmn.ApplyObj( item, "gzz_ventilationshaft_screw" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_screw", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_screw_use_emergencybutton" ) ) then

    cmn.CallEventHandler( "use_emergencybutton_inv" );
    cmn.CallEventHandler( "use_emergencybutton_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_emergencybutton" );
      cmn.CallEventHandler( "use_emergencybutton_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_green_button", 0, "", 0 );

    ObjAnimate( "spr_screw_button_over", "alp", 0, 0, "", { 0, 0, 1, 0.3, 0, 0 } );
    ObjAnimate( "spr_screw_button", "alp", 0, 0, "", { 0, 0, 0, 0.3, 0, 1 } );

    ObjAnimate( "spr_screw_light_button", "alp", 0, 0, "", 
    { 
      0.0, 0, 0, 
      0.3, 0, 0, 
      0.7, 3, 1 
    } );

    ObjAnimate( "spr_screw_latch_close", "alp", 0, 0, "", 
    { 
      0.0, 0, 1, 
      0.3, 0, 1, 
      0.7, 0, 0 
    } );
    ObjAnimate( "spr_screw_latch_open", "alp", 0, 0, "", 
    { 
      0.0, 0, 0, 
      0.3, 0, 0, 
      0.7, 0, 1 
    } );
    ObjAnimate( "spr_screw_door", "pos_x", 0, 0, func_end, 
    { 
      0.0, 0, 53, 
      0.7 ,0, 52, 
      1.0, 3, 72 
    } );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_wrench1 ()

  local item = "inv_wrench";

  if cmn.ApplyObj( item, "gzz_ventilationshaft_screw" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_screw", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_screw_use_wrench" ) ) then

    cmn.CallEventHandler( "use_wrench1_inv" );
    cmn.CallEventHandler( "use_wrench1_beg" );

    local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "use_wrench1" );
    cmn.CallEventHandler( "use_wrench1_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_wrench1", 0, "", 0 );

    local func_continue = function ()

      ObjAnimate( "anm_screw_wheel", "alp", 0, 0, func_end, { 0, 0, 1,   0.3, 0, 0 } );

    end;

    ObjSet( "vid_screw_key", { alp = 1 } );
    VidPlay( "vid_screw_key", func_continue );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_sliderule ()

  local item = "inv_sliderule";

  if cmn.ApplyObj( item, "gzz_ventilationshaft_screw" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_screw", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_screw_use_sliderule" ) ) then

    cmn.CallEventHandler( "use_sliderule_inv" );
    cmn.CallEventHandler( "use_sliderule_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_sliderule" );
      cmn.CallEventHandler( "use_sliderule_end" );

    end;

    local func_end_2 = function ()

      ObjSet( "spr_screw_copperlogo_shadow", { alp = 0 } );

    end; 

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_ruler", 0, "", 0 );

    ObjSet( "anm_screw_sliderruler", { alp = 0, visible = true } );
    ObjAnimate( "anm_screw_sliderruler", "alp",0,0, func_end_2, { 0, 0, 0,    0.3, 0, 1 } );
    AnimPlay( "anm_screw_sliderruler", "anum_sliderule", func_end );

  return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_glue ()

  local item = "inv_glue";

  if ( cmn.ApplyObj( item, "obj_ventilationshaft_use_glue" ) and ( cmn.IsEventDone( "use_patch" ) ) ) then

    cmn.CallEventHandler( "use_glue_inv" );
    cmn.CallEventHandler( "use_glue_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_glue" );
      cmn.CallEventHandler( "use_glue_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_glue", 0, "", 0 );

  AnimPlay( "anm_ventilationshaft_matress", "use_glue", func_end );
  
  return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_patch ()

  local item = "inv_patch";

  if ( cmn.ApplyObj( item, "obj_ventilationshaft_use_patch" ) ) then

    cmn.CallEventHandler( "use_patch_inv" );
    cmn.CallEventHandler( "use_patch_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_patch" );
      cmn.CallEventHandler( "use_patch_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );

  ObjAnimate( "anm_ventilationshaft_matress", "alp", 0, 0, func_end, { 0, 0, 0, 0.3, 0, 1 } );
  
  return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_pump ()

  local item = "inv_pump";

  if ( cmn.ApplyObj( item, "obj_ventilationshaft_use_pump" ) and ( cmn.IsEventDone( "use_glue" ) ) ) then

    cmn.CallEventHandler( "use_pump_inv" );
    cmn.CallEventHandler( "use_pump_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_pump" );
      cmn.CallEventHandler( "use_pump_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_pump", 0, "", 0 );

  AnimPlay( "anm_ventilationshaft_matress", "use_pump", func_end );
  
  return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_horizontaljack ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_horizontaljack" );
  cmn.CallEventHandler( "get_horizontaljack" );

  cmn.Lock( true );
  ObjAnimate( "spr_blockeddoor_lft_door", "pos_xy", 0, 0, function() cmn.Lock( false ); common_impl.PlayAudio( "sfx", "level2/sfx/aud_elevator_clk", 0, "", 0 ); end, 
  { 
    0.0, 0, ObjGet( "spr_blockeddoor_lft_door" ).pos_x, ObjGet( "spr_blockeddoor_lft_door" ).pos_y,
    0.3, 0, -263, 0
  } );

end;
--------------------------------------------------------------------------------------------
function private.get_boltcutterpart1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_boltcutterpart1" );
  cmn.CallEventHandler( "get_boltcutterpart1" );

end;
--------------------------------------------------------------------------------------------
function private.get_emergencybutton ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_emergencybutton" );
  cmn.CallEventHandler( "get_emergencybutton" );

end;
--------------------------------------------------------------------------------------------
function private.get_pliers ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_pliers" );
  cmn.CallEventHandler( "get_pliers" );

end;
--------------------------------------------------------------------------------------------
function private.get_wrench ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_wrench" );
  cmn.CallEventHandler( "get_wrench" );

end;
--------------------------------------------------------------------------------------------
function private.get_smallslider1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_smallslider1" );
  cmn.CallEventHandler( "get_smallslider1" );

end;
--------------------------------------------------------------------------------------------
function private.get_cable ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_cable" );
  cmn.CallEventHandler( "get_cable" );

end;
--------------------------------------------------------------------------------------------
function private.get_sliderule ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_sliderule" );
  cmn.CallEventHandler( "get_sliderule" );

end;
--------------------------------------------------------------------------------------------
function private.get_wirereel ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_wirereel" );
  cmn.CallEventHandler( "get_wirereel" );

  if ( cmn.IsGetCollect2( "get_collect2_item_3_1" ) ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_symbolset ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_symbolset" );
  cmn.CallEventHandler( "get_symbolset" );

end;
--------------------------------------------------------------------------------------------
function private.get_code1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_code1" );
  cmn.CallEventHandler( "get_code1" );

  common.CloseSubRoom();
  --private.see_ventilationshaft_mine();

end;
--------------------------------------------------------------------------------------------
function private.get_copperlogo ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_copperlogo" );
  cmn.CallEventHandler( "get_copperlogo" );

end;
--------------------------------------------------------------------------------------------
function private.get_screw1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_screw1" );
  cmn.CallEventHandler( "get_screw1" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_inflatedmattress ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_inflatedmattress" );
  cmn.CallEventHandler( "get_inflatedmattress" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_3_1 ()

  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_3_1" ); 

    if ( cmn.IsEventDone( "get_wirereel" ) ) then

      common.CloseSubRoom();

    end;

  end;

  common_impl.PlayEffectHO( "spr_collect2_item_3_1", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_3_1" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_emergencydoor ()
  
  cmn.Lock( true );

  cmn.CallEventHandler( "clk_emergencydoor_beg" );

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "clk_emergencydoor" );
    cmn.CallEventHandler( "clk_emergencydoor_end" );

  end;

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_open", 0, "", 0 );

  ObjAnimate( "spr_screw_door", "alp", 0, 0, func_end, { 0, 0, 1, 0.3, 0, 0 } );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_block_door ()
  
  cmn.Lock( true );

  cmn.CallEventHandler( "clk_block_door_beg" );

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "clk_block_door" );
    cmn.CallEventHandler( "clk_block_door_end" );

  end;

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk10", 0, "", 0 );

  --ObjAnimate( "spr_blockeddoor_block_door_open", "alp", 0, 0, func_end, { 0, 0, 0, 0.3, 0, 1 } );
  ObjAnimate( "anm_blockeddoor_doors", "alp", 0, 0, "", 
  { 
    0.0, 0, 0, 
    0.3, 0, 1 
  } );
  ObjAnimate( "spr_blockeddoor_block_door_close", "alp", 0, 0, func_end,      { 0, 0, 1, 0.3, 0, 0 } );
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_ventilationshaft ()

  if not ( cmn.IsEventDone( "opn_ventilationshaft" ) ) then

    cmn.SetEventDone( "opn_ventilationshaft" );

    common_impl.ShowBbt( "bbt_ventilationshaft_opn_ventilationshaft" );

    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "find_way_ventilation_shaft" );

  end;

  cmn.CallEventHandler( "opn_ventilationshaft" ); 

  if not ( cmn.IsEventDone( "see_ventilationshaft_mine" ) ) and ( cmn.IsEventDone( "get_code1" ) ) then

    private.see_ventilationshaft_mine();

  end;

end;
--------------------------------------------------------------------------------------------
function private.see_ventilationshaft_mine ()
  
  cmn.Lock( true );

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "see_ventilationshaft_mine" );
    cmn.CallEventHandler( "see_ventilationshaft_mine" );

    common_impl.ShowBbt( "bbt_ventilationshaft_mine" );

  end;

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_scare_lvl2", 0, "", 0 );
  AnimPlay( "anm_ventilationshaft_mine", "DoAnim", "" );
  ObjAnimate( "rm_ventilationshaft", "scale_xy", 0, 0, func_end, { 0, 0, 1, 1,   0.3, 3, 1.3, 1.3,   4, 0, 1.3, 1.3,   4.3, 3, 1, 1 } );
  
end;
--------------------------------------------------------------------------------------------
function private.KeyPadInit ()

  for i = 1, 7 do

    ObjSet( "spr_controlunit_button_"..i, 
    {
      input = true,
      event_mdown = function () private.ControlunitButtonClick( i ); end,
      event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end
    } );

  end;
  private.controlunit_pass = { true, true, true, false, true, false, true };
  private.count = 0;

  function private.ControlunitButtonClick ( but )

    cmn.Lock( true );

    local func_complete = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "win_keypad" );
      cmn.CallEventHandler( "win_keypad" ); 

    end;

    local func_end = function ()

      if ( private.count == 5 ) then

        common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk9", 0, "", 0 );

        ObjAnimate( "spr_controlunit_open", "alp", 0, 0, func_complete, { 0, 0, 0, 0.3, 3, 1 } );
        ObjAnimate( "spr_controlunit_door_open", "alp", 0, 0, "", { 0, 0, 0, 0.3, 3, 1 } );
        ObjAnimate( "spr_controlunit_code", "alp", 0, 0, "", { 0, 0, 1, 0.3, 3, 0 } );
        ObjAnimate( "spr_controlunit_scotch", "alp", 0, 0, "", { 0, 0, 1, 0.3, 3, 0 } );
        ObjAnimate( "spr_controlunit_patch", "alp", 0, 0, "", { 0, 0, 0, 0.3, 3, 1 } );

      else

        cmn.Lock( false );

      end;

    end;

    local func_continue = function ()

      if ( private.controlunit_pass[ but ] ) then

        common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_button_code1", 0, "", 0 );

        ObjAnimate( "spr_controlunit_button_"..but, "pos_y", 0, 0, func_end, 
        { 
          0, 0, ObjGet( "spr_controlunit_button_"..but ).pos_y,
          0.1, 3, ObjGet( "spr_controlunit_button_"..but ).pos_y + 4
        } );

        private.count = private.count + 1;
        ObjSet( "spr_controlunit_button_"..but, { input = false } );

      else

        common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

        ObjAnimate( "spr_controlunit_light_button_"..but, "alp", 0, 0, func_end, { 0, 0, 1, 0.2, 0, 0 } );

      end;

    end;

    ObjAnimate( "spr_controlunit_light_button_"..but, "alp", 0, 0, func_continue, { 0, 0, 0, 0.2, 0, 1 } );

  end;

end;
--------------------------------------------------------------------------------------------
function private.RustywallClickDoors ()

  cmn.Lock( true );

  local func_end = function ()

    cmn.Lock( false );

  end;

  common_impl.ShowBbt( "bbt_rustywall_use_horizontaljack" );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk3", 0, "", 0 );

  ObjAnimate( "spr_rustywall_door_rgt", "pos_x", 0, 0, func_end, 
  { 
    0.0, 0, 190, 
    0.2, 0, 200, 
    0.4, 0, 190 
  } );
  ObjAnimate( "spr_rustywall_door_lft", "pos_x", 0, 0, "", 
  { 
    0.0, 0, -59, 
    0.2, 0, -69, 
    0.4, 0, -59 
  } );

end;
--------------------------------------------------------------------------------------------
function private.RustywallClickNoteSmall ()

  private.page = 0;

  cmn.NoteScale( "obj_rustywall_clk_note", "obj_rustywall_clk_note_big" );

end;
--------------------------------------------------------------------------------------------
function private.RustywallClickNoteBig ()

  if ( private.page == 0 ) then

    ObjSet( "spr_rustywall_foto_big_front", { alp = 0 } );
    ObjSet( "spr_rustywall_foto_big_back", { alp = 1 } );

    private.page = 1;

  else

    ObjSet( "spr_rustywall_foto_big_front", { alp = 1 } );
    ObjSet( "spr_rustywall_foto_big_back", { alp = 0 } );

    cmn.NoteScale( "obj_rustywall_clk_note", "obj_rustywall_clk_note_big" );

    private.page = 0;

  end;

end;
--------------------------------------------------------------------------------------------
function private.RustywallCloseNoteBig ()

  cmn.NoteScaleClose( { "obj_rustywall_clk_note" }, { "obj_rustywall_clk_note_big" } );

  ObjSet( "spr_rustywall_foto_big_front", { alp = 1 } );
  ObjSet( "spr_rustywall_foto_big_back", { alp = 0 } );

  private.page = 0;

end;
--------------------------------------------------------------------------------------------
function private.ScrewClkNoteOpen ()

  cmn.NoteScale( "obj_screw_evidence", "spr_screw_evidence_big" );

end;
--------------------------------------------------------------------------------------------
function private.ScrewClkNoteClose ()

  cmn.NoteScale( "obj_screw_evidence", "spr_screw_evidence_big" );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function private.AnimClkRustywallCover1 ()

  local func_end = function ()

    cmn.Lock( false );

  end;

  cmn.Lock( true );

  common_impl.ShowBbt( 'bbt_rustywall_use_bronzeamulet' );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

  ObjAnimate( "spr_rustywall_cover_top", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 0, -2, -206, 
    0.1, 0,  0, -206,
    0.2, 0, -2, -206, 
    0.3, 0, -4, -206,
    0.4, 0, -2, -206,
  } );

end;
--------------------------------------------------------------------------------------------
function private.AnimClkRustywallCover2 ()

  local func_end = function ()

    cmn.Lock( false );

  end;

  cmn.Lock( true );

  common_impl.ShowBbt( 'bbt_rustywall_use_wirepiece' );

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk9", 0, "", 0 );

  ObjAnimate( "spr_rustywall_cover_bot", "scale_xy", 0, 0, func_end, 
  { 
    0.0, 0, 1.0,  1.0, 
    0.2, 0, 1.03, 1.03, 
    0.4, 0, 1.0,  1.0,
  } );

end;
--*********************************************************************************************************************
-- function *** ANIM *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_ventilationshaft_screw_1", "ang", 1, 0, "", { 0, 0, 0,    0.4, 0, -2 * math.pi } );
  ObjAnimate( "spr_ventilationshaft_screw_2", "ang", 1, 0, "", { 0, 0, 0,    0.8, 0, -2 * math.pi } );
  ObjAnimate( "spr_ventilationshaft_screw_3", "ang", 1, 0, "", { 0, 0, 0,    1.2, 0, -2 * math.pi } );

end;
--*********************************************************************************************************************