-- name=ho_bag
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "bag" );
  game.relations[ "ho_bag" ].exitroom = "rm_hall_ext";
  --------------------------------------------------------------------------------------------------
  ObjAnimate( "spr_ho_bag_light", "alp",1,0, "", { 0, 3, 0.7,    1.5, 3, 0.1,    3, 3, 0.4,    5, 3, 1,    6, 3, 0.7 } );
  --------------------------------------------------------------------------------------------------
  private.room_objname = "ho_bag";
  private.task_name = "win_bag";
  private.win = 6;

  private.coordinates_cover_object = { 
                                          spr_ho_bag_ring_2_cover = { old = { pos_x = 374, pos_y = 523 }, new = { pos_x = 500, pos_y = 532 } }, 
                                          spr_ho_bag_sock_1_cover = { old = { pos_x = 703, pos_y = 162 }, new = { pos_x = 584, pos_y = 141 } }, 
                                          spr_ho_bag_sweetie_1_cover = { old = { pos_x = 523, pos_y = 441 }, new = { pos_x = 445, pos_y = 326 } }, 
                                          spr_ho_bag_tie_1_cover = { old = { pos_x = 750, pos_y = 518 }, new = { pos_x = 942, pos_y = 575 } }, 
                                          spr_ho_bag_tie_2_cover = { old = { pos_x = 120, pos_y = 420 }, new = { pos_x = 16, pos_y = 318 } } 
                                      };


  private.coordinates_item = { 
                                spr_ho_bag_clip_2_cover = { old = { pos_x = 474, pos_y = 173 }, new = { pos_x = 469, pos_y = 83 } }, 
                                spr_ho_bag_key_2_cover = { old = { pos_x = 814, pos_y = 383 }, new = { pos_x = 894, pos_y = 309 } }, 
                                spr_ho_bag_ring_1_cover = { old = { pos_x = 653, pos_y = 380 }, new = { pos_x = 626, pos_y = 333 } }, 
                                spr_ho_bag_sock_2_cover = { old = { pos_x = 242, pos_y = 217 }, new = { pos_x = 207, pos_y = 128 } }, 
                                spr_ho_bag_sweetie_2_cover = { old = { pos_x = 760, pos_y = 308 }, new = { pos_x = 804, pos_y = 231 } } 
                             };


  private.moving_type = { 
                            spr_ho_bag_clip_1_cover = "MOVE_ALPHA",
                            spr_ho_bag_clip_2_cover = "MOVE_XY_ITEM",
                            spr_ho_bag_key_1_cover = "MOVE_ALPHA",
                            spr_ho_bag_key_2_cover = "MOVE_XY_ITEM",
                            spr_ho_bag_ring_1_cover = "MOVE_XY_ITEM",
                            spr_ho_bag_ring_2_cover = "MOVE_XY_COVER_OBJECT",
                            spr_ho_bag_sock_1_cover = "MOVE_XY_COVER_OBJECT",
                            spr_ho_bag_sock_2_cover = "MOVE_XY_ITEM",
                            spr_ho_bag_sweetie_1_cover = "MOVE_XY_COVER_OBJECT",
                            spr_ho_bag_sweetie_2_cover = "MOVE_XY_ITEM",
                            spr_ho_bag_tie_1_cover = "MOVE_XY_COVER_OBJECT",
                            spr_ho_bag_tie_2_cover = "MOVE_XY_COVER_OBJECT" 
                        };


  --------------------------------------------------------------------------------------------------
  
  ObjMultiSet( {
    { "spr_ho_bag_clip_1_cover",        { input = 1, event_mdown = function() private.TaskComplete( "spr_ho_bag_clip_1_cover", "clip" ) end       } },
    { "spr_ho_bag_clip_2_cover",        { input = 1, event_mdown = function() private.TaskComplete( "spr_ho_bag_clip_2_cover", "clip" ) end       } },
    { "spr_ho_bag_key_1_cover",         { input = 1, event_mdown = function() private.TaskComplete( "spr_ho_bag_key_1_cover", "key" ) end         } },
    { "spr_ho_bag_key_2_cover",         { input = 1, event_mdown = function() private.TaskComplete( "spr_ho_bag_key_2_cover", "key" ) end         } },
    { "spr_ho_bag_ring_1_cover",        { input = 1, event_mdown = function() private.TaskComplete( "spr_ho_bag_ring_1_cover", "ring" ) end       } },
    { "spr_ho_bag_ring_2_cover",        { input = 1, event_mdown = function() private.TaskComplete( "spr_ho_bag_ring_2_cover", "ring" ) end       } },
    { "spr_ho_bag_sock_1_cover",        { input = 1, event_mdown = function() private.TaskComplete( "spr_ho_bag_sock_1_cover", "sock" ) end       } },
    { "spr_ho_bag_sock_2_cover",        { input = 1, event_mdown = function() private.TaskComplete( "spr_ho_bag_sock_2_cover", "sock" ) end       } },
    { "spr_ho_bag_sweetie_1_cover",     { input = 1, event_mdown = function() private.TaskComplete( "spr_ho_bag_sweetie_1_cover","sweetie" ) end  } },
    { "spr_ho_bag_sweetie_2_cover",     { input = 1, event_mdown = function() private.TaskComplete( "spr_ho_bag_sweetie_2_cover", "sweetie" ) end } },
    { "spr_ho_bag_tie_1_cover",         { input = 1, event_mdown = function() private.TaskComplete( "spr_ho_bag_tie_1_cover", "tie" ) end         } },
    { "spr_ho_bag_tie_2_cover",         { input = 1, event_mdown = function() private.TaskComplete( "spr_ho_bag_tie_2_cover", "tie" ) end         } },
    { "spr_ho_bag_passport",            { input = 0, event_mdown = function() private.TaskComplete( "spr_ho_bag_passport", "passport" ) end       } }    
  } );
  
  --------------------------------------------------------------------------------------------
  -- function win_bag () end;
  --------------------------------------------------------------------------------------------  
  common_impl.hint[ "win_bag" ] = {
      type = "win",
      room = "rm_hall_ext",
      zz = "ho_bag",
      zz_gate = "gho_hall_ext_bag"
  };  
  local win_bag_inv = function ()
  
    if ( cmn.IsEventDone( "win_bag" ) ) then

      interface.InventoryItemAdd( "inv_passport", "spr_bag_win" );
  
    end;

  end;
  
  local win_bag_closezz = function ()
  
    
  
  end;
  
  local win_bag_loc = function ()
  
    if ( cmn.IsEventDone( "win_bag" ) ) then

      ObjSet( "gzz_hall_ext_reception_ext", { input = true } )
      ObjDelete( "gho_hall_ext_bag" );
      ObjDelete( "obj_hall_ext_clk_concierge_2" );
  
    end;

  end;
  
  cmn.AddSubscriber( "win_bag", win_bag_inv );
  cmn.AddSubscriber( "win_bag", win_bag_closezz, private.room_objname );
  cmn.AddSubscriber( "win_bag", win_bag_loc, "rm_hall_ext" );

  --------------------------------------------------------------------------------------------------
  local start_bag_func = function ()

    if ( cmn.IsEventStart( "win_bag" ) ) then

      local ho_found = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found;

      for i = 1, #ho_found, 1 do

        ObjDelete( ho_found[ i ][ "object" ] );

      end;
-------------------------------------
-------------------------------------
      local foundCouples = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples;
      local nameTaskObjects = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].name_task_objects;

      if #foundCouples > 0 then 

        local lastCouple = foundCouples[#foundCouples];
        if #lastCouple == 1 then

          local taskPanelObject = "spr_ho_bag_"..lastCouple[1].."_shadow_1";
          ObjAttach( taskPanelObject, "obj_int_taskpanel_ho_bag" ); 
          ObjSet( taskPanelObject, { pos_x = -150, pos_y = 22 } );

          ObjSet( "txt_ho_bag_taskpanel", { scale_x = 0, scale_y = 0 } );

        else 

          ObjSet( "txt_ho_bag_taskpanel", { scale_x = 1, scale_y = 1 } );

        end; 

        if ( #foundCouples == private.win and #lastCouple == 2 ) then 

          ObjAttach( "spr_ho_bag_passport_shadow", "obj_int_taskpanel_ho_bag" ); 
          ObjSet( "spr_ho_bag_passport_shadow", { pos_x = -5, pos_y = 22 } );
          ObjSet( "spr_ho_bag_passport", { input = true } );

        end;

      end;
-------------------------------------
-------------------------------------
      for i = 1, #foundCouples, 1 do 

        local curCoupleObject = foundCouples[i];
        local curCoupleCover = nameTaskObjects[i];

        for j = 1, #curCoupleObject, 1 do 

          local taskObjectCover = curCoupleCover[j];
          ObjSet( taskObjectCover, { input = false } );

          local taskObject = string.gsub( taskObjectCover, "_cover", "" );

          if #curCoupleObject == 2 then
            ObjDelete( taskObject );
          end;

          if private.moving_type[ taskObjectCover ] == "MOVE_XY_COVER_OBJECT" then 

            local taskObjectCoverX = private.coordinates_cover_object[ taskObjectCover ].new.pos_x;
            local taskObjectCoverY = private.coordinates_cover_object[ taskObjectCover ].new.pos_y; 
            ObjSet( taskObjectCover, { pos_x = taskObjectCoverX, pos_y = taskObjectCoverY } );

          elseif private.moving_type[ taskObjectCover ] == "MOVE_XY_ITEM" then 

            local taskItemX = private.coordinates_item[ taskObjectCover ].new.pos_x;
            local taskItemY = private.coordinates_item[ taskObjectCover ].new.pos_y;
            ObjSet( taskObject, { pos_x = taskItemX, pos_y = taskItemY } );

          elseif private.moving_type[ taskObjectCover ] == "MOVE_ALPHA" then 

            ObjSet( taskObjectCover, { alp = 1 } );

            if taskObjectCover == "spr_ho_bag_key_1_cover" then       
              ObjSet( "spr_ho_bag_key_1_cover_2", { alp = 0 } );
            end;  

          end;

        end; 

      end;

    end;

  end;
  cmn.AddSubscriber( "win_bag", start_bag_func, "ho_bag" );  

end;


--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();
  common_impl.EnvPlay( { "mus_env/aud_ho_mus_env" }, "", 0.5 );

  if ( not cmn.IsEventDone( "opn_bag" ) ) then
  
    cmn.InitHo( "bag" );
    cmn.SetEventDone( "opn_bag" );
    ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples = {};
    ng_global.progress[ ng_global.currentprogress ][ private.task_name ].name_task_objects = {};

  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "clip_1",          1, 0, { { "spr_ho_bag_clip_1_cover", "spr_ho_bag_clip_2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "clip_2",          1, 0, { { "spr_ho_bag_clip_2_cover", "spr_ho_bag_clip_1_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "key_1",           1, 0, { { "spr_ho_bag_key_1_cover", "spr_ho_bag_key_2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "key_2",           1, 0, { { "spr_ho_bag_key_2_cover", "spr_ho_bag_key_1_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "ring_1",          1, 0, { { "spr_ho_bag_ring_1_cover", "spr_ho_bag_ring_2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "ring_2",          1, 0, { { "spr_ho_bag_ring_2_cover", "spr_ho_bag_ring_1_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "sock_1",          1, 0, { { "spr_ho_bag_sock_1_cover", "spr_ho_bag_sock_2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "sock_2",          1, 0, { { "spr_ho_bag_sock_2_cover", "spr_ho_bag_sock_1_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "sweetie_1",       1, 0, { { "spr_ho_bag_sweetie_1_cover", "spr_ho_bag_sweetie_2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "sweetie_2",       1, 0, { { "spr_ho_bag_sweetie_2_cover", "spr_ho_bag_sweetie_1_cover"  } } );
  interface.TaskPanelTaskAdd( ho_items, "tie_1",           1, 0, { { "spr_ho_bag_tie_1_cover", "spr_ho_bag_tie_2_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "tie_2",           1, 0, { { "spr_ho_bag_tie_2_cover", "spr_ho_bag_tie_1_cover" } } );
  interface.TaskPanelTaskAdd( ho_items, "passport",        1, 0, { { "spr_ho_bag_passport" } } );

  ObjAttach( "obj_int_taskpanel_ho_bag", "int_taskpanel_impl" ); 
  private.TaskPanelUpdate(); 
  interface.TaskPanelShow( ho_items );

end;


--*********************************************************************************************************************
function public.Open ()

  int_slider.InitSlider( private.room_objname );
  common_impl.PassingHoStart();

end;


--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();

end;


--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  common_impl.PassingHoStop();
  ObjSet( "obj_int_taskpanel", { alp = 1, visible = true } );
  ObjDetach( "obj_int_taskpanel_ho_bag" );

end;


--*********************************************************************************************************************
function public.HoComplete ()

  common_impl.PassingHoWin();
  
end;


--*********************************************************************************************************************
function private.TaskComplete( sender, task ) 

  local EMPTY_PROGRESS = 0;
  local ACTIVATE_WIN_OBJECT = 6;
  local NOT_COMPLETED_COUPLE = 1;
  local COMPLETED_COUPLE = 2;

  local foundCouples = {};
  foundCouples = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples;
  local countFoundCouples = #foundCouples;

  local nameTaskObjects = {};
  nameTaskObjects = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].name_task_objects;

  if countFoundCouples == EMPTY_PROGRESS then
 
    local foundTask = { task };
    table.insert( foundCouples, foundTask );

    local foundObjectTask = { sender };
    table.insert( nameTaskObjects, foundObjectTask );

    private.AnimCoveringObjects( sender, "FIRST_OBJECT_OF_COUPLE", task );
    private.TaskPanel( "NOT_COMPLETED_COUPLE", task );
    ObjSet( sender, { input = false } );

    cmn.Lock( true );
    ObjSet( "ho_bag", { input = false } );

  else 

    local lastCouple = foundCouples[countFoundCouples];
    local sizeLastCouple = #lastCouple;

    if sizeLastCouple == COMPLETED_COUPLE then   

      if countFoundCouples == ACTIVATE_WIN_OBJECT then 

        local taskObjectNameWin = "spr_ho_bag_"..task;
        cmn.HoTaskFind( taskObjectNameWin, task );
        private.TaskPanel( "WINNING", "passport" );

      else 

        local foundTask = { task };
        table.insert( foundCouples, foundTask );

        local foundObjectTask = { sender };
        table.insert( nameTaskObjects, foundObjectTask );

        private.AnimCoveringObjects( sender, "FIRST_OBJECT_OF_COUPLE", task );
        private.TaskPanel( "NOT_COMPLETED_COUPLE", task );
        ObjSet( sender, { input = false } );

        cmn.Lock( true );
        ObjSet( "ho_bag", { input = false } );

      end;

    elseif sizeLastCouple == NOT_COMPLETED_COUPLE then  

      local firstObject = lastCouple[1];
      local lastObjectTask = nameTaskObjects[#nameTaskObjects];
      local prevSender = lastObjectTask[1];

      if firstObject == task then 

        table.insert( lastCouple, task );
        table.insert( lastObjectTask, sender );

        local taskObjectName_1 = "spr_ho_bag_"..task.."_1";
        local task_1 = task.."_1";
        cmn.HoTaskFind( taskObjectName_1, task_1 );
        common_impl.StopAudio( "sfx", "aud_hide_sfx", 0 );

        local taskObjectName_2 = "spr_ho_bag_"..task.."_2";
        local task_2 = task.."_2";
        cmn.HoTaskFind( taskObjectName_2, task_2 );

        private.AnimCoveringObjects( sender, "SECOND_OBJECT_OF_RIGHT_COUPLE", task );
        private.TaskPanel( "RIGHT_COMPLETED_COUPLE", task );
        ObjSet( sender, { input = false } );

        cmn.Lock( true );
        ObjSet( "ho_bag", { input = false } );

        if countFoundCouples == ACTIVATE_WIN_OBJECT then 

          ObjSet( "spr_ho_bag_passport", { input = true } );

          local func_end_win = function () 
            private.TaskPanel( "ACTIVATE_WIN_OBJECT", "passport" );
          end;

          ObjAnimate( "obj_ho_bag_items", "alp",0,0, func_end_win, { 0, 0, 1,    0.7, 0, 1 } );

        end;

      else 

        table.remove ( foundCouples );
        table.remove ( nameTaskObjects );

        private.AnimCoveringObjects( sender, "SECOND_OBJECT_OF_WRONG_COUPLE", task, prevSender );
        private.TaskPanel( "WRONG_COMPLETED_COUPLE", firstObject );
        ObjSet( prevSender, { input = true } );

        cmn.Lock( true );
        ObjSet( "ho_bag", { input = false } );

      end;

    end;

  end;

  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples = foundCouples;
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].name_task_objects = nameTaskObjects;

end;


--*********************************************************************************************************************
function private.MoveCoveringObjects( taskObject, moveType, direction ) 

  if moveType == "MOVE_XY_COVER_OBJECT" then 

    local oldX = private.coordinates_cover_object[ taskObject ].old.pos_x;
    local oldY = private.coordinates_cover_object[ taskObject ].old.pos_y;

    local newX = private.coordinates_cover_object[ taskObject ].new.pos_x;
    local newY = private.coordinates_cover_object[ taskObject ].new.pos_y;

    local beginX = 0;
    local beginY = 0;

    local endX = 0;
    local endY = 0;

    if direction == "OLD_TO_NEW" then 

      beginX = oldX;
      beginY = oldY;

      endX = newX;
      endY = newY;

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide", 0, "", 0 );

    elseif direction == "NEW_TO_OLD" then 

      beginX = newX;
      beginY = newY;

      endX = oldX;
      endY = oldY;

      common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

    end;

    ObjAnimate( taskObject, "pos_xy",0,0, func_end, { 0, 3, beginX, beginY,    0.4, 3, endX, endY } );

-------------------------------------
-------------------------------------
  elseif moveType == "MOVE_XY_ITEM" then 

    local item = string.gsub( taskObject, "_cover", "" );

    local oldX = private.coordinates_item[ taskObject ].old.pos_x;
    local oldY = private.coordinates_item[ taskObject ].old.pos_y;

    local newX = private.coordinates_item[ taskObject ].new.pos_x;
    local newY = private.coordinates_item[ taskObject ].new.pos_y;

    local beginX = 0;
    local beginY = 0;

    local endX = 0;
    local endY = 0;

    if direction == "OLD_TO_NEW" then 

      beginX = oldX;
      beginY = oldY;

      endX = newX;
      endY = newY;

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide", 0, "", 0 );

    elseif direction == "NEW_TO_OLD" then 

      beginX = newX;
      beginY = newY;

      endX = oldX;
      endY = oldY;

      common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

    end;

    ObjAnimate( item, "pos_xy",0,0, func_end, { 0, 3, beginX, beginY,    0.4, 3, endX, endY } );
-------------------------------------
-------------------------------------
  elseif moveType == "MOVE_ALPHA" then

    local beginState = 0;
    local endState = 0;

    if direction == "OLD_TO_NEW" then 

      beginState = 0;
      endState = 1;

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide", 0, "", 0 );

    elseif direction == "NEW_TO_OLD" then 

      beginState = 1;
      endState = 0;

      common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

    end;

    ObjAnimate( taskObject, "alp",0,0, "", { 0, 3, beginState,    0.4, 3, endState } );

    if taskObject == "spr_ho_bag_key_1_cover" then       
      ObjAnimate( "spr_ho_bag_key_1_cover_2", "alp",0,0, "", { 0, 3, endState,    0.4, 3, beginState } );
    end;  

  end;

end;
--*********************************************************************************************************************
function private.AnimCoveringObjects( sender, animType, task, prevSender ) 

  local func_end_block = function () 

    cmn.Lock( false );
    ObjSet( "ho_bag", { input = true } );

  end;

  if animType == "FIRST_OBJECT_OF_COUPLE" then 

    private.MoveCoveringObjects( sender, private.moving_type[ sender ], "OLD_TO_NEW" );
    ObjAnimate( "obj_bag_gates", "scale_x",0,0, func_end_block, { 0, 0, 1,    0.5, 0, 1 } );

  elseif animType == "SECOND_OBJECT_OF_RIGHT_COUPLE" then 

    private.MoveCoveringObjects( sender, private.moving_type[ sender ], "OLD_TO_NEW" );
    ObjAnimate( "obj_bag_gates", "scale_x",0,0, func_end_block, { 0, 0, 1,    0.5, 0, 1 } );

  elseif animType == "SECOND_OBJECT_OF_WRONG_COUPLE" then 

    local func_end = function () 

      if prevSender then 
        private.MoveCoveringObjects( prevSender, private.moving_type[ prevSender ], "NEW_TO_OLD" );
        private.MoveCoveringObjects( sender, private.moving_type[ sender ], "NEW_TO_OLD" ); 
      end;

    end;

    private.MoveCoveringObjects( sender, private.moving_type[ sender ], "OLD_TO_NEW" );
    ObjAnimate( "obj_bag_gates", "alp",0,0, func_end, { 0, 0, 1,    0.4, 0, 1 } );
    ObjAnimate( "obj_bag_gates", "scale_x",0,0, func_end_block, { 0, 0, 1,    1.0, 0, 1 } );

  end; 

end;


--*********************************************************************************************************************
function private.TaskPanelUpdate() 

  ObjSet( "obj_int_taskpanel", { alp = 0, visible = false } );

  ObjSet( "txt_ho_bag_taskpanel", { pos_x = -10, pos_y = 22 } );
  ObjAttach( "txt_ho_bag_taskpanel", "obj_int_taskpanel_ho_bag" );

  foundCouples = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples;
  local count = 6 - #foundCouples;

  local COLOR_R = 0.7804;
  local COLOR_G = 0.60392;
  local COLOR_B = 0.42352;

  ObjSet( "txt_ho_bag_taskpanel",
  {
     text   = "str_int_taskpanel_pattern_couples",
     param0 = COLOR_R,
     param1 = COLOR_G,
     param2 = COLOR_B,
     param3 = StringGet( "str_taskpanel_couple_ho" ),
     param4 = count
   } );

  if count == 0 then 
  
    ObjSet( "txt_ho_bag_taskpanel", { alp = 0 } );

  end;

end;


--*********************************************************************************************************************
function private.TaskPanel( animType, curTask ) 

  local OBJECT_Y = 22;
  local OBJECT_LEFT_X = -150;
  local OBJECT_MIDDLE_X = -5;
  local OBJECT_RIGHT_X = 145;

  if animType == "NOT_COMPLETED_COUPLE" then 

    local taskPanelObject = "spr_ho_bag_"..curTask.."_shadow_1";
    ObjAttach( taskPanelObject, "obj_int_taskpanel_ho_bag" ); 

    ObjSet( taskPanelObject, { pos_x = OBJECT_LEFT_X, pos_y = OBJECT_Y } );
    ObjAnimate( taskPanelObject, "alp",0,0, "", { 0, 3, 0,    0.3, 3, 1 } );

    ObjAnimate( "txt_ho_bag_taskpanel", "scale_xy",0,0, "", { 0, 3, 1, 1,    0.3, 3, 0, 0 } );

  elseif animType == "RIGHT_COMPLETED_COUPLE" then 

    local taskPanelObject_1 = "spr_ho_bag_"..curTask.."_shadow_1";
    local taskPanelObject_2 = "spr_ho_bag_"..curTask.."_shadow_2";
    ObjAttach( taskPanelObject_2, "obj_int_taskpanel_ho_bag" ); 

    local func_end = function () 

      ObjAnimate( taskPanelObject_1, "alp",0,0, "", { 0, 3, 1,    0.3, 3, 0 } );
      ObjAnimate( taskPanelObject_2, "alp",0,0, "", { 0, 3, 1,    0.3, 3, 0 } );
------------------------------
------------------------------
      local fxTaskPanelObject = "fx_ho_bag_"..curTask;
      local pos = GetObjPosByObj( taskPanelObject_1, "obj_int_taskpanel_ho_bag" );
      ObjCreate( fxTaskPanelObject, "partsys" );
      ObjSet( fxTaskPanelObject,
      {
        res = "assets/interface/resources/ho_collect_effect",
        blendmode = 2, color_r = 0.8, color_g = 0.4, color_b = 1, 
        alp = 1, visible = 1, pos_x = pos[1], pos_y = pos[2], pos_z = 1, input = 0
      } );

      local func_end_fx = function () 
        ObjDelete( fxTaskPanelObject );
      end;

      ObjAttach( fxTaskPanelObject, "obj_int_taskpanel_ho_bag" );
      ObjAnimate( fxTaskPanelObject, "alp", 0, 0, func_end_fx, { 0, 0, 1,    0.4, 0, 1,    0.7, 0, 0 } );
------------------------------
------------------------------
      private.TaskPanelUpdate();
      ObjAnimate( "txt_ho_bag_taskpanel", "scale_xy",0,0, "", { 0, 3, 0, 0,    0.3, 3, 1, 1 } );

    end;

    ObjSet( taskPanelObject_2, { pos_x = OBJECT_RIGHT_X, pos_y = OBJECT_Y } );
    ObjAnimate( taskPanelObject_2, "alp",0,0, "", { 0, 3, 0,    0.3, 3, 1 } );

    ObjAnimate( taskPanelObject_1, "pos_x",0,0, "", { 0, 3, OBJECT_LEFT_X,    0.3, 3, OBJECT_LEFT_X,    0.7, 3, OBJECT_MIDDLE_X } );
    ObjAnimate( taskPanelObject_2, "pos_x",0,0, func_end, { 0, 3, OBJECT_RIGHT_X,    0.3, 3, OBJECT_RIGHT_X,    0.7, 3, OBJECT_MIDDLE_X } );   

  elseif animType == "WRONG_COMPLETED_COUPLE" then 

    local taskPanelObject = "spr_ho_bag_"..curTask.."_shadow_1";

    local func_end = function () 

      ObjDetach( taskPanelObject );

    end;

    ObjAnimate( taskPanelObject, "alp",0,0, func_end, { 0, 3, 1,    0.3, 3, 0 } );

    private.TaskPanelUpdate();
    ObjAnimate( "txt_ho_bag_taskpanel", "scale_xy",0,0, "", { 0, 3, 0, 0,    0.3, 3, 1, 1 } );

  elseif animType == "ACTIVATE_WIN_OBJECT" then 

    local taskPanelObject = "spr_ho_bag_"..curTask.."_shadow";
    ObjAttach( taskPanelObject, "obj_int_taskpanel_ho_bag" ); 

    ObjSet( taskPanelObject, { pos_x = OBJECT_MIDDLE_X, pos_y = OBJECT_Y } );
    ObjAnimate( taskPanelObject, "alp",0,0, "", { 0, 3, 0,    0.3, 3, 1 } );

  elseif animType == "WINNING" then 

    local taskPanelObject = "spr_ho_bag_"..curTask.."_shadow";
    ObjAnimate( taskPanelObject, "alp",0,0, "", { 0, 3, 1,    0.3, 3, 0 } );

  end;

end;


















