-- name=ho_barcounter
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "barcounter" );
  game.relations[ "ho_barcounter" ].exitroom = "rm_cafe";
  private.room_objname = "ho_barcounter";
  --------------------------------------------------------------------------------------------------

  private.CANDY_COUNT = 6;
  private.LEMON_COUNT = 6;
  private.UMBRELLA_COUNT = 6;
  private.BARTENDERLOCKET_COUNT = 1;
  --------------------------------------------------------------------------------------------------

  ObjMultiSet( {
  
    { "spr_ho_barcounter_candy_1",              { event_mdown = function() private.TaskComplete( "spr_ho_barcounter_candy_1", "candy_1" ); end } },
    { "spr_ho_barcounter_candy_2",              { event_mdown = function() private.TaskComplete( "spr_ho_barcounter_candy_2", "candy_2" ); end } },
    { "spr_ho_barcounter_candy_3",              { event_mdown = function() private.TaskComplete( "spr_ho_barcounter_candy_3", "candy_3" ); end } },
    { "spr_ho_barcounter_candy_4",              { event_mdown = function() private.TaskComplete( "spr_ho_barcounter_candy_4", "candy_4" ); end } },
    { "spr_ho_barcounter_candy_5",              { event_mdown = function() private.TaskComplete( "spr_ho_barcounter_candy_5", "candy_5" ); end } },
    { "spr_ho_barcounter_candy_6",              { event_mdown = function() private.TaskComplete( "spr_ho_barcounter_candy_6", "candy_6" ); end } },

    { "spr_ho_barcounter_lemon_1",              { event_mdown = function() private.TaskComplete( "spr_ho_barcounter_lemon_1", "lemon_1" ); end } },
    { "spr_ho_barcounter_lemon_2",              { event_mdown = function() private.TaskComplete( "spr_ho_barcounter_lemon_2", "lemon_2" ); end } },
    { "spr_ho_barcounter_lemon_3",              { event_mdown = function() private.TaskComplete( "spr_ho_barcounter_lemon_3", "lemon_3" ); end } },
    { "spr_ho_barcounter_lemon_4",              { event_mdown = function() private.TaskComplete( "spr_ho_barcounter_lemon_4", "lemon_4" ); end } },
    { "spr_ho_barcounter_lemon_5",              { event_mdown = function() private.TaskComplete( "spr_ho_barcounter_lemon_5", "lemon_5" ); end } },
    { "spr_ho_barcounter_lemon_6",              { event_mdown = function() private.TaskComplete( "spr_ho_barcounter_lemon_6", "lemon_6" ); end } },

    { "spr_ho_barcounter_umbrella_1",           { event_mdown = function() private.TaskComplete( "spr_ho_barcounter_umbrella_1", "umbrella_1" ); end } },
    { "spr_ho_barcounter_umbrella_2",           { event_mdown = function() private.TaskComplete( "spr_ho_barcounter_umbrella_2", "umbrella_2" ); end } },
    { "spr_ho_barcounter_umbrella_3",           { event_mdown = function() private.TaskComplete( "spr_ho_barcounter_umbrella_3", "umbrella_3" ); end } },
    { "spr_ho_barcounter_umbrella_4",           { event_mdown = function() private.TaskComplete( "spr_ho_barcounter_umbrella_4", "umbrella_4" ); end } },
    { "spr_ho_barcounter_umbrella_5",           { event_mdown = function() private.TaskComplete( "spr_ho_barcounter_umbrella_5", "umbrella_5" ); end } },
    { "spr_ho_barcounter_umbrella_6",           { event_mdown = function() private.TaskComplete( "spr_ho_barcounter_umbrella_6", "umbrella_6" ); end } },
 
    { "spr_ho_barcounter_bartenderlocket_1",    { event_mdown = function() private.get_bartenderlocket(); end } },

  } );
  
  --------------------------------------------------------------------------------------------------

  --------------------------------------------------------------------------------------------
  -- function win_barcounter () end;
  --------------------------------------------------------------------------------------------  
  common_impl.hint[ "win_barcounter" ] = {
      type = "win",
      room = "rm_cafe",
      zz = "ho_barcounter",
      zz_gate = "gho_cafe_barcounter"
  };  
  local win_barcounter_inv = function ()
  
    if ( cmn.IsEventDone( "win_barcounter" ) ) then

      interface.InventoryItemAdd( "inv_bartenderlocket", "spr_barcounter_win" );
  
    end;

  end;
  
  local win_barcounter_closezz = function ()
  
    
  
  end;
  
  local win_barcounter_loc = function ()
  
    if ( cmn.IsEventDone( "win_barcounter" ) ) then

      ObjDelete( "gho_cafe_barcounter" );
  
    end;

  end;
  
  cmn.AddSubscriber( "win_barcounter", win_barcounter_inv );
  cmn.AddSubscriber( "win_barcounter", win_barcounter_closezz, private.room_objname );
  cmn.AddSubscriber( "win_barcounter", win_barcounter_loc, "rm_cafe" );
  
  --------------------------------------------------------------------------------------------------

  local start_barcounter_func = function ()

    if ( cmn.IsEventStart( "win_barcounter" ) ) then

      local ho_found = ng_global.progress[ ng_global.currentprogress ][ "win_barcounter" ].found;

      for i = 1, #ho_found, 1 do

        ObjDelete( ho_found[ i ][ "object" ] );

      end;
-------------------------------------
-------------------------------------
      private.TaskPanel(); 
-------------------------------------
-------------------------------------
      local curStageObjects = private.GettingStageTypeForUpdate();
      local countCurStageObjects = 0;

      if curStageObjects == "candy" then 
        countCurStageObjects = private.CANDY_COUNT;

      elseif curStageObjects == "lemon" then 
        countCurStageObjects = private.LEMON_COUNT;

      elseif curStageObjects == "umbrella" then 
        countCurStageObjects = private.UMBRELLA_COUNT;

      elseif curStageObjects == "bartenderlocket" then 
        countCurStageObjects = private.BARTENDERLOCKET_COUNT;

      end;

      for i = 1, countCurStageObjects, 1 do 

        local curObject = "spr_ho_barcounter_"..curStageObjects.."_"..i;
        
        if private.IsTaskObjectExist( curObject ) then  

          ObjSet( curObject, { input = true } );

        end;

      end;

    end;

  end;
  cmn.AddSubscriber( "win_barcounter", start_barcounter_func, "ho_barcounter" );  

end;


--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();
  common_impl.EnvPlay( { "mus_env/aud_ho_mus_env" }, "", 0.5 );

  ObjSet( "obj_int_taskpanel", { alp = 0, visible = false } );
  ObjAttach( "obj_int_taskpanel_ho_barcounter", "int_taskpanel_impl" );

  if ( not cmn.IsEventDone( "opn_barcounter" ) ) then
  
    cmn.InitHo( "barcounter" );
    cmn.SetEventDone( "opn_barcounter" );

    local COUNT_OBJECTS_OF_DEFAULT_STAGE = 6;
    local NAME_OBJECTS_OF_DEFAULT_STAGE = "candy";

    for i = 1, COUNT_OBJECTS_OF_DEFAULT_STAGE, 1 do 

      local curObject = "spr_ho_barcounter_"..NAME_OBJECTS_OF_DEFAULT_STAGE.."_"..i;
      ObjSet( curObject, { input = true } );

    end;
------------------------------------
------------------------------------
    local COLOR_R = 0.7804;
    local COLOR_G = 0.60392;
    local COLOR_B = 0.42352;

    ObjSet( "txt_ho_barcounter_taskpanel",
    {
       text   = "str_int_taskpanel_pattern_sequence",
       param0 = COLOR_R,
       param1 = COLOR_G,
       param2 = COLOR_B,
       param3 = StringGet( "str_taskpanel_sequence_ho_barcounter_1" ),
       param4 = private.CANDY_COUNT
     } );
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "candy_1",     1, 0, { { "spr_ho_barcounter_candy_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "candy_2",     1, 0, { { "spr_ho_barcounter_candy_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "candy_3",     1, 0, { { "spr_ho_barcounter_candy_3" } } );
  interface.TaskPanelTaskAdd( ho_items, "candy_4",     1, 0, { { "spr_ho_barcounter_candy_4" } } );
  interface.TaskPanelTaskAdd( ho_items, "candy_5",     1, 0, { { "spr_ho_barcounter_candy_5" } } );
  interface.TaskPanelTaskAdd( ho_items, "candy_6",     1, 0, { { "spr_ho_barcounter_candy_6" } } );

  interface.TaskPanelTaskAdd( ho_items, "lemon_1",         1, 0, { { "spr_ho_barcounter_lemon_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "lemon_2",         1, 0, { { "spr_ho_barcounter_lemon_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "lemon_3",         1, 0, { { "spr_ho_barcounter_lemon_3" } } );
  interface.TaskPanelTaskAdd( ho_items, "lemon_4",         1, 0, { { "spr_ho_barcounter_lemon_4" } } );
  interface.TaskPanelTaskAdd( ho_items, "lemon_5",         1, 0, { { "spr_ho_barcounter_lemon_5" } } );
  interface.TaskPanelTaskAdd( ho_items, "lemon_6",         1, 0, { { "spr_ho_barcounter_lemon_6" } } );

  interface.TaskPanelTaskAdd( ho_items, "umbrella_1",        1, 0, { { "spr_ho_barcounter_umbrella_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "umbrella_2",        1, 0, { { "spr_ho_barcounter_umbrella_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "umbrella_3",        1, 0, { { "spr_ho_barcounter_umbrella_3" } } );
  interface.TaskPanelTaskAdd( ho_items, "umbrella_4",        1, 0, { { "spr_ho_barcounter_umbrella_4" } } );
  interface.TaskPanelTaskAdd( ho_items, "umbrella_5",        1, 0, { { "spr_ho_barcounter_umbrella_5" } } );
  interface.TaskPanelTaskAdd( ho_items, "umbrella_6",        1, 0, { { "spr_ho_barcounter_umbrella_6" } } );

  interface.TaskPanelTaskAdd( ho_items, "bartenderlocket",        1, 0, { { "spr_ho_barcounter_bartenderlocket_1" } } );

  interface.TaskPanelShow( ho_items );

end;


--*********************************************************************************************************************
function public.Open ()

  int_slider.InitSlider( private.room_objname ); 
  common_impl.PassingHoStart();

end;


--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();
  --ObjSet( "txt_ho_barcounter_taskpanel", { alp = 0 } );

end;


--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  common_impl.PassingHoStop();
  ObjSet( "obj_int_taskpanel", { alp = 1, visible = true } );
  ObjDetach( "obj_int_taskpanel_ho_barcounter" );

end;


--*********************************************************************************************************************
function public.HoComplete ()

  common_impl.PassingHoWin();
  
end;


--*********************************************************************************************************************
function private.IsTaskObjectExist( taskObject )

  local result = true;
  local ho_found = ng_global.progress[ ng_global.currentprogress ][ "win_barcounter" ].found;

  for i = 1, #ho_found, 1 do

    if taskObject == ho_found[ i ][ "object" ] then 

      result = false;
      break;

    end; 

  end;

  return result; 

end;


--*********************************************************************************************************************
function private.GettingStageTypeForUpdate()

  local countFoundObjects = #ng_global.progress[ ng_global.currentprogress ][ "win_barcounter" ].found;  
  local result = "candy";

  if ( countFoundObjects < private.CANDY_COUNT ) then 

    result = "candy";

  elseif ( countFoundObjects >= private.CANDY_COUNT and 
  countFoundObjects < private.CANDY_COUNT + private.LEMON_COUNT ) then 

    result = "lemon";

  elseif ( countFoundObjects >= private.CANDY_COUNT + private.LEMON_COUNT and 
    countFoundObjects < private.CANDY_COUNT + private.LEMON_COUNT + private.UMBRELLA_COUNT ) then 

    result = "umbrella";

  elseif ( countFoundObjects >= private.CANDY_COUNT + private.LEMON_COUNT + private.UMBRELLA_COUNT ) then 

    result = "bartenderlocket";

  end; 

  return result; 

end;


--*********************************************************************************************************************
function private.GettingStageType()

  local countFoundObjects = #ng_global.progress[ ng_global.currentprogress ][ "win_barcounter" ].found;  
  local result = nil;

  if ( countFoundObjects == private.CANDY_COUNT ) then 

    result = "lemon";

  elseif ( countFoundObjects == private.CANDY_COUNT + private.LEMON_COUNT ) then 

    result = "umbrella";

  elseif ( countFoundObjects == private.CANDY_COUNT + private.LEMON_COUNT + private.UMBRELLA_COUNT ) then 

    result = "bartenderlocket";

  end; 

  return result; 

end;


--*********************************************************************************************************************
function private.TaskComplete( taskObject, task )

  cmn.HoTaskFind( taskObject, task );
  private.TaskPanel();

  local nextStageObjects = private.GettingStageType();

  if nextStageObjects then 

    local countNextStageObjects = 0;

    if nextStageObjects == "lemon" then 
      countNextStageObjects = private.LEMON_COUNT;

    elseif nextStageObjects == "umbrella" then 
      countNextStageObjects = private.UMBRELLA_COUNT;

    elseif nextStageObjects == "bartenderlocket" then 
      countNextStageObjects = private.BARTENDERLOCKET_COUNT;

    end;

    for i = 1, countNextStageObjects, 1 do 

      local nextObject = "spr_ho_barcounter_"..nextStageObjects.."_"..i;
      ObjSet( nextObject, { input = true } );

    end;

  end;

end;


--*********************************************************************************************************************
function private.TaskPanel() 
 
  local count = 0;
  local tasktext = "";

  local COLOR_R = 0.7804;
  local COLOR_G = 0.60392;
  local COLOR_B = 0.42352;

  local curStage = private.GettingStageTypeForUpdate();
  local countFoundObjects = #ng_global.progress[ ng_global.currentprogress ][ "win_barcounter" ].found; 

  if ( curStage == "candy" ) then 

    count = private.CANDY_COUNT - countFoundObjects;
    tasktext = "str_taskpanel_sequence_ho_barcounter_1";

  elseif ( curStage == "lemon" ) then 

    count = private.LEMON_COUNT - ( countFoundObjects - private.CANDY_COUNT );
    tasktext = "str_taskpanel_sequence_ho_barcounter_2";

  elseif ( curStage == "umbrella" ) then 

      count = private.UMBRELLA_COUNT - ( countFoundObjects - private.CANDY_COUNT - private.LEMON_COUNT );
      tasktext = "str_taskpanel_sequence_ho_barcounter_3";

  elseif ( curStage == "bartenderlocket" ) then 

    count = "";
    tasktext = "str_taskpanel_sequence_ho_barcounter_4";

  end;

  ObjSet( "txt_ho_barcounter_taskpanel",
  {
     text   = "str_int_taskpanel_pattern_sequence",
     param0 = COLOR_R,
     param1 = COLOR_G,
     param2 = COLOR_B,
     param3 = StringGet( tasktext ),
     param4 = count
   } );

end;

 --ObjSet( "txt_ho_barcounter_taskpanel", { alp = 0 } );
--*********************************************************************************************************************
function private.get_bartenderlocket ()

  cmn.HoTaskFind( "spr_ho_barcounter_bartenderlocket_1", "bartenderlocket" );  

end;
--*********************************************************************************************************************












