-- name=ho_droppedtreecrown
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "droppedtreecrown" );
  game.relations[ "ho_droppedtreecrown" ].exitroom = "rm_porch_ext";
  private.room_objname = "ho_droppedtreecrown";
  --------------------------------------------------------------------------------------------------
  private.win_droppedtreecrown = {};

  private.win_droppedtreecrown.pos_inv = 
  {-230, -110, 10, 130, 250, 370, 490, 610, 730, 850, 970, 1090};

  private.win_droppedtreecrown.task = { "aquarius", "bow",         "comb",  "drybranches", 
                                        "feather",  "mask",        "pin",   "seahorse", 
                                        "shoe",     "shuttlecock", "snail", "tube" };

  ObjSet( "obj_droppedtreecrown_clk_raven", { event_mdown = private.clk_raven } );

  for i = 1, #private.win_droppedtreecrown.task do

    ObjSet( "spr_droppedtreecrown_"..private.win_droppedtreecrown.task[ i ], { event_mdown = function () private.CompleteTask( private.win_droppedtreecrown.task[ i ] ); end, input = false } );

  end;

  private.Animation ();

  --------------------------------------------------------------------------------------------
  -- function opn_droppedtreecrown () end;
  --------------------------------------------------------------------------------------------
  local opn_droppedtreecrown = function ()

  end;

  cmn.AddSubscriber( "opn_droppedtreecrown", opn_droppedtreecrown, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_droppedtreecrown () end;
  --------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_droppedtreecrown" ] =
  {
      type = "win",
      room = "rm_porch_ext",
      zz = private.room_objname,
      zz = "ho_droppedtreecrown",
      zz_gate = "gho_porch_ext_droppedtreecrown"
  };
  --------------------------------------------------------------------------------------------------
  local win_droppedtreecrown_func = function ()

    if ( cmn.IsEventDone( "win_droppedtreecrown" ) ) then

      interface.InventoryItemAdd( "inv_drybranches", "spr_droppedtreecrown_win" );
      cmn.SetInvPlusRGB( "stick", true ); 
      ObjDelete( "gho_porch_ext_droppedtreecrown" );
      ObjAttach( "obj_droppedtreecrown_taskpanel", "ho_droppedtreecrown" );

    end;

  end;
  cmn.AddSubscriber( "win_droppedtreecrown", win_droppedtreecrown_func );
  --------------------------------------------------------------------------------------------------
  local start_droppedtreecrown_func = function ()

    if ( cmn.IsEventStart( "win_droppedtreecrown" ) ) then

        common_impl.ProcessHoStart( "droppedtreecrown" );

        local ho_found = ng_global.progress[ "ext" ][ "win_droppedtreecrown" ].found;

        for i = 1, #ho_found, 1 do

            ObjDelete( ho_found[ i ][ "object" ] );

        end;

    end;

  end;
  cmn.AddSubscriber( "win_droppedtreecrown", start_droppedtreecrown_func, "ho_droppedtreecrown" );
  --------------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();
  common_impl.EnvPlay( { "mus_env/aud_ho_mus_env" }, "", 0.5 );

  if ( not cmn.IsEventDone( "opn_droppedtreecrown" ) ) then

      cmn.SetEventDone( "opn_droppedtreecrown" );
      cmn.CallEventHandler( "opn_droppedtreecrown" );

  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aquarius",       1, 0, { { "spr_droppedtreecrown_aquarius"       } } );
  interface.TaskPanelTaskAdd( ho_items, "bow",            1, 0, { { "spr_droppedtreecrown_bow"            } } );
  interface.TaskPanelTaskAdd( ho_items, "comb",           1, 0, { { "spr_droppedtreecrown_comb"           } } );
  interface.TaskPanelTaskAdd( ho_items, "drybranches",    1, 0, { { "spr_droppedtreecrown_drybranches"    } } );
  interface.TaskPanelTaskAdd( ho_items, "feather",        1, 0, { { "spr_droppedtreecrown_feather"        } } );
  interface.TaskPanelTaskAdd( ho_items, "mask",           1, 0, { { "spr_droppedtreecrown_mask"           } } );
  interface.TaskPanelTaskAdd( ho_items, "pin",            1, 0, { { "spr_droppedtreecrown_pin"            } } );
  interface.TaskPanelTaskAdd( ho_items, "seahorse",       1, 0, { { "spr_droppedtreecrown_seahorse"       } } );
  interface.TaskPanelTaskAdd( ho_items, "shoe",           1, 0, { { "spr_droppedtreecrown_shoe"           } } );
  interface.TaskPanelTaskAdd( ho_items, "shuttlecock",    1, 0, { { "spr_droppedtreecrown_shuttlecock"    } } );
  interface.TaskPanelTaskAdd( ho_items, "snail",          1, 0, { { "spr_droppedtreecrown_snail"          } } );
  interface.TaskPanelTaskAdd( ho_items, "tube",           1, 0, { { "spr_droppedtreecrown_tube"           } } );

  if ( not cmn.IsEventStart( "win_droppedtreecrown" ) ) then

    cmn.InitHo( "droppedtreecrown" );

  end;

  interface.TaskPanelShow( ho_items );
  private.Panel();

  --local pages = ng_global.progress[ "ext" ][ "see_tutorial" ].state.pages;

--  if pages[ "tutorial_page_14" ][ "shown" ] == 0 then
--
--      cmn.TutorialShow( "tutorial_page_14" );  
--
--  elseif pages[ "tutorial_page_14" ][ "shown" ] == 1 and
--      pages[ "tutorial_page_17" ][ "shown" ] == 0 then
--
--      cmn.TutorialShow( "tutorial_page_17" );  
--      cmn.TutorialSetShown( "tutorial_page_14" );
--
--  end;

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();
  int_slider.InitSlider( private.room_objname );
--  if cmn.IsEventStart( "see_tutorial" ) then
--
--    common_impl.TutorialShow( "tutorial_page_13" );
--
--  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  common_impl.PassingHoStop();
  ObjAttach( "obj_droppedtreecrown_taskpanel" , "ho_droppedtreecrown" );

  ObjSet( "obj_int_taskpanel", { alp = 1 } );
  ObjSet( "txt_int_taskpanel", { alp = 1 } );

end;
--*********************************************************************************************************************
function public.HoComplete ()

  common_impl.PassingHoWin();

end;
--*********************************************************************************************************************
function private.CompleteTask ( name )

  cmn.Lock( true );

  cmn.HoTaskFind( "spr_droppedtreecrown_"..name, name );

  for i = 1,#private.win_droppedtreecrown.task do

    if ( private.win_droppedtreecrown.task[ i ] == name ) then 

      local object_name = "obj_"..i; 
      local collect_name  = "pfx_droppedtreecrown_collect_"..object_name.."_effect";
      ng_global.progress[ "ext" ][ "win_droppedtreecrown" ].task_check[ i ] = 1;
      ObjCreate( collect_name, "partsys" );

      ObjSet( collect_name,
      {
        res    = "assets/interface/resources/effects_ho_hint",
        pos_x  = ObjGet( object_name ).pos_x, pos_y = ObjGet( object_name ).pos_y,
        active = 1, visible = 1, input = 0
      } );

      ObjAttach( collect_name, "obj_droppedtreecrown_taskpanel" );
      ObjSet( collect_name, { blendmode = 2, scale_x = 0.9, scale_y = 0.9 } );
      --PartSysSetMaskObj( collect_name, object_name );  
      local func_end = function () private.AnimInv( i ); end;
      ObjAnimate( object_name, "alp", 0, 0, func_end,
      { 
        0.0, 0, 1.0,
        0.1, 0, 0.0
        --1.0, 0, 0.0
      } );

    end;

  end;

end;
--*********************************************************************************************************************
function private.GetItem ( name )

end;
--*********************************************************************************************************************
function private.UseItem ( name ) 
  
end;
--*********************************************************************************************************************
function private.UseItemEnd ( name )

end;
--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );
  ObjAttach( "obj_droppedtreecrown_taskpanel" , "spr_int_taskpanel" );

  if ( not ng_global.progress[ "ext" ]["win_droppedtreecrown"].task_check ) then

     ng_global.progress["ext"]["win_droppedtreecrown"].task_check = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

  end;

  local posx = -230;
  local tmp = 0;

  ObjSet( "obj_droppedtreecrown_taskpanel", { croprect_init = true, croprect_x = -295, croprect_y = -200, croprect_w = 617, croprect_h = 400 } );

  for i = 1,#private.win_droppedtreecrown.task do 

     local obj = "obj_"..i;

     if ( ng_global.progress["ext"]["win_droppedtreecrown"].task_check[ i ] == 0 ) and
        ( not ObjGet( obj ) ) then

        ObjCreate( obj, "obj" );
        ObjAttach( obj, "obj_droppedtreecrown_taskpanel" );
        ObjSet( obj, { pos_x = posx, pos_y = 30, inputrect_init = true, inputrect_x = -45, inputrect_y = -45, inputrect_w = 90, inputrect_h = 90, alp = 1, input = 0  } );
        local spr = "spr_droppedtreecrown_"..private.win_droppedtreecrown.task[ i ].."_inv";
        ObjCreate( spr, "spr" );
        ObjSet( spr, { res = "assets/levels/levelext/ho_droppedtreecrown/layers/"..private.win_droppedtreecrown.task[ i ].."_silhouette", scale_x = 0.95, scale_y = 0.95 } );
        ObjAttach( spr, obj );
        tmp = tmp + 1;
        if ( tmp < 6 ) then

           private.CheckPanel( i, tmp );
          
        end;

        posx = posx + 120;

        if ( tmp == 12 ) then

            ng_global.progress["ext"]["win_droppedtreecrown"].set = 1;

        end;

     else

     end;

  end;
   
end;
--********************************************************************************************************************* 
function private.CheckPanel ( i, tmp ) 

   local obj = "obj_"..i;

   if ( tmp < 6 ) then

      ObjSet( obj, { input = 1 } );

      ObjAnimate( obj, "alp", 0, 0, "", 
      { 
        0,0,0, 
        0.3,0,1 
      } );

      ObjSet( "spr_droppedtreecrown_"..private.win_droppedtreecrown.task[ i ], { alp = 1, input = 1 } );


   end;
   
end;
--*********************************************************************************************************************
function private.AnimInv ( num )

  local item = "obj_"..num;
  local tmp = num + 1;

    for i = tmp,#private.win_droppedtreecrown.task do

      local obj_tmp = "obj_"..i;

      if obj_tmp ~= nil and ng_global.progress["ext"]["win_droppedtreecrown"].task_check[i] ~= 1 then

        ObjAnimate( "obj_"..i, "pos_x", 0, 0, "", 
        { 
          0.0,3,ObjGet( "obj_"..i ).pos_x, 
          0.4,3,ObjGet( "obj_"..i ).pos_x-120
          --0.8,3,ObjGet( "obj_"..i ).pos_x-120
        } );

        if ObjGet( "obj_"..i ).pos_x-120 == 250 then

          ObjAnimate( "obj_"..i, "scale_xy", 0, 0, "", 
          { 
            0.0,0,0.2,0.2, 
            0.3,0,1,1, 
            0.4,0,1.2,1.2,
            0.5,0,1,1

            --0.0,0,0.2,0.2, 
            --0.6,0,1,1, 
            --0.8,0,1.2,1.2,
            --1.0,0,1,1

          } );

        end;

      end;

    end;

  private.Check( num );

end;
--*********************************************************************************************************************
function private.Check ( num )  

  local tmp = 0;

  for i = 1,#private.win_droppedtreecrown.task do

    local item = "obj_"..i;

    if ( item and ng_global.progress[ "ext" ][ "win_droppedtreecrown" ].task_check[ i ] ~= 1 ) then

       tmp = tmp + 1;

       if ( tmp < 6 ) then

          ObjSet( "spr_droppedtreecrown_"..private.win_droppedtreecrown.task[ i ], { alp = 1, input = 1 } );

       end;

       num = num + 1;

    end;

  end;

  local func_end = function () 

    if not cmn.IsEventDone( "win_droppedtreecrown" ) then

      cmn.Lock( false ) 

    end;

  end;

  ObjAnimate( "ho_droppedtreecrown", "alp", 0, 0, func_end, 
    { 
      0.0, 3, 1, 
      0.5, 3, 1
    } );

end;
--*********************************************************************************************************************
function private.Animation ()

  ObjAnimate( "spr_droppedtreecrown_light1", "alp", 1, 0, "", 
  { 
    0.0,  0,  1.0,
    3.0,  0,  0.0,
    6.0,  0,  1.0
  } );

end;
--*********************************************************************************************************************
function private.clk_raven ()

  local func_end = function ()

    cmn.Lock( false );
    ObjMultiSet( {
      { "obj_droppedtreecrown_earring",         { alp = 1 } },
      { "anm_droppedtreecrown_raven",           { alp = 1 } },
      { "anm_droppedtreecrown_raven_click",     { alp = 0 } },
    } );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_crow", 0, "", 0 );

  ObjMultiSet( {
    { "obj_droppedtreecrown_earring",       { alp = 0 } },
    { "anm_droppedtreecrown_raven",         { alp = 0 } },
    { "anm_droppedtreecrown_raven_click",   { alp = 1 } },
  } );
  AnimPlay( "anm_droppedtreecrown_raven_click", "click", func_end );

end;