-- name=ho_itemscollecting
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "itemscollecting" );
  game.relations[ "ho_itemscollecting" ].exitroom = "rm_apartment";
  private.room_objname = "ho_itemscollecting";
  private.cout_piece = 12;
  private.cout_items = 12;
  private.find_final_object = "str_itemscollecting_final_object";
  private.Init_Animation();
  --------------------------------------------------------------------------------------------------
   local table_multiset = {};

  table.insert( table_multiset, { "spr_itemscollecting_harmonica",             { event_mdown = function() private.TaskComplete( "harmonica",       3 ) end } } );
  table.insert( table_multiset, { "spr_itemscollecting_photo",                 { event_mdown = function() private.TaskComplete( "photo",           5 ) end } } );
  table.insert( table_multiset, { "spr_itemscollecting_chess",                 { event_mdown = function() private.TaskComplete( "chess",           11 ) end } } );
  table.insert( table_multiset, { "spr_itemscollecting_cup",                   { event_mdown = function() private.TaskComplete( "cup",             10 ) end } } );
  table.insert( table_multiset, { "spr_itemscollecting_white_shirt",           { event_mdown = function() private.TaskComplete( "white_shirt",     2 ) end } } );
  table.insert( table_multiset, { "spr_itemscollecting_swimming_trunks",       { event_mdown = function() private.TaskComplete( "swimming_trunks", 12 ) end } } );
  table.insert( table_multiset, { "spr_itemscollecting_ball",                  { event_mdown = function() private.TaskComplete( "ball",            1 ) end } } );
  table.insert( table_multiset, { "spr_itemscollecting_tablets",               { event_mdown = function() private.TaskComplete( "tablets",         7 ) end } } );
  table.insert( table_multiset, { "spr_itemscollecting_watch",                 { event_mdown = function() private.TaskComplete( "watch",           9 ) end } } );
  table.insert( table_multiset, { "spr_itemscollecting_toothpaste",            { event_mdown = function() private.TaskComplete( "toothpaste",      6 ) end } } );
  table.insert( table_multiset, { "spr_itemscollecting_mask_night",            { event_mdown = function() private.TaskComplete( "mask_night",      4 ) end } } );
  table.insert( table_multiset, { "spr_itemscollecting_message",               { event_mdown = function() private.TaskComplete( "message",         8 ) end } } );

  table.insert( table_multiset, { "spr_itemscollecting_suitcase",              { event_mdown = function() private.get_suitcase()                        end } } );

  for i = 1, private.cout_piece do

    table.insert( table_multiset, { "spr_itemscollecting_suitcase_"..i, 
                                  { 
                                    event_mdown  = function () private.ClkPiece( i ) end,
                                    event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end,
                                    event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end  
                                  } } );
  end;

  table.insert( table_multiset, { "obj_itemscollecting_clk_box_1",             { event_mdown = function() private.clk_box() end } } );
  table.insert( table_multiset, { "obj_itemscollecting_clk_box_2",             { event_mdown = function() private.clk_box() end } } );
  --private.item_list_with_piece = { "slide_photography",  "film_cassette",  "sunglasses",  "respirator",  "microscope",  "butterfly",
  --                                 "skeleton",           "suitcase",       "molecule",    "brain",       "blood",       "prism",
  --                               };  

  ObjMultiSet( table_multiset );
  --------------------------------------------------------------------------------------------
  -- function win_itemscollecting () end;
  --------------------------------------------------------------------------------------------  
  common_impl.hint[ "win_itemscollecting" ] = {
      type = "win",
      room = "rm_apartment",
      zz = "ho_itemscollecting",
      zz_gate = "gho_apartment_itemscollecting"
  };
  
  local win_itemscollecting_inv = function ()

    if ( cmn.IsEventDone( "win_itemscollecting" ) ) then

      interface.InventoryItemAdd( "inv_bagwiththings", "spr_itemscollecting_win" );
      ObjSet( "inv_bagwiththings", { drag = false } );   

    end;

  end;

  local win_itemscollecting_loc = function ()

    if ( cmn.IsEventDone( "win_itemscollecting" ) ) then

      ObjDelete( "gho_apartment_itemscollecting" );
      ObjDelete( "spr_apartment_itemscollecting_2" );

      ObjMultiSet( { 
        { "spr_apartment_itemscollecting_3",      { alp = 1 } }, 
        { "obj_coffeetable_ext_clk_david_kane_1", { input = true } },
        { "anm_apartment_phone",                  { playing = true } },
        { "anm_coffeetable_ext_call",             { active = 1 } },
      } );
    end;

  end;
  cmn.AddSubscriber( "win_itemscollecting", win_itemscollecting_inv );
  cmn.AddSubscriber( "win_itemscollecting", win_itemscollecting_loc, "rm_apartment" );
  --------------------------------------------------------------------------------------------------
  local start_itemscollecting_func = function ()

    if ( cmn.IsEventStart( "win_itemscollecting" ) ) then

      local ho_found = ng_global.progress[ "ext" ][ "win_itemscollecting" ].found;

      for i = 1, #ho_found, 1 do

        ObjDelete( ho_found[ i ][ "object" ] );

      end;

    end;

  end;
  cmn.AddSubscriber( "win_itemscollecting", start_itemscollecting_func, private.room_objname );  
end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();
  common_impl.EnvPlay( { "mus_env/aud_ho_mus_env" }, "", 0.5 );

  if ( not cmn.IsEventDone( "opn_itemscollecting" ) ) then
  
    cmn.InitHo( "itemscollecting" );
    cmn.SetEventDone( "opn_itemscollecting" );
    ng_global.progress[ "ext" ][ "win_itemscollecting" ].pieces = { };
    ng_global.progress[ "ext" ][ "win_itemscollecting" ].puzzles = { };

    for i = 1, private.cout_piece do
  
      ng_global.progress[ "ext" ][ "win_itemscollecting" ].pieces[ i ] = 0;
      ng_global.progress[ "ext" ][ "win_itemscollecting" ].puzzles[ i ] = 0;

    end;

    ng_global.progress[ "ext" ][ "win_itemscollecting" ].objects_counter = private.cout_piece;
    ng_global.progress[ "ext" ][ "win_itemscollecting" ].puzzle_counter = private.cout_piece;
    ng_global.progress[ "ext" ][ "win_itemscollecting" ].item_counter = private.cout_items;

    ng_global.progress[ "ext" ][ "win_itemscollecting" ].open_box = true;
    ng_global.progress[ "ext" ][ "win_itemscollecting" ].close_up = false;
    ng_global.progress[ "ext" ][ "win_itemscollecting" ].close_down = false;

    cmn.SetMarkedTask( "itemscollecting", "harmonica" );
    cmn.SetMarkedTask( "itemscollecting", "photo" );
    cmn.SetMarkedTask( "itemscollecting", "chess" );
    cmn.SetMarkedTask( "itemscollecting", "cup" );

    cmn.SetMarkedTask( "itemscollecting", "white_shirt" );
    cmn.SetMarkedTask( "itemscollecting", "swimming_trunks" );
    cmn.SetMarkedTask( "itemscollecting", "ball" );  

  end;

  local ho_items = {};
  
  interface.TaskPanelTaskAdd( ho_items, "chess",              1, 1, { { "spr_itemscollecting_chess"           }, { "obj_itemscollecting_clk_box_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "white_shirt",        1, 0, { { "spr_itemscollecting_white_shirt"     }, { "obj_itemscollecting_clk_box_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "swimming_trunks",    1, 0, { { "spr_itemscollecting_swimming_trunks" }, { "obj_itemscollecting_clk_box_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "cup",                1, 1, { { "spr_itemscollecting_cup"             }, { "obj_itemscollecting_clk_box_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "ball",               1, 0, { { "spr_itemscollecting_ball"            }, { "obj_itemscollecting_clk_box_2"} } );
  interface.TaskPanelTaskAdd( ho_items, "tablets",            1, 0, { { "spr_itemscollecting_tablets"         } } );
  interface.TaskPanelTaskAdd( ho_items, "harmonica",          1, 1, { { "spr_itemscollecting_harmonica"       }, { "obj_itemscollecting_clk_box_1"} } );
  interface.TaskPanelTaskAdd( ho_items, "watch",              1, 0, { { "spr_itemscollecting_watch"           } } );
  interface.TaskPanelTaskAdd( ho_items, "toothpaste",         1, 0, { { "spr_itemscollecting_toothpaste"      } } );
  interface.TaskPanelTaskAdd( ho_items, "mask_night",         1, 0, { { "spr_itemscollecting_mask_night"      } } );
  interface.TaskPanelTaskAdd( ho_items, "photo",              1, 1, { { "spr_itemscollecting_photo"           }, { "obj_itemscollecting_clk_box_1"} } );
  interface.TaskPanelTaskAdd( ho_items, "message",            1, 0, { { "spr_itemscollecting_message"         } } );

  interface.TaskPanelTaskAdd( ho_items, "suitcase_1",         1, 0, { { "spr_itemscollecting_suitcase_1"  }, { "obj_itemscollecting_clk_box_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "suitcase_2",         1, 0, { { "spr_itemscollecting_suitcase_2"  }, { "obj_itemscollecting_clk_box_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "suitcase_3",         1, 0, { { "spr_itemscollecting_suitcase_3"  }, { "obj_itemscollecting_clk_box_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "suitcase_4",         1, 0, { { "spr_itemscollecting_suitcase_4"  } } );
  interface.TaskPanelTaskAdd( ho_items, "suitcase_5",         1, 0, { { "spr_itemscollecting_suitcase_5"  }, { "obj_itemscollecting_clk_box_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "suitcase_6",         1, 0, { { "spr_itemscollecting_suitcase_6"  } } );
  interface.TaskPanelTaskAdd( ho_items, "suitcase_7",         1, 0, { { "spr_itemscollecting_suitcase_7"  } } );
  interface.TaskPanelTaskAdd( ho_items, "suitcase_8",         1, 0, { { "spr_itemscollecting_suitcase_8"  } } );
  interface.TaskPanelTaskAdd( ho_items, "suitcase_9",         1, 0, { { "spr_itemscollecting_suitcase_9"  } } );
  interface.TaskPanelTaskAdd( ho_items, "suitcase_10",        1, 0, { { "spr_itemscollecting_suitcase_10" }, { "obj_itemscollecting_clk_box_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "suitcase_11",        1, 0, { { "spr_itemscollecting_suitcase_11" }, { "obj_itemscollecting_clk_box_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "suitcase_12",        1, 0, { { "spr_itemscollecting_suitcase_12" }, { "obj_itemscollecting_clk_box_2" } } );

  interface.TaskPanelTaskAdd( ho_items, "suitcase",           1, 0, { { "spr_itemscollecting_suitcase" } } );  
  
  interface.TaskPanelShow( ho_items );

  for i = 1, #ng_global.progress[ "ext" ][ "win_itemscollecting" ].pieces do

    if ( ng_global.progress[ "ext" ][ "win_itemscollecting" ].pieces[ i ] == 1 ) then

      if ( i == 2 or i == 12 or i == 1 ) then

        if ( ng_global.progress[ "ext" ][ "win_itemscollecting" ].open_box == false ) then

          ObjSet( "spr_itemscollecting_suitcase_"..i, { input = true  } );

        end;

      elseif ( i == 10 or i == 11 or i == 5 or i == 3 ) then

        if ( ng_global.progress[ "ext" ][ "win_itemscollecting" ].open_box == false ) then

          ObjSet( "spr_itemscollecting_suitcase_"..i, { input = true  } );

        end;

      else 

        ObjSet( "spr_itemscollecting_suitcase_"..i, { input = true  } );

      end;

    end;   

  end;

  for i = 1, #ng_global.progress[ "ext" ][ "win_itemscollecting" ].puzzles do

    if ( ng_global.progress[ "ext" ][ "win_itemscollecting" ].puzzles[ i ] == 1 ) then

      ObjDelete( "spr_itemscollecting_suitcase_"..i );
      ObjSet( "spr_itemscollecting_in_suitcase_"..i, { alp = 1 } );

    end;   

  end;

  if ( ng_global.progress[ "ext" ][ "win_itemscollecting" ].open_box ) then

    private.clk_box_open();
    ObjSet( "obj_itemscollecting_box_up", { pos_x = 0, pos_y = 0 } );

  else

    private.clk_box_close();
    ObjSet( "obj_itemscollecting_box_up", { pos_x = 86, pos_y = -86 } );

  end;


  if ( ng_global.progress[ "ext" ][ "win_itemscollecting" ].close_up ) then

    private.clk_box_close();
    ObjSet( "obj_itemscollecting_box_up", { pos_x = 86, pos_y = -86 } );
    ObjDelete( "obj_itemscollecting_clk_box_1" );
    ObjDelete( "obj_itemscollecting_clk_box_2" );

  elseif ( ng_global.progress[ "ext" ][ "win_itemscollecting" ].close_down ) then

    private.clk_box_open();
    ObjSet( "obj_itemscollecting_box_up", { pos_x = 0, pos_y = 0 } );
    ObjDelete( "obj_itemscollecting_clk_box_1" );
    ObjDelete( "obj_itemscollecting_clk_box_2" );

  end;

  if ( ng_global.progress[ "ext" ][ "win_itemscollecting" ].item_counter == 0 ) then

    ObjAttach( "txt_itemscollecting_task", "int_taskpanel_impl");
    ObjSet( "obj_int_taskpanel", { alp = 0 } );

    if ( ng_global.progress[ "ext" ][ "win_itemscollecting" ].puzzle_counter == 0 ) then

      ObjSet( "spr_itemscollecting_suitcase", { alp = 1, input = true                     } );
      ObjSet( "txt_itemscollecting_task",              { alp = 1, text = private.find_final_object } );

    else 

      ObjSet( "txt_itemscollecting_task", { alp = 1, param0 = ng_global.progress[ "ext" ][ "win_itemscollecting" ].puzzle_counter } );
         
    end;

  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();

--  if cmn.IsEventStart( "see_tutorial" ) then
--
--    common_impl.TutorialShow( "tutorial_page_6" );
--
--  end;

end;
--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  ObjAttach( "txt_itemscollecting_task", "ho_itemscollecting");
  common_impl.PassingHoStop();

end;
--*********************************************************************************************************************
function public.HoComplete ()

  common_impl.PassingHoWin();

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete ( task_name, piece_number, object )
  
  local find_obj = "spr_itemscollecting_"..task_name;
  if ( object ) then

    find_obj = object;

  end;

  cmn.HoTaskFind( find_obj, task_name );
  
  ng_global.progress[ "ext" ][ "win_itemscollecting" ].item_counter = ng_global.progress[ "ext" ][ "win_itemscollecting" ].item_counter - 1;

  if ( piece_number ) then

    ObjSet( "spr_itemscollecting_suitcase_"..piece_number, { input = true } );
    ng_global.progress[ "ext" ][ "win_itemscollecting" ].pieces[ piece_number ] = 1;

  end;

  if ( ng_global.progress[ "ext" ][ "win_itemscollecting" ].item_counter == 0 ) then

    ObjAttach( "txt_itemscollecting_task", "int_taskpanel_impl");
    ObjSet( "obj_int_taskpanel",      { alp = 0 } );
    ObjSet( "txt_itemscollecting_task",  { alp = 1, param0 = ng_global.progress["ext"]["win_itemscollecting"].puzzle_counter } );
    
  end;

end;
--------------------------------------------------------------------------------------------
function private.ClkPiece ( id )
 
  local old_coords = ObjGet( "spr_itemscollecting_suitcase_"..id );
  local new_coords = ObjGet( "spr_itemscollecting_in_suitcase_"..id.."_complete" );

  ObjAttach( "spr_itemscollecting_suitcase_"..id, "ho_itemscollecting" );
  ObjSet( "spr_itemscollecting_suitcase_"..id, { pos_z = 20, input = false } );

  local func_end = function()

    ng_global.progress[ "ext" ][ "win_itemscollecting" ].puzzle_counter = ng_global.progress[ "ext" ][ "win_itemscollecting" ].puzzle_counter - 1;
    ng_global.progress[ "ext" ][ "win_itemscollecting" ].puzzles[ id ] = 1;
    ObjSet( "txt_itemscollecting_task", { param0 = ng_global.progress[ "ext" ][ "win_itemscollecting" ].puzzle_counter } );

      cmn.HoTaskFind( "spr_itemscollecting_in_suitcase_"..id.."_complete", "suitcase_"..id );     
      ObjDelete( "spr_itemscollecting_suitcase_"..id );

    if ( ng_global.progress[ "ext" ][ "win_itemscollecting" ].puzzle_counter == 0 ) then

      ObjSet( "spr_itemscollecting_suitcase", { alp = 1, input = true } );
      ObjSet( "txt_itemscollecting_task", { text = private.find_final_object } );
 
    end;

    if ( id == 2 or id == 1 or id == 12 ) then

      if ( private.IsFound( "suitcase_2" ) and private.IsFound( "suitcase_1" ) and 
          private.IsFound( "suitcase_12" ) ) then

        if ( private.IsFound( "suitcase_10" ) and private.IsFound( "suitcase_5" ) and
          private.IsFound( "suitcase_11" ) and private.IsFound( "suitcase_3" ) ) then

        else

          if ( ng_global.progress[ "ext" ][ "win_itemscollecting" ].close_down == false ) then

            ng_global.progress[ "ext" ][ "win_itemscollecting" ].close_up = true;

          end;

          cmn.Lock( true );
          ObjAnimate( "ho_itemscollecting", "alp", 0, 0, function() ObjDelete( "obj_itemscollecting_clk_box_1" );
                                                                    ObjDelete( "obj_itemscollecting_clk_box_2" );
                                                                    private.clk_box(); end, 
          { 
            0.00, 0, ObjGet( "ho_itemscollecting" ).alp, 
            0.25, 0, ObjGet( "ho_itemscollecting" ).alp,
          } );              

        end; 

      end;

    elseif ( id == 10 or id == 5 or id == 11 or id == 3 ) then

      if ( private.IsFound( "suitcase_10" ) and private.IsFound( "suitcase_5" ) and
          private.IsFound( "suitcase_11" ) and private.IsFound( "suitcase_3" ) ) then

        if ( private.IsFound( "suitcase_2" ) and private.IsFound( "suitcase_1" ) and 
          private.IsFound( "suitcase_12" ) ) then

        else

          if ( ng_global.progress[ "ext" ][ "win_itemscollecting" ].close_up == false ) then

            ng_global.progress[ "ext" ][ "win_itemscollecting" ].close_down = true;

          end;

          cmn.Lock( true );    
          ObjAnimate( "ho_itemscollecting", "alp", 0, 0, function() ObjDelete( "obj_itemscollecting_clk_box_1" );
                                                                    ObjDelete( "obj_itemscollecting_clk_box_2" );
                                                                    private.clk_box(); end, 
          { 
            0.00, 0, ObjGet( "ho_itemscollecting" ).alp, 
            0.25, 0, ObjGet( "ho_itemscollecting" ).alp,
          } ); 

        end; 

      end;

    end;   
  
  end;

  common_impl.StopAudio( "sfx", "aud_hide_sfx", 0 );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_ho_clk1", 0, "", 0 );

  ObjAnimate( "spr_itemscollecting_suitcase_"..id, "pos_xy", 0, 0, func_end, 
  { 
    0.0, 0, old_coords.pos_x, old_coords.pos_y,   
    0.5, 0, new_coords.pos_x, new_coords.pos_y 
  } );
  ObjAnimate( "spr_itemscollecting_in_suitcase_"..id, "alp", 0, 0, "", 
  { 
    0.0, 0, 0, 
    0.5, 0, 0, 
    0.7, 0, 1,
  } );  
  ObjAnimate( "spr_itemscollecting_in_suitcase_"..id.."_complete", "alp", 0, 0, "", 
  { 
    0.0, 0, 0, 
    0.3, 0, 0, 
    0.5, 0, 1,
  } );  

end;
--------------------------------------------------------------------------------------------
function private.clk_box ()

  local func_end_open = function()

    private.clk_box_open();

  end;
  local func_end_close = function()

    private.clk_box_close();

  end;  

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_drawer", 0, "", 0 );

  if ( ng_global.progress[ "ext" ][ "win_itemscollecting" ].open_box ) then

    ObjAnimate( "obj_itemscollecting_box_up", "pos_xy", 0, 0, func_end_close, 
    { 
      0.0, 0, ObjGet( "obj_itemscollecting_box_up" ).pos_x, ObjGet( "obj_itemscollecting_box_up" ).pos_y,
      0.3, 0, 86, -86, 
    } ); 

  else

    ObjAnimate( "obj_itemscollecting_box_up", "pos_xy", 0, 0, func_end_open, 
    { 
      0.0, 0, ObjGet( "obj_itemscollecting_box_up" ).pos_x, ObjGet( "obj_itemscollecting_box_up" ).pos_y,
      0.3, 0, 0, 0, 
    } ); 

  end;

end;
--------------------------------------------------------------------------------------------
function private.clk_box_open ()

  local white_shirt = private.IsFound( "white_shirt" );
  local swimming_trunks = private.IsFound( "swimming_trunks" );
  local ball = private.IsFound( "ball" );

  local chess = private.IsFound( "chess" );
  local cup = private.IsFound( "cup" );
  local harmonica = private.IsFound( "harmonica" );
  local photo = private.IsFound( "photo" ); 

  cmn.Lock( false );
  ng_global.progress[ "ext" ][ "win_itemscollecting" ].open_box = true;  

  ObjMultiSet( {
    {"obj_itemscollecting_clk_box_1",       { input = true } },   
    {"obj_itemscollecting_clk_box_2",       { input = false } },   
  
    {"obj_itemscollecting_box_up",          { pos_x = 0, pos_y = 0 } },    

    {"spr_itemscollecting_suitcase_10",     { input = false } }, 
    {"spr_itemscollecting_suitcase_3",      { input = false } }, 
    {"spr_itemscollecting_suitcase_5",      { input = false } }, 
    {"spr_itemscollecting_suitcase_11",     { input = false } }, 

    {"spr_itemscollecting_suitcase_12",     { input = false } }, 
    {"spr_itemscollecting_suitcase_2",      { input = false } }, 
    {"spr_itemscollecting_suitcase_1",      { input = false } }, 
  } );

  --верхний ящик
  if ( white_shirt == false ) then

    cmn.UnmarkTask( "itemscollecting", "white_shirt" );
    ObjSet( "spr_itemscollecting_white_shirt", { input = true } );

  else 

    if ( private.IsFound( "suitcase_2" ) == false ) then

      ObjSet( "spr_itemscollecting_suitcase_2", { input = true } );

    end;

  end;
  if ( swimming_trunks == false ) then

    cmn.UnmarkTask( "itemscollecting", "swimming_trunks" );
    ObjSet( "spr_itemscollecting_swimming_trunks", { input = true } );

  else

    if ( private.IsFound( "suitcase_12" ) == false ) then

      ObjSet( "spr_itemscollecting_suitcase_12", { input = true } );

    end;

  end;
  if ( ball == false ) then

    cmn.UnmarkTask( "itemscollecting", "ball" );
    ObjSet( "spr_itemscollecting_ball", { input = true } );

  else

    if ( private.IsFound( "suitcase_1" ) == false ) then

      ObjSet( "spr_itemscollecting_suitcase_1", { input = true } );

    end;

  end;

  --нижний ящик
  if ( chess == false ) then

    cmn.SetMarkedTask( "itemscollecting", "chess" );
    interface.TaskPanelTaskMark( "itemscollecting", "chess" );
    ObjSet( "spr_itemscollecting_chess", { input = false } );

  else

    if ( private.IsFound( "suitcase_11" ) == false ) then

      ObjSet( "spr_itemscollecting_suitcase_11", { input = false } );

    end;

  end;
  if ( cup == false ) then

    cmn.SetMarkedTask( "itemscollecting", "cup" );
    interface.TaskPanelTaskMark( "itemscollecting", "cup" );
    ObjSet( "spr_itemscollecting_cup", { input = false } );

  else

    if ( private.IsFound( "suitcase_10" ) == false ) then

      ObjSet( "spr_itemscollecting_suitcase_10", { input = false } );

    end;

  end;
  if ( harmonica == false ) then

    cmn.SetMarkedTask( "itemscollecting", "harmonica" );
    interface.TaskPanelTaskMark( "itemscollecting", "harmonica" );
    ObjSet( "spr_itemscollecting_harmonica", { input = false } );

  else

    if ( private.IsFound( "suitcase_3" ) == false ) then

      ObjSet( "spr_itemscollecting_suitcase_3", { input = false } );

    end;

  end;
  if ( photo == false ) then

    cmn.SetMarkedTask( "itemscollecting", "photo" );
    interface.TaskPanelTaskMark( "itemscollecting", "photo" );
    ObjSet( "spr_itemscollecting_photo", { input = false } );
  
  else 

    if ( private.IsFound( "suitcase_5" ) == false ) then

      ObjSet( "spr_itemscollecting_suitcase_5", { input = false } );

    end;

  end;

end;
--------------------------------------------------------------------------------------------
function private.clk_box_close ()

  local white_shirt = private.IsFound( "white_shirt" );
  local swimming_trunks = private.IsFound( "swimming_trunks" );
  local ball = private.IsFound( "ball" );

  local chess = private.IsFound( "chess" );
  local cup = private.IsFound( "cup" );
  local harmonica = private.IsFound( "harmonica" );
  local photo = private.IsFound( "photo" ); 

  cmn.Lock( false );
  ng_global.progress[ "ext" ][ "win_itemscollecting" ].open_box = false;

  ObjMultiSet( {
    {"obj_itemscollecting_clk_box_1",       { input = false } }, 
    {"obj_itemscollecting_clk_box_2",       { input = true } },
 
    {"obj_itemscollecting_box_up",          { pos_x = 86, pos_y = -86 } },   

    {"spr_itemscollecting_suitcase_10",     { input = false } }, 
    {"spr_itemscollecting_suitcase_3",      { input = false } }, 
    {"spr_itemscollecting_suitcase_5",      { input = false } }, 
    {"spr_itemscollecting_suitcase_11",     { input = false } }, 

    {"spr_itemscollecting_suitcase_12",     { input = false } }, 
    {"spr_itemscollecting_suitcase_2",      { input = false } }, 
    {"spr_itemscollecting_suitcase_1",      { input = false } }, 
  } );
  --нижний ящик
  if ( cup == false ) then

    cmn.UnmarkTask( "itemscollecting", "cup" );
    ObjSet( "spr_itemscollecting_cup", { input = true } );

  else

    if ( private.IsFound( "suitcase_10" ) == false ) then

      ObjSet( "spr_itemscollecting_suitcase_10", { input = true } );

    end;
  
  end;
  if ( harmonica == false ) then

    cmn.UnmarkTask( "itemscollecting", "harmonica" );
    ObjSet( "spr_itemscollecting_harmonica", { input = true } );

  else

    if ( private.IsFound( "suitcase_3" ) == false ) then

      ObjSet( "spr_itemscollecting_suitcase_3", { input = true } );

    end;

  end;
  if ( photo == false ) then

    cmn.UnmarkTask( "itemscollecting", "photo" );
    ObjSet( "spr_itemscollecting_photo", { input = true } );

  else 

    if ( private.IsFound( "suitcase_5" ) == false ) then

      ObjSet( "spr_itemscollecting_suitcase_5", { input = true } );

    end;

  end;
  if ( chess == false ) then

    cmn.UnmarkTask( "itemscollecting", "chess" );
    ObjSet( "spr_itemscollecting_chess", { input = true } );

  else

    if ( private.IsFound( "suitcase_11" ) == false ) then

      ObjSet( "spr_itemscollecting_suitcase_11", { input = true } );

    end;

  end;

  --верхний ящик
  if ( white_shirt == false ) then

    cmn.SetMarkedTask( "itemscollecting", "white_shirt" );
    interface.TaskPanelTaskMark( "itemscollecting", "white_shirt" );
    ObjSet( "spr_itemscollecting_white_shirt", { input = false } );

  else 

    if ( private.IsFound( "suitcase_2" ) == false ) then

      ObjSet( "spr_itemscollecting_suitcase_2", { input = false } );

    end;

  end;
  if ( swimming_trunks == false ) then

    cmn.SetMarkedTask( "itemscollecting", "swimming_trunks" );
    interface.TaskPanelTaskMark( "itemscollecting", "swimming_trunks" );
    ObjSet( "spr_itemscollecting_swimming_trunks", { input = false } );

  else

    if ( private.IsFound( "suitcase_12" ) == false ) then

      ObjSet( "spr_itemscollecting_suitcase_12", { input = false } );

    end;

  end;
  if ( ball == false ) then    

    cmn.SetMarkedTask( "itemscollecting", "ball" );
    interface.TaskPanelTaskMark( "itemscollecting", "ball" );
    ObjSet( "spr_itemscollecting_ball", { input = false } );

  else

    if ( private.IsFound( "suitcase_1" ) == false ) then

      ObjSet( "spr_itemscollecting_suitcase_1", { input = false } );

    end;

  end;

end;
--------------------------------------------------------------------------------------------
function private.IsFound ( task_name )

  local task_name = tostring( task_name );

  local ho_found = ng_global.progress[ "ext" ][ "win_itemscollecting" ].found;
  local task_found = false;
        
        for i = 1, #ho_found, 1 do
          
          local task = ho_found[ i ][ "task" ];

          if task == task_name then
             task_found = true;
             break;
          end;

        end;

   return task_found;  

end;
--------------------------------------------------------------------------------------------
function private.get_suitcase ()

  cmn.HoTaskFind( "spr_itemscollecting_suitcase", "suitcase" );

end;
--*********************************************************************************************************************
function private.Init_Animation()

    ObjAnimate( "spr_itemscollecting_light_add", "alp", 1, 0, "", 
    { 
      0.0, 0, 1, 
      3.0, 0, 0.4, 
      6.0, 0, 1, 
    } ); 

end;
