-- name=mg_forandagainst
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_forandagainst";

  private.count_small_simb = 8;
  private.count_big_simb = 4;

  private.name_simb = {
    "no_money", "doctor", "life", "family", "carriage", "phone", "hourglass", "death",
  };
  private.forandagainst_state = {
    false, false, false, false, 
    false, false, false, false,
  };
  private.forandagainst_step = 1;
  private.forandagainst_choose = { 0, 0 };

  ObjMultiSet( { 
    { "obj_forandagainst_marker1_clk", { event_mdown = private.marker1_clk } },
  } );

  for i = 1, private.count_small_simb do

    ObjMultiSet( { 
      { "obj_forandagainst_clk_small_"..i.."_1", { event_mdown = function() private.SmallSimbolClk( i, 1 ); end } },
      { "obj_forandagainst_clk_small_"..i.."_2", { event_mdown = function() private.SmallSimbolClk( i, 2 ); end } },
      { "obj_forandagainst_clk_small_big_"..i,   { event_mdown = function() private.SmallBigSimbolClk( i ); end } },
    } );

  end;
  for i = 1, private.count_big_simb do

    ObjSet( "obj_forandagainst_clk_big_"..i, 
    {
      event_mdown  = function() private.BigSimbolClk( i ); end,
      event_menter = function() private.EnterBigSimb( i ); end,     
      event_mleave = function() private.LeaveBigSimb( i ); end,       
    } );

  end;

  private.small_simb_data = 
  {
    { 418,  93, -2.28, 0.58 },
    { 446, 173,  0.03, 0.62 },
    { 443, 242,     0, 0.58 },
    { 463, 299, -0.07, 0.58 },
    { 479, 378, -0.07, 0.58 },
    { 476, 450,     0, 0.58 },
    { 515, 525,  0.58, 0.64 },
    { 472, 580,     0, 0.58 },
  };
  private.big_simb_data = {
    { 886, 65 },
    { 908, 183 },
    { 939, 313 },
    { 968, 456 },
  };
  private.small_choose = 0;
  private.big_state = { 0, 0, 0, 0 };
  --------------------------------------------------------------------------------------------
  -- function win_forandagainst () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_forandagainst" ] = {
    type = "win",
    room = "rm_managerroom",
    zz = private.room_objname,
    zz_gate = "gmg_managerroom_forandagainst",
  };
  local win_forandagainst = function ()

    if ( cmn.IsEventDone( "win_forandagainst" ) ) then  
      


    else

    end;

  end;
  local win_forandagainst_loc = function ()
    
    if ( cmn.IsEventDone( "win_forandagainst" ) ) then  

      ObjDelete( "gmg_managerroom_forandagainst" );
      --ObjSet( "spr_dlg_managerroom_interview_1_frazer_2", { alp = 0 } );
      --ObjSet( "spr_dlg_managerroom_interview_2_frazer", { alp = 1 } );
      ObjMultiSet( {
        { "anm_managerroom_dialog2_frazer",         { alp = 1, playing = true } },
        { "anm_managerroom_dialog2_frazerandmouse", { alp = 1 } },
      } );
      ObjDelete( "anm_managerroom_dialog_frazerandmouse" );
      ObjDelete( "anm_managerroom_dialog_frazer" );

    end;

  end;
  cmn.AddSubscriber( "win_forandagainst", win_forandagainst, private.room_objname );
  cmn.AddSubscriber( "win_forandagainst", win_forandagainst_loc, "rm_managerroom" );
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Load ()

  if ( cmn.IsEventStart( "win_forandagainst" ) ) then

    for i = 1, #private.forandagainst_state do

      private.forandagainst_state[ i ] = ng_global.progress[ "ext" ][ "win_forandagainst" ].state[ i ];

    end;
    for i = 1, #private.forandagainst_choose do

      private.forandagainst_choose[ i ] = ng_global.progress[ "ext" ][ "win_forandagainst" ].choose[ i ];           

    end; 

    private.forandagainst_step = ng_global.progress[ "ext" ][ "win_forandagainst" ].step;
    private.small_choose = ng_global.progress[ "ext" ][ "win_forandagainst" ].small_choose;

    for i = 1, #private.big_state do

      private.big_state[ i ] = ng_global.progress[ "ext" ][ "win_forandagainst" ].big_state[ i ];

    end;

    for i = 1, #private.forandagainst_state do

      if ( private.forandagainst_state[ i ] ) then
      
        ObjMultiSet( {  
          { "obj_forandagainst_clk_small_"..i.."_1",        { input = false } },
          { "obj_forandagainst_clk_small_"..i.."_2",        { input = false } },
          { "spr_forandagainst_marker_"..i.."_1",           { alp = 1 } },
          { "spr_forandagainst_marker_"..i.."_2",           { alp = 1 } },
          { "spr_forandagainst_"..private.name_simb[ i ],   { alp = 1 } },
        } );       

      end;

    end; 

    if ( private.forandagainst_choose[ 1 ] ~= 0 ) then

      ObjMultiSet( {  
        { "spr_forandagainst_marker_"..private.forandagainst_choose[ 1 ].."_"..private.forandagainst_choose[ 2 ],     { alp = 1 } },
        { "obj_forandagainst_clk_small_"..private.forandagainst_choose[ 1 ].."_"..private.forandagainst_choose[ 2 ],  { input = false  } },
      } );

    end;

    if ( ng_global.progress[ "ext" ][ "win_forandagainst" ].mg_win == 2 ) then

      ObjMultiSet( {
        { "obj_forandagainst_small_simbol_clk",   { input = false } }, 
        { "obj_forandagainst_small_big_clk",      { input = true } },
        { "obj_forandagainst_big_clk",            { input = true } },
      } );

      if ( private.small_choose ~= 0 ) then
        
        local name = "spr_forandagainst_"..private.name_simb[ private.small_choose ];
        local scale = ObjGet( name ).scale_x + 0.1;
        ObjSet( name, {  scale_x = scale, scale_y = scale } );

      end;

      for i = 1, #private.big_state do

        if ( private.big_state[ i ] ~= 0 ) then

          local name = "spr_forandagainst_"..private.name_simb[ private.big_state[ i ] ];
          ObjSet( name, 
          { 
            pos_x = private.big_simb_data[ i ][ 1 ], 
            pos_y = private.big_simb_data[ i ][ 2 ],
            ang = 0,
            scale_x = 1, 
            scale_y = 1,
          } )

        end;

      end;

      private.MakeInputCollumn();

    end;

  end;

end;
--*********************************************************************************************************************
function public.Open () 

  int_slider.InitSlider( private.room_objname );

  if not cmn.IsEventDone( "win_forandagainst" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();

  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  if ( not cmn.IsEventStart( "win_forandagainst" ) ) then

    ng_global.progress[ "ext" ][ "win_forandagainst" ].state = { 
      false, false, false, false, 
      false, false, false, false,
    };
    ng_global.progress[ "ext" ][ "win_forandagainst" ].step = 1;
    ng_global.progress[ "ext" ][ "win_forandagainst" ].choose = { 0, 0 };

    ng_global.progress[ "ext" ][ "win_forandagainst" ].small_choose = 0;
    ng_global.progress[ "ext" ][ "win_forandagainst" ].big_state = { 0, 0, 0, 0 };

    ng_global.progress[ "ext" ][ "win_forandagainst" ].mg_win = 1;

  end;

end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()

  if not cmn.IsEventDone( "win_forandagainst" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset ()

  local func_end = function()
  
    local func_end_1 = function()

      cmn.Lock( false );
      ng_global.progress[ "ext" ][ "win_forandagainst" ].mg_win = 1;
      private.small_choose = 0;
      private.big_state = { 0, 0, 0, 0 };    
      private.forandagainst_state = {
        false, false, false, false, 
        false, false, false, false,
      };
      private.forandagainst_step = 1;
      private.forandagainst_choose = { 0, 0 };  
      private.SaveBigVar();
      private.SaveSmallVar();
      private.MakeInputCollumn();

      for i = 1, private.count_small_simb do

        ObjMultiSet( { 
          { "obj_forandagainst_clk_small_"..i.."_1", { input = true } },
          { "obj_forandagainst_clk_small_"..i.."_2", { input = true } },
        } );   

      end;
      
      ObjMultiSet( {
        { "obj_forandagainst_small_big_clk",      { input = false } }, 
        { "obj_forandagainst_big_clk",            { input = false } }, 
        { "obj_forandagainst_small_simbol_clk",   { input = true } }
      } );

    end;
   
      for i = 1, private.count_small_simb do 

        ObjAnimate( "spr_forandagainst_marker_"..i.."_1", "alp", 0, 0, "", 
        { 
          0.0, 0, ObjGet( "spr_forandagainst_marker_"..i.."_1" ).alp,     
          0.3, 0, 0, 
        } ); 
        ObjAnimate( "spr_forandagainst_marker_"..i.."_2", "alp", 0, 0, "", 
        { 
          0.0, 0, ObjGet( "spr_forandagainst_marker_"..i.."_2" ).alp,     
          0.3, 0, 0, 
        } );  
        local name = "spr_forandagainst_"..private.name_simb[ i ]; 
        ObjAnimate( name, "alp", 0, 0, "", 
        { 
          0.0, 0, ObjGet( name ).alp,     
          0.3, 0, 0, 
        } );  

      end; 
   
    cmn.Lock( true );
    ObjAnimate( "mg_forandagainst", "alp", 0, 0, func_end_1, 
    { 
      0.0, 0, ObjGet( "mg_forandagainst" ).alp,
      0.3, 0, ObjGet( "mg_forandagainst" ).alp,
    } );

  end;

  for i = 1, #private.big_state do
    
    ObjAnimate( "spr_forandagainst_red_marker"..i, "alp", 0, 0, "", 
    { 
      0.0, 0, ObjGet( "spr_forandagainst_red_marker"..i ).alp, 
      0.3, 0, 0, 
    } );
    ObjAnimate( "spr_forandagainst_green_marker"..i, "alp", 0, 0, "", 
    { 
      0.0, 0, ObjGet( "spr_forandagainst_green_marker"..i ).alp, 
      0.3, 0, 0, 
    } );

    if ( private.big_state[ i ] ~= 0 ) then

      local name = "spr_forandagainst_"..private.name_simb[ private.big_state[ i ] ];
      ObjAnimate( name, "pos_xy", 0, 0, "", 
      { 
        0.0, 0, ObjGet( name ).pos_x, ObjGet( name ).pos_y, 
        0.3, 0, ObjGet( name ).pos_x, ObjGet( name ).pos_y,     
        0.5, 0, private.small_simb_data[ private.big_state[ i ] ][ 1 ], private.small_simb_data[ private.big_state[ i ] ][ 2 ],
      } ); 
      ObjAnimate( name, "ang", 0, 0, "", 
      { 
        0.0, 0, ObjGet( name ).ang, 
        0.3, 0, ObjGet( name ).ang, 
        0.5, 0, private.small_simb_data[ private.big_state[ i ] ][ 3 ], 
      } ); 
      ObjAnimate( name, "scale_xy", 0, 0, "", 
      { 
        0.0, 0, ObjGet( name ).scale_x, ObjGet( name ).scale_y,
        0.3, 0, ObjGet( name ).scale_x, ObjGet( name ).scale_y,  
        0.5, 0, private.small_simb_data[ private.big_state[ i ] ][ 4 ], private.small_simb_data[ private.big_state[ i ] ][ 4 ], 
      } ); 

    end;

  end;
  
  cmn.Lock( true );
  ObjAnimate( "mg_forandagainst", "alp", 0, 0, func_end, 
  { 
    0.0, 0, ObjGet( "mg_forandagainst" ).alp,
    0.5, 0, ObjGet( "mg_forandagainst" ).alp,
  } );

end;
--*********************************************************************************************************************
function public.Skip ()

port.skip_mg = true;
  cmn.Lock( true );
  
  local func_end = function()

    local func_end_1 = function()

      private.Win();

    end;

    local win_comb = { 1, 2, 3, 4 };

    for i = 1, #win_comb do

      ObjAnimate( "spr_forandagainst_green_marker"..i, "alp", 0, 0, "", 
      { 
        0.0, 0, ObjGet( "spr_forandagainst_green_marker"..i ).alp, 
        0.3, 0, 1, 
      } );

      local name = "spr_forandagainst_"..private.name_simb[ win_comb[ i ] ];
      ObjAnimate( name, "pos_xy", 0, 0, "", 
      { 
        0.0, 0, ObjGet( name ).pos_x, ObjGet( name ).pos_y, 
        0.3, 0, private.big_simb_data[ win_comb[ i ] ][ 1 ], private.big_simb_data[ win_comb[ i ] ][ 2 ],
      } ); 
      ObjAnimate( name, "ang", 0, 0, "", 
      { 
        0.0, 0, ObjGet( name ).ang, 
        0.3, 0, 0, 
      } ); 
      ObjAnimate( name, "scale_xy", 0, 0, "", 
      { 
        0.0, 0, ObjGet( name ).scale_x, ObjGet( name ).scale_y,  
        0.3, 0, 1, 1,
      } ); 

    end;

    ObjAnimate( "mg_forandagainst", "alp", 0, 0, func_end_1, 
    { 
      0.0, 0, ObjGet( "mg_forandagainst" ).alp,
      0.9, 0, ObjGet( "mg_forandagainst" ).alp,
    } );

  end;

  for i = 1, private.count_small_simb do 

    ObjAnimate( "spr_forandagainst_marker_"..i.."_1", "alp", 0, 0, "", 
    { 
      0.0, 0, ObjGet( "spr_forandagainst_marker_"..i.."_1" ).alp,     
      0.3, 0, 1, 
    } ); 
    ObjAnimate( "spr_forandagainst_marker_"..i.."_2", "alp", 0, 0, "", 
    { 
      0.0, 0, ObjGet( "spr_forandagainst_marker_"..i.."_2" ).alp,     
      0.3, 0, 1, 
    } );  
    local name = "spr_forandagainst_"..private.name_simb[ i ]; 
    ObjAnimate( name, "alp", 0, 0, "", 
    { 
      0.0, 0, ObjGet( name ).alp,     
      0.3, 0, 1, 
    } );  

  end;
  
  for i = 1, #private.big_state do
    
    ObjAnimate( "spr_forandagainst_red_marker"..i, "alp", 0, 0, "", 
    { 
      0.0, 0, ObjGet( "spr_forandagainst_red_marker"..i ).alp, 
      0.3, 0, 0, 
    } );

    if ( private.big_state[ i ] ~= 0 ) then

      local name = "spr_forandagainst_"..private.name_simb[ private.big_state[ i ] ];
      ObjAnimate( name, "pos_xy", 0, 0, "", 
      { 
        0.0, 0, ObjGet( name ).pos_x, ObjGet( name ).pos_y, 
        0.3, 0, ObjGet( name ).pos_x, ObjGet( name ).pos_y,     
        0.5, 0, private.small_simb_data[ private.big_state[ i ] ][ 1 ], private.small_simb_data[ private.big_state[ i ] ][ 2 ],
      } ); 
      ObjAnimate( name, "ang", 0, 0, "", 
      { 
        0.0, 0, ObjGet( name ).ang, 
        0.3, 0, ObjGet( name ).ang, 
        0.5, 0, private.small_simb_data[ private.big_state[ i ] ][ 3 ], 
      } ); 
      ObjAnimate( name, "scale_xy", 0, 0, "", 
      { 
        0.0, 0, ObjGet( name ).scale_x, ObjGet( name ).scale_y,
        0.3, 0, ObjGet( name ).scale_x, ObjGet( name ).scale_y,  
        0.5, 0, private.small_simb_data[ private.big_state[ i ] ][ 4 ], private.small_simb_data[ private.big_state[ i ] ][ 4 ], 
      } ); 

    end;

  end;

  ObjAnimate( "mg_forandagainst", "alp", 0, 0, func_end, 
  { 
    0.0, 0, ObjGet( "mg_forandagainst" ).alp,
    0.9, 0, ObjGet( "mg_forandagainst" ).alp,
  } );

end;
--*********************************************************************************************************************
function private.WinEnd ()

  --common_impl.PlayAudio( "sfx", "aud_mg_win" );
  cmn.Lock( false );
  cmn.MiniGameHide();
  cmn.SetEventDone( "win_forandagainst" );
  cmn.CallEventHandler( "win_forandagainst" );
  common_impl.PassingMgWin();
  cmn.GotoRoom( "rm_managerroom" ); 

end;
--*********************************************************************************************************************
function private.Win ()

  private.WinEnd();

end;
--*********************************************************************************************************************
-- function *** MMG SMALL *** () end;
--*********************************************************************************************************************
function private.SmallSimbolClk ( id, num )

  if ( id == private.forandagainst_step and 
    private.forandagainst_choose[ 1 ] == 0 ) then

    local func_end = function ()

      cmn.Lock( false );
      ObjSet( "obj_forandagainst_felttippen", { alp = 0 } );
      private.forandagainst_choose[ 1 ] = id;
      private.forandagainst_choose[ 2 ] = num;
      ObjSet( "obj_forandagainst_clk_small_"..id.."_"..num,  { input = false } );
      private.SaveSmallVar();

    end;

    local clk_obj = ObjGet( "obj_forandagainst_clk_small_"..id.."_"..num ); 
    ObjSet( "obj_forandagainst_felttippen", { alp = 1, pos_x = clk_obj.pos_x, pos_y = clk_obj.pos_y } );

    cmn.Lock( true );
    AnimPlay( "anm_forandagainst_felttippen", "DoAnim", func_end  );
    ObjAnimate( "spr_forandagainst_marker_"..id.."_"..num, "alp", 0, 0, "", 
    { 
      0.00, 0, 0,     
      0.52, 0, 0,     
      0.86, 0, 1
    } );  

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_pen", 0, "", 0 );

  elseif ( id == private.forandagainst_step and 
    private.forandagainst_choose[ 1 ] == id ) then

    local func_end = function ()

      local func_end_1 = function()

        ObjSet( "obj_forandagainst_clk_small_"..id.."_"..num,  { input = false } );
        private.CheckSmallWin();

      end;
 
      local name_simb = "spr_forandagainst_"..private.name_simb[ private.forandagainst_step ];
      ObjSet( name_simb, { color_r = 1, color_g = 1, color_b = 1 } );
      ObjAnimate( name_simb, "alp", 0, 0, func_end_1, 
      { 
        0.0, 0, 0,     
        0.3, 0, 1,
      } );

      common_impl.PlayAudio( "sfx", "levelext/sfx/aud_mg_clk1", 0, "", 0 );

    end;

    local clk_obj = ObjGet( "obj_forandagainst_clk_small_"..id.."_"..num ); 
    ObjSet( "obj_forandagainst_felttippen", { alp = 1, pos_x = clk_obj.pos_x, pos_y = clk_obj.pos_y } );

    cmn.Lock( true );
    AnimPlay( "anm_forandagainst_felttippen", "DoAnim", func_end  );
    ObjAnimate( "spr_forandagainst_marker_"..id.."_"..num, "alp", 0, 0, "", 
    { 
      0.00, 0, 0,     
      0.52, 0, 0,     
      0.86, 0, 1
    } ); 
       
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_pen", 0, "", 0 );

  else 

    local func_end = function()
      
      local func_end_1 = function () 

        cmn.Lock( false );
        ObjSet( "obj_forandagainst_felttippen", { alp = 0 } );

        for i = 1, private.count_small_simb do

          ObjMultiSet( { 
            { "obj_forandagainst_clk_small_"..i.."_1", { input = true } },
            { "obj_forandagainst_clk_small_"..i.."_2", { input = true } },
          } );         

        end;

        private.forandagainst_state = {
          false, false, false, false, 
          false, false, false, false,
        };
        private.forandagainst_step = 1;
        private.forandagainst_choose = { 0, 0 };        
        private.SaveSmallVar();

      end;

      for i = 1, private.count_small_simb do

        ObjAnimate( "spr_forandagainst_marker_"..i.."_1", "alp", 0, 0, "", 
        { 
          0.0, 0, ObjGet( "spr_forandagainst_marker_"..i.."_1" ).alp,     
          0.3, 0, 0,
        } ); 
        ObjAnimate( "spr_forandagainst_marker_"..i.."_2", "alp", 0, 0, "", 
        { 
          0.0, 0, ObjGet( "spr_forandagainst_marker_"..i.."_2" ).alp,     
          0.3, 0, 0,
        } ); 
        
        local name_simb = "spr_forandagainst_"..private.name_simb[ i ];
        ObjAnimate( name_simb, "alp", 0, 0, "", 
        { 
          0.0, 0, ObjGet( name_simb ).alp,     
          0.3, 0, 0,
        } );

      end;

      ObjAnimate( "mg_forandagainst", "alp", 0, 0, func_end_1, 
      { 
        0.0, 0, ObjGet( "mg_forandagainst" ).alp,     
        0.3, 0, ObjGet( "mg_forandagainst" ).alp,
      } ); 

    end;

    cmn.Lock( true );
    local name_simb = "spr_forandagainst_"..private.name_simb[ private.forandagainst_step ];
    ObjSet( name_simb, { color_r = 1, color_g = 0, color_b = 0 } );
    ObjAnimate( name_simb, "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0,     
      0.1, 0, 1,
      0.4, 0, 1, 
      0.5, 0, 0,  
    } );
    --ObjAnimate( name_simb, "scale_xy", 0, 0, "", 
    --{ 
    --  0.0, 0, 1.0, 1.0,     
    --  0.1, 0, 1.01, 1.01,
    --  0.4, 0, 1.01, 1.01,
    --  0.5, 0, 1.0, 1.0,  
    --} );

    common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

  end;

end;
--*********************************************************************************************************************
function private.CheckSmallWin ()

  cmn.Lock( false );
  ObjSet( "obj_forandagainst_felttippen", { alp = 0 } );
  private.forandagainst_state[ private.forandagainst_step ] = true;
  private.forandagainst_step = private.forandagainst_step + 1;   
  private.forandagainst_choose = { 0, 0 };

  if ( private.IsSmallWin() ) then

    private.WinSmallAnim();    

  else

    private.SaveSmallVar();

  end;
 
end;
--*********************************************************************************************************************
function private.IsSmallWin ()

  local bool = true;
  for i = 1, #private.forandagainst_state do

    if ( private.forandagainst_state[ i ] == false ) then

      bool = false; 
      break;

    end;

  end;   

  return bool;

end;
--*********************************************************************************************************************
function private.SaveSmallVar ()

  for i = 1, #ng_global.progress[ "ext" ][ "win_forandagainst" ].state do

    ng_global.progress[ "ext" ][ "win_forandagainst" ].state[ i ] = private.forandagainst_state[ i ];

  end;
  for i = 1, #ng_global.progress[ "ext" ][ "win_forandagainst" ].choose do

    ng_global.progress[ "ext" ][ "win_forandagainst" ].choose[ i ] = private.forandagainst_choose[ i ];

  end;
  ng_global.progress[ "ext" ][ "win_forandagainst" ].step = private.forandagainst_step;

end;
--*********************************************************************************************************************
function private.WinSmallAnim ()

  cmn.Lock( true );
  for i = 1, private.count_big_simb do

    local name = "spr_forandagainst_big_"..i.."_marker";
    ObjAnimate( name, "alp", 0, 0, "", 
    { 
      0.0, 0, ObjGet( name ).alp,     
      0.2, 0, 1,
      0.8, 0, 1,
      1.0, 0, 0,
    } );

  end;

  for i = 1, private.count_small_simb do 

    local name = "spr_forandagainst_"..private.name_simb[ i ];
    ObjAnimate( name, "scale_xy", 0, 0, "", 
    { 
      0.0, 0, ObjGet( name ).scale_x, ObjGet( name ).scale_y,     
      0.2, 0, ObjGet( name ).scale_x + 0.1, ObjGet( name ).scale_y + 0.1,
      0.8, 0, ObjGet( name ).scale_x + 0.1, ObjGet( name ).scale_y + 0.1,
      1.0, 0, ObjGet( name ).scale_x, ObjGet( name ).scale_y,
    } ); 

  end;

  ObjAnimate( "mg_forandagainst", "alp", 0, 0, function() private.WinSmallEnd(); end, 
  { 
    0.0, 0, ObjGet( "mg_forandagainst" ).alp,
    0.9, 0, ObjGet( "mg_forandagainst" ).alp,
  } );

end;
--*********************************************************************************************************************
function private.WinSmallEnd ()

  cmn.Lock( false );
  ng_global.progress[ "ext" ][ "win_forandagainst" ].mg_win = 2;
  ObjSet( "obj_forandagainst_small_simbol_clk", { input = false } );
  ObjSet( "obj_forandagainst_big_clk", { input = true } );
  ObjSet( "obj_forandagainst_small_big_clk", { input = true } );
  private.MakeInputCollumn();
  private.SaveSmallVar();

end;
--*********************************************************************************************************************
-- function *** MMG BIG *** () end;
--*********************************************************************************************************************
function private.EnterBigSimb ( id )

  common_impl.SetCursor( CURSOR_HAND );
  local name = "spr_forandagainst_big_"..id.."_marker";
  ObjAnimate( name, "alp", 0, 0, "", 
  { 
    0.00, 0, ObjGet( name ).alp,     
    0.05, 0, 1,
  } );

end;
--*********************************************************************************************************************
function private.LeaveBigSimb ( id )

  common_impl.SetCursor( CURSOR_DEFAULT );
  local name = "spr_forandagainst_big_"..id.."_marker";
  ObjAnimate( name, "alp", 0, 0, "", 
  { 
    0.00, 0, ObjGet( name ).alp,     
    0.05, 0, 0,
  } );

end;
--*********************************************************************************************************************
function private.SmallBigSimbolClk ( id ) 

  local scale = 0.1;
  local name = "spr_forandagainst_"..private.name_simb[ id ];

  local func_end = function()

    cmn.Lock( false );
    if ( private.small_choose == 0 or private.small_choose ~= id ) then  

      private.small_choose = id;

    elseif ( private.small_choose == id ) then

      private.small_choose = 0;      

    end;
  
    private.SaveBigVar();
    private.MakeInputCollumn();

  end;

  if ( private.small_choose == 0 ) then

    cmn.Lock( true );
    ObjSet( name, { pos_z = 10 } );
    ObjAnimate( name, "scale_xy", 0, 0, func_end, 
    { 
      0.0, 0, private.small_simb_data[ id ][ 4 ],        private.small_simb_data[ id ][ 4 ],     
      0.3, 0, private.small_simb_data[ id ][ 4 ] + scale, private.small_simb_data[ id ][ 4 ] +scale,
    } );
    

  elseif ( private.small_choose == id ) then

    cmn.Lock( true );
    ObjSet( name, { pos_z = 0 } );
    ObjAnimate( name, "scale_xy", 0, 0, func_end, 
    { 
      0.0, 0, ObjGet( name ).scale_x,             ObjGet( name ).scale_y,     
      0.3, 0, private.small_simb_data[ id ][ 4 ], private.small_simb_data[ id ][ 4 ],
    } );

  else 

    local name_other = "spr_forandagainst_"..private.name_simb[ private.small_choose ];
    cmn.Lock( true );
    ObjSet( name, { pos_z = 10 } );
    ObjSet( name_other, { pos_z = 0 } );
    ObjAnimate( name, "scale_xy", 0, 0, func_end, 
    { 
      0.0, 0, private.small_simb_data[ id ][ 4 ],        private.small_simb_data[ id ][ 4 ],     
      0.3, 0, private.small_simb_data[ id ][ 4 ] + scale, private.small_simb_data[ id ][ 4 ] + scale,
    } );
    ObjAnimate( name_other, "scale_xy", 0, 0, "", 
    { 
      0.0, 0,                         ObjGet( name_other ).scale_x,                         ObjGet( name_other ).scale_y,     
      0.3, 0, private.small_simb_data[ private.small_choose ][ 4 ], private.small_simb_data[ private.small_choose ][ 4 ],
    } );

  end;  

  common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );

end;
--*********************************************************************************************************************
function private.BigSimbolClk ( id )

  if ( private.small_choose ~= 0 ) then

    local func_end = function()

      local amount = 0;
      for i = 1, #private.big_state do

        if ( private.big_state[ i ] ~= 0 ) then
  
          amount = amount + 1;  

        end;
    
      end;

      cmn.Lock( false );
      private.big_state[ id ] = private.small_choose;
      private.small_choose = 0;

      if ( amount == 3 ) then

        if ( private.IsBigWin() ) then

          private.Win();          

        else

          private.LoseBigAnim();

        end;

      else

        private.SaveBigVar();

      end;
      private.MakeInputCollumn();

    end;

    local name = "spr_forandagainst_"..private.name_simb[ private.small_choose ];

    cmn.Lock( true );
    ObjAnimate( name, "pos_xy", 0, 0, "", 
    { 
      0.0, 0, ObjGet( name ).pos_x, ObjGet( name ).pos_y,     
      0.3, 0, private.big_simb_data[ id ][ 1 ], private.big_simb_data[ id ][ 2 ],
    } ); 
    ObjAnimate( name, "ang", 0, 0, "", 
    { 
      0.0, 0, ObjGet( name ).ang, 
      0.3, 0, 0, 
    } ); 
    ObjAnimate( name, "scale_xy", 0, 0, func_end, 
    { 
      0.0, 0, ObjGet( name ).scale_x, ObjGet( name ).scale_y,  
      0.3, 0, 1, 1, 
    } ); 

    common_impl.PlayAudio( "sfx", "aud_get_inv_in_hand_sfx", 0, "", 0 );

  end;

end;
--*********************************************************************************************************************
function private.LoseBigAnim ()

  local func_end = function()
  
    local func_end_1 = function()

      cmn.Lock( false )
      private.big_state = { 0, 0, 0, 0 };    
      private.small_choose = 0;
      private.SaveBigVar();
      private.MakeInputCollumn();
   
    end;

    for i = 1, #private.big_state do

      local name = "spr_forandagainst_"..private.name_simb[ private.big_state[ i ] ];
      ObjAnimate( name, "pos_xy", 0, 0, "", 
      { 
        0.0, 0, ObjGet( name ).pos_x, ObjGet( name ).pos_y,     
        0.3, 0, private.small_simb_data[ private.big_state[ i ] ][ 1 ], private.small_simb_data[ private.big_state[ i ] ][ 2 ],
      } ); 
      ObjAnimate( name, "ang", 0, 0, "", 
      { 
        0.0, 0, ObjGet( name ).ang, 
        0.3, 0, private.small_simb_data[ private.big_state[ i ] ][ 3 ], 
      } ); 
      ObjAnimate( name, "scale_xy", 0, 0, "", 
      { 
        0.0, 0, ObjGet( name ).scale_x, ObjGet( name ).scale_y,  
        0.3, 0, private.small_simb_data[ private.big_state[ i ] ][ 4 ], private.small_simb_data[ private.big_state[ i ] ][ 4 ], 
      } ); 

    end;

    cmn.Lock( true );
    ObjAnimate( "mg_forandagainst", "alp", 0, 0, func_end_1, 
    { 
      0.0, 0, ObjGet( "mg_forandagainst" ).alp,
      0.3, 0, ObjGet( "mg_forandagainst" ).alp,
    } );

  end;

  local win_comb = { 1, 2, 3, 4 };

  for i = 1, #private.big_state do

    local bool = false;
    for j = 1, #win_comb do

      if ( private.big_state[ i ] == win_comb[ j ] ) then

        bool = true;
        break;

      end;
      
    end; 

    if ( bool ) then

      ObjAnimate( "spr_forandagainst_green_marker"..i, "alp", 0, 0, "", 
      { 
        0.0, 0, 0,     
        0.2, 0, 1,
        1.2, 0, 1,
        1.4, 0, 0,
      } );

    else

      ObjAnimate( "spr_forandagainst_red_marker"..i, "alp", 0, 0, "", 
      { 
        0.0, 0, 0,     
        0.2, 0, 1,
        1.2, 0, 1,
        1.4, 0, 0,
      } );

    end;

  end;

  cmn.Lock( true );
  ObjAnimate( "mg_forandagainst", "alp", 0, 0, func_end, 
  { 
    0.0, 0, ObjGet( "mg_forandagainst" ).alp,
    1.8, 0, ObjGet( "mg_forandagainst" ).alp,
  } );

  common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

end;
--*********************************************************************************************************************
function private.IsBigWin ()


  local win_comb = { 1, 2, 3, 4 };
  local bool = { false, false, false, false };

  for i = 1, #private.big_state do

    for j = 1, #win_comb do

      if ( private.big_state[ i ] == win_comb[ j ] ) then

        bool[ i ] = true;
        break;

      end;
      
    end;   

  end;

  local win = true;
  for i = 1, #bool do

    if ( bool[ i ] == false ) then

      win = false;
      break;

    end;

  end;

  return win;

end;
--*********************************************************************************************************************
function private.SaveBigVar ()
  
  for i = 1, #private.big_state do

    ng_global.progress[ "ext" ][ "win_forandagainst" ].big_state[ i ] = private.big_state[ i ];

  end;
  
  ng_global.progress[ "ext" ][ "win_forandagainst" ].small_choose = private.small_choose;

end;
--*********************************************************************************************************************
function private.MakeInputCollumn () 

  for j = 1, private.count_small_simb do

    ObjSet( "obj_forandagainst_clk_small_big_"..j, { input = true } );

  end; 

  if ( private.small_choose ~= 0 ) then

    for i = 1, #private.big_state do

      if ( private.big_state[ i ] == 0 ) then

        ObjSet( "obj_forandagainst_clk_big_"..i, { input = true } );

      else

        ObjSet( "obj_forandagainst_clk_big_"..i, { input = false } );
        ObjSet( "obj_forandagainst_clk_small_big_"..private.big_state[ i ], { input = false } );

      end; 

    end; 

  else 

    for i = 1, #private.big_state do

      if ( private.big_state[ i ] ~= 0 ) then

        ObjSet( "obj_forandagainst_clk_small_big_"..private.big_state[ i ], { input = false } );

      end

      ObjSet( "obj_forandagainst_clk_big_"..i, { input = false } );

    end;

  end; 

end;
--*********************************************************************************************************************