-- name=mg_shelflock

--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_shelflock";
  private.lights_count = 8;

  local tb = {}
  table.insert( tb, { "spr_shelflock_labamulet", { event_mdown = private.get_labamulet } } );

  for i = 1, private.lights_count do

    table.insert( tb, { "obj_shelflock_clk_lights_"..i,    
      { 
        event_mdown  = function () private.ClkLights( i ); end,
        event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end,
        event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end    
      } } );

  end;

  ObjMultiSet( tb );

  private.state_win = { { true, false },  --1
                        { true, true },   --2
                        { false, true },  --3
                        { true, false },  --4
                        { true, false },  --5
                        { true, false } };--6

  private.state = { "blue","red","yellow", "white",
                    "blue", "red", "yellow", "white"}; 

  private.win_combination = { { "blue",   "yellow" }, --как элементы дложны бфть расположены при победе
                              { "yellow", "red"    }, 
                              { "red",    "white"  },
                              { "white",  "blue"   },
                              { "blue",   "red"    }, 
                              { "red",    "yellow" } };

  private.win_button_combination = { "blue", "yellow", "red", "white", 
                                     "white" ,"blue", "red", "yellow" };

  private.win_relation = { { 1, 2 }, { 2, 3 }, { 3, 4 }, --связи кругов с овалами
                           { 5, 6 }, { 6, 7 }, { 7, 8 } };
  --------------------------------------------------------------------------------------------
  -- function win_shelflock () end;
  --------------------------------------------------------------------------------------------
  local win_shelflock = function ()

    if ( cmn.IsEventDone( "win_shelflock" ) ) then  

      ObjSet( "obj_shelflock_mg", { input = false } );
      ObjMultiSet( {
        { "obj_shelflock_mg",         { input = false         } }, 
        { "spr_shelflock_labamulet",  { input = true, alp = 1 } }, 
        { "gfx_shelflock_labamulet",  { active = true         } }, 
      } );
      ObjDelete( "spr_shelflock_door_1" );
      ObjDelete( "spr_shelflock_door" );

    else

    end;

  end;

  local win_shelflock_loc = function ()

    if ( cmn.IsEventDone( "win_shelflock" ) ) then  

      --ObjDelete( "gmg_terenceroom_ext_shelflock" );

    end;

  end;

  cmn.AddSubscriber( "win_shelflock", win_shelflock, private.room_objname );
  cmn.AddSubscriber( "win_shelflock", win_shelflock_loc, "rm_terenceroom_ext" );
  --------------------------------------------------------------------------------------------
  -- function get_labamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_labamulet" ] = {
    type = "get",
    get_obj = "spr_shelflock_labamulet",
    room = private.room_objname,
  };
  
  local get_labamulet_inv = function ()
  
    interface.InventoryItemAdd( "inv_labamulet", "spr_shelflock_labamulet" );
    ObjDelete( "gmg_terenceroom_ext_shelflock" );
  
  end;
  
  local get_labamulet_closezz = function ()
  
    ObjDelete( "gfx_shelflock_labamulet" );
    ObjDelete( "spr_shelflock_labamulet_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_labamulet", get_labamulet_inv );
  cmn.AddSubscriber( "get_labamulet", get_labamulet_closezz, private.room_objname );
--*********************************************************************************************************************
end;
function public.Load ()

  if ( cmn.IsEventStart( "win_shelflock" ) ) then

    for i = 1, #ng_global.progress["ext"]["win_shelflock"].state_win do

      private.state_win[ i ][ 1 ] = ng_global.progress["ext"]["win_shelflock"].state_win[ i ][ 1 ];
      private.state_win[ i ][ 2 ] = ng_global.progress["ext"]["win_shelflock"].state_win[ i ][ 2 ];

    end;

    for i = 1, #ng_global.progress["ext"]["win_shelflock"].state do

      private.state[ i ] = ng_global.progress["ext"]["win_shelflock"].state[ i ];

    end;

    private.MakeRelation();
    private.MakeButton();

    local color = { "blue", "red", "white", "yellow" };

    for i = 1, #private.state do

      for j = 1, #color do
      
        ObjSet( "spr_shelflock_lights_"..i.."_"..color[ j ], { alp = 0 } );

      end;

      ObjSet( "spr_shelflock_lights_"..i.."_"..private.state[ i ], { alp = 1 } );
      
      if ( private.state[ i ] == private.win_button_combination [ i ] ) then
      end;

    end;

    if ( ng_global.progress["ext"]["win_shelflock"].chose ~= 0 ) then

      local chose = ng_global.progress[ "ext" ][ "win_shelflock" ].chose;
      ObjSet( "spr_shelflock_lights_"..chose.."_"..private.state[ chose ].."_light", { alp = 1 } );      

    end;

  end;

end;
--*********************************************************************************************************************
function public.Open () 

  if not cmn.IsEventDone( "win_shelflock" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();

  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  ObjSet("obj_int_button_info",{ pos_y = -405 });
  ObjSet("obj_int_button_reset",{ pos_y = -405 });
  
  --common_impl.PlayAudio( "env", "aud_shelflock_env", 1, "", 0.5 );

  if not cmn.IsEventStart( "win_shelflock" ) then

    ng_global.progress["ext"]["win_shelflock"].state_win = { { true, false },  --1
                                                         { true, true },  --2
                                                         { false, true },  --3
                                                         { true, false },  --4
                                                         { true, false },  --5
                                                         { true, false } };--6

    ng_global.progress["ext"]["win_shelflock"].state = { "blue","red","yellow", "white",
                                                     "blue", "red", "yellow", "white"}; 

    ng_global.progress["ext"]["win_shelflock"].chose = 0;
    private.MakeRelation();
    private.MakeButton();

  end;

end;
--*********************************************************************************************************************
function public.Close ()

  --

end;
--*********************************************************************************************************************
function public.PreClose ()

  if not cmn.IsEventDone( "win_shelflock" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  
  ObjSet("obj_int_button_info",{ pos_y = -105 });
  ObjSet("obj_int_button_reset",{ pos_y = -105 });
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
function private.GetDefaultState ()

  local state = { 0, 0, 0 };

  return state;

end;
--*********************************************************************************************************************
function private.WinAnim()

  cmn.Lock( true );
  ObjAnimate( "spr_shelflock_door", "pos_xy", 0, 0, "",
  { 
    0.0, 1, ObjGet( "spr_shelflock_door" ).pos_x, ObjGet( "spr_shelflock_door" ).pos_y,
    0.5, 1, 517, 128,
  } ); 
  ObjAnimate( "spr_shelflock_door_1", "pos_xy", 0, 0, function() private.Win (); end,
  { 
    0.0, 1, ObjGet( "spr_shelflock_door_1" ).pos_x, ObjGet( "spr_shelflock_door_1" ).pos_y,
    0.5, 1, 515, 575,
  } ); 

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide_4", 0, "", 0 );

end;
--*********************************************************************************************************************
function private.Win ()
  

  
  cmn.Lock( false )

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_shelflock" );
  cmn.CallEventHandler( "win_shelflock" );

  private.ShelflockSaveVar();

  --раскоментировать как будут готовы ачивки
  common_impl.PassingMgWin();

  ObjSet("obj_int_button_info",{ pos_y = -105 });
  ObjSet("obj_int_button_reset",{ pos_y = -105 });
  
end;
--*********************************************************************************************************************
function public.Skip ()

port.skip_mg = true;
  private.state_win = { { true, true },  --1
                        { true, true },  --2
                        { true, true },  --3
                        { true, true },  --4
                        { true, true },  --5
                        { true, true } };--6
  private.state = { "blue","yellow","red", "white",
                    "white", "blue", "red", "yellow"}; 

  cmn.Lock( true );

  for i = 1, #private.state_win do
    if ( private.state_win[ i ][ 1 ] == true ) then

      ObjAnimate( "spr_shelflock_relation_"..i.."_1", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_"..i.."_light" ).alp,
        0.3, 0, 1
      } ); 

    else

      ObjAnimate( "spr_shelflock_relation_"..i.."_1", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_"..i.."_light" ).alp,
        0.3, 0, 0
      } ); 

    end;

    if ( private.state_win[ i ][ 2 ] == true ) then

      ObjAnimate( "spr_shelflock_relation_"..i.."_2", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_relation_"..i.."_2" ).alp,
        0.3, 0, 1
      } ); 

    else

      ObjAnimate( "spr_shelflock_relation_"..i.."_2", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_relation_"..i.."_2" ).alp,
        0.3, 0, 0
      } ); 

    end;

    if ( private.state_win[ i ][ 1 ] == true and private.state_win[ i ][ 2 ] == true ) then

      ObjAnimate( "spr_shelflock_"..i.."_light", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_"..i.."_light" ).alp,
        0.3, 0, 1
      } ); 

    else

      ObjAnimate( "spr_shelflock_"..i.."_light", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_"..i.."_light" ).alp,
        0.3, 0, 0
      } ); 

    end;

  end;

  for i = 1, #private.state do

    if ( private.state[ i ] == private.win_button_combination[ i ]) then

      ObjAnimate( "spr_shelflock_button_"..i.."_green", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_button_"..i.."_green" ).alp,
        0.3, 0, 1
      } ); 
      ObjAnimate( "spr_shelflock_button_"..i.."_red", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_button_"..i.."_red" ).alp,
        0.3, 0, 0
      } ); 

    else

      ObjAnimate( "spr_shelflock_button_"..i.."_green", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_button_"..i.."_green" ).alp,
        0.3, 0, 0
      } ); 
      ObjAnimate( "spr_shelflock_button_"..i.."_red", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_button_"..i.."_red" ).alp,
        0.3, 0, 1
      } ); 

    end;

  end;

  local color = { "blue", "red", "white", "yellow" };

  for i = 1, #private.state do

    for j = 1, #color do

      ObjAnimate( "spr_shelflock_lights_"..i.."_"..color[ j ].."_light", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_lights_"..i.."_"..color[ j ].."_light" ).alp,
        0.3, 0, 0
      } ); 
      ObjAnimate( "spr_shelflock_lights_"..i.."_"..color[ j ], "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_lights_"..i.."_"..color[ j ] ).alp,
        0.3, 0, 0
      } ); 

    end;

    ObjAnimate( "spr_shelflock_lights_"..i.."_"..private.state[ i ], "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_shelflock_lights_"..i.."_"..private.state[ i ] ).alp,
      0.3, 0, 1
    } ); 

  end;


  local func_end = function ()

    cmn.Lock( true );

    private.WinAnim();

  end;

  ObjAnimate( "obj_shelflock_mg", "alp", 0, 0, func_end,
  { 
    0.0, 0, ObjGet( "obj_shelflock_mg" ).alp,
    0.3, 0, ObjGet( "obj_shelflock_mg" ).alp
  } ); 

end;
--*********************************************************************************************************************
function public.Reset ()

  private.state_win = { { true, false },  --1
                        { true, true },  --2
                        { false, true },  --3
                        { true, false },  --4
                        { true, false },  --5
                        { true, false } };--6
  private.state = { "blue","red","yellow", "white",
                    "blue", "red", "yellow", "white"}; 
 
  cmn.Lock( true );

  for i = 1, #private.state_win do

    if ( private.state_win[ i ][ 1 ] == true ) then

      ObjAnimate( "spr_shelflock_relation_"..i.."_1", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_relation_"..i.."_1" ).alp,
        0.3, 0, 1
      } ); 

    else

      ObjAnimate( "spr_shelflock_relation_"..i.."_1", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_relation_"..i.."_1" ).alp,
        0.3, 0, 0
      } ); 

    end;

    if ( private.state_win[ i ][ 2 ] == true ) then

      ObjAnimate( "spr_shelflock_relation_"..i.."_2", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_relation_"..i.."_2" ).alp,
        0.3, 0, 1
      } ); 

    else

      ObjAnimate( "spr_shelflock_relation_"..i.."_2", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_relation_"..i.."_2" ).alp,
        0.3, 0, 0
      } ); 

    end;

    if ( private.state_win[ i ][ 1 ] == true and private.state_win[ i ][ 2 ] == true ) then

      ObjAnimate( "spr_shelflock_"..i.."_light", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_"..i.."_light" ).alp,
        0.3, 0, 1
      } ); 

    else

      ObjAnimate( "spr_shelflock_"..i.."_light", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_"..i.."_light" ).alp,
        0.3, 0, 0
      } ); 

    end;

  end;

  for i = 1, #private.state do

    if ( private.state[ i ] == private.win_button_combination[ i ]) then

      ObjAnimate( "spr_shelflock_button_"..i.."_green", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_button_"..i.."_green" ).alp,
        0.3, 0, 1
      } ); 
      ObjAnimate( "spr_shelflock_button_"..i.."_red", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_button_"..i.."_red" ).alp,
        0.3, 0, 0
      } ); 

    else

      ObjAnimate( "spr_shelflock_button_"..i.."_green", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_button_"..i.."_green" ).alp,
        0.3, 0, 0
      } ); 
      ObjAnimate( "spr_shelflock_button_"..i.."_red", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_button_"..i.."_red" ).alp,
        0.3, 0, 1
      } ); 

    end;

  end;

  local color = { "blue", "red", "white", "yellow" };

  for i = 1, #private.state do

    for j = 1, #color do

      ObjAnimate( "spr_shelflock_lights_"..i.."_"..color[ j ].."_light", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_lights_"..i.."_"..color[ j ].."_light" ).alp,
        0.3, 0, 0
      } ); 
      ObjAnimate( "spr_shelflock_lights_"..i.."_"..color[ j ], "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_lights_"..i.."_"..color[ j ] ).alp,
        0.3, 0, 0
      } ); 

    end;

    ObjAnimate( "spr_shelflock_lights_"..i.."_"..private.state[ i ], "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_shelflock_lights_"..i.."_"..private.state[ i ] ).alp,
      0.3, 0, 1
    } ); 

  end;


  local func_end = function ()

    private.ResetEnd();

  end;

  ObjAnimate( "obj_shelflock_mg", "alp", 0, 0, func_end,
  { 
    0.0, 0, ObjGet( "obj_shelflock_mg" ).alp,
    0.3, 0, ObjGet( "obj_shelflock_mg" ).alp
  } ); 

end;
--*********************************************************************************************************************
function private.ResetEnd ()

  cmn.Lock( false );
  private.ShelflockSaveVar();
  private.MakeButton();
  private.MakeRelation();
  ng_global.progress["ext"]["win_shelflock"].chose = 0;

end;
--*********************************************************************************************************************
function private.ClkLights ( id )

  local chose = ng_global.progress["ext"]["win_shelflock"].chose;
  local state = private.state[ id ];

  local func_end = function ()

    if ( chose == 0 or chose == id ) then

      private.ClkLightsEnd( id );

    else 

      private.ClkLightsCheckWin( id );  
      
    end;

  end; 

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_menter1", 0, "", 0 );

  if ( chose == 0 ) then
    
    cmn.Lock( true );
    ObjAnimate( "spr_shelflock_lights_"..id.."_"..state.."_light", "alp", 0, 0, func_end,
    { 
      0.0, 0, ObjGet( "spr_shelflock_lights_"..id.."_"..state.."_light" ).alp,
      0.3, 0, 1
    } );        

  elseif ( ng_global.progress["ext"]["win_shelflock"].chose == id ) then

    cmn.Lock( true );
    ObjAnimate( "spr_shelflock_lights_"..id.."_"..state.."_light", "alp", 0, 0, func_end,
    { 
      0.0, 0, ObjGet( "spr_shelflock_lights_"..id.."_"..state.."_light" ).alp,
      0.3, 0, 0
    } );        

  else

    cmn.Lock( true );    
    ObjAnimate( "spr_shelflock_lights_"..id.."_"..state.."_light", "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_shelflock_lights_"..id.."_"..state.."_light" ).alp,
      0.3, 0, 1,
      0.3, 0, 1,
      0.5, 0, 0
    } );  

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_button4", 0, "", 0 );

    local chose_state = ng_global.progress["ext"]["win_shelflock"].state[ chose ];
    ObjAnimate( "spr_shelflock_lights_"..chose.."_"..chose_state.."_light", "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_shelflock_lights_"..chose.."_"..chose_state.."_light" ).alp,
      0.5, 0, 1,
      0.8, 0, 0
    } );
    ObjAnimate( "spr_shelflock_lights_"..id.."_"..state, "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_shelflock_lights_"..id.."_"..state ).alp,
      0.5, 0, ObjGet( "spr_shelflock_lights_"..id.."_"..state ).alp,
      0.8, 0, 0
    } ); 
    ObjAnimate( "spr_shelflock_lights_"..id.."_"..chose_state, "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_shelflock_lights_"..id.."_"..chose_state ).alp,
      0.5, 0, ObjGet( "spr_shelflock_lights_"..id.."_"..chose_state ).alp,
      0.8, 0, 1
    } );  

    ObjAnimate( "spr_shelflock_lights_"..chose.."_"..chose_state, "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_shelflock_lights_"..chose.."_"..chose_state ).alp,
      0.5, 0, ObjGet( "spr_shelflock_lights_"..chose.."_"..chose_state ).alp,
      0.8, 0, 0
    } ); 
    ObjAnimate( "spr_shelflock_lights_"..chose.."_"..state, "alp", 0, 0, func_end,
    { 
      0.0, 0, ObjGet( "spr_shelflock_lights_"..chose.."_"..state ).alp,
      0.5, 0, ObjGet( "spr_shelflock_lights_"..chose.."_"..state ).alp,
      0.8, 0, 1
    } );  

  end;   

end;
--*********************************************************************************************************************
function private.ClkLightsEnd ( id ) 

  local chose = ng_global.progress["ext"]["win_shelflock"].chose;
  local state = private.state[ id ];
  cmn.Lock( false );

  if ( chose == 0 ) then

    ng_global.progress["ext"]["win_shelflock"].chose = id;      

  elseif ( chose == id ) then  

    ng_global.progress["ext"]["win_shelflock"].chose = 0;

  end;

end;
--*********************************************************************************************************************
function private.ClkLightsCheckWin ( id )

  local chose = ng_global.progress["ext"]["win_shelflock"].chose;
  local chose_state = private.state[ chose ];

  local id_state = private.state[ id ];

  local cup = private.state[ id ];
  private.state[ id ] = private.state[ chose ];
  private.state[ chose ] = cup;

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_lamp", 0, "", 0 );
  
  cmn.Lock( true );    
  for i = 1, #private.win_relation do

    if ( private.state[ private.win_relation[ i ][ 1 ] ] == private.win_combination[ i ][ 1 ] or 
         private.state[ private.win_relation[ i ][ 1 ] ] == private.win_combination[ i ][ 2 ] ) then

      ObjAnimate( "spr_shelflock_relation_"..i.."_1", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_relation_"..i.."_1" ).alp,
        0.3, 0, 1
      } ); 
      private.state_win[ i ][ 1 ] = true;

      local number = private.win_relation[ i ][ 1 ];
      local color_element = private.state[ private.win_relation[ i ][ 1 ] ];
      
      if ( color_element == private.win_button_combination[ number ] ) then

        ObjAnimate( "spr_shelflock_button_"..number.."_green", "alp", 0, 0, "",
        { 
          0.0, 0, ObjGet( "spr_shelflock_button_"..number.."_green" ).alp,
          0.3, 0, 1
        } ); 
        ObjAnimate( "spr_shelflock_button_"..number.."_red", "alp", 0, 0, "",
        { 
          0.0, 0, ObjGet( "spr_shelflock_button_"..number.."_red" ).alp,
          0.3, 0, 0
        } ); 
      else 

        ObjAnimate( "spr_shelflock_button_"..number.."_green", "alp", 0, 0, "",
        { 
          0.0, 0, ObjGet( "spr_shelflock_button_"..number.."_green" ).alp,
          0.3, 0, 0
        } ); 
        ObjAnimate( "spr_shelflock_button_"..number.."_red", "alp", 0, 0, "",
        { 
          0.0, 0, ObjGet( "spr_shelflock_button_"..number.."_red" ).alp,
          0.3, 0, 1
        } );
 
      end;

    else 

      ObjAnimate( "spr_shelflock_relation_"..i.."_1", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_relation_"..i.."_1" ).alp,
        0.3, 0, 0
      } ); 
      private.state_win[ i ][ 1 ] = false;

      local number = private.win_relation[ i ][ 1 ];
      local color_element = private.state[ private.win_relation[ i ][ 1 ] ];
      
      ObjAnimate( "spr_shelflock_button_"..number.."_green", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_button_"..number.."_green" ).alp,
        0.3, 0, 0
      } ); 
      ObjAnimate( "spr_shelflock_button_"..number.."_red", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_button_"..number.."_red" ).alp,
        0.3, 0, 1,
      } ); 

    end;

    if ( ( private.state[ private.win_relation[ i ][ 2 ] ] == private.win_combination[ i ][ 2 ] or 
           private.state[ private.win_relation[ i ][ 2 ] ] == private.win_combination[ i ][ 1 ] ) and   
           private.state[ private.win_relation[ i ][ 2 ] ] ~= private.state[ private.win_relation[ i ][ 1 ] ] ) then  

      ObjAnimate( "spr_shelflock_relation_"..i.."_2", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_relation_"..i.."_2" ).alp,
        0.3, 0, 1
      } ); 
      private.state_win[ i ][ 2 ] = true;

      local number = private.win_relation[ i ][ 2 ];
      local color_element = private.state[ private.win_relation[ i ][ 2 ] ];

      if ( color_element == private.win_button_combination[ number ] ) then

        ObjAnimate( "spr_shelflock_button_"..number.."_green", "alp", 0, 0, "",
        { 
          0.0, 0, ObjGet( "spr_shelflock_button_"..number.."_green" ).alp,
          0.3, 0, 1
        } ); 
        ObjAnimate( "spr_shelflock_button_"..number.."_red", "alp", 0, 0, "",
        { 
          0.0, 0, ObjGet( "spr_shelflock_button_"..number.."_red" ).alp,
          0.3, 0, 0
        } ); 
      else 

        ObjAnimate( "spr_shelflock_button_"..number.."_green", "alp", 0, 0, "",
        { 
          0.0, 0, ObjGet( "spr_shelflock_button_"..number.."_green" ).alp,
          0.3, 0, 0
        } ); 
        ObjAnimate( "spr_shelflock_button_"..number.."_red", "alp", 0, 0, "",
        { 
          0.0, 0, ObjGet( "spr_shelflock_button_"..number.."_red" ).alp,
          0.3, 0, 1
        } );
 
      end; 

    else 

      ObjAnimate( "spr_shelflock_relation_"..i.."_2", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_relation_"..i.."_2" ).alp,
        0.3, 0, 0
      } ); 
      private.state_win[ i ][ 2 ] = false;

      local number = private.win_relation[ i ][ 2 ];
      local color_element = private.state[ private.win_relation[ i ][ 2 ] ];
      ObjAnimate( "spr_shelflock_button_"..number.."_green", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_button_"..number.."_green" ).alp,
        0.3, 0, 0
      } ); 
      ObjAnimate( "spr_shelflock_button_"..number.."_red", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_button_"..number.."_red" ).alp,
        0.3, 0, 1
      } ); 

    end;

  end;

  for i = 1, #private.state_win do

    if ( private.state_win[ i ][ 1 ] == true and private.state_win[ i ][ 2 ] == true ) then

      ObjAnimate( "spr_shelflock_"..i.."_light", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_"..i.."_light" ).alp,
        0.3, 0, 1
      } ); 

    else

      ObjAnimate( "spr_shelflock_"..i.."_light", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_"..i.."_light" ).alp,
        0.3, 0, 0
      } ); 

    end;

  end;

  local func_end = function ()

    cmn.Lock( false );

 
    if ( private.ShelflockIsWin() ) then 

      private.WinAnim();

    else

      private.ShelflockSaveVar();
      ng_global.progress["ext"]["win_shelflock"].chose = 0;

    end;

  end;

  ObjAnimate( "obj_shelflock_mg", "alp", 0, 0, func_end,
  { 
    0.0, 0, ObjGet( "obj_shelflock_mg" ).alp,
    0.3, 0, ObjGet( "obj_shelflock_mg" ).alp
  } ); 

end;
--*********************************************************************************************************************
function private.ShelflockIsWin ()

  local bool = true;
  for i = 1, #private.state_win do

    if ( private.state_win[ i ][ 1 ] == false or private.state_win[ i ][ 2 ] == false ) then

      bool = false;
      break;

    end;

  end;

  return bool;  

end;
--*********************************************************************************************************************
function private.ShelflockSaveVar ()

  for i = 1, #private.state_win  do

    ng_global.progress["ext"]["win_shelflock"].state_win[ i ][ 1 ] = private.state_win[ i ][ 1 ];  
    ng_global.progress["ext"]["win_shelflock"].state_win[ i ][ 2 ] = private.state_win[ i ][ 2 ];    

  end;
  
  for i = 1, #private.state do

    ng_global.progress["ext"]["win_shelflock"].state[ i ] = private.state[ i ]; 

  end;

end;
--*********************************************************************************************************************
function private.MakeRelation ()

  for i = 1, #private.state_win do


    if ( private.state_win[ i ][ 1 ] == true ) then

      ObjSet( "spr_shelflock_relation_"..i.."_1", { alp = 1 } );

    else

      ObjSet( "spr_shelflock_relation_"..i.."_1", { alp = 0 } );

    end;

    if ( private.state_win[ i ][ 2 ] == true ) then

      ObjSet( "spr_shelflock_relation_"..i.."_2", { alp = 1 } );

    else

      ObjSet( "spr_shelflock_relation_"..i.."_2", { alp = 0 } );

    end;

    if ( private.state_win[ i ][ 1 ] == true and private.state_win[ i ][ 2 ] == true ) then

      ObjSet( "spr_shelflock_"..i.."_light", { alp = 1 } );

    else

      ObjSet( "spr_shelflock_"..i.."_light", { alp = 0 } );

    end;

  end;

end;
--*********************************************************************************************************************
function private.MakeButton ()
  
  for i = 1, #private.state do

    if ( private.state[ i ] == private.win_button_combination[ i ]) then

      ObjSet( "spr_shelflock_button_"..i.."_green", { alp = 1 } );
      ObjSet( "spr_shelflock_button_"..i.."_red",   { alp = 0 } );

    else

      ObjSet( "spr_shelflock_button_"..i.."_green", { alp = 0 } );
      ObjSet( "spr_shelflock_button_"..i.."_red",   { alp = 1 } );

    end;

  end;

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_labamulet ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_labamulet" );
  cmn.CallEventHandler( "get_labamulet" );
  cmn.GotoRoom( "rm_terenceroom_ext" );   

end;










