-- name=mg_superpuzzle4
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_superpuzzle4";

  ObjSet( "obj_superpuzzle4_hint", { 
    event_mdown  = private.PuszzleHintClk, 
    event_menter = private.PuszzleHintEnter, 
    event_mleave = private.PuszzleHintLeave
  } );

  --------------------------------------------------------------------------------------------
  -- function win_superpuzzle4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_superpuzzle4" ] = {
    type = "win",
    room = "rm_hall_ext",
    zz = "mg_superpuzzle4",
    zz_gate = "gmg_hall_ext_superpuzzle4"
  };

  local win_superpuzzle4 = function ()

    if ( cmn.IsEventDone( "win_superpuzzle4" ) ) then  

      ObjDelete( "gmg_hall_ext_superpuzzle4" );
      ObjSet( "grm_hall_ext_secondfloor_ext", { input = true, visible = true, active = true, alp = 1 } );
      if port.isPortable() == 1 then
          port.GrmEventLightOn("grm_hall_ext_secondfloor_ext_focus");
      end;
    else

      -----------------------------------------    

      local table_multiset = {};

      -----------------------------------------    

      private.items_done = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].items_done;
      private.clk_done   = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].clk_done;

      --- Mini Progress Begin--------------------------

      private.arrowswrong_win = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].arrowswrong_win;

      if ( private.arrowswrong_win ) then

        private.ArrowswrongWinSet();
        
      else

        for i = 1, #private.arrowswrong_current_list do

          private.arrowswrong_current_list[ i ] = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].arrowswrong_current_list[ i ];

          if ( private.arrowswrong_current_list[ i ] ) then

            table.insert( table_multiset, { "spr_superpuzzle4_mg_1_on_"..i, { alp = 0, input = false } } );
        
          end;

        end;

      end;

      -----------------------------------------    

      private.arrowsright_index = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].arrowsright_index;
      private.arrowsright_win   = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].arrowsright_win;

      if ( private.arrowsright_win ) then

        private.ArrowsrightWinSet();
        
      else

        for i = 1, #private.arrowsright_current_list do

          private.arrowsright_current_list[ i ] = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].arrowsright_current_list[ i ];

          if ( private.arrowsright_current_list[ i ] ~= 0 ) then

            table.insert( table_multiset, { "spr_superpuzzle4_mg_1_on_"..private.arrowsright_current_list[ i ], { alp = 0, input = false } } );
        
          end;

        end;

      end;

      ----------------------------------------- 

      private.LoadItemsDone( "mg_1_on_3" );

      -----------------------------------------    

      private.gears_win = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].gears_win;

      if ( private.gears_win ) then

        private.GearsWinSet();
        
      else

        for i = 1, #private.gears_current_list do
        
          for j = 1, #private.gears_current_list[ i ] do
              
            private.gears_current_list[ i ][ j ] = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].gears_current_list[ i ][ j ];

            local pos = private.gears_pos[ i ][ j ];
            local number = private.gears_current_list[ i ][ j ];
                      
            table.insert( table_multiset, { "spr_superpuzzle4_mg_2_square_"..number, { pos_x = pos[ 1 ], pos_y = pos[ 2 ] } } );

            local name_gear = "spr_superpuzzle4_mg_2_gears_"..number;

            if ( ObjGet( name_gear ) ) then

              table.insert( table_multiset, { name_gear, { pos_x = pos[ 1 ], pos_y = pos[ 2 ] } } );

            end;

          end;
        
        end;

      end;

      ----------------------------------------- 

      private.LoadItemsDone( "mg_5_bone_get_1" );
      private.LoadItemsDone( "mg_5_bone_get_2" );
      private.LoadItemsDone( "mg_5_bone_get_3" );
      private.LoadItemsDone( "mg_5_bone_get_4" );

      -----------------------------------------    

      private.numbers_win = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].numbers_win;

      for i = 1, #private.numbers_current_list do
      
        private.numbers_current_list[ i ] = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].numbers_current_list[ i ];
      
      end;

      if ( private.numbers_win ) then

        private.NumbersWinSet();
        
      else

        for i = 1, #private.numbers_current_list do
              
          local number = private.numbers_current_list[ i ];
          local pos    = private.numbers_pos[ i ];

          table.insert( table_multiset, { "spr_superpuzzle4_mg_3_bone_"..number, { pos_x = pos[ 1 ], pos_y = pos[ 2 ] } } );

        end;

      end;

      -----------------------------------------    

      private.tubes_win = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].tubes_win;

      if ( private.tubes_win ) then

        private.TubesWinSet();
        
      else

        for i = 1, #private.tubes_current_list do
        
          for j = 1, #private.tubes_current_list[ i ] do
              
            private.tubes_current_list[ i ][ j ] = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].tubes_current_list[ i ][ j ];

            local ang = ( private.tubes_current_list[ i ][ j ] - 1 ) * math.pi / 2;
          
            ObjSet( "spr_superpuzzle4_mg_4_piece_"..i.."_"..j, { ang = ang } );

          end;
        
        end;

      end;

      --------------------------------------

      private.LoadClkDone( "mg_4_clk_lever" );
      private.LoadItemsDone( "mg_4_lamp_get" );

      -----------------------------------------    

      private.lamps_win = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].lamps_win;

      for i = 1, #private.lamps_current_list do
      
        private.lamps_current_list[ i ] = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].lamps_current_list[ i ];
      
      end;

      if ( private.lamps_win ) then

        private.LampsWinSet();
        
      else

        for i = 1, #private.lamps_current_list do
              
          local number = private.lamps_current_list[ i ];
          local pos    = private.lamps_pos[ i ];

          table.insert( table_multiset, { "spr_superpuzzle4_mg_6_lamp_"..number, { pos_x = pos[ 1 ], pos_y = pos[ 2 ] } } );

        end;

      end;

      ----------------------------------------- 

      private.LoadItemsDone( "mg_4_key_get_1" );
      private.LoadItemsDone( "mg_4_key_get_2" );
      private.LoadItemsDone( "mg_4_key_get_3" );
      private.LoadItemsDone( "mg_4_key_get_4" );      
      private.LoadItemsDone( "mg_4_key_get_5" );
      private.LoadItemsDone( "mg_4_key_get_6" );

      -----------------------------------------    

      private.brick_win = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].brick_win;

      for i = 1, #private.brick_current_list do
      
        for j = 1, #private.brick_current_list[ i ] do
        
          private.brick_current_list[ i ][ j ] = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].brick_current_list[ i ][ j ];
        
        end;

      end;

      if ( private.brick_win ) then

        private.BrickWinSet();
        
      else

        for i = 1, #private.brick_horizon do
              
          local index = private.BrickGetPosToArray( i );

          local pos_x  = private.brick_pos_begin[ 1 ] + ( index[ 1 ] * private.brick_pos_step );
          local pos_y  = private.brick_pos_begin[ 2 ] + ( index[ 2 ] * private.brick_pos_step );

          table.insert( table_multiset, { "spr_superpuzzle4_mg_8_brick_"..i, { 
            pos_x = pos_x, 
            pos_y = pos_y
          } } );

        end;

      end;

      -----------------------------------------    

      private.LoadItemsDone( "mg_8_circle_get" );

      -----------------------------------------    

      private.circles_win = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].circles_win;

      for i = 1, #private.circles_current_list do
      
        private.circles_current_list[ i ] = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].circles_current_list[ i ];
      
      end;

      if ( private.circles_win ) then

        private.CirclesWinSet();
        
      else

        for i = 1, #private.circles_current_list do
              
          local number = private.circles_current_list[ i ];
          local pos    = private.circles_pos[ i ];

          table.insert( table_multiset, { "spr_superpuzzle4_mg_5_circle_"..number, { pos_x = pos[ 1 ], pos_y = pos[ 2 ] } } );

        end;

      end;

      -----------------------------------------    

      private.LoadItemsDone( "mg_5_switch_get" );

      -----------------------------------------    

      private.switches_index = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].switches_index;
      private.switches_win   = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].switches_win;

      if ( private.switches_win ) then

        private.SwitchesWinSet();
        
      else

        if ( private.items_done[ "mg_5_switch_get" ] ) then

          for i = 1, #private.switches_current_list do
              
            local ang = 0.8 * ( private.switches_current_list[ i ] - 2 );
            local alp = private.switches_alp[ i ][ private.switches_current_list[ i ] ];

            table.insert( table_multiset, { "spr_superpuzzle4_mg_9_switch_"..i, { ang = ang } } );
            table.insert( table_multiset, { "spr_superpuzzle4_mg_9_tv_"..i, { alp = alp } } );

          end;

        end;

      end;

      -----------------------------------------    

      private.squares_win = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].squares_win;

      if ( private.squares_win ) then

        private.SquaresWinSet();
        
      end;

      for i = 1, #private.squares_current_list do
          
        private.squares_current_list[ i ] = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].squares_current_list[ i ];

        if ( private.squares_current_list[ i ] ) then

          table.insert( table_multiset, { "spr_superpuzzle4_mg_9_couple_"..i, { input = false, alp = 1 } } );

        end;

      end;

      -----------------------------------------    

      private.pictures_win = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].pictures_win;

      for i = 1, #private.pictures_current_list do
      
        private.pictures_current_list[ i ] = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].pictures_current_list[ i ];
      
      end;

      if ( private.pictures_win ) then

        private.PicturesWinSet();
        
      else

        for i = 1, #private.pictures_current_list do
              
          local number = private.pictures_current_list[ i ];
          local pos    = private.pictures_pos[ i ];

          table.insert( table_multiset, { "spr_superpuzzle4_mg_9_picture_"..number, { pos_x = pos[ 1 ], pos_y = pos[ 2 ] } } );

        end;

      end;

      -----------------------------------------    

      private.triangles_win = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].triangles_win;
      private.triangles_current_state = ng_global.progress[ "ext" ][ "win_superpuzzle4" ].triangles_current_state;

      if ( private.triangles_win ) then

        private.TrianglesWinSet();
        
      else

        for i = 1, ( private.triangles_current_state - 1 ) do
            
          table.insert( table_multiset, { "spr_superpuzzle4_mg_10_button_green_"..i, { alp = 1 } } );

        end;  

      end;

      --- Mini Progress End --------------------------

      if ( #table_multiset > 0 ) then

        ObjMultiSet( table_multiset );

      end;

    end;

  end;

  cmn.AddSubscriber( "win_superpuzzle4", win_superpuzzle4, private.room_objname );
  
  --------------------------------------------------------------------------------------------

  local table_multiset = {};
  --------------------------------------

  private.items_done = {};
  private.items_list = { 
    "mg_1_on_3", 
    "mg_5_bone_get_1", 
    "mg_5_bone_get_2", 
    "mg_5_bone_get_3", 
    "mg_5_bone_get_4", 
    "mg_4_lamp_get",
    "mg_4_key_get_1", 
    "mg_4_key_get_2", 
    "mg_4_key_get_3", 
    "mg_4_key_get_4", 
    "mg_4_key_get_5", 
    "mg_4_key_get_6", 
    "mg_8_circle_get",
    "mg_5_switch_get",
  };

  private.items_func_done = {};
  private.items_func_done[ "mg_1_on_3" ]       = private.ItemDoneOn3;
  private.items_func_done[ "mg_5_bone_get_1" ] = function () private.ItemDoneBone( 1 ); end;
  private.items_func_done[ "mg_5_bone_get_2" ] = function () private.ItemDoneBone( 2 ); end;
  private.items_func_done[ "mg_5_bone_get_3" ] = function () private.ItemDoneBone( 3 ); end;
  private.items_func_done[ "mg_5_bone_get_4" ] = function () private.ItemDoneBone( 4 ); end;
  private.items_func_done[ "mg_4_lamp_get" ] = private.ItemDoneLamp;
  private.items_func_done[ "mg_4_key_get_1" ] = function () private.ItemDoneKey( 1 ); end;
  private.items_func_done[ "mg_4_key_get_2" ] = function () private.ItemDoneKey( 2 ); end;
  private.items_func_done[ "mg_4_key_get_3" ] = function () private.ItemDoneKey( 3 ); end;
  private.items_func_done[ "mg_4_key_get_4" ] = function () private.ItemDoneKey( 4 ); end;
  private.items_func_done[ "mg_4_key_get_5" ] = function () private.ItemDoneKey( 5 ); end;
  private.items_func_done[ "mg_4_key_get_6" ] = function () private.ItemDoneKey( 6 ); end;
  private.items_func_done[ "mg_8_circle_get" ] = private.ItemDoneCircle;
  private.items_func_done[ "mg_5_switch_get" ] = private.ItemDoneSwitch;

  local item_names = { 
    "mg_5_bone_get_1", 
    "mg_5_bone_get_2", 
    "mg_5_bone_get_3", 
    "mg_5_bone_get_4", 
    "mg_4_lamp_get",
    "mg_4_key_get_1", 
    "mg_4_key_get_2", 
    "mg_4_key_get_3", 
    "mg_4_key_get_4", 
    "mg_4_key_get_5", 
    "mg_4_key_get_6",
    "mg_8_circle_get",
    "mg_5_switch_get",
  };

  for i = 1, #item_names do

    table.insert( table_multiset, { "spr_superpuzzle4_"..item_names[ i ], { 
      event_mdown    = function () private.ItemMDown( item_names[ i ] ); end, 
      event_dragdrop = function () private.ItemDragDrop( item_names[ i ] ); end,
      event_menter   = function () common_impl.SetCursor( CURSOR_GET ); end, 
      event_mleave   = function () common_impl.SetCursor( CURSOR_DEFAULT ); end
    } } );

  end;

  --------------------------------------

  private.clk_done = {};
  private.clk_list = { "mg_4_clk_lever" };

  private.clk_func_done = {};
  private.clk_func_done[ "mg_4_clk_lever" ] = private.ClkDoneLever;

  table.insert( table_multiset, { "obj_superpuzzle4_mg_4_clk_lever", { 
    event_mdown  = function () private.PlaceClk( "mg_4_clk_lever" ); end,
    event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end, 
    event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end
  } } );

  --------------------------------------

  private.arrowswrong_current_list = { false, false, false };
  private.arrowswrong_index = 1;

  for i = 1, #private.arrowswrong_current_list do
        
    table.insert( table_multiset, { "spr_superpuzzle4_mg_1_on_"..i, { 
      event_mdown = function () private.ArrowswrongClk( i ); end,
      event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end, 
      event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end
    } } );

  end;

  --------------------------------------

  private.arrowsright_current_list = { 0, 0, 0 };
  private.arrowsright_index = 1;

  private.arrowsright_win_list = { 1, 3, 2 };
  
  --------------------------------------

  private.gears_current_list = { 
    { 1,   2,  3,  4 }, 
    { 5,   6,  7,  8 }, 
    { 9,   10, 11, 12 },
    { 13,  14, 15, 0 },
  };
  
  private.gears_pos = { 
    { { -104, -100 }, { -54, -100 }, { -4, -100 }, { 46, -100 } }, 
    { { -104,  -50 }, { -54,  -50 }, { -4,  -50 }, { 46,  -50 } },  
    { { -104,    0 }, { -54,    0 }, { -4,    0 }, { 46,    0 } },
    { { -104,   50 }, { -54,   50 }, { -4,   50 }, { 46,   50 } }
  };

  private.gears_geared = { 3, 5, 6, 7, 8, 11, 15 };

  private.gears_start_pos = { 4, 1, -1 };
  private.gears_win_pos   = { 1, 4 };

  for i = 1, #private.gears_current_list do
  
    for j = 1, #private.gears_current_list[ i ] do
        
      local pos = private.gears_pos[ i ][ j ];
      local number = private.gears_current_list[ i ][ j ];
    
      ObjSet( "spr_superpuzzle4_mg_2_square_"..number, { 
        pos_x = pos[ 1 ], 
        pos_y = pos[ 2 ], 
        event_mdown = function () private.GearsClk( number ); end,
        event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end, 
        event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end 
      } );

      local name_gear = "spr_superpuzzle4_mg_2_gears_"..number;

      if ( ObjGet( name_gear ) ) then

        table.insert( table_multiset, { name_gear, { pos_x = pos[ 1 ], pos_y = pos[ 2 ] } } );

      end;

    end;
  
  end;

  --------------------------------------

  private.numbers_current_list = { 4, 1, 2, 3 };
  private.numbers_prev_number = 0;

  private.numbers_win_list = { 1, 2, 3, 4 };
  
  private.numbers_pos = { { -53, -81 }, { 146, -80 }, { -145, 31 }, { 146, 31 }};

  for i = 1, #private.numbers_current_list do
        
    local number = private.numbers_current_list[ i ];
    local pos    = private.numbers_pos[ i ];

    table.insert( table_multiset, { "spr_superpuzzle4_mg_3_bone_"..number, { 
      pos_x = pos[ 1 ], 
      pos_y = pos[ 2 ],
      event_mdown = function () private.NumbersClk( number ); end,
      event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end, 
      event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end
    } } );

  end;

  --------------------------------------

  private.tubes_current_list = { 
    { 2,  1,  3,  4 }, 
    { 2,  3,  3,  1 }, 
    { 3,  1,  2,  3 },
    { 4,  3,  1,  4 },
  };
  
  private.tubes_win_list = { 
    { 0,  0,  1,  1 }, 
    { 0,  1,  1,  2 }, 
    { 1,  2,  1,  1 },
    { 1,  1,  1,  2 },
  };
    
  for i = 1, #private.tubes_current_list do
  
    for j = 1, #private.tubes_current_list[ i ] do
        
      local ang = ( private.tubes_current_list[ i ][ j ] - 1 ) * math.pi / 2;
    
      ObjSet( "spr_superpuzzle4_mg_4_piece_"..i.."_"..j, { 
        ang = ang, 
        event_mdown = function () private.TubesClk( i, j ); end,
        event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end, 
        event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end
      } );

    end;
  
  end;

  --------------------------------------

  private.lamps_current_list = { 3, 2, 1, 5, 6, 4 };
  private.lamps_prev_number = 0;

  private.lamps_win_list = { 6, 5, 4, 3, 2, 1 };
  
  private.lamps_pos = { { -166, 3 }, { -101, 3 }, { -34, 3 }, { 32, 3 }, { 97, 3 }, { 164, 3 } };

  for i = 1, #private.lamps_current_list do
        
    local number = private.lamps_current_list[ i ];
    local pos    = private.lamps_pos[ i ];

    table.insert( table_multiset, { "spr_superpuzzle4_mg_6_lamp_"..number, { 
      pos_x = pos[ 1 ], 
      pos_y = pos[ 2 ],
      event_mdown = function () private.LampsClk( number ); end,
      event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end, 
      event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end
    } } );

  end;

  --------------------------------------

  private.brick_current_list = { 
    { 1,  10, 10, 10, 12, 2, 0 }, 
    { 1,  0,  3,  0,  12, 2, 0 }, 
    { 9,  9,  3,  0,  12, 4, 5 }, 
    { 0,  6,  11, 11, 11, 4, 5 }, 
    { 7,  6,  0,  8,  0,  0, 0 }, 
    { 7,  0,  0,  8,  0,  0, 0 }
  };

  private.brick_win_list = { 3, 7 };
  private.brick_win_number = 9;
  
  private.brick_pos_begin = { -18, -18 };
  private.brick_pos_step  = 36;

  private.brick_horizon  = { false, false, false, false, false, false, false, false, true, true, true, false };

  for i = 1, #private.brick_horizon do
        
    local index = private.BrickGetPosToArray( i );

    local pos_x  = private.brick_pos_begin[ 1 ] + ( index[ 1 ] * private.brick_pos_step );
    local pos_y  = private.brick_pos_begin[ 2 ] + ( index[ 2 ] * private.brick_pos_step );

    table.insert( table_multiset, { "spr_superpuzzle4_mg_8_brick_"..i, { 
      pos_x = pos_x, 
      pos_y = pos_y
    } } );

    if ( private.brick_horizon[ i ] ) then

      table.insert( table_multiset, { "spr_superpuzzle4_mg_8_brick_"..i.."_left", { 
        event_mdown  = function () private.BrickClk( i, -1, 0 ); end,
        event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end, 
        event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end
      } } );

      table.insert( table_multiset, { "spr_superpuzzle4_mg_8_brick_"..i.."_right", { 
        event_mdown  = function () private.BrickClk( i, 1, 0 ); end,
        event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end, 
        event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end
      } } );

    else

      table.insert( table_multiset, { "spr_superpuzzle4_mg_8_brick_"..i.."_up", { 
        event_mdown  = function () private.BrickClk( i, 0, -1 ); end,
        event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end, 
        event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end
      } } );

      table.insert( table_multiset, { "spr_superpuzzle4_mg_8_brick_"..i.."_down", { 
        event_mdown  = function () private.BrickClk( i, 0, 1 ); end,
        event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end, 
        event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end
      } } );

    end;

  end;

  --------------------------------------

  private.circles_current_list = { 5, 4, 1, 2, 3 };
  private.circles_prev_number = 0;

  private.circles_win_list = { 1, 2, 3, 4, 5 };
  
  private.circles_pos = { { -90, 52 }, { -75, -39 }, { 11, -65 }, { 79, -5 }, { -3, 26 } };

  for i = 1, #private.circles_current_list do
        
    local number = private.circles_current_list[ i ];
    local pos    = private.circles_pos[ i ];

    table.insert( table_multiset, { "spr_superpuzzle4_mg_5_circle_"..number, { 
      pos_x = pos[ 1 ], 
      pos_y = pos[ 2 ],
      event_mdown  = function () private.CirclesClk( number ); end,
      event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end, 
      event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end
    } } );

  end;

  --------------------------------------

  private.switches_current_list = { 1, 3 };
  private.switches_win_list = { 3, 1 };
  private.switches_alp = { { 1, 0.5, 0 }, { 0, 0.5, 1 } };
  
  for i = 1, #private.switches_current_list do
      
    local ang = 0.8 * ( private.switches_current_list[ i ] - 2 );

    table.insert( table_multiset, { "spr_superpuzzle4_mg_9_switch_"..i, { 
      ang = ang, 
      event_mdown  = function () private.SwitchesClk( i ); end,
      event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end, 
      event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end
    } } );

  end;

  --------------------------------------

  private.squares_prev_number = "";
  private.squares_list = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12 };

  private.squares_current_list = {};
  
  for i = 1,#private.squares_list do
    
    private.squares_current_list[ i ] = false;

  end;

  for s = 1, #private.squares_list do
    
    table.insert( table_multiset, { "spr_superpuzzle4_mg_9_couple_"..s, { 
      event_mdown  = function () private.SquaresClk( s ) end,
      event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end, 
      event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end 
    } } );

  end;
 
  --------------------------------------

  private.pictures_current_list = { 9, 6, 5, 12, 4, 7, 1, 2, 8, 3, 10, 11 };
  private.pictures_prev_number = 0;

  private.pictures_win_list = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12 };
  
  private.pictures_pos = { { 857, 92 }, { 918, 93 }, { 977, 92 }, { 857, 152 }, { 918, 152 }, { 978, 152 }, { 859, 272 }, { 919, 272 }, { 978, 272 }, { 859, 330 }, { 918, 331 }, { 978, 331 } };

  for i = 1, #private.pictures_current_list do
        
    local number = private.pictures_current_list[ i ];
    local pos    = private.pictures_pos[ i ];

    table.insert( table_multiset, { "spr_superpuzzle4_mg_9_picture_"..number, { 
      pos_x = pos[ 1 ], 
      pos_y = pos[ 2 ],
      event_mdown  = function () private.PicturesClk( number ); end,
      event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end, 
      event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end
    } } );

  end;

  --------------------------------------

  private.triangles_current_state = 1;
  private.triangles_index = 1;

  private.triangles_win_list = {
    { 1, 2, 1 }, 
    { 2, 1, 1, 2 }, 
    { 1, 1, 2, 1, 2, 2 }
  };

  for i = 1, 2 do
        
    table.insert( table_multiset, { "spr_superpuzzle4_mg_10_gray_"..i, { 
      event_mdown  = function () private.TrianglesClk( i ); end,
      event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end, 
      event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end
    } } );

  end;

  table.insert( table_multiset, { "spr_superpuzzle4_mg_10_button_1", { 
    event_mdown  = function () private.TrianglesShow(); end,
    event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end, 
    event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end
  } } );

  --------------------------------------

  if ( #table_multiset > 0 ) then

    ObjMultiSet( table_multiset );

  end;

  private.Animations();

  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open () 

  int_slider.InitSlider( private.room_objname );

  if not cmn.IsEventDone( "win_superpuzzle4" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();

  end;

  if ( private.items_done[ "mg_1_on_3" ] ) and ( not private.gears_win ) then

    private.gears_path = {};

    if ( private.GearsGeared( private.gears_start_pos[ 1 ], private.gears_start_pos[ 2 ] ) ) then

      table.insert( private.gears_path, private.gears_start_pos );

      private.GearsCheckPath( private.gears_start_pos );

    end;

    private.GearsRotateAnim();

    common_impl.PlayAudio( "env", "levelext/env/aud_gear_env", 1, "", 0 );

  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  if ( not cmn.IsEventStart( "win_superpuzzle4" ) ) then

    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].items_done = private.items_done;
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].clk_done   = private.clk_done;

    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].arrowswrong_current_list = {};
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].arrowswrong_win = private.arrowswrong_win;

    for i = 1, #private.arrowswrong_current_list do
    
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].arrowswrong_current_list[ i ] = private.arrowswrong_current_list[ i ];

    end;

    -----------------------------------------    

    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].arrowsright_current_list = {};
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].arrowsright_index = private.arrowsright_index;
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].arrowsright_win   = private.arrowsright_win;

    for i = 1, #private.arrowsright_current_list do
    
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].arrowsright_current_list[ i ] = private.arrowsright_current_list[ i ];

    end;

    -----------------------------------------    

    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].gears_current_list = {};
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].gears_win   = private.gears_win;

    for i = 1, #private.gears_current_list do

      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].gears_current_list[ i ] = {};

      for j = 1, #private.gears_current_list[ i ] do
        
         ng_global.progress[ "ext" ][ "win_superpuzzle4" ].gears_current_list[ i ][ j ] = private.gears_current_list[ i ][ j ];

      end;

    end;

    -----------------------------------------    

    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].numbers_current_list = {};
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].numbers_win   = private.numbers_win;

    for i = 1, #private.numbers_current_list do
    
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].numbers_current_list[ i ] = private.numbers_current_list[ i ];

    end;

    -----------------------------------------    

    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].tubes_current_list = {};
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].tubes_win   = private.tubes_win;

    for i = 1, #private.tubes_current_list do

      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].tubes_current_list[ i ] = {};

      for j = 1, #private.tubes_current_list[ i ] do
        
         ng_global.progress[ "ext" ][ "win_superpuzzle4" ].tubes_current_list[ i ][ j ] = private.tubes_current_list[ i ][ j ];

      end;

    end;

    -----------------------------------------    

    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].lamps_current_list = {};
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].lamps_win   = private.lamps_win;

    for i = 1, #private.lamps_current_list do
    
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].lamps_current_list[ i ] = private.lamps_current_list[ i ];

    end;

    -----------------------------------------    

    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].brick_current_list = {};
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].brick_win   = private.brick_win;

    for i = 1, #private.brick_current_list do
    
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].brick_current_list[ i ] = private.brick_current_list[ i ];

    end;

    -----------------------------------------    

    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].circles_current_list = {};
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].circles_win   = private.circles_win;

    for i = 1, #private.circles_current_list do
    
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].circles_current_list[ i ] = private.circles_current_list[ i ];

    end;

    -----------------------------------------    

    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].switches_current_list = {};
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].switches_index = private.switches_index;
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].switches_win   = private.switches_win;

    for i = 1, #private.switches_current_list do
    
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].switches_current_list[ i ] = private.switches_current_list[ i ];

    end;

    -----------------------------------------    

    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].squares_current_list = {};
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].squares_win = private.squares_win;

    for i = 1, #private.squares_current_list do
    
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].squares_current_list[ i ] = private.squares_current_list[ i ];

    end;

    -----------------------------------------    

    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].pictures_current_list = {};
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].pictures_win   = private.pictures_win;

    for i = 1, #private.pictures_current_list do
    
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].pictures_current_list[ i ] = private.pictures_current_list[ i ];

    end;

    -----------------------------------------    

    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].triangles_current_state = private.triangles_current_state;
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].triangles_win   = private.triangles_win;

    ----------------------------------------- 
   
  end;

end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()

  if not cmn.IsEventDone( "win_superpuzzle4" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;

  if ( private.items_done[ "mg_1_on_3" ] ) and ( not private.gears_win ) then

    common_impl.StopAudio( "env", "levelext/env/aud_gear_env", 0.5 );

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset ()

  private.ItemResetSet();
  private.ClkResetSet();
  private.ArrowswrongResetSet();
  private.ArrowsrightResetSet();
  private.GearsResetSet();
  private.NumbersResetSet();
  private.TubesResetSet();
  private.LampsResetSet();
  private.BrickResetSet();
  private.CirclesResetSet();
  private.SwitchesResetSet();
  private.SquaresResetSet();
  private.PicturesResetSet();
  private.TrianglesResetSet();
  
end;
--*********************************************************************************************************************
function public.Skip ()

port.skip_mg = true;
  private.arrowswrong_win  = true;
  private.arrowsright_win  = true;
  private.gears_win        = true;
  private.numbers_win      = true;
  private.tubes_win        = true;
  private.lamps_win        = true;
  private.brick_win        = true;
  private.circles_win      = true;
  private.switches_win     = true;
  private.squares_win      = true;
  private.pictures_win     = true;
  private.triangles_win  = true;

  for i = 1, #private.items_list do
    
    local name = private.items_list[ i ];
    private.items_done[ name ] = true;
    private.items_func_done[ name ]();

  end;

  for i = 1, #private.clk_list do
    
    local name = private.clk_list[ i ];
    private.clk_done[ name ] = true;

  end;

  common_impl.StopAudio( "env", "levelext/env/aud_gear_env", 0.5 );

  private.Win();

end;
--*********************************************************************************************************************
function private.WinEnd ()

  --common_impl.PlayAudio( "sfx", "aud_mg_win" );

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_superpuzzle4" );
  cmn.CallEventHandler( "win_superpuzzle4" );
  common_impl.PassingMgWin();

  if ( not ng_global.progress[ ng_global.currentprogress ][ "win_superpuzzle4" ].skip_clk ) then

    common_impl.CheckGiveCustomAchiev( "superpuzzle_no_skip" );

  end;

  cmn.GotoRoom( "rm_hall_ext" ); 

end;
--*********************************************************************************************************************
function private.Win ()

  private.WinEnd();

end;
--*********************************************************************************************************************
-- function *** Use Items ***() end
--*********************************************************************************************************************
  function private.ItemMDown ( sender )

    local obj_name = "spr_superpuzzle4_"..sender;

    private.item_parent = ObjGetRelations( obj_name ).parent;
    private.item_pos_z  = ObjGet( obj_name ).pos_z;

    ObjAttach( obj_name, "mg_superpuzzle4" )
    ObjSet( obj_name, { pos_z = 10 } );

    common_impl.PlayAudio( "sfx", "aud_get_inv_in_hand_sfx", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.ItemDragDrop ( sender )

    local obj_name = "spr_superpuzzle4_"..sender;

    ObjAttach( obj_name, private.item_parent )
    ObjSet( obj_name, { pos_z = private.item_pos_z } );

    common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );

    ----------------------------------------------------------------------------------------------------

    if ( sender == "mg_1_on_3" and common.ApplyObj( obj_name, "obj_superpuzzle4_mg_2_use_on_3" ) ) then

      local func_end = function ()

        private.items_done[ "mg_1_on_3" ] = true;
        ng_global.progress[ "ext" ][ "win_superpuzzle4" ].items_done[ "mg_1_on_3" ] = true;

        private.ItemDoneOn3();

        common_impl.PlayAudio( "env", "levelext/env/aud_gear_env", 1, "", 0 );

      end;
    
      ObjSet( "spr_superpuzzle4_mg_1_on_3", { alp = 0 } );

      ObjAnimate( "spr_superpuzzle4_mg_2_on_3_used", "alp", 0, 0, "", { 0,3,0,   0.4,3,1 } );

      ObjAnimate( "spr_superpuzzle4_mg_2_door_1", "pos_x", 0, 0, "", { 0,3,68,  0.4,3,68,  1.0,3,220 } );
      ObjAnimate( "spr_superpuzzle4_mg_2_door_2", "pos_x", 0, 0, func_end, { 0,3,-70,  0.4,3,-70,  1.0,3,-320 } );

    elseif ( sender == "mg_5_bone_get_1" and common.ApplyObj( obj_name, "obj_superpuzzle4_mg_3_use_bones" ) ) then

      private.items_done[ "mg_5_bone_get_1" ] = true;
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].items_done[ "mg_5_bone_get_1" ] = true;

      private.ItemDoneBone( 1 );

    elseif ( sender == "mg_5_bone_get_2" and common.ApplyObj( obj_name, "obj_superpuzzle4_mg_3_use_bones" ) ) then

      private.items_done[ "mg_5_bone_get_2" ] = true;
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].items_done[ "mg_5_bone_get_2" ] = true;

      private.ItemDoneBone( 2 );

    elseif ( sender == "mg_5_bone_get_3" and common.ApplyObj( obj_name, "obj_superpuzzle4_mg_3_use_bones" ) ) then

      private.items_done[ "mg_5_bone_get_3" ] = true;
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].items_done[ "mg_5_bone_get_3" ] = true;

      private.ItemDoneBone( 3 );

    elseif ( sender == "mg_5_bone_get_4" and common.ApplyObj( obj_name, "obj_superpuzzle4_mg_3_use_bones" ) ) then

      private.items_done[ "mg_5_bone_get_4" ] = true;
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].items_done[ "mg_5_bone_get_4" ] = true;

      private.ItemDoneBone( 4 );

    elseif ( sender == "mg_4_lamp_get" and common.ApplyObj( obj_name, "obj_superpuzzle4_mg_6_use_lamp" ) ) then

      local func_end = function ()

        private.items_done[ "mg_4_lamp_get" ] = true;
        ng_global.progress[ "ext" ][ "win_superpuzzle4" ].items_done[ "mg_4_lamp_get" ] = true;

        private.ItemDoneLamp();

      end;

      ObjSet( "spr_superpuzzle4_mg_4_lamp_get",  { alp = 0 } );
      ObjSet( "spr_superpuzzle4_mg_6_lamp_used", { alp = 1 } );

      ObjAnimate( "obj_superpuzzle4_mg_6_lamps", "alp", 0, 0, func_end, { 0,3,0,  0.4,3,1 } );

    elseif ( sender == "mg_4_key_get_1" and common.ApplyObj( obj_name, "obj_superpuzzle4_mg_7_use_keys" ) ) then

      private.ItemKeysAnim( 1 );

    elseif ( sender == "mg_4_key_get_2" and common.ApplyObj( obj_name, "obj_superpuzzle4_mg_7_use_keys" ) ) then

      private.ItemKeysAnim( 2 );

    elseif ( sender == "mg_4_key_get_3" and common.ApplyObj( obj_name, "obj_superpuzzle4_mg_7_use_keys" ) ) then

      private.ItemKeysAnim( 3 );

    elseif ( sender == "mg_4_key_get_4" and common.ApplyObj( obj_name, "obj_superpuzzle4_mg_7_use_keys" ) ) then

      private.ItemKeysAnim( 4 );

    elseif ( sender == "mg_4_key_get_5" and common.ApplyObj( obj_name, "obj_superpuzzle4_mg_7_use_keys" ) ) then

      private.ItemKeysAnim( 5 );

    elseif ( sender == "mg_4_key_get_6" and common.ApplyObj( obj_name, "obj_superpuzzle4_mg_7_use_keys" ) ) then

      private.ItemKeysAnim( 6 );

    elseif ( sender == "mg_8_circle_get" and common.ApplyObj( obj_name, "obj_superpuzzle4_mg_5_use_circle" ) ) then

      private.items_done[ "mg_8_circle_get" ] = true;
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].items_done[ "mg_8_circle_get" ] = true;

      private.ItemDoneCircle();

    elseif ( sender == "mg_5_switch_get" and common.ApplyObj( obj_name, "obj_superpuzzle4_mg_9_use_switch" ) ) then

      local func_end = function ()

        private.items_done[ "mg_5_switch_get" ] = true;
        ng_global.progress[ "ext" ][ "win_superpuzzle4" ].items_done[ "mg_5_switch_get" ] = true;

        private.ItemDoneSwitch();

      end;

      ObjSet( "spr_superpuzzle4_mg_5_switch_get",     { alp = 0 } );
      ObjSet( "spr_superpuzzle4_mg_9_switch_2",       { alp = 1 } );
      ObjSet( "spr_superpuzzle4_mg_9_switch_shadow",  { alp = 1 } );

      ObjAnimate( "spr_superpuzzle4_mg_9_tv_1", "alp", 0, 0, "", { 0,3,0,  0.2,3,1,  0.3,3,0,  0.4,3,1 } );
      ObjAnimate( "spr_superpuzzle4_mg_9_tv_2", "alp", 0, 0, func_end, { 0,3,0,  0.2,3,1,  0.3,3,0,  0.4,3,1 } );

    end;

  end;
  --*********************************************************************************************************************
  function private.ItemDoneOn3 ()

    local table_multiset = {};  

    table.insert( table_multiset, { "spr_superpuzzle4_mg_1_on_3",      { alp = 0, input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_2_on_3_used", { alp = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_2_door_1",    { pos_x = 220 } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_2_door_2",    { pos_x = -320 } } );    
    table.insert( table_multiset, { "obj_superpuzzle4_mg_2_crop",      { input = true } } );    
    table.insert( table_multiset, { "obj_superpuzzle4_mg_2_use_on_3",  { input = false } } );    

    ObjMultiSet( table_multiset )

  end;
  --*********************************************************************************************************************
  function private.ItemDoneBone ( number )

    local table_multiset = {};  

    table.insert( table_multiset, { "spr_superpuzzle4_mg_5_bone_get_"..number, { alp = 0, input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_3_bone_"..number,     { alp = 1 } } );

    private.ItemCheckAllBones();

    ObjMultiSet( table_multiset )

  end;
  --*********************************************************************************************************************
  function private.ItemCheckAllBones ()

    if ( private.items_done[ "mg_5_bone_get_1" ] ) and
       ( private.items_done[ "mg_5_bone_get_2" ] ) and
       ( private.items_done[ "mg_5_bone_get_3" ] ) and
       ( private.items_done[ "mg_5_bone_get_4" ] ) then

      ObjSet( "obj_superpuzzle4_mg_3_use_bones", { input = false } );
      ObjSet( "obj_superpuzzle4_mg_3_crop",      { input = true } );

    end;

  end;
  --*********************************************************************************************************************
  function private.ItemDoneLamp ()

    local table_multiset = {};  

    table.insert( table_multiset, { "spr_superpuzzle4_mg_4_lamp_get",     { alp = 0, input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_6_lamp_used",    { alp = 1 } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_6_use_lamp",     { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_6_lamps",        { alp = 1, input = true } } );

    ObjMultiSet( table_multiset )

  end;
  --*********************************************************************************************************************
  function private.ItemDoneKey ( number )

    local table_multiset = {};  

    table.insert( table_multiset, { "spr_superpuzzle4_mg_4_key_get_"..number, { alp = 0, input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_7_key_"..number,     { alp = 1 } } );

    private.ItemCheckAllKeys();

    ObjMultiSet( table_multiset )

  end;
  --*********************************************************************************************************************
  function private.ItemCheckAllKeys ()

    if ( private.items_done[ "mg_4_key_get_1" ] ) and
       ( private.items_done[ "mg_4_key_get_2" ] ) and
       ( private.items_done[ "mg_4_key_get_3" ] ) and
       ( private.items_done[ "mg_4_key_get_4" ] ) and
       ( private.items_done[ "mg_4_key_get_5" ] ) and
       ( private.items_done[ "mg_4_key_get_6" ] ) then

      ObjSet( "obj_superpuzzle4_mg_8_bricks",      { input = true } );
      ObjSet( "obj_superpuzzle4_mg_7_use_keys",    { input = false } );


      ObjSet( "spr_superpuzzle4_mg_7_door", { pos_y = -250 } );

    end;

  end;
  --*********************************************************************************************************************
  function private.ItemKeysAnim ( number )

    ObjSet( "spr_superpuzzle4_mg_4_key_get_"..number, { alp = 0 } );
    ObjSet( "spr_superpuzzle4_mg_7_key_"..number, { alp = 1 } );

    private.items_done[ "mg_4_key_get_"..number ] = true;
      
    local func_end = function ()
    
      common_impl.Lock( false );

      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].items_done[ "mg_4_key_get_"..number ] = true;

      private.ItemDoneKey( number );

    end;

    if ( private.items_done[ "mg_4_key_get_1" ] ) and
       ( private.items_done[ "mg_4_key_get_2" ] ) and
       ( private.items_done[ "mg_4_key_get_3" ] ) and
       ( private.items_done[ "mg_4_key_get_4" ] ) and
       ( private.items_done[ "mg_4_key_get_5" ] ) and
       ( private.items_done[ "mg_4_key_get_6" ] ) then

      common_impl.Lock( true );

      ObjAnimate( "spr_superpuzzle4_mg_7_door", "pos_y", 0, 0, func_end, { 0,3,-15,   0.2,3,-15,   0.6,3,-250 } );

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide1", 0, "", 0 );

    else

      func_end();

    end;

  end;
  --*********************************************************************************************************************
  function private.ItemDoneCircle ()

    local table_multiset = {};  

    table.insert( table_multiset, { "spr_superpuzzle4_mg_8_circle_get",     { alp = 0, input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_5_circle_hole",    { alp = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_5_circles",        { input = true } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_5_use_circle",     { input = false } } );

    ObjMultiSet( table_multiset )

  end;
  --*********************************************************************************************************************
  function private.ItemDoneSwitch ()

    local table_multiset = {};  

    table.insert( table_multiset, { "spr_superpuzzle4_mg_5_switch_get",     { alp = 0, input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_9_switch_2",       { alp = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_9_switch_shadow",  { alp = 1 } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_9_switches",       { input = true } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_9_use_switch",     { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_9_tv_1",           { alp = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_9_tv_2",           { alp = 1 } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_9_symbols",        { alp = 1 } } );

    ObjMultiSet( table_multiset )

  end;
  --*********************************************************************************************************************
  function private.ItemResetSet ()

    private.items_done[ "mg_1_on_3" ] = false;
    private.items_done[ "mg_5_bone_get_1" ] = false;
    private.items_done[ "mg_5_bone_get_2" ] = false;
    private.items_done[ "mg_5_bone_get_3" ] = false;
    private.items_done[ "mg_5_bone_get_4" ] = false;
    private.items_done[ "mg_4_lamp_get" ] = false;
    private.items_done[ "mg_4_key_get_1" ] = false;
    private.items_done[ "mg_4_key_get_2" ] = false;
    private.items_done[ "mg_4_key_get_3" ] = false;
    private.items_done[ "mg_4_key_get_4" ] = false;
    private.items_done[ "mg_4_key_get_5" ] = false;
    private.items_done[ "mg_4_key_get_6" ] = false;
    private.items_done[ "mg_8_circle_get" ] = false;
    private.items_done[ "mg_5_switch_get" ] = false;

    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].items_done = private.items_done;

    local table_multiset = {};

    table.insert( table_multiset, { "spr_superpuzzle4_mg_1_on_3",       { alp = 1, input = true } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_2_on_3_used",  { alp = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_2_door_1",     { pos_x = 68 } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_2_door_2",     { pos_x = -70 } } );    
    table.insert( table_multiset, { "obj_superpuzzle4_mg_2_crop",       { input = false } } );    
    table.insert( table_multiset, { "obj_superpuzzle4_mg_2_use_on_3",   { input = true } } );    

    for number = 1,4 do
    
      table.insert( table_multiset, { "spr_superpuzzle4_mg_5_bone_get_"..number, { alp = 1, input = true } } );
      table.insert( table_multiset, { "spr_superpuzzle4_mg_3_bone_"..number,     { alp = 0 } } );

    end;

    table.insert( table_multiset, { "obj_superpuzzle4_mg_3_use_bones",  { input = true } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_3_crop",       { input = false } } );

    table.insert( table_multiset, { "spr_superpuzzle4_mg_4_lamp_get",   { alp = 1, input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_6_lamp_used",  { alp = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_6_use_lamp",   { input = true } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_6_lamps",      { alp = 0, input = false } } );

    for number = 1,6 do
    
      table.insert( table_multiset, { "spr_superpuzzle4_mg_4_key_get_"..number, { alp = 1, input = true } } );
      table.insert( table_multiset, { "spr_superpuzzle4_mg_7_key_"..number,     { alp = 0 } } );

    end;

    table.insert( table_multiset, { "spr_superpuzzle4_mg_7_door",     { pos_y = -15 } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_7_use_keys", { input = true } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_8_bricks",   { input = false } } );

    table.insert( table_multiset, { "spr_superpuzzle4_mg_8_circle_get",     { alp = 1, input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_5_circle_hole",    { alp = 1 } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_5_circles",        { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_5_use_circle",     { input = true } } );

    table.insert( table_multiset, { "spr_superpuzzle4_mg_5_switch_get",     { alp = 0, input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_9_switch_2",       { alp = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_9_switch_shadow",  { alp = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_9_switches",       { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_9_use_switch",     { input = true } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_9_tv_1",           { alp = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_9_tv_2",           { alp = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_9_symbols",        { alp = 0 } } );

    ObjMultiSet( table_multiset )

  end;
 --*********************************************************************************************************************
  function private.LoadItemsDone ( event_name )

    if ( private.items_done[ event_name ] ) then

      private.items_func_done[ event_name ]();

    end;

  end;
--*********************************************************************************************************************
-- function *** Clicks ***() end
--*********************************************************************************************************************
  function private.PlaceClk ( sender )

    local obj_name = "obj_superpuzzle4_"..sender;

    if ( sender == "mg_4_clk_lever" ) then

      common_impl.Lock( true );

      local func_end = function ()
      
        common_impl.Lock( false );

        private.clk_done[ "mg_4_clk_lever" ] = true;
    
        private.ClkDoneLever();

      end;

      ObjAnimate( "spr_superpuzzle4_mg_4_lever",   "alp",   0, 0, "", { 0,3,1,  0.4,3,0 } );
      ObjAnimate( "spr_superpuzzle4_mg_4_lever_2", "alp",   0, 0, "", { 0,3,0,  0.4,3,1 } );
      ObjAnimate( "spr_superpuzzle4_mg_4_door",    "pos_y", 0, 0, func_end, { 0,3,-51,  0.4,3,-51,  0.8,3,180 } );

      common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk9", 0, "", 0 );

    end;

  end;
  --******************* **************************************************************************************************
  function private.ClkDoneLever ()

    local table_multiset = {};  

    table.insert( table_multiset, { "spr_superpuzzle4_mg_4_lever",     { alp   = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_4_lever_2",   { alp   = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_4_door",      { pos_y = 180 } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_4_clk_lever", { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_4_lamp_get",  { input = true } } );


    ObjMultiSet( table_multiset )

  end;
  
  --*********************************************************************************************************************
  function private.ClkResetSet ()

    private.clk_done[ "mg_4_clk_lever" ]    = false;

    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].clk_done[ "mg_4_clk_lever" ] = false;

    local table_multiset = {};

    table.insert( table_multiset, { "spr_superpuzzle4_mg_4_lever",     { alp   = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_4_lever_2",   { alp   = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_4_door",      { pos_y = -51 } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_4_clk_lever", { input = false } } );

    ObjMultiSet( table_multiset )

  end;
  --*********************************************************************************************************************
  function private.LoadClkDone ( event_name )

    if ( private.clk_done[ event_name ] ) then

      private.clk_func_done[ event_name ]();

    end;

  end;
--*********************************************************************************************************************
--  function *** Mmg Arrowswrong ***() end
--*********************************************************************************************************************
  function private.ArrowswrongClk ( number )

    cmn.Lock( true );

    local obj_name = "spr_superpuzzle4_mg_1_on_";

    ObjSet( obj_name..number, { input = false } );

    local func_end = function ()

      cmn.Lock( false );

      private.ArrowswrongClkEnd( number );

    end;
  
    ObjAnimate( obj_name..number, "alp", 0, 0, func_end, 
    { 
      0,   3, 1,  
      0.4, 3, 0 
    } );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_button", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.ArrowswrongClkEnd ( number )

    private.arrowswrong_current_list[ number ] = true;
    
    local flag_win = true;

    for i = 1, #private.arrowswrong_current_list do
      
      if ( not private.arrowswrong_current_list[ i ] ) then

        flag_win = false;
        break;

      end;

    end;

    if ( flag_win ) then

      private.ArrowswrongWinAnim();

    else

      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].arrowswrong_current_list[ number ] = true;

    end;

  end;
  --*********************************************************************************************************************
  function private.ArrowswrongWinAnim ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );

      private.arrowswrong_win = true;

      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].arrowswrong_win = true;

      private.ArrowswrongWinSet();

    end;

    for i = 1, #private.arrowsright_current_list do
    
      if ( i ~= 1 ) then

        func_end = ""

      end;

      ObjAnimate( "spr_superpuzzle4_mg_1_on_"..i, "alp", 0, 0, func_end, { 0,3,0,  0.4,3,1 } );

    end;

    --common_impl.PlayAudio( "sfx", "levelext/sfx/aud_mg_superpuzzle4_clk9", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.ArrowswrongWinSet ()

    private.arrowswrong_current_list = { true, true, true };

    local table_multiset = {};

    for i = 1, #private.arrowswrong_current_list do
          
      table.insert( table_multiset, { "spr_superpuzzle4_mg_1_on_"..i, { 
        alp = 1, 
        input = 1,  
        event_mdown = function () private.ArrowsrightClk( i ); end 
      } } );

    end;

    --table.insert( table_multiset, { "obj_superpuzzle4_mg_3_arrowswrong", { input = false, pos_y = 140 } } );
    --table.insert( table_multiset, { "spr_superpuzzle4_mg_3_door",    { pos_y = -80 } } );
    --table.insert( table_multiset, { "spr_superpuzzle4_logo_n",       { input = true } } );
    --table.insert( table_multiset, { "spr_superpuzzle4_hint_mg_3",    { alp = 0 } } );

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.ArrowswrongResetSet ()

    private.arrowswrong_current_list = { false, false, false };
    private.arrowswrong_win = false;

    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].arrowswrong_index = 1;
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].arrowswrong_current_list = { false, false, false };
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].arrowswrong_win = false;

    local table_multiset = {};

    --table.insert( table_multiset, { "obj_superpuzzle4_mg_3_arrowswrong", { input = true,  pos_y = 0 } } );
    --table.insert( table_multiset, { "spr_superpuzzle4_mg_3_door",    { pos_y = -7 } } );
    --table.insert( table_multiset, { "spr_superpuzzle4_logo_n",       { input = false } } );
    --table.insert( table_multiset, { "spr_superpuzzle4_hint_mg_3",    { alp = 0 } } );

    for i = 1, #private.arrowswrong_current_list do
          
      table.insert( table_multiset, { alp = 1, input = true, "spr_superpuzzle4_mg_1_on_"..i, { 
        alp = 1,
        ang = 0,
        input = true,
        drag = false,
        event_mdown  = function () private.ArrowswrongClk( i ); end,
        event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end,
      } } );

    end;

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
--  function *** Mmg Arrowsright ***() end
--*********************************************************************************************************************
  function private.ArrowsrightClk ( number )

    cmn.Lock( true );

    local obj_name = "spr_superpuzzle4_mg_1_on_";

    ObjSet( obj_name..number, { input = false } );

    local func_end = function ()

      cmn.Lock( false );

      private.ArrowsrightClkEnd( number );

    end;
  
    ObjAnimate( obj_name..number, "alp", 0, 0, func_end, 
    { 
      0,   3, 1,  
      0.4, 3, 0 
    } );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_button", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.ArrowsrightClkEnd ( number )

    private.arrowsright_current_list[ private.arrowsright_index ] = number;
    
    local flag_win = true;

    for i = 1, #private.arrowsright_current_list do
      
      if ( private.arrowsright_current_list[ i ] ~= private.arrowsright_win_list[ i ] ) then

        flag_win = false;
        break;

      end;

    end;

    local flag_reset = false;

    if ( private.arrowsright_current_list[ private.arrowsright_index ] ~= private.arrowsright_win_list[ private.arrowsright_index ] ) then

      flag_reset = true;

    end;

    if ( flag_win ) then

      private.ArrowsrightWinAnim();

    elseif ( flag_reset ) then

      private.ArrowsrightResetAnim();

    else

      private.arrowsright_index = private.arrowsright_index + 1;

      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].arrowsright_index = private.arrowsright_index;
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].arrowsright_current_list[ private.arrowsright_index ] = number;

    end;

  end;
  --*********************************************************************************************************************
  function private.ArrowsrightWinAnim ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );

      private.arrowsright_win = true;

      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].arrowsright_win = true;

      private.ArrowsrightWinSet();

    end;

    for i = 1, #private.arrowsright_current_list do
    
      ObjAnimate( "spr_superpuzzle4_mg_1_on_"..i, "alp", 0, 0, "", { 0,3,0,  0.4,3,1 } );

    end;

    ObjAnimate( "spr_superpuzzle4_mg_1_on_3", "ang", 0, 0, func_end, { 0,3,0,  0.4,3,0,  0.8,3,-0.7 } );

    --common_impl.PlayAudio( "sfx", "levelext/sfx/aud_mg_superpuzzle4_clk9", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.ArrowsrightWinSet ()

    private.arrowsright_current_list = { 1, 3, 2 };

    local table_multiset = {};

    table.insert( table_multiset, { "spr_superpuzzle4_mg_1_on_1", { input = false, alp = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_1_on_2", { input = false, alp = 1 } } );

    table.insert( table_multiset, { "spr_superpuzzle4_mg_1_on_3", { 
      input = true,
      alp = 1,
      ang = -0.7,
      drag = true,
      event_mdown    = function () private.ItemMDown( "mg_1_on_3" ); end, 
      event_dragdrop = function () private.ItemDragDrop( "mg_1_on_3" ); end,
      event_menter   = function () common_impl.SetCursor( CURSOR_GET ); end
    } } );

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.ArrowsrightResetAnim ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );

      private.arrowsright_index = 1;
      private.arrowsright_current_list = { 0, 0, 0 };

      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].arrowsright_index = 1;
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].arrowsright_current_list = { 0, 0, 0 };

      for i = 1, #private.arrowsright_win_list do 
        
        ObjSet( "spr_superpuzzle4_mg_1_on_"..i, { input = true } );

      end;

    end;

    for i = 1, #private.arrowsright_win_list do

      if ( i ~= 1 ) then

        func_end = "";

      end;

      local old_alp = ObjGet( "spr_superpuzzle4_mg_1_on_"..i ).alp;

      ObjAnimate( "spr_superpuzzle4_mg_1_on_"..i, "alp", 0, 0, func_end, 
      { 
        0,   3, old_alp,  
        0.4, 3, 1 
      } );    

    end;

    common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.ArrowsrightResetSet ()

    private.arrowsright_index = 1;
    private.arrowsright_current_list = { 0, 0, 0 };
    private.arrowsright_win = false;

    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].arrowsright_index = 1;
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].arrowsright_current_list = { 0, 0, 0 };
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].arrowsright_win = false;

    local table_multiset = {};

    for i = 1, #private.arrowsright_win_list do 
      
      table.insert( table_multiset, { "spr_superpuzzle4_mg_1_on_"..i, { input = true, alp = 1 } } );

    end;

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
-- function *** Mmg Gears ***() end
--*********************************************************************************************************************
  function private.GearsClk ( number )

    local index = private.GearsGetIndex( number );
    local index_empty = private.GearsGetEmpty( index );

    if ( index_empty ) then

      cmn.Lock( true );

      local name = "spr_superpuzzle4_mg_2_square_"..number;

      local name_gear = "spr_superpuzzle4_mg_2_gears_"..number;

      local obj = ObjGet( name );

      local ind_i = index_empty[ 1 ];
      local ind_j = index_empty[ 2 ];

      local pos_x_new = private.gears_pos[ ind_i ][ ind_j ][ 1 ];
      local pos_y_new = private.gears_pos[ ind_i ][ ind_j ][ 2 ];

      local func_end = function ()

        cmn.Lock( false );

        private.GearsClkEnd( index, index_empty );

      end;

      ObjAnimate( name, "pos_xy", 0, 0, func_end, 
      { 
        0,   3, obj.pos_x, obj.pos_y, 
        0.2, 3, pos_x_new, pos_y_new
      } );

      if ( ObjGet( name_gear ) ) then

        ObjAnimate( name_gear, "pos_xy", 0, 0, "", 
        { 
          0,   3, obj.pos_x, obj.pos_y, 
          0.2, 3, pos_x_new, pos_y_new
        } );

      end;

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_click2", 0, "", 0 );

    end;

  end;
  --*********************************************************************************************************************
  function private.GearsClkEnd ( index, index_new )
    
    private.gears_current_list[ index[1]     ][ index[2] ],
    private.gears_current_list[ index_new[1] ][ index_new[2] ] =

    private.gears_current_list[ index_new[1] ][ index_new[2] ],
    private.gears_current_list[ index[1]     ][ index[2] ];

    private.gears_path = {};

    if ( private.GearsGeared( private.gears_start_pos[ 1 ], private.gears_start_pos[ 2 ] ) ) then

      table.insert( private.gears_path, private.gears_start_pos );

      private.GearsCheckPath( private.gears_start_pos );

    end;

    private.GearsRotateAnim();

    local flag_win = false;

    if ( #private.gears_path > 0 ) and 
       ( private.gears_path[ #private.gears_path ][ 1 ] == private.gears_win_pos[ 1 ] ) and 
       ( private.gears_path[ #private.gears_path ][ 2 ] == private.gears_win_pos[ 2 ] ) then

      flag_win = true;

    end;

    if ( flag_win ) then

      private.GearsWinAnim();

    else

      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].gears_current_list[ index[1]     ][ index[2] ],
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].gears_current_list[ index_new[1] ][ index_new[2] ] =

      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].gears_current_list[ index_new[1] ][ index_new[2] ],
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].gears_current_list[ index[1]     ][ index[2] ];

    end;

  end;
  --*********************************************************************************************************************
  function private.GearsCheckPath ( index )

    local current_geared = private.GearsGeared( index[ 1 ], index[ 2 ] );

    local offset = { { -1, 0 }, { 1, 0 }, { 0, -1 }, { 0, 1 } };

    for i = 1, #offset do
      
      local i_cur = index[ 1 ] + offset[ i ][ 1 ];
      local j_cur = index[ 2 ] + offset[ i ][ 2 ];
      local dir   = index[ 3 ] * ( -1 );

      if ( i_cur > 0 ) and ( i_cur <= #private.gears_current_list ) and 
         ( j_cur > 0 ) and ( j_cur <= #private.gears_current_list[ i_cur ] ) then

        local already_exist = private.GearsGetAlready( i_cur, j_cur );
        local geared        = private.GearsGeared( i_cur, j_cur );

        if( not already_exist ) and
          ( geared ) then

          table.insert( private.gears_path, { i_cur, j_cur, dir } );

          private.GearsCheckPath( { i_cur, j_cur, dir } );

        end;

      end;

    end;

    return false;

  end;
  --*********************************************************************************************************************
  function private.GearsGetAlready ( i_cur, j_cur )

    for i = 1, #private.gears_path do
    
      if ( private.gears_path[ i ][ 1 ] == i_cur ) and ( private.gears_path[ i ][ 2 ] == j_cur ) then

        return true

      end;

    end;

    return false

  end;
  --*********************************************************************************************************************
  function private.GearsGeared ( i_cur, j_cur )

    local current = private.gears_current_list[ i_cur ][ j_cur ];

    for i = 1, #private.gears_geared do
    
      if ( current == private.gears_geared[ i ] ) then

        return true;

      end;

    end;

    return false

  end;
  --*********************************************************************************************************************
  function private.GearsGetIndex ( number )

    for i = 1, #private.gears_current_list do
    
      for j = 1, #private.gears_current_list[ i ] do
          
        if ( private.gears_current_list[ i ][ j ] == number ) then

          return { i, j };

        end;

      end;
    
    end;

  end;
  --*********************************************************************************************************************
  function private.GearsGetEmpty ( index )

    local offset = { { -1, 0 }, { 1, 0 }, { 0, -1 }, { 0, 1 } };

    for i = 1, #offset do
      
      local i_cur = index[ 1 ] + offset[ i ][ 1 ];
      local j_cur = index[ 2 ] + offset[ i ][ 2 ];

      if ( i_cur > 0 ) and ( i_cur <= #private.gears_current_list ) and 
         ( j_cur > 0 ) and ( j_cur <= #private.gears_current_list[ i ] ) and
         ( private.gears_current_list[ i_cur ][ j_cur ] == 0 ) then

        return { i_cur, j_cur };

      end;

    end;

    return false;

  end;
  --*********************************************************************************************************************
  function private.GearsRotateAnim ()

    for i = 1, #private.gears_geared do
    
      local name_gear = "spr_superpuzzle4_mg_2_gears_"..private.gears_geared[ i ];

      ObjStopAnimate( name_gear, "ang" );

    end;

    for i = 1, #private.gears_path do
    
      local number = private.gears_current_list[ private.gears_path[ i ][ 1 ] ][ private.gears_path[ i ][ 2 ] ]

      local name_gear = "spr_superpuzzle4_mg_2_gears_"..number;

      local dir = private.gears_path[ i ][ 3 ];

      ObjAnimate( name_gear, "ang", 1, 0, "", 
      { 
        0,    0,  0,  
        0.5,  0,  dir * math.pi * 2 
      } );    

    end;

    --common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_tag_win", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.GearsWinAnim ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );

      private.gears_win = true;

      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].gears_win = true;

      private.GearsWinSet();

      common_impl.StopAudio( "env", "levelext/env/aud_gear_env", 0.5 );

    end;

    ObjAnimate( "spr_superpuzzle4_mg_2_gears_gold_2", "ang", 1, 0, "", { 0,0,0,  0.5,0,math.pi * 2 } );

    local func_audio = function ()

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide1", 0, "", 0 );
      
    end;

    ObjAnimate( "obj_superpuzzle4_mg_5_move", "alp", 0, 0, func_audio, 
    { 
      0,   3, 1,  
      1.5, 3, 1 
    } );   

    ObjAnimate( "obj_superpuzzle4_mg_5_move", "pos_x", 0, 0, "", 
    { 
      0,   3, 300,  
      1.5, 3, 300,  
      2.0, 3, 0 
    } );   

    ObjAnimate( "obj_superpuzzle4_mg_2_move", "pos_x", 0, 0, func_end, 
    { 
      0,   3, 0,  
      1.5, 3, 0,  
      2.0, 3, -300 
    } );   

  end;
  --*********************************************************************************************************************
  function private.GearsWinSet ()

    ObjSet( "obj_superpuzzle4_mg_2_move", { pos_x = -300 } );
    ObjSet( "obj_superpuzzle4_mg_2_crop", { input = false } );

    ObjSet( "obj_superpuzzle4_mg_5_move", { pos_x = 0 } );
    ObjSet( "obj_superpuzzle4_mg_5_crop", { input = true } );

      
  end;
  --*********************************************************************************************************************
  function private.GearsResetSet ()

    private.gears_current_list = { 
      { 1,   2,  3,  4 }, 
      { 5,   6,  7,  8 }, 
      { 9,   10, 11, 12 },
      { 13,  14, 15, 0 },
    };

    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].gears_current_list = { 
      { 1,   2,  3,  4 }, 
      { 5,   6,  7,  8 }, 
      { 9,   10, 11, 12 },
      { 13,  14, 15, 0 },
    };

    private.gears_win = false;

    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].gears_win = false; 

    ObjSet( "obj_superpuzzle4_mg_2_move", { pos_x = 0 } );
    ObjSet( "obj_superpuzzle4_mg_2_crop", { input = false } );

    ObjSet( "obj_superpuzzle4_mg_5_move", { pos_x = -300 } );
    ObjSet( "obj_superpuzzle4_mg_5_crop", { input = false } );

    for i = 1, #private.gears_geared do
    
      local name_gear = "spr_superpuzzle4_mg_2_gears_"..private.gears_geared[ i ];

      ObjStopAnimate( name_gear, "ang" );

    end;

    for i = 1, #private.gears_current_list do
    
      for j = 1, #private.gears_current_list[ i ] do
          
        local pos = private.gears_pos[ i ][ j ];
        local number = private.gears_current_list[ i ][ j ];
      
        ObjSet( "spr_superpuzzle4_mg_2_square_"..number, { pos_x = pos[ 1 ], pos_y = pos[ 2 ] } );

        local name_gear = "spr_superpuzzle4_mg_2_gears_"..number;

        if ( ObjGet( name_gear ) ) then

          ObjSet( name_gear, { pos_x = pos[ 1 ], pos_y = pos[ 2 ] } );

        end;

      end;
    
    end;

    common_impl.StopAudio( "env", "levelext/env/aud_gear_env", 0.5 );

  end;
--*********************************************************************************************************************
--  function *** Mmg Numbers ***() end
--*********************************************************************************************************************
  function private.NumbersClk ( number )

    local cur_name = "spr_superpuzzle4_mg_3_bone_"..number;

    if ( private.numbers_prev_number == 0 ) then

      ObjSet( cur_name.."_light", { alp = 1 } );

      private.numbers_prev_number = number;

    elseif ( private.numbers_prev_number == number ) then

      ObjSet( cur_name.."_light", { alp = 0 } );

      private.numbers_prev_number = 0;

    else

      common_impl.Lock( true );

      local prev_name = "spr_superpuzzle4_mg_3_bone_"..private.numbers_prev_number;

      local func_end = function ()

        common_impl.Lock( false );

        private.NumbersClkEnd( number, private.numbers_prev_number );

        private.numbers_prev_number = 0;

      end;
  
      local index = private.NumbersGetPosToArray( number );

      local old_params = ObjGet( prev_name );
      local new_params = ObjGet( cur_name );
      
      ObjSet( prev_name.."_light", { alp = 0 } );

      ObjAnimate( prev_name, "pos_xy", 0, 0, func_end, 
      { 
        0,   3,  old_params.pos_x,  old_params.pos_y,  
        0.4, 3,  new_params.pos_x,  new_params.pos_y
      } );

      ObjAnimate( cur_name, "pos_xy", 0, 0, "", 
      { 
        0,   3,  new_params.pos_x,  new_params.pos_y,  
        0.4, 3,  old_params.pos_x,  old_params.pos_y
      } );

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk1", 0, "", 0 );

    end;  

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_menter1", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.NumbersGetPosToArray ( number )

    for i = 1, #private.numbers_current_list do
    
      if ( private.numbers_current_list[ i ] == number ) then

        return i;

      end;
  
    end;

  end;
  --*********************************************************************************************************************
  function private.NumbersAllLightOff ()

    for i = 1, #private.numbers_current_list do
    
      ObjSet( "spr_superpuzzle4_mg_3_bone_"..i.."_light", { alp = 0 } );
  
    end;

  end;
  --*********************************************************************************************************************
  function private.NumbersClkEnd ( number, prev_number )

    local index      = private.NumbersGetPosToArray( number );
    local prev_index = private.NumbersGetPosToArray( prev_number );

    private.numbers_current_list[ index ], private.numbers_current_list[ prev_index ] = 
    private.numbers_current_list[ prev_index ], private.numbers_current_list[ index ];
    
    local flag_win = true;

    for i = 1, #private.numbers_win_list do
      
      if ( private.numbers_current_list[ i ] ~= private.numbers_win_list[ i ] ) then

        flag_win = false;
        break;

      end;

    end;

    if ( flag_win ) then

      private.NumbersWinAnim();

    else

      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].numbers_current_list[ index ] = private.numbers_current_list[ index ];
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].numbers_current_list[ prev_index ] = private.numbers_current_list[ prev_index ];

    end;

  end;
  --*********************************************************************************************************************
  function private.NumbersWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.numbers_win = true;
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].numbers_win = true;

      private.NumbersWinSet();

    end;

    ObjAnimate( "obj_superpuzzle4_mg_3_move", "pos_y", 0, 0, func_end, 
    { 
      0,   3, 0,  
      0.5, 3, 0,  
      1.2, 3, -230,  
    } );   

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide1", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.NumbersWinSet ()

    local table_multiset = {};

    table.insert( table_multiset, { "obj_superpuzzle4_mg_3_move",     { pos_y = -230 } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_3_crop",     { input = false } } );

    table.insert( table_multiset, { "obj_superpuzzle4_mg_4_crop",     { input = true } } );

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.NumbersResetSet ()

    local table_multiset = {};

    private.NumbersAllLightOff();

    private.numbers_win = false;
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].numbers_win = false;

    private.numbers_current_list = { 4, 1, 2, 3 };
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].numbers_current_list = { 4, 1, 2, 3 };

    private.numbers_prev_number = 0;

    for i = 1, #private.numbers_current_list do
          
      local number = private.numbers_current_list[ i ];
      local pos_x  = private.numbers_pos[ i ][ 1 ];
      local pos_y  = private.numbers_pos[ i ][ 2 ];
      table.insert( table_multiset, { "spr_superpuzzle4_mg_3_bone_"..number, { pos_x = pos_x, pos_y = pos_y } } );

    end;

    table.insert( table_multiset, { "obj_superpuzzle4_mg_3_move",     { pos_y = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_3_crop",     { input = false } } );

    table.insert( table_multiset, { "obj_superpuzzle4_mg_4_crop",     { input = false } } );

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
-- function *** Mmg Tubes ***() end
--*********************************************************************************************************************
  function private.TubesClk ( pos_i, pos_j )

    local obj_name = "spr_superpuzzle4_mg_4_piece_"..pos_i.."_"..pos_j;

    local number_ang = private.tubes_current_list[ pos_i ][ pos_j ];
    local number_ang_new = number_ang + 1;
    local anm_ang = ( number_ang_new - 1 ) * math.pi / 2;

    local old_ang = ( number_ang - 1 ) * math.pi / 2;

    if ( number_ang_new > 4 ) then

      number_ang_new = 1;

    end;

    local new_ang = ( number_ang_new - 1 ) * math.pi / 2;

    local func_end = function ()

      cmn.Lock( false );

      private.TubesClkEnd( pos_i, pos_j, number_ang_new );

    end;

    cmn.Lock( true );

    ObjAnimate( obj_name, "ang", 0, 0, func_end, 
    { 
      0,   3, old_ang, 
      0.2, 3, anm_ang,
      0.2, 3, new_ang,
    } );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_click2", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.TubesClkEnd ( pos_i, pos_j, number_ang )
    
    private.tubes_current_list[ pos_i ][ pos_j ] = number_ang;

    local flag_win = true;

    for i = 1, #private.tubes_current_list do
    
      for j = 1, #private.tubes_current_list[ i ] do
          
        local win_state = private.tubes_win_list[ i ][ j ];
        local cur_state = private.tubes_current_list[ i ][ j ];

        if ( win_state == 1 and cur_state ~= 1 ) or
           ( win_state == 2 and cur_state ~= 1 and cur_state ~= 3 ) then

          flag_win = false;

        end;

      end;
    
    end;

    if ( flag_win ) then

      private.TubesWinAnim();

    else

      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].tubes_current_list[ pos_i ][ pos_j ] = number_ang;

    end;

  end;
  --*********************************************************************************************************************
  function private.TubesWinAnim ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );

      private.tubes_win = true;

      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].tubes_win = true;

      private.TubesWinSet();

    end;

    ObjAnimate( "spr_superpuzzle4_mg_4_green_2", "alp", 0, 0, func_end, { 0,3,0,  0.4,3,1 } );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_button4", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.TubesWinSet ()

    ObjSet( "obj_superpuzzle4_mg_4_pieces",    { input = false } );
    ObjSet( "obj_superpuzzle4_mg_4_clk_lever", { input = true } );
      
  end;
  --*********************************************************************************************************************
  function private.TubesResetSet ()

    private.tubes_current_list = { 
      { 2,  1,  3,  4 }, 
      { 2,  3,  3,  1 }, 
      { 3,  1,  2,  3 },
      { 4,  3,  1,  4 },
    };

    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].tubes_current_list = { 
      { 2,  1,  3,  4 }, 
      { 2,  3,  3,  1 }, 
      { 3,  1,  2,  3 },
      { 4,  3,  1,  4 },
    };

    private.tubes_win = false;

    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].tubes_win = false; 

    ObjSet( "obj_superpuzzle4_mg_4_pieces",    { input = true } );
    ObjSet( "obj_superpuzzle4_mg_4_clk_lever", { input = false } );

    for i = 1, #private.tubes_current_list do
    
      for j = 1, #private.tubes_current_list[ i ] do
          
        local ang = ( private.tubes_current_list[ i ][ j ] - 1 ) * math.pi / 2;
      
        ObjSet( "spr_superpuzzle4_mg_4_piece_"..i.."_"..j, { ang = ang } );

      end;
    
    end;

  end;
--*********************************************************************************************************************
--  function *** Mmg Lamps ***() end
--*********************************************************************************************************************
  function private.LampsClk ( number )

    local cur_name = "spr_superpuzzle4_mg_6_lamp_"..number;

    if ( private.lamps_prev_number == 0 ) then

      ObjSet( cur_name.."_light", { alp = 1 } );

      private.lamps_prev_number = number;

    elseif ( private.lamps_prev_number == number ) then

      ObjSet( cur_name.."_light", { alp = 0 } );

      private.lamps_prev_number = 0;

    else

      common_impl.Lock( true );

      local prev_name = "spr_superpuzzle4_mg_6_lamp_"..private.lamps_prev_number;

      local func_end = function ()

        common_impl.Lock( false );

        private.LampsClkEnd( number, private.lamps_prev_number );

        private.lamps_prev_number = 0;

      end;
  
      local index = private.LampsGetPosToArray( number );

      local old_params = ObjGet( prev_name );
      local new_params = ObjGet( cur_name );
      
      ObjSet( prev_name.."_light", { alp = 0 } );

      ObjAnimate( prev_name, "pos_xy", 0, 0, "", 
      { 
        0,   3,  old_params.pos_x,  old_params.pos_y,
        0.2, 3,  old_params.pos_x,  old_params.pos_y,  
        0.2, 3,  new_params.pos_x,  new_params.pos_y
      } );

      ObjAnimate( cur_name, "pos_xy", 0, 0, "", 
      { 
        0,   3,  new_params.pos_x,  new_params.pos_y,  
        0.2, 3,  new_params.pos_x,  new_params.pos_y,  
        0.2, 3,  old_params.pos_x,  old_params.pos_y
      } );

      ObjAnimate( prev_name, "alp", 0, 0, func_end, 
      { 
        0,   3,  1,
        0.2, 3,  0,  
        0.4, 3,  1
      } );

      ObjAnimate( cur_name, "alp", 0, 0, "", 
      { 
        0,   3,  1,  
        0.2, 3,  0,  
        0.4, 3,  1
      } );

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk4", 0, "", 0 );

    end;  

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_menter1", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.LampsGetPosToArray ( number )

    for i = 1, #private.lamps_current_list do
    
      if ( private.lamps_current_list[ i ] == number ) then

        return i;

      end;
  
    end;

  end;
  --*********************************************************************************************************************
  function private.LampsAllLightOff ()

    for i = 1, #private.lamps_current_list do
    
      ObjSet( "spr_superpuzzle4_mg_6_lamp_"..i.."_light", { alp = 0 } );
  
    end;

  end;
  --*********************************************************************************************************************
  function private.LampsClkEnd ( number, prev_number )

    local index      = private.LampsGetPosToArray( number );
    local prev_index = private.LampsGetPosToArray( prev_number );

    private.lamps_current_list[ index ], private.lamps_current_list[ prev_index ] = 
    private.lamps_current_list[ prev_index ], private.lamps_current_list[ index ];
    
    local flag_win = true;

    for i = 1, #private.lamps_win_list do
      
      if ( private.lamps_current_list[ i ] ~= private.lamps_win_list[ i ] ) then

        flag_win = false;
        break;

      end;

    end;

    if ( flag_win ) then

      private.LampsWinAnim();

    else

      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].lamps_current_list[ index ] = private.lamps_current_list[ index ];
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].lamps_current_list[ prev_index ] = private.lamps_current_list[ prev_index ];

    end;

  end;
  --*********************************************************************************************************************
  function private.LampsWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.lamps_win = true;
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].lamps_win = true;

      private.LampsWinSet();

    end;

    ObjAnimate( "obj_superpuzzle4_mg_4_pieces", "pos_y", 0, 0, func_end, 
    { 
      0,   3, 0,  
      0.4, 3, 0,  
      0.8, 3, -220
    } );   

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide1", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.LampsWinSet ()

    local table_multiset = {};

    table.insert( table_multiset, { "obj_superpuzzle4_mg_4_pieces",   { pos_y = -220 } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_6_lamps",    { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_4_keys",     { input = true } } );

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.LampsResetSet ()

    local table_multiset = {};

    private.LampsAllLightOff();

    private.lamps_win = false;
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].lamps_win = false;

    private.lamps_current_list = { 3, 2, 1, 5, 6, 4 };
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].lamps_current_list = { 3, 2, 1, 5, 6, 4 };

    private.lamps_prev_number = 0;

    for i = 1, #private.lamps_current_list do
          
      local number = private.lamps_current_list[ i ];
      local pos_x  = private.lamps_pos[ i ][ 1 ];
      local pos_y  = private.lamps_pos[ i ][ 2 ];
      table.insert( table_multiset, { "spr_superpuzzle4_mg_6_lamp_"..number, { pos_x = pos_x, pos_y = pos_y } } );

    end;

    table.insert( table_multiset, { "obj_superpuzzle4_mg_4_pieces",   { pos_y = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_4_keys",     { input = false } } );


    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
--  function *** Mmg Brick ***() end
--*********************************************************************************************************************
  function private.BrickClk ( number, offset_i, offset_j )

    local obj_name = "spr_superpuzzle4_mg_8_brick_"..number;

    local index = private.BrickGetPosToArray( number );

    local pos_move = private.BrickCheckMove( index, offset_i, offset_j );

    if ( pos_move ) then

      local params = ObjGet( obj_name );

      local new_x  = private.brick_pos_begin[ 1 ] + ( index[ 1 ] + offset_i ) * private.brick_pos_step;
      local new_y  = private.brick_pos_begin[ 2 ] + ( index[ 2 ] + offset_j ) * private.brick_pos_step;

      local func_end = function ()

        common_impl.Lock( false );

        private.BrickClkEnd( number, offset_i, offset_j );

      end;
  
      common_impl.Lock( true );

      ObjAnimate( obj_name, "pos_xy", 0, 0, func_end, 
      { 
        0,   3,  params.pos_x,  params.pos_y,
        0.1, 3,  new_x,         new_y
      } );

    end;

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_click2", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.BrickGetPosToArray ( number )

    for j = 1, #private.brick_current_list do
    
      for i = 1, #private.brick_current_list[ j ] do
      
        if ( private.brick_current_list[ j ][ i ] == number ) then

          return { i, j };

        end;
    
      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.BrickGetAllPosToArray ( number )

    local list = {};

    for j = 1, #private.brick_current_list do
    
      for i = 1, #private.brick_current_list[ j ] do
      
        if ( private.brick_current_list[ j ][ i ] == number ) then

          table.insert( list, { i, j } );

        end;
    
      end;

    end;

    return list;

  end;
  --*********************************************************************************************************************
  function private.BrickCheckMove ( index, offset_i, offset_j )

    local i_cur = index[ 1 ] + offset_i;
    local j_cur = index[ 2 ] + offset_j;

    if ( i_cur > 0 ) and ( i_cur <= #private.brick_current_list[ 1 ] ) and 
       ( j_cur > 0 ) and ( j_cur <= #private.brick_current_list ) then

      if ( private.brick_current_list[ j_cur ][ i_cur ] == 0 ) then

        return true

      elseif ( private.brick_current_list[ j_cur ][ i_cur ] == private.brick_current_list[ index[ 2 ] ][ index[ 1 ] ] ) then

        return private.BrickCheckMove( { i_cur, j_cur }, offset_i, offset_j )

      end;

    end;

    return false;

  end;
  --*********************************************************************************************************************
  function private.BrickChangeSet ( number, offset_i, offset_j )

    local indexs = private.BrickGetAllPosToArray( number );

    local point_begin = 1;
    local point_end = #indexs;
    local dir = 1;

    if ( offset_i > 0 ) or ( offset_j > 0 ) then

      point_begin = #indexs;
      point_end = 1;
      dir = -1;

    end;

    for i = point_begin, point_end, dir do
  
      local i_cur = indexs[ i ][ 1 ] + offset_i;
      local j_cur = indexs[ i ][ 2 ] + offset_j;
  
      private.brick_current_list[ indexs[ i ][ 2 ] ][ indexs[ i ][ 1 ] ] = 0; 
      private.brick_current_list[ j_cur ][ i_cur ] = number;

    end;

  end;
  --*********************************************************************************************************************
  function private.BrickClkEnd ( number, offset_i, offset_j )

    private.BrickChangeSet( number, offset_i, offset_j );

--    local jhgjfjg = "";
--
--    for i = 1, #private.brick_current_list do
--    
--      for j = 1, #private.brick_current_list[ i ] do
--      
--        jhgjfjg = jhgjfjg..", "..private.brick_current_list[ i ][ j ];
--    
--      end;
--
--      DbgTrace(jhgjfjg);
--      jhgjfjg = ""
--
--    end;

    local win_pos = private.brick_win_list;
    local win_number = private.brick_win_number;

    if ( private.brick_current_list[ win_pos[ 1 ] ][ win_pos[ 2 ] ] == win_number ) then

      private.BrickWinAnim();

    else

      for i = 1, #private.brick_current_list do
      
        for j = 1, #private.brick_current_list[ i ] do
        
          ng_global.progress[ "ext" ][ "win_superpuzzle4" ].brick_current_list[ i ][ j ] = private.brick_current_list[ i ][ j ];
      
        end;

      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.BrickWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.brick_win = true;
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].brick_win = true;

      private.BrickWinSet();

    end;

    local func_audio = function ()

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide1", 0, "", 0 );
      
    end;

    ObjAnimate( "spr_superpuzzle4_mg_8_brick_9", "pos_x", 0, 0, func_audio, 
    { 
      0,   3, 198,  
      0.6, 3, 280,
    } );   

    ObjAnimate( "spr_superpuzzle4_mg_8_door", "pos_y", 0, 0, func_end, 
    { 
      0,   3, 60,  
      0.6, 3, 60,  
      1.2, 3, -170,
    } );   

  end;
  --*********************************************************************************************************************
  function private.BrickWinSet ()

    local table_multiset = {};

    table.insert( table_multiset, { "spr_superpuzzle4_mg_8_brick_9",    { pos_x = 280 } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_8_door",       { pos_y = -170 } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_8_bricks",     { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_8_circle_get", { input = true } } );

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.BrickResetSet ()

    local table_multiset = {};

    private.brick_win = false;
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].brick_win = false;

    private.brick_current_list = { 
      { 1,  10, 10, 10, 12, 2, 0 }, 
      { 1,  0,  3,  0,  12, 2, 0 }, 
      { 9,  9,  3,  0,  12, 4, 5 }, 
      { 0,  6,  11, 11, 11, 4, 5 }, 
      { 7,  6,  0,  8,  0,  0, 0 }, 
      { 7,  0,  0,  8,  0,  0, 0 }
    };

    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].brick_current_list = { 
      { 1,  10, 10, 10, 12, 2, 0 }, 
      { 1,  0,  3,  0,  12, 2, 0 }, 
      { 9,  9,  3,  0,  12, 4, 5 }, 
      { 0,  6,  11, 11, 11, 4, 5 }, 
      { 7,  6,  0,  8,  0,  0, 0 }, 
      { 7,  0,  0,  8,  0,  0, 0 }
    };

    for i = 1, #private.brick_horizon do
          
      local index = private.BrickGetPosToArray( i );

      local pos_x  = private.brick_pos_begin[ 1 ] + ( index[ 1 ] * private.brick_pos_step );
      local pos_y  = private.brick_pos_begin[ 2 ] + ( index[ 2 ] * private.brick_pos_step );

      table.insert( table_multiset, { "spr_superpuzzle4_mg_8_brick_"..i, { 
        pos_x = pos_x, 
        pos_y = pos_y
      } } );

    end;

    table.insert( table_multiset, { "obj_superpuzzle4_mg_8_bricks",     { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_8_door",       { pos_y = 60 } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_8_circle_get", { input = false } } );

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
--  function *** Mmg Circles ***() end
--*********************************************************************************************************************
  function private.CirclesClk ( number )

    local cur_name = "spr_superpuzzle4_mg_5_circle_"..number;

    if ( private.circles_prev_number == 0 ) then

      ObjSet( cur_name.."_light", { alp = 1 } );

      private.circles_prev_number = number;

    elseif ( private.circles_prev_number == number ) then

      ObjSet( cur_name.."_light", { alp = 0 } );

      private.circles_prev_number = 0;

    else

      common_impl.Lock( true );

      local prev_name = "spr_superpuzzle4_mg_5_circle_"..private.circles_prev_number;

      local func_end = function ()

        common_impl.Lock( false );

        private.CirclesClkEnd( number, private.circles_prev_number );

        private.circles_prev_number = 0;

      end;
  
      local index = private.CirclesGetPosToArray( number );

      local old_params = ObjGet( prev_name );
      local new_params = ObjGet( cur_name );
      
      ObjSet( prev_name.."_light", { alp = 0 } );

      ObjAnimate( prev_name, "pos_xy", 0, 0, func_end, 
      { 
        0,   3,  old_params.pos_x,  old_params.pos_y,  
        0.4, 3,  new_params.pos_x,  new_params.pos_y
      } );

      ObjAnimate( cur_name, "pos_xy", 0, 0, "", 
      { 
        0,   3,  new_params.pos_x,  new_params.pos_y,  
        0.4, 3,  old_params.pos_x,  old_params.pos_y
      } );

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk4", 0, "", 0 );

    end;  

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_menter1", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.CirclesGetPosToArray ( number )

    for i = 1, #private.circles_current_list do
    
      if ( private.circles_current_list[ i ] == number ) then

        return i;

      end;
  
    end;

  end;
  --*********************************************************************************************************************
  function private.CirclesAllLightOff ()

    for i = 1, #private.circles_current_list do
    
      ObjSet( "spr_superpuzzle4_mg_5_circle_"..i.."_light", { alp = 0 } );
  
    end;

  end;
  --*********************************************************************************************************************
  function private.CirclesClkEnd ( number, prev_number )

    local index      = private.CirclesGetPosToArray( number );
    local prev_index = private.CirclesGetPosToArray( prev_number );

    private.circles_current_list[ index ], private.circles_current_list[ prev_index ] = 
    private.circles_current_list[ prev_index ], private.circles_current_list[ index ];
    
    local flag_win = true;

    for i = 1, #private.circles_win_list do
      
      if ( private.circles_current_list[ i ] ~= private.circles_win_list[ i ] ) then

        flag_win = false;
        break;

      end;

    end;

    if ( flag_win ) then

      private.CirclesWinAnim();

    else

      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].circles_current_list[ index ] = private.circles_current_list[ index ];
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].circles_current_list[ prev_index ] = private.circles_current_list[ prev_index ];

    end;

  end;
  --*********************************************************************************************************************
  function private.CirclesWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.circles_win = true;
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].circles_win = true;

      private.CirclesWinSet();

    end;

    ObjAnimate( "obj_superpuzzle4_mg_5_move", "pos_x", 0, 0, func_end, 
    { 
      0,   3, 0,  
      0.5, 3, 300
    } );   

    ObjSet( "spr_superpuzzle4_mg_5_switch_get", { alp = 1 } );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide1", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.CirclesWinSet ()

    local table_multiset = {};

    table.insert( table_multiset, { "obj_superpuzzle4_mg_5_move",        { pos_x = 300 } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_5_circles",     { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_5_switch_get",  { alp = 1, input = true } } );

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.CirclesResetSet ()

    local table_multiset = {};

    private.CirclesAllLightOff();

    private.circles_win = false;
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].circles_win = false;

    private.circles_current_list = { 5, 4, 1, 2, 3 };
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].circles_current_list = { 5, 4, 1, 2, 3 };

    private.circles_prev_number = 0;

    for i = 1, #private.circles_current_list do
          
      local number = private.circles_current_list[ i ];
      local pos_x  = private.circles_pos[ i ][ 1 ];
      local pos_y  = private.circles_pos[ i ][ 2 ];
      table.insert( table_multiset, { "spr_superpuzzle4_mg_5_circle_"..number, { pos_x = pos_x, pos_y = pos_y } } );

    end;

    table.insert( table_multiset, { "obj_superpuzzle4_mg_5_circles",     { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_5_switch_get",  { alp = 0, input = false } } );

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
--  function *** Mmg Switches ***() end
--*********************************************************************************************************************
  function private.SwitchesClk ( number )

    cmn.Lock( true );

    local obj_name = "spr_superpuzzle4_mg_9_switch_";
    local obj_tv_name = "spr_superpuzzle4_mg_9_tv_";

    local old_state = private.switches_current_list[ number ];
    local old_ang = 0.8 * ( old_state - 2 );

    local new_state = old_state - 1;

    if ( new_state < 1 ) then

      new_state = 3;

    end;

    local new_ang = 0.8 * ( new_state - 2 );

    local old_alp = private.switches_alp[ number ][ old_state ];
    local new_alp = private.switches_alp[ number ][ new_state ];

    local func_end = function ()

      cmn.Lock( false );

      private.SwitchesClkEnd( number, new_state );

    end;
  
    ObjAnimate( obj_name..number, "ang", 0, 0, "", 
    { 
      0,   3,  old_ang,  
      0.4, 3,  new_ang 
    } );

    ObjAnimate( obj_tv_name..number, "alp", 0, 0, func_end, 
    { 
      0,   3,  old_alp,   
      0.4, 3,  new_alp 
    } );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_click2", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.SwitchesClkEnd ( number, new_state )

    private.switches_current_list[ number ] = new_state;
    
    local flag_win = true;

    for i = 1, #private.switches_current_list do
      
      if ( private.switches_current_list[ i ] ~= private.switches_win_list[ i ] ) then

        flag_win = false;
        break;

      end;

    end;

    if ( flag_win ) then

      private.SwitchesWinAnim();

    else

      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].switches_current_list[ number ] = new_state;

    end;

  end;
  --*********************************************************************************************************************
  function private.SwitchesWinAnim ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );

      private.switches_win = true;

      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].switches_win = true;

      private.SwitchesWinSet();

    end;

    ObjAnimate( "spr_superpuzzle4_mg_9_back_1", "alp", 0, 0, func_end, { 0,3,0,  0.4,3,1 } );
    ObjAnimate( "spr_superpuzzle4_mg_9_back_2", "alp", 0, 0, "", { 0,3,0,  0.4,3,1 } );

    --common_impl.PlayAudio( "sfx", "levelext/sfx/aud_mg_superpuzzle4_clk9", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.SwitchesWinSet ()

    private.switches_current_list = { 3, 1 };

    local table_multiset = {};

    table.insert( table_multiset, { "obj_superpuzzle4_mg_9_switches", { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_9_symbols",  { input = true } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_9_back_1",   { alp = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_9_back_2",   { alp = 1 } } );

    for i = 1, #private.switches_current_list do
        
      local ang = 0.8 * ( private.switches_current_list[ i ] - 2 );

      table.insert( table_multiset, { "spr_superpuzzle4_mg_9_switch_"..i, { ang = ang } } );
      table.insert( table_multiset, { "spr_superpuzzle4_mg_9_tv_"..i, { alp = 0 } } );

    end;

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.SwitchesResetSet ()

    private.switches_current_list = { 1, 3 };
    private.switches_win = false;

    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].switches_current_list = { 1, 3 };
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].switches_win = false;

    local table_multiset = {};

    table.insert( table_multiset, { "spr_superpuzzle4_mg_9_back_1",   { alp = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle4_mg_9_back_2",   { alp = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_9_switches", { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_9_symbols",  { input = false } } );

    for i = 1, #private.switches_current_list do
        
      local ang = 0.8 * ( private.switches_current_list[ i ] - 2 );

      table.insert( table_multiset, { "spr_superpuzzle4_mg_9_switch_"..i, { ang = ang } } );
      table.insert( table_multiset, { "spr_superpuzzle4_mg_9_tv_"..i, { alp = 0 } } );

    end;

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
-- function *** Mmg Squares ***() end
--*********************************************************************************************************************
  function private.SquaresClk ( number )

    common_impl.Lock( true );

    local func_unlock = function ()

      common_impl.Lock( false );

    end;

    local obj_name  = "spr_superpuzzle4_mg_9_couple_"..number;

    local prev_number = private.squares_prev_number;

    if ( private.squares_prev_number == number ) then

      ObjAnimate( obj_name, "alp", 0, 0, func_unlock, { 0,3,1, 0.2,3,0 } );

      private.squares_prev_number = "";

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_button4", 0, "", 0 );

    elseif ( private.squares_prev_number ~= "" ) then

      local obj_name_prev = "spr_superpuzzle4_mg_9_couple_"..private.squares_prev_number;

      if ( private.squares_list[ number ] == private.squares_list[ private.squares_prev_number ] ) then

        ObjSet( obj_name,      { input = false } );
        ObjSet( obj_name_prev, { input = false } );

        local func_anim_end = function ()

          common_impl.Lock( false );

          private.SquaresCheck( number, prev_number );

        end;

        ObjAnimate( obj_name,  "alp", 0, 0, func_anim_end, { 0,3,0,  0.2,3,1 } );

        common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_button4", 0, "", 0 );

      else

        ObjAnimate( obj_name,       "alp", 0, 0, func_unlock, { 0,3,0,  0.2,3,1,  0.8,3,1,  1.0,3,0 } );
        ObjAnimate( obj_name_prev,  "alp", 0, 0, "", { 0,3,1,  0.8,3,1,  1.0,3,0  } );

        common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

      end;

      private.squares_prev_number = "";

    else

      ObjAnimate( obj_name, "alp", 0, 0, func_unlock, { 0,3,0,  0.2,3,1, } );

      private.squares_prev_number = number;

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_button4", 0, "", 0 );

    end;

  end;
  --*********************************************************************************************************************
  function private.SquaresCheck ( number, prev_number )

    private.squares_current_list[ number ]      = true;
    private.squares_current_list[ prev_number ] = true;

    local flag_win = true;
    
    for i = 1, #private.squares_current_list do
      
      if ( not private.squares_current_list[ i ] ) then

        flag_win = false;
        break;

      end

    end;

    if ( flag_win ) then

      private.SquaresWinAnim();

    else

      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].squares_current_list[ number ]      = true;
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].squares_current_list[ prev_number ] = true;

    end;

  end;
  --*********************************************************************************************************************
  function private.SquaresWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.squares_win = true;
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].squares_win = true;

      private.SquaresWinSet();

    end;

    ObjAnimate( "obj_superpuzzle4_mg_9_pictures", "alp", 0, 0, "", { 0,3,0,  0.6,3,1  } );
    ObjAnimate( "obj_superpuzzle4_mg_9_symbols",  "alp", 0, 0, func_end, { 0,3,1,  0.6,3,0  } );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_whoosh", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.SquaresWinSet ()

    local table_multiset = {};

    for i = 1,#private.squares_list do
      
      private.squares_current_list[ i ] = true;

    end;

    table.insert( table_multiset, { "obj_superpuzzle4_mg_9_pictures", { input = true,  alp = 1 } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_9_symbols",  { input = false, alp = 0 } } );

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.SquaresResetSet ()

    local table_multiset = {};

    for i = 1,#private.squares_list do
      
      private.squares_current_list[ i ] = false;

    end;


    for i = 1,#private.squares_list do
      
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].squares_current_list[ i ] = false;

    end;

    private.squares_win = false;                  
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].squares_win = false;

    private.squares_prev_number = "";
    
    table.insert( table_multiset, { "obj_superpuzzle4_mg_9_pictures", { input = false, alp = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_9_symbols",  { input = false, alp = 0 } } );

    for i = 1, #private.squares_current_list do
        
      table.insert( table_multiset, { "spr_superpuzzle4_mg_9_couple_"..i, { input = true, alp = 0 } } );

    end;

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
--  function *** Mmg Pictures ***() end
--*********************************************************************************************************************
  function private.PicturesClk ( number )

    local cur_name = "spr_superpuzzle4_mg_9_picture_"..number;

    if ( private.pictures_prev_number == 0 ) then

      ObjSet( cur_name.."_light", { alp = 1 } );

      private.pictures_prev_number = number;

    elseif ( private.pictures_prev_number == number ) then

      ObjSet( cur_name.."_light", { alp = 0 } );

      private.pictures_prev_number = 0;

    else

      common_impl.Lock( true );

      local prev_name = "spr_superpuzzle4_mg_9_picture_"..private.pictures_prev_number;

      local func_end = function ()

        common_impl.Lock( false );

        private.PicturesClkEnd( number, private.pictures_prev_number );

        private.pictures_prev_number = 0;

      end;
  
      local index = private.PicturesGetPosToArray( number );

      local old_params = ObjGet( prev_name );
      local new_params = ObjGet( cur_name );
      
      ObjSet( prev_name.."_light", { alp = 0 } );

      ObjAnimate( prev_name, "pos_xy", 0, 0, func_end, 
      { 
        0,   3,  old_params.pos_x,  old_params.pos_y,  
        0.4, 3,  new_params.pos_x,  new_params.pos_y
      } );

      ObjAnimate( cur_name, "pos_xy", 0, 0, "", 
      { 
        0,   3,  new_params.pos_x,  new_params.pos_y,  
        0.4, 3,  old_params.pos_x,  old_params.pos_y
      } );

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk1", 0, "", 0 );

    end;  

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_menter1", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.PicturesGetPosToArray ( number )

    for i = 1, #private.pictures_current_list do
    
      if ( private.pictures_current_list[ i ] == number ) then

        return i;

      end;
  
    end;

  end;
  --*********************************************************************************************************************
  function private.PicturesAllLightOff ()

    for i = 1, #private.pictures_current_list do
    
      ObjSet( "spr_superpuzzle4_mg_9_picture_"..i.."_light", { alp = 0 } );
  
    end;

  end;
  --*********************************************************************************************************************
  function private.PicturesClkEnd ( number, prev_number )

    local index      = private.PicturesGetPosToArray( number );
    local prev_index = private.PicturesGetPosToArray( prev_number );

    private.pictures_current_list[ index ], private.pictures_current_list[ prev_index ] = 
    private.pictures_current_list[ prev_index ], private.pictures_current_list[ index ];
    
    local flag_win = true;

    for i = 1, #private.pictures_win_list do
      
      if ( private.pictures_current_list[ i ] ~= private.pictures_win_list[ i ] ) then

        flag_win = false;
        break;

      end;

    end;

    if ( flag_win ) then

      private.PicturesWinAnim();

    else

      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].pictures_current_list[ index ] = private.pictures_current_list[ index ];
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].pictures_current_list[ prev_index ] = private.pictures_current_list[ prev_index ];

    end;

  end;
  --*********************************************************************************************************************
  function private.PicturesWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.pictures_win = true;
      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].pictures_win = true;

      private.PicturesWinSet();

      private.TrianglesShow();

    end;

    ObjAnimate( "spr_superpuzzle4_mg_10_door", "pos_y", 0, 0, func_end, 
    { 
      0,   3, 0,  
      0.5, 3, -180
    } );   

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide1", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.PicturesWinSet ()

    local table_multiset = {};

    table.insert( table_multiset, { "spr_superpuzzle4_mg_10_door",       { pos_y = -180 } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_10_buttons",    { input = true } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_9_pictures",    { input = false } } );

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.PicturesResetSet ()

    local table_multiset = {};

    private.PicturesAllLightOff();

    private.pictures_win = false;
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].pictures_win = false;

    private.pictures_current_list = { 9, 6, 5, 12, 4, 7, 1, 2, 8, 3, 10, 11 };
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].pictures_current_list = { 9, 6, 5, 12, 4, 7, 1, 2, 8, 3, 10, 11 };

    private.pictures_prev_number = 0;

    for i = 1, #private.pictures_current_list do
          
      local number = private.pictures_current_list[ i ];
      local pos_x  = private.pictures_pos[ i ][ 1 ];
      local pos_y  = private.pictures_pos[ i ][ 2 ];
      table.insert( table_multiset, { "spr_superpuzzle4_mg_9_picture_"..number, { pos_x = pos_x, pos_y = pos_y } } );

    end;

    table.insert( table_multiset, { "spr_superpuzzle4_mg_10_door",       { pos_y = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_10_buttons",    { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle4_mg_9_pictures",    { input = false } } );

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
--  function *** Mmg Triangles ***() end
--*********************************************************************************************************************
  function private.TrianglesClk ( number )

    local obj_name_green = "spr_superpuzzle4_mg_10_green_";
    local obj_name_red = "spr_superpuzzle4_mg_10_red_";

    local right_number = private.triangles_win_list[ private.triangles_current_state ][ private.triangles_index ];

    local func_end = function ()

      cmn.Lock( false );

      private.TrianglesClkEnd( number );

    end;

    cmn.Lock( true );

    if ( right_number == number ) then

      ObjAnimate( obj_name_green..number, "alp", 0, 0, func_end, 
      { 
        0,   3, 0,  
        0.2, 3, 1,
        0.4, 3, 1,
        0.6, 3, 0
      } );

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_button4", 0, "", 0 );

    else

      ObjAnimate( obj_name_red.."1", "alp", 0, 0, "", 
      { 
        0,   3, 0,  
        0.3, 3, 1,
        0.6, 3, 0,
        0.9, 3, 1,
        1.2, 3, 0,
        1.5, 3, 0
      } );

      ObjAnimate( obj_name_red.."2", "alp", 0, 0, func_end, 
      { 
        0,   3, 0,  
        0.3, 3, 1,
        0.6, 3, 0,
        0.9, 3, 1,
        1.2, 3, 0,
        1.5, 3, 0
      } );

      common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

    end;

  end;
  --*********************************************************************************************************************
  function private.TrianglesClkEnd ( number )

    local right_number = private.triangles_win_list[ private.triangles_current_state ][ private.triangles_index ];

    if ( right_number == number ) then

      if ( private.triangles_index == #private.triangles_win_list[ private.triangles_current_state ] ) then

        local func_end = function ()

          cmn.Lock( false );

          private.TrianglesShow();

        end;

        cmn.Lock( true );

        ObjAnimate( "spr_superpuzzle4_mg_10_button_green_"..private.triangles_current_state, "alp", 0, 0, func_end, { 
          0.0, 3, 0,  
          0.2, 3, 1,
          0.4, 3, 0,
          0.6, 3, 1,
        } );

        common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_lamp", 0, "", 0 );

        private.triangles_current_state = private.triangles_current_state + 1;

      else

        private.triangles_index = private.triangles_index + 1;

      end;

    else

      private.TrianglesShow();

    end;

    if ( private.triangles_current_state > #private.triangles_win_list ) then

      private.TrianglesWinAnim();

    else

      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].triangles_current_state = private.triangles_current_state;

    end;

  end;
--*********************************************************************************************************************
  function private.TrianglesShow ()

    private.triangles_index = 1;
    private.TrianglesOneAnimShow( 1 );

  end;
--*********************************************************************************************************************
  function private.TrianglesOneAnimShow ( index )

    local current_list = private.triangles_win_list[ private.triangles_current_state ];

    if ( index > #current_list ) then

      return;

    end;

    local obj_name = "spr_superpuzzle4_mg_10_green_";

    local cur_number = current_list[ index ];

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );

      private.TrianglesOneAnimShow( index + 1 );

    end;
  
    ObjAnimate( obj_name..cur_number, "alp", 0, 0, func_end, { 0,3,0,  0.2,3,1,  0.6,3,1,  0.8,3,0 } );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_button4", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.TrianglesWinAnim ()

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );

      private.triangles_win = true;

      ng_global.progress[ "ext" ][ "win_superpuzzle4" ].triangles_win = true;

      private.Win();

    end;

    ObjAnimate( "spr_superpuzzle4_mg_10_door", "pos_y", 0, 0, func_end, 
    { 
      0,   3, -180,  
      0.5, 3, 0
    } );   

    --common_impl.PlayAudio( "sfx", "levelext/sfx/aud_mg_superpuzzle4_clk9", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.TrianglesWinSet ()


  end;
  --*********************************************************************************************************************
  function private.TrianglesResetSet ()

    private.triangles_index = 1;
    private.triangles_current_state = 1;
    private.triangles_win = false;

    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].triangles_index = 1;
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].triangles_current_state = 1;
    ng_global.progress[ "ext" ][ "win_superpuzzle4" ].triangles_win = false;

    local table_multiset = {};

    for i = 1, 3 do
        
      table.insert( table_multiset, { "spr_superpuzzle4_mg_10_button_green_"..i, { alp = 0 } } );

    end;  

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
-- function *** Puszzle Hint ***() end
--*********************************************************************************************************************
  function private.PuszzleHintClk ()

    local postfix = private.GetHintPostfix();

    interface.DialogShow( "ifo_superpuzzle4_"..postfix );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_puzzle_hint", 0, "", 0 );

  end;
--*********************************************************************************************************************
  function private.PuszzleHintEnter ()

    common_impl.SetCursor( CURSOR_HAND );
    ObjSet( "spr_superpuzzle4_hint_1", { alp = 1 } );

  end;
--*********************************************************************************************************************
  function private.PuszzleHintLeave ()

    common_impl.SetCursor( CURSOR_DEFAULT );
    ObjSet( "spr_superpuzzle4_hint_1", { alp = 0 } );

  end;
--*********************************************************************************************************************
  function private.GetHintPostfix ()

    local postfix;

    if     ( not private.arrowsright_win )   then postfix = "1";
    elseif ( not private.gears_win )         then postfix = "2";
    elseif ( not private.numbers_win )       then postfix = "3";
    elseif ( not private.tubes_win )         then postfix = "4";
    elseif ( not private.lamps_win )         then postfix = "5";
    elseif ( not private.circles_win )       then postfix = "6";
    elseif ( not private.switches_win )      then postfix = "7";
    elseif ( not private.squares_win )       then postfix = "8";
    elseif ( not private.pictures_win )      then postfix = "9";
    elseif ( not private.triangles_win )     then postfix = "10";
    end;

    return postfix;

  end;
--*********************************************************************************************************************
-- function *** Animations *** ()
--*********************************************************************************************************************
  function private.Animations ()

    ObjAnimate( "spr_superpuzzle4_mg_2_gears_gold_1", "ang", 1, 0, "", { 0,0,0,  0.5,0,math.pi * 2 } );

  end;
--*********************************************************************************************************************