-- name=levelext

function public.Start ( param )

  interface.WidgetAdd( InterfaceWidget_Pause, 10000000 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 20 );

  if IsCollectorsEdition() then

    interface.WidgetAdd( InterfaceWidget_BtnGuide, 20 );

  end;

  interface.WidgetAdd( InterfaceWidget_BtnHint, 11  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 12 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 27 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 27 );

  --interface.WidgetAdd( InterfaceWidget_TaskHeader );
  interface.WidgetAdd( InterfaceWidget_Inventory, 9 );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 10 );

  interface.WidgetAdd( InterfaceWidget_Effects, 11 );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 11 );

  interface.WidgetAdd( InterfaceWidget_DialogHo, 19 );

  interface.ButtonLockAdd();
  interface.LockAdd();

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8);

  interface.WidgetAdd( InterfaceWidget_ItemPanel );
  interface.WidgetAdd( InterfaceWidget_Popup, 27 );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog, 26 );

  interface.WidgetAdd( InterfaceWidget_DialogVideo, 26 );
  interface.WidgetAdd( InterfaceWidget_DialogStory );
  interface.WidgetAdd( InterfaceWidget_DialogCharacter, 19 );

  interface.WidgetAdd( InterfaceWidget_StrategyGuide, 28 );
  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial );

  interface.WidgetAdd( InterfaceWidget_Map, 26  );

  interface.PanelNotificationAdd();
  interface.DeployInvAdd( 9 );
  interface.DialogHintAdd();
  interface.ButtonTaskAdd( 1 );
  interface.DialogTaskAdd( 20 );  
  interface.DiaryAdd( 28 );

  interface.SliderAdd( -1 );
  
  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    interface.BtnCollectibles2Add( 18 );
    interface.BtnCollectiblesAdd( 18 );
    interface.AchievementsAdd( 18 );
    interface.BtnMorphAdd( 18 );

  end;

  private.Init();
  ModLoad( "assets/levels/levelext/mod_levelext_inv" );
  levelext_inv.Init();

  common.LevelLoad( "levelext", "ext", "rm_apartment", param, private.menu_moduls );
  common_impl.Collectibles2Load();

  private.TutorialSetParams();
  interface.KeyUpdate();

end;
    
function private.Init ()

  game = {};
  game.room_names =
  {
  "rm_apartment"
  ,"rm_parkinglot"
  ,"rm_porch_ext"
  ,"rm_nearcafe"
  ,"rm_cafe"
  ,"rm_hall_ext"
  ,"rm_secondfloor_ext"
  ,"rm_terenceroom_ext"
  ,"rm_managerroom"
  ,"ho_itemscollecting"
  ,"ho_droppedtreecrown"
  ,"ho_barcounter"
  ,"mg_hoteldoor"
  ,"ho_bag"
  ,"mg_superpuzzle4"
  ,"mg_shelflock"
  ,"mg_forandagainst"
  };

  game.progress_names_room =
  {
  -- apartment
  { "opn_apartment" }
  ,{ "dlg_apartment_josh_fraser",             "rm_apartment",         { "opn_apartment" } }
  ,{ "get_pen",                               "rm_apartment",         { "dlg_apartment_josh_fraser" } }
  ,{ "get_officeaddress",                     "rm_apartment",         { "dlg_apartment_josh_fraser" } }
  ,{ "get_envelopeknife",                     "rm_apartment",         { "dlg_apartment_josh_fraser" } }
  ,{ "get_apartmentkey",                      "rm_apartment",         { "dlg_apartment_josh_fraser" } }
  ,{ "use_apartmentkey",                      "rm_apartment",         { "get_apartmentkey" } }
  ,{ "clk_apartment_key",                     "rm_apartment",         { "use_apartmentkey" } }
  -- parkinglot
  ,{ "opn_parkinglot" }
  ,{ "clk_postmankey",                        "rm_parkinglot",         { "opn_parkinglot" }  }
  ,{ "get_postmankey",                        "rm_parkinglot",         { "clk_postmankey" } }
  ,{ "use_postmankey",                        "rm_parkinglot",         { "get_postmankey" } }
  ,{ "clk_postmankey2",                       "rm_parkinglot",         { "use_postmankey" } }
  ,{ "get_letter",                            "rm_parkinglot",         { "clk_postmankey2" } }
  ,{ "use_envelopeknife"                                      }
  ,{ "clk_envelope"                                           }
  ,{ "clk_letter"                                             }
  ,{ "get_tobiasmessage",                                     }
  ,{ "get_tobiasamulet",                                      }
  ,{ "use_tobiasamulet",                      "rm_apartment",          { "get_tobiasamulet" }   }
  ,{ "get_lighter",                           "rm_apartment",          { "use_tobiasamulet" }  }
  ,{ "get_trinket",                           "rm_apartment",          { "use_tobiasamulet" }  }
  ,{ "get_can",                               "rm_apartment",          { "dlg_apartment_josh_fraser" }  }
  ,{ "clk_kitchen_switch",                    "rm_apartment",          { "get_can" }  }
  ,{ "use_lighter_1",                         "rm_apartment",          { "get_lighter", "clk_kitchen_switch" }  }
  ,{ "use_tobiasmessage",                     "rm_apartment",          { "use_lighter_1" }  }
  ,{ "get_code",                              "rm_apartment",          { "use_tobiasmessage" }  }
  ,{ "use_code",                              "rm_apartment",          { "get_code" }  }
  ,{ "win_safe",                              "rm_apartment",          { "use_code" }  }
  ,{ "get_externaldisk",                      "rm_apartment",          { "win_safe" }  }
  ,{ "use_externaldisk",                      "rm_parkinglot",          { "get_externaldisk" }  }
  ,{ "get_letter_t",                          "rm_parkinglot",          { "use_externaldisk" }  }
  ,{ "use_letter_t",                          "rm_parkinglot",          { "get_letter_t" }  }
  ,{ "clk_clip_1",                            "rm_parkinglot",          { "use_letter_t" }  }
  ,{ "clk_clip_2",                            "rm_parkinglot",          { "clk_clip_1" }  }
  ,{ "get_clip",                              "rm_parkinglot",          { "clk_clip_2" }  }
  ,{ "use_clip",                              "rm_apartment",          { "get_clip" }   }
  ,{ "get_firstaidkit",                       "rm_apartment",          { "use_clip" }   }
  ,{ "use_trinket" }
  ,{ "clk_firstaid_ring" }
  ,{ "clk_firstaid_trash" }
  ,{ "get_tweezers_ext" }
  ,{ "use_tweezers_ext",                      "rm_apartment",          { "get_tweezers_ext" }   }
  ,{ "get_patternelement",                    "rm_apartment",          { "use_tweezers_ext" }   }
  ,{ "clk_patternelement",                    "rm_apartment",          { "dlg_apartment_josh_fraser" }   }
  ,{ "use_patternelement",                    "rm_apartment",          { "get_patternelement", "clk_patternelement" }   }
  ,{ "opn_itemscollecting" }
  ,{ "win_itemscollecting",                   "rm_apartment",          { "use_patternelement" }  }
  ,{ "see_call_kane_1",                       "rm_apartment",          { "win_itemscollecting" }  }
  ,{ "dlg_apartment_david_kane_1",            "rm_apartment",          { "see_call_kane_1" }  }
  ,{ "clk_bag" }
  ,{ "clk_bag_knife" }
  ,{ "get_screwdriverknife" }
  ,{ "get_bag"          }
  ,{ "use_screwdriverknife",                  "rm_apartment",          { "get_screwdriverknife" }   }
  ,{ "clk_screwdriverknife",                  "rm_apartment",          { "use_screwdriverknife" }   }
  ,{ "clk_oilcan_ext",                        "rm_apartment",          { "clk_screwdriverknife" }   }
  ,{ "get_oilcan_ext",                        "rm_apartment",          { "clk_oilcan_ext" }   }
  ,{ "use_oilcan_ext_1",                      "rm_apartment",          { "get_oilcan_ext" }   }
  ,{ "get_holeyboot",                         "rm_apartment",          { "use_oilcan_ext_1" }   }
  ,{ "clk_holeyboot_1" }
  ,{ "clk_holeyboot_2" }
  ,{ "get_letter_i" }
  ,{ "use_letter_i",                          "rm_parkinglot",          { "get_letter_i" }  }
  ,{ "get_internaldisk",                      "rm_parkinglot",          { "use_letter_i" }  }
  ,{ "use_internaldisk",                      "rm_parkinglot",          { "get_internaldisk" }  }
  ,{ "get_foldumbrella",                      "rm_parkinglot",          { "use_internaldisk" }  }
  ,{ "use_foldumbrella",                      "rm_apartment",           { "get_foldumbrella" }   }
  ,{ "get_canopener",                         "rm_apartment",           { "use_foldumbrella" }   }
  ,{ "use_oilcan_ext_2",                      "rm_parkinglot",          { "get_oilcan_ext" }  }
  ,{ "clk_taxinumber",                        "rm_parkinglot",          { "use_oilcan_ext_2" }  }
  ,{ "get_taxinumber",                        "rm_parkinglot",          { "clk_taxinumber" }  }
  ,{ "use_taxinumber",                        "rm_apartment",           { "get_taxinumber" }   }
  ,{ "see_taxi",                              "rm_apartment",           { "use_taxinumber" }   }
  ,{ "use_canopener",                                         }
  ,{ "clk_can",                                               }
  ,{ "get_corn",                                               }
  ,{ "use_corn",                              "rm_parkinglot",           { "get_corn" }  }
  ,{ "get_coin_ext",                          "rm_parkinglot",           { "use_corn" }   }
  ,{ "use_coin_ext_1",                        "rm_parkinglot",           { "get_coin_ext" }   }
  ,{ "clk_lever_match_3",                     "rm_parkinglot",           { "use_coin_ext_1" }   }
  ,{ "win_match_3",                           "rm_parkinglot",           { "clk_lever_match_3" }   }
  ,{ "get_cash",                              "rm_parkinglot",           { "win_match_3" }   }
  ,{ "use_cash_1",                            "rm_parkinglot",           { "get_cash" }   }
  ,{ "use_officeaddress",                     "rm_parkinglot",           { "see_taxi" }   }
  -- porch_ext
  ,{ "opn_porch_ext" }
  ,{ "see_call_kane_2",                       "rm_porch",           { "opn_porch_ext" }  }
  ,{ "dlg_porch_ext_david_kane_2",            "rm_porch",           { "see_call_kane_2" }  }  
  ,{ "get_stone",                             "rm_porch",               { "dlg_porch_ext_david_kane_2" }  }
  ,{ "clk_stick_1",                           "rm_porch",           { "dlg_porch_ext_david_kane_2" }  }
  ,{ "clk_stick_2",                           "rm_porch",           { "clk_stick_1" }  }
  ,{ "get_stick",                             "rm_porch",           { "clk_stick_2" }  }
  ,{ "use_stone",                             "rm_porch",           { "get_stone" }  }
  ,{ "opn_droppedtreecrown",                  "rm_porch",           { "get_stone" }   }
  ,{ "win_droppedtreecrown",                  "rm_porch",           { "use_stone" }   }
  ,{ "clk_stick_peg"  }
  ,{ "get_peg",          }
  ,{ "use_peg",                               "rm_porch",           { "get_peg" }   }
  ,{ "clk_peg_1",                             "rm_porch",           { "use_peg" }   }
  ,{ "clk_peg_2",                             "rm_porch",           { "clk_peg_1" }   }
  ,{ "get_gumboots",                          "rm_porch",           { "clk_peg_2" }   }
  ,{ "use_gumboots",                          "rm_porch",           { "get_gumboots" }   }
  -- nearcafe
  ,{ "opn_nearcafe" }
  ,{ "get_wagonkey",                          "rm_nearcafe",           { "opn_nearcafe" }   }
  ,{ "use_wagonkey",                          "rm_nearcafe",           { "get_wagonkey" }   }
  ,{ "clk_wagonkey_1",                        "rm_nearcafe",           { "use_wagonkey" }   }
  ,{ "clk_wagonkey_2",                        "rm_nearcafe",           { "clk_wagonkey_1" }   }
  ,{ "get_rope_ext",                          "rm_nearcafe",           { "clk_wagonkey_2" }   }
  ,{ "use_drybranches",          }
  ,{ "use_rope_ext",          }
  ,{ "get_broom_ext",          }
  ,{ "use_broom_ext_1",                       "rm_nearcafe",           { "get_broom_ext" }   }
  ,{ "get_hacksawhandle",                     "rm_nearcafe",           { "use_broom_ext_1" }   }
  ,{ "use_hacksawhandle",                     "rm_nearcafe",           { "get_hacksawhandle" }   }
  ,{ "clk_hacksawhandle_1",                   "rm_nearcafe",           { "use_hacksawhandle" }   }
  ,{ "clk_hacksawhandle_2",                   "rm_nearcafe",           { "clk_hacksawhandle_1" }   }
  ,{ "get_hacksaw",                           "rm_nearcafe",           { "clk_hacksawhandle_2" }   }
  ,{ "use_hacksaw",                           "rm_porch",          { "get_hacksaw" }   }
  ,{ "get_ironpiece",                         "rm_porch",          { "use_hacksaw" }  }
  ,{ "use_ironpiece",                         "rm_porch",          { "get_ironpiece" }  }
  ,{ "get_sharpening",                        "rm_porch",          { "use_ironpiece" }  }
  ,{ "use_sharpening",                        "rm_nearcafe",           { "get_sharpening" }  }
  ,{ "get_frozenprecookedfood",               "rm_nearcafe",           { "use_sharpening" }  }
  ,{ "use_frozenprecookedfood",               "rm_nearcafe",           { "get_frozenprecookedfood" }  }
  ,{ "use_lighter_2",                         "rm_nearcafe",           { "opn_nearcafe" }  }
  ,{ "win_grill",                             "rm_nearcafe",           { "use_frozenprecookedfood", "use_lighter_2" } }
  ,{ "get_grilledmeat",                       "rm_nearcafe",           { "win_grill" }  }
  ,{ "use_grilledmeat",                       "rm_nearcafe",           { "get_grilledmeat" }  }
  -- cafe
  ,{ "opn_cafe" }
  ,{ "dlg_cafe_barman_1",                     "rm_cafe",           { "opn_cafe" } }
  ,{ "use_cash_2",                            "rm_cafe",           { "dlg_cafe_barman_1" }  }
  ,{ "clk_spoon",                             "rm_cafe",           { "use_cash_2" }  }
  ,{ "see_call_kane_3" }
  ,{ "dlg_cafe_david_kane_3",                 "rm_cafe",           { "clk_spoon" } }
  ,{ "use_pen_3",                             "rm_cafe",           { "dlg_cafe_david_kane_3" }  }
  ,{ "get_tableplacing",                      "rm_cafe",           { "use_pen_3" }  }
  ,{ "use_tableplacing",                      "rm_cafe",           { "get_tableplacing" }  }
  ,{ "clk_mmg_table",                         "rm_cafe",           { "use_tableplacing" } }
  ,{ "clk_table",                             "rm_cafe",           { "clk_mmg_table" } }
  ,{ "dlg_cafe_josh_fraser_2",                "rm_cafe",           { "clk_table" } }
  ,{ "see_josh_fraser_leave",                 "rm_cafe",           { "dlg_cafe_josh_fraser_2" } }
  ,{ "get_bill",                              "rm_cafe",           { "see_josh_fraser_leave" }  }
  ,{ "get_amuletmelodypart",                  "rm_cafe",           { "see_josh_fraser_leave" }  }
  ,{ "clk_bill_folder" }
  ,{ "get_coin_ext_2",          }
  ,{ "get_chewinggum",          }
  ,{ "get_amuletmelodypart2",                 "rm_cafe",           { "dlg_cafe_barman_1" }  }
  ,{ "use_amuletmelodypart2"    }
  ,{ "use_chewinggum",          }
  ,{ "clk_chewinggum_1",          }
  ,{ "clk_chewinggum_2",          }
  ,{ "clk_chewinggum_3",          }
  ,{ "clk_amuletmelodypart2",          }
  ,{ "get_amuletmelody",          }
  ,{ "use_amuletmelody",                      "rm_cafe",           { "get_amuletmelody" }  }
  ,{ "use_coin_ext_2",                        "rm_cafe",           { "get_coin_ext_2", "use_amuletmelody" }  }
  ,{ "clk_musicmachine_button",               "rm_cafe",           { "use_coin_ext_2" }  }
  ,{ "get_stonewings",                        "rm_cafe",           { "clk_musicmachine_button" }  }
  ,{ "use_stonewings",                        "rm_nearcafe",           { "get_stonewings" }  }
  ,{ "get_phoenixfigure",                     "rm_nearcafe",           { "use_stonewings" }  }
  ,{ "clk_phoenix_1" }
  ,{ "clk_phoenix_2" }
  ,{ "get_wheel",          }
  ,{ "see_frontdoor",                         "rm_porch",           { "get_wheel" } }
  ,{ "use_wheel",                             "rm_porch",           { "get_wheel" }  }
  ,{ "clk_wheel",                             "rm_porch",           { "use_wheel" }  }
  ,{ "get_lever_ext",                         "rm_porch",           { "clk_wheel" }  }
  ,{ "use_lever_ext",                         "rm_cafe",           { "get_lever_ext" }  }
  ,{ "clk_lever_ext",                         "rm_cafe",           { "use_lever_ext" }  }
  ,{ "get_magnet_ext",                        "rm_cafe",           { "clk_lever_ext" }  }
  ,{ "get_cafebadge1",                        "rm_cafe",           { "dlg_cafe_barman_1" }  }
  ,{ "use_magnet_ext",                        "rm_cafe",           { "get_magnet_ext" }  }
  ,{ "get_cafebadge2",                        "rm_cafe",           { "use_magnet_ext" }  }
  ,{ "use_cafebadge1",                        "rm_cafe",           { "get_cafebadge1" }  }
  ,{ "use_cafebadge2",                        "rm_cafe",           { "get_cafebadge2" }  }
  ,{ "get_bartenderslostrecipe",              "rm_cafe",           { "use_cafebadge1", "use_cafebadge2" }  }
  ,{ "use_bartenderslostrecipe",              "rm_cafe",           { "get_bartenderslostrecipe" }  }  
  ,{ "opn_barcounter" }
  ,{ "win_barcounter",                        "rm_cafe",           { "use_bartenderslostrecipe" }  }
  ,{ "clk_bartenderlocket",                   "rm_cafe",           { "dlg_cafe_barman_1" }  }
  ,{ "use_bartenderlocket",                   "rm_cafe",           { "win_barcounter", "clk_bartenderlocket" }   }
  ,{ "get_wrench_ext",                        "rm_cafe",           { "use_bartenderlocket" }  }
  ,{ "use_wrench_ext",                        "rm_porch",           { "get_wrench_ext" }  }
  ,{ "clk_wrench_ext",                        "rm_porch",           { "use_wrench_ext" }  }
  ,{ "get_joshcard",                          "rm_porch",           { "clk_wrench_ext" }  }
  ,{ "use_joshcard",                          "rm_porch",           { "get_joshcard" } }
  ,{ "win_hoteldoor",                         "rm_porch",           { "get_joshcard" } }
  -- hall ext
  ,{ "opn_hall_ext" }
  ,{ "dlg_hall_ext_concierge",                "rm_hall",           { "opn_hall_ext" } }
  ,{ "use_bag",                               "rm_hall",           { "dlg_hall_ext_concierge" }  }
  ,{ "opn_bag" }
  ,{ "win_bag",                               "rm_hall",           { "use_bag" } }
  ,{ "see_call_kane_4",                       "rm_hall",           { "win_bag" } }
  ,{ "dlg_hall_ext_david_kane_4",             "rm_hall",           { "win_bag" } }
  ,{ "use_passport",                          "rm_hall",           { "win_bag" }  }
  ,{ "get_oneoffpass1",                       "rm_hall",           { "use_passport" }  }
  ,{ "use_oneoffpass1",                       "rm_hall",           { "get_oneoffpass1" }  }
  ,{ "win_pas_gen_1",                         "rm_hall",           { "use_oneoffpass1" }  }
  ,{ "get_generatedpassword1",                "rm_hall",           { "win_pas_gen_1" }  }
  ,{ "use_generatedpassword1",                "rm_hall",           { "get_generatedpassword1" }  }
  ,{ "clk_generatedpassword1",                "rm_hall",           { "use_generatedpassword1" } }
  ,{ "get_elevatormap",                       "rm_hall",           { "clk_generatedpassword1" }  }
  ,{ "get_roomkey",                           "rm_hall",           { "get_elevatormap" }  }
  ,{ "use_elevatormap",                       "rm_hall",           { "get_roomkey" }  }
  ,{ "win_superpuzzle4",                      "rm_hall",           { "use_elevatormap" } }
  , { "see_opn_elevator_door",                "rm_hall",           { "win_superpuzzle4" } }
  -- secondfloor_ext
  ,{ "opn_secondfloor_ext" }
  ,{ "use_roomkey",                           "rm_secondfloor",           { "opn_secondfloor_ext" }  }
  -- terenceroom ext
  ,{ "opn_terenceroom_ext" }
  ,{ "get_sugartongs",                        "rm_terenceroom",           { "opn_terenceroom_ext" }  }
  ,{ "use_sugartongs",                        "rm_secondfloor",           { "get_sugartongs" }  }
  ,{ "get_piston",                            "rm_secondfloor",           { "use_sugartongs" }  }
  ,{ "use_piston",                            "rm_secondfloor",           { "get_piston" }  }
  ,{ "get_file_ext",                          "rm_secondfloor",           { "use_piston" }  }
  ,{ "use_file_ext",                          "rm_secondfloor",           { "get_file_ext" }  }
  ,{ "get_ironhook",                          "rm_secondfloor",           { "use_file_ext" }  }
  ,{ "use_ironhook",                          "rm_terenceroom",           { "get_ironhook" }  }
  ,{ "win_shelflock",                         "rm_terenceroom",           { "use_ironhook" } }
  ,{ "get_labamulet",                         "rm_terenceroom",           { "win_shelflock" }          }
  ,{ "use_labamulet",                         "rm_terenceroom",           { "get_labamulet" }  }
  ,{ "get_brochure",                          "rm_terenceroom",           { "use_labamulet" }  }
  ,{ "clk_brochure_front" }
  ,{ "clk_brochure_back" }
  ,{ "get_oneoffpass2" }
  ,{ "use_oneoffpass2",                       "rm_hall",           { "get_oneoffpass2" } } 
  ,{ "win_pas_gen_2",                         "rm_hall",           { "use_oneoffpass2" }  } 
  ,{ "get_generatedpassword2",                "rm_hall",           { "win_pas_gen_2" }  }
  ,{ "use_generatedpassword2",                "rm_hall",           { "get_generatedpassword2" }  }
  ,{ "clk_generatedpassword2",                "rm_hall",           { "use_generatedpassword2" } }
  ,{ "get_patientprofile",                    "rm_hall",           { "clk_generatedpassword2" }  }
  ,{ "use_patientprofile",                    "rm_secondfloor",    { "get_patientprofile" }  }
  ,{ "opn_managerroom" }
  ,{ "dlg_managerroom_interview_1",           "rm_managerroom",           { "opn_managerroom" } }
  ,{ "win_forandagainst",                     "rm_managerroom",           { "dlg_managerroom_interview_1" } }
  ,{ "dlg_managerroom_interview_2",           "rm_managerroom",           { "win_forandagainst" } }
  ,{ "dlg_terenceroom_ext_josh_fraser_3",     "rm_terenceroom",           { "dlg_managerroom_interview_2" } }
  ,{ "see_terenceroom_ext_josh_fraser_4",     "rm_terenceroom",           { "dlg_terenceroom_ext_josh_fraser_3" } }
  ,{ "see_outro_ext" }

  ,{ "get_collect_item_4_1" }
  ,{ "get_collect_item_4_2" }
  ,{ "get_collect_item_4_3" }
  ,{ "get_collect_morph_item_4_1" }
  ,{ "get_collect_morph_item_4_2" }
  ,{ "get_collect_morph_item_4_3" }
  ,{ "get_collect_morph_item_4_4" }
  ,{ "get_collect_morph_item_4_5" }
  ,{ "get_collect_morph_item_4_6" }

  };
  
  game.progress_names = {};
  for i = 1, #game.progress_names_room do
    game.progress_names[ i ] = game.progress_names_room[ i ][ 1 ];
  end;
  
  game.relations = {};

  private.menu_moduls = {
    "rm_credits"
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {
      "rm_collectibles2",
      "rm_collectibles",
      "rm_achievements",
    }

    for i = 1, #menu_moduls_ce do

      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );

    end;

  end;

end;

function private.TutorialSetParams ()

  if not ng_global.progress[ "ext" ][ "see_tutorial_ext" ] then

    if ng_global.progress[ "std" ][ "see_tutorial" ] then

      ng_global.progress[ "ext" ][ "see_tutorial_ext" ] = {};
      ng_global.progress[ "ext" ][ "see_tutorial_ext" ].done  = ng_global.progress[ "std" ][ "see_tutorial" ].done;
      ng_global.progress[ "ext" ][ "see_tutorial_ext" ].start = ng_global.progress[ "std" ][ "see_tutorial" ].start;
      ng_global.progress[ "ext" ][ "see_tutorial_ext" ].state = ng_global.progress[ "std" ][ "see_tutorial" ].state;
      ng_global.progress[ "ext" ][ "see_tutorial_ext" ].state.no  = ng_global.progress[ "std" ][ "see_tutorial" ].state.no;
      ng_global.progress[ "ext" ][ "see_tutorial_ext" ].state.currentpage = ng_global.progress[ "std" ][ "see_tutorial" ].state.currentpage;
      ng_global.progress[ "ext" ][ "see_tutorial_ext" ].func = function()

      end;

      ng_global.progress[ "ext" ][ "see_tutorial_ext" ].state.pages = {

        [ "tutorial_page_18" ] = { shown = ng_global.progress[ "std" ][ "see_tutorial" ].state.pages[ "tutorial_page_18" ].shown, noskip = false, posx = 600, posy = 500, arrows = { 
                                                                                { pos_x = 150, pos_y = 0, ang =  1.6, target = "obj_int_button_collectibles2_button" }
                                                                              } },   -- колекторс2
        [ "tutorial_page_19" ] = { shown = ng_global.progress[ "std" ][ "see_tutorial" ].state.pages[ "tutorial_page_19" ].shown, noskip = true, posx = 512, posy = 300, arrows = { 
                                                                                { pos_x = 0, pos_y = 0, ang =  -2, target = "obj_int_button_morph" }
                                                                              } },   -- морфинг
        [ "tutorial_page_20" ] = { shown = ng_global.progress[ "std" ][ "see_tutorial" ].state.pages[ "tutorial_page_20" ].shown, noskip = false, posx = 512, posy = 200, arrows = { 
                                                                                { pos_x = 150, pos_y = -50, ang =  2, target = "obj_int_button_collectibles_button" }
                                                                              } },   -- маски
      };

    else

      ng_global.progress[ "ext" ][ "see_tutorial_ext" ] = {};
      ng_global.progress[ "ext" ][ "see_tutorial_ext" ].done  = 0;
      ng_global.progress[ "ext" ][ "see_tutorial_ext" ].start = 1;
      ng_global.progress[ "ext" ][ "see_tutorial_ext" ].state = {};
      ng_global.progress[ "ext" ][ "see_tutorial_ext" ].state.no  = 0;
      ng_global.progress[ "ext" ][ "see_tutorial_ext" ].state.currentpage = "tutorial_page_1";
      ng_global.progress[ "ext" ][ "see_tutorial_ext" ].func = function()

      end;

      ng_global.progress[ "ext" ][ "see_tutorial_ext" ].state.pages = {

        [ "tutorial_page_18" ] = { shown = 0, noskip = false, posx = 600, posy = 500, arrows = { 
                                                                                { pos_x = 150, pos_y = 0, ang =  1.6, target = "obj_int_button_collectibles2_button" }
                                                                              } },   -- колекторс2
        [ "tutorial_page_19" ] = { shown = 0, noskip = true, posx = 512, posy = 300, arrows = { 
                                                                                { pos_x = 0, pos_y = 0, ang =  -2, target = "obj_int_button_morph" }
                                                                              } },   -- морфинг
        [ "tutorial_page_20" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
                                                                                { pos_x = 150, pos_y = -50, ang =  2, target = "obj_int_button_collectibles_button" }
                                                                              } },   -- маски
      };

    end;

    ng_global.progress[ "ext" ][ "see_tutorial_ext" ].state.pages[ "tutorial_page_22" ] = { shown = 0, noskip = true, posx = 300, posy = 450, arrows = { 

                                                                              { pos_x = 50, pos_y = 320, ang = 1, target = "obj_int_slider_clk_left" }
                                                                            } };   -- слайдер локации
  end;

end;