-- name=levelext_inv
--*********************************************************************************************************************
function public.Init ()
  --ObjMultiSet({ });
  if port.isPortable() == 1 then
    port.InventoryPopupInit("levelext_inv_hub");
    port.VideoResizeInRoom("levelext_inv");
  end;
  private.letter_init();
  private.can_init();
  private.trinket_init();
  private.bagwiththings_init();
  private.holeyboot_init();
  private.stick_init();
  private.bill_init();
  private.amuletmelodypart_init();
  private.phoenixfigure_init();
  private.brochure_init();

----------------------------------------------------------------------------------------
  -- sound on all inventory objects during dragging for conteiner inventory_hub
----------------------------------------------------------------------------------------
  local invRelationsHubExt = ObjGetRelations( "levelext_inv_hub" );

  if invRelationsHubExt.childs then
    
    for i = 1, #invRelationsHubExt.childs, 1 do 
      
      local invCurrent = invRelationsHubExt.childs[i];
      ObjSet( invCurrent, { event_startdrag = cmn.GetInvObjectSfx } );
      
    end;
    
  end;

end;
--*********************************************************************************************************************
function private.StringDivide ( string )  

  local table = { };
  local id = 1;
  local il = 1;

  for i = 1, string.len( string ) do

    if ( string.sub( string, i, i ) == "_" ) then

      table[ id ] = string.sub( string, il, i - 1 );
      il = i + 1;
      id = id + 1;

    end

    if ( i == string.len( string ) ) then

      table[id] = string.sub( string, il, i );
      il = i + 1;
      id = id + 1;

    end

  end

  return table;

end;
--*********************************************************************************************************************
function private.ObjIntersectCheck ( obj_to_apply, obj_to_check, obj_complex_inv )

  local obj_complex_inv = obj_complex_inv or "deploy_inv_"..private.StringDivide( obj_to_check )[4];  
  
  return interface.GetCurrentInv() == obj_complex_inv and ObjIntersect( obj_to_apply, obj_to_check );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** letter *** () end;
--*********************************************************************************************************************
  function private.letter_init ()
    --------------------------------------------------------------------------------------------
    ObjMultiSet( { 
      { "spr_deploy_inv_letter_tobiasamulet",     { event_mdown = private.get_tobiasamulet } }, 
      { "spr_deploy_inv_letter_tobiasmessage",    { event_mdown = private.get_tobiasmessage } }, 
      { "obj_deploy_inv_letter_clk_envelope",     { event_mdown = private.clk_envelope } }, 
      { "obj_deploy_inv_letter_clk_letter",       { event_mdown = private.clk_letter } }, 
    } );
    --------------------------------------------------------------------------------------------
    -- USE -------------------------------------------------------------------------------------
    common_impl.hint[ "use_envelopeknife" ] = {
        type = "use",
        inv_obj = "inv_envelopeknife",
        use_place = "obj_deploy_inv_letter_use_envelopeknife",
        room = "int_deploy_inv",
        zz = "deploy_inv_letter",
        zz_gate = "inv_letter"
    };    
    function use_envelopeknife_beg ()
      
      ObjDelete( "obj_deploy_inv_letter_use_envelopeknife" );
      interface.InventoryItemRemove( "inv_envelopeknife" );

    end;
    function use_envelopeknife_end ()
      
      ObjSet( "obj_deploy_inv_letter_clk_envelope", { input = true } );
      ObjSet( "spr_deploy_inv_letter_envelope_open", { alp = 1 } );
      ObjDelete( "spr_deploy_inv_letter_envelope" );

    end;
    cmn.AddSubscriber( "use_envelopeknife", use_envelopeknife_beg );
    cmn.AddSubscriber( "use_envelopeknife", use_envelopeknife_end, "inv_letter" );
    cmn.AddSubscriber( "use_envelopeknife_beg", use_envelopeknife_beg );
    cmn.AddSubscriber( "use_envelopeknife_end", use_envelopeknife_end, "inv_letter" );
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_envelope" ] = {
        type = "click",
        use_place = "obj_deploy_inv_letter_clk_envelope",
        room = "int_deploy_inv",
        zz = "deploy_inv_letter",
        zz_gate = "inv_letter"
    };
    function clk_envelope ()

      ObjDelete( "obj_deploy_inv_letter_clk_envelope" );
      ObjSet( "spr_deploy_inv_letter_letter", { alp = 1 } );
      ObjSet( "obj_deploy_inv_letter_clk_letter", { input = true } );

    end;
    cmn.AddSubscriber( "clk_envelope", clk_envelope, "inv_letter" );
        --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_letter" ] = {
        type = "click",
        use_place = "obj_deploy_inv_letter_clk_letter",
        room = "int_deploy_inv",
        zz = "deploy_inv_letter",
        zz_gate = "inv_letter"
    };
    function clk_letter ()

      ObjDelete( "obj_deploy_inv_letter_clk_letter" );
      ObjDelete( "spr_deploy_inv_letter_letter" );
      ObjSet( "spr_deploy_inv_letter_tobiasamulet", { input = true, alp = 1 } );
      ObjSet( "gfx_deploy_inv_letter_tobiasamulet", { active = true } );
      ObjSet( "spr_deploy_inv_letter_tobiasmessage", { input = true, alp = 1 } );
      ObjSet( "gfx_deploy_inv_letter_tobiasmessage", { active = true } );

    end;
    cmn.AddSubscriber( "clk_letter", clk_letter, "inv_letter");
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_tobiasamulet" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_letter_tobiasamulet",
        room = "int_deploy_inv",
        zz = "deploy_inv_letter",
        zz_gate = "inv_letter"
    };
    function get_tobiasamulet_inv ()
      
      interface.InventoryItemAdd( "inv_tobiasamulet", "spr_deploy_inv_letter_tobiasamulet" );

      if cmn.IsEventDone( "get_tobiasmessage" ) then 

        interface.InventoryItemRemove( "inv_letter" );

      end;

    end;
    cmn.AddSubscriber( "get_tobiasamulet", get_tobiasamulet_inv );
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_tobiasmessage" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_letter_tobiasmessage",
        room = "int_deploy_inv",
        zz = "deploy_inv_letter",
        zz_gate = "inv_letter"
    };
    function get_tobiasmessage_inv ()
      
      ObjSet( "gzz_apartment_safe", { input = true, visible = true, active = true, alp = 1 } );
      interface.InventoryItemAdd( "inv_tobiasmessage", "spr_deploy_inv_letter_tobiasmessage" );

      if cmn.IsEventDone( "get_tobiasamulet" ) then 

        interface.InventoryItemRemove( "inv_letter" );

      end;

    end;
    cmn.AddSubscriber( "get_tobiasmessage", get_tobiasmessage_inv );

  end;
  -- USE ---------------------------------------------------------------------------------------
  function public.use_envelopeknife ()

    local item = "inv_envelopeknife";

    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_letter_use_envelopeknife" ) )  then

      cmn.CallEventHandler( "use_envelopeknife_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_envelopeknife" );
        cmn.CallEventHandler( "use_envelopeknife_end", "inv_letter" );
        
      end;

      cmn.Lock( true );

      common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_knife", 0, "", 0 );

      ObjAnimate( "spr_deploy_inv_letter_knife", "alp", 0, 0, func_end, { 0, 0, 0, 0.3, 0, 1, 1.0, 0, 1, 1.3, 0, 0 } );
      ObjAnimate( "spr_deploy_inv_letter_knife", "pos_xy", 0, 0, "", 
      {
        0.0,  0, 512, 61, 
        0.3,  0, 512, 61,
        0.5,  0, 399, 36,
        0.65, 0, 399, 36,
        1.0,  0, 348, -212
      } );
      ObjAnimate( "spr_deploy_inv_letter_envelope_open", "alp", 0, 0, "", { 0, 0, 0, 0.8, 0, 0, 1.0, 0, 1 } );

      return true; 

    end;

    return false;

  end;
  -- CLK ---------------------------------------------------------------------------------------
  function private.clk_envelope ()

    local func_end = function ()
      
      cmn.Lock( false );
      cmn.SetEventDone( "clk_envelope" );
      cmn.CallEventHandler( "clk_envelope", "inv_letter" );
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "aud_paper", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_letter_letter", "alp", 0, 0, func_end, { 0, 0, 0, 0.3, 0, 1 } );

  end;
  -----------------------------------------------------------------------------------------
  function private.clk_letter ()

    local func_end = function ()
      
      cmn.Lock( false );
      cmn.SetEventDone( "clk_letter" );
      cmn.CallEventHandler( "clk_letter", "inv_letter" );
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "aud_paper", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_letter_letter", "alp", 0, 0, "", { 0, 0, 1, 0.3, 0, 0 } );
    ObjAnimate( "spr_deploy_inv_letter_tobiasmessage", "alp", 0, 0, "", { 0, 0, 0, 0.1, 0, 0, 0.3, 0, 1 } );
    ObjAnimate( "spr_deploy_inv_letter_tobiasamulet", "alp", 0, 0, func_end, { 0, 0, 0, 0.1, 0, 0, 0.3, 0, 1 } );

  end;
  -- GET ---------------------------------------------------------------------------------------
  function private.get_tobiasamulet ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_tobiasamulet" );
    cmn.CallEventHandler( "get_tobiasamulet", "inv_letter" );

    if cmn.IsEventDone( "get_tobiasmessage" ) then 

      common_impl.HideDeployInv();

    end;

  end;
  -----------------------------------------------------------------------------------------
  function private.get_tobiasmessage ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_tobiasmessage" );
    cmn.CallEventHandler( "get_tobiasmessage", "inv_letter" );

    if ( ng_global.progress[ "ext" ].common.currentroom == "rm_apartment" ) then

      rm_apartment.ScaleSafe();

    end;

    if ( cmn.IsEventDone( "get_tobiasamulet" ) ) then 

      common_impl.HideDeployInv();

    else

      private.get_tobiasamulet();

    end;

  end;
  ---------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** can *** () end;
--*********************************************************************************************************************
  function private.can_init ()
    --------------------------------------------------------------------------------------------
    ObjMultiSet( { 
      { "spr_deploy_inv_can_corn",     { event_mdown = private.get_corn } }, 
      { "obj_deploy_inv_can_clk_can",     { event_mdown = private.clk_can } }, 
    } );
    -- USE -------------------------------------------------------------------------------------
    common_impl.hint[ "use_canopener" ] = {
        type = "use",
        inv_obj = "inv_canopener",
        use_place = "obj_deploy_inv_can_use_canopener",
        room = "int_deploy_inv",
        zz = "deploy_inv_can",
        zz_gate = "inv_can"
    };    
    function use_canopener_beg ()
      
      ObjDelete( "obj_deploy_inv_can_use_canopener" );
      interface.InventoryItemRemove( "inv_canopener" );

    end;
    function use_canopener_end ()
      
      ObjDelete( "spr_deploy_inv_can_bank_over" );
      ObjDelete( "spr_deploy_inv_can_bank" );
      ObjDelete( "spr_deploy_inv_can_bank_closed" );
      ObjDelete( "spr_deploy_inv_can_knife" );

      ObjSet( "spr_deploy_inv_can_bank_open", { alp = 1 } );
      ObjSet( "obj_deploy_inv_can_clk_can", { input = true } );

    end;
    cmn.AddSubscriber( "use_canopener", use_canopener_beg );
    cmn.AddSubscriber( "use_canopener", use_canopener_end, "inv_can" );
    cmn.AddSubscriber( "use_canopener_beg", use_canopener_beg );
    cmn.AddSubscriber( "use_canopener_end", use_canopener_end, "inv_can" );
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_can" ] = {
        type = "click",
        use_place = "obj_deploy_inv_can_clk_can",
        room = "int_deploy_inv",
        zz = "deploy_inv_can",
        zz_gate = "inv_can"
    };
    function clk_can ()

      ObjDelete( "obj_deploy_inv_can_clk_can" );
      ObjSet( "spr_deploy_inv_can_corn", { input = true, alp = 1 } );

    end;
    cmn.AddSubscriber( "clk_can", clk_can, "inv_can" );
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_corn" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_can_corn",
        room = "int_deploy_inv",
        zz = "deploy_inv_can",
        zz_gate = "inv_can"
    };
    function get_corn_inv ()
      
      interface.InventoryItemAdd( "inv_corn", "spr_deploy_inv_can_corn" );
      interface.InventoryItemRemove( "inv_can" );

    end;
    cmn.AddSubscriber( "get_corn", get_corn_inv );

  end;
  -- USE ---------------------------------------------------------------------------------------
  function public.use_canopener ()

    local item = "inv_canopener";

    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_can_use_canopener" ) )  then

      cmn.CallEventHandler( "use_canopener_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_canopener" );
        cmn.CallEventHandler( "use_canopener_end", "inv_can" );
        
      end;

      cmn.Lock( true );

      common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_canopener", 0, "", 0 );

      ObjAnimate( "spr_deploy_inv_can_knife", "alp", 0, 0, "", { 0, 0, 0, 0.3, 0, 1, 1.5, 0, 1, 1.8, 0, 0 } );
      ObjAnimate( "spr_deploy_inv_can_knife", "pos_xy", 0, 0, "", 
      { 
        0.0, 0, 51, -240, 
        0.3, 0, 51, -240,
        0.5, 3, -35, -182,
        1.5, 3, -139, -213 
      } );
      ObjAnimate( "spr_deploy_inv_can_knife", "ang", 0, 0, "", 
      { 
        0.0, 0, 0,
        0.5, 3, 0,
        0.7, 0, 0.1,
        0.9, 0, 0,
        1.1, 0, 0.1,
        1.3, 3, 0,
        1.5, 0, 0.1 
      } );
      
      ObjAnimate( "spr_deploy_inv_can_bank_over", "alp", 0, 0, "", { 0, 0, 1, 1.7, 0, 1, 2.0, 0, 0 } );

      ObjAnimate( "spr_deploy_inv_can_bank", "alp", 0, 0, func_end, { 0, 0, 0, 0.5, 0, 0, 1.0, 0, 1, 1.8, 0, 1, 2.0, 0, 0 } );
      ObjAnimate( "spr_deploy_inv_can_bank_open", "alp", 0, 0, "", { 0, 0, 0, 1.8, 0, 0, 2.0, 0, 1 } );

      return true; 

    end;

    return false;

  end;
  -- CLK ---------------------------------------------------------------------------------------
  function private.clk_can ()

    local func_end = function ()
      
      cmn.Lock( false );
      cmn.SetEventDone( "clk_can" );
      cmn.CallEventHandler( "clk_can", "inv_can" );
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_can", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_can_bank_open", "ang", 0, 0, func_end, 
    { 
      0.0, 0, 0, 
      0.5, 0, -0.6 * math.pi, 
      1.0, 0, -0.6 * math.pi, 
      1.5, 0, 0 
    } );

    ObjAnimate( "spr_deploy_inv_can_bank_open", "pos_xy", 0, 0, "", 
    { 
      0.0, 0, -94, -137, 
      0.5, 0, -94, -137,
      0.6, 0, -87, -130, 
      0.7, 0, -94, -137,
      0.8, 0, -87, -130, 
      0.9, 0, -94, -137
    } );

    ObjAnimate( "spr_deploy_inv_can_corn", "alp", 0, 0, "", { 0, 0, 0, 0.5, 0, 0, 1.0, 0, 1 } );

  end;
  -- GET ---------------------------------------------------------------------------------------
  function private.get_corn ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_corn" );
    cmn.CallEventHandler( "get_corn", "inv_can" );
    common_impl.HideDeployInv();


  end;
  ------------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** trinket *** () end;
--*********************************************************************************************************************
  function private.trinket_init ()
    --------------------------------------------------------------------------------------------
    ObjMultiSet( { 
      { "spr_deploy_inv_firstaidkit_tweezers_ext",     { event_mdown = private.get_tweezers_ext } }, 
      { "obj_deploy_inv_firstaidkit_clk_firstaid_ring",     { event_mdown = private.clk_firstaid_ring } }, 
      { "obj_deploy_inv_firstaidkit_clk_firstaid_trash",     { event_mdown = private.clk_firstaid_trash } }
    } );
    --------------------------------------------------------------------------------------------
    -- USE -------------------------------------------------------------------------------------
    common_impl.hint[ "use_trinket" ] = {
        type = "use",
        inv_obj = "inv_trinket",
        use_place = "obj_deploy_inv_firstaidkit_use_trinket",
        room = "int_deploy_inv",
        zz = "deploy_inv_firstaidkit",
        zz_gate = "inv_firstaidkit"
    };    
    function use_trinket_beg ()
      
      ObjDelete( "obj_deploy_inv_firstaidkit_use_trinket" );
      interface.InventoryItemRemove( "inv_trinket" );

    end;
    function use_trinket_end ()

      ObjSet( "spr_deploy_inv_firstaidkit_ring_v", { alp = 1 } );
      ObjSet( "obj_deploy_inv_firstaidkit_clk_firstaid_ring", { input = true } );

    end;
    cmn.AddSubscriber( "use_trinket", use_trinket_beg );
    cmn.AddSubscriber( "use_trinket", use_trinket_end, "inv_firstaidkit" );
    cmn.AddSubscriber( "use_trinket_beg", use_trinket_beg );
    cmn.AddSubscriber( "use_trinket_end", use_trinket_end, "inv_firstaidkit" );
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_firstaid_ring" ] = {
        type = "click",
        use_place = "obj_deploy_inv_firstaidkit_clk_firstaid_ring",
        room = "int_deploy_inv",
        zz = "deploy_inv_firstaidkit",
        zz_gate = "inv_firstaidkit"
    };
    function clk_firstaid_ring ()

      ObjDelete( "obj_deploy_inv_firstaidkit_clk_firstaid_ring" );
      ObjDelete( "obj_deploy_inv_firstaidkit_close_chest" );
      ObjSet( "obj_deploy_inv_firstaidkit_open_chest", { alp = 1 } );
      ObjSet( "obj_deploy_inv_firstaidkit_clk_firstaid_trash", { input = true } );

    end;
    cmn.AddSubscriber( "clk_firstaid_ring", clk_firstaid_ring, "inv_firstaidkit" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_firstaid_trash" ] = {
        type = "click",
        use_place = "obj_deploy_inv_firstaidkit_clk_firstaid_trash",
        room = "int_deploy_inv",
        zz = "deploy_inv_firstaidkit",
        zz_gate = "inv_firstaidkit"
    };
    function clk_firstaid_trash ()

      ObjDelete( "obj_deploy_inv_firstaidkit_clk_firstaid_trash" );
      ObjDelete( "spr_deploy_inv_firstaidkit_bandage" );
      ObjSet( "spr_deploy_inv_firstaidkit_tweezers_ext", { input = true, active = true } );
      ObjSet( "obj_deploy_inv_firstaidkit_open_chest", { input = true } );

    end;
    cmn.AddSubscriber( "clk_firstaid_trash", clk_firstaid_trash, "inv_firstaidkit" );
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_tweezers_ext" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_firstaidkit_tweezers_ext",
        room = "int_deploy_inv",
        zz = "deploy_inv_firstaidkit",
        zz_gate = "inv_firstaidkit"
    };
    function get_tweezers_ext_inv ()
      
      interface.InventoryItemAdd( "inv_tweezers_ext", "spr_deploy_inv_firstaidkit_tweezers_ext" );
      interface.InventoryItemRemove( "inv_firstaidkit" );

    end;
    cmn.AddSubscriber( "get_tweezers_ext", get_tweezers_ext_inv );

  end;
  -- USE ---------------------------------------------------------------------------------------
  function public.use_trinket ()

    local item = "inv_trinket";

    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_firstaidkit_use_trinket" ) )  then

      cmn.CallEventHandler( "use_trinket_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_trinket" );
        cmn.CallEventHandler( "use_trinket_end", "inv_firstaidkit" );
        
      end;

      cmn.Lock( true );

      common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_ring", 0, "", 0 );

      cmn.ItemFly( "spr_deploy_inv_firstaidkit_ring_v", func_end, 1.3 );

      return true; 

    end;

    return false;

  end;
  -- CLK ---------------------------------------------------------------------------------------
  function private.clk_firstaid_ring ()

    local func_end = function ()
      
      cmn.Lock( false );
      cmn.SetEventDone( "clk_firstaid_ring" );
      cmn.CallEventHandler( "clk_firstaid_ring", "inv_firstaidkit" );
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_ring", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_firstaidkit_ring_v", "alp", 0, 0, "", 
    { 
      0.0, 0, 1, 
      0.3, 0, 0
    } );
    ObjAnimate( "spr_deploy_inv_firstaidkit_ring_h", "alp", 0, 0, "", 
    { 
      0.0, 0, 0, 
      0.3, 0, 1
    } );
    ObjAnimate( "spr_deploy_inv_firstaidkit_lock", "pos_y", 0, 0, "", 
    { 
      0.0, 0, 34, 
      0.3, 0, 24
    } );

    ObjAnimate( "obj_deploy_inv_firstaidkit_close_chest", "alp", 0, 0, "", 
    { 
      0.0, 0, 1, 
      0.3, 0, 1,
      0.6, 0, 0
    } );
    ObjAnimate( "obj_deploy_inv_firstaidkit_open_chest", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0, 
      0.3, 0, 0,
      0.6, 0, 1
    } );


  end;
  ----------------------------------------------------------------------------------------------
  function private.clk_firstaid_trash ()

    local func_end = function ()
      
      cmn.Lock( false );
      cmn.SetEventDone( "clk_firstaid_trash" );
      cmn.CallEventHandler( "clk_firstaid_trash", "inv_firstaidkit" );
      
    end;

    cmn.Lock( true );

    ObjAnimate( "spr_deploy_inv_firstaidkit_bandage", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 1, 
      0.3, 0, 0 
    } );

  end;
  -- GET ---------------------------------------------------------------------------------------
  function private.get_tweezers_ext ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_tweezers_ext" );
    cmn.CallEventHandler( "get_tweezers_ext", "inv_firstaidkit" );
    common_impl.HideDeployInv();

  end;
  ----------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** bagwiththings *** () end;
--*********************************************************************************************************************
  function private.bagwiththings_init ()
    --------------------------------------------------------------------------------------------
    ObjMultiSet( { 
      { "spr_deploy_inv_bagwiththings_screwdriverknife",      { event_mdown = private.get_screwdriverknife } }, 
      { "spr_deploy_inv_bagwiththings_bag",                   { event_mdown = private.get_bag } }, 
      { "obj_deploy_inv_bagwiththings_clk_bag",               { event_mdown = private.clk_bag } }, 
      { "obj_deploy_inv_bagwiththings_clk_knife",             { event_mdown = private.clk_bag_knife } }
    } );
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_bag" ] = {
        type = "click",
        use_place = "obj_deploy_inv_bagwiththings_clk_bag",
        room = "int_deploy_inv",
        zz = "deploy_inv_bagwiththings",
        zz_gate = "inv_bagwiththings"
    };
    function clk_bag ()

      ObjDelete( "obj_deploy_inv_bagwiththings_clk_bag" );
      ObjSet( "spr_deploy_inv_bagwiththings_screwdriverknife", { pos_x = 171, pos_y = 104, alp = 1 } );
      ObjAttach( "spr_deploy_inv_bagwiththings_screwdriverknife", "deploy_inv_bagwiththings" );
      ObjSet( "obj_deploy_inv_bagwiththings_clk_knife", { input = true } );
      

    end;
    cmn.AddSubscriber( "clk_bag", clk_bag, "inv_bagwiththings" );
    ---------------------------------------------------------------------------------------
    common_impl.hint[ "clk_bag_knife" ] = {
        type = "click",
        use_place = "obj_deploy_inv_bagwiththings_clk_knife",
        room = "int_deploy_inv",
        zz = "deploy_inv_bagwiththings",
        zz_gate = "inv_bagwiththings"
    };
    function clk_bag_knife ()

      ObjDelete( "obj_deploy_inv_bagwiththings_clk_knife" );
      ObjSet( "spr_deploy_inv_bagwiththings_screwdriverknife", { input = true } );
      ObjSet( "spr_deploy_inv_bagwiththings_screwdriver", { ang = 0 } );
      ObjSet( "gfx_deploy_inv_bagwiththings_screwdriverknife", { active = true } );
    ObjSet( "spr_deploy_inv_bagwiththings_bag", { input = true } );
      ObjSet( "gfx_deploy_inv_bagwiththings_bag", { active = true } );

    end;
    cmn.AddSubscriber( "clk_bag_knife", clk_bag_knife, "inv_bagwiththings" );
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_screwdriverknife" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_bagwiththings_screwdriverknife",
        room = "int_deploy_inv",
        zz = "deploy_inv_bagwiththings",
        zz_gate = "inv_bagwiththings"
    };
    function get_screwdriverknife_inv ()
      
      interface.InventoryItemAdd( "inv_screwdriverknife", "spr_deploy_inv_bagwiththings_screwdriverknife" );

    end;
    cmn.AddSubscriber( "get_screwdriverknife", get_screwdriverknife_inv );
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_bag" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_bagwiththings_bag",
        room = "int_deploy_inv",
        zz = "deploy_inv_bagwiththings",
        zz_gate = "inv_bagwiththings"
    };
    function get_bag_inv ()
      
      interface.InventoryItemAdd( "inv_bag", "spr_deploy_inv_bagwiththings_bag" );
      interface.InventoryItemRemove( "inv_bagwiththings" );

    end;
    cmn.AddSubscriber( "get_bag", get_bag_inv );

  end;
  -- CLK ---------------------------------------------------------------------------------------
  function private.clk_bag ()

    local func_end = function ()
      
      cmn.Lock( false );
      cmn.SetEventDone( "clk_bag" );
      cmn.CallEventHandler( "clk_bag", "inv_bagwiththings" );
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_zipper", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_bagwiththings_key", "pos_xy", 0, 0, "", 
    { 
      0.0, 3, -7, -66, 
      0.3, 3, -73, 46
    } );

    ObjAnimate( "spr_deploy_inv_bagwiththings_lock", "alp", 0, 0, "", 
    { 
      0.0, 3, 0, 
      0.1, 3, 0,
      0.3, 3, 1
    } );

    ObjAnimate( "spr_deploy_inv_bagwiththings_open_bag", "alp", 0, 0, "", 
    { 
      0.0, 3, 0, 
      0.4, 3, 0,
      0.7, 3, 1
    } );

    ObjAnimate( "spr_deploy_inv_bagwiththings_screwdriverknife", "pos_xy", 0, 0, func_end, 
    { 
      0.0, 0, -87, 21, 
      0.7, 0, -87, 21,
      1.2, 3, 112, -133, 
      1.8, 3, 228, 219
    } );

  end;
  -----------------------------------------------------------------------------------------
  function private.clk_bag_knife ()

    local func_end = function ()
      
      cmn.Lock( false );
      cmn.SetEventDone( "clk_bag_knife" );
      cmn.CallEventHandler( "clk_bag_knife", "inv_bagwiththings" );
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_button", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_bagwiththings_screwdriver", "ang", 0, 0, func_end, 
    { 
      0.0, 3, 0.89, 
      0.4, 3, 0
    } );

  end;
  
  -- GET ---------------------------------------------------------------------------------------
  function private.get_screwdriverknife ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_screwdriverknife" );
    cmn.CallEventHandler( "get_screwdriverknife", "inv_bagwiththings" );

  end;
  -- GET ---------------------------------------------------------------------------------------
  function private.get_bag ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_bag" );
    cmn.CallEventHandler( "get_bag", "inv_bagwiththings" );

    if ( not cmn.IsEventDone( "get_screwdriverknife" ) ) then

      private.get_screwdriverknife()

    end;

    common_impl.HideDeployInv();

  end;
  ----------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** holeyboot *** () end;
--*********************************************************************************************************************
  function private.holeyboot_init ()
    --------------------------------------------------------------------------------------------
    ObjMultiSet( { 
      { "spr_deploy_inv_holeyboot_letter_i",      { event_mdown = private.get_letter_i } },
      { "obj_deploy_inv_holeyboot_clk_boot",      { event_mdown = private.clk_holeyboot } }, 
    } );
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_letter_i" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_holeyboot_letter_i",
        room = "int_deploy_inv",
        zz = "deploy_inv_holeyboot",
        zz_gate = "inv_holeyboot"
    };
    function get_letter_i_inv ()
      
      ObjSet( "spr_deploy_inv_holeyboot_letter_i", { alp = 1 } );
      interface.InventoryItemAdd( "inv_letter_i", "spr_deploy_inv_holeyboot_letter_i" );
      interface.InventoryItemRemove( "inv_holeyboot" );

    end;
    function get_letter_i_deploy ()
      
      ObjDelete( "spr_deploy_inv_holeyboot_letter_shadow" );
      ObjDelete( "gfx_deploy_inv_holeyboot_letter_i" );

    end;
    cmn.AddSubscriber( "get_letter_i", get_letter_i_inv );
    cmn.AddSubscriber( "get_letter_i", get_letter_i_deploy, "inv_holeyboot" );
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_holeyboot_1" ] = {
        type = "click",
        use_place = "obj_deploy_inv_holeyboot_clk_boot",
        room = "int_deploy_inv",
        zz = "deploy_inv_holeyboot",
        zz_gate = "inv_holeyboot"
    };
    function clk_holeyboot_1 ()

      ObjSet( "spr_deploy_inv_holeyboot_state_2", { alp = 1 } );
      ObjDelete( "spr_deploy_inv_holeyboot_state_1" );

    end;
    cmn.AddSubscriber( "clk_holeyboot_1", clk_holeyboot_1, "inv_holeyboot" );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_holeyboot_2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_holeyboot_clk_boot",
        room = "int_deploy_inv",
        zz = "deploy_inv_holeyboot",
        zz_gate = "inv_holeyboot"
    };
    function clk_holeyboot_2 ()

      ObjSet( "spr_deploy_inv_holeyboot_letter_i", { input = true } );
      ObjSet( "gfx_deploy_inv_holeyboot_letter_i", { active = true } );
      ObjSet( "spr_deploy_inv_holeyboot_state_3", { alp = 1 } );
      ObjDelete( "spr_deploy_inv_holeyboot_state_2" );
      ObjDelete( "obj_deploy_inv_holeyboot_clk_boot" );

    end;
    cmn.AddSubscriber( "clk_holeyboot_2", clk_holeyboot_2, "inv_holeyboot" );

  end;
  -- CLK ---------------------------------------------------------------------------------------
  function private.clk_holeyboot ()

    local state = 1;
    if ( cmn.IsEventDone( "clk_holeyboot_1" ) ) then state = 2; end;

    local func_end = function ()
      
      cmn.Lock( false );
      cmn.SetEventDone( "clk_holeyboot_"..state );
      cmn.CallEventHandler( "clk_holeyboot_"..state, "inv_holeyboot" );
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_shoe", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_holeyboot_state_"..state, "alp", 0, 0, func_end, 
    { 
      0.0, 3, 1, 
      0.3, 3, 0
    } );

    ObjAnimate( "spr_deploy_inv_holeyboot_state_"..( state + 1 ), "alp", 0, 0, "", 
    { 
      0.0, 3, 0, 
      0.3, 3, 1
    } );

  end;
  -----------------------------------------------------------------------------------------
  function private.get_letter_i ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_letter_i" );
    cmn.CallEventHandler( "get_letter_i", "inv_holeyboot" );
    common_impl.HideDeployInv();


  end;
  ----------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** stick *** () end;
--*********************************************************************************************************************
  function private.stick_init ()
    --------------------------------------------------------------------------------------------
    ObjMultiSet( { 
      { "spr_deploy_inv_stick_peg",             { event_mdown = private.get_peg } }, 
      { "spr_deploy_inv_stick_broom_ext",       { event_mdown = private.get_broom_ext } }, 
      { "obj_deploy_inv_stick_clk_stick_peg",   { event_mdown = private.clk_stick_peg } },
    } );
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_stick_peg" ] = {
        type = "click",
        use_place = "obj_deploy_inv_stick_clk_stick_peg",
        room = "int_deploy_inv",
        zz = "deploy_inv_stick",
        zz_gate = "inv_stick"
    };
    function clk_stick_peg ()

      ObjDelete( "obj_deploy_inv_stick_clk_stick_peg" );

      if ( not cmn.IsEventDone( "win_droppedtreecrown" ) ) then

        cmn.SetInvPlusRGB( "stick", false );  

      end;

    end;
    cmn.AddSubscriber( "clk_stick_peg", clk_stick_peg, "inv_stick" );
    -- USE -------------------------------------------------------------------------------------
    common_impl.hint[ "use_rope_ext" ] = {
        type = "use",
        inv_obj = "inv_rope_ext",
        use_place = "obj_deploy_inv_stick_use_rope_ext",
        room = "int_deploy_inv",
        zz = "deploy_inv_stick",
        zz_gate = "inv_stick"
    };    
    function use_rope_ext_beg ()
      
      ObjDelete( "obj_deploy_inv_stick_use_rope_ext" );
      interface.InventoryItemRemove( "inv_rope_ext" );
      cmn.SetInvPlusRGB( "stick", true ); 

    end;
    function use_rope_ext_end ()
    
      ObjSet( "spr_deploy_inv_stick_rope", { alp = 1 } );
      ObjSet( "spr_deploy_inv_stick_broom_ext", { input = true, alp = 1 } );

    end;
    cmn.AddSubscriber( "use_rope_ext", use_rope_ext_beg );
    cmn.AddSubscriber( "use_rope_ext", use_rope_ext_end, "inv_stick" );
    cmn.AddSubscriber( "use_rope_ext_beg", use_rope_ext_beg );
    cmn.AddSubscriber( "use_rope_ext_end", use_rope_ext_end, "inv_stick" );
    -- USE -------------------------------------------------------------------------------------
    common_impl.hint[ "use_drybranches" ] = {
        type = "use",
        inv_obj = "inv_drybranches",
        use_place = "obj_deploy_inv_stick_use_drybranches",
        room = "int_deploy_inv",
        zz = "deploy_inv_stick",
        zz_gate = "inv_stick"
    };    
    function use_drybranches_beg ()
      
      ObjDelete( "obj_deploy_inv_stick_use_drybranches" );
      interface.InventoryItemRemove( "inv_drybranches" );
      ObjSet( "inv_stick", { res = "assets/levels/levelext/inv_deploy/inv_stick/inv/inv_broom_ext" } );

      if ( not cmn.IsEventDone("get_rope_ext" ) ) then

        cmn.SetInvPlusRGB( "stick", false ); 

      else

        cmn.SetInvPlusRGB( "stick", true ); 

      end;

    end;
    function use_drybranches_end ()
    
      ObjSet( "spr_deploy_inv_stick_branch", { alp = 1 } );

    end;
    cmn.AddSubscriber( "use_drybranches", use_drybranches_beg );
    cmn.AddSubscriber( "use_drybranches", use_drybranches_end, "inv_stick" );
    cmn.AddSubscriber( "use_drybranches_beg", use_drybranches_beg );
    cmn.AddSubscriber( "use_drybranches_end", use_drybranches_end, "inv_stick" );
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_peg" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_stick_peg",
        room = "int_deploy_inv",
        zz = "deploy_inv_stick",
        zz_gate = "inv_stick"
    };
    function get_peg_inv ()
      
      interface.InventoryItemAdd( "inv_peg", "spr_deploy_inv_stick_peg" );

    end;
    cmn.AddSubscriber( "get_peg", get_peg_inv );
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_broom_ext" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_stick_broom_ext",
        room = "int_deploy_inv",
        zz = "deploy_inv_stick",
        zz_gate = "inv_stick"
    };
    function get_broom_ext_inv ()
      
      interface.InventoryItemAdd( "inv_broom_ext", "obj_deploy_inv_stick_broom" );
      interface.InventoryItemRemove( "inv_stick" );

    end;
    cmn.AddSubscriber( "get_broom_ext", get_broom_ext_inv );

  end;
  -- CLK ---------------------------------------------------------------------------------------
  function private.clk_stick_peg ()

    local func_end = function ()
      
      cmn.Lock( false );
      cmn.SetEventDone( "clk_stick_peg" );
      cmn.CallEventHandler( "clk_stick_peg", "inv_stick" );

      private.get_peg();
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_stick2", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_stick_peg", "ang", 0, 0, func_end, 
    { 
      0.0, 3, 0, 
      0.3, 3, -0.2,
      0.5, 3, -0.1,
      0.7, 3, -0.3
    } );

  end;
  -- USE ---------------------------------------------------------------------------------------
  function public.use_rope_ext ()

    local item = "inv_rope_ext";

    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_stick_use_rope_ext" ) and cmn.IsEventDone( "use_drybranches" ) )  then

      cmn.CallEventHandler( "use_rope_ext_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_rope_ext" );
        cmn.CallEventHandler( "use_rope_ext_end", "inv_stick" );
        
      end;

      cmn.Lock( true );

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_clk_rope", 0, "", 0 );

      cmn.ItemFly( "spr_deploy_inv_stick_rope", func_end );

      return true; 

    end;

    return false;

  end;
  -- USE ---------------------------------------------------------------------------------------
  function public.use_drybranches ()

    local item = "inv_drybranches";

    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_stick_use_drybranches" ) and cmn.IsEventDone( "clk_stick_peg" ) )  then

      cmn.CallEventHandler( "use_drybranches_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_drybranches" );
        cmn.CallEventHandler( "use_drybranches_end", "inv_stick" );
        
      end;

      cmn.Lock( true );

      common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx" );

      cmn.ItemFly( "spr_deploy_inv_stick_branch", func_end );

      return true; 

    end;

    return false;

  end;
  -- GET ---------------------------------------------------------------------------------------
  function private.get_peg ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_peg" );
    cmn.CallEventHandler( "get_peg", "inv_stick" );

  end;
  ----------------------------------------------------------------------------------------------
  -- GET ---------------------------------------------------------------------------------------
  function private.get_broom_ext ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_broom_ext" );
    cmn.CallEventHandler( "get_broom_ext", "inv_stick" );
    common_impl.HideDeployInv();

  end;
  ----------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** bill *** () end;
--*********************************************************************************************************************
  function private.bill_init ()

    --------------------------------------------------------------------------------------------
    ObjMultiSet( { 
      { "spr_deploy_inv_bill_coin_ext_2",         { event_mdown = private.get_coin_ext_2 } },
      { "spr_deploy_inv_bill_chewinggum",         { event_mdown = private.get_chewinggum } },
      { "obj_deploy_inv_bill_clk_folder",         { event_mdown = private.clk_bill_folder } },
    } );
    -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_bill_folder" ] = {
        type = "click",
        use_place = "obj_deploy_inv_bill_clk_folder",
        room = "int_deploy_inv",
        zz = "deploy_inv_bill",
        zz_gate = "inv_bill"
    };
    function clk_bill_folder ()

      ObjDelete( "obj_deploy_inv_bill_clk_folder" );  
      ObjSet( "obj_deploy_inv_bill_open_folder", { alp = 1, input = true } );
      ObjDelete( "spr_deploy_inv_bill_folder" )

    end;
    cmn.AddSubscriber( "clk_bill_folder", clk_bill_folder, "inv_bill" );
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_coin_ext_2" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_bill_coin_ext_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_bill",
        zz_gate = "inv_bill"
    };
    function get_coin_ext_2_inv ()
      
      ObjSet( "spr_deploy_inv_bill_coin_ext_2", { alp = 1 } );
      ObjDelete( "spr_deploy_inv_bill_coin_shadow" );
      interface.InventoryItemAdd( "inv_coin_ext_2", "spr_deploy_inv_bill_coin_ext_2" );
  
      if ( cmn.IsEventDone( "get_chewinggum" ) ) then

        interface.InventoryItemRemove( "inv_bill" );

      end;

    end;
    cmn.AddSubscriber( "get_coin_ext_2", get_coin_ext_2_inv );
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_chewinggum" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_bill_chewinggum",
        room = "int_deploy_inv",
        zz = "deploy_inv_bill",
        zz_gate = "inv_bill"
    };
    function get_chewinggum_inv ()
      
      ObjSet( "spr_deploy_inv_bill_chewinggum", { alp = 1 } );
      ObjDelete( "spr_deploy_inv_bill_chewinggum_shadow" );
      interface.InventoryItemAdd( "inv_chewinggum", "spr_deploy_inv_bill_chewinggum" );
      cmn.SetInvPlusRGB( "amuletmelodypart", true );

      if ( cmn.IsEventDone( "get_coin_ext_2" ) ) then

        interface.InventoryItemRemove( "inv_bill" );

      end;

    end;
    cmn.AddSubscriber( "get_chewinggum", get_chewinggum_inv );

  end;
   -- CLK ---------------------------------------------------------------------------------------
  function private.clk_bill_folder ()

    local func_end = function ()
      
      cmn.Lock( false );
      cmn.SetEventDone( "clk_bill_folder" );
      cmn.CallEventHandler( "clk_bill_folder", "inv_bill" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_book", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_bill_folder", "alp", 0, 0, func_end, 
    { 
      0.0, 3, 1, 
      0.3, 3, 0
    } );

    ObjAnimate( "obj_deploy_inv_bill_open_folder", "alp", 0, 0, "", 
    { 
      0.0, 3, 0, 
      0.3, 3, 1
    } );

  end;
  -- GET ---------------------------------------------------------------------------------------
  function private.get_coin_ext_2 ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_coin_ext_2" );
    cmn.CallEventHandler( "get_coin_ext_2", "inv_bill" );

    if ( cmn.IsEventDone( "get_chewinggum" ) ) then

      common_impl.HideDeployInv();

    end;

  end;
  -- GET ---------------------------------------------------------------------------------------
  function private.get_chewinggum ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_chewinggum" );
    cmn.CallEventHandler( "get_chewinggum", "inv_bill" );

    if ( cmn.IsEventDone( "get_coin_ext_2" ) ) then

      common_impl.HideDeployInv();

    end;

  end;
  ----------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** amuletmelodypart *** () end;
--*********************************************************************************************************************
  function private.amuletmelodypart_init ()
    --------------------------------------------------------------------------------------------
    ObjMultiSet( { 
      { "spr_deploy_inv_amuletmelodypart_amuletmelody",             { event_mdown = private.get_amuletmelody } },
      { "obj_deploy_inv_amuletmelodypart_clk_chewinggum_1",         { event_mdown = private.clk_chewinggum_1 } },
      { "obj_deploy_inv_amuletmelodypart_clk_chewinggum_2",         { event_mdown = private.clk_chewinggum_2 } },
      { "obj_deploy_inv_amuletmelodypart_clk_chewinggum_3",         { event_mdown = private.clk_chewinggum_3 } },
      { "obj_deploy_inv_amuletmelodypart_clk_amuletmelodypart2",    { event_mdown = private.clk_amuletmelodypart2 } },

    } );

    -- USE -------------------------------------------------------------------------------------
    common_impl.hint[ "use_chewinggum" ] = {
        type = "use",
        inv_obj = "inv_chewinggum",
        use_place = "obj_deploy_inv_amuletmelodypart_use_chewinggum",
        room = "int_deploy_inv",
        zz = "deploy_inv_amuletmelodypart",
        zz_gate = "inv_amuletmelodypart"
    };    
    function use_chewinggum_beg ()
      
      ObjDelete( "obj_deploy_inv_amuletmelodypart_use_chewinggum" );
      interface.InventoryItemRemove( "inv_chewinggum" );

    end;
    function use_chewinggum_end ()
    
      ObjSet( "spr_deploy_inv_amuletmelodypart_gum_close", { alp = 1, visible = true } );
      ObjSet( "obj_deploy_inv_amuletmelodypart_clk_chewinggum_1", { input = true } );

    end;
    cmn.AddSubscriber( "use_chewinggum", use_chewinggum_beg );
    cmn.AddSubscriber( "use_chewinggum", use_chewinggum_end, "inv_amuletmelodypart" );
    cmn.AddSubscriber( "use_chewinggum_beg", use_chewinggum_beg );
    cmn.AddSubscriber( "use_chewinggum_end", use_chewinggum_end, "inv_amuletmelodypart" );
    -- USE -------------------------------------------------------------------------------------
    common_impl.hint[ "use_amuletmelodypart2" ] = {
        type = "use",
        inv_obj = "inv_amuletmelodypart2",
        use_place = "obj_deploy_inv_amuletmelodypart_use_amuletmelodypart2",
        room = "int_deploy_inv",
        zz = "deploy_inv_amuletmelodypart",
        zz_gate = "inv_amuletmelodypart"
    };    
    function use_amuletmelodypart2_beg ()
      
      ObjDelete( "obj_deploy_inv_amuletmelodypart_use_amuletmelodypart2" );
      interface.InventoryItemRemove( "inv_amuletmelodypart2" );

    end;
    function use_amuletmelodypart2_end ()
    
      ObjSet( "spr_deploy_inv_amuletmelodypart_top_amulet", { alp = 1, visible = true } );

      if cmn.IsEventDone( "clk_chewinggum_3" ) then 
        ObjSet( "obj_deploy_inv_amuletmelodypart_clk_amuletmelodypart2", { input = true } );
      end;

    end;
    cmn.AddSubscriber( "use_amuletmelodypart2", use_amuletmelodypart2_beg );
    cmn.AddSubscriber( "use_amuletmelodypart2", use_amuletmelodypart2_end, "inv_amuletmelodypart" );
    cmn.AddSubscriber( "use_amuletmelodypart2_beg", use_amuletmelodypart2_beg );
    cmn.AddSubscriber( "use_amuletmelodypart2_end", use_amuletmelodypart2_end, "inv_amuletmelodypart" );
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_amuletmelody" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_amuletmelodypart_amuletmelody",
        room = "int_deploy_inv",
        zz = "deploy_inv_amuletmelodypart",
        zz_gate = "inv_amuletmelodypart"
    };
    function get_amuletmelody_inv ()
      
      interface.InventoryItemAdd( "inv_amuletmelody", "spr_deploy_inv_amuletmelodypart_amuletmelody" );
      interface.InventoryItemRemove( "inv_amuletmelodypart" );

    end;
    cmn.AddSubscriber( "get_amuletmelody", get_amuletmelody_inv );

    --------------------------------------------------------------------------------------------
    -- function clk_chewinggum_1 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_chewinggum_1" ] = {
        type = "click",
        use_place = "obj_deploy_inv_amuletmelodypart_clk_chewinggum_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_amuletmelodypart",
        zz_gate = "inv_amuletmelodypart"
    };

    local clk_chewinggum_1_beg = function ()

      ObjDelete( "obj_deploy_inv_amuletmelodypart_clk_chewinggum_1" );

    end;
    local clk_chewinggum_1_end = function ()

      ObjSet( "spr_deploy_inv_amuletmelodypart_gum_preopen", { alp = 1, visible = true } );
      ObjSet( "obj_deploy_inv_amuletmelodypart_clk_chewinggum_2", { input = true } );
      ObjDelete( "spr_deploy_inv_amuletmelodypart_gum_close" );

    end;

    cmn.AddSubscriber( "clk_chewinggum_1", clk_chewinggum_1_beg, "inv_amuletmelodypart" );
    cmn.AddSubscriber( "clk_chewinggum_1", clk_chewinggum_1_end, "inv_amuletmelodypart" );
    cmn.AddSubscriber( "clk_chewinggum_1_beg", clk_chewinggum_1_beg, "inv_amuletmelodypart" );
    cmn.AddSubscriber( "clk_chewinggum_1_end", clk_chewinggum_1_end, "inv_amuletmelodypart" );

    --------------------------------------------------------------------------------------------
    -- function clk_chewinggum_2 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_chewinggum_2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_amuletmelodypart_clk_chewinggum_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_amuletmelodypart",
        zz_gate = "inv_amuletmelodypart"
    };

    local clk_chewinggum_2_beg = function ()

      ObjDelete( "obj_deploy_inv_amuletmelodypart_clk_chewinggum_2" );

    end;
    local clk_chewinggum_2_end = function ()

      ObjSet( "spr_deploy_inv_amuletmelodypart_gum_open", { alp = 1, visible = true } );
      ObjSet( "obj_deploy_inv_amuletmelodypart_clk_chewinggum_3", { input = true } );
      ObjDelete( "spr_deploy_inv_amuletmelodypart_gum_preopen" );

    end;

    cmn.AddSubscriber( "clk_chewinggum_2", clk_chewinggum_2_beg, "inv_amuletmelodypart" );
    cmn.AddSubscriber( "clk_chewinggum_2", clk_chewinggum_2_end, "inv_amuletmelodypart" );
    cmn.AddSubscriber( "clk_chewinggum_2_beg", clk_chewinggum_2_beg, "inv_amuletmelodypart" );
    cmn.AddSubscriber( "clk_chewinggum_2_end", clk_chewinggum_2_end, "inv_amuletmelodypart" );

    --------------------------------------------------------------------------------------------
    -- function clk_chewinggum_3 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_chewinggum_3" ] = {
        type = "click",
        use_place = "obj_deploy_inv_amuletmelodypart_clk_chewinggum_3",
        room = "int_deploy_inv",
        zz = "deploy_inv_amuletmelodypart",
        zz_gate = "inv_amuletmelodypart"
    };

    local clk_chewinggum_3_beg = function ()

      ObjDelete( "obj_deploy_inv_amuletmelodypart_clk_chewinggum_3" );

      cmn.SetInvPlusRGB( "amuletmelodypart", false );
      if ( cmn.IsEventDone( "use_amuletmelodypart2" ) or cmn.IsEventDone( "get_amuletmelodypart2" ) ) then

        cmn.SetInvPlusRGB( "amuletmelodypart", true );

      end;

    end;
    local clk_chewinggum_3_end = function ()

      ObjSet( "spr_deploy_inv_amuletmelodypart_pieces_gum", { alp = 1, visible = true } );
      ObjDelete( "spr_deploy_inv_amuletmelodypart_gum_piece" );

      if cmn.IsEventDone( "use_amuletmelodypart2" ) then 

        ObjSet( "obj_deploy_inv_amuletmelodypart_clk_amuletmelodypart2", { input = true } );

      end;

    end;

    cmn.AddSubscriber( "clk_chewinggum_3", clk_chewinggum_3_beg, "inv_amuletmelodypart" );
    cmn.AddSubscriber( "clk_chewinggum_3", clk_chewinggum_3_end, "inv_amuletmelodypart" );
    cmn.AddSubscriber( "clk_chewinggum_3_beg", clk_chewinggum_3_beg, "inv_amuletmelodypart" );
    cmn.AddSubscriber( "clk_chewinggum_3_end", clk_chewinggum_3_end, "inv_amuletmelodypart" );

    --------------------------------------------------------------------------------------------
    -- function clk_amuletmelodypart2 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_amuletmelodypart2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_amuletmelodypart_clk_amuletmelodypart2",
        room = "int_deploy_inv",
        zz = "deploy_inv_amuletmelodypart",
        zz_gate = "inv_amuletmelodypart"
    };

    local clk_amuletmelodypart2_beg = function ()

      ObjDelete( "obj_deploy_inv_amuletmelodypart_clk_amuletmelodypart2" );
      cmn.SetInvPlusRGB( "amuletmelodypart", false );
      if ( cmn.IsEventDone( "get_chewinggum" ) or cmn.IsEventDone( "use_chewinggum" ) ) then

        cmn.SetInvPlusRGB( "amuletmelodypart", true );

      end;

    end;
    local clk_amuletmelodypart2_end = function ()

      ObjSet( "spr_deploy_inv_amuletmelodypart_top_amulet", { pos_x = 88, pos_y = -57 } );
      ObjSet( "spr_deploy_inv_amuletmelodypart_amuletmelody", { input = true } );
      ObjSet( "gfx_deploy_inv_amuletmelodypart_amuletmelody", { active = true } );      

    end;

    cmn.AddSubscriber( "clk_amuletmelodypart2", clk_amuletmelodypart2_beg, "inv_amuletmelodypart" );
    cmn.AddSubscriber( "clk_amuletmelodypart2", clk_amuletmelodypart2_end, "inv_amuletmelodypart" );
    cmn.AddSubscriber( "clk_amuletmelodypart2_beg", clk_amuletmelodypart2_beg, "inv_amuletmelodypart" );
    cmn.AddSubscriber( "clk_amuletmelodypart2_end", clk_amuletmelodypart2_end, "inv_amuletmelodypart" );

  end;
  -- USE ---------------------------------------------------------------------------------------
  function public.use_chewinggum ()

    local item = "inv_chewinggum";

    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_amuletmelodypart_use_chewinggum" ) )  then

      cmn.CallEventHandler( "use_chewinggum_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_chewinggum" );
        cmn.CallEventHandler( "use_chewinggum_end", "inv_amuletmelodypart" );
        
      end;

      cmn.Lock( true );

      common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );

      ObjSet( "spr_deploy_inv_amuletmelodypart_gum_close", { alp = 0, visible = true } );
      ObjAnimate( "spr_deploy_inv_amuletmelodypart_gum_close", "alp",0,0, func_end, { 0, 0, 0,    0.6, 0, 1 } );

      return true; 

    end;

    return false;

  end;
  -- USE ---------------------------------------------------------------------------------------
  function public.use_amuletmelodypart2 ()

    local item = "inv_amuletmelodypart2";

    if ( private.ObjIntersectCheck( item, "obj_deploy_inv_amuletmelodypart_use_amuletmelodypart2" ) )  then

      cmn.CallEventHandler( "use_amuletmelodypart2_beg" );

      local func_end = function ()
        
        cmn.Lock( false );
        cmn.SetEventDone( "use_amuletmelodypart2" );
        cmn.CallEventHandler( "use_amuletmelodypart2_end", "inv_amuletmelodypart" );
        
      end;

      cmn.Lock( true );
      common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );
      
      ObjSet( "spr_deploy_inv_amuletmelodypart_top_amulet", { alp = 0, visible = true } );
      ObjAnimate( "spr_deploy_inv_amuletmelodypart_top_amulet", "alp",0,0, func_end, { 0, 0, 0,    0.6, 0, 1 } );

      return true; 

    end;

    return false;

  end;
  -- GET ---------------------------------------------------------------------------------------
  function private.get_amuletmelody ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_amuletmelody" );
    cmn.CallEventHandler( "get_amuletmelody", "inv_amuletmelodypart" );
    common_impl.HideDeployInv();

  end;
  -- CLK ------------------------------------------------------------------------------------
  function private.clk_chewinggum_1 ()

    cmn.CallEventHandler( "clk_chewinggum_1_beg", "inv_amuletmelodypart" );

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.SetEventDone( "clk_chewinggum_1" );
      cmn.CallEventHandler( "clk_chewinggum_1_end", "inv_amuletmelodypart" );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx" );

    ObjAnimate( "spr_deploy_inv_amuletmelodypart_gum_close", "alp",0,0, "", { 0, 2, 1,    0.6, 2, 0 } );  
    ObjSet( "spr_deploy_inv_amuletmelodypart_gum_preopen", { alp = 0, visible = true } );
    ObjAnimate( "spr_deploy_inv_amuletmelodypart_gum_preopen", "alp",0,0, func_end, { 0, 1, 0,    0.6, 1, 1 } );    

  end;

  -- CLK ------------------------------------------------------------------------------------
  function private.clk_chewinggum_2 ()

    cmn.CallEventHandler( "clk_chewinggum_2_beg", "inv_amuletmelodypart" );

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.SetEventDone( "clk_chewinggum_2" );
      cmn.CallEventHandler( "clk_chewinggum_2_end", "inv_amuletmelodypart" );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx" );

    ObjAnimate( "spr_deploy_inv_amuletmelodypart_gum_preopen", "alp",0,0, "", { 0, 2, 1,    0.6, 2, 0 } );  
    ObjSet( "spr_deploy_inv_amuletmelodypart_gum_open", { alp = 0, visible = true } );
    ObjAnimate( "spr_deploy_inv_amuletmelodypart_gum_open", "alp",0,0, func_end, { 0, 1, 0,    0.6, 1, 1 } );    

  end;

  -- CLK ------------------------------------------------------------------------------------
  function private.clk_chewinggum_3 ()

    cmn.CallEventHandler( "clk_chewinggum_3_beg", "inv_amuletmelodypart" );

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.SetEventDone( "clk_chewinggum_3" );
      cmn.CallEventHandler( "clk_chewinggum_3_end", "inv_amuletmelodypart" );
      
    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx" );

    ObjAnimate( "spr_deploy_inv_amuletmelodypart_gum_piece", "alp",0,0, "", { 0, 2, 1,    0.6, 2, 0 } );  
    ObjSet( "spr_deploy_inv_amuletmelodypart_pieces_gum", { alp = 0, visible = true } );
    ObjAnimate( "spr_deploy_inv_amuletmelodypart_pieces_gum", "alp",0,0, func_end, { 0, 1, 0,    0.6, 1, 1 } );    

  end;

  -- CLK ------------------------------------------------------------------------------------
  function private.clk_amuletmelodypart2 ()

    cmn.CallEventHandler( "clk_amuletmelodypart2_beg", "inv_amuletmelodypart" );

    local func_end = function ()
      
      cmn.Lock( false );

      cmn.SetEventDone( "clk_amuletmelodypart2" );
      cmn.CallEventHandler( "clk_amuletmelodypart2_end", "inv_amuletmelodypart" );
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx" );

    ObjAnimate( "spr_deploy_inv_amuletmelodypart_top_amulet", "pos_xy",0,0, func_end, { 0, 3, 197, -95,    0.6, 3, 88, -57 } );    

  end;


--*********************************************************************************************************************
-- function *** phoenixfigure *** () end;
--*********************************************************************************************************************
  function private.phoenixfigure_init()
    --------------------------------------------------------------------------------------------
    ObjMultiSet( { 
      { "spr_deploy_inv_phoenixfigure_wheel",           { event_mdown = private.get_wheel     } },
      { "obj_deploy_inv_phoenixfigure_clk_phoenix_1",   { event_mdown = private.clk_phoenix_1 } },
      { "obj_deploy_inv_phoenixfigure_clk_phoenix_2",   { event_mdown = private.clk_phoenix_2 } },
    } );
     -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_phoenix_1" ] = {
        type = "click",
        use_place = "obj_deploy_inv_phoenixfigure_clk_phoenix_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_phoenixfigure",
        zz_gate = "inv_phoenixfigure"
    };
    function clk_phoenix_1 ()

      ObjDelete( "obj_deploy_inv_phoenixfigure_clk_phoenix_1" );
      ObjSet( "spr_deploy_inv_phoenixfigure_wing_1", { ang = -0.29 } );
  
      if ( cmn.IsEventDone( "clk_phoenix_2" ) ) then

        ObjSet( "spr_deploy_inv_phoenixfigure_wheel", { input = true } );
        ObjSet( "spr_deploy_inv_phoenixfigure_body_2", { ang = 0.45 } );
        ObjSet( "spr_deploy_inv_phoenixfigure_button_light", { alp = 1 } );

      end;

    end;
    cmn.AddSubscriber( "clk_phoenix_1", clk_phoenix_1, "inv_phoenixfigure" );
     -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_phoenix_2" ] = {
        type = "click",
        use_place = "obj_deploy_inv_phoenixfigure_clk_phoenix_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_phoenixfigure",
        zz_gate = "inv_phoenixfigure"
    };
    function clk_phoenix_2 ()

      ObjDelete( "obj_deploy_inv_phoenixfigure_clk_phoenix_2" );
      ObjSet( "spr_deploy_inv_phoenixfigure_wing_2", { ang = 0.44 } );

      if ( cmn.IsEventDone( "clk_phoenix_1" ) ) then

        ObjSet( "spr_deploy_inv_phoenixfigure_wheel", { input = true } );
        ObjSet( "spr_deploy_inv_phoenixfigure_body_2", { ang = 0.45 } );
        ObjSet( "spr_deploy_inv_phoenixfigure_button_light", { alp = 1 } );

      end;

    end;
    cmn.AddSubscriber( "clk_phoenix_2", clk_phoenix_2, "inv_phoenixfigure" );
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_wheel" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_phoenixfigure_wheel",
        room = "int_deploy_inv",
        zz = "deploy_inv_phoenixfigure",
        zz_gate = "inv_phoenixfigure"
    };
    function get_wheel_inv ()
      
      interface.InventoryItemAdd( "inv_wheel", "spr_deploy_inv_phoenixfigure_wheel" );
      interface.InventoryItemRemove( "inv_phoenixfigure" );

    end;
    cmn.AddSubscriber( "get_wheel", get_wheel_inv );

  end;
  -- GET ---------------------------------------------------------------------------------------
  function private.get_wheel ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.Lock( false );
    cmn.SetEventDone( "get_wheel" );
    cmn.CallEventHandler( "get_wheel", "inv_phoenixfigure" );
    common_impl.HideDeployInv();

  end;
  -- CLK ---------------------------------------------------------------------------------------
  function private.clk_phoenix_1 ()

    local func_end = function ()
      
      cmn.Lock( false );
      cmn.SetEventDone( "clk_phoenix_1" );
      cmn.CallEventHandler( "clk_phoenix_1", "inv_phoenixfigure" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_phoenix_1", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_phoenixfigure_wing_1", "ang", 0, 0, func_end, 
    { 
      0.0, 0, 0, 
      0.4, 0, 0, 
      0.8, 0, -0.29
    } );

    if ( cmn.IsEventDone( "clk_phoenix_2" ) ) then

      ObjAnimate( "spr_deploy_inv_phoenixfigure_button_light", "alp", 0, 0, "", 
      { 
        0.0, 0, 0, 
        0.1, 0, 1, 
        0.2, 0, 0, 
        0.3, 0, 1, 
      } );
      ObjAnimate( "spr_deploy_inv_phoenixfigure_body_2", "ang", 0, 0, "", 
      { 
        0.0, 0, 0, 
        0.4, 0, 0, 
        0.8, 0, 0.45
      } );

    end;

  end;
  -- CLK ---------------------------------------------------------------------------------------
  function private.clk_phoenix_2 ()

    local func_end = function ()
      
      cmn.Lock( false );
      cmn.SetEventDone( "clk_phoenix_2" );
      cmn.CallEventHandler( "clk_phoenix_2", "inv_phoenixfigure" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_phoenix_1", 0, "", 0 );

    ObjAnimate( "spr_deploy_inv_phoenixfigure_wing_2", "ang", 0, 0, func_end, 
    { 
      0.0, 0, 0, 
      0.4, 0, 0, 
      0.8, 0, 0.44
    } );

    if ( cmn.IsEventDone( "clk_phoenix_1" ) ) then

      ObjAnimate( "spr_deploy_inv_phoenixfigure_button_light", "alp", 0, 0, "", 
      { 
        0.0, 0, 0, 
        0.1, 0, 1, 
        0.2, 0, 0, 
        0.3, 0, 1, 
      } );
      ObjAnimate( "spr_deploy_inv_phoenixfigure_body_2", "ang", 0, 0, "", 
      { 
        0.0, 0, 0, 
        0.4, 0, 0, 
        0.8, 0, 0.45
      } );
  
    end;

  end;
--*********************************************************************************************************************
-- function *** brochure *** () end;
--*********************************************************************************************************************
  function private.brochure_init ()
    --------------------------------------------------------------------------------------------
    ObjMultiSet( {  
      { "obj_deploy_inv_brochure_clk_brochure_front",     { event_mdown = private.clk_brochure_front } },
      { "obj_deploy_inv_brochure_clk_brochure_back",      { event_mdown = private.clk_brochure_back } },
      { "spr_deploy_inv_brochure_oneoffpass2",            { event_mdown = private.get_oneoffpass2 } },
    } );
     -- CLK -------------------------------------------------------------------------------------
    common_impl.hint[ "clk_brochure_front" ] = {
        type = "click",
        use_place = "obj_deploy_inv_brochure_clk_brochure_front",
        room = "int_deploy_inv",
        zz = "deploy_inv_brochure",
        zz_gate = "inv_brochure"
    };
    function clk_brochure_front ()

      ObjDelete( "obj_deploy_inv_brochure_clk_brochure_front" );
      ObjDelete( "spr_deploy_inv_brochure_front" );
      ObjSet( "obj_deploy_inv_brochure_back", { alp = 1 } );
      ObjSet( "obj_deploy_inv_brochure_clk_brochure_back", { input = true } );

    end;
    cmn.AddSubscriber( "clk_brochure_front", clk_brochure_front, "inv_brochure" );  
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_brochure_back" ] = {
        type = "click",
        use_place = "obj_deploy_inv_brochure_clk_brochure_back",
        room = "int_deploy_inv",
        zz = "deploy_inv_brochure",
        zz_gate = "inv_brochure"
    };
    function clk_brochure_back ()

      ObjDelete( "obj_deploy_inv_brochure_clk_brochure_back" );
      ObjSet( "spr_deploy_inv_brochure_oneoffpass2", { pos_x = -24, pos_y = -156, input = true } );

    end;
    cmn.AddSubscriber( "clk_brochure_back", clk_brochure_back, "inv_brochure" );  
    -- GET -------------------------------------------------------------------------------------
    common_impl.hint[ "get_oneoffpass2" ] = {
        type = "get",
        get_obj = "spr_deploy_inv_brochure_oneoffpass2",
        room = "int_deploy_inv",
        zz = "deploy_inv_brochure",
        zz_gate = "inv_brochure"
    };
    function get_oneoffpass2_inv ()
      
      interface.InventoryItemAdd( "inv_oneoffpass2", "spr_deploy_inv_brochure_oneoffpass2" );
      interface.InventoryItemRemove( "inv_brochure" );

    end;
    cmn.AddSubscriber( "get_oneoffpass2", get_oneoffpass2_inv );

  end;
  -- GET ---------------------------------------------------------------------------------------
  function private.get_oneoffpass2 ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_oneoffpass2" );
    cmn.CallEventHandler( "get_oneoffpass2", "inv_brochure" );
    common_impl.HideDeployInv();

  end;
  -- CLK ---------------------------------------------------------------------------------------
  function private.clk_brochure_front ()

    local func_end = function ()
      
      cmn.Lock( false );
      cmn.SetEventDone( "clk_brochure_front" );
      cmn.CallEventHandler( "clk_brochure_front", "inv_brochure" );

    end;

    cmn.Lock( true );

    ObjAnimate( "spr_deploy_inv_brochure_front", "alp", 0, 0, "", 
    { 
      0.0, 0, 1, 
      0.3, 0, 0
    } );

    ObjAnimate( "obj_deploy_inv_brochure_back", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0, 
      0.3, 0, 1
    } );

  end;
  -----------------------------------------------------------------------------------------
  function private.clk_brochure_back ()

    local func_end = function ()
      
      cmn.Lock( false );
      cmn.SetEventDone( "clk_brochure_back" );
      cmn.CallEventHandler( "clk_brochure_back", "inv_brochure" );

    end;

    cmn.Lock( true );

    ObjAnimate( "spr_deploy_inv_brochure_oneoffpass2", "pos_xy", 0, 0, func_end, 
    { 
      0.0, 0, 4, 46, 
      0.5, 0, -24, -156
    } );

  end;
  

