-- name=rm_apartment
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_apartment";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_closet", "room_hub" );
  ObjAttach( "zz_shoeshelf", "room_hub" );
  ObjAttach( "zz_coffeetable_ext", "room_hub" );
  ObjAttach( "zz_safe", "room_hub" );
  ObjAttach( "zz_kitchen", "room_hub" );
  ObjAttach( "zz_kitchen_2", "room_hub" );

  private.Init_Subroom();
  private.Init_Animation();
  private.InitSafe();

  ObjMultiSet( { 
    { "spr_closet_apartmentkey",                      { event_mdown  = private.get_apartmentkey       } },
    { "spr_shoeshelf_holeyboot",                      { event_mdown  = private.get_holeyboot          } },
    { "spr_coffeetable_ext_officeaddress",            { event_mdown  = private.get_officeaddress      } },
    { "spr_coffeetable_ext_envelopeknife",            { event_mdown  = private.get_envelopeknife      } },
    { "spr_coffeetable_ext_pen",                      { event_mdown  = private.get_pen                } },
    { "spr_safe_trinket",                             { event_mdown  = private.get_trinket            } },
    { "spr_safe_patternelement",                      { event_mdown  = private.get_patternelement     } },
    { "spr_safe_externaldisk",                        { event_mdown  = private.get_externaldisk       } },
    { "spr_safe_lighter",                             { event_mdown  = private.get_lighter            } },
    { "spr_kitchen_firstaidkit",                      { event_mdown  = private.get_firstaidkit        } },
    { "spr_kitchen_can",                              { event_mdown  = private.get_can                } },
    { "spr_kitchen_canopener",                        { event_mdown  = private.get_canopener          } },
    { "spr_kitchen_oilcan_ext",                       { event_mdown  = private.get_oilcan_ext         } },
    { "spr_kitchen_code",                             { event_mdown  = private.get_code               } },
    { "obj_apartment_clk_josh_fraser",                { event_mdown  = private.dlg_josh_fraser_click  } },
    { "obj_apartment_clk_josh_fraser_focus",          { event_mdown  = private.dlg_josh_fraser_click  } },
    { "obj_coffeetable_ext_clk_david_kane_1",         { event_mdown  = private.see_call_kane_1        } },
    { "obj_safe_use_tweezers_ext",                    { event_mdown  = private.UseTweezers_ext        } },
    { "obj_safe_use_tobiasamulet",                    { event_mdown  = private.UseTobiasamulet        } },
    { "obj_closet_clk_patternelement",                { event_mdown  = private.clk_patternelement     } },
    { "obj_closet_use_patternelement",                { event_mdown  = private.UsePatternelement      } },
    { "obj_shoeshelf_use_apartmentkey",               { event_mdown  = private.UseApartmentkey        } },
    { "obj_shoeshelf_use_oilcan_ext_1",               { event_mdown  = private.UseOilcan_ext_1        } },
    { "obj_kitchen_clk_kitchen_switch",               { event_mdown  = private.clk_kitchen_switch     } },
    { "obj_kitchen_clk_screwdriverknife",             { event_mdown  = private.clk_screwdriverknife   } },
    { "obj_kitchen_clk_oilcan_ext",                   { event_mdown  = private.clk_oilcan_ext         } },
    { "obj_apartment_cat",                            { event_mdown  = private.clkCat                 } },
    { "obj_kitchen_use_screwdriverknife",             { event_mdown  = private.UseScrewdriverknife    } },
    { "obj_kitchen_use_clip",                         { event_mdown  = private.clk_obj_use_clip       } },
    { "spr_apartment_collect_morph_item",             { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_4_1" ); end } },
    { "obj_shoeshelf_clk_apartmentkey",               { event_mdown = private.clk_apartment_key       } },

  } );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_apartment = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "gho_apartment_itemscollecting",
      "gzz_apartment_closet",
      "gzz_apartment_shoeshelf",
      "gzz_apartment_coffeetable_ext",
      "gzz_apartment_safe",
      "gzz_apartment_kitchen",
      "gzz_apartment_kitchen_2",
      "grm_apartment_parkinglot",
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_closet",
      "zz_shoeshelf",
      "zz_coffeetable_ext",
      "zz_safe",
      "zz_kitchen",
      "zz_kitchen_2",
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_apartment", update_game_mode_apartment, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_apartment = function ()

  local effects_table = 
  {
    "obj_apartment_anim" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_apartment", update_performance_mode_apartment, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_apartment () end;
  --------------------------------------------------------------------------------------------
  local opn_apartment = function ()


  end;
  local opn_apartment_map = function ()

    common_impl.VisitMapRoom( "apartment" );

  end;
  cmn.AddSubscriber( "opn_apartment", opn_apartment_map );
  cmn.AddSubscriber( "opn_apartment", opn_apartment, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_apartmentkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_apartmentkey" ] = {
    type = "get",
    get_obj = "spr_closet_apartmentkey_thread",
    room = private.room_objname,
    zz = "zz_closet",
    zz_gate = "gzz_apartment_closet"
  };
  
  local get_apartmentkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_apartmentkey", "spr_closet_apartmentkey" );
  
  end;
  
  local get_apartmentkey_closezz = function ()
  
    ObjDelete( "gfx_closet_apartmentkey" );
    ObjDelete( "spr_closet_apartmentkey_thread" );
    ObjDelete( "spr_apartment_closet_patch_key" );

  end;
  
  cmn.AddSubscriber( "get_apartmentkey", get_apartmentkey_inv );
  cmn.AddSubscriber( "get_apartmentkey", get_apartmentkey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_holeyboot () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_holeyboot" ] = {
    type = "get",
    get_obj = "spr_shoeshelf_holeyboot",
    room = private.room_objname,
    zz = "zz_shoeshelf",
    zz_gate = "gzz_apartment_shoeshelf"
  };
  
  local get_holeyboot_inv = function ()
  
    interface.InventoryItemAdd( "inv_holeyboot", "spr_shoeshelf_holeyboot" );
    ObjSet( "inv_holeyboot", { drag = false } );    
    cmn.SetInvPlusRGB( "holeyboot", true ); 

  end;
  
  local get_holeyboot_closezz = function ()
  
    ObjDelete( "gfx_shoeshelf_holeyboot" );
    ObjDelete( "gzz_apartment_shoeshelf" );
    ObjDelete( "spr_shoeshelf_old_boot_shadow" );
    ObjDelete( "spr_apartment_shoeshelf_patch_shoe" );

  end;
  
  cmn.AddSubscriber( "get_holeyboot", get_holeyboot_inv );
  cmn.AddSubscriber( "get_holeyboot", get_holeyboot_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_officeaddress () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_officeaddress" ] = {
    type = "get",
    get_obj = "spr_coffeetable_ext_officeaddress",
    room = private.room_objname,
    zz = "zz_coffeetable_ext",
    zz_gate = "gzz_apartment_coffeetable_ext"
  };
  
  local get_officeaddress_inv = function ()
  
    interface.InventoryItemAdd( "inv_officeaddress", "spr_coffeetable_ext_officeaddress" );
  
  end;
  
  local get_officeaddress_closezz = function ()
  
    ObjDelete( "gfx_coffeetable_ext_officeaddress" );

    if ( cmn.IsEventDone( "use_taxinumber" ) ) then

      ObjDelete( "gzz_apartment_coffeetable_ext" );  

    end;

  end;
  
  cmn.AddSubscriber( "get_officeaddress", get_officeaddress_inv );
  cmn.AddSubscriber( "get_officeaddress", get_officeaddress_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_envelopeknife () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_envelopeknife" ] = {
    type = "get",
    get_obj = "spr_coffeetable_ext_envelopeknife",
    room = private.room_objname,
    zz = "zz_coffeetable_ext",
    zz_gate = "gzz_apartment_coffeetable_ext"
  };
  
  local get_envelopeknife_inv = function ()
  
    interface.InventoryItemAdd( "inv_envelopeknife", "spr_coffeetable_ext_envelopeknife" );
    cmn.SetInvPlusRGB( "letter", true );  
  
  end;
  
  local get_envelopeknife_closezz = function ()
    
    ObjSet( "spr_apartment_coffeetable_ext_patch_noknife", { alp = 1 } );
    ObjDelete( "gfx_coffeetable_ext_envelopeknife" );
    ObjDelete( "spr_apartment_coffeetable_ext_patch_knife" );

  end;
  
  cmn.AddSubscriber( "get_envelopeknife", get_envelopeknife_inv );
  cmn.AddSubscriber( "get_envelopeknife", get_envelopeknife_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pen () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pen" ] = {
    type = "get",
    get_obj = "spr_coffeetable_ext_pen",
    room = private.room_objname,
    zz = "zz_coffeetable_ext",
    zz_gate = "gzz_apartment_coffeetable_ext"
  };
  
  local get_pen_inv = function ()
  
    interface.InventoryItemAdd( "inv_pen", "spr_coffeetable_ext_pen" );
  
  end;
  
  local get_pen_closezz = function ()
  
    ObjDelete( "gfx_coffeetable_ext_pen" );
  
  end;
  
  cmn.AddSubscriber( "get_pen", get_pen_inv );
  cmn.AddSubscriber( "get_pen", get_pen_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_trinket () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_trinket" ] = {
    type = "get",
    get_obj = "spr_safe_trinket_shadow",
    room = private.room_objname,
    zz = "zz_safe",
    zz_gate = "gzz_apartment_safe"
  };
  
  local get_trinket_inv = function ()
  
    interface.InventoryItemAdd( "inv_trinket", "spr_safe_trinket" );
    cmn.SetInvPlusRGB( "firstaidkit", true );
  
  end;
  
  local get_trinket_closezz = function ()
  
    ObjDelete( "gfx_safe_trinket" );
    ObjDelete( "spr_safe_trinket_shadow" );

    if ( cmn.IsEventDone( "win_safe" ) ) then

        ObjMultiSet( { 
        { "gfx_safe_externaldisk",            { active = true, alp = 1 } },   
        { "obj_safe_safe_door_open",          { input = true } },   
        { "obj_safe_use_tweezers_ext",        { input = true, alp = 1 } }, 
        { "spr_apartment_patch_safe_open",    { alp = 1 } },
      } ); 

      ObjDelete( "obj_safe_safe_door_close" );
      ObjDelete( "spr_apartment_safe_patch_safe" ); 

    end;

  end;
  cmn.AddSubscriber( "get_trinket", get_trinket_inv );
  cmn.AddSubscriber( "get_trinket", get_trinket_closezz, private.room_objname );
  cmn.AddSubscriber( "get_trinket_inv", get_trinket_inv, private.room_objname );
  cmn.AddSubscriber( "get_trinket_closezz", get_trinket_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_patternelement () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_patternelement" ] = {
    type = "get",
    get_obj = "spr_safe_patternelement",
    room = private.room_objname,
    zz = "zz_safe",
    zz_gate = "gzz_apartment_safe"
  };
  
  local get_patternelement_inv = function ()
  
    interface.InventoryItemAdd( "inv_patternelement", "spr_safe_patternelement" );
  
  end;
  
  local get_patternelement_closezz = function ()
  
    ObjDelete( "gfx_safe_patternelement" );

    if ( cmn.IsEventDone( "get_externaldisk" ) ) then

      ObjDelete( "gzz_apartment_safe" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_patternelement", get_patternelement_inv );
  cmn.AddSubscriber( "get_patternelement", get_patternelement_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_externaldisk () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_externaldisk" ] = {
    type = "get",
    get_obj = "spr_safe_externaldisk",
    room = private.room_objname,
    zz = "zz_safe",
    zz_gate = "gzz_apartment_safe"
  };
  
  local get_externaldisk_inv = function ()
  
    interface.InventoryItemAdd( "inv_externaldisk", "spr_safe_externaldisk" );
  
  end;
  
  local get_externaldisk_closezz = function ()
  
    ObjDelete( "gfx_safe_externaldisk" );
    ObjDelete( "spr_safe_externaldisk_shadow" );
    ObjDelete( "spr_apartment_safe_patch_externaldisk_safe" );

    if ( cmn.IsEventDone( "get_patternelement" ) ) then

      ObjDelete( "gzz_apartment_safe" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_externaldisk", get_externaldisk_inv );
  cmn.AddSubscriber( "get_externaldisk", get_externaldisk_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lighter () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lighter" ] = {
    type = "get",
    get_obj = "spr_safe_lighter",
    room = private.room_objname,
    zz = "zz_safe",
    zz_gate = "gzz_apartment_safe"
  };
  
  local get_lighter_inv = function ()
  
    interface.InventoryItemAdd( "inv_lighter", "spr_safe_lighter" );
  
  end;
  
  local get_lighter_closezz = function ()
  
    ObjDelete( "gfx_safe_lighter" );
    ObjDelete( "spr_safe_lighter_shadow" );  
    ObjDelete( "spr_apartment_safe_patch_lighter_safe" );

  end;
  
  cmn.AddSubscriber( "get_lighter", get_lighter_inv );
  cmn.AddSubscriber( "get_lighter", get_lighter_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_firstaidkit () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_firstaidkit" ] = {
    type = "get",
    get_obj = "spr_kitchen_firstaidkit",
    room = private.room_objname,
    zz = "zz_kitchen",
    zz_gate = "gzz_apartment_kitchen"
  };
  
  local get_firstaidkit_inv = function ()
  
    interface.InventoryItemAdd( "inv_firstaidkit", "spr_kitchen_firstaidkit" );
    ObjSet( "inv_firstaidkit", { drag = false } );

    cmn.SetInvPlusRGB( "firstaidkit", false );  
    if ( cmn.IsEventDone( "get_trinket" ) ) then

      cmn.SetInvPlusRGB( "firstaidkit", true );  

    end; 
  
  end;
  
  local get_firstaidkit_closezz = function ()
  
    ObjDelete( "gfx_kitchen_firstaidkit" );
  
  end;
  
  cmn.AddSubscriber( "get_firstaidkit", get_firstaidkit_inv );
  cmn.AddSubscriber( "get_firstaidkit", get_firstaidkit_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_can () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_can" ] = {
    type = "get",
    get_obj = "spr_kitchen_can",
    room = private.room_objname,
    zz = "zz_kitchen",
    zz_gate = "gzz_apartment_kitchen"
  };
  
  local get_can_inv = function ()
  
    interface.InventoryItemAdd( "inv_can", "spr_kitchen_can" );
    ObjSet( "inv_can", { drag = false } );   
 
    cmn.SetInvPlusRGB( "can", false );  
    if ( cmn.IsEventDone( "get_canopener" ) ) then

      cmn.SetInvPlusRGB( "can", true );  

    end;   

  end;
  
  local get_can_closezz = function ()
  
    ObjDelete( "gfx_kitchen_can" );

    if ( cmn.IsEventDone( "get_oilcan_ext" ) ) then

      ObjDelete( "gzz_apartment_kitchen" );

    end;

  end;
  
  cmn.AddSubscriber( "get_can", get_can_inv );
  cmn.AddSubscriber( "get_can", get_can_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_canopener () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_canopener" ] = {
    type = "get",
    get_obj = "spr_kitchen_2_canopener",
    room = private.room_objname,
    zz = "zz_kitchen_2",
    zz_gate = "gzz_apartment_kitchen_2"
  };
  
  local get_canopener_inv = function ()
  
    interface.InventoryItemAdd( "inv_canopener", "spr_kitchen_2_canopener" );
    cmn.SetInvPlusRGB( "can", true ); 

  end;
  
  local get_canopener_closezz = function ()
  
    ObjDelete( "gfx_kitchen_2_canopener" );
    ObjDelete( "gzz_apartment_kitchen_2" );  

  end;
  
  cmn.AddSubscriber( "get_canopener", get_canopener_inv );
  cmn.AddSubscriber( "get_canopener", get_canopener_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_oilcan_ext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_oilcan_ext" ] = {
    type = "get",
    get_obj = "spr_kitchen_oilcan_ext",
    room = private.room_objname,
    zz = "zz_kitchen",
    zz_gate = "gzz_apartment_kitchen"
  };
  
  local get_oilcan_ext_inv = function ()
  
    interface.InventoryItemAdd( "inv_oilcan_ext", "spr_kitchen_oilcan_ext" );
  
  end;
  
  local get_oilcan_ext_closezz = function ()
  
    ObjDelete( "gfx_kitchen_oilcan_ext" );
    ObjDelete( "spr_apartment_kitchen_oiler" );    

    if ( cmn.IsEventDone( "get_can" ) ) then

      ObjDelete( "gzz_apartment_kitchen" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_oilcan_ext", get_oilcan_ext_inv );
  cmn.AddSubscriber( "get_oilcan_ext", get_oilcan_ext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_code () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_code" ] = {
    type = "get",
    get_obj = "spr_kitchen_code",
    room = private.room_objname,
    zz = "zz_kitchen",
    zz_gate = "gzz_apartment_kitchen"
  };
  
  local get_code_inv = function ()
  
    interface.InventoryItemAdd( "inv_code", "spr_kitchen_code" );
  
  end;
  
  local get_code_closezz = function ()
  
    ObjDelete( "gfx_kitchen_code" );
  
  end;
  
  cmn.AddSubscriber( "get_code", get_code_inv );
  cmn.AddSubscriber( "get_code", get_code_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_4_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_4_1 = function ()
  
    ObjDelete( "obj_apartment_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_4_1", get_collect_morph_item_4_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_patternelement () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_patternelement" ] = {
    type = "use",
    inv_obj = "inv_patternelement",
    use_place = "obj_closet_use_patternelement",
    room = private.room_objname,
    zz = "zz_closet",
    zz_gate = "gzz_apartment_closet"
  };
  local use_patternelement_inv = function ()
  
    interface.InventoryItemRemove( "inv_patternelement" );
  
  end;
  local use_patternelement_beg = function ()
  
    ObjDelete( "obj_closet_use_patternelement" );
  
  end;
  local use_patternelement_end = function ()

    ObjMultiSet( { 
      { "spr_apartment_patch_element_safe", { alp = 1 } },
      { "spr_apartment_itemscollecting_2",  { alp = 1 } },
      { "gho_apartment_itemscollecting", { input = true, active = true, alp = 1 } }
    } );
    
    ObjDelete( "gzz_apartment_closet" );
    ObjDelete( "spr_apartment_itemscollecting_1" );    

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_patternelement", use_patternelement_beg, private.room_objname );
  cmn.AddSubscriber( "use_patternelement", use_patternelement_inv );
  cmn.AddSubscriber( "use_patternelement", use_patternelement_end, private.room_objname );
  cmn.AddSubscriber( "use_patternelement_inv", use_patternelement_inv, private.room_objname );
  cmn.AddSubscriber( "use_patternelement_beg", use_patternelement_beg, private.room_objname );
  cmn.AddSubscriber( "use_patternelement_end", use_patternelement_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_apartmentkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_apartmentkey" ] = {
    type = "use",
    inv_obj = "inv_apartmentkey",
    use_place = "obj_shoeshelf_use_apartmentkey",
    room = private.room_objname,
    zz = "zz_shoeshelf",
    zz_gate = "gzz_apartment_shoeshelf"
  };
  local use_apartmentkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_apartmentkey" );
  
  end;
  local use_apartmentkey_beg = function ()
  
    ObjDelete( "obj_shoeshelf_use_apartmentkey" );
  
  end;
  local use_apartmentkey_end = function ()

    ObjMultiSet( {

        { "spr_shoeshelf_key_1", { alp = 1 } },
        { "obj_shoeshelf_clk_apartmentkey", { input = true } },

    } );
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_apartmentkey", use_apartmentkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_apartmentkey", use_apartmentkey_inv );
  cmn.AddSubscriber( "use_apartmentkey", use_apartmentkey_end, private.room_objname );
  cmn.AddSubscriber( "use_apartmentkey_inv", use_apartmentkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_apartmentkey_beg", use_apartmentkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_apartmentkey_end", use_apartmentkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_oilcan_ext_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_oilcan_ext_1" ] = {
    type = "use",
    inv_obj = "inv_oilcan_ext",
    use_place = "obj_shoeshelf_use_oilcan_ext_1",
    room = private.room_objname,
    zz = "zz_shoeshelf",
    zz_gate = "gzz_apartment_shoeshelf"
  };
  local use_oilcan_ext_1_inv = function ()
  
    if ( cmn.IsEventDone( "use_oilcan_ext_2" ) ) then

      interface.InventoryItemRemove( "inv_oilcan_ext" );

    end;
  
  end;
  local use_oilcan_ext_1_beg = function ()
  
    ObjDelete( "obj_shoeshelf_use_oilcan_ext_1" );
  
  end;
  local use_oilcan_ext_1_end = function ()

    ObjMultiSet( { 
      { "spr_shoeshelf_holeyboot",                                { input = true, alp = 1   } },
      { "gfx_shoeshelf_holeyboot",                                { active = true           } },
      { "spr_shoeshelf_box_open",                                 { alp = 1                 } },
      { "spr_shoeshelf_door_box_move",                            { alp = 0                 } },
      { "spr_apartment_shoeshelf_patch_nightstand_open",          { alp = 1                 } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_oilcan_ext_1", use_oilcan_ext_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_oilcan_ext_1", use_oilcan_ext_1_inv );
  cmn.AddSubscriber( "use_oilcan_ext_1", use_oilcan_ext_1_end, private.room_objname );
  cmn.AddSubscriber( "use_oilcan_ext_1_inv", use_oilcan_ext_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_oilcan_ext_1_beg", use_oilcan_ext_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_oilcan_ext_1_end", use_oilcan_ext_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_taxinumber () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_taxinumber" ] = {
    type = "use",
    inv_obj = "inv_taxinumber",
    use_place = "obj_coffeetable_ext_use_taxinumber",
    room = private.room_objname,
    zz = "zz_coffeetable_ext",
    zz_gate = "gzz_apartment_coffeetable_ext"
  };
  local use_taxinumber_inv = function ()
  
    interface.InventoryItemRemove( "inv_taxinumber" );
  
  end;
  local use_taxinumber_beg = function ()
  
    ObjDelete( "obj_coffeetable_ext_use_taxinumber" );
  
  end;
  local use_taxinumber_end = function ()
  
    ObjSet( "obj_coffeetable_ext_phone", { alp = 1 } );

    if ( cmn.IsEventDone( "get_officeaddress" ) ) then

      ObjDelete( "gzz_apartment_coffeetable_ext" ); 
 
    end;

  end;

  local use_taxinumber_end_parkinglot = function ()
  
    ObjSet( "spr_parkinglot_taxi", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_taxinumber", use_taxinumber_beg, private.room_objname );
  cmn.AddSubscriber( "use_taxinumber", use_taxinumber_inv );
  cmn.AddSubscriber( "use_taxinumber", use_taxinumber_end, private.room_objname );
  cmn.AddSubscriber( "use_taxinumber", use_taxinumber_end_parkinglot, "rm_parkinglot" );
  cmn.AddSubscriber( "use_taxinumber_inv", use_taxinumber_inv, private.room_objname );
  cmn.AddSubscriber( "use_taxinumber_beg", use_taxinumber_beg, private.room_objname );
  cmn.AddSubscriber( "use_taxinumber_end", use_taxinumber_end, private.room_objname );
  cmn.AddSubscriber( "use_taxinumber_end", use_taxinumber_end_parkinglot, "rm_parkinglot" );
  --------------------------------------------------------------------------------------------
  -- function use_tobiasamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tobiasamulet" ] = {
    type = "use",
    inv_obj = "inv_tobiasamulet",
    use_place = "obj_safe_use_tobiasamulet",
    room = private.room_objname,
    zz = "zz_safe",
    zz_gate = "gzz_apartment_safe"
  };
  local use_tobiasamulet_inv = function ()
  
    interface.InventoryItemRemove( "inv_tobiasamulet" );
  
  end;
  local use_tobiasamulet_beg = function ()
  
    ObjDelete( "obj_safe_use_tobiasamulet" );
  
  end;
  local use_tobiasamulet_end = function ()

    ObjMultiSet( { 
      { "obj_safe_safe_door_close",       { input = true, alp = 1 } },
      { "spr_safe_paper",                 { input = true } },
      { "obj_safe_use_code",              { active = true, input = true, alp = 1 } },   
      { "spr_apartment_safe_patch_safe",  { alp = 1 } },   
      { "spr_apartment_mirror",           { pos_x = 17, pos_y = 217 } }
    } ); 
  
    ObjDelete( "obj_safe_safe_up_side" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tobiasamulet", use_tobiasamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_tobiasamulet", use_tobiasamulet_inv );
  cmn.AddSubscriber( "use_tobiasamulet", use_tobiasamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_tobiasamulet_inv", use_tobiasamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_tobiasamulet_beg", use_tobiasamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_tobiasamulet_end", use_tobiasamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tweezers_ext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tweezers_ext" ] = {
    type = "use",
    inv_obj = "inv_tweezers_ext",
    use_place = "obj_safe_use_tweezers_ext",
    room = private.room_objname,
    zz = "zz_safe",
    zz_gate = "gzz_apartment_safe"
  };
  local use_tweezers_ext_inv = function ()
  
    interface.InventoryItemRemove( "inv_tweezers_ext" );
  
  end;
  local use_tweezers_ext_beg = function ()
  
    ObjDelete( "obj_safe_use_tweezers_ext" );
  
  end;
  local use_tweezers_ext_end = function ()
  
    ObjSet( "spr_safe_patternelement", { input = true, alp = 1 } );
    ObjSet( "gfx_safe_patternelement", { active = true } );  

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tweezers_ext", use_tweezers_ext_beg, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_ext", use_tweezers_ext_inv );
  cmn.AddSubscriber( "use_tweezers_ext", use_tweezers_ext_end, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_ext_inv", use_tweezers_ext_inv, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_ext_beg", use_tweezers_ext_beg, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_ext_end", use_tweezers_ext_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_code () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_code" ] = {
    type = "use",
    inv_obj = "inv_code",
    use_place = "obj_safe_use_code",
    room = private.room_objname,
    zz = "zz_safe",
    zz_gate = "gzz_apartment_safe"
  };
  local use_code_inv = function ()
  
    interface.InventoryItemRemove( "inv_code" );
  
  end;
  local use_code_beg = function ()
  
    ObjDelete( "obj_safe_use_code" );
  
  end;
  local use_code_end = function ()

    ObjMultiSet( { 
      { "spr_apartment_safe_patch_code_safe", { alp = 1 } },
      { "spr_safe_safe_door_close",           { visible = true, active = true } },
      { "obj_safe_safe_door_close_mmg",       { input = true } },
      { "spr_safe_paper_code",                { alp = 1 } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_code", use_code_beg, private.room_objname );
  cmn.AddSubscriber( "use_code", use_code_inv );
  cmn.AddSubscriber( "use_code", use_code_end, private.room_objname );
  cmn.AddSubscriber( "use_code_inv", use_code_inv, private.room_objname );
  cmn.AddSubscriber( "use_code_beg", use_code_beg, private.room_objname );
  cmn.AddSubscriber( "use_code_end", use_code_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tobiasmessage () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tobiasmessage" ] = {
    type = "use",
    inv_obj = "inv_tobiasmessage",
    use_place = "obj_kitchen_use_tobiasmessage",
    room = private.room_objname,
    zz = "zz_kitchen",
    zz_gate = "gzz_apartment_kitchen"
  };
  local use_tobiasmessage_inv = function ()
  
    interface.InventoryItemRemove( "inv_tobiasmessage" );
  
  end;
  local use_tobiasmessage_beg = function ()
  
    ObjDelete( "obj_kitchen_use_tobiasmessage" );
  
  end;
  local use_tobiasmessage_end = function ()  
  
    ObjDelete( "anm_kitchen_use_tobiasmessage" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tobiasmessage", use_tobiasmessage_beg, private.room_objname );
  cmn.AddSubscriber( "use_tobiasmessage", use_tobiasmessage_inv );
  cmn.AddSubscriber( "use_tobiasmessage", use_tobiasmessage_end, private.room_objname );
  cmn.AddSubscriber( "use_tobiasmessage_inv", use_tobiasmessage_inv, private.room_objname );
  cmn.AddSubscriber( "use_tobiasmessage_beg", use_tobiasmessage_beg, private.room_objname );
  cmn.AddSubscriber( "use_tobiasmessage_end", use_tobiasmessage_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_screwdriverknife () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screwdriverknife" ] = {
    type = "use",
    inv_obj = "inv_screwdriverknife",
    use_place = "obj_kitchen_use_screwdriverknife",
    room = private.room_objname,
    zz = "zz_kitchen",
    zz_gate = "gzz_apartment_kitchen"
  };
  local use_screwdriverknife_inv = function ()
  
    interface.InventoryItemRemove( "inv_screwdriverknife" );
  
  end;
  local use_screwdriverknife_beg = function ()
  
    ObjDelete( "obj_kitchen_use_screwdriverknife" );
  
  end;
  local use_screwdriverknife_end = function ()
  
    ObjSet( "spr_kitchen_knife1",               { alp = 1, visible = true } );
    ObjSet( "obj_kitchen_clk_screwdriverknife", { input = true } );
    ObjSet( "spr_apartment_kitchen_opendoor1",  { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_screwdriverknife", use_screwdriverknife_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriverknife", use_screwdriverknife_inv );
  cmn.AddSubscriber( "use_screwdriverknife", use_screwdriverknife_end, private.room_objname );
  cmn.AddSubscriber( "use_screwdriverknife_inv", use_screwdriverknife_inv, private.room_objname );
  cmn.AddSubscriber( "use_screwdriverknife_beg", use_screwdriverknife_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriverknife_end", use_screwdriverknife_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_foldumbrella () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_foldumbrella" ] = {
    type = "use",
    inv_obj = "inv_foldumbrella",
    use_place = "obj_kitchen_2_use_foldumbrella",
    room = private.room_objname,
    zz = "zz_kitchen_2",
    zz_gate = "gzz_apartment_kitchen_2"
  };
  local use_foldumbrella_inv = function ()
  
    interface.InventoryItemRemove( "inv_foldumbrella" );
  
  end;
  local use_foldumbrella_beg = function ()
  
    ObjDelete( "obj_kitchen_2_use_foldumbrella" );
  
  end;
  local use_foldumbrella_end = function ()
  
    ObjDelete( "anm_kitchen_2_use_foldumbrella" );
    ObjDelete( "gzz_apartment_kitchen_2" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_foldumbrella", use_foldumbrella_beg, private.room_objname );
  cmn.AddSubscriber( "use_foldumbrella", use_foldumbrella_inv );
  cmn.AddSubscriber( "use_foldumbrella", use_foldumbrella_end, private.room_objname );
  cmn.AddSubscriber( "use_foldumbrella_inv", use_foldumbrella_inv, private.room_objname );
  cmn.AddSubscriber( "use_foldumbrella_beg", use_foldumbrella_beg, private.room_objname );
  cmn.AddSubscriber( "use_foldumbrella_end", use_foldumbrella_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_clip () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_clip" ] = {
    type = "use",
    inv_obj = "inv_clip",
    use_place = "obj_kitchen_use_clip",
    room = private.room_objname,
    zz = "zz_kitchen",
    zz_gate = "gzz_apartment_kitchen"
  };
  local use_clip_inv = function ()
  
    interface.InventoryItemRemove( "inv_clip" );
  
  end;
  local use_clip_beg = function ()

    ObjDelete( "spr_kitchen_box_closed" );
    ObjDelete( "obj_kitchen_use_clip" );
  
  end;
  local use_clip_end = function ()
  
    ObjDelete( "anm_kitchen_use_clip" );
    ObjSet( "spr_kitchen_box_open", { alp = 1, visible = true, input = true } );
    ObjSet( "spr_apartment_kitchen_box", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_clip", use_clip_beg, private.room_objname );
  cmn.AddSubscriber( "use_clip", use_clip_inv );
  cmn.AddSubscriber( "use_clip", use_clip_end, private.room_objname );
  cmn.AddSubscriber( "use_clip_inv", use_clip_inv, private.room_objname );
  cmn.AddSubscriber( "use_clip_beg", use_clip_beg, private.room_objname );
  cmn.AddSubscriber( "use_clip_end", use_clip_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lighter_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lighter_1" ] = {
    type = "use",
    inv_obj = "inv_lighter",
    use_place = "obj_kitchen_use_lighter_1",
    room = private.room_objname,
    zz = "zz_kitchen",
    zz_gate = "gzz_apartment_kitchen"
  };
  local use_lighter_1_inv = function ()
  
  
  end;
  local use_lighter_1_beg = function ()
  
    ObjDelete( "obj_kitchen_use_lighter_1" );
  
  end;
  local use_lighter_1_end = function ()

    ObjDelete( "anm_kitchen_use_lighter" );
    ObjSet( "anm_kitchen_gas", { alp = 1, visible = true } );  
    ObjSet( "obj_kitchen_use_tobiasmessage", { input = true } );
    ObjSet( "spr_kitchen_switch_on", { alp = 1, visible = true } );
    ObjDelete( "spr_kitchen_switch_off" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lighter_1", use_lighter_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_lighter_1", use_lighter_1_inv );
  cmn.AddSubscriber( "use_lighter_1", use_lighter_1_end, private.room_objname );
  cmn.AddSubscriber( "use_lighter_1_inv", use_lighter_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_lighter_1_beg", use_lighter_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_lighter_1_end", use_lighter_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_patternelement () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_patternelement" ] = {
    type = "click",
    use_place = "obj_closet_clk_patternelement",
    room = private.room_objname,
    zz = "zz_closet",
    zz_gate = "gzz_apartment_closet"
  };
  local clk_patternelement_beg = function ()

    ObjDelete( "obj_closet_clk_patternelement" );

  end;
  local clk_patternelement_end = function ()

    ObjMultiSet( { 
      { "obj_closet_use_patternelement",      { input = true, alp = 1 } },   
    } ); 

    ObjDelete( "spr_closet_wood_button_1_part" );
    ObjDelete( "spr_closet_wood_button_2_part" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_patternelement", clk_patternelement_beg, private.room_objname );
  cmn.AddSubscriber( "clk_patternelement", clk_patternelement_end, private.room_objname );
  cmn.AddSubscriber( "clk_patternelement_beg", clk_patternelement_beg, private.room_objname );
  cmn.AddSubscriber( "clk_patternelement_end", clk_patternelement_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_kitchen_switch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_kitchen_switch" ] = {
    type = "click",
    use_place = "obj_kitchen_clk_kitchen_switch",
    room = private.room_objname,
    zz = "zz_kitchen",
    zz_gate = "gzz_apartment_kitchen"
  };

  local clk_kitchen_switch_beg = function ()

    ObjDelete( "obj_kitchen_clk_kitchen_switch" );
  
  end;
  local clk_kitchen_switch_end = function ()

    ObjSet( "obj_kitchen_use_lighter_1", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_kitchen_switch", clk_kitchen_switch_beg, private.room_objname );
  cmn.AddSubscriber( "clk_kitchen_switch", clk_kitchen_switch_end, private.room_objname );
  cmn.AddSubscriber( "clk_kitchen_switch_beg", clk_kitchen_switch_beg, private.room_objname );
  cmn.AddSubscriber( "clk_kitchen_switch_end", clk_kitchen_switch_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_screwdriverknife () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_screwdriverknife" ] = {
    type = "click",
    use_place = "obj_kitchen_clk_screwdriverknife",
    room = private.room_objname,
    zz = "zz_kitchen",
    zz_gate = "gzz_apartment_kitchen"
  };

  local clk_screwdriverknife_beg = function ()

    ObjDelete( "obj_kitchen_clk_screwdriverknife" );
    
  end;
  local clk_screwdriverknife_end = function ()

    ObjSet( "obj_kitchen_clk_oilcan_ext", { input = true } );
    ObjSet( "spr_kitchen_door_open", { alp = 1, visible = true } );
    ObjDelete( "spr_kitchen_door_close" );
    ObjDelete( "spr_kitchen_box_path" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_screwdriverknife", clk_screwdriverknife_beg, private.room_objname );
  cmn.AddSubscriber( "clk_screwdriverknife", clk_screwdriverknife_end, private.room_objname );
  cmn.AddSubscriber( "clk_screwdriverknife_beg", clk_screwdriverknife_beg, private.room_objname );
  cmn.AddSubscriber( "clk_screwdriverknife_end", clk_screwdriverknife_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_oilcan_ext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_oilcan_ext" ] = {
    type = "click",
    use_place = "obj_kitchen_clk_oilcan_ext",
    room = private.room_objname,
    zz = "zz_kitchen",
    zz_gate = "gzz_apartment_kitchen"
  };

  local clk_oilcan_ext_beg = function ()

    ObjDelete( "obj_kitchen_clk_oilcan_ext" );
  
  end;
  local clk_oilcan_ext_end = function ()

    ObjSet( "spr_kitchen_door_open", { input = true } );
    ObjSet( "gfx_kitchen_oilcan_ext", { active = true } );
    ObjSet( "spr_kitchen_bank", { pos_x = -216, pos_y = 53 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_oilcan_ext", clk_oilcan_ext_beg, private.room_objname );
  cmn.AddSubscriber( "clk_oilcan_ext", clk_oilcan_ext_end, private.room_objname );
  cmn.AddSubscriber( "clk_oilcan_ext_beg", clk_oilcan_ext_beg, private.room_objname );
  cmn.AddSubscriber( "clk_oilcan_ext_end", clk_oilcan_ext_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function clk_apartment_key () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_apartment_key" ] = {
    type = "click",
    use_place = "obj_shoeshelf_clk_apartmentkey",
    room = private.room_objname,
    zz = "zz_shoeshelf",
    zz_gate = "gzz_apartment_shoeshelf"
  };

  local clk_apartment_key_beg = function ()

    ObjDelete( "obj_shoeshelf_clk_apartmentkey" );
  
  end;

  local clk_apartment_key_end = function ()

    ObjMultiSet({
      { "spr_shoeshelf_door_open",                 { alp = 1 } },
      { "grm_apartment_parkinglot",                { input = true, visible = true, active = true, alp = 1 } },
      { "spr_apartment_shoeshelf_patch_door_open", { alp = 1 } },
    });
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_apartment_parkinglot_focus");
    end;
    ObjDelete( "obj_shoeshelf_door_close" );
    ObjDelete( "spr_shoeshelf_key_1" );

  end;

  cmn.AddSubscriber( "clk_apartment_key", clk_apartment_key_beg, private.room_objname );
  cmn.AddSubscriber( "clk_apartment_key", clk_apartment_key_end, private.room_objname );
  cmn.AddSubscriber( "clk_apartment_key_beg", clk_apartment_key_beg, private.room_objname );
  cmn.AddSubscriber( "clk_apartment_key_end", clk_apartment_key_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_safe () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_safe" ] =
  {
      type = "win",
      room = private.room_objname,
      zz = "zz_safe",
      zz_gate = "gzz_apartment_safe"
  };
  local win_safe = function ()

    if ( cmn.IsEventDone( "win_safe" ) ) then

      ObjMultiSet( { 
        { "spr_safe_lamp_light_80",         { alp = 1 } },
        { "spr_safe_lamp_light_60",         { alp = 1 } },
        { "spr_safe_lamp_light_20",         { alp = 1 } },
        { "obj_safe_safe_door_close_mmg",   { input = false } },
      } );

      if ( cmn.IsEventDone( "get_trinket" ) ) then

        ObjMultiSet( { 
          { "gfx_safe_externaldisk",            { active = true, alp = 1 } },   
          { "obj_safe_safe_door_open",          { input = true } },   
          { "obj_safe_use_tweezers_ext",        { input = true, alp = 1 } }, 
          { "spr_apartment_patch_safe_open",    { alp = 1 } },
        } ); 

        ObjDelete( "obj_safe_safe_door_close" );
        ObjDelete( "spr_apartment_safe_patch_safe" );  
    
      end;

    end;

  end;
  cmn.AddSubscriber( "win_safe", win_safe, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_call_kane_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_call_kane_1" ] = {
    type = "click",
    use_place = "obj_coffeetable_ext_clk_david_kane_1",
    room = private.room_objname,
    zz = "zz_coffeetable_ext",
    zz_gate = "gzz_apartment_coffeetable_ext"
  };

  local see_call_kane_1 = function ()


  end;
  cmn.AddSubscriber( "see_call_kane_1", see_call_kane_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_taxi () end;
  --------------------------------------------------------------------------------------------
  local see_taxi = function ()

    --ObjDelete( "" );
    ObjSet( "obj_parkinglot_use_cash_1", { input = true, visible = true, active = true, alp = 1 } );
    ObjSet( "obj_parkinglot_use_officeaddress", { input = true, visible = true, active = true, alp = 1 } );

  end;
  cmn.AddSubscriber( "see_taxi", see_taxi, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_apartment_josh_fraser () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_apartment_josh_fraser" ] = {
    type = "click",
    use_place = "obj_apartment_clk_josh_fraser_focus",
    room = private.room_objname
  };
  local dlg_apartment_josh_fraser = function ()

    ObjDelete( "obj_apartment_clk_josh_fraser" );
    ObjDelete( "dlg_apartment_josh_fraser_lip" );

    ObjMultiSet( {
      { "anm_apartment_phone",                      { playing = false } },
      { "spr_coffeetable_ext_officeaddress",        { input = true, alp = 1 } },
      { "gfx_coffeetable_ext_officeaddress",        { active = true } },
      { "spr_coffeetable_ext_png_stickers_2_text",  { alp = 1 } }, 
    } );

  end;
  cmn.AddSubscriber( "dlg_apartment_josh_fraser", dlg_apartment_josh_fraser, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_apartment_david_kane_1 () end;
  --------------------------------------------------------------------------------------------
  local dlg_apartment_david_kane_1 = function ()

    ObjDelete( "obj_coffeetable_ext_clk_david_kane_1" );
    ObjDelete( "anm_coffeetable_ext_call" );
    ObjSet( "obj_coffeetable_ext_phone", { alp = 1 } );
    ObjDelete( "dlg_apartment_david_kane_1_lip" );
    ObjSet( "anm_apartment_phone", { playing = false } );

    ObjSet( "obj_coffeetable_ext_use_taxinumber", { input = true } );

  end;
  cmn.AddSubscriber( "dlg_apartment_david_kane_1", dlg_apartment_david_kane_1, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load ()

  --function mmg_safe () end; --------------------------------------------------------------------------
    if ( cmn.IsEventStart( "win_safe" ) and not cmn.IsEventDone( "win_safe" ) ) then

      for i = 1, #private.safe_state do

        private.safe_state[ i ] = ng_global.progress[ "ext" ][ "win_safe" ].state[ i ];    

      end;

      private.safe_count = ng_global.progress[ "ext" ][ "win_safe" ].count;
      local ang = ng_global.progress[ "ext" ][ "win_safe" ].ang;
      ObjSet( "spr_safe_safe_disk", { ang = ang } );

      local light = { "80", "60", "20" };
      for i = 1, #private.safe_state do

        if ( private.safe_state[ i ] ~= "" ) then

          ObjSet( "spr_safe_lamp_light_"..light[ i ], { alp = 1 } );

        end;

      end;   

    end;  
  ------------------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function private.Init_Subroom ()

  --*********************************************************************************************************************
  -- function zz_coffeetable_ext () end;
  --*********************************************************************************************************************
    subroom.Define( "zz_coffeetable_ext" );
    function zz_coffeetable_ext.PreOpen()

    end;
    -------------------------------------------------
    function zz_coffeetable_ext.Open()

      if not ( cmn.IsEventDone( "dlg_apartment_josh_fraser" ) ) then

        private.dlg_josh_fraser_click();
    
      end;

    end;
    -------------------------------------------------
    function zz_coffeetable_ext.PreClose()
    end;
    -------------------------------------------------
    function zz_coffeetable_ext.Close()

      if ( cmn.IsEventDone( "use_taxinumber" ) and not cmn.IsEventDone( "see_taxi" ) ) then

        private.see_taxi();

      end;

    end;
    -------------------------------------------------
  --*********************************************************************************************************************
  -- function zz_safe () end;
  --*********************************************************************************************************************
    subroom.Define( "zz_safe" );
    -------------------------------------------------
    function zz_safe.PreOpen()
    end;
    -------------------------------------------------
    function zz_safe.Open()

      if ( cmn.IsEventStart( "win_safe" ) and not cmn.IsEventDone( "win_safe" ) ) then

        cmn.MiniGameShow( "safe" );
        common_impl.PassingMgStart( "safe" );

      end;

    end;
    -------------------------------------------------
    function zz_safe.PreClose()

      if ( cmn.IsEventStart( "win_safe" ) and not cmn.IsEventDone( "win_safe" ) ) then

        cmn.MiniGameHide( "safe" );

      end;

    end;
    -------------------------------------------------
    function zz_safe.Close()

      if cmn.IsEventDone( "use_tobiasamulet" ) then

        cmn.NoteScaleClose( { "spr_safe_paper" } );

      end;

      if cmn.IsEventDone( "win_safe" ) then

        cmn.NoteScaleClose( { "obj_safe_photo" }, { "spr_safe_photo_big" } );

      end;

    end;
    -------------------------------------------------
    function zz_safe.Reset ()

      local light = {"60", "20", "80" };
      cmn.Lock( true );
      for i = 1, #private.safe_state do

        ObjAnimate( "spr_safe_lamp_light_"..light[ i ], "alp", 0, 0, "", 
        { 
          0.0, 0, ObjGet( "spr_safe_lamp_light_"..light[ i ] ).alp,     
          0.3, 0, 0.0,
        } );

      end; 

      ObjAnimate( "zz_safe", "alp", 0, 0, function() zz_safe.ResetEnd() end, 
      { 
        0.0, 0, ObjGet( "zz_safe" ).alp,     
        0.3, 0, ObjGet( "zz_safe" ).alp,
      } );

    end;
    -------------------------------------------------
    function zz_safe.ResetEnd ()
    
      cmn.Lock( false );

      private.safe_state = { "", "", "" };
      private.safe_count = 0;
      ng_global.progress[ "ext" ][ "win_safe" ].state = { "", "", "" };
      ng_global.progress[ "ext" ][ "win_safe" ].count = 0;

    end;
    -------------------------------------------------
    function zz_safe.Skip ()

      cmn.Lock( true );
      ObjAnimate( "spr_safe_lamp_light_60", "alp", 0, 0, "", 
      { 
        0.0, 0, ObjGet( "spr_safe_lamp_light_60" ).alp,    
        0.3, 0, 1 
      } );
      ObjAnimate( "spr_safe_lamp_light_20", "alp", 0, 0, "", 
      { 
        0.0, 0, ObjGet( "spr_safe_lamp_light_20" ).alp,    
        0.3, 0, 1 
      } );
      ObjAnimate( "spr_safe_lamp_light_80", "alp", 0, 0, function() private.WinAnimSafe(); end, 
      { 
        0.0, 0, ObjGet( "spr_safe_lamp_light_80" ).alp,    
        0.3, 0, 1 
      } );

    end;
    -------------------------------------------------
    
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_apartment();
  int_slider.InitSlider( private.room_objname );

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

  if ( not ng_global.progress[ "ext" ][ "opn_apartment" ].see_phone ) then

    ng_global.progress[ "ext" ][ "opn_apartment" ].see_phone = 0;
    
  end;

  if ( cmn.IsEventDone( "win_itemscollecting" ) and ng_global.progress[ "ext" ][ "opn_apartment" ].see_phone == 0 ) then

    private.ScalePhone();    

  end;

  if ( not ng_global.progress[ "ext" ][ "opn_apartment" ].see_safe ) then

    ng_global.progress[ "ext" ][ "opn_apartment" ].see_safe = 0;
    
  end;

  if ( cmn.IsEventDone( "get_tobiasmessage" ) and ng_global.progress[ "ext" ][ "opn_apartment" ].see_safe == 0 ) then

    private.ScaleSafeEnd();   

  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();

  common_impl.EnvPlay( { "levelext/env/aud_apartment_env" }, "", 0.5 );

  if ( not cmn.IsEventDone( "dlg_apartment_josh_fraser" ) ) or 
     (     cmn.IsEventDone( "win_itemscollecting")          and 
       not cmn.IsEventDone( "dlg_apartment_david_kane_1" ) ) then

    common_impl.EnvPlay( { "levelext/env/aud_telephone_env" }, "", 0.5 );

  end;


  if ( not cmn.IsEventDone( "opn_apartment" ) ) then

    local widget_settings = {}

    if IsCollectorsEdition() then

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu,
        InterfaceWidget_morph
      }

    else

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnMenu
      }

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 0 );

    end;

    ObjSet( private.room_objname, { color_r = 0, color_g = 0, color_b = 0 } );
    ObjAttach( "tmr_apartment_intro", private.room_objname );
    ObjSet( "tmr_apartment_intro",
    {
      time = 0.001,
      playing = true,
      endtrig = function() private.SeeIntro(); end
    } );

  end;

  if ( cmn.IsEventDone( "see_call_kane_1" ) and 
    not cmn.IsEventDone( "dlg_apartment_david_kane_1" ) ) then

    private.dlg_david_kane_1_click();

  end;

  if ( cmn.IsEventDone( "use_taxinumber" ) and not cmn.IsEventDone( "see_taxi" ) ) then

    private.see_taxi();

  end;

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_patternelement ()

  local item = "inv_patternelement";

  if ( cmn.ApplyObj( item, "gzz_apartment_closet" ) and cmn.IsEventDone( "clk_patternelement" ) ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_closet", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_closet_use_patternelement" ) and cmn.IsEventDone( "clk_patternelement" ) ) then

    cmn.CallEventHandler( "use_patternelement_inv" );
    cmn.CallEventHandler( "use_patternelement_beg" );

    local func_end = function()

      local func_end_1 = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_patternelement" );
        cmn.CallEventHandler( "use_patternelement_end" );

        common.CloseSubRoom();

      end;

      ObjAnimate( "spr_closet_pattern_element", "pos_xy",0,0, func_end_1, 
      { 
        0.0, 0, ObjGet( "spr_closet_pattern_element" ).pos_x, ObjGet( "spr_closet_pattern_element" ).pos_y, 
        0.3, 0, ObjGet( "spr_closet_pattern_element" ).pos_x, ObjGet( "spr_closet_pattern_element" ).pos_y,      
        0.6, 0, ObjGet( "spr_closet_pattern_element" ).pos_x + 3, ObjGet( "spr_closet_pattern_element" ).pos_y, 
      } );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_patternelements", 0, "", 0 );
    cmn.ItemFly( "spr_closet_pattern_element", func_end, -1.7 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_apartmentkey ()

  local item = "inv_apartmentkey";

  if cmn.ApplyObj( item, "gzz_apartment_shoeshelf" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shoeshelf", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_shoeshelf_use_apartmentkey" ) ) then

    cmn.CallEventHandler( "use_apartmentkey_inv" );
    cmn.CallEventHandler( "use_apartmentkey_beg" );

    local func_end = function ()

        cmn.Lock( false );
        cmn.SetEventDone( "use_apartmentkey" );
        cmn.CallEventHandler( "use_apartmentkey_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_apartmentkey", 0, "", 0 );
    cmn.ItemFly( "spr_shoeshelf_key_1", func_end, 1.8 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_oilcan_ext_1 ()

  local item = "inv_oilcan_ext";

  if cmn.ApplyObj( item, "gzz_apartment_shoeshelf" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shoeshelf", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_shoeshelf_use_oilcan_ext_1" ) ) then

    cmn.CallEventHandler( "use_oilcan_ext_1_inv" );
    cmn.CallEventHandler( "use_oilcan_ext_1_beg" );

    local func_anim = function ()

      local func_end = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_oilcan_ext_1" );
        cmn.CallEventHandler( "use_oilcan_ext_1_end" );

      end;

      ObjAnimate( "spr_shoeshelf_box_open", "alp", 0, 0, func_end, 
      { 
        0.0, 0, ObjGet( "spr_shoeshelf_box_open" ).alp,     
        0.3, 0, 1
      } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_oilcan_ext", 0, "", 0 );

    ObjSet( "vid_shoeshelf_oil", { alp = 1 } );
    VidPlay( "vid_shoeshelf_oil", func_anim );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_taxinumber ()

  local item = "inv_taxinumber";

  if cmn.ApplyObj( item, "gzz_apartment_coffeetable_ext" ) and cmn.IsEventDone( "dlg_apartment_david_kane_1" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_coffeetable_ext", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_coffeetable_ext_use_taxinumber" ) and cmn.IsEventDone( "dlg_apartment_david_kane_1" ) ) then

    cmn.CallEventHandler( "use_taxinumber_inv" );
    cmn.CallEventHandler( "use_taxinumber_beg" );

    local func_anim = function ()

      local func_end = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_taxinumber" );
        cmn.CallEventHandler( "use_taxinumber_end" );

        if ( cmn.IsEventDone( "get_officeaddress" ) ) then

          common.CloseSubRoom();

        end;

      end;

      VidPlay( "vid_coffeetable_ext_phoning", func_end );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_taxinumber", 0, "", 0 );

    ObjAnimate( "obj_coffeetable_ext_phone", "alp", 0, 0, func_anim, { 0, 0, 1,   0.3, 0, 0 } );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_tobiasamulet ()

  local item = "inv_tobiasamulet";

  if cmn.ApplyObj( item, "gzz_apartment_safe" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_safe", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_safe_use_tobiasamulet" ) ) then

    cmn.CallEventHandler( "use_tobiasamulet_inv" );
    cmn.CallEventHandler( "use_tobiasamulet_beg" );

    local func_end = function ()

      local func_end_1 = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_tobiasamulet" );
        cmn.CallEventHandler( "use_tobiasamulet_end" );

      end;

      ObjAnimate( "obj_safe_safe_up_side", "pos_x",0,0, func_end_1, 
      { 
        0.0, 1, ObjGet( "obj_safe_safe_up_side" ).pos_x,
        0.8, 1, -700
      } );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_tobiasamulet", 0, "", 0 );
    cmn.ItemFly( "spr_safe_tobiaspermit", func_end, -3.14 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_tweezers_ext ()

  local item = "inv_tweezers_ext";

  if cmn.ApplyObj( item, "gzz_apartment_safe" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_safe", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_safe_use_tweezers_ext" ) ) then

    cmn.CallEventHandler( "use_tweezers_ext_inv" );
    cmn.CallEventHandler( "use_tweezers_ext_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_tweezers_ext" );
      cmn.CallEventHandler( "use_tweezers_ext_end" );

      private.get_patternelement();

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_tweezers_ext", 0, "", 0 );
    ObjMultiSet( { 
      { "anm_safe_tweezers",                  { alp = 1 } },
      { "spr_safe_pattern_element_up_side",   { alp = 0 } },
      { "spr_safe_patternelement",            { alp = 0 } },
    } );
    AnimPlay( "anm_safe_tweezers", "DoAnim", func_end );
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_code ()

  local item = "inv_code";

  if cmn.ApplyObj( item, "gzz_apartment_safe" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_safe", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_safe_use_code" ) ) then

    cmn.CallEventHandler( "use_code_inv" );
    cmn.CallEventHandler( "use_code_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_code" );
      cmn.CallEventHandler( "use_code_end" );

      private.InitSafeStart();

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "aud_paper", 0, "", 0 );
    cmn.ItemFly( "spr_safe_paper_code", func_end, 1.5 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_tobiasmessage ()

  local item = "inv_tobiasmessage";

  if cmn.ApplyObj( item, "gzz_apartment_kitchen" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_kitchen", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_kitchen_use_tobiasmessage" ) and 
  cmn.IsEventDone( "use_lighter_1" ) ) then

    cmn.CallEventHandler( "use_tobiasmessage_inv" );
    cmn.CallEventHandler( "use_tobiasmessage_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_tobiasmessage" );
      cmn.CallEventHandler( "use_tobiasmessage_end" );

      ObjSet( "anm_kitchen_gas", { alp = 1 } );
      private.get_code(); 

    end;

    local func_end_2 = function ()

      ObjSet( "anm_kitchen_gas", { alp = 0 } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_tobiasmessage", 0, "", 0 );

    ObjSet( "anm_kitchen_use_tobiasmessage", { alp = 0, visible = true } );
    ObjAnimate( "anm_kitchen_use_tobiasmessage", "alp",0,0, func_end_2, { 0, 0, 0,    0.3, 0, 1 } );
    AnimPlay( "anm_kitchen_use_tobiasmessage", "func_5901", func_end );
  
  return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_screwdriverknife ()

  local item = "inv_screwdriverknife";

  if cmn.ApplyObj( item, "gzz_apartment_kitchen" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_kitchen", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_kitchen_use_screwdriverknife" ) ) then

    cmn.CallEventHandler( "use_screwdriverknife_inv" );
    cmn.CallEventHandler( "use_screwdriverknife_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_screwdriverknife" );
      cmn.CallEventHandler( "use_screwdriverknife_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_click", 0, "", 0 );

    ObjSet( "spr_kitchen_knife1", { alp = 0, visible = true } );
    ObjAnimate( "spr_kitchen_knife1", "alp",0,0, func_end, { 0, 0, 0,    0.6, 0, 1 } );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_foldumbrella ()

  local item = "inv_foldumbrella";

  if cmn.ApplyObj( item, "gzz_apartment_kitchen_2" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_kitchen_2", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_kitchen_2_use_foldumbrella" ) ) then

    cmn.CallEventHandler( "use_foldumbrella_inv" );
    cmn.CallEventHandler( "use_foldumbrella_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_foldumbrella" );
      cmn.CallEventHandler( "use_foldumbrella_end" );

      ObjSet( "spr_kitchen_2_canopener", { alp = 1, pos_x = 112, pos_y = 308 } );
      private.get_canopener();      

    end;

    local func_end_2 = function ()

      ObjSet( "spr_kitchen_2_canopener", { alp = 0 } );

    end; 

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_umbrella", 0, "", 0 );

    ObjSet( "anm_kitchen_2_use_foldumbrella", { alp = 0, visible = true } );
    ObjAnimate( "anm_kitchen_2_use_foldumbrella", "alp",0,0, func_end_2, { 0, 0, 0,    0.3, 0, 1 } );
    AnimPlay( "anm_kitchen_2_use_foldumbrella", "DoAnim", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_clip ()

  local item = "inv_clip";

  if cmn.ApplyObj( item, "gzz_apartment_kitchen" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_kitchen", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_kitchen_use_clip" ) ) then

    cmn.CallEventHandler( "use_clip_inv" );
    cmn.CallEventHandler( "use_clip_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_clip" );
      cmn.CallEventHandler( "use_clip_end" );

    end;

    local func_end_2 = function ()

      ObjSet( "spr_kitchen_box_open", { alp = 0, visible = true } );
      ObjAnimate( "spr_kitchen_box_open", "alp",0,0, func_end, { 0, 0, 0,    0.6, 0, 1 } );
      ObjAnimate( "anm_kitchen_use_clip", "alp",0,0, "", { 0, 0, 1,    0.3, 0, 0 } );

    end; 

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_clip", 0, "", 0 );

    ObjSet( "anm_kitchen_use_clip", { alp = 0, visible = true } );
    ObjAnimate( "anm_kitchen_use_clip", "alp",0,0, "", { 0, 0, 0,    0.3, 0, 1 } );
    AnimPlay( "anm_kitchen_use_clip", "func_5032", func_end_2 );

    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_lighter_1 ()

  local item = "inv_lighter";

  if cmn.ApplyObj( item, "gzz_apartment_kitchen" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_kitchen", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_kitchen_use_lighter_1" ) and
  cmn.IsEventDone( "clk_kitchen_switch" ) ) then

    cmn.CallEventHandler( "use_lighter_1_inv" );
    cmn.CallEventHandler( "use_lighter_1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_lighter_1" );
      cmn.CallEventHandler( "use_lighter_1_end" );

    end;

    local func_end_2 = function ()

      ObjSet( "spr_kitchen_switch_off", { alp = 0 } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_zippo", 0, "", 0 );

    ObjSet( "anm_kitchen_use_lighter", { alp = 0, visible = true } );
    ObjAnimate( "anm_kitchen_use_lighter", "alp",0,0, func_end_2, { 0, 0, 0,    0.3, 0, 1 } );
    AnimPlay( "anm_kitchen_use_lighter", "DoAnim", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_apartmentkey ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_apartmentkey" );
  cmn.CallEventHandler( "get_apartmentkey" );

end;
--------------------------------------------------------------------------------------------
function private.get_holeyboot ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_holeyboot" );
  cmn.CallEventHandler( "get_holeyboot" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_officeaddress ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_officeaddress" );
  cmn.CallEventHandler( "get_officeaddress" );

  if not cmn.IsEventDone( "get_pen" ) then

    private.get_pen();

  end;

  if ( cmn.IsEventDone( "use_taxinumber" ) ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_envelopeknife ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_envelopeknife" );
  cmn.CallEventHandler( "get_envelopeknife" );

end;
--------------------------------------------------------------------------------------------
function private.get_pen ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_pen" );
  cmn.CallEventHandler( "get_pen" );

end;
--------------------------------------------------------------------------------------------
function private.get_trinket ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_trinket" );
  cmn.CallEventHandler( "get_trinket_inv" );
  ObjSet( "spr_safe_trinket_shadow", { alp = 0 } );

  if ( cmn.IsEventDone( "win_safe" ) ) then

    local func_end = function ()

      cmn.Lock( false );
      cmn.CallEventHandler( "get_trinket_closezz" );

    end;  

    cmn.Lock( true );
    ObjAnimate( "spr_safe_safe_door_close", "scale_xy", 0, 0, "", 
    { 
      0.0, 0, 1, 1.0,     
      0.5, 0, 0, 1.0,
    } );
    ObjAnimate( "spr_safe_safe_door_close", "alp", 0, 0, "", 
    { 
      0.0, 0, 1.0,
      0.1, 0, 1.0,
      0.5, 0, 0.0,
    } );
    ObjAnimate( "spr_safe_safe_door_open", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0.0,     
      0.1, 0, 0.0,
      0.5, 0, 1.0,
    } );  
  else

    cmn.CallEventHandler( "get_trinket_closezz" );

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_patternelement ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_patternelement" );
  cmn.CallEventHandler( "get_patternelement" );
  ObjSet( "spr_safe_patternelement", { alp = 1 } );

  if ( cmn.IsEventDone( "get_externaldisk" ) ) then

    common.CloseSubRoom();  

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_externaldisk ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_externaldisk" );
  cmn.CallEventHandler( "get_externaldisk" );

  if ( cmn.IsEventDone( "get_patternelement" ) ) then

    common.CloseSubRoom();  

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_lighter ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_lighter" );
  cmn.CallEventHandler( "get_lighter" );

end;
--------------------------------------------------------------------------------------------
function private.get_firstaidkit ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_firstaidkit" );
  cmn.CallEventHandler( "get_firstaidkit" );

end;
--------------------------------------------------------------------------------------------
function private.get_can ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_can" );
  cmn.CallEventHandler( "get_can" );

  if ( cmn.IsEventDone( "get_oilcan_ext" ) ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_canopener ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_canopener" );
  cmn.CallEventHandler( "get_canopener" );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_oilcan_ext ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_oilcan_ext" );
  cmn.CallEventHandler( "get_oilcan_ext" );
  
  if ( cmn.IsEventDone( "get_can" ) ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_code ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_code" );
  cmn.CallEventHandler( "get_code" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_apartment_key()

  local func_end = function()

    cmn.Lock( false )
    cmn.SetEventDone( "clk_apartment_key" );
    cmn.CallEventHandler( "clk_apartment_key_end" );    
    common.CloseSubRoom();
  end;
  
  ObjAnimate( "spr_shoeshelf_key_2", "alp",0,0, "", 
  { 
    0.0, 0, ObjGet( "spr_shoeshelf_key_2" ).alp,  
    0.3, 0, 1,
  } );

  ObjAnimate( "spr_shoeshelf_key_1", "alp",0,0, "", 
  { 
    0.0, 0, ObjGet( "spr_shoeshelf_key_1" ).alp,  
    0.3, 0, 0,
  } );

  ObjAnimate( "obj_shoeshelf_door_close", "alp",0,0, "", 
  { 
    0.0, 0, ObjGet( "obj_shoeshelf_door_close" ).alp,  
    0.3, 0, ObjGet( "obj_shoeshelf_door_close" ).alp,  
    0.6, 0, 0,
  } );

  ObjAnimate( "spr_shoeshelf_door_open", "alp",0,0, func_end, 
  { 
    0.0, 0, ObjGet( "spr_shoeshelf_door_open" ).alp,  
    0.3, 0, ObjGet( "spr_shoeshelf_door_open" ).alp, 
    0.6, 0, 1,
  } );

  cmn.CallEventHandler( "clk_apartment_key_beg" );
  cmn.Lock( true );
  

end;
---------------------------------------------------------------------------------------------
function private.clk_kitchen_switch ()

  cmn.CallEventHandler( "clk_kitchen_switch_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_kitchen_switch" );
    cmn.CallEventHandler( "clk_kitchen_switch_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_burner", 0, "", 0 );

  ObjAnimate( "spr_kitchen_switch_off", "alp",0,0, "", { 0, 2, 1,    0.6, 2, 0,    1.2, 1, 1 } );
  ObjSet( "spr_kitchen_switch_on", { alp = 0, visible = true } );
  ObjAnimate( "spr_kitchen_switch_on", "alp",0,0, func_end, { 0, 1, 0,    0.6, 1, 1,    1.2, 2, 0 } );

end;

--------------------------------------------------------------------------------------------

function private.clk_screwdriverknife ()

  cmn.CallEventHandler( "clk_screwdriverknife_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_screwdriverknife" );
    cmn.CallEventHandler( "clk_screwdriverknife_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_screwdriverknife", 0, "", 0 );

  ObjAnimate( "spr_kitchen_knife1", "alp",0,0, "", { 0, 2, 1,    0.6, 2, 0 } );
  ObjSet( "spr_kitchen_knife2", { alp = 0, visible = true } );
  ObjAnimate( "spr_kitchen_knife2", "alp",0,0, "", { 0, 1, 0,    0.6, 1, 1 } );

  ObjAnimate( "spr_kitchen_door_close", "alp",0,0, "", { 0, 2, 1,    0.6, 2, 1,    1.2, 2, 0 } );
  ObjSet( "spr_kitchen_door_open", { alp = 0, visible = true } );
  ObjAnimate( "spr_kitchen_door_open", "alp",0,0, func_end, { 0, 1, 0,    0.6, 1, 0,    1.2, 1, 1 } );

end;

--------------------------------------------------------------------------------------------

function private.clk_oilcan_ext ()

  cmn.CallEventHandler( "clk_oilcan_ext_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_oilcan_ext" );
    cmn.CallEventHandler( "clk_oilcan_ext_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_oilcan_ext", 0, "", 0 );

  ObjAnimate( "spr_kitchen_bank", "pos_xy",0,0, func_end, { 0, 3, -134, 41,    0.6, 3, -216, 53 } );

end;
--------------------------------------------------------------------------------------------
function private.clk_patternelement ()

  cmn.CallEventHandler( "clk_patternelement_beg" );

  local func_end = function()

    local func_end_1 = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_patternelement" );
      cmn.CallEventHandler( "clk_patternelement_end" );

    end;

    ObjAttach( "spr_closet_wood_button_1_part", "zz_closet" );
    ObjSet( "spr_closet_wood_button_1_part", { pos_z = 20 } );
    ObjAttach( "spr_closet_wood_button_2_part", "zz_closet" );
    ObjSet( "spr_closet_wood_button_2_part", { pos_z = 20 } );

    ObjAnimate( "spr_closet_wood_button_1_part", "ang", 0, 0, "",
    { 
      0.0, 1, ObjGet( "spr_closet_wood_button_1_part" ).ang,
      0.3, 1, 0.29,
    } );
    ObjAnimate( "spr_closet_wood_button_1_part", "pos_xy", 0, 0, "",
    { 
      0.0, 1, ObjGet( "spr_closet_wood_button_1_part" ).pos_x, ObjGet( "spr_closet_wood_button_1_part" ).pos_y,
      0.6, 1, -131, 314
    } );

    ObjAnimate( "spr_closet_wood_button_2_part", "ang", 0, 0, "",
    { 
      0.0, 1, ObjGet( "spr_closet_wood_button_2_part" ).ang,
      0.3, 1, -0.39,
    } );
    ObjAnimate( "spr_closet_wood_button_2_part", "pos_xy", 0, 0, func_end_1,
    { 
      0.0, 1, ObjGet( "spr_closet_wood_button_2_part" ).pos_x, ObjGet( "spr_closet_wood_button_2_part" ).pos_y,
      0.6, 1, 4, 326,
    } );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_figure_drawer", 0, "", 0 );

  ObjAnimate( "obj_closet_wood_button", "pos_x", 0, 0, func_end,
  { 
    0.0, 0, ObjGet( "obj_closet_wood_button" ).pos_x,
    0.2, 0, ObjGet( "obj_closet_wood_button" ).pos_x + 3,
    0.4, 0, ObjGet( "obj_closet_wood_button" ).pos_x,
  } );
  ObjAnimate( "spr_closet_box_2_preopen", "pos_xy", 0, 0, "",
  { 
    0.0, 0, ObjGet( "spr_closet_box_2_preopen" ).pos_x,     ObjGet( "spr_closet_box_2_preopen" ).pos_y,
    0.2, 0, ObjGet( "spr_closet_box_2_preopen" ).pos_x - 3, ObjGet( "spr_closet_box_2_preopen" ).pos_y + 3,
    0.4, 0, ObjGet( "spr_closet_box_2_preopen" ).pos_x,     ObjGet( "spr_closet_box_2_preopen" ).pos_y,
  } );

end;
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG SAFE *** () end;
--*********************************************************************************************************************
  function private.InitSafeStart ()

    ng_global.progress[ "ext" ][ "win_safe" ].state = { "", "", "" };
    ng_global.progress[ "ext" ][ "win_safe" ].count = 0;
    ng_global.progress[ "ext" ][ "win_safe" ].ang = 0;
    cmn.MiniGameShow( "safe" );
    common_impl.PassingMgStart( "safe" );

  end;
  --------------------------------------------------------------------------------------------
  function private.InitSafe ()

    private.dragobj_coords = { -21, - 11 };
    private.safe_state = { "", "", "" };
    private.safe_count = 0;

    ObjMultiSet( { 
      { "spr_safe_safe_disk_drag", { event_startdrag  = function() private.Circle_startdrag( "spr_safe_safe_disk", "spr_safe_safe_disk_drag" ) end;
                                     event_drag       = function() private.Circle_drag( "spr_safe_safe_disk" ) end; 
                                     event_dragdrop   = function() private.Circle_dragdrop( "spr_safe_safe_disk", "spr_safe_safe_disk_drag" ) end;} },
    } );    

  end;
  --------------------------------------------------------------------------------------------
  function private.Circle_startdrag ( circle_obj_name,drag_obj_name )

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_handle_safe1", 1, "", 0 );

    private.coords_begin = GetZoomCursorPos();
    private.coords_begin[ 1 ] = private.coords_begin[ 1 ] - 512;
    private.coords_begin[ 2 ] = private.coords_begin[ 2 ] - 360;

    --private.coords_begin[ 1 ] = private.coords_begin[ 1 ] - 512;
    --private.coords_begin[ 2 ] = private.coords_begin[ 2 ] - 512;

    private.dragobj_coords = { ObjGet( drag_obj_name ).pos_x, ObjGet( drag_obj_name ).pos_y };

    ObjSet( drag_obj_name, { pos_x = private.coords_begin[ 1 ], pos_y = private.coords_begin[ 2 ] } );

    private.ang13 = ObjGet( circle_obj_name ).ang;

    private.atan = math.atan2( private.coords_begin[ 1 ] - private.dragobj_coords[ 1 ] ,private.coords_begin[ 2 ] - private.dragobj_coords[ 2 ] );

  end;
  --------------------------------------------------------------------------------------------
  function private.Circle_drag ( circle_obj_name )

    common_impl.SetCursor( CURSOR_HAND );

    private.coords_end = GetZoomCursorPos();
    private.coords_end[ 1 ] = private.coords_end[ 1 ] - ObjGet( circle_obj_name ).pos_x - 512;
    private.coords_end[ 2 ] = private.coords_end[ 2 ] - ObjGet( circle_obj_name ).pos_y - 360;

    --private.coords_end[ 1 ] = private.coords_end[ 1 ] - ObjGet( circle_obj_name ).pos_x;
    --private.coords_end[ 2 ] = private.coords_end[ 2 ] - ObjGet( circle_obj_name ).pos_y;

    private.circle_ang = math.atan2( private.coords_end[1],private.coords_end[ 2 ] ) - private.atan; 

    ObjSet( circle_obj_name, { ang = private.circle_ang + private.ang13  } );
    
  end;
  --------------------------------------------------------------------------------------------
  function private.Circle_dragdrop ( circle_obj_name,drag_obj_name )

    common_impl.StopAudio( "sfx", "levelext/sfx/aud_clk_handle_safe1", 0.2 );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_handle_safe2", 0, "", 0 );

    --local win_ang = { { -2.5, 3.7 }, { -5.0, 1.2 }, { -1.31, 4.96 } };
    --local win_comnbination = { "60", "20", "80" };

    local win_ang = { { -1.31, 4.96 } , { -2.5, 3.7 } , { -5.0, 1.2 }  };
    local win_comnbination = { "80", "60", "20" };

    SetCursor(CURSOR_DEFAULT);

    local ang = ObjGet( circle_obj_name ).ang;
    local temp = math.modf( ang / 6.28 );
    ang = ang - ( temp * 6.28 );
    ObjSet( circle_obj_name, { ang = ang } );
    ObjSet( drag_obj_name,{ pos_x = private.dragobj_coords[ 1 ], pos_y = private.dragobj_coords[ 2 ] } );


    -- ищем в какое число мы попали
    local index = 0;
    for i= 1, #win_ang do

      local temp_win;

      if ( ang < 0 ) then

        temp_win = math.abs( ang - win_ang[ i ][ 1 ] );

      else

        temp_win = math.abs( ang - win_ang[ i ][ 2 ] );

      end;

      if ( temp_win < 0.08 ) then

        index = i;
        break;  

      end;

    end;

    -- определяем есть ли это число у нас в массиве
    local bool = true;
    if ( index ~= 0 ) then

      for i = 1, #private.safe_state do
        
        if ( private.safe_state[ i ] ==  win_comnbination[ index ] ) then

          bool = false;
          break;

        end;

      end;



    end;
 
    local func_end = function()

      cmn.Lock( false );
      if ( private.IsWinSafe() ) then

        private.WinAnimSafe();

      else
      
        if ( private.safe_count == 3 ) then

          private.LoseAnimSafe();

        else

          private.SaveVarSafe();
  
        end

      end;

    end;
    
    if ( bool and index ~= 0 ) then
  
      cmn.Lock( true );
      local count = private.safe_count + 1;
      private.safe_state[ count ] = win_comnbination[ index ];
      private.safe_count = count;

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_lamp", 0, "", 0 );

      ObjAnimate( "spr_safe_lamp_light_"..private.safe_state[ private.safe_count ], "alp", 0, 0, func_end,
      { 
        0.0, 0, ObjGet( "spr_safe_lamp_light_"..private.safe_state[ private.safe_count ] ).alp,
        0.3, 0, 1,
      } );   

    else 

      common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

      func_end();

    end;   

  end;
  --------------------------------------------------------------------------------------------
  function private.IsWinSafe ()

    local safe_win = { "80", "60", "20" };

    for i = 1, #private.safe_state do

      if ( private.safe_state[ i ] ~= safe_win[ i ] ) then

        return false;

      end;

    end;

   return true;

  end;
  --------------------------------------------------------------------------------------------
  function private.LoseAnimSafe ()

    local light = { "80", "60", "20" };

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

    for i = 1, #private.safe_state do

      ObjAnimate( "spr_safe_lamp_light_"..light[ i ], "alp", 0, 0, "", 
      { 
        0.0, 0, ObjGet( "spr_safe_lamp_light_"..light[ i ] ).alp,     
        0.3, 0, 0.0,
      } );

    end; 

    ObjAnimate( "obj_safe_lamp_light_red", "alp", 0, 0, function() zz_safe.ResetEnd(); end, 
    { 
      0.0, 0, 0.0,     
      0.3, 0, 0.0,
      0.4, 0, 1.0,
      0.6, 0, 1.0,
      0.7, 0, 0.0,
    } ); 

  end;
  --------------------------------------------------------------------------------------------
  function private.SaveVarSafe()

    for i = 1, #private.safe_state do

      ng_global.progress[ "ext" ][ "win_safe" ].state[ i ] = private.safe_state[ i ];    

    end;

    ng_global.progress[ "ext" ][ "win_safe" ].count = private.safe_count;
    ng_global.progress[ "ext" ][ "win_safe" ].ang = ObjGet( "spr_safe_safe_disk" ).ang;

  end;
  --------------------------------------------------------------------------------------------
  function private.WinAnimSafe ()

    cmn.Lock( true );

    if ( cmn.IsEventDone( "get_trinket" ) ) then

      common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_open", 0, "", 0 );

      ObjAnimate( "spr_safe_safe_door_close", "scale_xy", 0, 0, "", 
      { 
        0.0, 0, 1, 1.0,     
        0.5, 0, 0, 1.0,
      } );
      ObjAnimate( "spr_safe_safe_door_close", "alp", 0, 0, "", 
      { 
        0.0, 0, 1.0,
        0.1, 0, 1.0,
        0.5, 0, 0.0,
      } );
      ObjAnimate( "spr_safe_safe_door_open", "alp", 0, 0, function() private.WinSafe(); end, 
      { 
        0.0, 0, 0.0,     
        0.1, 0, 0.0,
        0.5, 0, 1.0,
      } );

    else

      private.WinSafe();

    end;

  end;
  --------------------------------------------------------------------------------------------
  function private.WinSafe ()

    cmn.Lock( false );  
  
    cmn.MiniGameHide( "safe" );
    cmn.SetEventDone( "win_safe" );
    cmn.CallEventHandler( "win_safe" );    
    common_impl.PassingMgWin( "safe" );      

  end;
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function private.SeeIntro ()
  
  ObjDelete( "tmr_apartment_intro" );  

  local func_end = function ()

    local func_end_1 = function ()

      cmn.Lock( false );


      --common_impl.StopAudio( "voc", "levelext/voc/aud_intro_lvlext_voc", 0.2 );
      common_impl.StopAudio( "sfx", "levelext/sfx/aud_intro_lvlext", 0.2 );
      --common_impl.EnvPlay( { "levelext/env/aud_rm_apartment_env" }, "", 0.5 );

      cmn.SetEventDone( "opn_apartment" ); 
      cmn.CallEventHandler( "opn_apartment" ); 

      common_impl.ShowBbt( "bbt_apartment_opn_apartment" );

      interface.KeyTaskAdd( "answer_phone" );
        
      local widget_settings = {}

      if IsCollectorsEdition() then

        widget_settings = 
        {
          InterfaceWidget_Inventory,
          InterfaceWidget_BtnHint,
          InterfaceWidget_BtnMap,
          InterfaceWidget_BtnGuide,
          InterfaceWidget_BtnMenu,
          InterfaceWidget_morph
        }

      else

        widget_settings = 
        {
          InterfaceWidget_Inventory,
          InterfaceWidget_BtnHint,
          InterfaceWidget_BtnMap,
          InterfaceWidget_BtnMenu
        }

      end;

      for i = 1, #widget_settings do

        interface.WidgetSetVisible( widget_settings[ i ], 1, true );

      end;    

    end;

    cmn.Lock( true );
    ObjSet( private.room_objname, { color_r = 1, color_g = 1, color_b = 1 } );
    ObjAnimate( "rm_apartment", "pos_xy", 0, 0, func_end_1,
    { 
      0.0, 0,    0, 0,  
      0.3, 0, -236, -152, 
      1.0, 0, -236, -152, 
      1.3, 0,    0, 0,  

    } );
    ObjAnimate( "rm_apartment", "scale_xy", 0, 0, "",
    { 
      0.0, 0,   1, 1,  
      0.3, 0, 1.2, 1.2, 
      1.0, 0, 1.2, 1.2, 
      1.3, 0,   1, 1, 
    } );


  end;

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_intro_lvlext", 0, "", 0 );
  --common_impl.PlayAudio( "voc", "levelext/voc/aud_intro_lvlext_voc", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_apartment_intro", func_end );

end;
--------------------------------------------------------------------------------------------
function private.see_call_kane_1 ()

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "see_call_kane_1" ); 
    cmn.CallEventHandler( "see_call_kane_1" ); 
    private.dlg_david_kane_1_click();

  end;  

  cmn.Lock( true );
  func_end();

end;
--------------------------------------------------------------------------------------------
function private.see_taxi ()

  local func_end = function ()

    common_impl.StopAudio( "sfx", "levelext/sfx/aud_taxi", 0.2 );
    common_impl.StopAudio( "voc", "levelext/voc/aud_see_taxit_voc", 0.2 );

    cmn.SetEventDone( "see_taxi" ); 
    cmn.CallEventHandler( "see_taxi" ); 

    common_impl.ShowBbt( "bbt_apartment_see_taxi" );

  end;  
  
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_taxi", 0, "", 0 );
  common_impl.PlayAudio( "voc", "levelext/voc/aud_see_taxit_voc", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_apartment_see_taxi", func_end );

end;
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )

  if dlg_name == "josh_fraser" then
        
    if ( count_txt == 2 ) then -- Terence Irwing 

      ObjSet( "spr_int_dialog_character_icon", { res = "assets/interface/resources/dialog_character/btm_4" } );

    elseif ( count_txt == 4 ) then

      ObjMultiSet( {
        { "anm_dlg_apartment_josh_fraser_hand",   { alp = 1 } },
        { "anm_dlg_apartment_josh_fraser_hand1",  { alp = 0 } },
      } );

      AnimPlay( "anm_dlg_apartment_josh_fraser_hand", "hand", "" );

    else -- Josh Fraiser 

      ObjSet( "spr_int_dialog_character_icon", { res = "assets/interface/resources/dialog_character/btm_5" } );

    end;

  elseif dlg_name == "david_kane_1" then

    if ( count_txt == 1 ) then -- Terence Irwing 

      ObjSet( "spr_int_dialog_character_icon", { res = "assets/interface/resources/dialog_character/btm_6" } );

    end;

  end;  

end;
--------------------------------------------------------------------------------------------
function private.dlg_josh_fraser_click ()

  common_impl.StopAllEnv( "levelext/env/aud_apartment_env" );

  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "josh_fraser", 6, nil, nil, true, private.dlg_josh_fraser_end );

end;
--------------------------------------------------------------------------------------------
function private.dlg_josh_fraser_end ()

  ObjSet( "spr_int_dialog_character_icon", { res = "" } ); 
  cmn.CallEventHandler( "dlg_apartment_josh_fraser" );   
  common_impl.ShowBbt( "bbt_apartment_dlg_apartment_josh_fraser" );

  interface.KeyTaskDone( true );
  interface.KeyTaskAdd( "pack_things" );

  for i = 1, 2 do

    --VidStop( "vid_dlg_park_1_professor_1_lip_"..i );
    --ObjSet( "vid_dlg_park_1_professor_1_lip_"..i, { alp = 0 } );

  end;

end;
--------------------------------------------------------------------------------------------
function private.dlg_david_kane_1_click ()

  common_impl.StopAllEnv( "levelext/env/aud_apartment_env" );

  common.CloseSubRoom();
  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "david_kane_1", 2, nil, nil, true, private.dlg_david_kane_1_end );

  --common_impl.PlayAudio( "voc", "levelext/voc/aud_apartment_david_kane_1_1_voc", 0, "", 0 );

end;
--------------------------------------------------------------------------------------------
function private.dlg_david_kane_1_end ()

  local func_end = function ()

    cmn.Lock( false );

    ObjDelete( "anm_apartment_life_time" );

  end;

  common_impl.StopAudio( "voc", "levelext/voc/aud_apartment_david_kane_1_1_voc", 0.2 );

  cmn.CallEventHandler( "dlg_apartment_david_kane_1" );   
  common_impl.ShowBbt( "bbt_apartment_dlg_apartment_david_kane_1" );

  interface.KeyTaskDone( true );
  interface.KeyTaskAdd( "call_taxi" );

  for i = 1, 2 do

    --VidStop( "vid_dlg_park_1_professor_1_lip_"..i );
    --ObjSet( "vid_dlg_park_1_professor_1_lip_"..i, { alp = 0 } );

  end;

  cmn.Lock( true );

  ObjSet( "anm_apartment_life_time", { alp = 1 } );
  AnimPlay( "anm_apartment_life_time", "DoAnim", func_end );

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_see_date", 0, "", 0 );

end;
--*********************************************************************************************************************
-- function *** ANIMATON *** () end;
--*********************************************************************************************************************
function private.Init_Animation ()

  ObjAnimate( "spr_dlg_apartment_josh_fraser_light", "alp",1,0, "", { 0, 3, 0.7,    1.5, 3, 0.1,    3, 3, 0.4,    5, 3, 1,    6, 3, 0.7 } );
--------------------------------------------------------------------------------------------
  ObjAnimate( "spr_safe_trinket", "ang", 1, 0, "", 
  { 
    0.0, 3, -0.03,
    2.0, 3,  0.03,
    4.0, 3, -0.03,
  } ); 

  ObjAnimate( "spr_closet_apartmentkey", "ang", 1, 0, "", 
  { 
    0.0, 3, -0.04,
    2.5, 3,  0.04,
    5.0, 3, -0.04,
  } ); 

end;
--*********************************************************************************************************************
-- function *** FEEDBACKANIM *** () end;
--*********************************************************************************************************************
function private.UseTweezers_ext ()

  local func_end = function()

    cmn.Lock( false );
    common_impl.ShowBbt( "bbt_safe_use_tweezers_ext" );    

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk2", 0, "", 0 );

  ObjAnimate( "spr_safe_patternelement", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 0, ObjGet( "spr_safe_patternelement" ).pos_x, ObjGet( "spr_safe_patternelement" ).pos_y,
    0.15, 0, ObjGet( "spr_safe_patternelement" ).pos_x + 3, ObjGet( "spr_safe_patternelement" ).pos_y - 3,
    0.3, 0, ObjGet( "spr_safe_patternelement" ).pos_x, ObjGet( "spr_safe_patternelement" ).pos_y,
  } ); 

end;
--------------------------------------------------------------------------------------------
function private.UseTobiasamulet ()

  local func_end = function()

    cmn.Lock( false );
    common_impl.ShowBbt( "bbt_safe_use_tobiasamulet" );   

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk2", 0, "", 0 );

  ObjAnimate( "obj_safe_safe_up_side", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 0, ObjGet( "obj_safe_safe_up_side" ).pos_x, ObjGet( "obj_safe_safe_up_side" ).pos_y,
    0.2, 0, ObjGet( "obj_safe_safe_up_side" ).pos_x, ObjGet( "obj_safe_safe_up_side" ).pos_y - 5,
    0.4, 0, ObjGet( "obj_safe_safe_up_side" ).pos_x, ObjGet( "obj_safe_safe_up_side" ).pos_y,
  } ); 

end;
--------------------------------------------------------------------------------------------
function private.UsePatternelement() 

  local func_end = function()

    cmn.Lock( false );
    common_impl.ShowBbt( "bbt_closet_use_patternelement" ); 

  end; 

  cmn.Lock( true ); 

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_single_drawer", 0, "", 0 );

  ObjAnimate( "spr_closet_box_2_preopen", "pos_xy", 0, 0, func_end,
  { 
    0.0, 0, ObjGet( "spr_closet_box_2_preopen" ).pos_x,     ObjGet( "spr_closet_box_2_preopen" ).pos_y,
    0.2, 0, ObjGet( "spr_closet_box_2_preopen" ).pos_x - 3, ObjGet( "spr_closet_box_2_preopen" ).pos_y + 3,
    0.4, 0, ObjGet( "spr_closet_box_2_preopen" ).pos_x,     ObjGet( "spr_closet_box_2_preopen" ).pos_y,
  } );

end;
--------------------------------------------------------------------------------------------
function private.UseApartmentkey ()

  local func_end = function()

    cmn.Lock( false );
    common_impl.ShowBbt( "bbt_shoeshelf_use_apartmentkey" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_single_handle", 0, "", 0 );

  ObjAnimate( "spr_shoeshelf_nandle_door_move_1", "ang", 0, 0, func_end,
  { 
    0.0, 0,     0,  
    0.1, 0, -0.14, 
    0.2, 0,     0, 
  } );

end
--------------------------------------------------------------------------------------------
function private.UseOilcan_ext_1 ()

  local func_end = function()

    cmn.Lock( false );
    common_impl.ShowBbt( "bbt_shoeshelf_use_oilcan_ext_1" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_single_drawer1", 0, "", 0 );

  ObjAnimate( "spr_shoeshelf_door_box_move", "pos_xy", 0, 0, func_end,
  { 
    0.00, 0, ObjGet( "spr_shoeshelf_door_box_move" ).pos_x,     ObjGet( "spr_shoeshelf_door_box_move" ).pos_y,  
    0.15, 0, ObjGet( "spr_shoeshelf_door_box_move" ).pos_x + 2, ObjGet( "spr_shoeshelf_door_box_move" ).pos_y + 2,  
    0.30, 0, ObjGet( "spr_shoeshelf_door_box_move" ).pos_x,     ObjGet( "spr_shoeshelf_door_box_move" ).pos_y,  
  } );

end;
--------------------------------------------------------------------------------------------
function private.UseScrewdriverknife ()

  local func_end = function()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_kitchen_use_screwdriverknife' );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_single_handle", 0, "", 0 );
  ObjAnimate( "spr_kitchen_door_close", "pos_xy", 0, 0, func_end,
  { 
    0.00, 0, ObjGet( "spr_kitchen_door_close" ).pos_x,     ObjGet( "spr_kitchen_door_close" ).pos_y,  
    0.15, 0, ObjGet( "spr_kitchen_door_close" ).pos_x + 2, ObjGet( "spr_kitchen_door_close" ).pos_y + 2,  
    0.30, 0, ObjGet( "spr_kitchen_door_close" ).pos_x,     ObjGet( "spr_kitchen_door_close" ).pos_y,  
  } );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_apartment ()

  if not ( cmn.IsEventDone( "opn_apartment" ) ) then

    cmn.SetEventDone( "opn_apartment" );

    ng_global.progress[ "std" ].common.gamewin = true;

  end;

  cmn.CallEventHandler( "opn_apartment" );

end;
--------------------------------------------------------------------------------------------
function private.ScalePhone ()

  local func_end = function()

    cmn.Lock( false );
    ng_global.progress[ "ext" ][ "opn_apartment" ].see_phone = 1;

    common_impl.ShowBbt( "bbt_apartment_scalephone" );

  end;

  cmn.Lock( true );
  ObjAnimate( "rm_apartment", "pos_xy", 0, 0, func_end,
  { 
    --0.0, 0,    0, 0,  
    --0.3, 0, -101, -68, 
    --0.8, 0, -101, -68, 
    --1.1, 0,    0, 0,  

    0.0, 0,    0, 0,  
    0.3, 0, -236, -152, 
    1.0, 0, -236, -152, 
    1.3, 0,    0, 0,  

  } );
  ObjAnimate( "rm_apartment", "scale_xy", 0, 0, "",
  { 
    0.0, 0,   1, 1,  
    0.3, 0, 1.2, 1.2, 
    1.0, 0, 1.2, 1.2, 
    1.3, 0,   1, 1, 
  } );

end;
--------------------------------------------------------------------------------------------
function public.ScaleSafe ()

  --функция костыль, блочился экран, и что бы закрытии сложного инв. его не расблочивал 
  cmn.Lock( true );
  ObjAnimate( "rm_apartment", "scale_xy", 0, 0, "", 
  { 
    0.0,  0,   1, 1,
    0.55, 0,   1, 1,
  } );  
  ObjAnimate( "rm_apartment", "pos_xy", 0, 0, function() private.ScaleSafeEnd(); end, 
  { 
    0.0,  0,  0, 0,
    0.55, 0,  0, 0,
  } );

end;
--------------------------------------------------------------------------------------------
function private.ScaleSafeEnd ()


  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_apartment_scale_safe' );
    ng_global.progress[ "ext" ][ "opn_apartment" ].see_safe = 1;

  end;

  cmn.Lock( true );

  --common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_pigeon", 0, "", 0 );

  ObjAnimate( "rm_apartment", "scale_xy", 0, 0, "", 
  { 
    0.0, 0,   1, 1, 
    0.3, 0, 1.2, 1.2, 
    1.3, 0, 1.2, 1.2, 
    1.6, 0,   1, 1, 
  } );
  ObjAnimate( "rm_apartment", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 0,  0, 0,
    0.3, 0, 15, 1,
    1.3, 0, 15, 1,
    1.6, 0,  0, 0,
  } );

end;
--------------------------------------------------------------------------------------------
function private.clkCat()

  local func_end = function()

    cmn.Lock( false );

  end;

  cmn.Lock( true );

  common_impl.ShowBbt( "bbt_apartment_cat" );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_cat_purr", 0, "", 0 );

  ObjAnimate( "obj_apartment_cat", "alp", 0, 0, func_end,
  { 
    0.0, 0, 1, 
    0.4, 0, 1, 
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_obj_use_clip()

  common_impl.ShowBbt( 'bbt_kitchen_use_clip' );
  
  local endfunc = function ()
    
    cmn.Lock( false );

  end;
  
  cmn.Lock( true );  
  
  ObjAnimate( "spr_kitchen_box_closed", "pos_xy", 0, 1, endfunc, 
    { 
      0.00, 1, 0,0,
      0.15, 1, 1,2, 
      0.30, 1, 0,0

    });

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk2", 0, "", 0 );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------