-- name=rm_cafe
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_cafe";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_barcounter", "room_hub" );
  ObjAttach( "zz_table", "room_hub" );
  ObjAttach( "zz_musicmachine", "room_hub" );
  ObjAttach( "zz_storeroom", "room_hub" );
  private.Init_Subroom();
  private.InitAnimations();
  private.InitTables();  

  ObjMultiSet( { 
    { "spr_barcounter_tableplacing",                          { event_mdown = private.get_tableplacing            } },
    { "spr_barcounter_cafebadge1",                            { event_mdown = private.get_cafebadge1              } },
    { "spr_table_bill",                                       { event_mdown = private.get_bill                    } },
    { "spr_table_amuletmelodypart",                           { event_mdown = private.get_amuletmelodypart        } },
    { "spr_musicmachine_amuletmelodypart2",                   { event_mdown = private.get_amuletmelodypart2       } },
    { "spr_musicmachine_stonewings",                          { event_mdown = private.get_stonewings              } },
    { "spr_musicmachine_cafebadge2",                          { event_mdown = private.get_cafebadge2              } },
    { "spr_storeroom_bartenderslostrecipe",                   { event_mdown = private.get_bartenderslostrecipe    } },
    { "spr_storeroom_magnet_ext",                             { event_mdown = private.get_magnet_ext              } },
    { "spr_storeroom_wrench_ext",                             { event_mdown = private.get_wrench_ext              } },
    { "obj_cafe_clk_barman_1",                                { event_mdown = private.dlg_barman_1_click          } },
    { "obj_cafe_clk_barman_1_focus",                          { event_mdown = private.dlg_barman_1_click          } },
    { "obj_table_clk_table",                                  { event_mdown = private.clk_table                   } },
    { "obj_storeroom_clk_lever_ext",                          { event_mdown = private.clk_lever_ext               } },
    { "obj_storeroom_use_cafebadge1",                         { event_mdown = private.UseCafebadge                } },
    { "obj_storeroom_use_cafebadge2",                         { event_mdown = private.UseCafebadge                } },
    { "obj_storeroom_use_lever_ext",                          { event_mdown = private.UseLever_ext                } },
    { "obj_storeroom_use_bartenderlocket",                    { event_mdown = private.UseBartenderlocket          } },
    { "obj_storeroom_clk_bartenderlocket",                    { event_mdown = private.clk_bartenderlocket         } },
    { "obj_barcounter_clk_sugar",                             { event_mdown = private.clk_sugar                   } },
    { "obj_barcounter_clk_spoon",                             { event_mdown = private.clk_spoon                   } },
    { "obj_barcounter_clk_barphone",                          { event_mdown = private.see_call_kane_3             } },
    { "obj_cafe_mmg_back",                                    { event_mdown = private.clk_mmg_back                } },
    { "spr_collect2_item_4_5",                                { event_mdown = private.get_collect2_item_4_5       } },
    { "obj_zz_musicmachine_clk_button_red",                   { event_mdown = function() private.clk_musicmachine_button( "red" ); end      } },
    { "obj_zz_musicmachine_clk_button_yellow",                { event_mdown = function() private.clk_musicmachine_button( "yellow" ); end   } },
    { "obj_zz_musicmachine_clk_button_green",                 { event_mdown = function() private.clk_musicmachine_button( "green" ); end    } },
    { "spr_cafe_collect_morph_item",                          { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_4_2" ); end } },
  } );


  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_cafe = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "grm_cafe_nearcafe",
      "gho_cafe_barcounter",
      "gzz_cafe_barcounter",
      "gzz_cafe_table",
      "gzz_cafe_musicmachine",
      "gzz_cafe_storeroom",
      "grm_cafe_nearcafe_1",
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_barcounter",
      "zz_table",
      "zz_musicmachine",
      "zz_storeroom",
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_cafe", update_game_mode_cafe, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_cafe = function ()

  local effects_table = 
  {
    "obj_cafe_anim",
    "anm_cafe_barman",
    "anm_cafe_all",
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_cafe", update_performance_mode_cafe, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_cafe () end;
  --------------------------------------------------------------------------------------------
  local opn_cafe_map = function ()

    common_impl.VisitMapRoom( "cafe" );

  end;
  cmn.AddSubscriber( "opn_cafe", opn_cafe_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_tableplacing () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tableplacing" ] = {
    type = "get",
    get_obj = "spr_barcounter_tableplacing",
    room = private.room_objname,
    zz = "zz_barcounter",
    zz_gate = "gzz_cafe_barcounter"
  };
  
  local get_tableplacing_inv = function ()
  
    interface.InventoryItemAdd( "inv_tableplacing", "spr_barcounter_tableplacing" );
  
  end;
  
  local get_tableplacing_closezz = function ()
  
    ObjDelete( "gfx_barcounter_tableplacing" );
    ObjSet( "obj_cafe_use_tableplacing", { input = true } );
  
  end;
  
  cmn.AddSubscriber( "get_tableplacing", get_tableplacing_inv );
  cmn.AddSubscriber( "get_tableplacing", get_tableplacing_closezz, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_cafebadge1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cafebadge1" ] = {
    type = "get",
    get_obj = "spr_barcounter_cafebadge1",
    room = private.room_objname,
    zz = "zz_barcounter",
    zz_gate = "gzz_cafe_barcounter"
  };
  
  local get_cafebadge1_inv = function ()
  
    interface.InventoryItemAdd( "inv_cafebadge1", "spr_barcounter_cafebadge1" );
  
  end;
  
  local get_cafebadge1_closezz = function ()
  
    ObjDelete( "spr_cafe_barcounter_amulet_layers" );
    ObjDelete( "gfx_barcounter_cafebadge1" );
  
  end;
  
  cmn.AddSubscriber( "get_cafebadge1", get_cafebadge1_inv );
  cmn.AddSubscriber( "get_cafebadge1", get_cafebadge1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bill () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bill" ] = {
    type = "get",
    get_obj = "spr_table_bill",
    room = private.room_objname,
    zz = "zz_table",
    zz_gate = "gzz_cafe_table"
  };
  
  local get_bill_inv = function ()
  
    interface.InventoryItemAdd( "inv_bill", "spr_table_bill" );
    ObjSet( "inv_bill", { drag = false } );
    cmn.SetInvPlusRGB( "bill", true );
  
  end;
  
  local get_bill_closezz = function ()
  
    ObjDelete( "gfx_table_bill" );
    ObjDelete( "spr_cafe_table_bill_layer" );

    if ( cmn.IsEventDone( "get_amuletmelodypart" ) ) then

      ObjDelete( "gzz_cafe_table" );

    end;

  end;
  
  cmn.AddSubscriber( "get_bill", get_bill_inv );
  cmn.AddSubscriber( "get_bill", get_bill_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletmelodypart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletmelodypart" ] = {
    type = "get",
    get_obj = "spr_table_amuletmelodypart",
    room = private.room_objname,
    zz = "zz_table",
    zz_gate = "gzz_cafe_table"
  };
  
  local get_amuletmelodypart_inv = function ()
  
    interface.InventoryItemAdd( "inv_amuletmelodypart", "spr_table_amuletmelodypart" );
    ObjSet( "inv_amuletmelodypart", { drag = false } );

    cmn.SetInvPlusRGB( "amuletmelodypart", false );
    if ( cmn.IsEventDone( "get_chewinggum" ) or cmn.IsEventDone( "get_amuletmelodypart2" ) ) then

      cmn.SetInvPlusRGB( "amuletmelodypart", true );

    end;

  end;
  
  local get_amuletmelodypart_closezz = function ()
  
    ObjDelete( "gfx_table_amuletmelodypart" );

    if ( cmn.IsEventDone( "get_bill" ) ) then

      ObjDelete( "gzz_cafe_table" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_amuletmelodypart", get_amuletmelodypart_inv );
  cmn.AddSubscriber( "get_amuletmelodypart", get_amuletmelodypart_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletmelodypart2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletmelodypart2" ] = {
    type = "get",
    get_obj = "spr_musicmachine_amuletmelodypart2",
    room = private.room_objname,
    zz = "zz_musicmachine",
    zz_gate = "gzz_cafe_musicmachine"
  };
  
  local get_amuletmelodypart2_inv = function ()
  
    interface.InventoryItemAdd( "inv_amuletmelodypart2", "spr_musicmachine_amuletmelodypart2" );
    cmn.SetInvPlusRGB( "amuletmelodypart", true );
  
  end;
  
  local get_amuletmelodypart2_closezz = function ()
  
    ObjDelete( "gfx_musicmachine_amuletmelodypart2" );
    ObjDelete( "spr_zz_musicmachine_amuletmelodypart2_shadow" );

    if ( cmn.IsEventDone( "get_cafebadge2" ) and 
      cmn.IsEventDone( "get_stonewings" ) ) then

      ObjDelete( "gzz_cafe_musicmachine" );

    end;  

  end;
  
  cmn.AddSubscriber( "get_amuletmelodypart2", get_amuletmelodypart2_inv );
  cmn.AddSubscriber( "get_amuletmelodypart2", get_amuletmelodypart2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stonewings () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stonewings" ] = {
    type = "get",
    get_obj = "spr_musicmachine_stonewings",
    room = private.room_objname,
    zz = "zz_musicmachine",
    zz_gate = "gzz_cafe_musicmachine"
  };
  
  local get_stonewings_inv = function ()
  
    interface.InventoryItemAdd( "inv_stonewings", "spr_musicmachine_stonewings" );
  
  end;
  
  local get_stonewings_closezz = function ()
  
    ObjDelete( "gfx_musicmachine_stonewings" );
    ObjDelete( "spr_zz_musicmachine_wings_shadow" );
    ObjDelete( "spr_cafe_musicmachine_musicmachine3" );
    
    if ( cmn.IsEventDone( "get_cafebadge2" ) and 
      cmn.IsEventDone( "get_amuletmelodypart2" ) ) then

      ObjDelete( "gzz_cafe_musicmachine" );

    end; 
   
  end;
  
  cmn.AddSubscriber( "get_stonewings", get_stonewings_inv );
  cmn.AddSubscriber( "get_stonewings", get_stonewings_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cafebadge2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cafebadge2" ] = {
    type = "get",
    get_obj = "spr_musicmachine_cafebadge2",
    room = private.room_objname,
    zz = "zz_musicmachine",
    zz_gate = "gzz_cafe_musicmachine"
  };
  
  local get_cafebadge2_inv = function ()
  
    interface.InventoryItemAdd( "inv_cafebadge2", "spr_musicmachine_cafebadge2" );
  
  end;
  
  local get_cafebadge2_closezz = function ()
  
    ObjDelete( "gfx_musicmachine_cafebadge2" );
    ObjDelete( "spr_cafe_musicmachine_musicmachine1" );

    if ( cmn.IsEventDone( "get_stonewings" ) and 
      cmn.IsEventDone( "get_amuletmelodypart2" ) ) then

      ObjDelete( "gzz_cafe_musicmachine" );

    end; 
  
  end;
  
  cmn.AddSubscriber( "get_cafebadge2", get_cafebadge2_inv );
  cmn.AddSubscriber( "get_cafebadge2", get_cafebadge2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bartenderslostrecipe () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bartenderslostrecipe" ] = {
    type = "get",
    get_obj = "spr_storeroom_bartenderslostrecipe",
    room = private.room_objname,
    zz = "zz_storeroom",
    zz_gate = "gzz_cafe_storeroom"
  };
  
  local get_bartenderslostrecipe_inv = function ()
  
    interface.InventoryItemAdd( "inv_bartenderslostrecipe", "spr_storeroom_bartenderslostrecipe" );
  
  end;
  
  local get_bartenderslostrecipe_closezz = function ()
  
    ObjDelete( "gfx_storeroom_bartenderslostrecipe" );
    ObjDelete( "spr_storeroom_bartenderslostrecipe_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_bartenderslostrecipe", get_bartenderslostrecipe_inv );
  cmn.AddSubscriber( "get_bartenderslostrecipe", get_bartenderslostrecipe_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_magnet_ext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_magnet_ext" ] = {
    type = "get",
    get_obj = "spr_storeroom_magnet_ext",
    room = private.room_objname,
    zz = "zz_storeroom",
    zz_gate = "gzz_cafe_storeroom"
  };
  
  local get_magnet_ext_inv = function ()
  
    interface.InventoryItemAdd( "inv_magnet_ext", "spr_storeroom_magnet_ext" );
  
  end;
  
  local get_magnet_ext_closezz = function ()
  
    ObjDelete( "gfx_storeroom_magnet_ext" );
    ObjDelete( "spr_storeroom_magnet_ext_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_magnet_ext", get_magnet_ext_inv );
  cmn.AddSubscriber( "get_magnet_ext", get_magnet_ext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wrench_ext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wrench_ext" ] = {
    type = "get",
    get_obj = "spr_storeroom_wrench_ext",
    room = private.room_objname,
    zz = "zz_storeroom",
    zz_gate = "gzz_cafe_storeroom"
  };
  
  local get_wrench_ext_inv = function ()
  
    interface.InventoryItemAdd( "inv_wrench_ext", "spr_storeroom_wrench_ext" );
  
  end;
  
  local get_wrench_ext_closezz = function ()
  
    ObjDelete( "gfx_storeroom_wrench_ext" );
    ObjDelete( "spr_cafe_storeroom_storeroom5" );
    ObjSet( "spr_cafe_storeroom_storeroom6", { alp = 1 } );

    if ( cmn.IsGetCollect2( "get_collect2_item_4_5" ) ) then

      ObjDelete( "gzz_cafe_storeroom" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_wrench_ext", get_wrench_ext_inv );
  cmn.AddSubscriber( "get_wrench_ext", get_wrench_ext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_4_5 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_4_5 = function ()
  
    ObjDelete( "obj_collect2_item_4_5" );

    if ( cmn.IsEventDone( "get_wrench_ext" ) ) then

      ObjDelete( "gzz_cafe_storeroom" );

    end;
  
  end;    
  cmn.AddSubscriber( "get_collect2_item_4_5", get_collect2_item_4_5, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_4_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_4_2 = function ()
  
    ObjDelete( "obj_cafe_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_4_2", get_collect_morph_item_4_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cash_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cash_2" ] = {
    type = "use",
    inv_obj = "inv_cash",
    use_place = "obj_barcounter_use_cash_2",
    room = private.room_objname,
    zz = "zz_barcounter",
    zz_gate = "gzz_cafe_barcounter"
  };
  local use_cash_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_cash" );
  
  end;
  local use_cash_2_beg = function ()
  
    ObjDelete( "obj_barcounter_use_cash_2" );
  
  end;
  local use_cash_2_end = function ()

    ObjMultiSet( { 
      { "obj_barcounter_clk_spoon", { input = true } },
      { "spr_barcounter_coffeecup",       { alp = 1 } },
      { "spr_barcounter_coffeecup_shadow",       { alp = 1 } },
      { "spr_barcounter_hand_l_1",       { alp = 1 } }
    } );
    ObjDelete( "anm_barcounter_coffie_1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cash_2", use_cash_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_cash_2", use_cash_2_inv );
  cmn.AddSubscriber( "use_cash_2", use_cash_2_end, private.room_objname );
  cmn.AddSubscriber( "use_cash_2_inv", use_cash_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_cash_2_beg", use_cash_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_cash_2_end", use_cash_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pen_3 () end;
  --------------------------------------------------------------------------------------------

  local use_pen_3_inv = function ()
  
    interface.InventoryItemRemove( "inv_pen" );
  
  end;
  local use_pen_3_beg = function ()
  
    ObjDelete( "obj_barcounter_use_pen_3" );
  
  end;
  local use_pen_3_end = function ()

    ObjMultiSet( { 
      { "spr_barcounter_tableplacing",  { input = true, alp = 1 } },
      { "gfx_barcounter_tableplacing",  { active = true } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pen_3", use_pen_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_pen_3", use_pen_3_inv );
  cmn.AddSubscriber( "use_pen_3", use_pen_3_end, private.room_objname );
  cmn.AddSubscriber( "use_pen_3_inv", use_pen_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_pen_3_beg", use_pen_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_pen_3_end", use_pen_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bartenderslostrecipe () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bartenderslostrecipe" ] = {
    type = "use",
    inv_obj = "inv_bartenderslostrecipe",
    use_place = "obj_barcounter_use_bartenderslostrecipe",
    room = private.room_objname,
    zz = "zz_barcounter",
    zz_gate = "gzz_cafe_barcounter"
  };
  local use_bartenderslostrecipe_inv = function ()
  
    interface.InventoryItemRemove( "inv_bartenderslostrecipe" );
  
  end;
  local use_bartenderslostrecipe_beg = function ()
  
    ObjDelete( "obj_barcounter_use_bartenderslostrecipe" );
  
  end;
  local use_bartenderslostrecipe_end = function ()

    ObjSet( "gho_cafe_barcounter", { input = true, active = true, alp = 1 } );
    ObjDelete( "gzz_cafe_barcounter" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bartenderslostrecipe", use_bartenderslostrecipe_beg, private.room_objname );
  cmn.AddSubscriber( "use_bartenderslostrecipe", use_bartenderslostrecipe_inv );
  cmn.AddSubscriber( "use_bartenderslostrecipe", use_bartenderslostrecipe_end, private.room_objname );
  cmn.AddSubscriber( "use_bartenderslostrecipe_inv", use_bartenderslostrecipe_inv, private.room_objname );
  cmn.AddSubscriber( "use_bartenderslostrecipe_beg", use_bartenderslostrecipe_beg, private.room_objname );
  cmn.AddSubscriber( "use_bartenderslostrecipe_end", use_bartenderslostrecipe_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_coin_ext_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_coin_ext_2" ] = {
    type = "use",
    inv_obj = "inv_coin_ext_2",
    use_place = "obj_musicmachine_use_coin_ext_2",
    room = private.room_objname,
    zz = "zz_musicmachine",
    zz_gate = "gzz_cafe_musicmachine"
  };
  local use_coin_ext_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_coin_ext_2" );
  
  end;
  local use_coin_ext_2_beg = function ()
  
    ObjDelete( "obj_musicmachine_use_coin_ext_2" );
  
  end;
  local use_coin_ext_2_end = function ()
  
    ObjDelete( "anm_zz_musicmachine_use_coin_2" );
    ObjSet( "obj_zz_musicmachine_clk_button_light", { input = true } );

    ObjDelete( "obj_musicmachine_coin" );
    ObjSet( "obj_musicmachine_track", { alp = 1, active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_coin_ext_2", use_coin_ext_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_coin_ext_2", use_coin_ext_2_inv );
  cmn.AddSubscriber( "use_coin_ext_2", use_coin_ext_2_end, private.room_objname );
  cmn.AddSubscriber( "use_coin_ext_2_inv", use_coin_ext_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_coin_ext_2_beg", use_coin_ext_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_coin_ext_2_end", use_coin_ext_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletmelody () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletmelody" ] = {
    type = "use",
    inv_obj = "inv_amuletmelody",
    use_place = "obj_musicmachine_use_amuletmelody",
    room = private.room_objname,
    zz = "zz_musicmachine",
    zz_gate = "gzz_cafe_musicmachine"
  };
  local use_amuletmelody_inv = function ()
  
    interface.InventoryItemRemove( "inv_amuletmelody" );
  
  end;
  local use_amuletmelody_beg = function ()
  
    ObjDelete( "obj_musicmachine_use_amuletmelody" );
  
  end;
  local use_amuletmelody_end = function ()
  
    ObjSet( "spr_zz_musicmachine_amuletmelody", { alp = 1, visible = true } );
    ObjSet( "obj_musicmachine_use_coin_ext_2", { input = true } );

    ObjDelete( "spr_musicmachine_text_1" );
    ObjSet( "obj_musicmachine_coin", { alp = 1, active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amuletmelody", use_amuletmelody_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletmelody", use_amuletmelody_inv );
  cmn.AddSubscriber( "use_amuletmelody", use_amuletmelody_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletmelody_inv", use_amuletmelody_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletmelody_beg", use_amuletmelody_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletmelody_end", use_amuletmelody_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_magnet_ext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_magnet_ext" ] = {
    type = "use",
    inv_obj = "inv_magnet_ext",
    use_place = "obj_musicmachine_use_magnet_ext",
    room = private.room_objname,
    zz = "zz_musicmachine",
    zz_gate = "gzz_cafe_musicmachine"
  };
  local use_magnet_ext_inv = function ()
  
    interface.InventoryItemRemove( "inv_magnet_ext" );
  
  end;
  local use_magnet_ext_beg = function ()
  
    ObjDelete( "obj_musicmachine_use_magnet_ext" );
    ObjDelete( "spr_musicmachine_cafebadge2_2" );
  
  end;
  local use_magnet_ext_end = function ()
  
    ObjDelete( "anm_zz_musicmachine_use_magnet" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_magnet_ext", use_magnet_ext_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnet_ext", use_magnet_ext_inv );
  cmn.AddSubscriber( "use_magnet_ext", use_magnet_ext_end, private.room_objname );
  cmn.AddSubscriber( "use_magnet_ext_inv", use_magnet_ext_inv, private.room_objname );
  cmn.AddSubscriber( "use_magnet_ext_beg", use_magnet_ext_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnet_ext_end", use_magnet_ext_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lever_ext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lever_ext" ] = {
    type = "use",
    inv_obj = "inv_lever_ext",
    use_place = "obj_storeroom_use_lever_ext",
    room = private.room_objname,
    zz = "zz_storeroom",
    zz_gate = "gzz_cafe_storeroom"
  };
  local use_lever_ext_inv = function ()
  
    interface.InventoryItemRemove( "inv_lever_ext" );
  
  end;
  local use_lever_ext_beg = function ()
  
    ObjDelete( "obj_storeroom_use_lever_ext" );
  
  end;
  local use_lever_ext_end = function ()

    ObjMultiSet( {
      { "spr_storeroom_lever_ext_off",    { alp = 1 } },
      { "obj_storeroom_clk_lever_ext",    { input = true, alp = 1 } },
      { "spr_cafe_storeroom_storeroom2",  { alp = 1 } },

      { "obj_storeroom_roast_beef", { input = true, active = true, visible = true } },
    } );
    ObjDelete( "spr_cafe_storeroom_storeroom1" );  

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lever_ext", use_lever_ext_beg, private.room_objname );
  cmn.AddSubscriber( "use_lever_ext", use_lever_ext_inv );
  cmn.AddSubscriber( "use_lever_ext", use_lever_ext_end, private.room_objname );
  cmn.AddSubscriber( "use_lever_ext_inv", use_lever_ext_inv, private.room_objname );
  cmn.AddSubscriber( "use_lever_ext_beg", use_lever_ext_beg, private.room_objname );
  cmn.AddSubscriber( "use_lever_ext_end", use_lever_ext_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cafebadge1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cafebadge1" ] = {
    type = "use",
    inv_obj = "inv_cafebadge1",
    use_place = "obj_storeroom_use_cafebadge1",
    room = private.room_objname,
    zz = "zz_storeroom",
    zz_gate = "gzz_cafe_storeroom"
  };
  local use_cafebadge1_inv = function ()
  
    interface.InventoryItemRemove( "inv_cafebadge1" );
  
  end;
  local use_cafebadge1_beg = function ()
  
    ObjDelete( "obj_storeroom_use_cafebadge1" );
  
  end;
  local use_cafebadge1_end = function ()
  
    ObjSet( "spr_storeroom_cafebadge1", { alp = 1 } );

    if ( cmn.IsEventDone( "use_cafebadge2" ) ) then

      ObjMultiSet( { 
        { "spr_storeroom_bartenderslostrecipe", { input = true, alp = 1 } },
        { "spr_storeroom_door_cafebadge1",      { pos_x = 398, pos_y = 175 } }, 
        { "spr_storeroom_door_cafebadge2",      { pos_x = 96, pos_y = 39 } },
        { "gfx_storeroom_bartenderslostrecipe", { active = true } }, 
      } );

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cafebadge1", use_cafebadge1_beg, private.room_objname );
  cmn.AddSubscriber( "use_cafebadge1", use_cafebadge1_inv );
  cmn.AddSubscriber( "use_cafebadge1", use_cafebadge1_end, private.room_objname );
  cmn.AddSubscriber( "use_cafebadge1_inv", use_cafebadge1_inv, private.room_objname );
  cmn.AddSubscriber( "use_cafebadge1_beg", use_cafebadge1_beg, private.room_objname );
  cmn.AddSubscriber( "use_cafebadge1_end", use_cafebadge1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cafebadge2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cafebadge2" ] = {
    type = "use",
    inv_obj = "inv_cafebadge2",
    use_place = "obj_storeroom_use_cafebadge2",
    room = private.room_objname,
    zz = "zz_storeroom",
    zz_gate = "gzz_cafe_storeroom"
  };
  local use_cafebadge2_inv = function ()
  
    interface.InventoryItemRemove( "inv_cafebadge2" );
  
  end;
  local use_cafebadge2_beg = function ()
  
    ObjDelete( "obj_storeroom_use_cafebadge2" );
  
  end;
  local use_cafebadge2_end = function ()
  
    ObjSet( "spr_storeroom_cafebadge2", { alp = 1 } );

    if ( cmn.IsEventDone( "use_cafebadge1" ) ) then

      ObjMultiSet( { 
        { "spr_storeroom_bartenderslostrecipe", { input = true, alp = 1 } },
        { "spr_storeroom_door_cafebadge1", { pos_x = 398, pos_y = 175 } }, 
        { "spr_storeroom_door_cafebadge2", { pos_x = 96, pos_y = 39 } }, 
        { "gfx_storeroom_bartenderslostrecipe", { active = true } }, 
      } );

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cafebadge2", use_cafebadge2_beg, private.room_objname );
  cmn.AddSubscriber( "use_cafebadge2", use_cafebadge2_inv );
  cmn.AddSubscriber( "use_cafebadge2", use_cafebadge2_end, private.room_objname );
  cmn.AddSubscriber( "use_cafebadge2_inv", use_cafebadge2_inv, private.room_objname );
  cmn.AddSubscriber( "use_cafebadge2_beg", use_cafebadge2_beg, private.room_objname );
  cmn.AddSubscriber( "use_cafebadge2_end", use_cafebadge2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bartenderlocket () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bartenderlocket" ] = {
    type = "use",
    inv_obj = "inv_bartenderlocket",
    use_place = "obj_storeroom_use_bartenderlocket",
    room = private.room_objname,
    zz = "zz_storeroom",
    zz_gate = "gzz_cafe_storeroom"
  };
  local use_bartenderlocket_inv = function ()
  
    interface.InventoryItemRemove( "inv_bartenderlocket" );
  
  end;
  local use_bartenderlocket_beg = function ()
  
    ObjDelete( "obj_storeroom_use_bartenderlocket" );
  
  end;
  local use_bartenderlocket_end = function ()
  
    ObjMultiSet( { 
      { "spr_storeroom_wrench_ext",           { input = true, alp = 1 } },
      { "spr_storeroom_door_bartenderlocket", { pos_x = -178, pos_y = 176 } }, 
      { "gfx_storeroom_wrench_ext",           { active = true } },
      { "spr_cafe_storeroom_storeroom5",        { alp = 1 } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bartenderlocket", use_bartenderlocket_beg, private.room_objname );
  cmn.AddSubscriber( "use_bartenderlocket", use_bartenderlocket_inv );
  cmn.AddSubscriber( "use_bartenderlocket", use_bartenderlocket_end, private.room_objname );
  cmn.AddSubscriber( "use_bartenderlocket_inv", use_bartenderlocket_inv, private.room_objname );
  cmn.AddSubscriber( "use_bartenderlocket_beg", use_bartenderlocket_beg, private.room_objname );
  cmn.AddSubscriber( "use_bartenderlocket_end", use_bartenderlocket_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tableplacing () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tableplacing" ] = {
    type = "use",
    inv_obj = "inv_tableplacing",
    use_place = "obj_cafe_use_tableplacing",
    room = private.room_objname,
  };
  local use_tableplacing_inv = function ()
  
    interface.InventoryItemRemove( "inv_tableplacing" );
  
  end;
  local use_tableplacing_beg = function ()
  
    ObjDelete( "obj_cafe_use_tableplacing" );
  
  end;
  local use_tableplacing_end = function ()
  
    ObjMultiSet( { 
      { "obj_cafe_mmg",             { alp = 1, input = true } },
      { "spr_cafe_hand",            { pos_x = 967, pos_y = 590 } },
      { "gzz_cafe_barcounter",      { input = false, alp = 0, active = false, alp = 0 } },
      { "gzz_cafe_musicmachine",    { input = false, alp = 0, active = false, alp = 0 } },
      { "gzz_cafe_storeroom",       { input = false, alp = 0, active = false, alp = 0 } },
      { "grm_cafe_nearcafe_1",      { input = false, alp = 0, active = false, alp = 0 } },
    } ); 

      if port.isPortable() == 1 then
        port.GrmEventLightOff("grm_cafe_nearcafe_1_focus");
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tableplacing", use_tableplacing_beg, private.room_objname );
  cmn.AddSubscriber( "use_tableplacing", use_tableplacing_inv );
  cmn.AddSubscriber( "use_tableplacing", use_tableplacing_end, private.room_objname );
  cmn.AddSubscriber( "use_tableplacing_inv", use_tableplacing_inv, private.room_objname );
  cmn.AddSubscriber( "use_tableplacing_beg", use_tableplacing_beg, private.room_objname );
  cmn.AddSubscriber( "use_tableplacing_end", use_tableplacing_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_table () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_table" ] = {
    type = "click",
    use_place = "obj_table_clk_table",
    room = private.room_objname,
    zz = "zz_table",
    zz_gate = "gzz_cafe_table",
  };

  local clk_table_beg = function ()
  
    ObjDelete( "obj_table_clk_table" );
  
  end;
  local clk_table_end = function ()

    ObjDelete( "anm_table_frazer" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_table", clk_table_beg, private.room_objname );
  cmn.AddSubscriber( "clk_table", clk_table_end, private.room_objname );
  cmn.AddSubscriber( "clk_table_beg", clk_table_beg, private.room_objname );
  cmn.AddSubscriber( "clk_table_end", clk_table_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_lever_ext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_lever_ext" ] = {
    type = "click",
    use_place = "obj_storeroom_clk_lever_ext",
    room = private.room_objname,
    zz = "zz_storeroom",
    zz_gate = "gzz_cafe_storeroom"
  };

  local clk_lever_ext_beg = function ()
  
    ObjDelete( "obj_storeroom_clk_lever_ext" );
  
  end;
  local clk_lever_ext_end = function ()

    ObjMultiSet( {
      { "spr_storeroom_lever_ext_on",     { alp = 1 } }, 
      { "spr_storeroom_magnet_ext",       { input = true  } }, 
      { "gfx_storeroom_magnet_ext",       { active = true } }, 
      { "spr_cafe_storeroom_storeroom3",  { alp = 1 } },
    } );  
    ObjDelete( "spr_storeroom_feetback1" );
    ObjDelete( "spr_storeroom_lever_door" );
    ObjDelete( "spr_cafe_storeroom_storeroom2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_lever_ext", clk_lever_ext_beg, private.room_objname );
  cmn.AddSubscriber( "clk_lever_ext", clk_lever_ext_end, private.room_objname );
  cmn.AddSubscriber( "clk_lever_ext_beg", clk_lever_ext_beg, private.room_objname );
  cmn.AddSubscriber( "clk_lever_ext_end", clk_lever_ext_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_bartenderlocket () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_bartenderlocket" ] = {
    type = "click",
    use_place = "obj_storeroom_clk_bartenderlocket",
    room = private.room_objname,
    zz = "zz_storeroom",
    zz_gate = "gzz_cafe_storeroom"
  };

  local clk_bartenderlocket_beg = function ()

    ObjDelete( "obj_storeroom_clk_bartenderlocket" );

  end;
  local clk_bartenderlocket_end = function ()

    ObjMultiSet( { 
      { "obj_storeroom_use_bartenderlocket",    { input = true } },
    } );

    ObjDelete( "spr_storeroom_barmanclothing" );
    ObjDelete( "spr_cafe_storeroom_storeroom4" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_bartenderlocket", clk_bartenderlocket_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bartenderlocket", clk_bartenderlocket_end, private.room_objname );
  cmn.AddSubscriber( "clk_bartenderlocket_beg", clk_bartenderlocket_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bartenderlocket_end", clk_bartenderlocket_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_musicmachine_button () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_musicmachine_button" ] = {
    type = "click",
    use_place = "obj_zz_musicmachine_clk_button_red",
    room = private.room_objname,
    zz = "zz_musicmachine",
    zz_gate = "gzz_cafe_musicmachine"
  };

  local clk_musicmachine_button_beg = function ()

    ObjDelete( "obj_zz_musicmachine_clk_button_light" );
    ObjDelete( "obj_musicmachine_track" );

  end;
  local clk_musicmachine_button_end = function ()

    ObjSet( "spr_cafe_musicmachine_musicmachine3", { alp = 1 } );
    ObjDelete( "spr_cafe_musicmachine_musicmachine4", { alp = 1 } );
    ObjDelete( "spr_cafe_musicmachine_musicmachine2" );
    ObjSet( "obj_zz_musicmachine_angel_after",  { alp = 1, visible = true, input = true } ); 
    ObjDelete( "obj_zz_musicmachine_angel_before" );
    ObjDelete( "anm_zz_musicmachine_playing" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_musicmachine_button", clk_musicmachine_button_beg, private.room_objname );
  cmn.AddSubscriber( "clk_musicmachine_button", clk_musicmachine_button_end, private.room_objname );
  cmn.AddSubscriber( "clk_musicmachine_button_beg", clk_musicmachine_button_beg, private.room_objname );
  cmn.AddSubscriber( "clk_musicmachine_button_end", clk_musicmachine_button_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_spoon () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_spoon" ] = {
    type = "click",
    use_place = "obj_barcounter_clk_spoon",
    room = private.room_objname,
    zz = "zz_barcounter",
    zz_gate = "gzz_cafe_barcounter"
  };

  local clk_spoon_beg = function ()

    ObjDelete( "obj_barcounter_clk_spoon" );
    ObjDelete( "spr_barcounter_coffeecup" );
    ObjDelete( "spr_barcounter_coffeecup_shadow" );

  end;
  local clk_spoon_end = function ()

    ObjMultiSet( {
      { "obj_barcounter_clk_barphone",    { input = true } }, 
      { "anm_barcounter_call_hand",       { alp = 1, playing = true } },
    } );
    ObjDelete( "anm_barcounter_call_call" );
    ObjDelete( "spr_barcounter_cup" );
    ObjDelete( "anm_barcounter_coffie_2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_spoon", clk_spoon_beg, private.room_objname );
  cmn.AddSubscriber( "clk_spoon", clk_spoon_end, private.room_objname );
  cmn.AddSubscriber( "clk_spoon_beg", clk_spoon_beg, private.room_objname );
  cmn.AddSubscriber( "clk_spoon_end", clk_spoon_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_mmg_table () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_mmg_table" ] = {
    type = "click",
    use_place = "obj_barcounter_clk_mmg_table",
    room = private.room_objname,
  };

  local clk_mmg_table_beg = function ()

    ObjDelete( "obj_barcounter_clk_spoon" );

  end;
  local clk_mmg_table_end = function ()

    ObjMultiSet( {
      { "gzz_cafe_table",           { input = true, alp = 1, active = true, alp = 1 } },
      { "gzz_cafe_barcounter",      { input = true, alp = 1, active = true, alp = 1 } },
      { "gzz_cafe_musicmachine",    { input = true, alp = 1, active = true, alp = 1 } },
      { "gzz_cafe_storeroom",       { input = true, alp = 1, active = true, alp = 1 } },
      { "grm_cafe_nearcafe_1",      { input = true, alp = 1, active = true, alp = 1 } },
    } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_cafe_nearcafe_1_focus");
    end;
    ObjDelete( "obj_cafe_mmg" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_mmg_table", clk_mmg_table_beg, private.room_objname );
  cmn.AddSubscriber( "clk_mmg_table", clk_mmg_table_end, private.room_objname );
  cmn.AddSubscriber( "clk_mmg_table_beg", clk_mmg_table_beg, private.room_objname );
  cmn.AddSubscriber( "clk_mmg_table_end", clk_mmg_table_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_call_kane_3 () end;
  --------------------------------------------------------------------------------------------
  local see_call_kane_3 = function ()

    --ObjDelete( "" );
    ObjSet( "obj_cafe_clk_david_kane_3", { input = true, visible = true, active = true, alp = 1} );
   
  end;
  cmn.AddSubscriber( "see_call_kane_3", see_call_kane_3, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function see_josh_fraser_leave () end;
  --------------------------------------------------------------------------------------------
  local see_josh_fraser_leave = function ()

    ObjDelete( "spr_table_folder" );    
   
  end;
  cmn.AddSubscriber( "see_josh_fraser_leave", see_josh_fraser_leave, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function dlg_cafe_barman_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_cafe_barman_1" ] = {
    type = "click",
    use_place = "obj_cafe_clk_barman_1_focus",
    room = private.room_objname
  };
  local dlg_cafe_barman_1 = function ()

    ObjDelete( "obj_cafe_clk_barman_1" );
    ObjDelete( "dlg_cafe_barman_1_lip" );

  end;
  cmn.AddSubscriber( "dlg_cafe_barman_1", dlg_cafe_barman_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_cafe_david_kane_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_cafe_david_kane_3" ] = {
    type = "click",
    use_place = "obj_barcounter_clk_barphone",
    room = private.room_objname,
    zz = "zz_barcounter",
    zz_gate = "gzz_cafe_barcounter"
  };

  local dlg_cafe_david_kane_3 = function ()

    ObjDelete( "anm_barcounter_call_hand" );
    ObjDelete( "obj_barcounter_clk_barphone" );
    ObjDelete( "dlg_cafe_david_kane_3_lip" );
    ObjSet( "spr_barcounter_hand_r_1", { alp = 1 } );

  end;
  cmn.AddSubscriber( "dlg_cafe_david_kane_3", dlg_cafe_david_kane_3, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function dlg_cafe_josh_fraser_2 () end;
  --------------------------------------------------------------------------------------------
  local dlg_cafe_josh_fraser_2 = function ()

    ObjDelete( "dlg_cafe_josh_fraser_2_lip" );
    
  end;
  cmn.AddSubscriber( "dlg_cafe_josh_fraser_2", dlg_cafe_josh_fraser_2, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()

  --*********************************************************************************************************************
  -- function zz_barcounter () end;
  --*********************************************************************************************************************
    subroom.Define( "zz_barcounter" );
    function zz_barcounter.PreOpen()

    end;
    -------------------------------------------------
    function zz_barcounter.Open()
    end;
    -------------------------------------------------
    function zz_barcounter.PreClose()
    end;
    -------------------------------------------------
    function zz_barcounter.Close()
--
--      if ( cmn.IsEventDone( "get_coffeecup" ) and not cmn.IsEventDone( "see_call_kane_3" ) ) then
--
--        private.see_call_kane_3();
--
--      end;

    end;
    -------------------------------------------------

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_cafe();
  int_slider.InitSlider( private.room_objname );

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

  if ( cmn.IsEventDone( "clk_table" ) and not cmn.IsEventDone( "dlg_cafe_josh_fraser_2" ) ) then
    private.dlg_josh_fraser_2_click(); 
  end; 

  if ( cmn.IsEventDone( "dlg_cafe_josh_fraser_2" ) and not cmn.IsEventDone( "see_josh_fraser_leave" ) ) then
    private.see_josh_fraser_leave(); 
  end; 

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();

  common_impl.EnvPlay( { "levelext/env/aud_cafe_env" }, "", 0.5 );

  if ( cmn.IsEventDone( "use_tableplacing" ) and not cmn.IsEventDone( "clk_mmg_table" ) ) then
    
    private.HandAnimations();

  end;

end;
--*********************************************************************************************************************
function public.Close ()

  if ( cmn.IsEventDone( "use_tableplacing" ) and not cmn.IsEventDone( "clk_mmg_table" ) ) then
    
    ObjSet( "spr_cafe_hand", { pos_x = 967, pos_y = 590 } );

  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  if ( cmn.IsEventDone( "clk_musicmachine_button" ) ) then

    common_impl.StopAudio( "mus", "levelext/mus/aud_mus_hh_7", 0.3 );
    common_impl.StopAudio( "mus", "levelext/mus/aud_mus_mt", 0.3 );
    common_impl.StopAudio( "mus", "levelext/mus/aud_mus_hh_6" , 0.3 );

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_cash_2 ()

  local item = "inv_cash";

  if ( cmn.ApplyObj( item, "gzz_cafe_barcounter" ) and cmn.IsEventDone( "dlg_cafe_barman_1" ) ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_barcounter", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_barcounter_use_cash_2" ) and cmn.IsEventDone( "dlg_cafe_barman_1" ) ) then

    cmn.CallEventHandler( "use_cash_2_inv" );
    cmn.CallEventHandler( "use_cash_2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_cash_2" );
      cmn.CallEventHandler( "use_cash_2_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_money1", 0, "", 0 );
    ObjSet( "anm_barcounter_coffie_1", { alp = 1 } ); 
    AnimPlay( "anm_barcounter_coffie_1", "coffeegive", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_pen_3 ()

  local item = "inv_pen";

  if ( cmn.ApplyObj( item, "gzz_cafe_barcounter" ) and cmn.IsEventDone( "dlg_cafe_david_kane_3" ) ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_barcounter", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_barcounter_use_pen_3" ) and cmn.IsEventDone( "dlg_cafe_david_kane_3" ) ) then

    cmn.CallEventHandler( "use_pen_3_inv" );
    cmn.CallEventHandler( "use_pen_3_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_pen_3" );
      cmn.CallEventHandler( "use_pen_3_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_pen_3", 0, "", 0 );

    func_end();

    --cmn.ItemFly( "spr", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_bartenderslostrecipe ()

  local item = "inv_bartenderslostrecipe";

  if cmn.ApplyObj( item, "gzz_cafe_barcounter" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_barcounter", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_barcounter_use_bartenderslostrecipe" ) ) then

    cmn.CallEventHandler( "use_bartenderslostrecipe_inv" );
    cmn.CallEventHandler( "use_bartenderslostrecipe_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_bartenderslostrecipe" );
      cmn.CallEventHandler( "use_bartenderslostrecipe_end" );
      common.CloseSubRoom();

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "aud_paper", 0, "", 0 );

    func_end();
    --cmn.ItemFly( "spr_storeroom_bartenderlocket", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_coin_ext_2 ()

  local item = "inv_coin_ext_2";

  if cmn.ApplyObj( item, "gzz_cafe_musicmachine" ) and cmn.IsEventDone( "use_amuletmelody" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_musicmachine", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_musicmachine_use_coin_ext_2" ) and cmn.IsEventDone( "use_amuletmelody" ) ) then

    cmn.CallEventHandler( "use_coin_ext_2_inv" );
    cmn.CallEventHandler( "use_coin_ext_2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_coin_ext_2" );
      cmn.CallEventHandler( "use_coin_ext_2_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_use_coin", 0, "", 0 );

    AnimPlay( "anm_zz_musicmachine_use_coin_2", "DoAnim", func_end );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_amuletmelody ()

  local item = "inv_amuletmelody";

  if cmn.ApplyObj( item, "gzz_cafe_musicmachine" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_musicmachine", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_musicmachine_use_amuletmelody" ) ) then

    cmn.CallEventHandler( "use_amuletmelody_inv" );
    cmn.CallEventHandler( "use_amuletmelody_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_amuletmelody" );
      cmn.CallEventHandler( "use_amuletmelody_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );

    ObjSet( "spr_zz_musicmachine_amuletmelody", { alp = 0, visible = true } );
    ObjAnimate( "spr_zz_musicmachine_amuletmelody", "alp",0,0, func_end, { 0, 0, 0,    0.6, 0, 1 } );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_magnet_ext ()

  local item = "inv_magnet_ext";

  if cmn.ApplyObj( item, "gzz_cafe_musicmachine" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_musicmachine", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_musicmachine_use_magnet_ext" ) ) then

    cmn.CallEventHandler( "use_magnet_ext_inv" );
    cmn.CallEventHandler( "use_magnet_ext_beg" );

    local func_end = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "use_magnet_ext" );
      cmn.CallEventHandler( "use_magnet_ext_end" );

      private.get_cafebadge2();

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_magnet_ext", 0, "", 0 );

    ObjSet( "anm_zz_musicmachine_use_magnet", { alp = 1 } );
    AnimPlay( "anm_zz_musicmachine_use_magnet", "DoAnim", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_lever_ext ()

  local item = "inv_lever_ext";

  if cmn.ApplyObj( item, "gzz_cafe_storeroom" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_storeroom", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_storeroom_use_lever_ext" ) ) then

    cmn.CallEventHandler( "use_lever_ext_inv" );
    cmn.CallEventHandler( "use_lever_ext_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_lever_ext" );
      cmn.CallEventHandler( "use_lever_ext_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_lever", 0, "", 0 );
    cmn.ItemFly( "spr_storeroom_lever_ext_off", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_cafebadge1 ()

  local item = "inv_cafebadge1";

  if ( cmn.ApplyObj( item, "gzz_cafe_storeroom" ) and ( 
    not cmn.IsEventDone( "use_tableplacing" ) or cmn.IsEventDone( "clk_mmg_table" ) ) ) then

  --interface.ObjDoNotDrop( item );
   cmn.GotoSubRoom( "zz_storeroom", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_storeroom_use_cafebadge1" ) and ( 
    not cmn.IsEventDone( "use_tableplacing" ) or cmn.IsEventDone( "clk_mmg_table" ) ) ) then

    cmn.CallEventHandler( "use_cafebadge1_inv" );
    cmn.CallEventHandler( "use_cafebadge1_beg" );

    local func_end = function ()

      local func_end_1 = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_cafebadge1" );
        cmn.CallEventHandler( "use_cafebadge1_end" );

      end;

      if ( cmn.IsEventDone( "use_cafebadge2" ) ) then

        ObjAnimate( "spr_storeroom_door_cafebadge1", "pos_xy",0,0, func_end_1, 
        { 
          0.0, 1, ObjGet( "spr_storeroom_door_cafebadge1" ).pos_x, ObjGet( "spr_storeroom_door_cafebadge1" ).pos_y,    
          0.5, 1, 398, 175,
        } );
        ObjAnimate( "spr_storeroom_door_cafebadge2", "pos_xy",0,0, "", 
        { 
          0.0, 1, ObjGet( "spr_storeroom_door_cafebadge2" ).pos_x, ObjGet( "spr_storeroom_door_cafebadge2" ).pos_y,    
          0.5, 1, 96, 39,
        } );    

      else  

        func_end_1();        

      end;

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );

    cmn.ItemFly( "spr_storeroom_cafebadge1", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_cafebadge2 ()

  local item = "inv_cafebadge2";

  if cmn.ApplyObj( item, "gzz_cafe_storeroom" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_storeroom", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_storeroom_use_cafebadge2" ) ) then

    cmn.CallEventHandler( "use_cafebadge2_inv" );
    cmn.CallEventHandler( "use_cafebadge2_beg" );

    local func_end = function() 

      local func_end_1 = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_cafebadge2" );
        cmn.CallEventHandler( "use_cafebadge2_end" );

      end;

      if ( cmn.IsEventDone( "use_cafebadge1" ) ) then

        ObjAnimate( "spr_storeroom_door_cafebadge1", "pos_xy",0,0, func_end_1, 
        { 
          0.0, 1, ObjGet( "spr_storeroom_door_cafebadge1" ).pos_x, ObjGet( "spr_storeroom_door_cafebadge1" ).pos_y,    
          0.5, 1, 398, 175,
        } );
        ObjAnimate( "spr_storeroom_door_cafebadge2", "pos_xy",0,0, "", 
        { 
          0.0, 1, ObjGet( "spr_storeroom_door_cafebadge2" ).pos_x, ObjGet( "spr_storeroom_door_cafebadge2" ).pos_y,    
          0.5, 1, 96, 39,
        } );    

      else  

        func_end_1();        

      end;

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );

    cmn.ItemFly( "spr_storeroom_cafebadge2", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_bartenderlocket ()

  local item = "inv_bartenderlocket";

  if ( cmn.ApplyObj( item, "gzz_cafe_storeroom" ) and cmn.IsEventDone( "clk_bartenderlocket" ) ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_storeroom", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_storeroom_use_bartenderlocket" ) and cmn.IsEventDone( "clk_bartenderlocket" ) ) then

    cmn.CallEventHandler( "use_bartenderlocket_inv" );
    cmn.CallEventHandler( "use_bartenderlocket_beg" );

    local func_end = function ()

      local func_end_1 = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_bartenderlocket" );
        cmn.CallEventHandler( "use_bartenderlocket_end" );

      end;

      ObjAnimate( "spr_storeroom_door_bartenderlocket", "pos_xy", 0, 0, func_end_1, 
      { 
        0.0, 1, ObjGet( "spr_storeroom_door_bartenderlocket" ).pos_x, ObjGet( "spr_storeroom_door_bartenderlocket" ).pos_y,    
        0.5, 1, -178, 176,
      } );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );

    cmn.ItemFly( "spr_storeroom_bartenderlocket", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_tableplacing ()

  local item = "inv_tableplacing";

  if ( cmn.ApplyObj( item, "obj_cafe_use_tableplacing" ) ) then

    cmn.CallEventHandler( "use_tableplacing_inv" );
    cmn.CallEventHandler( "use_tableplacing_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_tableplacing" );
      cmn.CallEventHandler( "use_tableplacing_end" );
      private.HandAnimations();

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_tableplacing", 0, "", 0 );

    ObjAnimate( "obj_cafe_mmg", "alp", 0, 0, "", 
    { 
      0.0, 0, ObjGet( "obj_cafe_mmg" ).alp,     
      0.3, 0, 1
    } );
    ObjAnimate( "spr_cafe_hand", "pos_xy", 0, 0, func_end, 
    { 
      0.0, 0, ObjGet( "spr_cafe_hand" ).pos_x, ObjGet( "spr_cafe_hand" ).pos_y,     
      0.3, 0, ObjGet( "spr_cafe_hand" ).pos_x, ObjGet( "spr_cafe_hand" ).pos_y, 
      0.8, 0, 967, 590,    
    } );

    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_tableplacing ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_tableplacing" );
  cmn.CallEventHandler( "get_tableplacing" );

end;

--------------------------------------------------------------------------------------------
function private.get_cafebadge1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_cafebadge1" );
  cmn.CallEventHandler( "get_cafebadge1" );

end;
--------------------------------------------------------------------------------------------
function private.get_bill ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_bill" );
  cmn.CallEventHandler( "get_bill" );

  if ( cmn.IsEventDone( "get_amuletmelodypart" ) ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_amuletmelodypart ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_amuletmelodypart" );
  cmn.CallEventHandler( "get_amuletmelodypart" );

  if ( cmn.IsEventDone( "get_bill" ) ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_amuletmelodypart2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_amuletmelodypart2" );
  cmn.CallEventHandler( "get_amuletmelodypart2" );

  if ( cmn.IsEventDone( "get_cafebadge2" ) and 
    cmn.IsEventDone( "get_stonewings" ) ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_stonewings ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_stonewings" );
  cmn.CallEventHandler( "get_stonewings" );

  if ( cmn.IsEventDone( "get_cafebadge2" ) and 
    cmn.IsEventDone( "get_amuletmelodypart2" ) ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_cafebadge2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_cafebadge2" );
  cmn.CallEventHandler( "get_cafebadge2" );

  if ( cmn.IsEventDone( "get_amuletmelodypart2" ) and 
    cmn.IsEventDone( "get_stonewings" ) ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_bartenderslostrecipe ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_bartenderslostrecipe" );
  cmn.CallEventHandler( "get_bartenderslostrecipe" );

end;
--------------------------------------------------------------------------------------------
function private.get_magnet_ext ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_magnet_ext" );
  cmn.CallEventHandler( "get_magnet_ext" );

end;
--------------------------------------------------------------------------------------------
function private.get_wrench_ext ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_wrench_ext" );
  cmn.CallEventHandler( "get_wrench_ext" );

  if ( cmn.IsGetCollect2( "get_collect2_item_4_5" ) ) then
  
    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_4_5 ()

  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_4_5" ); 

    if ( cmn.IsEventDone( "get_wrench_ext" ) ) then

      common.CloseSubRoom();

    end;

  end;

  common_impl.PlayEffectHO( "spr_collect2_item_4_5", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_4_5" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_table ()

  cmn.CallEventHandler( "clk_table_beg" );

  local func_end = function ()
  
    cmn.Lock( false );
    cmn.SetEventDone( "clk_table" );
    cmn.CallEventHandler( "clk_table_end" ); 

    common.CloseSubRoom();

    common_impl.ShowBbt( "bbt_cafe_clk_table" );

    private.dlg_josh_fraser_2_click();

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "aud_remove_clk1", 0, "", 0 );
  AnimPlay( "anm_table_frazer", "DoAnim", func_end );

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_josh_appears", 0, "", 0 );

end;

--------------------------------------------------------------------------------------------
function private.clk_lever_ext ()

  cmn.CallEventHandler( "clk_lever_ext_beg" ); 

  local func_end = function()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_lever_ext" );
    cmn.CallEventHandler( "clk_lever_ext_end" ); 

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide1", 0, "", 0 );

  ObjAnimate( "spr_storeroom_feetback1", "alp", 0, 0, "", 
  { 
    0.0, 0, ObjGet( "spr_storeroom_feetback1" ).alp,    
    0.3, 0, 0,
  } );  
  ObjAnimate( "spr_storeroom_lever_ext_on", "alp", 0, 0, "", 
  { 
    0.0, 0, ObjGet( "spr_storeroom_lever_ext_on" ).alp,    
    0.3, 0, 1,
  } );  
  ObjAnimate( "spr_storeroom_lever_door", "pos_xy", 0, 0, func_end, 
  { 
    0.00, 1, ObjGet( "spr_storeroom_lever_door" ).pos_x, ObjGet( "spr_storeroom_lever_door" ).pos_y,   
    0.15, 1, ObjGet( "spr_storeroom_lever_door" ).pos_x, ObjGet( "spr_storeroom_lever_door" ).pos_y, 
    0.45, 1, ObjGet( "spr_storeroom_lever_door" ).pos_x, -338
  } ); 

end;
--------------------------------------------------------------------------------------------
function private.clk_bartenderlocket ()

  cmn.CallEventHandler( "clk_bartenderlocket_beg" ); 

  local func_end = function()

    cmn.Lock( false );

    cmn.SetEventDone( "clk_bartenderlocket" );
    cmn.CallEventHandler( "clk_bartenderlocket_end" ); 

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_cloth1", 0, "", 0 );

  ObjAnimate( "spr_storeroom_barmanclothing", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 0, ObjGet( "spr_storeroom_barmanclothing" ).pos_x, ObjGet( "spr_storeroom_barmanclothing" ).pos_y,   
    0.3, 0, -153, 395
  } ); 

end;

--------------------------------------------------------------------------------------------
function private.clk_musicmachine_button ( id )

  cmn.CallEventHandler( "clk_musicmachine_button_beg" ); 

  local func_end = function()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_musicmachine_button" );
    cmn.CallEventHandler( "clk_musicmachine_button_end" ); 

  end;

  cmn.Lock( true );

  local musicArray = { 
                        red = "levelext/mus/aud_mus_hh_7",
                        yellow = "levelext/mus/aud_mus_mt",
                        green = "levelext/mus/aud_mus_hh_6" 
                     }; 

  local curMusic = musicArray[ id ];

  cmn.PlayMusEnv();

  common_impl.PlayAudio( "mus", curMusic, 0, "", 0 );

  local curButton = "spr_zz_musicmachine_"..id.."_focus";
  ObjAnimate( curButton, "alp",0,0, "", { 0, 3, 0,    0.4, 3, 1,    0.7, 3, 0.3,    1.1, 3, 1,    1.7, 3, 0 } );

  ObjSet( "anm_zz_musicmachine_playing", { alp = 1 } );
  AnimPlay( "anm_zz_musicmachine_playing", "DoAnim", func_end );

end;
--------------------------------------------------------------------------------------------
function private.clk_spoon ()

  cmn.CallEventHandler( "clk_spoon_beg" ); 

  local func_end = function()

    local func_end_1 = function()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_spoon" );
      cmn.CallEventHandler( "clk_spoon_end" );  

      common_impl.ShowBbt( "bbt_cafe_clk_spoon" );     

    end;

    ObjMultiSet( { 
      { "anm_barcounter_call_call",           { alp = 1 } },
      { "spr_barcounter_hand_r_1",           { alp = 0 } },
    } );
    AnimPlay( "anm_barcounter_call_call", "phone", func_end_1 );

  end;

  cmn.Lock( true );
  ObjSet( "obj_barcounter_cup",       { alp =  0 } );
  ObjSet( "anm_barcounter_coffie_2",  { alp =  1 } );
  AnimPlay( "anm_barcounter_coffie_2", "coffeetake", func_end );

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_coffee", 0, "", 0 );

end;
--------------------------------------------------------------------------------------------
function private.InitTables ()

  for i = 1, 4 do

    ObjSet( "obj_cafe_light_clk_table_"..i, 
    {
      event_mdown  = function() private.clk_mmg_table( i ); end,
      event_menter = function() private.ent_mmg_table( i ); end,
      event_mleave = function() private.lve_mmg_table( i ); end,
    } );

  end;

end;
--------------------------------------------------------------------------------------------
function private.clk_mmg_table ( id )

  if ( id == 2 ) then

    cmn.CallEventHandler( "clk_mmg_table_beg" ); 

    local func_end = function ()

      local func_end_1 = function ()

        cmn.Lock( false );
        cmn.SetEventDone( "clk_mmg_table" );
        cmn.CallEventHandler( "clk_mmg_table_end" );          

      end;

      ObjAnimate( "obj_cafe_mmg", "alp", 0, 0, func_end_1, 
      { 
        0.0, 0, ObjGet( "obj_cafe_mmg" ).alp,         
        0.3, 0, 0,       
      } );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_table", 0, "", 0 );

    ObjAnimate( "spr_cafe_light_table"..id, "alp", 0, 0, "", 
    { 
      0.0, 0, ObjGet( "spr_cafe_light_table"..id ).alp,         
      0.1, 0, 1,       
    } );
    ObjAnimate( "spr_cafe_light_light_win", "alp", 0, 0, func_end, 
    { 
      0.0, 0, ObjGet( "spr_cafe_light_light_win" ).alp,         
      0.1, 0, 1,    
      0.4, 0, 1,     
    } );

  else

    common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );
    common_impl.ShowBbt( 'bbt_cafe_clk_mmg_table' );      

  end; 

end; 
--------------------------------------------------------------------------------------------
function private.ent_mmg_table ( id )

  common_impl.SetCursor( CURSOR_HAND );
  ObjAnimate( "spr_cafe_light_table"..id, "alp", 0, 0, "", 
  { 
    0.0, 0, ObjGet( "spr_cafe_light_table"..id ).alp,         
    0.1, 0, 1,       
  } );

end;
--------------------------------------------------------------------------------------------
function private.lve_mmg_table ( id )

  common_impl.SetCursor( CURSOR_DEFAULT );
  ObjAnimate( "spr_cafe_light_table"..id, "alp", 0, 0, "", 
  { 
    0.0, 0, ObjGet( "spr_cafe_light_table"..id ).alp,         
    0.1, 0, 0,       
  } );

end;
--*********************************************************************************************************************
-- function *** FEEDBACKANIM *** () end;
--*********************************************************************************************************************
function private.UseCafebadge ()

  local func_end = function()

    cmn.Lock( false );
    common_impl.ShowBbt( "bbt_storeroom_use_cafebadge1" );
    common_impl.ShowBbt( "bbt_storeroom_use_cafebadge2" );

  end;

  cmn.Lock( true );
  ObjAnimate( "spr_storeroom_door_cafebadge1", "pos_xy", 0, 0, func_end, 
  { 
    0.00, 1, ObjGet( "spr_storeroom_door_cafebadge1" ).pos_x,      ObjGet( "spr_storeroom_door_cafebadge1" ).pos_y,    
    0.15, 1, ObjGet( "spr_storeroom_door_cafebadge1" ).pos_x + 3,  ObjGet( "spr_storeroom_door_cafebadge1" ).pos_y,
    0.30, 1, ObjGet( "spr_storeroom_door_cafebadge1" ).pos_x,      ObjGet( "spr_storeroom_door_cafebadge1" ).pos_y,   
  } );
  ObjAnimate( "spr_storeroom_door_cafebadge2", "pos_xy", 0, 0, "", 
  { 
    0.00, 1, ObjGet( "spr_storeroom_door_cafebadge2" ).pos_x, ObjGet( "spr_storeroom_door_cafebadge2" ).pos_y,    
    0.15, 1, ObjGet( "spr_storeroom_door_cafebadge2" ).pos_x, ObjGet( "spr_storeroom_door_cafebadge2" ).pos_y - 3,
    0.30, 1, ObjGet( "spr_storeroom_door_cafebadge2" ).pos_x, ObjGet( "spr_storeroom_door_cafebadge2" ).pos_y,   
  } );     

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk9", 0, "", 0 );

end;
--------------------------------------------------------------------------------------------
function private.UseLever_ext ()

  local func_end = function()

    cmn.Lock( false );
    common_impl.ShowBbt( "bbt_storeroom_use_lever_ext" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_metal_door", 0, "", 0 );

  ObjAnimate( "spr_storeroom_lever_door", "pos_xy", 0, 0, func_end, 
  { 
    0.00, 0, ObjGet( "spr_storeroom_lever_door" ).pos_x, ObjGet( "spr_storeroom_lever_door" ).pos_y,    
    0.15, 0, ObjGet( "spr_storeroom_lever_door" ).pos_x, ObjGet( "spr_storeroom_lever_door" ).pos_y - 8,
    0.30, 0, ObjGet( "spr_storeroom_lever_door" ).pos_x, ObjGet( "spr_storeroom_lever_door" ).pos_y,   
  } );
  ObjAnimate( "spr_storeroom_feetback1", "alp", 0, 0, "", 
  { 
    0.00, 0, 1, 
    0.15, 0, 0,
    0.30, 0, 1,
  } );   
  ObjAnimate( "spr_storeroom_feetback2", "alp", 0, 0, "", 
  { 
    0.00, 0, 0, 
    0.15, 0, 1,
    0.30, 0, 0,
  } )  

end;
--------------------------------------------------------------------------------------------
function private.UseBartenderlocket ()

  local func_end = function()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_storeroom_use_bartenderlocket' );

  end;

  cmn.Lock( true );
  ObjAnimate( "spr_storeroom_door_bartenderlocket", "pos_xy", 0, 0, func_end, 
  { 
    0.00, 0, ObjGet( "spr_storeroom_door_bartenderlocket" ).pos_x,      ObjGet( "spr_storeroom_door_bartenderlocket" ).pos_y,    
    0.15, 0, ObjGet( "spr_storeroom_door_bartenderlocket" ).pos_x - 4,  ObjGet( "spr_storeroom_door_bartenderlocket" ).pos_y,
    0.30, 0, ObjGet( "spr_storeroom_door_bartenderlocket" ).pos_x,      ObjGet( "spr_storeroom_door_bartenderlocket" ).pos_y,   
  } );

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk9", 0, "", 0 );

end;
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
function private.see_call_kane_3 ()

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "see_call_kane_3" ); 
    cmn.CallEventHandler( "see_call_kane_3" ); 

    private.dlg_david_kane_3_click(); 

  end;  
  
  cmn.Lock( true );
  func_end();

end;

--------------------------------------------------------------------------------------------
function private.see_josh_fraser_leave ()

  local func_end = function ()

    cmn.SetEventDone( "see_josh_fraser_leave" );
    cmn.CallEventHandler( "see_josh_fraser_leave" ); 
    common_impl.ShowBbt( "bbt_cafe_josh_fraser_leave" );    

    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "find_manager" );

    common_impl.StopAudio( "sfx", "levelext/sfx/aud_fraiser_away_1", 0.5 );

  end;

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_fraiser_away_1", 0, "", 0 );
  common_impl.PlayAudio( "voc", "levelext/voc/aud_leave_josh_fraser_voc", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_cafe_leave_josh_fraser", func_end );  

end;

--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )

  if dlg_name == "barman_1" then

    if ( count_txt == 1 ) then

      ObjSet( "spr_int_dialog_character_icon", { res = "" } );
      VidPlay( "vid_dlg_cafe_barman_1_1_voc", "" );

    elseif ( count_txt == 2 ) then

      ObjDelete( "vid_dlg_cafe_barman_1_1_voc" );
      ObjSet( "vid_dlg_cafe_barman_1_2_voc", { visible = true } );
      VidPlay( "vid_dlg_cafe_barman_1_2_voc", "" );

    elseif ( count_txt == 3 ) then

      ObjDelete( "vid_dlg_cafe_barman_1_2_voc" );
      ObjSet( "vid_dlg_cafe_barman_1_3_voc", { visible = true } );
      VidPlay( "vid_dlg_cafe_barman_1_3_voc", "" );

    end;

  --------------------------------------------------------------------

  elseif dlg_name == "david_kane_3" then

    if ( count_txt == 1 ) then

      ObjSet( "spr_int_dialog_character_icon", { res = "assets/interface/resources/dialog_character/btm_6" } );

    elseif ( count_txt == 3 ) then

      local func_end = function ()

        common_impl.StopAudio( "sfx", "levelext/sfx/aud_use_pen1", 0.5 );
      
      end;

      ObjMultiSet( {
        { "anm_dlg_cafe_david_kane_3_inscription",      { alp = 1 } },
        { "anm_dlg_cafe_david_kane_3_davidkane_right",  { alp = 0 } },
      } );
      AnimPlay( "anm_dlg_cafe_david_kane_3_inscription", "DoAnim", func_end );

      common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_pen1", 1, "", 0 );

    end;

  --------------------------------------------------------------------------------------

  elseif dlg_name == "josh_fraser_2" then

    if ( count_txt == 1 ) then

      ObjSet( "spr_int_dialog_character_icon", { res = "assets/interface/resources/dialog_character/btm_5" } );
      VidPlay( "vid_dlg_cafe_josh_fraser_2_1", "" );

    elseif ( count_txt == 2 ) then -- Terence Irwing 

      VidStop( "vid_dlg_cafe_josh_fraser_2_1" );
      ObjSet( "spr_int_dialog_character_icon", { res = "assets/interface/resources/dialog_character/btm_4" } );

    elseif ( count_txt == 3 ) then -- Josh Fraiser 
      
      ObjSet( "spr_int_dialog_character_icon", { res = "assets/interface/resources/dialog_character/btm_5" } );
      ObjDelete( "vid_dlg_cafe_josh_fraser_2_1" );
      ObjSet( "vid_dlg_cafe_josh_fraser_2_3", { visible = true } )
      VidPlay( "vid_dlg_cafe_josh_fraser_2_3", "" );

    elseif ( count_txt == 4 ) then

      ObjDelete( "vid_dlg_cafe_josh_fraser_2_3" );
      ObjSet( "vid_dlg_cafe_josh_fraser_2_4", { visible = true } )
      VidPlay( "vid_dlg_cafe_josh_fraser_2_4", "" );

    end;

  end; 

end;
--------------------------------------------------------------------------------------------
function private.dlg_barman_1_click ()

  ObjSet( "anm_cafe_barman", { alp = 0 } );
  ObjSet( "obj_cafe_clk_barman_1", { input = false } );

  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "barman_1", 4, nil, nil, true, private.dlg_barman_1_end );

end;
--------------------------------------------------------------------------------------------
function private.dlg_barman_1_end ()


  ObjSet( "anm_cafe_barman", { alp = 1 } );

  cmn.CallEventHandler( "dlg_cafe_barman_1" );   
  common_impl.ShowBbt( "bbt_cafe_dlg_cafe_barman_1" );

    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "wait_message" );

  for i = 1, 2 do

    --VidStop( "vid_dlg_park_1_professor_1_lip_"..i );
    --ObjSet( "vid_dlg_park_1_professor_1_lip_"..i, { alp = 0 } );

  end;

end;

--*********************************************************************************************************************
function private.dlg_david_kane_3_click ()

  common.CloseSubRoom();
  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "david_kane_3", 4, nil, nil, true, private.dlg_david_kane_3_end );

end;
--------------------------------------------------------------------------------------------
function private.dlg_david_kane_3_end ()

  common_impl.StopAudio( "sfx", "levelext/sfx/aud_use_pen1", 0.5 );

  cmn.CallEventHandler( "dlg_cafe_david_kane_3" );   
  common_impl.ShowBbt( "bbt_cafe_dlg_cafe_david_kane_3" );

  cmn.SetEventDone( "use_pen_3" );
  cmn.CallEventHandler( "use_pen_3" );

  interface.KeyTaskDone( true );
  interface.KeyTaskAdd( "get_eternity" );

  for i = 1, 2 do

    --VidStop( "vid_dlg_park_1_professor_1_lip_"..i );
    --ObjSet( "vid_dlg_park_1_professor_1_lip_"..i, { alp = 0 } );

  end;

  local pos_beg = { ObjGet( "gzz_cafe_barcounter" ).pos_x, ObjGet( "gzz_cafe_barcounter" ).pos_y }
  cmn.GotoSubRoom( "zz_barcounter", pos_beg, { 512, 360 } );

end;

--*********************************************************************************************************************
function private.dlg_josh_fraser_2_click ()

  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "josh_fraser_2", 5, nil, nil, true, private.dlg_josh_fraser_2_end );

end;
--------------------------------------------------------------------------------------------
function private.dlg_josh_fraser_2_end ()

  cmn.CallEventHandler( "dlg_cafe_josh_fraser_2" );   
  common_impl.ShowBbt( "bbt_cafe_dlg_cafe_josh_fraser_2" );

  for i = 1, 2 do

    --VidStop( "vid_dlg_park_1_professor_1_lip_"..i );
    --ObjSet( "vid_dlg_park_1_professor_1_lip_"..i, { alp = 0 } );

  end;

  ObjSet( "spr_int_dialog_character_icon", { res = "" } );
  private.see_josh_fraser_leave();

end;

--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************

function private.InitAnimations ()

  ObjAnimate( "spr_zz_musicmachine_light_env", "alp",1,0, "", { 0, 3, 0.7,    1.5, 3, 0.1,    3, 3, 0.4,    5, 3, 1,    6, 3, 0.7 } );
  ObjAnimate( "spr_dlg_cafe_josh_fraser_2_light", "alp",1,0, "", { 0, 3, 0.7,    1.5, 3, 0.1,    3, 3, 0.4,    5, 3, 1,    6, 3, 0.7 } );
--------------------------------------------------------------------------------------------
  ObjAnimate( "spr_musicmachine_coin_arrow_focus", "alp",1,0, "", { 0, 3, 1,    0.5, 3, 0.5,    1, 3, 1 } );
  ObjAnimate( "spr_musicmachine_track_arrow_focus", "alp",1,0, "", { 0, 3, 1,    0.5, 3, 0.5,    1, 3, 1 } );
--------------------------------------------------------------------------------------------

end;
--------------------------------------------------------------------------------------------
function private.HandAnimations ()

  ObjAnimate( "spr_cafe_light", "alp", 1, 0, "", 
  {
    0.0, 0, 1, 
    2.6, 0, 0.3,
    5.2, 0, 1,
  } );

  ObjAnimate( "spr_cafe_hand", "pos_xy", 1, 0, "", 
  {
    0.0, 0, 967, 590, 
    0.8, 0, 963, 593, 
    1.6, 0, 967, 597, 
    2.4, 0, 970, 593, 
    3.2, 0, 972, 587, 
    4.0, 0, 967, 590, 
  } );

end;

--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_cafe ()

  if not ( cmn.IsEventDone( "opn_cafe" ) ) then

    cmn.SetEventDone( "opn_cafe" );
    common_impl.ShowBbt( "bbt_cafe_opn_cafe" );

  end;

  cmn.CallEventHandler( "opn_cafe" ); 

end;

--*******************************************************************************************************************
function public.MusicmachineEnter ( id )
 
  SetCursor( CURSOR_HAND );
  local current = "spr_zz_musicmachine_"..id.."_light";
  local alpha = ObjGet( current ).alp;
  ObjAnimate( current, "alp",0,0, "", { 0, 0, alpha,    0.2 * ( 1 - alpha ), 0, 1 } );

end;

--*******************************************************************************************************************
function public.MusicmachineLeave ( id )  

  SetCursor( CURSOR_DEFAULT );
  local current = "spr_zz_musicmachine_"..id.."_light";
  local alpha = ObjGet( current ).alp;
  ObjAnimate( current, "alp",0,0, "", { 0, 0, alpha,    0.2 * alpha, 0, 0 } );

end;
--*********************************************************************************************************************
















