-- name=rm_hall_ext
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_hall_ext";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_reception_ext", "room_hub" );
  ObjAttach( "zz_passgenerator", "room_hub" );
  ObjAttach( "zz_hallelevator", "room_hub" );
  private.Init_Subroom();
  private.PasGenInit();
  private.InitAnimations();

  ObjMultiSet( { 
    { "spr_reception_ext_patientprofile",               { event_mdown = private.get_patientprofile        } },
    { "spr_reception_ext_oneoffpass1",                  { event_mdown = private.get_oneoffpass1           } },
    { "spr_reception_ext_elevatormap",                  { event_mdown = private.get_elevatormap           } },
    { "spr_passgenerator_generatedpassword1",           { event_mdown = private.get_generatedpassword1    } },
    { "spr_passgenerator_generatedpassword2",           { event_mdown = private.get_generatedpassword2    } },
    { "obj_hall_ext_clk_concierge",                     { event_mdown = private.dlg_concierge_click       } },
    { "obj_hall_ext_clk_concierge_focus",               { event_mdown = private.dlg_concierge_click       } },
    { "spr_reception_ext_roomkey",                      { event_mdown = private.get_roomkey               } },
    { "obj_hallelevator_use_elevatormap",               { event_mdown = private.UseElevatormap            } },
    { "spr_collect2_item_4_3",                          { event_mdown = private.get_collect2_item_4_3     } },
    { "obj_reception_ext_clk_generatedpassword1",       { event_mdown = private.clk_generatedpassword1    } },
    { "obj_reception_ext_clk_generatedpassword2",       { event_mdown = private.clk_generatedpassword2    } },
    { "obj_reception_ext_use_generatedpassword1",       { event_mdown = private.UseGeneratedpassword      } },
    { "obj_reception_ext_use_generatedpassword2",       { event_mdown = private.UseGeneratedpassword      } },
    { "obj_reception_ext_clk_generatedpassword_static", { event_mdown = private.clk_generatedpassword_static  } },
    { "obj_hall_ext_clk_concierge_2",                   { event_mdown = private.ClkConcierge_2            } },
    { "spr_hall_ext_collect_item",                      { event_mdown = function () common_impl.GetCollectItem( "get_collect_item_4_1" ); end } },
  } );

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_hall_ext = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "grm_hall_ext_porch_ext",
      "grm_hall_ext_secondfloor_ext",
      "gho_hall_ext_bag",
      "gmg_hall_ext_superpuzzle4",
      "gzz_hall_ext_reception_ext", 
      "gzz_hall_ext_passgenerator",
      "gzz_hall_ext_hallelevator",
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_reception_ext",
      "zz_passgenerator",
      "zz_hallelevator",
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_hall_ext", update_game_mode_hall_ext, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_hall_ext = function ()

  local effects_table = 
  {
    "obj_hall_ext_anim" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_hall_ext", update_performance_mode_hall_ext, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_hall_ext () end;
  --------------------------------------------------------------------------------------------
  local opn_hall_ext_map = function ()

    common_impl.VisitMapRoom( "hall" );

  end;
  cmn.AddSubscriber( "opn_hall_ext", opn_hall_ext_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_roomkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_roomkey" ] = {
    type = "get",
    get_obj = "spr_reception_ext_roomkey",
    room = private.room_objname,
    zz = "zz_reception_ext",
    zz_gate = "gzz_hall_ext_reception_ext"
  };
  
  local get_roomkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_roomkey", "spr_reception_ext_roomkey" );
  
  end;
  
  local get_roomkey_closezz = function ()
  
    if ( cmn.IsEventDone( "get_elevatormap" ) ) then

      ObjMultiSet( {
        { "spr_reception_ext_door",         { pos_y = 112 } },
        { "spr_reception_ext_door_shadow",  { alp = 1 } },
        { "obj_reception_ext_use_generatedpassword2", { input = true } },
      } );

    end;

    ObjDelete( "gfx_reception_ext_roomkey" );
    ObjDelete( "spr_hall_ext_reception_ext_reception_1" ); 
 
  end;
  cmn.AddSubscriber( "get_roomkey", get_roomkey_inv );
  cmn.AddSubscriber( "get_roomkey", get_roomkey_closezz, private.room_objname );
  cmn.AddSubscriber( "get_roomkey_inv", get_roomkey_inv, private.room_objname );
  cmn.AddSubscriber( "get_roomkey_closezz", get_roomkey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_patientprofile () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_patientprofile" ] = {
    type = "get",
    get_obj = "spr_reception_ext_patientprofile",
    room = private.room_objname,
    zz = "zz_reception_ext",
    zz_gate = "gzz_hall_ext_reception_ext"
  };
  
  local get_patientprofile_inv = function ()
  
    interface.InventoryItemAdd( "inv_patientprofile", "spr_reception_ext_patientprofile" );
  
  end;
  
  local get_patientprofile_closezz = function ()
  
    ObjDelete( "gfx_reception_ext_patientprofile" );

    if ( cmn.IsGetCollect2( "get_collect2_item_4_3" ) ) then

      ObjDelete( "gzz_hall_ext_reception_ext" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_patientprofile", get_patientprofile_inv );
  cmn.AddSubscriber( "get_patientprofile", get_patientprofile_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_oneoffpass1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_oneoffpass1" ] = {
    type = "get",
    get_obj = "spr_reception_ext_oneoffpass1",
    room = private.room_objname,
    zz = "zz_reception_ext",
    zz_gate = "gzz_hall_ext_reception_ext"
  };
  
  local get_oneoffpass1_inv = function ()
  
    ObjSet( "spr_reception_ext_oneoffpass1", { alp = 1 } );
    interface.InventoryItemAdd( "inv_oneoffpass1", "spr_reception_ext_oneoffpass1" );
  
  end;
  
  local get_oneoffpass1_closezz = function ()
  
    ObjDelete( "gfx_reception_ext_oneoffpass1" );
    ObjDelete( "spr_reception_ext_get_oneoffpassword_1" );
  
  end;
  
  cmn.AddSubscriber( "get_oneoffpass1", get_oneoffpass1_inv );
  cmn.AddSubscriber( "get_oneoffpass1", get_oneoffpass1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_elevatormap () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_elevatormap" ] = {
    type = "get",
    get_obj = "spr_reception_ext_elevatormap",
    room = private.room_objname,
    zz = "zz_reception_ext",
    zz_gate = "gzz_hall_ext_reception_ext"
  };
  
  local get_elevatormap_inv = function ()
  
    interface.InventoryItemAdd( "inv_elevatormap", "spr_reception_ext_elevatormap" );
  
  end;
  
  local get_elevatormap_closezz = function ()
  
    ObjDelete( "gfx_reception_ext_elevatormap" );
    ObjDelete( "spr_hall_ext_reception_ext_reception_2" );  

    if ( cmn.IsEventDone( "get_roomkey" ) ) then

      ObjMultiSet( {
        { "spr_reception_ext_door",         { pos_y = 112 } },
        { "spr_reception_ext_door_shadow",  { alp = 1 } },
        { "obj_reception_ext_use_generatedpassword2", { input = true } },
      } );

    end;

  end;
  cmn.AddSubscriber( "get_elevatormap", get_elevatormap_inv );
  cmn.AddSubscriber( "get_elevatormap", get_elevatormap_closezz, private.room_objname );
  cmn.AddSubscriber( "get_elevatormap_inv", get_elevatormap_inv, private.room_objname );
  cmn.AddSubscriber( "get_elevatormap_closezz", get_elevatormap_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_generatedpassword1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_generatedpassword1" ] = {
    type = "get",
    get_obj = "spr_passgenerator_generatedpassword1",
    room = private.room_objname,
    zz = "zz_passgenerator",
    zz_gate = "gzz_hall_ext_passgenerator"
  };
  
  local get_generatedpassword1_inv = function ()
  
    interface.InventoryItemAdd( "inv_generatedpassword1", "spr_passgenerator_generatedpassword1" );
    ObjSet( "obj_passgenerator_use_oneoffpass2", { input = true } );

  end;
  
  local get_generatedpassword1_closezz = function ()

    ObjDelete( "gfx_passgenerator_generatedpassword1" );
    ObjDelete( "spr_reception_ext_roomkey_shadow" );
    
    ObjMultiSet( {
      { "obj_reception_ext_bbt_password_1",       { input = true, visible = true, active = true } },
      { "spr_passgenerator_display_enter_code",   { alp = 1 } },
      { "spr_passgenerator_display_take",         { alp = 0 } },
    } );

  end;
  
  cmn.AddSubscriber( "get_generatedpassword1", get_generatedpassword1_inv );
  cmn.AddSubscriber( "get_generatedpassword1", get_generatedpassword1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_generatedpassword2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_generatedpassword2" ] = {
    type = "get",
    get_obj = "spr_passgenerator_generatedpassword2",
    room = private.room_objname,
    zz = "zz_passgenerator",
    zz_gate = "gzz_hall_ext_passgenerator"
  };
  
  local get_generatedpassword2_inv = function ()
  
    interface.InventoryItemAdd( "inv_generatedpassword2", "spr_passgenerator_generatedpassword2" );
    ObjSet( "obj_passgenerator_display", { alp = 0 });

  end;
  
  local get_generatedpassword2_closezz = function ()
  
    ObjDelete( "gzz_hall_ext_passgenerator" );
    ObjDelete( "gfx_passgenerator_generatedpassword2" );
    ObjMultiSet( {
      { "obj_reception_ext_bbt_password_2",       { input = true, visible = true, active = true } },
      { "spr_passgenerator_display_enter_code",   { alp = 1 } },
      { "spr_passgenerator_display_take",         { alp = 0 } },
    } );

  end;
  
  cmn.AddSubscriber( "get_generatedpassword2", get_generatedpassword2_inv );
  cmn.AddSubscriber( "get_generatedpassword2", get_generatedpassword2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_4_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_4_1 = function ()
  
    ObjDelete( "obj_hall_ext_collect" );
  
  end;    
  cmn.AddSubscriber( "get_collect_item_4_1", get_collect_item_4_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_4_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_4_3 = function ()
  
    ObjDelete( "obj_collect2_item_4_3" );

    if ( cmn.IsEventDone( "get_patientprofile" ) ) then

      ObjDelete( "gzz_hall_ext_reception_ext" );

    end;
  
  end;    
  cmn.AddSubscriber( "get_collect2_item_4_3", get_collect2_item_4_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_passport () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_passport" ] = {
    type = "use",
    inv_obj = "inv_passport",
    use_place = "obj_reception_ext_use_passport",
    room = private.room_objname,
    zz = "zz_reception_ext",
    zz_gate = "gzz_hall_ext_reception_ext"
  };
  local use_passport_inv = function ()
  
    interface.InventoryItemRemove( "inv_passport" );
  
  end;
  local use_passport_beg = function ()
  
    ObjDelete( "obj_reception_ext_use_passport" );
  
  end;
  local use_passport_end = function ()
  
    ObjDelete( "spr_reception_ext_get_passport" );
    ObjDelete( "spr_reception_ext_open_hand" );
    ObjSet( "spr_reception_ext_get_oneoffpassword_1", { alp = 1 } );
    ObjSet( "spr_reception_ext_oneoffpass1", { input = true } );

    ObjSet( "anm_hall_ext_concierge_1", { alp = 1 } );
    ObjDelete( "anm_hall_ext_concierge_2" );

    ObjDelete( "obj_reception_ext_bbt_passport" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_passport", use_passport_beg, private.room_objname );
  cmn.AddSubscriber( "use_passport", use_passport_inv );
  cmn.AddSubscriber( "use_passport", use_passport_end, private.room_objname );
  cmn.AddSubscriber( "use_passport_inv", use_passport_inv, private.room_objname );
  cmn.AddSubscriber( "use_passport_beg", use_passport_beg, private.room_objname );
  cmn.AddSubscriber( "use_passport_end", use_passport_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_generatedpassword1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_generatedpassword1" ] = {
    type = "use",
    inv_obj = "inv_generatedpassword1",
    use_place = "obj_reception_ext_use_generatedpassword1",
    room = private.room_objname,
    zz = "zz_reception_ext",
    zz_gate = "gzz_hall_ext_reception_ext"
  };
  local use_generatedpassword1_inv = function ()
  
    interface.InventoryItemRemove( "inv_generatedpassword1" );
  
  end;
  local use_generatedpassword1_beg = function ()
  
    ObjDelete( "obj_reception_ext_use_generatedpassword1" );
  
  end;
  local use_generatedpassword1_end = function ()
  
    ObjSet( "obj_reception_ext_clk_generatedpassword1", { input = true } );
    ObjSet( "obj_reception_ext_clk_generatedpassword_static", { input = false } );
    ObjDelete( "obj_reception_ext_bbt_password_1" );
    --ObjSet( "spr_reception_ext_roomkey", { input = true, alp = 1 } );  
    --ObjSet( "spr_reception_ext_roomkey_shadow", { alp = 1 } ); 
    --ObjSet( "spr_reception_ext_elevatormap", { input = true, alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_generatedpassword1", use_generatedpassword1_beg, private.room_objname );
  cmn.AddSubscriber( "use_generatedpassword1", use_generatedpassword1_inv );
  cmn.AddSubscriber( "use_generatedpassword1", use_generatedpassword1_end, private.room_objname );
  cmn.AddSubscriber( "use_generatedpassword1_inv", use_generatedpassword1_inv, private.room_objname );
  cmn.AddSubscriber( "use_generatedpassword1_beg", use_generatedpassword1_beg, private.room_objname );
  cmn.AddSubscriber( "use_generatedpassword1_end", use_generatedpassword1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_generatedpassword2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_generatedpassword2" ] = {
    type = "use",
    inv_obj = "inv_generatedpassword2",
    use_place = "obj_reception_ext_use_generatedpassword2",
    room = private.room_objname,
    zz = "zz_reception_ext",
    zz_gate = "gzz_hall_ext_reception_ext"
  };
  local use_generatedpassword2_inv = function ()
  
    interface.InventoryItemRemove( "inv_generatedpassword2" );
  
  end;
  local use_generatedpassword2_beg = function ()
  
    ObjDelete( "obj_reception_ext_use_generatedpassword2" );
  
  end;
  local use_generatedpassword2_end = function ()
  
    ObjSet( "obj_reception_ext_clk_generatedpassword2", { input = true } );
    ObjSet( "obj_reception_ext_clk_generatedpassword_static", { input = false } );
    ObjDelete( "obj_reception_ext_bbt_password_2" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_generatedpassword2", use_generatedpassword2_beg, private.room_objname );
  cmn.AddSubscriber( "use_generatedpassword2", use_generatedpassword2_inv );
  cmn.AddSubscriber( "use_generatedpassword2", use_generatedpassword2_end, private.room_objname );
  cmn.AddSubscriber( "use_generatedpassword2_inv", use_generatedpassword2_inv, private.room_objname );
  cmn.AddSubscriber( "use_generatedpassword2_beg", use_generatedpassword2_beg, private.room_objname );
  cmn.AddSubscriber( "use_generatedpassword2_end", use_generatedpassword2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_oneoffpass1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_oneoffpass1" ] = {
    type = "use",
    inv_obj = "inv_oneoffpass1",
    use_place = "obj_passgenerator_use_oneoffpass1",
    room = private.room_objname,
    zz = "zz_passgenerator",
    zz_gate = "gzz_hall_ext_passgenerator"
  };
  local use_oneoffpass1_inv = function ()
  
    interface.InventoryItemRemove( "inv_oneoffpass1" );
  
  end;
  local use_oneoffpass1_beg = function ()
  
    ObjDelete( "obj_passgenerator_use_oneoffpass1" );
  
  end;
  local use_oneoffpass1_end = function ()
    
    ObjMultiSet( {
      { "spr_hall_ext_passgenerator_passgenerator_1",     { alp = 1 } },
      { "obj_passgenerator_buttons",                      { input = true } },
      { "spr_passgenerator_oneoffpass_1",                 { alp = 1 } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_oneoffpass1", use_oneoffpass1_beg, private.room_objname );
  cmn.AddSubscriber( "use_oneoffpass1", use_oneoffpass1_inv );
  cmn.AddSubscriber( "use_oneoffpass1", use_oneoffpass1_end, private.room_objname );
  cmn.AddSubscriber( "use_oneoffpass1_inv", use_oneoffpass1_inv, private.room_objname );
  cmn.AddSubscriber( "use_oneoffpass1_beg", use_oneoffpass1_beg, private.room_objname );
  cmn.AddSubscriber( "use_oneoffpass1_end", use_oneoffpass1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_oneoffpass2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_oneoffpass2" ] = {
    type = "use",
    inv_obj = "inv_oneoffpass2",
    use_place = "obj_passgenerator_use_oneoffpass2",
    room = private.room_objname,
    zz = "zz_passgenerator",
    zz_gate = "gzz_hall_ext_passgenerator"
  };
  local use_oneoffpass2_inv = function ()
  
    interface.InventoryItemRemove( "inv_oneoffpass2" );
  
  end;
  local use_oneoffpass2_beg = function ()
  
    ObjDelete( "obj_passgenerator_use_oneoffpass2" );
  
  end;
  local use_oneoffpass2_end = function ()

    ObjMultiSet( {
      { "spr_hall_ext_passgenerator_passgenerator_2",     { alp = 1 } },
      { "obj_passgenerator_buttons",                      { input = true } },
      { "spr_passgenerator_oneoffpass_2",                 { alp = 1 } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_oneoffpass2", use_oneoffpass2_beg, private.room_objname );
  cmn.AddSubscriber( "use_oneoffpass2", use_oneoffpass2_inv );
  cmn.AddSubscriber( "use_oneoffpass2", use_oneoffpass2_end, private.room_objname );
  cmn.AddSubscriber( "use_oneoffpass2_inv", use_oneoffpass2_inv, private.room_objname );
  cmn.AddSubscriber( "use_oneoffpass2_beg", use_oneoffpass2_beg, private.room_objname );
  cmn.AddSubscriber( "use_oneoffpass2_end", use_oneoffpass2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_elevatormap () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elevatormap" ] = {
    type = "use",
    inv_obj = "inv_elevatormap",
    use_place = "obj_hallelevator_use_elevatormap",
    room = private.room_objname,
    zz = "zz_hallelevator",
    zz_gate = "gzz_hall_ext_hallelevator"
  };
  local use_elevatormap_inv = function ()
  
    interface.InventoryItemRemove( "inv_elevatormap" );
  
  end;
  local use_elevatormap_beg = function ()
  
    ObjDelete( "obj_hallelevator_use_elevatormap" );
  
  end;
  local use_elevatormap_end = function ()
  
    ObjDelete( "spr_hallelevator_door" );
    ObjDelete( "gzz_hall_ext_hallelevator" );
    ObjDelete( "spr_hall_ext_hallelevator_cover" );
    ObjSet( "gmg_hall_ext_superpuzzle4", { input = true, visible = true, active = true, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elevatormap", use_elevatormap_beg, private.room_objname );
  cmn.AddSubscriber( "use_elevatormap", use_elevatormap_inv );
  cmn.AddSubscriber( "use_elevatormap", use_elevatormap_end, private.room_objname );
  cmn.AddSubscriber( "use_elevatormap_inv", use_elevatormap_inv, private.room_objname );
  cmn.AddSubscriber( "use_elevatormap_beg", use_elevatormap_beg, private.room_objname );
  cmn.AddSubscriber( "use_elevatormap_end", use_elevatormap_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bag () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bag" ] = {
    type = "use",
    inv_obj = "inv_bag",
    use_place = "obj_hall_ext_use_bag",
    room = private.room_objname,
  };
  local use_bag_inv = function ()
  
    interface.InventoryItemRemove( "inv_bag" );
  
  end;
  local use_bag_beg = function ()
  
    ObjDelete( "obj_hall_ext_use_bag" );
  
  end;
  local use_bag_end = function ()
  
    ObjMultiSet( {  
      { "gho_hall_ext_bag",         { input = true, active = true, alp = 1 } },
      { "spr_hall_ext_bag_bag",     { alp = 1 } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bag", use_bag_beg, private.room_objname );
  cmn.AddSubscriber( "use_bag", use_bag_inv );
  cmn.AddSubscriber( "use_bag", use_bag_end, private.room_objname );
  cmn.AddSubscriber( "use_bag_inv", use_bag_inv, private.room_objname );
  cmn.AddSubscriber( "use_bag_beg", use_bag_beg, private.room_objname );
  cmn.AddSubscriber( "use_bag_end", use_bag_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_generatedpassword1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_generatedpassword1" ] = {
    type = "click",
    use_place = "obj_reception_ext_clk_generatedpassword1",
    room = private.room_objname,
    zz = "zz_reception_ext",
    zz_gate = "gzz_hall_ext_reception_ext"
  };

  local clk_generatedpassword1_beg = function ()

    ObjDelete( "obj_reception_ext_clk_generatedpassword1" );
  
  end;
  local clk_generatedpassword1_end = function ()

    ObjMultiSet( {
      { "spr_reception_ext_roomkey",          { input = true, alp = 1 } },
      { "spr_reception_ext_roomkey_shadow",   { alp = 1 } },
      { "spr_reception_ext_elevatormap",      { input = true, alp = 1 } },
      { "gfx_reception_ext_elevatormap",      { active = true } },
      { "gfx_reception_ext_roomkey",          { active = true } },
      { "spr_reception_ext_door",             { pos_y = 60 } },
      { "spr_reception_ext_door_shadow",      { alp = 0 } },
      { "obj_reception_ext_clk_generatedpassword_static", { input = true } }
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_generatedpassword1", clk_generatedpassword1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_generatedpassword1", clk_generatedpassword1_end, private.room_objname );
  cmn.AddSubscriber( "clk_generatedpassword1_beg", clk_generatedpassword1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_generatedpassword1_end", clk_generatedpassword1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_generatedpassword2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_generatedpassword2" ] = {
    type = "click",
    use_place = "obj_reception_ext_clk_generatedpassword2",
    room = private.room_objname,
    zz = "zz_reception_ext",
    zz_gate = "gzz_hall_ext_reception_ext"
  };

  local clk_generatedpassword2_beg = function ()

    ObjDelete( "obj_reception_ext_clk_generatedpassword2" );
  
  end;
  local clk_generatedpassword2_end = function ()

    ObjMultiSet( {
      { "spr_reception_ext_patientprofile",   { input = true, alp = 1 } },
      { "gfx_reception_ext_patientprofile",   { active = true } },
      { "spr_reception_ext_door",             { pos_y = 60 } },
      { "spr_reception_ext_door_shadow",      { alp = 0 } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_generatedpassword2", clk_generatedpassword2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_generatedpassword2", clk_generatedpassword2_end, private.room_objname );
  cmn.AddSubscriber( "clk_generatedpassword2_beg", clk_generatedpassword2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_generatedpassword2_end", clk_generatedpassword2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_call_kane_4 () end;
  --------------------------------------------------------------------------------------------
  local see_call_kane_4 = function ()

    --ObjDelete( "" );
    --ObjSet( "obj_hall_ext_clk_david_kane_4", { input = true, visible = true, active = true, alp = 1 } );
    
  end;
  cmn.AddSubscriber( "see_call_kane_4", see_call_kane_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_hall_ext_concierge () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_hall_ext_concierge" ] = {
    type = "click",
    use_place = "obj_hall_ext_clk_concierge_focus",
    room = private.room_objname
  };

  local dlg_hall_ext_concierge = function ()

    ObjSet( "anm_hall_ext_concierge_1", { alp = 1, visible = true } );
    ObjDelete( "obj_hall_ext_clk_concierge" );
    ObjDelete( "dlg_hall_ext_concierge_lip" ); 

  end;
  cmn.AddSubscriber( "dlg_hall_ext_concierge", dlg_hall_ext_concierge, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_hall_ext_david_kane_4 () end;
  --------------------------------------------------------------------------------------------
  local dlg_hall_ext_david_kane_4 = function ()

    ObjDelete( "dlg_hall_ext_david_kane_4_lip" );
    ObjDelete( "anm_reception_ext_call" );

    ObjSet( "obj_reception_ext_use_passport", { input = true } );
    --ObjSet( "anm_hall_ext_concierge_1", { alp = 0 } );
    --ObjSet( "anm_hall_ext_concierge_2", { alp = 1, visible = true } );

    ObjSet( "obj_reception_ext_bbt_passport", { input = true, active = true, visible = true });

  end;
  cmn.AddSubscriber( "dlg_hall_ext_david_kane_4", dlg_hall_ext_david_kane_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_pas_gen_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_pas_gen_1" ] =
  {
      type = "win",
      room = private.room_objname,
      zz = "zz_passgenerator",
      zz_gate = "gzz_hall_ext_passgenerator"
  };

  local win_pas_gen_1 = function ()

    if ( cmn.IsEventDone( "win_pas_gen_1" ) ) then

      ObjMultiSet({

        { "spr_passgenerator_generatedpassword1", { input = true, visible = true, alp = 1 } },
        { "obj_passgenerator_buttons", { input = false} },

      });     

    else
                  
      for i = 1,#ng_global.progress[ "ext" ][ "win_pas_gen_1" ].numbers[1]  do

        local num = ng_global.progress[ "ext" ][ "win_pas_gen_1" ].numbers[1][i]
        ObjSet( "spr_passgenerator_display_num_"..i, {
        alp = 1, res = "assets/levels/levelext/rm_hall_ext/zz_passgenerator/anims/number_"..num} );

      end;

    end;

  end;

  cmn.AddSubscriber( "win_pas_gen_1", win_pas_gen_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function win_pas_gen_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_pas_gen_2" ] =
  {
      type = "win",
      room = private.room_objname,
      zz = "zz_passgenerator",
      zz_gate = "gzz_hall_ext_passgenerator"
  };

  local win_pas_gen_2 = function ()

    if ( cmn.IsEventDone( "win_pas_gen_2" ) ) then

      ObjMultiSet({

        { "spr_passgenerator_generatedpassword2", { input = true, visible = true, alp = 1 } },
        { "obj_passgenerator_buttons", { input = false} },

      }); 

    else
                  
      for i = 1,#ng_global.progress[ "ext" ][ "win_pas_gen_1" ].numbers[2]  do

        local num = ng_global.progress[ "ext" ][ "win_pas_gen_1" ].numbers[2][i]
        ObjSet( "spr_passgenerator_display_num_"..i, {
        alp = 1, res = "assets/levels/levelext/rm_hall_ext/zz_passgenerator/anims/number_"..num} );

      end;

    end;

  end;

  cmn.AddSubscriber( "win_pas_gen_2", win_pas_gen_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_opn_elevator_door () end;
  --------------------------------------------------------------------------------------------
  local see_opn_elevator_door = function ()

    ObjDelete( "spr_hall_ext_doors_2" );
    ObjDelete( "spr_hall_ext_doors_1" );
    ObjDelete( "spr_hall_ext_patch_elewator" );

    ObjDelete( "gmg_hall_ext_superpuzzle4" );
    ObjSet( "grm_hall_ext_secondfloor_ext", { input = true, visible = true, active = true, alp = 1 } );    
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_hall_ext_secondfloor_ext_focus");
    end;
  end;

  cmn.AddSubscriber( "see_opn_elevator_door", see_opn_elevator_door, private.room_objname );
end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function private.Init_Subroom ()

  --*********************************************************************************************************************
  -- function zz_reception_ext () end;
  --*********************************************************************************************************************  
    subroom.Define( "zz_reception_ext" );    
    function zz_reception_ext.PreOpen()

    end;
    -------------------------------------------------
    function zz_reception_ext.Open()

      if ( cmn.IsEventDone( "win_bag" ) and not cmn.IsEventDone( "dlg_hall_ext_david_kane_4" ) ) then

        private.see_call_kane_4();    

      end;
      if ( cmn.IsEventDone( "dlg_hall_ext_david_kane_4" ) and not cmn.IsEventDone( "use_passport" ) ) then

        local func_end = function ()

          cmn.Lock( false );
          ObjMultiSet( {
            { "spr_reception_ext_open_hand",  { alp = 1 } },
          } );

        end;

        cmn.Lock( true );
        ObjAnimate( "spr_reception_ext_open_hand", "alp", 0, 0, func_end, 
        { 
          0.0, 0, 0, 
          0.3, 0, 1, 
        } );       

      end;

    end;
    -------------------------------------------------
    function zz_reception_ext.PreClose()

      --

    end;
    -------------------------------------------------
    function zz_reception_ext.Close()

      ObjMultiSet( {
        { "spr_reception_ext_open_hand",  { alp = 0 } },
      } );

    end;
  --*********************************************************************************************************************
  -- function zz_passgenerator () end;
  --*********************************************************************************************************************  
    --------------------------------------------------------------------------------------------------
    subroom.Define( "zz_passgenerator" );
    -------------------------------------------------
    function zz_passgenerator.PreOpen ()

      if ( cmn.IsEventDone( "use_oneoffpass1" ) ) and ( not cmn.IsEventDone( "win_pas_gen_1" ) ) then

        cmn.MiniGameShow( "pas_gen_1" );
        common_impl.PassingMgStart( "pas_gen_1" );
        private.Gen_num = 1;

        if ( not ng_global.progress[ "ext" ][ "win_pas_gen_1" ].numbers ) then 
          
          ng_global.progress[ "ext" ][ "win_pas_gen_1" ].numbers = {};
          ng_global.progress[ "ext" ][ "win_pas_gen_1" ].numbers[1] = {};

        end;

      end; 

      if ( cmn.IsEventDone( "use_oneoffpass2" ) ) and ( not cmn.IsEventDone( "win_pas_gen_2" ) ) then

      cmn.MiniGameShow( "pas_gen_2" );
      common_impl.PassingMgStart( "pas_gen_2" );

      private.Gen_num = 2;

      if ( not ng_global.progress[ "ext" ][ "win_pas_gen_1" ].numbers ) then 

        ng_global.progress[ "ext" ][ "win_pas_gen_1" ].numbers = {};
        ng_global.progress[ "ext" ][ "win_pas_gen_1" ].numbers[2] = {};

      end;

      end; 

    end;
    -------------------------------------------------
    function zz_passgenerator.PreClose ()

      if ( cmn.IsEventDone( "use_oneoffpass1" ) ) and ( not cmn.IsEventDone( "win_pas_gen_1" ) ) then

        cmn.MiniGameHide( "pas_gen_1" );
        

      end;

      if ( cmn.IsEventDone( "use_oneoffpass2" ) ) and ( not cmn.IsEventDone( "win_pas_gen_2" ) ) then

        cmn.MiniGameHide( "pas_gen_2" );

      end;

    
    end;

    function zz_passgenerator.Skip ()

       private.MgPasGenWin();

    end;

    function zz_passgenerator.Reset ()

       private.MgPasGenReset();

    end;

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_hall_ext();
  int_slider.InitSlider( private.room_objname );

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

  if not ( cmn.IsEventDone( "see_opn_elevator_door" ) ) then

    if ( cmn.IsEventDone( "win_superpuzzle4" ) ) then

      private.see_opn_elevator_door();      
      
    end;

  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();
  common_impl.CollectItemMorphing();

  common_impl.EnvPlay( { "levelext/env/aud_hall_ext_env" }, "", 0.5 );
  
end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_passport ()

  local item = "inv_passport";

  if ( cmn.ApplyObj( item, "gzz_hall_ext_reception_ext" ) ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_reception_ext", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_reception_ext_use_passport" ) and cmn.IsEventDone( "dlg_hall_ext_david_kane_4" ) and 
    ObjGet( "spr_reception_ext_open_hand" ).alp == 1 ) then

    cmn.CallEventHandler( "use_passport_inv" );
    cmn.CallEventHandler( "use_passport_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_passport" );
      cmn.CallEventHandler( "use_passport_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_passport", 0, "", 0 );

    ObjAnimate( "spr_reception_ext_open_hand", "alp", 0, 0, "", { 0, 0, 1, 0.2, 0, 0 } );
    ObjAnimate( "spr_reception_ext_get_passport", "alp", 0, 0, "", { 0, 0, 0, 0.2, 0, 1, 0.4, 0, 1, 0.7, 0, 0 } );

    ObjAnimate( "spr_reception_ext_get_oneoffpassword_1", "alp", 0, 0, func_end, { 0, 0, 0, 0.7, 0, 0, 1.0, 0, 1 } );

    --cmn.ItemFly( "spr", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_generatedpassword1 ()

  local item = "inv_generatedpassword1";

  if cmn.ApplyObj( item, "gzz_hall_ext_reception_ext" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_reception_ext", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_reception_ext_use_generatedpassword1" ) ) then

    cmn.CallEventHandler( "use_generatedpassword1_inv" );
    cmn.CallEventHandler( "use_generatedpassword1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_generatedpassword1" );
      cmn.CallEventHandler( "use_generatedpassword1_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk1", 0, "", 0 );

    ObjAnimate( "spr_reception_ext_password_1", "alp", 0, 0, "", 
    { 
      0.00, 0, 0, 
      0.25, 0, 1 
    } );
    ObjAnimate( "spr_reception_ext_password_1", "pos_xy", 0, 0, func_end, 
    { 
      0.0, 0, 192, 13, 
      0.3, 0, 192, 13,
      0.6, 0, 203, -14
    } ); 

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_generatedpassword2 ()

  local item = "inv_generatedpassword2";

  if cmn.ApplyObj( item, "gzz_hall_ext_reception_ext" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_reception_ext", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_reception_ext_use_generatedpassword2" ) ) then

    cmn.CallEventHandler( "use_generatedpassword2_inv" );
    cmn.CallEventHandler( "use_generatedpassword2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_generatedpassword2" );
      cmn.CallEventHandler( "use_generatedpassword2_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk1", 0, "", 0 );

    ObjAnimate( "spr_reception_ext_password_2", "alp", 0, 0, "", { 0, 0, 0, 0.25, 0, 1 } );
    ObjAnimate( "spr_reception_ext_password_2", "pos_xy", 0, 0, func_end, 
    { 
      0.0, 0, 192, 13, 
      0.3, 0, 192, 13,
      0.6, 0, 203, -14
    } ); 

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_oneoffpass1 ()

  local item = "inv_oneoffpass1";

  if cmn.ApplyObj( item, "gzz_hall_ext_passgenerator" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_passgenerator", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_passgenerator_use_oneoffpass1" ) ) then

    cmn.CallEventHandler( "use_oneoffpass1_inv" );
    cmn.CallEventHandler( "use_oneoffpass1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_oneoffpass1" );
      cmn.CallEventHandler( "use_oneoffpass1_end" );
      cmn.MiniGameShow( "pas_gen_1" );
      common_impl.PassingMgStart( "pas_gen_1" );
      ng_global.progress[ "ext" ][ "win_pas_gen_1" ].numbers = {};
      ng_global.progress[ "ext" ][ "win_pas_gen_1" ].numbers[1] = {};
      private.Gen_num = 1;

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "aud_paper", 0, "", 0 );

    cmn.ItemFly( "spr_passgenerator_oneoffpass_1", func_end, 0 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_oneoffpass2 ()

  local item = "inv_oneoffpass2";

  if cmn.ApplyObj( item, "gzz_hall_ext_passgenerator" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_passgenerator", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_passgenerator_use_oneoffpass2" ) ) then

    cmn.CallEventHandler( "use_oneoffpass2_inv" );
    cmn.CallEventHandler( "use_oneoffpass2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_oneoffpass2" );
      cmn.CallEventHandler( "use_oneoffpass2_end" );
      cmn.MiniGameShow( "pas_gen_2" );
      common_impl.PassingMgStart( "pas_gen_2" );
      ng_global.progress[ "ext" ][ "win_pas_gen_1" ].numbers = {};
      ng_global.progress[ "ext" ][ "win_pas_gen_1" ].numbers[1] = {};
      ng_global.progress[ "ext" ][ "win_pas_gen_1" ].numbers[2] = {};
      private.Gen_num = 2;

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "aud_paper", 0, "", 0 );

    ObjSet( "spr_passgenerator_display_take", { alp = 0 } );
    ObjSet( "spr_passgenerator_display_enter_code", { alp = 1 } );
    cmn.ItemFly( "spr_passgenerator_oneoffpass_2", func_end, 2.56 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_elevatormap ()

  local item = "inv_elevatormap";

  if cmn.ApplyObj( item, "gzz_hall_ext_hallelevator" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_hallelevator", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_hallelevator_use_elevatormap" ) ) then

    cmn.CallEventHandler( "use_elevatormap_inv" );
    cmn.CallEventHandler( "use_elevatormap_beg" );

    local func_end = function ()

      local func_end_1 = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_elevatormap" );
        cmn.CallEventHandler( "use_elevatormap_end" );
        common.CloseSubRoom();
        cmn.GotoRoom( "mg_superpuzzle4" ); 

      end;

      ObjAnimate( "spr_hallelevator_red_light", "alp", 0, 0, "", 
      { 
        0.0, 0, ObjGet( "spr_hallelevator_red_light" ).alp, 
        0.5, 0, 0.0,
      } );
      ObjAnimate( "spr_hallelevator_green_light", "alp", 0, 0, func_end_1, 
      { 
        0.0, 0, ObjGet( "spr_hallelevator_green_light" ).alp, 
        0.5, 0, 1.0,
        1.0, 0, 1.0,
      } );
      ObjAnimate( "spr_hallelevator_door", "pos_xy", 0, 0, "", 
      { 
        0.0, 0, ObjGet( "spr_hallelevator_door" ).pos_x, ObjGet( "spr_hallelevator_door" ).pos_y, 
        0.5, 0, ObjGet( "spr_hallelevator_door" ).pos_x, ObjGet( "spr_hallelevator_door" ).pos_y,
        1.0, 0, 27, -111
      } );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_elevatormap", 0, "", 0 );

    cmn.ItemFly( "spr_hallelevator_card", func_end, 0 );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_bag ()

  local item = "inv_bag";

  if ( cmn.ApplyObj( item, "obj_hall_ext_use_bag" ) and cmn.IsEventDone( "dlg_hall_ext_concierge" ) ) then

    cmn.CallEventHandler( "use_bag_inv" );
    cmn.CallEventHandler( "use_bag_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_bag" );
      cmn.CallEventHandler( "use_bag_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_bag", 0, "", 0 );
  
    cmn.ItemFly( "spr_hall_ext_bag_bag", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_roomkey ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  ObjSet( "gfx_reception_ext_roomkey", { alp = 0 } );

  cmn.SetEventDone( "get_roomkey" );
  cmn.CallEventHandler( "get_roomkey_inv" );
  
  if ( cmn.IsEventDone( "get_elevatormap" ) ) then

    local func_end = function ()

      cmn.Lock( false );
      cmn.CallEventHandler( "get_roomkey_closezz" );

    end;  

    cmn.Lock( true );
    ObjAnimate( "spr_reception_ext_door", "pos_y", 0, 0, func_end, 
    { 
      0.0, 0, ObjGet( "spr_reception_ext_door" ).pos_y,
      0.3, 0, 112,
    } );
    ObjAnimate( "spr_reception_ext_door_shadow", "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      0.3, 0, 1,
    } );

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_patientprofile ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_patientprofile" );
  cmn.CallEventHandler( "get_patientprofile" );

  if ( cmn.IsGetCollect2( "get_collect2_item_4_3" ) ) then  

    common.CloseSubRoom(); 

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_oneoffpass1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_oneoffpass1" );
  cmn.CallEventHandler( "get_oneoffpass1" );

end;
--------------------------------------------------------------------------------------------
function private.get_elevatormap ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_elevatormap" );
  cmn.CallEventHandler( "get_elevatormap_inv" );

  if ( cmn.IsEventDone( "get_roomkey" ) ) then

    local func_end = function ()

      cmn.Lock( false );
      cmn.CallEventHandler( "get_elevatormap_closezz" );

    end;  

    cmn.Lock( true );
    ObjAnimate( "spr_reception_ext_door", "pos_y", 0, 0, func_end, 
    { 
      0.0, 0, ObjGet( "spr_reception_ext_door" ).pos_y,
      0.3, 0, 112,
    } );
    ObjAnimate( "spr_reception_ext_door_shadow", "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      0.3, 0, 1,
    } );

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_generatedpassword1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_generatedpassword1" );
  cmn.CallEventHandler( "get_generatedpassword1" );

end;
--------------------------------------------------------------------------------------------
function private.get_generatedpassword2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_generatedpassword2" );
  cmn.CallEventHandler( "get_generatedpassword2" );
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_4_3 ()

  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_4_3" ); 

    if ( cmn.IsEventDone( "get_patientprofile" ) ) then

      common.CloseSubRoom();

    end;

  end;

  common_impl.PlayEffectHO( "spr_collect2_item_4_3", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_4_3" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_generatedpassword1 ()

  cmn.CallEventHandler( "clk_generatedpassword1_beg" );

  local func_end = function ()

    cmn.Lock( false );    
    cmn.SetEventDone( "clk_generatedpassword1" );
    cmn.CallEventHandler( "clk_generatedpassword1_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_button2", 0, "", 0 );

  ObjAnimate( "spr_reception_ext_button", "alp", 0, 0, "", 
  { 
    0.0, 0, 0,
    0.1, 0, 1,
    0.3, 0, 1,
    0.4, 0, 0,  
  } );
  ObjAnimate( "spr_reception_ext_door", "pos_y", 0, 0, func_end, 
  { 
    0.0, 0, ObjGet( "spr_reception_ext_door" ).pos_y,
    0.3, 0, ObjGet( "spr_reception_ext_door" ).pos_y,
    0.6, 0, 60,
  } );
  ObjAnimate( "spr_reception_ext_door_shadow", "alp", 0, 0, "", 
  { 
    0.0, 0, 1,
    0.3, 0, 1,
    0.4, 0, 0,
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_generatedpassword2 ()

  cmn.CallEventHandler( "clk_generatedpassword2_beg" );

  local func_end = function ()

    cmn.Lock( false );    
    cmn.SetEventDone( "clk_generatedpassword2" );
    cmn.CallEventHandler( "clk_generatedpassword2_end" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_button2", 0, "", 0 );

  ObjSet( "spr_reception_ext_patientprofile", { alp = 1 } );
  ObjAnimate( "spr_reception_ext_button", "alp", 0, 0, "", 
  { 
    0.0, 0, 0,
    0.1, 0, 1,
    0.3, 0, 1,
    0.4, 0, 0,  
  } );
  ObjAnimate( "spr_reception_ext_door", "pos_y", 0, 0, func_end, 
  { 
    0.0, 0, ObjGet( "spr_reception_ext_door" ).pos_y,
    0.3, 0, ObjGet( "spr_reception_ext_door" ).pos_y,
    0.6, 0, 60,
  } );
  ObjAnimate( "spr_reception_ext_door_shadow", "alp", 0, 0, "", 
  { 
    0.0, 0, 1,
    0.3, 0, 1,
    0.4, 0, 0,
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_generatedpassword_static ()

  local func_end = function ()

    cmn.Lock( false );    

  end;

  cmn.Lock( true );

  --common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_button2", 0, "", 0 );

  --ObjSet( "spr_reception_ext_patientprofile", { alp = 1 } );
  ObjAnimate( "spr_reception_ext_button", "alp", 0, 0, "", 
  { 
    0.0, 0, 0,
    0.1, 0, 1,
    0.3, 0, 1,
    0.4, 0, 0,  
  } );
  local s_y = ObjGet( "spr_reception_ext_door" ).pos_y;
  ObjAnimate( "spr_reception_ext_door", "pos_y", 0, 0, func_end, 
  { 
    0.0, 0, s_y,
    0.3, 0, s_y,
    0.5, 0, 95,
    0.7, 0, s_y
  } );
  ObjAnimate( "spr_reception_ext_door_shadow", "alp", 0, 0, "", 
  { 
    0.0, 0, 1,
    0.3, 0, 1,
    0.4, 0, 0,
    0.6, 0, 0, 
    0.7, 0, 1
  } );

end;
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.see_call_kane_4 ()

  local func_end = function ()

    cmn.Lock( false );

    private.dlg_david_kane_4_click();
    ObjMultiSet( {
      { "spr_reception_ext_reciever",       { alp = 1 } },
      { "spr_reception_ext_concierge_hand", { alp = 1 } },
    } );

  end;  
  
  cmn.Lock( true );

  common_impl.ShowBbt( "bbt_hall_ext_reception_call" );

  ObjMultiSet( {
    { "anm_reception_ext_call",           { alp = 1 } },
    { "spr_reception_ext_reciever",       { alp = 0 } },
    { "spr_reception_ext_concierge_hand", { alp = 0 } },
  } );

  AnimPlay( "anm_reception_ext_call", "call", func_end );

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_ring_phone", 0, "", 0 );

end;
--------------------------------------------------------------------------------------------
function private.see_opn_elevator_door ()

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "see_opn_elevator_door" );
    cmn.CallEventHandler( "see_opn_elevator_door" );

  end;  
  
  cmn.Lock( true );

  ObjAnimate( "spr_hall_ext_doors_1", "pos_xy", 0, 0, "", 
  { 
    0.0, 1, ObjGet( "spr_hall_ext_doors_1" ).pos_x, ObjGet( "spr_hall_ext_doors_1" ).pos_y,  
    0.3, 1, 131, 443,
  } );
  ObjAnimate( "spr_hall_ext_doors_2", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 1, ObjGet( "spr_hall_ext_doors_2" ).pos_x, ObjGet( "spr_hall_ext_doors_2" ).pos_y,   
    0.3, 1, 282, 431,
  } );

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_opn_elevator_ext", 0, "", 0 );

end;
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )

  if dlg_name == "david_kane_4" then

    if ( count_txt == 1 ) then

      ObjSet( "spr_int_dialog_character_icon", { res = "assets/interface/resources/dialog_character/btm_6" } );

    end;

  end;  

  if ( dlg_name == "concierge" ) then

    if ( count_txt == 1 ) then
      
      ObjSet( "vid_hall_ext_concierge_1_voc", { alp = 1 } );
      VidPlay( "vid_hall_ext_concierge_1_voc", "" );

    elseif ( count_txt == 2 ) then
       
      ObjDelete("vid_hall_ext_concierge_1_voc");
      ObjSet( "vid_hall_ext_concierge_2_voc", { alp = 1 } );
      VidPlay( "vid_hall_ext_concierge_2_voc", "" );

    end;


  end;

end;
--------------------------------------------------------------------------------------------
function private.dlg_concierge_click ()

  ObjSet( "obj_hall_ext_clk_concierge", { input = false } );
  ObjSet( "anm_hall_ext_concierge_1", { alp = 0 } );

  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "concierge", 3, nil, nil, true, private.dlg_concierge_end );

end;
--------------------------------------------------------------------------------------------
function private.dlg_concierge_end ()

  common_impl.ShowBbt( "bbt_hall_ext_dlg_hall_ext_concierge" );
  cmn.CallEventHandler( "dlg_hall_ext_concierge" ); 

  --interface.KeyTaskDone( true );
  --interface.KeyTaskAdd( "id" );

  for i = 1, 2 do

    --VidStop( "vid_dlg_park_1_professor_1_lip_"..i );
    --ObjSet( "vid_dlg_park_1_professor_1_lip_"..i, { alp = 0 } );

  end;

end;
--------------------------------------------------------------------------------------------
function private.dlg_david_kane_4_click ()

  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "david_kane_4", 3, nil, nil, true, private.dlg_david_kane_4_end );

end;
--------------------------------------------------------------------------------------------
function private.dlg_david_kane_4_end ()

  common_impl.ShowBbt( "bbt_hall_ext_dlg_hall_ext_david_kane_4" );

  --interface.KeyTaskDone( true );
  --interface.KeyTaskAdd( "id" );

  for i = 1, 2 do

    --VidStop( "vid_dlg_park_1_professor_1_lip_"..i );
    --ObjSet( "vid_dlg_park_1_professor_1_lip_"..i, { alp = 0 } );

  end;

  local func_end = function ()

    cmn.Lock( false );

    cmn.CallEventHandler( "dlg_hall_ext_david_kane_4" );   

    cmn.SetEventDone( "see_call_kane_4" ); 
    cmn.CallEventHandler( "see_call_kane_4" );   

  end;

  cmn.Lock( true );

  ObjAnimate( "anm_reception_ext_call", "alp", 0, 0, "", 
  { 
    0.0, 0, 1, 
    0.3, 0, 0 
  } );
  ObjAnimate( "spr_reception_ext_open_hand", "alp", 0, 0, func_end, 
  { 
    0.0, 0, 0, 
    0.5, 0, 0, 
    0.8, 0, 1 
  } );

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_phone2", 0, "", 0 );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_hall_ext ()

  if not ( cmn.IsEventDone( "opn_hall_ext" ) ) then

    cmn.SetEventDone( "opn_hall_ext" );
    common_impl.ShowBbt( "bbt_hall_ext_opn_hall_ext" );

  end;

  cmn.CallEventHandler( "opn_hall_ext" ); 

end;
--*********************************************************************************************************************
-- function *** MG Password_Generator 1 and 2 *** () end;
--*********************************************************************************************************************
function private.PasGenInit ()

  local table_multiset = {};

  for i = 0, 9  do

    table.insert( table_multiset, { "obj_passgenerator_button_"..i, { event_mdown  = function () private.MgPasGenButClk( i ) end,
                                                                      event_menter = function () common_impl.SetCursor( CURSOR_HAND ) end,
                                                                      event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ) end, } } );

  end;
  
  table.insert( table_multiset, { "obj_passgenerator_button_enter", { event_mdown = function () private.MgPasGenEnterClk() end,
                                                                      event_menter = function () common_impl.SetCursor( CURSOR_HAND ) end,
                                                                      event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ) end, } } );
  table.insert( table_multiset, { "obj_passgenerator_button_backspace", { event_mdown = function () private.MgPasGenBackspaceClk() end,
                                                                          event_menter = function () common_impl.SetCursor( CURSOR_HAND ) end,
                                                                          event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ) end, } } ); 

  ObjMultiSet(table_multiset);

--*********************************************************************************************************************
  function private.MgPasGenButClk( num )

    local endfunc = function ()
    
      cmn.Lock( false );  

    end;

    local num_count = #ng_global.progress[ "ext" ][ "win_pas_gen_1" ].numbers[private.Gen_num];
    
    if ( num_count < 3 ) then
    
      table.insert( ng_global.progress[ "ext" ][ "win_pas_gen_1" ].numbers[private.Gen_num], num );
      ObjSet( "spr_passgenerator_display_num_"..( num_count + 1 ), { alp = 0, res = "assets/levels/levelext/rm_hall_ext/zz_passgenerator/anims/number_"..num} )
      ObjAnimate( "spr_passgenerator_display_num_"..( num_count + 1 ), "alp", 0, 0, "", { 0, 3, 0, 0.2, 3, 0, 0.4, 3, 1 });

    end;
    cmn.Lock( true );
    ObjAttach( "spr_passgenerator_button_press", "obj_passgenerator_button_"..num );
    ObjAnimate( "spr_passgenerator_button_press", "alp", 0, 0, endfunc, { 0, 3, 0, 0.2, 3, 1, 0.4, 3, 0 });

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_button4", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.MgPasGenBackspaceClk()
    
    local endfunc = function ()
    
      cmn.Lock( false );  

    end;
    
    local num_count = #ng_global.progress[ "ext" ][ "win_pas_gen_1" ].numbers[private.Gen_num];
    
    table.remove(ng_global.progress[ "ext" ][ "win_pas_gen_1" ].numbers[private.Gen_num]);
    cmn.Lock( true );

    if ( num_count ~= 0 ) then

      ObjAnimate( "spr_passgenerator_display_num_"..num_count, "alp", 0, 0, "", { 0, 3, 1, 0.2, 3, 1, 0.4, 3, 0 });   
 
    end;

    ObjAttach( "spr_passgenerator_button_press", "obj_passgenerator_button_backspace" );
    ObjAnimate( "spr_passgenerator_button_press", "alp", 0, 0, endfunc, { 0, 3, 0, 0.2, 3, 1, 0.4, 3, 0 });

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_button4", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.MgPasGenEnterClk()

    ObjAttach( "spr_passgenerator_button_press", "obj_passgenerator_button_enter" );
    ObjAnimate( "spr_passgenerator_button_press", "alp", 0, 0, "", { 0, 3, 0, 0.2, 3, 1, 0.4, 3, 0 });

    local endfunc = function ()

      cmn.Lock( false );
      ng_global.progress[ "ext" ][ "win_pas_gen_1" ].numbers[private.Gen_num] = {};

    end;

    if ( private.MgPasGenIsWin() ) then

      private.MgPasGenWin();

    else

      cmn.Lock( true );

      ObjAnimate( "spr_passgenerator_display_enter_code", "alp", 0, 0, endfunc, { 0, 3, 1, 0.2, 3, 0, 0.8, 3, 0, 1.0, 3, 1 });
      ObjAnimate( "spr_passgenerator_display_error", "alp", 0, 0, ""     , { 0, 3, 0, 0.2, 3, 1, 0.8, 3, 1, 1.0, 3, 0 });

      for i = 1,3 do

        ObjAnimate( "spr_passgenerator_display_num_"..i, "alp", 0, 0, "", { 0, 3, ObjGet("spr_passgenerator_display_num_"..i).alp, 0.2, 3, 0 });
      
      end

      common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

    end;
    
  end;
  --*********************************************************************************************************************
  function private.MgPasGenIsWin()
    
    local win_nums = {};

    win_nums[1] = { 4, 7, 9 };
    win_nums[2] = { 1, 3, 5 };
    
    for i = 1,#win_nums[private.Gen_num] do
      
      if ( win_nums[private.Gen_num][i] ~= ng_global.progress[ "ext" ][ "win_pas_gen_1" ].numbers[private.Gen_num][i] ) then
    
        return false;

      end;

    end;
    
    return true;

  end;
  --*********************************************************************************************************************
  function private.MgPasGenWin()
    
    local endfunc = function ()

      cmn.SetEventDone( "win_pas_gen_"..private.Gen_num );
      cmn.CallEventHandler( "win_pas_gen_"..private.Gen_num );
      cmn.Lock( false );

    end;   

    cmn.Lock( true );

    for i = 1,3  do

      ObjSet( "spr_passgenerator_display_num_"..i, { alp = 0 } );

    end;

    ObjAnimate( "spr_passgenerator_display_enter_code", "alp", 0, 0, endfunc, { 0, 3, 1, 0.2, 3, 0 });
    ObjAnimate( "spr_passgenerator_display_take", "alp", 0, 0, ""     , { 0, 3, 0, 0.2, 3, 1 });
    ObjAnimate( "spr_passgenerator_generatedpassword"..private.Gen_num, "pos_xy", 0, 0,endfunc , { 0, 3, 114, 9, 0.4, 3, 117, 109  });
    cmn.MiniGameHide( "pas_gen_"..private.Gen_num );

    common_impl.PassingMgWin( "pas_gen_"..private.Gen_num );

    
  end;
  --*********************************************************************************************************************
  function private.MgPasGenReset()

    for i = 1,3  do

      ObjSet( "spr_passgenerator_display_num_"..i, { alp = 0 } );

    end;

    ng_global.progress[ "ext" ][ "win_pas_gen_1" ].numbers[private.Gen_num] = {};
    
  end;
  --*********************************************************************************************************************
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** Animations *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.InitAnimations ()
--------------------------------------------------------------------------------------------

  ObjAnimate( "spr_passgenerator_light", "alp", 1, 0, "", 
  { 
    0.0, 3, 1.0, 
    2.0, 3, 0.1, 
    4.1, 3, 1.0, 
    6.0, 3, 0.3, 
    8.1, 3, 0.9, 
    9.2, 3, 0.3, 
    15.3, 3, 1.0, 

  } );

  ObjAnimate( "spr_hallelevator_red_light", "alp", 1, 0, "", 
  { 
    0.0, 0, 1.0, 
    1.5, 0, 0.0, 
    3.0, 0, 1.0, 
  } );

end;
--------------------------------------------------------------------------------------------
function private.ClkConcierge_2 ()

  local func_end = function ()

    common_impl.ShowBbt( 'bbt_hall_ext_clk_concierge_2' );
    cmn.Lock( false );
    ObjMultiSet( {
      { "anm_hall_ext_concierge_1", { alp = 1 } },
      { "anm_hall_ext_concierge_2", { alp = 0 } },
    } );

  end;

  cmn.Lock( true );
  ObjMultiSet( {
    { "anm_hall_ext_concierge_1", { alp = 0 } },
    { "anm_hall_ext_concierge_2", { alp = 1 } },
  } );
  AnimPlay( "anm_hall_ext_concierge_2", "DoAnim", func_end );

end;
--*********************************************************************************************************************
-- function *** FEEDDBACKANIM *** () end;
--*********************************************************************************************************************
function private.UseElevatormap ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_hallelevator_use_elevatormap' );

  end;

  cmn.Lock( true );
  ObjAnimate( "spr_hallelevator_door", "pos_xy", 0, 0, func_end, 
  { 
    0.00, 0, ObjGet( "spr_hallelevator_door" ).pos_x, ObjGet( "spr_hallelevator_door" ).pos_y, 
    0.15, 0, ObjGet( "spr_hallelevator_door" ).pos_x, ObjGet( "spr_hallelevator_door" ).pos_y - 3,     
    0.30, 0, ObjGet( "spr_hallelevator_door" ).pos_x, ObjGet( "spr_hallelevator_door" ).pos_y,
  } );  

end;
--------------------------------------------------------------------------------------------
function private.UseGeneratedpassword ()

  local func_end = function ()

    cmn.Lock( false );

    if ( not cmn.IsEventDone( "use_generatedpassword1" ) ) then

      common_impl.ShowBbt( 'bbt_reception_ext_use_generatedpassword1' );

    else

      common_impl.ShowBbt( 'bbt_reception_ext_use_generatedpassword2' );

    end;

  end;

  cmn.Lock( true );
  ObjAnimate( "spr_reception_ext_door", "pos_xy", 0, 0, func_end, 
  { 
    0.00, 0, ObjGet( "spr_reception_ext_door" ).pos_x, ObjGet( "spr_reception_ext_door" ).pos_y, 
    0.15, 0, ObjGet( "spr_reception_ext_door" ).pos_x, ObjGet( "spr_reception_ext_door" ).pos_y - 3,     
    0.30, 0, ObjGet( "spr_reception_ext_door" ).pos_x, ObjGet( "spr_reception_ext_door" ).pos_y,
  } ); 

end;
--------------------------------------------------------------------------------------------