-- name=rm_managerroom
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_managerroom";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.InitAnimations();
  
  local tb = {}

  table.insert( tb, { "obj_managerroom_clk_interview_1",                  { event_mdown = private.dlg_interview_1_click } } );
  table.insert( tb, { "obj_managerroom_clk_interview_1_focus",            { event_mdown = private.dlg_interview_1_click } } );

  table.insert( tb, { "obj_managerroom_interview_2_statement",            { event_mdown = function() private.ClkDlgStatement( "start" ) end; } } );
  table.insert( tb, { "obj_managerroom_interview_2_statement_focus",      { event_mdown = function() private.ClkDlgStatement( "start" ) end; } } );
  table.insert( tb, { "spr_managerroom_interview_2_statement_pen_1",      { event_mdown = private.StatementGetPen } } );

  for i = 1, 3 do

    table.insert( tb, { "obj_managerroom_interview_2_statement_text_"..i,
    {
      event_mdown  = function() private.StatementClkText( i ) end,
      event_menter = private.StatementEnterText,
      event_mleave = private.StatementLeaveText
    } } );

  end;

  ObjMultiSet( tb );

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_managerroom = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "grm_managerroom_secondfloor_ext",
    "gmg_managerroom_forandagainst"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_managerroom", update_game_mode_managerroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_managerroom = function ()

  local effects_table = 
  {
    "obj_managerroom_anim" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_managerroom", update_performance_mode_managerroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_managerroom () end;
  --------------------------------------------------------------------------------------------
  local opn_managerroom_map = function ()

    common_impl.VisitMapRoom( "managerroom" );

  end;
  cmn.AddSubscriber( "opn_managerroom", opn_managerroom_map );
  --------------------------------------------------------------------------------------------
  -- function dlg_managerroom_interview_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_managerroom_interview_1" ] = {
    type = "click",
    use_place = "obj_managerroom_clk_interview_1_focus",
    room = private.room_objname
  };

  local dlg_managerroom_interview_1 = function ()

    ObjDelete( "obj_managerroom_clk_interview_1" );
    ObjDelete( "dlg_managerroom_interview_1_lip" );
    ObjSet( "spr_dlg_managerroom_interview_1_frazer_1", { alp = 1 } );
    ObjSet( "spr_dlg_managerroom_interview_1_frazer_2", { alp = 0 } );
    ObjSet( "gmg_managerroom_forandagainst", { active = true, alp = 1, visible = true, input = true } );
    ObjSet( "spr_managerroom_forandagainst_2", { alp = 1 } );
    ObjDelete( "spr_managerroom_forandagainst_1" );

  end;
  cmn.AddSubscriber( "dlg_managerroom_interview_1", dlg_managerroom_interview_1, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function dlg_managerroom_interview_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_managerroom_interview_2" ] = {
    type = "click",
    use_place = "obj_managerroom_clk_interview_2_focus", --нужна только локация
    room = private.room_objname
  };
  local dlg_managerroom_interview_2 = function ()

    ObjDelete( "spr_dlg_managerroom_interview_1_frazer_1" );
    ObjDelete( "spr_dlg_managerroom_interview_1_frazer_2" );
    ObjDelete( "spr_dlg_managerroom_interview_2_frazer" );
    ObjDelete( "dlg_managerroom_interview_2_lip" );

  end;
--  local dlg_managerroom_interview_2_terenceroom = function ()
--
--    ObjSet( "obj_terenceroom_ext_clk_josh_fraser_3", { input = true, visible = true, active = true, alp = 1 } );
--
--  end;
  cmn.AddSubscriber( "dlg_managerroom_interview_2", dlg_managerroom_interview_2, private.room_objname );  
  --cmn.AddSubscriber( "dlg_managerroom_interview_2", dlg_managerroom_interview_2_terenceroom, "rm_terenceroom" );  

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_managerroom();
  int_slider.InitSlider( private.room_objname );

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

  if cmn.IsEventDone( "win_forandagainst" ) and
  not cmn.IsEventDone( "dlg_managerroom_interview_2" ) then 

    private.dlg_interview_2_click(); 

  end; 

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )

  if dlg_name == "interview_1" then

    if ( count_txt == 1 ) then -- Kevin Reynolds 

      ObjSet( "spr_int_dialog_character_icon", { res = "assets/interface/resources/dialog_character/btm_1" } );
      ObjSet( "vid_managerroom_interview_1_lip_1", { visible = true } );
      VidPlay( "vid_managerroom_interview_1_lip_1", "" );

    elseif ( count_txt == 2 ) then -- Terence Irwing 

      ObjSet( "spr_int_dialog_character_icon", { res = "assets/interface/resources/dialog_character/btm_4" } );
      ObjAnimate( "rm_managerroom", "scale_xy",0,0, "", { 0, 3, 1.2, 1.2,    0.3, 3, 1, 1 } );

      ObjDelete( "vid_managerroom_interview_1_lip_1" );

    elseif ( count_txt == 3 ) then -- Kevin Reynolds 

      ObjSet( "spr_int_dialog_character_icon", { res = "assets/interface/resources/dialog_character/btm_1" } );
      ObjAnimate( "rm_managerroom", "scale_xy",0,0, "", { 0, 3, 1, 1,    0.3, 3, 1.2, 1.2 } );

      ObjSet( "vid_managerroom_interview_1_lip_2", { visible = true, alp = 1 } );
      VidPlay( "vid_managerroom_interview_1_lip_2", "" );

    elseif ( count_txt == 4 ) then -- Kevin Reynolds 

      ObjMultiSet( {
        { "anm_managerroom_dialog_frazer",          { alp = 1 } },
        { "anm_managerroom_dialog_frazerandmouse",  { alp = 1 } },
      } );

      AnimPlay( "anm_managerroom_dialog_frazerandmouse", "frazerandmouse", "" );
      ObjDelete( "vid_managerroom_interview_1_lip_2" );
      ObjSet( "vid_managerroom_interview_1_lip_3", { visible = true, alp = 1 } );
      VidPlay( "vid_managerroom_interview_1_lip_3", "" );

    elseif ( count_txt == 5 ) then -- Josh Fraiser 

      ObjSet( "spr_int_dialog_character_icon", { res = "assets/interface/resources/dialog_character/btm_5" } ); 
      ObjAnimate( "rm_managerroom", "pos_xy",0,0, "", { 0, 3, 0, 0,    0.3, 3, -200, 0 } );
      ObjDelete( "vid_managerroom_interview_1_lip_3" );
      ObjSet( "vid_managerroom_interview_1_lip_4", { visible = true, alp = 1 } );
      VidPlay( "vid_managerroom_interview_1_lip_4", "" );

    end;
  -----------------------------------------------------
  -----------------------------------------------------
  elseif dlg_name == "interview_2" then

    if ( count_txt == 1 ) then -- Terence Irwing 

      ObjSet( "spr_int_dialog_character_icon", { res = "assets/interface/resources/dialog_character/btm_4" } );


    elseif ( count_txt == 2 ) then -- Kevin Reynolds 

      ObjSet( "spr_int_dialog_character_icon", { res = "assets/interface/resources/dialog_character/btm_1" } );
      ObjAnimate( "rm_managerroom", "scale_xy",0,0, "", { 0, 3, 1, 1,    0.3, 3, 1.2, 1.2 } );
      ObjSet( "vid_managerroom_interview_2_lip_1", { visible = true } );
      VidPlay( "vid_managerroom_interview_2_lip_1", "" );
      

    elseif ( count_txt == 3 ) then -- Josh Fraiser 

      ObjSet( "spr_int_dialog_character_icon", { res = "assets/interface/resources/dialog_character/btm_5" } ); 
      ObjAnimate( "rm_managerroom", "pos_xy",0,0, "", { 0, 3, 0, 0,    0.3, 3, -200, 0 } );
      ObjMultiSet( {
        { "anm_managerroom_dialog2_frazerandmouse",   { alp = 1  } },
      } );
      AnimPlay( "anm_managerroom_dialog2_frazerandmouse", "frazerandmouse", "" );
      ObjDelete( "vid_managerroom_interview_2_lip_1" );
      ObjSet( "vid_managerroom_interview_2_lip_2", { visible = true } );
      VidPlay( "vid_managerroom_interview_2_lip_2", "" );
      
    
    elseif ( count_txt == 4 ) then -- Josh Fraiser MMg

      private.DlgStatement = ObjGet( "obj_int_dialog_character_input" ).event_mdown;
      ObjSet( "obj_int_dialog_character_input", { input = false } );
      ObjSet( "obj_managerroom_interview_2_statement", { input = true } );
      ObjAnimate( "obj_managerroom_interview_2_statement", "alp",0,0, "", { 0, 3, 0,   0.2, 3, 1 } );
      ObjDelete( "vid_managerroom_interview_2_lip_2" );
      ObjSet( "vid_managerroom_interview_2_lip_3", { visible = true } );
      VidPlay( "vid_managerroom_interview_2_lip_3", "" );

    elseif ( count_txt == 5 ) then -- Kevin Reynolds 

      ObjSet( "spr_int_dialog_character_icon", { res = "assets/interface/resources/dialog_character/btm_1" } );
      ObjAnimate( "rm_managerroom", "pos_xy",0,0, "", { 0, 3, -200, 0,    0.3, 3, 0, 0 } );
      ObjDelete( "vid_managerroom_interview_2_lip_3" );
      ObjSet( "vid_managerroom_interview_2_lip_4", { visible = true } );
      VidPlay( "vid_managerroom_interview_2_lip_4", "" );

    end;

  end;  

end;
--------------------------------------------------------------------------------------------
function private.dlg_interview_1_click ()

  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "interview_1", 6, nil, nil, true, private.dlg_interview_1_end );

  ObjAnimate( "rm_managerroom", "scale_xy",0,0, "", { 0, 3, 1, 1,    0.3, 3, 1.2, 1.2 } );

end;
--------------------------------------------------------------------------------------------
function private.dlg_interview_1_end ()

  ObjSet( "rm_managerroom", { scale_x = 1, scale_y = 1, pos_x = 0, pos_y = 0 } );
  ObjSet( "spr_int_dialog_character_icon", { res = "" } );
  ObjDelete( "vid_managerroom_interview_1_lip_4" );
  cmn.CallEventHandler( "dlg_managerroom_interview_1" );   
  common_impl.ShowBbt( "bbt_managerroom_dlg_managerroom_interview_1" );

  cmn.GotoRoom( "mg_forandagainst" ); 

  --interface.KeyTaskDone( true );
  --interface.KeyTaskAdd( "id" );

  for i = 1, 2 do

    --VidStop( "vid_dlg_park_1_professor_1_lip_"..i );
    --ObjSet( "vid_dlg_park_1_professor_1_lip_"..i, { alp = 0 } );

  end;

end;
--------------------------------------------------------------------------------------------
function private.dlg_interview_2_click ()

  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "interview_2", 6, nil, nil, true, private.dlg_interview_2_end );

end;
--------------------------------------------------------------------------------------------
function private.dlg_interview_2_end ()

  ObjSet( "rm_managerroom", { scale_x = 1, scale_y = 1, pos_x = 0, pos_y = 0 } );
  ObjSet( "spr_int_dialog_character_icon", { res = "" } );

  int_button_info.Hide();

  cmn.CallEventHandler( "dlg_managerroom_interview_2" );   
  common_impl.ShowBbt( "bbt_managerroom_dlg_managerroom_interview_2" );
  cmn.GotoRoom( "rm_terenceroom_ext" ); 

end;
--------------------------------------------------------------------------------------------
function private.ClkDlgStatement ( state )

  if state == "start" then

    ObjSet( "spr_managerroom_interview_2_statement", { input = true } );

    local func_end = function()

      cmn.Lock( false );

      ObjDelete( "obj_managerroom_interview_2_statement" );

      private.statement_pen = false;
      private.statement = 0;

      int_button_info.Show( "statement" );

    end;

    cmn.Lock( true );

    ObjAnimate( "spr_managerroom_interview_2_statement", "alp", 0, 0, func_end, { 0, 0, 0,   0.3, 0, 1 } );
    ObjAnimate( "txt_int_dialog_character_continue", "alp", 0, 0, "", { 0, 0, 1,   0.3, 0, 0 } );

  elseif state == "close" then

    local func_end = function()

      cmn.Lock( false );

      private.DlgStatement();
      ObjSet( "obj_int_dialog_character_input", { input = true, event_mdown = private.DlgStatement } );
      ObjSet( "spr_managerroom_interview_2_statement", { input = false } );

    end;

    cmn.Lock( true );

    ObjAnimate( "spr_managerroom_interview_2_statement", "alp", 0, 0, func_end, { 0, 0, 1,   0.3, 0, 0 } )
    ObjAnimate( "txt_int_dialog_character_continue", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 } );

  end;

end;
--------------------------------------------------------------------------------------------
-- function *** Mmg Statement *** ()
--------------------------------------------------------------------------------------------
  function private.StatementGetPen ()

    SetCursor( CURSOR_NULL );

    private.statement_pen = true;

    ObjSet( "spr_managerroom_interview_2_statement_pen_1", { alp = 0, input = false } );
    ObjSet( "spr_managerroom_interview_2_statement_pen_2", { alp = 1 } );

    private.StatementPenDrag();

  end;
  --------------------------------------------------------------------------------------------
  function private.StatementPenDrag ()

    if not private.statement_pen then

      return;

    end;

    local pos = GetZoomCursorPos();

    local pos_x = pos[ 1 ] - 512;
    local pos_y = pos[ 2 ] - 384;
    
    if port.isPortable() == 1 then
      if tostring(GetPlatform()) == "ios" and port.isTablet() == 0 then
        pos_y = pos_y - 75;
      else
        pos_y = pos_y - 50;
      end;
    end;

    ObjSet( "spr_managerroom_interview_2_statement_pen_2", { pos_x = pos_x, pos_y = pos_y } );

    ObjAnimate( "spr_managerroom_interview_2_statement_pen_2", "alp", 0, 0, private.StatementPenDrag, { 0, 0, 1,   0.01, 0, 1 } );

  end;
  --------------------------------------------------------------------------------------------
  function private.StatementClkText ( text )

    if not private.statement_pen then

      return;

    end;

    cmn.Lock( true );

    local func_end = function ()

      cmn.Lock( false );

      private.statement = private.statement + 1;

      ObjDelete( "obj_managerroom_interview_2_statement_text_"..text );

      if ( private.statement == 3 ) then

        private.statement_pen = false;

        SetCursor( CURSOR_DEFAULT );

        private.ClkDlgStatement( "close" );

        int_button_info.Hide();

      end;

    end;

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_use_pen", 0, "", 0 );

    ObjAnimate( "spr_managerroom_interview_2_statement_text_"..text, "alp", 0, 0, func_end, { 0, 0, 0,   0.3, 0, 1 } );

  end;
  --------------------------------------------------------------------------------------------
  function private.StatementEnterText ()

    if not private.statement_pen then

      common_impl.SetCursor( CURSOR_USE );

    end;

  end;
  --------------------------------------------------------------------------------------------
  function private.StatementLeaveText ()

    if not private.statement_pen then

      common_impl.SetCursor( CURSOR_DEFAULT );

    end;

  end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_managerroom ()

  if not ( cmn.IsEventDone( "opn_managerroom" ) ) then

    cmn.SetEventDone( "opn_managerroom" );
    common_impl.ShowBbt( "bbt_managerroom_opn_managerroom" );

    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "pass_interview" );

  end;

  cmn.CallEventHandler( "opn_managerroom" ); 

end;
--*********************************************************************************************************************
-- function *** ANIM *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_managerroom_light", "alp", 1, 0, "", { 0, 0, 1,    2, 0, 0.5,   4, 0, 1  } );

end;
--*********************************************************************************************************************