-- name=rm_nearcafe
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_nearcafe";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_cafedoor", "room_hub" );
  ObjAttach( "zz_wagon", "room_hub" );
  ObjAttach( "zz_grill", "room_hub" );
  private.Init_Subroom();
  private.InitGrill();
  
  ObjMultiSet( { 
    { "spr_cafedoor_wagonkey",                        { event_mdown = private.get_wagonkey            } },
    { "spr_wagon_rope_ext",                           { event_mdown = private.get_rope_ext            } },
    { "spr_wagon_hacksaw",                            { event_mdown = private.get_hacksaw             } },
    { "spr_wagon_frozenprecookedfood",                { event_mdown = private.get_frozenprecookedfood } },
    { "spr_grill_phoenixfigure",                      { event_mdown = private.get_phoenixfigure       } },
    { "spr_grill_sausage_used",                       { event_mdown = private.get_grilledmeat         } },
    { "spr_grill_hacksawhandle",                      { event_mdown = private.get_hacksawhandle       } },
    { "obj_cafedoor_use_grilledmeat",                 { event_mdown = private.CafedoorClickDog        } },
    { "obj_wagon_clk_wagonkey_1",                     { event_mdown = private.clk_wagonkey_1          } },
    { "obj_wagon_clk_wagonkey_2",                     { event_mdown = private.clk_wagonkey_2          } },
    { "obj_wagon_clk_sharpening",                     { event_mdown = private.get_frozenprecookedfood } },
    { "obj_wagon_clk_hacksawhandle_1",                { event_mdown = private.clk_hacksawhandle_1     } },
    { "obj_wagon_clk_hacksawhandle_2",                { event_mdown = private.clk_hacksawhandle_2     } },
    { "obj_wagon_use_hacksawhandle",                  { event_mdown = private.WagonClickHackSaw       } },
    { "obj_grill_use_stonewings",                     { event_mdown = private.UseStonewings           } },
    { "spr_collect2_item_4_4",                        { event_mdown = private.get_collect2_item_4_4   } },
    { "spr_nearcafe_collect_morph_item",              { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_4_3" ); end } },
  } );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_nearcafe = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "grm_nearcafe_porch_ext",
      "grm_nearcafe_cafe",
      "gzz_nearcafe_cafedoor",
      "gzz_nearcafe_wagon",
      "gzz_nearcafe_grill",
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_grill",
      "zz_cafedoor",
      "zz_wagon",
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_nearcafe", update_game_mode_nearcafe, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_nearcafe = function ()

  local effects_table = 
  {
    "obj_nearcafe_anim",
    "anm_nearcafe_clouds",
    "vid_nearcafe_grill_fire_loop", 
  };

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_nearcafe", update_performance_mode_nearcafe, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_nearcafe () end;
  --------------------------------------------------------------------------------------------
  local opn_nearcafe_map = function ()

    common_impl.VisitMapRoom( "nearcafe" );

  end;
  cmn.AddSubscriber( "opn_nearcafe", opn_nearcafe_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_wagonkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wagonkey" ] = {
    type = "get",
    get_obj = "spr_cafedoor_wagonkey",
    room = private.room_objname,
    zz = "zz_cafedoor",
    zz_gate = "gzz_nearcafe_cafedoor"
  };
  
  local get_wagonkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_wagonkey", "spr_cafedoor_wagonkey" );
  
  end;
  
  local get_wagonkey_closezz = function ()
  
    ObjDelete( "gfx_cafedoor_wagonkey" );
  
  end;
  
  cmn.AddSubscriber( "get_wagonkey", get_wagonkey_inv );
  cmn.AddSubscriber( "get_wagonkey", get_wagonkey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_rope_ext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_rope_ext" ] = {
    type = "get",
    get_obj = "spr_wagon_rope_ext",
    room = private.room_objname,
    zz = "zz_wagon",
    zz_gate = "gzz_nearcafe_wagon"
  };
  
  local get_rope_ext_inv = function ()
  
    interface.InventoryItemAdd( "inv_rope_ext", "spr_wagon_rope_ext" );
  
  end;
  
  local get_rope_ext_closezz = function ()
  
    ObjDelete( "gfx_wagon_rope_ext" );
    ObjDelete( "spr_nearcafe_wagon_rope" );

    if cmn.IsEventDone( "win_droppedtreecrown" ) then

      cmn.SetInvPlusRGB( "stick", true );

    end;

  end;
  
  cmn.AddSubscriber( "get_rope_ext", get_rope_ext_inv );
  cmn.AddSubscriber( "get_rope_ext", get_rope_ext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hacksaw () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hacksaw" ] = {
    type = "get",
    get_obj = "spr_wagon_hacksaw",
    room = private.room_objname,
    zz = "zz_wagon",
    zz_gate = "gzz_nearcafe_wagon"
  };
  
  local get_hacksaw_inv = function ()
  
    interface.InventoryItemAdd( "inv_hacksaw", "spr_wagon_hacksaw" );
  
  end;
  
  local get_hacksaw_closezz = function ()
  
    ObjDelete( "gfx_wagon_hacksaw" );
  
  end;
  
  cmn.AddSubscriber( "get_hacksaw", get_hacksaw_inv );
  cmn.AddSubscriber( "get_hacksaw", get_hacksaw_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_frozenprecookedfood () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_frozenprecookedfood" ] = {
    type = "get",
    get_obj = "spr_wagon_frozenprecookedfood",
    room = private.room_objname,
    zz = "zz_wagon",
    zz_gate = "gzz_nearcafe_wagon"
  };
  
  local get_frozenprecookedfood_inv = function ()
  
    ObjSet( "spr_wagon_frozenprecookedfood", { alp = 1, visible = true } );
    interface.InventoryItemAdd( "inv_frozenprecookedfood", "spr_wagon_frozenprecookedfood" );
  
  end;
  
  local get_frozenprecookedfood_closezz = function ()
  
    ObjDelete( "gfx_wagon_frozenprecookedfood" );
    ObjDelete( "obj_wagon_clk_sharpening" );

    if ( cmn.IsGetCollect2( "get_collect2_item_4_4" ) ) then

      ObjDelete( "gzz_nearcafe_wagon" );

    end;

  end;
  
  cmn.AddSubscriber( "get_frozenprecookedfood", get_frozenprecookedfood_inv );
  cmn.AddSubscriber( "get_frozenprecookedfood", get_frozenprecookedfood_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_phoenixfigure () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_phoenixfigure" ] = {
    type = "get",
    get_obj = "spr_grill_phoenixfigure",
    room = private.room_objname,
    zz = "zz_grill",
    zz_gate = "gzz_nearcafe_grill"
  };
  
  local get_phoenixfigure_inv = function ()
  
    interface.InventoryItemAdd( "inv_phoenixfigure", "spr_grill_phoenixfigure" );
    ObjSet( "inv_phoenixfigure", { drag = false } );
    cmn.SetInvPlusRGB( "phoenixfigure", true );     

  end;
  
  local get_phoenixfigure_closezz = function ()
  
    ObjDelete( "gfx_grill_phoenixfigure" );
    ObjDelete( "gzz_nearcafe_grill" );   
    ObjSet( "spr_nearcafe_grill_grill_5", { alp = 1 } );
    ObjDelete( "spr_nearcafe_grill_grill_6" );

  end;
  
  cmn.AddSubscriber( "get_phoenixfigure", get_phoenixfigure_inv );
  cmn.AddSubscriber( "get_phoenixfigure", get_phoenixfigure_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_grilledmeat () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_grilledmeat" ] = {
    type = "get",
    get_obj = "spr_grill_grilledmeat",
    room = private.room_objname,
    zz = "zz_grill",
    zz_gate = "gzz_nearcafe_grill"
  };
  
  local get_grilledmeat_inv = function ()
  
    interface.InventoryItemAdd( "inv_grilledmeat", "spr_grill_sausage_used" );
  
  end;
  
  local get_grilledmeat_closezz = function ()
  
    ObjDelete( "gfx_grill_grilledmeat" );
    ObjDelete( "spr_nearcafe_grill_grill_2" );      

  end;
  
  cmn.AddSubscriber( "get_grilledmeat", get_grilledmeat_inv );
  cmn.AddSubscriber( "get_grilledmeat", get_grilledmeat_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hacksawhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hacksawhandle" ] = {
    type = "get",
    get_obj = "spr_grill_hacksawhandle",
    room = private.room_objname,
    zz = "zz_grill",
    zz_gate = "gzz_nearcafe_grill"
  };
  
  local get_hacksawhandle_inv = function ()
  
    interface.InventoryItemAdd( "inv_hacksawhandle", "spr_grill_hacksawhandle" );
  
  end;
  
  local get_hacksawhandle_closezz = function ()
  
    ObjDelete( "gfx_grill_hacksawhandle" );
    ObjDelete( "spr_grill_sawhandle_shadow" );

    ObjDelete( "spr_nearcafe_grill_grill_7" );
  
  end;
  
  cmn.AddSubscriber( "get_hacksawhandle", get_hacksawhandle_inv );
  cmn.AddSubscriber( "get_hacksawhandle", get_hacksawhandle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_4_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_4_4 = function ()
  
    ObjDelete( "obj_collect2_item_4_4" );

    if ( cmn.IsEventDone( "get_frozenprecookedfood" ) ) then

      ObjDelete( "gzz_nearcafe_wagon" );

    end;
  
  end;    
  cmn.AddSubscriber( "get_collect2_item_4_4", get_collect2_item_4_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_4_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_4_3 = function ()
  
    ObjDelete( "obj_nearcafe_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_4_3", get_collect_morph_item_4_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_wagonkey_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_wagonkey_1" ] = {
    type = "click",
    use_place = "obj_wagon_clk_wagonkey_1",
    room = private.room_objname,
    zz = "zz_wagon",
    zz_gate = "gzz_nearcafe_wagon"
  };

  local clk_wagonkey_1_beg = function ()

    ObjDelete( "obj_wagon_clk_wagonkey_1" );
  
  end;
  local clk_wagonkey_1_end = function ()

    ObjSet( "obj_wagon_clk_wagonkey_2", { input = true } );
    ObjDelete( "spr_zz_wagon_door1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_wagonkey_1", clk_wagonkey_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_wagonkey_1", clk_wagonkey_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_wagonkey_1_beg", clk_wagonkey_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_wagonkey_1_end", clk_wagonkey_1_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_wagonkey_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_wagonkey_2" ] = {
    type = "click",
    use_place = "obj_wagon_clk_wagonkey_2",
    room = private.room_objname,
    zz = "zz_wagon",
    zz_gate = "gzz_nearcafe_wagon"
  };

  local clk_wagonkey_2_beg = function ()

    ObjDelete( "obj_wagon_clk_wagonkey_2" );
  
  end;
  local clk_wagonkey_2_end = function ()

    ObjSet( "obj_wagon_use_sharpening", { input = true } );
    ObjSet( "obj_wagon_use_hacksawhandle", { input = true } );
    ObjSet( "spr_wagon_rope_ext", { input = true } );
    ObjSet( "spr_nearcafe_wagon_open_door", { alp = 1 } );
    ObjSet( "obj_collect2_item_4_4", { input = true } ) ;
    ObjDelete( "spr_zz_wagon_door2" );
    ObjDelete( "spr_nearcafe_wagon_hendle_wagon" );    

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_wagonkey_2", clk_wagonkey_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_wagonkey_2", clk_wagonkey_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_wagonkey_2_beg", clk_wagonkey_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_wagonkey_2_end", clk_wagonkey_2_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_hacksawhandle_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_hacksawhandle_1" ] = {
    type = "click",
    use_place = "obj_wagon_clk_hacksawhandle_1",
    room = private.room_objname,
    zz = "zz_wagon",
    zz_gate = "gzz_nearcafe_wagon"
  };

  local clk_hacksawhandle_1_beg = function ()

    ObjDelete( "obj_wagon_clk_hacksawhandle_1" );
  
  end;
  local clk_hacksawhandle_1_end = function ()

    ObjSet( "obj_wagon_clk_hacksawhandle_2", { input = true } );
    ObjSet( "spr_wagon_hacksaw", { ang = 0.2 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_hacksawhandle_1", clk_hacksawhandle_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_hacksawhandle_1", clk_hacksawhandle_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_hacksawhandle_1_beg", clk_hacksawhandle_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_hacksawhandle_1_end", clk_hacksawhandle_1_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_hacksawhandle_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_hacksawhandle_2" ] = {
    type = "click",
    use_place = "obj_wagon_clk_hacksawhandle_2",
    room = private.room_objname,
    zz = "zz_wagon",
    zz_gate = "gzz_nearcafe_wagon"
  };

  local clk_hacksawhandle_2_beg = function ()

    ObjDelete( "obj_wagon_clk_hacksawhandle_2" );
  
  end;
  local clk_hacksawhandle_2_end = function ()

    ObjSet( "spr_wagon_hacksaw", { ang = -0.2, input = true } );
    ObjSet( "gfx_wagon_hacksaw", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_hacksawhandle_2", clk_hacksawhandle_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_hacksawhandle_2", clk_hacksawhandle_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_hacksawhandle_2_beg", clk_hacksawhandle_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_hacksawhandle_2_end", clk_hacksawhandle_2_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_grilledmeat () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_grilledmeat" ] = {
    type = "use",
    inv_obj = "inv_grilledmeat",
    use_place = "obj_cafedoor_use_grilledmeat",
    room = private.room_objname,
    zz = "zz_cafedoor",
    zz_gate = "gzz_nearcafe_cafedoor"
  };
  local use_grilledmeat_inv = function ()
  
    interface.InventoryItemRemove( "inv_grilledmeat" );
  
  end;
  local use_grilledmeat_beg = function ()
  
    ObjDelete( "obj_cafedoor_use_grilledmeat" );
  
  end;
  local use_grilledmeat_end = function ()
  
    ObjDelete( "anm_zz_cafedoor_dog_sitting" );
    ObjDelete( "anm_zz_cafedoor_dog_growl" );

    ObjDelete( "gzz_nearcafe_cafedoor" );
    ObjSet( "grm_nearcafe_cafe", { input = true, visible = true, active = true, alp = 1 } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_nearcafe_cafe_focus");
    end;
    ObjSet( "spr_nearcafe_cafedoor_open_door", { alp = 1 } );
    ObjDelete( "anm_nearcafe_cafedoor_dog" );
    ObjSet( "anm_nearcafe_cafedoor_dog_sleep", { alp = 1, playing = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_grilledmeat", use_grilledmeat_beg, private.room_objname );
  cmn.AddSubscriber( "use_grilledmeat", use_grilledmeat_inv );
  cmn.AddSubscriber( "use_grilledmeat", use_grilledmeat_end, private.room_objname );
  cmn.AddSubscriber( "use_grilledmeat_inv", use_grilledmeat_inv, private.room_objname );
  cmn.AddSubscriber( "use_grilledmeat_beg", use_grilledmeat_beg, private.room_objname );
  cmn.AddSubscriber( "use_grilledmeat_end", use_grilledmeat_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sharpening () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sharpening" ] = {
    type = "use",
    inv_obj = "inv_sharpening",
    use_place = "obj_wagon_use_sharpening",
    room = private.room_objname,
    zz = "zz_wagon",
    zz_gate = "gzz_nearcafe_wagon"
  };
  local use_sharpening_inv = function ()
  
    interface.InventoryItemRemove( "inv_sharpening" );
  
  end;
  local use_sharpening_beg = function ()
  
    ObjDelete( "obj_wagon_use_sharpening" );
  
  end;
  local use_sharpening_end = function ()
  
    ObjSet( "spr_zz_wagon_package", { alp = 1, visible = true } );
    ObjSet( "obj_wagon_clk_sharpening", { input = true } );
    ObjDelete( "anm_zz_wagon_use_sharpening" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sharpening", use_sharpening_beg, private.room_objname );
  cmn.AddSubscriber( "use_sharpening", use_sharpening_inv );
  cmn.AddSubscriber( "use_sharpening", use_sharpening_end, private.room_objname );
  cmn.AddSubscriber( "use_sharpening_inv", use_sharpening_inv, private.room_objname );
  cmn.AddSubscriber( "use_sharpening_beg", use_sharpening_beg, private.room_objname );
  cmn.AddSubscriber( "use_sharpening_end", use_sharpening_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wagonkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wagonkey" ] = {
    type = "use",
    inv_obj = "inv_wagonkey",
    use_place = "obj_wagon_use_wagonkey",
    room = private.room_objname,
    zz = "zz_wagon",
    zz_gate = "gzz_nearcafe_wagon"
  };
  local use_wagonkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_wagonkey" );
  
  end;
  local use_wagonkey_beg = function ()
  
    ObjDelete( "obj_wagon_use_wagonkey" );
  
  end;
  local use_wagonkey_end = function ()
  
    ObjSet( "obj_wagon_clk_wagonkey_1", { input = true } );
    ObjSet( "spr_zz_wagon_key1", { alp = 1, visible = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wagonkey", use_wagonkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_wagonkey", use_wagonkey_inv );
  cmn.AddSubscriber( "use_wagonkey", use_wagonkey_end, private.room_objname );
  cmn.AddSubscriber( "use_wagonkey_inv", use_wagonkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_wagonkey_beg", use_wagonkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_wagonkey_end", use_wagonkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hacksawhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hacksawhandle" ] = {
    type = "use",
    inv_obj = "inv_hacksawhandle",
    use_place = "obj_wagon_use_hacksawhandle",
    room = private.room_objname,
    zz = "zz_wagon",
    zz_gate = "gzz_nearcafe_wagon"
  };
  local use_hacksawhandle_inv = function ()
  
    interface.InventoryItemRemove( "inv_hacksawhandle" );
  
  end;
  local use_hacksawhandle_beg = function ()
  
    ObjDelete( "obj_wagon_use_hacksawhandle" );
  
  end;
  local use_hacksawhandle_end = function ()
  
    ObjSet( "obj_wagon_clk_hacksawhandle_1", { input = true } );
    ObjSet( "spr_zz_wagon_hendle_hacksaw", { alp = 1, visible = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hacksawhandle", use_hacksawhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_hacksawhandle", use_hacksawhandle_inv );
  cmn.AddSubscriber( "use_hacksawhandle", use_hacksawhandle_end, private.room_objname );
  cmn.AddSubscriber( "use_hacksawhandle_inv", use_hacksawhandle_inv, private.room_objname );
  cmn.AddSubscriber( "use_hacksawhandle_beg", use_hacksawhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_hacksawhandle_end", use_hacksawhandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_broom_ext_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_broom_ext_1" ] = {
    type = "use",
    inv_obj = "inv_broom_ext",
    use_place = "obj_grill_use_broom_ext_1",
    room = private.room_objname,
    zz = "zz_grill",
    zz_gate = "gzz_nearcafe_grill"
  };
  local use_broom_ext_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_broom_ext" );
  
  end;
  local use_broom_ext_1_beg = function ()
  
    ObjDelete( "obj_grill_use_broom_ext_1" );
  
  end;
  local use_broom_ext_1_end = function ()
  
    ObjSet( "obj_grill_use_stonewings", { input = true } )
    ObjSet( "spr_grill_hacksawhandle", { input = true, alp = 1 } );
    ObjDelete( "spr_nearcafe_grill_grill_8" );
    ObjDelete( "anm_grill_stick" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_broom_ext_1", use_broom_ext_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_broom_ext_1", use_broom_ext_1_inv );
  cmn.AddSubscriber( "use_broom_ext_1", use_broom_ext_1_end, private.room_objname );
  cmn.AddSubscriber( "use_broom_ext_1_inv", use_broom_ext_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_broom_ext_1_beg", use_broom_ext_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_broom_ext_1_end", use_broom_ext_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lighter_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lighter_2" ] = {
    type = "use",
    inv_obj = "inv_lighter",
    use_place = "obj_grill_use_lighter_2",
    room = private.room_objname,
    zz = "zz_grill",
    zz_gate = "gzz_nearcafe_grill"
  };
  local use_lighter_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_lighter" );
  
  end;
  local use_lighter_2_beg = function ()
  
    ObjDelete( "obj_grill_use_lighter_2" );
  
  end;
  local use_lighter_2_end = function ()
  
    ObjMultiSet( {
      { "vid_grill_gas_loop",             { alp = 1, playing = true, looped = true } },
      { "vid_grill_fire_loop",            { alp = 1, playing = true, looped = true } },
      { "vid_nearcafe_grill_fire_loop",   { visible = true, playing = true, looped = true } },
    } );
    ObjDelete( "vid_grill_use_zip" );
    if ( cmn.IsEventDone( "use_frozenprecookedfood" ) ) then

      ObjMultiSet( { 
        { "spr_nearcafe_grill_grill_2",     { res = "assets/levels/levelext/rm_nearcafe/layers/zz_grill_2" } },
        { "obj_grill_clk_button_1",         { input = true } },
        { "obj_grill_clk_button_2",         { input = true } },
      } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lighter_2", use_lighter_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_lighter_2", use_lighter_2_inv );
  cmn.AddSubscriber( "use_lighter_2", use_lighter_2_end, private.room_objname );
  cmn.AddSubscriber( "use_lighter_2_inv", use_lighter_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_lighter_2_beg", use_lighter_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_lighter_2_end", use_lighter_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_frozenprecookedfood () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_frozenprecookedfood" ] = {
    type = "use",
    inv_obj = "inv_frozenprecookedfood",
    use_place = "obj_grill_use_frozenprecookedfood",
    room = private.room_objname,
    zz = "zz_grill",
    zz_gate = "gzz_nearcafe_grill"
  };
  local use_frozenprecookedfood_inv = function ()
  
    interface.InventoryItemRemove( "inv_frozenprecookedfood" );
  
  end;
  local use_frozenprecookedfood_beg = function ()
  
    ObjDelete( "obj_grill_use_frozenprecookedfood" );
  
  end;
  local use_frozenprecookedfood_end = function ()
  
    ObjSet( "spr_grill_sausage_used", { alp = 1 } );  
    ObjSet( "obj_grill_sausages", { alp = 1 } );
    ObjSet( "obj_nearcafe_grill_sausage", { alp = 1 } );

    if ( cmn.IsEventDone( "use_lighter_2" ) ) then

      ObjSet( "spr_nearcafe_grill_grill_2", { res = "assets/levels/levelext/rm_nearcafe/layers/zz_grill_2" } );
      ObjSet( "obj_grill_clk_button_1", { input = true } );
      ObjSet( "obj_grill_clk_button_2", { input = true } );

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_frozenprecookedfood", use_frozenprecookedfood_beg, private.room_objname );
  cmn.AddSubscriber( "use_frozenprecookedfood", use_frozenprecookedfood_inv );
  cmn.AddSubscriber( "use_frozenprecookedfood", use_frozenprecookedfood_end, private.room_objname );
  cmn.AddSubscriber( "use_frozenprecookedfood_inv", use_frozenprecookedfood_inv, private.room_objname );
  cmn.AddSubscriber( "use_frozenprecookedfood_beg", use_frozenprecookedfood_beg, private.room_objname );
  cmn.AddSubscriber( "use_frozenprecookedfood_end", use_frozenprecookedfood_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_stonewings () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_stonewings" ] = {
    type = "use",
    inv_obj = "inv_stonewings",
    use_place = "obj_grill_use_stonewings",
    room = private.room_objname,
    zz = "zz_grill",
    zz_gate = "gzz_nearcafe_grill"
  };
  local use_stonewings_inv = function ()
  
    interface.InventoryItemRemove( "inv_stonewings" );
  
  end;
  local use_stonewings_beg = function ()
  
    ObjDelete( "obj_grill_use_stonewings" );
  
  end;
  local use_stonewings_end = function ()
  
    ObjSet( "spr_nearcafe_grill_grill_6", { alp = 1 } );
    ObjSet( "spr_grill_phoenixfigure", { input = true, alp = 1 } );
    ObjDelete( "spr_grill_cover" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_stonewings", use_stonewings_beg, private.room_objname );
  cmn.AddSubscriber( "use_stonewings", use_stonewings_inv );
  cmn.AddSubscriber( "use_stonewings", use_stonewings_end, private.room_objname );
  cmn.AddSubscriber( "use_stonewings_inv", use_stonewings_inv, private.room_objname );
  cmn.AddSubscriber( "use_stonewings_beg", use_stonewings_beg, private.room_objname );
  cmn.AddSubscriber( "use_stonewings_end", use_stonewings_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_grill () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_grill" ] =
  {
      type = "win",
      room = private.room_objname,
      zz = "zz_grill",
      zz_gate = "gzz_nearcafe_grill"
  };
  local win_grill = function ()

    if ( cmn.IsEventDone( "win_grill" ) ) then
    
      ObjSet( "spr_grill_sausage_used", { input = true } );
      ObjSet( "spr_grill_sausage_ready", { alp = 1 } );
      ObjSet( "gfx_grill_grilledmeat", { active = true } );

      ObjDelete( "obj_grill_clk_button_1" );
      ObjDelete( "obj_grill_clk_button_2" );
    
    else

      private.arrow_speed = ng_global.progress.ext[ "win_grill" ].state.arrow_speed;
      ObjSet( "spr_grill_arrow", { pos_x = ng_global.progress.ext[ "win_grill" ].state.arrow_state } );
      ObjSet( "spr_grill_sausage_ready", { alp = ng_global.progress.ext[ "win_grill" ].state.sausage_state } );

    end;

  end;
  cmn.AddSubscriber( "win_grill", win_grill, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load ()

  --function mmg_grill () end; --------------------------------------------------------------------------
    if ( cmn.IsEventStart( "win_grill" ) ) then

    end;  
  ------------------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function private.Init_Subroom ()

  --*********************************************************************************************************************
  -- function zz_grill () end;
  --*********************************************************************************************************************
    subroom.Define( "zz_grill" );
    -------------------------------------------------
    function zz_grill.PreOpen()
    end;
    -------------------------------------------------
    function zz_grill.Open()

      if ( cmn.IsEventDone( "use_lighter_2" ) and cmn.IsEventDone( "use_frozenprecookedfood" ) and not cmn.IsEventDone( "win_grill" ) ) then
    
        cmn.MiniGameShow( "grill" );
        common_impl.PassingMgStart( "grill" );

        if not ( private.started ) then

          private.ArrowAnimation();
          private.started = true;

        end;

      end;

      if ( cmn.IsEventDone( "use_lighter_2" ) ) then
    
        common_impl.PlayAudio( "env", "levelext/env/aud_fire_env", 1, "", 0 );

      end;

    end;
    -------------------------------------------------
    function zz_grill.PreClose()

      if ( cmn.IsEventDone( "use_lighter_2" ) and cmn.IsEventDone( "use_frozenprecookedfood" ) and not cmn.IsEventDone( "win_grill" ) ) then
    
        cmn.MiniGameHide( "grill" );
        common_impl.PassingMgStop( "grill" );

      end;

    end;
    -------------------------------------------------
    function zz_grill.Close()

      if ( cmn.IsEventDone( "use_lighter_2" ) ) then
    
        common_impl.StopAudio( "env", "levelext/env/aud_fire_env", 1.0 );

      end;

    end;
    -------------------------------------------------
    function zz_grill.Reset ()

      private.LoseGrill();

    end;
    -------------------------------------------------
    function zz_grill.Skip ()

      cmn.Lock( true );

      local func_end = function ()
  
        private.WinGrill();
        cmn.Lock( false );

      end;

      ObjStopAnimate( "spr_grill_arrow", "pos_x" );
      ObjAnimate( "spr_grill_sausage_ready", "alp", 0, 0, func_end, 
      { 
        0.0, 0, ObjGet( "spr_grill_sausage_ready" ).alp, 
        0.3, 0, 1,
      } );

    end;
    -------------------------------------------------

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_nearcafe();
  int_slider.InitSlider( private.room_objname );

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();

  common_impl.EnvPlay( { "level1/env/aud_porch_env" }, "", 0.5 );

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_grilledmeat ()

  local item = "inv_grilledmeat";

  if cmn.ApplyObj( item, "gzz_nearcafe_cafedoor" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cafedoor", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_cafedoor_use_grilledmeat" ) ) then

    cmn.CallEventHandler( "use_grilledmeat_inv" );
    cmn.CallEventHandler( "use_grilledmeat_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_grilledmeat" );
      cmn.CallEventHandler( "use_grilledmeat_end" );

      common.CloseSubRoom();

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_grilledmeat", 0, "", 0 );

    common_impl.ShowBbt( "bbt_cafedoor_use_grilledmeat_1" );

    ObjSet( "anm_zz_cafedoor_dog_sitting", { alp = 0 } );
    AnimStop( "anm_zz_cafedoor_dog_sitting" );

    ObjSet( "anm_zz_cafedoor_dog_eating", { alp = 1 } );
    AnimPlay( "anm_zz_cafedoor_dog_eating", "func_9709", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_sharpening ()

  local item = "inv_sharpening";

  if cmn.ApplyObj( item, "gzz_nearcafe_wagon" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wagon", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_wagon_use_sharpening" ) ) then

    cmn.CallEventHandler( "use_sharpening_inv" );
    cmn.CallEventHandler( "use_sharpening_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_sharpening" );
      cmn.CallEventHandler( "use_sharpening_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_sharpening", 0, "", 0 );

    ObjSet( "anm_zz_wagon_use_sharpening", { alp = 0, visible = true } );
    ObjAnimate( "anm_zz_wagon_use_sharpening", "alp",0,0, "", { 0, 0, 0,    0.3, 0, 1 } );
    AnimPlay( "anm_zz_wagon_use_sharpening", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_wagonkey ()

  local item = "inv_wagonkey";

  if cmn.ApplyObj( item, "gzz_nearcafe_wagon" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wagon", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_wagon_use_wagonkey" ) ) then

    cmn.CallEventHandler( "use_wagonkey_inv" );
    cmn.CallEventHandler( "use_wagonkey_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_wagonkey" );
      cmn.CallEventHandler( "use_wagonkey_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_key_car", 0, "", 0 );
    
    ObjSet( "spr_zz_wagon_key1", { alp = 0, visible = true } );
    ObjAnimate( "spr_zz_wagon_key1", "alp",0,0, func_end, { 0, 0, 0,    0.6, 0, 1 } );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_hacksawhandle ()

  local item = "inv_hacksawhandle";

  if cmn.ApplyObj( item, "gzz_nearcafe_wagon" ) then

  --interface.ObjDoNotDrop( item );
   cmn.GotoSubRoom( "zz_wagon", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_wagon_use_hacksawhandle" ) ) then

    cmn.CallEventHandler( "use_hacksawhandle_inv" );
    cmn.CallEventHandler( "use_hacksawhandle_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_hacksawhandle" );
      cmn.CallEventHandler( "use_hacksawhandle_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );

    ObjSet( "spr_zz_wagon_hendle_hacksaw", { alp = 0, visible = true } );
    ObjAnimate( "spr_zz_wagon_hendle_hacksaw", "alp",0,0, func_end, { 0, 0, 0,    0.6, 0, 1 } );
  
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_broom_ext_1 ()

  local item = "inv_broom_ext";

  if cmn.ApplyObj( item, "gzz_nearcafe_grill" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_grill", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_grill_use_broom_ext_1" ) ) then

    cmn.CallEventHandler( "use_broom_ext_1_inv" );
    cmn.CallEventHandler( "use_broom_ext_1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_broom_ext_1" );
      cmn.CallEventHandler( "use_broom_ext_1_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_broom", 0, "", 0 );
    AnimPlay( "anm_grill_stick", "DoAnim", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_lighter_2 ()

  local item = "inv_lighter";

  if cmn.ApplyObj( item, "gzz_nearcafe_grill" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_grill", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_grill_use_lighter_2" ) ) then

    cmn.CallEventHandler( "use_lighter_2_inv" );
    cmn.CallEventHandler( "use_lighter_2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_lighter_2" );
      cmn.CallEventHandler( "use_lighter_2_end" );

      if ( cmn.IsEventDone( "use_frozenprecookedfood" ) ) then 

        private.InitGrillStart();

      end;

      common_impl.PlayAudio( "env", "levelext/env/aud_fire_env", 1, "", 0 );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_zippo1", 0, "", 0 );
    ObjSet( "vid_grill_use_zip",  { alp = 1 } );
    VidPlay( "vid_grill_use_zip", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_frozenprecookedfood ()

  local item = "inv_frozenprecookedfood";

  if cmn.ApplyObj( item, "gzz_nearcafe_grill" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_grill", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_grill_use_frozenprecookedfood" ) ) then

    cmn.CallEventHandler( "use_frozenprecookedfood_inv" );
    cmn.CallEventHandler( "use_frozenprecookedfood_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_frozenprecookedfood" );
      cmn.CallEventHandler( "use_frozenprecookedfood_end" );

      if ( cmn.IsEventDone( "use_lighter_2" ) ) then 

        private.InitGrillStart();

      end;

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_frozenprecookedfood", 0, "", 0 );

    ObjAnimate( "obj_grill_sausages", "alp", 0, 0, "", { 0, 0, 0, 0.3, 0, 1 } );
    ObjAnimate( "spr_grill_sausage_used", "alp", 0, 0, func_end, { 0, 0, 0, 0.3, 0, 1 } );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_stonewings ()

  local item = "inv_stonewings";

  if cmn.ApplyObj( item, "gzz_nearcafe_grill" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_grill", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_grill_use_stonewings" ) ) then

    cmn.CallEventHandler( "use_stonewings_inv" );
    cmn.CallEventHandler( "use_stonewings_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_stonewings" );
      cmn.CallEventHandler( "use_stonewings_end" );

    end;

    local func_continue = function ()

      ObjAnimate( "spr_grill_cover", "pos_y", 0, 0, func_end, { 0, 0, 160,   0.5, 0, 410 } );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_stonewings", 0, "", 0 );

    cmn.ItemFly( "spr_grill_wings", func_continue, 0.3 );
    
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_wagonkey ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_wagonkey" );
  cmn.CallEventHandler( "get_wagonkey" );

end;
--------------------------------------------------------------------------------------------
function private.get_rope_ext ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_rope_ext" );
  cmn.CallEventHandler( "get_rope_ext" );

end;
--------------------------------------------------------------------------------------------
function private.get_hacksaw ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_hacksaw" );
  cmn.CallEventHandler( "get_hacksaw" );

end;
--------------------------------------------------------------------------------------------
function private.get_frozenprecookedfood ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_frozenprecookedfood" );
  cmn.CallEventHandler( "get_frozenprecookedfood" );

  if ( cmn.IsGetCollect2( "get_collect2_item_4_4" ) ) then

    common.CloseSubRoom();  

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_phoenixfigure ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_phoenixfigure" );
  cmn.CallEventHandler( "get_phoenixfigure" );
  common.CloseSubRoom();  

end;
--------------------------------------------------------------------------------------------
function private.get_grilledmeat ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_grilledmeat" );
  cmn.CallEventHandler( "get_grilledmeat" );

end;
--------------------------------------------------------------------------------------------
function private.get_hacksawhandle ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_hacksawhandle" );
  cmn.CallEventHandler( "get_hacksawhandle" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_4_4 ()

  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_4_4" ); 

    if ( cmn.IsEventDone( "get_frozenprecookedfood" ) ) then

      common.CloseSubRoom();

    end;

  end;

  common_impl.PlayEffectHO( "spr_collect2_item_4_4", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_4_4" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************

function private.clk_wagonkey_1 ()

  cmn.CallEventHandler( "clk_wagonkey_1_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_wagonkey_1" );
    cmn.CallEventHandler( "clk_wagonkey_1_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_key_car", 0, "", 0 );

  ObjAnimate( "spr_zz_wagon_door1", "alp",0,0, func_end, { 0, 2, 1,    0.6, 2, 0 } );

end;

--------------------------------------------------------------------------------------------

function private.clk_wagonkey_2 ()

  cmn.CallEventHandler( "clk_wagonkey_2_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_wagonkey_2" );
    cmn.CallEventHandler( "clk_wagonkey_2_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_door_car", 0, "", 0 );

  ObjAnimate( "spr_zz_wagon_door2", "alp",0,0, func_end, { 0, 2, 1,    0.6, 2, 0 } );

end;

--------------------------------------------------------------------------------------------

function private.clk_hacksawhandle_1 ()

  cmn.CallEventHandler( "clk_hacksawhandle_1_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_hacksawhandle_1" );
    cmn.CallEventHandler( "clk_hacksawhandle_1_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

  ObjAnimate( "spr_wagon_hacksaw", "ang",0,0, func_end, { 0, 0, 0,    0.4, 0, 0.2 } );

end;

--------------------------------------------------------------------------------------------

function private.clk_hacksawhandle_2 ()

  cmn.CallEventHandler( "clk_hacksawhandle_2_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_hacksawhandle_2" );
    cmn.CallEventHandler( "clk_hacksawhandle_2_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

  ObjAnimate( "spr_wagon_hacksaw", "ang",0,0, func_end, { 0, 0, 0.2,    0.6, 0, -0.2 } );

end;


--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG GRILL *** () end;
--*********************************************************************************************************************
  function private.InitGrillStart ()

    ng_global.progress.ext[ "win_grill" ].state = 
    {
      arrow_state = 127,
      arrow_speed = 18,
      sausage_state = 0
    };
    cmn.MiniGameShow( "grill" );
    common_impl.PassingMgStart( "grill" );

    private.ArrowAnimation( true );

  end;
  --------------------------------------------------------------------------------------------
  function private.InitGrill ()

    private.arrow_speed = 18;
    private.left_x = 82;
    private.right_x = 192;
    private.max_x = 227;
    private.min_x = 51;
    private.win_time = 15;

    ObjMultiSet( { 
      { "obj_grill_clk_button_1", { event_mdown = function () private.ClkButton( - math.random( 8, 21 ) ); end } },
      { "obj_grill_clk_button_2", { event_mdown = function () private.ClkButton( math.random( 8, 21 ) ); end } },
    } );    

  end;
  --------------------------------------------------------------------------------------------
  function private.ArrowAnimation ( first_run )

    local old_x = ObjGet( "spr_grill_arrow" ).pos_x;
    local old_alp = ObjGet( "spr_grill_sausage_ready" ).alp;

    if ( not first_run ) then

      if ( old_x < private.left_x ) or ( old_x > private.right_x ) then

        private.LoseGrill();
        return;

      end;

      if ( old_alp == 1 ) then

        private.WinGrill();
        return;

      end;

      private.SaveValues();

    end;

    local tme = 0.3;
    local new_x = math.min( private.arrow_speed * tme + old_x, private.max_x );
    new_x = math.max( new_x, private.min_x );
  
    ObjAnimate( "spr_grill_arrow", "pos_x", 0, 0, function () private.ArrowAnimation() end, 
    {  
      0,   0, old_x,
      tme, 0, new_x
    } );

    local alp_speed = tme / private.win_time;
    local new_alp = math.min( old_alp + alp_speed, 1 );

    ObjAnimate( "spr_grill_sausage_ready", "alp", 0, 0, "", 
    {  
      0,   0, old_alp,
      tme, 0, new_alp
    } );

  end;
  --------------------------------------------------------------------------------------------
  function private.ClkButton ( value )

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_button", 0, "", 0 );

    ObjStopAnimate( "spr_grill_arrow", "pos_x" );
    ObjStopAnimate( "spr_grill_sausage_ready", "alp" );

    private.arrow_speed = private.arrow_speed + value;

    private.ArrowAnimation();
  
  end;
  --------------------------------------------------------------------------------------------
  function private.SaveValues ()

    ng_global.progress.ext[ "win_grill" ].state.arrow_speed   = private.arrow_speed;
    ng_global.progress.ext[ "win_grill" ].state.arrow_state   = ObjGet( "spr_grill_arrow" ).pos_x;
    ng_global.progress.ext[ "win_grill" ].state.sausage_state = ObjGet( "spr_grill_sausage_ready" ).alp;
  
  end;
  --------------------------------------------------------------------------------------------
  function private.LoseGrill () 

    ObjStopAnimate( "spr_grill_arrow", "pos_x" );
    ObjStopAnimate( "spr_grill_sausage_ready", "alp" );

    cmn.Lock( true );

    local func_end = function ()

      private.arrow_speed = 18;
      ng_global.progress.ext[ "win_grill" ].state = 
      {
        arrow_state = 127,
        arrow_speed = 18,
        sausage_state = 0
      };

      private.ArrowAnimation( true );

      cmn.Lock( false );

    end;

    local func_reset = function ()

      ObjAnimate( "spr_grill_sausage_used", "alp", 0, 0, func_end, { 0, 0, 1, 0.3, 0, 0, 0.6, 0, 1 } );
      ObjAnimate( "spr_grill_sausage_fail", "alp", 0, 0, "", { 0, 0, 1, 0.3, 0, 1, 0.3, 0, 0 } );
      ObjAnimate( "spr_grill_sausage_ready", "alp", 0, 0, "", 
      { 
        0, 0, ObjGet( "spr_grill_sausage_ready" ).alp, 
        0.3, 0, ObjGet( "spr_grill_sausage_ready" ).alp, 
        0.3, 0, 0 
      } );

      local use_sausage = math.random( 1, 3 );
      ObjAnimate( "spr_grill_sausage_"..use_sausage, "alp", 0, 0, "", { 0, 0, 1, 0.3, 0, 1, 0.6, 0, 0, 1.2, 0, 0, 1.4, 0, 1 } );
      ObjAnimate( "spr_grill_sausage_"..use_sausage.."_shadow", "alp", 0, 0, "", { 0, 0, 1, 0.3, 0, 1, 0.6, 0, 0, 1.2, 0, 0, 1.4, 0, 1 } );

    end;

    ObjAnimate( "spr_grill_arrow", "pos_x", 0, 0, "", 
    {  
      0, 0, ObjGet( "spr_grill_arrow" ).pos_x,
      0.3, 3, 127
    } );

    ObjAnimate( "spr_grill_sausage_fail", "alp", 0, 0, func_reset, { 0, 0, 0, 0.3, 0, 1 } );

  end;
  --------------------------------------------------------------------------------------------
  function private.WinGrill ()

    cmn.Lock( false );  
  
    ObjStopAnimate( "spr_grill_arrow", "pos_x" );
    ObjStopAnimate( "spr_grill_sausage_ready", "alp" );

    cmn.MiniGameHide( "grill" );
    common_impl.PassingMgWin( "grill" );
    cmn.SetEventDone( "win_grill" );
    cmn.CallEventHandler( "win_grill" );    

  end;
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_nearcafe ()

  if not ( cmn.IsEventDone( "opn_nearcafe" ) ) then

    cmn.SetEventDone( "opn_nearcafe" );
    common_impl.ShowBbt( "bbt_nearcafe_opn_nearcafe" );

    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "enter_diner" );

  end;

  cmn.CallEventHandler( "opn_nearcafe" ); 

end;


--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************

function private.CafedoorClickDog ()

  common_impl.ShowBbt( "bbt_cafedoor_use_grilledmeat" );

  local func_end = function ()

    cmn.Lock( false ); 

    ObjSet( "anm_zz_cafedoor_dog_growl", { alp = 0 } );
    AnimStop( "anm_zz_cafedoor_dog_growl" );

    ObjSet( "anm_zz_cafedoor_dog_sitting", { alp = 1 } );
    AnimPlay( "anm_zz_cafedoor_dog_sitting", "DoAnim", "" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_dog", 0, "", 0 );

  ObjSet( "anm_zz_cafedoor_dog_sitting", { alp = 0 } );
  AnimStop( "anm_zz_cafedoor_dog_sitting" );

  ObjSet( "anm_zz_cafedoor_dog_growl", { alp = 1 } );
  AnimPlay( "anm_zz_cafedoor_dog_growl", "func_1581", func_end );

end;

--------------------------------------------------------------------------------------------

function private.WagonClickHackSaw ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( "bbt_wagon_use_hacksawhandle" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

  ObjAnimate( "spr_wagon_hacksaw", "ang",0,0, func_end, 
  { 
    0.0, 0, 0,    
    0.2, 0, 0.1,    
    0.5, 0, -0.1,    
    0.7, 0, 0.05,    
    0.8, 0, 0 
  } );

end;
--------------------------------------------------------------------------------------------
function private.UseStonewings ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_grill_use_stonewings' );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_gear", 0, "", 0 );

  ObjAnimate( "spr_grill_cover", "pos_xy", 0, 0, func_end, 
  { 
    0.00, 0, ObjGet( "spr_grill_cover" ).pos_x,       ObjGet( "spr_grill_cover" ).pos_y,   
    0.25, 0, ObjGet( "spr_grill_cover" ).pos_x - 3.0, ObjGet( "spr_grill_cover" ).pos_y + 3.0,    
    0.50, 0, ObjGet( "spr_grill_cover" ).pos_x,       ObjGet( "spr_grill_cover" ).pos_y,   
  } );

end;
--------------------------------------------------------------------------------------------



