-- name=rm_parkinglot
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_parkinglot";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_bush", "room_hub" );
  ObjAttach( "zz_postmanthings", "room_hub" );
  ObjAttach( "zz_billboard", "room_hub" );
  ObjAttach( "zz_instantlottery", "room_hub" );
  private.Init_Subroom();
  private.Init_Animation();

  ObjMultiSet( { 
    { "spr_bush_postmankey",                    { event_mdown = private.get_postmankey    } },
    { "spr_bush_letter_t",                      { event_mdown = private.get_letter_t      } },
    { "spr_bush_foldumbrella",                  { event_mdown = private.get_foldumbrella  } },
    { "spr_postmanthings_letter",               { event_mdown = private.get_letter        } },
    { "spr_postmanthings_internaldisk",         { event_mdown = private.get_internaldisk  } },
    { "spr_postmanthings_clip",                 { event_mdown = private.get_clip          } },
    { "spr_billboard_taxinumber",               { event_mdown = private.get_taxinumber    } },
    { "spr_billboard_coin_ext",                 { event_mdown = private.get_coin_ext      } },
    { "spr_instantlottery_cash",                { event_mdown = private.get_cash          } },
    { "obj_billboard_use_oilcan_ext_2",         { event_mdown = private.UseOilcan_ext_2   } },
    { "obj_billboard_taxinumber_1",             { event_mdown = private.get_taxinumber_1  } },
    { "obj_billboard_taxinumber_2",             { event_mdown = private.get_taxinumber_2  } },
    { "obj_billboard_clk_taxinumber",           { event_mdown = private.clk_taxinumber    } },
    { "obj_bush_clk_postmankey",                { event_mdown = private.clk_postmankey    } },
    { "obj_bush_use_externaldisk",              { event_mdown = private.UseExternaldisk   } },
    { "obj_bush_use_internaldisk",              { event_mdown = private.UseInternaldisk   } },
    { "spr_instantlottery_lever_handle",        { event_mdown = private.clk_lever_match_3 } },
    { "obj_postmanthings_clk_clip_1",           { event_mdown = private.clk_clip_1        } },
    { "obj_postmanthings_clk_clip_2",           { event_mdown = private.clk_clip_2        } },
    { "spr_postmanthings_paper",                { event_mdown = private.ClkPaper          } },
    { "spr_postmanthings_paper_big",            { event_mdown = private.ClkPaperBig       } },
    { "obj_postmanthings_use_letter_i",         { event_mdown = private.UseLetter_I       } },
    { "obj_postmanthings_use_letter_t",         { event_mdown = private.UseLetter_T       } },
    { "obj_postmanthings_clk_postmankey2",      { event_mdown = private.clk_postmankey2   } },
    { "obj_parkinglot_clk_pigeon",              { event_mdown = private.clk_pigeon        } },
    { "obj_postmanthings_use_postmankey",       { event_mdown = private.UsePostmankey     } },
    { "obj_billboard_use_corn",                 { event_mdown = private.ClkBird           } },
    { "spr_parkinglot_collect_morph_item",      { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_4_4" ); end } },
  } );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_parkinglot = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "grm_parkinglot_apartment",
      "grm_parkinglot_porch_ext",
      "gzz_parkinglot_bush",
      "gzz_parkinglot_postmanthings", 
      "gzz_parkinglot_billboard",
      "gzz_parkinglot_instantlottery",
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_bush",
      "zz_postmanthings",
      "zz_billboard",
      "zz_instantlottery",
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_parkinglot", update_game_mode_parkinglot, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_parkinglot = function ()

  local effects_table = 
  {
    "obj_parkinglot_anim",
    "tmr_parkinglot_pigeon_fly",
    "anm_parkinglot_pigeon_fly",
    "spr_parkinglot_light_taxi", 
    "spr_parkinglot_light_1",
    "anm_parkinglot_all",
    "anm_bush_light",
  };

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_parkinglot", update_performance_mode_parkinglot, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_parkinglot () end;
  --------------------------------------------------------------------------------------------
  local opn_parkinglot_map = function ()

    common_impl.VisitMapRoom( "parkinglot" );

  end;
  cmn.AddSubscriber( "opn_parkinglot", opn_parkinglot_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_postmankey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_postmankey" ] = {
    type = "get",
    get_obj = "spr_bush_postmankey",
    room = private.room_objname,
    zz = "zz_bush",
    zz_gate = "gzz_parkinglot_bush"
  };
  
  local get_postmankey_inv = function ()
  
    interface.InventoryItemAdd( "inv_postmankey", "spr_bush_postmankey" );
  
  end;
  
  local get_postmankey_closezz = function ()
  
    ObjDelete( "gfx_bush_postmankey" );
    ObjDelete( "spr_bush_key_shadow" );

    if ( cmn.IsEventDone( "get_foldumbrella" ) and  
      cmn.IsEventDone( "get_letter_t" ) ) then

      ObjDelete( "gzz_parkinglot_bush" );    

    end;
  
  end;
  
  cmn.AddSubscriber( "get_postmankey", get_postmankey_inv );
  cmn.AddSubscriber( "get_postmankey", get_postmankey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_letter_t () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_letter_t" ] = {
    type = "get",
    get_obj = "spr_bush_letter_t",
    room = private.room_objname,
    zz = "zz_bush",
    zz_gate = "gzz_parkinglot_bush"
  };
  
  local get_letter_t_inv = function ()
  
    interface.InventoryItemAdd( "inv_letter_t", "spr_bush_letter_t" );
  
  end;
  
  local get_letter_t_closezz = function ()
  
    ObjDelete( "gfx_bush_letter_t" );
    ObjDelete( "spr_bush_letter_t_shadow" );

    if ( cmn.IsEventDone( "get_foldumbrella" ) and  
      cmn.IsEventDone( "get_postmankey" ) ) then

      ObjDelete( "gzz_parkinglot_bush" );    

    end;
  
  end;
  
  cmn.AddSubscriber( "get_letter_t", get_letter_t_inv );
  cmn.AddSubscriber( "get_letter_t", get_letter_t_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_foldumbrella () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_foldumbrella" ] = {
    type = "get",
    get_obj = "spr_bush_foldumbrella",
    room = private.room_objname,
    zz = "zz_bush",
    zz_gate = "gzz_parkinglot_bush"
  };
  
  local get_foldumbrella_inv = function ()
  
    interface.InventoryItemAdd( "inv_foldumbrella", "spr_bush_foldumbrella" );
  
  end;
  
  local get_foldumbrella_closezz = function ()
  
    ObjDelete( "gfx_bush_foldumbrella" );
    ObjDelete( "spr_bush_foldumbrella_shadow" );

    if ( cmn.IsEventDone( "get_letter_t" ) and  
      cmn.IsEventDone( "get_postmankey" ) ) then

      ObjDelete( "gzz_parkinglot_bush" );    

    end;
  
  end;
  
  cmn.AddSubscriber( "get_foldumbrella", get_foldumbrella_inv );
  cmn.AddSubscriber( "get_foldumbrella", get_foldumbrella_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_letter () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_letter" ] = {
    type = "get",
    get_obj = "spr_postmanthings_letter",
    room = private.room_objname,
    zz = "zz_postmanthings",
    zz_gate = "gzz_parkinglot_postmanthings"
  };
  
  local get_letter_inv = function ()
  
    interface.InventoryItemAdd( "inv_letter", "spr_postmanthings_letter" );
    ObjSet( "inv_letter", { drag = false } );  

    cmn.SetInvPlusRGB( "letter", false );  
    if ( cmn.IsEventDone( "get_envelopeknife" ) ) then

      cmn.SetInvPlusRGB( "letter", true );  

    end;        
      
  end;
  
  local get_letter_closezz = function ()
  
    ObjDelete( "gfx_postmanthings_letter" );

    if ( cmn.IsEventDone( "get_internaldisk" ) and  
      cmn.IsEventDone( "get_clip" ) ) then

      ObjDelete( "gzz_parkinglot_postmanthings" );    

    end;  

  end;
  
  cmn.AddSubscriber( "get_letter", get_letter_inv );
  cmn.AddSubscriber( "get_letter", get_letter_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_internaldisk () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_internaldisk" ] = {
    type = "get",
    get_obj = "spr_postmanthings_internaldisk",
    room = private.room_objname,
    zz = "zz_postmanthings",
    zz_gate = "gzz_parkinglot_postmanthings"
  };
  
  local get_internaldisk_inv = function ()
  
    interface.InventoryItemAdd( "inv_internaldisk", "spr_postmanthings_internaldisk" );
  
  end;
  
  local get_internaldisk_closezz = function ()
  
    ObjDelete( "gfx_postmanthings_internaldisk" );

    if ( cmn.IsEventDone( "get_letter" ) and  
      cmn.IsEventDone( "get_clip" ) ) then

      ObjDelete( "gzz_parkinglot_postmanthings" );    

    end; 
  
  end;
  
  cmn.AddSubscriber( "get_internaldisk", get_internaldisk_inv );
  cmn.AddSubscriber( "get_internaldisk", get_internaldisk_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_clip () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_clip" ] = {
    type = "get",
    get_obj = "obj_postmanthings_paper_hint",
    room = private.room_objname,
    zz = "zz_postmanthings",
    zz_gate = "gzz_parkinglot_postmanthings"
  };
  
  local get_clip_inv = function ()
  
    interface.InventoryItemAdd( "inv_clip", "spr_postmanthings_clip" );
  
  end;
  
  local get_clip_closezz = function ()
  
    ObjDelete( "gfx_postmanthings_clip" );
    ObjDelete( "obj_postmanthings_paper_hint" );
    ObjDelete( "spr_postmanthings_clip_shadow" );
    ObjDelete( "spr_postmanthings_clip4" );
    ObjSet( "spr_postmanthings_paper", { input = false } );

    if ( cmn.IsEventDone( "get_letter" ) and  
      cmn.IsEventDone( "get_internaldisk" ) ) then

      ObjDelete( "gzz_parkinglot_postmanthings" );    

    end;
  
  end;
  
  cmn.AddSubscriber( "get_clip", get_clip_inv );
  cmn.AddSubscriber( "get_clip", get_clip_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_taxinumber () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_taxinumber" ] = {
    type = "get",
    get_obj = "spr_billboard_taxinumber",
    room = private.room_objname,
    zz = "zz_billboard",
    zz_gate = "gzz_parkinglot_billboard"
  };
  
  local get_taxinumber_inv = function ()
  
    interface.InventoryItemAdd( "inv_taxinumber", "spr_billboard_taxinumber_2" );
  
  end;
  
  local get_taxinumber_closezz = function ()
  
    ObjDelete( "gfx_billboard_taxinumber" );
    ObjDelete( "spr_billboard_taxinumber" );
    ObjDelete( "spr_billboard_taxinumber_1" );
    ObjDelete( "spr_parkinglot_billboard_2" );

    if ( cmn.IsEventDone( "get_coin_ext" ) ) then

      ObjDelete( "gzz_parkinglot_billboard" );

    end;   

  end;
  
  cmn.AddSubscriber( "get_taxinumber", get_taxinumber_inv );
  cmn.AddSubscriber( "get_taxinumber", get_taxinumber_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coin_ext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_coin_ext" ] = {
    type = "get",
    get_obj = "spr_billboard_coin_ext",
    room = private.room_objname,
    zz = "zz_billboard",
    zz_gate = "gzz_parkinglot_billboard"
  };
  
  local get_coin_ext_inv = function ()
  
    interface.InventoryItemAdd( "inv_coin_ext", "spr_billboard_coin_ext" );
  
  end;
  
  local get_coin_ext_closezz = function ()
  
    ObjDelete( "gfx_billboard_coin_ext" );

    if ( cmn.IsEventDone( "get_taxinumber" ) ) then

      ObjDelete( "gzz_parkinglot_billboard" );

    end;  

  end;
  
  cmn.AddSubscriber( "get_coin_ext", get_coin_ext_inv );
  cmn.AddSubscriber( "get_coin_ext", get_coin_ext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cash () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cash" ] = {
    type = "get",
    get_obj = "spr_instantlottery_cash",
    room = private.room_objname,
    zz = "zz_instantlottery",
    zz_gate = "gzz_parkinglot_instantlottery"
  };
  
  local get_cash_inv = function ()
  
    interface.InventoryItemAdd( "inv_cash", "spr_instantlottery_cash" );
  
  end;
  
  local get_cash_closezz = function ()
  
    ObjDelete( "gzz_parkinglot_instantlottery" );
    ObjDelete( "gfx_instantlottery_cash" );
    ObjDelete( "spr_instantlottery_money_shadow" );

  end;
  
  cmn.AddSubscriber( "get_cash", get_cash_inv );
  cmn.AddSubscriber( "get_cash", get_cash_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_4_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_4_4 = function ()
  
    ObjDelete( "obj_parkinglot_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_4_4", get_collect_morph_item_4_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_externaldisk () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_externaldisk" ] = {
    type = "use",
    inv_obj = "inv_externaldisk",
    use_place = "obj_bush_use_externaldisk",
    room = private.room_objname,
    zz = "zz_bush",
    zz_gate = "gzz_parkinglot_bush"
  };
  local use_externaldisk_inv = function ()
  
    interface.InventoryItemRemove( "inv_externaldisk" );
  
  end;
  local use_externaldisk_beg = function ()
  
    ObjDelete( "obj_bush_use_externaldisk" );
  
  end;
  local use_externaldisk_end = function ()

    ObjMultiSet( { 
      { "spr_bush_beetle1",     { alp = 1               } },
      { "spr_bush_letter_t",    { input = true, alp = 1 } },
      { "obj_bush_box_1",       { pos_x = 0, pos_y = 0, pos_z = 6 } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_externaldisk", use_externaldisk_beg, private.room_objname );
  cmn.AddSubscriber( "use_externaldisk", use_externaldisk_inv );
  cmn.AddSubscriber( "use_externaldisk", use_externaldisk_end, private.room_objname );
  cmn.AddSubscriber( "use_externaldisk_inv", use_externaldisk_inv, private.room_objname );
  cmn.AddSubscriber( "use_externaldisk_beg", use_externaldisk_beg, private.room_objname );
  cmn.AddSubscriber( "use_externaldisk_end", use_externaldisk_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_internaldisk () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_internaldisk" ] = {
    type = "use",
    inv_obj = "inv_internaldisk",
    use_place = "obj_bush_use_internaldisk",
    room = private.room_objname,
    zz = "zz_bush",
    zz_gate = "gzz_parkinglot_bush"
  };
  local use_internaldisk_inv = function ()
  
    interface.InventoryItemRemove( "inv_internaldisk" );
  
  end;
  local use_internaldisk_beg = function ()
  
    ObjDelete( "obj_bush_use_internaldisk" );
  
  end;
  local use_internaldisk_end = function ()
  
    ObjMultiSet( { 
      { "spr_bush_beetle2",         { alp = 1               } },
      { "spr_bush_foldumbrella",    { input = true, alp = 1 } },
      { "obj_bush_box_2",           { pos_x = 0, pos_y = 0, pos_z = 5 } },
    } );
    ObjDelete( "spr_bush_box_patch" );  

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_internaldisk", use_internaldisk_beg, private.room_objname );
  cmn.AddSubscriber( "use_internaldisk", use_internaldisk_inv );
  cmn.AddSubscriber( "use_internaldisk", use_internaldisk_end, private.room_objname );
  cmn.AddSubscriber( "use_internaldisk_inv", use_internaldisk_inv, private.room_objname );
  cmn.AddSubscriber( "use_internaldisk_beg", use_internaldisk_beg, private.room_objname );
  cmn.AddSubscriber( "use_internaldisk_end", use_internaldisk_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_letter_i () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_letter_i" ] = {
    type = "use",
    inv_obj = "inv_letter_i",
    use_place = "obj_postmanthings_use_letter_i",
    room = private.room_objname,
    zz = "zz_postmanthings",
    zz_gate = "gzz_parkinglot_postmanthings"
  };
  local use_letter_i_inv = function ()
  
    interface.InventoryItemRemove( "inv_letter_i" );
  
  end;
  local use_letter_i_beg = function ()
  
    ObjDelete( "obj_postmanthings_use_letter_i" );
  
  end;
  local use_letter_i_end = function ()

    ObjMultiSet( {
      { "spr_postmanthings_cover_i",          { pos_x = 320, pos_y = -238 } }, 
      { "spr_postmanthings_letter_i",         { alp = 1 } },
      { "spr_postmanthings_internaldisk",     { input = true, alp = 1 } },
      { "gfx_postmanthings_internaldisk",     { active = true } },
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_letter_i", use_letter_i_beg, private.room_objname );
  cmn.AddSubscriber( "use_letter_i", use_letter_i_inv );
  cmn.AddSubscriber( "use_letter_i", use_letter_i_end, private.room_objname );
  cmn.AddSubscriber( "use_letter_i_inv", use_letter_i_inv, private.room_objname );
  cmn.AddSubscriber( "use_letter_i_beg", use_letter_i_beg, private.room_objname );
  cmn.AddSubscriber( "use_letter_i_end", use_letter_i_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_postmankey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_postmankey" ] = {
    type = "use",
    inv_obj = "inv_postmankey",
    use_place = "obj_postmanthings_use_postmankey",
    room = private.room_objname,
    zz = "zz_postmanthings",
    zz_gate = "gzz_parkinglot_postmanthings"
  };
  local use_postmankey_inv = function ()
  
    interface.InventoryItemRemove( "inv_postmankey" );
  
  end;
  local use_postmankey_beg = function ()
  
    ObjDelete( "obj_postmanthings_use_postmankey" );
  
  end;
  local use_postmankey_end = function ()
  
    ObjSet( "obj_postmanthings_clk_postmankey2",  { input = true, alp = 1 } );
    ObjSet( "spr_postmanthings_key",              { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_postmankey", use_postmankey_beg, private.room_objname );
  cmn.AddSubscriber( "use_postmankey", use_postmankey_inv );
  cmn.AddSubscriber( "use_postmankey", use_postmankey_end, private.room_objname );
  cmn.AddSubscriber( "use_postmankey_inv", use_postmankey_inv, private.room_objname );
  cmn.AddSubscriber( "use_postmankey_beg", use_postmankey_beg, private.room_objname );
  cmn.AddSubscriber( "use_postmankey_end", use_postmankey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_letter_t () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_letter_t" ] = {
    type = "use",
    inv_obj = "inv_letter_t",
    use_place = "obj_postmanthings_use_letter_t",
    room = private.room_objname,
    zz = "zz_postmanthings",
    zz_gate = "gzz_parkinglot_postmanthings"
  };
  local use_letter_t_inv = function ()
  
    interface.InventoryItemRemove( "inv_letter_t" );
  
  end;
  local use_letter_t_beg = function ()
  
    ObjDelete( "obj_postmanthings_use_letter_t" );
  
  end;
  local use_letter_t_end = function ()

    ObjMultiSet( { 
      { "spr_postmanthings_letter_t",     { alp = 1                   } },
      { "spr_postmanthings_cover_t",      { pos_x = -115, pos_y = -66 } },
      { "spr_postmanthings_paper",        { input = true, alp = 1     } },
      { "spr_parkinglot_postmanthings_2", { alp = 1                   } },
    } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_letter_t", use_letter_t_beg, private.room_objname );
  cmn.AddSubscriber( "use_letter_t", use_letter_t_inv );
  cmn.AddSubscriber( "use_letter_t", use_letter_t_end, private.room_objname );
  cmn.AddSubscriber( "use_letter_t_inv", use_letter_t_inv, private.room_objname );
  cmn.AddSubscriber( "use_letter_t_beg", use_letter_t_beg, private.room_objname );
  cmn.AddSubscriber( "use_letter_t_end", use_letter_t_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_corn () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_corn" ] = {
    type = "use",
    inv_obj = "inv_corn",
    use_place = "obj_billboard_use_corn",
    room = private.room_objname,
    zz = "zz_billboard",
    zz_gate = "gzz_parkinglot_billboard"
  };
  local use_corn_inv = function ()
  
    interface.InventoryItemRemove( "inv_corn" );
  
  end;
  local use_corn_beg = function ()
  
    ObjDelete( "obj_billboard_use_corn" );
  
  end;
  local use_corn_end = function ()

    ObjMultiSet( { 
      { "spr_billboard_coin_ext",       { input = true, alp = 1, pos_x = 135, pos_y = -16   } },
      { "gfx_billboard_coin_ext",       { active = true                                     } },
      { "anm_billboard_bird_no_coin",   { alp = 1, playing = true                           } },
      { "anm_parkinglot_billboard_bird_no_coin",   { alp = 1, playing = true                } },
    } );
    ObjDelete( "anm_billboard_bird_feed" );
    ObjDelete( "anm_billboard_bird_with_coin" );
    ObjDelete( "anm_parkinglot_billboard_bird_with_coin" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_corn", use_corn_beg, private.room_objname );
  cmn.AddSubscriber( "use_corn", use_corn_inv );
  cmn.AddSubscriber( "use_corn", use_corn_end, private.room_objname );
  cmn.AddSubscriber( "use_corn_inv", use_corn_inv, private.room_objname );
  cmn.AddSubscriber( "use_corn_beg", use_corn_beg, private.room_objname );
  cmn.AddSubscriber( "use_corn_end", use_corn_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_oilcan_ext_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_oilcan_ext_2" ] = {
    type = "use",
    inv_obj = "inv_oilcan_ext",
    use_place = "obj_billboard_use_oilcan_ext_2",
    room = private.room_objname,
    zz = "zz_billboard",
    zz_gate = "gzz_parkinglot_billboard"
  };
  local use_oilcan_ext_2_inv = function ()

    if ( cmn.IsEventDone( "use_oilcan_ext_1" ) ) then

      interface.InventoryItemRemove( "inv_oilcan_ext" );

    end;
  
  end;
  local use_oilcan_ext_2_beg = function ()
  
    ObjDelete( "obj_billboard_use_oilcan_ext_2" );
  
  end;
  local use_oilcan_ext_2_end = function ()

    ObjMultiSet( { 
      { "spr_billboard_hand_2",         { alp = 1       } },
      { "obj_billboard_clk_taxinumber", { input = true  } },
      { "spr_parkinglot_billboard_3",   { alp = 1       } },
    } );

    ObjDelete( "vid_billboard_oil" );
    ObjDelete( "spr_billboard_hand_1" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_oilcan_ext_2", use_oilcan_ext_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_oilcan_ext_2", use_oilcan_ext_2_inv );
  cmn.AddSubscriber( "use_oilcan_ext_2", use_oilcan_ext_2_end, private.room_objname );
  cmn.AddSubscriber( "use_oilcan_ext_2_inv", use_oilcan_ext_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_oilcan_ext_2_beg", use_oilcan_ext_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_oilcan_ext_2_end", use_oilcan_ext_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_coin_ext_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_coin_ext_1" ] = {
    type = "use",
    inv_obj = "inv_coin_ext",
    use_place = "obj_instantlottery_use_coin_ext_1",
    room = private.room_objname,
    zz = "zz_instantlottery",
    zz_gate = "gzz_parkinglot_instantlottery"
  };
  local use_coin_ext_1_inv = function ()

    interface.InventoryItemRemove( "inv_coin_ext" );  

  end;
  local use_coin_ext_1_beg = function ()
  
    ObjDelete( "obj_instantlottery_use_coin_ext_1" );
  
  end;
  local use_coin_ext_1_end = function ()

    ObjDelete( "spr_instantlottery_coin" );
    ObjDelete( "spr_instantlottery_coin_up_side" );
    ObjSet( "spr_instantlottery_lever_handle", { input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_coin_ext_1", use_coin_ext_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_coin_ext_1", use_coin_ext_1_inv );
  cmn.AddSubscriber( "use_coin_ext_1", use_coin_ext_1_end, private.room_objname );
  cmn.AddSubscriber( "use_coin_ext_1_inv", use_coin_ext_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_coin_ext_1_beg", use_coin_ext_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_coin_ext_1_end", use_coin_ext_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cash_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cash_1" ] = {
    type = "use",
    inv_obj = "inv_cash",
    use_place = "obj_parkinglot_use_cash_1",
    room = private.room_objname,
  };
  local use_cash_1_inv = function ()
  
    --interface.InventoryItemRemove( "inv_cash" );
  
  end;
  local use_cash_1_beg = function ()
  
    ObjDelete( "obj_parkinglot_use_cash_1" );
  
  end;
  local use_cash_1_end = function ()

    if ( cmn.IsEventDone( "use_officeaddress" ) ) then

      ObjSet( "grm_parkinglot_porch_ext", { input = true, visible = true, active = true, alp = 1 } );
      if port.isPortable() == 1 then
          port.GrmEventLightOn("grm_parkinglot_porch_ext_focus");
      end;
      ObjDelete( "obj_parkinglot_taxi_bbt" );

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cash_1", use_cash_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_cash_1", use_cash_1_inv );
  cmn.AddSubscriber( "use_cash_1", use_cash_1_end, private.room_objname );
  cmn.AddSubscriber( "use_cash_1_inv", use_cash_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_cash_1_beg", use_cash_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_cash_1_end", use_cash_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_officeaddress () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_officeaddress" ] = {
    type = "use",
    inv_obj = "inv_officeaddress",
    use_place = "obj_parkinglot_use_officeaddress",
    room = private.room_objname,
  };
  local use_officeaddress_inv = function ()
  
    interface.InventoryItemRemove( "inv_officeaddress" );
  
  end;
  local use_officeaddress_beg = function ()
  
    ObjDelete( "obj_parkinglot_use_officeaddress" );
  
  end;
  local use_officeaddress_end = function ()
  
    if ( cmn.IsEventDone( "use_cash_1" ) ) then

      ObjSet( "grm_parkinglot_porch_ext", { input = true, visible = true, active = true, alp = 1 } );

      ObjDelete( "obj_parkinglot_taxi_bbt" );

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_officeaddress", use_officeaddress_beg, private.room_objname );
  cmn.AddSubscriber( "use_officeaddress", use_officeaddress_inv );
  cmn.AddSubscriber( "use_officeaddress", use_officeaddress_end, private.room_objname );
  cmn.AddSubscriber( "use_officeaddress_inv", use_officeaddress_inv, private.room_objname );
  cmn.AddSubscriber( "use_officeaddress_beg", use_officeaddress_beg, private.room_objname );
  cmn.AddSubscriber( "use_officeaddress_end", use_officeaddress_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_taxinumber () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_taxinumber" ] = {
    type = "click",
    use_place = "obj_billboard_clk_taxinumber",
    room = private.room_objname,
    zz = "zz_billboard",
    zz_gate = "gzz_parkinglot_billboard",
  };
  local clk_taxinumber_beg = function ()

    ObjDelete( "obj_billboard_clk_taxinumber" );

  end;
  local clk_taxinumber_end = function ()

    ObjMultiSet( { 
      { "spr_billboard_taxinumber",     { alp = 1, input = true  } },
      { "spr_billboard_hand_2",         { ang = -0.65  } },
      { "spr_parkinglot_billboard_2",   { alp = 1 } },
      { "spr_billboard_hand_3",         { alp = 1 } },
    } );
    
    ObjDelete( "anm_billboard_hand" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_taxinumber", clk_taxinumber_beg, private.room_objname );
  cmn.AddSubscriber( "clk_taxinumber", clk_taxinumber_end, private.room_objname );
  cmn.AddSubscriber( "clk_taxinumber_beg", clk_taxinumber_beg, private.room_objname );
  cmn.AddSubscriber( "clk_taxinumber_end", clk_taxinumber_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_lever_match_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_lever_match_3" ] = {
    type = "click",
    use_place = "spr_instantlottery_lever_handle",
    room = private.room_objname,
    zz = "zz_instantlottery",
    zz_gate = "gzz_parkinglot_instantlottery",
  };
  local clk_lever_match_3 = function ()

    ObjMultiSet( { 
      { "spr_instantlottery_green_lamp_light", { alp = 1 } },
      { "spr_instantlottery_lever_handle", { pos_x = 255, pos_y = 39,  input = false  } },
      { "obj_instantlottery_crop", { input = true, alp = 1 } },
    } );

    ObjDelete( "spr_instantlottery_text" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_lever_match_3", clk_lever_match_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_postmankey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_postmankey" ] = {
    type = "click",
    use_place = "obj_bush_clk_postmankey",
    room = private.room_objname,
    zz = "zz_bush",
    zz_gate = "gzz_parkinglot_bush"
  };
  local clk_postmankey_beg = function ()

    ObjDelete( "obj_bush_clk_postmankey" );

  end;
  local clk_postmankey_end = function ()

    ObjMultiSet( { 
      { "spr_bush_postmankey",              { alp = 1, input = true  } },
      { "spr_bush_bush_3",                  { pos_x = 266, pos_y = 47, ang = -1.1 } }
    } );
   
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_postmankey", clk_postmankey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_postmankey", clk_postmankey_end, private.room_objname );
  cmn.AddSubscriber( "clk_postmankey_beg", clk_postmankey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_postmankey_end", clk_postmankey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_clip_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_clip_1" ] = {
    type = "click",
    use_place = "obj_postmanthings_paper_hint",
    room = private.room_objname,
    zz = "zz_postmanthings",
    zz_gate = "gzz_parkinglot_postmanthings"
  };
  local clk_clip_1_beg = function ()

    ObjDelete( "obj_postmanthings_clk_clip_1" );

  end;
  local clk_clip_1_end = function ()

    ObjMultiSet( { 
      { "spr_postmanthings_clip",          { pos_x = -111, pos_y = -107 } },
      { "obj_postmanthings_clk_clip_2",    { input = true } },
    } );
   
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_clip_1", clk_clip_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_clip_1", clk_clip_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_clip_1_beg", clk_clip_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_clip_1_end", clk_clip_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_clip_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_clip_2" ] = {
    type = "click",
    use_place = "obj_postmanthings_paper_hint",
    room = private.room_objname,
    zz = "zz_postmanthings",
    zz_gate = "gzz_parkinglot_postmanthings"
  };
  local clk_clip_2_beg = function ()

    ObjDelete( "obj_postmanthings_clk_clip_2" );

  end;
  local clk_clip_2_end = function ()

    ObjMultiSet( { 
      { "spr_postmanthings_clip3",          { alp = 1  } },
      { "gfx_postmanthings_clip",           { active = true } },
      { "spr_postmanthings_clip",           { input = true } },
    } );
   ObjDelete( "spr_postmanthings_clip2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_clip_2", clk_clip_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_clip_2", clk_clip_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_clip_2_beg", clk_clip_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_clip_2_end", clk_clip_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_postmankey2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_postmankey2" ] = {
    type = "click",
    use_place = "obj_postmanthings_clk_postmankey2",
    room = private.room_objname,
    zz = "zz_postmanthings",
    zz_gate = "gzz_parkinglot_postmanthings"
  };
  local clk_postmankey2_beg = function ()

    ObjDelete( "obj_postmanthings_clk_postmankey2" );

  end;
  local clk_postmankey2_end = function ()

    ObjMultiSet( { 
      { "spr_postmanthings_letter", { input = true, alp = 1 } }, 
      { "gfx_postmanthings_letter", { active = true } },
      { "spr_parkinglot_postmanthings_1",   { alp = 1 } }
    } );
    ObjDelete( "spr_postmanthings_cover_bag" );
   
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_postmankey2", clk_postmankey2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_postmankey2", clk_postmankey2_end, private.room_objname );
  cmn.AddSubscriber( "clk_postmankey2_beg", clk_postmankey2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_postmankey2_end", clk_postmankey2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_match_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_match_3" ] =
  {
      type = "win",
      room = private.room_objname,
      zz = "zz_instantlottery",
      zz_gate = "gzz_parkinglot_instantlottery"
  };

  local win_match_3 = function ()

    if ( cmn.IsEventDone( "win_match_3" ) ) then
    
      ObjSet( "spr_instantlottery_red_lamp_light", { alp = 1 } );
      ObjSet( "spr_instantlottery_cash", { input = true, alp = 1 } );
      ObjDelete( "obj_instantlottery_crop" );
      ObjDelete( "obj_instantlottery_progrees_bar" );

    else

      private.Match3Init();
      private.match3.points = ng_global.progress[ "ext" ][ "win_match_3" ].match3.points;
      private.Match3ProgressBarInit();
      private.Match3Load();
      

    end;

  end;
  cmn.AddSubscriber( "win_match_3", win_match_3, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()

  --*********************************************************************************************************************
  -- function zz_billboard () end;
  --*********************************************************************************************************************
    subroom.Define( "zz_billboard" );
    function zz_billboard.PreOpen()
    end;
    -------------------------------------------------
    function zz_billboard.Open()
    end;
    -------------------------------------------------
    function zz_billboard.PreClose()
    end;
    -------------------------------------------------
    function zz_billboard.Close()

      if ( cmn.IsEventDone( "clk_taxinumber" ) and not cmn.IsEventDone( "get_taxinumber" ) ) then

        ObjMultiSet( { 
          { "spr_billboard_taxinumber",   { pos_x = 36, pos_y = 202, alp = 1, input = true } },
          { "spr_billboard_taxinumber_1", { scale_x = 0, scale_y = 0, input = false } },
          { "spr_billboard_taxinumber_2", { scale_x = 0, scale_y = 1, input = false } },
        } );  

      end;    

    end;
    -------------------------------------------------
  --*********************************************************************************************************************
  -- function zz_instantlottery () end;
  --*********************************************************************************************************************
    subroom.Define( "zz_instantlottery" );
    -------------------------------------------------
    function zz_instantlottery.PreOpen()

      if ( cmn.IsEventDone( "clk_lever_match_3" ) ) and ( not cmn.IsEventDone( "win_match_3" ) ) then

        cmn.MiniGameShow( "match_3" );
        common_impl.PassingMgStart( "match_3" );

      end; 

    end;
    -------------------------------------------------
    function zz_instantlottery.PreClose()

      if ( cmn.IsEventDone( "clk_lever_match_3" ) ) and ( not cmn.IsEventDone( "win_match_3" ) ) then

        cmn.MiniGameHide( "match_3" );
        common_impl.PassingMgStop( "match_3" );

      end;     

    end;
    -------------------------------------------------
    function zz_instantlottery.Skip ()

       private.WinMatch_3();

    end;
    -------------------------------------------------
    function zz_instantlottery.Reset ()

       private.Match3ResetSet();

    end;
    -------------------------------------------------
  --*********************************************************************************************************************
  -- function zz_postmanthings () end;
  --*********************************************************************************************************************
    subroom.Define( "zz_postmanthings" );
    function zz_postmanthings.PreOpen()
    end;
    -------------------------------------------------
    function zz_postmanthings.Open()
    end;
    -------------------------------------------------
    function zz_postmanthings.PreClose()
    end;
    -------------------------------------------------
    function zz_postmanthings.Close()

      if ( cmn.IsEventDone( "use_letter_t" ) and not cmn.IsEventDone( "get_clip" ) ) then

        cmn.NoteScaleClose( { "spr_postmanthings_paper" } );
        ObjSet( "obj_postmanthings_paper_hint", { pos_x = 3, pos_y = -147 } );

      end;  

    end;
    -------------------------------------------------
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_parkinglot();
  int_slider.InitSlider( private.room_objname );

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();

  common_impl.EnvPlay( { "levelext/env/aud_parkinglot_env" }, "", 0.5 );

  if ( not ng_global.progress[ "ext" ][ "opn_parkinglot" ].pigeon ) then

    ng_global.progress[ "ext" ][ "opn_parkinglot" ].pigeon = 0;

  elseif ( ng_global.progress[ "ext" ][ "opn_parkinglot" ].pigeon == 1 ) then 

    ObjDelete( "obj_parkinglot_clk_pigeon" );
    ObjDelete( "anm_parkinglot_pigeon_1" );
    ObjSet( "anm_parkinglot_pigeon_1_1", { alp = 1, playing = true } );

  end;

  if ( not cmn.IsEventDone( "use_taxinumber" ) ) then
    AnimPlay( "anm_parkinglot_pigeon_fly", "DoAnim", func_end );
    AnimStop( "anm_parkinglot_pigeon_fly", "DoAnim" );

    ObjSet( "tmr_parkinglot_pigeon_fly", 
    { 
      time = 3, playing = true, 
      endtrig = function() private.Pigeon_Fly_Animation() end 
    } );

  else 

    ObjSet( "obj_parkinglot_taxi_bbt", { input = true, visible = true, active = true } );

    AnimStop( "anm_parkinglot_pigeon_fly", "DoAnim" );
    ObjSet( "tmr_parkinglot_pigeon_fly", { playing = false } ); 
    ObjDelete( "anm_parkinglot_pigeon_fly" );
    ObjDelete( "tmr_parkinglot_pigeon_fly" );
    ng_global.progress[ "ext" ][ "opn_parkinglot" ].pigeon = 1
    ObjDelete( "obj_parkinglot_clk_pigeon" );
    ObjDelete( "anm_parkinglot_pigeon_1" );
    ObjSet( "anm_parkinglot_pigeon_1_1", { alp = 1, playing = true } );

  end;

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_externaldisk ()

  local item = "inv_externaldisk";

  if cmn.ApplyObj( item, "gzz_parkinglot_bush" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bush", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_bush_use_externaldisk" ) ) then

    cmn.CallEventHandler( "use_externaldisk_inv" );
    cmn.CallEventHandler( "use_externaldisk_beg" );

    local func_end = function ()

      local func_end_1 = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_externaldisk" );
        cmn.CallEventHandler( "use_externaldisk_end" );

      end;

      ObjSet( "obj_bush_box_1", { pos_z = 6 } );

      ObjAnimate( "obj_bush_box_1", "pos_xy",0,0, func_end_1, 
      { 
        0.0, 1, ObjGet( "obj_bush_box_1" ).pos_x, ObjGet( "obj_bush_box_1" ).pos_y,    
        0.3, 1, 0, 0,
      } );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_externaldisc", 0, "", 0 );

    cmn.ItemFly( "spr_bush_beetle1", func_end, 0.1 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_internaldisk ()

  local item = "inv_internaldisk";

  if cmn.ApplyObj( item, "gzz_parkinglot_bush" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bush", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_bush_use_internaldisk" ) ) then

    cmn.CallEventHandler( "use_internaldisk_inv" );
    cmn.CallEventHandler( "use_internaldisk_beg" );

    local func_end = function ()

      local func_end_1 = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_internaldisk" );
        cmn.CallEventHandler( "use_internaldisk_end" );

      end;

      ObjSet( "obj_bush_box_2", { pos_z = 5 } ); 
      ObjAnimate( "obj_bush_box_2", "pos_xy",0,0, func_end_1, 
      { 
        0.0, 1, ObjGet( "obj_bush_box_2" ).pos_x, ObjGet( "obj_bush_box_2" ).pos_y,    
        0.3, 1, 0, 0,
      } );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_externaldisc", 0, "", 0 );

    cmn.ItemFly( "spr_bush_beetle2", func_end, 0.1 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_letter_i ()

  local item = "inv_letter_i";

  if cmn.ApplyObj( item, "gzz_parkinglot_postmanthings" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_postmanthings", nil, { 512, 360 } );

    return true;
  
  elseif ( cmn.ApplyObj( item, "obj_postmanthings_use_letter_i" ) ) then

    cmn.CallEventHandler( "use_letter_i_inv" );
    cmn.CallEventHandler( "use_letter_i_beg" );
    
    local func_end = function ()

      local func_end_1 = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_letter_i" );
        cmn.CallEventHandler( "use_letter_i_end" );

      end;

      ObjAnimate( "spr_postmanthings_cover_i", "pos_xy",0,0, func_end_1, 
      { 
        0.0, 1, ObjGet( "spr_postmanthings_cover_i" ).pos_x, ObjGet( "spr_postmanthings_cover_i" ).pos_y,    
        0.3, 1, 320, -238,
      } );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_letter", 0, "", 0 );

    cmn.ItemFly( "spr_postmanthings_letter_i", func_end, 0 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_postmankey ()

  local item = "inv_postmankey";

  if cmn.ApplyObj( item, "gzz_parkinglot_postmanthings" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_postmanthings", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_postmanthings_use_postmankey" ) ) then

    cmn.CallEventHandler( "use_postmankey_inv" );
    cmn.CallEventHandler( "use_postmankey_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_postmankey" );
      cmn.CallEventHandler( "use_postmankey_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_letter", 0, "", 0 );

    --ObjAnimate( "spr_postmanthings_key", "alp",0,0, func_end, 
    --{ 
    --  0.0, 0, ObjGet( "spr_postmanthings_key" ).alp,
    --  0.3, 0, 1,
    --} );

    cmn.ItemFly( "spr_postmanthings_key", func_end, -1 );
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_letter_t ()

  local item = "inv_letter_t";

  if cmn.ApplyObj( item, "gzz_parkinglot_postmanthings" ) then

   --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_postmanthings", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_postmanthings_use_letter_t" ) ) then

    cmn.CallEventHandler( "use_letter_t_inv" );
    cmn.CallEventHandler( "use_letter_t_beg" );

    local func_end = function ()

      local func_end_1 = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_letter_t" );
        cmn.CallEventHandler( "use_letter_t_end" );

      end;

      ObjAnimate( "spr_postmanthings_cover_t", "pos_xy",0,0, func_end_1, 
      { 
        0.0, 1, ObjGet( "spr_postmanthings_cover_t" ).pos_x, ObjGet( "spr_postmanthings_cover_t" ).pos_y,    
        0.3, 1, -115, -66,
      } );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_letter", 0, "", 0 );
    cmn.ItemFly( "spr_postmanthings_letter_t", func_end, 0 );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_corn ()

  local item = "inv_corn";

  if cmn.ApplyObj( item, "gzz_parkinglot_billboard" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_billboard", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_billboard_use_corn" ) ) then

    cmn.CallEventHandler( "use_corn_inv" );
    cmn.CallEventHandler( "use_corn_beg" );

    local func_end = function () 

      local func_end_1 = function ()

        cmn.Lock( false );

        cmn.SetEventDone( "use_corn" );
        cmn.CallEventHandler( "use_corn_end" );
        
        private.get_coin_ext();
    
      end;

      AnimPlay( "anm_billboard_bird_feed", "DoAnim", func_end_1 );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_corn", 0, "", 0 );

    ObjAnimate( "anm_billboard_bird_feed", "alp",0,0, "", 
    { 
      0.00, 0, 0,    
      0.02, 0, 1,
      0.04, 0, 1,
    } );
    ObjAnimate( "anm_billboard_bird_with_coin", "alp",0,0, func_end, 
    { 
      0.00, 0, 1,    
      0.02, 0, 1,
      0.04, 0, 0,
    } );


    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_oilcan_ext_2 ()

  local item = "inv_oilcan_ext";

  if cmn.ApplyObj( item, "gzz_parkinglot_billboard" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_billboard", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_billboard_use_oilcan_ext_2" ) ) then

    cmn.CallEventHandler( "use_oilcan_ext_2_inv" );
    cmn.CallEventHandler( "use_oilcan_ext_2_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_oilcan_ext_2" );
      cmn.CallEventHandler( "use_oilcan_ext_2_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_oilcan_ext1", 0, "", 0 );

    ObjSet( "vid_billboard_oil", { alp = 1 } );
    VidPlay( "vid_billboard_oil", func_end );

    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_coin_ext_1 ()

  local item = "inv_coin_ext";

  if cmn.ApplyObj( item, "gzz_parkinglot_instantlottery" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_instantlottery", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_instantlottery_use_coin_ext_1" ) ) then

    cmn.CallEventHandler( "use_coin_ext_1_inv" );
    cmn.CallEventHandler( "use_coin_ext_1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_coin_ext_1" );
      cmn.CallEventHandler( "use_coin_ext_1_end" );
      
    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_coin", 0, "", 0 );

    ObjAnimate( "spr_instantlottery_coin", "scale_xy", 0, 0, func_end, { 0, 2, 1, 1,  1, 2, 0.35, 0.35 } );
    ObjAnimate( "spr_instantlottery_coin", "pos_xy", 0, 0, "",   { 0, 2, -400 , 10,  1 , 2, -226, -71 } );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_cash_1 ()

  local item = "inv_cash";

  if ( cmn.ApplyObj( item, "obj_parkinglot_use_cash_1" ) and cmn.IsEventDone( "see_taxi" ) ) then

    cmn.CallEventHandler( "use_cash_1_inv" );
    cmn.CallEventHandler( "use_cash_1_beg" );

    local func_end = function ()

      cmn.Lock( false );

      if ( cmn.IsEventDone( "use_officeaddress" ) ) then

        private.use_cash_1_officeaddress_end( "use_cash_1" );

      else

        cmn.SetEventDone( "use_cash_1" );
        cmn.CallEventHandler( "use_cash_1_end" );

      end;

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_money", 0, "", 0 );

    func_end();

    --cmn.ItemFly( "spr", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function private.use_cash_1_officeaddress_end ( event_name )

  local func_end = function ()

    cmn.Lock( false );

    common_impl.StopAudio( "voc", "levelext/voc/aud_taxidriver_voc", 0.2 );
    common_impl.StopAudio( "sfx", "levelext/sfx/aud_taxi_ride", 0.2 );

    cmn.SetEventDone( event_name );
    cmn.CallEventHandler( event_name.."_end" );

    cmn.GotoRoom( "rm_porch_ext" );

    common_impl.ShowBbt( "bbt_perkinglot_drive_taxi" );    

  end;

  cmn.Lock( false );

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_taxi_ride", 0, "", 0 );
  common_impl.PlayAudio( "voc", "levelext/voc/aud_taxidriver_voc", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_parkinglot_trip", func_end );

end;
--------------------------------------------------------------------------------------------
function public.use_officeaddress ()

  local item = "inv_officeaddress";

  if ( cmn.ApplyObj( item, "obj_parkinglot_use_officeaddress" ) and cmn.IsEventDone( "see_taxi" ) ) then

    cmn.CallEventHandler( "use_officeaddress_inv" );
    cmn.CallEventHandler( "use_officeaddress_beg" );

    local func_end = function ()

      cmn.Lock( false );

      if ( cmn.IsEventDone( "use_cash_1" ) ) then

        private.use_cash_1_officeaddress_end( "use_officeaddress" );

      else

        cmn.SetEventDone( "use_officeaddress" );
        cmn.CallEventHandler( "use_officeaddress_end" );

      end;

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "aud_paper", 0, "", 0 );

    func_end();

    --cmn.ItemFly( "spr", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_postmankey ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_postmankey" );
  cmn.CallEventHandler( "get_postmankey" );

  if ( cmn.IsEventDone( "get_foldumbrella" ) and  
    cmn.IsEventDone( "get_letter_t" ) ) then

    common.CloseSubRoom();    

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_letter_t ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_letter_t" );
  cmn.CallEventHandler( "get_letter_t" );

  if ( cmn.IsEventDone( "get_foldumbrella" ) and  
    cmn.IsEventDone( "get_postmankey" ) ) then

    common.CloseSubRoom();    

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_foldumbrella ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_foldumbrella" );
  cmn.CallEventHandler( "get_foldumbrella" );

  if ( cmn.IsEventDone( "get_letter_t" ) and  
    cmn.IsEventDone( "get_postmankey" ) ) then

    common.CloseSubRoom();    

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_letter ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_letter" );
  cmn.CallEventHandler( "get_letter" );

  if ( cmn.IsEventDone( "get_internaldisk" ) and  
    cmn.IsEventDone( "get_clip" ) ) then

    common.CloseSubRoom();    

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_internaldisk ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_internaldisk" );
  cmn.CallEventHandler( "get_internaldisk" );

  if ( cmn.IsEventDone( "get_clip" ) and  
    cmn.IsEventDone( "get_letter" ) ) then

    common.CloseSubRoom();    

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_clip ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_clip" );
  cmn.CallEventHandler( "get_clip" );

  cmn.NoteScale( "spr_postmanthings_paper" );

  if ( cmn.IsEventDone( "get_internaldisk" ) and  
    cmn.IsEventDone( "get_letter" ) ) then

    common.CloseSubRoom();    

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_taxinumber ()

  local func_end = function()

    cmn.Lock( false );
    ObjSet( "spr_billboard_taxinumber_1", { input = true, scale_x = 1, scale_y = 1 } );
    ObjSet( "spr_billboard_taxinumber",   { input = false, alp = false, pos_x = 0, pos_y = 0 } );

  end;

  cmn.Lock( true );
  ObjAnimate( "spr_billboard_taxinumber", "alp",0,0, func_end, 
  { 
    0.0, 0, ObjGet( "spr_billboard_taxinumber" ).alp,     
    0.3, 0, 0
  } );
  ObjAnimate( "spr_billboard_taxinumber_1", "pos_xy",0,0, "", 
  { 
    0.0, 0, ObjGet( "spr_billboard_taxinumber" ).pos_x, ObjGet( "spr_billboard_taxinumber" ).pos_y,    
    0.3, 0, 0, 0,
  } );
  ObjAnimate( "spr_billboard_taxinumber_1", "scale_xy",0,0, "", 
  { 
    0.0, 0, 0, 0,    
    0.3, 0, 1, 1,
  } );

end;
--------------------------------------------------------------------------------------------
function private.get_taxinumber_1 ()

  local func_end = function()

    cmn.Lock( false );
    ObjSet( "spr_billboard_taxinumber_1", { input = false, scale_x = 0, scale_y = 0 } );
    ObjSet( "spr_billboard_taxinumber_2", { input = true, scale_x = 1, scale_y = 1 } );
    ObjSet( "gfx_billboard_taxinumber",   { active = true } );

  end;

  cmn.Lock( true );
  ObjAnimate( "spr_billboard_taxinumber_1", "scale_xy",0,0, "", 
  { 
    0.0, 0, ObjGet( "spr_billboard_taxinumber_1" ).scale_x, ObjGet( "spr_billboard_taxinumber_1" ).scale_y,    
    0.3, 0, 0, ObjGet( "spr_billboard_taxinumber_1" ).scale_y, 
  } );
  ObjAnimate( "spr_billboard_taxinumber_2", "scale_xy",0,0, func_end, 
  { 
    0.0, 0, ObjGet( "spr_billboard_taxinumber_2" ).scale_x, ObjGet( "spr_billboard_taxinumber_2" ).scale_y,   
    0.3, 0, ObjGet( "spr_billboard_taxinumber_2" ).scale_x, ObjGet( "spr_billboard_taxinumber_2" ).scale_y,         
    0.6, 0, 1, ObjGet( "spr_billboard_taxinumber_2" ).scale_y,
  } ); 

end;
--------------------------------------------------------------------------------------------
function private.get_taxinumber_2 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_taxinumber" );
  cmn.CallEventHandler( "get_taxinumber" );

  if ( cmn.IsEventDone( "get_coin_ext" ) ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_coin_ext ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  ObjSet( "spr_billboard_coin_ext", { alp = 1 } );
  cmn.SetEventDone( "get_coin_ext" );
  cmn.CallEventHandler( "get_coin_ext" );
  
  if ( cmn.IsEventDone( "get_taxinumber" ) ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_cash ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_cash" );
  cmn.CallEventHandler( "get_cash" );
  common.CloseSubRoom();

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_lever_match_3 ()

  if ( not cmn.IsEventDone( "use_coin_ext_1" ) ) then

    cmn.Lock( true );

    ObjAnimate( "spr_instantlottery_lever_handle", "pos_y", 0, 0, function () cmn.Lock( false ); end, { 0, 3, -86, 0.1, 3, -80, 0.2, 3, -84, 0.3, 0, -77, 0.4, 0, -86 });

  else

    local endfunc = function ()

      cmn.Lock( false );
      cmn.SetEventDone( "clk_lever_match_3" );
      cmn.CallEventHandler( "clk_lever_match_3" );
      cmn.MiniGameShow( "match_3" );
      common_impl.PassingMgStart( "match_3" );

    end;
    
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_lever", 0, "", 0 );

    ObjAnimate( "spr_instantlottery_lever_handle", "pos_xy", 0, 0, endfunc, { 0, 3, 250, -86, 0.5, 3, 255, 39});
    ObjAnimate( "spr_instantlottery_green_lamp_light", "alp", 0, 0, "", { 0, 3, 0, 0.3, 3, 0, 0.5, 3, 1 });
    
    cmn.Lock( true );  

    private.Match3Init ();
    ng_global.progress[ "ext" ][ "win_match_3" ].match3_field  = { {}, {}, {}, {}, {}, {} };
    ng_global.progress[ "ext" ][ "win_match_3" ].match3 = {}
    ng_global.progress[ "ext" ][ "win_match_3" ].match3.points = private.match3.points;
    
    for i = 1, private.match3_cell_y do

      ng_global.progress[ "ext" ][ "win_match_3" ].match3_field[ i ] = { 0, 0, 0, 0, 0 };

    end;

    private.Match3GenerateField( true );
    private.Match3ProgressBarInit();
    private.Match3ProgressBarSet();
    
    ObjAnimate( "obj_instantlottery_crop", "alp", 0, 0, "", { 0, 3, 0, 0.5, 3, 1});
    ObjAnimate( "spr_instantlottery_text", "alp", 0, 0, "", { 0, 3, 1, 0.5, 3, 0});  
    ObjAnimate( "obj_instantlottery_progrees_bar", "alp", 0, 0, "", { 0, 3, 0, 0.5, 3, 1});

  end;
  

end;
--------------------------------------------------------------------------------------------
function private.clk_taxinumber ()

  cmn.CallEventHandler( "clk_taxinumber_beg" );

  local func_end = function ()

    local func_end_1 = function ()

      local func_end_2 = function ()

        cmn.Lock( false );
        cmn.SetEventDone( "clk_taxinumber" );
        cmn.CallEventHandler( "clk_taxinumber_end" );    

      end;

      ObjSet( "spr_billboard_taxinumber", { alp = 1 } );
      ObjAnimate( "anm_billboard_hand", "alp",0,0, "", 
      { 
        0.0, 0, 1,     
        0.1, 0, 0,
      } );
      ObjAnimate( "spr_billboard_hand_3", "alp",0,0, func_end_2, 
      { 
        0.0, 0, 0,     
        0.05, 0, 1,
      } );

    end;

    AnimPlay( "anm_billboard_hand", "DoAnim", func_end_1 );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_taxinumber", 0, "", 0 );

  ObjAnimate( "spr_billboard_hand_2", "ang",0,0, func_end, 
  { 
    0.0, 0, ObjGet( "spr_billboard_taxinumber" ).ang,     
    0.3, 0, -0.65,
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_postmankey ()

  cmn.CallEventHandler( "clk_postmankey_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_postmankey" );
    cmn.CallEventHandler( "clk_postmankey_end" );    

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_key_bag", 0, "", 0 );

  ObjAnimate( "spr_bush_bush_3", "pos_xy",0,0, func_end, 
  { 
    0.0, 3, ObjGet( "spr_bush_bush_3" ).pos_x, ObjGet( "spr_bush_bush_3" ).pos_y,    
    0.9, 3, 266, 47      
  } );
  ObjAnimate( "spr_bush_bush_3", "ang",0,0, "", 
  { 
    0.0, 3, ObjGet( "spr_bush_bush_3" ).ang,     
    0.9, 3, -1.1,
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_clip_1 ()

  cmn.CallEventHandler( "clk_clip_1_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_clip_1" );
    cmn.CallEventHandler( "clk_clip_1_end" );    

    ObjSet( "obj_postmanthings_paper_hint", { pos_x = -104, pos_y = -107 } );  

  end;

  cmn.Lock( true );
  ObjAnimate( "spr_postmanthings_clip", "pos_xy",0,0, func_end, 
  { 
    0.0, 0, ObjGet( "spr_postmanthings_clip" ).pos_x, ObjGet( "spr_postmanthings_clip" ).pos_y,    
    0.3, 0, -111, -107      
  } );
  ObjAnimate( "spr_postmanthings_clip_shadow", "pos_xy",0,0, "", 
  { 
    0.0, 0, ObjGet( "spr_postmanthings_clip_shadow" ).pos_x, ObjGet( "spr_postmanthings_clip_shadow" ).pos_y,    
    0.3, 0, -110, -104      
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_clip_2 ()

  cmn.CallEventHandler( "clk_clip_2_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_clip_2" );
    cmn.CallEventHandler( "clk_clip_2_end" );    

  end;

  cmn.Lock( true );
  ObjAnimate( "spr_postmanthings_clip2", "alp",0,0, "", 
  { 
    0.0, 0, ObjGet( "spr_postmanthings_clip2" ).alp, 
    0.3, 0, 0     
  } );
  ObjAnimate( "spr_postmanthings_clip3", "alp",0,0, func_end, 
  { 
    0.0, 0, ObjGet( "spr_postmanthings_clip3" ).alp,
    0.3, 0, 1     
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_postmankey2 ()

  cmn.CallEventHandler( "clk_postmankey2_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_postmankey2" );
    cmn.CallEventHandler( "clk_postmankey2_end" );    

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_key_bag", 0, "", 0 );

  ObjAnimate( "spr_postmanthings_key", "alp",0,0, "", 
  { 
    0.0, 0, ObjGet( "spr_postmanthings_key" ).alp,
    0.3, 0, 0,
  } );
  ObjAnimate( "spr_postmanthings_key2", "alp",0,0, "", 
  { 
    0.0, 0, ObjGet( "spr_postmanthings_key2" ).alp,
    0.3, 0, 1,
  } );
  ObjAnimate( "spr_postmanthings_cover_bag", "alp",0,0, func_end, 
  { 
    0.0, 0, ObjGet( "spr_postmanthings_cover_bag" ).alp,
    0.5, 0, ObjGet( "spr_postmanthings_cover_bag" ).alp,
    0.8, 0, 0,
  } );

end;
 --
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG MATCH_3 *** () end;
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  function private.Match3WinAnim ()

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_win_match_3", 0, "", 0 );

    cmn.ItemFly( "spr_instantlottery_money_shadow", private.WinMatch_3, 0, 120, 1, 0.5 );
    cmn.ItemFly( "spr_instantlottery_cash", nil, 0, 120, 1, 0.5 );
    ObjAnimate( "obj_instantlottery_crop", "alp", 0, 0, "", { 0, 3, 1, 0.5, 3, 0 });
    ObjAnimate( "spr_instantlottery_red_lamp_light", "alp", 0, 0, "", { 0, 3, 0, 0.5, 3, 1 });
    ObjAnimate( "obj_instantlottery_progrees_bar", "alp", 0, 0, "", { 0, 3, 1, 0.5, 3, 0 });

  end;
  --------------------------------------------------------------------------------------------
  function private.WinMatch_3 ()

    cmn.Lock( false ); 
    cmn.MiniGameHide( "match_3" );
    common_impl.PassingMgWin( "match_3" );
    cmn.SetEventDone( "win_match_3" );
    cmn.CallEventHandler( "win_match_3" );    

  end;
  --------------------------------------------------------------------------------------------
  function private.Match3Init ()

    private.match3 = {};

    private.match3.color_types = {

      { 0, 0, 1 },
      { 1, 0, 0 },
      { 0, 1, 0 },
      { 1, 1, 0 },
      { 1, 0, 1 },

    };

    private.match3.points = 0;

    private.match3_cell_x = 6;
    private.match3_cell_y = 5;

    private.match3_points_win = 58;
    private.match3_first_chip = nil;

    private.match3_toremove = {};
    private.match3_field    = {};
    private.match3_weidth   = {};

    private.delta_pos_y = 100;

    private.start_pos_x = 104;

    private.chip_pos = { { 0, 56, 112, 204, 272, 340, 408 }, { 0, 56, 112, 198, 264 } };
    
    local step_x = 60;
    local step_y = 60;
    

    for i = 2, private.match3_cell_x + 1 do 
    
      private.chip_pos[1][i] = private.chip_pos[1][i-1] + step_x; 

    end;
    
    for i = 2, private.match3_cell_y + 1 do 
    
      private.chip_pos[2][i] = private.chip_pos[2][i-1] + step_y; 

    end;

    for i = 1, private.match3_cell_x do

      private.match3_field[ i ]  = { 0, 0, 0, 0, 0, 0, 0 };
      private.match3_weidth[ i ] = { 0, 0, 0, 0, 0, 0, 0 };

    end;

    private.Match3ProgressBarSet();

  end;
--*********************************************************************************************************************
  function private.Match3Load ()

    for i = 1, private.match3_cell_y do

      for j = 1, private.match3_cell_x do

        ObjCreate( "obj_instantlottery_chip_"..i.."_"..j, "obj" );
        ObjCreate( "spr_instantlottery_chip_"..i.."_"..j, "spr" );
        ObjCreate( "spr_instantlottery_chip_flash_"..i.."_"..j, "spr" );

        ObjAttach( "obj_instantlottery_chip_"..i.."_"..j, "obj_instantlottery_chips" );
        ObjAttach( "spr_instantlottery_chip_"..i.."_"..j, "obj_instantlottery_chip_"..i.."_"..j );
        ObjAttach( "spr_instantlottery_chip_flash_"..i.."_"..j, "obj_instantlottery_chip_"..i.."_"..j );

        local type = ng_global.progress[ "ext" ][ "win_match_3" ].match3_field[ i ][ j ];
        private.match3_field[ i ][ j ] = type;

        ObjSet( "obj_instantlottery_chip_"..i.."_"..j,
        {
          pos_x = private.chip_pos[ 1 ][ j ],
          pos_y = private.chip_pos[ 2 ][ i ],
          input   = true,
          active  = true,
          visible = true,
          event_mdown  = function () private.Match3ClickChip ( "obj_instantlottery_chip_"..i.."_"..j ) end,
          event_menter = function () common_impl.SetCursor( CURSOR_HAND ) end,
          event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ) end,
          inputrect_init = true,
          inputrect_x = -25,
          inputrect_y = -25,
          inputrect_w =  50,
          inputrect_h =  50,
        } );

        local color_type = private.match3.color_types[type];
        

        ObjSet( "spr_instantlottery_chip_"..i.."_"..j,
        {
          input = false,
          res = "assets/levels/levelext/rm_parkinglot/zz_instantlottery/layers/chip",
          color_r = color_type[1];
          color_g = color_type[2];
          color_b = color_type[3];
        } );

        ObjSet( "spr_instantlottery_chip_flash_"..i.."_"..j,
        {
          input = false,
          scale_x = 0.5,
          alp = 0,
          res = "assets/levels/levelext/rm_parkinglot/zz_instantlottery/layers/chip_light_flash",
        } );

      end;

    end;

    private.Match3ProgressBarSet();
  
  end;
  --*********************************************************************************************************************
  function private.Match3ResetSet ()
    
    ng_global.progress[ "ext" ][ "win_match_3" ].match3.points = 0;
    private.match3.points = 0; 
    private.Match3GenerateField();
    private.Match3ProgressBarSet();

  end;
  ------------------------------------------------------------
  function private.Match3GenerateField ( is_first )

    local is_done = false;

    for i = 1, private.match3_cell_y do

      for j = 1, private.match3_cell_x do

        local type = private.Match3GetRandomChip();

        ng_global.progress[ "ext" ][ "win_match_3" ].match3_field[ i ][ j ] = type;

        if ( is_first ) then

          ObjCreate( "obj_instantlottery_chip_"..i.."_"..j, "obj" );
          ObjCreate( "spr_instantlottery_chip_"..i.."_"..j, "spr" );
          ObjCreate( "spr_instantlottery_chip_flash_"..i.."_"..j, "spr" );

          ObjAttach( "obj_instantlottery_chip_"..i.."_"..j, "obj_instantlottery_chips" );
          ObjAttach( "spr_instantlottery_chip_"..i.."_"..j, "obj_instantlottery_chip_"..i.."_"..j );
          ObjAttach( "spr_instantlottery_chip_flash_"..i.."_"..j, "obj_instantlottery_chip_"..i.."_"..j );

        end;

      end;

    end;

    while ( not is_done ) do

      is_done = private.Match3ShuffleField();

    end;

    for i = 1, private.match3_cell_y do

      for j = 1,private.match3_cell_x do

        local type = ng_global.progress[ "ext" ][ "win_match_3" ].match3_field[ i ][ j ];

        ObjSet( "obj_instantlottery_chip_"..i.."_"..j,
        {
          pos_x = private.chip_pos[ 1 ][ j ],
          pos_y = private.chip_pos[ 2 ][ i ],
          input   = true,
          active  = true,
          visible = true,
          event_mdown  = function () private.Match3ClickChip ( "obj_instantlottery_chip_"..i.."_"..j ) end,
          event_menter = function () common_impl.SetCursor( CURSOR_HAND ) end,
          event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ) end,
          inputrect_init = true,
          inputrect_x = -25,
          inputrect_y = -25,
          inputrect_w =  50,
          inputrect_h =  50,
        } );

        local color_type = private.match3.color_types[type];

        ObjSet( "spr_instantlottery_chip_"..i.."_"..j,
        {
          input = false,
          res = "assets/levels/levelext/rm_parkinglot/zz_instantlottery/layers/chip",
          color_r = color_type[1];
          color_g = color_type[2];
          color_b = color_type[3];

        } );

        ObjSet( "spr_instantlottery_chip_flash_"..i.."_"..j,
        {
          input = false,
          scale_x = 0.5,
          alp = 0,
          res = "assets/levels/levelext/rm_parkinglot/zz_instantlottery/layers/chip_light_flash",
        } );

      end;

    end;

  end;
------------------------------------------------------------
  function private.Match3ShuffleField ()

    local is_done = true;

    for i = 1, private.match3_cell_y do

      for j = 1, ( private.match3_cell_x - 2 ) do

        if ( ng_global.progress[ "ext" ][ "win_match_3" ].match3_field[ i ][ j ] == ng_global.progress[ "ext" ][ "win_match_3" ].match3_field[ i ][ j + 1 ] ) and
           ( ng_global.progress[ "ext" ][ "win_match_3" ].match3_field[ i ][ j ] == ng_global.progress[ "ext" ][ "win_match_3" ].match3_field[ i ][ j + 2 ] ) then

          ng_global.progress[ "ext" ][ "win_match_3" ].match3_field[ i ][ j + 1 ] = private.Match3GetRandomChip();

          is_done = false;

        end;

      end;

    end;

    for i = 1, ( private.match3_cell_y - 2 ) do

      for j = 1, private.match3_cell_x do

        if ( ng_global.progress[ "ext" ][ "win_match_3" ].match3_field[ i ][ j ] == ng_global.progress[ "ext" ][ "win_match_3" ].match3_field[ i + 1 ][ j ] ) and
           ( ng_global.progress[ "ext" ][ "win_match_3" ].match3_field[ i ][ j ] == ng_global.progress[ "ext" ][ "win_match_3" ].match3_field[ i + 2 ][ j ] ) then

          ng_global.progress[ "ext" ][ "win_match_3" ].match3_field[ i + 1 ][ j ] = private.Match3GetRandomChip();

          is_done = false;

        end;

      end;

    end;

    for i = 1, private.match3_cell_y do

      for j = 1, private.match3_cell_x do

        private.match3_field[ i ][ j ] = ng_global.progress[ "ext" ][ "win_match_3" ].match3_field[ i ][ j ];

      end;

    end;

    return is_done;

  end;
------------------------------------------------------------
  function private.Match3GetRandomChip ()

    local type = math.random( 1, 100 );

    if     ( type > 0  and type < 21 ) then type = 2;
    elseif ( type > 21 and type < 41 ) then type = 3;
    elseif ( type > 41 and type < 61 ) then type = 4;
    elseif ( type > 61 and type < 81 ) then type = 5;
    else                                    type = 1;
    end;

    return type;
    
  end;
------------------------------------------------------------
  function private.Match3ClickChip ( chip )

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_fairytale_clk_chip", 0, "", 0 );

    if ( not private.match3_first_chip ) then

      private.match3_first_chip = chip;

      local pos = ObjGet( chip );

      ObjSet("spr_instantlottery_chip_light",
      {
        pos_x = pos.pos_x, 
        pos_y = pos.pos_y,
        visible = true
      } );

    else

      ObjSet( "spr_instantlottery_chip_light", { visible = false } );


      if ( private.match3_first_chip == chip ) then

        private.match3_first_chip = nil;

        return;

      end;

      private.match3_second_chip = chip;

      local old_x = ObjGet( private.match3_first_chip ).pos_x;
      local old_y = ObjGet( private.match3_first_chip ).pos_y;
      local new_x = ObjGet( chip ).pos_x;
      local new_y = ObjGet( chip ).pos_y;

      local old_i_x = 0;
      local old_i_y = 0;
      local new_i_x = 0;
      local new_i_y = 0;

      for i = 1, private.match3_cell_x do

        if ( old_x == private.chip_pos[ 1 ][ i ] ) then

          old_i_y = i;

        end;

        if ( new_x == private.chip_pos[ 1 ][ i ] ) then

          new_i_y = i;

        end;

      end;

      for i = 1, private.match3_cell_y do

        if ( old_y == private.chip_pos[ 2 ][ i ] ) then

          old_i_x = i;

        end;

        if ( new_y == private.chip_pos[ 2 ][ i ] ) then

          new_i_x = i;

        end;

      end;

      if ( old_i_x == new_i_x ) and ( math.abs( old_i_y - new_i_y ) == 1 ) or
         ( old_i_y == new_i_y ) and ( math.abs( old_i_x - new_i_x ) == 1 ) then

        private.Match3SwapChips( new_x, new_y, old_x, old_y );

        local temp = private.match3_field[ old_i_x ][ old_i_y ];

        private.match3_field[ old_i_x ][ old_i_y ] = private.match3_field[ new_i_x ][ new_i_y ];
        private.match3_field[ new_i_x ][ new_i_y ] = temp;

        if ( private.Match3Checking() ) then

          ObjSet( "tmr_instantlottery_exchange", 
          {
            time = 0.2, 
            playing = true,
            endtrig = function ()

              private.Match3SetFieldState();

              private.Match3Disappearance();

            end;

          } );

        else

          local temp = private.match3_field[ old_i_x ][ old_i_y ];

          private.match3_field[ old_i_x ][ old_i_y ] = private.match3_field[ new_i_x ][ new_i_y ];
          private.match3_field[ new_i_x ][ new_i_y ] = temp; 

          ObjSet( "tmr_instantlottery_exchange", 
          {
            time = 0.2, 
            playing = true,
            endtrig = function ()

              private.Match3SwapChips( old_x, old_y, new_x, new_y, true );

            end;
          } );


        end;

        private.match3_firstclk = nil;

      else

        private.match3_first_chip = chip;

        local pos = ObjGet( chip );

        ObjSet("spr_instantlottery_chip_light",
        {
          pos_x = pos.pos_x, 
          pos_y = pos.pos_y,
          visible = true
        } );

      end;

    end;

  end;
------------------------------------------------------------
  function private.Match3SwapChips ( new_x, new_y, old_x, old_y, is_back )

    common_impl.Lock( true );

    ObjAnimate( private.match3_second_chip, "pos_xy", 0, 0,
    function ()

      if ( is_back ) then

        private.match3_first_chip = nil;

        common_impl.Lock( false );

      end;

    end,
    {
      0.0, 0, new_x, new_y,
      0.2, 0, old_x, old_y
    } );

    ObjAnimate( private.match3_first_chip, "pos_xy", 0, 0, "",
    {
      0.0, 0, old_x, old_y,
      0.2, 0, new_x, new_y
    } );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_fairytale_swap_chip", 0, "", 0 );

  end;
------------------------------------------------------------
  function private.Match3Checking ()

    for i = 1, private.match3_cell_y do

      for j = 1, ( private.match3_cell_x - 2 ) do

        if ( private.match3_field[ i ][ j ] == private.match3_field[ i ][ j + 1 ] ) and
           ( private.match3_field[ i ][ j ] == private.match3_field[ i ][ j + 2 ] ) and
           ( private.match3_field[ i ][ j ] ~= 7) then

          if ( private.Match3AddToQueue( i, j ) )     then private.match3_toremove[ #private.match3_toremove + 1 ] = { i, j,     0 }; end;
          if ( private.Match3AddToQueue( i, j + 1 ) ) then private.match3_toremove[ #private.match3_toremove + 1 ] = { i, j + 1, 0 }; end;
          if ( private.Match3AddToQueue( i, j + 2 ) ) then private.match3_toremove[ #private.match3_toremove + 1 ] = { i, j + 2, 0 }; end;

        end;

      end;

    end;

    for i = 1, ( private.match3_cell_y - 2 ) do

      for j = 1, private.match3_cell_x do

        if ( private.match3_field[ i ][ j ] == private.match3_field[ i + 1 ][ j ] ) and
           ( private.match3_field[ i ][ j ] == private.match3_field[ i + 2 ][ j ] )  and
           ( private.match3_field[ i ][ j ] ~= 7) then

          if ( private.Match3AddToQueue( i, j ) )     then private.match3_toremove[ #private.match3_toremove + 1 ] = { i,     j, math.pi / 2 }; end;
          if ( private.Match3AddToQueue( i + 1, j ) ) then private.match3_toremove[ #private.match3_toremove + 1 ] = { i + 1, j, math.pi / 2 }; end;
          if ( private.Match3AddToQueue( i + 2, j ) ) then private.match3_toremove[ #private.match3_toremove + 1 ] = { i + 2, j, math.pi / 2 }; end;

        end;

      end;

    end;

    private.match3.points = private.match3.points + #private.match3_toremove;

    private.Match3ProgressBarSet();

    if ( #private.match3_toremove == 0 ) then

      return false;

    end;

    return true;

  end;
------------------------------------------------------------
  function private.Match3AddToQueue ( pos_x, pos_y )

    for i = 1, #private.match3_toremove do

      if ( private.match3_toremove[ i ][ 1 ] == pos_x ) and
         ( private.match3_toremove[ i ][ 2 ] == pos_y ) then

        return false;

      end;

    end;

    return true;

  end;
------------------------------------------------------------
  function private.Match3SetFieldState ()

    for i = 1, private.match3_cell_y do

      for j = 1, private.match3_cell_x do

        local type = private.match3_field[ i ][ j ];
        local color_type = private.match3.color_types[type];

        ObjSet( "obj_instantlottery_chip_"..i.."_"..j,
        {
          pos_x = private.chip_pos[ 1 ][ j ],
          pos_y = private.chip_pos[ 2 ][ i ],
        } );

        ObjSet( "spr_instantlottery_chip_"..i.."_"..j,
        {
          res = "assets/levels/levelext/rm_parkinglot/zz_instantlottery/layers/chip",
          color_r = color_type[1];
          color_g = color_type[2];
          color_b = color_type[3];

        } );

      end;

    end;

  end;
------------------------------------------------------------
  function private.Match3Disappearance ()

    common_impl.Lock( true );

    if ( #private.match3_toremove ~= 0 ) then

      common_impl.PlayAudio( "sfx", "level2/sfx/aud_fairytale_disappearance_chip", 0, "", 0 );

      for i = 1, ( #private.match3_toremove ) do

        local x = private.match3_toremove[ i ][ 1 ];
        local y = private.match3_toremove[ i ][ 2 ];
        local a = private.match3_toremove[ i ][ 3 ];

        ObjAnimate( "spr_instantlottery_chip_"..x.."_"..y, "alp", 0, 0, "",
        {
          0.0, 0, 1,
          0.3, 0, 0
        } );

        ObjSet( "spr_instantlottery_chip_flash_"..x.."_"..y, { ang = a } );

        ObjAnimate( "spr_instantlottery_chip_flash_"..x.."_"..y, "alp", 0, 0, "",
        {
          0.00, 0, 0,
          0.15, 0, 1,
          0.30, 0, 0
        } );

        private.match3_field[ private.match3_toremove[ i ][ 1 ] ][ private.match3_toremove[ i ][ 2 ] ] = 0;

      end;

      ObjSet( "tmr_instantlottery_remove", 
      {
        time = 0.3, 
        playing = true,
        endtrig = function ()

          private.Match3FallChips();

        end;
      } );

    end;

  end;
------------------------------------------------------------
  function private.Match3FallChips ()

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_fairytale_fall_chip", 0, "", 0 );

    for j = private.match3_cell_x, 1, -1 do

      for i = private.match3_cell_y, 1, -1 do

        if ( private.match3_field[ i ][ j ] == 0 ) then

          local index = i;

          while ( index > 0 ) do

            if ( private.match3_field[ index ][ j ] ~= 0 ) then

              private.match3_weidth[ index ][ j ] = private.match3_weidth[ index ][ j ] + 1;

            else

              private.match3_weidth[ index ][ j ] = private.match3_weidth[ index ][ j ] - 1;

            end;

            index = index - 1;

          end;

        end;

      end;

    end;

    for j = private.match3_cell_x, 1, -1 do

      local count = 0;

      for i = private.match3_cell_y, 1, -1 do

        local pos = private.match3_weidth[ i ][ j ];

        if ( pos < 0 ) then

          local chip = "obj_instantlottery_chip_"..i.."_"..j;

          ObjSet( chip, { pos_y = ( 51 * pos - private.delta_pos_y ), pos_x = private.start_pos_x } );

        end;

      end;

    end;

    for i = private.match3_cell_y, 1, -1 do

      for j = private.match3_cell_x, 1, -1 do

        if ( private.match3_weidth[ i ][ j ] > 0 ) then

          local chip = "obj_instantlottery_chip_"..i.."_"..j;

          local pos_start = private.chip_pos[ 2 ][ i ];
          local pos_end   = pos_start + 51 * private.match3_weidth[ i ][ j ];

          ObjAnimate( chip, "pos_y", 0, 0, "",
          {
            0.0, 1, pos_start,
            0.3, 1, pos_end
          } );

          private.match3_field[ i + private.match3_weidth[ i ][ j ] ][ j ] = private.match3_field[ i ][ j ];
          private.match3_field[ i ][ j ] = 0;

        end;

      end;

    end;

    for i = 1, private.match3_cell_y do

      for j = 1, private.match3_cell_x do

        if ( private.match3_field[ i ][ j ] == 0 ) then

          private.match3_field[ i ][ j ] = private.Match3GetRandomChip();

          local x = 0;
          local y = 0;

          local loop = true;

          for i = 1, private.match3_cell_y do

            if ( loop ) then

              for j = 1, private.match3_cell_x do

                if ( private.match3_weidth[ i ][ j ] < 0 ) then

                  x = i;
                  y = j;

                  private.match3_weidth[ i ][ j ] = 0;

                  loop = false;

                  break;

                end;

              end;

            end;

          end;

          local chip = "obj_instantlottery_chip_"..x.."_"..y;

          local pos_y = ObjGet( chip ).pos_y;

          local color_type = private.match3.color_types[private.match3_field[ i ][ j ]];

          ObjSet( "spr_instantlottery_chip_"..x.."_"..y, 
          { alp = 1, 
            res = "assets/levels/levelext/rm_parkinglot/zz_instantlottery/layers/chip",
            color_r = color_type[1],
            color_g = color_type[2],
            color_b = color_type[3],
          } );

          ObjAnimate( chip, "pos_y", 0, 0, "",
          {
            0.00, 1, pos_y, 
            0.30, 1, private.chip_pos[ 2 ][ i ],
          } );

          ObjAnimate( chip, "pos_x", 0, 0, "",
          {
            0.00, 1, private.start_pos_x,
            0.05, 1, private.start_pos_x,
            0.30, 1, private.chip_pos[ 1 ][ j ],
          } );

        end;

      end;

    end;

    private.match3_toremove = {};
    private.match3_grain = {};

    for i = 1, private.match3_cell_y do 

      private.match3_weidth[ i ] = { 0, 0, 0, 0, 0, 0, 0 };

    end;

    ObjSet( "tmr_instantlottery_fall", 
    {
      time = 0.3, 
      playing = true,
      endtrig = function ()

        private.Match3SetFieldState();

        local is_delete_chips = private.Match3Checking();

        if ( is_delete_chips ) then

          private.Match3Disappearance();

        else 

          private.Match3FallChipsEnd();

        end;

      end;
    } );

  end;
------------------------------------------------------------
  function private.Match3FallChipsEnd ()

    common_impl.Lock( false );

    private.match3_first_chip = nil;

    for i = 1, private.match3_cell_y do

      for j = 1, private.match3_cell_x do

        ng_global.progress[ "ext" ][ "win_match_3" ].match3_field[ i ][ j ] = private.match3_field[ i ][ j ];

      end;

    end;



    if ( private.match3.points >= private.match3_points_win ) then
      
      private.Match3WinAnim();

    else
      
      ng_global.progress[ "ext" ][ "win_match_3" ].match3.points = private.match3.points;

    end;

  end;
------------------------------------------------------------
  function private.Match3ProgressBarSet()

    local value    = private.match3.points;
    local max      = private.match3_points_win;
    local num_bars = 29;
    local cur_bars = math.floor(value/max*num_bars);
 
    local table_multiset = {};

    for i = 1,num_bars do

      if ( i < cur_bars ) then

        table.insert( table_multiset, { "spr_instantlottery_progrees_bar_green_"..i, { alp = 1 }  } );
        table.insert( table_multiset, { "spr_instantlottery_progrees_bar_red_"..i, { alp = 0 }  } );

      else

        table.insert( table_multiset, { "spr_instantlottery_progrees_bar_green_"..i, { alp = 0 }  } );
        table.insert( table_multiset, { "spr_instantlottery_progrees_bar_red_"..i, { alp = 1 }  } );

      end;

    end;

    if ( #table_multiset > 0 ) then

      ObjMultiSet( table_multiset );
    
    end;

  end;
------------------------------------------------------------
  function private.Match3ProgressBarInit ()

      local step_x = 12;
      
      local num_bars = 29;

      for i = 1, num_bars do

        ObjCreate( "spr_instantlottery_progrees_bar_green_"..i, "spr" );
        ObjCreate( "spr_instantlottery_progrees_bar_red_"..i, "spr");

        ObjAttach( "spr_instantlottery_progrees_bar_green_"..i, "obj_instantlottery_progrees_bar_green" );
        ObjAttach( "spr_instantlottery_progrees_bar_red_"..i, "obj_instantlottery_progrees_bar_red" );

        ObjSet( "spr_instantlottery_progrees_bar_green_"..i,
        { 
          alp = 0,
          input = false,
          pos_x = step_x*i,
          res = "assets/levels/levelext/rm_parkinglot/zz_instantlottery/layers/green_lamp_indikator",

        });

        ObjSet( "spr_instantlottery_progrees_bar_red_"..i,
        { 
          alp = 0,
          input = false,
          pos_x = step_x*i,
          res = "assets/levels/levelext/rm_parkinglot/zz_instantlottery/layers/red_lamp_indikator",

        });

      end;

  end;
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.Init_Animation ()

  ObjAnimate( "spr_bush_bush_1", "pos_xy", 1, 0, "", 
  { 
    0.0, 3, -199, 72,     
    4.0, 3, -190, 67,
    8.0, 3, -199, 72,
  } );
  ObjAnimate( "spr_bush_bush_2", "pos_xy", 1, 0, "", 
  { 
    0.0, 3, 105, -74,  
    3.3, 3, 112, -82,
    6.6, 3, 105, -74,
  } );
  ObjAnimate( "spr_parkinglot_light_taxi", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.0, 0, 0,
    2.0, 0, 1,
  } );
  ObjAnimate( "spr_parkinglot_light_1", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    3.0, 0, 0,
    6.0, 0, 1,
  } );

  private.car_delay = { 11, 3.5, 5 };
  private.AnimationsCarStep1();

end;
--------------------------------------------------------------------------------------------
function private.Pigeon_Fly_Animation ()

  local func_end = function ()

    ObjSet( "tmr_parkinglot_pigeon_fly", { time = 30, playing = true, endtrig = function() private.Pigeon_Fly_Animation() end } );

  end
  
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_wings", 0, "", 0 );

  AnimPlay( "anm_parkinglot_pigeon_fly", "DoAnim", func_end );

end;
--------------------------------------------------------------------------------------------
function private.AnimationsCarStep1 ()

  AnimPlay( "anm_parkinglot_all", "DoAnim", "" );

  ObjSet( "tmr_parkinglot_car", { playing = 1, time = private.car_delay[ 1 ], endtrig = function () 

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_single_car1", 0, "", 0 );

    private.AnimationsCarStep2();

  end } );

end;
--------------------------------------------------------------------------------------------
function private.AnimationsCarStep2 ()

  ObjSet( "tmr_parkinglot_car", { playing = 1, time = private.car_delay[ 2 ], endtrig = function () 

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_single_car2", 0, "", 0 );

    private.AnimationsCarStep3();

  end } );

end;
--------------------------------------------------------------------------------------------
function private.AnimationsCarStep3 ()

  ObjSet( "tmr_parkinglot_car", { playing = 1, time = private.car_delay[ 3 ], endtrig = function () 

    private.AnimationsCarStep1();

  end } );

end;
--*********************************************************************************************************************
-- function *** FEEDBACKANIM *** () end;
--*********************************************************************************************************************
function private.UseOilcan_ext_2 ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( "bbt_billboard_use_oilcan_ext_2" );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_lever", 0, "", 0 );

  ObjAnimate( "spr_billboard_hand_1", "ang", 0, 0, func_end, 
  { 
    0.00, 0,     0, 
    0.15, 0, -0.11,     
    0.30, 0,     0,
  } );

end;
--------------------------------------------------------------------------------------------
function private.UseExternaldisk ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_bush_use_externaldisk' );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

  ObjAnimate( "obj_bush_box_1", "pos_xy", 0, 0, func_end, 
  { 
    0.00, 0, ObjGet( "obj_bush_box_1" ).pos_x,     ObjGet( "obj_bush_box_1" ).pos_y, 
    0.15, 0, ObjGet( "obj_bush_box_1" ).pos_x + 3, ObjGet( "obj_bush_box_1" ).pos_y + 3 ,     
    0.30, 0, ObjGet( "obj_bush_box_1" ).pos_x,     ObjGet( "obj_bush_box_1" ).pos_y,
  } );

end;
--------------------------------------------------------------------------------------------
function private.UseInternaldisk ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_bush_use_internaldisk' );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

  ObjAnimate( "obj_bush_box_2", "pos_xy", 0, 0, func_end, 
  { 
    0.00, 0, ObjGet( "obj_bush_box_2" ).pos_x,     ObjGet( "obj_bush_box_2" ).pos_y, 
    0.15, 0, ObjGet( "obj_bush_box_2" ).pos_x + 3, ObjGet( "obj_bush_box_2" ).pos_y + 3 ,     
    0.30, 0, ObjGet( "obj_bush_box_2" ).pos_x,     ObjGet( "obj_bush_box_2" ).pos_y,
  } );

end;
--------------------------------------------------------------------------------------------
function private.UseLetter_I ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( "bbt_postmanthings_use_letter_i" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_button", 0, "", 0 );
  ObjAnimate( "spr_postmanthings_cover_i", "pos_xy", 0, 0, func_end, 
  { 
    0.00, 0, ObjGet( "spr_postmanthings_cover_i" ).pos_x,     ObjGet( "spr_postmanthings_cover_i" ).pos_y, 
    0.15, 0, ObjGet( "spr_postmanthings_cover_i" ).pos_x + 3, ObjGet( "spr_postmanthings_cover_i" ).pos_y - 1,     
    0.30, 0, ObjGet( "spr_postmanthings_cover_i" ).pos_x,     ObjGet( "spr_postmanthings_cover_i" ).pos_y,
  } );

end;
--------------------------------------------------------------------------------------------
function private.UseLetter_T ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( "bbt_postmanthings_use_letter_t" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_button", 0, "", 0 );
  ObjAnimate( "spr_postmanthings_cover_t", "pos_xy", 0, 0, func_end, 
  { 
    0.00, 0, ObjGet( "spr_postmanthings_cover_t" ).pos_x,     ObjGet( "spr_postmanthings_cover_t" ).pos_y, 
    0.15, 0, ObjGet( "spr_postmanthings_cover_t" ).pos_x - 3, ObjGet( "spr_postmanthings_cover_t" ).pos_y + 1,     
    0.30, 0, ObjGet( "spr_postmanthings_cover_t" ).pos_x,     ObjGet( "spr_postmanthings_cover_t" ).pos_y,
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_pigeon ()

  local func_end = function()

    local func_end_1 = function ()

      cmn.Lock( false );
      ObjDelete( "obj_parkinglot_clk_pigeon" );
      ObjDelete( "anm_parkinglot_pigeon_1" );
      ObjSet( "anm_parkinglot_pigeon_1_1", { alp = 1, playing = true } );      
      ng_global.progress[ "ext" ][ "opn_parkinglot" ].pigeon = 1;

    end;

    ObjAnimate( "anm_parkinglot_pigeon_1", "alp", 0, 0, "", 
    { 
      0.00, 0, 1, 
      0.05, 0, 1,  
      0.10, 0, 0,
    } );   
    ObjAnimate( "anm_parkinglot_pigeon_1_1", "alp", 0, 0, func_end_1, 
    { 
      0.00, 0, 0, 
      0.05, 0, 1,  
      0.10, 0, 1, 
    } ); 
 
  end;

  cmn.Lock( true );
  AnimPlay( "anm_parkinglot_pigeon_1", "DoAnim", func_end );

end;
--------------------------------------------------------------------------------------------
function private.UsePostmankey ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_postmanthings_use_postmankey' );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_cloth1", 0, "", 0 );

  ObjAnimate( "spr_postmanthings_cover_bag", "pos_xy", 0, 0, func_end, 
  { 
    0.00, 0, ObjGet( "spr_postmanthings_cover_bag" ).pos_x,     ObjGet( "spr_postmanthings_cover_bag" ).pos_y, 
    0.15, 0, ObjGet( "spr_postmanthings_cover_bag" ).pos_x - 3, ObjGet( "spr_postmanthings_cover_bag" ).pos_y + 2,     
    0.30, 0, ObjGet( "spr_postmanthings_cover_bag" ).pos_x,     ObjGet( "spr_postmanthings_cover_bag" ).pos_y,
  } );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_parkinglot ()

  if not ( cmn.IsEventDone( "opn_parkinglot" ) ) then

    cmn.SetEventDone( "opn_parkinglot" );
    common_impl.ShowBbt( "bbt_parkinglot_opn_parkinglot" );

  end;

  cmn.CallEventHandler( "opn_parkinglot" ); 

end;
--------------------------------------------------------------------------------------------
function private.ClkPaper ()

  cmn.NoteScale( "spr_postmanthings_paper" );

  if not ( cmn.IsEventDone( "clk_clip_1" ) ) then

    ObjSet( "obj_postmanthings_paper_hint", { pos_x = 124, pos_y = -207 } );

  else

    ObjSet( "obj_postmanthings_paper_hint", { pos_x = -104, pos_y = -107 } );    

  end;

end;
--------------------------------------------------------------------------------------------
function private.ClkPaperBig ()

  cmn.NoteScale( "spr_postmanthings_paper" );
  ObjSet( "obj_postmanthings_paper_hint", { pos_x = 3, pos_y = -147 } );

end;
--*********************************************************************************************************************
function private.ClkBird()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_billboard_use_corn' );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_pigeon", 0, "", 0 );

  ObjAnimate( "anm_billboard_bird_with_coin", "alp", 0, 0, func_end, 
  { 
    0.0, 0, 1,
    0.3, 0, 1, 
 } );

end;
--------------------------------------------------------------------------------------------
