-- name=rm_porch_ext
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_porch_ext";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_callbox", "room_hub" );
  ObjAttach( "zz_gate", "room_hub" );
  ObjAttach( "zz_wall", "room_hub" );
  ObjAttach( "zz_frontdoor", "room_hub" );
  private.Init_Subroom();
  private.InitAnimations();

  ObjMultiSet( { 
    { "spr_gate_stone",                               { event_mdown = private.get_stone } },
    { "spr_gate_stick",                               { event_mdown = private.get_stick } },
    { "spr_wall_gumboots",                            { event_mdown = private.get_gumboots } },
    { "spr_wall_sharpening",                          { event_mdown = private.get_sharpening } },
    { "spr_wall_lever_ext",                           { event_mdown = private.get_lever_ext } },
    { "spr_frontdoor_joshcard",                       { event_mdown = private.get_joshcard } },
    { "obj_callbox_clk_phone",                        { event_mdown = private.see_call_kane_2 } },
    { "obj_gate_clk_stick_1",                         { event_mdown = private.clk_stick_1 } },
    { "obj_gate_clk_stick_2",                         { event_mdown = private.clk_stick_2 } },
    { "obj_frontdoor_clk_wrench_ext",                 { event_mdown = private.clk_wrench_ext } },
    { "obj_frontdoor_use_wrench_ext",                 { event_mdown = private.FrontdoorFeedbackAnim } },
    { "obj_wall_clk_peg_1",                           { event_mdown = private.clk_peg_1 } },
    { "obj_wall_clk_peg_2",                           { event_mdown = private.clk_peg_2 } },
    { "obj_wall_clk_wheel",                           { event_mdown = private.clk_wheel } },
    { "obj_wall_use_peg",                             { event_mdown = private.WallFeedbackAnim } },
    { "obj_wall_use_wheel",                           { event_mdown = private.WallClickWheel } },
    { "obj_porch_ext_logo",                           { event_mdown = private.Logo } },
    { "obj_callbox_clk_paper",                        { event_mdown = private.ClkPaper } },
  } );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_porch_ext = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "grm_porch_ext_parkinglot",
      "grm_porch_ext_nearcafe",
      "grm_porch_ext_hall_ext",
      "gho_porch_ext_droppedtreecrown",
      "gmg_porch_ext_hoteldoor",
      "gzz_porch_ext_callbox",
      "gzz_porch_ext_gate",
      "gzz_porch_ext_wall",
      "gzz_porch_ext_frontdoor",
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_gate",
      "zz_callbox",
      "zz_frontdoor",
      "zz_wall",
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_porch_ext", update_game_mode_porch_ext, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_porch_ext = function ()

  local effects_table = 
  {
    "obj_porch_ext_anim",
    "anm_porch_ext_background", 
    "anm_porch_ext_stone_tree",
    "tmr_porch_ext_paper", 
    "vid_porch_ext_paper", 
  };

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_porch_ext", update_performance_mode_porch_ext, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_porch_ext () end;
  --------------------------------------------------------------------------------------------
  local opn_porch_ext_map = function ()

    common_impl.VisitMapRoom( "porch" );

    common_impl.LockMapRoom( "parkinglot", true );
    common_impl.LockMapRoom( "apartment",  true );

  end;
  cmn.AddSubscriber( "opn_porch_ext", opn_porch_ext_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_ironpiece () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ironpiece" ] = {
    type = "get",
    get_obj = "spr_callbox_ironpiece",
    room = private.room_objname,
    zz = "zz_callbox",
    zz_gate = "gzz_porch_ext_callbox"
  };
  
  local get_ironpiece_inv = function ()
  
    interface.InventoryItemAdd( "inv_ironpiece", "spr_callbox_ironpiece" );
  
  end;
  
  local get_ironpiece_closezz = function ()
  
    ObjDelete( "gfx_callbox_ironpiece" );
    ObjDelete( "gzz_porch_ext_callbox" );  

  end;
  
  cmn.AddSubscriber( "get_ironpiece", get_ironpiece_inv );
  cmn.AddSubscriber( "get_ironpiece", get_ironpiece_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stone () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stone" ] = {
    type = "get",
    get_obj = "spr_gate_stone",
    room = private.room_objname,
    zz = "zz_gate",
    zz_gate = "gzz_porch_ext_gate"
  };
  
  local get_stone_inv = function ()
  
    interface.InventoryItemAdd( "inv_stone", "spr_gate_stone" );
  
  end;
  
  local get_stone_closezz = function ()

    if ( cmn.IsEventDone( "use_gumboots" ) ) then

      ObjDelete( "gzz_porch_ext_gate" );      

    end;

    ObjDelete( "gfx_gate_stone" );
    ObjDelete( "spr_zz_gate_stone_shadow" );
    ObjDelete( "spr_porch_ext_zz_gates_stone_layer" );  

  end;
  
  cmn.AddSubscriber( "get_stone", get_stone_inv );
  cmn.AddSubscriber( "get_stone", get_stone_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stick () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stick" ] = {
    type = "get",
    get_obj = "gfx_gate_stick",
    room = private.room_objname,
    zz = "zz_gate",
    zz_gate = "gzz_porch_ext_gate"
  };
  
  local get_stick_inv = function ()
  
    interface.InventoryItemAdd( "inv_stick", "spr_gate_stick" );
    ObjSet( "inv_stick", { drag = false } );   
    cmn.SetInvPlusRGB( "stick", true );  
  
  end;
  
  local get_stick_closezz = function ()
  
    ObjDelete( "gfx_gate_stick" );
    ObjDelete( "spr_zz_gate_stick_shadow" );
    ObjDelete( "spr_porch_ext_zz_gates_stick_layer" );

  end;
  
  cmn.AddSubscriber( "get_stick", get_stick_inv );
  cmn.AddSubscriber( "get_stick", get_stick_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gumboots () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_gumboots" ] = {
    type = "get",
    get_obj = "spr_wall_gumboots",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_porch_ext_wall"
  };
  
  local get_gumboots_inv = function ()
  
    interface.InventoryItemAdd( "inv_gumboots", "spr_wall_gumboots" );
  
  end;
  
  local get_gumboots_closezz = function ()
  
    ObjDelete( "spr_porch_ext_wall_gumboots" );
    ObjDelete( "gfx_wall_gumboots" );
    ObjDelete( "spr_zz_wall_gumboots_shadow" );
    ObjSet( "obj_wall_use_ironpiece", { input = true } );
  
  end;
  
  cmn.AddSubscriber( "get_gumboots", get_gumboots_inv );
  cmn.AddSubscriber( "get_gumboots", get_gumboots_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sharpening () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sharpening" ] = {
    type = "get",
    get_obj = "spr_wall_sharpening",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_porch_ext_wall"
  };
  
  local get_sharpening_inv = function ()
  
    interface.InventoryItemAdd( "inv_sharpening", "spr_wall_sharpening" );
  
  end;
  
  local get_sharpening_closezz = function ()
  
    ObjDelete( "gfx_wall_sharpening" );
  
  end;
  
  cmn.AddSubscriber( "get_sharpening", get_sharpening_inv );
  cmn.AddSubscriber( "get_sharpening", get_sharpening_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lever_ext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lever_ext" ] = {
    type = "get",
    get_obj = "spr_wall_lever_ext",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_porch_ext_wall"
  };
  
  local get_lever_ext_inv = function ()
  
    interface.InventoryItemAdd( "inv_lever_ext", "spr_wall_lever_ext" );
  
  end;
  
  local get_lever_ext_closezz = function ()
  
    ObjDelete( "spr_zz_wall_lever_shadow" );
    ObjDelete( "gfx_wall_lever_ext" );
    ObjDelete( "gzz_porch_ext_wall" );
    ObjDelete( "spr_porch_ext_wall_lever_layer" );

  end;
  
  cmn.AddSubscriber( "get_lever_ext", get_lever_ext_inv );
  cmn.AddSubscriber( "get_lever_ext", get_lever_ext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_joshcard () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_joshcard" ] = {
    type = "get",
    get_obj = "spr_frontdoor_joshcard",
    room = private.room_objname,
    zz = "zz_frontdoor",
    zz_gate = "gzz_porch_ext_frontdoor"
  };
  
  local get_joshcard_inv = function ()
  
    interface.InventoryItemAdd( "inv_joshcard", "spr_frontdoor_joshcard" );
  
  end;
  
  local get_joshcard_closezz = function ()
  
    ObjDelete( "gfx_frontdoor_joshcard" );
    ObjDelete( "spr_frontdoor_joshcard_shadow" );
    ObjDelete( "spr_porch_ext_frontdoor_card_layer" );  

  end;
  
  cmn.AddSubscriber( "get_joshcard", get_joshcard_inv );
  cmn.AddSubscriber( "get_joshcard", get_joshcard_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hacksaw () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hacksaw" ] = {
    type = "use",
    inv_obj = "inv_hacksaw",
    use_place = "obj_callbox_use_hacksaw",
    room = private.room_objname,
    zz = "zz_callbox",
    zz_gate = "gzz_porch_ext_callbox"
  };
  local use_hacksaw_inv = function ()
  
    interface.InventoryItemRemove( "inv_hacksaw" );
  
  end;
  local use_hacksaw_beg = function ()
  
    ObjDelete( "obj_callbox_use_hacksaw" );
  
  end;
  local use_hacksaw_end = function ()
  
    ObjDelete( "anm_zz_callbox_use_hacksaw" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hacksaw", use_hacksaw_beg, private.room_objname );
  cmn.AddSubscriber( "use_hacksaw", use_hacksaw_inv );
  cmn.AddSubscriber( "use_hacksaw", use_hacksaw_end, private.room_objname );
  cmn.AddSubscriber( "use_hacksaw_inv", use_hacksaw_inv, private.room_objname );
  cmn.AddSubscriber( "use_hacksaw_beg", use_hacksaw_beg, private.room_objname );
  cmn.AddSubscriber( "use_hacksaw_end", use_hacksaw_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gumboots () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gumboots" ] = {
    type = "use",
    inv_obj = "inv_gumboots",
    use_place = "obj_gate_use_gumboots",
    room = private.room_objname,
    zz = "zz_gate",
    zz_gate = "gzz_porch_ext_gate"
  };
  local use_gumboots_inv = function ()
  
    interface.InventoryItemRemove( "inv_gumboots" );
  
  end;
  local use_gumboots_beg = function ()
  
    ObjDelete( "obj_gate_use_gumboots" );
  
  end;
  local use_gumboots_end = function ()

    if ( cmn.IsEventDone( "get_stone" ) ) then
    
      ObjDelete( "gzz_porch_ext_gate" );

    end;
    
    ObjSet( "grm_porch_ext_nearcafe", { input = true, visible = true, active = true, alp = 1 } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_porch_ext_nearcafe_focus");
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gumboots", use_gumboots_beg, private.room_objname );
  cmn.AddSubscriber( "use_gumboots", use_gumboots_inv );
  cmn.AddSubscriber( "use_gumboots", use_gumboots_end, private.room_objname );
  cmn.AddSubscriber( "use_gumboots_inv", use_gumboots_inv, private.room_objname );
  cmn.AddSubscriber( "use_gumboots_beg", use_gumboots_beg, private.room_objname );
  cmn.AddSubscriber( "use_gumboots_end", use_gumboots_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_peg () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_peg" ] = {
    type = "use",
    inv_obj = "inv_peg",
    use_place = "obj_wall_use_peg",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_porch_ext_wall"
  };
  local use_peg_inv = function ()
  
    interface.InventoryItemRemove( "inv_peg" );
  
  end;
  local use_peg_beg = function ()
  
    ObjDelete( "obj_wall_use_peg" );
  
  end;
  local use_peg_end = function ()
  
    ObjSet( "obj_wall_clk_peg_1", { input = true } );
    ObjSet( "spr_zz_wall_wedge_2", { alp = 1, visible = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_peg", use_peg_beg, private.room_objname );
  cmn.AddSubscriber( "use_peg", use_peg_inv );
  cmn.AddSubscriber( "use_peg", use_peg_end, private.room_objname );
  cmn.AddSubscriber( "use_peg_inv", use_peg_inv, private.room_objname );
  cmn.AddSubscriber( "use_peg_beg", use_peg_beg, private.room_objname );
  cmn.AddSubscriber( "use_peg_end", use_peg_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wheel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wheel" ] = {
    type = "use",
    inv_obj = "inv_wheel",
    use_place = "obj_wall_use_wheel",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_porch_ext_wall"
  };
  local use_wheel_inv = function ()
  
    interface.InventoryItemRemove( "inv_wheel" );
  
  end;
  local use_wheel_beg = function ()
  
    ObjDelete( "obj_wall_use_wheel" );
  
  end;
  local use_wheel_end = function ()
  
    ObjSet( "obj_wall_clk_wheel", { input = true } );
    ObjSet( "spr_zz_wall_cogwheel5_slot", { alp = 1, visible = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wheel", use_wheel_beg, private.room_objname );
  cmn.AddSubscriber( "use_wheel", use_wheel_inv );
  cmn.AddSubscriber( "use_wheel", use_wheel_end, private.room_objname );
  cmn.AddSubscriber( "use_wheel_inv", use_wheel_inv, private.room_objname );
  cmn.AddSubscriber( "use_wheel_beg", use_wheel_beg, private.room_objname );
  cmn.AddSubscriber( "use_wheel_end", use_wheel_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ironpiece () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ironpiece" ] = {
    type = "use",
    inv_obj = "inv_ironpiece",
    use_place = "obj_wall_use_ironpiece",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_porch_ext_wall"
  };
  local use_ironpiece_inv = function ()
  
    interface.InventoryItemRemove( "inv_ironpiece" );
  
  end;
  local use_ironpiece_beg = function ()
  
    ObjDelete( "obj_wall_use_ironpiece" );
  
  end;
  local use_ironpiece_end = function ()
  
    ObjDelete( "anm_zz_wall_use_ironpiece" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ironpiece", use_ironpiece_beg, private.room_objname );
  cmn.AddSubscriber( "use_ironpiece", use_ironpiece_inv );
  cmn.AddSubscriber( "use_ironpiece", use_ironpiece_end, private.room_objname );
  cmn.AddSubscriber( "use_ironpiece_inv", use_ironpiece_inv, private.room_objname );
  cmn.AddSubscriber( "use_ironpiece_beg", use_ironpiece_beg, private.room_objname );
  cmn.AddSubscriber( "use_ironpiece_end", use_ironpiece_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wrench_ext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wrench_ext" ] = {
    type = "use",
    inv_obj = "inv_wrench_ext",
    use_place = "obj_frontdoor_use_wrench_ext",
    room = private.room_objname,
    zz = "zz_frontdoor",
    zz_gate = "gzz_porch_ext_frontdoor"
  };
  local use_wrench_ext_inv = function ()
  
    interface.InventoryItemRemove( "inv_wrench_ext" );
  
  end;
  local use_wrench_ext_beg = function ()
  
    ObjDelete( "obj_frontdoor_use_wrench_ext" );
  
  end;
  local use_wrench_ext_end = function ()
      
    ObjSet( "obj_frontdoor_clk_wrench_ext", { input = true } );
    ObjDelete( "anm_zz_frontdoor_use_wrench_ext" );
    ObjDelete( "obj_zz_frontdoor_screws" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wrench_ext", use_wrench_ext_beg, private.room_objname );
  cmn.AddSubscriber( "use_wrench_ext", use_wrench_ext_inv );
  cmn.AddSubscriber( "use_wrench_ext", use_wrench_ext_end, private.room_objname );
  cmn.AddSubscriber( "use_wrench_ext_inv", use_wrench_ext_inv, private.room_objname );
  cmn.AddSubscriber( "use_wrench_ext_beg", use_wrench_ext_beg, private.room_objname );
  cmn.AddSubscriber( "use_wrench_ext_end", use_wrench_ext_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_joshcard () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_joshcard" ] = {
    type = "use",
    inv_obj = "inv_joshcard",
    use_place = "obj_frontdoor_use_joshcard",
    room = private.room_objname,
    zz = "zz_frontdoor",
    zz_gate = "gzz_porch_ext_frontdoor"
  };
  local use_joshcard_inv = function ()
  
    interface.InventoryItemRemove( "inv_joshcard" );
  
  end;
  local use_joshcard_beg = function ()
  
    ObjDelete( "obj_frontdoor_use_joshcard" );
  
  end;
  local use_joshcard_end = function ()

    ObjSet( "spr_zz_frontdoor_card_in", { alp = 1, visible = true } );
    ObjSet( "spr_zz_frontdoor_green_arrow", { alp = 1, visible = true } );
    ObjSet( "gmg_porch_ext_hoteldoor", { input = true, visible = true, active = true, alp = 1 } );
    ObjDelete( "gzz_porch_ext_frontdoor" );
    ObjDelete( "spr_porch_ext_frontdoor_red_light" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_joshcard", use_joshcard_beg, private.room_objname );
  cmn.AddSubscriber( "use_joshcard", use_joshcard_inv );
  cmn.AddSubscriber( "use_joshcard", use_joshcard_end, private.room_objname );
  cmn.AddSubscriber( "use_joshcard_inv", use_joshcard_inv, private.room_objname );
  cmn.AddSubscriber( "use_joshcard_beg", use_joshcard_beg, private.room_objname );
  cmn.AddSubscriber( "use_joshcard_end", use_joshcard_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_stone () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_stone" ] = {
    type = "use",
    inv_obj = "inv_stone",
    use_place = "obj_porch_ext_use_stone",
    zz = "slider_right",
    room = private.room_objname,
  };
  local use_stone_inv = function ()
  
    interface.InventoryItemRemove( "inv_stone" );
  
  end;
  local use_stone_beg = function ()
  
    ObjDelete( "obj_porch_ext_use_stone" );
  
  end;
  local use_stone_end = function ()
  
    ObjSet( "gho_porch_ext_droppedtreecrown", { input = true, active = true, alp = 1 } );
    ObjSet( "spr_porch_ext_treecrown_layer", { alp = 1 } );
    ObjDelete( "anm_porch_ext_stone_stone" );
    ObjDelete( "anm_porch_ext_stone_tree" );  

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_stone", use_stone_beg, private.room_objname );
  cmn.AddSubscriber( "use_stone", use_stone_inv );
  cmn.AddSubscriber( "use_stone", use_stone_end, private.room_objname );
  cmn.AddSubscriber( "use_stone_inv", use_stone_inv, private.room_objname );
  cmn.AddSubscriber( "use_stone_beg", use_stone_beg, private.room_objname );
  cmn.AddSubscriber( "use_stone_end", use_stone_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_stick_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_stick_1" ] = {
    type = "click",
    use_place = "obj_gate_clk_stick_1",
    room = private.room_objname,
    zz = "zz_gate",
    zz_gate = "gzz_porch_ext_gate"
  };

  local clk_stick_1_beg = function ()

    ObjDelete( "obj_gate_clk_stick_1" );
  
  end;
  local clk_stick_1_end = function ()

    ObjSet( "obj_gate_clk_stick_2", { input = true } );
    ObjSet( "spr_gate_stick", { ang = 0.2 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_stick_1", clk_stick_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_stick_1", clk_stick_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_stick_1_beg", clk_stick_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_stick_1_end", clk_stick_1_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_stick_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_stick_2" ] = {
    type = "click",
    use_place = "obj_gate_clk_stick_2",
    room = private.room_objname,
    zz = "zz_gate",
    zz_gate = "gzz_porch_ext_gate"
  };

  local clk_stick_2_beg = function ()

    ObjDelete( "obj_gate_clk_stick_2" );
  
  end;
  local clk_stick_2_end = function ()

    ObjSet( "spr_gate_stick", { ang = -0.2, input = true } );
    ObjSet( "gfx_gate_stick", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_stick_2", clk_stick_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_stick_2", clk_stick_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_stick_2_beg", clk_stick_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_stick_2_end", clk_stick_2_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_wrench_ext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_wrench_ext" ] = {
    type = "click",
    use_place = "obj_frontdoor_clk_wrench_ext",
    room = private.room_objname,
    zz = "zz_frontdoor",
    zz_gate = "gzz_porch_ext_frontdoor"
  };

  local clk_wrench_ext_beg = function ()

    ObjDelete( "obj_frontdoor_clk_wrench_ext" );
  
  end;
  local clk_wrench_ext_end = function ()

    ObjSet( "spr_frontdoor_joshcard", { input = true } );
    ObjSet( "gfx_frontdoor_joshcard", { active = true } );
    ObjSet( "spr_zz_frontdoor_grid", { pos_x = -137, pos_y = 265 } );
    ObjSet( "spr_porch_ext_frontdoor_grill_layer", { pos_x = 401, pos_y = 507 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_wrench_ext", clk_wrench_ext_beg, private.room_objname );
  cmn.AddSubscriber( "clk_wrench_ext", clk_wrench_ext_end, private.room_objname );
  cmn.AddSubscriber( "clk_wrench_ext_beg", clk_wrench_ext_beg, private.room_objname );
  cmn.AddSubscriber( "clk_wrench_ext_end", clk_wrench_ext_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_peg_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_peg_1" ] = {
    type = "click",
    use_place = "obj_wall_clk_peg_1",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_porch_ext_wall"
  };

  local clk_peg_1_beg = function ()

    ObjDelete( "obj_wall_clk_peg_1" );
  
  end;
  local clk_peg_1_end = function ()

    ObjSet( "obj_wall_clk_peg_2", { input = true } );
    ObjSet( "spr_zz_wall_door_half_opened", { alp = 1, visible = true } );
    ObjDelete( "spr_zz_wall_door_closed" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_peg_1", clk_peg_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_peg_1", clk_peg_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_peg_1_beg", clk_peg_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_peg_1_end", clk_peg_1_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_peg_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_peg_2" ] = {
    type = "click",
    use_place = "obj_wall_clk_peg_2",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_porch_ext_wall"
  };

  local clk_peg_2_beg = function ()

    ObjDelete( "obj_wall_clk_peg_2" );
  
  end;
  local clk_peg_2_end = function ()

    ObjSet( "spr_wall_gumboots", { input = true } );
    ObjSet( "obj_wall_use_wheel", { input = true } );
    ObjSet( "spr_zz_wall_door_opened", { alp = 1, visible = true } );
    ObjSet( "spr_porch_ext_wall_opendoor", { alp = 1 } );
    ObjSet( "spr_porch_ext_wall_mechanism", { alp = 1 } );

    ObjDelete( "spr_zz_wall_door_half_opened" );
    ObjDelete( "spr_porch_ext_wall_close" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_peg_2", clk_peg_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_peg_2", clk_peg_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_peg_2_beg", clk_peg_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_peg_2_end", clk_peg_2_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_wheel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_wheel" ] = {
    type = "click",
    use_place = "obj_wall_clk_wheel",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_porch_ext_wall"
  };

  local clk_wheel_beg = function ()

    ObjDelete( "obj_wall_clk_wheel" );
  
  end;
  local clk_wheel_end = function ()

    ObjSet( "spr_wall_lever_ext", { input = true } );
    ObjDelete( "spr_zz_wall_mechanism_back" );
    ObjDelete( "spr_porch_ext_wall_mechanism" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_wheel", clk_wheel_beg, private.room_objname );
  cmn.AddSubscriber( "clk_wheel", clk_wheel_end, private.room_objname );
  cmn.AddSubscriber( "clk_wheel_beg", clk_wheel_beg, private.room_objname );
  cmn.AddSubscriber( "clk_wheel_end", clk_wheel_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function see_call_kane_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_call_kane_2" ] = {
    type = "click",
    use_place = "obj_callbox_clk_phone",
    room = private.room_objname,
    zz = "zz_callbox",
    zz_gate = "gzz_porch_ext_callbox"
  };

  local see_call_kane_2 = function ()

    ObjDelete( "obj_callbox_clk_phone" );
    ObjDelete( "anm_zz_callbox_calling_phone" );
    ObjDelete( "anm_zz_callbox_calling_phone_click" );
    ObjSet( "spr_callbox_phone", { alp = 1 } );
    
  end;
  cmn.AddSubscriber( "see_call_kane_2", see_call_kane_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_frontdoor () end;
  --------------------------------------------------------------------------------------------
  local see_frontdoor = function ()

    --ObjDelete( "" );
    ObjSet( "gzz_porch_ext_frontdoor", { input = true, active = true, alp = 1 } );

  end;
  cmn.AddSubscriber( "see_frontdoor", see_frontdoor, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_porch_ext_david_kane_2 () end;
  --------------------------------------------------------------------------------------------
  local dlg_porch_ext_david_kane_2 = function ()

    ObjDelete( "dlg_porch_ext_david_kane_2_lip" );
    ObjSet( "anm_porch_ext_phone", { frame = 0 } );
    AnimStop( "anm_porch_ext_phone" );
    ObjSet( "gzz_porch_ext_gate", { input = true, active = true, alp = 1 } );

  end;
  cmn.AddSubscriber( "dlg_porch_ext_david_kane_2", dlg_porch_ext_david_kane_2, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()

  common_impl.hint.position_zz[ "gzz_porch_ext_gate" ] = { "right" };
  common_impl.hint.position_zz[ "gho_porch_ext_droppedtreecrown" ] = { "right" };
  common_impl.hint.position_zz[ "gzz_porch_ext_callbox" ] = { "left" };
  common_impl.hint.position_zz[ "gmg_porch_ext_hoteldoor" ] = { "mid" };
  common_impl.hint.position_zz[ "gzz_porch_ext_frontdoor" ] = { "mid" };
  common_impl.hint.position_zz[ "gzz_porch_ext_wall" ] = { "mid", "left" };

  --*********************************************************************************************************************
  -- function zz_callbox () end;
  --*********************************************************************************************************************
    subroom.Define( "zz_callbox" );
    function zz_callbox.PreOpen()
    end;
    -------------------------------------------------
    function zz_callbox.Open()

      if ( cmn.IsEventDone( "dlg_porch_ext_david_kane_2" ) and ng_global.progress[ "ext" ][ "opn_porch_ext" ].see_numbers == 0 ) then

        local func_end = function ()

          cmn.Lock( false );
          ng_global.progress[ "ext" ][ "opn_porch_ext" ].see_numbers = 1; 
          ObjMultiSet( {
            { "anm_callbox_pen",      { alp = 0 } },
            { "spr_zz_callbox_diner", { alp = 1 } },
          } );
          common.CloseSubRoom();

        end;

        cmn.Lock( true );
        AnimPlay( "anm_callbox_time_1", "DoAnim", func_end );
        ObjSet( "anm_callbox_pen", { alp = 1 } );

        common_impl.PlayAudio( "sfx", "levelext/sfx/aud_see_date", 0, "", 0 );

        local func_end_pen = function ()

          ObjMultiSet( {
            { "anm_callbox_pen",      { alp = 0 } },
            { "spr_zz_callbox_diner", { alp = 1 } },
          } );

        end;
        AnimPlay( "anm_callbox_pen", "DoAnim", func_end_pen );

        common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_pen", 0, "", 0 );

      end;

    end;
    -------------------------------------------------
    function zz_callbox.PreClose()
    end;
    -------------------------------------------------
    function zz_callbox.Close()

      if ( cmn.IsEventDone( "dlg_porch_ext_david_kane_2" ) and ng_global.progress[ "ext" ][ "opn_porch_ext" ].see_gate == 0 ) then

        private.ScaleGate();        

      end;

    end;
    -------------------------------------------------

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_porch_ext();
  int_slider.InitSlider( private.room_objname );

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

  private.Paper();

  if ( not ng_global.progress[ "ext" ][ "opn_porch_ext" ].see_phone ) then

    ng_global.progress[ "ext" ][ "opn_porch_ext" ].see_phone = 0;
    
  end;
  if ( not ng_global.progress[ "ext" ][ "opn_porch_ext" ].see_gate ) then

    ng_global.progress[ "ext" ][ "opn_porch_ext" ].see_gate = 0;
    
  end;
  if ( not ng_global.progress[ "ext" ][ "opn_porch_ext" ].see_numbers ) then

    ng_global.progress[ "ext" ][ "opn_porch_ext" ].see_numbers = 0;
    
  end;

  if ( ng_global.progress[ "ext" ][ "opn_porch_ext" ].see_numbers == 1 ) then

    ObjMultiSet( {
      { "anm_callbox_pen",      { alp = 0 } },
      { "spr_zz_callbox_diner", { alp = 1 } },
    } );

  end;

  if ( ng_global.progress[ "ext" ][ "opn_porch_ext" ].see_phone == 0 ) then

    private.ScalePhone();

  else

    common_impl.TutorialShow( "tutorial_page_22" );

  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();

  common_impl.EnvPlay( { "level1/env/aud_porch_env" }, "", 0.5 );

  if ( not cmn.IsEventDone( "dlg_porch_ext_david_kane_2" ) ) then

    common_impl.PlayAudio( "env", "levelext/env/aud_payphone_env", 1, "", 0 );

  end;

  if ( cmn.IsEventDone( "get_wheel" ) and not cmn.IsEventDone( "see_frontdoor" ) ) then

    private.see_frontdoor();  

  end;

  if ( cmn.IsEventDone( "see_call_kane_2" ) and not cmn.IsEventDone( "dlg_porch_ext_david_kane_2" ) ) then

    private.dlg_david_kane_2_click();

  end;

  if ( not cmn.IsEventDone( "dlg_porch_ext_david_kane_2" ) ) then

    AnimPlay( "anm_porch_ext_phone", "DoAnim", "" );

  end;

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_hacksaw ()

  local item = "inv_hacksaw";

  if cmn.ApplyObj( item, "gzz_porch_ext_callbox" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_callbox", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_callbox_use_hacksaw" ) ) then

    cmn.CallEventHandler( "use_hacksaw_inv" );
    cmn.CallEventHandler( "use_hacksaw_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_hacksaw" );
      cmn.CallEventHandler( "use_hacksaw_end" );

      ObjSet( "spr_callbox_ironpiece", { alp = 1, pos_x = 411, pos_y = -15 } );
      private.get_ironpiece();

    end;

    local func_end_2 = function ()

      ObjSet( "spr_callbox_ironpiece", { alp = 0 } );

    end; 

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_saw", 0, "", 0 );

    ObjSet( "anm_zz_callbox_use_hacksaw", { alp = 0, visible = true } );
    ObjAnimate( "anm_zz_callbox_use_hacksaw", "alp",0,0, func_end_2, { 0, 0, 0,    0.3, 0, 1 } );
    AnimPlay( "anm_zz_callbox_use_hacksaw", "DoAnim", func_end );

  return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_gumboots ()

  local item = "inv_gumboots";

  if cmn.ApplyObj( item, "gzz_porch_ext_gate" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_gate", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_gate_use_gumboots" ) ) then

    cmn.CallEventHandler( "use_gumboots_inv" );
    cmn.CallEventHandler( "use_gumboots_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_gumboots" );
      cmn.CallEventHandler( "use_gumboots_end" );

      common.CloseSubRoom();

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_boots", 0, "", 0 );

  func_end();
  
  return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_peg ()

  local item = "inv_peg";

  if cmn.ApplyObj( item, "gzz_porch_ext_wall" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wall", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_wall_use_peg" ) ) then

    cmn.CallEventHandler( "use_peg_inv" );
    cmn.CallEventHandler( "use_peg_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_peg" );
      cmn.CallEventHandler( "use_peg_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_wedge", 0, "", 0 );

    cmn.ItemFly( "spr_zz_wall_wedge_2", func_end, 1.22 );
  
  return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_wheel ()

  local item = "inv_wheel";

  if cmn.ApplyObj( item, "gzz_porch_ext_wall" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wall", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_wall_use_wheel" ) ) then

    cmn.CallEventHandler( "use_wheel_inv" );
    cmn.CallEventHandler( "use_wheel_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_wheel" );
      cmn.CallEventHandler( "use_wheel_end" );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide_4", 0, "", 0 );

    ObjSet( "spr_zz_wall_cogwheel5_slot", { alp = 0, visible = true } );
    ObjAnimate( "spr_zz_wall_cogwheel5_slot", "alp",0,0, func_end, { 0, 0, 0,    0.6, 0, 1 } );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_ironpiece ()

  local item = "inv_ironpiece";

  if cmn.ApplyObj( item, "gzz_porch_ext_wall" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wall", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_wall_use_ironpiece" ) ) then

    cmn.CallEventHandler( "use_ironpiece_inv" );
    cmn.CallEventHandler( "use_ironpiece_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_ironpiece" );
      cmn.CallEventHandler( "use_ironpiece_end" );
      private.get_sharpening();

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_ironpiece", 0, "", 0 );
    ObjSet( "anm_wall_use_ironpiece", { alp = 1 } );
    AnimPlay( "anm_wall_use_ironpiece", "DoAnim", func_end );
  
  return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_wrench_ext ()

  local item = "inv_wrench_ext";

  if cmn.ApplyObj( item, "gzz_porch_ext_frontdoor" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_frontdoor", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_frontdoor_use_wrench_ext" ) ) then

    cmn.CallEventHandler( "use_wrench_ext_inv" );
    cmn.CallEventHandler( "use_wrench_ext_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_wrench_ext" );
      cmn.CallEventHandler( "use_wrench_ext_end" );

    end;

    local func_end_2 = function ()

      ObjSet( "obj_zz_frontdoor_screws", { alp = 0 } );

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_wrench_ext", 0, "", 0 );

    ObjSet( "anm_zz_frontdoor_use_wrench_ext", { alp = 0, visible = true } );
    ObjAnimate( "anm_zz_frontdoor_use_wrench_ext", "alp",0,0, func_end_2, { 0, 0, 0,    0.3, 0, 1 } );
    AnimPlay( "anm_zz_frontdoor_use_wrench_ext", "DoAnim", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_joshcard ()

  local item = "inv_joshcard";

  if cmn.ApplyObj( item, "gzz_porch_ext_frontdoor" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_frontdoor", nil, { 512, 360 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_frontdoor_use_joshcard" ) ) then

    cmn.CallEventHandler( "use_joshcard_inv" );
    cmn.CallEventHandler( "use_joshcard_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_joshcard" );
      cmn.CallEventHandler( "use_joshcard_end" );
      common.CloseSubRoom();
      cmn.GotoRoom( "mg_hoteldoor" );       

    end;

    cmn.Lock( true );
    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_joshcard", 0, "", 0 );

    cmn.ItemFly( "spr_zz_frontdoor_card_in", nil, 2.97 );
    ObjSet( "spr_zz_frontdoor_green_arrow", { alp = 0, visible = true } );
    ObjAnimate( "spr_zz_frontdoor_green_arrow", "alp",0,0, func_end, { 0, 0, 0,    1, 0, 0,    1.6, 0, 1,    1.9, 0, 1 } );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_stone ()

  local item = "inv_stone";

  if ( cmn.ApplyObj( item, "obj_porch_ext_use_stone" ) ) then

    cmn.CallEventHandler( "use_stone_inv" );
    cmn.CallEventHandler( "use_stone_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_stone" );
      cmn.CallEventHandler( "use_stone_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_stone", 0, "", 0 );
    ObjSet( "anm_porch_ext_stone_tree", { alp = 0 } );
    ObjSet( "anm_porch_ext_stone_stone", { alp = 1 } );
    AnimPlay( "anm_porch_ext_stone_stone", "stone", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_ironpiece ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_ironpiece" );
  cmn.CallEventHandler( "get_ironpiece" );
  common.CloseSubRoom();  

end;
--------------------------------------------------------------------------------------------
function private.get_stone ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_stone" );
  cmn.CallEventHandler( "get_stone" );
    
  if ( cmn.IsEventDone( "use_gumboots" ) ) then

    common.CloseSubRoom();  

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_stick ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_stick" );
  cmn.CallEventHandler( "get_stick" );

end;
--------------------------------------------------------------------------------------------
function private.get_gumboots ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_gumboots" );
  cmn.CallEventHandler( "get_gumboots" );

end;
--------------------------------------------------------------------------------------------
function private.get_sharpening ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_sharpening" );
  cmn.CallEventHandler( "get_sharpening" );

end;
--------------------------------------------------------------------------------------------
function private.get_lever_ext ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_lever_ext" );
  cmn.CallEventHandler( "get_lever_ext" );
  common.CloseSubRoom(); 

end;
--------------------------------------------------------------------------------------------
function private.get_joshcard ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_joshcard" );
  cmn.CallEventHandler( "get_joshcard" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************

function private.clk_stick_1 ()

  cmn.CallEventHandler( "clk_stick_1_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_stick_1" );
    cmn.CallEventHandler( "clk_stick_1_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_wedge1", 0, "", 0 );

  ObjAnimate( "spr_gate_stick", "ang",0,0, func_end, { 0, 0, 0,    0.4, 0, 0.2 } );

end;

--------------------------------------------------------------------------------------------

function private.clk_stick_2 ()

  cmn.CallEventHandler( "clk_stick_2_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_stick_2" );
    cmn.CallEventHandler( "clk_stick_2_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_wedge2", 0, "", 0 );

  ObjAnimate( "spr_gate_stick", "ang",0,0, func_end, { 0, 0, 0.2,    0.6, 0, -0.2 } );

end;

--------------------------------------------------------------------------------------------

function private.clk_wrench_ext ()

  cmn.CallEventHandler( "clk_wrench_ext_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_wrench_ext" );
    cmn.CallEventHandler( "clk_wrench_ext_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_wrench_ext", 0, "", 0 );

  ObjAnimate( "spr_zz_frontdoor_grid", "pos_xy",0,0, func_end, { 0, 3, 20, 138,    0.6, 3, -137, 265 } );

end;

--------------------------------------------------------------------------------------------

function private.clk_peg_1 ()

  cmn.CallEventHandler( "clk_peg_1_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_peg_1" );
    cmn.CallEventHandler( "clk_peg_1_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_wedge1", 0, "", 0 );

  ObjSet( "spr_zz_wall_wedge_2", { alp = 0 } );

  ObjAnimate( "spr_zz_wall_door_closed", "alp",0,0, func_end, { 0, 0, 1,    0.3, 0, 1,    0.6, 0, 0 } );
  ObjSet( "spr_zz_wall_door_half_opened", { alp = 0, visible = true } );
  ObjAnimate( "spr_zz_wall_door_half_opened", "alp",0,0, "", { 0, 0, 0,    0.4, 0, 1 } );

end;

--------------------------------------------------------------------------------------------

function private.clk_peg_2 ()

  cmn.CallEventHandler( "clk_peg_2_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_peg_2" );
    cmn.CallEventHandler( "clk_peg_2_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_wedge2", 0, "", 0 );

  ObjAnimate( "spr_zz_wall_door_half_opened", "alp",0,0, "", { 0, 2, 1,    0.6, 2, 0 } );
  ObjSet( "spr_zz_wall_door_opened", { alp = 0, visible = true } );
  ObjAnimate( "spr_zz_wall_door_opened", "alp",0,0, func_end, { 0, 1, 0,    0.6, 1, 1 } );

end;

--------------------------------------------------------------------------------------------

function private.clk_wheel ()

  cmn.CallEventHandler( "clk_wheel_beg" );

  local func_end = function ()

    cmn.Lock( false );
    cmn.SetEventDone( "clk_wheel" );
    cmn.CallEventHandler( "clk_wheel_end" );

  end;

  cmn.Lock( true );
  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_wheel", 0, "", 0 );

  for i = 1, 7, 1 do 

    local curWheel = "spr_zz_wall_cogwheel"..i;
    ObjAnimate( curWheel, "ang",0,0, "", { 0, 0, 0,    1.8, 0, 12.56 } );

  end; 

  ObjAnimate( "spr_zz_wall_mechanism_back", "pos_x",0,0, func_end, { 0, 3, 11,    1.8, 3, 11,    2.4, 3, -282 } );

end;

--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.see_call_kane_2 ()

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "see_call_kane_2" ); 
    cmn.CallEventHandler( "see_call_kane_2" ); 

    common.CloseSubRoom(); 
    private.dlg_david_kane_2_click();

  end;  
  
  cmn.Lock( true );
  --common_impl.PlayAudio( "sfx", "levelext/sfx/aud_see_call_kane_2", 0, "", 0 );

  ObjSet( "anm_zz_callbox_calling_phone_click", { alp = 0, visible = true } );
  ObjAnimate( "anm_zz_callbox_calling_phone_click", "alp",0,0, "", { 0, 0, 0,    0.3, 0, 1 } );
  AnimPlay( "anm_zz_callbox_calling_phone_click", "func_6969", func_end );

  ObjAnimate( "anm_zz_callbox_calling_phone", "alp",0,0, "", { 0, 0, 1,    0.1, 0, 1,    0.3, 0, 0 } );

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_phone", 0, "", 0 );

end;
--------------------------------------------------------------------------------------------
function private.see_frontdoor ()

  local func_end = function ()

    cmn.Lock( false );

    cmn.SetEventDone( "see_frontdoor" ); 
    cmn.CallEventHandler( "see_frontdoor" ); 

    common_impl.StopAudio( "sfx", "levelext/sfx/aud_frontdoor", 0.2 );

    common_impl.ShowBbt( "bbt_porch_ext_see_frontdoor" );

  end;  

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_frontdoor", 0, "", 0 );

  cmn.PlayDialogVideo( "vid_porch_ext_frontdoor", func_end );

end;
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )

  if dlg_name == "david_kane_2" then

    if ( count_txt == 1 ) then -- Terence Irwing 

      ObjSet( "spr_int_dialog_character_icon", { res = "assets/interface/resources/dialog_character/btm_6" } );

    end;

  end;  

end;
--------------------------------------------------------------------------------------------
function private.dlg_david_kane_2_click ()

  common_impl.StopAudio( "env", "levelext/env/aud_payphone_env", 0.2 );

  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "david_kane_2", 3, nil, nil, true, private.dlg_david_kane_2_end );

end;
--------------------------------------------------------------------------------------------
function private.dlg_david_kane_2_end ()

  cmn.CallEventHandler( "dlg_porch_ext_david_kane_2" );   
  common_impl.ShowBbt( "bbt_porch_ext_dlg_porch_ext_david_kane_2" );

  for i = 1, 2 do

    --VidStop( "vid_dlg_park_1_professor_1_lip_"..i );
    --ObjSet( "vid_dlg_park_1_professor_1_lip_"..i, { alp = 0 } );

  end;

  local pos_beg = { ObjGet( "gzz_porch_ext_callbox" ).pos_x, ObjGet( "gzz_porch_ext_callbox" ).pos_y }
  cmn.GotoSubRoom( "zz_callbox", pos_beg, { 512, 360 } );

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_phone1", 0, "", 0 );

end;

--*********************************************************************************************************************
-- function *** ANIM *** () end;
--*********************************************************************************************************************

function private.InitAnimations ()

  ObjAnimate( "spr_zz_callbox_light", "alp",1,0, "", { 0, 3, 0.7,    1.5, 3, 0.1,    3, 3, 0.4,    5, 3, 1,    6, 3, 0.7 } );

  ObjAnimate( "spr_porch_ext_foliage", "pos_xy", 1, 0, "", 
  { 
    0.0, 3, ObjGet( "spr_porch_ext_foliage" ).pos_x,      ObjGet( "spr_porch_ext_foliage" ).pos_y,   
    2.5, 3, ObjGet( "spr_porch_ext_foliage" ).pos_x + 8,  ObjGet( "spr_porch_ext_foliage" ).pos_y - 5,     
    5.0, 3, ObjGet( "spr_porch_ext_foliage" ).pos_x,      ObjGet( "spr_porch_ext_foliage" ).pos_y,     
  } );

end;
--------------------------------------------------------------------------------------------
function private.Paper ()

  local tme = 10;

  ObjSet( "tmr_porch_ext_paper", { time = tme, playing = true, endtrig = private.AnimPaper } );

end;

--------------------------------------------------------------------------------------------

function private.AnimPaper ()

  --common_impl.PlayAudio( "sfx", "level1/sfx/aud_park_2_clk_shot_2", 0, "", 0 );

  local func_end = function ()

    private.Paper();

  end;

  VidPlay( "vid_porch_ext_paper", func_end );

end;

--------------------------------------------------------------------------------------------

function private.Logo ()

  cmn.Lock( true )

  AnimPlay( "anm_porch_ext_anim_logo2", "DoAnim", function() cmn.Lock( false ) end );

end;

--*********************************************************************************************************************

--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------

function private.FrontdoorFeedbackAnim()

  common_impl.ShowBbt( "bbt_frontdoor_use_wrench_ext" );

  local obj = "spr_zz_frontdoor_grid";
  local obj_click = "obj_frontdoor_use_wrench_ext";

  local x_start = ObjGet( obj ).pos_x;
  local y_start = ObjGet( obj ).pos_y;

  local time = 0.3;
  local dx = 1;
  local dy = -1;

  ObjSet( obj_click, { input = false } );
  local func_end = function ()
    ObjSet( obj_click, { input = true } );
  end;

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

  ObjAnimate( obj, "pos_x",0,0, "", { 0,0,x_start, time/4,0,x_start+dx, 3/4*time,0,x_start-dx, time,0,x_start } ); 
  ObjAnimate( obj, "pos_y",0,0, func_end, { 0,0,y_start, time/4,0,y_start+dy, 3/4*time,0,y_start-dy, time,0,y_start });  

end;

--------------------------------------------------------------------------------------------

function private.WallFeedbackAnim()

  common_impl.ShowBbt( "bbt_wall_use_peg" );

  local obj = "spr_zz_wall_door_closed";
  local obj_click = "obj_wall_use_peg";

  local x_start = ObjGet( obj ).pos_x;
  local y_start = ObjGet( obj ).pos_y;

  local time = 0.3;
  local dx = 1;
  local dy = -1;

  ObjSet( obj_click, { input = false } );
  local func_end = function ()
    ObjSet( obj_click, { input = true } );
  end;

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

  ObjAnimate( obj, "pos_x",0,0, "", { 0,0,x_start, time/4,0,x_start+dx, 3/4*time,0,x_start-dx, time,0,x_start } ); 
  ObjAnimate( obj, "pos_y",0,0, func_end, { 0,0,y_start, time/4,0,y_start+dy, 3/4*time,0,y_start-dy, time,0,y_start });  

end;

--------------------------------------------------------------------------------------------

function private.WallClickWheel ()

  common_impl.ShowBbt( "bbt_wall_use_wheel" );

  local func_end = function ()

    cmn.Lock( false );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_slide_4", 0, "", 0 );

  local ang = -1;

  for i = 1, 7, 1 do 

    local trg_after = "";
    if i == 7 then
      trg_after = func_end;
    end; 
    ang = -1*ang;
    local curWheel = "spr_zz_wall_cogwheel"..i;
    ObjAnimate( curWheel, "ang",0,0, trg_after, { 0, 0, 0,    0.3, 0, 0.6*ang,    0.5, 0, 0,    0.8, 0, 0.6*ang,    1.0, 0, 0  } );
    

  end; 

end;


--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_porch_ext ()

  if not ( cmn.IsEventDone( "opn_porch_ext" ) ) then

    cmn.SetEventDone( "opn_porch_ext" );

  end;

  cmn.CallEventHandler( "opn_porch_ext" ); 

end;

--------------------------------------------------------------------------------------------
function private.ClkPaper ()

  local func_end = function ()

    ObjSet( "obj_callbox_clk_paper", { input = true } );
  
  end;

  ObjSet( "obj_callbox_clk_paper", { input = false } );

  ObjAnimate( "obj_callbox_clk_paper", "alp", 0, 0, func_end, { 0,3,0,  0.3,3,1 } );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk1", 0, "", 0 );

end;
--------------------------------------------------------------------------------------------
function private.ScalePhone ()

  local func_end = function()

    cmn.Lock( false );
    ng_global.progress[ "ext" ][ "opn_porch_ext" ].see_phone = 1;

    common_impl.TutorialShow( "tutorial_page_22" );
    common_impl.ShowBbt( "bbt_porch_ext_scalephone" );

    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "pick_up_phone" );

  end;

  cmn.Lock( true );
  ObjAnimate( "obj_porch_ext_center", "pos_xy", 0, 0, "",
  { 
    0.0, 0,   0, 0,
  
    1.0, 0, 492, 0,
    1.3, 0, 592, 0, 
    2.0, 0, 592, 0, 
    2.3, 0, 492, 0,
 
    3.3, 0,   0, 0,
  } );
  ObjAnimate( "obj_porch_ext_center", "scale_xy", 0, 0, func_end,
  { 
    0.0, 0,   1, 1,
 
    1.0, 0,   1, 1, 
    1.3, 0, 1.2, 1.2, 
    2.0, 0, 1.2, 1.2, 
    2.3, 0,   1, 1, 

    3.3, 0,   1, 1, 
  } );

end;
--------------------------------------------------------------------------------------------
function private.ScaleGate ()

  local func_end = function ()

    local func_end_1 = function ()

      local func_end_2 = function ()

        cmn.Lock( false );
        ng_global.progress[ "ext" ][ "opn_porch_ext" ].see_gate = 1;
        common_impl.ShowBbt( "bbt_porch_ext_gate" );

        interface.KeyTaskDone( true );
        interface.KeyTaskAdd( "get_diner" );

      end;

      ObjAnimate( "obj_porch_ext_center", "pos_xy", 0, 0, "",
      { 
        0.0, 0,   ObjGet( "obj_porch_ext_center" ).pos_x, 0, 
        0.3, 0,   -826, 0, 
        1.3, 0,   -826, 0,    
        1.6, 0,   ObjGet( "obj_porch_ext_center" ).pos_x, 0,
      } );
      ObjAnimate( "obj_porch_ext_center", "scale_xy", 0, 0, func_end_2,
      { 
        0.0, 0,     1, 1, 
        0.3, 0,   1.2, 1.2, 
        1.3, 0,   1.2, 1.2,     
        1.6, 0,     1, 1, 
      } );

    end;

    cmn.Lock( true );
    int_slider.ClickObj( "right" );
    ObjAnimate( "obj_porch_ext_center", "alp", 0, 0, func_end_1,
    {
      0.0, 0, ObjGet( "obj_porch_ext_center" ).alp, 
      1.0, 0, ObjGet( "obj_porch_ext_center" ).alp
    } );

  end;

  cmn.Lock( true );
  ObjAnimate( "obj_porch_ext_center", "pos_xy", 0, 0, func_end,
  {
    0.0, 0, ObjGet( "obj_porch_ext_center" ).pos_x, ObjGet( "obj_porch_ext_center" ).pos_y,  
    1.0, 0, 0, 0,
  } );

end;
--------------------------------------------------------------------------------------------