-- name=rm_secondfloor_ext
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_secondfloor_ext";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_floor_ext", "room_hub" );
  ObjAttach( "zz_tools", "room_hub" );
  ObjAttach( "zz_searchlight", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
    { "spr_tools_file_ext",                       { event_mdown = private.get_file_ext } },
    { "spr_searchlight_ironhook",                 { event_mdown = private.get_ironhook } },
    { "spr_collect2_item_4_1",                    { event_mdown = private.get_collect2_item_4_1 } },
    { "obj_floor_ext_use_sugartongs",             { event_mdown = private.UseSugartongs } },
    { "obj_searchlight_use_file_ext",             { event_mdown = private.UseFileExt } },
    { "spr_secondfloor_ext_collect_item",         { event_mdown = function () common_impl.GetCollectItem( "get_collect_item_4_2" ); end } },
    { "spr_secondfloor_ext_collect_morph_item",   { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_4_5" ); end } },
    { "obj_tools_use_piston",                       { event_mdown = private.tools_clk_door } },

  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_secondfloor_ext = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "grm_secondfloor_ext_hall_ext",
      "grm_secondfloor_ext_terenceroom_ext",
      "grm_secondfloor_ext_managerroom",
      "gzz_secondfloor_ext_floor_ext",
      "gzz_secondfloor_ext_tools",
      "gzz_secondfloor_ext_searchlight"
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_floor_ext",
      "zz_tools",
      "zz_searchlight",
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_secondfloor_ext", update_game_mode_secondfloor_ext, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_secondfloor_ext = function ()

  local effects_table = 
  {
    "obj_secondfloor_ext_anim" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_secondfloor_ext", update_performance_mode_secondfloor_ext, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_secondfloor_ext () end;
  --------------------------------------------------------------------------------------------
  local opn_secondfloor_ext_map = function ()

    common_impl.VisitMapRoom( "secondfloor" );

  end;
  cmn.AddSubscriber( "opn_secondfloor_ext", opn_secondfloor_ext_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_piston () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_piston" ] = {
    type = "get",
    get_obj = "spr_floor_ext_piston",
    room = private.room_objname,
    zz = "zz_floor_ext",
    zz_gate = "gzz_secondfloor_ext_floor_ext"
  };
  
  local get_piston_inv = function ()
  
    interface.InventoryItemAdd( "inv_piston", "spr_floor_ext_piston" );
  
  end;
  
  local get_piston_closezz = function ()
  
    ObjDelete( "spr_floor_ext_piston_over" );
    ObjDelete( "gfx_floor_ext_piston" );
    ObjDelete( "spr_secondfloor_ext_floor_ext_floor" );

    if ( cmn.IsGetCollect2( "get_collect2_item_4_1" ) ) then

      ObjDelete( "gzz_secondfloor_ext_floor_ext" );

    end;

  end;
  
  cmn.AddSubscriber( "get_piston", get_piston_inv );
  cmn.AddSubscriber( "get_piston", get_piston_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_file_ext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_file_ext" ] = {
    type = "get",
    get_obj = "spr_tools_file_ext",
    room = private.room_objname,
    zz = "zz_tools",
    zz_gate = "gzz_secondfloor_ext_tools"
  };
  
  local get_file_ext_inv = function ()
  
    ObjSet( "spr_tools_file_ext", { alp = 1 } )
    interface.InventoryItemAdd( "inv_file_ext", "spr_tools_file_ext" );
  
  end;
  
  local get_file_ext_closezz = function ()
  
    ObjDelete( "spr_tools_file_ext_shadow" );
    ObjDelete( "gzz_secondfloor_ext_tools" );
    ObjDelete( "gfx_tools_file_ext" );
    ObjDelete( "spr_secondfloor_ext_tools_file" );
    
  end;
  
  cmn.AddSubscriber( "get_file_ext", get_file_ext_inv );
  cmn.AddSubscriber( "get_file_ext", get_file_ext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ironhook () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ironhook" ] = {
    type = "get",
    get_obj = "spr_searchlight_ironhook",
    room = private.room_objname,
    zz = "zz_searchlight",
    zz_gate = "gzz_secondfloor_ext_searchlight"
  };
  
  local get_ironhook_inv = function ()
  
    interface.InventoryItemAdd( "inv_ironhook", "spr_searchlight_ironhook" );
  
  end;
  
  local get_ironhook_closezz = function ()
  
    ObjDelete( "gzz_secondfloor_ext_searchlight" );
    ObjDelete( "gfx_searchlight_ironhook" );
    ObjDelete( "spr_secondfloor_ext_searchlight_spotlight" );  

  end;
  
  cmn.AddSubscriber( "get_ironhook", get_ironhook_inv );
  cmn.AddSubscriber( "get_ironhook", get_ironhook_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_4_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_4_2 = function ()
  
    ObjDelete( "obj_secondfloor_ext_collect" );
  
  end;    
  cmn.AddSubscriber( "get_collect_item_4_2", get_collect_item_4_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_4_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_4_1 = function ()
  
    ObjDelete( "obj_collect2_item_4_1" );

    if ( cmn.IsEventDone( "get_piston" ) ) then

      ObjDelete( "gzz_secondfloor_ext_floor_ext" );

    end;
  
  end;    
  cmn.AddSubscriber( "get_collect2_item_4_1", get_collect2_item_4_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_4_5 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_4_5 = function ()
  
    ObjDelete( "obj_secondfloor_ext_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_4_5", get_collect_morph_item_4_5, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sugartongs () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sugartongs" ] = {
    type = "use",
    inv_obj = "inv_sugartongs",
    use_place = "obj_floor_ext_use_sugartongs",
    room = private.room_objname,
    zz = "zz_floor_ext",
    zz_gate = "gzz_secondfloor_ext_floor_ext"
  };
  local use_sugartongs_inv = function ()
  
    interface.InventoryItemRemove( "inv_sugartongs" );
  
  end;
  local use_sugartongs_beg = function ()
  
    ObjDelete( "obj_floor_ext_use_sugartongs" );
  
  end;
  local use_sugartongs_end = function ()
  
    ObjSet( "spr_floor_ext_piston", { input = true, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sugartongs", use_sugartongs_beg, private.room_objname );
  cmn.AddSubscriber( "use_sugartongs", use_sugartongs_inv );
  cmn.AddSubscriber( "use_sugartongs", use_sugartongs_end, private.room_objname );
  cmn.AddSubscriber( "use_sugartongs_inv", use_sugartongs_inv, private.room_objname );
  cmn.AddSubscriber( "use_sugartongs_beg", use_sugartongs_beg, private.room_objname );
  cmn.AddSubscriber( "use_sugartongs_end", use_sugartongs_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_piston () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_piston" ] = {
    type = "use",
    inv_obj = "inv_piston",
    use_place = "obj_tools_use_piston",
    room = private.room_objname,
    zz = "zz_tools",
    zz_gate = "gzz_secondfloor_ext_tools"
  };
  local use_piston_inv = function ()
  
    interface.InventoryItemRemove( "inv_piston" );
  
  end;
  local use_piston_beg = function ()
  
    ObjDelete( "obj_tools_use_piston" );
  
  end;
  local use_piston_end = function ()  
    
    ObjSet( "spr_tools_file_ext",                     { input = true } );
    ObjSet( "anm_tools_open_door",                    { frame = 500 } );
    ObjSet( "spr_secondfloor_ext_tools_piston",       { alp = 1 } );
    ObjSet( "spr_tools_forcers_green_light",          { alp = 1 } );
    ObjSet( "spr_secondfloor_ext_tools_green_light2", { alp = 1 } );

    ObjDelete( "obj_tools_forcer_1" );
    ObjDelete( "spr_tools_forcer_2" );
    ObjDelete( "spr_tools_door" );
    ObjDelete( "obj_tools_sensor" );
    ObjDelete( "spr_secondfloor_ext_tools_cover" );      

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_piston", use_piston_beg, private.room_objname );
  cmn.AddSubscriber( "use_piston", use_piston_inv );
  cmn.AddSubscriber( "use_piston", use_piston_end, private.room_objname );
  cmn.AddSubscriber( "use_piston_inv", use_piston_inv, private.room_objname );
  cmn.AddSubscriber( "use_piston_beg", use_piston_beg, private.room_objname );
  cmn.AddSubscriber( "use_piston_end", use_piston_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_file_ext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_file_ext" ] = {
    type = "use",
    inv_obj = "inv_file_ext",
    use_place = "obj_searchlight_use_file_ext",
    room = private.room_objname,
    zz = "zz_searchlight",
    zz_gate = "gzz_secondfloor_ext_searchlight"
  };
  local use_file_ext_inv = function ()
  
    interface.InventoryItemRemove( "inv_file_ext" );
  
  end;
  local use_file_ext_beg = function ()
  
    ObjDelete( "obj_searchlight_use_file_ext" );
  
  end;
  local use_file_ext_end = function ()  
    
    ObjSet( "spr_searchlight_ironhook", { input = true, alp = 1 } );
    ObjDelete( "anm_searchlight_hook_click" );  

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_file_ext", use_file_ext_beg, private.room_objname );
  cmn.AddSubscriber( "use_file_ext", use_file_ext_inv );
  cmn.AddSubscriber( "use_file_ext", use_file_ext_end, private.room_objname );
  cmn.AddSubscriber( "use_file_ext_inv", use_file_ext_inv, private.room_objname );
  cmn.AddSubscriber( "use_file_ext_beg", use_file_ext_beg, private.room_objname );
  cmn.AddSubscriber( "use_file_ext_end", use_file_ext_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_roomkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_roomkey" ] = {
    type = "use",
    inv_obj = "inv_roomkey",
    use_place = "obj_secondfloor_ext_use_roomkey",
    zz = "slider_left", 
    room = private.room_objname,
  };
  local use_roomkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_roomkey" );
  
  end;
  local use_roomkey_beg = function ()
  
    ObjDelete( "obj_secondfloor_ext_use_roomkey" );
  
  end;
  local use_roomkey_end = function ()

    ObjDelete( "anm_secondfloor_ext_use_key" );

    ObjMultiSet( {
      { "grm_secondfloor_ext_terenceroom_ext",                  { input = true, visible = true, active = true, alp = 1 } },
      { "spr_secondfloor_ext_privat_room_door_preopen_back",    { alp = 1 } },
      { "spr_secondfloor_ext_privat_room_door_preopen",         { alp = 1 } }, 
    } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_secondfloor_ext_terenceroom_ext_focus");
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_roomkey", use_roomkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_roomkey", use_roomkey_inv );
  cmn.AddSubscriber( "use_roomkey", use_roomkey_end, private.room_objname );
  cmn.AddSubscriber( "use_roomkey_inv", use_roomkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_roomkey_beg", use_roomkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_roomkey_end", use_roomkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_patientprofile () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_patientprofile" ] = {
    type = "use",
    inv_obj = "inv_patientprofile",
    use_place = "obj_secondfloor_ext_use_patientprofile",
    zz = "slider_right", 
    room = private.room_objname,
  };
  local use_patientprofile_inv = function ()
  
    interface.InventoryItemRemove( "inv_patientprofile" );
  
  end;
  local use_patientprofile_beg = function ()
  
    ObjDelete( "obj_secondfloor_ext_use_patientprofile" );
  
  end;
  local use_patientprofile_end = function ()
  
    ObjDelete( "anm_secondfloor_ext_card" );
    ObjSet( "spr_secondfloor_ext_meneger_room_door_open", { alp =  1} );
    ObjSet( "grm_secondfloor_ext_managerroom", { input = true, visible = true, active = true, alp = 1 } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_secondfloor_ext_managerroom_focus");
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_patientprofile", use_patientprofile_beg, private.room_objname );
  cmn.AddSubscriber( "use_patientprofile", use_patientprofile_inv );
  cmn.AddSubscriber( "use_patientprofile", use_patientprofile_end, private.room_objname );
  cmn.AddSubscriber( "use_patientprofile_inv", use_patientprofile_inv, private.room_objname );
  cmn.AddSubscriber( "use_patientprofile_beg", use_patientprofile_beg, private.room_objname );
  cmn.AddSubscriber( "use_patientprofile_end", use_patientprofile_end, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()

  common_impl.hint.position_zz[ "gzz_secondfloor_ext_floor_ext" ] = { "mid" };
  common_impl.hint.position_zz[ "gzz_secondfloor_ext_tools" ] = { "left", "mid" };
  common_impl.hint.position_zz[ "gzz_secondfloor_ext_searchlight" ] = { "right" };

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_secondfloor_ext();
  int_slider.InitSlider( private.room_objname );

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

  private.Door();

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();
  common_impl.CollectItemMorphing();

  common_impl.EnvPlay( { "level3/env/aud_secondfloor_env" }, "", 0.5 );

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_sugartongs ()

  local item = "inv_sugartongs";

  if cmn.ApplyObj( item, "gzz_secondfloor_ext_floor_ext" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_floor_ext", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_floor_ext_use_sugartongs" ) ) then

    cmn.CallEventHandler( "use_sugartongs_inv" );
    cmn.CallEventHandler( "use_sugartongs_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_sugartongs" );
      cmn.CallEventHandler( "use_sugartongs_end" );

      private.get_piston();

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_sugartongs", 0, "", 0 );

    ObjSet( "spr_floor_ext_piston", { alp = 0 } );    
    ObjSet( "anm_floor_ext_tweezers", { alp = 1 });
    AnimPlay( "anm_floor_ext_tweezers", "DoAnim", func_end );
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_piston ()

  local item = "inv_piston";

  if cmn.ApplyObj( item, "gzz_secondfloor_ext_tools" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tools", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_tools_use_piston" ) ) then

    cmn.CallEventHandler( "use_piston_inv" );
    cmn.CallEventHandler( "use_piston_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_piston" );
      cmn.CallEventHandler( "use_piston_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_piston", 0, "", 0 );

    local func_continue = function ()
  
      ObjSet( "anm_tools_open_door", { alp = 1 } )
      AnimPlay( "anm_tools_open_door", "DoAnim", func_end );

      ObjDelete( "obj_tools_forcer_1" );
      ObjDelete( "spr_tools_forcer_2" );
      ObjDelete( "spr_tools_door" );
      ObjDelete( "obj_tools_sensor" );

    end;
    
    ObjAnimate( "spr_tools_forcers_green_light", "alp", 0, 0, "", { 0 ,0, 0, 0.3, 0, 1 } );
    ObjAnimate( "obj_tools_forcer_1", "alp", 0, 0, func_continue, { 0 ,0, 0, 0.3, 0, 1 } );
    
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_file_ext ()

  local item = "inv_file_ext";

  if cmn.ApplyObj( item, "gzz_secondfloor_ext_searchlight" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_searchlight", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_searchlight_use_file_ext" ) ) then

    cmn.CallEventHandler( "use_file_ext_inv" );
    cmn.CallEventHandler( "use_file_ext_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_file_ext" );
      cmn.CallEventHandler( "use_file_ext_end" );

      private.get_ironhook();

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_file_ext", 0, "", 0 );
    ObjMultiSet( {
      { "spr_searchlight_ironhook", { alp = 0 } }, 
      { "spr_searchlight_hook", { alp = 0 } }, 
      { "anm_searchlight_use_file", { alp = 1 } },
    } );   
    AnimPlay( "anm_searchlight_use_file", "DoAnim", func_end );
    return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_roomkey ()

  local item = "inv_roomkey";

  if ( cmn.ApplyObj( item, "obj_secondfloor_ext_use_roomkey" ) ) then

    cmn.CallEventHandler( "use_roomkey_inv" );
    cmn.CallEventHandler( "use_roomkey_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_roomkey" );
      cmn.CallEventHandler( "use_roomkey_end" );

  end;

  cmn.Lock( true );

  --common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_door_car", 0, "", 0 );

  --func_end();

  AnimPlay( "anm_secondfloor_ext_use_key", "DoAnim", func_end );
  
  return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_patientprofile ()

  local item = "inv_patientprofile";

  if ( cmn.ApplyObj( item, "obj_secondfloor_ext_use_patientprofile" ) ) then

    cmn.CallEventHandler( "use_patientprofile_inv" );
    cmn.CallEventHandler( "use_patientprofile_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_patientprofile" );
      cmn.CallEventHandler( "use_patientprofile_end" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_clk_door_car", 0, "", 0 );

    AnimPlay( "anm_secondfloor_ext_card", "DoAnim", func_end );
  
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_piston ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_piston" );
  cmn.CallEventHandler( "get_piston" );
  ObjSet( "spr_floor_ext_piston", { pos_x = 407, pos_y = -211, alp = 1, drawoff_y = 0 } );   
  if ( cmn.IsGetCollect2( "get_collect2_item_4_1" ) ) then

    common.CloseSubRoom(); 

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_file_ext ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_file_ext" );
  cmn.CallEventHandler( "get_file_ext" );
  common.CloseSubRoom(); 

end;
--------------------------------------------------------------------------------------------
function private.get_ironhook ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_ironhook" );
  cmn.CallEventHandler( "get_ironhook" );
  common.CloseSubRoom(); 

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_4_1 ()

  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_4_1" ); 

    if ( cmn.IsEventDone( "get_piston" ) ) then

      common.CloseSubRoom();

    end;

  end;

  common_impl.PlayEffectHO( "spr_collect2_item_4_1", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_4_1" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.Door ()

  local tme = 10;

  ObjSet( "tmr_porch_ext_door", { time = tme, playing = true, endtrig = private.AnimDoor } );

end;
--------------------------------------------------------------------------------------------
function private.AnimDoor ()

  --common_impl.PlayAudio( "sfx", "level1/sfx/aud_park_2_clk_shot_2", 0, "", 0 );

  local func_end = function ()

     private.Door();

  end;

  AnimPlay( "anm_secondfloor_ext_door_safe", "DoAnim", func_end );

end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
function private.UseSugartongs ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_floor_ext_use_sugartongs' );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_single_clk5", 0, "", 0 );

  ObjAnimate( "spr_floor_ext_piston", "ang", 0, 0, func_end, 
  { 
    0.00, 0, 0,  
    0.15, 0, 0.02, 
    0.30, 0, 0, 
    0.40, 0, 0.01, 
    0.50, 0, 0.00, 
  } );  

end;
--------------------------------------------------------------------------------------------
function private.UseFileExt ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_searchlight_use_file_ext' );
    ObjMultiSet( {
      { "spr_searchlight_ironhook", { alp = 1 } }, 
      { "spr_searchlight_hook", { alp = 1 } }, 
      { "anm_searchlight_hook_click", { alp = 0 } },
    } );

  end;

  cmn.Lock( true );

  common_impl.PlayAudio( "sfx", "level2/sfx/aud_single_clk9", 0, "", 0 );

  ObjMultiSet( {
    { "spr_searchlight_ironhook", { alp = 0 } }, 
    { "spr_searchlight_hook", { alp = 0 } }, 
    { "anm_searchlight_hook_click", { alp = 1 } },
  } );
  AnimPlay( "anm_searchlight_hook_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_secondfloor_ext ()

  if not ( cmn.IsEventDone( "opn_secondfloor_ext" ) ) then

    cmn.SetEventDone( "opn_secondfloor_ext" );
    common_impl.ShowBbt( "bbt_secondfloor_ext_opn_secondfloor_ext" );

  end;

  cmn.CallEventHandler( "opn_secondfloor_ext" ); 

end;
--*********************************************************************************************************************
function private.tools_clk_door()

  cmn.Lock( true )
  common_impl.ShowBbt( 'bbt_tools_use_piston' );

  local endfunc = function ()

    cmn.Lock( false );

  end;

  ObjAnimate( "spr_tools_door", "pos_y", 0, 1, endfunc, 
  { 
    0.1, 0, 0,
    0.2, 0, -2,
    0.3, 0, 0,
    0.4, 0, -2,
    0.5, 0, 0

  });

end;
--*********************************************************************************************************************