-- name=rm_terenceroom_ext
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_terenceroom_ext";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_bedsidetable", "room_hub" );
  ObjAttach( "zz_shelves", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet( { 
    { "spr_bedsidetable_brochure",                      { event_mdown = private.get_brochure            } },
    { "spr_bedsidetable_sugartongs",                    { event_mdown = private.get_sugartongs          } },
    { "obj_terenceroom_ext_clk_josh_fraser_3",          { event_mdown = private.dlg_josh_fraser_3_click } },
    { "obj_terenceroom_ext_clk_josh_fraser_3_focus",    { event_mdown = private.dlg_josh_fraser_3_click } },
    { "spr_collect2_item_4_2",                          { event_mdown = private.get_collect2_item_4_2   } },
    { "obj_bedsidetable_use_labamulet",                 { event_mdown = private.UseLabamulet           } },

    { "obj_terenceroom_ext_josh_fraser_3_clk_start_nerve",    { event_mdown = function() private.ClkDlgFraser3( "start_nerve" ) end; } },
    { "obj_terenceroom_ext_josh_fraser_3_clk_start_sight",    { event_mdown = function() private.ClkDlgFraser3( "start_sight" ) end; } },
    { "obj_terenceroom_ext_josh_fraser_3_clk_start_pressure", { event_mdown = function() private.ClkDlgFraser3( "start_pressure" ) end; } },

    { "spr_terenceroom_ext_josh_fraser_3_nerve_point",      { event_mdown = private.ClkNerve } },

    { "spr_terenceroom_ext_josh_fraser_3_sight_america_1",  { event_mdown = function() private.ClkSight( "america", "show", 2 ) end; } },
    { "spr_terenceroom_ext_josh_fraser_3_sight_america_2",  { event_mdown = function() private.ClkSight( "america", "show", 2 ) end; } },
    { "spr_terenceroom_ext_josh_fraser_3_sight_atom_1",     { event_mdown = function() private.ClkSight( "atom",    "show", 2 ) end; } },
    { "spr_terenceroom_ext_josh_fraser_3_sight_atom_2",     { event_mdown = function() private.ClkSight( "atom",    "show", 2 ) end; } },
    { "spr_terenceroom_ext_josh_fraser_3_sight_redball_1",  { event_mdown = function() private.ClkSight( "redball", "hide", 1 ) end; } },
    { "spr_terenceroom_ext_josh_fraser_3_sight_redball_2",  { event_mdown = function() private.ClkSight( "redball", "hide", 1 ) end; } },
    { "spr_terenceroom_ext_josh_fraser_3_sight_sign_1",     { event_mdown = function() private.ClkSight( "sign",    "rotate", 1 ) end; } },
    { "spr_terenceroom_ext_josh_fraser_3_sight_sign_2",     { event_mdown = function() private.ClkSight( "sign",    "rotate", 1 ) end; } },
    { "spr_terenceroom_ext_josh_fraser_3_sight_spiral_1",   { event_mdown = function() private.ClkSight( "spiral",  "show", 1 ) end; } },
    { "spr_terenceroom_ext_josh_fraser_3_sight_spiral_2",   { event_mdown = function() private.ClkSight( "spiral",  "show", 1 ) end; } },

    { "spr_terenceroom_ext_collect_item",                   { event_mdown = function () common_impl.GetCollectItem( "get_collect_item_4_3" ); end } },
    { "spr_terenceroom_ext_collect_morph_item",             { event_mdown = function () common_impl.GetMorphItem( "get_collect_morph_item_4_6" ); end } },
  } );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_terenceroom_ext = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "grm_terenceroom_ext_secondfloor_ext",
      "gmg_terenceroom_ext_shelflock",
      "gzz_terenceroom_ext_bedsidetable",
      "gzz_terenceroom_ext_shelves",
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname,
      "zz_bedsidetable",
      "zz_shelves",
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_terenceroom_ext", update_game_mode_terenceroom_ext, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_terenceroom_ext = function ()

  local effects_table = 
  {
    "obj_terenceroom_ext_anim" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_terenceroom_ext", update_performance_mode_terenceroom_ext, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_terenceroom_ext () end;
  --------------------------------------------------------------------------------------------
  local opn_terenceroom_ext_map = function ()

    common_impl.VisitMapRoom( "terenceroom" );

  end;
  cmn.AddSubscriber( "opn_terenceroom_ext", opn_terenceroom_ext_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_brochure () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_brochure" ] = {
    type = "get",
    get_obj = "spr_bedsidetable_brochure",
    room = private.room_objname,
    zz = "zz_bedsidetable",
    zz_gate = "gzz_terenceroom_ext_bedsidetable"
  };
  
  local get_brochure_inv = function ()
  
    interface.InventoryItemAdd( "inv_brochure", "spr_bedsidetable_brochure" );
    ObjSet( "inv_brochure", { drag = false } );  
    cmn.SetInvPlusRGB( "brochure", true ); 

  end;
  
  local get_brochure_closezz = function ()
  
    if ( cmn.IsGetCollect2( "get_collect2_item_4_2" ) ) then

      ObjDelete( "gzz_terenceroom_ext_bedsidetable" );

    end;

    ObjDelete( "gfx_bedsidetable_brochure" );
    ObjDelete( "spr_bedsidetable_brochure_shadow" );
    ObjDelete( "spe_terenceroom_ext_bedsidetable_booklet" );  

  end;
  
  cmn.AddSubscriber( "get_brochure", get_brochure_inv );
  cmn.AddSubscriber( "get_brochure", get_brochure_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sugartongs () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sugartongs" ] = {
    type = "get",
    get_obj = "spr_bedsidetable_sugartongs",
    room = private.room_objname,
    zz = "zz_bedsidetable",
    zz_gate = "gzz_terenceroom_ext_bedsidetable"
  };
  
  local get_sugartongs_inv = function ()
  
    ObjSet( "spr_bedsidetable_sugartongs", { alp = 1 } );
    interface.InventoryItemAdd( "inv_sugartongs", "spr_bedsidetable_sugartongs" );
  
  end;
  
  local get_sugartongs_closezz = function ()
  
    ObjDelete( "spr_bedsidetable_sugartongs_shadow" );
    ObjDelete( "spr_terenceroom_ext_bedsidetable_forceps" );  

  end;
  
  cmn.AddSubscriber( "get_sugartongs", get_sugartongs_inv );
  cmn.AddSubscriber( "get_sugartongs", get_sugartongs_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_4_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_4_3 = function ()

    ObjDelete( "obj_terenceroom_ext_collect" );

  end;    
  cmn.AddSubscriber( "get_collect_item_4_3", get_collect_item_4_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_item_4_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_item_4_2 = function ()
  
    ObjDelete( "obj_collect2_item_4_2" );

    if ( cmn.IsEventDone( "get_brochure" ) ) then

      ObjDelete( "gzz_terenceroom_ext_bedsidetable" );

    end;
  
  end;    
  cmn.AddSubscriber( "get_collect2_item_4_2", get_collect2_item_4_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_4_6 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_4_6 = function ()
  
    ObjDelete( "obj_terenceroom_ext_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_4_6", get_collect_morph_item_4_6, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_labamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_labamulet" ] = {
    type = "use",
    inv_obj = "inv_labamulet",
    use_place = "obj_bedsidetable_use_labamulet",
    room = private.room_objname,
    zz = "zz_bedsidetable",
    zz_gate = "gzz_terenceroom_ext_bedsidetable"
  };
  local use_labamulet_inv = function ()
  
    interface.InventoryItemRemove( "inv_labamulet" );
  
  end;
  local use_labamulet_beg = function ()
  
    ObjDelete( "obj_bedsidetable_use_labamulet" );
  
  end;
  local use_labamulet_end = function ()
  
    ObjDelete( "spr_terenceroom_ext_bedsidetable_cover" );
    ObjSet( "spr_terenceroom_ext_bedsidetable_cover_open", { alp = 1 } );
    ObjDelete( "spr_bedsidetable_door" );
    ObjSet( "spr_bedsidetable_door_open", { alp = 1 } );
    ObjSet( "spr_bedsidetable_brochure", { active = true, input = true, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_labamulet", use_labamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_labamulet", use_labamulet_inv );
  cmn.AddSubscriber( "use_labamulet", use_labamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_labamulet_inv", use_labamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_labamulet_beg", use_labamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_labamulet_end", use_labamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ironhook () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ironhook" ] = {
    type = "use",
    inv_obj = "inv_ironhook",
    use_place = "obj_shelves_use_ironhook",
    room = private.room_objname,
    zz = "zz_shelves",
    zz_gate = "gzz_terenceroom_ext_shelves"
  };
  local use_ironhook_inv = function ()
  
    interface.InventoryItemRemove( "inv_ironhook" );
  
  end;
  local use_ironhook_beg = function ()
  
    ObjDelete( "obj_shelves_use_ironhook" );
  
  end;
  local use_ironhook_end = function ()
  
    ObjDelete( "gzz_terenceroom_ext_shelves" );
    ObjDelete( "spr_terenceroom_ext_shelves" );
    ObjDelete( "spr_shelves_shelf_small" );
    ObjDelete( "anm_shelves_hook_use" );
    ObjSet( "spr_shelves_shelf", { alp = 1 } );
    ObjSet( "gmg_terenceroom_ext_shelflock", { input = true, visible = true, active = true, alp = 1 } );
    ObjSet( "spr_terenceroom_ext_shelves_1", { alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ironhook", use_ironhook_beg, private.room_objname );
  cmn.AddSubscriber( "use_ironhook", use_ironhook_inv );
  cmn.AddSubscriber( "use_ironhook", use_ironhook_end, private.room_objname );
  cmn.AddSubscriber( "use_ironhook_inv", use_ironhook_inv, private.room_objname );
  cmn.AddSubscriber( "use_ironhook_beg", use_ironhook_beg, private.room_objname );
  cmn.AddSubscriber( "use_ironhook_end", use_ironhook_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_outro_ext () end;
  --------------------------------------------------------------------------------------------
  local see_outro_ext = function ()


  end;
  cmn.AddSubscriber( "see_outro_ext", see_outro_ext, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_terenceroom_ext_josh_fraser_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_terenceroom_ext_josh_fraser_3" ] = {
    type = "click",
    use_place = "obj_terenceroom_ext_clk_josh_fraser_3_focus",
    room = private.room_objname
  };

  local dlg_terenceroom_ext_josh_fraser_3 = function ()

    ObjDelete( "dlg_terenceroom_ext_josh_fraser_3_lip" );
    ObjDelete( "obj_terenceroom_ext_clk_josh_fraser_3" );

  end;
  cmn.AddSubscriber( "dlg_terenceroom_ext_josh_fraser_3", dlg_terenceroom_ext_josh_fraser_3, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function see_terenceroom_ext_josh_fraser_4 () end;
  --------------------------------------------------------------------------------------------
  local see_terenceroom_ext_josh_fraser_4 = function ()

  end;
  cmn.AddSubscriber( "see_terenceroom_ext_josh_fraser_4", see_terenceroom_ext_josh_fraser_4, private.room_objname ); 

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_terenceroom_ext();
  int_slider.InitSlider( private.room_objname );

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

  if cmn.IsEventDone( "dlg_managerroom_interview_2" ) and
  not cmn.IsEventDone( "dlg_terenceroom_ext_josh_fraser_3" ) then

    ObjSet( "anm_terenceroom_ext_frazer", { alp = 1, playing = true } );
    ObjSet( "obj_terenceroom_ext_clk_josh_fraser_3", { input = true, visible = true, active = true, alp = 1 } );

  end; 

  if cmn.IsEventDone( "dlg_terenceroom_ext_josh_fraser_3" ) and
  not cmn.IsEventDone( "see_outro_ext" ) then

    private.see_outro_ext();

  end; 

  if cmn.IsEventDone( "dlg_managerroom_interview_2") and not cmn.IsEventDone( "dlg_terenceroom_ext_josh_fraser_3") then
    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( "get_vaccinated" );
  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();
  common_impl.CollectItemMorphing();

  common_impl.EnvPlay( { "level2/env/aud_lab_env" }, "", 0.5 );

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_labamulet ()

  local item = "inv_labamulet";

  if cmn.ApplyObj( item, "gzz_terenceroom_ext_bedsidetable" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bedsidetable", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_bedsidetable_use_labamulet" ) ) then

    cmn.CallEventHandler( "use_labamulet_inv" );
    cmn.CallEventHandler( "use_labamulet_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_labamulet" );
      cmn.CallEventHandler( "use_labamulet_end" );

  end;

  cmn.Lock( true );

  local func_continue = function ()

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_single_clk_open", 0, "", 0 );

    ObjAnimate( "spr_bedsidetable_door", "alp", 0, 0, "", { 0, 0, 1, 0.3, 0, 0 } );
    ObjAnimate( "spr_bedsidetable_door_open", "alp", 0, 0, func_end, { 0, 0, 0, 0.3, 0, 1 } );

  end;

  cmn.ItemFly( "spr_bedsidetable_amulet", func_continue, 3.14 );
  
  return true;

  end;
  
  return false;
  
end;
--------------------------------------------------------------------------------------------
function public.use_ironhook ()

  local item = "inv_ironhook";

  if cmn.ApplyObj( item, "gzz_terenceroom_ext_shelves" ) then

  --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shelves", nil, { 512, 360 } );

  return true;

  elseif ( cmn.ApplyObj( item, "obj_shelves_use_ironhook" ) ) then

    cmn.CallEventHandler( "use_ironhook_inv" );
    cmn.CallEventHandler( "use_ironhook_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_ironhook" );
      cmn.CallEventHandler( "use_ironhook_end" );
      common.CloseSubRoom();
      cmn.GotoRoom( "mg_shelflock" ); 

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "levelext/sfx/aud_use_ironhook", 0, "", 0 );

    ObjMultiSet( { 
      { "spr_shelves_shelf_small", { alp = 0 } },
      { "anm_shelves_hook_use", { alp = 1 } },
    } );
    AnimPlay( "anm_shelves_hook_use", "DoAnim", func_end );
    
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_brochure ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_brochure" );
  cmn.CallEventHandler( "get_brochure" );

  if ( cmn.IsGetCollect2( "get_collect2_item_4_2" ) ) then

    common.CloseSubRoom(); 

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_sugartongs ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_sugartongs" );
  cmn.CallEventHandler( "get_sugartongs" );

end;
--------------------------------------------------------------------------------------------
function private.get_collect2_item_4_2 ()

  local func_end = function ()

    cmn.CallEventHandler( "get_collect2_item_4_2" ); 

    if ( cmn.IsEventDone( "get_brochure" ) ) then

      common.CloseSubRoom();

    end;

  end;

  common_impl.PlayEffectHO( "spr_collect2_item_4_2", func_end );
  common_impl.GetCollect2Done( "get_collect2_item_4_2" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS SEE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.see_outro_ext ()

  local func_end = function ()

    common_impl.StopAudio( "sfx", "levelext/sfx/aud_outro_ext", 0.2 );
    common_impl.StopAudio( "voc", "levelext/voc/aud_see_outro_ext_voc", 0.5 );

    cmn.SetEventDone( "see_outro_ext" ); 
    cmn.CallEventHandler( "see_outro_ext" ); 

    cmn.GotoRoom( "rm_credits" );

  end;  

  common_impl.StopAudio( "sfx", "levelext/sfx/aud_fraiser_away_2", 0.5 );

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_outro_ext", 0, "", 0 );
  common_impl.PlayAudio( "voc", "levelext/voc/aud_see_outro_ext_voc", 0, "", 0 );    

  cmn.PlayDialogVideo( "vid_terenceroom_ext_outro_ext", func_end );

end;
--*********************************************************************************************************************
-- function *** PROGRESS DLG *** () end;
--*********************************************************************************************************************
function public.SwitchFrase ( dlg_name, count_txt )

  if dlg_name == "josh_fraser_3" then

    if ( count_txt == 1 ) then

      ObjSet( "spr_int_dialog_character_icon", { res = "assets/interface/resources/dialog_character/btm_5" } );
      ObjSet( "vid_terenceroom_ext_josh_fraser_3_1_voc", { alp = 1 } );
      VidPlay( "vid_terenceroom_ext_josh_fraser_3_1_voc", "" );

    elseif ( count_txt == 2 ) then

      private.DlgNext = ObjGet( "obj_int_dialog_character_input" ).event_mdown;
      ObjSet( "obj_int_dialog_character_input", { input = false } );
      ObjDelete( "vid_terenceroom_ext_josh_fraser_3_1_voc" );
      ObjSet( "vid_terenceroom_ext_josh_fraser_3_2_voc", { alp = 1 } );
      VidPlay( "vid_terenceroom_ext_josh_fraser_3_2_voc", "" );
      ObjSet( "obj_terenceroom_ext_josh_fraser_3_clk_start_nerve", { input = true } );

    elseif ( count_txt == 3 ) then

      private.DlgNext = ObjGet( "obj_int_dialog_character_input" ).event_mdown;
      ObjSet( "obj_int_dialog_character_input", { input = false } );
      ObjDelete( "vid_terenceroom_ext_josh_fraser_3_2_voc" );
      ObjSet( "vid_terenceroom_ext_josh_fraser_3_3_voc", { alp = 1 } );
      VidPlay( "vid_terenceroom_ext_josh_fraser_3_3_voc", "" );
      ObjSet( "obj_terenceroom_ext_josh_fraser_3_clk_start_sight", { input = true } );

    elseif ( count_txt == 4 ) then

      private.DlgNext = ObjGet( "obj_int_dialog_character_input" ).event_mdown;
      ObjSet( "obj_int_dialog_character_input", { input = false } );
      ObjDelete( "vid_terenceroom_ext_josh_fraser_3_3_voc" );
      ObjSet( "vid_terenceroom_ext_josh_fraser_3_4_voc", { alp = 1 } );
      VidPlay( "vid_terenceroom_ext_josh_fraser_3_4_voc", "" );
      ObjSet( "obj_terenceroom_ext_josh_fraser_3_clk_start_pressure", { input = true } );

    elseif ( count_txt == 5 ) then

      ObjDelete( "vid_terenceroom_ext_josh_fraser_3_4_voc" );
      ObjSet( "vid_terenceroom_ext_josh_fraser_3_5_voc", { alp = 1 } );
      VidPlay( "vid_terenceroom_ext_josh_fraser_3_5_voc", "" );
      ObjAnimate( "obj_terenceroom_ext_josh_fraser_3_pressure", "alp", 0, 0, "", { 0,3,1,  0.4,3,0 } );

    end;

  end;  

end;
--------------------------------------------------------------------------------------------
function private.dlg_josh_fraser_3_click ()

  ObjSet( "anm_terenceroom_ext_frazer",             { alp = 0, playing = false } );
  ObjSet( "obj_terenceroom_ext_clk_josh_fraser_3",  { input = false } );
  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "josh_fraser_3", 6, nil, nil, true, private.dlg_josh_fraser_3_end );

end;
--------------------------------------------------------------------------------------------
function private.dlg_josh_fraser_3_end ()

  cmn.CallEventHandler( "dlg_terenceroom_ext_josh_fraser_3" );   
  common_impl.ShowBbt( "bbt_terenceroom_ext_dlg_terenceroom_ext_josh_fraser_3" );

  int_button_info.Hide();

  --interface.KeyTaskDone( true );
  --interface.KeyTaskAdd( "id" );

  for i = 1, 2 do

    --VidStop( "vid_dlg_park_1_professor_1_lip_"..i );
    --ObjSet( "vid_dlg_park_1_professor_1_lip_"..i, { alp = 0 } );

  end;

  private.see_josh_fraser_4_click ()
  
end;
--------------------------------------------------------------------------------------------
function private.see_josh_fraser_4_click () 

  local func_end_2 = function ()

    private.see_outro_ext();

  end; 

  local func_end = function ()

    cmn.SetEventDone( "see_terenceroom_ext_josh_fraser_4" ); 
    cmn.CallEventHandler( "see_terenceroom_ext_josh_fraser_4" ); 

    common_impl.ShowBbt( "bbt_terenceroom_ext_see_terenceroom_ext_josh_fraser_4" );

    ObjAnimate( "rm_terenceroom_ext", "alp",0,0, func_end_2, { 0, 0, 1,    0.7, 0, 1 } );

  end;  

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_fraiser_away_2", 0, "", 0 );
  cmn.PlayDialogVideo( "vid_terenceroom_ext_fraiser_away_2", func_end );

  common_impl.PlayAudio( "sfx", "levelext/sfx/aud_fraiser_away_2", 0, "", 0 );

end;
--------------------------------------------------------------------------------------------
function private.ClkDlgFraser3( state )

  if state == "start_nerve" then

    ObjSet( "obj_terenceroom_ext_josh_fraser_3_nerve", { input = true } );

    local func_end = function()

      cmn.Lock( false );

      ObjDelete( "obj_terenceroom_ext_josh_fraser_3_clk_start_nerve" );

      int_button_info.Show( "nerve" );

    end;

    cmn.Lock( true );

    local delta = 0.5;
    local x_max = 510;
    local y_max = 110;

    ObjAnimate( "spr_terenceroom_ext_josh_fraser_3_nerve_point", "pos_x", 1, 0, "", { 
      0.0,        0,  0,  
      4 * delta,  3,  x_max,
      8 * delta,  3,  0 
    } );
    ObjAnimate( "spr_terenceroom_ext_josh_fraser_3_nerve_point", "pos_y", 1, 0, "", { 
      0.0,        3,  0,  
      1 * delta,  3,  - y_max,
      3 * delta,  3,  y_max, 
      4 * delta,  3,  0,
      5 * delta,  3,  - y_max,
      7 * delta,  3,  y_max, 
      8 * delta,  3,  0,
    } );

    ObjAnimate( "obj_terenceroom_ext_josh_fraser_3_nerve", "alp", 0, 0, func_end, { 0, 0, 0,   0.3, 0, 1 } );

  ---------------------------------------------------------------------------------------------

  elseif state == "start_sight" then

    ObjSet( "obj_terenceroom_ext_josh_fraser_3_sight", { input = true } );

    local func_end = function()

      cmn.Lock( false );

      ObjDelete( "obj_terenceroom_ext_josh_fraser_3_clk_start_sight" );
  
      private.sight_count = 0;

      int_button_info.Show( "sight" );

    end;

    cmn.Lock( true );

    ObjAnimate( "obj_terenceroom_ext_josh_fraser_3_sight", "alp", 0, 0, func_end, { 0, 0, 0,   0.3, 0, 1 } );

  ---------------------------------------------------------------------------------------------

  elseif state == "start_pressure" then

    ObjSet( "obj_int_dialog_character_input", { input = true } );

    local func_2_end = function()

      cmn.Lock( false );

      int_button_info.Hide();

      private.DlgNext();

    end;

    local func_end = function()

      ObjDelete( "obj_terenceroom_ext_josh_fraser_3_clk_start_pressure" );
  
      --int_button_info.Show( "pressure" );

      AnimPlay( "anm_terenceroom_ext_josh_fraser_3_pressure", "DoAnim", func_2_end );

    end;

    cmn.Lock( true );

    ObjAnimate( "obj_terenceroom_ext_josh_fraser_3_pressure", "alp", 0, 0, func_end, { 0, 0, 0,   0.3, 0, 1 } );

  end;

end;
--*********************************************************************************************************************
-- function *** Mmg Nerve *** () end;
--*********************************************************************************************************************
  function private.ClkNerve ()

    if ObjIntersect( "spr_terenceroom_ext_josh_fraser_3_nerve_point", "obj_terenceroom_ext_josh_fraser_3_nerve_center" ) then

      local func_end = function()

        cmn.Lock( false );

        ObjDelete( "obj_terenceroom_ext_josh_fraser_3_nerve" );

        int_button_info.Hide();

        private.DlgNext();

        ObjSet( "obj_terenceroom_ext_josh_fraser_3_clk_start_sight", { input = true } );

      end;

      ObjStopAnimate( "spr_terenceroom_ext_josh_fraser_3_nerve_point", "pos_x" );
      ObjStopAnimate( "spr_terenceroom_ext_josh_fraser_3_nerve_point", "pos_y" );

      cmn.Lock( true );

      ObjAnimate( "obj_terenceroom_ext_josh_fraser_3_nerve", "alp", 0, 0, func_end, { 0, 0, 1,   0.3, 0, 0 } );

    end;
  
  end;
--*********************************************************************************************************************
-- function *** Mmg Sight *** () end;
--*********************************************************************************************************************
  function private.ClkSight ( name, action, number )

    local obj_name = "spr_terenceroom_ext_josh_fraser_3_sight_";
  
    cmn.Lock( true );

    local func_end = function()

      cmn.Lock( false );

      private.sight_count = private.sight_count + 1;

      if ( private.sight_count == 5) then

        int_button_info.Hide();

        ObjAnimate( "obj_terenceroom_ext_josh_fraser_3_sight", "alp", 0, 0, private.DlgNext, { 0, 0, 1,   0.3, 0, 0 } );

      end

    end;

    ObjSet( obj_name..name.."_1", { input = false } );
    ObjSet( obj_name..name.."_2", { input = false } );

    if ( action == "show" ) then

      ObjAnimate( obj_name..name.."_"..number, "alp", 0, 0, func_end, { 0, 0, 0,   0.3, 0, 1 } );

    elseif ( action == "hide" ) then

      ObjAnimate( obj_name..name.."_"..number, "alp", 0, 0, func_end, { 0, 0, 1,   0.3, 0, 0 } );

    elseif ( action == "rotate" ) then

      ObjAnimate( obj_name..name.."_"..number, "alp", 0, 0, func_end, { 0, 0, 1,   0.3, 0, 0} );
      ObjAnimate( obj_name..name.."_"..number.."_1", "alp", 0, 0, "", { 0, 0, 0,   0.3, 0, 1 } );

    end;

  end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_terenceroom_ext ()

  if not ( cmn.IsEventDone( "opn_terenceroom_ext" ) ) then

    cmn.SetEventDone( "opn_terenceroom_ext" );
    common_impl.ShowBbt( "bbt_terenceroom_ext_opn_terenceroom_ext" );

  end;

  cmn.CallEventHandler( "opn_terenceroom_ext" ); 

end;
--*********************************************************************************************************************
-- function *** FEEDBACK ANIM *** () end;
--*********************************************************************************************************************
function private.UseLabamulet ()

  local func_end = function ()

    cmn.Lock( false );
    common_impl.ShowBbt( 'bbt_bedsidetable_use_labamulet' );

  end;

  cmn.Lock( true );
  ObjAnimate( "spr_bedsidetable_door", "pos_xy", 0, 0, func_end, 
  { 
    0.00, 0, ObjGet( "spr_bedsidetable_door" ).pos_x,       ObjGet( "spr_bedsidetable_door" ).pos_y,   
    0.15, 0, ObjGet( "spr_bedsidetable_door" ).pos_x - 2.0, ObjGet( "spr_bedsidetable_door" ).pos_y + 2.0,    
    0.30, 0, ObjGet( "spr_bedsidetable_door" ).pos_x,       ObjGet( "spr_bedsidetable_door" ).pos_y,   
  } );  

end;
--------------------------------------------------------------------------------------------