-- name=ho_archivedata_scr
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "archivedata_scr" );
  game.relations[ "ho_archivedata_scr" ].exitroom = "rm_mysteryroom";
  private.room_objname = "ho_archivedata_scr";
  --------------------------------------------------------------------------------------------------
  private.win_archivedata_scr = {};

  private.win_archivedata_scr.pos_inv = 
  { -230, -110, 10, 130, 250, 370, 490, 610, 730, 850, 970, 1090 };

  private.found = {};
  private.table_obj = 
  {
    { "bucket",             0, 1, { { "spr_archivedata_scr_bucket" } } },
    { "button",             0, 1, { { "spr_archivedata_scr_button" } } },
    { "dropper",            0, 1, { { "spr_archivedata_scr_dropper" } } },
    { "glasses",            0, 1, { { "spr_archivedata_scr_glasses" } } },
    { "gloves",             0, 1, { { "spr_archivedata_scr_gloves" } } },
    { "bandage",            0, 1, { { "spr_archivedata_scr_bandage" } } },
    { "bolt",               0, 1, { { "spr_archivedata_scr_bolt" } } },
    { "handcuffs",          0, 1, { { "spr_archivedata_scr_handcuffs" } } },
    { "hat",                0, 1, { { "spr_archivedata_scr_hat" } } },
    { "lantern",            0, 1, { { "spr_archivedata_scr_lantern" } } },
    { "patch",              0, 1, { { "spr_archivedata_scr_patch" } } },
    { "purse",              0, 1, { { "spr_archivedata_scr_purse" } } },--
    { "ruler",              0, 1, { { "spr_archivedata_scr_ruler" } } },
    { "sandwich",           0, 1, { { "spr_archivedata_scr_sandwich" } } },
    { "scissors",           0, 1, { { "spr_archivedata_scr_scissors" } } },
    { "sponge",             0, 1, { { "spr_archivedata_scr_sponge" } } },
    { "tablets",            0, 1, { { "spr_archivedata_scr_tablets" } } },
    { "towel",              0, 1, { { "spr_archivedata_scr_towel" } } },    
    { "folder_1",           0, 1, { { "spr_archivedata_scr_folder_1" } } },
    { "folder_2",           0, 1, { { "spr_archivedata_scr_folder_2" } } },
    { "folder_3",           0, 1, { { "spr_archivedata_scr_folder_3" } } },
    { "watch_2",            0, 1, { { "spr_archivedata_scr_watch_2" } } },
    { "watch_1",            0, 1, { { "spr_archivedata_scr_watch_1" } } }
  };

  private.ResetInit();
  private.Animation();
  --------------------------------------------------------------------------------------------
  -- function opn_archivedata_scr () end;
  --------------------------------------------------------------------------------------------
  local opn_archivedata_scr = function ()

    --

  end;

  cmn.AddSubscriber( "opn_archivedata_scr", opn_archivedata_scr, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_archivedata_scr () end;
  --------------------------------------------------------------------------------------------------
  local win_archivedata_scr_func = function ()

    if ( cmn.IsEventDone( "win_archivedata_scr" ) ) then

      --

    end;

  end;
  cmn.AddSubscriber( "win_archivedata_scr", win_archivedata_scr_func );
  --------------------------------------------------------------------------------------------------
  local start_archivedata_scr_func = function ()

    if ( not cmn.IsEventDone( "win_archivedata_scr" ) ) then

      local t_gen = ng_global.progress[ "scr" ][ "win_archivedata_scr" ].t_gen;
      for i = 1, #t_gen do

        ObjSet( "spr_archivedata_scr_"..t_gen[ i ][ 1 ], { visible = true, input = true, event_mdown = function() private.TaskComplete( t_gen[ i ][ 1 ] ) end } );

      end;

      --common_impl.ProcessHoStart( "archivedata_scr" );--AK>?????

      local ho_found = ng_global.progress[ "scr" ][ "win_archivedata_scr" ].found;

      for i = 1, #ho_found, 1 do

        ObjDetach( ho_found[ i ][ "object" ] );

      end;

    end;

  end;
  cmn.AddSubscriber( "win_archivedata_scr", start_archivedata_scr_func, "ho_archivedata_scr" );
  --------------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function private.Generate ()

  local tmp_array = {};
  for i = 1, #private.table_obj do
    tmp_array[ i ] = private.table_obj[ i ];
  end;

  ng_global.progress[ "scr" ][ "win_archivedata_scr" ].t_gen = {};
  
  for i = 1, 10 do

    local obj = table.remove( tmp_array, math.random( #tmp_array - 5 ) );
    ng_global.progress[ "scr" ][ "win_archivedata_scr" ].t_gen[ i ] = obj;
    ObjSet( "spr_archivedata_scr_"..obj[ 1 ], { alp = 1, visible = true, --[[input = true,]] event_mdown = function() private.TaskComplete( obj[ 1 ] ) end } );

  end;
  local obj = table.remove( tmp_array, math.random( #tmp_array - 4, #tmp_array - 2 ) );
  ng_global.progress[ "scr" ][ "win_archivedata_scr" ].t_gen[ 11 ] = obj;
  ObjSet( "spr_archivedata_scr_"..obj[ 1 ], { alp = 1, visible = true, --[[input = true,]] event_mdown = function() private.TaskComplete( obj[ 1 ] ) end } );

  local obj = table.remove( tmp_array, math.random( #tmp_array - 1, #tmp_array ) );
  ng_global.progress[ "scr" ][ "win_archivedata_scr" ].t_gen[ 12 ] = obj;
  ObjSet( "spr_archivedata_scr_"..obj[ 1 ], { alp = 1, visible = true, --[[input = true,]] event_mdown = function() private.TaskComplete( obj[ 1 ] ) end } );

end;
--*********************************************************************************************************************
function private.ResetInit ()

  local table_multiset = {};

  for i = 1, #private.table_obj do
    table.insert( table_multiset, { "spr_archivedata_scr_"..private.table_obj[ i ][ 1 ], { input = false, visible = false } } );--, pos_z = 0
  end;

  ObjMultiSet( table_multiset );

end;
--*********************************************************************************************************************
function public.ResetStart()

  local ho_found = private.found;

  for key = 1, #ho_found do

    ObjAttach( ho_found[ key ][ "object" ], "obj_archivedata_scr_objects" );
    ObjSet( ho_found[ key ][ "object" ], { alp = 1 } );

    local pfx_name = "pfx_int_taskpanel_collect_"..ho_found[ key ][ "object" ];
    if ( ObjGet( pfx_name ) ) then
      ObjDelete( pfx_name );
    end;

    pfx_name = "pfx_archivedata_scr_collect_"..ho_found[ key ][ "object" ].."_effect";
    if ( ObjGet( pfx_name ) ) then
      ObjDelete( pfx_name );
    end;

    pfx_name = "pfx_archivedata_scr_collect_obj_"..key.."_effect";
    if ( ObjGet( pfx_name ) ) then
      ObjDelete( pfx_name );
    end;

  end;  

  ng_global.progress[ "scr" ][ "win_archivedata_scr" ].task_check = nil;

  local table_multiset = {
    --
  }
  --ObjMultiSet( table_multiset );  

end;

--*********************************************************************************************************************
function public.PreOpen ()
  
  cmn.StopMusEnv();
  common_impl.EnvPlay( { "mus_env/aud_ho_mus_env" }, "", 0.5 );

  local is_repeat = false;
  
  if ( cmn.IsEventDone( "win_archivedata_scr" ) and cmn.IsEventStart( "win_archivedata_scr" ) ) then

    private.found = ng_global.progress[ "scr" ][ "win_archivedata_scr" ].found;
    ng_global.progress[ "scr" ][ "opn_archivedata_scr" ].done = 0;
    
    ng_global.progress[ "scr" ][ "win_archivedata_scr" ].done = 0;
    ng_global.progress[ "scr" ][ "win_archivedata_scr" ].start = 0;

    ng_global.progress[ "scr" ][ "win_archivedata_scr" ].t_gen = {};
    is_repeat = true;

    private.ResetInit();

  end; 
  
  if ( not cmn.IsEventDone( "opn_archivedata_scr" ) ) then

    private.Generate();

    cmn.InitHo( "archivedata_scr" );
    cmn.SetEventDone( "opn_archivedata_scr" );

    ng_global.progress[ "scr" ][ "win_archivedata_scr" ].count = 0;
    ng_global.progress[ "scr" ][ "win_archivedata_scr" ].anim  = false;

    ng_global.progress[ "scr" ][ "win_archivedata_scr" ].timer = { default = 40, time = 40, diff = 20, extra = 0 };
  
  end;

  local ho_items = {};
  local tmp_progress = ng_global.progress[ "scr" ][ "win_archivedata_scr" ].t_gen;
  private.win_archivedata_scr.task = {};

  for i = 1, 12 do

    interface.TaskPanelTaskAdd( ho_items, tmp_progress[ i ][ 1 ],  1, tmp_progress[ i ][ 2 ], tmp_progress[ i ][ 3 ] );
    table.insert( private.win_archivedata_scr.task, tmp_progress[ i ][ 1 ] );

  end;
  interface.TaskPanelShow( ho_items );

  if ( is_repeat ) then
 
    public.ResetStart();

  end;

  levelscr.InventoryDisable();
  private.Panel();
  
end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.TutorialShow( "tutorial_page_6_scr" );

  int_button_timer.Show();

  --  if cmn.IsEventStart( "see_tutorial" ) then
  --
  --    common_impl.TutorialShow( "tutorial_page_13" );
  --
  --  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  
  int_button_timer.Hide();

  ObjSet( "obj_int_taskpanel", { alp = 1 } );
  ObjSet( "txt_int_taskpanel", { alp = 1 } );

  ObjDetach( "spr_archivedata_scr_win" );

  ObjAttach( "obj_int_taskpanel_ho_archivedata_scr" , "ho_archivedata_scr" );

end;
--*********************************************************************************************************************
function public.HoComplete ()

  rm_mysteryroom.WinTask();

end;
--*********************************************************************************************************************
function private.TaskComplete ( name )

  local func_end = function ()

    cmn.Lock( true );

    cmn.HoTaskFind( "spr_archivedata_scr_"..name, name );

    for i = 1,#private.win_archivedata_scr.task do

      if ( private.win_archivedata_scr.task[ i ] == name ) then 

        local object_name = "obj_"..i; 
        local collect_name  = "pfx_archivedata_scr_collect_"..object_name.."_effect";
        ng_global.progress[ "scr" ][ "win_archivedata_scr" ].task_check[ i ] = 1;
        ObjCreate( collect_name, "partsys" );

        if  ( cmn.IsEventDone( "win_archivedata_scr" ) ) then

          cmn.Lock( false );

        end;

        ObjSet( collect_name,
        {
          res    = "assets/interface/resources/effects_ho_hint",
          pos_x  = ObjGet( object_name ).pos_x, pos_y = ObjGet( object_name ).pos_y,
          active = 1, visible = 1, input = 0
        } );

        ObjAttach( collect_name, "obj_int_taskpanel_ho_archivedata_scr" );
        ObjSet( collect_name, { blendmode = 2, scale_x = 0.9, scale_y = 0.9 } );
        --PartSysSetMaskObj( collect_name, object_name );  
        local func_end = function () private.AnimInv( i ); end;
        ObjAnimate( object_name, 8,0,0, func_end,
        { 
          0.0, 0, 1.0,
          0.1, 0, 0.0
          --1.0, 0, 0.0
        } );

      end;

    end;

  end;

  --[[if #ng_global.progress[ "scr" ][ "win_archivedata_scr" ].found == 11 then

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_terence_2lvl", 0, "", 0 );

    cmn.PlayDialogVideo( "vid_archivedata_scr_terenec", func_end );

  else]]

    func_end();

  --end;

end;
--*********************************************************************************************************************
function private.GetItem ( name )

end;
--*********************************************************************************************************************
function private.UseItem ( name ) 
  
end;
--*********************************************************************************************************************
function private.UseItemEnd ( name )

end;
--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );

  if ( not ng_global.progress[ "scr" ][ "win_archivedata_scr" ].task_check ) then

     ng_global.progress["scr"]["win_archivedata_scr"].task_check = {0,0,0,0,0,0,0,0,0,0,0,0};

  end;

  local posx = -230;
  local tmp = 0;

  ObjSet( "obj_int_taskpanel_ho_archivedata_scr", { croprect_init = true, croprect_x = -295, croprect_y = -200, croprect_w = 617, croprect_h = 400 } );

  for i = 1,#private.win_archivedata_scr.task do 

    local obj = "obj_"..i;

    if ( ObjGet( obj ) ) then

      ObjDelete( obj );        

    end;

    if ( ng_global.progress[ "scr" ][ "win_archivedata_scr" ].task_check[ i ] == 0 ) then

      ObjCreate( obj, "obj" );
      ObjAttach( obj, "obj_int_taskpanel_ho_archivedata_scr" );
      ObjAttach( "obj_int_taskpanel_ho_archivedata_scr" , "spr_int_taskpanel" );
      ObjSet( obj, { pos_x = posx, pos_y = 30, inputrect_init = true, inputrect_x = -45, inputrect_y = -45, inputrect_w = 90, inputrect_h = 90, alp = 1, input = 0  } );
      local spr = "spr_archivedata_scr_"..private.win_archivedata_scr.task[ i ].."_inv";
      ObjCreate( spr, "spr" );
      ObjSet( spr, { res = "assets/levels/levelscr/ho_archivedata_scr/layers/"..private.win_archivedata_scr.task[ i ].."_shadow", scale_x = 0.95, scale_y = 0.95 } );
      ObjAttach( spr, obj );
      tmp = tmp + 1;
      if ( tmp < 6 ) then

         private.CheckPanel( i, tmp );
        
      end;

      posx = posx + 120;

      if ( tmp == 12 ) then

          ng_global.progress["scr"]["win_archivedata_scr"].set = 1;

      end;

    end;

  end;
   
end;
--********************************************************************************************************************* 
function private.CheckPanel ( i, tmp ) 

   local obj = "obj_"..i;

   if ( tmp < 6 ) then

      ObjSet( obj, { input = 1 } );

      ObjAnimate( obj, "alp", 0, 0, "", 
      { 
        0,0,0, 
        0.3,0,1 
      } );

      ObjSet( "spr_archivedata_scr_"..private.win_archivedata_scr.task[ i ], { alp = 1, input = 1 } );


   end;
   
end;
--*********************************************************************************************************************
function private.AnimInv ( num )

  local item = "obj_"..num;
  local tmp = num + 1;

    for i = tmp,#private.win_archivedata_scr.task do

      local obj_tmp = "obj_"..i;

      if obj_tmp ~= nil and ng_global.progress["scr"]["win_archivedata_scr"].task_check[i] ~= 1 then

        ObjAnimate( "obj_"..i, "pos_x", 0, 0, "", 
        { 
          0.0,3,ObjGet( "obj_"..i ).pos_x, 
          0.4,3,ObjGet( "obj_"..i ).pos_x-120
          --0.8,3,ObjGet( "obj_"..i ).pos_x-120
        } );

        if ObjGet( "obj_"..i ).pos_x-120 == 250 then

          ObjAnimate( "obj_"..i, "scale_xy", 0, 0, "", 
          { 
            0.0,0,0.2,0.2, 
            0.3,0,1,1, 
            0.4,0,1.2,1.2,
            0.5,0,1,1

            --0.0,0,0.2,0.2, 
            --0.6,0,1,1, 
            --0.8,0,1.2,1.2,
            --1.0,0,1,1

          } );

        end;

      end;

    end;

  private.Check( num );

end;
--*********************************************************************************************************************
function private.Check ( num )  

  local tmp = 0;

  for i = 1,#private.win_archivedata_scr.task do

    local item = "obj_"..i;

    if ( item and ng_global.progress[ "scr" ][ "win_archivedata_scr" ].task_check[ i ] ~= 1 ) then

       tmp = tmp + 1;

       if ( tmp < 6 ) then

          ObjSet( "spr_archivedata_scr_"..private.win_archivedata_scr.task[ i ], { alp = 1, input = 1 } );

       end;

       num = num + 1;

    end;

  end;

  local func_end = function () 

  cmn.Lock( false ) 

  end;

  ObjAnimate( "ho_archivedata_scr", "alp", 0, 0, func_end, 
    { 
      0.0, 3, 1, 
      0.5, 3, 1
    } );

end;
--*********************************************************************************************************************
function private.Animation ()

  ObjAnimate( "spr_archivedata_scr_light1", "alp", 1, 0, "", 
  { 
    0.0,  0,  1.0,
    3.0,  0,  0.0,
    6.0,  0,  1.0
  } );

end;
--*********************************************************************************************************************