-- name=ho_behindmirror_scr
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "behindmirror_scr" );
  game.relations[ "ho_behindmirror_scr" ].exitroom = "rm_mysteryroom";
  private.room_objname = "ho_behindmirror_scr";
  --------------------------------------------------------------------------------------------------
  private.found = {};
  private.table_obj = 
  {
    { "apple",        0, 1, { { "spr_behindmirror_scr_apple" } } },
    { "ball",         0, 1, { { "spr_behindmirror_scr_ball" } } },
    { "bead",         0, 1, { { "spr_behindmirror_scr_bead" } } },
    { "beetle",       0, 1, { { "spr_behindmirror_scr_beetlee" } } },
    { "candy",        0, 1, { { "spr_behindmirror_scr_candy" } } },
    { "cat",          0, 1, { { "spr_behindmirror_scr_cat" } } },
    { "compass",      0, 1, { { "spr_behindmirror_scr_compass" } } },
    { "ear",          0, 1, { { "spr_behindmirror_scr_ear" } } },
    { "fenix",        0, 1, { { "spr_behindmirror_scr_fenix" } } },
    { "fish",         0, 1, { { "spr_behindmirror_scr_fish" } } },
    { "heart",        0, 1, { { "spr_behindmirror_scr_heart" } } },
    { "pearl",        0, 1, { { "spr_behindmirror_scr_pearl" } } },
    { "sun",          0, 1, { { "spr_behindmirror_scr_sun" } } },
    { "tablets",      0, 1, { { "spr_behindmirror_scr_tablets" } } },
    { "watch",        0, 1, { { "spr_behindmirror_scr_watch" } } },
    { "hand",         0, 1, { { "spr_behindmirror_scr_hand" } } },
    { "flowers",      0, 1, { { "spr_behindmirror_scr_flowers" } } },
    { "jaw",          0, 1, { { "spr_behindmirror_scr_jaw" } } },
    { "eye",          0, 1, { { "spr_behindmirror_scr_eye" } } },
    { "bone",         0, 1, { { "spr_behindmirror_scr_bone" } } },
    { "paper_1",      0, 1, { { "spr_behindmirror_scr_paper_1" } } },
    { "paper_2",      0, 1, { { "spr_behindmirror_scr_paper_2" } } },
    { "paper_3",      0, 1, { { "spr_behindmirror_scr_paper_3" } } }
  };

  private.ResetInit();
  --------------------------------------------------------------------------------------------
  -- function opn_behindmirror_scr () end;
  --------------------------------------------------------------------------------------------    
  local opn_behindmirror_scr = function ()

    --

  end;
  cmn.AddSubscriber( "opn_behindmirror_scr", opn_behindmirror_scr, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_behindmirror_scr () end;
  --------------------------------------------------------------------------------------------    
  local win_behindmirror_scr_loc = function ()

    if ( cmn.IsEventDone( "win_behindmirror_scr" ) ) then

       --

    end;

  end;
  cmn.AddSubscriber( "win_behindmirror_scr", win_behindmirror_scr_loc );
  --------------------------------------------------------------------------------------------------
  local start_behindmirror_scr_func = function ()

    if ( not cmn.IsEventDone( "win_behindmirror_scr" ) ) then

      local t_gen = ng_global.progress[ "scr" ][ "win_behindmirror_scr" ].t_gen;
      for i = 1, #t_gen do

        ObjSet( "spr_behindmirror_scr_"..t_gen[ i ][ 1 ], { visible = true, input = true, event_mdown = function() private.TaskComplete( t_gen[ i ][ 1 ] ) end } );

      end;

      local ho_found = ng_global.progress[ "scr" ][ "win_behindmirror_scr" ].found;

      for i = 1, #ho_found, 1 do

        ObjDetach( ho_found[ i ][ "object" ] );

      end;

    end;

  end;

  cmn.AddSubscriber( "win_behindmirror_scr", start_behindmirror_scr_func, private.room_objname );
  
end;
--*********************************************************************************************************************
function private.Generate ()

  local tmp_array = {};
  for i = 1, #private.table_obj do
    tmp_array[ i ] = private.table_obj[ i ];
  end;

  ng_global.progress[ "scr" ][ "win_behindmirror_scr" ].t_gen = {};
  
  for i = 1, 11 do

    local obj = table.remove( tmp_array, math.random( #tmp_array - 3 ) );
    ng_global.progress[ "scr" ][ "win_behindmirror_scr" ].t_gen[ i ] = obj;
    ObjSet( "spr_behindmirror_scr_"..obj[ 1 ], { alp = 1, visible = true, input = true, event_mdown = function() private.TaskComplete( obj[ 1 ] ) end } );

  end;

  local paper = math.random( 21, 23 );
  table.insert( ng_global.progress[ "scr" ][ "win_behindmirror_scr" ].t_gen, math.random( 11 ), private.table_obj[ paper ] );
  ObjSet( "spr_behindmirror_scr_"..private.table_obj[ paper ][ 1 ], { alp = 1, visible = true, input = true, event_mdown = function() private.TaskComplete( private.table_obj[ paper ][ 1 ] ) end } );
 
end;
--*********************************************************************************************************************
function private.ResetInit ()

  local table_multiset = {};

  for i = 1, #private.table_obj do

    table.insert( table_multiset, { "spr_behindmirror_scr_"..private.table_obj[ i ][ 1 ], { input = false, visible = false } } );

  end;

  ObjMultiSet( table_multiset );

end;
--*********************************************************************************************************************
function public.ResetStart()

  local ho_found = private.found;

  for key = 1, #ho_found do

    ObjAttach( ho_found[ key ][ "object" ], "obj_behindmirror_scr_objects" );
    ObjSet( ho_found[ key ][ "object" ], { alp = 1 } );

    local pfx_name = "pfx_int_taskpanel_collect_"..ho_found[ key ][ "object" ];
    if ( ObjGet( pfx_name ) ) then
      ObjDelete( pfx_name );
    end;

  end; 

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.EnvPlay( { "mus_env/aud_ho_mus_env" }, "", 0.5 );

  common_impl.TutorialShow( "tutorial_page_6_scr" );

  local is_repeat = false;
  
  if ( cmn.IsEventDone( "win_behindmirror_scr" ) and cmn.IsEventStart( "win_behindmirror_scr" ) ) then

    private.found = ng_global.progress[ "scr" ][ "win_behindmirror_scr" ].found;
    ng_global.progress[ "scr" ][ "opn_behindmirror_scr" ].done = 0;
    
    ng_global.progress[ "scr" ][ "win_behindmirror_scr" ].done = 0;
    ng_global.progress[ "scr" ][ "win_behindmirror_scr" ].start = 0;

    ng_global.progress[ "scr" ][ "win_behindmirror_scr" ].t_gen = {};
    is_repeat = true;

    private.ResetInit();

  end; 
  
  if ( not cmn.IsEventDone( "opn_behindmirror_scr" ) ) then

    private.Generate();

    cmn.InitHo( "behindmirror_scr" );
    cmn.SetEventDone( "opn_behindmirror_scr" );

    ng_global.progress[ "scr" ][ "win_behindmirror_scr" ].count = 0;
    ng_global.progress[ "scr" ][ "win_behindmirror_scr" ].anim  = false;

    ng_global.progress[ "scr" ][ "win_behindmirror_scr" ].timer = { default = 40, time = 40, diff = 20, extra = 0 };
  
  end;

  local ho_items = {};
  local tmp_progress = ng_global.progress[ "scr" ][ "win_behindmirror_scr" ].t_gen;

  for i = 1, 12 do

    interface.TaskPanelTaskAdd( ho_items, tmp_progress[ i ][ 1 ],  1, tmp_progress[ i ][ 2 ], tmp_progress[ i ][ 3 ] );

  end;
  interface.TaskPanelShow( ho_items );

  if ( is_repeat ) then
 
    public.ResetStart();

  end;

  levelscr.InventoryDisable();

end;
--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Open ()
  
  int_button_timer.Show();

end;
--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  
  int_button_timer.Hide();

  ObjDetach( "spr_behindmirror_scr_win" );

end;
--*********************************************************************************************************************
function public.HoComplete ()
  
  rm_mysteryroom.WinTask();

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete ( task_name, object )
  
  local find_obj = "spr_behindmirror_scr_"..task_name;
  if ( object ) then

    find_obj = object;

  end;

  cmn.HoTaskFind( find_obj, task_name );
   
end;
--*********************************************************************************************************************