-- name=ho_engineerbox_scr
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "engineerbox_scr" );
  game.relations[ "ho_engineerbox_scr" ].exitroom = "rm_mysteryroom";

  ObjAnimate( "spr_ho_engineerbox_scr_light", "alp",1,0, "", { 0, 3, 0.7,    1.5, 3, 0.1,    3, 3, 0.4,    5, 3, 1,    6, 3, 0.7 } );

  private.room_objname = "ho_engineerbox_scr";
  private.task_name = "win_engineerbox_scr";
  private.win = 6;

  private.coordinates = 
  { 
      spr_ho_engineerbox_scr_brush1_cover         = { old = { pos_x = 858, pos_y = 317 }, new = { pos_x = 761, pos_y = 335 } },
      spr_ho_engineerbox_scr_brush2_cover         = { old = { pos_x = 632, pos_y = 588 }, new = { pos_x = 638, pos_y = 639 } },
      spr_ho_engineerbox_scr_tape_measure2_cover  = { old = { pos_x = 33, pos_y = 433 }, new = { pos_x = -49, pos_y = 409 } },
      spr_ho_engineerbox_scr_rope1_cover          = { old = { pos_x = 540, pos_y = 463 }, new = { pos_x = 616, pos_y = 466 } },      
      spr_ho_engineerbox_scr_rope2_cover          = { old = { pos_x = 804, pos_y = 174 }, new = { pos_x = 885, pos_y = 166 } },
      spr_ho_engineerbox_scr_pin1_cover           = { old = { pos_x = 174, pos_y = 357 }, new = { pos_x = 185, pos_y = 308 } },
      spr_ho_engineerbox_scr_pin2_cover           = { old = { pos_x = 1015, pos_y = 85 }, new = { pos_x = 1015, pos_y = 48 } },
      spr_ho_engineerbox_scr_vise1_cover          = { old = { pos_x = 94, pos_y = 166 }, new = { pos_x = 151, pos_y = 144 } },
      spr_ho_engineerbox_scr_vise2_cover          = { old = { pos_x = 577, pos_y = 299 }, new = { pos_x = 482, pos_y = 334 } },
      spr_ho_engineerbox_scr_tube2_cover          = { old = { pos_x = 398, pos_y = 129 }, new = { pos_x = 355, pos_y = 126 } },
      spr_ho_engineerbox_scr_screwdriver1_cover   = { old = { pos_x = 261, pos_y = 81 }, new = { pos_x = 176, pos_y = 63 } },
      spr_ho_engineerbox_scr_screwdriver2_cover   = { old = { pos_x = 382, pos_y = 572 }, new = { pos_x = 310, pos_y = 553 } },
      spr_ho_engineerbox_scr_pliers1_cover        = { old = { pos_x = 310, pos_y = 255 }, new = { pos_x = 233, pos_y = 268 } },
      spr_ho_engineerbox_scr_key2_cover           = { old = { pos_x = 844, pos_y = 578 }, new = { pos_x = 903, pos_y = 516 } },
      spr_ho_engineerbox_scr_bulb2_cover          = { old = { pos_x = 230, pos_y = 566 }, new = { pos_x = 293, pos_y = 553 } },
      spr_ho_engineerbox_scr_key1_cover           = { old = { pos_x = 196, pos_y = 438 }, new = { pos_x = 232, pos_y = 384 } }
  };

  --------------------------------------------------------------------------------------------------
  private.found = {};
  private.table_obj = 
  {
    { "brush1",         0, 1, { { "spr_ho_engineerbox_scr_brush1_cover", "spr_ho_engineerbox_scr_brush2_cover" } } },
    { "brush2",         0, 1, { { "spr_ho_engineerbox_scr_brush2_cover", "spr_ho_engineerbox_scr_brush1_cover" } } },
    { "pliers1",        0, 1, { { "spr_ho_engineerbox_scr_pliers1_cover", "spr_ho_engineerbox_scr_pliers2_cover" } } },
    { "pliers2",        0, 1, { { "spr_ho_engineerbox_scr_pliers2_cover", "spr_ho_engineerbox_scr_pliers1_cover" } } },    
    { "tape_measure1",  0, 1, { { "spr_ho_engineerbox_scr_tape_measure1_cover", "spr_ho_engineerbox_scr_tape_measure2_cover" } } },
    { "tape_measure2",  0, 1, { { "spr_ho_engineerbox_scr_tape_measure2_cover", "spr_ho_engineerbox_scr_tape_measure1_cover" } } },
    { "rope1",          0, 1, { { "spr_ho_engineerbox_scr_rope1_cover", "spr_ho_engineerbox_scr_rope2_cover" } } },
    { "rope2",          0, 1, { { "spr_ho_engineerbox_scr_rope2_cover", "spr_ho_engineerbox_scr_rope1_cover" } } },
    { "pin1",           0, 1, { { "spr_ho_engineerbox_scr_pin1_cover", "spr_ho_engineerbox_scr_pin2_cover" } } },
    { "pin2",           0, 1, { { "spr_ho_engineerbox_scr_pin2_cover", "spr_ho_engineerbox_scr_pin1_cover" } } },
    { "vise1",          0, 1, { { "spr_ho_engineerbox_scr_vise1_cover", "spr_ho_engineerbox_scr_vise2_cover" } } },
    { "vise2",          0, 1, { { "spr_ho_engineerbox_scr_vise2_cover", "spr_ho_engineerbox_scr_vise1_cover" } } },
    { "tube1",          0, 1, { { "spr_ho_engineerbox_scr_tube1_cover", "spr_ho_engineerbox_scr_tube2_cover" } } },
    { "tube2",          0, 1, { { "spr_ho_engineerbox_scr_tube2_cover", "spr_ho_engineerbox_scr_tube1_cover" } } },
    { "screwdriver1",   0, 1, { { "spr_ho_engineerbox_scr_screwdriver1_cover", "spr_ho_engineerbox_scr_screwdriver2_cover" } } },
    { "screwdriver2",   0, 1, { { "spr_ho_engineerbox_scr_screwdriver2_cover", "spr_ho_engineerbox_scr_screwdriver1_cover"} } },
    { "key1",           0, 1, { { "spr_ho_engineerbox_scr_key1_cover", "spr_ho_engineerbox_scr_key2_cover" } } },
    { "key2",           0, 1, { { "spr_ho_engineerbox_scr_key2_cover", "spr_ho_engineerbox_scr_key1_cover"} } },
    { "bulb1",          0, 1, { { "spr_ho_engineerbox_scr_bulb1_cover", "spr_ho_engineerbox_scr_bulb2_cover" } } },
    { "bulb2",          0, 1, { { "spr_ho_engineerbox_scr_bulb2_cover", "spr_ho_engineerbox_scr_bulb1_cover" } } }--,
    --{ "key",          0, 1, { { "spr_indollhouse_scr_key" } } }
  };

  private.ResetInit();
  --------------------------------------------------------------------------------------------
  -- function opn_engineerbox_scr () end;
  --------------------------------------------------------------------------------------------    
  local opn_engineerbox_scr = function ()

    --

  end;
  cmn.AddSubscriber( "opn_engineerbox_scr", opn_engineerbox_scr, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_indollhouse_scr () end;
  --------------------------------------------------------------------------------------------  
  local win_engineerbox_scr_func = function ()

    if ( cmn.IsEventDone( "win_engineerbox_scr" ) ) then

      --

    end;

  end;
  cmn.AddSubscriber( "win_engineerbox_scr", win_engineerbox_scr_func );
  --------------------------------------------------------------------------------------------  
  local start_engineerbox_scr_func = function ()

    local ho_name = common.GetObjectName( private.room_objname );
    if ( not cmn.IsEventDone( "win_"..ho_name ) ) then

      local t_gen = ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].t_gen;
      for i = 1, #t_gen do

        local name_task = string.sub( t_gen[ i ][ 1 ], 1, string.len( t_gen[ i ][ 1 ] ) - 1 );
        local cover_name = "spr_ho_"..ho_name.."_"..t_gen[ i ][ 1 ].."_cover";
        local task_prefix = "spr_ho_"..ho_name.."_"..t_gen[ i ][ 1 ];
        ObjSet( cover_name, { visible = true, input = true, event_mdown = function() private.TaskComplete( cover_name, name_task ) end } );
        ObjSet( task_prefix, { visible = true } );

      end;  

      local foundCouples = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples;
      local nameTaskObjects = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].name_task_objects;

      if ( #foundCouples > 0 ) then 

        local lastCouple = foundCouples[ #foundCouples ];
        if ( #lastCouple == 1 ) then

          local taskPanelObject = "spr_ho_engineerbox_scr_"..lastCouple[ 1 ].."_shadow1";
          ObjAttach( taskPanelObject, "obj_int_taskpanel_ho_engineerbox_scr" ); 
          ObjSet( taskPanelObject, { pos_x = -150, pos_y = 22 } );

          ObjSet( "txt_ho_engineerbox_scr_taskpanel", { scale_x = 0, scale_y = 0 } );

        else 

          ObjSet( "txt_ho_engineerbox_scr_taskpanel", { scale_x = 1, scale_y = 1 } );

        end; 

        if ( #foundCouples == private.win ) and ( #lastCouple == 2 ) then 

          --[[ObjAttach( "spr_ho_engineerbox_scr_boltcutterpart_shadow", "obj_int_taskpanel_ho_engineerbox_scr" ); 
          ObjSet( "spr_ho_engineerbox_scr_boltcutterpart_shadow", { pos_x = -5, pos_y = 22 } );
          ObjSet( "spr_ho_engineerbox_scr_boltcutterpart", { input = true } );]]

        end;

      end;
-------------------------------------
-------------------------------------
      for i = 1, #foundCouples do 

        local curCoupleObject = foundCouples[ i ];
        local curCoupleCover = nameTaskObjects[ i ];

        for j = 1, #curCoupleObject, 1 do 

          local task = curCoupleObject[ j ];
          local taskObject = "spr_ho_engineerbox_scr_"..task..j;

          if ( #curCoupleObject == 2 ) then
            ObjSet( taskObject, { visible = false, input = false } );--AK> вместо detach
            --ObjDelete( taskObject );
          end;

          local taskObjectCover = curCoupleCover[ j ];
          ObjSet( taskObjectCover, { input = false } );

          if ( taskObjectCover == "spr_ho_engineerbox_scr_pliers2_cover" ) then
    
            ObjSet( "spr_ho_engineerbox_scr_pliers2_cover", { alp = 1 } );
            ObjSet( "spr_ho_engineerbox_scr_pliers2_up", { alp = 1 } );
            ObjSet( "spr_ho_engineerbox_scr_pliers2_up_2", { alp = 0 } );

          elseif ( taskObjectCover == "spr_ho_engineerbox_scr_bulb1_cover" ) then

            ObjSet( "spr_ho_engineerbox_scr_bulb1_used", { alp = 1 } );
            ObjSet( "spr_ho_engineerbox_scr_bulb1_cover", { alp = 0 } );

          elseif ( taskObjectCover == "spr_ho_engineerbox_scr_tube1_cover" ) then

            ObjSet( "spr_ho_engineerbox_scr_tube1_cover", { alp = 0 } );

          elseif ( taskObjectCover == "spr_ho_engineerbox_scr_tape_measure1_cover" ) then

            ObjSet( "spr_ho_engineerbox_scr_tape_measure1_cover_used", { alp = 1 } );
            ObjSet( "spr_ho_engineerbox_scr_tape_measure1_cover", { alp = 0 } );

          else 

            local taskObjectCoverX = private.coordinates[ taskObjectCover ].new.pos_x;
            local taskObjectCoverY = private.coordinates[ taskObjectCover ].new.pos_y;

            ObjSet( taskObjectCover, { pos_x = taskObjectCoverX, pos_y = taskObjectCoverY } );

          end;

        end; 

      end;

    end;

  end;
  cmn.AddSubscriber( "win_engineerbox_scr", start_engineerbox_scr_func, "ho_engineerbox_scr" );  

end;
--*********************************************************************************************************************
function private.Generate ()

  local tmp_array = {};
  for i = 1, #private.table_obj do
    tmp_array[ i ] = private.table_obj[ i ];
  end;

  local ho_name = common.GetObjectName( private.room_objname );
  ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].t_gen = {};
  
  for i = 1, 6 do

    local id = ( math.random( ( #tmp_array )/2 ) - 1 ) * 2;

    local obj = table.remove( tmp_array, id + 1 );
    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].t_gen[ ( i - 1 ) * 2 + 1 ] = obj;

    local name_task = string.sub( obj[ 1 ], 1, string.len( obj[ 1 ] ) - 1 );
    local cover_name = "spr_ho_"..ho_name.."_"..obj[ 1 ].."_cover";
    local task_prefix = "spr_ho_"..ho_name.."_"..name_task;
    ObjSet( cover_name, { visible = true, input = true, event_mdown = function() private.TaskComplete( cover_name, name_task ) end } );
    ObjSet( task_prefix, { visible = true } );

    local objd = table.remove( tmp_array, id + 1 );
    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].t_gen[ ( i - 1 ) * 2 + 2 ] = objd;

    local cover_named = "spr_ho_"..ho_name.."_"..objd[ 1 ].."_cover";
    local task_prefixd = "spr_ho_"..ho_name.."_"..name_task;
    ObjSet( cover_named, { visible = true, input = true, event_mdown = function() private.TaskComplete( cover_named, name_task ) end } );
    ObjSet( task_prefixd, { visible = true } );


  end;

  --[[local num_key = math.random( #private.table_key_params );
  ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].num_key = num_key;
  ObjSet( "spr_"..ho_name.."_key", { 
    res = "assets/levels/levelscr/ho_indollhouse_scr/items/key"..num_key,
    pos_x = private.table_key_params[ num_key ].pos_x, 
    pos_y = private.table_key_params[ num_key ].pos_y, 
    alp = 1, visible = true, 
    event_mdown = function() private.TaskComplete( "key" ) end } );]]

end;
--*********************************************************************************************************************
function private.ResetInit ()

  local ho_name = common.GetObjectName( private.room_objname );

  local table_multiset = {};

  for i = 1, #private.table_obj do

    local name_task = string.sub( private.table_obj[ i ][ 1 ], 1, string.len( private.table_obj[ i ][ 1 ] ) - 1 );
    local cover_name = "spr_ho_"..ho_name.."_"..private.table_obj[ i ][ 1 ].."_cover";
    local task_prefix = "spr_ho_"..ho_name.."_"..name_task;

    table.insert( table_multiset, { cover_name, { input = false } } );
    table.insert( table_multiset, { task_prefix.."1", { input = false } } );
    table.insert( table_multiset, { task_prefix.."2", { input = false } } );--, pos_z = 0
    ObjAttach( task_prefix.."1", "obj_"..ho_name.."_layers" );
    ObjAttach( task_prefix.."2", "obj_"..ho_name.."_layers" );

  end;

  ObjMultiSet( table_multiset );

end;
 --*********************************************************************************************************************
function public.ResetStart ()

  local ho_found = private.found;
  local ho_name = common.GetObjectName( private.room_objname );

  for key = 1, #ho_found do

    local cover_name = "spr_ho_"..ho_name.."_"..ho_found[ key ][ "task" ].."_cover";
    local task_object = "spr_ho_"..ho_name.."_"..ho_found[ key ][ "task" ];
    ObjSet( task_object, { alp = 1 } );
    ObjAttach( task_object, "obj_ho_engineerbox_scr_layers" );

    if ( cover_name == "spr_ho_engineerbox_scr_pliers2_cover" ) then
    
      ObjSet( "spr_ho_engineerbox_scr_pliers2_cover", { alp = 0 } );
      ObjSet( "spr_ho_engineerbox_scr_pliers2_up", { alp = 0 } );
      ObjSet( "spr_ho_engineerbox_scr_pliers2_up_2", { alp = 1 } );

    elseif ( cover_name == "spr_ho_engineerbox_scr_bulb1_cover" ) then

      ObjSet( "spr_ho_engineerbox_scr_bulb1_used", { alp = 0 } );
      ObjSet( "spr_ho_engineerbox_scr_bulb1_cover", { alp = 1 } );

    elseif ( cover_name == "spr_ho_engineerbox_scr_tube1_cover" ) then

      ObjSet( "spr_ho_engineerbox_scr_tube1_cover", { alp = 1 } );

    elseif ( cover_name == "spr_ho_engineerbox_scr_tape_measure1_cover" ) then

      ObjSet( "spr_ho_engineerbox_scr_tape_measure1_cover_used", { alp = 0 } );
      ObjSet( "spr_ho_engineerbox_scr_tape_measure1_cover", { alp = 1 } );

    else

      ObjSet( cover_name, { pos_x = private.coordinates[ cover_name ].old.pos_x, pos_y = private.coordinates[ cover_name ].old.pos_y } );
  
    end;

    ObjSet( "txt_ho_engineerbox_scr_taskpanel", { alp = 1 } );

    local pfx_name = "pfx_int_taskpanel_collect_spr_ho_engineerbox_scr_"..ho_found[ key ][ "task" ];
    if ( ObjGet( pfx_name ) ) then
      ObjDelete( pfx_name );
    end;

    --[[ObjAttach( ho_found[ key ][ "object" ], "obj_"..ho_name.."_objects" );
    ObjSet( ho_found[ key ][ "object" ], { alp = 1 } );]]

  end; 

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.EnvPlay( { "mus_env/aud_ho_mus_env" }, "", 0.5 );

  local ho_name = common.GetObjectName( private.room_objname );
  local is_repeat = false;
  if ( cmn.IsEventDone( "win_"..ho_name ) and cmn.IsEventStart( "win_"..ho_name ) ) then

    private.found = ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].found;
    ng_global.progress[ ng_global.currentprogress ][ "opn_"..ho_name ].done = 0;
    
    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].done = 0;
    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].start = 0;

    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].t_gen = {};
    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].num_key = 0;
    is_repeat = true;

    private.ResetInit();

  end;

  if ( not cmn.IsEventDone( "opn_"..ho_name ) ) then
  
    ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples = {};
    ng_global.progress[ ng_global.currentprogress ][ private.task_name ].name_task_objects = {};
    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].timer = { default = 40, time = 40, diff = 20, extra = 0 };

    private.Generate();

    cmn.InitHo( ho_name );
    cmn.SetEventDone( "opn_"..ho_name );
      
  end;

  local ho_items = {};

  local tmp_progress = ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].t_gen;

  for i = 1, 12 do

    interface.TaskPanelTaskAdd( ho_items, tmp_progress[ i ][ 1 ],  1, tmp_progress[ i ][ 2 ], tmp_progress[ i ][ 3 ] );

  end;

  --interface.TaskPanelTaskAdd( ho_items, "key",  1, 0, { { "spr_indollhouse_scr_key" } } ); 
  ObjAttach( "obj_int_taskpanel_ho_engineerbox_scr", "int_taskpanel_impl" ); 
  private.TaskPanelUpdate(); 
  interface.TaskPanelShow( ho_items );

  if ( is_repeat ) then
 
    public.ResetStart();

  end;

  levelscr.InventoryDisable();

end;


--*********************************************************************************************************************
function public.Open ()

  common_impl.TutorialShow( "tutorial_page_6_scr" );

  int_button_timer.Show();

end;


--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();

end;


--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  
  ObjSet( "obj_int_taskpanel", { alp = 1, visible = true } );
  ObjDetach( "obj_int_taskpanel_ho_engineerbox_scr" );
  int_button_timer.Hide();

  ObjDetach( "spr_engineerbox_scr_win" );

end;


--*********************************************************************************************************************
function public.HoComplete ()
  
  rm_mysteryroom.WinTask()
  
end;


--*********************************************************************************************************************
function private.TaskComplete( sender, task ) 

  local EMPTY_PROGRESS = 0;
  local ACTIVATE_WIN_OBJECT = 6;
  local NOT_COMPLETED_COUPLE = 1;
  local COMPLETED_COUPLE = 2;

  local foundCouples = {};
  foundCouples = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples;
  local countFoundCouples = #foundCouples;

  local nameTaskObjects = {};
  nameTaskObjects = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].name_task_objects;

  if countFoundCouples == EMPTY_PROGRESS then
 
    local foundTask = { task };
    table.insert( foundCouples, foundTask );

    local foundObjectTask = { sender };
    table.insert( nameTaskObjects, foundObjectTask );

    private.AnimCoveringObjects( sender, "FIRST_OBJECT_OF_COUPLE", task );
    private.TaskPanel( "NOT_COMPLETED_COUPLE", task );
    ObjSet( sender, { input = false } );

    cmn.Lock( true );
    ObjSet( "ho_engineerbox_scr", { input = false } );

  else 

    local lastCouple = foundCouples[countFoundCouples];
    local sizeLastCouple = #lastCouple;

    if sizeLastCouple == COMPLETED_COUPLE then   

      if countFoundCouples == ACTIVATE_WIN_OBJECT then 

        local taskObjectNameWin = "spr_ho_engineerbox_scr_"..task;
        cmn.HoTaskFind( taskObjectNameWin, task );
        --private.TaskPanel( "WINNING", "boltcutterpart" );
        public.HoComplete();

      else 

        local foundTask = { task };
        table.insert( foundCouples, foundTask );

        local foundObjectTask = { sender };
        table.insert( nameTaskObjects, foundObjectTask );

        private.AnimCoveringObjects( sender, "FIRST_OBJECT_OF_COUPLE", task );
        private.TaskPanel( "NOT_COMPLETED_COUPLE", task );
        ObjSet( sender, { input = false } );

        cmn.Lock( true );
        ObjSet( "ho_engineerbox_scr", { input = false } );

      end;

    elseif sizeLastCouple == NOT_COMPLETED_COUPLE then  

      local firstObject = lastCouple[1];
      local lastObjectTask = nameTaskObjects[#nameTaskObjects];
      local prevSender = lastObjectTask[1];

      if firstObject == task then 

        table.insert( lastCouple, task );
        table.insert( lastObjectTask, sender );

        local taskObjectName_1 = "spr_ho_engineerbox_scr_"..task.."1";
        local task_1 = task.."1";
        cmn.HoTaskFind( taskObjectName_1, task_1 );
        common_impl.StopAudio( "sfx", "aud_hide_sfx", 0 );

        local taskObjectName_2 = "spr_ho_engineerbox_scr_"..task.."2";
        local task_2 = task.."2";
        cmn.HoTaskFind( taskObjectName_2, task_2 );

        private.AnimCoveringObjects( sender, "SECOND_OBJECT_OF_RIGHT_COUPLE", task );
        private.TaskPanel( "RIGHT_COMPLETED_COUPLE", task );
        ObjSet( sender, { input = false } );

        cmn.Lock( true );
        ObjSet( "ho_engineerbox_scr", { input = false } );

        if countFoundCouples == ACTIVATE_WIN_OBJECT then 

          ObjSet( "spr_ho_engineerbox_scr_boltcutterpart", { input = true } );

          local func_end_win = function () 
            private.TaskPanel( "ACTIVATE_WIN_OBJECT", "boltcutterpart" );
          end;

          ObjAnimate( "obj_ho_engineerbox_scr_items", "alp",0,0, func_end_win, { 0, 0, 1,    0.7, 0, 1 } );

        end;

      else 

        table.remove ( foundCouples );
        table.remove ( nameTaskObjects );

        private.AnimCoveringObjects( sender, "SECOND_OBJECT_OF_WRONG_COUPLE", task, prevSender );
        private.TaskPanel( "WRONG_COMPLETED_COUPLE", firstObject );
        ObjSet( prevSender, { input = true } );

        cmn.Lock( true );
        ObjSet( "ho_engineerbox_scr", { input = false } );

      end;

    end;

  end;

  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples = foundCouples;
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].name_task_objects = nameTaskObjects;

end;


--*********************************************************************************************************************
function private.GettingMoveType( taskObject ) 

  local result = "MOVE_XY";
  
  if ( taskObject == "spr_ho_engineerbox_scr_pliers2_cover" ) or
     ( taskObject == "spr_ho_engineerbox_scr_bulb1_cover" ) or 
     ( taskObject == "spr_ho_engineerbox_scr_tube1_cover" ) or
     ( taskObject == "spr_ho_engineerbox_scr_tape_measure1_cover" ) then

    result = "MOVE_ALPHA";

  end;

  return result;

end;


--*********************************************************************************************************************
function private.MoveCoveringObjects( taskObject, moveType, direction ) 

  if moveType == "MOVE_XY" then 

    local oldX = private.coordinates[ taskObject ].old.pos_x;
    local oldY = private.coordinates[ taskObject ].old.pos_y;

    local newX = private.coordinates[ taskObject ].new.pos_x;
    local newY = private.coordinates[ taskObject ].new.pos_y;

    local beginX = 0;
    local beginY = 0;

    local endX = 0;
    local endY = 0;

    if direction == "OLD_TO_NEW" then 

      beginX = oldX;
      beginY = oldY;

      endX = newX;
      endY = newY;

    elseif direction == "NEW_TO_OLD" then 

      beginX = newX;
      beginY = newY;

      endX = oldX;
      endY = oldY;

    end;

    ObjAnimate( taskObject, "pos_xy",0,0, func_end, { 0, 3, beginX, beginY,    0.4, 3, endX, endY } );

  elseif moveType == "MOVE_ALPHA" then

    local beginState = 0;
    local endState = 0;

    if direction == "OLD_TO_NEW" then 

      beginState = 0;
      endState = 1;

    elseif direction == "NEW_TO_OLD" then 

      beginState = 1;
      endState = 0;

    end;

    if ( string.find( taskObject, "pliers2" ) ) then

      ObjAnimate( "spr_ho_engineerbox_scr_pliers2_cover", "alp",0,0, "", { 0, 3, beginState,    0.4, 3, endState } );
      ObjAnimate( "spr_ho_engineerbox_scr_pliers2_up", "alp",0,0, "", { 0, 3, beginState,    0.4, 3, endState } );
      ObjAnimate( "spr_ho_engineerbox_scr_pliers2_up_2", "alp",0,0, "", { 0, 3, endState,    0.4, 3, beginState } );
    
    elseif ( string.find( taskObject, "bulb1" ) ) then

      ObjAnimate( "spr_ho_engineerbox_scr_bulb1_cover", "alp",0,0, "", { 0, 3, endState,    0.4, 3, beginState } );
      ObjAnimate( "spr_ho_engineerbox_scr_bulb1_used", "alp",0,0, "", { 0, 3, beginState,    0.4, 3, endState } );

    elseif ( string.find( taskObject, "tube1" ) ) then

      ObjAnimate( "spr_ho_engineerbox_scr_tube1_cover", "alp",0,0, "", { 0, 3, endState,    0.4, 3, beginState } );

    else

      ObjAnimate( "spr_ho_engineerbox_scr_tape_measure1_cover", "alp",0,0, "", { 0, 3, endState,    0.4, 3, beginState } );
      ObjAnimate( "spr_ho_engineerbox_scr_tape_measure1_cover_used", "alp",0,0, "", { 0, 3, beginState,    0.4, 3, endState } );

    end;

  end;
  
end;


--*********************************************************************************************************************
function private.AnimCoveringObjects( sender, animType, task, prevSender ) 

  local func_end_block = function () 

    cmn.Lock( false );
    ObjSet( "ho_engineerbox_scr", { input = true } );

  end;

  if animType == "FIRST_OBJECT_OF_COUPLE" then 

    private.MoveCoveringObjects( sender, private.GettingMoveType( sender ), "OLD_TO_NEW" );
    ObjAnimate( "obj_ho_engineerbox_scr_layers", "scale_x",0,0, func_end_block, { 0, 0, 1,    0.5, 0, 1 } );

  elseif animType == "SECOND_OBJECT_OF_RIGHT_COUPLE" then 

    private.MoveCoveringObjects( sender, private.GettingMoveType( sender ), "OLD_TO_NEW" );
    ObjAnimate( "obj_ho_engineerbox_scr_layers", "scale_x",0,0, func_end_block, { 0, 0, 1,    0.5, 0, 1 } );

  elseif animType == "SECOND_OBJECT_OF_WRONG_COUPLE" then 

    local func_end = function () 

      if prevSender then 
        private.MoveCoveringObjects( prevSender, private.GettingMoveType( prevSender ), "NEW_TO_OLD" );
        private.MoveCoveringObjects( sender, private.GettingMoveType( sender ), "NEW_TO_OLD" ); 
      end;

    end;

    private.MoveCoveringObjects( sender, private.GettingMoveType( sender ), "OLD_TO_NEW" );
    ObjAnimate( "obj_ho_engineerbox_scr_layers", "alp",0,0, func_end, { 0, 0, 1,    0.4, 0, 1 } );
    ObjAnimate( "obj_ho_engineerbox_scr_layers", "scale_x",0,0, func_end_block, { 0, 0, 1,    1.0, 0, 1 } );

  end; 

end;


--*********************************************************************************************************************
function private.TaskPanelUpdate() 

  ObjSet( "obj_int_taskpanel", { alp = 0, visible = false } );

  ObjSet( "txt_ho_engineerbox_scr_taskpanel", { pos_x = -10, pos_y = 22 } );
  ObjAttach( "txt_ho_engineerbox_scr_taskpanel", "obj_int_taskpanel_ho_engineerbox_scr" );

  foundCouples = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].couples;
  local count = 6 - #foundCouples;

  local COLOR_R = 0.7804;
  local COLOR_G = 0.60392;
  local COLOR_B = 0.42352;

  ObjSet( "txt_ho_engineerbox_scr_taskpanel",
  {
     text   = "str_int_taskpanel_pattern_couples",
     param0 = COLOR_R,
     param1 = COLOR_G,
     param2 = COLOR_B,
     param3 = StringGet( "str_taskpanel_couple_ho" ),
     param4 = count
   } );

  if count == 0 then 
  
    ObjSet( "txt_ho_engineerbox_scr_taskpanel", { alp = 0 } );

  end;

end;


--*********************************************************************************************************************
function private.TaskPanel( animType, curTask ) 

  local OBJECT_Y = 22;
  local OBJECT_LEFT_X = -150;
  local OBJECT_MIDDLE_X = -5;
  local OBJECT_RIGHT_X = 145;

  if animType == "NOT_COMPLETED_COUPLE" then 

    local taskPanelObject = "spr_ho_engineerbox_scr_"..curTask.."_shadow1";
    ObjAttach( taskPanelObject, "obj_int_taskpanel_ho_engineerbox_scr" ); 

    ObjSet( taskPanelObject, { pos_x = OBJECT_LEFT_X, pos_y = OBJECT_Y } );
    ObjAnimate( taskPanelObject, "alp",0,0, "", { 0, 3, 0,    0.3, 3, 1 } );

    ObjAnimate( "txt_ho_engineerbox_scr_taskpanel", "scale_xy",0,0, "", { 0, 3, 1, 1,    0.3, 3, 0, 0 } );

  elseif animType == "RIGHT_COMPLETED_COUPLE" then 

    local taskPanelObject_1 = "spr_ho_engineerbox_scr_"..curTask.."_shadow1";
    local taskPanelObject_2 = "spr_ho_engineerbox_scr_"..curTask.."_shadow2";
    ObjAttach( taskPanelObject_2, "obj_int_taskpanel_ho_engineerbox_scr" ); 

    local func_end = function () 

      ObjAnimate( taskPanelObject_1, "alp",0,0, "", { 0, 3, 1,    0.3, 3, 0 } );
      ObjAnimate( taskPanelObject_2, "alp",0,0, "", { 0, 3, 1,    0.3, 3, 0 } );
------------------------------
------------------------------
      local fxTaskPanelObject = "fx_spr_ho_engineerbox_scr_"..curTask;
      local pos = GetObjPosByObj( taskPanelObject_1, "obj_int_taskpanel_ho_engineerbox_scr" );
      ObjCreate( fxTaskPanelObject, "partsys" );
      ObjSet( fxTaskPanelObject,
      {
        res = "assets/interface/resources/ho_collect_effect",
        blendmode = 2, color_r = 0.8, color_g = 0.4, color_b = 1, 
        alp = 1, visible = 1, pos_x = pos[1], pos_y = pos[2], pos_z = 1, input = 0
      } );

      local func_end_fx = function () 
        ObjDelete( fxTaskPanelObject );
      end;

      ObjAttach( fxTaskPanelObject, "obj_int_taskpanel_ho_engineerbox_scr" );
      ObjAnimate( fxTaskPanelObject, "alp", 0, 0, func_end_fx, { 0, 0, 1,    0.4, 0, 1,    0.7, 0, 0 } );
------------------------------
------------------------------
      private.TaskPanelUpdate();
      ObjAnimate( "txt_ho_engineerbox_scr_taskpanel", "scale_xy",0,0, "", { 0, 3, 0, 0,    0.3, 3, 1, 1 } );

    end;

    ObjSet( taskPanelObject_2, { pos_x = OBJECT_RIGHT_X, pos_y = OBJECT_Y } );
    ObjAnimate( taskPanelObject_2, "alp",0,0, "", { 0, 3, 0,    0.3, 3, 1 } );

    ObjAnimate( taskPanelObject_1, "pos_x",0,0, "", { 0, 3, OBJECT_LEFT_X,    0.3, 3, OBJECT_LEFT_X,    0.7, 3, OBJECT_MIDDLE_X } );
    ObjAnimate( taskPanelObject_2, "pos_x",0,0, func_end, { 0, 3, OBJECT_RIGHT_X,    0.3, 3, OBJECT_RIGHT_X,    0.7, 3, OBJECT_MIDDLE_X } );   

  elseif animType == "WRONG_COMPLETED_COUPLE" then 

    local taskPanelObject = "spr_ho_engineerbox_scr_"..curTask.."_shadow1";

    local func_end = function () 

      ObjDetach( taskPanelObject );

    end;

    ObjAnimate( taskPanelObject, "alp",0,0, func_end, { 0, 3, 1,    0.3, 3, 0 } );

    private.TaskPanelUpdate();
    ObjAnimate( "txt_ho_engineerbox_scr_taskpanel", "scale_xy",0,0, "", { 0, 3, 0, 0,    0.3, 3, 1, 1 } );

  elseif animType == "ACTIVATE_WIN_OBJECT" then 

    local taskPanelObject = "spr_ho_engineerbox_scr_"..curTask.."_shadow";
    ObjAttach( taskPanelObject, "obj_int_taskpanel_ho_engineerbox_scr" ); 

    ObjSet( taskPanelObject, { pos_x = OBJECT_MIDDLE_X, pos_y = OBJECT_Y } );
    ObjAnimate( taskPanelObject, "alp",0,0, "", { 0, 3, 0,    0.3, 3, 1 } );

  elseif animType == "WINNING" then 

    local taskPanelObject = "spr_ho_engineerbox_scr_"..curTask.."_shadow";
    ObjAnimate( taskPanelObject, "alp",0,0, "", { 0, 3, 1,    0.3, 3, 0 } );

  end;

end;
