-- name=ho_indollhouse_scr
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "indollhouse_scr" );
  game.relations[ "ho_indollhouse_scr" ].exitroom = "rm_mysteryroom";
  private.room_objname = "ho_indollhouse_scr";

  private.find_final_object = "str_indollhouse_scr_final_object";--

  --------------------------------------------------------------------------------------------------
  private.found = {};
  private.table_obj = 
  {
    { "cake",         0, 1, { { "spr_indollhouse_scr_cake" } } },
    { "airplane",     0, 1, { { "spr_indollhouse_scr_airplane" } } },
    { "glasses",      0, 1, { { "spr_indollhouse_scr_glasses" } } },
    { "bruin",        0, 1, { { "spr_indollhouse_scr_bruin" } } },    
    { "elephant",     0, 1, { { "spr_indollhouse_scr_elephant" } } },
    { "nutcracker",   0, 1, { { "spr_indollhouse_scr_nutcracker" } } },
    { "sun",          0, 1, { { "spr_indollhouse_scr_sun" } } },
    { "tortoise",     0, 1, { { "spr_indollhouse_scr_tortoise" } } },
    { "helicopter",   0, 1, { { "spr_indollhouse_scr_helicopter" } } },
    { "oldpaper",     0, 1, { { "spr_indollhouse_scr_oldpaper" } } },
    { "pony",         0, 1, { { "spr_indollhouse_scr_pony" } } },
    { "rattle",       0, 1, { { "spr_indollhouse_scr_rattle" } } },
    { "rolypoly",     0, 1, { { "spr_indollhouse_scr_rolypoly" } } },
    { "sticker",      0, 1, { { "spr_indollhouse_scr_sticker" } } },
    { "duckling",     0, 1, { { "spr_indollhouse_scr_duckling" } } },
    { "thread",       0, 1, { { "spr_indollhouse_scr_thread" } } },
    { "pyramid",      0, 1, { { "spr_indollhouse_scr_pyramid" } } },
    { "pillow",       0, 1, { { "spr_indollhouse_scr_pillow" } } },
    { "yoyo",         0, 1, { { "spr_indollhouse_scr_yoyo" } } },
    { "pingpong",     0, 1, { { "spr_indollhouse_scr_pingpong" } } },
    { "key",          0, 1, { { "spr_indollhouse_scr_key" } } }
  };
  private.table_key_params = { { pos_x = 167, pos_y = 545 }, { pos_x = 724, pos_y = 565 }, { pos_x = 398, pos_y = 239 } };

  private.InitAnimations();

  private.ResetInit();

  --------------------------------------------------------------------------------------------
  -- function opn_indollhouse_scr () end;
  --------------------------------------------------------------------------------------------    
  local opn_indollhouse_scr = function ()

    --

  end;
  cmn.AddSubscriber( "opn_indollhouse_scr", opn_indollhouse_scr, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_indollhouse_scr () end;
  --------------------------------------------------------------------------------------------  
  local win_indollhouse_scr_func = function ()

    if ( cmn.IsEventDone( "win_indollhouse_scr" ) ) then

      --

    end;

  end;
  cmn.AddSubscriber( "win_indollhouse_scr", win_indollhouse_scr_func );
  --------------------------------------------------------------------------------------------------
  local start_indollhouse_scr_func = function ()

    local ho_name = common.GetObjectName( private.room_objname );
    if ( not cmn.IsEventDone( "win_"..ho_name ) ) then

      local t_gen = ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].t_gen;
      for i = 1, #t_gen do

        ObjSet( "spr_"..ho_name.."_"..t_gen[ i ][ 1 ], { visible = true, input = true, event_mdown = function() private.TaskComplete( t_gen[ i ][ 1 ] ) end } );

      end;  
      local num_key = ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].num_key
      ObjSet( "spr_"..ho_name.."_key", { 
        res = "assets/levels/levelscr/ho_indollhouse_scr/items/key"..num_key,
        pos_x = private.table_key_params[ num_key ].pos_x, 
        pos_y = private.table_key_params[ num_key ].pos_y, 
        visible = true,  input = false,
        event_mdown = function() private.TaskComplete( "key" ) end } );    

      local ho_found = ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].found;

      for i = 1, #ho_found, 1 do

        ObjDetach( ho_found[ i ][ "object" ] );

      end;

      if ( #ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].found == 12 ) then

        ObjAttach( "txt_"..ho_name.."_task", "int_taskpanel_impl");
        ObjSet( "spr_"..ho_name.."_key", { input = true } ); 
        ObjSet( "obj_int_taskpanel", { alp = 0 } );
        ObjSet( "txt_"..ho_name.."_task", { alp = 1, text = private.find_final_object } );
           
      end;

    end;

  end;
  cmn.AddSubscriber( "win_indollhouse_scr", start_indollhouse_scr_func, "ho_indollhouse_scr" );  

end;
--*********************************************************************************************************************
function private.Generate ()

  local tmp_array = {};
  for i = 1, #private.table_obj - 1 do
    tmp_array[ i ] = private.table_obj[ i ];
  end;

  local ho_name = common.GetObjectName( private.room_objname );
  ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].t_gen = {};
  
  for i = 1, 12 do

    local obj = table.remove( tmp_array, math.random( #tmp_array ) );
    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].t_gen[ i ] = obj;
    ObjSet( "spr_"..ho_name.."_"..obj[ 1 ], { alp = 1, visible = true, input = true, event_mdown = function() private.TaskComplete( obj[ 1 ] ) end } );

  end;

  local num_key = math.random( #private.table_key_params );
  ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].num_key = num_key;
  ObjSet( "spr_"..ho_name.."_key", { 
    res = "assets/levels/levelscr/ho_indollhouse_scr/items/key"..num_key,
    pos_x = private.table_key_params[ num_key ].pos_x, 
    pos_y = private.table_key_params[ num_key ].pos_y, 
    alp = 1, visible = true, 
    event_mdown = function() private.TaskComplete( "key" ) end } );

end;
--*********************************************************************************************************************
function private.ResetInit ()

  local ho_name = common.GetObjectName( private.room_objname );

  ObjSet( "txt_"..ho_name.."_task", { alp = 0 } );

  local table_multiset = {};

  for i = 1, #private.table_obj do

    table.insert( table_multiset, { "spr_"..ho_name.."_"..private.table_obj[ i ][ 1 ], { input = false, visible = false } } );--, pos_z = 0
    ObjAttach( "spr_"..ho_name.."_"..private.table_obj[ i ][ 1 ], "obj_"..ho_name.."_objects" );

  end;

  ObjMultiSet( table_multiset );

end;
--*********************************************************************************************************************
function public.ResetStart ()

  local ho_found = private.found;
  local ho_name = common.GetObjectName( private.room_objname );

  for key = 1, #ho_found do

    ObjAttach( ho_found[ key ][ "object" ], "obj_"..ho_name.."_objects" );
    ObjSet( ho_found[ key ][ "object" ], { alp = 1 } );

    local pfx_name = "pfx_int_taskpanel_collect_"..ho_found[ key ][ "object" ];
    if ( ObjGet( pfx_name ) ) then
      ObjDelete( pfx_name );
    end;

  end; 

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.EnvPlay( { "mus_env/aud_ho_mus_env" }, "", 0.5 );

  local ho_name = common.GetObjectName( private.room_objname );
  local is_repeat = false;
  if ( cmn.IsEventDone( "win_"..ho_name ) and cmn.IsEventStart( "win_"..ho_name ) ) then

    private.found = ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].found;
    ng_global.progress[ ng_global.currentprogress ][ "opn_"..ho_name ].done = 0;
    
    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].done = 0;
    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].start = 0;

    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].t_gen = {};
    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].num_key = 0;
    is_repeat = true;

    private.ResetInit();

  end;

  if ( not cmn.IsEventDone( "opn_"..ho_name ) ) then

    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].timer = { default = 40, time = 40, diff = 20, extra = 0 };
  
    private.Generate();

    cmn.InitHo( ho_name );
    cmn.SetEventDone( "opn_"..ho_name );
      
  end;

  local ho_items = {};

  local tmp_progress = ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].t_gen;

  for i = 1, 12 do

    interface.TaskPanelTaskAdd( ho_items, tmp_progress[ i ][ 1 ],  1, tmp_progress[ i ][ 2 ], tmp_progress[ i ][ 3 ] );

  end;

  interface.TaskPanelTaskAdd( ho_items, "key",  1, 0, { { "spr_indollhouse_scr_key" } } ); 
 
  interface.TaskPanelShow( ho_items );

  if ( is_repeat ) then
 
    public.ResetStart();

  end;

  levelscr.InventoryDisable();

  if ( #ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].found == 12 ) then

    ObjAttach( "txt_"..ho_name.."_task", "int_taskpanel_impl");    
    ObjSet( "obj_int_taskpanel", { alp = 0 } );
    ObjSet( "txt_"..ho_name.."_task", { alp = 1, text = private.find_final_object } );
       
  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.TutorialShow( "tutorial_page_6_scr" );

  int_button_timer.Show();

--  if cmn.IsEventStart( "see_tutorial" ) then
--
--    common_impl.TutorialShow( "tutorial_page_6" );
--
--  end;

end;
--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  ObjAttach( "txt_indollhouse_scr_task", "ho_indollhouse_scr");
  ObjSet( "obj_int_taskpanel", { alp = 1 } );
  
  int_button_timer.Hide();

  ObjDetach( "spr_indollhouse_scr_win" );

end;
--*********************************************************************************************************************
function public.HoComplete ()
  
  rm_mysteryroom.WinTask()

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete ( task_name, piece_number )
  
  local find_obj = "spr_indollhouse_scr_"..task_name;
  local ho_name = common.GetObjectName( private.room_objname );

  cmn.HoTaskFind( find_obj, task_name );
  
  if ( #ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].found == 12 ) then

    ObjAttach( "txt_"..ho_name.."_task", "int_taskpanel_impl");
    ObjSet( "obj_int_taskpanel", { alp = 0 } );
    ObjSet( "txt_"..ho_name.."_task", { alp = 1, text = private.find_final_object } );
    ObjSet( "spr_"..ho_name.."_key", { input = true } ); 
       
  end;
 
end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_indollhouse_scr_s_hook", "ang", 1, 0, "", 
  { 
    0.0, 3, 0.11, 
    2.0, 3, -0.06, 
    4.0, 3, 0.11 
  } );  
  ObjAnimate( "spr_indollhouse_scr_s_whirligig", "ang", 1, 0, "", 
  { 
    0.0, 3, 0.11, 
    4.0, 3, -0.07, 
    8.0, 3, 0.11 
  } );  

end;
--*********************************************************************************************************************