-- name=ho_itemscollecting_scr
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "itemscollecting_scr" );
  game.relations[ "ho_itemscollecting_scr" ].exitroom = "rm_mysteryroom";
  private.room_objname = "ho_itemscollecting_scr";

  private.find_final_object = "str_itemscollecting_scr_final_object";
  private.Init_Animation();

  --------------------------------------------------------------------------------------------------
  private.found = {};
  private.table_obj = 
  {
    { "fork",            1, 1, { { "spr_itemscollecting_scr_fork"           }, { "obj_itemscollecting_scr_clk_box_1"} } , "obj_itemscollecting_scr_box_down_objects" },
    { "pen",             1, 1, { { "spr_itemscollecting_scr_pen"           }, { "obj_itemscollecting_scr_clk_box_1"} } , "obj_itemscollecting_scr_box_down_objects" },
    { "gun",             1, 1, { { "spr_itemscollecting_scr_gun"           }, { "obj_itemscollecting_scr_clk_box_1"} } , "obj_itemscollecting_scr_box_down_objects" },
    { "compass",         1, 1, { { "spr_itemscollecting_scr_compass"           }, { "obj_itemscollecting_scr_clk_box_1"} } , "obj_itemscollecting_scr_box_down_objects" },
    { "flask",           1, 1, { { "spr_itemscollecting_scr_flask"           }, { "obj_itemscollecting_scr_clk_box_1"} } , "obj_itemscollecting_scr_box_down_objects" },
    { "money",           1, 1, { { "spr_itemscollecting_scr_money"           }, { "obj_itemscollecting_scr_clk_box_1"} } , "obj_itemscollecting_scr_box_down_objects" },
    { "belt",            1, 1, { { "spr_itemscollecting_scr_belt"           }, { "obj_itemscollecting_scr_clk_box_1"} } , "obj_itemscollecting_scr_box_down_objects" },
    { "pin",             0, 1, { { "spr_itemscollecting_scr_pin" } } , "obj_itemscollecting_scr_objects" },
    { "perfume",         0, 1, { { "spr_itemscollecting_scr_perfume" } } , "obj_itemscollecting_scr_objects" },
    { "map",             0, 1, { { "spr_itemscollecting_scr_map" } } , "ho_itemscollecting_scr" },
    { "bracelet",        0, 1, { { "spr_itemscollecting_scr_bracelet" } } , "obj_itemscollecting_scr_objects" },
    { "feather",         0, 1, { { "spr_itemscollecting_scr_feather" } } , "obj_itemscollecting_scr_objects" },
    { "spoon",           0, 1, { { "spr_itemscollecting_scr_spoon" } } , "obj_itemscollecting_scr_objects" },
    { "butterflytie",    0, 1, { { "spr_itemscollecting_scr_butterflytie" } } , "ho_itemscollecting_scr" },
    { "banana",          0, 1, { { "spr_itemscollecting_scr_banana" } } , "ho_itemscollecting_scr" },
    { "cigarettecase",   0, 1, { { "spr_itemscollecting_scr_cigarettecase" } } , "ho_itemscollecting_scr" },
    { "rope",            0, 1, { { "spr_itemscollecting_scr_rope" }, { "obj_itemscollecting_scr_clk_box_2"} } , "obj_itemscollecting_scr_box_objects" },
    { "scissors",        0, 1, { { "spr_itemscollecting_scr_scissors" }, { "obj_itemscollecting_scr_clk_box_2"} } , "obj_itemscollecting_scr_box_objects" },
    { "gloves",          0, 1, { { "spr_itemscollecting_scr_gloves" }, { "obj_itemscollecting_scr_clk_box_2"} } , "obj_itemscollecting_scr_box_objects" },
    { "wisp",            0, 1, { { "spr_itemscollecting_scr_wisp" }, { "obj_itemscollecting_scr_clk_box_2"} } , "obj_itemscollecting_scr_box_objects" },
    { "soap",            0, 1, { { "spr_itemscollecting_scr_soap" }, { "obj_itemscollecting_scr_clk_box_2"} } , "obj_itemscollecting_scr_box_objects" },
    { "camera",          0, 1, { { "spr_itemscollecting_scr_camera" }, { "obj_itemscollecting_scr_clk_box_2"} } , "obj_itemscollecting_scr_box_objects" },
  };
  private.intersecting_objects = 
  {
    { "fork", "pen" },
    { "rope", "scissors" },
    { "gloves", "wisp" },
    { "soap", "camera" },
    { "pin", "bracelet" },
    { "spoon", "feather" },
    { "cigarettecase", "banana" },
    { "flask", "compass" },
    { "belt", "money" },
  };

  --------------------------------------------------------------------------------------------------
  local table_multiset = {
    { "spr_itemscollecting_scr_map", { event_mdown = function() private.TaskComplete( "map" ) end } },
    { "spr_itemscollecting_scr_gun", { event_mdown = function() private.TaskComplete( "gun" ) end } },
    { "spr_itemscollecting_scr_butterflytie", { event_mdown = function() private.TaskComplete( "butterflytie" ) end } },
    { "spr_itemscollecting_scr_perfume", { event_mdown = function() private.TaskComplete( "perfume" ) end } },
    { "obj_itemscollecting_scr_clk_box_1",             { event_mdown = function() private.clk_box() end } },
    { "obj_itemscollecting_scr_clk_box_2",             { event_mdown = function() private.clk_box() end } } };

  ObjMultiSet( table_multiset );

  private.ResetInit();

  --------------------------------------------------------------------------------------------
  -- function opn_itemscollecting_scr () end;
  --------------------------------------------------------------------------------------------    
  local opn_itemscollecting_scr = function ()

    --

  end;
  cmn.AddSubscriber( "opn_itemscollecting_scr", opn_itemscollecting_scr, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_itemscollecting_scr () end;
  --------------------------------------------------------------------------------------------  
  local win_itemscollecting_scr_func = function ()

    if ( cmn.IsEventDone( "win_itemscollecting_scr" ) ) then

      --

    end;

  end;
  cmn.AddSubscriber( "win_itemscollecting_scr", win_itemscollecting_scr_func );
  --------------------------------------------------------------------------------------------------
  local start_itemscollecting_scr_func = function ()

    local ho_name = common.GetObjectName( private.room_objname );
    if ( not cmn.IsEventDone( "win_"..ho_name ) ) then

      local t_gen = ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].t_gen;
      for i = 1, #t_gen do

        ObjSet( "spr_"..ho_name.."_"..t_gen[ i ][ 1 ], { alp = 1, visible = true, input = true, event_mdown = function() private.TaskComplete( t_gen[ i ][ 1 ] ) end } );

      end;    
      ObjSet( "spr_"..ho_name.."_map", { visible = true, alp = 1 } );   
      ObjSet( "spr_"..ho_name.."_gun", { visible = true, alp = 1, input = true } );   
      ObjSet( "spr_"..ho_name.."_perfume", { visible = true, alp = 1, input = true } ); 
      ObjSet( "spr_"..ho_name.."_butterflytie", { visible = true, alp = 1, input = true } ); 

      local ho_found = ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].found;

      for i = 1, #ho_found, 1 do

        ObjDetach( ho_found[ i ][ "object" ] );

      end;

      if ( #ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].found == 12 ) then

        ObjAttach( "txt_"..ho_name.."_task", "int_taskpanel_impl");
        ObjSet( "spr_"..ho_name.."_map", { input = true } ); 
        ObjSet( "obj_int_taskpanel", { alp = 0 } );
        ObjSet( "txt_"..ho_name.."_task", { alp = 1, text = private.find_final_object } );
           
      end;

    end;

  end;
  cmn.AddSubscriber( "win_itemscollecting_scr", start_itemscollecting_scr_func, private.room_objname );  
end;

--*********************************************************************************************************************
function private.Generate ()

  local tmp_array = {};
  for i = 1, #private.intersecting_objects do    
    tmp_array[ i ] = {};
    for j = 1, #private.intersecting_objects[ i ] do
      tmp_array[ i ][ j ] = private.intersecting_objects[ i ][ j ];
    end;
  end;

  local ho_name = common.GetObjectName( private.room_objname );
  ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].t_gen = {};
  
  for i = 1, 9 do

    local arr_random = table.remove( tmp_array, math.random( #tmp_array ) );
    local name_random = table.remove( arr_random, math.random( #arr_random ) );
    for j = 1, #private.table_obj do

      if ( name_random == private.table_obj[ j ][ 1 ] ) then
        
        ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].t_gen[ i ] = private.table_obj[ j ];
        ObjSet( "spr_"..ho_name.."_"..private.table_obj[ j ][ 1 ], { alp = 1, visible = true, input = true, event_mdown = function() private.TaskComplete( private.table_obj[ j ][ 1 ] ) end } );
        break;

      end;

    end;

  end;

  ObjSet( "spr_"..ho_name.."_perfume", { alp = 1, visible = true, input = true } );
  ObjSet( "spr_"..ho_name.."_map", { alp = 1, visible = true } );
  ObjSet( "spr_"..ho_name.."_butterflytie", { alp = 1, visible = true, input = true } );
  ObjSet( "spr_"..ho_name.."_gun", { alp = 1, visible = true, input = true } );

end;
--*********************************************************************************************************************
function private.ResetInit ()

  local ho_name = common.GetObjectName( private.room_objname );

  ObjSet( "txt_"..ho_name.."_task", { alp = 0 } );

  local table_multiset = {};

  for i = 1, #private.table_obj do

    table.insert( table_multiset, { "spr_"..ho_name.."_"..private.table_obj[ i ][ 1 ], { input = false, visible = false } } ); --, pos_z = 0
    ObjAttach( "spr_"..ho_name.."_"..private.table_obj[ i ][ 1 ], private.table_obj[ i ][ 5 ] );

  end;

  ObjMultiSet( table_multiset );

end;
--*********************************************************************************************************************
function public.ResetStart ()

  local ho_found = private.found;
  local ho_name = common.GetObjectName( private.room_objname );

  for key = 1, #ho_found do

    --ObjAttach( ho_found[ key ][ "object" ], "obj_"..ho_name.."_objects" );
    ObjSet( ho_found[ key ][ "object" ], { alp = 1 } );

    local pfx_name = "pfx_int_taskpanel_collect_"..ho_found[ key ][ "object" ];
    if ( ObjGet( pfx_name ) ) then
      ObjDelete( pfx_name );
    end;

  end; 

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.EnvPlay( { "mus_env/aud_ho_mus_env" }, "", 0.5 );

  local ho_name = common.GetObjectName( private.room_objname );
  local is_repeat = false;
  if ( cmn.IsEventDone( "win_"..ho_name ) and cmn.IsEventStart( "win_"..ho_name ) ) then

    private.found = ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].found;
    ng_global.progress[ ng_global.currentprogress ][ "opn_"..ho_name ].done = 0;
    
    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].done = 0;
    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].start = 0;

    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].t_gen = {};

    ng_global.progress[ ng_global.currentprogress ][ "win_itemscollecting_scr" ].open_box = false;
    ng_global.progress[ ng_global.currentprogress ][ "win_itemscollecting_scr" ].close_up = false;
    ng_global.progress[ ng_global.currentprogress ][ "win_itemscollecting_scr" ].close_down = false;

    is_repeat = true;

    private.ResetInit();

  end;

  if ( not cmn.IsEventDone( "opn_"..ho_name ) ) then
  
    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].timer = { default = 40, time = 40, diff = 20, extra = 0 };

    private.Generate();

    cmn.InitHo( ho_name );
    cmn.SetEventDone( "opn_"..ho_name );

    cmn.SetMarkedTask( "itemscollecting_scr", "fork" );
    cmn.SetMarkedTask( "itemscollecting_scr", "pen" );
    cmn.SetMarkedTask( "itemscollecting_scr", "gun" );
    cmn.SetMarkedTask( "itemscollecting_scr", "compass" );
    cmn.SetMarkedTask( "itemscollecting_scr", "flask" );
    cmn.SetMarkedTask( "itemscollecting_scr", "money" );
    cmn.SetMarkedTask( "itemscollecting_scr", "belt" );

    cmn.SetMarkedTask( "itemscollecting_scr", "rope" );
    cmn.SetMarkedTask( "itemscollecting_scr", "scissors" );
    cmn.SetMarkedTask( "itemscollecting_scr", "gloves" );  
    cmn.SetMarkedTask( "itemscollecting_scr", "wisp" );
    cmn.SetMarkedTask( "itemscollecting_scr", "soap" );
    cmn.SetMarkedTask( "itemscollecting_scr", "camera" ); 
      
  end;

  local ho_items = {};

  local tmp_progress = ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].t_gen;

  for i = 1, 9 do

    interface.TaskPanelTaskAdd( ho_items, tmp_progress[ i ][ 1 ],  1, tmp_progress[ i ][ 2 ], tmp_progress[ i ][ 3 ] );

  end;
  interface.TaskPanelTaskAdd( ho_items, "gun", 1, 0, { { "spr_itemscollecting_scr_gun" } } );
  interface.TaskPanelTaskAdd( ho_items, "butterflytie", 1, 0, { { "spr_itemscollecting_scr_butterflytie" } } );
  interface.TaskPanelTaskAdd( ho_items, "perfume", 1, 0, { { "spr_itemscollecting_scr_perfume" } } );
  interface.TaskPanelTaskAdd( ho_items, "map",  1, 0, { { "spr_itemscollecting_scr_map" } } );
  
  interface.TaskPanelShow( ho_items );

  if ( ng_global.progress[ ng_global.currentprogress ][ "win_itemscollecting_scr" ].open_box ) then

    private.clk_box_open();
    ObjSet( "obj_itemscollecting_scr_box_up", { pos_x = 0, pos_y = 0 } );

  else

    private.clk_box_close();
    ObjSet( "obj_itemscollecting_scr_box_up", { pos_x = 86, pos_y = -86 } );

  end;


  if ( ng_global.progress[ ng_global.currentprogress ][ "win_itemscollecting_scr" ].close_up ) then

    private.clk_box_close();
    ObjSet( "obj_itemscollecting_scr_box_up", { pos_x = 86, pos_y = -86 } );
    ObjDelete( "obj_itemscollecting_scr_clk_box_1" );
    ObjDelete( "obj_itemscollecting_scr_clk_box_2" );

  elseif ( ng_global.progress[ ng_global.currentprogress ][ "win_itemscollecting_scr" ].close_down ) then

    private.clk_box_open();
    ObjSet( "obj_itemscollecting_scr_box_up", { pos_x = 0, pos_y = 0 } );
    ObjDelete( "obj_itemscollecting_scr_clk_box_1" );
    ObjDelete( "obj_itemscollecting_scr_clk_box_2" );

  end;
  if ( #ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].found == 12 ) then

    ObjAttach( "txt_"..ho_name.."_task", "int_taskpanel_impl");
    ObjSet( "obj_int_taskpanel", { alp = 0 } );
    ObjSet( "txt_"..ho_name.."_task", { alp = 1, text = private.find_final_object } );
       
  end;

  if ( is_repeat ) then
 
    public.ResetStart();

  end;

  levelscr.InventoryDisable();

end;
--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.TutorialShow( "tutorial_page_6_scr" );

  int_button_timer.Show();

--  if cmn.IsEventStart( "see_tutorial" ) then
--
--    common_impl.TutorialShow( "tutorial_page_6" );
--
--  end;

end;
--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();

  ObjAttach( "txt_itemscollecting_scr_task", "ho_itemscollecting_scr");
  ObjSet( "obj_int_taskpanel", { alp = 1 } );
  
  int_button_timer.Hide();

  ObjDetach( "spr_itemscollecting_scr_win" );

end;
--*********************************************************************************************************************
function public.HoComplete ()
  
  rm_mysteryroom.WinTask()

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete ( task_name )
  
  local find_obj = "spr_itemscollecting_scr_"..task_name;
  local ho_name = common.GetObjectName( private.room_objname );

  cmn.HoTaskFind( find_obj, task_name );
  
  if ( #ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].found == 12 ) then

    ObjAttach( "txt_"..ho_name.."_task", "int_taskpanel_impl");
    ObjSet( "obj_int_taskpanel", { alp = 0 } );
    ObjSet( "txt_"..ho_name.."_task", { alp = 1, text = private.find_final_object } );
    ObjSet( "spr_"..ho_name.."_map", { input = true } ); 
       
  end;

end;
--------------------------------------------------------------------------------------------
function private.clk_box ()

  local func_end_open = function()

    private.clk_box_open();

  end;
  local func_end_close = function()

    private.clk_box_close();

  end;  

  cmn.Lock( true );

  if ( ng_global.progress[ ng_global.currentprogress ][ "win_itemscollecting_scr" ].open_box ) then

    ObjAnimate( "obj_itemscollecting_scr_box_up", "pos_xy", 0, 0, func_end_close, 
    { 
      0.0, 0, ObjGet( "obj_itemscollecting_scr_box_up" ).pos_x, ObjGet( "obj_itemscollecting_scr_box_up" ).pos_y,
      0.3, 0, 86, -86, 
    } ); 

  else

    ObjAnimate( "obj_itemscollecting_scr_box_up", "pos_xy", 0, 0, func_end_open, 
    { 
      0.0, 0, ObjGet( "obj_itemscollecting_scr_box_up" ).pos_x, ObjGet( "obj_itemscollecting_scr_box_up" ).pos_y,
      0.3, 0, 0, 0, 
    } ); 

  end;

end;
--------------------------------------------------------------------------------------------
function private.clk_box_open ()

  local ho_name = common.GetObjectName( private.room_objname );

  local bottom_drawer = { "rope", "scissors", "gloves", "wisp", "soap", "camera" };
  local top_drawer = { "fork", "pen", "flask", "compass", "belt", "money", "gun" };

  cmn.Lock( false );
  ng_global.progress[ ng_global.currentprogress ][ "win_itemscollecting_scr" ].open_box = true;  

  ObjMultiSet( {
    {"obj_itemscollecting_scr_clk_box_1",       { input = true } },   
    {"obj_itemscollecting_scr_clk_box_2",       { input = false } },   
  
    {"obj_itemscollecting_scr_box_up",          { pos_x = 0, pos_y = 0 } },    
  } );

  for i = 1, #bottom_drawer do
  
    if ( not private.IsFound( bottom_drawer[ i ] ) ) then
      cmn.UnmarkTask( ho_name, bottom_drawer[ i ] );
      ObjSet( "spr_"..ho_name.."_"..bottom_drawer[ i ], { input = true } );
    end;

  end;

  for i = 1, #top_drawer do
  
    if ( not private.IsFound( top_drawer[ i ] ) ) then

      cmn.SetMarkedTask( ho_name, top_drawer[ i ] );
      interface.TaskPanelTaskMark( ho_name, top_drawer[ i ] );
      ObjSet( "spr_"..ho_name.."_"..top_drawer[ i ], { input = false } );

    end;

  end;

end;
--------------------------------------------------------------------------------------------
function private.clk_box_close ()

  local ho_name = common.GetObjectName( private.room_objname );

  local bottom_drawer = { "rope", "scissors", "gloves", "wisp", "soap", "camera" };
  local top_drawer = { "fork", "pen", "flask", "compass", "belt", "money", "gun" };

  cmn.Lock( false );
  ng_global.progress[ ng_global.currentprogress ][ "win_itemscollecting_scr" ].open_box = false;

  ObjMultiSet( {
    {"obj_itemscollecting_scr_clk_box_1",       { input = false } }, 
    {"obj_itemscollecting_scr_clk_box_2",       { input = true } },
 
    {"obj_itemscollecting_scr_box_up",          { pos_x = 86, pos_y = -86 } },   

  } );

  for i = 1, #top_drawer do
  
    if ( not private.IsFound( top_drawer[ i ] ) ) then
      cmn.UnmarkTask( ho_name, top_drawer[ i ] );
      ObjSet( "spr_"..ho_name.."_"..top_drawer[ i ], { input = true } );
    end;

  end;

  for i = 1, #bottom_drawer do
  
    if ( not private.IsFound( bottom_drawer[ i ] ) ) then

      cmn.SetMarkedTask( ho_name, bottom_drawer[ i ] );
      interface.TaskPanelTaskMark( ho_name, bottom_drawer[ i ] );
      ObjSet( "spr_"..ho_name.."_"..bottom_drawer[ i ], { input = false } );

    end;

  end;

end;
--------------------------------------------------------------------------------------------
function private.IsFound ( task_name )

  local task_name = tostring( task_name );
  local ho_name = common.GetObjectName( private.room_objname );

  local tmp_progress = ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].t_gen;
  local flag_find = false;
  for i = 1, 9 do

    if ( tmp_progress[ i ][ 1 ] == task_name ) then
      flag_find = true;
      break;
    end;

  end;

  if ( not flag_find ) then -- нет в списке
    return true;
  end;

  local ho_found = ng_global.progress[ ng_global.currentprogress ][ "win_itemscollecting_scr" ].found;
  local task_found = false;
        
        for i = 1, #ho_found, 1 do
          
          local task = ho_found[ i ][ "task" ];

          if task == task_name then
             task_found = true;
             break;
          end;

        end;

   return task_found;  

end;
--*********************************************************************************************************************
function private.Init_Animation()

    ObjAnimate( "spr_itemscollecting_scr_light_add", "alp", 1, 0, "", 
    { 
      0.0, 0, 1, 
      3.0, 0, 0.4, 
      6.0, 0, 1, 
    } ); 

end;
