-- name=ho_suitcase_scr
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "suitcase_scr" );
  game.relations[ "ho_suitcase_scr" ].exitroom = "rm_mysteryroom";
  private.room_objname = "ho_suitcase_scr";

  private.find_final_object = "str_suitcase_scr_final_object";
  --------------------------------------------------------------------------------------------------
  private.found = {};
  private.table_obj = 
  {
    { "compass",         0, 1, { { "spr_suitcase_scr_compass" } } },
    { "dictaphone",      0, 1, { { "spr_suitcase_scr_dictaphone" } } },
    { "fieldglass",      0, 1, { { "spr_suitcase_scr_fieldglass" } } },
    { "hammer",          0, 1, { { "spr_suitcase_scr_hammer" } } },
    { "keys",            0, 1, { { "spr_suitcase_scr_keys" } } },
    { "bullet",          0, 1, { { "spr_suitcase_scr_bullet" } } },
    { "candals",         0, 1, { { "spr_suitcase_scr_candals" } } },
    { "card",            0, 1, { { "spr_suitcase_scr_card" } } },
    { "lighter",         0, 1, { { "spr_suitcase_scr_lighter" } } },
    { "lock",            0, 1, { { "spr_suitcase_scr_lock" } } },
    { "open_razor",      0, 1, { { "spr_suitcase_scr_open_razor" } } },
    { "photopart",       0, 1, { { "spr_suitcase_scr_photopart" } } },
    { "paper",           0, 1, { { "spr_suitcase_scr_paper" } } },
    { "apple_1",         0, 1, { { "spr_suitcase_scr_apple_1" } } },
    { "apple_2",         0, 1, { { "spr_suitcase_scr_apple_2" } } },
    { "apple_3",         0, 1, { { "spr_suitcase_scr_apple_3" } } },
    { "knife_1",         0, 1, { { "spr_suitcase_scr_knife_1" } } },
    { "knife_2",         0, 1, { { "spr_suitcase_scr_knife_2" } } },
    { "knife_3",         0, 1, { { "spr_suitcase_scr_knife_3" } } },
    { "watch_1",         0, 1, { { "spr_suitcase_scr_watch_1" } } },
    { "watch_2",         0, 1, { { "spr_suitcase_scr_watch_2" } } },
  };
  private.intersecting_objects = 
  {
    { "apple_1", "apple_2", "apple_3" },
    { "knife_1", "knife_2", "knife_3" },
    { "watch_1", "watch_2" }
  };

  private.table_paper_params = { { pos_x = 936, pos_y = 461 }, { pos_x = 348, pos_y = 486 }, { pos_x = 272, pos_y = 81 } };

  --------------------------------------------------------------------------------------------------
  local table_multiset = {
    { "spr_suitcase_scr_paper", { event_mdown = function() private.TaskComplete( "paper" ) end } } };

  ObjMultiSet( table_multiset );
  private.InitAnimations();

  private.ResetInit();
  --------------------------------------------------------------------------------------------
  -- function opn_suitcase_scr () end;
  --------------------------------------------------------------------------------------------    
  local opn_suitcase_scr = function ()

    --

  end;
  cmn.AddSubscriber( "opn_suitcase_scr", opn_suitcase_scr, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_suitcase_scr () end;
  --------------------------------------------------------------------------------------------  
  local win_suitcase_scr_func = function ()

    if ( cmn.IsEventDone( "win_suitcase_scr" ) ) then

      --

    end;

  end;
  cmn.AddSubscriber( "win_suitcase_scr", win_suitcase_scr_func );
  --------------------------------------------------------------------------------------------------
  local start_suitcase_scr_func = function ()
  
    local tmp = private.room_objname;
    local ho_name = common.GetObjectName( private.room_objname ); 
    if ( not cmn.IsEventDone( "win_"..ho_name ) ) then

      local t_gen = ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].t_gen;
      for i = 1, #t_gen do

        ObjSet( "spr_"..ho_name.."_"..t_gen[ i ][ 1 ], { alp = 1, visible = true, input = true, event_mdown = function() private.TaskComplete( t_gen[ i ][ 1 ] ) end } );

      end;

      local num_paper = ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].num_paper;

      ObjSet( "spr_"..ho_name.."_paper", { 
        res = "assets/levels/levelscr/ho_suitcase_scr/layers/final_paper_"..num_paper,
        pos_x = private.table_paper_params[ num_paper ].pos_x, 
        pos_y = private.table_paper_params[ num_paper ].pos_y, 
        visible = true,  input = false,
        event_mdown = function() private.TaskComplete( "paper" ) end } );   

      local ho_found = ng_global.progress[ "scr" ][ "win_suitcase_scr" ].found;

      for i = 1, #ho_found, 1 do

        ObjDetach( ho_found[ i ][ "object" ] );

      end;

      if ( #ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].found == 12 ) then

        ObjAttach( "txt_"..ho_name.."_task", "int_taskpanel_impl");
        ObjSet( "spr_"..ho_name.."_paper", { input = true } ); 
        ObjSet( "obj_int_taskpanel", { alp = 0 } );
        ObjSet( "txt_"..ho_name.."_task", { alp = 1, text = private.find_final_object } );
           
      end;

    end;

  end;
  cmn.AddSubscriber( "win_suitcase_scr", start_suitcase_scr_func, private.room_objname );  

end;
--*********************************************************************************************************************
function private.Generate ()

  local tmp_array = {};
  for i = 1, #private.intersecting_objects do    
    tmp_array[ i ] = {};
    for j = 1, #private.intersecting_objects[ i ] do
      tmp_array[ i ][ j ] = private.intersecting_objects[ i ][ j ];
    end;
  end;

  local random_array = {};
  local random_count = math.random( #tmp_array );
  for i = 1, random_count do

    local arr_random = table.remove( tmp_array, math.random( #tmp_array ) );
    local name_random = table.remove( arr_random, math.random( #arr_random ) );
    for j = 1, #private.table_obj do

      if ( name_random == private.table_obj[ j ][ 1 ] ) then
        table.insert( random_array, private.table_obj[ j ] );
        break;
      end;

    end;  

  end;

  for i = 1, 12 do
    table.insert( random_array, private.table_obj[ i ] );
  end;

  local ho_name = common.GetObjectName( private.room_objname );
  ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].t_gen = {};

  for i = 1, 12 do

    local obj = table.remove( random_array, math.random( #random_array ) );
    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].t_gen[ i ] = obj;
    ObjSet( "spr_"..ho_name.."_"..obj[ 1 ], { alp = 1, visible = true, input = true, event_mdown = function() private.TaskComplete( obj[ 1 ] ) end } );

  end;

  local num_paper = math.random( #private.table_paper_params );
  ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].num_paper = num_paper;
  ObjSet( "spr_"..ho_name.."_paper", { 
    res = "assets/levels/levelscr/ho_suitcase_scr/layers/final_paper_"..num_paper,
    pos_x = private.table_paper_params[ num_paper ].pos_x, 
    pos_y = private.table_paper_params[ num_paper ].pos_y, 
    alp = 1, visible = true, 
    event_mdown = function() private.TaskComplete( "paper" ) end } );

  ObjSet( "spr_"..ho_name.."_paper", { alp = 1, visible = true } );

end;
--*********************************************************************************************************************
function private.ResetInit ()

  local ho_name = common.GetObjectName( private.room_objname );

  ObjSet( "txt_"..ho_name.."_task", { alp = 0 } );

  local table_multiset = {};

  for i = 1, #private.table_obj do

    table.insert( table_multiset, { "spr_"..ho_name.."_"..private.table_obj[ i ][ 1 ], { input = false, visible = false } } ); --, pos_z = 0
    ObjAttach( "spr_"..ho_name.."_"..private.table_obj[ i ][ 1 ], "obj_"..ho_name.."_objects" );

  end;

  ObjMultiSet( table_multiset );

end;
--*********************************************************************************************************************
function public.ResetStart ()

  local ho_found = private.found;
  local ho_name = common.GetObjectName( private.room_objname );

  for key = 1, #ho_found do

    ObjAttach( ho_found[ key ][ "object" ], "obj_"..ho_name.."_objects" );
    ObjSet( ho_found[ key ][ "object" ], { alp = 1 } );

    local pfx_name = "pfx_int_taskpanel_collect_"..ho_found[ key ][ "object" ];
    if ( ObjGet( pfx_name ) ) then
      ObjDelete( pfx_name );
    end;

  end; 

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.EnvPlay( { "mus_env/aud_ho_mus_env" }, "", 0.5 );

  local ho_name = common.GetObjectName( private.room_objname );
  local is_repeat = false;
  if ( cmn.IsEventDone( "win_"..ho_name ) and cmn.IsEventStart( "win_"..ho_name ) ) then

    private.found = ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].found;
    ng_global.progress[ ng_global.currentprogress ][ "opn_"..ho_name ].done = 0;
    
    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].done = 0;
    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].start = 0;

    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].t_gen = {};
    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].num_paper = 0;

    is_repeat = true;

    private.ResetInit();

  end;

  if ( not cmn.IsEventDone( "opn_"..ho_name ) ) then
  
    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].timer = { default = 40, time = 40, diff = 20, extra = 0 };

    private.Generate();

    cmn.InitHo( ho_name );
    cmn.SetEventDone( "opn_"..ho_name );
  
  end;

  local tmp_progress = ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].t_gen;
  local ho_items = {};

  for i = 1, 12 do

    interface.TaskPanelTaskAdd( ho_items, tmp_progress[ i ][ 1 ],  1, tmp_progress[ i ][ 2 ], tmp_progress[ i ][ 3 ] );

  end;

  interface.TaskPanelTaskAdd( ho_items, "paper",  1, 0, { { "spr_suitcase_scr_paper" } } );
  
  interface.TaskPanelShow( ho_items );

  if ( #ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].found == 12 ) then

    ObjAttach( "txt_"..ho_name.."_task", "int_taskpanel_impl");
    ObjSet( "obj_int_taskpanel", { alp = 0 } );
    ObjSet( "txt_"..ho_name.."_task", { alp = 1, text = private.find_final_object } );
       
  end;

  if ( is_repeat ) then
 
    public.ResetStart();

  end;

  levelscr.InventoryDisable();

end;
--*********************************************************************************************************************
function public.PreClose ()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.TutorialShow( "tutorial_page_6_scr" );

  int_button_timer.Show();

end;
--*********************************************************************************************************************
function public.Close ()

  cmn.PlayMusEnv();
  ObjAttach( "txt_suitcase_scr_task", "ho_suitcase_scr");
  
  ObjSet( "obj_int_taskpanel", { alp = 1 } );
  int_button_timer.Hide();

  ObjDetach( "spr_suitcase_scr_win" );

end;
--*********************************************************************************************************************
function public.HoComplete ()
  
  rm_mysteryroom.WinTask()

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete ( task_name )
  
  local find_obj = "spr_suitcase_scr_"..task_name;
  local ho_name = common.GetObjectName( private.room_objname );

  cmn.HoTaskFind( find_obj, task_name );
  
  if ( #ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].found == 12 ) then

    ObjAttach( "txt_"..ho_name.."_task", "int_taskpanel_impl");
    ObjSet( "obj_int_taskpanel", { alp = 0 } );
    ObjSet( "txt_"..ho_name.."_task", { alp = 1, text = private.find_final_object } );
    ObjSet( "spr_"..ho_name.."_paper", { input = true } ); 
       
  end;
 
end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_suitcase_scr_light", "alp", 1, 0, "", 
  { 
    0.0, 0, 1, 
    3.0, 0, 0, 
    6.0, 0, 1 
  } );  

end;
--*********************************************************************************************************************