-- name=mg_forandagainst_scr
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_forandagainst_scr";

  private.count_small_simb = 8;
  private.count_big_simb = 4;

  private.random_data = { "4", "apple", "bird", "boat", "bridge", "heart", "house", "infinite_time", "letter_a", "pen", "purse", "scissors", "sunflower" };

  private.forandagainst_scr_state = {
    false, false, false, false, 
    false, false, false, false,
  };
  private.forandagainst_scr_step = 1;
  private.forandagainst_scr_choose = { 0, 0 };

  ObjMultiSet( { 
    { "obj_forandagainst_scr_marker1_clk", { event_mdown = private.marker1_clk } },
  } );

  for i = 1, private.count_small_simb do

    ObjMultiSet( { 
      { "spr_forandagainst_scr_small_simbol_"..i.."_1", { event_mdown = function() private.SmallSimbolClk( i, 1 ); end } },
      { "spr_forandagainst_scr_small_simbol_"..i.."_2", { event_mdown = function() private.SmallSimbolClk( i, 2 ); end } },
      { "obj_forandagainst_scr_clk_small_big_"..i,   { event_mdown = function() private.SmallBigSimbolClk( i ); end } },
    } );

  end;
  for i = 1, private.count_big_simb do

    ObjSet( "obj_forandagainst_scr_clk_big_"..i, 
    {
      event_mdown  = function() private.BigSimbolClk( i ); end,
      event_menter = function() private.EnterBigSimb( i ); end,     
      event_mleave = function() private.LeaveBigSimb( i ); end,       
    } );

  end;


  private.small_simb_data = 
  {
    { 412, 100, 0, 1 },
    { 453, 169, 0, 1 },
    { 433, 238, 0, 1 },
    { 471, 309, 0, 1 },
    { 448, 372, 0, 1 },
    { 481, 448, 0, 1 },
    { 474, 521, 0, 1 },
    { 510, 597, 0, 1 },
  };
  private.big_simb_data = {
    { 886, 65 },
    { 908, 183 },
    { 939, 313 },
    { 968, 456 },
  };
  private.small_choose = 0;
  private.big_state = { 0, 0, 0, 0 };
  --------------------------------------------------------------------------------------------
  -- function win_forandagainst_scr () end;
  --------------------------------------------------------------------------------------------
  local win_forandagainst_scr = function ()

    if ( cmn.IsEventDone( "win_forandagainst_scr" ) ) then  
      
    else

      local room_name = common.GetObjectName( private.room_objname );
      local win_comb = ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].win_comb;
      private.win_comb = {};
      for i = 1, #win_comb do

        private.win_comb[ i ] = win_comb[ i ];

      end; 

    end;

  end;
  cmn.AddSubscriber( "win_forandagainst_scr", win_forandagainst_scr, private.room_objname );
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Load ()

  if ( cmn.IsEventStart( "win_forandagainst_scr" ) ) then

    local path = "assets/levels/levelscr/mg_forandagainst_scr/layers/";
    local room_name = common.GetObjectName( private.room_objname );
    local name_simb = ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].name_simb;
    for i = 1, #name_simb do

      ObjSet( "spr_forandagainst_scr_small_simbol_"..i.."_1", { res = path..name_simb[ i ].."_part1" } );
      ObjSet( "spr_forandagainst_scr_small_simbol_"..i.."_2", { res = path..name_simb[ i ].."_part2" } );
      ObjSet( "spr_forandagainst_scr_simb_center_"..i, { res = path..name_simb[ i ].."_gray" } );
      ObjSet( "spr_forandagainst_scr_simb_find_"..i, { res = path..name_simb[ i ].."_color" } );

    end;

    for i = 1, #private.forandagainst_scr_state do

      private.forandagainst_scr_state[ i ] = ng_global.progress[ "scr" ][ "win_forandagainst_scr" ].state[ i ];

    end;
    for i = 1, #private.forandagainst_scr_choose do

      private.forandagainst_scr_choose[ i ] = ng_global.progress[ "scr" ][ "win_forandagainst_scr" ].choose[ i ];           

    end; 

    private.forandagainst_scr_step = ng_global.progress[ "scr" ][ "win_forandagainst_scr" ].step;
    private.small_choose = ng_global.progress[ "scr" ][ "win_forandagainst_scr" ].small_choose;

    for i = 1, #private.big_state do

      private.big_state[ i ] = ng_global.progress[ "scr" ][ "win_forandagainst_scr" ].big_state[ i ];

    end;

    for i = 1, #private.forandagainst_scr_state do

      if ( private.forandagainst_scr_state[ i ] ) then
      
        ObjMultiSet( {  
          { "spr_forandagainst_scr_small_simbol_"..i.."_1",        { input = false } },
          { "spr_forandagainst_scr_small_simbol_"..i.."_2",        { input = false } },
          { "spr_forandagainst_scr_marker_"..i.."_1",           { alp = 1 } },
          { "spr_forandagainst_scr_marker_"..i.."_2",           { alp = 1 } },
          { "spr_forandagainst_scr_simb_find_"..i,   { alp = 1 } },
        } );       

      end;

    end; 

    if ( private.forandagainst_scr_choose[ 1 ] ~= 0 ) then

      ObjMultiSet( {  
        { "spr_forandagainst_scr_marker_"..private.forandagainst_scr_choose[ 1 ].."_"..private.forandagainst_scr_choose[ 2 ],     { alp = 1 } },
        { "spr_forandagainst_scr_small_simbol_"..private.forandagainst_scr_choose[ 1 ].."_"..private.forandagainst_scr_choose[ 2 ],  { input = false  } },
      } );

    end;

    if ( ng_global.progress[ "scr" ][ "win_forandagainst_scr" ].mg_win == 2 ) then

      ObjMultiSet( {
        { "obj_forandagainst_scr_small_simbol",   { input = false } }, 
        { "obj_forandagainst_scr_small_big_clk",      { input = true } },
        { "obj_forandagainst_scr_big_clk",            { input = true } },
      } );

      if ( private.small_choose ~= 0 ) then
        
        local name = "spr_forandagainst_scr_simb_find_"..private.small_choose;
        local scale = ObjGet( name ).scale_x + 0.1;
        ObjSet( name, {  scale_x = scale, scale_y = scale } );

      end;

      for i = 1, #private.big_state do

        if ( private.big_state[ i ] ~= 0 ) then

          local name = "spr_forandagainst_scr_simb_find_"..private.big_state[ i ];
          ObjSet( name, 
          { 
            pos_x = private.big_simb_data[ i ][ 1 ], 
            pos_y = private.big_simb_data[ i ][ 2 ],
            ang = 0,
            scale_x = 1, 
            scale_y = 1,
          } )

        end;

      end;

      private.MakeInputCollumn();

    end;

  end;

end;
--*********************************************************************************************************************
function public.Open () 

  common_impl.TutorialShow( "tutorial_page_6_scr" );

  if not cmn.IsEventDone( "win_forandagainst_scr" ) then

    cmn.MiniGameShow();
    
    int_button_timer.Show();

  end;

end;
--*********************************************************************************************************************
function private.Generate ()
  
  local room_name = common.GetObjectName( private.room_objname );
  
  local tmp_array = {};
  for i = 1, #private.random_data do
    tmp_array[ i ] = private.random_data[ i ];
  end;

  ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].name_simb = {};
  local path = "assets/levels/levelscr/mg_forandagainst_scr/layers/";

  for i = 1, 8 do

    local name = table.remove( tmp_array, math.random( #tmp_array ) );  
    ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].name_simb[ i ] = name;
    ObjSet( "spr_forandagainst_scr_small_simbol_"..i.."_1", { res = path..name.."_part1" } );
    ObjSet( "spr_forandagainst_scr_small_simbol_"..i.."_2", { res = path..name.."_part2" } );
    ObjSet( "spr_forandagainst_scr_simb_center_"..i, { res = path..name.."_gray" } );
    ObjSet( "spr_forandagainst_scr_simb_find_"..i, { res = path..name.."_color" } );

  end;

  tmp_array = { 1, 2, 3, 4, 5, 6, 7, 8 };
  ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].win_comb = {};
  private.win_comb = {};
  for i = 1, 4 do

    local pos = table.remove( tmp_array, math.random( #tmp_array ) );
    private.win_comb[ i ] = pos;
    ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].win_comb[ i ] = pos;

  end; 

end;
--*********************************************************************************************************************
function public.PreOpen ()

  local room_name = common.GetObjectName( private.room_objname );

  if ( cmn.IsEventDone( "win_"..room_name ) and cmn.IsEventStart( "win_"..room_name ) ) then
    
    ng_global.progress[ ng_global.currentprogress ][ "opn_"..room_name ].done = 0;
    
    ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].done = 0;
    ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].start = 0;    

  end;

  if ( not cmn.IsEventDone( "opn_"..room_name ) ) then

    cmn.SetEventDone( "opn_"..room_name );

    ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].timer = { default = 60, time = 60, diff = 30, extra = 0 };

    ng_global.progress[ "scr" ][ "win_forandagainst_scr" ].state = { 
      false, false, false, false, 
      false, false, false, false,
    };
    ng_global.progress[ "scr" ][ "win_forandagainst_scr" ].step = 1;
    ng_global.progress[ "scr" ][ "win_forandagainst_scr" ].choose = { 0, 0 };

    ng_global.progress[ "scr" ][ "win_forandagainst_scr" ].small_choose = 0;
    ng_global.progress[ "scr" ][ "win_forandagainst_scr" ].big_state = { 0, 0, 0, 0 };

    ng_global.progress[ "scr" ][ "win_forandagainst_scr" ].mg_win = 1;

    public.Reset();

    private.Generate();

  end;

  levelscr.InventoryDisable();

end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()

  if not cmn.IsEventDone( "win_forandagainst_scr" ) then

    cmn.MiniGameHide();    

  end;
  int_button_timer.Hide();

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset ()

  for i = 1, #private.small_simb_data do
    
    ObjSet( "spr_forandagainst_scr_red_marker"..i, { alp = 0 } ); 
    ObjSet( "spr_forandagainst_scr_green_marker"..i, { alp = 0 } ); 

    local name = "spr_forandagainst_scr_simb_find_"..i;
    ObjSet( name, 
    { 
      pos_x = private.small_simb_data[ i ][ 1 ], 
      pos_y = private.small_simb_data[ i ][ 2 ],
      ang = private.small_simb_data[ i ][ 3 ],
      scale_x = private.small_simb_data[ i ][ 4 ], 
      scale_y = private.small_simb_data[ i ][ 4 ]
    } );
 
  end;

   for i = 1, private.count_small_simb do 

      ObjSet( "spr_forandagainst_scr_marker_"..i.."_1", { alp = 0 } );
      ObjSet( "spr_forandagainst_scr_marker_"..i.."_2", { alp = 0 } );
      local name = "spr_forandagainst_scr_simb_find_"..i; 
      ObjSet( name, { alp = 0 } );

    end; 
  
   ng_global.progress[ "scr" ][ "win_forandagainst_scr" ].mg_win = 1;
    private.small_choose = 0;
    private.big_state = { 0, 0, 0, 0 };    
    private.forandagainst_scr_state = {
      false, false, false, false, 
      false, false, false, false,
    };
    private.forandagainst_scr_step = 1;
    private.forandagainst_scr_choose = { 0, 0 };  
    private.SaveBigVar();
    private.SaveSmallVar();
    private.MakeInputCollumn();

    for i = 1, private.count_small_simb do

      ObjMultiSet( { 
        { "spr_forandagainst_scr_small_simbol_"..i.."_1", { input = true } },
        { "spr_forandagainst_scr_small_simbol_"..i.."_2", { input = true } },
      } );   

    end;
    
    ObjMultiSet( {
      { "obj_forandagainst_scr_small_big_clk",      { input = false } }, 
      { "obj_forandagainst_scr_big_clk",            { input = false } }, 
      { "obj_forandagainst_scr_small_simbol",   { input = true } }
    } );

end;
--*********************************************************************************************************************
function public.Skip ()

  cmn.Lock( true );
  
  local func_end = function()

    local func_end_1 = function()

      private.Win();

    end;

    for i = 1, #private.win_comb do

      ObjAnimate( "spr_forandagainst_scr_green_marker"..i, "alp", 0, 0, "", 
      { 
        0.0, 0, ObjGet( "spr_forandagainst_scr_green_marker"..i ).alp, 
        0.3, 0, 1, 
      } );

      local name = "spr_forandagainst_scr_simb_find_"..private.win_comb[ i ];
      ObjAnimate( name, "pos_xy", 0, 0, "", 
      { 
        0.0, 0, ObjGet( name ).pos_x, ObjGet( name ).pos_y, 
        0.3, 0, private.big_simb_data[ i ][ 1 ], private.big_simb_data[ i ][ 2 ],
      } ); 
      ObjAnimate( name, "ang", 0, 0, "", 
      { 
        0.0, 0, ObjGet( name ).ang, 
        0.3, 0, 0, 
      } ); 
      ObjAnimate( name, "scale_xy", 0, 0, "", 
      { 
        0.0, 0, ObjGet( name ).scale_x, ObjGet( name ).scale_y,  
        0.3, 0, 1.2, 1.2,
      } ); 

    end;

    ObjAnimate( "mg_forandagainst_scr", "alp", 0, 0, func_end_1, 
    { 
      0.0, 0, ObjGet( "mg_forandagainst_scr" ).alp,
      0.9, 0, ObjGet( "mg_forandagainst_scr" ).alp,
    } );

  end;

  for i = 1, private.count_small_simb do 

    ObjAnimate( "spr_forandagainst_scr_marker_"..i.."_1", "alp", 0, 0, "", 
    { 
      0.0, 0, ObjGet( "spr_forandagainst_scr_marker_"..i.."_1" ).alp,     
      0.3, 0, 1, 
    } ); 
    ObjAnimate( "spr_forandagainst_scr_marker_"..i.."_2", "alp", 0, 0, "", 
    { 
      0.0, 0, ObjGet( "spr_forandagainst_scr_marker_"..i.."_2" ).alp,     
      0.3, 0, 1, 
    } );  
    local name = "spr_forandagainst_scr_simb_find_"..i; 
    ObjAnimate( name, "alp", 0, 0, "", 
    { 
      0.0, 0, ObjGet( name ).alp,     
      0.3, 0, 1, 
    } );  

  end;
  
  for i = 1, #private.big_state do
    
    ObjAnimate( "spr_forandagainst_scr_red_marker"..i, "alp", 0, 0, "", 
    { 
      0.0, 0, ObjGet( "spr_forandagainst_scr_red_marker"..i ).alp, 
      0.3, 0, 0, 
    } );

    if ( private.big_state[ i ] ~= 0 ) then

      local name = "spr_forandagainst_scr_simb_find_"..private.big_state[ i ];
      ObjAnimate( name, "pos_xy", 0, 0, "", 
      { 
        0.0, 0, ObjGet( name ).pos_x, ObjGet( name ).pos_y, 
        0.3, 0, ObjGet( name ).pos_x, ObjGet( name ).pos_y,     
        0.5, 0, private.small_simb_data[ private.big_state[ i ] ][ 1 ], private.small_simb_data[ private.big_state[ i ] ][ 2 ],
      } ); 
      ObjAnimate( name, "ang", 0, 0, "", 
      { 
        0.0, 0, ObjGet( name ).ang, 
        0.3, 0, ObjGet( name ).ang, 
        0.5, 0, private.small_simb_data[ private.big_state[ i ] ][ 3 ], 
      } ); 
      ObjAnimate( name, "scale_xy", 0, 0, "", 
      { 
        0.0, 0, ObjGet( name ).scale_x, ObjGet( name ).scale_y,
        0.3, 0, ObjGet( name ).scale_x, ObjGet( name ).scale_y,  
        0.5, 0, private.small_simb_data[ private.big_state[ i ] ][ 4 ], private.small_simb_data[ private.big_state[ i ] ][ 4 ], 
      } ); 

    end;

  end;

  ObjAnimate( "mg_forandagainst_scr", "alp", 0, 0, func_end, 
  { 
    0.0, 0, ObjGet( "mg_forandagainst_scr" ).alp,
    0.9, 0, ObjGet( "mg_forandagainst_scr" ).alp,
  } );

end;
--*********************************************************************************************************************
function private.WinEnd ()

  --common_impl.PlayAudio( "sfx", "aud_mg_win" );
  cmn.Lock( false );
  cmn.MiniGameHide();
  cmn.SetEventDone( "win_forandagainst_scr" );
  cmn.CallEventHandler( "win_forandagainst_scr" );
  
  cmn.GotoRoom( "rm_mysteryroom" ); 
  rm_mysteryroom.WinTask();

end;
--*********************************************************************************************************************
function private.Win ()

  private.WinEnd();

end;
--*********************************************************************************************************************
-- function *** MMG SMALL *** () end;
--*********************************************************************************************************************
function private.SmallSimbolClk ( id, num )

  if ( id == private.forandagainst_scr_step and 
    private.forandagainst_scr_choose[ 1 ] == 0 ) then

    local func_end = function ()

      cmn.Lock( false );
      ObjSet( "obj_forandagainst_scr_felttippen", { alp = 0 } );
      private.forandagainst_scr_choose[ 1 ] = id;
      private.forandagainst_scr_choose[ 2 ] = num;
      ObjSet( "spr_forandagainst_scr_small_simbol_"..id.."_"..num,  { input = false } );
      private.SaveSmallVar();

    end;

    local clk_obj = ObjGet( "spr_forandagainst_scr_small_simbol_"..id.."_"..num ); 
    ObjSet( "obj_forandagainst_scr_felttippen", { alp = 1, pos_x = clk_obj.pos_x, pos_y = clk_obj.pos_y } );

    cmn.Lock( true );
    AnimPlay( "anm_forandagainst_scr_felttippen", "DoAnim", func_end  );
    ObjAnimate( "spr_forandagainst_scr_marker_"..id.."_"..num, "alp", 0, 0, "", 
    { 
      0.00, 0, 0,     
      0.52, 0, 0,     
      0.86, 0, 1
    } );  

  elseif ( id == private.forandagainst_scr_step and 
    private.forandagainst_scr_choose[ 1 ] == id ) then

    local func_end = function ()

      local func_end_1 = function()

        ObjSet( "spr_forandagainst_scr_small_simbol_"..id.."_"..num,  { input = false } );
        private.CheckSmallWin();

      end;
 
      local name_simb = "spr_forandagainst_scr_simb_find_"..private.forandagainst_scr_step;
      ObjSet( name_simb, { color_r = 1, color_g = 1, color_b = 1 } );
      ObjAnimate( name_simb, "alp", 0, 0, func_end_1, 
      { 
        0.0, 0, 0,     
        0.3, 0, 1,
      } );

    end;

    local clk_obj = ObjGet( "spr_forandagainst_scr_small_simbol_"..id.."_"..num ); 
    ObjSet( "obj_forandagainst_scr_felttippen", { alp = 1, pos_x = clk_obj.pos_x, pos_y = clk_obj.pos_y } );

    cmn.Lock( true );
    AnimPlay( "anm_forandagainst_scr_felttippen", "DoAnim", func_end  );
    ObjAnimate( "spr_forandagainst_scr_marker_"..id.."_"..num, "alp", 0, 0, "", 
    { 
      0.00, 0, 0,     
      0.52, 0, 0,     
      0.86, 0, 1
    } ); 
       
  else 

    local func_end = function()
      
      local func_end_1 = function () 

        cmn.Lock( false );
        ObjSet( "obj_forandagainst_scr_felttippen", { alp = 0 } );

        for i = 1, private.count_small_simb do

          ObjMultiSet( { 
            { "spr_forandagainst_scr_small_simbol_"..i.."_1", { input = true } },
            { "spr_forandagainst_scr_small_simbol_"..i.."_2", { input = true } },
          } );         

        end;

        private.forandagainst_scr_state = {
          false, false, false, false, 
          false, false, false, false,
        };
        private.forandagainst_scr_step = 1;
        private.forandagainst_scr_choose = { 0, 0 };        
        private.SaveSmallVar();

      end;

      for i = 1, private.count_small_simb do

        ObjAnimate( "spr_forandagainst_scr_marker_"..i.."_1", "alp", 0, 0, "", 
        { 
          0.0, 0, ObjGet( "spr_forandagainst_scr_marker_"..i.."_1" ).alp,     
          0.3, 0, 0,
        } ); 
        ObjAnimate( "spr_forandagainst_scr_marker_"..i.."_2", "alp", 0, 0, "", 
        { 
          0.0, 0, ObjGet( "spr_forandagainst_scr_marker_"..i.."_2" ).alp,     
          0.3, 0, 0,
        } ); 
        
        local name_simb = "spr_forandagainst_scr_simb_find_"..i;
        ObjAnimate( name_simb, "alp", 0, 0, "", 
        { 
          0.0, 0, ObjGet( name_simb ).alp,     
          0.3, 0, 0,
        } );

      end;

      ObjAnimate( "mg_forandagainst_scr", "alp", 0, 0, func_end_1, 
      { 
        0.0, 0, ObjGet( "mg_forandagainst_scr" ).alp,     
        0.3, 0, ObjGet( "mg_forandagainst_scr" ).alp,
      } ); 

    end;

    cmn.Lock( true );
    local name_simb = "spr_forandagainst_scr_simb_find_"..private.forandagainst_scr_step;
    ObjSet( name_simb, { color_r = 1, color_g = 0, color_b = 0 } );
    ObjAnimate( name_simb, "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0,     
      0.1, 0, 1,
      0.4, 0, 1, 
      0.5, 0, 0,  
    } );
    --ObjAnimate( name_simb, "scale_xy", 0, 0, "", 
    --{ 
    --  0.0, 0, 1.0, 1.0,     
    --  0.1, 0, 1.01, 1.01,
    --  0.4, 0, 1.01, 1.01,
    --  0.5, 0, 1.0, 1.0,  
    --} );

  end;

end;
--*********************************************************************************************************************
function private.CheckSmallWin ()

  cmn.Lock( false );
  ObjSet( "obj_forandagainst_scr_felttippen", { alp = 0 } );
  private.forandagainst_scr_state[ private.forandagainst_scr_step ] = true;
  private.forandagainst_scr_step = private.forandagainst_scr_step + 1;   
  private.forandagainst_scr_choose = { 0, 0 };

  if ( private.IsSmallWin() ) then

    private.WinSmallAnim();    

  else

    private.SaveSmallVar();

  end;
 
end;
--*********************************************************************************************************************
function private.IsSmallWin ()

  local bool = true;
  for i = 1, #private.forandagainst_scr_state do

    if ( private.forandagainst_scr_state[ i ] == false ) then

      bool = false; 
      break;

    end;

  end;   

  return bool;

end;
--*********************************************************************************************************************
function private.SaveSmallVar ()

  for i = 1, #ng_global.progress[ "scr" ][ "win_forandagainst_scr" ].state do

    ng_global.progress[ "scr" ][ "win_forandagainst_scr" ].state[ i ] = private.forandagainst_scr_state[ i ];

  end;
  for i = 1, #ng_global.progress[ "scr" ][ "win_forandagainst_scr" ].choose do

    ng_global.progress[ "scr" ][ "win_forandagainst_scr" ].choose[ i ] = private.forandagainst_scr_choose[ i ];

  end;
  ng_global.progress[ "scr" ][ "win_forandagainst_scr" ].step = private.forandagainst_scr_step;

end;
--*********************************************************************************************************************
function private.WinSmallAnim ()

  cmn.Lock( true );
  for i = 1, private.count_big_simb do

    local name = "spr_forandagainst_scr_big_"..i.."_marker";
    ObjAnimate( name, "alp", 0, 0, "", 
    { 
      0.0, 0, ObjGet( name ).alp,     
      0.2, 0, 1,
      0.8, 0, 1,
      1.0, 0, 0,
    } );

  end;

  for i = 1, private.count_small_simb do 

    local name = "spr_forandagainst_scr_simb_find_"..i;
    ObjAnimate( name, "scale_xy", 0, 0, "", 
    { 
      0.0, 0, ObjGet( name ).scale_x, ObjGet( name ).scale_y,     
      0.2, 0, ObjGet( name ).scale_x + 0.1, ObjGet( name ).scale_y + 0.1,
      0.8, 0, ObjGet( name ).scale_x + 0.1, ObjGet( name ).scale_y + 0.1,
      1.0, 0, ObjGet( name ).scale_x, ObjGet( name ).scale_y,
    } ); 

  end;

  ObjAnimate( "mg_forandagainst_scr", "alp", 0, 0, function() private.WinSmallEnd(); end, 
  { 
    0.0, 0, ObjGet( "mg_forandagainst_scr" ).alp,
    0.9, 0, ObjGet( "mg_forandagainst_scr" ).alp,
  } );

end;
--*********************************************************************************************************************
function private.WinSmallEnd ()

  cmn.Lock( false );
  ng_global.progress[ "scr" ][ "win_forandagainst_scr" ].mg_win = 2;
  ObjSet( "obj_forandagainst_scr_small_simbol", { input = false } );
  ObjSet( "obj_forandagainst_scr_big_clk", { input = true } );
  ObjSet( "obj_forandagainst_scr_small_big_clk", { input = true } );
  private.MakeInputCollumn();
  private.SaveSmallVar();

end;
--*********************************************************************************************************************
-- function *** MMG BIG *** () end;
--*********************************************************************************************************************
function private.EnterBigSimb ( id )

  common_impl.SetCursor( CURSOR_HAND );
  local name = "spr_forandagainst_scr_big_"..id.."_marker";
  ObjAnimate( name, "alp", 0, 0, "", 
  { 
    0.00, 0, ObjGet( name ).alp,     
    0.05, 0, 1,
  } );

end;
--*********************************************************************************************************************
function private.LeaveBigSimb ( id )

  common_impl.SetCursor( CURSOR_DEFAULT );
  local name = "spr_forandagainst_scr_big_"..id.."_marker";
  ObjAnimate( name, "alp", 0, 0, "", 
  { 
    0.00, 0, ObjGet( name ).alp,     
    0.05, 0, 0,
  } );

end;
--*********************************************************************************************************************
function private.SmallBigSimbolClk ( id ) 

  local scale = 0.1;
  local name = "spr_forandagainst_scr_simb_find_"..id;

  local func_end = function()

    cmn.Lock( false );
    if ( private.small_choose == 0 or private.small_choose ~= id ) then  

      private.small_choose = id;

    elseif ( private.small_choose == id ) then

      private.small_choose = 0;      

    end;
  
    private.SaveBigVar();
    private.MakeInputCollumn();

  end;

  if ( private.small_choose == 0 ) then

    cmn.Lock( true );
    ObjSet( name, { pos_z = 10 } );
    ObjAnimate( name, "scale_xy", 0, 0, func_end, 
    { 
      0.0, 0, private.small_simb_data[ id ][ 4 ],        private.small_simb_data[ id ][ 4 ],     
      0.3, 0, private.small_simb_data[ id ][ 4 ] + scale, private.small_simb_data[ id ][ 4 ] +scale,
    } );
    

  elseif ( private.small_choose == id ) then

    cmn.Lock( true );
    ObjSet( name, { pos_z = 0 } );
    ObjAnimate( name, "scale_xy", 0, 0, func_end, 
    { 
      0.0, 0, ObjGet( name ).scale_x,             ObjGet( name ).scale_y,     
      0.3, 0, private.small_simb_data[ id ][ 4 ], private.small_simb_data[ id ][ 4 ],
    } );

  else 

    local name_other = "spr_forandagainst_scr_simb_find_"..private.small_choose;
    cmn.Lock( true );
    ObjSet( name, { pos_z = 10 } );
    ObjSet( name_other, { pos_z = 0 } );
    ObjAnimate( name, "scale_xy", 0, 0, func_end, 
    { 
      0.0, 0, private.small_simb_data[ id ][ 4 ],        private.small_simb_data[ id ][ 4 ],     
      0.3, 0, private.small_simb_data[ id ][ 4 ] + scale, private.small_simb_data[ id ][ 4 ] + scale,
    } );
    ObjAnimate( name_other, "scale_xy", 0, 0, "", 
    { 
      0.0, 0,                         ObjGet( name_other ).scale_x,                         ObjGet( name_other ).scale_y,     
      0.3, 0, private.small_simb_data[ private.small_choose ][ 4 ], private.small_simb_data[ private.small_choose ][ 4 ],
    } );

  end;  

end;
--*********************************************************************************************************************
function private.BigSimbolClk ( id )

  if ( private.small_choose ~= 0 ) then

    local func_end = function()

      local amount = 0;
      for i = 1, #private.big_state do

        if ( private.big_state[ i ] ~= 0 ) then
  
          amount = amount + 1;  

        end;
    
      end;

      cmn.Lock( false );
      private.big_state[ id ] = private.small_choose;
      private.small_choose = 0;

      if ( amount == 3 ) then

        if ( private.IsBigWin() ) then

          private.Win();          

        else

          private.LoseBigAnim();

        end;

      else

        private.SaveBigVar();

      end;
      private.MakeInputCollumn();

    end;

    local name = "spr_forandagainst_scr_simb_find_"..private.small_choose;

    cmn.Lock( true );
    ObjAnimate( name, "pos_xy", 0, 0, "", 
    { 
      0.0, 0, ObjGet( name ).pos_x, ObjGet( name ).pos_y,     
      0.3, 0, private.big_simb_data[ id ][ 1 ], private.big_simb_data[ id ][ 2 ],
    } ); 
    ObjAnimate( name, "ang", 0, 0, "", 
    { 
      0.0, 0, ObjGet( name ).ang, 
      0.3, 0, 0, 
    } ); 
    ObjAnimate( name, "scale_xy", 0, 0, func_end, 
    { 
      0.0, 0, ObjGet( name ).scale_x, ObjGet( name ).scale_y,  
      0.3, 0, 1.2, 1.2, 
    } ); 

  end;

end;
--*********************************************************************************************************************
function private.LoseBigAnim ()

  local func_end = function()
  
    local func_end_1 = function()

      cmn.Lock( false )
      private.big_state = { 0, 0, 0, 0 };    
      private.small_choose = 0;
      private.SaveBigVar();
      private.MakeInputCollumn();
   
    end;

    for i = 1, #private.big_state do

      local name = "spr_forandagainst_scr_simb_find_"..private.big_state[ i ];
      ObjAnimate( name, "pos_xy", 0, 0, "", 
      { 
        0.0, 0, ObjGet( name ).pos_x, ObjGet( name ).pos_y,     
        0.3, 0, private.small_simb_data[ private.big_state[ i ] ][ 1 ], private.small_simb_data[ private.big_state[ i ] ][ 2 ],
      } ); 
      ObjAnimate( name, "ang", 0, 0, "", 
      { 
        0.0, 0, ObjGet( name ).ang, 
        0.3, 0, private.small_simb_data[ private.big_state[ i ] ][ 3 ], 
      } ); 
      ObjAnimate( name, "scale_xy", 0, 0, "", 
      { 
        0.0, 0, ObjGet( name ).scale_x, ObjGet( name ).scale_y,  
        0.3, 0, private.small_simb_data[ private.big_state[ i ] ][ 4 ], private.small_simb_data[ private.big_state[ i ] ][ 4 ], 
      } ); 

    end;

    cmn.Lock( true );
    ObjAnimate( "mg_forandagainst_scr", "alp", 0, 0, func_end_1, 
    { 
      0.0, 0, ObjGet( "mg_forandagainst_scr" ).alp,
      0.3, 0, ObjGet( "mg_forandagainst_scr" ).alp,
    } );

  end;

  for i = 1, #private.big_state do

    local bool = false;
    for j = 1, #private.win_comb do

      if ( private.big_state[ i ] == private.win_comb[ j ] ) then

        bool = true;
        break;

      end;
      
    end; 

    if ( bool ) then

      ObjAnimate( "spr_forandagainst_scr_green_marker"..i, "alp", 0, 0, "", 
      { 
        0.0, 0, 0,     
        0.2, 0, 1,
        1.2, 0, 1,
        1.4, 0, 0,
      } );

    else

      ObjAnimate( "spr_forandagainst_scr_red_marker"..i, "alp", 0, 0, "", 
      { 
        0.0, 0, 0,     
        0.2, 0, 1,
        1.2, 0, 1,
        1.4, 0, 0,
      } );

    end;

  end;

  cmn.Lock( true );
  ObjAnimate( "mg_forandagainst_scr", "alp", 0, 0, func_end, 
  { 
    0.0, 0, ObjGet( "mg_forandagainst_scr" ).alp,
    1.8, 0, ObjGet( "mg_forandagainst_scr" ).alp,
  } );

end;
--*********************************************************************************************************************
function private.IsBigWin ()
  
  local bool = { false, false, false, false };

  for i = 1, #private.big_state do

    for j = 1, #private.win_comb do

      if ( private.big_state[ i ] == private.win_comb[ j ] ) then

        bool[ i ] = true;
        break;

      end;
      
    end;   

  end;

  local win = true;
  for i = 1, #bool do

    if ( bool[ i ] == false ) then

      win = false;
      break;

    end;

  end;

  return win;

end;
--*********************************************************************************************************************
function private.SaveBigVar ()
  
  for i = 1, #private.big_state do

    ng_global.progress[ "scr" ][ "win_forandagainst_scr" ].big_state[ i ] = private.big_state[ i ];

  end;
  
  ng_global.progress[ "scr" ][ "win_forandagainst_scr" ].small_choose = private.small_choose;

end;
--*********************************************************************************************************************
function private.MakeInputCollumn () 

  for j = 1, private.count_small_simb do

    ObjSet( "obj_forandagainst_scr_clk_small_big_"..j, { input = true } );

  end; 

  if ( private.small_choose ~= 0 ) then

    for i = 1, #private.big_state do

      if ( private.big_state[ i ] == 0 ) then

        ObjSet( "obj_forandagainst_scr_clk_big_"..i, { input = true } );

      else

        ObjSet( "obj_forandagainst_scr_clk_big_"..i, { input = false } );
        ObjSet( "obj_forandagainst_scr_clk_small_big_"..private.big_state[ i ], { input = false } );

      end; 

    end; 

  else 

    for i = 1, #private.big_state do

      if ( private.big_state[ i ] ~= 0 ) then

        ObjSet( "obj_forandagainst_scr_clk_small_big_"..private.big_state[ i ], { input = false } );

      end

      ObjSet( "obj_forandagainst_scr_clk_big_"..i, { input = false } );

    end;

  end; 

end;
--*********************************************************************************************************************