-- name=mg_shelflock_scr

--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_shelflock_scr";
  private.lights_count = 8;

  local tb = {}
  
  for i = 1, private.lights_count do

    table.insert( tb, { "obj_shelflock_scr_clk_lights_"..i,    
      { 
        event_mdown  = function () private.ClkLights( i ); end,
        event_menter = function () common_impl.SetCursor( CURSOR_HAND ); end,
        event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end    
      } } );

  end;

  ObjMultiSet( tb );

  private.win_combination = { { "blue",   "yellow" }, --как элементы дложны бфть расположены при победе
                              { "yellow", "red"    }, 
                              { "red",    "white"  },
                              { "white",  "blue"   },
                              { "blue",   "red"    }, 
                              { "red",    "yellow" } };

  private.win_button_combination = { "blue", "yellow", "red", "white", 
                                     "white" ,"blue", "red", "yellow" };

  private.win_relation = { { 1, 2 }, { 2, 3 }, { 3, 4 }, --связи кругов с овалами
                           { 5, 6 }, { 6, 7 }, { 7, 8 } };
  --------------------------------------------------------------------------------------------
  -- function win_shelflock_scr () end;
  --------------------------------------------------------------------------------------------
  local win_shelflock_scr = function ()

    if ( cmn.IsEventDone( "win_shelflock_scr" ) ) then  

      ObjSet( "obj_shelflock_scr_mg", { input = false } );
      ObjMultiSet( {
        { "obj_shelflock_scr_mg",         { input = false         } }, 
      } );
      --ObjDelete( "spr_shelflock_scr_door_1" );
      --ObjDelete( "spr_shelflock_scr_door" );

    else

    end;

  end;

  cmn.AddSubscriber( "win_shelflock_scr", win_shelflock_scr, private.room_objname );  
--*********************************************************************************************************************
end;
--*********************************************************************************************************************
function private.Generate ()
  
  local room_name = common.GetObjectName( private.room_objname );

  local collor_array1 = { "blue","red","yellow", "white" };
  local collor_array2 = { "blue","red","yellow", "white" };

  local random_state = {};

  for i = 1, 4 do    
    random_state[ i ] = table.remove( collor_array1, math.random( #collor_array1 ) );
  end;

  for i = 5, 8 do    
    random_state[ i ] = table.remove( collor_array2, math.random( #collor_array2 ) );
  end;

  ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].state = {};
  ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].start_state = {};
  private.state = {};
  for i = 1, 8 do
    ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].state[ i ] = random_state[ i ];
    ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].start_state[ i ] = random_state[ i ];
    private.state[ i ] = random_state[ i ];
  end;

  local count = 0;
  local state_win = {};
  for j = 1, 2 do
    for i = j*3-2, j*3 do

      state_win[ i ] = { false, false };

      if ( private.win_button_combination[ private.win_relation[ i ][ 1 ] ] == random_state[ i ] ) then
        state_win[ i ][ 1 ] = true;
      end;

      if ( private.win_button_combination[ private.win_relation[ i ][ 2 ] ] == random_state[ i + 1 ] ) then
        state_win[ i ][ 2 ] = true;
      end;

      if ( private.win_button_combination[ private.win_relation[ i ][ 1 ] ] == random_state[ i + 1 ] ) and
         ( private.win_button_combination[ private.win_relation[ i ][ 2 ] ] == random_state[ i ] ) then
        state_win[ i ] = { true, true };
      end;

    end;
  end;

  ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].start_state_win = {};
  ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].state_win = {};
  private.state_win = {};
  for i = 1, #state_win do
    ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].state_win[ i ] = state_win[ i ];
    ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].start_state_win[ i ] = state_win[ i ];
    private.state_win[ i ] = state_win[ i ];
  end;

end;
--*********************************************************************************************************************
function public.Open () 

  common_impl.TutorialShow( "tutorial_page_6_scr" );

  if not cmn.IsEventDone( "win_shelflock_scr" ) then

    cmn.MiniGameShow();    
    int_button_timer.Show();

  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  --common_impl.PlayAudio( "env", "aud_shelflock_scr_env", 1, "", 0.5 );

  local room_name = common.GetObjectName( private.room_objname );

  if ( cmn.IsEventDone( "win_"..room_name ) and cmn.IsEventStart( "win_"..room_name ) ) then
    
    ng_global.progress[ ng_global.currentprogress ][ "opn_"..room_name ].done = 0;
    
    ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].done = 0;
    ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].start = 0;    

  end;

  if ( not cmn.IsEventDone( "opn_"..room_name ) ) then

    cmn.SetEventDone( "opn_"..room_name );

    ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].timer = { default = 40, time = 40, diff = 20, extra = 0 };

    private.Generate();

    private.ResetInit();

    ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].chose = 0;
    private.MakeRelation();
    private.MakeButton();

  end;

  private.state_win = {};
  for i = 1, #ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].state_win do

    private.state_win[ i ] = {};
    private.state_win[ i ][ 1 ] = ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].state_win[ i ][ 1 ];
    private.state_win[ i ][ 2 ] = ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].state_win[ i ][ 2 ];

  end;

  private.state = {};
  for i = 1, #ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].state do

    private.state[ i ] = ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].state[ i ];

  end;

  private.MakeRelation();
  private.MakeButton();

  local color = { "blue", "red", "white", "yellow" };

  for i = 1, #private.state do

    for j = 1, #color do
    
      ObjSet( "spr_shelflock_scr_lights_"..i.."_"..color[ j ], { alp = 0 } );

    end;

    ObjSet( "spr_shelflock_scr_lights_"..i.."_"..private.state[ i ], { alp = 1 } );
    
    if ( private.state[ i ] == private.win_button_combination [ i ] ) then
    end;

  end;

  if ( ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].chose ~= 0 ) then

    local chose = ng_global.progress[ ng_global.currentprogress ][ "win_shelflock_scr" ].chose;
    ObjSet( "spr_shelflock_scr_lights_"..chose.."_"..private.state[ chose ].."_light", { alp = 1 } );      

  end;

  levelscr.InventoryDisable();

end;
--*********************************************************************************************************************
function public.Close ()

  --

end;
--*********************************************************************************************************************
function public.PreClose ()

  if not cmn.IsEventDone( "win_shelflock_scr" ) then

    cmn.MiniGameHide();    

  end;
  int_button_timer.Hide();

end;

--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS WIN *** () end;
--*********************************************************************************************************************
function private.GetDefaultState ()

  local state = { 0, 0, 0 };

  return state;

end;
--*********************************************************************************************************************
function private.WinAnim()

  cmn.Lock( true );
  ObjAnimate( "spr_shelflock_scr_door", "pos_xy", 0, 0, "",
  { 
    0.0, 1, ObjGet( "spr_shelflock_scr_door" ).pos_x, ObjGet( "spr_shelflock_scr_door" ).pos_y,
    0.6, 1, 517, 128,
    1.0, 1, 517, 128,
  } ); 
  ObjAnimate( "spr_shelflock_scr_door_1", "pos_xy", 0, 0, function() private.Win (); end,
  { 
    0.0, 1, ObjGet( "spr_shelflock_scr_door_1" ).pos_x, ObjGet( "spr_shelflock_scr_door_1" ).pos_y,
    0.6, 1, 515, 575,
    1.0, 1, 515, 575
  } ); 

end;
--*********************************************************************************************************************
function private.Win ()

  cmn.Lock( false )
  common_impl.PlayAudio( "sfx", "level1/sfx/aud_opn_shelflock_scr", 0, "", 0 );

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_shelflock_scr" );
  cmn.CallEventHandler( "win_shelflock_scr" );

  private.shelflock_scrSaveVar();
  
  rm_mysteryroom.WinTask();

  cmn.GotoRoom( "rm_mysteryroom" );

end;
--*********************************************************************************************************************
function public.Skip ()

  private.state_win = { { true, true },  --1
                        { true, true },  --2
                        { true, true },  --3
                        { true, true },  --4
                        { true, true },  --5
                        { true, true } };--6
  private.state = { "blue","yellow","red", "white",
                    "white", "blue", "red", "yellow"}; 

  cmn.Lock( true );

  for i = 1, #private.state_win do
    if ( private.state_win[ i ][ 1 ] == true ) then

      ObjAnimate( "spr_shelflock_scr_relation_"..i.."_1", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_"..i.."_light" ).alp,
        0.3, 0, 1
      } ); 

    else

      ObjAnimate( "spr_shelflock_scr_relation_"..i.."_1", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_"..i.."_light" ).alp,
        0.3, 0, 0
      } ); 

    end;

    if ( private.state_win[ i ][ 2 ] == true ) then

      ObjAnimate( "spr_shelflock_scr_relation_"..i.."_2", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_relation_"..i.."_2" ).alp,
        0.3, 0, 1
      } ); 

    else

      ObjAnimate( "spr_shelflock_scr_relation_"..i.."_2", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_relation_"..i.."_2" ).alp,
        0.3, 0, 0
      } ); 

    end;

    if ( private.state_win[ i ][ 1 ] == true and private.state_win[ i ][ 2 ] == true ) then

      ObjAnimate( "spr_shelflock_scr_"..i.."_light", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_"..i.."_light" ).alp,
        0.3, 0, 1
      } ); 

    else

      ObjAnimate( "spr_shelflock_scr_"..i.."_light", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_"..i.."_light" ).alp,
        0.3, 0, 0
      } ); 

    end;

  end;

  for i = 1, #private.state do

    if ( private.state[ i ] == private.win_button_combination[ i ]) then

      ObjAnimate( "spr_shelflock_scr_button_"..i.."_green", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_button_"..i.."_green" ).alp,
        0.3, 0, 1
      } ); 
      ObjAnimate( "spr_shelflock_scr_button_"..i.."_red", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_button_"..i.."_red" ).alp,
        0.3, 0, 0
      } ); 

    else

      ObjAnimate( "spr_shelflock_scr_button_"..i.."_green", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_button_"..i.."_green" ).alp,
        0.3, 0, 0
      } ); 
      ObjAnimate( "spr_shelflock_scr_button_"..i.."_red", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_button_"..i.."_red" ).alp,
        0.3, 0, 1
      } ); 

    end;

  end;

  local color = { "blue", "red", "white", "yellow" };

  for i = 1, #private.state do

    for j = 1, #color do

      ObjAnimate( "spr_shelflock_scr_lights_"..i.."_"..color[ j ].."_light", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_lights_"..i.."_"..color[ j ].."_light" ).alp,
        0.3, 0, 0
      } ); 
      ObjAnimate( "spr_shelflock_scr_lights_"..i.."_"..color[ j ], "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_lights_"..i.."_"..color[ j ] ).alp,
        0.3, 0, 0
      } ); 

    end;

    ObjAnimate( "spr_shelflock_scr_lights_"..i.."_"..private.state[ i ], "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_shelflock_scr_lights_"..i.."_"..private.state[ i ] ).alp,
      0.3, 0, 1
    } ); 

  end;


  local func_end = function ()

    cmn.Lock( true );

    private.WinAnim();

  end;

  ObjAnimate( "obj_shelflock_scr_mg", "alp", 0, 0, func_end,
  { 
    0.0, 0, ObjGet( "obj_shelflock_scr_mg" ).alp,
    0.3, 0, ObjGet( "obj_shelflock_scr_mg" ).alp
  } ); 

end;
--*********************************************************************************************************************
function private.ResetInit ()
  
  private.ResetEnd();

  ObjMultiSet( {
    { "obj_shelflock_scr_mg",         { input = true         } },
    { "spr_shelflock_scr_door_1",     { pos_x = 516, pos_y = 429 } },
    { "spr_shelflock_scr_door",       { pos_x = 517, pos_y = 286 } }
  } );

end;
--*********************************************************************************************************************
function public.Reset ()

  local start_state_win = ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].start_state_win;
  local start_state = ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].start_state;
  
  private.state_win = {};
  for i = 1, #start_state_win do
    private.state_win[ i ] = { start_state_win[ i ][ 1 ], start_state_win[ i ][ 2 ] };
  end;

  private.state = {};
  for i = 1, #start_state do
    private.state[ i ] = start_state[ i ];
  end;
 
  cmn.Lock( true );

  for i = 1, #private.state_win do

    if ( private.state_win[ i ][ 1 ] == true ) then

      ObjAnimate( "spr_shelflock_scr_relation_"..i.."_1", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_relation_"..i.."_1" ).alp,
        0.3, 0, 1
      } ); 

    else

      ObjAnimate( "spr_shelflock_scr_relation_"..i.."_1", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_relation_"..i.."_1" ).alp,
        0.3, 0, 0
      } ); 

    end;

    if ( private.state_win[ i ][ 2 ] == true ) then

      ObjAnimate( "spr_shelflock_scr_relation_"..i.."_2", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_relation_"..i.."_2" ).alp,
        0.3, 0, 1
      } ); 

    else

      ObjAnimate( "spr_shelflock_scr_relation_"..i.."_2", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_relation_"..i.."_2" ).alp,
        0.3, 0, 0
      } ); 

    end;

    if ( private.state_win[ i ][ 1 ] == true and private.state_win[ i ][ 2 ] == true ) then

      ObjAnimate( "spr_shelflock_scr_"..i.."_light", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_"..i.."_light" ).alp,
        0.3, 0, 1
      } ); 

    else

      ObjAnimate( "spr_shelflock_scr_"..i.."_light", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_"..i.."_light" ).alp,
        0.3, 0, 0
      } ); 

    end;

  end;

  for i = 1, #private.state do

    if ( private.state[ i ] == private.win_button_combination[ i ]) then

      ObjAnimate( "spr_shelflock_scr_button_"..i.."_green", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_button_"..i.."_green" ).alp,
        0.3, 0, 1
      } ); 
      ObjAnimate( "spr_shelflock_scr_button_"..i.."_red", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_button_"..i.."_red" ).alp,
        0.3, 0, 0
      } ); 

    else

      ObjAnimate( "spr_shelflock_scr_button_"..i.."_green", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_button_"..i.."_green" ).alp,
        0.3, 0, 0
      } ); 
      ObjAnimate( "spr_shelflock_scr_button_"..i.."_red", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_button_"..i.."_red" ).alp,
        0.3, 0, 1
      } ); 

    end;

  end;

  local color = { "blue", "red", "white", "yellow" };

  for i = 1, #private.state do

    for j = 1, #color do

      ObjAnimate( "spr_shelflock_scr_lights_"..i.."_"..color[ j ].."_light", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_lights_"..i.."_"..color[ j ].."_light" ).alp,
        0.3, 0, 0
      } ); 
      ObjAnimate( "spr_shelflock_scr_lights_"..i.."_"..color[ j ], "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_lights_"..i.."_"..color[ j ] ).alp,
        0.3, 0, 0
      } ); 

    end;

    ObjAnimate( "spr_shelflock_scr_lights_"..i.."_"..private.state[ i ], "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_shelflock_scr_lights_"..i.."_"..private.state[ i ] ).alp,
      0.3, 0, 1
    } ); 

  end;


  local func_end = function ()

    private.ResetEnd();

  end;

  ObjAnimate( "obj_shelflock_scr_mg", "alp", 0, 0, func_end,
  { 
    0.0, 0, ObjGet( "obj_shelflock_scr_mg" ).alp,
    0.3, 0, ObjGet( "obj_shelflock_scr_mg" ).alp
  } ); 

end;
--*********************************************************************************************************************
function private.ResetEnd ()

  cmn.Lock( false );
  private.shelflock_scrSaveVar();
  private.MakeButton();
  private.MakeRelation();
  ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].chose = 0;

end;
--*********************************************************************************************************************
function private.ClkLights ( id )

  local chose = ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].chose;
  local state = private.state[ id ];

  local func_end = function ()

    if ( chose == 0 or chose == id ) then

      private.ClkLightsEnd( id );

    else 

      private.ClkLightsCheckWin( id );  
      
    end;

  end; 

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_color1", 0, "", 0 );

  if ( chose == 0 ) then
    
    cmn.Lock( true );
    ObjAnimate( "spr_shelflock_scr_lights_"..id.."_"..state.."_light", "alp", 0, 0, func_end,
    { 
      0.0, 0, ObjGet( "spr_shelflock_scr_lights_"..id.."_"..state.."_light" ).alp,
      0.3, 0, 1
    } );        

  elseif ( ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].chose == id ) then

    cmn.Lock( true );
    ObjAnimate( "spr_shelflock_scr_lights_"..id.."_"..state.."_light", "alp", 0, 0, func_end,
    { 
      0.0, 0, ObjGet( "spr_shelflock_scr_lights_"..id.."_"..state.."_light" ).alp,
      0.3, 0, 0
    } );        

  else

    cmn.Lock( true );    
    ObjAnimate( "spr_shelflock_scr_lights_"..id.."_"..state.."_light", "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_shelflock_scr_lights_"..id.."_"..state.."_light" ).alp,
      0.3, 0, 1,
      0.3, 0, 1,
      0.5, 0, 0
    } );  

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_color2", 0, "", 0 );

    local chose_state = ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].state[ chose ];
    ObjAnimate( "spr_shelflock_scr_lights_"..chose.."_"..chose_state.."_light", "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_shelflock_scr_lights_"..chose.."_"..chose_state.."_light" ).alp,
      0.5, 0, 1,
      0.8, 0, 0
    } );
    ObjAnimate( "spr_shelflock_scr_lights_"..id.."_"..state, "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_shelflock_scr_lights_"..id.."_"..state ).alp,
      0.5, 0, ObjGet( "spr_shelflock_scr_lights_"..id.."_"..state ).alp,
      0.8, 0, 0
    } ); 
    ObjAnimate( "spr_shelflock_scr_lights_"..id.."_"..chose_state, "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_shelflock_scr_lights_"..id.."_"..chose_state ).alp,
      0.5, 0, ObjGet( "spr_shelflock_scr_lights_"..id.."_"..chose_state ).alp,
      0.8, 0, 1
    } );  

    ObjAnimate( "spr_shelflock_scr_lights_"..chose.."_"..chose_state, "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_shelflock_scr_lights_"..chose.."_"..chose_state ).alp,
      0.5, 0, ObjGet( "spr_shelflock_scr_lights_"..chose.."_"..chose_state ).alp,
      0.8, 0, 0
    } ); 
    ObjAnimate( "spr_shelflock_scr_lights_"..chose.."_"..state, "alp", 0, 0, func_end,
    { 
      0.0, 0, ObjGet( "spr_shelflock_scr_lights_"..chose.."_"..state ).alp,
      0.5, 0, ObjGet( "spr_shelflock_scr_lights_"..chose.."_"..state ).alp,
      0.8, 0, 1
    } );  

  end;   

end;
--*********************************************************************************************************************
function private.ClkLightsEnd ( id ) 

  local chose = ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].chose;
  local state = private.state[ id ];
  cmn.Lock( false );

  if ( chose == 0 ) then

    ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].chose = id;      

  elseif ( chose == id ) then  

    ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].chose = 0;

  end;

end;
--*********************************************************************************************************************
function private.ClkLightsCheckWin ( id )

  local chose = ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].chose;
  local chose_state = private.state[ chose ];

  local id_state = private.state[ id ];

  local cup = private.state[ id ];
  private.state[ id ] = private.state[ chose ];
  private.state[ chose ] = cup;

  cmn.Lock( true );    
  for i = 1, #private.win_relation do

    if ( private.state[ private.win_relation[ i ][ 1 ] ] == private.win_combination[ i ][ 1 ] or 
         private.state[ private.win_relation[ i ][ 1 ] ] == private.win_combination[ i ][ 2 ] ) then

      ObjAnimate( "spr_shelflock_scr_relation_"..i.."_1", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_relation_"..i.."_1" ).alp,
        0.3, 0, 1
      } ); 
      private.state_win[ i ][ 1 ] = true;

      local number = private.win_relation[ i ][ 1 ];
      local color_element = private.state[ private.win_relation[ i ][ 1 ] ];
      
      if ( color_element == private.win_button_combination[ number ] ) then

        ObjAnimate( "spr_shelflock_scr_button_"..number.."_green", "alp", 0, 0, "",
        { 
          0.0, 0, ObjGet( "spr_shelflock_scr_button_"..number.."_green" ).alp,
          0.3, 0, 1
        } ); 
        ObjAnimate( "spr_shelflock_scr_button_"..number.."_red", "alp", 0, 0, "",
        { 
          0.0, 0, ObjGet( "spr_shelflock_scr_button_"..number.."_red" ).alp,
          0.3, 0, 0
        } ); 
      else 

        ObjAnimate( "spr_shelflock_scr_button_"..number.."_green", "alp", 0, 0, "",
        { 
          0.0, 0, ObjGet( "spr_shelflock_scr_button_"..number.."_green" ).alp,
          0.3, 0, 0
        } ); 
        ObjAnimate( "spr_shelflock_scr_button_"..number.."_red", "alp", 0, 0, "",
        { 
          0.0, 0, ObjGet( "spr_shelflock_scr_button_"..number.."_red" ).alp,
          0.3, 0, 1
        } );
 
      end;

    else 

      ObjAnimate( "spr_shelflock_scr_relation_"..i.."_1", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_relation_"..i.."_1" ).alp,
        0.3, 0, 0
      } ); 
      private.state_win[ i ][ 1 ] = false;

      local number = private.win_relation[ i ][ 1 ];
      local color_element = private.state[ private.win_relation[ i ][ 1 ] ];
      
      ObjAnimate( "spr_shelflock_scr_button_"..number.."_green", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_button_"..number.."_green" ).alp,
        0.3, 0, 0
      } ); 
      ObjAnimate( "spr_shelflock_scr_button_"..number.."_red", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_button_"..number.."_red" ).alp,
        0.3, 0, 1,
      } ); 

    end;

    if ( ( private.state[ private.win_relation[ i ][ 2 ] ] == private.win_combination[ i ][ 2 ] or 
           private.state[ private.win_relation[ i ][ 2 ] ] == private.win_combination[ i ][ 1 ] ) and   
           private.state[ private.win_relation[ i ][ 2 ] ] ~= private.state[ private.win_relation[ i ][ 1 ] ] ) then  

      ObjAnimate( "spr_shelflock_scr_relation_"..i.."_2", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_relation_"..i.."_2" ).alp,
        0.3, 0, 1
      } ); 
      private.state_win[ i ][ 2 ] = true;

      local number = private.win_relation[ i ][ 2 ];
      local color_element = private.state[ private.win_relation[ i ][ 2 ] ];

      if ( color_element == private.win_button_combination[ number ] ) then

        ObjAnimate( "spr_shelflock_scr_button_"..number.."_green", "alp", 0, 0, "",
        { 
          0.0, 0, ObjGet( "spr_shelflock_scr_button_"..number.."_green" ).alp,
          0.3, 0, 1
        } ); 
        ObjAnimate( "spr_shelflock_scr_button_"..number.."_red", "alp", 0, 0, "",
        { 
          0.0, 0, ObjGet( "spr_shelflock_scr_button_"..number.."_red" ).alp,
          0.3, 0, 0
        } ); 
      else 

        ObjAnimate( "spr_shelflock_scr_button_"..number.."_green", "alp", 0, 0, "",
        { 
          0.0, 0, ObjGet( "spr_shelflock_scr_button_"..number.."_green" ).alp,
          0.3, 0, 0
        } ); 
        ObjAnimate( "spr_shelflock_scr_button_"..number.."_red", "alp", 0, 0, "",
        { 
          0.0, 0, ObjGet( "spr_shelflock_scr_button_"..number.."_red" ).alp,
          0.3, 0, 1
        } );
 
      end; 

    else 

      ObjAnimate( "spr_shelflock_scr_relation_"..i.."_2", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_relation_"..i.."_2" ).alp,
        0.3, 0, 0
      } ); 
      private.state_win[ i ][ 2 ] = false;

      local number = private.win_relation[ i ][ 2 ];
      local color_element = private.state[ private.win_relation[ i ][ 2 ] ];
      ObjAnimate( "spr_shelflock_scr_button_"..number.."_green", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_button_"..number.."_green" ).alp,
        0.3, 0, 0
      } ); 
      ObjAnimate( "spr_shelflock_scr_button_"..number.."_red", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_button_"..number.."_red" ).alp,
        0.3, 0, 1
      } ); 

    end;

  end;

  for i = 1, #private.state_win do

    if ( private.state_win[ i ][ 1 ] == true and private.state_win[ i ][ 2 ] == true ) then

      ObjAnimate( "spr_shelflock_scr_"..i.."_light", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_"..i.."_light" ).alp,
        0.3, 0, 1
      } ); 

    else

      ObjAnimate( "spr_shelflock_scr_"..i.."_light", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_shelflock_scr_"..i.."_light" ).alp,
        0.3, 0, 0
      } ); 

    end;

  end;

  local func_end = function ()

    cmn.Lock( false );

 
    if ( private.shelflock_scrIsWin() ) then 

      private.WinAnim();

    else

      private.shelflock_scrSaveVar();
      ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].chose = 0;

    end;

  end;

  ObjAnimate( "obj_shelflock_scr_mg", "alp", 0, 0, func_end,
  { 
    0.0, 0, ObjGet( "obj_shelflock_scr_mg" ).alp,
    0.3, 0, ObjGet( "obj_shelflock_scr_mg" ).alp
  } ); 

end;
--*********************************************************************************************************************
function private.shelflock_scrIsWin ()

  local bool = true;
  for i = 1, #private.state_win do

    if ( private.state_win[ i ][ 1 ] == false or private.state_win[ i ][ 2 ] == false ) then

      bool = false;
      break;

    end;

  end;

  return bool;  

end;
--*********************************************************************************************************************
function private.shelflock_scrSaveVar ()

  for i = 1, #private.state_win  do

    ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].state_win[ i ][ 1 ] = private.state_win[ i ][ 1 ];  
    ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].state_win[ i ][ 2 ] = private.state_win[ i ][ 2 ];    

  end;
  
  for i = 1, #private.state do

    ng_global.progress[ng_global.currentprogress]["win_shelflock_scr"].state[ i ] = private.state[ i ]; 

  end;

end;
--*********************************************************************************************************************
function private.MakeRelation ()

  for i = 1, #private.state_win do


    if ( private.state_win[ i ][ 1 ] == true ) then

      ObjSet( "spr_shelflock_scr_relation_"..i.."_1", { alp = 1 } );

    else

      ObjSet( "spr_shelflock_scr_relation_"..i.."_1", { alp = 0 } );

    end;

    if ( private.state_win[ i ][ 2 ] == true ) then

      ObjSet( "spr_shelflock_scr_relation_"..i.."_2", { alp = 1 } );

    else

      ObjSet( "spr_shelflock_scr_relation_"..i.."_2", { alp = 0 } );

    end;

    if ( private.state_win[ i ][ 1 ] == true and private.state_win[ i ][ 2 ] == true ) then

      ObjSet( "spr_shelflock_scr_"..i.."_light", { alp = 1 } );

    else

      ObjSet( "spr_shelflock_scr_"..i.."_light", { alp = 0 } );

    end;

  end;

end;
--*********************************************************************************************************************
function private.MakeButton ()
  
  for i = 1, #private.state do

    if ( private.state[ i ] == private.win_button_combination[ i ]) then

      ObjSet( "spr_shelflock_scr_button_"..i.."_green", { alp = 1 } );
      ObjSet( "spr_shelflock_scr_button_"..i.."_red",   { alp = 0 } );

    else

      ObjSet( "spr_shelflock_scr_button_"..i.."_green", { alp = 0 } );
      ObjSet( "spr_shelflock_scr_button_"..i.."_red",   { alp = 1 } );

    end;

  end;

end;
--*********************************************************************************************************************










