-- name=mg_transformer_scr
--*********************************************************************************************************************
function public.Init ()

  private.LogicInit();
  private.InitAnimations();

  private.room_objname = "mg_transformer_scr";

  ObjMultiSet({ 
    --{ "spr_transformer_scr_mechanismpart", { event_mdown = private.get_mechanismpart }},
    { "obj_transformer_scr_click",         { event_mdown = private.LeverClick }},
  });

  --------------------------------------------------------------------------------------------
  -- function win_transformer () end;
  --------------------------------------------------------------------------------------------
  local win_transformer_scr = function ()

    if ( cmn.IsEventDone( "win_transformer_scr" ) ) then  

      --

    else

      local room_name = common.GetObjectName( private.room_objname );
      private.level = ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].random_index;
      ObjSet( "obj_transformer_scr_scheme_"..private.level, { input = true, visible = true } );      

      private.state = {};
      for i = 1, 5 do
  
        private.state[ i ] = ng_global.progress[ ng_global.currentprogress ][ "win_transformer_scr" ].state[ i ];

      end;

      private.Update();

    end;

  end;

  cmn.AddSubscriber( "win_transformer_scr", win_transformer_scr, private.room_objname );
  --------------------------------------------------------------------------------------------
end;

--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** ANIMATIONS *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************

function private.InitAnimations ()

  for i = 1, 5, 1 do 

    ObjAnimate( "spr_transformer_scr_lamp_"..i, "alp",1,0, "", { 0, 3, 1,    0.2, 3, 0.9,    0.4, 3, 1 } );
    --ObjAnimate( "spr_transformer_scr_wire_"..i, "alp",1,0, "", { 0, 3, 1,    0.8, 3, 0.6,    1.6, 3, 1 } );

  end;

end;

--*********************************************************************************************************************
--*********************************************************************************************************************
function private.Generate ()
  
  local room_name = common.GetObjectName( private.room_objname );
  ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].random_index = math.random( 3 );
  private.level = ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].random_index;
  ObjSet( "obj_transformer_scr_scheme_"..ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].random_index, { input = true, visible = true } );

  private.Default();
  private.Save();

  private.Update();

end;
--*********************************************************************************************************************
function private.ResetInit ()

  for i = 1, 3 do

    ObjSet( "obj_transformer_scr_scheme_"..i, { input = false, visible = false } );

    for j = 1, 5 do

      ObjSet( "spr_transformer_scr_scheme_"..i.."_button_"..j, { ang = private.state_start[ i ][ j ] * math.pi/2 } );
      ObjSet( "spr_transformer_scr_scheme_"..i.."_wire_"..j, { visible = false } );
      ObjSet( "spr_transformer_scr_lamp_"..j, { visible = false, alp = 1 } );      

    end;

  end;

  ObjSet( "obj_transformer_scr_click",      { input = true } );
  ObjSet( "spr_transformer_scr_lever",      { pos_y = 220 } );
  ObjSet( "spr_transformer_scr_photo_back", { pos_y = 1000 } );

end;
--*********************************************************************************************************************
function public.Open () 

  common_impl.TutorialShow( "tutorial_page_6_scr" );

  if not cmn.IsEventDone( "win_transformer_scr" ) then

    cmn.MiniGameShow();    
    int_button_timer.Show();

  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  local room_name = common.GetObjectName( private.room_objname );

  if ( cmn.IsEventDone( "win_"..room_name ) and cmn.IsEventStart( "win_"..room_name ) ) then
    
    ng_global.progress[ ng_global.currentprogress ][ "opn_"..room_name ].done = 0;
    
    ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].done = 0;
    ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].start = 0;    

  end;

  if ( not cmn.IsEventDone( "opn_"..room_name ) ) then

    cmn.SetEventDone( "opn_"..room_name );

    ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].timer = { default = 40, time = 40, diff = 20, extra = 0 };

    ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].state = {};
    ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].random_index = 0;

    private.ResetInit();
    private.Generate();

  end;

  levelscr.InventoryDisable();

  --[[private.Load();
  private.Update();]]

end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()

  if not cmn.IsEventDone( "win_transformer_scr" ) then

    cmn.MiniGameHide();    

  end;
  int_button_timer.Hide();

end;


--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MINIGAME LOGIC *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
private.state = {};
private.level = 0;

private.state_start = 
{ 
  { 0, 0, 0, 2, 2 },
  { 0, 3, 1, 3, 1 },
  { 0, 0, 0, 0, 0 }
};

private.state_win = 
{ 
  { 1, 2, 1, 1, 1 },
  { 3, 3, 1, 2, 0 },
  { 0, 1, 2, 1, 3 }
};

private.links = {};
private.links[ 1 ] = 
{ 
  { 
    degrees_0   = { wires = {},       lamp_burns = {} }, 
    degrees_90  = { wires = { 1 },    lamp_burns = { 1, 2 } }, 
    degrees_180 = { wires = {},       lamp_burns = {} }, 
    degrees_270 = { wires = { 1 },    lamp_burns = { 1, 2 } } 
  },
  { 
    degrees_0   = { wires = {},       lamp_burns = {} }, 
    degrees_90  = { wires = { 1 },    lamp_burns = { 1, 2 } }, 
    degrees_180 = { wires = { 1 },    lamp_burns = { 1, 2 } }, 
    degrees_270 = { wires = { 1 },    lamp_burns = { 1, 2 } } 
  },
  { 
    degrees_0   = { wires = {},       lamp_burns = {} }, 
    degrees_90  = { wires = { 1, 2 }, lamp_burns = { 1, 2, 3 } }, 
    degrees_180 = { wires = { 1 },    lamp_burns = { 1, 2 } }, 
    degrees_270 = { wires = { 2 },    lamp_burns = { 3 } } 
  },
  { 
    degrees_0   = { wires = { 3 },    lamp_burns = { 4 } }, 
    degrees_90  = { wires = { 3 },    lamp_burns = { 4 } }, 
    degrees_180 = { wires = {},       lamp_burns = {} }, 
    degrees_270 = { wires = { 3 },    lamp_burns = { 4 } } 
  },
  { 
    degrees_0   = { wires = { 4 },    lamp_burns = { 5 } }, 
    degrees_90  = { wires = { 4 },    lamp_burns = { 5 } }, 
    degrees_180 = { wires = {},       lamp_burns = {} }, 
    degrees_270 = { wires = { 4 },    lamp_burns = { 5 } } 
  } 

};

private.links[ 2 ] = 
{ 
  { 
    degrees_0   = { wires = {},       lamp_burns = {} }, 
    degrees_90  = { wires = { 1 },    lamp_burns = { 1 } }, 
    degrees_180 = { wires = {},       lamp_burns = {} }, 
    degrees_270 = { wires = { 1 },    lamp_burns = { 1 } } 
  },
  { 
    degrees_0   = { wires = { 2 },    lamp_burns = { 2 } }, 
    degrees_90  = { wires = { 2 },    lamp_burns = { 2 } }, 
    degrees_180 = { wires = {},       lamp_burns = {} }, 
    degrees_270 = { wires = { 2 },    lamp_burns = { 2 } } 
  },
  { 
    degrees_0   = { wires = { 3 },    lamp_burns = { 3 } }, 
    degrees_90  = { wires = {},       lamp_burns = {} }, 
    degrees_180 = { wires = {},       lamp_burns = {} }, 
    degrees_270 = { wires = {},       lamp_burns = {} } 
  },
  { 
    degrees_0   = { wires = { 4 },    lamp_burns = { 4 } }, 
    degrees_90  = { wires = { 4 },    lamp_burns = { 4 } }, 
    degrees_180 = { wires = { 4 },    lamp_burns = { 4 } }, 
    degrees_270 = { wires = {},       lamp_burns = {} } 
  },
  { 
    degrees_0   = { wires = { 4, 5 }, lamp_burns = { 4, 5 } }, 
    degrees_90  = { wires = {},       lamp_burns = {} }, 
    degrees_180 = { wires = { 4 },    lamp_burns = { 4 } }, 
    degrees_270 = { wires = { 5 },    lamp_burns = { 5 } } 
  } 

};  

private.links[ 3 ] = 
{ 
  { 
    degrees_0   = { wires = {},       lamp_burns = {} }, 
    degrees_90  = { wires = { 1, 2 }, lamp_burns = { 1, 2 } }, 
    degrees_180 = { wires = { 2 },    lamp_burns = { 2 } }, 
    degrees_270 = { wires = { 1 },    lamp_burns = { 1 } } 
  },
  { 
    degrees_0   = { wires = {},       lamp_burns = {} }, 
    degrees_90  = { wires = { 2 },    lamp_burns = { 2 } }, 
    degrees_180 = { wires = {},       lamp_burns = {} }, 
    degrees_270 = { wires = { 2 },    lamp_burns = { 2 } } 
  },
  { 
    degrees_0   = { wires = {},       lamp_burns = {} }, 
    degrees_90  = { wires = { 3 },    lamp_burns = { 3 } }, 
    degrees_180 = { wires = { 3 },    lamp_burns = { 3 } }, 
    degrees_270 = { wires = {},       lamp_burns = {} } 
  },
  { 
    degrees_0   = { wires = {},       lamp_burns = {} }, 
    degrees_90  = { wires = { 4, 5 }, lamp_burns = { 4, 5 } }, 
    degrees_180 = { wires = { 5 },    lamp_burns = { 5 } }, 
    degrees_270 = { wires = { 4 },    lamp_burns = { 4 } } 
  },
  { 
    degrees_0   = { wires = {},       lamp_burns = {} }, 
    degrees_90  = { wires = { 5 },    lamp_burns = { 5 } }, 
    degrees_180 = { wires = {},       lamp_burns = {} }, 
    degrees_270 = { wires = { 5 },    lamp_burns = { 5 } } 
  } 

};


local TRANSFORMER_BUTTON_NAME = "spr_transformer_scr_button_";
local TRANSFORMER_WIRE_NAME = "spr_transformer_scr_wire_";
local TRANSFORMER_LAMP_NAME = "spr_transformer_scr_lamp_";

local TRANSFORMER_BUTTON_COUNT = 5;
local TRANSFORMER_BUTTON_ANGLE_DEGREE = 90;
local TRANSFORMER_BUTTON_ANGLE_RADIAN = -1.57;

local isWin = true;

--*******************************************************************************************************************
function private.Default ()

  for i = 1, 5 do
    private.state[ i ] = private.state_start[ private.level ][ i ];
  end;
  

end; 
--*******************************************************************************************************************
function private.Save ()

  for i = 1, 5 do

    ng_global.progress[ "scr" ][ "win_transformer_scr" ].state[ i ] = private.state[ i ];

  end;

end;
--*******************************************************************************************************************
function private.LogicInit ()   

  for i = 1, 3 do
    for j = 1, 5 do

      local curButton = "spr_transformer_scr_scheme_"..i.."_button_"..j;
      ObjSet( curButton, { 
                            input = 1,
                            event_mdown = function () private.Click( j ); end,
                            event_menter = function () private.Enter(); end,
                            event_mleave = function () private.Leave(); end
                         } );

    end;  
  end;

end;


--*******************************************************************************************************************
function private.Enter ()
 
  SetCursor( CURSOR_HAND );

end;


--*******************************************************************************************************************
function private.Leave ()  

  SetCursor( CURSOR_DEFAULT );

end;


--*******************************************************************************************************************
-- giving field name in data array by angle value for button   

function private.GiveFieldNameByAngle ( angle )

  local number = angle * TRANSFORMER_BUTTON_ANGLE_DEGREE;
  local field = "degrees_"..number;

  return field;

end;


--*******************************************************************************************************************
-- all wires and lamps are fading 

function private.ClearWiresAndLamps ()

  for i = 1, 5 do

    local curWire = "spr_transformer_scr_scheme_"..private.level.."_wire_"..i;
    ObjSet( curWire, { visible = false } );

    local curLamp = "spr_transformer_scr_lamp_"..i;
    ObjSet( curLamp, { visible = false } );

  end;

end;


--*******************************************************************************************************************
function private.Click ( id )

  cmn.Lock( true );

  local func_end = function ()

    cmn.Lock( false );
    private.Update();

  end;

  local curButton = "spr_transformer_scr_scheme_"..private.level.."_button_"..id;
  local prevAngle = private.state[id] * TRANSFORMER_BUTTON_ANGLE_RADIAN;

  private.state[id] = private.state[id] + 1;
  local nextAngle = private.state[id] * TRANSFORMER_BUTTON_ANGLE_RADIAN;

  -- if angle == 2*PI, it will reset   
  if private.state[id] > 3 then
    private.state[id] = 0;
  end;

  private.Save();

  ObjAnimate( curButton, "ang",0,0, func_end, { 0, 0, prevAngle,    0.6, 0, nextAngle } );

end;


--*******************************************************************************************************************
function private.Update ()

  isWin = true;
  private.ClearWiresAndLamps();

  for i = 1, 5 do

    local curButton = "spr_transformer_scr_scheme_"..private.level.."_button_"..i;
    local curButtonAngle = TRANSFORMER_BUTTON_ANGLE_RADIAN * private.state[ i ];

    ObjSet( curButton, { ang = curButtonAngle } );

    if ( private.level == 1 ) then

      if ( i == 2 and ( private.state[ i ] == 0 ) ) then 

        if ( private.state[ 1 ] == 1 ) or ( private.state[ 1 ] == 3 ) then

          ObjSet( "spr_transformer_scr_scheme_"..private.level.."_wire_2", { visible = true } );
          ObjSet( "spr_transformer_scr_lamp_2", { visible = true } );

        end;

      end;

      if ( i == 3 and ( private.state[ i ] == 0 ) ) then 

        if ( private.state[ 1 ] == 1 ) or ( private.state[ 1 ] == 3 ) or
        ( private.state[ 2 ] ~= 0 ) then

          ObjSet( "spr_transformer_scr_scheme_"..private.level.."_wire_3", { visible = true } );
          ObjSet( "spr_transformer_scr_lamp_3", { visible = true } );

        end;

      end;

    elseif ( private.level == 2 ) then

      if ( i == 5 and ( private.state[ i ] == 1 ) ) then 

        if private.state[ 4 ] ~= 3 then

          ObjSet( "spr_transformer_scr_scheme_"..private.level.."_wire_5", { visible = true } );
          ObjSet( "spr_transformer_scr_lamp_5", { visible = true } );

        end;

      end;

    else

      if ( i == 2 and ( private.state[i] == 1 or private.state[i] == 3 ) ) then 

        if private.state[1] == 0 or private.state[1] == 1 then

          ObjSet( "spr_transformer_scr_scheme_"..private.level.."_wire_1", { visible = true } );
          ObjSet( "spr_transformer_scr_lamp_1", { visible = true } );

        end;

      end;

      if ( i == 5 and ( private.state[i] == 1 or private.state[i] == 3 ) ) then 

        if private.state[4] == 0 or private.state[4] == 1 then

          ObjSet( "spr_transformer_scr_scheme_"..private.level.."_wire_4", { visible = true } );
          ObjSet( "spr_transformer_scr_lamp_4", { visible = true } );

        end;

      end;
  
    end;


    local degrees = private.GiveFieldNameByAngle( private.state[ i ] );
    local wires = private.links[ private.level ][ i ][ degrees ].wires;
    for j = 1, #wires, 1 do

      isWin = false;
      local curWire = "spr_transformer_scr_scheme_"..private.level.."_wire_"..wires[ j ];
      ObjSet( curWire, { visible = true } );

    end;

    local lamps = private.links[ private.level ][ i ][ degrees ].lamp_burns;
    for j = 1, #lamps, 1 do

      isWin = false;
      local curLamp = "spr_transformer_scr_lamp_"..lamps[ j ];
      ObjSet( curLamp, { visible = true } );

    end;

  end;

end;


--*******************************************************************************************************************
function private.CheckWin ()

  local flag_win = true;

  for i = 1, 5 do
    if not ( ObjGet( "spr_transformer_scr_lamp_"..i ).visible == true ) then
      return false;
    end;

  end;


  return flag_win;  
    
end;
--*********************************************************************************************************************
function private.Win ()  

  local func_end = function ()

    cmn.SetEventDone( "win_transformer_scr" );
    cmn.CallEventHandler( "win_transformer_scr" );
    rm_mysteryroom.WinTask();

    cmn.Lock( false );
    cmn.GotoRoom( "rm_mysteryroom" );

  end;

  local func_step2 = function ()

    ObjAnimate( "spr_transformer_scr_photo_back", "pos_y", 0, 0, func_end, { 0,3,1000,  0.6,3,502,  1.0,3,502 } );

  end;

  cmn.MiniGameHide();
  cmn.Lock( true );

  for i = 1, 5 do 

    local curLamp = "spr_transformer_scr_lamp_"..i;
    ObjStopAnimate( curLamp, "alp" );

    ObjSet( curLamp, { alp = 1, visible = true } );

    local anim_end = "";
    if i == 5 then 

      anim_end = func_step2;      

    end;

    ObjAnimate( curLamp, "alp",0,0, anim_end, { 0, 3, 1,    0.4, 3, 0,    0.8, 3, 1,    1.6, 3, 0 } );

  end;

end;
--*********************************************************************************************************************
function private.LeverClick ()

  if private.CheckWin() then 

    local func_end = function ()
      private.Win(); 
    end;

    ObjSet( "obj_transformer_scr_click", { input = false } );
    ObjAnimate( "spr_transformer_scr_lever", "pos_y",0,0, func_end, { 0, 2, 220,    0.6, 2, 480 } );

  else 

    local func_end = function ()

      cmn.Lock( false );
      ObjSet( "spr_transformer_scr_lever", { alp = 1 } );
      ObjSet( "anm_mg_transformer_scr_idle_speed", { alp = 0 } );

    end;

    local func_end_2 = function ()
      ObjSet( "spr_transformer_scr_lever", { alp = 0 } );
    end;

    cmn.Lock( true );
    ObjAnimate( "anm_mg_transformer_scr_idle_speed", "alp",0,0, func_end_2, { 0, 0, 0,    0.1, 0, 1 } );
    AnimPlay( "anm_mg_transformer_scr_idle_speed", "DoAnim", func_end );

  end;

end;


--*********************************************************************************************************************
function public.Reset ()

  cmn.Lock( true );

  local oldAngle = {};

  for i = 1, 5 do
    oldAngle[ i ] = private.state[ i ];
  end; 

  private.Default();
  private.Save();

  for j = 1, 5 do

    local prevAngle = TRANSFORMER_BUTTON_ANGLE_RADIAN * oldAngle[ j ];
    local nextAngle = TRANSFORMER_BUTTON_ANGLE_RADIAN * private.state[ j ];
    local curButon = "spr_transformer_scr_scheme_"..private.level.."_button_"..j;

    local func_end = "";

    if j == 5 then 

      func_end = function ()

        cmn.Lock( false );
        private.Update();

      end;

    end;  

    if prevAngle > nextAngle then 

      prevAngle = prevAngle - 2*math.pi;

    end; 

    ObjAnimate( curButon, "ang",0,0, func_end, { 0, 2, prevAngle,    0.4, 2, nextAngle } );

  end; 

end;


--*********************************************************************************************************************
function public.Skip ()

  cmn.Lock( true );

  local oldAngle = {};

  for i = 1, 5 do
    oldAngle[ i ] = private.state[ i ];
  end; 

  private.state = private.state_win[ private.level ];

  for j = 1, 5 do

    local prevAngle = TRANSFORMER_BUTTON_ANGLE_RADIAN * oldAngle[ j ];
    local nextAngle = TRANSFORMER_BUTTON_ANGLE_RADIAN * private.state[ j ];
    local curButon = "spr_transformer_scr_scheme_"..private.level.."_button_"..j;

    local func_end = "";

    if j == 5 then 

      func_end = function ()

        cmn.Lock( false );
        private.Update();
        private.LeverClick();

      end;

    end;  

    if ( prevAngle > nextAngle ) then 

      prevAngle = prevAngle - 2*math.pi;

    end; 

    ObjAnimate( curButon, "ang",0,0, func_end, { 0, 2, prevAngle,    0.4, 2, nextAngle } );

  end; 

end;

--*********************************************************************************************************************










