-- name=levelscr

function public.Start ( param )

  interface.WidgetAdd( InterfaceWidget_Pause, 10000000 );
  interface.WidgetAdd( InterfaceWidget_BtnMenu, 12 );

  interface.WidgetAdd( InterfaceWidget_BtnHint, 9  );
  interface.WidgetSetVisible( InterfaceWidget_BtnHint, 0 );
  interface.WidgetSetInput( InterfaceWidget_BtnHint, false );  

  interface.WidgetAdd( InterfaceWidget_BtnSkip, 12 );
  interface.WidgetSetVisible( InterfaceWidget_BtnSkip, 0 );
  interface.WidgetSetInput( InterfaceWidget_BtnSkip, false );    

  interface.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  interface.WidgetAdd( InterfaceWidget_Inventory, 9 ); 
  interface.WidgetSetVisible( InterfaceWidget_Inventory, 0 );
  interface.WidgetSetInput( InterfaceWidget_Inventory, false );   

  interface.WidgetAdd( InterfaceWidget_TaskPanel, 10 );

  interface.WidgetAdd( InterfaceWidget_Effects, 11 );

  interface.WidgetAdd( InterfaceWidget_DialogHo );

  interface.ButtonLockAdd();
  interface.LockAdd();

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8);

  interface.WidgetAdd( InterfaceWidget_ItemPanel );
  interface.WidgetAdd( InterfaceWidget_Popup );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog );

  interface.WidgetAdd( InterfaceWidget_DialogVideo );
  interface.WidgetAdd( InterfaceWidget_DialogStory );
  interface.WidgetAdd( InterfaceWidget_DialogCharacter, 8 );

  interface.WidgetAdd( InterfaceWidget_Tutorial );
  interface.WidgetAdd( InterfaceWidget_Window );

  interface.PanelNotificationAdd();

  --interface.DialogHintAdd();
  --interface.EvidenceAdd( 18 );
  --interface.DialogEvidenceAdd( 20 );
  --interface.InvestigationButtonAdd( 17 ); 
  --interface.SliderAdd( -1 );
  --interface.ProvideAdd( 8 );
  interface.ButtonTimerAdd( 10 );
  interface.DialogTaskAdd( 20 );  

  --if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    interface.BtnCollectibles2Add( 25 );
    interface.BtnCollectiblesAdd( 25 );
    interface.AchievementsAdd( 25 );
    --interface.BtnMorphAdd( 25 );

  --end;

  private.Init();
  ModLoad( "assets/levels/levelscr/mod_levelscr_inv" );
  levelscr_inv.Init();

  common.LevelLoad( "levelscr", "scr", "rm_mysteryroom", param );
  --if IsCollectorsEdition() then

    --common_impl.Collectibles2CoinsLoad();

  --end;

  private.TutorialSetParams();
  --interface.KeyUpdate();

  --event_show_investigation = "beg_levelscr";

  --interface.InvestigationButtonCheck();
  
  --interface.PanelProvideShow();
  
  cmn.PlayMusEnv();

end;
    
function private.Init ()

  game = {};
  game.room_names =
  {
    "rm_mysteryroom"
   ,"ho_archivedata_scr"
   ,"ho_behindmirror_scr"
   ,"ho_engineerbox_scr"
   ,"ho_indollhouse_scr"
   ,"ho_itemscollecting_scr"
   ,"ho_suitcase_scr"
   ,"mg_forandagainst_scr"
   ,"mg_hoteldoor_scr"
   ,"mg_minelabyrinth_scr"
   ,"mg_panel_scr"
   ,"mg_shelflock_scr"
   ,"mg_transformer_scr"
  };

  game.progress_names_room =
  {
   { "beg_levelscr" }
  ,{ "opn_mysteryroom" }
  
  ,{ "opn_forandagainst_scr" }
  ,{ "win_forandagainst_scr" }
  ,{ "opn_hoteldoor_scr" }
  ,{ "win_hoteldoor_scr" }
  ,{ "opn_minelabyrinth_scr" }
  ,{ "win_minelabyrinth_scr" }
  ,{ "opn_panel_scr" }
  ,{ "win_panel_scr" }
  ,{ "opn_shelflock_scr" }
  ,{ "win_shelflock_scr" }
  ,{ "opn_transformer_scr" }
  ,{ "win_transformer_scr" }
  
  ,{ "opn_archivedata_scr" }
  ,{ "win_archivedata_scr" }
  ,{ "opn_behindmirror_scr" }
  ,{ "win_behindmirror_scr" }
  ,{ "opn_engineerbox_scr" }
  ,{ "win_engineerbox_scr" }
  ,{ "opn_indollhouse_scr" }
  ,{ "win_indollhouse_scr" }
  ,{ "opn_itemscollecting_scr" }
  ,{ "win_itemscollecting_scr" }
  ,{ "opn_suitcase_scr" }
  ,{ "win_suitcase_scr" }
  };
  
  game.progress_names = {};
  for i = 1, #game.progress_names_room do
    game.progress_names[ i ] = game.progress_names_room[ i ][ 1 ];
  end;
  
  game.relations = {};
  
  private.menu_moduls = {
    "rm_credits"
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {
      "rm_collectibles2",
      "rm_collectibles",
      "rm_achievements",
    }
    for i = 1, #menu_moduls_ce do
      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );
    end;

  end;

end;
--************************************************************************************************************************

function private.TutorialSetParams()

  if not ng_global.progress[ "scr" ][ "see_tutorial_scr" ] then

    ng_global.progress[ "scr" ][ "see_tutorial_scr" ] = {};
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].done  = 0;
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].start = 0;
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].state = {};
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].state.no  = 0;
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].state.currentpage = "tutorial_page_1_scr";
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].func = function() end;

    local offset = 0;

    if ( GetWideScreen() ) then

      offset = 0.5 * ( GetAppWidth() - 1024 );
      
    end;

    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].state.pages = {

      [ "tutorial_page_1_scr" ] = { shown = 0, noskip = true, posx = 512, posy = 200, arrows = {} } , -- Показать туториал? 

      [ "tutorial_page_2_scr" ] = { shown = 0, noskip = false, posx = 350, posy = 280, arrows = { 
                                                                              { pos_x = 650, pos_y = 200, ang =  -1.2 }
                                                                            } },   -- туториал на кнопку сообщений

      [ "tutorial_page_3_scr" ] = { shown = 0, noskip = false, posx = 400, posy = 500, arrows = { 
                                                                              { pos_x = 350, pos_y = 350, ang =  0 }
                                                                            } },   -- туториал на две папки

      [ "tutorial_page_4_scr" ] = { shown = 0, noskip = false, posx = 700, posy = 500, arrows = { 
                                                                              { pos_x = 400, pos_y = 490, ang =  1.3 }
                                                                            } },   -- туториал на задания в папках

      [ "tutorial_page_5_scr" ] = { shown = 0, noskip = false, posx = 200, posy = 400, arrows = { 
                                                                              { pos_x = 500, pos_y = 300, ang =  -1.1 }
                                                                            } },   -- туториал о получении звезд

      [ "tutorial_page_6_scr" ] = { shown = 0, noskip = false, posx = 350, posy = 350, arrows = { 
                                                                              { pos_x = 100, pos_y = -30, ang =  2, target = "spr_int_button_timer" }
                                                                            } },   -- туториал на таймер

      [ "tutorial_page_7_scr" ] = { shown = 0, noskip = false, posx = 210, posy = 300, arrows = { 
                                                                              { pos_x = 500, pos_y = 230, ang =  -1.3 }
                                                                            } },   -- туториал на папку с видеороликами
    };

  end;

end;
--************************************************************************************************************************
function public.InventoryDisable()

  interface.WidgetSetVisible( InterfaceWidget_Inventory, false );
  interface.WidgetSetInput( InterfaceWidget_Inventory, false );    
  ObjStopAnimate( "int_inventory", "alp" );
  ObjSet( "int_inventory", { alp = 0 } );  

end;