-- name=rm_achievements
--******************************************************************************************
function public.Init ()

  private.LIST = --такой же список есть int_achievements
  { --2 ой элемент в этой матрице - назване спрайта
    { "not_skip_mg_1",        "fin_3_mg_withoutskip" }, --прохождение 3 мг без скипа 
    { "not_skip_mg_2",        "fin_5_mg_withoutskip" }, --прохождение 5 мг без скипа
    { "not_skip_mg_3",        "fin_10_mg_withoutskip" }, --прохождение 10 мг без скипа
    { "not_skip_mg_4",        "fin_all_mg_withoutskip" },  --прохождение всех мг без скипа

    { "not_skip_ho_1",        "fin_3_ho_withouthint" }, --прохождение 3 ХО без хинта
    { "not_skip_ho_2",        "fin_5_ho_withouthint" }, --прохождение 5 ХО без хинта
    { "not_skip_ho_3",        "fin_10_ho_withouthint" }, --прохождение 10 ХО без хинта
    { "not_skip_ho_4",        "fin_all_ho_withouthint" }, --прохождение всех ХО без хинта

    { "ho_three_1",           "fin_3ho_3minutes" }, --прохождение 3-х ХО подряд, меньше чем за 3 минуты каждое
    { "ho_three_2",           "fin_5ho_3minutes" }, --прохождение 5 ХО подряд, меньше чем за 3 минуты каждое
    { "ho_three_3",           "fin_10ho_3minutes" }, --прохождение 10 ХО подряд, меньше чем за 3 минуты каждое

    { "ho_three_obj_three",   "get3object_ho_3seconds" }, --подбор 3-х объектов ХО за 3 секунды
    { "ho_five_obj_five",     "get3object_ho_5seconds" }, --подбор 5 объектов ХО за 5 секунды
    { "ho_ten_obj_ten",       "get3object_ho_10seconds" }, --подбор 10 объектов ХО за 10 секунды

    { "ho_ten_min",           "fin_1ho_10minutes" }, --прохождение 1-го ХО больше чем за 10 минут

    { "ho_one_min",           "fin_1ho_1minute" }, --прохождение 1-го ХО меньше чем за 1 минуту

    { "mg_one_min",           "fin_1mg_1minutes" }, --Прохождение 1-ой МГ меньше чем за 1 минуту
    
    --нестандартные ачивки
    { "save_professor",       "save_professor" }, --спасение професора
    { "use_teleport",         "teleport" }, --использование телепорта
    { "superpuzzle_no_skip",  "superpuzzle_no_skip" }, --прохождение суперпазла без скипа 
    { "vid_no_skip",          "vid_no_skip" }, --просмотр видео без скипа
    { "dialog_no_skip",       "dialog_no_skip" }, --просмотр биалогов без скипа
    { "wrong_apply",          "wrong_apply" }, --неправильное применение
    { "cake",                 "cake" }, --скушать пироженку
  };

  local table_multiset = {};
  for i = 1, #private.LIST do

    table.insert( table_multiset, {"obj_achievements_"..private.LIST[ i ][ 2 ].."_pop_up", 
       {
         event_menter = function() private.PopupShow( private.LIST[ i ][ 2 ] ); end ,
         event_mleave = function() private.PopupHide() end
       } 
    } );

  end;  

  table.insert( table_multiset, { "obj_achievements_btn_close", { 
      event_mdown = private.BtnCloseMouseDown, 
      event_menter = function() private.BtnMouseEnter( CURSOR_DOWN, "anm_achievements_btn_close_focus" ) end, 
      event_mleave = function() private.BtnMouseLeave( "anm_achievements_btn_close_focus" ) end; } } );

  table.insert( table_multiset, { "obj_achievements_btn_exit", { 
      event_mdown = private.BtnCloseMouseDown, 
      event_menter = function() private.BtnMouseEnter( CURSOR_HAND, "spr_achievements_btn_exit_focus" ) end, 
      event_mleave = function() private.BtnMouseLeave( "spr_achievements_btn_exit_focus" ) end; } } );

  
  ObjMultiSet( table_multiset );
  
  private.InitAnim();
  
end;
--******************************************************************************************
function public.PreOpen ()
   
  for i = 1, #private.LIST do

    ObjSet( "spr_achievements_"..private.LIST[ i ][ 2 ], { input = false, alp = 0 } );
    ObjSet( "spr_achievements_"..private.LIST[ i ][ 2 ].."_screen", { input = false, alp = 0 } );

  end;
  ObjSet( "spr_achievements_fin_mg_withoutskip_screen", { alp = 0 } );

  local current_room = common.GetCurrentRoom();
  if ( current_room ) then

    common_impl.Lock( false );--разблокировка для карты EE
    interface.WidgetSetVisible( InterfaceWidget_Map, true ); 

  end;
  private.Update();
  common_impl.PlayAudio( "env", "aud_menu_env", 1, "", 0 );
  
end;
--******************************************************************************************
function public.Close ()

  local current_room = common.GetCurrentRoom();

  if ( current_room ) then

    cmn.ExitRmWithoutInterface();
    
  end;

end;
--******************************************************************************************
function private.Update ()

  for i = 1, #private.LIST do

    local event = private.LIST[ i ][ 1 ];

      if ( ng_global.achievements[ event ].done == 1 ) then

        if ( ng_global.achievements[ event ].show == 0 ) then

          ObjAnimate( "spr_achievements_"..private.LIST[ i ][ 2 ], "alp", 0, 0, function () ng_global.achievements[ event ].show = 1 end,
          { 
            0.0, 0, 0, 
            0.6, 0, 0,
            1.0, 0, 1,
          } );
          ObjAnimate( "spr_achievements_"..private.LIST[ i ][ 2 ].."_screen", "alp", 0, 0, "",
          { 
            0.0, 0, 0, 
            0.3, 0, 1,
            0.6, 0, 1,
            1.0, 0, 0,
          } );

        else 

          ObjSet( "spr_achievements_"..private.LIST[ i ][ 2 ], { alp = 1 } );

        end;        
      
    end;

  end;

end;
--******************************************************************************************
function private.BtnMouseEnter ( type_cursor, obj )
      
  if ( type_cursor ) then
    SetCursor( type_cursor );
  else
    SetCursor( CURSOR_DEFAULT );
  end;
    
  local alp = ObjGet( obj ).alp;
  local time = 0.3;
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,              0, alp, 
    time*( 1 - alp ), 0, 1
  } );

end;
--******************************************************************************************
function private.BtnMouseLeave ( obj )
    
  SetCursor( CURSOR_DEFAULT );

  local alp = ObjGet( obj ).alp;
  local time = 0.3;
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,        0, alp,
    time * alp, 0,   0 
  });

end;
--******************************************************************************************
function private.BtnCloseMouseDown ()

  local current_room = common.GetCurrentRoom();
  if ( not current_room ) then

    current_room = "rm_extra";

  end;  

  common.GotoRoom( current_room );

end;
--******************************************************************************************
--function *** POPUP *** () end;
--******************************************************************************************
function private.PopupShow ( number )

  SetCursor( CURSOR_LOUPE );

  local title = "pop_achievements_"..number;
  local description = "";
  for i = 1, #private.LIST do
    if ( private.LIST[ i ][ 2 ] == number ) then
      description = "str_achievements_description_"..private.LIST[ i ][ 1 ];
      break;
    end;
  end;

  private.WindowShow( title, description );  

end;
--------------------------------------------------------------------------------------------
function private.PopupHide () 

  private.WindowHide();  
  SetCursor( CURSOR_DEFAULT );

end;

--******************************************************************************************
--function *** ANIMATIONS *** () end;
--******************************************************************************************
function private.InitAnim ()
end;
--******************************************************************************************
--function *** DIALOG *** () end;
--******************************************************************************************
function private.WindowShow ( dialog_text_title, dialog_text )

  local game_cursor = GetZoomCursorPos();
  --dialog_pos_x = game_cursor[ 1 ];
  --dialog_pos_y = game_cursor[ 2 ];
    
  ObjSet( "txt_achievements_window_title", { text = dialog_text_title } );
  ObjSet( "txt_achievements_window", { text = dialog_text } );

  private.GRID_CORNER_W =  58;
  private.GRID_CORNER_H =  58;
  private.GRID_MID_W    =   4;
  private.GRID_MID_H    =   4;

  private.GRID_BORDER_W = 100;
  private.GRID_BORDER_H = 100;

  private.MIN_W = 370;
  private.MAX_W = 500;
  private.MIN_H = 150;
  private.MAX_H = 500;

  private.WindowShow_ANIM_TIME = 0.3;

  local off_x = private.GRID_BORDER_W;
  local off_y = private.GRID_BORDER_H;

  local dialog_w = ObjGet( "txt_achievements_window" ).draw_width + off_x;

  if ( dialog_w < private.MIN_W ) then

    dialog_w = private.MIN_W;

  elseif ( dialog_w > private.MAX_W ) then

    dialog_w = private.MAX_W;

  end;

  local dialog_h = ObjGet( "txt_achievements_window" ).draw_height + off_y;

  if ( dialog_h < private.MIN_H ) then

    dialog_h = private.MIN_H;

  elseif ( dialog_h > private.MAX_H ) then
  
    dialog_h = private.MAX_H;

  end;

  local offset = 50;
  local dialog_pos_x = game_cursor[ 1 ] - dialog_w/2 - 20;
  if ( dialog_pos_x < 171 ) then

    dialog_pos_x = game_cursor[ 1 ] + dialog_w/2 + 20;

  end;
  
  local dialog_pos_y = game_cursor[ 2 ] - dialog_h/2;
  if ( dialog_pos_y - dialog_h < 0 ) then

    dialog_pos_y = dialog_h / 2;

  end;

  local grid_corner_w = private.GRID_CORNER_W;
  local grid_corner_h = private.GRID_CORNER_H;

  local grid_mid_w = private.GRID_MID_W;
  local grid_mid_h = private.GRID_MID_H;

  interface.FrameGridSet( "achievements_window",
  {
    grid_w   = dialog_w,
    grid_h   = dialog_h,
    corner_w = grid_corner_w,
    corner_h = grid_corner_h,
    mid_w    = grid_mid_w,
    mid_h    = grid_mid_h
  } );

  ObjSet( "obj_achievements_window",
  {
    active = true, visible = true,
    pos_x = dialog_pos_x, pos_y = dialog_pos_y
  } );

  local event_id = "show";
  
  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = private.WindowShow_ANIM_TIME;

  ObjAnimate( "obj_achievements_window", "alp", 0, 0, trg,
  {
    0.0, 2, 0,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.WindowHide ()
  
  ObjSet( "obj_achievements_window", { input = false } );

  local event_id = "hide";  
  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = private.WindowShow_ANIM_TIME;

  ObjAnimate( "obj_achievements_window", "alp", 0, 0, trg,
  {
    0.0, 2, 1,
    tme, 2, 0
  } );

end;
--******************************************************************************************
function private.EventAnimEnd ( event_id )

------------------------------------------------------------------------------------
  if ( event_id == "show" ) then
  
  ObjSet( "obj_achievements_window", { active = true, visible = true } );

------------------------------------------------------------------------------------
  elseif ( event_id == "hide" ) then

  ObjSet( "obj_achievements_window", { active = false, visible = false } );

------------------------------------------------------------------------------------
  end;

end;
--******************************************************************************************






