-- name=rm_collectibles
--******************************************************************************************
function public.Init ()
-------------------------------------------------------------------------------------------- 
  private.ANIM_TIME = 0.2;
  private.current_item = nil;
  private.count_item = 3;
  private.count_level = 4;
  private.black_screen = 0.7;
--------------------------------------------------------------------------------------------
  local table_multiset = {};

  local table_multiset = {};
  for i = 1, private.count_level do

    for j = 1, private.count_item do

      table.insert( table_multiset, { "spr_collectibles_item_"..i.."_"..j, { 
        event_mdown = function() private.ClkItem( i.."_"..j ) end, 
        event_menter = function() private.PopupShow( "str_collectibles_name_"..i.."_"..j ); end, 
        event_mleave = function() private.PopupHide() end; } } );
    end;

  end;

  table.insert( table_multiset, { "obj_collectibles_big_item", { 
      event_mdown = private.ClkBigItem, 
      event_menter = function() SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() SetCursor( CURSOR_DEFAULT ) end; } } );

  table.insert( table_multiset, { "obj_collectibles_btn_close", { 
      event_mdown = private.BtnCloseMouseDown, 
      event_menter = function() private.BtnMouseEnter( CURSOR_DOWN, "anm_collectibles_btn_close_focus" ) end, 
      event_mleave = function() private.BtnMouseLeave( "anm_collectibles_btn_close_focus" ) end; } } );

  table.insert( table_multiset, { "obj_collectibles_btn_exit", { 
      event_mdown = private.BtnCloseMouseDown, 
      event_menter = function() private.BtnMouseEnter( CURSOR_HAND, "spr_collectibles_btn_exit_focus" ) end, 
      event_mleave = function() private.BtnMouseLeave( "spr_collectibles_btn_exit_focus" ) end; } } );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

end;
--******************************************************************************************
function public.PreOpen ()

  local current_room = common.GetCurrentRoom();
  if ( current_room ) then

    common_impl.Lock( false );--разблокировка для карты EE
    interface.WidgetSetVisible( InterfaceWidget_Map, true ); 

  end;

  local table_multiset = {};
  for i = 1, private.count_level do

    local prg = "std";
    if ( i == private.count_level ) then
      prg = "ext";
    end;
    for j = 1, private.count_item do
    
      local event = "get_collect_item_"..i.."_"..j;
      if ( ng_global.progress[ prg ][ event ] and ng_global.progress[ prg ][ event ].done == 0 )
         or ( not ng_global.progress[ prg ][ event ] ) then

        table.insert( table_multiset, { "obj_collectibles_item_"..i.."_"..j, { input = false, alp = 0 } } );

      else

        table.insert( table_multiset, { "obj_collectibles_item_"..i.."_"..j, { input = true, alp = 1 } } );

      end;

    end;

  end;
  
  if( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset ); 
  end;

end;
--******************************************************************************************
function public.Open ()

end;
--******************************************************************************************
function public.Close ()
  
  if ( private.current_item ) then

    ObjSet( "obj_collectibles_big_item", { scale_x = 0, scale_y = 0, visible = false, input = false } );
    ObjSet( "obj_collectibles_item_"..private.current_item, { alp = 1 } );
    ObjSet( "spr_collectibles_black_back", { alp = 0 } );
    private.current_item = nil;

  end;

  local current_room = common.GetCurrentRoom();

  if ( current_room ) then

    cmn.ExitRmWithoutInterface();
    
  end;

end;
--******************************************************************************************
function private.ClkItem ( number )

  local table_multiset = {};

  local func_end = function()

    ObjSet( "rm_collectibles", { input = true } );
    --common_impl.ShowBbt( "bbt_collectibles_item_" );

  end;

  private.current_item = number;

  ObjSet( "rm_collectibles", { input = false } );

  ObjAnimate( "obj_collectibles_item_"..number, "alp", 0, 0, "", 
    { 
                      0, 3, 1, 
      private.ANIM_TIME, 3, 0 
    } );

  table.insert( table_multiset, { "obj_collectibles_big_item", { visible = true, input = true } });
  ObjSet( "spr_collectibles_big_item", { res = ObjGet( "spr_collectibles_item_"..number ).res.."_big" } );-- через multiset draw_height старого ресурса
  --table.insert( table_multiset, { "spr_collectibles_big_item", { drawoff_y = - ObjGet( "spr_collectibles_big_item" ).draw_height / 2 } });

  table.insert( table_multiset, { "txt_collectibles_plate_name", { text = "str_collectibles_name_"..number } });

  ObjAnimate( "obj_collectibles_big_item", "scale_xy", 0, 0, "", 
  { 
                    0, 3, ObjGet( "obj_collectibles_big_item" ).scale_x, ObjGet( "obj_collectibles_big_item" ).scale_y, 
    private.ANIM_TIME, 3, 1, 1

  } );  
  local pos_item = { ObjGet( "spr_collectibles_item_"..number ).pos_x, ObjGet( "spr_collectibles_item_"..number ).pos_y };
  ObjAnimate( "obj_collectibles_big_item", "pos_xy", 0, 0, "", 
  { 
                    0, 3, pos_item[ 1 ], pos_item[ 2 ], 
    private.ANIM_TIME, 3, 512, 384

  } );
  ObjAnimate( "spr_collectibles_black_back", "alp", 0, 0, func_end, 
  { 
                    0, 3, 0, 
    private.ANIM_TIME, 3, private.black_screen

  } );
  ObjMultiSet( table_multiset );

  private.PopupHide();

end;
--******************************************************************************************
function private.ClkBigItem ( )

  local func_end = function()

    ObjSet( "rm_collectibles", { input = true } );
    ObjSet( "obj_collectibles_big_item", { visible = false, input = false } );
    private.current_item = nil;

  end;  

  local number = private.current_item;
  ObjSet( "rm_collectibles", { input = false } );

  ObjAnimate( "obj_collectibles_item_"..private.current_item, "alp", 0, 0, "", 
  { 
                    0, 3, 0, 
    private.ANIM_TIME, 3, 1 

  } );
  ObjAnimate( "obj_collectibles_big_item", "scale_xy", 0, 0, "", 
  { 
                    0, 3, ObjGet( "obj_collectibles_big_item" ).scale_x, ObjGet( "obj_collectibles_big_item" ).scale_y, 
    private.ANIM_TIME, 3, 0, 0

  } );  
  local pos_item = { ObjGet( "spr_collectibles_item_"..number ).pos_x, ObjGet( "spr_collectibles_item_"..number ).pos_y };
  ObjAnimate( "obj_collectibles_big_item", "pos_xy", 0, 0, "", 
  { 
                    0, 3, ObjGet( "obj_collectibles_big_item" ).pos_x, ObjGet( "obj_collectibles_big_item" ).pos_y, 
    private.ANIM_TIME, 3, pos_item[ 1 ], pos_item[ 2 ]

  } );
  ObjAnimate( "spr_collectibles_black_back", "alp", 0, 0, func_end,
  { 
                    0, 3, ObjGet( "spr_collectibles_black_back" ).alp,
    private.ANIM_TIME, 3, 0.0

  } );

end;
--******************************************************************************************
function private.BtnMouseEnter( type_cursor, obj )
      
  if ( type_cursor ) then
    SetCursor( type_cursor );
  else
    SetCursor( CURSOR_DEFAULT );
  end;
    
  local alp = ObjGet( obj ).alp;
  local time = 0.3;
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,              0, alp, 
    time*( 1 - alp ), 0, 1
  } );

end;
--******************************************************************************************
function private.BtnMouseLeave( obj )
    
  SetCursor( CURSOR_DEFAULT );

  local alp = ObjGet( obj ).alp;
  local time = 0.3;
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,        0, alp,
    time * alp, 0,   0 
  });

end;
--******************************************************************************************
function private.BtnCloseMouseDown( )

  local current_room = common.GetCurrentRoom();
  if ( not current_room ) then

    current_room = "rm_extra";

  end;  

  common.GotoRoom( current_room );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--******************************************************************************************
--function *** POPUP *** () end;
--******************************************************************************************
function private.PopupShow ( name )

  SetCursor( CURSOR_LOUPE );  
  local game_cursor = GetZoomCursorPos();
  dialog_pos_x = game_cursor[ 1 ];
  dialog_pos_y = game_cursor[ 2 ];
    

  ObjSet( "txt_collect_window_title", { text = name } );

  private.GRID_CORNER_W =  58;
  private.GRID_CORNER_H =  58;
  private.GRID_MID_W    =   4;
  private.GRID_MID_H    =   4;

  private.GRID_BORDER_W = 100;
  private.GRID_BORDER_H = 100;

  private.MIN_W = 200;
  private.MAX_W = 300;
  private.MIN_H = 70;
  private.MAX_H = 100;

  private.WindowShow_ANIM_TIME = 0.3;

  local off_x = private.GRID_BORDER_W;
  local off_y = private.GRID_BORDER_H;

  local dialog_w = ObjGet( "txt_collect_window_title" ).draw_width + off_x;

  if ( dialog_w < private.MIN_W ) then

    dialog_w = private.MIN_W;

  elseif ( dialog_w > private.MAX_W ) then

    dialog_w = private.MAX_W;

  end;

  local dialog_h = ObjGet( "txt_collect_window_title" ).draw_height + off_y;

  if ( dialog_h < private.MIN_H ) then

    dialog_h = private.MIN_H;

  elseif ( dialog_h > private.MAX_H ) then
  
    dialog_h = private.MAX_H;

  end;

  local offset = 50;
  if ( dialog_pos_x < 0 ) then

    dialog_pos_x = 0 ;
  
  elseif ( dialog_pos_x > GetAppWidth() ) then

    dialog_pos_x = GetAppWidth();

  end;
  
  dialog_pos_y = dialog_pos_y - dialog_h/2;
  if ( dialog_pos_y - dialog_h < 0 ) then

    dialog_pos_y = dialog_h / 2;

  end;

  local grid_corner_w = private.GRID_CORNER_W;
  local grid_corner_h = private.GRID_CORNER_H;

  local grid_mid_w = private.GRID_MID_W;
  local grid_mid_h = private.GRID_MID_H;

  interface.FrameGridSet( "collectibles_window",
  {
    grid_w   = dialog_w,
    grid_h   = dialog_h,
    corner_w = grid_corner_w,
    corner_h = grid_corner_h,
    mid_w    = grid_mid_w,
    mid_h    = grid_mid_h
  } );

  ObjSet( "obj_collectibles_window",
  {
    active = true, visible = true,
    pos_x = dialog_pos_x, pos_y = dialog_pos_y
  } );

  local event_id = "show";
  
  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = private.WindowShow_ANIM_TIME;

  ObjAnimate( "obj_collectibles_window", "alp", 0, 0, trg,
  {
    0.0, 2, 0,
    tme, 2, 1
  } );

end;
--------------------------------------------------------------------------------------------
function private.PopupHide () 

  SetCursor( CURSOR_DEFAULT );
  
  ObjSet( "obj_collectibles_window", { input = false } );

  local event_id = "hide";  
  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = private.WindowShow_ANIM_TIME;

  ObjAnimate( "obj_collectibles_window", "alp", 0, 0, trg,
  {
    0.0, 2, 1,
    tme, 2, 0
  } );

end;
--------------------------------------------------------------------------------------------
function private.EventAnimEnd ( event_id )

------------------------------------------------------------------------------------
  if ( event_id == "show" ) then
  
  ObjSet( "obj_collectibles_window", { active = true, visible = true } );

------------------------------------------------------------------------------------
  elseif ( event_id == "hide" ) then

  ObjSet( "obj_collectibles_window", { active = false, visible = false } );

------------------------------------------------------------------------------------
  end;

end;
--******************************************************************************************
