-- name=rm_collectibles2
--******************************************************************************************
function public.Init ()
-------------------------------------------------------------------------------------------- 
  private.ANIM_TIME = 0.2;
  private.current_item = nil;
  private.count_item = 5;
  private.count_level = 4;
  private.black_screen = 0.7;
--------------------------------------------------------------------------------------------
  local table_multiset = {};

  local table_multiset = {};
  for i = 1, private.count_level do

    table.insert( table_multiset, { "obj_collectibles2_frame_"..i.."_clk", { 
      event_mdown = function() private.ClkItem( i ) end, 
      event_menter = function() SetCursor( CURSOR_LOUPE ) end, 
      event_mleave = function() SetCursor( CURSOR_DEFAULT ) end; } } );

  end;

  table.insert( table_multiset, { "obj_collectibles2_frame_big", { 
      event_mdown = private.ClkBigItem, 
      event_menter = function() SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() SetCursor( CURSOR_DEFAULT ) end; } } );

  table.insert( table_multiset, { "obj_collectibles2_btn_exit", { 
      event_mdown = private.BtnCloseMouseDown, 
      event_menter = function() private.BtnMouseEnter( CURSOR_HAND, "spr_collectibles2_btn_exit_focus" ) end, 
      event_mleave = function() private.BtnMouseLeave( "spr_collectibles2_btn_exit_focus" ) end; } } );

  if ( #table_multiset > 0 ) then

    ObjMultiSet( table_multiset );

  end;

end;
--******************************************************************************************
function public.PreOpen ()

  local current_room = common.GetCurrentRoom();
  if ( current_room ) then

    common_impl.Lock( false );--разблокировка для карты EE
    interface.WidgetSetVisible( InterfaceWidget_Map, true ); 

  end;

  local table_multiset = {};
  for i = 1, private.count_level do

    local prg = "std";

    if ( i == private.count_level ) then

      prg = "ext";

    end;

    for j = 1, private.count_item do
    
      local event = "get_collect2_item_"..i.."_"..j;
    
      if ( ( ng_global.collectibles2[ event ] and ng_global.collectibles2[ event ].done == false )

         or ( not ng_global.collectibles2[ event ] ) ) then

        --table.insert( table_multiset, { "spr_collectibles2_frame"..i.."_layer"..j, { alp = 0 } } );
        --table.insert( table_multiset, { "spr_collectibles2_frame"..i.."_part"..j, { alp = 0 } } );
        ObjMultiSet( {
          { "spr_collectibles2_frame"..i.."_layer"..j, { alp = 0 } },
          { "spr_collectibles2_frame"..i.."_part"..j, { alp = 0 } },
        } );

      else 

        ObjMultiSet( {
          { "spr_collectibles2_frame"..i.."_layer"..j, { alp = 1 } },
          { "spr_collectibles2_frame"..i.."_part"..j, { alp = 1 } },
        } );

      end;

    end;

  end;
  
--  if( #table_multiset > 0 ) then
--
--
--    ObjMultiSet( table_multiset ); 
--
--  end;

end;
--******************************************************************************************
function public.Open ()

end;
--******************************************************************************************
function public.Close ()
  
  if ( private.current_item ) then

    ObjMultiSet( {
      { "obj_collectibles2_frame_big", { scale_x = 0, scale_y = 0, visible = false, input = false } },
      { "obj_collectibles2_frame_"..private.current_item, { alp = 1 } },
      { "spr_collectibles2_black_back", { alp = 0 } },
    } );
    private.current_item = nil;

  end;

  local current_room = common.GetCurrentRoom();

  if ( current_room ) then

    cmn.ExitRmWithoutInterface();
    
  end;

end;
--******************************************************************************************
function private.ClkItem ( number )

  local table_multiset = {};

  local func_end = function()

    ObjSet( "rm_collectibles2", { input = true } );
    --common_impl.ShowBbt( "bbt_collectibles_item_" );

  end;

  private.current_item = number;

  for i = 1, private.count_level do

    ObjSet( "obj_collectibles2_frame_"..i.."_big", { alp = 0 } );

  end;

  table.insert( table_multiset, { "obj_collectibles2_frame_big", { visible = true, input = true } } );
  table.insert( table_multiset, { "obj_collectibles2_frame_"..number.."_big", { alp = 1 } } );

  if( #table_multiset > 0 ) then

    ObjMultiSet( table_multiset ); 

  end;

  ObjSet( "rm_collectibles2", { input = false } );

  ObjAnimate( "obj_collectibles2_frame_"..number, "alp", 0, 0, "", 
  { 
                    0, 3, 1, 
    private.ANIM_TIME, 3, 0 
  } );

  ObjAnimate( "obj_collectibles2_frame_big", "scale_xy", 0, 0, "", 
  { 
                    0, 3, ObjGet( "obj_collectibles2_frame_big" ).scale_x, ObjGet( "obj_collectibles2_frame_big" ).scale_y, 
    private.ANIM_TIME, 3, 1, 1

  } );  
  local pos_item = { ObjGet( "obj_collectibles2_frame_"..number ).pos_x, ObjGet( "obj_collectibles2_frame_"..number ).pos_y };
  ObjAnimate( "obj_collectibles2_frame_big", "pos_xy", 0, 0, func_end, 
  { 
                    0, 3, pos_item[ 1 ], pos_item[ 2 ], 
    private.ANIM_TIME, 3, 512, 384

  } );
  ObjAnimate( "spr_collectibles2_black_back", "alp", 0, 0, "", 
  { 
                    0, 3, 0, 
    private.ANIM_TIME, 3, private.black_screen

  } );

end;
--******************************************************************************************
function private.ClkBigItem ( )

  local func_end = function()

    ObjSet( "rm_collectibles", { input = true } );
    ObjSet( "obj_collectibles2_frame_big", { visible = false, input = false } );
    private.current_item = nil;

    for i = 1, private.count_level do

      ObjSet( "obj_collectibles2_frame_"..i.."_big", { alp = 0 } );

    end;

  end;  

  local number = private.current_item;
  ObjSet( "rm_collectibles", { input = false } );

  ObjAnimate( "obj_collectibles2_frame_"..private.current_item, "alp", 0, 0, "", 
  { 
                    0, 3, 0, 
    private.ANIM_TIME, 3, 1 

  } );
  ObjAnimate( "obj_collectibles2_frame_big", "scale_xy", 0, 0, "", 
    { 
                      0, 3, ObjGet( "obj_collectibles2_frame_big" ).scale_x, ObjGet( "obj_collectibles2_frame_big" ).scale_y, 
      private.ANIM_TIME, 3, 0, 0

    } );  
  local pos_item = { ObjGet( "obj_collectibles2_frame_"..number ).pos_x, ObjGet( "obj_collectibles2_frame_"..number ).pos_y };
  ObjAnimate( "obj_collectibles2_frame_big", "pos_xy", 0, 0, "", 
  { 
                    0, 3, ObjGet( "obj_collectibles2_frame_big" ).pos_x, ObjGet( "obj_collectibles2_frame_big" ).pos_y, 
    private.ANIM_TIME, 3, pos_item[ 1 ], pos_item[ 2 ]

  } );
  ObjAnimate( "spr_collectibles2_black_back", "alp", 0, 0, "",
  { 
                    0, 3, ObjGet( "spr_collectibles2_black_back" ).alp,
    private.ANIM_TIME, 3, 0.0

  } );
--  ObjAnimate( "txt_collectibles_plate_name", "alp", 0, 0, func_end, 
--  { 
--                    0, 3, 1, 
--    private.ANIM_TIME, 3, 0 
--
--  } );

end;
--******************************************************************************************
function private.BtnMouseEnter( type_cursor, obj )
      
  if ( type_cursor ) then
    SetCursor( type_cursor );
  else
    SetCursor( CURSOR_DEFAULT );
  end;
    
  local alp = ObjGet( obj ).alp;
  local time = 0.3;
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,              0, alp, 
    time*( 1 - alp ), 0, 1
  } );

end;
--******************************************************************************************
function private.BtnMouseLeave( obj )
    
  SetCursor( CURSOR_DEFAULT );

  local alp = ObjGet( obj ).alp;
  local time = 0.3;
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,        0, alp,
    time * alp, 0,   0 
  });

end;
--******************************************************************************************
function private.BtnCloseMouseDown( )

  local current_room = common.GetCurrentRoom();
  if ( not current_room ) then

    current_room = "rm_extra";

  end;  

  common.GotoRoom( current_room );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------