-- name=rm_credits
--******************************************************************************************
function public.Init()

  SetCursor(CURSOR_DEFAULT);

  ObjSet("obj_credits_btn_quit", {
    event_mdown = function () private.QuitClk(); end,
    event_menter = function () private.ButtonMouseEnter(); end,
    event_mleave = function () private.ButtonMouseLeave(); end
  }); 

  private.namePlayEnv = { { "aud_menu_env",             63 }, 
                          { "aud_masked_man_theme_mus", 27 }, 
                          { "aud_lyric_theme_mus",      89 } 
                        }

end;
--******************************************************************************************
function private.CreditsPlayEnv( i )

  common_impl.StopAllMus();

  if i == 4 then i = 1 end; 
   
  common_impl.EnvPlay( { private.namePlayEnv[i][1] }, "", 0.5 );
  ObjSet( "tmr_credits_musenv", { playing = true, time = private.namePlayEnv[i][2], endtrig = function() private.CreditsPlayEnv( i + 1 ) end } );

end;
--******************************************************************************************
function public.PreOpen()

  if common.IsInSubRoom() then

    ObjSet( "subroom", { input = false } );

  end;

  local current_room = common.GetCurrentRoom();

  if ( current_room ) then

    local mas_widgets = {

      InterfaceWidget_BtnMenu
      ,InterfaceWidget_BtnHint
      ,InterfaceWidget_BtnSkip
      ,InterfaceWidget_BtnInfo
      ,InterfaceWidget_BtnReset
      ,InterfaceWidget_Inventory
      ,InterfaceWidget_TaskPanel
      ,InterfaceWidget_BtnMap
      ,InterfaceWidget_DialogHo
      ,InterfaceWidget_ItemPanel 
      ,InterfaceWidget_Popup
      ,InterfaceWidget_Window
      ,InterfaceWidget_Map
      ,InterfaceWidget_Deploy_Inv
      ,InterfaceWidget_Dialog_Hint

    };

    if IsCollectorsEdition() then

      table.insert( mas_widgets, InterfaceWidget_BtnGuide );
      table.insert( mas_widgets, InterfaceWidget_collectibles2 );
      table.insert( mas_widgets, InterfaceWidget_collectibles );
      table.insert( mas_widgets, InterfaceWidget_achievements );
      table.insert( mas_widgets, InterfaceWidget_morph );

    end;

    local prg = ng_global.currentprogress;

    if ng_global.progress[ prg ].common.chapter == "levelext" then

      table.insert( mas_widgets, InterfaceWidget_Slider );

    end;

    for i = 1, #mas_widgets do

      interface.WidgetSetVisible( mas_widgets[i], false, true );   
      interface.WidgetSetInput( mas_widgets[i], false );    

    end;

    if string.find( common.GetCurrentRoom(), "ho_" ) then
      ObjSet( "obj_int_inventory_impl_root", { visible = false, input = false } );
    end;

  end;

  ObjSet( "spr_credits_logo_ce", { visible = IsCollectorsEdition() } );

  ObjSet( "obj_credits_btn_quit", { alp = 0, input = 0 } );

  cmn.StopMusEnv();

  private.CreditsPlayEnv( 1 );

  local prg  = ng_global.currentprogress;
  if prg == "std" then 

    -- ! Вставить последнее событие прогресса
    if ( ng_global.progress[ "std" ][ "see_outro_3" ] and 
       ng_global.progress[ "std" ][ "see_outro_3" ].done == 1 ) then
        
      if IsCollectorsEdition() then

        ng_global.progress[ "std" ].common.gamewin   = true; 
        ng_global.progress[ "std" ].common.gamestart = false;

      end;

    end;

    SaveProfiles();
    SaveSettings();

  elseif prg == "ext" then

    -- ! Вставить последнее событие прогресса
    if ( ng_global.progress[ "ext" ][ "see_outro_ext" ] and
       ng_global.progress[ "ext" ][ "see_outro_ext" ].done == 1 ) then
        
      ng_global.progress[ "ext" ].common.gamewin   = true; 
      ng_global.progress[ "ext" ].common.gamestart = false;
      
    end;

    SaveProfiles();
    SaveSettings();

  end;

end;
--******************************************************************************************
function public.Open()

  private.current_room = common.GetCurrentRoom();

  private.screen_current = 1;

  private.Screen();

  local func_end = function ()

    ObjSet( "obj_credits_btn_quit", { alp = 1, input = 1 } );

  end;

  ObjAnimate("obj_credits_btn_quit", "alp", 0, 0, func_end, { 
    0,  0,  0, 
    4,  0,  0, 
    5,  0,  1 
  });

  common_impl.StopAllMus();
  --common_impl.PlayAudio( "mus", "common/audio/mus/aud_credits_mus", 1 );

end;
--******************************************************************************************
function public.Close()

  local current_room = common.GetCurrentRoom();

  if ( current_room ) then

    local mas_widgets = {

      InterfaceWidget_BtnMenu
      ,InterfaceWidget_BtnHint
      ,InterfaceWidget_BtnSkip
      ,InterfaceWidget_BtnInfo
      ,InterfaceWidget_BtnReset
      ,InterfaceWidget_Inventory
      ,InterfaceWidget_TaskPanel
      ,InterfaceWidget_BtnMap
      ,InterfaceWidget_DialogHo
      ,InterfaceWidget_ItemPanel 
      ,InterfaceWidget_Popup
      ,InterfaceWidget_Window
      ,InterfaceWidget_Map
      ,InterfaceWidget_Deploy_Inv
      ,InterfaceWidget_Dialog_Hint

    };

    if IsCollectorsEdition() then

      table.insert( mas_widgets, InterfaceWidget_BtnGuide );
      table.insert( mas_widgets, InterfaceWidget_collectibles2 );
      table.insert( mas_widgets, InterfaceWidget_collectibles );
      table.insert( mas_widgets, InterfaceWidget_achievements );
      table.insert( mas_widgets, InterfaceWidget_morph );

    end;

    local prg = ng_global.currentprogress;

    if ng_global.progress[ prg ].common.chapter == "levelext" then

      table.insert( mas_widgets, InterfaceWidget_Slider );

    end;

    for i = 1, #mas_widgets do

      interface.WidgetSetVisible( mas_widgets[i], true, true );   
      interface.WidgetSetInput( mas_widgets[i], true );    

    end;

    if string.find( common.GetCurrentRoom(), "ho_" ) then
      ObjSet( "obj_int_inventory_impl_root", { visible = true, input = true } );
    end;

  end;

  if common.IsInSubRoom() then

    ObjSet( "subroom", { input = true } );

  end;

  ObjStopAnimate( "obj_credits_screens", "pos_y" );
  ObjSet( "obj_credits_screens", { pos_y = 760 } );

end;
--******************************************************************************************
function public.PreClose()

  cmn.StopMusEnv();

end;
--******************************************************************************************
function private.Screen ()

  ObjSet( "rm_credits", { input = 1 } );

  local line_time = 1.7;
  local time = 0;

  local func_anim = function ()

    local func_exit = function ()

      private.Exit();
    
    end;

    ObjAnimate( "rm_credits", "alp", 0, 0, func_exit, { 0,0,1, 2,0,0 });

  end;

  ObjAnimate( "obj_credits_screens", "pos_y", 0, 0, func_anim, { 0, 0, 760,   200, 0, -3240 } )

end;
--******************************************************************************************
function private.ButtonMouseEnter ()

  local tme = 0.3;
  local obj = "spr_credits_btn_quit_focus";
  local alp = ObjGet( obj ).alp;
  SetCursor( CURSOR_HAND );

  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,               0,    alp, 
    tme *( 1 - alp ),  0,    1
  } );

  common_impl.PlayAudio( "sfx", "aud_guidance" );

end;
--******************************************************************************************
function private.ButtonMouseLeave ()

  local tme = 0.3;
  local obj = "spr_credits_btn_quit_focus";
  local alp = ObjGet( obj ).alp;
  SetCursor( CURSOR_DEFAULT );

  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,                      0, alp, 
    tme * alp, 0,    0
  } );

end;
--******************************************************************************************
function private.QuitClk ()

  ObjSet( "rm_credits", { input = 0 } );

  local func_end = function ()

    private.Exit();

  end;

  ObjAnimate("obj_credits_btn_quit", "alp", 0, 0, func_end, { 
    0,    0,  1, 
    0.5,  0,  1, 
    0.8,  0,  0 
  });

  common_impl.PlayAudio( "sfx", "aud_click_menu" );

end;
--******************************************************************************************
function private.Exit ()

  local prg  = ng_global.currentprogress;  
  local flag = true;

  if prg == "std" then 

    -- ! Вставить последнее событие прогресса
    if ( ng_global.progress[ "std" ][ "see_outro_3" ] and 
       ng_global.progress[ "std" ][ "see_outro_3" ].done == 1 ) then
        
        private.Skip();
        flag = false;

    end;

  elseif prg == "ext" then

    -- ! Вставить последнее событие прогресса
    if ( ng_global.progress[ "ext" ][ "see_outro_ext" ] and
       ng_global.progress[ "ext" ][ "see_outro_ext" ].done == 1 ) then
        
      private.SkipExt();
      flag = false;
      
    end;

  end;

  common_impl.StopAllMus();

  if ( not private.current_room ) then

    private.current_room = "rm_menu";

  end;

  if ( flag ) then

    common.GotoRoom( private.current_room );

    if private.current_room ~= "rm_menu" then

      cmn.PlayMusEnv();

    end;

  end;

end;
--******************************************************************************************
function private.Skip ()

  if IsCollectorsEdition() then

    ng_global.progress[ "std" ].common.gamewin   = true; 
    ng_global.progress[ "std" ].common.gamestart = false;

  end;

  SaveProfiles();
  SaveSettings();

  SetCursor( CURSOR_DEFAULT );  

  common.LevelSwitch( "menu", "game" );

end;
--******************************************************************************************
function private.SkipExt ()

  ng_global.progress[ "ext" ].common.gamewin   = true; 
  ng_global.progress[ "ext" ].common.gamestart = false;

  SaveProfiles();
  SaveSettings();

  SetCursor( CURSOR_DEFAULT );  

  common.LevelSwitch( "menu", "game" );

end;