-- name=rm_extra
--******************************************************************************************
function public.Init()

  ObjSet( "btn_extra_wallpapers", 
    {
      event_mdown =  function () private.ShowScreen( "wallpapers" ); end,
      event_menter = function () private.ButtonMouseEnter( "wallpapers" ); end,
      event_mleave = function () private.ButtonMouseLeave( "wallpapers" ); end
    } 
  );

  ObjSet( "btn_extra_conceptart", 
    {
      event_mdown =  function () private.ShowScreen( "conceptart" ); end,
      event_menter = function () private.ButtonMouseEnter( "conceptart" ); end,
      event_mleave = function () private.ButtonMouseLeave( "conceptart" ); end
    } 
  );

  ObjSet( "btn_extra_music", 
    {
      event_mdown =  function () private.ShowScreen( "music" ); end,
      event_menter = function () private.ButtonMouseEnter( "music" ); end,
      event_mleave = function () private.ButtonMouseLeave( "music" ); end
    } 
  );

  ObjSet( "btn_extra_bonus_chapter", 
    {
      event_mdown =  function () private.ShowScreen( "bonus_chapter" ); end,
      event_menter = function () private.ButtonMouseEnter( "bonus_chapter" ); end,
      event_mleave = function () private.ButtonMouseLeave( "bonus_chapter" ); end
    } 
  );
  
  ObjSet( "btn_extra_mainmenu", 
    {
      event_mdown =  function () common.GotoRoom( "rm_menu" ); end,
      event_menter = function () private.ButtonMouseEnter( "mainmenu" ); end,
      event_mleave = function () private.ButtonMouseLeave( "mainmenu" ); end
    } 
  );
  
  ObjSet( "btn_extra_achievements", 
    {
      event_mdown =  function () common.GotoRoom( "rm_achievements" ); end,
      event_menter = function () private.ButtonMouseEnter( "achievements" ); end,
      event_mleave = function () private.ButtonMouseLeave( "achievements" ); end
    } 
  );
  
  ObjSet( "btn_extra_collectibles", 
    {
      event_mdown =  function () common.GotoRoom( "rm_collectibles" ); end,
      event_menter = function () private.ButtonMouseEnter( "collectibles" ); end,
      event_mleave = function () private.ButtonMouseLeave( "collectibles" ); end
    } 
  );
  ObjSet( "btn_extra_collectibles_2", 
    {
      event_mdown =  function () common.GotoRoom( "rm_collectibles2" ); end,
      event_menter = function () private.ButtonMouseEnter( "collectibles_2" ); end,
      event_mleave = function () private.ButtonMouseLeave( "collectibles_2" ); end
    } 
  );
  ObjSet( "btn_extra_change_lft", 
    {
      event_mdown =  function () private.ArrowClick( true ) end,
      event_menter = function () private.ButtonMouseEnter( "change_lft" ); end,
      event_mleave = function () private.ButtonMouseLeave( "change_lft" ); end
    } 
  );
  ObjSet( "btn_extra_change_rgt", 
    {
      event_mdown =  function () private.ArrowClick( false ) end,
      event_menter = function () private.ButtonMouseEnter( "change_rgt" ); end,
      event_mleave = function () private.ButtonMouseLeave( "change_rgt" ); end
    } 
  );

  ObjSet( "btn_extra_play", 
    {
      event_mdown =  function () private.ButtonSetClick() end,
      event_menter = function () private.ButtonMouseEnter( "play" ); end,
      event_mleave = function () private.ButtonMouseLeave( "play" ); end
    } 
  );


  ObjSet( "btn_extra_secretroom", 
    {
      --event_mdown =  function () private.ShowScreen( "secretroom" ) end, 
      event_mdown =  function () private.SecretRoomPlay() end,
      event_menter = function () private.ButtonMouseEnter( "secretroom" ) end,
      event_mleave = function () private.ButtonMouseLeave( "secretroom" ) end
    } 
  );

  local set_table = {};

  for i = 1,4 do

    table.insert( set_table, { "btn_extra_music_"..i, 
      {
        event_mdown = function() private.BtnMusicPlay( i ); end ,
        event_menter = function () private.ButtonMouseEnter( "music_"..i ); end,
        event_mleave = function () private.ButtonMouseLeave( "music_"..i ); end
      } 
    } );

  end;

  ObjMultiSet( set_table );

  private.current_screen = "wallpapers";
  private.wallpapers = {};
  private.wallpapers.current_number = 1;
  private.wallpapers.MAX_COUNT = 7;
  private.conceptart = {};
  private.conceptart.current_number = 1;
  private.conceptart.MAX_COUNT = 11;
  private.music = {};
  private.music.current_number = 1;
  private.music.MAX_COUNT = 4;
  private.music.vid_number = 1;
  private.music.is_playing = "";
  private.StartAnims();
  ObjSet( "txt_extra_play", { text = "str_extra_set_count", param0 = 1, param1 = private.wallpapers.MAX_COUNT } );
  
  -- сохранить музыку
  common.dialog.common.buttons.savemusic = { left = { text = "ok", func = "save" }, center = nil, right = { text = "no", func = "Close" } };
  -- сохранить арт
  common.dialog.common.buttons.saveart = { left = { text = "ok", func = "save" }, center = nil, right = { text = "no", func = "Close" } };
  -- установить обои
  common.dialog.common.buttons.setwallpaper = { left = { text = "ok", func = "set" }, center = nil, right = { text = "no", func = "Close" } };
  -- не полная версия
  common.dialog.common.buttons[ "notfull" ] = { left = nil, center = { text = "ok", func = "Close" }, right = nil };

end;
--******************************************************************************************
function public.PreOpen()
 
end;
--******************************************************************************************
function public.Open()

  --private.music.is_playing

  common_impl.EnvPlay( { "rm_extra_track/aud_extra_env" }, "", 0.5 );

end;
--******************************************************************************************
function public.Close()

  if private.music.is_playing ~= "" then

    common_impl.StopAudio( "mus",  "rm_extra_track/"..private.music.is_playing, 0.2 )
    ObjSet( "spr_extra_stop_"..private.music.is_playing , { alp = 0 } );
    ObjSet( "spr_extra_play_"..private.music.is_playing , { alp = 1 } );
    private.music.is_playing = "";

  end;

end;
--******************************************************************************************
function private.ShowScreen ( new_screen )
  
  if ( private.current_screen == new_screen ) then
    return;
  end;

  if new_screen == "music" then
    ObjSet( "btn_extra_play",{ input = false, active = false, alp = 0, visible = false });
  else
    ObjSet( "btn_extra_play",{ input = true, active = true, alp = 1, visible = true });
  end;
  
  local func_end = function ()

    private.current_screen = new_screen;
    common_impl.Lock( false );

  end;

  local func_after = function ()
    ObjMultiSet( {
      { "btn_extra_change_lft", { input = true } },
      { "btn_extra_change_rgt", { input = true } },
    } );
    -----------------------------------
    local new_alp, active = 0, false;
    
    if ( new_screen == "music" ) then

      new_alp, active = 1, true;

    end;    
    -----------------------------------
    
    local text_new = "str_extra_play";
    local res = "assets/levels/menu/rm_extra/layers/noise";
    if ( new_screen == "music" ) then
      text_new = "str_extra_save";
      res = "assets/levels/menu/rm_extra/layers/"..new_screen.."/mini/"..private[new_screen].current_number;
    elseif ( new_screen == "wallpapers" ) then

      ObjSet( "txt_extra_play", { param0 = private[ new_screen ].current_number, param1 = private[ new_screen ].MAX_COUNT } );

      text_new = "str_extra_set_count";
      res = "assets/levels/menu/rm_extra/layers/"..new_screen.."/mini/"..private[new_screen].current_number;

    elseif ( new_screen == "conceptart" ) then

      ObjSet( "txt_extra_play", { param0 = private[ new_screen ].current_number, param1 = private[ new_screen ].MAX_COUNT } );

      text_new = "str_extra_save_count";
      res = "assets/levels/menu/rm_extra/layers/"..new_screen.."/mini/"..private[new_screen].current_number;

    elseif ( new_screen == "bonus_chapter" ) then

      ObjMultiSet( {
        { "btn_extra_change_lft", { input = false } },
        { "btn_extra_change_rgt", { input = false } },
      } );

    end;
    -----------------------------------
    
    ObjSet( "spr_extra_picture", { res = res } );
    ObjSet( "txt_extra_play", { text = text_new } );
    ObjSet( "obj_extra_music_list", { input = active, visible = active } );
    ObjSet( "txt_extra_title", { text = "str_extra_"..new_screen } )

    ObjAnimate( "spr_extra_picture", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0, 
      0.4, 0, 1 - new_alp 
    } );

    ObjAnimate( "obj_extra_music_list", "alp", 0, 0, "", 
    { 
      0.0, 0, 0, 
      0.4, 0, new_alp 
    } );

  end;  

  common_impl.Lock( true );

  ObjAnimate( "spr_extra_picture", "alp", 0, 0, func_after, 
  { 
    0.0, 0, ObjGet( "spr_extra_picture" ).alp, 
    0.4, 0, 0 
  } );

  ObjAnimate( "obj_extra_music_list", "alp", 0, 0, "", 
  { 
    0.0, 0, ObjGet( "obj_extra_music_list" ).alp, 
    0.4, 0, 0 
  } );

end;
--******************************************************************************************
function private.ArrowClick ( direction )

  local new_res = 1;

  if not direction then

    if private[private.current_screen].current_number < private[private.current_screen].MAX_COUNT then

      new_res = private[private.current_screen].current_number + 1;

    end;

  else 

    if private[private.current_screen].current_number == 1 then

      new_res = private[private.current_screen].MAX_COUNT;

    else

      new_res = private[private.current_screen].current_number - 1;      

    end;

  end;

  if private.current_screen == "music" then

    private.BtnMusicPlay( new_res );

  else

    common_impl.Lock( true );

    local anm_after = function ()

      local func_after = function ()

        common_impl.Lock( false );
        private[private.current_screen].current_number = new_res;

      end;

      ObjSet( "spr_extra_picture",
      {
        res = "assets/levels/menu/rm_extra/layers/"..private.current_screen.."/mini/"..new_res
      } );

      local text = "str_extra_play";
      if ( private.current_screen == "wallpapers" ) then

        ObjSet( "txt_extra_play", { param0 = new_res, param1 = private[ private.current_screen ].MAX_COUNT } );

        text = "str_extra_set_count";

      elseif ( private.current_screen == "conceptart" ) then

        ObjSet( "txt_extra_play", { param0 = new_res, param1 = private[ private.current_screen ].MAX_COUNT } );

        text = "str_extra_save_count";

      end;
      ObjSet( "txt_extra_play", { text = text } );

      ObjAnimate( "spr_extra_picture", "alp", 0, 0, func_after, { 0,0,0, 0.4,0,1 });

    end;

    ObjAnimate( "spr_extra_picture", "alp", 0, 0, anm_after, { 0,0,1, 0.4,0,0});

  end;

end;
--******************************************************************************************
function private.BtnMusicPlay( track_number )

  if private.music.is_playing == "" then

    local vid_after = function ()

      private.music.vid_number = new_vid;
      common_impl.Lock( false );

      ObjSet( "spr_extra_music_"..track_number.."_play" , { alp = 1 } );
      private.music.current_number = track_number;
      private.music.is_playing = track_number;

      common_impl.PlayAudio( "mus", "rm_extra_track/"..private.music.is_playing, 0.2 );

    end;

    common_impl.Lock( true );
    vid_after();

  else

    common_impl.StopAudio( "mus",  "rm_extra_track/"..private.music.is_playing, 0.2 )

    local vid_after;

    if private.music.is_playing == track_number then

       vid_after = function ()

        common_impl.Lock( false );
        ObjSet( "spr_extra_music_"..private.music.is_playing.."_play" , { alp = 0 } );
        private.music.current_number = track_number;
        private.music.is_playing = "";

      end;

    else

      vid_after = function ()

        common_impl.Lock( false );
        ObjSet( "spr_extra_music_"..private.music.is_playing.."_play" , { alp = 0 } );
        private.music.is_playing = "";
        private.BtnMusicPlay( track_number )

      end;

    end;

    common_impl.Lock( true );
    vid_after();


  end;

end;
function private.ButtonMouseEnter ( but_name )

  SetCursor( CURSOR_HAND );

  local obj = "spr_extra_"..but_name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

  if ( but_name == "play" ) then

    if ( private.current_screen == "wallpapers" ) or ( private.current_screen == "conceptart" ) then
      
      ObjSet( "txt_extra_play", { text = "str_extra_save" } );

    end;

  end;

  --cmn.PlayAudio( "sfx", "common/audio/aud_menter_sfx" );

end;
--******************************************************************************************
function private.ButtonMouseLeave ( but_name )

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_extra_"..but_name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

  if ( but_name == "play" ) then

    if ( private.current_screen == "wallpapers" ) or ( private.current_screen == "conceptart" ) then
      
      local text = "str_extra_play";
      if ( private.current_screen == "wallpapers" ) then

        ObjSet( "txt_extra_play", { param0 = private[private.current_screen].current_number, param1 = private[ private.current_screen ].MAX_COUNT } );

        text = "str_extra_set_count";

      elseif ( private.current_screen == "conceptart" ) then

        ObjSet( "txt_extra_play", { param0 = private[private.current_screen].current_number, param1 = private[ private.current_screen ].MAX_COUNT } );

        text = "str_extra_save_count";

      end;
      ObjSet( "txt_extra_play", { text = text } );

    end;

  end;

end;
--******************************************************************************************
function private.ButtonSetClick ()

  common_impl.PlayAudio( "sfx", "aud_click_menu" );

  if ( private.current_screen == "bonus_chapter" ) then

    if not IsDemoEdition() then

      if ng_global.progress[ "std" ].common.gamewin then

        ng_global.currentprogress = "ext";

        if ( not ng_global.progress[ "ext" ].common.gamestart ) then
          ng_global.progress[ "ext" ].common.gamestart = true;
        end;

        SetCursor( CURSOR_DEFAULT );
        local level = ng_global.progress[ "ext" ].common.chapter;
        cmn.is_inmenunow = false;
        common.LevelSwitch( level );

      else

        common.DialogWindowShow( "common", "unlockextra" );

      end;

    else

        common.DialogWindowShow( "common", "notfull" );

    end;

  else

    if IsDemoEdition() then

      common.DialogWindowShow( "common", "notfull" );

    else

      if ( private.current_screen == "music" ) then
        common.DialogWindowShow( "common", "savemusic" );
      elseif ( private.current_screen == "wallpapers" ) then
        common.DialogWindowShow( "common", "setwallpaper" );
      elseif ( private.current_screen == "conceptart" ) then
        common.DialogWindowShow( "common", "saveart" );
      end;

    end;
  
  end;

end;
--******************************************************************************************
function private.SecretRoomPlay () 

  if not IsDemoEdition() then

    if ng_global.progress[ "ext" ].common.gamewin then

      local prg = "scr";
      ng_global.currentprogress = prg;

      if ( not ng_global.progress[ prg ].common.gamestart ) then
        ng_global.progress[ prg ].common.gamestart = true;
      end;

      SetCursor( CURSOR_DEFAULT );
      local level = ng_global.progress[ prg ].common.chapter;
      cmn.is_inmenunow = false;
      common.LevelSwitch( level );

    else

      common.DialogWindowShow( "common", "unlocksecret" );

    end;

  else

      common.DialogWindowShow( "common", "notfull" );

  end;
 
end;
----------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------
--******************************************************************************************
--function --**ANIMATIONS**-- () end;
--******************************************************************************************
function private.StartAnims ()

  ObjAnimate( "spr_extra_light", "alp", 1, 0, "",
  {
    0.0,  0, 1.0,
    2.5,  0, 0.6,
    4.8,  0, 0.93,
    7.0,  3, 0.5,
    9.0,  2, 1.0
  } );

end;
----------------------------------------------------------------------------------------------------
function common.dialog.common.save()

  if private.current_screen == "music" then

    CopyFileToMyDocs( "assets/audio/rm_extra_track/soundtrack_"..private[private.current_screen].current_number..".mp3" );
    
  elseif private.current_screen == "conceptart" then

    CopyFileToMyDocs( "assets/levels/menu/rm_extra/layers/conceptart/conceptart"..private[private.current_screen].current_number );

  end;

  common.DialogWindowHide( "common" );

end;
--------------------------------------------------------------------
function common.dialog.common.set()

  local way = "assets/levels/menu/rm_extra/layers/wallpapers/wallpaper"..private[private.current_screen].current_number;

  CopyFileToMyDocs( way );

  common.DialogWindowHide( "common" );

end;