-- name=rm_menu
--******************************************************************************************
local wait_gear;

function public.Init()

  local tb = {};

  table.insert( tb, { "obj_menu_but_play", 
  {
    event_mdown = private.PlayDown
  }});

  
  table.insert( tb, { "obj_menu_but_extra", 
  {
    event_mdown = private.ExtraDown
  }});

  table.insert( tb, { "menu_buttons_profile", 
  {
    event_mdown = private.ProfileDown
  }});
  table.insert( tb, { "menu_but_moregames", 
  {
    event_mdown = private.MoreGamesDown
  }});
  
  table.insert( tb, { "menu_but_options", 
  {
    event_mdown = private.OptionsDown
  }});
  
  table.insert( tb, { "menu_buttons_profile", 
  {
    event_mdown = private.ProfileDown
  }});

  table.insert( tb, { "obj_menu_clk_telephone", 
  {
    event_mdown  = function () private.ClkPlaceMenu( "telephone" ); end
  }});

  table.insert( tb, { "obj_menu_clk_window", 
  {
    event_mdown  = function () private.ClkPlaceMenu( "window" ); end
  }});

  table.insert( tb, { "obj_menu_clk_microphone", 
  {
    event_mdown  = function () private.ClkPlaceMenu( "microphone" ); end
  }});

  ObjMultiSet( tb );
  
  ObjSet("menu_but_unlock", { event_mdown = private.UnlockDown });
  ObjSet("menu_but_sequel", { event_mdown = private.SneakPeakDown });
  ObjSet("menu_but_save50", { event_mdown = private.Save50Down });
  ObjSet("menu_but_gear", { event_mdown = private.GearClick });
  
  ObjSet("menu_but_support", { event_mdown = function() common.dialog.options.SupportDown(); end });
  ObjSet("menu_but_terms", { event_mdown = function() common.dialog.options.TermsDown(); end });
  ObjSet("menu_but_privacy", { event_mdown = function() common.dialog.options.PolicyDown() end});
  ObjSet("menu_but_credits", { event_mdown = function() common.MenuCredits("credits"); end});
    
    
  ObjSet("spr_menu_but_back_button", { event_mdown = function() public.closeGearSubMenu(); end });
  ObjSet("menu_but_gear", { event_mdown = function() public.openGearSubMenu(); end });
  
  
  ObjSet("menu_port_hub_sub_menu", { active = false, visible = false, input = false, alp = false });


end;
--******************************************************************************************
function public.closeGearSubMenu()
  
   ObjSet("menu_port_hub_sub_menu", { active = false, visible = false, input = false, alp = false });
  
end;
 
function public.openGearSubMenu()
  
  ObjSet("menu_port_hub_sub_menu", { active = true, visible = true, input = true, alp = true });
  
end;
 --******************************************************************************************

function public.gearOverAngle()
  
  local current_ang = ObjGet("spr_menu_but_gear").ang;
  
  if (wait_gear) then
    
    ObjSet( "tmr_gear", { time = 0.5, playing = 1, endtrig = function() wait_gear = false; public.gearOverAngle(); end  } );
  else
    wait_gear = true;
    local end_ang = current_ang + ((360/8)*3.14)/180;
    ObjAnimate( "spr_menu_but_gear", "ang", 0, 0, function() public.gearOverAngle(); end , {0,0,current_ang, 1,0,end_ang} ); 
  end;
  
  
end;
--******************************************************************************************
function public.PreOpen()
    
  ObjSet( "obj_menu_ce_buttons_left",  { active = false, visible = false, input = false } );
  ObjSet( "obj_menu_ce_buttons_right", { active = false, visible = false, input = false } );

  if ( IsCollectorsEdition() ) then

    ObjSet( "obj_menu_ce_buttons_left",  { active = true, visible = true, input = true } );
    ObjSet( "obj_menu_ce_buttons_right", { active = true, visible = true, input = true } );
    ObjSet( "spr_menu_logo_ce",      { visible = true } );

  elseif ( IsSurveyEdition() ) then

    ObjSet( "obj_menu_ce_buttons_left", { active = false, visible = false, input = false } );
 
  else

    ObjSet( "obj_menu_ce_buttons_left", { active = false, visible = false, input = false } );

  end;

  if GetPlatform() == "mac" then

    ObjSet( "dialog_options_widescreen", { active = false, visible = false, input = false } );

  end;

  public.SetProfileText( GetCurrentProfile() );
  public.ButtonSetPos();

  private.AnimMenu();

  common_impl.EnvPlay( { "aud_menu_env" }, "", 0.5 );
  
  
  ObjSet("menu_port_hub_sub_menu", { active = false, visible = false, input = false, alp = false });
  wait_gear = false;
  public.gearOverAngle();
  
  if tostring(GetPlatform()) == "ios" or tostring(GetPlatform()) == "android" then
      iOS_LogEvents(2);
      iOS_ManageAds(1);
        
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
      ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
      ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
      ObjSet("menu_but_save50", {input = 1, visible = 1, active = 1, alp = 1});
      ObjSet("menu_but_sequel", {input = 1, visible = 1, active = 1, alp = 1});
    end;

    if port.isTablet() == 0 then
      if preformance_warning == 0 then
        preformance_warning = 1;
        ObjSet("tmr_menu_performance", {endtrig = function() private.PerformanceWarning(); end, time = 2, playing = 1 });
      end;
    end;

    if iOS_IsiSplashPressed() == 1 then
        ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_save50", {endtrig = function() private.Save50Timer(); end, time = 0.5, playing = 1 });
    end;

    if iOS_IsRated() == 1 then
        ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_sneakpeak", {endtrig = function() private.SneakpeakTimer(); end, time = 0.5, playing = 1 });
    end;

    if iOS_IsBought() == 1 then
        ObjSet("menu_but_unlock", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_unlock", {endtrig = function() private.UnlockTimer(); end, time = 0.5, playing = 1 });
    end;
  end;
  
end;
  
--******************************************************************************************
function private.PerformanceWarning()
  iOS_PerformanceWarning();
end;
--******************************************************************************************
function private.Save50Timer()
  if iOS_IsiSplashPressed() == 1 then
    ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
  else
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
        ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("menu_but_save50", {input = 1, visible = 1, active = 1, alp = 1});
    end;
    ObjSet("tmr_menu_save50", {endtrig = function() private.Save50Timer(); end, time = 0.5, playing = 1 });
  end;
end;
--******************************************************************************************
function private.SneakpeakTimer()
  if iOS_IsRated() == 1 then
    ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
  else
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
        ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("menu_but_sequel", {input = 1, visible = 1, active = 1, alp = 1});
    end;
    ObjSet("tmr_menu_sneakpeak", {endtrig = function() private.SneakpeakTimer(); end, time = 0.5, playing = 1 });
  end;
end;
-------------------------ios----------------------------------------
function private.UnlockTimer()
  if iOS_IsBought() == 1 then
    ObjSet("menu_but_unlock", { input = 0, visible = 0, active = 0, alp = 0 });
  else
    ObjSet("tmr_menu_unlock", {endtrig = function() private.UnlockTimer(); end, time = 0.5, playing = 1 });  
  end;
end;
--******************************************************************************************
--******************************************************************************************
function public.Open()

  if ( IsCollectorsEdition() ) then

    if ( ng_global.progress[ "std" ].common.gamewin == true ) and
       ( ng_global.progress[ "std" ].common.gamestart == false ) and
         ( not ng_global.bonusunlock ) then

      common.DialogWindowShow( "common", "bonusunlock", false );
      ng_global.bonusunlock = true;

      SaveProfiles();

    elseif ( ng_global.progress[ "ext" ].common.gamewin == true ) and
       ( ng_global.progress[ "ext" ].common.gamestart == false ) and
         ( not ng_global.secretunlock ) then

      common.DialogWindowShow( "common", "secretunlock", false );
      ng_global.secretunlock = true;

      SaveProfiles();

    end;

  end;

end;
--******************************************************************************************
function public.SetProfileText ( name )
  
  local obj = "txt_menu_but_profile";
  local profile_name = "";

  if  ( name ~= "ng_noprofiles" ) and ( name ~= "ng_error" ) then

    profile_name = name;

  end;

  ObjSet( obj, { text = profile_name } );

end;
--******************************************************************************************
function private.PlayDown()

  common_impl.PlayAudio( "sfx", "aud_click_menu", 0, "", 0 );
  common.MenuPlay();

end;
--******************************************************************************************
function private.OptionsDown()

  common_impl.PlayAudio( "sfx", "aud_click_menu", 0, "", 0 );
  common.MenuOptions();

end;
--******************************************************************************************
function private.QuitDown()

  common_impl.PlayAudio( "sfx", "aud_click_menu", 0, "", 0 );
  common.MenuQuit();

end;
--******************************************************************************************
function private.ExtraDown()

  if port.isPortable() == 1 then
    if iOS_IsBought() == 1 then
      common.MenuExtra();
    else
      common.MenuUnlock();
    end;
  else
    common.MenuExtra();
  end;
  common_impl.PlayAudio( "sfx", "aud_click_menu", 0, "", 0 );

end;
--******************************************************************************************
function private.StrguideDown()

  common_impl.PlayAudio( "sfx", "aud_click_menu", 0, "", 0 );

    if IsCollectorsEdition() then

      common_impl.ButtonGuide_Click();
      interface.StrategyGuideShow();

    else

      local guide_url = GetGuideUrl();
      OpenBrowser( guide_url );

    end;

end;
--******************************************************************************************
function private.ProfileDown()
  --DbgTrace("ProfileDown");
  common_impl.PlayAudio( "sfx", "aud_click_menu", 0, "", 0 );
  common.MenuProfile();

end;
--*****************************************************************************************
function private.MoreGamesDown()
  --DbgTrace("MoreGamesDown");
  common_impl.PlayAudio( "sfx", "aud_click_menu", 0, "", 0 );
  iOS_MoreGamesPressed();

end;
--*************************************ios*****************************************************
function private.Save50Down()
  common_impl.PlayAudio( "sfx", "aud_click_menu", 0, "", 0 );
  common.MenuSave50();
end;
--*************************************ios*****************************************************
function private.UnlockDown()
  common_impl.PlayAudio( "sfx", "aud_click_menu", 0, "", 0 );
  common.MenuUnlock();
end;
--*************************************ios*****************************************************
function private.SneakPeakDown()
  common_impl.PlayAudio( "sfx", "aud_click_menu", 0, "", 0 );
  common.MenuSneakPeak();
end;
--******************************************************************************************
function private.ButtonMouseEnter( but_name, type )

  common_impl.PlayAudio( "sfx", "aud_guidance", 0, "", 0 );
  SetCursor( CURSOR_HAND );

  local type = type or "spr";
  local obj_focus = type.."_menu_but_"..but_name.."_focus";
  local alp = ObjGet( obj_focus ).alp;

  ObjAnimate( obj_focus, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

  if but_name ~= "profile" then

    local vid_name = "vid_menu_"..but_name;
    local lamp_name = "spr_menu_but_"..but_name.."_lamp";

    ObjAnimate( vid_name, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );
    ObjAnimate( lamp_name, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

  end;

end;
--******************************************************************************************
function private.ButtonMouseLeave( but_name, type )

  SetCursor( CURSOR_DEFAULT );

  local type = type or "spr";
  local obj_focus = type.."_menu_but_"..but_name.."_focus";
  local alp = ObjGet( obj_focus ).alp;

  ObjAnimate( obj_focus, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

  if but_name ~= "profile" then

    local vid_name = "vid_menu_"..but_name;
    local lamp_name = "spr_menu_but_"..but_name.."_lamp";

    ObjAnimate( vid_name, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );
    ObjAnimate( lamp_name, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

  end;

end;
--******************************************************************************************
function private.AnimMenu()



end;
--******************************************************************************************
function private.ClkPlaceMenu( name )

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_clk_"..name, 0, "", 0 );

end;
--******************************************************************************************
function public.ButtonSetPos()

  local offwidth = 0.5 * ( GetAppWidth() - 1024 );

end;
--*****************************************************************************************
