-- name=rm_moregames
--******************************************************************************************
function public.Init()

  ObjAttach( "rm_moregames", "rooms_hub" );
  
  ObjMultiSet( {
    {"btn_moregames_button_hh5", 
      {
        event_mdown =  function () private.ChangeURL( "1" ); end,
        event_menter = function () private.ButtonMouseEnter( "hh5" ); end,
        event_mleave = function () private.ButtonMouseLeave( "hh5" ); end
      } 
    },
    {"btn_moregames_button_hh6",
      {
        event_mdown =  function () private.ChangeURL( "2" ); end,
        event_menter = function () private.ButtonMouseEnter( "hh6" ); end,
        event_mleave = function () private.ButtonMouseLeave( "hh6" ); end
      }
    },
    {"btn_moregames_button_hh7",
      {
        event_mdown =  function () private.ChangeURL( "3" ); end,
        event_menter = function () private.ButtonMouseEnter( "hh7" ); end,
        event_mleave = function () private.ButtonMouseLeave( "hh7" ); end
      }
    },
    {"spr_moregames_button_main_menu",
      {
        event_mdown =  function () common.GotoRoom( "rm_menu" ); end,
        event_menter = function () private.ButtonMouseEnter( "main_menu" ); end,
        event_mleave = function () private.ButtonMouseLeave( "main_menu" ); end
      }
    },

  } );
  ----------------------------------------------------------------------------------------
  private.Link = 
  {
    -- games_5
    { 
      mac_ce = "http://www.bigfishgames.com/download-games/24894/mac/haunted-hotel-eclipse-collectors-edition/index.html",
      mac_se = "http://www.bigfishgames.com/download-games/25246/mac/haunted-hotel-eclipse/index.html",
      win_ce = "http://www.bigfishgames.com/download-games/24820/haunted-hotel-eclipse-collectors-edition/index.html",
      win_se = "http://www.bigfishgames.com/download-games/25244/haunted-hotel-eclipse/index.html"
    },
    -- games_6
    { 
      mac_ce = "http://www.bigfishgames.com/download-games/26798/mac/haunted-hotel-ancient-bane-ce/index.html",
      mac_se = "http://www.bigfishgames.com/download-games/27174/mac/haunted-hotel-ancient-bane/index.html",
      win_ce = "http://www.bigfishgames.com/download-games/26799/haunted-hotel-ancient-bane-ce/index.html",
      win_se = "http://www.bigfishgames.com/download-games/27173/haunted-hotel-ancient-bane/index.html"
    },
    -- games_7
    { 
      mac_ce = "http://www.bigfishgames.com/games/8436/haunted-hotel-death-sentence-ce/?mac",
      mac_se = "http://www.bigfishgames.com/games/8489/haunted-hotel-death-sentence/?mac",
      win_ce = "http://www.bigfishgames.com/games/8436/haunted-hotel-death-sentence-ce/?pc",
      win_se = "http://www.bigfishgames.com/games/8489/haunted-hotel-death-sentence/?pc"
    }



  }
end;
--******************************************************************************************
function public.PreOpen()

  ObjSet( "obj_moregames_collectors_edition", { visible = IsCollectorsEdition() } );

end;
--******************************************************************************************
function public.Open()

end;
--******************************************************************************************
function private.ChangeURL( but_name )
  
  local link = "";
  local mas_name = "Link";


  local num_games = tonumber(  string.sub( but_name, string.len( but_name ) ,string.len( but_name ) ) );

  if IsCollectorsEdition() then

    if GetPlatform() == "mac" then

      link = private[mas_name][ num_games ][ "mac_ce" ];

    else
     
      link = private[mas_name][ num_games ][ "win_ce" ];
  
    end;

  else

    if GetPlatform() == "mac" then
     
      link = private[mas_name][ num_games ][ "mac_se" ];      

    else
      
      link = private[mas_name][ num_games ][ "win_se" ];      
    
    end;

  end;
  

  OpenBrowser( link );

end;
--******************************************************************************************
function private.ButtonMouseEnter ( but_name )

  SetCursor( CURSOR_HAND );

  local obj = "spr_moregames_button_"..but_name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );


end;
--******************************************************************************************
function private.ButtonMouseLeave ( but_name )

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_moregames_button_"..but_name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

end;
--******************************************************************************************